# Copyright (C) 2023 Mandiant, Inc. All Rights Reserved.
# Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
# You may obtain a copy of the License at: [package root]/LICENSE.txt
# Unless required by applicable law or agreed to in writing, software distributed under the License
#  is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and limitations under the License.
from typing import Dict, List

COM_INTERFACES: Dict[str, List[str]] = {
    "IClusterApplicationWizard": ["24F97151-6689-11D1-9AA7-00C04FB93A80"],
    "IWEExtendWizard97": ["97DEDE68-FC6B-11CF-B5F5-00A0C90AB505"],
    "IWCWizard97Callback": ["97DEDE67-FC6B-11CF-B5F5-00A0C90AB505"],
    "IWEInvokeCommand": ["97DEDE66-FC6B-11CF-B5F5-00A0C90AB505"],
    "IWEExtendContextMenu": ["97DEDE65-FC6B-11CF-B5F5-00A0C90AB505"],
    "IWCContextMenuCallback": ["97DEDE64-FC6B-11CF-B5F5-00A0C90AB505"],
    "IWEExtendWizard": ["97DEDE63-FC6B-11CF-B5F5-00A0C90AB505"],
    "IWCWizardCallback": ["97DEDE62-FC6B-11CF-B5F5-00A0C90AB505"],
    "IWEExtendPropertySheet": ["97DEDE61-FC6B-11CF-B5F5-00A0C90AB505"],
    "IWCPropertySheetCallback": ["97DEDE60-FC6B-11CF-B5F5-00A0C90AB505"],
    "IGetClusterNetInterfaceInfo": ["97DEDE57-FC6B-11CF-B5F5-00A0C90AB505"],
    "IGetClusterNetworkInfo": ["97DEDE56-FC6B-11CF-B5F5-00A0C90AB505"],
    "IGetClusterResourceInfo": ["97DEDE55-FC6B-11CF-B5F5-00A0C90AB505"],
    "IGetClusterGroupInfo": ["97DEDE54-FC6B-11CF-B5F5-00A0C90AB505"],
    "IGetClusterNodeInfo": ["97DEDE53-FC6B-11CF-B5F5-00A0C90AB505"],
    "IGetClusterObjectInfo": ["97DEDE52-FC6B-11CF-B5F5-00A0C90AB505"],
    "IGetClusterDataInfo": ["97DEDE51-FC6B-11CF-B5F5-00A0C90AB505"],
    "IGetClusterUIInfo": ["97DEDE50-FC6B-11CF-B5F5-00A0C90AB505"],
    "AsyncIClusCfgEvictNotify": ["AD2E83CC-1D14-4D20-928E-22D344847454"],
    "IClusCfgEvictNotify": ["090E7745-9E5B-4D76-936E-D760CF2FF3B9"],
    "AsyncIClusCfgEvictListener": ["08609AC3-D284-4009-805F-17D3CFE4160B"],
    "IClusCfgEvictListener": ["E20DDEE3-DEFC-4D54-B1F7-2AEB784C3847"],
    "IClusCfgVerifyQuorum": ["90A2EFAE-1B62-4ADA-BF1C-BECAB56F748D"],
    "IClusCfgManagedResourceData": ["8447ECB7-2171-4E21-A108-0EB5B0B516DA"],
    "AsyncIClusCfgStartupNotify": ["C2B0D06A-6353-4EE1-B253-6B0D75DB2CD3"],
    "IClusCfgStartupNotify": ["C2B0D069-6353-4EE1-B253-6B0D75DB2CD3"],
    "AsyncIClusCfgStartupListener": ["D282CAF0-2EDE-4AB9-A5D5-F7BDE3D23F10"],
    "IClusCfgStartupListener": ["D282CAEF-2EDE-4AB9-A5D5-F7BDE3D23F0F"],
    "AsyncIClusCfgEvictCleanup": ["6FE3E362-D373-4C5F-A0AF-1DFE8493C655"],
    "IClusCfgEvictCleanup": ["6FE3E361-D373-4C5F-A0AF-1DFE8493C655"],
    "AsyncIClusCfgResourceTypeCreate": ["3AFCE3B9-5F3E-4DDF-A8F4-4B4FCBF28F8F"],
    "IClusCfgResourceTypeCreate": ["3AFCE3B8-5F3E-4DDF-A8F4-4B4FCBF28F8F"],
    "AsyncIClusCfgResourceTypeInfo": ["C649A282-C847-4F5C-9841-D2F73B5AA71D"],
    "IClusCfgResourceTypeInfo": ["C649A281-C847-4F5C-9841-D2F73B5AA71D"],
    "AsyncIClusCfgMemberSetChangeListener": ["2B645350-2643-4ABC-A4E5-824D881B7582"],
    "IClusCfgMemberSetChangeListener": ["2B64534F-2643-4ABC-A4E5-824D881B7582"],
    "IClusCfgGroupCfg": ["DCB6D3D2-A55F-49E5-A64A-0CCFEB01ED3A"],
    "IClusCfgResourcePostCreate": ["72A9BF54-13B6-451F-910D-6913EBF025AB"],
    "IClusCfgResourceCreate": ["0647B41A-C777-443C-9432-02CCCF4FF443"],
    "IClusCfgResourcePreCreate": ["4240F6A1-9D49-427E-8F3D-09384E1F59E4"],
    "IClusCfgManagedResourceCfg": ["60300A0F-77E1-440C-BD94-6BFB0DBFDB3A"],
    "IClusCfgCapabilities": ["D94AB253-36C7-41C1-B52E-26B451975C8D"],
    "AsyncIClusCfgCredentials": ["54AA9406-A409-4B49-B314-5F0A0CE4C88F"],
    "IClusCfgCredentials": ["54AA9406-A409-4B49-B314-5F0A0CE4C88E"],
    "AsyncIClusCfgCallback": ["EBCE8945-AC69-4B3A-865D-E2D4EB33E41B"],
    "IClusCfgCallback": ["238DCA63-E2EF-4F32-A24D-ACBF975BE842"],
    "AsyncIClusCfgInitialize": ["2A0EB82E-F878-492A-951E-AE000918C4A6"],
    "IClusCfgInitialize": ["2A0EB82D-F878-492A-951E-AE000918C4A6"],
    "AsyncIClusCfgClusterInfo": ["8BDBA247-04F5-4114-837E-B263412A4B64"],
    "IClusCfgClusterInfo": ["85B4BBC0-DDC4-4AE7-8268-F4850BB2A6EE"],
    "AsyncIClusCfgNetworkInfo": ["ED71FD2D-AD02-4DFC-B376-5FFA5F5A7C2C"],
    "IClusCfgNetworkInfo": ["19FC7580-950A-44A6-966E-74B14B20918F"],
    "AsyncIClusCfgIPAddressInfo": ["AAEAF0A5-E310-4604-A55E-2F9DDC4157A9"],
    "IClusCfgIPAddressInfo": ["AAEAF0A5-E310-4604-A55E-2F9DDC4157A8"],
    "AsyncIEnumClusCfgIPAddresses": ["BD5F35BA-0BC0-455F-926D-C3D356419487"],
    "IEnumClusCfgIPAddresses": ["BD5F35BA-0BC0-455F-926D-C3D356419486"],
    "AsyncIClusCfgPartitionInfo": ["EC1EBD9F-5866-4846-8952-EC36C3961EEF"],
    "IClusCfgPartitionInfo": ["EC1EBD9F-5866-4846-8952-EC36C3961EEE"],
    "AsyncIEnumClusCfgPartitions": ["4440BB6A-B0AC-479D-B534-7265A31D6C56"],
    "IEnumClusCfgPartitions": ["4440BB6A-B0AC-479D-B534-7265A31D6C55"],
    "AsyncIClusCfgManagedResourceInfo": ["0560D153-892F-4BF5-87B0-06AF2803955C"],
    "IClusCfgManagedResourceInfo": ["8389D687-DF99-442B-81AB-58BA5B029688"],
    "AsyncIEnumClusCfgNetworks": ["F56B9B0D-E7B8-49EC-A843-5475076B947D"],
    "IEnumClusCfgNetworks": ["CF3FAED8-1322-4BCB-9923-B5B745A69E36"],
    "AsyncIEnumClusCfgManagedResources": ["B138483F-9695-4FA6-A98F-0DE2FB355449"],
    "IEnumClusCfgManagedResources": ["7DBE11EB-A5DF-4534-ABF6-8BAC7B53FC95"],
    "AsyncIClusCfgNodeInfo": ["4F3BB40B-DF27-40A0-B31A-BA18324CEB9D"],
    "IClusCfgNodeInfo": ["E4B5FA15-DD07-439E-A623-8823524E3D19"],
    "IClusCfgAddNodesWizard": ["9DA133CB-3B08-4C30-967E-56D96047F10C"],
    "IClusCfgCreateClusterWizard": ["F65C6990-A144-4127-AB6E-3712B75F1843"],
    "IInterfaceRelated": ["D1FB5A79-7706-11D1-ADBA-00C04FC2ADC0"],
    "ICallFrameWalker": ["08B23919-392D-11D2-B8A4-00C04FB9618A"],
    "ICallUnmarshal": ["5333B003-2E42-11D2-B89D-00C04FB9618A"],
    "ICallFrameEvents": ["FD5E0843-FC91-11D0-97D7-00C04FB9618A"],
    "ICallInterceptor": ["60C7CA75-896D-11D2-B8B6-00C04FB9618A"],
    "ICallIndirect": ["D573B4B1-894E-11D2-B8B6-00C04FB9618A"],
    "ICallFrame": ["D573B4B0-894E-11D2-B8B6-00C04FB9618A"],
    "IContextCallback": ["000001DA-0000-0000-C000-000000000046"],
    "IAuditControl": ["1DA6292F-BC66-11CE-AAE3-00AA004C2737"],
    "IAccessControl": ["EEDD23E0-8410-11CE-A1C3-08002B2B8D8F"],
    "ISpecialSystemProperties": ["000001B9-0000-0000-C000-000000000046"],
    "IOpaqueDataInfo": ["000001A9-0000-0000-C000-000000000046"],
    "IStandardActivator": ["000001B8-0000-0000-C000-000000000046"],
    "IPropertyBag": ["55272A00-42CB-11CE-8135-00AA004BB851"],
    "IErrorLog": ["3127CA40-446E-11CE-8135-00AA004BB851"],
    "IRecordInfo": ["0000002F-0000-0000-C000-000000000046"],
    "ITypeMarshal": ["0000002D-0000-0000-C000-000000000046"],
    "ITypeFactory": ["0000002E-0000-0000-C000-000000000046"],
    "ISupportErrorInfo": ["DF0B3D60-548F-101B-8E65-08002B2BD119"],
    "ICreateErrorInfo": ["22F03340-547D-101B-8E65-08002B2BD119"],
    "IErrorInfo": ["1CF2B120-547D-101B-8E65-08002B2BD119"],
    "ITypeChangeEvents": ["00020410-0000-0000-C000-000000000046"],
    "ITypeLib2": ["00020411-0000-0000-C000-000000000046"],
    "ITypeLib": ["00020402-0000-0000-C000-000000000046"],
    "ITypeInfo2": ["00020412-0000-0000-C000-000000000046"],
    "ITypeInfo": ["00020401-0000-0000-C000-000000000046"],
    "ITypeComp": ["00020403-0000-0000-C000-000000000046"],
    "IEnumVARIANT": ["00020404-0000-0000-C000-000000000046"],
    "IDispatch": ["00020400-0000-0000-C000-000000000046"],
    "ICreateTypeLib2": ["0002040F-0000-0000-C000-000000000046"],
    "ICreateTypeLib": ["00020406-0000-0000-C000-000000000046"],
    "ICreateTypeInfo2": ["0002040E-0000-0000-C000-000000000046"],
    "ICreateTypeInfo": ["00020405-0000-0000-C000-000000000046"],
    "IInitializeSpy": ["00000034-0000-0000-C000-000000000046"],
    "IProcessInitControl": ["72380D55-8D2B-43A3-8513-2B6EF31434E9"],
    "IComThreadingInfo": ["000001CE-0000-0000-C000-000000000046"],
    "ISurrogateService": ["000001D4-0000-0000-C000-000000000046"],
    "IProcessLock": ["000001D5-0000-0000-C000-000000000046"],
    "IObjContext": ["000001C6-0000-0000-C000-000000000046"],
    "IContext": ["000001C0-0000-0000-C000-000000000046"],
    "IEnumContextProps": ["000001C1-0000-0000-C000-000000000046"],
    "IDummyHICONIncluder": ["947990DE-CC28-11D2-A0F7-00805F858FB1"],
    "IThumbnailExtractor": ["969DC708-5C76-11D1-8D86-0000F804B057"],
    "AsyncIPipeDouble": ["DB2F3ACF-2F86-11D1-8E04-00C04FB9989A"],
    "IPipeDouble": ["DB2F3ACE-2F86-11D1-8E04-00C04FB9989A"],
    "AsyncIPipeLong": ["DB2F3ACD-2F86-11D1-8E04-00C04FB9989A"],
    "IPipeLong": ["DB2F3ACC-2F86-11D1-8E04-00C04FB9989A"],
    "AsyncIPipeByte": ["DB2F3ACB-2F86-11D1-8E04-00C04FB9989A"],
    "IPipeByte": ["DB2F3ACA-2F86-11D1-8E04-00C04FB9989A"],
    "IAddrExclusionControl": ["00000148-0000-0000-C000-000000000046"],
    "IAddrTrackingControl": ["00000147-0000-0000-C000-000000000046"],
    "IForegroundTransfer": ["00000145-0000-0000-C000-000000000046"],
    "IUrlMon": ["00000026-0000-0000-C000-000000000046"],
    "IWaitMultiple": ["0000002B-0000-0000-C000-000000000046"],
    "IReleaseMarshalBuffers": ["EB0CB9E8-7996-11D2-872E-0000F8080859"],
    "IRpcHelper": ["00000149-0000-0000-C000-000000000046"],
    "ICallFactory": ["1C733A30-2A1C-11CE-ADE5-00AA0044773D"],
    "IAsyncManager": ["0000002A-0000-0000-C000-000000000046"],
    "ICancelMethodCalls": ["00000029-0000-0000-C000-000000000046"],
    "ISynchronizeMutex": ["00000025-0000-0000-C000-000000000046"],
    "ISynchronizeContainer": ["00000033-0000-0000-C000-000000000046"],
    "ISynchronizeEvent": ["00000032-0000-0000-C000-000000000046"],
    "ISynchronizeHandle": ["00000031-0000-0000-C000-000000000046"],
    "ISynchronize": ["00000030-0000-0000-C000-000000000046"],
    "IDirectWriterLock": ["0E6D4D92-6738-11CF-9608-00AA00680DB4"],
    "IGlobalInterfaceTable": ["00000146-0000-0000-C000-000000000046"],
    "ISurrogate": ["00000022-0000-0000-C000-000000000046"],
    "IOplockStorage": ["8D19C834-8879-11D1-83E9-00C04FC2C6D4"],
    "ITimeAndNoticeControl": ["BC0BF6AE-8878-11D1-83E9-00C04FC2C6D4"],
    "IBlockingLock": ["30F3D47A-6447-11D1-8E3C-00C04FB9386D"],
    "ILayoutStorage": ["0E6D4D90-6738-11CF-9608-00AA00680DB4"],
    "IProgressNotify": ["A9D758A0-4617-11CF-95FC-00AA00680DB4"],
    "IFillLockBytes": ["99CAF010-415E-11CF-8814-00AA00B569F5"],
    "IRpcOptions": ["00000144-0000-0000-C000-000000000046"],
    "IClassActivator": ["00000140-0000-0000-C000-000000000046"],
    "IServerSecurity": ["0000013E-0000-0000-C000-000000000046"],
    "IClientSecurity": ["0000013D-0000-0000-C000-000000000046"],
    "IChannelHook": ["1008C4A0-7613-11CF-9AF1-0020AF6E72F4"],
    "IPSFactoryBuffer": ["D5F569D0-593B-101A-B569-08002B2DBF7A"],
    "IRpcStubBuffer": ["D5F56AFC-593B-101A-B569-08002B2DBF7A"],
    "IRpcProxyBuffer": ["D5F56A34-593B-101A-B569-08002B2DBF7A"],
    "IRpcSyntaxNegotiate": ["58A08519-24C8-4935-B482-3FD823333A4F"],
    "IRpcChannelBuffer3": ["25B15600-0115-11D0-BF0D-00AA00B8DFD2"],
    "IAsyncRpcChannelBuffer": ["A5029FB6-3C34-11D1-9C99-00C04FB998AA"],
    "IRpcChannelBuffer2": ["594F31D0-7F19-11D0-B194-00A0C90DC8BF"],
    "IRpcChannelBuffer": ["D5F56B60-593B-101A-B569-08002B2DBF7A"],
    "IMessageFilter": ["00000016-0000-0000-C000-000000000046"],
    "IDataAdviseHolder": ["00000110-0000-0000-C000-000000000046"],
    "IDataObject": ["0000010E-0000-0000-C000-000000000046"],
    "AsyncIAdviseSink2": ["00000151-0000-0000-C000-000000000046"],
    "IAdviseSink2": ["00000125-0000-0000-C000-000000000046"],
    "AsyncIAdviseSink": ["00000150-0000-0000-C000-000000000046"],
    "IAdviseSink": ["0000010F-0000-0000-C000-000000000046"],
    "IRootStorage": ["00000012-0000-0000-C000-000000000046"],
    "IEnumSTATDATA": ["00000105-0000-0000-C000-000000000046"],
    "IEnumFORMATETC": ["00000103-0000-0000-C000-000000000046"],
    "ILockBytes": ["0000000A-0000-0000-C000-000000000046"],
    "IPersistStorage": ["0000010A-0000-0000-C000-000000000046"],
    "IPersistFile": ["0000010B-0000-0000-C000-000000000046"],
    "IStorage": ["0000000B-0000-0000-C000-000000000046"],
    "IEnumSTATSTG": ["0000000D-0000-0000-C000-000000000046"],
    "IStream": ["0000000C-0000-0000-C000-000000000046"],
    "ISequentialStream": ["0C733A30-2A1C-11CE-ADE5-00AA0044773D"],
    "IEnumString": ["00000101-0000-0000-C000-000000000046"],
    "IROTData": ["F29F6BC0-5021-11CE-AA15-00006901293F"],
    "IMoniker": ["0000000F-0000-0000-C000-000000000046"],
    "IPersistStream": ["00000109-0000-0000-C000-000000000046"],
    "IPersist": ["0000010C-0000-0000-C000-000000000046"],
    "IRunningObjectTable": ["00000010-0000-0000-C000-000000000046"],
    "IRunnableObject": ["00000126-0000-0000-C000-000000000046"],
    "IEnumMoniker": ["00000102-0000-0000-C000-000000000046"],
    "IBindCtx": ["0000000E-0000-0000-C000-000000000046"],
    "IEnumUnknown": ["00000100-0000-0000-C000-000000000046"],
    "IInternalUnknown": ["00000021-0000-0000-C000-000000000046"],
    "AsyncIMultiQI": ["000E0020-0000-0000-C000-000000000046"],
    "IMultiQI": ["00000020-0000-0000-C000-000000000046"],
    "IExternalConnection": ["00000019-0000-0000-C000-000000000046"],
    "IStdMarshalInfo": ["00000018-0000-0000-C000-000000000046"],
    "IMallocSpy": ["0000001D-0000-0000-C000-000000000046"],
    "IMalloc": ["00000002-0000-0000-C000-000000000046"],
    "IMarshal2": ["000001CF-0000-0000-C000-000000000046"],
    "IMarshal": ["00000003-0000-0000-C000-000000000046"],
    "IQuickActivate": ["CF51ED10-62FE-11CF-BF86-00A0C9034836"],
    "IAdviseSinkEx": ["3AF24290-0C96-11CE-A0CF-00AA00600AB8"],
    "IPersistPropertyBag2": ["22F55881-280B-11D0-A8A9-00A0C90C2004"],
    "IPropertyBag2": ["22F55882-280B-11D0-A8A9-00A0C90C2004"],
    "IPerPropertyBrowsing": ["376BD3AA-3845-101B-84ED-08002B2EC713"],
    "IObjectWithSite": ["FC4801A3-2BA9-11CF-A229-00AA003D7352"],
    "IPointerInactive": ["55980BA0-35AA-11CF-B671-00AA004CD6D8"],
    "IOleUndoManager": ["D001F200-EF97-11CE-9BC9-00AA00608E01"],
    "IEnumOleUndoUnits": ["B3E7C340-EF97-11CE-9BC9-00AA00608E01"],
    "IOleParentUndoUnit": ["A1FAF330-EF97-11CE-9BC9-00AA00608E01"],
    "IOleUndoUnit": ["894AD3B0-EF97-11CE-9BC9-00AA00608E01"],
    "IViewObjectEx": ["3AF24292-0C96-11CE-A0CF-00AA00600AB8"],
    "IOleInPlaceSiteWindowless": ["922EADA0-3424-11CF-B670-00AA004CD6D8"],
    "IOleInPlaceSiteEx": ["9C2CAD80-3424-11CF-B670-00AA004CD6D8"],
    "IOleInPlaceObjectWindowless": ["1C2056CC-5EF4-101B-8BC8-00AA003E3B29"],
    "IPictureDisp": ["7BF80981-BF32-101A-8BBB-00AA00300CAB"],
    "IFontDisp": ["BEF6E003-A874-101A-8BBA-00AA00300CAB"],
    "IFontEventsDisp": ["4EF6100A-AF88-11D0-9846-00C04FC29993"],
    "IPicture": ["7BF80980-BF32-101A-8BBB-00AA00300CAB"],
    "IFont": ["BEF6E002-A874-101A-8BBA-00AA00300CAB"],
    "ISimpleFrameSite": ["742B0E01-14E6-101B-914E-00AA00300CAB"],
    "IPersistPropertyBag": ["37D84F60-42CB-11CE-8135-00AA004BB851"],
    "IPersistStreamInit": ["7FD52380-4E07-101B-AE2D-08002B2EC713"],
    "IPersistMemory": ["BD1AE5E0-A6AE-11CE-BD37-504200C10000"],
    "ISpecifyPropertyPages": ["B196B28B-BAB4-101A-B69C-00AA00341D07"],
    "IPropertyNotifySink": ["9BFBBC02-EFF1-101A-84ED-00AA00341D07"],
    "IPropertyPageSite": ["B196B28C-BAB4-101A-B69C-00AA00341D07"],
    "IPropertyPage2": ["01E44665-24AC-101B-84ED-08002B2EC713"],
    "IPropertyPage": ["B196B28D-BAB4-101A-B69C-00AA00341D07"],
    "IOleControlSite": ["B196B289-BAB4-101A-B69C-00AA00341D07"],
    "IOleControl": ["B196B288-BAB4-101A-B69C-00AA00341D07"],
    "IProvideMultipleClassInfo": ["A7ABA9C1-8983-11CF-8F20-00805F2CD064"],
    "IProvideClassInfo2": ["A6BC3AC0-DBAA-11CE-9DE3-00AA004BB851"],
    "IProvideClassInfo": ["B196B283-BAB4-101A-B69C-00AA00341D07"],
    "IClassFactory2": ["B196B28F-BAB4-101A-B69C-00AA00341D07"],
    "IConnectionPointContainer": ["B196B284-BAB4-101A-B69C-00AA00341D07"],
    "IEnumConnectionPoints": ["B196B285-BAB4-101A-B69C-00AA00341D07"],
    "IConnectionPoint": ["B196B286-BAB4-101A-B69C-00AA00341D07"],
    "IEnumConnections": ["B196B287-BAB4-101A-B69C-00AA00341D07"],
    "IMultiplePropertyAccess": ["EC81FEDE-D432-11CE-9244-0020AF6E72DB"],
    "IDifferencing": ["994F0AF0-2977-11CE-BB80-08002B36B2B0"],
    "IReconcileInitiator": ["99180161-DA16-101A-935C-444553540000"],
    "IReconcilableObject": ["99180162-DA16-101A-935C-444553540000"],
    "INotifyReplica": ["99180163-DA16-101A-935C-444553540000"],
    "IPropertySetContainer": ["B4FFAE60-A7CA-11CD-B58B-00006B829156"],
    "IEnumOLEVERB": ["00000104-0000-0000-C000-000000000046"],
    "IDropTarget": ["00000122-0000-0000-C000-000000000046"],
    "IDropSource": ["00000121-0000-0000-C000-000000000046"],
    "IViewObject2": ["00000127-0000-0000-C000-000000000046"],
    "IViewObject": ["0000010D-0000-0000-C000-000000000046"],
    "IContinue": ["0000012A-0000-0000-C000-000000000046"],
    "IOleInPlaceSite": ["00000119-0000-0000-C000-000000000046"],
    "IOleInPlaceObject": ["00000113-0000-0000-C000-000000000046"],
    "IOleInPlaceFrame": ["00000116-0000-0000-C000-000000000046"],
    "IOleInPlaceActiveObject": ["00000117-0000-0000-C000-000000000046"],
    "IOleInPlaceUIWindow": ["00000115-0000-0000-C000-000000000046"],
    "IOleItemContainer": ["0000011C-0000-0000-C000-000000000046"],
    "IOleLink": ["0000011D-0000-0000-C000-000000000046"],
    "IOleWindow": ["00000114-0000-0000-C000-000000000046"],
    "IOleObject": ["00000112-0000-0000-C000-000000000046"],
    "IOleClientSite": ["00000118-0000-0000-C000-000000000046"],
    "IOleContainer": ["0000011B-0000-0000-C000-000000000046"],
    "IParseDisplayName": ["0000011A-0000-0000-C000-000000000046"],
    "IOleCacheControl": ["00000129-0000-0000-C000-000000000046"],
    "IOleCache2": ["00000128-0000-0000-C000-000000000046"],
    "IOleCache": ["0000011E-0000-0000-C000-000000000046"],
    "IOleAdviseHolder": ["00000111-0000-0000-C000-000000000046"],
    "IEnumSTATPROPBAG": ["20021801-5DE6-11D1-8E38-00C04FB9386D"],
    "IPropertyBagEx": ["20011801-5DE6-11D1-8E38-00C04FB9386D"],
    "IEnumSTATPROPSETSTG": ["0000013B-0000-0000-C000-000000000046"],
    "IEnumSTATPROPSTG": ["00000139-0000-0000-C000-000000000046"],
    "IPropertySetStorage": ["0000013A-0000-0000-C000-000000000046"],
    "IPropertyStorage": ["00000138-0000-0000-C000-000000000046"],
    "IOverlappedStream": ["49384070-E40A-11CE-B2C9-00AA00680937"],
    "IOverlappedCompletion": ["521A28F0-E40B-11CE-B2C9-00AA00680937"],
    "IAlertTarget": ["589B61C0-54E6-11CE-94DD-00AA0051E40F"],
    "IAlertReport": ["4E81DFE8-4CA0-101A-8206-08002B2FC09B"],
    "IClassFactory": ["00000001-0000-0000-C000-000000000046"],
    "AsyncIUnknown": ["000E0000-0000-0000-C000-000000000046"],
    "IBoundObjectSite": ["9BFBBC01-EFF1-101A-84ED-00AA00341D07"],
    "IBoundObject": ["9BFBBC00-EFF1-101A-84ED-00AA00341D07"],
    "IEntryID": ["E4D19810-D188-11CD-AD48-00AA003C9CB6"],
    "ICursorFind": ["E01D7850-D188-11CD-AD48-00AA003C9CB6"],
    "INotifyDBEvents": ["DB526CC0-D188-11CD-AD48-00AA003C9CB6"],
    "ICursorUpdateARow": ["D14216A0-D188-11CD-AD48-00AA003C9CB6"],
    "ICursorScroll": ["BB87E420-D188-11CD-AD48-00AA003C9CB6"],
    "ICursorMove": ["ACFF0690-D188-11CD-AD48-00AA003C9CB6"],
    "ICursor": ["9F6AA700-D188-11CD-AD48-00AA003C9CB6"],
    "StdOle": ["00020430-0000-0000-C000-000000000046"],
    "IPropertyFrame": ["B196B28A-BAB4-101A-B69C-00AA00341D07"],
    "IRichEditOleCallback": ["00020D03-0000-0000-C000-000000000046"],
    "IRichEditOle": ["00020D00-0000-0000-C000-000000000046"],
    "IDebugStream": ["00000124-0000-0000-C000-000000000046"],
    "IDebug": ["00000123-0000-0000-C000-000000000046"],
    "IOlePresObj": ["00000120-0000-0000-C000-000000000046"],
    "IOleManager": ["0000011F-0000-0000-C000-000000000046"],
    "IEnumCallback": ["00000108-0000-0000-C000-000000000046"],
    "IEnumHolder": ["00000107-0000-0000-C000-000000000046"],
    "IEnumGeneric": ["00000106-0000-0000-C000-000000000046"],
    "IProxy": ["00000027-0000-0000-C000-000000000046"],
    "IDfReserved3": ["00000015-0000-0000-C000-000000000046"],
    "IDfReserved2": ["00000014-0000-0000-C000-000000000046"],
    "IDfReserved1": ["00000013-0000-0000-C000-000000000046"],
    "IInternalMoniker": ["00000011-0000-0000-C000-000000000046"],
    "IPSFactory": ["00000009-0000-0000-C000-000000000046"],
    "IProxyManager": ["00000008-0000-0000-C000-000000000046"],
    "IRpcProxy": ["00000007-0000-0000-C000-000000000046"],
    "IStubManager": ["00000006-0000-0000-C000-000000000046"],
    "IRpcStub": ["00000005-0000-0000-C000-000000000046"],
    "IRpcChannel": ["00000004-0000-0000-C000-000000000046"],
    "ITrkRestoreParser": ["755939E3-E381-11D0-B1C5-00C04FB9386D"],
    "ITrkRestoreNotify": ["D0056F6B-E2A0-11D0-B1C2-00C04FB9386D"],
    "ITrkForceOwnership": ["A2531F44-C67D-11D0-8CB1-00C04FD90F85"],
    "ITrackFile": ["8790C948-A30B-11D0-8CAB-00C04FD90F85"],
    "IEnroll4": ["F8053FE5-78F4-448F-A0DB-41D61B73446B"],
    "IEnroll2": ["C080E199-B7DF-11D2-A421-00C04F79FE8E"],
    "IEnroll": ["ACAA7838-4585-11D1-AB57-00C04FC295E1"],
    "ICEnroll4": ["C1F1188A-2EB5-4A80-841B-7E729A356D90"],
    "ICEnroll3": ["C28C2D95-B7DE-11D2-A421-00C04F79FE8E"],
    "ICEnroll2": ["704CA730-C90B-11D1-9BEC-00C04FC295E1"],
    "ICEnroll": ["43F8F288-7A20-11D0-8F06-00C04FC295E1"],
    "ICatInformation": ["0002E013-0000-0000-C000-000000000046"],
    "ICatRegister": ["0002E012-0000-0000-C000-000000000046"],
    "IEnumCATEGORYINFO": ["0002E011-0000-0000-C000-000000000046"],
    "IEnumGUID": ["0002E000-0000-0000-C000-000000000046"],
    "ISyncMgrRegister": ["6295DF42-35EE-11D1-8707-00C04FD93327"],
    "ISyncMgrSynchronizeInvoke": ["6295DF2C-35EE-11D1-8707-00C04FD93327"],
    "ISyncMgrEnumItems": ["6295DF2A-35EE-11D1-8707-00C04FD93327"],
    "ISyncMgrSynchronizeCallback": ["6295DF41-35EE-11D1-8707-00C04FD93327"],
    "ISyncMgrSynchronize": ["6295DF40-35EE-11D1-8707-00C04FD93327"],
    "ISyncMgrRegisterCSC": ["47681A61-BC74-11D2-B5C5-00C04FB93981"],
    "IOldSyncMgrRegister": ["894D8C55-BDDF-11D1-B85D-00C04FB93981"],
    "IOldSyncMgrSynchronizeCallback": ["6295DF29-35EE-11D1-8707-00C04FD93327"],
    "IOldSyncMgrSynchronize": ["6295DF28-35EE-11D1-8707-00C04FD93327"],
    "IEnumSyncItems": ["F0E1589A-A700-11D1-9831-00C04FD910DD"],
    "ISyncSchedulep": ["F0E1589B-A700-11D1-9831-00C04FD910DD"],
    "ISyncSchedule": ["F0E15899-A700-11D1-9831-00C04FD910DD"],
    "IEnumSyncSchedules": ["F0E15898-A700-11D1-9831-00C04FD910DD"],
    "ISyncScheduleMgr": ["F0E15897-A700-11D1-9831-00C04FD910DD"],
    "IPrivSyncMgrSynchronizeInvoke": ["6295DF2E-35EE-11D1-8707-00C04FD93327"],
    "ISensLogon2": ["D597BAB4-5B9F-11D1-8DD2-00AA004ABD5E"],
    "ISensLogon": ["D597BAB3-5B9F-11D1-8DD2-00AA004ABD5E"],
    "ISensOnNow": ["D597BAB2-5B9F-11D1-8DD2-00AA004ABD5E"],
    "ISensNetwork": ["D597BAB1-5B9F-11D1-8DD2-00AA004ABD5E"],
    "IXMLNodeFactory": ["D242361F-51A0-11D2-9CAF-0060B0EC3D39"],
    "IXMLParser3": ["C9407B83-04E7-496A-AF26-A5677AEFCC86"],
    "IXMLParser2": ["50FB5B1A-A75C-4FF4-86B2-14C62189E2CC"],
    "IXMLParser": ["D242361E-51A0-11D2-9CAF-0060B0EC3D39"],
    "IXMLNodeSource": ["D242361D-51A0-11D2-9CAF-0060B0EC3D39"],
    "IXMLError": ["948C5AD3-C58D-11D0-9C0B-00C04FC99C8E"],
    "IXMLAttribute": ["D4D4A0FC-3B73-11D1-B2B4-00C04FB92596"],
    "IXMLElement2": ["2B8DE2FF-8D2D-11D1-B2FC-00C04FD915A9"],
    "IXMLElement": ["3F7F31AC-E15F-11D0-9C25-00C04FC99C8E"],
    "IXMLDocument2": ["2B8DE2FE-8D2D-11D1-B2FC-00C04FD915A9"],
    "IXMLDocument": ["F52E2B61-18A1-11D1-B105-00805F49916B"],
    "IXMLElementCollection": ["65725580-9B5D-11D0-9BFE-00C04FC99C8E"],
    "IXMLDSOControl": ["310AFA62-0575-11D2-9CA9-0060B0EC3D39"],
    "IXMLHttpRequest": ["ED8C108D-4349-11D2-91A4-00C04F7969E8"],
    "IXTLRuntime": ["3EFAA425-272F-11D2-836F-0000F87A7782"],
    "IXMLDOMParseError": ["3EFAA426-272F-11D2-836F-0000F87A7782"],
    "IXMLDOMEntityReference": ["2933BF8E-7B36-11D2-B20E-00C04F983E60"],
    "IXMLDOMEntity": ["2933BF8D-7B36-11D2-B20E-00C04F983E60"],
    "IXMLDOMNotation": ["2933BF8C-7B36-11D2-B20E-00C04F983E60"],
    "IXMLDOMDocumentType": ["2933BF8B-7B36-11D2-B20E-00C04F983E60"],
    "IXMLDOMCDATASection": ["2933BF8A-7B36-11D2-B20E-00C04F983E60"],
    "IXMLDOMProcessingInstruction": ["2933BF89-7B36-11D2-B20E-00C04F983E60"],
    "IXMLDOMComment": ["2933BF88-7B36-11D2-B20E-00C04F983E60"],
    "IXMLDOMText": ["2933BF87-7B36-11D2-B20E-00C04F983E60"],
    "IXMLDOMElement": ["2933BF86-7B36-11D2-B20E-00C04F983E60"],
    "IXMLDOMAttribute": ["2933BF85-7B36-11D2-B20E-00C04F983E60"],
    "IXMLDOMCharacterData": ["2933BF84-7B36-11D2-B20E-00C04F983E60"],
    "IXMLDOMNamedNodeMap": ["2933BF83-7B36-11D2-B20E-00C04F983E60"],
    "IXMLDOMNodeList": ["2933BF82-7B36-11D2-B20E-00C04F983E60"],
    "IXMLDOMDocument": ["2933BF81-7B36-11D2-B20E-00C04F983E60"],
    "IXMLDOMDocumentFragment": ["3EFAA413-272F-11D2-836F-0000F87A7782"],
    "IXMLDOMNode": ["2933BF80-7B36-11D2-B20E-00C04F983E60"],
    "IXMLDOMImplementation": ["2933BF8F-7B36-11D2-B20E-00C04F983E60"],
    "IActiveScriptAuthorProcedure": ["7E2D4B70-BD9A-11D0-9336-00A0C90DCAA9"],
    "IActiveScriptAuthor": ["9C109DA0-7006-11D1-B36C-00A0C911E8B2"],
    "IScriptScriptlet": ["0AEE2A96-BCBB-11D0-8C72-00C04FC2B085"],
    "IScriptEntry": ["0AEE2A95-BCBB-11D0-8C72-00C04FC2B085"],
    "IScriptNode": ["0AEE2A94-BCBB-11D0-8C72-00C04FC2B085"],
    "IProvideExpressionContexts": ["51973C41-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IEnumDebugExpressionContexts": ["51973C40-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IDebugHelper": ["51973C3F-CB0C-11D0-B5C9-00A0244A0E7A"],
    "ISimpleConnectionPoint": ["51973C3E-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IDebugFormatter": ["51973C05-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IEnumRemoteDebugApplicationThreads": ["51973C3C-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IEnumRemoteDebugApplications": ["51973C3B-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IEnumDebugApplicationNodes": ["51973C3A-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IDebugCookie": ["51973C39-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IDebugApplicationThread64": ["9DAC5886-DBAD-456D-9DEE-5DEC39AB3DDA"],
    "IDebugApplicationThread": ["51973C38-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IRemoteDebugApplicationThread": ["51973C37-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IDebugThreadCall64": ["CB3FA335-E979-42FD-9FCF-A7546A0F3905"],
    "IDebugThreadCall32": ["51973C36-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IDebugApplicationNodeEvents": ["51973C35-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IDebugApplicationNode": ["51973C34-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IRemoteDebugApplicationEvents": ["51973C33-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IDebugApplication64": ["4DEDC754-04C7-4F10-9E60-16A390FE6E62"],
    "IDebugApplication32": ["51973C32-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IRemoteDebugApplication": ["51973C30-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IProcessDebugManager64": ["56B9FC1C-63A9-4CC1-AC21-087D69A17FAB"],
    "IProcessDebugManager32": ["51973C2F-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IMachineDebugManagerEvents": ["51973C2E-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IMachineDebugManagerCookie": ["51973C2D-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IMachineDebugManager": ["51973C2C-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IApplicationDebuggerUI": ["51973C2B-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IApplicationDebugger": ["51973C2A-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IDebugSessionProvider": ["51973C29-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IDebugDocumentContext": ["51973C28-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IDebugDocumentHost": ["51973C27-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IDebugDocumentHelper64": ["C4C7363C-20FD-47F9-BD82-4855E0150871"],
    "IDebugDocumentHelper32": ["51973C26-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IDebugDocumentTextExternalAuthor": ["51973C25-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IDebugDocumentTextAuthor": ["51973C24-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IDebugDocumentTextEvents": ["51973C23-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IDebugDocumentText": ["51973C22-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IDebugDocument": ["51973C21-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IDebugDocumentProvider": ["51973C20-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IDebugDocumentInfo": ["51973C1F-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IEnumDebugStackFrames64": ["0DC38853-C1B0-4176-A984-B298361027AF"],
    "IEnumDebugStackFrames": ["51973C1E-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IEnumDebugCodeContexts": ["51973C1D-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IDebugAsyncOperationCallBack": ["51973C1C-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IDebugAsyncOperation": ["51973C1B-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IDebugSyncOperation": ["51973C1A-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IDebugStackFrameSnifferEx64": ["8CD12AF4-49C1-4D52-8D8A-C146F47581AA"],
    "IDebugStackFrameSnifferEx32": ["51973C19-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IDebugStackFrameSniffer": ["51973C18-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IDebugStackFrame": ["51973C17-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IDebugExpressionCallBack": ["51973C16-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IDebugExpressionContext": ["51973C15-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IDebugExpression": ["51973C14-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IDebugCodeContext": ["51973C13-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IActiveScriptErrorDebug": ["51973C12-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IActiveScriptSiteDebug64": ["D6B96B0A-7463-402C-92AC-89984226942F"],
    "IActiveScriptSiteDebug32": ["51973C11-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IActiveScriptDebug64": ["BC437E23-F5B8-47F4-BB79-7D1CE5483B86"],
    "IActiveScriptDebug32": ["51973C10-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IActiveScriptTraceInfo": ["C35456E7-BEBF-4A1B-86A9-24D56BE8B369"],
    "IActiveScriptSiteTraceInfo": ["4B7272AE-1955-4BFE-98B0-780621888569"],
    "IActiveScriptSIPInfo": ["764651D0-38DE-11D4-A2A3-00104BD35090"],
    "IActiveScriptGarbageCollector": ["6AA2C4A0-2B53-11D4-A2A0-00104BD35090"],
    "ITridentEventSink": ["1DC9CA50-06EF-11D2-8415-006008C3FBFC"],
    "IActiveScriptProperty": ["4954E0D0-FBC7-11D1-8410-006008C3FBFC"],
    "IActiveScriptStats": ["B8DA6310-E19B-11D0-933C-00A0C90DCAA9"],
    "IBindEventHandler": ["63CDBCB0-C1B1-11D0-9336-00A0C90DCAA9"],
    "IActiveScriptHostEncode": ["BEE9B76E-CFE3-11D1-B747-00C04FC2B085"],
    "IActiveScriptEncode": ["BB1A2AE3-A4F9-11CF-8F20-00805F2CD064"],
    "IActiveScriptParseProcedure2_64": ["FE7C4271-210C-448D-9F54-76DAB7047B28"],
    "IActiveScriptParseProcedure2_32": ["71EE5B20-FB04-11D1-B3A8-00A0C911E8B2"],
    "IActiveScriptParseProcedure64": ["C64713B6-E029-4CC5-9200-438B72890B6A"],
    "IActiveScriptParseProcedure32": ["AA5B6A80-B834-11D0-932F-00A0C90DCAA9"],
    "IActiveScriptParseProcedureOld64": ["21F57128-08C9-4638-BA12-22D15D88DC5C"],
    "IActiveScriptParseProcedureOld32": ["1CFF0050-6FDD-11D0-9328-00A0C90DCAA9"],
    "IActiveScriptParse64": ["C7EF7658-E1EE-480E-97EA-D52CB4D76D17"],
    "IActiveScriptParse32": ["BB1A2AE2-A4F9-11CF-8F20-00805F2CD064"],
    "IActiveScript": ["BB1A2AE1-A4F9-11CF-8F20-00805F2CD064"],
    "IActiveScriptSiteInterruptPoll": ["539698A0-CDCA-11CF-A5EB-00AA0047A063"],
    "IActiveScriptSiteWindow": ["D10F6761-83E9-11CF-8F20-00805F2CD064"],
    "IActiveScriptError64": ["B21FB2A1-5B8F-4963-8C21-21450F84ED7F"],
    "IActiveScriptError": ["EAE1BA61-A4ED-11CF-8F20-00805F2CD064"],
    "IActiveScriptSite": ["DB01A1E3-A42B-11CF-8F20-00805F2CD064"],
    "IMailProtocolADEntry": ["40EF8C68-D554-47ED-AA37-E5FB6BC91075"],
    "IAccountDiscovery": ["FA202BBC-6ABE-4C17-B184-570B6CF256A6"],
    "IMailAutoDiscovery": ["80402DEE-B114-4D32-B44E-82FD8234C92A"],
    "IAutoDiscoveryProvider": ["9DCF4A37-01DE-4549-A9CB-3AC31EC23C4F"],
    "IDebugPropertyEnumType_Registers": ["51973C59-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IDebugPropertyEnumType_LocalsPlusArgs": ["51973C58-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IDebugPropertyEnumType_Arguments": ["51973C57-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IDebugPropertyEnumType_Locals": ["51973C56-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IDebugPropertyEnumType_All": ["51973C55-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IPerPropertyBrowsing2": ["51973C54-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IEnumDebugExtendedPropertyInfo": ["51973C53-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IDebugExtendedProperty": ["51973C52-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IEnumDebugPropertyInfo": ["51973C51-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IDebugProperty": ["51973C50-CB0C-11D0-B5C9-00A0244A0E7A"],
    "IActiveIME2": ["E1C4BF0E-2D53-11D2-93E1-0060B067B86E"],
    "IActiveIME": ["6FE20962-D077-11D0-8FE7-00AA006BCC59"],
    "IActiveIMMIME": ["08C03411-F96B-11D0-A475-00AA006BCC59"],
    "IActiveIMMApp": ["08C0E040-62D1-11D1-9326-0060B067B86E"],
    "IActiveIMMMessagePumpOwner": ["B5CF2CFA-8AEB-11D1-9364-0060B067B86E"],
    "IActiveIMMRegistrar": ["B3458082-BD00-11D1-939B-0060B067B86E"],
    "IEnumInputContext": ["09B5EAB0-F997-11D1-93D4-0060B067B86E"],
    "IEnumRegisterWordW": ["4955DD31-B159-11D0-8FCF-00AA006BCC59"],
    "IEnumRegisterWordA": ["08C03412-F96B-11D0-A475-00AA006BCC59"],
    "IProvideRuntimeContext": ["10E2414A-EC59-49D2-BC51-5ADD2C36FEBC"],
    "IObjectIdentity": ["CA04B7E6-0D21-11D1-8CC5-00C04FC2B085"],
    "IVariantChangeType": ["A6EF9862-C720-11D0-9337-00A0C90DCAA9"],
    "IDispError": ["A6EF9861-C720-11D0-9337-00A0C90DCAA9"],
    "IDispatchEx": ["A6EF9860-C720-11D0-9337-00A0C90DCAA9"],
    "IDownloadManager": ["988934A4-064B-11D3-BB80-00104B35E7F9"],
    "IOleCommandTarget": ["B722BCCB-4E68-101B-A2BC-00AA00404770"],
    "IPrint": ["B722BCC9-4E68-101B-A2BC-00AA00404770"],
    "IContinueCallback": ["B722BCCA-4E68-101B-A2BC-00AA00404770"],
    "IEnumOleDocumentViews": ["B722BCC8-4E68-101B-A2BC-00AA00404770"],
    "IOleDocumentView": ["B722BCC6-4E68-101B-A2BC-00AA00404770"],
    "IOleDocumentSite": ["B722BCC7-4E68-101B-A2BC-00AA00404770"],
    "IOleDocument": ["B722BCC5-4E68-101B-A2BC-00AA00404770"],
    "IDownloadNotify": ["CAEB5D28-AE4C-11D1-BA40-00C04FB92D79"],
    "IDXTICMFilter": ["734321ED-1E7B-4E1C-BBFA-89C819800E2F"],
    "IDXTMatrix": ["AC66A493-0F0C-4C76-825C-9D68BEDE9188"],
    "IDXTMotionBlur": ["089057BE-D3F5-4A2C-B10A-A5130184A0F7"],
    "IDXTLight": ["F9EFBEC1-4302-11D2-952A-00C04FA34F05"],
    "IDXTWave": ["1D4637E7-383C-11D2-952A-00C04FA34F05"],
    "IDXTShadow": ["1D4637E6-383C-11D2-952A-00C04FA34F05"],
    "IDXTGlow": ["1D4637E4-383C-11D2-952A-00C04FA34F05"],
    "IDXTAlpha": ["1D4637E0-383C-11D2-952A-00C04FA34F05"],
    "IDXTMetaWormHole": ["0E6AE021-0C83-11D2-8CD4-00104BC75D9A"],
    "IDXTMetaThreshold": ["2A54C914-07AA-11D2-8D6D-00C04F8EF8E0"],
    "IDXTMetaGriddler2": ["2A54C912-07AA-11D2-8D6D-00C04F8EF8E0"],
    "IDXTMetaGriddler": ["2A54C910-07AA-11D2-8D6D-00C04F8EF8E0"],
    "IDXTMetaVacuum": ["2A54C90C-07AA-11D2-8D6D-00C04F8EF8E0"],
    "IDXTMetaFlowMotion": ["2A54C90A-07AA-11D2-8D6D-00C04F8EF8E0"],
    "IDXTMetaColorFade": ["2A54C907-07AA-11D2-8D6D-00C04F8EF8E0"],
    "IDXTMetaJaws": ["2A54C903-07AA-11D2-8D6D-00C04F8EF8E0"],
    "IDXTMetaBurnFilm": ["107045D0-06E0-11D2-8D6D-00C04F8EF8E0"],
    "IDXTMetaTwister": ["107045CE-06E0-11D2-8D6D-00C04F8EF8E0"],
    "IDXTMetaWhiteOut": ["107045CB-06E0-11D2-8D6D-00C04F8EF8E0"],
    "IDXTMetaRadialScaleWipe": ["107045C9-06E0-11D2-8D6D-00C04F8EF8E0"],
    "IDXTMetaLightWipe": ["107045C7-06E0-11D2-8D6D-00C04F8EF8E0"],
    "IDXTMetaWater": ["107045C4-06E0-11D2-8D6D-00C04F8EF8E0"],
    "IDXTMetaPeelSplit": ["AA0D4D11-06A3-11D2-8F98-00C04FB92EB7"],
    "IDXTMetaPeelPiece": ["AA0D4D0F-06A3-11D2-8F98-00C04FB92EB7"],
    "IDXTMetaPeelSmall": ["AA0D4D0D-06A3-11D2-8F98-00C04FB92EB7"],
    "IDXTMetaCenterPeel": ["AA0D4D0B-06A3-11D2-8F98-00C04FB92EB7"],
    "IDXTMetaLiquid": ["AA0D4D09-06A3-11D2-8F98-00C04FB92EB7"],
    "IDXTMetaPageTurn": ["AA0D4D07-06A3-11D2-8F98-00C04FB92EB7"],
    "IDXTMetaRipple": ["AA0D4D02-06A3-11D2-8F98-00C04FB92EB7"],
    "IDXTMetaRoll": ["9C61F46D-0530-11D2-8F98-00C04FB92EB7"],
    "IDXTStrips": ["A83C9B5C-FB11-4AF5-8F65-D03F151D3ED5"],
    "IDXTRandomBars": ["8A6D2022-4A8F-4EB9-BB25-AA05201F9C84"],
    "IDXTAlphaImageLoader": ["A5F2D3E8-7A7E-48E5-BC75-40790BE4A941"],
    "IDXTRedirect": ["02F5140B-626F-4019-9C9E-2DAA1E93E8FC"],
    "IDXTMask": ["A1067146-B063-47D7-A54A-2C2309E9889D"],
    "IDXTRevealTrans": ["B8095006-A128-464B-8B2D-90580AEE2B05"],
    "IDXTCheckerBoard": ["AD3C2576-117C-4510-84DD-B668971DCFD1"],
    "IDXTDropShadow": ["1D4637E3-383C-11D2-952A-00C04FA34F05"],
    "IDXTChroma": ["1D4637E2-383C-11D2-952A-00C04FA34F05"],
    "ICrWheel": ["3943DE80-1464-11D2-A484-00C04F8EFB69"],
    "ICrZigzag": ["4E5A64A0-0C8B-11D2-A484-00C04F8EFB69"],
    "ICrSpiral": ["0DE527A0-0C7E-11D2-A484-00C04F8EFB69"],
    "IDXTGridSize": ["D6BBE91E-FF60-11D2-8F6E-00A0C9697274"],
    "ICrStretch": ["6684AF00-0A87-11D2-A484-00C04F8EFB69"],
    "ICrInset": ["05C5EE20-0BA6-11D2-A484-00C04F8EFB69"],
    "ICrBlinds2": ["7059D403-599A-4264-8140-641EB8AE1F64"],
    "ICrBlinds": ["5AF5C340-0BA9-11D2-A484-00C04F8EFB69"],
    "ICrBarn2": ["B66A7A1B-8FC6-448C-A2EB-3C55957478A1"],
    "ICrBarn": ["276A2EE0-0B5D-11D2-A484-00C04F8EFB69"],
    "ICrRadialWipe": ["424B71AE-0695-11D2-A484-00C04F8EFB69"],
    "ICrSlide": ["810E402E-056B-11D2-A484-00C04F8EFB69"],
    "ICrIris2": ["F7B06961-BA8C-4970-918B-1C60CB9FF180"],
    "ICrIris": ["3F69F350-0379-11D2-A484-00C04F8EFB69"],
    "IDXPixelate": ["D33E180F-FBE9-11D1-906A-00C04FD9189D"],
    "IDXBasicImage": ["16B280C7-EE70-11D1-9066-00C04FD9189D"],
    "IDXTFade": ["16B280C4-EE70-11D1-9066-00C04FD9189D"],
    "ICrEmboss": ["E4ACFB80-053E-11D2-81EA-0000F87557DB"],
    "ICrEngrave": ["E4ACFB7F-053E-11D2-81EA-0000F87557DB"],
    "ICrBlur": ["9F7C7827-E87A-11D1-81E0-0000F87557DB"],
    "IDXTWipe2": ["E1FF8091-442B-4801-88B6-2B47B1611FD2"],
    "IDXTWipe": ["AF279B2F-86EB-11D1-81BF-0000F87557DB"],
    "IDXTComposite": ["9A43A843-0831-11D1-817F-0000F87557DB"],
    "IDXDMapper": ["7FD9088B-35ED-11D1-81A1-0000F87557DB"],
    "IDXMapper": ["555278E5-05DB-11D1-883A-3C8B00C10000"],
    "IDXTConvolution": ["7BA7F8AF-E5EA-11D1-81DD-0000F87557DB"],
    "IDXTGradientD": ["623E2881-FC0E-11D1-9A77-0000F8756A10"],
    "IDXDLUTBuilder": ["73068231-35EE-11D1-81A1-0000F87557DB"],
    "IDXLUTBuilder": ["F4370FC1-CADB-11D0-B52C-00A0C9054373"],
    "ICSSFilterDispatch": ["9519152B-9484-4A6C-B6A7-4F25E92D6C6B"],
    "IObjectWithBehaviorSite": ["B03DCBE3-DDDB-48CC-9961-74DCA693BFB2"],
    "IHTMLDXTransform": ["30E2AB7D-4FDD-4159-B7EA-DC722BF4ADE5"],
    "IDXRawSurface": ["09756C8A-D96A-11D1-9062-00C04FD9189D"],
    "IDXLookupTable": ["01BAFC7F-9E63-11D1-9053-00C04FD9189D"],
    "IDXEffect": ["E31FB81B-1335-11D1-8189-0000F87557DB"],
    "IDXTScale": ["B39FD742-E139-11D1-9065-00C04FD9189D"],
    "IDXGradient": ["B2024B51-EE77-11D1-9066-00C04FD9189D"],
    "IDXTScaleOutput": ["B2024B50-EE77-11D1-9066-00C04FD9189D"],
    "IDXDCLock": ["0F619456-CF39-11D1-905E-00C04FD9189D"],
    "IDXARGBReadWritePtr": ["EAAAC2D7-C290-11D1-905D-00C04FD9189D"],
    "IDXARGBReadPtr": ["EAAAC2D6-C290-11D1-905D-00C04FD9189D"],
    "IDXARGBSurfaceInit": ["9EA3B63A-C37D-11D1-905E-00C04FD9189D"],
    "IDXSurfaceInit": ["9EA3B639-C37D-11D1-905E-00C04FD9189D"],
    "IDXSurface": ["B39FD73F-E139-11D1-9065-00C04FD9189D"],
    "IDXSurfaceModifier": ["9EA3B637-C37D-11D1-905E-00C04FD9189D"],
    "IDXSurfaceFactory": ["144946F5-C4D4-11D1-81D1-0000F87557DB"],
    "IDXTaskManager": ["254DBBC1-F922-11D0-883A-3C8B00C10000"],
    "IDXTBindHost": ["D26BCE55-E9DC-11D1-9066-00C04FD9189D"],
    "IDXTransform": ["30A5FB78-E11F-11D1-9064-00C04FD9189D"],
    "IDXTransformFactory": ["6A950B2B-A971-11D1-81C8-0000F87557DB"],
    "IDXBaseObject": ["17B59B2B-9CC8-11D1-9053-00C04FD9189D"],
    "IDXTClipOrigin": ["EE1663D8-0988-4C48-9FD6-DB4450885668"],
    "IDXTRedirectFilterInit": ["D1A57094-21F7-4E6C-93E5-F5F77F748293"],
    "IDXTFilterController": ["5CF315F2-273D-47B6-B9ED-F75DC3B0150B"],
    "IDXTFilter": ["6187E5A2-A445-4608-8FC0-BE7A6C8DB386"],
    "IDXTFilterCollection": ["22B07B33-8BFB-49D4-9B90-0938370C9019"],
    "IDXTFilterBehaviorSite": ["909B23C2-9018-499F-A86D-4E7DA937E931"],
    "IDXTFilterBehavior": ["14D7DDDD-ACA2-4E45-9504-3808ABEB4F92"],
    "IDXGradient2": ["D0EF2A80-61DC-11D2-B2EB-00A0C936B212"],
    "IDX2D": ["9EFD02A9-A996-11D1-81C9-0000F87557DB"],
    "IDX2DDebug": ["03BB2457-A279-11D1-81C6-0000F87557DB"],
    "IDXTLabel": ["C0C17F0E-AE41-11D1-9A3B-0000F8756A10"],
    "IDXRasterizer": ["9EA3B635-C37D-11D1-905E-00C04FD9189D"],
    "ISearchAssistantOC3": ["72423E8F-8011-11D2-BE79-00A0C9A83DA3"],
    "ISearchAssistantOC2": ["72423E8F-8011-11D2-BE79-00A0C9A83DA2"],
    "ISearchAssistantOC": ["72423E8F-8011-11D2-BE79-00A0C9A83DA1"],
    "ISearches": ["47C922A2-3DD5-11D2-BF8B-00C04FB93661"],
    "ISearch": ["BA9239A4-3DD5-11D2-BF8B-00C04FB93661"],
    "IScriptErrorList": ["F3470F24-15FD-11D2-BB2E-00805FF7EFCA"],
    "IShellNameSpace": ["E572D3C9-37BE-4AE2-825D-D521763E3108"],
    "IShellFavoritesNameSpace": ["55136804-B2DE-11D1-B9F2-00A0C98BC547"],
    "IShellUIHelper": ["729FE2F8-1EA8-11D1-8F85-00C04FC2FBE1"],
    "IShellWindows": ["85CB6900-4D95-11CF-960C-0080C7F4EE85"],
    "IWebBrowser2": ["D30C1661-CDAF-11D0-8A3E-00C04FC9E26E"],
    "IWebBrowserApp": ["0002DF05-0000-0000-C000-000000000046"],
    "IWebBrowser": ["EAB22AC1-30C1-11CF-A7EB-0000C05BAE0B"],
    "ITargetFramePriv": ["9216E421-2BF5-11D0-82B4-00A0C90C29C5"],
    "ITargetEmbedding": ["548793C0-9E74-11CF-9655-00A0C9034923"],
    "ITargetFrame": ["D5F78C80-5252-11CF-90FA-00AA0042106E"],
    "ITargetContainer": ["7847EC01-2BEC-11D0-82B4-00A0C90C29C5"],
    "ITargetFrame2": ["86D52E11-94A8-11D0-82AF-00C04FD5AE38"],
    "ITargetNotify2": ["3050F6B1-98B5-11CF-BB82-00AA00BDCE0B"],
    "ITargetNotify": ["863A99A0-21BC-11D0-82B4-00A0C90C29C5"],
    "IHTMLViewFilterSite": ["3050F2F4-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLViewFilter": ["3050F2F1-98B5-11CF-BB82-00AA00BDCE0B"],
    "IWinHttpRequestEvents": ["F97F4E15-B787-4212-80D1-D380CBBF982E"],
    "IWinHttpRequest": ["016FE2EC-B2C8-45F8-B23B-39E53A75396B"],
    "IDialBranding": ["8AECAFA9-4306-43CC-8C5A-765F2979CC16"],
    "IDialEngine": ["39FD782B-7905-40D5-9148-3C9B190423D5"],
    "IDialEventSink": ["2D86F4FF-6E2D-4488-B2E9-6934AFD41BEA"],
    "IUtilityButton": ["3050F6AF-98B5-11CF-BB82-00AA00BDCE0B"],
    "ISliderBar": ["3050F68D-98B5-11CF-BB82-00AA00BDCE0B"],
    "ISpinButton": ["3050F68B-98B5-11CF-BB82-00AA00BDCE0B"],
    "IScrollBar": ["3050F689-98B5-11CF-BB82-00AA00BDCE0B"],
    "IRadioButton": ["3050F69B-98B5-11CF-BB82-00AA00BDCE0B"],
    "ICheckBox": ["3050F685-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLSelectElement3": ["3050F687-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLOptionElement2": ["3050F697-98B5-11CF-BB82-00AA00BDCE0B"],
    "ICombobox": ["3050F677-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHeaderFooter": ["3050F6CE-98B5-11CF-BB82-00AA00BDCE0B"],
    "ITemplatePrinter2": ["3050F83F-98B5-11CF-BB82-00AA00BDCE0B"],
    "ITemplatePrinter": ["3050F6B4-98B5-11CF-BB82-00AA00BDCE0B"],
    "IDeviceRect": ["3050F6D5-98B5-11CF-BB82-00AA00BDCE0B"],
    "ILayoutRect": ["3050F665-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHtmlArea": ["3050F64E-98B5-11CF-BB82-00AA00BDCE0B"],
    "IDownloadBehavior": ["3050F5BD-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLPersistData": ["3050F4C5-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLPersistDataOM": ["3050F4C0-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLUserDataOM": ["3050F48F-98B5-11CF-BB82-00AA00BDCE0B"],
    "IAnchorClick": ["13D5413B-33B9-11D2-95A7-00C04F8ECB02"],
    "Iwfolders": ["BAE31F98-1B81-11D2-A97A-00C04F8ECB02"],
    "IIntelliForms": ["9B9F68E6-1AAA-11D2-BCA5-00C04FD929DB"],
    "IClientCaps": ["7E8BC44D-AEFF-11D1-89C2-00C04FB6BFC4"],
    "IHomePage": ["766BF2AF-D650-11D1-9811-00C04FC31D2E"],
    "IPeerFactory": ["6663F9D3-B482-11D1-89C6-00C04FB6BFC4"],
    "IDithererImpl": ["7C48E840-3910-11D0-86FC-00A0C913F750"],
    "ISniffStream": ["4EF17940-30E0-11D0-B724-00AA006C1A01"],
    "IElementNamespacePrivate": ["3050F7FF-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLFilterPaintSite": ["3050F6D3-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLFilterPainter": ["3050F6DE-98B5-11CF-BB82-00AA00BDCE0B"],
    "IPrivacyServices": ["3050F84B-98B5-11CF-BB82-00AA00BDCE0B"],
    "IEditDebugServices": ["3050F60B-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLEditingServices": ["3050F7FB-98B5-11CF-BB82-00AA00BDCE0B"],
    "IElementAdorner": ["3050F607-98B5-11CF-BB82-00AA00BDCE0B"],
    "IElementBehaviorUI": ["3050F4BF-98B5-11CF-BB82-00AA00BDCE0B"],
    "ISubDivisionProvider": ["3050F4D2-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLPrivateWindow3": ["3050F840-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLPrivateWindow2": ["3050F7E5-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLPrivateWindow": ["3050F6DC-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLEditor": ["3050F7FA-98B5-11CF-BB82-00AA00BDCE0B"],
    "ISelectionObject2": ["3050F7FC-98B5-11CF-BB82-00AA00BDCE0B"],
    "IMimeInfo": ["F77459A0-BF9A-11CF-BA4E-00C04FD70816"],
    "IHTMLOMWindowServices": ["3050F5FC-98B5-11CF-BB82-00AA00BDCE0B"],
    "IClassFactoryEx": ["342D1EA0-AE25-11D1-89C5-006008C3FBFC"],
    "IDocHostShowUI": ["C4D244B0-D43E-11CF-893B-00AA00BDCE1A"],
    "ICustomDoc": ["3050F3F0-98B5-11CF-BB82-00AA00BDCE0B"],
    "IDocHostUIHandler2": ["3050F6D0-98B5-11CF-BB82-00AA00BDCE0B"],
    "IDocHostUIHandler": ["BD3F23C0-D43E-11CF-893B-00AA00BDCE1A"],
    "IHostDialogHelper": ["53DEC138-A51E-11D2-861E-00C04FA35C89"],
    "IHostBehaviorInit": ["3050F842-98B5-11CF-BB82-00AA00BDCE0B"],
    "IElementBehaviorSiteLayout2": ["3050F847-98B5-11CF-BB82-00AA00BDCE0B"],
    "IElementBehaviorSiteLayout": ["3050F6B7-98B5-11CF-BB82-00AA00BDCE0B"],
    "IElementBehaviorLayout2": ["3050F846-98B5-11CF-BB82-00AA00BDCE0B"],
    "IElementBehaviorLayout": ["3050F6BA-98B5-11CF-BB82-00AA00BDCE0B"],
    "IElementBehaviorFocus": ["3050F6B6-98B5-11CF-BB82-00AA00BDCE0B"],
    "IElementBehaviorSubmit": ["3050F646-98B5-11CF-BB82-00AA00BDCE0B"],
    "IElementBehaviorSiteCategory": ["3050F4EE-98B5-11CF-BB82-00AA00BDCE0B"],
    "IElementBehaviorCategory": ["3050F4ED-98B5-11CF-BB82-00AA00BDCE0B"],
    "IElementBehaviorSiteOM2": ["3050F659-98B5-11CF-BB82-00AA00BDCE0B"],
    "IElementNamespaceFactoryCallback": ["3050F7FD-98B5-11CF-BB82-00AA00BDCE0B"],
    "IElementNamespaceFactory2": ["3050F805-98B5-11CF-BB82-00AA00BDCE0B"],
    "IElementNamespaceFactory": ["3050F672-98B5-11CF-BB82-00AA00BDCE0B"],
    "IElementNamespaceTable": ["3050F670-98B5-11CF-BB82-00AA00BDCE0B"],
    "IElementNamespace": ["3050F671-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLAppBehavior3": ["3050F5CD-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLAppBehavior2": ["3050F5C9-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLAppBehavior": ["3050F5CA-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLPopup": ["3050F666-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLModelessInit": ["3050F5E4-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLDialog3": ["3050F388-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLDialog2": ["3050F5E0-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLDialog": ["3050F216-98B5-11CF-BB82-00AA00BDCE0B"],
    "IEnumPrivacyRecords": ["3050F844-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLIPrintCollection": ["3050F6B5-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLPainterOverlay": ["3050F7E3-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLPainterEventInfo": ["3050F6DF-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLPaintSite": ["3050F6A7-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLPainter": ["3050F6A6-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLNamespaceCollection": ["3050F6B8-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLNamespace": ["3050F6BB-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLComputedStyle": ["3050F6C3-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLEditServices2": ["3050F812-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLEditServices": ["3050F663-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLEditDesigner": ["3050F662-98B5-11CF-BB82-00AA00BDCE0B"],
    "ISelectionServices": ["3050F684-98B5-11CF-BB82-00AA00BDCE0B"],
    "ISelectionServicesListener": ["3050F699-98B5-11CF-BB82-00AA00BDCE0B"],
    "IIMEServices": ["3050F6CA-98B5-11CF-BB82-00AA00BDCE0B"],
    "ISequenceNumber": ["3050F6C1-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLEditHost2": ["3050F848-98B5-11CF-BB82-00AA00BDCE0D"],
    "IHTMLEditHost": ["3050F6A0-98B5-11CF-BB82-00AA00BDCE0B"],
    "IXMLGenericParse": ["E4E23071-4D07-11D2-AE76-0080C73BC199"],
    "IMarkupTextFrags": ["3050F5FA-98B5-11CF-BB82-00AA00BDCE0B"],
    "IMarkupPointer2": ["3050F675-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLChangePlayback": ["3050F6E0-98B5-11CF-BB82-00AA00BDCE0B"],
    "IMarkupServices2": ["3050F682-98B5-11CF-BB82-00AA00BDCE0B"],
    "IMarkupServices": ["3050F4A0-98B5-11CF-BB82-00AA00BDCE0B"],
    "ISecureUrlHost": ["C81984C4-74C8-11D2-BAA9-00C04FC2040E"],
    "ICSSFilter": ["3050F3EC-98B5-11CF-BB82-00AA00BDCE0B"],
    "IFontNames": ["3050F839-98B5-11CF-BB82-00AA00BDCE0B"],
    "IBlockFormats": ["3050F830-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHtmlDlgSafeHelper": ["3050F81A-98B5-11CF-BB82-00AA00BDCE0B"],
    "IDisplayServices": ["3050F69D-98B5-11CF-BB82-00AA00BDCE0B"],
    "IDisplayPointer": ["3050F69E-98B5-11CF-BB82-00AA00BDCE0B"],
    "ILineInfo": ["3050F7E2-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHighlightRenderingServices": ["3050F606-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHighlightSegment": ["3050F690-98B5-11CF-BB82-00AA00BDCE0B"],
    "IElementSegment": ["3050F68F-98B5-11CF-BB82-00AA00BDCE0B"],
    "ISegment": ["3050F683-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLCaret": ["3050F604-98B5-11CF-BB82-00AA00BDCE0B"],
    "ISegmentListIterator": ["3050F692-98B5-11CF-BB82-00AA00BDCE0B"],
    "ISegmentList": ["3050F605-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLChangeSink": ["3050F64A-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLChangeLog": ["3050F649-98B5-11CF-BB82-00AA00BDCE0B"],
    "IMarkupContainer2": ["3050F648-98B5-11CF-BB82-00AA00BDCE0B"],
    "IMarkupContainer": ["3050F5F9-98B5-11CF-BB82-00AA00BDCE0B"],
    "IMarkupPointer": ["3050F49F-98B5-11CF-BB82-00AA00BDCE0B"],
    "ICSSFilterSite": ["3050F3ED-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLStyleFontFace": ["3050F3D5-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLStyleElement": ["3050F375-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLOptionsHolder": ["3050F378-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLFontSizesCollection": ["3050F377-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLFontNamesCollection": ["3050F376-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLBGsound": ["3050F369-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLFrameSetElement2": ["3050F5C6-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLFrameSetElement": ["3050F319-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLSpanFlow": ["3050F3E5-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLLegendElement2": ["3050F834-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLLegendElement": ["3050F3EA-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLFieldSetElement2": ["3050F833-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLFieldSetElement": ["3050F3E7-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLDivPosition": ["3050F212-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLIFrameElement2": ["3050F4E6-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLIFrameElement": ["3050F315-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLFrameElement2": ["3050F7F5-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLFrameElement": ["3050F313-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLFrameBase3": ["3050F82E-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLFrameBase2": ["3050F6DB-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLParamElement": ["3050F83D-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLObjectElement3": ["3050F827-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLObjectElement2": ["3050F4CD-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLObjectElement": ["3050F24F-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLNoShowElement": ["3050F38A-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLScriptElement2": ["3050F828-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLScriptElement": ["3050F28B-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLTableCell2": ["3050F82D-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLTableCell": ["3050F23D-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLTableRowMetrics": ["3050F413-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLTableRow3": ["3050F82C-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLTableRow2": ["3050F4A1-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLTableRow": ["3050F23C-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLTableSection3": ["3050F82B-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLTableSection2": ["3050F5C7-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLTableCol2": ["3050F82A-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLTableCol": ["3050F23A-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLTable3": ["3050F829-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLTable2": ["3050F4AD-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLTable": ["3050F21E-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLTableSection": ["3050F23B-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLSpanElement": ["3050F3F3-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLPhraseElement2": ["3050F824-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLPhraseElement": ["3050F20A-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLCommentElement2": ["3050F813-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLCommentElement": ["3050F20C-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLTableCaption": ["3050F2EB-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLAreaElement": ["3050F265-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLMapElement": ["3050F266-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLAreasCollection3": ["3050F837-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLAreasCollection2": ["3050F5EC-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLAreasCollection": ["3050F383-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLEmbedElement": ["3050F25F-98B5-11CF-BB82-00AA00BDCE0B"],
    "IWBScriptControl": ["A5170870-0CF8-11D1-8B91-0080C744F389"],
    "IWebBridge": ["AE24FDAD-03C6-11D1-8B76-0080C744F389"],
    "IHTMLDocument5": ["3050F80C-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLDocument4": ["3050F69A-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLDocument3": ["3050F485-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLWindow4": ["3050F6CF-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLScreen2": ["3050F84A-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLScreen": ["3050F35C-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLFrameBase": ["3050F311-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLWindow3": ["3050F4AE-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLWindow2": ["332C4427-26CB-11D0-B483-00C04FD90119"],
    "IHTMLFramesCollection2": ["332C4426-26CB-11D0-B483-00C04FD90119"],
    "IHTMLDocument2": ["332C4425-26CB-11D0-B483-00C04FD90119"],
    "IHTMLEventObj4": ["3050F814-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLEventObj3": ["3050F680-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLEventObj2": ["3050F48B-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLDataTransfer": ["3050F4B3-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLBookmarkCollection": ["3050F4CE-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLLocation": ["163BB1E0-6E00-11CF-837A-48DC04C10000"],
    "IOmNavigator": ["FECEAAA5-8405-11CF-8BA1-00AA00476DA6"],
    "IHTMLOpsProfile": ["3050F401-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLPluginsCollection": ["3050F3FD-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLMimeTypesCollection": ["3050F3FC-98B5-11CF-BB82-00AA00BDCE0B"],
    "IOmHistory": ["FECEAAA2-8405-11CF-8BA1-00AA00476DA6"],
    "IHTMLUnknownElement": ["3050F209-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLBaseFontElement": ["3050F202-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLNextIdElement": ["3050F207-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLIsIndexElement2": ["3050F82F-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLIsIndexElement": ["3050F206-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLBaseElement": ["3050F204-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLMetaElement2": ["3050F81F-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLMetaElement": ["3050F203-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLTitleElement": ["3050F322-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLHeadElement": ["3050F81D-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLHtmlElement": ["3050F81C-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLMarqueeElement": ["3050F2B5-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLButtonElement": ["3050F2BB-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLTextAreaElement": ["3050F2AA-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLInputImage": ["3050F2C2-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLOptionButtonElement": ["3050F2BC-98B5-11CF-BB82-00AA00BDCE0B", "3050F509-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLInputFileElement": ["3050F2AD-98B5-11CF-BB82-00AA00BDCE0B", "3050F542-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLInputTextElement": ["3050F2A6-98B5-11CF-BB82-00AA00BDCE0B", "3050F520-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLInputHiddenElement": ["3050F2A4-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLInputButtonElement": ["3050F2B2-98B5-11CF-BB82-00AA00BDCE0B", "3050F51E-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLInputElement2": ["3050F821-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLInputElement": ["3050F5D2-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLOptionElementFactory": ["3050F38C-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLOptionElement3": ["3050F820-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLOptionElement": ["3050F211-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLSelectionObject2": ["3050F7EC-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLSelectionObject": ["3050F25A-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLSelectElement4": ["3050F838-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLSelectElement2": ["3050F5ED-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLSelectElement": ["3050F244-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLHeaderElement": ["3050F1F6-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLElementCollection3": ["3050F835-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLElementCollection2": ["3050F5EE-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLParaElement": ["3050F1F5-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLHRElement": ["3050F1F4-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLDListElement": ["3050F1F1-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLBRElement": ["3050F1F0-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLDTElement": ["3050F1F3-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLDDElement": ["3050F1F2-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLDivElement": ["3050F200-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLBlockElement2": ["3050F823-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLBlockElement": ["3050F208-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLLIElement": ["3050F1E0-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLOListElement": ["3050F1DE-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLUListElement": ["3050F1DD-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLListElement2": ["3050F822-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLListElement": ["3050F20E-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLLabelElement2": ["3050F832-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLLabelElement": ["3050F32A-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLAnchorElement2": ["3050F825-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLAnchorElement": ["3050F1DA-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLFontElement": ["3050F1D9-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLBodyElement2": ["3050F5C5-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLBodyElement": ["3050F1D8-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLImageElementFactory": ["3050F38E-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLImgElement2": ["3050F826-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLImgElement": ["3050F240-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLControlRange2": ["3050F65E-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLControlRange": ["3050F29C-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLTextContainer": ["3050F230-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLTextElement": ["3050F218-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLControlElement": ["3050F4E9-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLSubmitData": ["3050F645-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLFormElement3": ["3050F836-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLFormElement2": ["3050F4F6-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLFormElement": ["3050F1F7-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLTxtRangeCollection": ["3050F7ED-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLTextRangeMetrics2": ["3050F4A6-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLTextRangeMetrics": ["3050F40B-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLTxtRange": ["3050F220-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLLinkElement3": ["3050F81E-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLLinkElement2": ["3050F4E5-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLLinkElement": ["3050F205-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLStyleSheet2": ["3050F3D1-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLStyleSheet": ["3050F2E3-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLStyleSheetsCollection": ["3050F37E-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLStyleSheetPagesCollection": ["3050F7F0-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLStyleSheetPage": ["3050F7EE-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLStyleSheetRulesCollection": ["3050F2E5-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLStyleSheetRule": ["3050F357-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLGenericElement": ["3050F4B7-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLUrnCollection": ["3050F5E2-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTCDescBehavior": ["3050F5DC-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTCAttachBehavior2": ["3050F7EB-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTCAttachBehavior": ["3050F5F4-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTCEventBehavior": ["3050F4FF-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTCMethodBehavior": ["3050F631-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTCPropertyBehavior": ["3050F5DF-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTCDefaultDispatch": ["3050F4FD-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLElementDefaults": ["3050F6C9-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLDocument": ["626FC520-A41E-11CF-A731-00A0C9082637"],
    "IHTMLDatabinding": ["3050F3F2-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLUniqueName": ["3050F4D0-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLElementRender": ["3050F669-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLElement4": ["3050F80F-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLElement3": ["3050F673-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLElement2": ["3050F434-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLElementCollection": ["3050F21F-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLDOMChildrenCollection": ["3050F5AB-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLAttributeCollection2": ["3050F80A-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLAttributeCollection": ["3050F4C3-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLDOMImplementation": ["3050F80D-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLDOMTextNode2": ["3050F809-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLDOMTextNode": ["3050F4B1-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLDOMAttribute2": ["3050F810-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLDOMAttribute": ["3050F4B0-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLDOMNode2": ["3050F80B-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLDOMNode": ["3050F5DA-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLRectCollection": ["3050F4A4-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLRect": ["3050F4A3-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLElement": ["3050F1FF-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLCurrentStyle3": ["3050F818-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLCurrentStyle2": ["3050F658-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLCurrentStyle": ["3050F3DB-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLRenderStyle": ["3050F6AE-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLRuleStyle4": ["3050F817-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLRuleStyle3": ["3050F657-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLRuleStyle2": ["3050F4AC-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLRuleStyle": ["3050F3CF-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLStyle4": ["3050F816-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLStyle3": ["3050F656-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLStyle2": ["3050F4A2-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLStyle": ["3050F25E-98B5-11CF-BB82-00AA00BDCE0B"],
    "IElementBehaviorSiteRender": ["3050F4A7-98B5-11CF-BB82-00AA00BDCE0B"],
    "IElementBehaviorRender": ["3050F4AA-98B5-11CF-BB82-00AA00BDCE0B"],
    "IElementBehaviorSiteOM": ["3050F489-98B5-11CF-BB82-00AA00BDCE0B"],
    "IElementBehaviorFactory": ["3050F429-98B5-11CF-BB82-00AA00BDCE0B"],
    "IElementBehavior": ["3050F425-98B5-11CF-BB82-00AA00BDCE0B"],
    "IElementBehaviorSite": ["3050F427-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLEventObj": ["3050F32D-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHTMLFiltersCollection": ["3050F3EE-98B5-11CF-BB82-00AA00BDCE0B"],
    "ITIMEMediaPlayerControl": ["897A99E7-F386-45C8-B51B-3A25BBCBBA69"],
    "ITIMEMediaPlayerNetwork": ["B9987FCA-7FBB-4015-BD3D-7418605514DA"],
    "ITIMEMediaPlayerAudio": ["FFAACFDA-B374-4F22-AC9A-C5BB9437CB56"],
    "ITIMEMediaPlayer": ["EA4A95BE-ACC9-4BF0-85A4-1BF3C51E431C"],
    "ITIMEMediaPlayerSite": ["BF0571ED-344F-4F58-82C7-7431ED0FD834"],
    "IAnimationComposerSiteFactory": ["B4EA5681-ED72-4EFE-BBD7-7C47D1325696"],
    "IAnimationComposerFactory": ["BEEB3233-F71F-4683-8B05-9A5314C97DBC"],
    "ITIMEFactory": ["CD51E446-3006-434F-90E2-E37E8FB8CA8F"],
    "ITIMEDMusicPlayerObject": ["407954F5-2BAB-4CFA-954D-249F9FCE43A1"],
    "ITIMEDVDPlayerObject": ["3AF7AB68-4F29-462C-AA6E-5872448899E3"],
    "ITIMEPlayList": ["E9B75B62-DD97-4B19-8FD9-9646292952E0"],
    "ITIMEPlayItem2": ["4262CD38-6BDC-40A4-BC50-4CC50366E702"],
    "ITIMEPlayItem": ["2A6096D9-2CE0-47DC-A813-9099A2466309"],
    "ITIMEState": ["DD5EC62A-9D77-4573-80A8-758594E69CEA"],
    "ITIMEElementCollection": ["50ABC224-6D53-4F83-9135-2440A41B7BC8"],
    "IFilterAnimationInfo": ["02E29300-C758-49B4-9E11-C58BFE90558B"],
    "IAnimationFragment": ["319DFD88-0AC6-4AB1-A19F-90223BA2DA16"],
    "IAnimationRoot": ["29DF6387-30B4-4A62-891B-A9C5BE37BE88"],
    "IAnimationComposerSiteSink": ["8EF76C64-71CD-480F-96FC-BA2696E659BE"],
    "IAnimationComposerSite": ["488FCB56-8FD6-4CDA-A06A-5BB232930ECA"],
    "IAnimationComposer2": ["1A4F0E79-09CD-47F3-AFF1-483BF3A222DC"],
    "IAnimationComposer": ["5459C83D-322B-44B3-8DAA-24C947E7B275"],
    "ITIMEAnimationElement2": ["29CE8661-BD43-421A-B616-E9B31F33A572"],
    "ITIMEAnimationElement": ["A74F14B1-B6A2-430A-A5E8-1F4E53F710FE"],
    "ITIMETransitionElement": ["F383D66F-5E68-4FC2-B641-03672B543A49"],
    "ITIMEMediaElement2": ["9EE29400-7EE6-453A-85B3-4EC28E0305B4"],
    "ITIMEMediaElement": ["47A6972F-AE65-4A6B-AE63-D0C1D5307B58"],
    "ITIMEBodyElement": ["8C90E348-EC0A-4229-90B0-E57D2CA45CCB"],
    "ITIMEElement": ["1C2EF64E-F07D-4338-9771-9154491CD8B9"],
    "ITIMEActiveElementCollection": ["403E2540-4520-11D3-93AB-00A0C967A438"],
    "IObjectSafety": ["CB5BDC81-93C1-11CF-8F20-00805F2CD064"],
    "IImageDecodeEventSink": ["BAA342A0-2DED-11D0-86F4-00A0C913F750"],
    "IImageDecodeFilter": ["A3CCEDF3-2DE2-11D0-86F4-00A0C913F750"],
    "IMapMIMEToCLSID": ["D9E89500-30FA-11D0-B724-00AA006C1A01"],
    "ITimerSink": ["3050F361-98B5-11CF-BB82-00AA00BDCE0B"],
    "ITimer": ["3050F360-98B5-11CF-BB82-00AA00BDCE0B"],
    "ITimerService": ["3050F35F-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHtmlLoadOptions": ["A71A0808-0F88-11D1-BA19-00C04FD912D0"],
    "IOptionArray": ["22B6D492-0F88-11D1-BA19-00C04FD912D0"],
    "IPersistHistory": ["91A565C1-E38F-11D0-94BF-00A0C9055CBF"],
    "IProgSink": ["3050F371-98B5-11CF-BB82-00AA00BDCE0B"],
    "ICustomRatingHelper": ["D0D9842D-E211-4B2C-88DC-BC729342DFCB"],
    "IRatingNotification": ["639447BD-B2D3-44B9-9FB0-510F23CB45E4"],
    "IRecalcHostDebug": ["3050F5F7-98B5-11CF-BB82-00AA00BDCE0B"],
    "IRecalcProperty": ["3050F5D6-98B5-11CF-BB82-00AA00BDCE0B"],
    "IRecalcHost": ["3050F497-98B5-11CF-BB82-00AA00BDCE0B"],
    "IRecalcEngine": ["3050F496-98B5-11CF-BB82-00AA00BDCE0B"],
    "IActiveXSafetyProvider": ["69FF5101-FC63-11D0-97EB-00AA00615333"],
    "IServiceProvider": ["6D5140C1-7436-11CE-8034-00AA006009FA"],
    "ISubscriptionMgr2": ["614BC270-AEDF-11D1-A1F9-00C04FC2FBE1"],
    "ISubscriptionMgr": ["085FB2C0-0DF8-11D1-8F4B-00A0C905413F"],
    "IEnumSubscription": ["F72C8D97-6DBD-11D1-A1E8-00C04FC2FBE1"],
    "ISubscriptionItem": ["A97559F8-6C4A-11D1-A1E8-00C04FC2FBE1"],
    "IEnumItemProperties": ["F72C8D96-6DBD-11D1-A1E8-00C04FC2FBE1"],
    "IUrlHistoryNotify": ["BC40BEC1-C493-11D0-831B-00C04FD5AE38"],
    "IUrlHistoryStg2": ["AFA0DC11-C313-11D0-831A-00C04FD5AE38"],
    "IUrlHistoryStg": ["3C374A41-BAE4-11CF-BF7D-00AA006946EE"],
    "IEnumSTATURL": ["3C374A42-BAE4-11CF-BF7D-00AA006946EE"],
    "IWrappedProtocol": ["53C84785-8425-4DC5-971B-E58D9C19F9B6"],
    "IEncodingFilterFactory": ["70BDDE00-C18E-11D0-A9CE-006097942311"],
    "IDataFilter": ["69D14C80-C18E-11D0-A9CE-006097942311"],
    "ICatalogFileInfo": ["711C7600-6B48-11D1-B403-00AA00B92AF1"],
    "ISoftDistExt": ["B15B8DC1-C7E1-11D0-8680-00AA00BDCB71"],
    "IInternetZoneManagerEx": ["A4C23339-8E06-431E-9BF4-7E711C085648"],
    "IInternetZoneManager": ["79EAC9EF-BAF9-11CE-8C82-00AA004BA90B"],
    "IInternetHostSecurityManager": ["3AF280B6-CB3F-11D0-891E-00C04FB6BFC4"],
    "IZoneIdentifier": ["CD45F185-1B21-48E2-967B-EAD743A8914E"],
    "IInternetSecurityManagerEx": ["F164EDF1-CC7C-4F0D-9A94-34222625C393"],
    "IInternetSecurityManager": ["79EAC9EE-BAF9-11CE-8C82-00AA004BA90B"],
    "IInternetSecurityMgrSite": ["79EAC9ED-BAF9-11CE-8C82-00AA004BA90B"],
    "IInternetProtocolInfo": ["79EAC9EC-BAF9-11CE-8C82-00AA004BA90B"],
    "IInternetPriority": ["79EAC9EB-BAF9-11CE-8C82-00AA004BA90B"],
    "IInternetThreadSwitch": ["79EAC9E8-BAF9-11CE-8C82-00AA004BA90B"],
    "IInternetSession": ["79EAC9E7-BAF9-11CE-8C82-00AA004BA90B"],
    "IInternetProtocolSinkStackable": ["79EAC9F0-BAF9-11CE-8C82-00AA004BA90B"],
    "IInternetProtocolSink": ["79EAC9E5-BAF9-11CE-8C82-00AA004BA90B"],
    "IInternetProtocol": ["79EAC9E4-BAF9-11CE-8C82-00AA004BA90B"],
    "IInternetProtocolRoot": ["79EAC9E3-BAF9-11CE-8C82-00AA004BA90B"],
    "IInternetBindInfo": ["79EAC9E1-BAF9-11CE-8C82-00AA004BA90B"],
    "IInternet": ["79EAC9E0-BAF9-11CE-8C82-00AA004BA90B"],
    "IBindHost": ["FC4801A1-2BA9-11CF-A229-00AA003D7352"],
    "IWinInetCacheHints": ["DD1EC3B3-8391-4FDB-A9E6-347C3CAAA7DD"],
    "IWinInetHttpInfo": ["79EAC9D8-BAFA-11CE-8C82-00AA004BA90B"],
    "IHttpSecurity": ["79EAC9D7-BAFA-11CE-8C82-00AA004BA90B"],
    "IWinInetInfo": ["79EAC9D6-BAFA-11CE-8C82-00AA004BA90B"],
    "ICodeInstall": ["79EAC9D1-BAF9-11CE-8C82-00AA004BA90B"],
    "IWindowForBindingUI": ["79EAC9D5-BAFA-11CE-8C82-00AA004BA90B"],
    "IWinInetFileStream": ["F134C4B7-B1F8-4E75-B886-74B90943BECB"],
    "IHttpNegotiate2": ["4F9F9FCB-E0F4-48EB-B7AB-FA2EA9365CB4"],
    "IHttpNegotiate": ["79EAC9D2-BAF9-11CE-8C82-00AA004BA90B"],
    "IAuthenticate": ["79EAC9D0-BAF9-11CE-8C82-00AA004BA90B"],
    "IBindStatusCallback": ["79EAC9C1-BAF9-11CE-8C82-00AA004BA90B"],
    "IBinding": ["79EAC9C0-BAF9-11CE-8C82-00AA004BA90B"],
    "IBindProtocol": ["79EAC9CD-BAF9-11CE-8C82-00AA004BA90B"],
    "IMonikerProp": ["A5CA5F7F-1847-4D87-9C5B-918509F7511D"],
    "IPersistMoniker": ["79EAC9C9-BAF9-11CE-8C82-00AA004BA90B"],
    "IUrlTrackingStg": ["F2F8CBB3-B040-11D0-BB16-00C04FB66F63"],
    "IVersionHost": ["667115AC-DC02-11D1-BA57-00C04FC2040E"],
    "IVersionVector": ["4EB01410-DB1A-11D1-BA53-00C04FC2040E"],
    "ISubscriptionMgrPriv": ["D66B399E-AF1D-11D1-A1F9-00C04FC2FBE1"],
    "ISubscriptionAgentEvents": ["A89E8FF1-70F4-11D1-BC7F-00C04FD929DB"],
    "ISubscriptionAgentShellExt": ["81B184BA-B302-11D1-8552-00C04FA35C89"],
    "ISubscriptionAgentControl": ["A89E8FF0-70F4-11D1-BC7F-00C04FD929DB"],
    "ISubscriptionThrottler": ["1E9B00E4-9846-11D1-A1EE-00C04FC2FBE1"],
    "IIntDitherer": ["06670CA0-ECEF-11D0-AAE7-00C04FC9B304"],
    "IImgCtx": ["3050F3D7-98B5-11CF-BB82-00AA00BDCE0B"],
    "IAccessible": ["618736E0-3C3D-11CF-810C-00AA00389B71"],
    "IOInetCache": ["79EAC9EA-BAF9-11CE-8C82-00AA004BA90B"],
    "IOInetThreadSwitch": ["79EAC968-BAF9-11CE-8C82-00AA004BA90B"],
    "IOInetSession": ["79EAC967-BAF9-11CE-8C82-00AA004BA90B"],
    "IOInetBindClient": ["79EAC9E2-BAF9-11CE-8C82-00AA004BA90B"],
    "INotificationProcessMgr0": ["C733E4AE-576E-11D0-B28C-00C04FD7CD22"],
    "INotificationRunning": ["C733E4AD-576E-11D0-B28C-00C04FD7CD22"],
    "INotificationPing": ["C733E4AC-576E-11D0-B28C-00C04FD7CD22"],
    "INotificationHelper": ["C733E4AB-576E-11D0-B28C-00C04FD7CD22"],
    "IEnumNotificationSinkItem": ["C733E4AA-576E-11D0-B28C-00C04FD7CD22"],
    "IEnumScheduleGroup": ["C733E4A9-576E-11D0-B28C-00C04FD7CD22"],
    "IEnumNotification": ["C733E4A8-576E-11D0-B28C-00C04FD7CD22"],
    "INotificationReport": ["C733E4A7-576E-11D0-B28C-00C04FD7CD22"],
    "IScheduleGroup": ["C733E4A6-576E-11D0-B28C-00C04FD7CD22"],
    "INotificationSink": ["C733E4A5-576E-11D0-B28C-00C04FD7CD22"],
    "INotificationMgr": ["C733E4A4-576E-11D0-B28C-00C04FD7CD22"],
    "INotification": ["C733E4A3-576E-11D0-B28C-00C04FD7CD22"],
    "IPropertyMap": ["C733E4A2-576E-11D0-B28C-00C04FD7CD22"],
    "IEnumPropertyMap": ["C733E4A1-576E-11D0-B28C-00C04FD7CD22"],
    "IDebugOut": ["C733E4F1-576E-11D0-B28C-00C04FD7CD22"],
    "IDebugRegister": ["C733E4F0-576E-11D0-B28C-00C04FD7CD22"],
    "IBindStatusCallbackMsg": ["79EAC9D5-BAF9-11CE-8C82-00AA004BA90B"],
    "IAsyncBindCtx": ["79EAC9D4-BAF9-11CE-8C82-00AA004BA90B"],
    "IBindStatusCallbackHolder": ["79EAC9CC-BAF9-11CE-8C82-00AA004BA90B"],
    "IAsyncMoniker": ["79EAC9D3-BAF9-11CE-8C82-00AA004BA90B"],
    "ICiCResourceMonitor": ["F700FF8E-20EE-11D2-80F7-00C04FA354BA"],
    "ICiCFilterStatus": ["BC5F3D60-8BBC-11D1-8F73-00A0C91917F5"],
    "ICiCEventLogItem": ["44CC886A-4314-11D0-8C91-0020AF1D740E"],
    "ICiCQueryNotification": ["0A9E9F6C-3CE2-11D0-8C90-0020AF1D740E"],
    "ICiDocChangeNotifySink": ["8BFA1386-3CE5-11D0-8C90-0020AF1D740E"],
    "ICiCSecurityChecker": ["CA130CF4-3CC2-11D0-8C90-0020AF1D740E"],
    "ICiCUserSecurity": ["5D01D9CE-3CC2-11D0-8C90-0020AF1D740E"],
    "ICiCScopeChecker": ["7D820C9C-3CBC-11D0-8C90-0020AF1D740E"],
    "ICiCScope": ["1021C882-3CC0-11D0-8C90-0020AF1D740E"],
    "ICiCIndexNotificationStatus": ["5FFF3840-8E76-11D0-8D69-00A0C908DBF1"],
    "ICiIndexNotificationEntry": ["210769D0-8E75-11D0-8D69-00A0C908DBF1"],
    "ICiIndexNotification": ["4F2CD6E0-8E74-11D0-8D69-00A0C908DBF1"],
    "ICiISearchCreator": ["7DC07FA0-902E-11D0-A80C-00A0C906241A"],
    "ICiCDocStoreLocator": ["97EE7C06-5908-11D0-8C9B-0020AF1D740E"],
    "IPropertyMapper": ["B324B226-41A0-11D0-8C91-0020AF1D740E"],
    "ICiManager": ["CF0FCF56-3CCE-11D0-8C90-0020AF1D740E"],
    "ICiPersistIncrFile": ["31B311E2-4498-11D0-8C91-0020AF1D740E"],
    "ICiEnumWorkids": ["77900150-A09C-11D0-A80D-00A0C906241A"],
    "ICiStartup": ["68232CB8-3CCC-11D0-8C90-0020AF1D740E"],
    "ICiControl": ["63DEB7F4-3CCB-11D0-8C90-0020AF1D740E"],
    "ICiCQuerySession": ["AE461FD6-4E1D-11D0-8C94-0020AF1D740E"],
    "ICiQueryPropertyMapper": ["D2333EB0-756B-11D0-8D66-00A0C908DBF1"],
    "ICiCScopeEnumerator": ["CF8505EA-3CCA-11D0-8C90-0020AF1D740E"],
    "ICiCDeferredPropRetriever": ["C273AF70-6D72-11D0-8D64-00A0C908DBF1"],
    "ICiCPropRetriever": ["77D9B2DA-4401-11D0-8C91-0020AF1D740E"],
    "ICiCPropertyStorage": ["4C46225A-3CB5-11D0-8C90-0020AF1D740E"],
    "ICiCDocNameToWorkidTranslatorEx": ["7BBA76E6-A0E3-11D2-BC5D-00C04FA354BA"],
    "ICiCDocNameToWorkidTranslator": ["25FC3F54-3CB4-11D0-8C90-0020AF1D740E"],
    "ICiCDocStoreEx": ["F98282A7-FA72-11D1-9798-00C04FC2F410"],
    "ICiCDocStore": ["46625468-3C32-11D0-8C90-0020AF1D740E"],
    "ICiCFilterClient": ["A1E0BCB6-3C24-11D0-8C90-0020AF1D740E"],
    "ICiCAdviseStatus": ["CA05734A-1218-11D3-AE7A-00C04F72F831"],
    "ICiFrameworkQuery": ["AE67C7D9-85D3-11D0-8C45-00C04FC2DB8D"],
    "ICiAdmin": ["AE67C7D8-85D3-11D0-8C45-00C04FC2DB8D"],
    "ICiCLangRes": ["914C2E6C-43FE-11D0-8C91-0020AF1D740E"],
    "ICiAdminParams": ["A82D48C6-3F0F-11D0-8C91-0020AF1D740E"],
    "ICiCOpenedDoc": ["151EDFBE-3C2F-11D0-8C90-0020AF1D740E"],
    "ICiCDocName": ["76615076-3C2B-11D0-8C90-0020AF1D740E"],
    "IFilterStatus": ["F4EB8260-8DDA-11D1-B3AA-00A0C9063796"],
    "IFsCiAdmin": ["75398C30-7A26-11D0-A80A-00A0C906241A"],
    "IRowsetQueryStatus": ["A7AC77ED-F8D7-11CE-A798-0020F8008024"],
    "ISearchQueryHits": ["ED8CE7E0-106C-11CE-84E2-00AA004B9986"],
    "IColumnMapperCreator": ["0B63E37B-9CCC-11D0-BCDB-00805FCCCE04"],
    "IColumnMapper": ["0B63E37A-9CCC-11D0-BCDB-00805FCCCE04"],
    "ISimpleCommandCreator": ["5E341AB7-02D0-11D1-900C-00A0C9063796"],
    "IStemmer": ["EFBAF140-7F42-11CE-BE57-00AA0051FE20"],
    "IWordFormSink": ["FE77C330-7F42-11CE-BE57-00AA0051FE20"],
    "IWordBreaker": ["D53552C8-77E3-101A-B552-08002B33B0E6"],
    "IWordSink": ["CC907054-C058-101A-B554-08002B33B0E6"],
    "IPhraseSink": ["CC906FF0-C058-101A-B554-08002B33B0E6"],
    "IParser": ["186442B0-472E-11D1-8952-00C04FD611D7"],
    "IParserSession": ["186442B1-472E-11D1-8952-00C04FD611D7"],
    "IParserTreeProperties": ["186442B2-472E-11D1-8952-00C04FD611D7"],
    "IParserVerify": ["186442B3-472E-11D1-8952-00C04FD611D7"],
    "IFilter": ["89BCB740-6119-101A-BCB7-00DD010655AF"],
    "IApplicationGateway": ["5134842B-FDCE-485D-93CD-DE1640643BBE"],
    "IApplicationGatewayServices": ["5134842A-FDCE-485D-93CD-DE1640643BBE"],
    "IAdapterNotificationSink": ["44AB2DC3-23B2-47DE-8228-2E1CCEEB9911"],
    "IEnumAdapterInfo": ["A23F9D11-714C-41FE-8471-FFB19BC28454"],
    "ISecondaryControlChannel": ["A23F9D10-714C-41FE-8471-FFB19BC28454"],
    "IPrimaryControlChannel": ["1A2E8B62-9012-4BE6-84AE-32BD66BA657A"],
    "IPersistentDataChannel": ["A180E934-D92A-415D-9144-759F8054E8F6"],
    "IDataChannel": ["AD42D12A-4AD0-4856-919E-E854C91D1856"],
    "IPendingProxyConnection": ["B68E5043-3E3D-4CC2-B9C1-5F8F88FEE81C"],
    "IAdapterInfo": ["480BF94A-09FD-4F8A-A3E0-B0700282D84D"],
    "ITQOSApplicationID": ["E8C89D27-A3BD-47D5-A6FC-D2AE40CDBC6E"],
    "ITAudioSettings": ["6C0AB6C6-21E3-11D3-A577-00C04F8EF6E3"],
    "ITAudioDeviceControl": ["6C0AB6C5-21E3-11D3-A577-00C04F8EF6E3"],
    "ITCallQualityControl": ["FE1D8AE0-EDC4-49B5-8F8C-4DE40F9CDFAF"],
    "ITStreamQualityControl": ["6C0AB6C2-21E3-11D3-A577-00C04F8EF6E3"],
    "ITFormatControl": ["6C0AB6C1-21E3-11D3-A577-00C04F8EF6E3"],
    "ITParticipant": ["5899B820-5A34-11D2-95A0-00A0244D2298"],
    "IMulticastControl": ["410FA507-4DC6-415A-9014-633875D5406E"],
    "ITParticipantEvent": ["8BB35070-2DAD-11D3-A580-00C04F8EF6E3"],
    "ITParticipantSubStreamControl": ["2C679108-5A35-11D2-95A0-00A0244D2298"],
    "ITParticipantControl": ["D2EE6684-5A34-11D2-95A0-00A0244D2298"],
    "IEnumParticipant": ["0A91B56C-5A35-11D2-95A0-00A0244D2298"],
    "ITLocalParticipant": ["39CBF055-F77A-11D2-A824-00C04F8EF6E3"],
    "IDummy": ["0D7CA54A-D252-4FCB-9104-F6DDD310B3F9"],
    "IKeyFrameControl": ["C3341386-AF91-4EF9-83B6-BE3762E42ECB"],
    "IH323LineEx": ["44CF6A9D-CB40-4BBC-B2D3-B6AA93322C71"],
    "IInternetConnectionDeviceClient": ["04DF6139-5610-11D4-9EC8-00B0D022DD1F"],
    "IInternetConnectionDeviceSharedConnection": ["04DF6138-5610-11D4-9EC8-00B0D022DD1F"],
    "IInternetConnectionDevice": ["04DF6137-5610-11D4-9EC8-00B0D022DD1F"],
    "IEnumHNetBridgedConnections": ["85D18B7D-3032-11D4-9348-00C04F8EEB71"],
    "IEnumHNetPortMappingBindings": ["85D18B81-3032-11D4-9348-00C04F8EEB71"],
    "IEnumHNetPortMappingProtocols": ["85D18B7C-3032-11D4-9348-00C04F8EEB71"],
    "IEnumHNetApplicationProtocols": ["85D18B7B-3032-11D4-9348-00C04F8EEB71"],
    "IEnumHNetIcsPrivateConnections": ["85D18B7A-3032-11D4-9348-00C04F8EEB71"],
    "IEnumHNetIcsPublicConnections": ["85D18B79-3032-11D4-9348-00C04F8EEB71"],
    "IEnumHNetFirewalledConnections": ["85D18B78-3032-11D4-9348-00C04F8EEB71"],
    "IEnumHNetBridges": ["85D18B77-3032-11D4-9348-00C04F8EEB71"],
    "IEnumHNetConnections": ["E48CB68F-7CF0-496D-B8F7-D2EF8B639E1B"],
    "IHNetApplicationProtocol": ["85D18B7F-3032-11D4-9348-00C04F8EEB71"],
    "IHNetPortMappingBinding": ["85D18B80-3032-11D4-9348-00C04F8EEB71"],
    "IHNetPortMappingProtocol": ["85D18B7E-3032-11D4-9348-00C04F8EEB71"],
    "IHNetBridgedConnection": ["85D18B76-3032-11D4-9348-00C04F8EEB71"],
    "IHNetBridge": ["85D18B75-3032-11D4-9348-00C04F8EEB71"],
    "IHNetIcsPrivateConnection": ["85D18B74-3032-11D4-9348-00C04F8EEB71"],
    "IHNetIcsPublicConnection": ["85D18B73-3032-11D4-9348-00C04F8EEB71"],
    "IHNetFirewalledConnection": ["85D18B72-3032-11D4-9348-00C04F8EEB71"],
    "IHNetConnection": ["85D18B71-3032-11D4-9348-00C04F8EEB71"],
    "IHNetProtocolSettings": ["85D18B70-3032-11D4-9348-00C04F8EEB71"],
    "IHNetIcsSettings": ["85D18B6F-3032-11D4-9348-00C04F8EEB71"],
    "IHNetFirewallSettings": ["85D18B6E-3032-11D4-9348-00C04F8EEB71"],
    "IHNetBridgeSettings": ["85D18B6D-3032-11D4-9348-00C04F8EEB71"],
    "IHNetCfgMgr": ["85D18B6C-3032-11D4-9348-00C04F8EEB71"],
    "IStaticPortMapping": ["6F10711F-729B-41E5-93B8-F21D0F818DF1"],
    "IStaticPortMappingCollection": ["CD1F3E77-66D6-4664-82C7-36DBB641D0F1"],
    "IDynamicPortMapping": ["4FC80282-23B6-4378-9A27-CD8F17C9400C"],
    "IDynamicPortMappingCollection": ["B60DE00F-156E-4E8D-9EC1-3A2342C10899"],
    "INATNumberOfEntriesCallback": ["C83A0A74-91EE-41B6-B67A-67E0F00BBD78"],
    "INATExternalIPAddressCallback": ["9C416740-A34E-446F-BA06-ABD04C3149AE"],
    "INATEventManager": ["624BD588-9060-4109-B0B0-1ADBBCAC32DF"],
    "IUPnPNAT": ["B171C812-CC76-485A-94D8-B6B3A2794E99"],
    "IH26XRTPControl": ["1FC3F2C0-2BFD-11D0-8800-444553540000"],
    "IH26XEncoderControl": ["F9B78AA1-EA12-11CF-9FEC-00AA00A59F69"],
    "IH26XSnapshot": ["3CB194A0-10AA-11D0-8800-444553540000"],
    "IH26XEncodeOptions": ["65698D40-282D-11D0-8800-444553540000"],
    "IH26XVideoEffects": ["21555140-9C2B-11CF-90FA-00AA00A729EA"],
    "IQualityControl": ["6BC096AB-0CE6-11D1-BAAE-00C04FC2E20D", "56A868A5-0AD4-11CE-B03A-0020AF0BA770"],
    "IRequestSource": ["6BC096A9-0CE6-11D1-BAAE-00C04FC2E20D"],
    "IRequestHandler": ["6BC096AA-0CE6-11D1-BAAE-00C04FC2E20D"],
    "IRequestState": ["6BC096BA-0CE6-11D1-BAAE-00C04FC2E20D"],
    "IAttributesRaw": ["6BC096A8-0CE6-11D1-BAAE-00C04FC2E20D"],
    "IRequest": ["6BC096A7-0CE6-11D1-BAAE-00C04FC2E20D"],
    "IStats": ["944AD530-B09D-11CE-B59C-00AA006CB37D"],
    "IRTC": ["4811EA40-B582-11CE-B5AF-00AA006CB37D"],
    "IDelaydC": ["BFF9C030-B58F-11CE-B5B0-00AA006CB37D"],
    "IMcastAddressAllocation": ["DF0DAEF1-A289-11D1-8697-006008B0E5D2"],
    "IEnumMcastScope": ["DF0DAF09-A289-11D1-8697-006008B0E5D2"],
    "IMcastLeaseInfo": ["DF0DAEFD-A289-11D1-8697-006008B0E5D2"],
    "IMcastScope": ["DF0DAEF4-A289-11D1-8697-006008B0E5D2"],
    "ITMSPAddress": ["EE3BD600-3868-11D2-A045-00C04FB6809F"],
    "ITPluggableTerminalEventSinkRegistration": ["F7115709-A216-4957-A759-060AB32A90D1"],
    "ITPluggableTerminalEventSink": ["6E0887BE-BA1A-492E-BD10-4020EC5E33E0"],
    "INetCfgComponentSysPrep": ["C0E8AE9A-306E-11D1-AACF-00805FC1270E"],
    "INetLanConnectionUiInfo": ["C08956A6-1CD3-11D1-B1C5-00805FC1270E"],
    "INetCfgComponentUpperEdge": ["932238E4-BEA1-11D0-9298-00C04FC99DCF"],
    "INetCfgComponentNotifyGlobal": ["932238E2-BEA1-11D0-9298-00C04FC99DCF"],
    "INetCfgComponentNotifyBinding": ["932238E1-BEA1-11D0-9298-00C04FC99DCF"],
    "INetCfgComponentPropertyUi": ["932238E0-BEA1-11D0-9298-00C04FC99DCF"],
    "INetCfgComponentSetup": ["932238E3-BEA1-11D0-9298-00C04FC99DCF"],
    "INetCfgComponentControl": ["932238DF-BEA1-11D0-9298-00C04FC99DCF"],
    "INetCfgPnpReconfigCallback": ["8D84BD35-E227-11D2-B700-00A0C98A6A85"],
    "INetCfgSpecialCase": ["C0E8AE95-306E-11D1-AACF-00805FC1270E"],
    "INetInstallQueue": ["98133274-4B20-11D1-AB01-00805FC1270E"],
    "INetCfgComponentPrivate": ["98133273-4B20-11D1-AB01-00805FC1270E"],
    "INetCfgInternalSetup": ["98133276-4B20-11D1-AB01-00805FC1270E"],
    "ITcpipProperties": ["98133271-4B20-11D1-AB01-00805FC1270E"],
    "IIpxAdapterInfo": ["98133270-4B20-11D1-AB01-00805FC1270E"],
    "INetCfgSysPrep": ["C0E8AE98-306E-11D1-AACF-00805FC1270E"],
    "INetCfgComponentBindings": ["C0E8AE9E-306E-11D1-AACF-00805FC1270E"],
    "INetCfgComponent": ["C0E8AE99-306E-11D1-AACF-00805FC1270E"],
    "INetCfgClassSetup": ["C0E8AE9D-306E-11D1-AACF-00805FC1270E"],
    "INetCfgClass": ["C0E8AE97-306E-11D1-AACF-00805FC1270E"],
    "INetCfgBindingPath": ["C0E8AE96-306E-11D1-AACF-00805FC1270E"],
    "INetCfgBindingInterface": ["C0E8AE94-306E-11D1-AACF-00805FC1270E"],
    "INetCfgLock": ["C0E8AE9F-306E-11D1-AACF-00805FC1270E"],
    "INetCfg": ["C0E8AE93-306E-11D1-AACF-00805FC1270E"],
    "IEnumNetCfgComponent": ["C0E8AE92-306E-11D1-AACF-00805FC1270E"],
    "IEnumNetCfgBindingPath": ["C0E8AE91-306E-11D1-AACF-00805FC1270E"],
    "IEnumNetCfgBindingInterface": ["C0E8AE90-306E-11D1-AACF-00805FC1270E"],
    "INetSharingManager": ["C08956B7-1CD3-11D1-B1C5-00805FC1270E"],
    "INetSharingPrivateConnectionCollection": ["38AE69E0-4409-402A-A2CB-E965C727F840"],
    "INetSharingPublicConnectionCollection": ["7D7A6355-F372-4971-A149-BFC927BE762A"],
    "INetSharingEveryConnectionCollection": ["33C4643C-7811-46FA-A89A-768597BD7223"],
    "INetSharingConfiguration": ["C08956B6-1CD3-11D1-B1C5-00805FC1270E"],
    "INetConnectionProps": ["F4277C95-CE5B-463D-8167-5662D9BCAA72"],
    "INetSharingPortMappingCollection": ["02E4A2DE-DA20-4E34-89C8-AC22275A010B"],
    "IEnumNetSharingPrivateConnection": ["C08956B5-1CD3-11D1-B1C5-00805FC1270E"],
    "IEnumNetSharingPublicConnection": ["C08956B4-1CD3-11D1-B1C5-00805FC1270E"],
    "IEnumNetSharingEveryConnection": ["C08956B8-1CD3-11D1-B1C5-00805FC1270E"],
    "INetSharingPortMapping": ["C08956B1-1CD3-11D1-B1C5-00805FC1270E"],
    "INetSharingPortMappingProps": ["24B7E9B5-E38F-4685-851B-00892CF5F940"],
    "IEnumNetSharingPortMapping": ["C08956B0-1CD3-11D1-B1C5-00805FC1270E"],
    "INetConnectionCommonUi": ["C08956A5-1CD3-11D1-B1C5-00805FC1270E"],
    "INetConnectionPropertyUi2": ["C08956B9-1CD3-11D1-B1C5-00805FC1270E"],
    "INetConnectionPropertyUi": ["C08956A4-1CD3-11D1-B1C5-00805FC1270E"],
    "INetConnectionConnectUi": ["C08956A3-1CD3-11D1-B1C5-00805FC1270E"],
    "INetConnectionManagerEvents": ["C08956BA-1CD3-11D1-B1C5-00805FC1270E"],
    "INetConnectionManager": ["C08956A2-1CD3-11D1-B1C5-00805FC1270E"],
    "INetConnection": ["C08956A1-1CD3-11D1-B1C5-00805FC1270E"],
    "IEnumNetConnection": ["C08956A0-1CD3-11D1-B1C5-00805FC1270E"],
    "ISharedAccessBeaconFinder": ["FAEDCF67-31FE-11D1-AAD2-00805FC1270E"],
    "ISharedAccessBeacon": ["FAEDCF6B-31FE-11D1-AAD2-00805FC1270E"],
    "INetConnectionManagerDebug": ["FAEDCF5D-31FE-11D1-AAD2-00805FC1270E"],
    "INetMachinePolicies": ["FAEDCF68-31FE-11D1-AAD2-00805FC1270E"],
    "INetConnectionSysTray": ["FAEDCF65-31FE-11D1-AAD2-00805FC1270E"],
    "INetConnectionHNetUtil": ["FAEDCF64-31FE-11D1-AAD2-00805FC1270E"],
    "INetConnectionCMUtil": ["FAEDCF60-31FE-11D1-AAD2-00805FC1270E"],
    "INetConnectionRefresh": ["FAEDCF5F-31FE-11D1-AAD2-00805FC1270E"],
    "INetConnectionUiUtilities": ["FAEDCF5E-31FE-11D1-AAD2-00805FC1270E"],
    "INetConnectionNotifySink": ["FAEDCF5C-31FE-11D1-AAD2-00805FC1270E"],
    "INetConnection2": ["FAEDCF6A-31FE-11D1-AAD2-00805FC1270E"],
    "INetConnectionManager2": ["FAEDCF69-31FE-11D1-AAD2-00805FC1270E"],
    "INetConnectionBrandingInfo": ["FAEDCF5B-31FE-11D1-AAD2-00805FC1270E"],
    "IPersistNetConnection": ["FAEDCF59-31FE-11D1-AAD2-00805FC1270E"],
    "INetRasConnectionIpUiInfo": ["FAEDCF58-31FE-11D1-AAD2-00805FC1270E"],
    "INetDefaultConnection": ["FAEDCF66-31FE-11D1-AAD2-00805FC1270E"],
    "INetRasConnection": ["FAEDCF57-31FE-11D1-AAD2-00805FC1270E"],
    "INetLanConnectionWizardUi": ["FAEDCF56-31FE-11D1-AAD2-00805FC1270E"],
    "INetSharedAccessConnection": ["FAEDCF55-31FE-11D1-AAD2-00805FC1270E"],
    "INetLanConnection": ["FAEDCF54-31FE-11D1-AAD2-00805FC1270E"],
    "INetInboundConnection": ["FAEDCF53-31FE-11D1-AAD2-00805FC1270E"],
    "INetConnectionWizardUiContext": ["FAEDCF52-31FE-11D1-AAD2-00805FC1270E"],
    "INetConnectionWizardUi": ["FAEDCF51-31FE-11D1-AAD2-00805FC1270E"],
    "INetConnectionUiLock": ["FAEDCF50-31FE-11D1-AAD2-00805FC1270E"],
    "IEnumNetFwV6PortsAsVariants": ["C8A4F5EF-8DC9-4806-90AF-DB5AD4A5307C"],
    "INetFwV6PortsCollection": ["43287AC8-F5AB-498B-A455-74DC84750C49"],
    "IEnumNetFwV6ConnectionsAsVariants": ["D3CE39F1-3EA1-4AB2-AB29-D37E46A62315"],
    "INetFwV6ConnectionCollection": ["2A57D76E-94D7-484A-9D41-72CE289DED01"],
    "IEnumNetFwV6Ports": ["1901CCC7-A8CE-4207-BE51-E343419DEF19"],
    "IEnumNetFwV6Connections": ["05A800CA-317F-4608-9274-43D97D3924F5"],
    "INetFwV6Port": ["FD695182-B9FF-4224-B55F-6774CC4CDB38"],
    "INetFwV6Connection": ["1B664CB0-9403-4061-B356-B374C63B1241"],
    "INetFwV6Mgr": ["1C3FEDF7-1B2B-4550-A964-1511DF2163C8"],
    "IFlashConfig": ["8244DEDF-CF04-41FA-812F-E151F492C5AA"],
    "IProvisioningProfileWireless": ["C96FBD51-24DD-11D8-89FB-00904B2EA9C6"],
    "IProvisioningDomain": ["C96FBD50-24DD-11D8-89FB-00904B2EA9C6"],
    "ITRendezvous": ["34621D6B-6CFF-11D1-AFF7-00C04FC31FEE"],
    "IEnumDirectory": ["34621D6D-6CFF-11D1-AFF7-00C04FC31FEE"],
    "ITDirectory": ["34621D6C-6CFF-11D1-AFF7-00C04FC31FEE"],
    "ITILSConfig": ["34621D72-6CFF-11D1-AFF7-00C04FC31FEE"],
    "IEnumDirectoryObject": ["06C9B64A-306D-11D1-9774-00C04FD91AC0"],
    "ITDirectoryObject": ["34621D6E-6CFF-11D1-AFF7-00C04FC31FEE"],
    "IEnumDialableAddrs": ["34621D70-6CFF-11D1-AFF7-00C04FC31FEE"],
    "ITDirectoryObjectUser": ["34621D6F-6CFF-11D1-AFF7-00C04FC31FEE"],
    "ITDirectoryObjectConference": ["F1029E5D-CB5B-11D0-8D59-00C04FD91AC0"],
    "ISdoDictionaryOld": ["D432E5F4-53D8-11D2-9A3A-00C04FB998AC"],
    "ISdoCollection": ["56BC53E2-96DB-11D1-BF3F-000000000000"],
    "ISdo": ["56BC53DE-96DB-11D1-BF3F-000000000000"],
    "ISdoServiceControl": ["479F6E74-49A2-11D2-8ECA-00C04FC2F519"],
    "ISdoMachine": ["479F6E75-49A2-11D2-8ECA-00C04FC2F519"],
    "ITAttributeList": ["5037FB82-CAE9-11D0-8D58-00C04FD91AC0"],
    "ITConnection": ["8FA381D4-C8C2-11D0-8D58-00C04FD91AC0"],
    "ITSdp": ["9B2719D8-B696-11D0-A489-00C04FD91AC0"],
    "ITTimeCollection": ["0CC1F04F-CAEB-11D0-8D58-00C04FD91AC0"],
    "IEnumTime": ["9055322E-2FA8-11D1-9774-00C04FD91AC0"],
    "ITTime": ["2652BB78-1516-11D1-9771-00C04FD91AC0"],
    "ITMediaCollection": ["6A8E16A2-0ABC-11D1-976D-00C04FD91AC0"],
    "IEnumMedia": ["CA8397BE-2FA4-11D1-9774-00C04FD91AC0"],
    "ITMedia": ["0CC1F053-CAEB-11D0-8D58-00C04FD91AC0"],
    "ITConferenceBlob": ["C259D7AA-C8AB-11D0-8D58-00C04FD91AC0"],
    "ITAllocatorProperties": ["C1BC3C90-BCFE-11D1-9745-00C04FD91AC0"],
    "ITAMMediaFormat": ["0364EB00-4A77-11D1-A671-006097C9A2E8"],
    "IEnumAgentHandler": ["587E8C28-9802-11D1-A0A4-00805FC147D3"],
    "IEnumACDGroup": ["5AFC3157-4BCC-11D1-BF80-00805FC147D3"],
    "IEnumQueue": ["5AFC3158-4BCC-11D1-BF80-00805FC147D3"],
    "IEnumAgentSession": ["5AFC314E-4BCC-11D1-BF80-00805FC147D3"],
    "IEnumAgent": ["5AFC314D-4BCC-11D1-BF80-00805FC147D3"],
    "ITAgentHandler": ["587E8C22-9802-11D1-A0A4-00805FC147D3"],
    "ITTAPICallCenter": ["5AFC3154-4BCC-11D1-BF80-00805FC147D3"],
    "ITAgentHandlerEvent": ["297F3034-BD11-11D1-A0A7-00805FC147D3"],
    "ITQueueEvent": ["297F3033-BD11-11D1-A0A7-00805FC147D3"],
    "ITACDGroupEvent": ["297F3032-BD11-11D1-A0A7-00805FC147D3"],
    "ITAgentSessionEvent": ["5AFC314B-4BCC-11D1-BF80-00805FC147D3"],
    "ITAgentEvent": ["5AFC314A-4BCC-11D1-BF80-00805FC147D3"],
    "ITQueue": ["5AFC3149-4BCC-11D1-BF80-00805FC147D3"],
    "ITACDGroup": ["5AFC3148-4BCC-11D1-BF80-00805FC147D3"],
    "ITAgentSession": ["5AFC3147-4BCC-11D1-BF80-00805FC147D3"],
    "ITAgent": ["5770ECE5-4B27-11D1-BF80-00805FC147D3"],
    "ITScriptableAudioFormat": ["B87658BD-3C59-4F64-BE74-AEDE3E86A81E"],
    "ITBasicCallControl2": ["161A4A56-1E99-4B3F-A46A-168F38A5EE4C"],
    "ITLegacyWaveSupport": ["207823EA-E252-11D2-B77E-0080C7135381"],
    "IEnumSubStream": ["EE3BD609-3868-11D2-A045-00C04FB6809F"],
    "ITSubStream": ["EE3BD608-3868-11D2-A045-00C04FB6809F"],
    "ITSubStreamControl": ["EE3BD607-3868-11D2-A045-00C04FB6809F"],
    "IEnumStream": ["EE3BD606-3868-11D2-A045-00C04FB6809F"],
    "ITStream": ["EE3BD605-3868-11D2-A045-00C04FB6809F"],
    "ITStreamControl": ["EE3BD604-3868-11D2-A045-00C04FB6809F"],
    "ITDispatchMapper": ["E9225295-C759-11D1-A02B-00C04FB6809F"],
    "ITCallNotificationEvent": ["895801DF-3DD6-11D1-8F30-00C04FB6809F"],
    "IEnumCallingCard": ["0C4D8F02-8DDB-11D1-A09E-00805FC147D3"],
    "ITCallingCard": ["0C4D8F00-8DDB-11D1-A09E-00805FC147D3"],
    "IEnumLocation": ["0C4D8F01-8DDB-11D1-A09E-00805FC147D3"],
    "ITLocationInfo": ["0C4D8EFF-8DDB-11D1-A09E-00805FC147D3"],
    "ITAddressTranslationInfo": ["AFC15945-8D40-11D1-A09E-00805FC147D3"],
    "ITAddressTranslation": ["0C4D8F03-8DDB-11D1-A09E-00805FC147D3"],
    "ITForwardInformation2": ["5229B4ED-B260-4382-8E1A-5DF3A8A4CCC0"],
    "ITForwardInformation": ["449F659E-88A3-11D1-BB5D-00C04FB6809F"],
    "ITCollection2": ["E6DDDDA5-A6D3-48FF-8737-D32FC4D95477"],
    "ITCollection": ["5EC5ACF2-9C02-11D0-8362-00AA003CCABD"],
    "ITRequestEvent": ["AC48FFDE-F8C4-11D1-A030-00C04FB6809F"],
    "ITRequest": ["AC48FFDF-F8C4-11D1-A030-00C04FB6809F"],
    "ITCallInfoChangeEvent": ["5D4B65F9-E51C-11D1-A02F-00C04FB6809F"],
    "ITQOSEvent": ["CFA3357C-AD77-11D1-BB68-00C04FB6809F"],
    "ITToneTerminalEvent": ["E6F56009-611F-4945-BBD2-2D0CE5612056"],
    "ITASRTerminalEvent": ["EE016A02-4FA9-467C-933F-5A15B12377D7"],
    "ITTTSTerminalEvent": ["D964788F-95A5-461D-AB0C-B9900A6C2713"],
    "ITFileTerminalEvent": ["E4A7FBAC-8C17-4427-9F55-9F589AC8AF00"],
    "ITAddressDeviceSpecificEvent": ["3ACB216B-40BD-487A-8672-5CE77BD7E3A3"],
    "ITAddressEvent": ["831CE2D1-83B5-11D1-BB5C-00C04FB6809F"],
    "ITCallHubEvent": ["A3C15451-5B92-11D1-8F4E-00C04FB6809F"],
    "ITTAPIEventNotification": ["EDDB9426-3B91-11D1-8F30-00C04FB6809F"],
    "ITTAPIObjectEvent2": ["359DDA6E-68CE-4383-BF0B-169133C41B46"],
    "ITTAPIObjectEvent": ["F4854D48-937A-11D1-BB58-00C04FB6809F"],
    "ITToneDetectionEvent": ["407E0FAF-D047-4753-B0C6-8E060373FECD"],
    "ITDigitsGatheredEvent": ["E52EC4C1-CBA3-441A-9E6A-93CB909E9724"],
    "ITDigitGenerationEvent": ["80D3BFAD-57D9-11D2-A04A-00C04FB6809F"],
    "ITDigitDetectionEvent": ["80D3BFAC-57D9-11D2-A04A-00C04FB6809F"],
    "ITCallMediaEvent": ["FF36B87F-EC3A-11D0-8EE4-00C04FB6809F"],
    "ITPhoneDeviceSpecificEvent": ["63FFB2A6-872B-4CD3-A501-326E8FB40AF7"],
    "ITCallStateEvent": ["62F47097-95C9-11D0-835D-00AA003CCABD"],
    "ITPhoneEvent": ["8F942DD8-64ED-4AAF-A77D-B23DB0837EAD"],
    "IEnumPluggableSuperclassInfo": ["E9586A80-89E6-4CFF-931D-478D5751F4C0"],
    "IEnumPluggableTerminalClassInfo": ["4567450C-DBEE-4E3F-AAF5-37BF9EBF5E29"],
    "IEnumBstr": ["35372049-0BC6-11D2-A033-00C04FB6809F"],
    "IEnumCallHub": ["A3C15450-5B92-11D1-8F4E-00C04FB6809F"],
    "IEnumAddress": ["1666FCA1-9363-11D0-835C-00AA003CCABD"],
    "IEnumCall": ["AE269CF6-935E-11D0-835C-00AA003CCABD"],
    "IEnumTerminalClass": ["AE269CF5-935E-11D0-835C-00AA003CCABD"],
    "IEnumTerminal": ["AE269CF4-935E-11D0-835C-00AA003CCABD"],
    "IEnumPhone": ["F15B7669-4780-4595-8C89-FB369C8CF7AA"],
    "ITCustomTone": ["357AD764-B3C6-4B2A-8FA5-0722827A9254"],
    "ITDetectTone": ["961F79BD-3097-49DF-A1D6-909B77E89CA0"],
    "ITLegacyCallMediaControl2": ["57CA332D-7BC2-44F1-A60C-936FE8D7CE73"],
    "ITLegacyCallMediaControl": ["D624582F-CC23-4436-B8A5-47C625C8045D"],
    "ITLegacyAddressMediaControl2": ["B0EE512B-A531-409E-9DD9-4099FE86C738"],
    "ITPrivateEvent": ["0E269CD0-10D4-4121-9C22-9C85D625650D"],
    "ITLegacyAddressMediaControl": ["AB493640-4C0B-11D2-A046-00C04FB6809F"],
    "ITCallHub": ["A3C1544E-5B92-11D1-8F4E-00C04FB6809F"],
    "ITStaticAudioTerminal": ["A86B7871-D14C-48E6-922E-A8D15F984800"],
    "ITBasicAudioTerminal": ["B1EFC38D-9355-11D0-835C-00AA003CCABD"],
    "ITMediaControl": ["C445DDE8-5199-4BC7-9807-5FFB92E42E09"],
    "ITMediaRecord": ["F5DD4592-5476-4CC1-9D4D-FAD3EEFE7DB2"],
    "ITMediaPlayback": ["627E8AE6-AE4C-4A69-BB63-2AD625404B77"],
    "ITFileTrack": ["31CA6EA9-C08A-4BEA-8811-8E9C1BA3EA3A"],
    "ITMultiTrackTerminal": ["FE040091-ADE8-4072-95C9-BF7DE8C54B44"],
    "ITTerminal": ["B1EFC38A-9355-11D0-835C-00AA003CCABD"],
    "ITCallInfo2": ["94D70CA6-7AB0-4DAA-81CA-B8F8643FAEC1"],
    "ITCallInfo": ["350F85D1-1227-11D3-83D4-00C04FB6809F"],
    "ITBasicCallControl": ["B1EFC389-9355-11D0-835C-00AA003CCABD"],
    "ITAutomatedPhoneControl": ["1EE1AF0E-6159-4A61-B79B-6A4BA3FC9DFC"],
    "ITPhone": ["09D48DB4-10CC-4388-9DE7-A8465618975A"],
    "ITAddressCapabilities": ["8DF232F5-821B-11D1-BB5C-00C04FB6809F"],
    "ITAddress2": ["B0AE5D9B-BE51-46C9-B0F7-DFA8A22A8BC4"],
    "ITAddress": ["B1EFC386-9355-11D0-835C-00AA003CCABD"],
    "ITTerminalSupport2": ["F3EB39BC-1B1F-4E99-A0C0-56305C4DD591"],
    "ITTerminalSupport": ["B1EFC385-9355-11D0-835C-00AA003CCABD"],
    "ITPluggableTerminalSuperclassInfo": ["6D54E42C-4625-4359-A6F7-631999107E05"],
    "ITPluggableTerminalClassInfo": ["41757F4A-CF09-4B34-BC96-0A79D2390076"],
    "ITMediaSupport": ["B1EFC384-9355-11D0-835C-00AA003CCABD"],
    "ITTAPI2": ["54FBDC8C-D90F-4DAD-9695-B373097F094B"],
    "ITTAPI": ["B1EFC382-9355-11D0-835C-00AA003CCABD"],
    "ITPluggableTerminalSuperclassRegistration": ["60D3C08A-C13E-4195-9AB0-8DE768090F25"],
    "ITPluggableTerminalClassRegistration": ["924A3723-A00B-4F5F-9FEE-8E9AEB9E82AA"],
    "ITTerminalManager2": ["BB33DEC6-B2C7-46E6-9ED1-498B91FA85AC"],
    "ITTerminalManager": ["7170F2DE-9BE3-11D0-A009-00AA00B605A4"],
    "ITPluggableTerminalInitialization": ["AED6483C-3304-11D2-86F1-006008B0E5D2"],
    "ITTerminalControl": ["AED6483B-3304-11D2-86F1-006008B0E5D2"],
    "IRTCPresenceDevice": ["BC6A90DD-AD9A-48DA-9B0C-2515E38521AD"],
    "IRTCEnumPresenceDevices": ["708C2AB7-8BF8-42F8-8C7D-635197AD5539"],
    "IRTCSessionDescriptionManager": ["BA7F518E-D336-4070-93A6-865395C843F9"],
    "IRTCSessionReferredEvent": ["176A6828-4FCC-4F28-A862-04597A6CF1C4"],
    "IRTCSessionReferStatusEvent": ["3D8FC2CD-5D76-44AB-BB68-2A80353B34A2"],
    "IRTCUserSearchResultsEvent": ["D8C8C3CD-7FAC-4088-81C5-C24CBC0938E3"],
    "IRTCEnumUserSearchResults": ["83D4D877-AA5D-4A5B-8D0E-002A8067E0E8"],
    "IRTCUserSearchResult": ["851278B2-9592-480F-8DB5-2DE86B26B54D"],
    "IRTCUserSearchQuery": ["288300F5-D23A-4365-9A73-9985C98C2881"],
    "IRTCUserSearch": ["B619882B-860C-4DB4-BE1B-693B6505BBE5"],
    "IRTCClientPortManagement": ["D5DF3F03-4BDE-4417-AEFE-71177BDAEA66"],
    "IRTCSessionPortManagement": ["A072F1D6-0286-4E1F-85F2-17A2948456EC"],
    "IRTCPortManager": ["DA77C14B-6208-43CA-8DDF-5B60A0A69FAC"],
    "IRTCEventNotification": ["13FA24C7-5748-4B21-91F5-7397609CE747"],
    "IRTCBuddyGroup": ["60361E68-9164-4389-A4C6-D0B3925BDA5E"],
    "IRTCWatcher2": ["D4D9967F-D011-4B1D-91E3-ABA78F96393D"],
    "IRTCWatcher": ["C7CEDAD8-346B-4D1B-AC02-A2088DF9BE4F"],
    "IRTCBuddy2": ["102F9588-23E7-40E3-954D-CD7A1D5C0361"],
    "IRTCBuddy": ["FCB136C8-7B90-4E0C-BEFE-56EDF0BA6F1C"],
    "IRTCPresenceContact": ["8B22F92C-CD90-42DB-A733-212205C3E3DF"],
    "IRTCEnumGroups": ["742378D6-A141-4415-8F27-35D99076CF5D"],
    "IRTCEnumWatchers": ["A87D55D7-DB74-4ED1-9CA4-77A0E41B413E"],
    "IRTCEnumBuddies": ["F7296917-5569-4B3B-B3AF-98D1144B2B87"],
    "IRTCEnumProfiles": ["29B7C41C-ED82-4BCA-84AD-39D5101B58E3"],
    "IRTCEnumParticipants": ["FCD56F29-4A4F-41B2-BA5C-F5BCCC060BF6"],
    "IRTCCollection": ["EC7C8096-B918-4044-94F1-E4FBA0361D5C"],
    "IRTCPresenceStatusEvent": ["78673F32-4A0F-462C-89AA-EE7706707678"],
    "IRTCPresenceDataEvent": ["38F0E78C-8B87-4C04-A82D-AEDD83C909BB"],
    "IRTCPresencePropertyEvent": ["F777F570-A820-49D5-86BD-E099493F1518"],
    "IRTCReInviteEvent": ["11558D84-204C-43E7-99B0-2034E9417F7D"],
    "IRTCMediaRequestEvent": ["52572D15-148C-4D97-A36C-2DA55C289D63"],
    "IRTCInfoEvent": ["4E1D68AE-1912-4F49-B2C3-594FADFD425F"],
    "IRTCBuddyGroupEvent": ["3A79E1D1-B736-4414-96F8-BBC7F08863E4"],
    "IRTCWatcherEvent2": ["E52891E8-188C-49AF-B005-98ED13F83F9C"],
    "IRTCWatcherEvent": ["F30D7261-587A-424F-822C-312788F43548"],
    "IRTCBuddyEvent2": ["484A7F1E-73F0-4990-BFC2-60BC3978A720"],
    "IRTCBuddyEvent": ["F36D755D-17E6-404E-954F-0FC07574C78D"],
    "IRTCMessagingEvent": ["D3609541-1B29-4DE5-A4AD-5AEBAF319512"],
    "IRTCIntensityEvent": ["4C23BF51-390C-4992-A41D-41EEC05B2A4B"],
    "IRTCMediaEvent": ["099944FB-BCDA-453E-8C41-E13DA2ADF7F3"],
    "IRTCParticipantStateChangeEvent": ["09BCB597-F0FA-48F9-B420-468CEA7FDE04"],
    "IRTCSessionOperationCompleteEvent2": ["F6FC2A9B-D5BC-4241-B436-1B8460C13832"],
    "IRTCSessionOperationCompleteEvent": ["A6BFF4C0-F7C8-4D3C-9A41-3550F78A95B0"],
    "IRTCSessionStateChangeEvent2": ["4F933171-6F95-4880-80D9-2EC8D495D261"],
    "IRTCSessionStateChangeEvent": ["B5BAD703-5952-48B3-9321-7F4500521506"],
    "IRTCRegistrationStateChangeEvent": ["62D0991B-50AB-4F02-B948-CA94F26F8F95"],
    "IRTCClientEvent": ["2B493B7A-3CBA-4170-9C8B-76A9DACDD644"],
    "IRTCProfileEvent2": ["62E56EDC-03FA-4121-94FB-23493FD0AE64"],
    "IRTCProfileEvent": ["D6D5AB3B-770E-43E8-800A-79B062395FCA"],
    "IRTCRoamingEvent": ["79960A6B-0CB1-4DC8-A805-7318E99902E8"],
    "IRTCParticipant": ["AE86ADD5-26B1-4414-AF1D-B94CD938D739"],
    "IRTCSessionCallControl": ["E9A50D94-190B-4F82-9530-3B8EBF60758A"],
    "IRTCSession2": ["17D7CDFC-B007-484C-99D2-86A8A820991D"],
    "IRTCSession": ["387C8086-99BE-42FB-9973-7C0FC0CA9FA8"],
    "IRTCProfile2": ["4B81F84E-BDC7-4184-9154-3CB2DD7917FB"],
    "IRTCProfile": ["D07ECA9E-4062-4DD4-9E7D-722A49BA7303"],
    "IRTCClientProvisioning2": ["A70909B5-F40E-4587-BB75-E6BC0845023E"],
    "IRTCClientProvisioning": ["B9F5CF06-65B9-4A80-A0E6-73CAE3EF3822"],
    "IRTCClientPresence2": ["AD1809E8-62F7-4783-909A-29C9D2CB1D34"],
    "IRTCClientPresence": ["11C3CBCC-0744-42D1-968A-51AA1BB274C6"],
    "IRTCClient2": ["0C91D71D-1064-42DA-BFA5-572BEB8EEA84"],
    "IRTCClient": ["07829E45-9A34-408E-A011-BDDF13487CD1"],
    "IUPnPDeviceHostSetup": ["6BD34909-54E7-4FBF-8562-7B89709A589A"],
    "IUPnPDescriptionDocumentCallback": ["77394C69-5486-40D6-9BC3-4991983E02DA"],
    "IUPnPDescriptionDocument": ["11D1C1B2-7DAA-4C9E-9595-7F82ED206D1E"],
    "IUPnPDeviceDocumentAccess": ["E7772804-3287-418E-9072-CF2B47238981"],
    "IUPnPDevice": ["3D44D0D1-98C9-4889-ACD1-F9D674BF2221"],
    "IUPnPDevices": ["FDBC0C73-BDA3-4C66-AC4F-F2D96FDAD68C"],
    "IUPnPServiceCallback": ["31FADCA9-AB73-464B-B67D-5C1D0F83C8B8"],
    "IUPnPService": ["A295019C-DC65-47DD-90DC-7FE918A1AB44"],
    "IUPnPServices": ["3F8C8E9E-9A7A-4DC8-BC41-FF31FA374956"],
    "IUPnPDeviceFinderCallback": ["415A984A-88B3-49F3-92AF-0508BEDF0D6C"],
    "IUPnPDeviceFinder": ["ADDA3D55-6F72-4319-BFF9-18600A539B10"],
    "IUPnPPrivateDocumentCallbackHelper": ["19432A8E-4A32-4860-B8FB-95B1117CD4E5"],
    "IUPnPDeviceFinderAddCallbackWithInterface": ["983DFC0B-1796-44DF-8975-CA545B620EE5"],
    "IUPnPDeviceHostICSSupport": ["3FFC5AE5-A66B-499C-A180-C7393DB6BA8D"],
    "ISOAPRequest": ["AD194525-6E01-4BCA-929C-23C7383336AF"],
    "IUPnPServiceCallbackPrivate": ["24EA2515-F612-4528-BA82-7BD3DBBAD303"],
    "IUPnPPrivateServiceHelper2": ["340F4076-6856-48F9-B3C4-97B91B68D77E"],
    "IUPnPPrivateCallbackHelper": ["8DCC8327-DBE9-48E6-846C-33725865D50C"],
    "IUPnPRemoteEndpointInfo": ["C92EB863-0269-4AFF-9C72-75321BBA2952"],
    "IUPnPDeviceProvider": ["204810B8-73B2-11D4-BF42-00B0D0118B56"],
    "IUPnPDeviceControl": ["204810BA-73B2-11D4-BF42-00B0D0118B56"],
    "IUPnPReregistrar": ["204810B7-73B2-11D4-BF42-00B0D0118B56"],
    "IUPnPRegistrar": ["204810B6-73B2-11D4-BF42-00B0D0118B56"],
    "IUPnPEventSource": ["204810B5-73B2-11D4-BF42-00B0D0118B56"],
    "IUPnPEventSink": ["204810B4-73B2-11D4-BF42-00B0D0118B56"],
    "IXmlProviderEventNotification": ["A4886EFF-60B4-11D7-AE0A-00104BC54117"],
    "IXmlProviderNotification": ["A4886EFE-60B4-11D7-AE0A-00104BC54117"],
    "IXmlProviderDocuments": ["A4886EFD-60B4-11D7-AE0A-00104BC54117"],
    "IXmlProviderMaster": ["A4886EFC-60B4-11D7-AE0A-00104BC54117"],
    "IRowInfo": ["0C733AC1-2A1C-11CE-ADE5-00AA0044773D"],
    "ITmNodeName": ["30274F88-6EE4-474E-9B95-7807BC9EF8CF"],
    "ITransactionOutcomeEvents": ["3A6AD9E2-23B9-11CF-AD60-00AA00A74CCD"],
    "ITransactionOptions": ["3A6AD9E0-23B9-11CF-AD60-00AA00A74CCD"],
    "ITransactionDispenser": ["3A6AD9E1-23B9-11CF-AD60-00AA00A74CCD"],
    "ITransaction2": ["34021548-0065-11D3-BAC1-00C04F797BE2"],
    "ITransactionCloner": ["02656950-2152-11D0-944C-00A0C905416E"],
    "ITransaction": ["0FB15084-AF41-11CE-BD2B-204C4F4F5020"],
    "IEventServerTrace": ["9A9F12B8-80AF-47AB-A579-35EA57725370"],
    "IComLceEventDispatcher": ["6E35779B-305C-11D2-98A5-00C04F8EE1C4"],
    "INtaHelper": ["F5659960-0799-11D2-B720-00C04F8EE1C4"],
    "IProcessWatch": ["3194B4CE-EF32-11D1-93AE-00AA00BA3258"],
    "IProcessTerminateNotify": ["3194B4CF-EF32-11D1-93AE-00AA00BA3258"],
    "IEventServerInternal": ["2A5354DD-0634-4B0E-9D5A-FC5836CDCDF5"],
    "IEventServer2": ["378F3CA7-BD24-481C-8DC3-5E5ECE1BCAD7"],
    "IEventServer": ["F1CB0608-EC04-11D1-93AE-00AA00BA3258"],
    "IEventRegistrar": ["B4777622-6EB8-4655-AE1B-AF0A6E046CD0"],
    "IEventDispatcher": ["3194B4CD-EF32-11D1-93AE-00AA00BA3258"],
    "IEventCall": ["90D6AF83-0648-11D2-B719-00C04F8EE1C4"],
    "AsyncIEventSourceCallback2": ["C95BFC3D-76C5-4FDF-B0DE-A31F56785638"],
    "IEventSourceCallback2": ["F4C459A1-A13D-4BB8-B0F3-B76F860A07A0"],
    "AsyncIEventSourceCallback": ["90D6AF82-0648-11D2-B719-00C04F8EE1C4"],
    "IEventSourceCallback": ["3194B4CC-EF32-11D1-93AE-00AA00BA3258"],
    "IEnterActivityWithNoLock": ["D7174F82-36B8-4AA8-800A-E963AB2DFAB9"],
    "IQCPartitionInfo": ["59AA8AFC-F483-4862-A9A8-BEF669F6583D"],
    "IMarshalInterceptor": ["C99D1FC8-D0DC-11D2-9228-00C04F79D1EB"],
    "IQCMonikerInfo": ["83F3D27D-0646-11D2-9F6F-00C04FC340EE"],
    "IMkOption": ["E83BCB9F-5B12-11D2-9B88-00C04F7978E0"],
    "IQCQueueAdministration": ["1FA984EA-E213-11D2-9B41-00C04F7978E0"],
    "IMSMQQueueOptions": ["EF50B580-71BC-11D2-9BB9-00C04F7978E0"],
    "IQCPlayer": ["A3E69F2B-00AA-11D2-B58A-00E0290E6C31"],
    "IIntegrator": ["1F20BC5A-0549-11D2-8B2A-0000F8065031"],
    "ILQue": ["EC9E950E-AF2A-11D2-9A72-00C04F79B14C"],
    "ILMessage": ["CB34ADCA-9C0D-11D4-8373-00C04F605588"],
    "IQCListener": ["2A36CF7E-9B12-11D4-8373-00C04F605588"],
    "IQCInterfaceManager": ["7DAB9041-3180-42C6-A4D6-D895B512746B"],
    "IRpcChannelBufferInternal": ["6BC6DF07-620F-4219-BC54-B5C65BB71E9B"],
    "IChannelManager": ["99921E41-C341-11D0-8B1D-00A0C90365D6"],
    "IRecorderInternal": ["5D0B6204-35DE-4A66-AB26-1E5A7B332A4A"],
    "IMarshal3": ["7090ED49-E141-11D1-B586-00E0290E6C31"],
    "IMessageMover": ["588A085A-B795-11D1-8054-00C04FC340EE"],
    "IClassVbDebugInfo": ["2AAC1488-7809-11D2-9FEF-00C04F8EF934"],
    "IClassFactoryWithCoContext": ["0628A7E8-6918-11D2-9FED-00C04F8EF934"],
    "IMtsVbHelper": ["FC4886B2-A40F-11D1-AA88-00AA00BA3258"],
    "IEventSystem2": ["99CC098F-A48A-4E9C-8E58-965C0AFC19D5"],
    "IEventSubscription3": ["FBC1D17D-C498-43A0-81AF-423DDD530AF6"],
    "IEventSubscription2": ["4A6B0E16-2E38-11D1-9965-00C04FBBB345"],
    "IEventClassParallelFiringTimeout": ["A5657E5C-7BAE-4E81-9C17-284655918763"],
    "IEventClass3": ["7FB7EA43-2D76-4EA8-8CD9-3DECC270295E"],
    "IMultiInterfaceEventControl": ["0343E2F5-86F6-11D1-B760-00C04FB926AF"],
    "IEventControl": ["0343E2F4-86F6-11D1-B760-00C04FB926AF"],
    "IEventProperty": ["DA538EE2-F4DE-11D1-B6BB-00805FC79216"],
    "IEventObjectCollection": ["F89AC270-D4EB-11D1-B682-00805FC79216"],
    "IEnumEventObject": ["F4A07D63-2E25-11D1-9964-00C04FBBB345"],
    "IEventObjectChange2": ["7701A9C3-BD68-438F-83E0-67BF4F53A422"],
    "IEventObjectChange": ["F4A07D70-2E25-11D1-9964-00C04FBBB345"],
    "IMultiInterfacePublisherFilter": ["465E5CC1-7B26-11D1-88FB-0080C7D771BF"],
    "IPublisherFilter": ["465E5CC0-7B26-11D1-88FB-0080C7D771BF"],
    "IFiringControl": ["E0498C93-4EFE-11D1-9971-00C04FBBB345"],
    "IEventSubscription": ["4A6B0E15-2E38-11D1-9965-00C04FBBB345"],
    "IEventClass2": ["FB2B72A1-7A68-11D1-88F9-0080C7D771BF"],
    "IEventClass": ["FB2B72A0-7A68-11D1-88F9-0080C7D771BF"],
    "IEventPublisher": ["E341516B-2E32-11D1-9964-00C04FBBB345"],
    "IEventSystem": ["4E14FB9F-2E22-11D1-9964-00C04FBBB345"],
    "ISystemDebugEventFireAuto": ["6C736DEE-AB0E-11D0-A2AD-00A0C90F27E8"],
    "ISystemDebugEventFire": ["6C736DC1-AB0D-11D0-A2AD-00A0C90F27E8"],
    "ICatalogCollection": ["6EB22872-8A19-11D0-81B6-00A0C9231C29"],
    "ICatalogObject": ["6EB22871-8A19-11D0-81B6-00A0C9231C29"],
    "ICOMAdminCatalog2": ["790C6E0B-9194-4CC9-9426-A48A63185696"],
    "ICOMAdminCatalog": ["DD662187-DFC2-11D1-A2CF-00805FC79235"],
    "IMtsGrp": ["4B2E958C-0393-11D1-B1AB-00AA00BA3258"],
    "IMTSLocator": ["D19B8BFD-7F88-11D0-B16E-00AA00BA3258"],
    "IMtsEventInfo": ["D56C3DC1-8482-11D0-B170-00AA00BA3258"],
    "IMtsEvents": ["BACEDF4D-74AB-11D0-B162-00AA00BA3258"],
    "ISystemAppEventData": ["D6D48A3C-D5C5-49E7-8C74-99E4889ED52F"],
    "IComObjectConstruction2Events": ["4B5A7827-8DF2-45C0-8F6F-57EA1F856A9F"],
    "IComObjectPool2Events": ["65BF6534-85EA-4F64-8CF4-3D974B2AB1CF"],
    "IComInstance2Events": ["20E3BF07-B506-4AD5-A50C-D2CA5B9C158E"],
    "IComTransaction2Events": ["A136F62A-2F94-4288-86E0-D8A1FA4C0299"],
    "IComApp2Events": ["1290BC1A-B219-418D-B078-5934DED08242"],
    "IComTrackingInfoProperties": ["789B42BE-6F6B-443A-898E-67ABF390AA14"],
    "IComTrackingInfoObject": ["116E42C5-D8B1-47BF-AB1E-C895ED3E2372"],
    "IComTrackingInfoCollection": ["C266C677-C9AD-49AB-9FD9-D9661078588A"],
    "IComTrackingInfoEvents": ["4E6CDCC9-FB25-4FD5-9CC5-C9F4B6559CEC"],
    "IComMethod2Events": ["FB388AAA-567D-4024-AF8E-6E93EE748573"],
    "IComCRMEvents": ["683130B5-2E50-11D2-98A5-00C04F8EE1C4"],
    "ILBEvents": ["683130B4-2E50-11D2-98A5-00C04F8EE1C4"],
    "IComExceptionEvents": ["683130B3-2E50-11D2-98A5-00C04F8EE1C4"],
    "IComQCEvents": ["683130B2-2E50-11D2-98A5-00C04F8EE1C4"],
    "IComIdentityEvents": ["683130B1-2E50-11D2-98A5-00C04F8EE1C4"],
    "IComActivityEvents": ["683130B0-2E50-11D2-98A5-00C04F8EE1C4"],
    "IComObjectConstructionEvents": ["683130AF-2E50-11D2-98A5-00C04F8EE1C4"],
    "IComObjectPoolEvents2": ["683130AE-2E50-11D2-98A5-00C04F8EE1C4"],
    "IComObjectPoolEvents": ["683130AD-2E50-11D2-98A5-00C04F8EE1C4"],
    "IComSecurityEvents": ["683130AC-2E50-11D2-98A5-00C04F8EE1C4"],
    "IComResourceEvents": ["683130AB-2E50-11D2-98A5-00C04F8EE1C4"],
    "IComObjectEvents": ["683130AA-2E50-11D2-98A5-00C04F8EE1C4"],
    "IComMethodEvents": ["683130A9-2E50-11D2-98A5-00C04F8EE1C4"],
    "IComTransactionEvents": ["683130A8-2E50-11D2-98A5-00C04F8EE1C4"],
    "IComInstanceEvents": ["683130A7-2E50-11D2-98A5-00C04F8EE1C4"],
    "IComAppEvents": ["683130A6-2E50-11D2-98A5-00C04F8EE1C4"],
    "IComThreadEvents": ["683130A5-2E50-11D2-98A5-00C04F8EE1C4"],
    "IComUserEvent": ["683130A4-2E50-11D2-98A5-00C04F8EE1C4"],
    "IMtsEventsPriv2": ["59415D35-A530-4C14-AF2A-C71F8BFAE2EE"],
    "IMtsEventsPriv": ["44F876D8-8391-11D0-B16F-00AA00BA3258"],
    "IVolatilePolicyManager": ["9211A2CA-7B10-11D1-8633-0060089F6007"],
    "ICreateWithTipTransactionEx": ["455ACF59-5345-11D2-99CF-00C04F797BC9"],
    "ICreateWithTransactionEx": ["455ACF57-5345-11D2-99CF-00C04F797BC9"],
    "ITransactionContext": ["7999FC21-D3C6-11CF-ACAB-00A024A55AEF"],
    "ITransactionContextEx": ["7999FC22-D3C6-11CF-ACAB-00A024A55AEF"],
    "IEnumTRUSTPOLICYINFO": ["9211A291-7B10-11D1-8633-0060089F6007"],
    "IEnumTrustPolicy": ["9211A290-7B10-11D1-8633-0060089F6007"],
    "IScriptPolicyMaker": ["9211A27B-7B10-11D1-8633-0060089F6007"],
    "ITrustPolicyScript": ["9211A27A-7B10-11D1-8633-0060089F6007"],
    "ITrustPolicySetup": ["9211A279-7B10-11D1-8633-0060089F6007"],
    "ITrustPolicyVerbs": ["9211A278-7B10-11D1-8633-0060089F6007"],
    "ITrustPropertySet": ["9211A277-7B10-11D1-8633-0060089F6007"],
    "ITrustEvaluationContextProvider": ["9211A27C-7B10-11D1-8633-0060089F6007"],
    "ITrustEvaluationContext": ["9211A276-7B10-11D1-8633-0060089F6007"],
    "IInstancesCollection": ["9211A27E-7B10-11D1-8633-0060089F6007"],
    "ICategoriesCollection": ["9211A27D-7B10-11D1-8633-0060089F6007"],
    "IPolicyCategoryRegister": ["9211A275-7B10-11D1-8633-0060089F6007"],
    "IPolicyManager": ["9211A274-7B10-11D1-8633-0060089F6007"],
    "ITrustManager": ["9211A272-7B10-11D1-8633-0060089F6007"],
    "ITrustPolicy": ["9211A271-7B10-11D1-8633-0060089F6007"],
    "IProvideEvalContext": ["9211A297-7B10-11D1-8633-0060089F6007"],
    "ITrustable": ["9211A270-7B10-11D1-8633-0060089F6007"],
    "IClrObjectFactory": ["ECABAFD2-7F19-11D2-978E-0000F8757E2A"],
    "IClerksCollection": ["3ADEFFE3-C802-11D1-82FB-00A0C91EEDE9"],
    "ICRMRecoveryClerk": ["46E4FA02-8789-4AB9-8AD3-8CF46B8459C7"],
    "ICRMClerk": ["53610480-9695-11D1-82ED-00A0C91EEDE9"],
    "IPoolMgrPrivate": ["2BD0C880-D2E2-11D1-939A-00AA00BA3258"],
    "IPoolMgr": ["AA089089-3689-11D1-B1CF-00AA00BA3258"],
    "IServicePoolOptions": ["1D04CDF7-EAD5-41F0-AA0A-80218BD53B0D"],
    "ISvcPoolInit": ["68954CDF-5D4E-4EF2-B9B7-604A9B22FBF8"],
    "IObjPool": ["7D8805A0-2EA7-11D1-B1CC-00AA00BA3258"],
    "IPooledObj": ["7D8805A1-2EA7-11D1-B1CC-00AA00BA3258"],
    "ISTAPropStore": ["F4319F39-C523-11D1-A64E-0000F805B4B0"],
    "IUserPropsEnumInternal": ["FE00EDC3-6BE3-4792-AA01-E663F1B70B10"],
    "IUserPropsInternal": ["2599BAB0-C5FB-11D1-9396-00AA00BA3258"],
    "IAssociation": ["FE454FF4-C5CF-11D1-9396-00AA00BA3258"],
    "IImpersonationControl": ["51372AFF-CAE7-11CF-BE81-00AA00A2FA25"],
    "INonMTSActivation": ["51372AFB-CAE7-11CF-BE81-00AA00A2FA25"],
    "IThreadEventSource": ["51372AFA-CAE7-11CF-BE81-00AA00A2FA25"],
    "IThreadEvents": ["51372AF9-CAE7-11CF-BE81-00AA00A2FA25"],
    "IDumpControl": ["368F417F-280E-4639-B17A-6DDB0D9EE2BE"],
    "IFailfastControl": ["51372AF8-CAE7-11CF-BE81-00AA00A2FA25"],
    "IPauseResumeApp": ["E7228E0B-A708-4113-84E8-239DB12E0DB2"],
    "IMTSPackage": ["9A83A958-B859-11D1-AA90-00AA00BA3258"],
    "IMTSPackageControl": ["51372AF1-CAE7-11CF-BE81-00AA00A2FA25"],
    "IPackageControlInternal": ["B1B229B0-B77E-11D0-8079-00C04FC2F9C1"],
    "ISecurityInternal": ["A71D9C69-AE37-11D1-B82B-0000F8757E2A"],
    "IObjectContextTransaction": ["51372AEE-CAE7-11CF-BE81-00AA00A2FA25"],
    "IGetInternalTransaction": ["BF3108F3-D51C-47F2-9E58-E2C874F639A4"],
    "ITransactionProperty": ["788EA814-87B1-11D1-BBA6-00C04FC2FA5F"],
    "IRootTxStreamInternal": ["4E311080-8E81-11D1-9DCE-00C04FC2FBA2"],
    "ITxStreamInternal": ["4E31107F-8E81-11D1-9DCE-00C04FC2FBA2"],
    "ITransactionEvents": ["6287E875-9050-11D1-9DCE-00C04FC2FBA2"],
    "ITransactionStream": ["97199110-DB2E-11D1-A251-0000F805CA53"],
    "IActivity": ["C3813A4A-CE3A-11D1-939A-00AA00BA3258"],
    "IMTSActivity": ["51372AF0-CAE7-11CF-BE81-00AA00A2FA25"],
    "ICallContextNotify": ["51372AEB-CAE7-11CF-BE81-00AA00A2FA25"],
    "IBabyJITInterceptor": ["4BC31C23-C58D-4964-BD3F-01A302A96ED5"],
    "IBabyJITActivation": ["A7F3111A-56C6-47DE-A32D-0C4F5769BB14"],
    "IEnableDisableProperty": ["822646E6-D8B4-4B6F-A000-CFD379510CA9"],
    "ITrackerProperty": ["FBAC04F0-7D8C-45BF-B5B6-C6841D16FB61"],
    "IJITActivationProperty": ["788EA813-87B1-11D1-BBA6-00C04FC2FA5F"],
    "IActivationEvents": ["788EA812-87B1-11D1-BBA6-00C04FC2FA5F"],
    "IRegisterPhase0": ["0199706D-7B3E-11D2-99FB-00C04F797BC9"],
    "IPhase0Notify": ["0199706C-7B3E-11D2-99FB-00C04F797BC9"],
    "IServiceConfigInternal": ["374093DF-B5E7-4B91-8445-5102C062C2C9"],
    "IContextProperties": ["D396DA85-BF8F-11D1-BBAE-00C04FC2FA5F"],
    "IMTSCall": ["51372AEF-CAE7-11CF-BE81-00AA00A2FA25"],
    "ITransactionResourcePool": ["C5FEB7C1-346A-11D1-B1CC-00AA00BA3258"],
    "ISendMethodEvents": ["2732FD59-B2B4-4D44-878C-8B8F09626008"],
    "IManagedActivationEvents": ["A5F325AF-572F-46DA-B8AB-827C3D95D99E"],
    "IAssemblyLocator": ["391FFBB9-A8EE-432A-ABC8-BAA238DAB90F"],
    "IAppDomainHelper": ["C7B67079-8255-42C6-9EC0-6994A3548780"],
    "IManagedObjectInfo": ["1427C51A-4584-49D8-90A0-C50D8086CBE9"],
    "IManagedPoolAction": ["DA91B74E-5388-4783-949D-C1CD5FB00506"],
    "IManagedPooledObj": ["C5DA4BEA-1B42-4437-8926-B6A38860A770"],
    "IServicePool": ["B302DF81-EA45-451E-99A2-09F9FD1B1E13"],
    "IServicePoolConfig": ["A9690656-5BCA-470C-8451-250C1F43A33E"],
    "IProcessInitializer": ["1113F52D-DC7F-4943-AED6-88D04027E32A"],
    "IComStaThreadPoolKnobs2": ["73707523-FF9A-4974-BF84-2108DC213740"],
    "IComMtaThreadPoolKnobs": ["F9A76D2E-76A5-43EB-A0C4-49BEC8E48480"],
    "IComStaThreadPoolKnobs": ["324B64FA-33B6-11D2-98B7-00C04F8EE1C4"],
    "IThreadPoolKnobs": ["51372AF7-CAE7-11CF-BE81-00AA00A2FA25"],
    "IServiceActivity": ["67532E0C-9E2F-4450-A354-035633944E17"],
    "IAsyncErrorNotify": ["FE6777FB-A674-4177-8F32-6D707E113484"],
    "IServiceCall": ["BD3E2E12-42DD-40F4-A09A-95A50C58304B"],
    "IServicePartitionConfig": ["80182D03-5EA4-4831-AE97-55BEFFC2E590"],
    "IServiceTrackerConfig": ["6C3A3E1D-0BA6-4036-B76F-D0404DB816C9"],
    "IServiceSynchronizationConfig": ["FD880E81-6DCE-4C58-AF83-A208846C0030"],
    "IServiceTransactionConfig": ["59F4C2A3-D3D7-4A31-B6E4-6AB3177C50B9"],
    "IServiceTransactionConfigBase": ["772B3FBE-6FFD-42FB-B5F8-8F9B260F3810"],
    "IServiceThreadPoolConfig": ["186D89BC-F277-4BCC-80D5-4DF7B836EF4A"],
    "IServiceInheritanceConfig": ["92186771-D3B4-4D77-A8EA-EE842D586F35"],
    "ICheckSxsConfig": ["0FF5A96F-11FC-47D1-BAA6-25DD347E7242"],
    "IServiceSxsConfig": ["C7CD7379-F3F2-4634-811B-703281D73E08"],
    "IServiceComTIIntrinsicsConfig": ["09E6831E-04E1-4ED4-9D0F-E8B168BAFEAF"],
    "IServiceIISIntrinsicsConfig": ["1A0CF920-D452-46F4-BC36-48118D54EA52"],
    "ICrmFormatLogRecords": ["9C51D821-C98B-11D1-82FB-00A0C91EEDE9"],
    "ICrmMonitor": ["70C8E443-C7ED-11D1-82FB-00A0C91EEDE9"],
    "ICrmMonitorClerks": ["70C8E442-C7ED-11D1-82FB-00A0C91EEDE9"],
    "ICrmMonitorLogRecords": ["70C8E441-C7ED-11D1-82FB-00A0C91EEDE9"],
    "ICrmCompensator": ["BBC01830-8D3B-11D1-82EC-00A0C91EEDE9"],
    "ICrmCompensatorVariants": ["F0BAF8E4-7804-11D1-82E9-00A0C91EEDE9"],
    "ICrmLogControl": ["A0E174B3-D26E-11D2-8F84-00805FC7BCD9"],
    "ICOMLBArguments": ["3A0F150F-8EE5-4B94-B40E-AEF2F9E42ED2"],
    "ISelectCOMLBServer": ["DCF443F4-3F8A-4872-B9F0-369A796D12D6"],
    "IPoolManager": ["0A469861-5A91-43A0-99B6-D5E179BB0631"],
    "IContextState": ["3C05E54B-A42A-11D2-AFC4-00C04F8EE1C4"],
    "IGetContextProperties": ["51372AF4-CAE7-11CF-BE81-00AA00A2FA25"],
    "IPlaybackControl": ["51372AFD-CAE7-11CF-BE81-00AA00A2FA25"],
    "IObjectContextTip": ["92FD41CA-BAD9-11D2-9A2D-00C04F797BC9"],
    "ITransactionStatus": ["61F589E8-3724-4898-A0A4-664AE9E1D1B4"],
    "IObjectContextInfo2": ["594BE71A-4BC4-438B-9197-CFD176248B09"],
    "IObjectContextInfo": ["75B52DDB-E8ED-11D1-93AD-00AA00BA3258"],
    "IObjectContextActivity": ["51372AFC-CAE7-11CF-BE81-00AA00A2FA25"],
    "IObjectConstructString": ["41C4F8B2-7439-11D2-98CB-00C04F8EE1C4"],
    "IObjectConstruct": ["41C4F8B3-7439-11D2-98CB-00C04F8EE1C4"],
    "ISharedPropertyGroupManager": ["2A005C0D-A5DE-11CF-9E66-00AA00A3F464"],
    "ISharedPropertyGroup": ["2A005C07-A5DE-11CF-9E66-00AA00A3F464"],
    "ISharedProperty": ["2A005C01-A5DE-11CF-9E66-00AA00A3F464"],
    "ObjectControl": ["7DC41850-0C31-11D0-8B79-00AA00B8A790"],
    "ISecurityProperty": ["51372AEA-CAE7-11CF-BE81-00AA00A2FA25"],
    "IEnumNames": ["51372AF2-CAE7-11CF-BE81-00AA00A2FA25"],
    "IObjectControl": ["51372AEC-CAE7-11CF-BE81-00AA00A2FA25"],
    "IObjectContext": ["51372AE0-CAE7-11CF-BE81-00AA00A2FA25"],
    "IDispenserDriver": ["208B3651-2B48-11CF-BE10-00AA00A2FA25"],
    "IHolder": ["BF6A1850-2B45-11CF-BE10-00AA00A2FA25"],
    "IDispenserManagerShutdownGuarantee": ["5CB31E11-2B5F-11CF-BE10-00AA00A2FA25"],
    "IDispenserManager": ["5CB31E10-2B5F-11CF-BE10-00AA00A2FA25"],
    "IProcessDump": ["23C9DD26-2355-4FE2-84DE-F779A238ADBD"],
    "ITrkSvrAppControl": ["6EB6BA78-BE49-4044-9FE5-25B98380CA3F"],
    "IGetAppData": ["B60040E0-BCF3-11D1-861D-0080C729264D"],
    "IReceiveAppData": ["413DAFB0-BCF4-11D1-861D-0080C729264D"],
    "IClassTrackerUpdate": ["EA61E3C2-7C62-11CF-BE3F-00AA00A2FA25"],
    "IAppTracker": ["9096B831-7472-11CF-BE39-00AA00A2FA25"],
    "IGetSecurityCallContext": ["CAFC823F-B441-11D1-B82B-0000F8757E2A"],
    "ISecurityCallContext": ["CAFC823E-B441-11D1-B82B-0000F8757E2A"],
    "ISecurityCallersColl": ["CAFC823D-B441-11D1-B82B-0000F8757E2A"],
    "ISecurityIdentityColl": ["CAFC823C-B441-11D1-B82B-0000F8757E2A"],
    "ISecurityCertificateColl": ["CAFC823B-B441-11D1-B82B-0000F8757E2A"],
    "ISecurityCallCtxPrivate": ["29012F73-8C30-11D1-8E04-0080C7F8C2BF"],
    "IMTxAS": ["74C08641-CEDB-11CF-8B49-00AA00B8A790"],
    "ObjectContext": ["74C08646-CEDB-11CF-8B49-00AA00B8A790"],
    "ContextInfo2": ["C99D6E75-2375-11D4-8331-00C04F605588"],
    "ContextInfo": ["19A5A02C-0AC8-11D2-B286-00C04F8EF934"],
    "SecurityProperty": ["E74A7215-014D-11D1-A63C-00A0C911B4E0"],
    "IEnumChannels": ["A4C65425-0F82-11D1-90C3-00C04FC2F568"],
    "IChannelMgr": ["85BD8E82-0FBA-11D1-90C3-00C04FC2F568"],
    "IImageList": ["46EB5926-582E-4017-9FDF-E8998DAA0950", "43136EB8-D36C-11CF-ADBC-00AA00A80033"],
    "IEmptyVolumeCache2": ["02B7E3BA-4DB3-11D2-B2D9-00C04F8EEC8C"],
    "IEmptyVolumeCache": ["8FCE5227-04DA-11D1-A004-00805F8ABE06"],
    "IEmptyVolumeCacheCallBack": ["6E793361-73C6-11D0-8469-00AA00442901"],
    "IDiscMaster": ["520CCA62-51A5-11D3-9144-00104BA11C5E"],
    "IDiscMasterProgressEvents": ["EC9E51C1-4E5D-11D3-9144-00104BA11C5E"],
    "IJolietDiscMaster": ["E3BC42CE-4E5C-11D3-9144-00104BA11C5E"],
    "IRedbookDiscMaster": ["E3BC42CD-4E5C-11D3-9144-00104BA11C5E"],
    "IEnumDiscMasterFormats": ["DDF445E1-54BA-11D3-9144-00104BA11C5E"],
    "IEnumDiscRecorders": ["9B1921E1-54AC-11D3-9144-00104BA11C5E"],
    "IDiscRecorder": ["85AC9776-CA88-4CF2-894E-09598C078A41"],
    "IMultiLanguage3": ["4E5868AB-B157-4623-9ACC-6A1D9CAEBE04"],
    "IMLangFontLink2": ["DCCFC162-2B38-11D2-B7EC-00C04F8F5D9A"],
    "IMLangFontLink": ["359F3441-BD4A-11D0-B188-00AA0038C969"],
    "IMLangCodePages": ["359F3443-BD4A-11D0-B188-00AA0038C969"],
    "IMultiLanguage2": ["DCCFC164-2B38-11D2-B7EC-00C04F8F5D9A"],
    "IMultiLanguage": ["275C23E1-3747-11D0-9FEA-00AA003F8646"],
    "IMLangConvertCharset": ["D66D6F98-CDAA-11D0-B822-00C04FC9B31F"],
    "IEnumScript": ["AE5F1430-388B-11D2-8380-00C04F8F5DA1"],
    "IEnumRfc1766": ["3DC39D1D-C030-11D0-B81B-00C04FC9B31F"],
    "IEnumCodePage": ["275C23E3-3747-11D0-9FEA-00AA003F8646"],
    "IMLangLineBreakConsole": ["F5BE2EE1-BFD7-11D0-B188-00AA0038C969"],
    "IMLangStringAStr": ["C04D65D2-B70D-11D0-B188-00AA0038C969"],
    "IMLangStringWStr": ["C04D65D0-B70D-11D0-B188-00AA0038C969"],
    "IMLangString": ["C04D65CE-B70D-11D0-B188-00AA0038C969"],
    "IMLangStringBufA": ["D24ACD23-BA72-11D0-B188-00AA0038C969"],
    "IMLangStringBufW": ["D24ACD21-BA72-11D0-B188-00AA0038C969"],
    "IOpsProfileSimple": ["7DD1362C-28B6-11D2-BCA7-00C04FD929DB"],
    "IAppPublisher": ["07250A10-9CF9-11D1-9076-006008059382"],
    "IEnumPublishedApps": ["0B124F8C-91F0-11D1-B8B5-006008059382"],
    "IPublishedApp": ["1BC752E0-9046-11D1-B8B3-006008059382"],
    "IShellApp": ["A3E14960-935F-11D1-B8B8-006008059382"],
    "ILogonStatusHost": ["60664CAF-AF0D-1007-A300-5C7D25FF22A0"],
    "ILocalMachine": ["60664CAF-AF0D-1005-A300-5C7D25FF22A0"],
    "ILogonEnumUsers": ["60664CAF-AF0D-1004-A300-5C7D25FF22A0"],
    "ILogonUser": ["60664CAF-AF0D-1003-A300-5C7D25FF22A0"],
    "IShellImageDataAbort": ["53FB8E58-50C0-4003-B4AA-0C8DF28E7F3A"],
    "IShellImageData": ["BFDEEC12-8040-4403-A5EA-9E07DAFCF530"],
    "IShellImageDataFactory": ["9BE8ED5C-EDAB-4D75-90F3-BD5BDBB21C82"],
    "IAsyncOperation": ["3D8B0590-F691-11D2-8EA9-006097DF5BD4"],
    "IEnumACString": ["8E74C210-CF9D-4EAF-A403-7356428F0A5A"],
    "IAutoComplete2": ["EAC04BC0-3791-11D2-BB95-0060977B464C"],
    "IAutoComplete": ["00BB2762-6A77-11D0-A535-00C04FD7D062"],
    "IPassportClientServices": ["B30F7305-5967-45D1-B7BC-D6EB7163D770"],
    "INewWDEvents": ["0751C551-7568-41C9-8E5B-E22E38919236"],
    "IWebWizardHost": ["18BCC359-4990-4BFB-B951-3C83702BE5F9"],
    "IFileSearchBand": ["2D91EEA1-9932-11D2-BE86-00A0C9A83DA1"],
    "IShellDispatch4": ["EFD84B2D-4BCF-4298-BE25-EB542A59FBDA"],
    "IShellDispatch3": ["177160CA-BB5A-411C-841D-BD38FACDEAA0"],
    "IShellDispatch2": ["A4C6892C-3BA9-11D2-9DEA-00C04FB16162"],
    "IShellDispatch": ["D8F015C0-C278-11CE-A49E-444553540000"],
    "IShellFolderViewDual2": ["31C147B6-0ADE-4A3C-B514-DDF932EF6D17"],
    "IShellFolderViewDual": ["E7A1AF80-4D96-11CF-960C-0080C7F4EE85"],
    "IShellLinkDual2": ["317EE249-F12E-11D2-B1E4-00C04F8EEB3E"],
    "IShellLinkDual": ["88A05C00-F000-11CE-8350-444553540000"],
    "FolderItems3": ["EAA7C309-BBEC-49D5-821D-64D966CB667F"],
    "FolderItems2": ["C94F0AD0-F363-11D2-A327-00C04F8EEC7F"],
    "FolderItem2": ["EDC817AA-92B8-11D1-B075-00C04FC33AA5"],
    "Folder3": ["A7AE5F64-C4D7-4D7F-9307-4D24EE54B841"],
    "Folder2": ["F0D2D8EF-3890-11D2-BF8B-00C04FB93661"],
    "Folder": ["BBCBDE60-C3FF-11CE-8350-444553540000"],
    "FolderItemVerbs": ["1F8352C0-50B0-11CF-960C-0080C7F4EE85"],
    "FolderItemVerb": ["08EC3E00-50B0-11CF-960C-0080C7F4EE85"],
    "FolderItems": ["744129E0-CBE5-11CE-8350-444553540000"],
    "FolderItem": ["FAC32C80-CBE4-11CE-8350-444553540000"],
    "ISearchCommandExt": ["1D2EFD50-75CE-11D1-B75A-00A0C90564FE"],
    "DFConstraint": ["4A3DF050-23BD-11D2-939F-00A0C91EEDBA"],
    "IFolderViewOC": ["9BA05970-F6A8-11CF-A442-00A0C90A8F39"],
    "IShellMenu": ["EE1F7637-E138-11D1-8379-00C04FD918D0"],
    "IAttachmentExecute": ["73DB1241-1E85-4581-8E4F-A81E1D0F8C57"],
    "IShellMenuCallback": ["4CA300A1-9B8D-11D1-8B22-00C04FD918D0"],
    "INewWindowManager": ["D2BC4C84-3F72-4A52-A604-7BCBF3982CBB"],
    "IBrowserFrameOptions": ["10DF43C8-1DBE-11D3-8B34-006097DF5BD4"],
    "IDelegateFolder": ["ADD8BA80-002B-11D0-8F0F-00C04FD7D062"],
    "IContextMenuSite": ["0811AEBE-0B87-4C54-9E72-548CF649016B"],
    "IDefViewSafety": ["9A93B3FB-4E75-4C74-871A-2CDA667F39A5"],
    "IImageRecompress": ["505F1513-6B3E-4892-A272-59F8889A4D3E"],
    "IShellItem": ["43826D1E-E718-42EE-BC55-A1E261C37BFE"],
    "IMenuPopup": ["D1E7AFEB-6A2E-11D0-8C78-00C04FD918B4"],
    "IRegTreeItem": ["A9521922-0812-4D44-9EC3-7FD38C726F3D"],
    "INamespaceWalk": ["57CED8A7-3F4A-432C-9350-30F24483F74F"],
    "INamespaceWalkCB": ["D92995F8-CF5E-4A76-BF59-EAD39EA2B97E"],
    "IBandSite": ["4CF504B0-DE96-11D0-8B3F-00A0C911E8E5"],
    "IFolderBandPriv": ["47C01F95-E185-412C-B5C5-4F27DF965AEA"],
    "IMenuBand": ["568804CD-CBD7-11D0-9816-00C04FD91972"],
    "IDeskBar": ["EB0FE173-1A3A-11D0-89B3-00A0C90A90AC"],
    "IInsertItem": ["D2B57227-3D23-4B95-93C0-492BD454C356"],
    "IDVGetEnum": ["70F55181-5FEA-4900-B6B8-7343CB0A348C"],
    "ICDBurnExt": ["2271DCCA-74FC-4414-8FB7-C56B05ACE2D7"],
    "IPassportWizard": ["A09DB586-9180-41AC-9114-460A7F362B76"],
    "IModalWindow": ["B4DB1657-70D7-485E-8E3E-6FCB5A5C1802"],
    "IAutoCompleteDropDown": ["3CD141F4-3C6A-11D2-BCAA-00C04FD929DB"],
    "IFolderViewHost": ["1EA58F02-D55A-411D-B09E-9E65AC21605B"],
    "IPublishingWizard": ["AA9198BB-CCEC-472D-BEED-19A4F6733F7A"],
    "IWebWizardExtension": ["0E6B3F66-98D1-48C0-A222-FBDE74E2FBC5"],
    "IWizardExtension": ["C02EA696-86CC-491E-9B23-74394A0444A8"],
    "IWizardSite": ["88960F5B-422F-4E7B-8013-73415381C3C3"],
    "ICDBurn": ["3D73A659-E5D0-4D42-AFC0-5121BA425C8D"],
    "ITaskbarList2": ["602D4995-B13A-429B-A66E-1935E44F4317"],
    "ITaskbarList": ["56FDF342-FD6D-11D0-958A-006097C9A090"],
    "IDeskBand": ["EB0FE172-1A3A-11D0-89B3-00A0C90A90AC"],
    "IDockingWindow": ["012DD920-7B26-11D0-8CA9-00A0C92DBFE8"],
    "IUserEventTimer": ["0F504B94-6E42-42E6-99E0-E20FAFE52AB4"],
    "IUserEventTimerCallback": ["E9EAD8E6-2A25-410E-9B58-A9FBEF1DD1A2"],
    "IExtractImage2": ["953BB1EE-93B4-11D1-98A3-00C04FB687DA"],
    "IExtractImage": ["BB2E617C-0920-11D1-9A0B-00C04FC2D6C1"],
    "INetCrawler": ["49C929EE-A1B7-4C58-B539-E63BE392B6F3"],
    "IItemNameLimits": ["1DF0D7F1-B267-4D28-8B10-12E23202A5C4"],
    "IUserNotification": ["BA9711BA-5893-4787-A7E1-41277151550B"],
    "IQueryContinue": ["7307055C-B24A-486B-9F25-163E597A28A9"],
    "IRemoteComputer": ["000214FE-0000-0000-C000-000000000046"],
    "IShellPropSheetExt": ["000214E9-0000-0000-C000-000000000046"],
    "IShellExtInit": ["000214E8-0000-0000-C000-000000000046"],
    "IActionProgress": ["49FF1173-EADC-446D-9285-156453A6431C"],
    "IQueryCancelAutoPlay": ["DDEFE873-6997-4E68-BE26-39B633ADBE12"],
    "IHWEventHandler": ["C1FB73D0-EC3A-4BA2-B512-8CDB9187B6D1"],
    "IActionProgressDialog": ["49FF1172-EADC-446D-9285-156453A6431C"],
    "IShellLinkW": ["000214F9-0000-0000-C000-000000000046"],
    "IShellLinkA": ["000214EE-0000-0000-C000-000000000046"],
    "ICategorizer": ["A3B14589-9174-49A8-89A3-06A1AE2B9BA7"],
    "ICategoryProvider": ["9AF64809-5864-4C26-A720-C1F78C086EE3"],
    "IPropertyUI": ["757A7D9F-919A-4118-99D7-DBB208C8CC66"],
    "IProfferService": ["CB728B20-F786-11CE-92AD-00AA00A74CD0"],
    "IShellBrowser": ["000214E2-0000-0000-C000-000000000046"],
    "IFolderFilter": ["9CC22886-DC8E-11D2-B1D0-00C04F8EEB3E"],
    "IFolderFilterSite": ["C0A651F5-B48B-11D2-B5ED-006097C686F6"],
    "IFolderView": ["CDE725B0-CCC9-4519-917E-325D72FAB4CE"],
    "IShellView2": ["88E39E80-3578-11CF-AE69-08002B2E1262"],
    "IShellView": ["000214E3-0000-0000-C000-000000000046"],
    "IShellFolder2": ["93F2F68C-1D1B-11D3-A30E-00C04F79ABD1", "000214E7-0000-0000-C000-000000000046"],
    "IEnumExtraSearch": ["0E700BE1-9DB6-11D1-A1CE-00C04FD75D13"],
    "IShellFolder": ["000214E6-0000-0000-C000-000000000046"],
    "IEnumIDList": ["000214F2-0000-0000-C000-000000000046"],
    "IPersistIDList": ["1079ACFC-29BD-11D3-8E0D-00C04F6837D5"],
    "IPersistFolder2": ["1AC3D9F0-175C-11D1-95BE-00609797EA4F"],
    "IPersistFolder": ["000214EA-0000-0000-C000-000000000046"],
    "ITravelLogClient2": ["0AD364CE-ADCB-11D3-8269-00805FC732C0"],
    "ITravelLogClient": ["3050F67A-98B5-11CF-BB82-00AA00BDCE0B"],
    "ITravelLogEx": ["3050F679-98B5-11CF-BB82-00AA00BDCE0B"],
    "ITravelLog": ["66A9CB08-4802-11D2-A561-00A0C92DBFE8"],
    "ITravelEntry": ["F46EDB3B-BC2F-11D0-9412-00AA00A3EBD3"],
    "ITravelLogStg": ["7EBFDD80-AD18-11D3-A4C5-00C04F72D6B8"],
    "IEnumTravelLogEntry": ["7EBFDD85-AD18-11D3-A4C5-00C04F72D6B8"],
    "ITravelLogEntry": ["7EBFDD87-AD18-11D3-A4C5-00C04F72D6B8"],
    "IVirusScanEngine": ["083DB180-B4A8-11CF-AAFA-00AA00B6015C"],
    "IRegisterVirusScanEngine": ["0825E060-B961-11CF-AAFA-00AA00B6015C"],
    "IVirusScanner": ["4589BEE0-B4B1-11CF-AAFA-00AA00B6015C"],
    "IDsQueryColumnHandler": ["C072999E-FA49-11D1-A0AF-00C04FA31A86"],
    "IQueryHandler": ["A60CC73F-E0FC-11D0-9750-00A0C906AF45"],
    "IQueryFrame": ["7E8C7C20-7C9D-11D0-913F-00AA00C16E65"],
    "ICommonQuery": ["AB50DEC0-6F1D-11D0-A1C4-00AA00C16E65"],
    "IPersistQuery": ["1A3114B8-A62E-11D0-A6C5-00A0C906AF45"],
    "IQueryForm": ["8CFCEE30-39BD-11D0-B8D1-00A024AB2DBB"],
    "IDsBrowseDomainTree": ["7CABCF1E-78F5-11D2-960C-00C04FA31A86"],
    "IPrintDialogServices": ["509AAEDA-5639-11D1-B6A1-0000F8757BF9"],
    "IPrintDialogCallback": ["5852A2C3-6530-11D1-B6A3-0000F8757BF9"],
    "IBanneredBar": ["596A9A94-013E-11D1-8D34-00A0C90F2719"],
    "CDefView": ["4434FF80-EF4C-11CE-AE65-08002B2E1262"],
    "IDocViewSite": ["87D605E0-C511-11CF-89A9-00A0C9054129"],
    "IFileSystemBindData": ["01E18D10-4D8B-11D2-855D-006008059367"],
    "IDragSourceHelper": ["DE5BF786-477A-11D2-839D-00C04FD918D0"],
    "IDropTargetHelper": ["4657278B-411B-11D2-839A-00C04FD918D0"],
    "IMountedVolume": ["12518492-00B2-11D2-9FA5-9E3420524153"],
    "INamedPropertyBag": ["FB700430-952C-11D1-946F-000000000000"],
    "IColumnProvider": ["E8025004-1C42-11D2-BE2C-00A0C9A83DA1", "24F14F00-7B1C-11D1-838F-0000F80461CF"],
    "IQueryAssociations": ["C46CA590-3C3F-11D2-BEE6-0000F805CA57"],
    "IShellDetails3": ["D2A105C0-87D5-11D1-8391-0000F80461CF"],
    "ISynchronizedCallBack": ["74C26041-70D1-11D1-B75A-00A0C90564FE"],
    "IADesktopP2": ["B22754E2-4574-11D1-9888-006097DEACF9"],
    "IActiveDesktopP": ["52502EE0-EC80-11D0-89AB-00C04FC2972D"],
    "IActiveDesktop": ["F490EB00-1240-11D1-9888-006097DEACF9"],
    "IProgressDialog": ["EBBC7C04-315E-11D2-B62F-006097DF5BD4"],
    "ICurrentWorkingDirectory": ["91956D21-9276-11D1-921A-006097DF5BD4"],
    "IACList2": ["470141A0-5186-11D2-BBB6-0060977B464C"],
    "IACList": ["77A130B0-94FD-11D0-A544-00C04FD7D062"],
    "IObjMgr": ["00BB2761-6A77-11D0-A535-00C04FD7D062"],
    "IAutoCompList": ["00BB2760-6A77-11D0-A535-00C04FD7D062"],
    "IUniformResourceLocatorW": ["CABB0DA0-DA57-11CF-9974-0020AFD79762"],
    "IUniformResourceLocatorA": ["FBF23B80-E3F0-101B-8488-00AA003E56F8"],
    "IShellChangeNotify": ["D82BE2B1-5764-11D0-A96E-00C04FD705A2"],
    "IDiscardableBrowserProperty": ["49C3DE7C-D329-11D0-AB73-00C04FC33E80"],
    "IDefViewFrame": ["710EB7A0-45ED-11D0-924A-0020AFC7AC4D"],
    "IShellFolderBand": ["7FE80CC8-C247-11D0-B93A-00A0C90312E1"],
    "IContextMenu3": ["BCFCE0A0-EC17-11D0-8D10-00A0C90F2719"],
    "IEnumShellImageStore": ["6DFD582B-92E3-11D1-98A3-00C04FB687DA"],
    "IShellImageStore": ["48C8118C-B924-11D1-98D5-00C04FB687DA"],
    "IThumbnailCapture": ["4EA39266-7211-409F-B622-F63DBD16C533"],
    "IRunnableTask": ["85788D00-6807-11D0-B810-00C04FD706EC"],
    "IShellIconOverlayManager": ["F10B5E34-DD3B-42A7-AA7D-2F4EC54BB09B", "63B51F80-C868-11D0-999C-00C04FD655E1"],
    "IPersistFolder3": ["CEF04FDF-FE72-11D2-87A5-00C04F6837CF"],
    "IShellFolderViewCB": ["2047E320-F2A9-11CE-AE65-08002B2E1262"],
    "ICommDlgBrowser2": ["10339516-2894-11D2-9039-00C04F8EEB3E", "6D71532E-889E-11D1-997F-080036AF3F03"],
    "IShellIconOverlayIdentifier": ["0C6C4200-C589-11D0-999A-00C04FD655E1"],
    "IShellIconOverlay": ["7D688A70-C613-11D0-999B-00C04FD655E1"],
    "IDockingWindowFrame": ["47D2657A-7B27-11D0-8CA9-00A0C92DBFE8"],
    "IDockingWindowSite": ["2A342FC2-7B26-11D0-8CA9-00A0C92DBFE8"],
    "IInputObjectSite": ["F1DB8392-7331-11D0-8C99-00A0C92DBFE8"],
    "IInputObject": ["68284FAA-6A48-11D0-8C78-00C04FD918B4"],
    "IShellTaskScheduler": ["6CCB7BE0-6807-11D0-B810-00C04FD706EC"],
    "IDefViewID": ["985F64F0-D410-4E02-BE22-DA07F2B5C5E1"],
    "IURLSearchHook2": ["5EE44DA4-6D32-46E3-86BC-07540DEDD0E0"],
    "ISearchContext": ["09F656A2-41AF-480C-88F7-16CC0D164615"],
    "IURLSearchHook": ["AC60F6A0-0FD9-11D0-99CB-00C04FD64497"],
    "IResolveShellLink": ["5CD52983-9449-11D2-963A-00C04F79ADF0"],
    "IShellLinkDataList": ["45E2B4AE-B1C3-11D0-B92F-00A0C90312E1"],
    "IBriefcaseStg": ["8BCE1FA1-0921-101B-B1FF-00DD010CCC48"],
    "IQueryInfo": ["00021500-0000-0000-C000-000000000046"],
    "IShellCopyHookW": ["000214FC-0000-0000-C000-000000000046"],
    "IShellExecuteHookW": ["000214FB-0000-0000-C000-000000000046"],
    "IExtractIconW": ["000214FA-0000-0000-C000-000000000046"],
    "IFileViewerW": ["000214F8-0000-0000-C000-000000000046"],
    "INewShortcutHookW": ["000214F7-0000-0000-C000-000000000046"],
    "IPropSheetPage": ["000214F6-0000-0000-C000-000000000046"],
    "IShellExecuteHookA": ["000214F5-0000-0000-C000-000000000046"],
    "IContextMenu2": ["000214F4-0000-0000-C000-000000000046"],
    "IFileViewerSite": ["000214F3-0000-0000-C000-000000000046"],
    "ICommDlgBrowser": ["000214F1-0000-0000-C000-000000000046"],
    "IFileViewerA": ["000214F0-0000-0000-C000-000000000046"],
    "IShellCopyHookA": ["000214EF-0000-0000-C000-000000000046"],
    "IDelayedRelease": ["000214ED-0000-0000-C000-000000000046"],
    "IShellDetails": ["000214EC-0000-0000-C000-000000000046"],
    "IExtractIconA": ["000214EB-0000-0000-C000-000000000046"],
    "IShellIcon": ["000214E5-0000-0000-C000-000000000046"],
    "IContextMenu": ["000214E4-0000-0000-C000-000000000046"],
    "INewShortcutHookA": ["000214E1-0000-0000-C000-000000000046"],
    "IAccPropServices": ["6E26E776-04F0-495D-80E4-3330352E3169"],
    "IAccPropServer": ["76C0DBBB-15E0-4E7B-B61B-20EEEA2001E0"],
    "IAccIdentity": ["7852B78D-1CFD-41C1-A615-9C0C85960B5F"],
    "IAccessibleHandler": ["03022430-ABC4-11D0-BDE2-00AA001A1953"],
    "IBidiRequestSpl": ["9C007000-FFA8-44FF-B2B3-AE9102C74D4C"],
    "ITfSpeechUIServer": ["90E9A944-9244-489F-A78F-DE67AFC013A7"],
    "ITfLangBarAddIn": ["C9ADDAC3-15CB-4957-B93C-DB0873FF98BB"],
    "ITfInputScope": ["FDE1EAEE-6924-4CDF-91E7-DA38CFF5559D"],
    "ID3DXAnimationController": ["AC8948EC-F86D-43E2-96DE-31FC35F96D9E"],
    "ID3DXCompressedAnimationSet": ["6CC2480D-3808-4739-9F88-DE49FACD8D4C"],
    "ID3DXKeyframedAnimationSet": ["FA4E8E3A-9786-407D-8B4C-5995893764AF"],
    "ID3DXAnimationSet": ["698CFB3F-9289-4D95-9A57-33A94B5A65F9"],
    "ID3DXEffectCompiler": ["51B8A949-1A31-47E6-BEA0-4B30DB53F1E0"],
    "ID3DXEffect": ["F6CEB4B3-4E4C-40DD-B883-8D8DE5EA0CD5"],
    "ID3DXEffectStateManager": ["79AAB587-6DBC-4FA7-82DE-37FA1781C5CE"],
    "ID3DXBaseEffect": ["017C18AC-103F-4417-8C51-6BF6EF1E56BE"],
    "ID3DXEffectPool": ["9537AB04-3250-412E-8213-FCD2F8677933"],
    "ID3DXFragmentLinker": ["1A2C0CC2-E5B6-4EBC-9E8D-390E057811B6"],
    "ID3DXTextureShader": ["3E3D67F8-AA7A-405D-A857-BA01D4758426"],
    "ID3DXConstantTable": ["AB3C758F-093E-4356-B762-4DB18F1B3A01"],
    "ID3DXPRTEngine": ["683A4278-CD5F-4D24-90AD-C4E1B6855D53"],
    "ID3DXTextureGutterHelper": ["838F01EC-9729-4527-AADB-DF70ADE7FEA9"],
    "ID3DXPRTCompBuffer": ["A758D465-FE8D-45AD-9CF0-D01E56266A07"],
    "ID3DXPRTBuffer": ["F1827E47-00A8-49CD-908C-9D11955F8728"],
    "ID3DXPatchMesh": ["3CE6CC22-DBF2-44F4-894D-F9C34A337139"],
    "ID3DXSkinInfo": ["11EAA540-F9A6-4D49-AE6A-E19221F70CC4"],
    "ID3DXSPMesh": ["667EA4C7-F1CD-4386-B523-7C0290B83CC5"],
    "ID3DXPMesh": ["8875769A-D579-4088-AAEB-534D1AD84E96"],
    "ID3DXMesh": ["4020E5C2-1403-4929-883F-E2E849FAC195"],
    "ID3DXBaseMesh": ["7ED943DD-52E8-40B5-A8D8-76685C406330"],
    "ID3DXFileData": ["CEF08CFD-7B4F-4429-9624-2A690A933201"],
    "ID3DXFileEnumObject": ["CEF08CFC-7B4F-4429-9624-2A690A933201"],
    "ID3DXFileSaveData": ["CEF08CFB-7B4F-4429-9624-2A690A933201"],
    "ID3DXFileSaveObject": ["CEF08CFA-7B4F-4429-9624-2A690A933201"],
    "ID3DXFile": ["CEF08CF9-7B4F-4429-9624-2A690A933201"],
    "ID3DXLine": ["D379BA7F-9042-4AC4-9F5E-58192A4C6BD8"],
    "ID3DXRenderToEnvMap": ["313F1B4B-C7B0-4FA2-9D9D-8D380B64385E"],
    "ID3DXRenderToSurface": ["6985F346-2C3D-43B3-BE8B-DAAE8A03D894"],
    "ID3DXFont": ["D79DBB70-5F21-4D36-BBC2-FF525C213CDC"],
    "ID3DXSprite": ["BA0B762D-7D28-43EC-B9DC-2F84443B0614"],
    "ID3DXBuffer": ["8BA5FB08-5195-40E2-AC58-0D989C3A0102"],
    "ID3DXMatrixStack": ["C7885BA7-F990-4FE7-922D-8515E477DD85"],
    "IDirect3DSwapChain9Ex": ["91886CAF-1C3D-4D2E-A0AB-3E4C7D8D3303"],
    "IDirect3DDevice9Ex": ["B18B10CE-2649-405A-870F-95F777D4313A"],
    "IDirect3D9Ex": ["02177241-69FC-400C-8FF1-93A44DF6861D"],
    "HelperName": ["E4A36723-FDFE-4B22-B146-3C04C07F4CC8"],
    "IDirect3DQuery9": ["D9771460-A695-4F26-BBD3-27B840B541CC"],
    "IDirect3DStateBlock9": ["B07C4FE5-310D-4BA8-A23C-4F0F206F218B"],
    "IDirect3DPixelShader9": ["6D3BDBDC-5B02-4415-B852-CE5E8BCCB289"],
    "IDirect3DVertexShader9": ["EFC5557E-6265-4613-8A94-43857889EB36"],
    "IDirect3DVertexDeclaration9": ["DD13C59C-36FA-4098-A8FB-C7ED39DC8546"],
    "IDirect3DSwapChain9": ["794950F2-ADFC-458A-905E-10A10B0B503B"],
    "IDirect3DVolume9": ["24F416E6-1F67-4AA7-B88E-D33F6F3128A1"],
    "IDirect3DSurface9": ["0CFBAF3A-9FF6-429A-99B3-A2796AF8B89B"],
    "IDirect3DIndexBuffer9": ["7C9DD65E-D3F7-4529-ACEE-785830ACDE35"],
    "IDirect3DVertexBuffer9": ["B64BB1B5-FD70-4DF6-BF91-19D0A12455E3"],
    "IDirect3DVolumeTexture9": ["2518526C-E789-4111-A7B9-47EF328D13E6"],
    "IDirect3DCubeTexture9": ["FFF32F81-D953-473A-9223-93D652ABA93F"],
    "IDirect3DTexture9": ["85C31227-3DE5-4F00-9B3A-F11AC38C18B5"],
    "IDirect3DBaseTexture9": ["580CA87E-1D3C-4D54-991D-B7D3E3C298CE"],
    "IDirect3DResource9": ["05EEC05D-8F7D-4362-B999-D1BAF357C704"],
    "IDirect3DDevice9": ["D0223B96-BF7A-43FD-92BD-A43B0D82B9EB"],
    "IDirect3D9": ["81BDCBCA-64D4-426D-AE8D-AD0147F4275C"],
    "ID3DX10SkinInfo": ["420BD604-1C76-4A34-A466-E45D0658A32C"],
    "ID3DX10MeshBuffer": ["04B0D117-1041-46B1-AA8A-3952848BA22E"],
    "ID3DX10ThreadPump": ["C93FECFA-6967-478A-ABBC-402D90621FCB"],
    "ID3DX10Sprite": ["BA0B762D-8D28-43EC-B9DC-2F84443B0614"],
    "ID3D10Multithread": ["9B7E4E00-342C-4106-A19F-4F2704F689F0"],
    "ID3D10Device": ["9B7E4C0F-342C-4106-A19F-4F2704F689F0"],
    "ID3D10Counter": ["9B7E4C11-342C-4106-A19F-4F2704F689F0"],
    "ID3D10Predicate": ["9B7E4C10-342C-4106-A19F-4F2704F689F0"],
    "ID3D10Query": ["9B7E4C0E-342C-4106-A19F-4F2704F689F0"],
    "ID3D10Asynchronous": ["9B7E4C0D-342C-4106-A19F-4F2704F689F0"],
    "ID3D10SamplerState": ["9B7E4C0C-342C-4106-A19F-4F2704F689F0"],
    "ID3D10InputLayout": ["9B7E4C0B-342C-4106-A19F-4F2704F689F0"],
    "ID3D10PixelShader": ["4968B601-9D00-4CDE-8346-8E7F675819B6"],
    "ID3D10GeometryShader": ["6316BE88-54CD-4040-AB44-20461BC81F68"],
    "ID3D10VertexShader": ["9B7E4C0A-342C-4106-A19F-4F2704F689F0"],
    "ID3D10DepthStencilView": ["9B7E4C09-342C-4106-A19F-4F2704F689F0"],
    "ID3D10RenderTargetView": ["9B7E4C08-342C-4106-A19F-4F2704F689F0"],
    "ID3D10ShaderResourceView": ["9B7E4C07-342C-4106-A19F-4F2704F689F0"],
    "ID3D10View": ["C902B03F-60A7-49BA-9936-2A3AB37A7E33"],
    "ID3D10Texture3D": ["9B7E4C05-342C-4106-A19F-4F2704F689F0"],
    "ID3D10Texture2D": ["9B7E4C04-342C-4106-A19F-4F2704F689F0"],
    "ID3D10Texture1D": ["9B7E4C03-342C-4106-A19F-4F2704F689F0"],
    "ID3D10Buffer": ["9B7E4C02-342C-4106-A19F-4F2704F689F0"],
    "ID3D10Resource": ["9B7E4C01-342C-4106-A19F-4F2704F689F0"],
    "ID3D10RasterizerState": ["A2A07292-89AF-4345-BE2E-C53D9FBB6E9F"],
    "ID3D10BlendState": ["EDAD8D19-8A35-4D6D-8566-2EA276CDE161"],
    "ID3D10DepthStencilState": ["2B4B1CC8-A4AD-41F8-8322-CA86FC3EC675"],
    "ID3D10DeviceChild": ["9B7E4C00-342C-4106-A19F-4F2704F689F0"],
    "ID3D10Effect": ["51B0CA8B-EC0B-4519-870D-8EE1CB5017C7"],
    "ID3D10EffectTechnique": ["DB122CE8-D1C9-4292-B237-24ED3DE8B175"],
    "ID3D10EffectPass": ["5CFBEB89-1A06-46E0-B282-E3F9BFA36A54"],
    "ID3D10EffectSamplerVariable": ["6530D5C7-07E9-4271-A418-E7CE4BD1E480"],
    "ID3D10EffectRasterizerVariable": ["21AF9F0E-4D94-4EA9-9785-2CB76B8C0B34"],
    "ID3D10EffectDepthStencilVariable": ["AF482368-330A-46A5-9A5C-01C71AF24C8D"],
    "ID3D10EffectBlendVariable": ["1FCD2294-DF6D-4EAE-86B3-0E9160CFB07B"],
    "ID3D10EffectShaderVariable": ["80849279-C799-4797-8C33-0407A07D9E06"],
    "ID3D10EffectConstantBuffer": ["56648F4D-CC8B-4444-A5AD-B5A3D76E91B3"],
    "ID3D10EffectDepthStencilViewVariable": ["3E02C918-CC79-4985-B622-2D92AD701623"],
    "ID3D10EffectRenderTargetViewVariable": ["28CA0CC3-C2C9-40BB-B57F-67B737122B17"],
    "ID3D10EffectShaderResourceVariable": ["C0A7157B-D872-4B1D-8073-EFC2ACD4B1FC"],
    "ID3D10EffectStringVariable": ["71417501-8DF9-4E0A-A78A-255F9756BAFF"],
    "ID3D10EffectMatrixVariable": ["50666C24-B82F-4EED-A172-5B6E7E8522E0"],
    "ID3D10EffectVectorVariable": ["62B98C44-1F82-4C67-BCD0-72CF8F217E81"],
    "ID3D10EffectScalarVariable": ["00E48F7B-D2C8-49E8-A86C-022DEE53431F"],
    "ID3D10EffectVariable": ["AE897105-00E6-45BF-BB8E-281DD6DB8E1B"],
    "ID3D10EffectType": ["4E9E1DDC-CD9D-4772-A837-00180B9B88FD"],
    "ID3D10StateBlock": ["0803425A-57F5-4DD6-9465-A87570834A08"],
    "ID3D10ShaderReflection": ["D40E20B6-F8F7-42AD-AB20-4BAF8F15DFAA"],
    "ID3D10ShaderReflectionConstantBuffer": ["66C66A94-DDDD-4B62-A66A-F0DA33C2B4D0"],
    "ID3D10ShaderReflectionVariable": ["1BF63C95-2650-405D-99C1-3636BD1DA0A1"],
    "ID3D10ShaderReflectionType": ["C530AD7D-9B16-4395-A979-BA2ECFF83ADD"],
    "ID3D10InfoQueue": ["1B940B17-2642-4D1F-AB1F-B99BAD0C395F"],
    "ID3D10SwitchToRef": ["9B7E4E02-342C-4106-A19F-4F2704F689F0"],
    "ID3D10Debug": ["9B7E4E01-342C-4106-A19F-4F2704F689F0"],
    "IDXGIDevice": ["54EC77FA-1377-44E6-8C32-88FD5F44C84C"],
    "IDXGIFactory": ["7B7166EC-21C7-44AE-B21A-C9AE321AE369"],
    "IDXGISwapChain": ["310D36A0-D2E7-4C0A-AA04-6A9D23B8886A"],
    "IDXGIOutput": ["AE02EEDB-C735-4690-8D52-5A8DC20213AA"],
    "IDXGIAdapter": ["2411E7E1-12AC-4CCF-BD14-9798E8534DC0"],
    "IDXGISurface": ["CAFCB56C-6AC3-4889-BF47-9E23BBD260EC"],
    "IDXGIResource": ["035F3AB4-482E-4E50-B41F-8A7F8BD8960B"],
    "IDXGIDeviceSubObject": ["3D3E0379-F9DE-4D58-BB6C-18D62992F1A6"],
    "IDXGIObject": ["AEC22FB8-76F3-4639-9BE0-28EB43A67A2E"],
    "IDxDiagContainer": ["7D0F462F-4064-4862-BC7F-933E5058C10F"],
    "IDxDiagProvider": ["9C6B4CB0-23F8-49CC-A3ED-45A55000A6D2"],
    "IKsControl": ["28F54685-06FD-11D2-B27A-00A0C9223196"],
    "IDirectMusicAudioPath": ["C87631F5-23BE-4986-8836-05832FCC48F9"],
    "IDirectMusicContainer": ["9301E386-1F22-11D3-8226-D2FA76255D47"],
    "IDirectMusicScript": ["2252373A-5814-489B-8209-31FEDEBAF137"],
    "IDirectMusicPatternTrack": ["51C22E10-B49F-46FC-BEC2-E6288FB9EDE6"],
    "IDirectMusicStyle8": ["FD24AD8A-A260-453D-BF50-6F9384F70985"],
    "IDirectMusicSegmentState8": ["A50E4730-0AE4-48A7-9839-BC04BFE07772"],
    "IDirectMusicSegment8": ["C6784488-41A3-418F-AA15-B35093BA42D4"],
    "IDirectMusicPerformance8": ["679C4137-C62E-4147-B2B4-9D569ACB254C"],
    "IDirectMusicLoader8": ["19E7C08C-0A44-4E6A-A116-595A7CD5DE8C"],
    "IDirectMusicSegment2": ["D38894D1-C052-11D2-872F-00600893B1BD"],
    "IDirectMusicPerformance2": ["6FC2CAE0-BC78-11D2-AFA6-00AA0024D8B6"],
    "IDirectMusicBand": ["D2AC28C0-B39B-11D1-8704-00600893B1BD"],
    "IDirectMusicComposer": ["D2AC28BF-B39B-11D1-8704-00600893B1BD"],
    "IDirectMusicChordMap": ["D2AC28BE-B39B-11D1-8704-00600893B1BD"],
    "IDirectMusicStyle": ["D2AC28BD-B39B-11D1-8704-00600893B1BD"],
    "IDirectMusicGraph": ["2BEFC277-5497-11D2-BCCB-00A0C922E6EB"],
    "IDirectMusicPerformance": ["07D43D03-6523-11D2-871D-00600893B1BD"],
    "IDirectMusicSegmentState": ["A3AFDCC7-D3EE-11D1-BC8D-00A0C922E6EB"],
    "IDirectMusicSegment": ["F96029A2-4282-11D2-8717-00600893B1BD"],
    "IDirectMusicObject": ["D2AC28B5-B39B-11D1-8704-00600893B1BD"],
    "IDirectMusicGetLoader": ["68A04844-D13D-11D1-AFA6-00AA0024D8B6"],
    "IDirectMusicLoader": ["2FFAACA2-5DCA-11D2-AFA6-00AA0024D8B6"],
    "IDirectMusicTrack8": ["0E674304-3B05-11D3-9BD1-F9E7F0A01536"],
    "IDirectMusicTool8": ["0E674303-3B05-11D3-9BD1-F9E7F0A01536"],
    "IDirectMusicTool": ["D2AC28BA-B39B-11D1-8704-00600893B1BD"],
    "IDirectMusicTrack": ["F96029A1-4282-11D2-8717-00600893B1BD"],
    "IDirectMusic8": ["2D3629F7-813D-4939-8508-F05C6B75FD97"],
    "IDirectMusic2": ["6FC2CAE1-BC78-11D2-AFA6-00AA0024D8B6"],
    "IDirectMusicDownloadedInstrument": ["D2AC287E-B39B-11D1-8704-00600893B1BD"],
    "IDirectMusicInstrument": ["D2AC287D-B39B-11D1-8704-00600893B1BD"],
    "IDirectMusicCollection": ["D2AC287C-B39B-11D1-8704-00600893B1BD"],
    "IDirectMusicDownload": ["D2AC287B-B39B-11D1-8704-00600893B1BD"],
    "IDirectMusicPortDownload": ["D2AC287A-B39B-11D1-8704-00600893B1BD"],
    "IDirectMusicThru": ["CED153E7-3606-11D2-B9F9-0000F875AC12"],
    "IDirectMusicPort": ["08F2D8C9-37C2-11D2-B9F9-0000F875AC12"],
    "IDirectMusicBuffer": ["D2AC2878-B39B-11D1-8704-00600893B1BD"],
    "IDirectMusic": ["6536115A-7B2D-11D2-BA18-0000F875AC12"],
    "IDirectPlay8LobbyClient": ["819074A2-016C-11D3-AE14-006097B01411"],
    "IDirectPlay8LobbiedApplication": ["819074A3-016C-11D3-AE14-006097B01411"],
    "IDirectPlay8NATResolver": ["A9E213F2-9A60-486F-BF3B-53408B6D1CBB"],
    "IDirectPlay8ThreadPool": ["0D22EE73-4A46-4A0D-89B2-045B4D666425"],
    "IDirectPlay8Peer": ["5102DACF-241B-11D3-AEA7-006097B01411"],
    "IDirectPlay8Server": ["5102DACE-241B-11D3-AEA7-006097B01411"],
    "IDirectPlay8Client": ["5102DACD-241B-11D3-AEA7-006097B01411"],
    "IDirectPlay8AddressIP": ["E5A0E990-2BAD-430B-87DA-A142CF75DE58"],
    "IDirectPlay8Address": ["83783300-4063-4C8A-9DB3-82830A7FEB31"],
    "IDirectPlayVoiceTest": ["D26AF734-208B-41DA-8224-E0CE79810BE1"],
    "IDirectPlayVoiceServer": ["FAA1C173-0468-43B6-8A2A-EA8A4F2076C9"],
    "IDirectPlayVoiceClient": ["1DFDC8EA-BCF7-41D6-B295-AB64B3B23306"],
    "IDirectSoundFullDuplex": ["EDCB4C7A-DAAB-4216-A42E-6C50596DDC1D"],
    "IDirectSoundCaptureFXNoiseSuppress": ["ED311E41-FBAE-4175-9625-CD0854F693CA"],
    "IDirectSoundCaptureFXAec": ["AD74143D-903D-4AB7-8066-28D363036D65"],
    "IDirectSoundFXWavesReverb": ["46858C3A-0DC6-45E3-B760-D4EEF16CB325"],
    "IDirectSoundFXI3DL2Reverb": ["4B166A6A-0D66-43F3-80E3-EE6280DEE1A4"],
    "IDirectSoundFXParamEq": ["C03CA9FE-FE90-4204-8078-82334CD177DA"],
    "IDirectSoundFXCompressor": ["4BBD1154-62F6-4E2C-A15C-D3B6C417F7A0"],
    "IDirectSoundFXDistortion": ["8ECF4326-455F-4D8B-BDA9-8D5D3E9E3E0B"],
    "IDirectSoundFXEcho": ["8BD28EDF-50DB-4E92-A2BD-445488D1ED42"],
    "IDirectSoundFXFlanger": ["903E9878-2C92-4072-9B2C-EA68F5396783"],
    "IDirectSoundFXChorus": ["880842E3-145F-43E6-A934-A71806E50547"],
    "IDirectSoundFXGargle": ["D616F352-D622-11CE-AAC5-0020AF0B99A3"],
    "IKsPropertySet": ["31EFAC30-515C-11D0-A9AA-00AA0061BE93"],
    "IDirectSoundNotify": ["B0210783-89CD-11D0-AF08-00A0C925CD16"],
    "IDirectSoundCaptureBuffer8": ["00990DF4-0DBB-4872-833E-6D303E80AEB6"],
    "IDirectSoundCaptureBuffer": ["B0210782-89CD-11D0-AF08-00A0C925CD16"],
    "IDirectSoundCapture": ["B0210781-89CD-11D0-AF08-00A0C925CD16"],
    "IDirectSound3DBuffer": ["279AFA86-4981-11CE-A521-0020AF0BE560"],
    "IDirectSound3DListener": ["279AFA84-4981-11CE-A521-0020AF0BE560"],
    "IDirectSoundBuffer8": ["6825A449-7524-4D82-920F-50E36AB3AB1E"],
    "IDirectSoundBuffer": ["279AFA85-4981-11CE-A521-0020AF0BE560"],
    "IDirectSound8": ["C50A7E93-F395-4834-9EF6-7FA99DE50966"],
    "IDirectSound": ["279AFA83-4981-11CE-A521-0020AF0BE560"],
    "IReferenceClock": ["56A86897-0AD4-11CE-B03A-0020AF0BA770"],
    "IDirectPlayLobby3A": ["2DB72491-652C-11D1-A7A8-0000F803ABFC"],
    "IDirectPlayLobby3": ["2DB72490-652C-11D1-A7A8-0000F803ABFC"],
    "IDirectPlayLobby2A": ["1BB4AF80-A303-11D0-9C4F-00A0C905425E"],
    "IDirectPlayLobby2": ["0194C220-A303-11D0-9C4F-00A0C905425E"],
    "IDirectPlayLobbyA": ["26C66A70-B367-11CF-A024-00AA006157AC"],
    "IDirectPlayLobby": ["AF465C71-9588-11CF-A020-00AA006157AC"],
    "IDirectPlay": ["5454E9A0-DB65-11CE-921C-00AA006C4972"],
    "IDirectPlay4A": ["0AB1C531-4745-11D1-A7A1-0000F803ABFC"],
    "IDirectPlay4": ["0AB1C530-4745-11D1-A7A1-0000F803ABFC"],
    "IDirectPlay3A": ["133EFE41-32DC-11D0-9CFB-00A0C90A43CB"],
    "IDirectPlay3": ["133EFE40-32DC-11D0-9CFB-00A0C90A43CB"],
    "IDirectPlay2A": ["9D460580-A822-11CF-960C-0080C7534E82"],
    "IDirectPlay2": ["2B74F7C0-9154-11CF-A9CD-00AA006886E3"],
    "IDirectInputJoyConfig8": ["EB0D7DFA-1990-4F27-B4D6-EDF2EEC4A44C"],
    "IDirectInputPIDDriver": ["EEC6993A-B3FD-11D2-A916-00C04FB98638"],
    "IDirectInputJoyConfig": ["1DE12AB1-C9F5-11CF-BFC7-444553540000"],
    "IDirectInputEffectDriver": ["02538130-898F-11D0-9AD0-00A0C9A06E35"],
    "IDirectInputEffect": ["E7E1F7C0-88D2-11D0-9AD0-00A0C9A06E35"],
    "IDirectInputDevice8W": ["54D41081-DC15-4833-A41B-748F73A38179"],
    "IDirectInputDevice8A": ["54D41080-DC15-4833-A41B-748F73A38179"],
    "IDirectInputDevice7W": ["57D7C6BD-2356-11D3-8E9D-00C04F6844AE"],
    "IDirectInputDevice7A": ["57D7C6BC-2356-11D3-8E9D-00C04F6844AE"],
    "IDirectInputDevice2W": ["5944E683-C92E-11CF-BFC7-444553540000"],
    "IDirectInputDevice2A": ["5944E682-C92E-11CF-BFC7-444553540000"],
    "IDirectInputDeviceW": ["5944E681-C92E-11CF-BFC7-444553540000"],
    "IDirectInputDeviceA": ["5944E680-C92E-11CF-BFC7-444553540000"],
    "IDirectInput8W": ["BF798031-483A-4DA2-AA99-5D64ED369700"],
    "IDirectInput8A": ["BF798030-483A-4DA2-AA99-5D64ED369700"],
    "IDirectInput7W": ["9A4CB685-236D-11D3-8E9D-00C04F6844AE"],
    "IDirectInput7A": ["9A4CB684-236D-11D3-8E9D-00C04F6844AE"],
    "IDirectInput2W": ["5944E663-AA8A-11CF-BFC7-444553540000"],
    "IDirectInput2A": ["5944E662-AA8A-11CF-BFC7-444553540000"],
    "IDirectInputW": ["89521361-AA8A-11CF-BFC7-444553540000"],
    "IDirectInputA": ["89521360-AA8A-11CF-BFC7-444553540000"],
    "IDirectXFileBinary": ["3D82AB46-62DA-11CF-AB39-0020AF71E433"],
    "IDirectXFileDataReference": ["3D82AB45-62DA-11CF-AB39-0020AF71E433"],
    "IDirectXFileData": ["3D82AB44-62DA-11CF-AB39-0020AF71E433"],
    "IDirectXFileObject": ["3D82AB43-62DA-11CF-AB39-0020AF71E433"],
    "IDirectXFileSaveObject": ["3D82AB42-62DA-11CF-AB39-0020AF71E433"],
    "IDirectXFileEnumObject": ["3D82AB41-62DA-11CF-AB39-0020AF71E433"],
    "IDirectXFile": ["3D82AB40-62DA-11CF-AB39-0020AF71E433"],
    "IDirect3DRMWinDevice": ["C5016CC0-D273-11CE-AC48-0000C03825A1"],
    "IDirect3DRM3": ["4516EC83-8F20-11D0-9B6D-0000C0781BC3"],
    "IDirect3DRM2": ["4516ECC8-8F20-11D0-9B6D-0000C0781BC3"],
    "IDirect3DRM": ["2BC49361-8327-11CF-AC4A-0000C03825A1"],
    "IDirect3DRMClippedVisual": ["5434E733-6D66-11D1-BB0B-0000F875865A"],
    "IDirect3DRMPicked2Array": ["4516EC7B-8F20-11D0-9B6D-0000C0781BC3"],
    "IDirect3DRMProgressiveMesh": ["4516EC79-8F20-11D0-9B6D-0000C0781BC3"],
    "IDirect3DRMInterpolator": ["242F6BC1-3849-11D0-9B6D-0000C0781BC3"],
    "IDirect3DRMShadow2": ["86B44E25-9C82-11D1-BB0B-00A0C981A0A6"],
    "IDirect3DRMShadow": ["AF359780-6BA3-11CF-AC4A-0000C03825A1"],
    "IDirect3DRMUserVisual": ["59163DE0-6D43-11CF-AC4A-0000C03825A1"],
    "IDirect3DRMAnimationArray": ["D5F1CAE0-4BD7-11D1-B974-0060083E45F3"],
    "IDirect3DRMFaceArray": ["EB16CB17-D271-11CE-AC48-0000C03825A1"],
    "IDirect3DRMPickedArray": ["EB16CB16-D271-11CE-AC48-0000C03825A1"],
    "IDirect3DRMLightArray": ["EB16CB14-D271-11CE-AC48-0000C03825A1"],
    "IDirect3DRMVisualArray": ["EB16CB13-D271-11CE-AC48-0000C03825A1"],
    "IDirect3DRMFrameArray": ["EB16CB12-D271-11CE-AC48-0000C03825A1"],
    "IDirect3DRMViewportArray": ["EB16CB11-D271-11CE-AC48-0000C03825A1"],
    "IDirect3DRMDeviceArray": ["EB16CB10-D271-11CE-AC48-0000C03825A1"],
    "IDirect3DRMObjectArray": ["242F6BC2-3849-11D0-9B6D-0000C0781BC3"],
    "IDirect3DRMAnimationSet2": ["FF6B7F79-A40E-11D1-91F9-0000F8758E66"],
    "IDirect3DRMAnimationSet": ["EB16CB0E-D271-11CE-AC48-0000C03825A1"],
    "IDirect3DRMAnimation2": ["FF6B7F77-A40E-11D1-91F9-0000F8758E66"],
    "IDirect3DRMAnimation": ["EB16CB0D-D271-11CE-AC48-0000C03825A1"],
    "IDirect3DRMMaterial2": ["FF6B7F75-A40E-11D1-91F9-0000F8758E66"],
    "IDirect3DRMMaterial": ["EB16CB0B-D271-11CE-AC48-0000C03825A1"],
    "IDirect3DRMWrap": ["EB16CB0A-D271-11CE-AC48-0000C03825A1"],
    "IDirect3DRMTexture3": ["FF6B7F73-A40E-11D1-91F9-0000F8758E66"],
    "IDirect3DRMTexture2": ["120F30C0-1629-11D0-941C-0080C80CFA7B"],
    "IDirect3DRMTexture": ["EB16CB09-D271-11CE-AC48-0000C03825A1"],
    "IDirect3DRMLight": ["EB16CB08-D271-11CE-AC48-0000C03825A1"],
    "IDirect3DRMFace2": ["4516EC81-8F20-11D0-9B6D-0000C0781BC3"],
    "IDirect3DRMFace": ["EB16CB07-D271-11CE-AC48-0000C03825A1"],
    "IDirect3DRMMeshBuilder3": ["4516EC82-8F20-11D0-9B6D-0000C0781BC3"],
    "IDirect3DRMMeshBuilder2": ["4516EC77-8F20-11D0-9B6D-0000C0781BC3"],
    "IDirect3DRMMeshBuilder": ["A3A80D02-6E12-11CF-AC4A-0000C03825A1"],
    "IDirect3DRMMesh": ["A3A80D01-6E12-11CF-AC4A-0000C03825A1"],
    "IDirect3DRMVisual": ["EB16CB04-D271-11CE-AC48-0000C03825A1"],
    "IDirect3DRMFrame3": ["FF6B7F70-A40E-11D1-91F9-0000F8758E66"],
    "IDirect3DRMFrame2": ["C3DFBD60-3988-11D0-9EC2-0000C0291AC3"],
    "IDirect3DRMFrame": ["EB16CB03-D271-11CE-AC48-0000C03825A1"],
    "IDirect3DRMViewport2": ["4A1B1BE6-BFED-11D1-8ED8-00A0C967A482"],
    "IDirect3DRMViewport": ["EB16CB02-D271-11CE-AC48-0000C03825A1"],
    "IDirect3DRMDevice3": ["549F498B-BFEB-11D1-8ED8-00A0C967A482"],
    "IDirect3DRMDevice2": ["4516EC78-8F20-11D0-9B6D-0000C0781BC3"],
    "IDirect3DRMDevice": ["E9E19280-6E05-11CF-AC4A-0000C03825A1"],
    "IDirect3DRMObject2": ["4516EC7C-8F20-11D0-9B6D-0000C0781BC3"],
    "IDirect3DRMObject": ["EB16CB00-D271-11CE-AC48-0000C03825A1"],
    "IDirect3DSwapChain8": ["928C088B-76B9-4C6B-A536-A590853876CD"],
    "IDirect3DVolume8": ["BD7349F5-14F1-42E4-9C79-972380DB40C0"],
    "IDirect3DSurface8": ["B96EEBCA-B326-4EA5-882F-2FF5BAE021DD"],
    "IDirect3DIndexBuffer8": ["0E689C9A-053D-44A0-9D92-DB0E3D750F86"],
    "IDirect3DVertexBuffer8": ["8AEEEAC7-05F9-44D4-B591-000B0DF1CB95"],
    "IDirect3DVolumeTexture8": ["4B8AAAFA-140F-42BA-9131-597EAFAA2EAD"],
    "IDirect3DCubeTexture8": ["3EE5B968-2ACA-4C34-8BB5-7E0C3D19B750"],
    "IDirect3DTexture8": ["E4CDD575-2866-4F01-B12E-7EECE1EC9358"],
    "IDirect3DBaseTexture8": ["B4211CFA-51B9-4A9F-AB78-DB99B2BB678E"],
    "IDirect3DResource8": ["1B36BB7B-09B7-410A-B445-7D1430D7B33F"],
    "IDirect3DDevice8": ["7385E5DF-8FE8-41D5-86B6-D7B48547B6CF"],
    "IDirect3D8": ["1DD9E8DA-1C77-4D40-B0CF-98FEFDFF9512"],
    "IDirect3DVertexBuffer7": ["F5049E7D-4861-11D2-A407-00A0C90629A8"],
    "IDirect3DVertexBuffer": ["7A503555-4A83-11D1-A5DB-00A0C90367F8"],
    "IDirect3DViewport3": ["B0AB3B61-33D7-11D1-A981-00C04FD7B174"],
    "IDirect3DViewport2": ["93281500-8CF8-11D0-89AB-00A0C9054129"],
    "IDirect3DViewport": ["4417C146-33AD-11CF-816F-0000C020156E"],
    "IDirect3DExecuteBuffer": ["4417C145-33AD-11CF-816F-0000C020156E"],
    "IDirect3DMaterial3": ["CA9C46F4-D3C5-11D1-B75A-00600852B312"],
    "IDirect3DMaterial2": ["93281503-8CF8-11D0-89AB-00A0C9054129"],
    "IDirect3DMaterial": ["4417C144-33AD-11CF-816F-0000C020156E"],
    "IDirect3DLight": ["4417C142-33AD-11CF-816F-0000C020156E"],
    "IDirect3DTexture2": ["93281502-8CF8-11D0-89AB-00A0C9054129"],
    "IDirect3DTexture": ["2CDCD9E0-25A0-11CF-A31A-00AA00B93356"],
    "IDirect3DDevice7": ["F5049E79-4861-11D2-A407-00A0C90629A8"],
    "IDirect3DDevice3": ["B0AB3B60-33D7-11D1-A981-00C04FD7B174"],
    "IDirect3DDevice2": ["93281501-8CF8-11D0-89AB-00A0C9054129"],
    "IDirect3DDevice": ["64108800-957D-11D0-89AB-00A0C9054129"],
    "IDirect3DTnLHalDevice": ["F5049E78-4861-11D2-A407-00A0C90629A8"],
    "IDirect3DNullDevice": ["8767DF22-BACC-11D1-8969-00A0C90629A8"],
    "IDirect3DRefDevice": ["50936643-13E9-11D1-89AA-00A0C9054129"],
    "IDirect3DMMXDevice": ["881949A1-D6F3-11D0-89AB-00A0C9054129"],
    "IDirect3DHALDevice": ["84E63DE0-46AA-11CF-816F-0000C020156E"],
    "IDirect3DRGBDevice": ["A4665C60-2673-11CF-A31A-00AA00B93356"],
    "IDirect3DRampDevice": ["F2086B20-259F-11CF-A31A-00AA00B93356"],
    "IDirect3D7": ["F5049E77-4861-11D2-A407-00A0C90629A8"],
    "IDirect3D3": ["BB223240-E72B-11D0-A9B4-00AA00C0993E"],
    "IDirect3D2": ["6AAE1EC1-662A-11D0-889D-00AA00BBB76A"],
    "IDirect3D": ["3BBA0080-2421-11CF-A31A-00AA00B93356"],
    "IDirectDrawVideoPortNotify": ["A655FB94-0589-4E57-B333-567A89468C88"],
    "IDirectDrawVideoPort": ["B36D93E0-2B43-11CF-A2DE-00AA00B93356"],
    "IDDVideoPortContainer": ["6C142760-A733-11CE-A521-0020AF0BE560"],
    "IXACTEngine": ["0AA000A0-F404-11D9-BD7A-0010DC4F8F81"],
    "IDirectDrawGammaControl": ["69C11C3E-B46B-11D1-AD7A-00C04FC29B4E"],
    "IDirectDrawColorControl": ["4B9F0EE0-0D7E-11D0-9B06-00A0C903A3B8"],
    "IDirectDrawClipper": ["6C14DB85-A733-11CE-A521-0020AF0BE560"],
    "IDirectDrawPalette": ["6C14DB84-A733-11CE-A521-0020AF0BE560"],
    "IDirectDrawPalette2": ["C03C477E-6519-11D1-8C52-00C04FD930C5"],
    "IDirectDrawOptSurface": ["51191F1E-4F2B-11D1-8CC3-00A0C90629A8"],
    "IDirectDrawFactory2": ["89B2C488-4AF4-11D1-8C4C-00C04FD930C5"],
    "IDirectDrawSurfaceNew": ["1BAB8E96-9CFE-4CE3-BC72-D7E9E99A2175"],
    "IDirectDrawSurface7": ["06675A80-3B9B-11D2-B92F-00609797EA5B"],
    "IDirectDrawSurface4": ["0B2B8630-AD35-11D0-8EA6-00609797EA5B"],
    "IDirectDrawSurface3": ["DA044E00-69B2-11D0-A1D5-00AA00B8DFBB"],
    "IDirectDrawSurface2": ["57805885-6EEC-11CF-9441-A82303C10E27"],
    "IDirectDrawSurface": ["6C14DB81-A733-11CE-A521-0020AF0BE560"],
    "IDirectDraw7": ["15E65EC0-3B9C-11D2-B92F-00609797EA5B"],
    "IDirectDraw4": ["9C59509A-39BD-11D1-8C4A-00C04FD930C5"],
    "IDirectDraw2": ["B3A6F3E0-2B43-11CF-A2DE-00AA00B93356"],
    "IDirectDraw": ["6C14DB80-A733-11CE-A521-0020AF0BE560"],
    "IRTPSPHFilter": ["D5284681-B680-11D0-9643-00AA00A89C1D"],
    "ISilenceSuppressor": ["40C1D160-52F2-11D0-A874-00AA00B5CA1B"],
    "IMAPIAdviseSink": ["00020302-0000-0000-C000-000000000046"],
    "IMAPIProgress": ["0002031F-0000-0000-C000-000000000046"],
    "IMAPITableData": ["00020316-0000-0000-C000-000000000046"],
    "IKoInitializeParentDeviceObject": ["21B36996-8DE3-11D1-8AE0-00A0C9223196"],
    "IKsAllocator": ["8DA64899-C0D9-11D0-8413-0000F822FE8A"],
    "IKsClockPropertySet": ["5C5CBD84-E755-11D0-AC18-00A0C9223196"],
    "IKsInterfaceHandler": ["D3ABC7E0-9A61-11D0-A40D-00A0C9223196"],
    "IKsDataTypeHandler": ["5FFBAA02-49A3-11D0-9F36-00AA00A216A1"],
    "IKsPin": ["B61178D1-A2D9-11CF-9E53-00AA00A216A1"],
    "IKsObject": ["423C13A2-2070-11D0-9EF7-00AA00A216A1"],
    "IMediumValidation": ["40DC0EAE-5FAB-11D1-9AA6-00A0C9223196"],
    "IJavaComModuleManager": ["AC680B40-CDA0-11D1-A936-0080C7C575C0"],
    "IJavaExecute2": ["D7658820-01DD-11D0-9746-00AA00342BD8"],
    "IEnumJAVAPROPERTY": ["56E7DF80-F527-11CF-B728-FC8703C10000"],
    "ICodeStoreDBEntry": ["D2073C40-AB4F-11D0-A732-00A0C9082637"],
    "ICodeStoreDB": ["DF3D9C22-AB4E-11D0-A732-00A0C9082637"],
    "IEnumCodeStoreDBEntry": ["D2073C42-AB4F-11D0-A732-00A0C9082637"],
    "IJavaPackageManager": ["D2073C43-AB4F-11D0-A732-00A0C9082637"],
    "IJavaPackage": ["D2073C46-AB4F-11D0-A732-00A0C9082637"],
    "IJavaPackage2": ["F79E6FA1-86A0-11D1-811E-00C04FB92687"],
    "IJavaFile": ["D2073C48-AB4F-11D0-A732-00A0C9082637"],
    "IPersistJavaTypeLib": ["3A29ACD0-78D5-11D0-AF77-0080C71F7993"],
    "ICreateJavaPackageMgr": ["D2073C47-AB4F-11D0-A732-00A0C9082637"],
    "IEnumJavaPackage": ["D2073C45-AB4F-11D0-A732-00A0C9082637"],
    "IEnumJavaFile": ["D2073C49-AB4F-11D0-A732-00A0C9082637"],
    "IEnumBeanInfo": ["4D6007E2-0306-11D1-98C9-00C04FB609B9"],
    "IBeanInfo": ["4D6007E3-0306-11D1-98C9-00C04FB609B9"],
    "IJavaPackageManager2": ["3D1D4C60-3F32-11D1-A733-00C04FD79B94"],
    "IClassPathElement": ["3D1D4C61-3F32-11D1-A733-00C04FD79B94"],
    "IEnumClassPathElement": ["3D1D4C65-3F32-11D1-A733-00C04FD79B94"],
    "IJavaFileContainer": ["297982B3-39B8-11D1-A943-00A0C921A4D2"],
    "IEnumJavaFileContainer": ["297982B2-39B8-11D1-A943-00A0C921A4D2"],
    "IJavaZonePermissionEditor": ["85347F8A-C8B7-11D0-8823-00C04FB67C84"],
    "ICreatesJavaObjects": ["92F362C0-CF5A-11D1-A93C-0080C7C575C0"],
    "IJavaExecute": ["3EFB1803-C2A1-11CF-960C-0080C7C2BA87"],
    "ITNotification": ["DDA68522-B6A5-11D0-A489-00C04FD91AC0"],
    "IDocFindFolder": ["A5DF1EA0-5702-11D1-83FA-00A0C90DC849"],
    "IConnectionPointDefaultImpl": ["881DEEC0-6BA2-11D1-B758-00A0C90564FE"],
    "INotifyCallback": ["A5EA8D2E-253D-11D1-B3F1-00AA003761C5"],
    "IFilterSideInterface": ["A5EA8D2D-253D-11D1-B3F1-00AA003761C5"],
    "ICutListGraphBuilder": ["A5EA8D2C-253D-11D1-B3F1-00AA003761C5"],
    "IElementInfo": ["A5EA8D2B-253D-11D1-B3F1-00AA003761C5"],
    "IFileClip": ["A5EA8D2A-253D-11D1-B3F1-00AA003761C5"],
    "IStandardCutList": ["A5EA8D29-253D-11D1-B3F1-00AA003761C5"],
    "IElementDefinition": ["A5EA8D28-253D-11D1-B3F1-00AA003761C5"],
    "IAudioCutListElement": ["A5EA8D27-253D-11D1-B3F1-00AA003761C5"],
    "IVidFXCutListElement": ["A5EA8D26-253D-11D1-B3F1-00AA003761C5"],
    "IVideoCutListElement": ["A5EA8D25-253D-11D1-B3F1-00AA003761C5"],
    "IFileCutListElement": ["A5EA8D24-253D-11D1-B3F1-00AA003761C5"],
    "ICutListElement": ["A5EA8D23-253D-11D1-B3F1-00AA003761C5"],
    "ICutList": ["A5EA8D22-253D-11D1-B3F1-00AA003761C5"],
    "ICutListSourceFilter": ["A5EA8D21-253D-11D1-B3F1-00AA003761C5"],
    "IDvdGraphBuilder": ["FCC152B6-F372-11D0-8E00-00C04FD7C08B"],
    "IDvdInfo": ["A70EFE60-E2A3-11D0-A9BE-00AA0061BE93"],
    "IDvdControl": ["A70EFE61-E2A3-11D0-A9BE-00AA0061BE93"],
    "ICreateDevEnum": ["29840822-5B84-11D0-BD3B-00A0C911CE86"],
    "IAMovie": ["359ACE10-7688-11CF-8B23-00805F6CEF60"],
    "IAMStreamSelect": ["C1960960-17F5-11D1-ABE1-00A0C905F375"],
    "IAMDevMemoryControl": ["C6545BF1-E76B-11D0-BD52-00A0C911CE86"],
    "IAMDevMemoryAllocator": ["C6545BF0-E76B-11D0-BD52-00A0C911CE86"],
    "IAMTimecodeDisplay": ["9B496CE2-811B-11CF-8C77-00AA006B6814"],
    "IAMTimecodeGenerator": ["9B496CE0-811B-11CF-8C77-00AA006B6814"],
    "IAMTimecodeReader": ["9B496CE1-811B-11CF-8C77-00AA006B6814"],
    "IAMExtTransport": ["A03CD5F0-3045-11CF-8C44-00AA006B6814"],
    "IAMExtDevice": ["B5730A90-1A2C-11CF-8C23-00AA006B6814"],
    "IAMPhysicalPinInfo": ["F938C991-3029-11CF-8C44-00AA006B6814"],
    "IPersistMediaPropertyBag": ["5738E040-B67F-11D0-BD4D-00A0C911CE86"],
    "IMediaPropertyBag": ["6025A880-C0D5-11D0-BD4E-00A0C911CE86"],
    "IAMAnalogVideoEncoder": ["C6E133B0-30AC-11D0-A18C-00A0C9118956"],
    "IAMTVTuner": ["C6E133A0-30AC-11D0-A18C-00A0C9118956", "211A8766-03AC-11D1-8D13-00AA00BD8339"],
    "IAMCrossbar": ["C6E13380-30AC-11D0-A18C-00A0C9118956"],
    "IAMCameraControl": ["C6E13370-30AC-11D0-A18C-00A0C9118956"],
    "IAMVideoProcAmp": ["C6E13360-30AC-11D0-A18C-00A0C9118956"],
    "IAMAnalogVideoDecoder": ["C6E13350-30AC-11D0-A18C-00A0C9118956"],
    "IAMBufferNegotiation": ["56ED71A0-AF5F-11D0-B3F0-00AA003761C5"],
    "IAMAudioInputMixer": ["54C39221-8380-11D0-B3F0-00AA003761C5"],
    "IAMDroppedFrames": ["C6E13344-30AC-11D0-A18C-00A0C9118956"],
    "IAMVfwCompressDialogs": ["D8D715A3-6E5E-11D0-B3F0-00AA003761C5"],
    "IAMVfwCaptureDialogs": ["D8D715A0-6E5E-11D0-B3F0-00AA003761C5"],
    "IAMVideoCompression": ["C6E13343-30AC-11D0-A18C-00A0C9118956"],
    "IConfigAviMux": ["5ACD6AA0-F482-11CE-8B67-00AA00A3F1A6"],
    "IConfigInterleaving": ["BEE3D220-157B-11D0-BD23-00A0C911CE86"],
    "IAMStreamConfig": ["C6E13340-30AC-11D0-A18C-00A0C9118956"],
    "ISeekingPassThru": ["36B73883-C2C8-11CF-8B46-00805F6CEF60"],
    "IAMStreamControl": ["36B73881-C2C8-11CF-8B46-00805F6CEF60"],
    "IDistributorNotify": ["56A868AF-0AD4-11CE-B03A-0020AF0BA770"],
    "IResourceManager": ["56A868AC-0AD4-11CE-B03A-0020AF0BA770"],
    "IResourceConsumer": ["56A868AD-0AD4-11CE-B03A-0020AF0BA770"],
    "IGraphVersion": ["56A868AB-0AD4-11CE-B03A-0020AF0BA770"],
    "IAsyncReader": ["56A868AA-0AD4-11CE-B03A-0020AF0BA770"],
    "IStreamBuilder": ["56A868BF-0AD4-11CE-B03A-0020AF0BA770"],
    "IFilterGraph2": ["36B73882-C2C8-11CF-8B46-00805F6CEF60"],
    "IAMCopyCaptureFileProgress": ["670D1D20-A068-11D0-B3F0-00AA003761C5"],
    "ICaptureGraphBuilder": ["BF87B6E0-8C27-11D0-B3F0-00AA003761C5"],
    "IGraphBuilder": ["56A868A9-0AD4-11CE-B03A-0020AF0BA770"],
    "IFileAsyncIO": ["56A868A7-0AD4-11CE-B03A-0020AF0BA770"],
    "IFileSinkFilter2": ["00855B90-CE1B-11D0-BD4F-00A0C911CE86"],
    "IFileSinkFilter": ["A2104830-7C70-11CF-8BCE-00AA00A3F1A6"],
    "IFileSourceFilter": ["56A868A6-0AD4-11CE-B03A-0020AF0BA770"],
    "IMediaEventSink": ["56A868A2-0AD4-11CE-B03A-0020AF0BA770"],
    "IOverlay": ["56A868A1-0AD4-11CE-B03A-0020AF0BA770"],
    "IOverlayNotify": ["56A868A0-0AD4-11CE-B03A-0020AF0BA770"],
    "IFilterMapper2": ["B79BB0B0-33C1-11D1-ABE1-00A0C905F375"],
    "IFilterMapper": ["56A868A3-0AD4-11CE-B03A-0020AF0BA770"],
    "IEnumRegFilters": ["56A868A4-0AD4-11CE-B03A-0020AF0BA770"],
    "IMediaSeeking": ["36B73880-C2C8-11CF-8B46-00805F6CEF60"],
    "IAMovieSetup": ["A3D8CEC0-7E5A-11CF-BBC5-00805F6CEF20"],
    "IMemInputPin": ["56A8689D-0AD4-11CE-B03A-0020AF0BA770"],
    "IMemAllocator": ["56A8689C-0AD4-11CE-B03A-0020AF0BA770"],
    "IMediaSample2": ["36B73884-C2C8-11CF-8B46-00805F6CEF60"],
    "IMediaSample": ["56A8689A-0AD4-11CE-B03A-0020AF0BA770"],
    "IReferenceClock2": ["36B73885-C2C8-11CF-8B46-00805F6CEF60"],
    "IBaseFilter": ["56A86895-0AD4-11CE-B03A-0020AF0BA770"],
    "IMediaFilter": ["56A86899-0AD4-11CE-B03A-0020AF0BA770"],
    "IEnumFilters": ["56A86893-0AD4-11CE-B03A-0020AF0BA770"],
    "IFilterGraph": ["56A8689F-0AD4-11CE-B03A-0020AF0BA770"],
    "IEnumMediaTypes": ["89C31040-846B-11CE-97D3-00AA0055595A"],
    "IEnumPins": ["56A86892-0AD4-11CE-B03A-0020AF0BA770"],
    "IPin": ["56A86891-0AD4-11CE-B03A-0020AF0BA770"],
    "IPinInfo": ["56A868BD-0AD4-11CE-B03A-0020AF0BA770"],
    "IMediaTypeInfo": ["56A868BC-0AD4-11CE-B03A-0020AF0BA770"],
    "IRegFilterInfo": ["56A868BB-0AD4-11CE-B03A-0020AF0BA770"],
    "IFilterInfo": ["56A868BA-0AD4-11CE-B03A-0020AF0BA770"],
    "IQueueCommand": ["56A868B7-0AD4-11CE-B03A-0020AF0BA770"],
    "IDeferredCommand": ["56A868B8-0AD4-11CE-B03A-0020AF0BA770"],
    "IBasicVideo": ["56A868B5-0AD4-11CE-B03A-0020AF0BA770"],
    "IVideoWindow": ["56A868B4-0AD4-11CE-B03A-0020AF0BA770"],
    "IBasicAudio": ["56A868B3-0AD4-11CE-B03A-0020AF0BA770"],
    "IMediaPosition": ["56A868B2-0AD4-11CE-B03A-0020AF0BA770"],
    "IMediaEventEx": ["56A868C0-0AD4-11CE-B03A-0020AF0BA770"],
    "IMediaEvent": ["56A868B6-0AD4-11CE-B03A-0020AF0BA770"],
    "IMediaControl": ["56A868B1-0AD4-11CE-B03A-0020AF0BA770"],
    "IAMCollection": ["56A868B9-0AD4-11CE-B03A-0020AF0BA770"],
    "IAMLine21Decoder": ["6E8D4A21-310C-11D0-B79A-00AA003767A7"],
    "IMpegAudioDecoder": ["A8BB1580-B5EE-11CE-8D2B-0000E202599C", "B45DD570-3C77-11D1-ABE1-00A0C905F375"],
    "IAMDirectSound": ["546F4260-D53E-11CF-B3F0-00AA003761C5"],
    "IFullScreenVideoEx": ["53479470-F1DD-11CF-BC42-00AA00AC74F6"],
    "IFullScreenVideo": ["DD1D7110-7836-11CF-BF47-00AA0055595A"],
    "IDirectDrawSurfaceKernel": ["60755DA0-6A40-11D0-9B06-00A0C903A3B8"],
    "IDirectDrawKernel": ["8D56C120-6A08-11D0-9B06-00A0C903A3B8"],
    "IMixerPinConfig": ["593CDDE1-0759-11D1-9E69-00C04FD7C15B"],
    "IVPVBINotify": ["EC529B01-1A1F-11D1-BAD9-00609744111A"],
    "IVPVBIConfig": ["EC529B00-1A1F-11D1-BAD9-00609744111A"],
    "IVPNotify": ["C76794A1-D6C5-11D0-9E69-00C04FD7C15B"],
    "IVPConfig": ["BC29A660-30E3-11D0-9E69-00C04FD7C15B"],
    "IVPVBIObject": ["814B9802-1C88-11D1-BAD9-00609744111A"],
    "IVPObject": ["CE292862-FC88-11D0-9E69-00C04FD7C15B"],
    "IQualProp": ["1BD0ECB0-F8E2-11CE-AAC6-0020AF0B99A3"],
    "IDirectDrawVideo": ["36D39EB0-DD75-11CE-BF0E-00AA0055595A"],
    "IBaseVideoMixer": ["61DED640-E912-11CE-A099-00AA00479A58"],
    "IAMTuner": ["211A8761-03AC-11D1-8D13-00AA00BD8339"],
    "IAMTunerNotification": ["211A8760-03AC-11D1-8D13-00AA00BD8339"],
    "IBPCSatelliteTuner": ["211A8765-03AC-11D1-8D13-00AA00BD8339"],
    "IAMTVAudio": ["83EC1C30-23D1-11D1-99E6-00A0C9560266"],
    "IAMTVAudioNotification": ["83EC1C33-23D1-11D1-99E6-00A0C9560266"],
    "IAMCutListElement": ["CDE29520-3418-11CF-A5B0-0020AF053D8F"],
    "IAMFileCutListElement": ["F0947070-276C-11D0-8316-0020AF11C010"],
    "IAMVideoCutListElement": ["CDE29522-3418-11CF-A5B0-0020AF053D8F"],
    "IAMAudioCutListElement": ["CDE29524-3418-11CF-A5B0-0020AF053D8F"],
    "IVPControl": ["25DF12C1-3DE0-11D1-9E69-00C04FD7C15B"],
    "IDCInfo": ["0C733A9C-2A1C-11CE-ADE5-00AA0044773D"],
    "IDataConvert": ["0C733A8D-2A1C-11CE-ADE5-00AA0044773D"],
    "IADsSecurityUtility": ["A63251B2-5F21-474B-AB52-4A8EFAD10895"],
    "IADsAcePrivate": ["FD145DF2-FD96-4135-9B22-68FF0F6BF5BB"],
    "IUmiADSIPrivate": ["CFCECB01-3123-4926-B5E3-627808272643"],
    "IADsUmiHelperPrivate": ["4FE243F0-AD89-4CBC-9B14-486126446AE0"],
    "IADsExtension": ["3D35553C-D2B0-11D1-B17B-0000F87593A0"],
    "IADsObjOptPrivate": ["81CBB829-1867-11D2-9220-00C04FB6D0D1"],
    "IADsObjectOptions": ["46F14FDA-232B-11D1-A808-00C04FD8D5A8"],
    "IADsPropertyList": ["C6F602B6-8F69-11D0-8528-00C04FD8D503"],
    "IADsSearch": ["C69F7780-4008-11D0-B94C-00C04FD8D5A8"],
    "IDirectorySchemaMgmt": ["75DB3B9C-A4D8-11D0-A79C-00C04FD8D5A8"],
    "IDirectorySearch": ["109BA8EC-92F0-11D0-A790-00C04FD8D5A8"],
    "IDirectoryObject": ["E798DE2C-22E4-11D0-84FE-00C04FD8D503"],
    "IADsOpenDSObject": ["DDF2891E-0F9C-11D0-8AD4-00C04FD8D503"],
    "IADsOU": ["A2F733B8-EFFE-11CF-8ABC-00C04FD8D503"],
    "IADsO": ["A1CD2DC6-EFFE-11CF-8ABC-00C04FD8D503"],
    "IADsLocality": ["A05E03A2-EFFE-11CF-8ABC-00C04FD8D503"],
    "IADsProperty": ["C8F93DD3-4AE0-11CF-9E73-00AA004A5691"],
    "IADsSyntax": ["C8F93DD2-4AE0-11CF-9E73-00AA004A5691"],
    "IADsClass": ["C8F93DD0-4AE0-11CF-9E73-00AA004A5691"],
    "IADsFileShare": ["EB6DCAF0-4B83-11CF-A995-00AA006BC149"],
    "IADsSession": ["398B7DA0-4AAB-11CF-AE2C-00AA006EBFB9"],
    "IADsResource": ["34A05B20-4AAB-11CF-AE2C-00AA006EBFB9"],
    "IADsFileService": ["A89D1900-31CA-11CF-A98A-00AA006BC149"],
    "IADsFileServiceOperations": ["A02DED10-31CA-11CF-A98A-00AA006BC149"],
    "IADsService": ["68AF66E0-31CA-11CF-A98A-00AA006BC149"],
    "IADsServiceOperations": ["5D7B33F0-31CA-11CF-A98A-00AA006BC149"],
    "IADsCollection": ["72B945E0-253B-11CF-A988-00AA006BC149"],
    "IADsPrintJob": ["32FB6780-1ED0-11CF-A988-00AA006BC149"],
    "IADsPrintJobOperations": ["9A52DB30-1ECF-11CF-A988-00AA006BC149"],
    "IADsPrintQueueOperations": ["124BE5C0-156E-11CF-A986-00AA006BC149"],
    "IADsPrintQueue": ["B15160D0-1226-11CF-A985-00AA006BC149"],
    "IADsMembers": ["451A0030-72EC-11CF-B03B-00AA006E0975"],
    "IADsGroup": ["27636B00-410F-11CF-B1FF-02608C9E7553"],
    "IADsComputer": ["EFE3CC70-1D9F-11CF-B1F3-02608C9E7553"],
    "IADsComputerOperations": ["EF497680-1D9F-11CF-B1F3-02608C9E7553"],
    "IADsUser": ["3E37E320-17E2-11CF-ABC4-02608C9E7553"],
    "IADsDomain": ["00E4C220-FD16-11CE-ABC4-02608C9E7553"],
    "IADsNamespaces": ["28B96BA0-B330-11CF-A9AD-00AA006BC149"],
    "IADsContainer": ["001677D0-FD16-11CE-ABC4-02608C9E7553"],
    "IADs": ["FD8256D0-FD15-11CE-ABC4-02608C9E7553"],
    "IBitsTest1": ["51A183DB-67E0-4472-8602-3DBC730B7EF5"],
    "ICertManageModule": ["E7D7AD42-BD3D-11D1-9A4D-00C04FC297EB"],
    "IGCHost": ["FAC34F6E-0DCD-47B5-8021-531BC5ECCA63"],
    "IManagedInstanceWrapper": ["96E328FE-9A83-439F-A298-8F9CAA2995F0"],
    "IRegistrar": ["44EC053B-400F-11D0-9DCD-00A0C90391D3"],
    "IAxWinHostWindow": ["B6EA2050-048A-11D1-82B9-00C04FB9942E"],
    "IAxWinAmbientDispatch": ["B6EA2051-048A-11D1-82B9-00C04FB9942E"],
    "IInternalConnection": ["72AD0770-6A9F-11D1-BCEC-0060088F444E"],
    "IDocHostUIHandlerDispatch": ["425B5AF0-65F1-11D1-9611-0000F81E0D0D"],
    "IAxWinHostWindowLic": ["3935BDA8-4ED9-495C-8650-E01FC1E38A4B"],
    "IAxWinAmbientDispatchEx": ["B2D0778B-AC99-4C58-A5C8-E7724E5316B5"],
    "IMetaDataInternal": ["39EE28B3-0181-4D48-B53C-2FFAFFD5FEC1"],
    "IMetaDataError": ["B81FF171-20F3-11D2-8DCC-00A0C9B09C19"],
    "IMapToken": ["06A3EA8B-0225-11D1-BF72-00C04FC31E12"],
    "IMetaDataDispenser": ["809C652E-7396-11D2-9771-00A0C9B4D50C"],
    "IMetaDataEmit": ["BA3FEE4C-ECB9-4E41-83B7-183FA41CD859"],
    "IMetaDataEmit2": ["F5DD9950-F693-42E6-830E-7B833E8146A9"],
    "IMetaDataImport": ["7DAC8207-D3AE-4C75-9B67-92801A497D44"],
    "IMetaDataImport2": ["FCE5EFA0-8BBA-4F8E-A036-8F2022B08466"],
    "IMetaDataFilter": ["D0E80DD1-12D4-11D3-B39D-00C04FF81795"],
    "IHostFilter": ["D0E80DD3-12D4-11D3-B39D-00C04FF81795"],
    "IMetaDataConverter": ["D9DEBD79-2992-11D3-8BC1-0000F8083A57"],
    "IMetaDataAssemblyEmit": ["211EF15B-5317-4438-B196-DEC87B887693"],
    "IMetaDataAssemblyImport": ["EE62470B-E94B-424E-9B7C-2F00C9249F93"],
    "IMetaDataValidate": ["4709C9C6-81FF-11D3-9FC7-00C04F79A0A3"],
    "IMetaDataDispenserEx": ["31BCFCE2-DAFB-11D2-9F81-00C04F79A0A3"],
    "ICeeGen": ["7ED1BDFF-8E36-11D2-9C56-00A0C9B7CC45"],
    "ICorModule": ["2629F8E1-95E5-11D2-9C56-00A0C9B7CC45"],
    "IMetaDataTables": ["D8F579AB-402D-4B8E-82D9-5D63B1065C68"],
    "IMetaDataTables2": ["BADB5F70-58DA-43A9-A1C6-D74819F19B15"],
    "INativeImageDependency": ["814C9E35-3F3F-4975-977A-371F0A878AC7"],
    "INativeImageInstallInfo": ["0EA273D0-B4DA-4008-A60D-8D6EFFDD6E91"],
    "INativeImageEvaluate": ["065AA013-9BDC-447C-922F-FEE929908447"],
    "IGPMMigrationTable": ["48F823B1-EFAF-470B-B6ED-40D14EE1A4EC"],
    "IGPMMapEntry": ["8E79AD06-2381-4444-BE4C-FF693E6E6F2B"],
    "IGPMMapEntryCollection": ["BB0BF49B-E53F-443F-B807-8BE22BFB6D42"],
    "IGPMResult": ["86DFF7E9-F76F-42AB-9570-CEBC6BE8A52D"],
    "IGPMConstants": ["50EF73E6-D35C-4C8D-BE63-7EA5D2AAC5C4"],
    "IGPMStatusMessage": ["8496C22F-F3DE-4A1F-8F58-603CAAA93D7B"],
    "IGPMStatusMsgCollection": ["9B6E1AF0-1A92-40F3-A59D-F36AC1F728B7"],
    "IGPMAsyncProgress": ["6AAC29F8-5948-4324-BF70-423818942DBC"],
    "IGPMAsyncCancel": ["DDC67754-BE67-4541-8166-F48166868C9C"],
    "IGPMClientSideExtension": ["69DA7488-B8DB-415E-9266-901BE4D49928"],
    "IGPMCSECollection": ["2E52A97D-0A4A-4A6F-85DB-201622455DA0"],
    "IGPMGPOLinksCollection": ["189D7B68-16BD-4D0D-A2EC-2E6AA2288C7F"],
    "IGPMGPOLink": ["434B99BD-5DE7-478A-809C-C251721DF70C"],
    "IGPMGPOCollection": ["F0F0D5CF-70CA-4C39-9E29-B642F8726C01"],
    "IGPMGPO": ["58CC4352-1CA3-48E5-9864-1DA4D6E0D60F"],
    "IGPMRSOP": ["49ED785A-3237-4FF2-B1F0-FDF5A8D5A1EE"],
    "IGPMWMIFilterCollection": ["5782D582-1A36-4661-8A94-C3C32551945B"],
    "IGPMWMIFilter": ["EF2FF9B4-3C27-459A-B979-038305CEC75D"],
    "IGPMSOMCollection": ["ADC1688E-00E4-4495-ABBA-BED200DF0CAB"],
    "IGPMSOM": ["C0A7F09E-05A1-4F0C-8158-9E5C33684F6B"],
    "IGPMBackupCollection": ["C786FC0F-26D8-4BAB-A745-39CA7E800CAC"],
    "IGPMBackup": ["D8A16A35-3B0D-416B-8D02-4DF6F95A7119"],
    "IGPMSecurityInfo": ["B6C31ED4-1C93-4D3E-AE84-EB6D61161B60"],
    "IGPMPermission": ["35EBCA40-E1A1-4A02-8905-D79416FB464A"],
    "IGPMTrustee": ["3B466DA8-C1A4-4B2A-999A-BEFCDD56CEFB"],
    "IGPMSearchCriteria": ["D6F11C42-829B-48D4-83F5-3615B67DFC22"],
    "IGPMSitesContainer": ["4725A899-2782-4D27-A6BB-D499246FFD72"],
    "IGPMBackupDir": ["B1568BED-0A93-4ACC-810F-AFE7081019B9"],
    "IGPMDomain": ["6B21CC14-5A00-4F44-A738-FEEC8A94C7E3"],
    "IGPM": ["F5FAE809-3BD6-4DA9-A65E-17665B41D763"],
    "IKsTopology": ["28F54683-06FD-11D2-B27A-00A0C9223196"],
    "IKsAggregateControl": ["7F40EAC0-3947-11D2-874E-00A0C9223196"],
    "IKsAllocatorEx": ["091BB63A-603F-11D1-B067-00A0C9062802"],
    "IKsDataTypeCompletion": ["827D1A0E-0F73-11D2-B27A-00A0C9223196"],
    "IKsPinPipe": ["E539CD90-A8B4-11D1-8189-00A0C9062802"],
    "IKsPinEx": ["7BB38260-D19C-11D2-B38A-00A0C95EC22E"],
    "IFolderTabView": ["F4D3C5A8-0314-11D3-8859-00C04F72C717"],
    "ITitleView": ["DCA68D28-EEB3-11D2-883E-00C04F72C717"],
    "ITaskView": ["9FF7A05C-E7B9-11D2-883C-00C04F72C717"],
    "ITaskCallback": ["4B2293BA-E7BA-11D2-883C-00C04F72C717"],
    "IStringTablePrivate": ["461A6010-0F9E-11D2-A6A1-0000F875A9CE"],
    "ITaskPadHost": ["4F7606D0-5568-11D1-9FEA-00600832DB4A"],
    "IMMCListView": ["1B3C1392-D68B-11CF-8C2B-00AA003CA9F6"],
    "IPropertySheetProviderPrivate": ["FEF554F8-A55A-11D0-A7D7-00C04FD909DD"],
    "IDumpSnapins": ["A16496D0-1D2F-11D3-AEB8-00C04F8ECD78"],
    "IEnumNodeTypes": ["ABBD61E6-9686-11D0-A799-00C04FD8D565"],
    "INodeTypesCache": ["DE40436E-9671-11D0-A799-00C04FD8D565"],
    "INodeType": ["B08A8368-967F-11D0-A799-00C04FD8D565"],
    "IControlbarsCache": ["2E9FCD38-B9A0-11D0-A79D-00C04FD8D565"],
    "INodeCallback": ["B241FCED-5FB3-11D0-A986-00C04FD8D565"],
    "IScopeTreeIter": ["D779F8D1-6057-11D0-A986-00C04FD8D565"],
    "IScopeTree": ["D8DBF067-5FB2-11D0-A986-00C04FD8D565"],
    "IHeaderCtrlPrivate": ["0B384311-701B-4E8A-AEC2-DA6321E27AD2"],
    "IResultDataPrivate": ["1EBA2300-0854-11D0-8B03-00AA003CA9F6"],
    "IImageListPrivate": ["7538C620-0083-11D0-8B00-00AA003CA9F6"],
    "IScopeDataPrivate": ["60BD2FE0-F7C5-11CF-8AFD-00AA003CA9F6"],
    "IFramePrivate": ["D71D1F2A-1BA2-11D0-A29B-00C04FD909DD"],
    "IPropertySheetNotify": ["D700DD8E-2646-11D0-A2A7-00C04FD909DD"],
    "IHHCollectionWrapper": ["06A03424-C9EB-11D2-8CAA-0080C739E3E0"],
    "IMMCClipboardDataObject": ["5491AB67-AFEB-48B1-B8DF-B2D63810EF40"],
    "IDocConfig": ["F1E752C2-FD72-11D0-AEF6-00C04FB6DD2C"],
    "Property": ["4600C3A5-E301-41D8-B6D0-EF2E4212E0CA"],
    "Properties": ["2886ABC2-A425-42B2-91C6-E25C0E04581C"],
    "MenuItem": ["0178FAD1-B361-4B27-96AD-67C57EBF2E1D"],
    "ContextMenu": ["DAB39CE0-25E6-4E07-8362-BA9C95706545"],
    "Nodes": ["313B01DF-B22F-4D42-B1B8-483CDCF51D35"],
    "View": ["6EFC2DA2-B38C-457E-9ABB-ED2D189B8C38"],
    "Views": ["D6B8C29D-A1FF-4D72-AAB0-E381E9B9338D"],
    "Column": ["FD1C5F63-2B16-4D06-9AB3-F45350B940AB"],
    "Columns": ["383D4D97-FC44-478B-B139-6323DC48611C"],
    "Extensions": ["82DBEA43-8CA4-44BC-A2CA-D18741059EC8"],
    "Extension": ["AD4D6CA6-912F-409B-A26E-7FD234AEF542"],
    "SnapIns": ["2EF3DE1D-B12A-49D1-92C5-0B00798768F1"],
    "SnapIn": ["3BE910F6-3459-49C6-A1BB-41E6BE9DF3EA"],
    "Document": ["225120D6-1E0F-40A3-93FE-1079E6A8017B"],
    "ScopeNamespace": ["EBBB48DC-1A3B-4D86-B786-C21B28389012"],
    "Node": ["F81ED800-7839-4447-945D-8E15DA59CA55"],
    "Frame": ["E5E2D970-5BB3-4306-8804-B0968A31C8E6"],
    "_EventConnector": ["C0BCCD30-DE44-4528-8403-A05A6A1CC8EA"],
    "_AppEvents": ["DE46CBDD-53F5-4635-AF54-4FE71E923D3F"],
    "_Application": ["A3AFB9CC-B653-4741-86AB-F0470EC1384C"],
    "ISnapinPropertiesCallback": ["A50FA2E5-7E61-45EB-A8D4-9A07B3E851A8"],
    "ISnapinProperties": ["F7889DA9-4A02-4837-BF89-1A6F2A021010"],
    "IResultData2": ["0F36E0EB-A7F1-4A81-BE5A-9247F7DE4B1B"],
    "IConsole3": ["4F85EFDB-D0E1-498C-8D4A-D010DFDD404F"],
    "INodeProperties": ["15BC4D24-A522-4406-AA55-0749537A6865"],
    "IConsolePowerSink": ["3333759F-FE4F-4975-B143-FEC0A5DD6D65"],
    "IConsolePower": ["1CFBDD0E-62CA-49CE-A3AF-DBB2DE61B068"],
    "IViewExtensionCallback": ["34DD928A-7599-41E5-9F5E-D6BC3062C2DA"],
    "IExtendView": ["89995CEE-D2ED-4C0E-AE5E-DF7E76F3FA53"],
    "IMMCVersionInfo": ["A8D2C5FE-CDCB-4B9D-BDE5-A27343FF54BC"],
    "IContextMenuCallback2": ["E178BC0E-2ED0-4B5E-8097-42C9087E8B33"],
    "IComponent2": ["79A2D615-4A10-4ED4-8C65-8633F9335095"],
    "IComponentData2": ["CCA0F2D2-82DE-41B5-BF47-3B2076273D5C"],
    "IResultDataCompareEx": ["96933476-0251-11D3-AEB0-00C04F8ECD78"],
    "IMessageView": ["80F94174-FCCC-11D2-B991-00C04F8ECD78"],
    "IColumnData": ["547C1354-024D-11D3-A707-00C04F8EF4CB"],
    "IStringTable": ["DE40B7A4-0F65-11D2-8E25-00C04F8ECD78"],
    "IRequiredExtensions": ["72782D7A-A4A0-11D1-AF0F-00C04FB6DD2C"],
    "IDisplayHelp": ["CC593830-B926-11D1-8063-0000F875A9CE"],
    "IConsole2": ["103D842A-AA63-11D1-A7E1-00C04FD8D565"],
    "IExtendTaskPad": ["8DEE6511-554D-11D1-9FEA-00600832DB4A"],
    "IEnumTASK": ["338698B1-5A02-11D1-9FEC-00600832DB4A"],
    "ISnapinHelp2": ["4861A010-20F9-11D2-A510-00C04FB6DD2C"],
    "IHeaderCtrl2": ["9757ABB8-1B32-11D1-A7CE-00C04FD8D565"],
    "IExtendPropertySheet2": ["B7A87232-4A51-11D1-A7EA-00C04FD909DD"],
    "ISnapinHelp": ["A6B15ACE-DF59-11D0-A7DD-00C04FD909DD"],
    "IMenuButton": ["951ED750-D080-11D0-B197-000000000000"],
    "ISnapinAbout": ["1245208C-A151-11D0-A7D7-00C04FD909DD"],
    "IConsoleVerb": ["E49F7A60-74AF-11D0-A286-00C04FD8FE93"],
    "IToolbar": ["43136EB9-D36C-11CF-ADBC-00AA00A80033"],
    "IExtendControlbar": ["49506520-6F40-11D0-A98B-00C04FD8D565"],
    "IControlbar": ["69FB811E-6C1C-11D0-A2CB-00C04FD909DD"],
    "IExtendPropertySheet": ["85DE64DC-EF21-11CF-A285-00C04FD8DBE6"],
    "IPropertySheetProvider": ["85DE64DE-EF21-11CF-A285-00C04FD8DBE6"],
    "IPropertySheetCallback": ["85DE64DD-EF21-11CF-A285-00C04FD8DBE6"],
    "IConsoleNameSpace2": ["255F18CC-65DB-11D1-A7DC-00C04FD8D565"],
    "IConsoleNameSpace": ["BEDEB620-F24D-11CF-8AFC-00AA003CA9F6"],
    "IResultData": ["31DA5FA0-E0EB-11CF-9F21-00AA003CA9F6"],
    "IExtendContextMenu": ["4F3B7A4F-CFAC-11CF-B8E3-00C04FD8D5B0"],
    "IContextMenuProvider": ["43136EB6-D36C-11CF-ADBC-00AA00A80033"],
    "IContextMenuCallback": ["43136EB7-D36C-11CF-ADBC-00AA00A80033"],
    "IHeaderCtrl": ["43136EB3-D36C-11CF-ADBC-00AA00A80033"],
    "IConsole": ["43136EB1-D36C-11CF-ADBC-00AA00A80033"],
    "IResultOwnerData": ["9CB396D8-EA83-11D0-AEF1-00C04FB6DD2C"],
    "IResultDataCompare": ["E8315A52-7A1A-11D0-A2D2-00C04FD909DD"],
    "IComponent": ["43136EB2-D36C-11CF-ADBC-00AA00A80033"],
    "IComponentData": ["955AB28A-5218-11D0-A985-00C04FD8D565"],
    "IProvideTaskPage": ["4086658A-CBBB-11CF-B604-00C04FD8D565"],
    "ITaskScheduler": ["148BD527-A2AB-11CE-B11F-00AA00530503"],
    "IEnumWorkItems": ["148BD528-A2AB-11CE-B11F-00AA00530503"],
    "ITask": ["148BD524-A2AB-11CE-B11F-00AA00530503"],
    "IScheduledWorkItem": ["A6B952F0-A4B1-11D0-997D-00AA006887EC"],
    "ITaskTrigger": ["148BD52B-A2AB-11CE-B11F-00AA00530503"],
    "IXMLDocumentNotify": ["53BE4F42-3602-11D2-801B-0000F87A6CDF"],
    "IMXNamespaceManager": ["C90352F6-643C-4FBC-BB23-E996EB2D51FD"],
    "IVBMXNamespaceManager": ["C90352F5-643C-4FBC-BB23-E996EB2D51FD"],
    "IMXNamespacePrefixes": ["C90352F4-643C-4FBC-BB23-E996EB2D51FD"],
    "IServerXMLHTTPRequest2": ["2E01311B-C322-4B0A-BD77-B90CFDC8DCE7"],
    "IServerXMLHTTPRequest": ["2E9196BF-13BA-4DD4-91CA-6C571F281495"],
    "IXMLDOMSelection": ["AA634FC7-5888-44A7-A257-3A47150D3A0E"],
    "ISchemaNotation": ["50EA08BE-DD1B-4664-9A50-C2F40F4BD79A"],
    "ISchemaIdentityConstraint": ["50EA08BD-DD1B-4664-9A50-C2F40F4BD79A"],
    "ISchemaAny": ["50EA08BC-DD1B-4664-9A50-C2F40F4BD79A"],
    "ISchemaModelGroup": ["50EA08BB-DD1B-4664-9A50-C2F40F4BD79A"],
    "ISchemaAttributeGroup": ["50EA08BA-DD1B-4664-9A50-C2F40F4BD79A"],
    "ISchemaComplexType": ["50EA08B9-DD1B-4664-9A50-C2F40F4BD79A"],
    "ISchemaType": ["50EA08B8-DD1B-4664-9A50-C2F40F4BD79A"],
    "ISchemaElement": ["50EA08B7-DD1B-4664-9A50-C2F40F4BD79A"],
    "ISchemaAttribute": ["50EA08B6-DD1B-4664-9A50-C2F40F4BD79A"],
    "ISchemaParticle": ["50EA08B5-DD1B-4664-9A50-C2F40F4BD79A"],
    "ISchema": ["50EA08B4-DD1B-4664-9A50-C2F40F4BD79A"],
    "ISchemaItem": ["50EA08B3-DD1B-4664-9A50-C2F40F4BD79A"],
    "ISchemaItemCollection": ["50EA08B2-DD1B-4664-9A50-C2F40F4BD79A"],
    "ISchemaStringCollection": ["50EA08B1-DD1B-4664-9A50-C2F40F4BD79A"],
    "IXMLDOMSchemaCollection2": ["50EA08B0-DD1B-4664-9A50-C2F40F4BD79A"],
    "IMXSchemaDeclHandler": ["FA4BB38C-FAF9-4CCA-9302-D1DD0FE520DB"],
    "IMXReaderControl": ["808F4E35-8D5A-4FBE-8466-33A41279ED30"],
    "IMXAttributes": ["F10D27CC-3EC0-415C-8ED8-77AB1C5E7262"],
    "IMXWriter": ["4D7FF4BA-1565-4EA8-94E1-6E724A46F98D"],
    "IVBSAXAttributes": ["10DC0586-132B-4CAC-8BB3-DB00AC8B7EE0"],
    "IVBSAXDeclHandler": ["E8917260-7579-4BE1-B5DD-7AFBFA6F077B"],
    "IVBSAXLexicalHandler": ["032AAC35-8C0E-4D9D-979F-E3B702935576"],
    "IVBSAXErrorHandler": ["D963D3FE-173C-4862-9095-B92F66995F52"],
    "IVBSAXDTDHandler": ["24FB3297-302D-4620-BA39-3A732D850558"],
    "IVBSAXContentHandler": ["2ED7290A-4DD5-4B46-BB26-4E4155E77FAA"],
    "IVBSAXEntityResolver": ["0C05D096-F45B-4ACA-AD1A-AA0BC25518DC"],
    "IVBSAXLocator": ["796E7AC5-5AA2-4EFF-ACAD-3FAAF01A3288"],
    "IVBSAXXMLFilter": ["1299EB1B-5B88-433E-82DE-82CA75AD4E04"],
    "IVBSAXXMLReader": ["8C033CAA-6CD6-4F73-B728-4531AF74945F"],
    "ISAXAttributes": ["F078ABE1-45D2-4832-91EA-4466CE2F25C9"],
    "ISAXDeclHandler": ["862629AC-771A-47B2-8337-4E6843C1BE90"],
    "ISAXLexicalHandler": ["7F85D5F5-47A8-4497-BDA5-84BA04819EA6"],
    "ISAXErrorHandler": ["A60511C4-CCF5-479E-98A3-DC8DC545B7D0"],
    "ISAXDTDHandler": ["E15C1BAF-AFB3-4D60-8C36-19A8C45DEFED"],
    "ISAXContentHandler": ["1545CDFA-9E4E-4497-A8A4-2BF7D0112C44"],
    "ISAXEntityResolver": ["99BCA7BD-E8C4-4D5F-A0CF-6D907901FF07"],
    "ISAXLocator": ["9B7E472A-0DE4-4640-BFF3-84D38A051C31"],
    "ISAXXMLFilter": ["70409222-CA09-4475-ACB8-40312FE8D145"],
    "ISAXXMLReader": ["A4F96ED0-F829-476E-81C0-CDC7BD2A0802"],
    "IXSLProcessor": ["2933BF92-7B36-11D2-B20E-00C04F983E60"],
    "IXSLTemplate": ["2933BF93-7B36-11D2-B20E-00C04F983E60"],
    "IXMLDOMSchemaCollection": ["373984C8-B845-449B-91E7-45AC83036ADE"],
    "IXMLDOMDocument2": ["2933BF95-7B36-11D2-B20E-00C04F983E60"],
    "IDataSourceListener": ["7C0FFAB2-CD84-11D0-949A-00A0C91110ED"],
    "IDataSource": ["7C0FFAB3-CD84-11D0-949A-00A0C91110ED"],
    "IVBDSC": ["1AB42240-8C70-11CE-9421-00AA0062BE57"],
    "IWiaVideo": ["D52920AA-DB88-41F0-946C-E00DC0A19CFA"],
    "IStiWow64Device": ["E5332A98-80FD-463C-80E4-A8E370752906"],
    "IWiaWow64": ["7BB68E65-F426-4698-A0B7-D2AF28B1BA81"],
    "IWiaItemInternal": ["B884E681-66BA-4014-AFBF-DCB3BEE45FAA"],
    "IStiLockMgr": ["70681EA0-E7BF-4291-9FB1-FE550482AB88"],
    "IWia": ["B10BA1BC-3713-4EC0-8EEA-690EBD2CED8A"],
    "IWiaDeviceInfo": ["5267FF5E-7CAF-4769-865D-17A25968525E"],
    "IWiaDispatchItem": ["D06D503F-4B71-40F3-94A7-66478F732BC9"],
    "ICollection": ["C34C8CE7-B253-4F89-AA25-8A24AD71D0C0"],
    "IWiaDrvItem": ["1F02B5C5-B00C-11D2-A094-00C04F72DC3C"],
    "IWiaMiniDrvCallBack": ["33A57D5A-3DE8-11D2-9A36-00C04FA36145"],
    "IWiaMiniDrv": ["D8CDEE14-3C6C-11D2-9A35-00C04FA36145"],
    "IWiaItemExtras": ["6291EF2C-36EF-4532-876A-8E132593778D"],
    "IWiaNotifyDevMgr": ["70681EA0-E7BF-4291-9FB1-4E8813A3F78E"],
    "IWiaLogEx": ["AF1F22AC-7A40-4787-B421-AEB47A1FBD0B"],
    "IWiaLog": ["A00C10B6-82A1-452F-8B6C-86062AAD6890"],
    "IEnumWIA_FORMAT_INFO": ["81BEFC5B-656D-44F1-B24C-D41D51B4DC81"],
    "IEnumWIA_DEV_CAPS": ["1FCC4287-ACA6-11D2-A093-00C04F72DC3C"],
    "IEnumWiaItem": ["5E8383FC-3391-11D2-9A33-00C04FA36145"],
    "IWiaPropertyStorage": ["98B5E8A0-29CC-491A-AAC0-E6DB4FDCCEB6"],
    "IWiaItem": ["4DB1AD10-3391-11D2-9A33-00C04FA36145"],
    "IWiaDataTransfer": ["A6CEF998-A5B0-11D2-A08F-00C04F72DC3C"],
    "IWiaDataCallback": ["A558A866-A5B0-11D2-A08F-00C04F72DC3C"],
    "IWiaEventCallback": ["AE6287B0-0084-11D2-973B-00A0C9068F2E"],
    "IEnumWIA_DEV_INFO": ["5E38B83C-8CF1-11D1-BF92-0060081ED811"],
    "IWiaDevMgr": ["5EB2502A-8CF1-11D1-BF92-0060081ED811"],
    "IWiaProgressDialog": ["F740718A-E460-4B05-83E8-C5D221C772E5"],
    "IWiaGetImageDlg": ["4F67AD3C-19EA-4CE9-80E2-3ADE50D502A2"],
    "IWiaUIExtension": ["DA319113-50EE-4C80-B460-57D005D44A2C"],
    "IStiDevice": ["6CFA5A80-2DC8-11D0-90EA-00AA0060F86C"],
    "IStillImageA": ["A7B1F740-1D7F-11D1-ACA9-00A02438AD48"],
    "IStillImageW": ["641BD880-2DC8-11D0-90EA-00AA0060F86C"],
    "IViewTransition": ["3050F372-98B5-11CF-BB82-00AA00BDCE0B"],
    "IViewTransitionSite": ["3050F373-98B5-11CF-BB82-00AA00BDCE0B"],
    "IHlinkSite": ["79EAC9C2-BAF9-11CE-8C82-00AA004BA90B"],
    "IHlink": ["79EAC9C3-BAF9-11CE-8C82-00AA004BA90B"],
    "IHlinkTarget": ["79EAC9C4-BAF9-11CE-8C82-00AA004BA90B"],
    "IHlinkFrame": ["79EAC9C5-BAF9-11CE-8C82-00AA004BA90B"],
    "IEnumHLITEM": ["79EAC9C6-BAF9-11CE-8C82-00AA004BA90B"],
    "IHlinkBrowseContext": ["79EAC9C7-BAF9-11CE-8C82-00AA004BA90B"],
    "IExtensionServices": ["79EAC9CB-BAF9-11CE-8C82-00AA004BA90B"],
    "OLEDBSimpleProvider": ["E0E270C0-C0BE-11D0-8FE4-00A0C90A6341"],
    "OLEDBSimpleProviderListener": ["E0E270C1-C0BE-11D0-8FE4-00A0C90A6341"],
    "IPStore": ["5A6F1EC0-2DB1-11D0-8C39-00C04FD9126B"],
    "__PSTORECLib": ["5A6F1EBD-2DB1-11D0-8C39-00C04FD9126B"],
    "IUnknown": ["00000000-0000-0000-C000-000000000046"],
    "DWebBrowserEvents": ["EAB22AC2-30C1-11CF-A7EB-0000C05BAE0B"],
    "DWebBrowserEvents2": ["34A715A0-6587-11D0-924A-0020AFC7AC4D"],
    "DShellWindowsEvents": ["FE4106E0-399A-11D0-A48C-00A0C90A8F39"],
    "DShellFavoritesNameSpaceEvents": ["55136806-B2DE-11D1-B9F2-00A0C98BC547"],
    "DShellFolderViewEvents": ["62112AA2-EBE4-11CF-A5FB-0020AFE7292D"],
    "IBackgroundCopyFile": ["01B7BD23-FB88-4A77-8490-5891D3E4653A"],
    "IEnumBackgroundCopyFiles": ["CA51E165-C365-424C-8D41-24AAA4FF3C40"],
    "IBackgroundCopyError": ["19C613A0-FCB8-4F28-81AE-897C3D078F81"],
    "IBackgroundCopyJob": ["37668D37-507E-4160-9316-26306D150B12"],
    "IEnumBackgroundCopyJobs": ["1AF4F612-3B71-466F-8F58-7B6F73AC57AD"],
    "AsyncIBackgroundCopyCallback": ["CA29D251-B4BB-4679-A3D9-AE8006119D54"],
    "IBackgroundCopyManager": ["5CE34C0D-0DC9-4C1F-897C-DAA1B78CEE7C"],
    "MS_BackgroundCopyQueueManager1_0": ["1DEEB74F-7915-4560-B558-918C83F176A6"],
    "IBackgroundCopyCallback": ["97EA99C7-0186-4AD4-8DF9-C5B4E0ED6B22"],
    "IBackgroundCopyJob2": ["54B50739-686F-45EB-9DFF-D6A9A0FAA9AF"],
    "IBackgroundCopyJob3": ["443C8934-90FF-48ED-BCDE-26F5C7450042"],
    "IBackgroundCopyFile2": ["83E81B93-0873-474D-8A8C-F2018B1A939C"],
    "IOutlookExpress": ["3338DF6A-4660-11D1-8A8D-00C04FB951F3"],
    "IStoreNamespace": ["E70C92AA-4BFD-11D1-8A95-00C04FB951F3"],
    "IStoreFolder": ["E70C92AC-4BFD-11D1-8A95-00C04FB951F3"],
    "IUserIdentity": ["A9AE6C8E-1D1B-11D2-B21A-00C04FA357FA"],
    "IEnumUserIdentity": ["A9AE6C8F-1D1B-11D2-B21A-00C04FA357FA"],
    "IUserIdentityManager": ["A9AE6C90-1D1B-11D2-B21A-00C04FA357FA"],
    "IIdentityChangeNotify": ["A9AE6C92-1D1B-11D2-B21A-00C04FA357FA"],
    "IPrivateIdentityManager": ["A9AE6C93-1D1B-11D2-B21A-00C04FA357FA"],
    "IPrivateIdentityManager2": ["15E84C92-2E4D-11D3-9C92-00104B35E7F9"],
    "IUserIdentity2": ["A9AE6C94-1D1B-11D2-B21A-00C04FA357FA"],
    "IEnumPStoreProviders": ["5A6F1EBF-2DB1-11D0-8C39-00C04FD9126B"],
    "IEnumPStoreTypes": ["789C1CBF-31EE-11D0-8C39-00C04FD9126B"],
    "IEnumPStoreItems": ["5A6F1EC1-2DB1-11D0-8C39-00C04FD9126B"],
    "IEnumPStoreProviders_Default": ["5A6F1EC3-2DB1-11D0-8C39-00C04FD9126B"],
    "IEnumPStoreTypes_Default": ["09BB61E7-31EC-11D0-8C39-00C04FD9126B"],
    "IEnumPStoreItems_Default": ["09BB61E6-31EC-11D0-8C39-00C04FD9126B"],
    "HTMLStyle": ["3050F55A-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLRuleStyle": ["3050F55C-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLRenderStyle": ["3050F58B-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLCurrentStyle": ["3050F557-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLDOMAttribute": ["3050F564-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLDOMTextNode": ["3050F565-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLDOMImplementation": ["3050F58F-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLAttributeCollection": ["3050F56C-98B5-11CF-BB82-00AA00BDCE0B"],
    "DOMChildrenCollection": ["3050F577-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLElementEvents2": ["3050F60F-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLElementEvents": ["3050F33C-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLDefaults": ["3050F58C-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTCDefaultatch": ["3050F573-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTCPropertyBehavior": ["3050F57F-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTCMethodBehavior": ["3050F587-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTCEventBehavior": ["3050F574-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTCAttachBehavior": ["3050F583-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTCDescBehavior": ["3050F57E-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLGenericElement": ["3050F563-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLStyleSheet": ["3050F58D-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLLinkElementEvents2": ["3050F61D-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLLinkElementEvents": ["3050F3CC-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLLinkElement": ["3050F524-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLFormElementEvents2": ["3050F614-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLFormElementEvents": ["3050F364-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLFormElement": ["3050F510-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLControlElementEvents2": ["3050F612-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLControlElementEvents": ["3050F4EA-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLTextElement": ["3050F537-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLTextContainerEvents2": ["3050F624-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLTextContainerEvents": ["1FF6AA72-5842-11CF-A707-00AA00C0098D"],
    "HTMLImgEvents2": ["3050F616-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLImgEvents": ["3050F25B-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLImg": ["3050F51C-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLBody": ["3050F507-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLFontElement": ["3050F512-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLAnchorEvents2": ["3050F610-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLAnchorEvents": ["3050F29D-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLAnchorElement": ["3050F502-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLLabelEvents2": ["3050F61C-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLLabelEvents": ["3050F329-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLLabelElement": ["3050F522-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLListElement": ["3050F525-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLUListElement": ["3050F538-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLOListElement": ["3050F52A-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLLIElement": ["3050F523-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLBlockElement": ["3050F506-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLDivElement": ["3050F50C-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLDDElement": ["3050F50B-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLDTElement": ["3050F50D-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLBRElement": ["3050F53A-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLDListElement": ["3050F53B-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLHRElement": ["3050F53D-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLParaElement": ["3050F52C-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLElementCollection": ["3050F56B-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLHeaderElement": ["3050F515-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLSelectElementEvents2": ["3050F622-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLSelectElementEvents": ["3050F302-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLSelectElement": ["3050F531-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLOptionElement": ["3050F52B-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLButtonElementEvents2": ["3050F617-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLButtonElementEvents": ["3050F2B3-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLInputTextElementEvents2": ["3050F618-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLOptionButtonElementEvents2": ["3050F619-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLInputFileElementEvents2": ["3050F61A-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLInputImageEvents2": ["3050F61B-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLInputTextElementEvents": ["3050F2A7-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLOptionButtonElementEvents": ["3050F2BD-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLInputFileElementEvents": ["3050F2AF-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLInputImageEvents": ["3050F2C3-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLInputElement": ["3050F57D-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLTextAreaElement": ["3050F521-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLRichtextElement": ["3050F54D-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLButtonElement": ["3050F51F-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLMarqueeElementEvents2": ["3050F61F-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLMarqueeElementEvents": ["3050F2B8-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLMarqueeElement": ["3050F527-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLHtmlElement": ["3050F560-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLHeadElement": ["3050F561-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLTitleElement": ["3050F516-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLMetaElement": ["3050F517-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLBaseElement": ["3050F518-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLIsIndexElement": ["3050F519-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLNextIdElement": ["3050F51A-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLBaseFontElement": ["3050F504-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLUnknownElement": ["3050F539-98B5-11CF-BB82-00AA00BDCE0B"],
    "CEventObj": ["3050F558-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLWindowEvents2": ["3050F625-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLWindowEvents": ["96A0A4E0-D062-11CF-94B6-00AA0060275C"],
    "HTMLScreen": ["3050F591-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLWindow2": ["3050F55D-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLWindowProxy": ["3050F55E-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLDocumentEvents2": ["3050F613-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLDocumentEvents": ["3050F260-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLDocument": ["3050F55F-98B5-11CF-BB82-00AA00BDCE0B"],
    "DWebBridgeEvents": ["A6D897FF-0A95-11D1-B0BA-006008166E11"],
    "IWebBridge_Default": ["AE24FDAE-03C6-11D1-8B76-0080C744F389"],
    "HTMLEmbed": ["3050F52E-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLMapEvents2": ["3050F61E-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLMapEvents": ["3050F3BA-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLAreasCollection": ["3050F56A-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLMapElement": ["3050F526-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLAreaEvents2": ["3050F611-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLAreaEvents": ["3050F366-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLAreaElement": ["3050F503-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLTableCaption": ["3050F508-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLCommentElement": ["3050F50A-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLPhraseElement": ["3050F52D-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLSpanElement": ["3050F548-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLTableEvents2": ["3050F623-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLTableEvents": ["3050F407-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLTable": ["3050F532-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLTableCol": ["3050F533-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLTableSection": ["3050F534-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLTableRow": ["3050F535-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLTableCell": ["3050F536-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLScriptEvents2": ["3050F621-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLScriptEvents": ["3050F3E2-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLScriptElement": ["3050F530-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLNoShowElement": ["3050F528-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLObjectElementEvents2": ["3050F620-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLObjectElementEvents": ["3050F3C4-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLObjectElement": ["3050F529-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLParamElement": ["3050F590-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLFrameSiteEvents": ["3050F800-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLFrameBase": ["3050F541-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLFrameElement": ["3050F513-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLIFrame": ["3050F51B-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLDivPosition": ["3050F50F-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLFieldSetElement": ["3050F545-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLLegendElement": ["3050F546-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLSpanFlow": ["3050F544-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLFrameSetSite": ["3050F514-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLBGsound": ["3050F53C-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLStyleElementEvents2": ["3050F615-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLStyleElementEvents": ["3050F3CB-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLStyleElement": ["3050F511-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLNamespaceEvents": ["3050F6BD-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLPopup": ["3050F589-98B5-11CF-BB82-00AA00BDCE0B"],
    "HTMLAppBehavior": ["3050F57C-98B5-11CF-BB82-00AA00BDCE0B"],
    "WinHttpRequest_component": ["2087C2F4-2CEF-4953-A8AB-66779B670495"],
    "IMailMsgNotify": ["0F7C3C30-A8AD-11D1-AA91-00AA006BC80B"],
    "IMailMsgPropertyStream": ["A44819C0-A7CF-11D1-AA91-00AA006BC80B"],
    "IMailMsgRecipientsBase": ["D1A97920-A891-11D1-AA91-00AA006BC80B"],
    "IMailMsgRecipientsAdd": ["4C28A700-A892-11D1-AA91-00AA006BC80B"],
    "IMailMsgRecipients": ["19507FE0-A892-11D1-AA91-00AA006BC80B"],
    "IMailMsgProperties": ["AB95FB40-A34F-11D1-AA8A-00AA006BC80B"],
    "IMailMsgCommit": ["02B80EDB-6D5A-4D05-950A-237811F8D412"],
    "IMailMsgValidate": ["6717B03C-072C-11D3-94FF-00C04FA379F1"],
    "IMailMsgValidateContext": ["60A482B1-B311-4ECA-A3A3-907F9DAFD16F"],
    "IMailMsgPropertyManagement": ["A2F196C0-A351-11D1-AA8A-00AA006BC80B"],
    "IMailMsgEnumMessages": ["E760A840-C8F1-11D1-9FF2-00C04FA37348"],
    "IMailMsgStoreDriver": ["246AAE60-ACC4-11D1-AA91-00AA006BC80B"],
    "IMailMsgQueueMgmt": ["B2564D0A-D5A1-11D1-9FF7-00C04FA37348"],
    "ISMTPStoreDriver": ["EE51588C-D64A-11D1-9FF7-00C04FA37348"],
    "IMailMsgStoreDriverValidateContext": ["C6742794-AD31-4711-BE73-9869142A8A23"],
    "IMailMsgBind": ["38CB448A-CA62-11D1-9FF3-00C04FA37348"],
    "IMailMsgPropertyBag": ["D6D0509C-EC51-11D1-AA65-00C04FA35B82"],
    "IMailMsgLoggingPropertyBag": ["4CB17416-EC53-11D1-AA65-00C04FA35B82"],
    "IMailMsgCleanupCallback": ["951C04A1-29F0-4B8E-9ED5-836C73766051"],
    "IMailMsgRegisterCleanupCallback": ["00561C2F-5E90-49E5-9E73-7BF9129298A0"],
    "ISMTPServer": ["22625594-D822-11D1-9FF7-00C04FA37348"],
    "ISMTPServerEx": ["52AE6373-90F6-470C-9D38-526E9060B07D"],
    "ISMTPServerAsync": ["08AF2A87-8C10-4196-9AE6-D517A86B9795"],
    "ISMTPServerGetAuxDomainInfoFlags": ["735E9929-1885-4736-8D07-492F962ECEB9"],
    "ISMTPServerInternal": ["57EE6C15-1870-11D2-A689-00C04FA3490A"],
    "IMimeInternational": ["C5588349-7F86-11D0-8252-00C04FD85AB4"],
    "IMimeSecurity": ["C5588353-7F86-11D0-8252-00C04FD85AB4"],
    "IMimeHeaderTable": ["FD853CD1-7F86-11D0-8252-00C04FD85AB4"],
    "IMimePropertySchema": ["FD853CEC-7F86-11D0-8252-00C04FD85AB4"],
    "IMimePropertySet": ["FD853CD3-7F86-11D0-8252-00C04FD85AB4"],
    "IMimeAddressTable": ["C558834A-7F86-11D0-8252-00C04FD85AB4"],
    "IMimeWebDocument": ["EE519F11-851A-11D0-825C-00C04FD85AB4"],
    "IMimeBody": ["C558834C-7F86-11D0-8252-00C04FD85AB4"],
    "IMimeMessageTree": ["FD853CD4-7F86-11D0-8252-00C04FD85AB4"],
    "IMimeMessage": ["FD853CD5-7F86-11D0-8252-00C04FD85AB4"],
    "IMimeMessageCallback": ["761AA641-7BDA-11D1-8AA9-00C04FB951F3"],
    "IPersistMime": ["DE4AD8DA-555F-11D1-8DD0-00C04FB951F9"],
    "IMimeMessageParts": ["C558834F-7F86-11D0-8252-00C04FD85AB4"],
    "IMimeEnumHeaderRows": ["C558834D-7F86-11D0-8252-00C04FD85AB4"],
    "IMimeEnumProperties": ["FD853CEE-7F86-11D0-8252-00C04FD85AB4"],
    "IMimeEnumAddressTypes": ["C5588354-7F86-11D0-8252-00C04FD85AB4"],
    "IMimeEnumMessageParts": ["C5588350-7F86-11D0-8252-00C04FD85AB4"],
    "IHashTable": ["64577981-86D7-11D1-BDFC-00C04FA31009"],
    "IMimeAllocator": ["C5588351-7F86-11D0-8252-00C04FD85AB4"],
    "IMimeObjResolver": ["FECEAFFD-C441-11D1-960E-00C04FBD7C09"],
    "IFontCache": ["B0D17FC2-7BC4-11D1-BDFA-00C04FA31009"],
    "IFontCacheNotify": ["B0D17FC5-7BC4-11D1-BDFA-00C04FA31009"],
    "IMimeEditTag": ["70183210-7B36-11D2-8C12-00C04FA31009"],
    "IMimeEditTagCollection": ["D09EE528-7B38-11D2-8C12-00C04FA31009"],
    "INetFwRemoteAdminSettings": ["D4BECDDF-6F73-4A83-B832-9C66874CD20E"],
    "INetFwIcmpSettings": ["A6207B2E-7CDD-426A-951E-5E1CBC5AFEAD"],
    "INetFwOpenPort": ["E0483BA0-47FF-4D9C-A6D6-7741D0B195F7"],
    "INetFwOpenPorts": ["C0E9D7FA-E07E-430A-B19A-090CE82D92E2"],
    "INetFwService": ["79FD57C8-908E-4A36-9888-D5B3F0A444CF"],
    "INetFwServices": ["79649BB4-903E-421B-94C9-79848E79F6EE"],
    "INetFwAuthorizedApplication": ["B5E64FFA-C2C5-444E-A301-FB5E00018050"],
    "INetFwAuthorizedApplications": ["644EFD52-CCF9-486C-97A2-39F352570B30"],
    "INetFwProfile": ["174A0DDA-E9F9-449D-993B-21AB667CA456"],
    "INetFwPolicy": ["D46D2478-9AC9-4008-9DC7-5563CE5536CC"],
    "INetFwMgr": ["F7898AF5-CAC4-4632-A2EC-DA06E5111AF2"],
    "INetFwOpenPort_Default": ["0CA545C6-37AD-4A6C-BF92-9F7610067EF5"],
    "INetFwAuthorizedApplication_Default": ["EC9846B3-2762-4A6B-A214-6ACB603462D2"],
    "INetFwMgr_Default": ["304CE942-6E39-40D8-943A-B913C40C9CD4"],
    "ISmtpInCommandContext": ["5F15C533-E90E-11D1-8852-00C04FA35B86"],
    "ISmtpInCallbackContext": ["5E4FC9DA-3E3B-11D3-88F1-00C04FA35B86"],
    "ISmtpOutCommandContext": ["C849B5F2-0A80-11D2-AA67-00C04FA35B82"],
    "ISmtpServerResponseContext": ["E38F9AD2-0A82-11D2-AA67-00C04FA35B82"],
    "ISmtpInCommandSink": ["B2D42A0E-0D5F-11D2-AA68-00C04FA35B82"],
    "ISmtpOutCommandSink": ["CFDBB9B0-0CA0-11D2-AA68-00C04FA35B82"],
    "ISmtpServerResponseSink": ["D7E10222-0CA1-11D2-AA68-00C04FA35B82"],
    "ISmtpInCallbackSink": ["0012B624-3E3C-11D3-88F1-00C04FA35B86"],
    "IMailTransportNotify": ["6E1CAA77-FCD4-11D1-9DF9-00C04FA322BA"],
    "IMailTransportSubmission": ["CE681916-FF14-11D1-9DFB-00C04FA322BA"],
    "IMailTransportOnPreCategorize": ["A3ACFB0E-83FF-11D2-9E14-00C04FA322BA"],
    "IMailTransportOnPostCategorize": ["76719653-05A6-11D2-9DFD-00C04FA322BA"],
    "IMailTransportRouterReset": ["A928AD12-1610-11D2-9E02-00C04FA322BA"],
    "IMailTransportSetRouterReset": ["A928AD11-1610-11D2-9E02-00C04FA322BA"],
    "IMessageRouter": ["A928AD14-1610-11D2-9E02-00C04FA322BA"],
    "IMailTransportRouterSetLinkState": ["B870CE28-A755-11D2-A6A9-00C04FA3490A"],
    "IMessageRouterLinkStateNotification": ["B870CE29-A755-11D2-A6A9-00C04FA3490A"],
    "IMailTransportRoutingEngine": ["A928AD13-1610-11D2-9E02-00C04FA322BA"],
    "IMsgTrackLog": ["1BC3580E-7E4F-11D2-94F4-00C04F79F1D6"],
    "IDnsResolverRecord": ["E5B89C52-8E0B-11D2-94F6-00C04F79F1D6"],
    "IDnsInfoSink": ["6A417A4C-27BA-4867-A286-83E332074558"],
    "IDnsStatus": ["4E60BFAD-A179-47AC-8961-C7C1F0785AC1"],
    "IDnsResolverRecordSink": ["D95A4D0C-8E06-11D2-94F6-00C04F79F1D6"],
    "ISmtpMaxMsgSize": ["B997F192-A67D-11D2-94F7-00C04F79F1D6"],
    "ISmtpLog": ["35BC9AD7-7AA5-43EE-A0AB-94E1D6BE99E5"],
    "ISmtpGetAuxDomainInfoFlags": ["D038C9DA-4977-491D-8B0E-97F2E546C35A"],
    "ICategorizerProperties": ["96BF3199-79D8-11D2-9E11-00C04FA322BA"],
    "ICategorizerParameters": ["86F9DA7B-EB6E-11D1-9DF3-00C04FA322BA"],
    "ICategorizerQueries": ["86F9DA7D-EB6E-11D1-9DF3-00C04FA322BA"],
    "ICategorizerMailMsgs": ["86F9DA80-EB6E-11D1-9DF3-00C04FA322BA"],
    "ICategorizerItemAttributes": ["86F9DA7F-EB6E-11D1-9DF3-00C04FA322BA"],
    "ICategorizerItemRawAttributes": ["34C3D389-8FA7-11D2-9E16-00C04FA322BA"],
    "ICategorizerItem": ["86F9DA7C-EB6E-11D1-9DF3-00C04FA322BA"],
    "ICategorizerAsyncCompletion": ["86F9DA7E-EB6E-11D1-9DF3-00C04FA322BA"],
    "ICategorizerListResolve": ["960252A4-0A3A-11D2-9E00-00C04FA322BA"],
    "IMailTransportCategorize": ["86F9DA7A-EB6E-11D1-9DF3-00C04FA322BA"],
    "ISMTPCategorizer": ["B23C35B8-9219-11D2-9E17-00C04FA322BA"],
    "ISMTPCategorizerCompletion": ["B23C35B9-9219-11D2-9E17-00C04FA322BA"],
    "ISMTPCategorizerDLCompletion": ["B23C35BA-9219-11D2-9E17-00C04FA322BA"],
    "ICategorizerDomainInfo": ["E210EDC6-F27D-481F-9DFC-1CA840905FD9"],
    "ICategorizerParametersEx": ["E962BA1F-3FB9-11D3-80D7-00C04FA322BA"],
    "ICategorizerRequestedAttributes": ["CB0924E0-357B-11D3-8328-00C04FA322BA"],
    "ICategorizerUTF8Attributes": ["BEBF931D-17E0-4EC8-BC1C-CC3286D72CB7"],
    "ICategorizerLdapConfig": ["27C1B2D3-1A28-4B90-BC0A-E52057D30712"],
    "IServersListInfo": ["C54CEA94-E501-4F34-8704-F5881EA5CBF4"],
    "IDSNGenerationSink": ["3A513AB9-339D-4589-A137-D54C5F520E6F"],
    "IDSNRecipientIterator": ["1D45C98A-56A0-4FE8-BF33-8986EEB85B63"],
    "IDSNSubmission": ["C016B75D-CE65-496F-A2C9-B487C83C0F6B"],
    "ATLVer30": ["B62F5910-6528-11D1-9611-0000F81E0D0D"],
    "ImageFormatBMP": ["B96B3CAB-0728-11D3-9D7B-0000F81EF32E"],
    "ImageFormatEMF": ["B96B3CAC-0728-11D3-9D7B-0000F81EF32E"],
    "ImageFormatEXIF": ["B96B3CB2-0728-11D3-9D7B-0000F81EF32E"],
    "ImageFormatGIF": ["B96B3CB0-0728-11D3-9D7B-0000F81EF32E"],
    "ImageFormatIcon": ["B96B3CB5-0728-11D3-9D7B-0000F81EF32E"],
    "ImageFormatJPEG": ["B96B3CAE-0728-11D3-9D7B-0000F81EF32E"],
    "ImageFormatPNG": ["B96B3CAF-0728-11D3-9D7B-0000F81EF32E"],
    "ImageFormatTIFF": ["B96B3CB1-0728-11D3-9D7B-0000F81EF32E"],
    "ImageFormatUndefined": ["B96B3CA9-0728-11D3-9D7B-0000F81EF32E"],
    "ImageFormatWMF": ["B96B3CAD-0728-11D3-9D7B-0000F81EF32E"],
    "FrameDimensionPage": ["7462DC86-6180-4C7E-8E3F-EE7333A7A483"],
    "FrameDimensionResolution": ["84236F7B-3BD3-428F-8DAB-4EA1439CA315"],
    "FrameDimensionTime": ["6AEDBD6D-3FB5-418A-83A6-7F45229DC872"],
    "EncoderChrominanceTable": ["F2E455DC-09B3-4316-8260-676ADA32481C"],
    "EncoderColorDepth": ["66087055-AD66-4C7C-9A18-38A2310B8337"],
    "EncoderCompression": ["E09D739D-CCD4-44EE-8EBA-3FBF8BE4FC58"],
    "EncoderLuminanceTable": ["EDB33BCE-0266-4A77-B904-27216099E717"],
    "EncoderQuality": ["1D5BE4B5-FA4A-452D-9CDD-5DB35105E7EB"],
    "EncoderRenderMethod": ["6D42C53A-229A-4825-8BB7-5C99E2B9A8B8"],
    "EncoderSaveFlag": ["292266FC-AC40-47BF-8CFC-A85B89A655DE"],
    "EncoderScanMethod": ["3A4E2661-3109-4E56-8536-42C156E7DCFA"],
    "EncoderTransformation": ["8D0EB2D1-A58E-4EA8-AA14-108074B7B6F9"],
    "EncoderVersion": ["24D18C76-814A-41A4-BF53-1C219CCCF797"],
    "Shell32": ["50A7E9B0-70EF-11D1-B75A-00A0C90564FE"],
    "SearchCommandExecuteErrors": ["418F4E6A-B903-11D1-B0A6-00C04FC33AA5"],
    "Folder2OfflineStatusConstants": ["35F1A0D0-3E9A-11D2-8499-005345000000"],
    "ViewOptionsConstants": ["742A99A0-C77E-11D0-A32C-00A0C91EEDBA"],
    "SpecialFoldersForOpenExploreConstants": ["CA31EA20-48D0-11CF-8350-444553540000"],
    "DSearchCommandEvents": ["60890160-69F0-11D1-B758-00A0C90564FE"],
    "StmOCX_Main_RE": ["7A0D1738-10EA-47FF-92BE-4E137B5BE1A4"],
    "StmOCX_TypeLib_RE": ["0AB6D809-3081-494F-BD93-D58F480BF0E3"],
    "StmOCX_Catagory1_RE": ["7DD95801-9882-11CF-9FA9-00AA006C42C4"],
    "StmOCX_Catagory2_RE": ["7DD95802-9882-11CF-9FA9-00AA006C42C4"],
    "StmOCX_3_Unknown_RE": ["4D418083-A65A-744B-93EB-855D7361E6B4"],
    "StmOCX_3_Crypted00_RE": ["EA4F5CEC-BC42-4B64-8B18-EFFC62ADDA31"],
    "ICaptureGraphBuilder2": ["93E5A4E0-2D50-11D2-ABFA-00A0C9C6E38D"],
    "FIAsyncOperationCompletedHandler_1_ContentManagement__CTargetedContent__CTargetedContentCollection": [
        "e1e99453-1a6e-58f5-8356-8e24ba4a0d4d",
        "e1e99453-1a6e-58f5-8356-8e24ba4a0d4d",
    ],
    "FIAsyncOperationCompletedHandler_1_ContentManagement__CTargetedContent__CTargetedContentSubscription": [
        "3bcc47af-6708-5acd-81af-fa7331aa2db1",
        "3bcc47af-6708-5acd-81af-fa7331aa2db1",
    ],
    "FIAsyncOperationCompletedHandler_1_DevicesFlowInteraction__CConnection__CIDeviceConnection": [
        "701ebb34-0bd0-5456-848e-5ed7cec441ef",
        "701ebb34-0bd0-5456-848e-5ed7cec441ef",
    ],
    "FIAsyncOperationCompletedHandler_1_PhoneInternal__CExperiences__CSync__CAccount": [
        "8142b78c-3c08-53fe-a74e-506063c49063",
        "8142b78c-3c08-53fe-a74e-506063c49063",
    ],
    "FIAsyncOperationCompletedHandler_1_PhoneInternal__CExperiences__CSync__CAccountErrorInformation": [
        "826bd12f-c1bb-5730-bf72-05db739871ae",
        "826bd12f-c1bb-5730-bf72-05db739871ae",
    ],
    "FIAsyncOperationCompletedHandler_1_PhoneInternal__CExperiences__CSync__CAccountStatus": [
        "62e9e23a-de30-5736-b0e5-9e9925442328",
        "62e9e23a-de30-5736-b0e5-9e9925442328",
    ],
    "FIAsyncOperationCompletedHandler_1_PhoneInternal__CExperiences__CSync__CAccountSyncScheduleInformation": [
        "c1f995d7-c911-57c7-99e0-38239f48cfe1",
        "c1f995d7-c911-57c7-99e0-38239f48cfe1",
    ],
    "FIAsyncOperationCompletedHandler_1_PhoneInternal__CExperiences__CSync__CExchangeServerAuthType": [
        "c9ac0b4c-9912-55ed-8f96-faad2f45e449",
        "c9ac0b4c-9912-55ed-8f96-faad2f45e449",
    ],
    "FIAsyncOperationCompletedHandler_1_PhoneInternal__CExperiences__CSync__CExchangeServerDiscoveryResult": [
        "e31b75bd-8a80-535d-a873-23586e84bdc5",
        "e31b75bd-8a80-535d-a873-23586e84bdc5",
    ],
    "FIAsyncOperationCompletedHandler_1_PhoneInternal__CExperiences__CSync__CInternetMailServerDiscoveryResult": [
        "cc8015c0-c914-55a3-add6-7b1982ced2dd",
        "cc8015c0-c914-55a3-add6-7b1982ced2dd",
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CApplicationModel__CCalls__CPhoneCallStore": [
        "27b63bb3-d008-58f5-854d-ddae65a020b9",
        "27b63bb3-d008-58f5-854d-ddae65a020b9",
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CApplicationModel__CCalls__CPhoneCallVideoCapabilities": [
        "e50fc826-3ef3-5669-aa14-eb95903793a5",
        "e50fc826-3ef3-5669-aa14-eb95903793a5",
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CApplicationModel__CCalls__CPhoneLine": [
        "92ce5bfd-1417-55ee-b0b6-298ae78cb179",
        "92ce5bfd-1417-55ee-b0b6-298ae78cb179",
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CApplicationModel__CContracts__CInternal__CBackgroundContractLaunchStatus": [
        "3d67f8bf-29cf-5d83-a70e-ef257bdcfdb6",
        "3d67f8bf-29cf-5d83-a70e-ef257bdcfdb6",
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CApplicationModel__CContracts__CInternal__CIBackgroundContractOperation": [
        "e21c6105-2667-5229-a682-83e4e8ea0c3a",
        "e21c6105-2667-5229-a682-83e4e8ea0c3a",
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CApplicationModel__CContracts__CInternal__CICdpLaunchResult": [
        "bbf0f7ce-56fb-521e-95ee-e5c557c1cbe4",
        "bbf0f7ce-56fb-521e-95ee-e5c557c1cbe4",
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CApplicationModel__CInternal__CDataTransfer__CDataRequestResult": [
        "62279b47-d495-5eff-983f-62c89c22ef4d",
        "62279b47-d495-5eff-983f-62c89c22ef4d",
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CApplicationModel__CInternal__CStartupTaskInternal": [
        "1b56d989-5d74-5b59-b109-9bdf26c38726",
        "1b56d989-5d74-5b59-b109-9bdf26c38726",
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CApplicationModel__CUserActivities__CUserActivity": [
        "a337dbef-620a-5bdc-843b-b50b38d3d00c",
        "a337dbef-620a-5bdc-843b-b50b38d3d00c",
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CBackupProviderStatus": [
        "296d91bc-848c-5b4d-97b0-6a97f24fe995",
        "296d91bc-848c-5b4d-97b0-6a97f24fe995",
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CBackupScopeStatus": [
        "49128036-7a26-55df-a220-ff97a1d1399a",
        "49128036-7a26-55df-a220-ff97a1d1399a",
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CBackupTargetStatus": [
        "062eec43-84ad-5290-af7a-3191dd58d52b",
        "062eec43-84ad-5290-af7a-3191dd58d52b",
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CBackupTargetValidationResult": [
        "c88957a0-4f7e-5152-b87e-322d7078aacd",
        "c88957a0-4f7e-5152-b87e-322d7078aacd",
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CInternal__CSecurity__CAuthentication__CWeb__CGetDefaultSignInAccountResult": [
        "51aa6c40-b054-5c68-801e-03b75f43e2a1",
        "51aa6c40-b054-5c68-801e-03b75f43e2a1",
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CInternal__CSecurity__CAuthentication__CWeb__CHttpCookieRequestResult": [
        "662e4720-ef23-589c-b21d-13e9e6fbab02",
        "662e4720-ef23-589c-b21d-13e9e6fbab02",
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CInternal__CSecurity__CSmartScreen__CAppReputationResult": [
        "1b988c32-1bc7-52fa-83ba-0b97e79c878b",
        "1b988c32-1bc7-52fa-83ba-0b97e79c878b",
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CInternal__CSecurity__CSmartScreen__CDownload__CDownloadReputationResult": [
        "4356f0fa-6153-5186-92ca-2e913fd15193",
        "4356f0fa-6153-5186-92ca-2e913fd15193",
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CInternal__CSecurity__CSmartScreen__CDownload__CFileReputationResult": [
        "e406ebb7-b140-562f-bcbc-40f0ef479d38",
        "e406ebb7-b140-562f-bcbc-40f0ef479d38",
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CInternal__CSecurity__CSmartScreen__CUriReputationResult": [
        "d164f201-3f19-588a-a21e-06c60651d335",
        "d164f201-3f19-588a-a21e-06c60651d335",
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CInternal__CSettingSync__CSettingSyncResult": [
        "d8cb7b5c-277a-5e63-894f-c03abbab9dad",
        "d8cb7b5c-277a-5e63-894f-c03abbab9dad",
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CInternal__CShell__CViewManagerInterop__CAppRequestHandledResult": [
        "10e84b15-acbe-5d0c-b7e4-204bf733bbe5",
        "10e84b15-acbe-5d0c-b7e4-204bf733bbe5",
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CSystem__CInternal__CSetUserAutologonResult": [
        "ecb07d05-745b-5c70-9417-78db4d11d050",
        "ecb07d05-745b-5c70-9417-78db4d11d050",
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CSystem__CInternal__CSignInResult": [
        "0b93f10e-773f-52b6-b46d-063534f2107b",
        "0b93f10e-773f-52b6-b46d-063534f2107b",
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CSystem__CInternal__CValidateCredentialsResult": [
        "880ebaee-3e15-5419-86de-e79f492f06ed",
        "880ebaee-3e15-5419-86de-e79f492f06ed",
    ],
    "FIAsyncOperationCompletedHandler_1___FIIterable_1_Windows__CInternal__CSettingSync__CICollectionBackup": [
        "8f668cb2-0e8c-56be-ab8c-3cc898aa4fea",
        "8f668cb2-0e8c-56be-ab8c-3cc898aa4fea",
    ],
    "FIAsyncOperationCompletedHandler_1___FIIterator_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIBackupTargetItem": [
        "b8d5af86-9a98-570f-a9c1-5c3ce0a62920",
        "b8d5af86-9a98-570f-a9c1-5c3ce0a62920",
    ],
    "FIAsyncOperationCompletedHandler_1___FIMapView_2_HSTRING_Windows__CMedia__CSpeechRecognition__CVoiceCommandSet": [
        "cab62352-dce4-5633-99ba-cc8a0d3ea9b8",
        "cab62352-dce4-5633-99ba-cc8a0d3ea9b8",
    ],
    "FIAsyncOperationCompletedHandler_1___FIVectorView_1_SharingPlatform__CISessionIdentifier": [
        "c37f57e5-31b8-5293-8a44-b7a17f544768",
        "c37f57e5-31b8-5293-8a44-b7a17f544768",
    ],
    "FIAsyncOperationCompletedHandler_1___FIVectorView_1_Windows__CApplicationModel__CDataTransfer__CShareProvider": [
        "4d98e785-8d94-5d86-a6cf-2cb56576c806",
        "4d98e785-8d94-5d86-a6cf-2cb56576c806",
    ],
    "FIAsyncOperationCompletedHandler_1___FIVectorView_1_Windows__CApplicationModel__CInternal__CDataTransfer__CShareAppExtension": [
        "f7f52561-574b-5514-96a1-024813e859a5",
        "f7f52561-574b-5514-96a1-024813e859a5",
    ],
    "FIAsyncOperationCompletedHandler_1___FIVectorView_1_Windows__CApplicationModel__CInternal__CStartupTaskInternal": [
        "f771cc67-0856-5efd-ac6f-37b6e05c63e2",
        "f771cc67-0856-5efd-ac6f-37b6e05c63e2",
    ],
    "FIAsyncOperationCompletedHandler_1___FIVectorView_1_Windows__CInternal__CApplicationModel__CWindowManagement__CAppView": [
        "98d53db6-a4c4-5a86-8c0c-3d2cd51c75a8",
        "98d53db6-a4c4-5a86-8c0c-3d2cd51c75a8",
    ],
    "FIAsyncOperationCompletedHandler_1___FIVectorView_1_Windows__CInternal__CApplicationModel__CWindowManagement__CWindow": [
        "54664ab2-7b9b-517c-afad-056cf02ee31d",
        "54664ab2-7b9b-517c-afad-056cf02ee31d",
    ],
    "FIAsyncOperationCompletedHandler_1___FIVectorView_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIBackupFrequency": [
        "3303a1d7-7c3e-54cb-94e6-e166913079e2",
        "3303a1d7-7c3e-54cb-94e6-e166913079e2",
    ],
    "FIAsyncOperationCompletedHandler_1___FIVectorView_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIBackupRelatedActionItem": [
        "d6173425-f2f5-50d9-bb05-9094742bdffb",
        "d6173425-f2f5-50d9-bb05-9094742bdffb",
    ],
    "FIAsyncOperationCompletedHandler_1___FIVectorView_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIFolderBackupScopeItem": [
        "b6f8985c-2720-5ad1-b841-b34a1bd0c2e3",
        "b6f8985c-2720-5ad1-b841-b34a1bd0c2e3",
    ],
    "FIAsyncOperationCompletedHandler_1___FIVectorView_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIRetentionListItem": [
        "6bfd0150-3ddb-50fa-9bf1-277f6b3752b4",
        "6bfd0150-3ddb-50fa-9bf1-277f6b3752b4",
    ],
    "FIAsyncOperationCompletedHandler_1___FIVectorView_1_Windows__CInternal__CStateRepository__CApplicationExtension": [
        "eea18408-5dcb-5bb1-b7ff-1b084d8bb951",
        "eea18408-5dcb-5bb1-b7ff-1b084d8bb951",
    ],
    "FIAsyncOperationCompletedHandler_1___FIVectorView_1_Windows__CMedia__CSpeech__CSpeechSupportedLanguage": [
        "79d2165b-36a4-5b3e-a726-a084d7b43207",
        "79d2165b-36a4-5b3e-a726-a084d7b43207",
    ],
    "FIAsyncOperationCompletedHandler_1___FIVectorView_1_Windows__CSecurity__CCredentials__CWebAccountProvider": [
        "44c86b7a-16ab-566d-8073-49be73ab6e52",
        "44c86b7a-16ab-566d-8073-49be73ab6e52",
    ],
    "FIAsyncOperationCompletedHandler_1___FIVectorView_1_Windows__CServices__CTargetedContent__CInternal__CTargetedContentTriggerInternal": [
        "ff35ba04-0b83-5f86-aa01-90b39bdb586f",
        "ff35ba04-0b83-5f86-aa01-90b39bdb586f",
    ],
    "FIAsyncOperationCompletedHandler_1___FIVectorView_1_Windows__CStorage__CPickers__CUpdateFilesResult": [
        "563f2dab-2814-583b-988f-f5cf942362ac",
        "563f2dab-2814-583b-988f-f5cf942362ac",
    ],
    "FIAsyncOperationCompletedHandler_1___FIVector_1_IInspectable": [
        "69f426f9-8d65-5235-8e1d-80f92f18416b",
        "69f426f9-8d65-5235-8e1d-80f92f18416b",
    ],
    "FIAsyncOperationCompletedHandler_1___FIVector_1_PhoneInternal__CExperiences__CSync__CAccount": [
        "b0cda29d-cd30-5375-a6b5-6c25158617e4",
        "b0cda29d-cd30-5375-a6b5-6c25158617e4",
    ],
    "FIAsyncOperationCompletedHandler_1___FIVector_1_Windows__CApplicationModel__CAppointments__CAppointment": [
        "d13815dc-ad88-5b2f-bf25-3c97b75262d5",
        "d13815dc-ad88-5b2f-bf25-3c97b75262d5",
    ],
    "FIAsyncOperationCompletedHandler_1___FIVector_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIBackupSettingsProvider": [
        "ff8b9b09-c556-57dc-9147-735ce5b60892",
        "ff8b9b09-c556-57dc-9147-735ce5b60892",
    ],
    "FIAsyncOperationCompletedHandler_1___FIVector_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIManualCleanupOption": [
        "794fa4e8-924d-5ec1-91c8-8b98ee00a3f8",
        "794fa4e8-924d-5ec1-91c8-8b98ee00a3f8",
    ],
    "FIAsyncOperationProgressHandler_2_Windows__CApplicationModel__CInternal__CDataTransfer__CNearShare__CNearShareStatus_Windows__CApplicationModel__CInternal__CDataTransfer__CNearShare__CReceiveDataProgress": [
        "edf45241-b54f-5055-9a13-bf2758225c40",
        "edf45241-b54f-5055-9a13-bf2758225c40",
    ],
    "FIAsyncOperationProgressHandler_2_Windows__CApplicationModel__CInternal__CDataTransfer__CNearShare__CNearShareStatus_Windows__CApplicationModel__CInternal__CDataTransfer__CNearShare__CSendDataProgress": [
        "f8720281-46dd-5a3d-a453-df834d8862b7",
        "f8720281-46dd-5a3d-a453-df834d8862b7",
    ],
    "FIAsyncOperationWithProgressCompletedHandler_2_Windows__CApplicationModel__CInternal__CDataTransfer__CNearShare__CNearShareStatus_Windows__CApplicationModel__CInternal__CDataTransfer__CNearShare__CReceiveDataProgress": [
        "40118fcb-91c5-57cb-8772-f0e515d67556",
        "40118fcb-91c5-57cb-8772-f0e515d67556",
    ],
    "FIAsyncOperationWithProgressCompletedHandler_2_Windows__CApplicationModel__CInternal__CDataTransfer__CNearShare__CNearShareStatus_Windows__CApplicationModel__CInternal__CDataTransfer__CNearShare__CSendDataProgress": [
        "dd97c40e-2d56-5a00-b678-c92d9ac62ffe",
        "dd97c40e-2d56-5a00-b678-c92d9ac62ffe",
    ],
    "FIAsyncOperationWithProgress_2_Windows__CApplicationModel__CInternal__CDataTransfer__CNearShare__CNearShareStatus_Windows__CApplicationModel__CInternal__CDataTransfer__CNearShare__CReceiveDataProgress": [
        "d73cba8a-f073-5e1c-94fd-05fdf2275f60",
        "d73cba8a-f073-5e1c-94fd-05fdf2275f60",
    ],
    "FIAsyncOperationWithProgress_2_Windows__CApplicationModel__CInternal__CDataTransfer__CNearShare__CNearShareStatus_Windows__CApplicationModel__CInternal__CDataTransfer__CNearShare__CSendDataProgress": [
        "40772286-cf1a-5cbd-9d74-4137587691d5",
        "40772286-cf1a-5cbd-9d74-4137587691d5",
    ],
    "FIAsyncOperation_1_ContentManagement__CTargetedContent__CTargetedContentCollection": [
        "c3b82949-7b48-533f-9a32-5db5bbd1d54d",
        "c3b82949-7b48-533f-9a32-5db5bbd1d54d",
    ],
    "FIAsyncOperation_1_ContentManagement__CTargetedContent__CTargetedContentSubscription": [
        "056677ef-7e5c-55dd-9949-94b09922f64f",
        "056677ef-7e5c-55dd-9949-94b09922f64f",
    ],
    "FIAsyncOperation_1_DevicesFlowInteraction__CConnection__CIDeviceConnection": [
        "0f3dd3e8-ed5b-547a-a9dc-6cfa2c27f1be",
        "0f3dd3e8-ed5b-547a-a9dc-6cfa2c27f1be",
    ],
    "FIAsyncOperation_1_PhoneInternal__CExperiences__CSync__CAccount": [
        "cc0c0864-c865-5cc9-a4a3-c2b57ff24745",
        "cc0c0864-c865-5cc9-a4a3-c2b57ff24745",
    ],
    "FIAsyncOperation_1_PhoneInternal__CExperiences__CSync__CAccountErrorInformation": [
        "24dc4a95-b674-5a8b-990c-5fd09d041411",
        "24dc4a95-b674-5a8b-990c-5fd09d041411",
    ],
    "FIAsyncOperation_1_PhoneInternal__CExperiences__CSync__CAccountStatus": [
        "5fff8dc7-b064-5238-8cc8-c1f27c54b09e",
        "5fff8dc7-b064-5238-8cc8-c1f27c54b09e",
    ],
    "FIAsyncOperation_1_PhoneInternal__CExperiences__CSync__CAccountSyncScheduleInformation": [
        "b31d28aa-a479-526b-94a6-7eade39fff7e",
        "b31d28aa-a479-526b-94a6-7eade39fff7e",
    ],
    "FIAsyncOperation_1_PhoneInternal__CExperiences__CSync__CExchangeServerAuthType": [
        "89652a86-a64d-5bd4-b9f1-a73b096efaba",
        "89652a86-a64d-5bd4-b9f1-a73b096efaba",
    ],
    "FIAsyncOperation_1_PhoneInternal__CExperiences__CSync__CExchangeServerDiscoveryResult": [
        "7be2c271-d134-5f81-97f5-fcb120dafd20",
        "7be2c271-d134-5f81-97f5-fcb120dafd20",
    ],
    "FIAsyncOperation_1_PhoneInternal__CExperiences__CSync__CInternetMailServerDiscoveryResult": [
        "6f3dc58a-ca84-53f3-8864-bf421ae7f31d",
        "6f3dc58a-ca84-53f3-8864-bf421ae7f31d",
    ],
    "FIAsyncOperation_1_Windows__CApplicationModel__CCalls__CPhoneCallStore": [
        "871cad28-01e8-53b5-a14b-30316df65907",
        "871cad28-01e8-53b5-a14b-30316df65907",
    ],
    "FIAsyncOperation_1_Windows__CApplicationModel__CCalls__CPhoneCallVideoCapabilities": [
        "7b4b280a-e312-5f06-b953-7e482b67cfcf",
        "7b4b280a-e312-5f06-b953-7e482b67cfcf",
    ],
    "FIAsyncOperation_1_Windows__CApplicationModel__CCalls__CPhoneLine": [
        "d8712730-aa68-5614-a408-b2012463120b",
        "d8712730-aa68-5614-a408-b2012463120b",
    ],
    "FIAsyncOperation_1_Windows__CApplicationModel__CContracts__CInternal__CBackgroundContractLaunchStatus": [
        "82f605af-d054-500e-b5cf-a522c8c27c75",
        "82f605af-d054-500e-b5cf-a522c8c27c75",
    ],
    "FIAsyncOperation_1_Windows__CApplicationModel__CContracts__CInternal__CIBackgroundContractOperation": [
        "02acc881-167e-5108-865f-3cfe714ae29d",
        "02acc881-167e-5108-865f-3cfe714ae29d",
    ],
    "FIAsyncOperation_1_Windows__CApplicationModel__CContracts__CInternal__CICdpLaunchResult": [
        "613d85d2-77ab-5588-9a10-16a3c4af5711",
        "613d85d2-77ab-5588-9a10-16a3c4af5711",
    ],
    "FIAsyncOperation_1_Windows__CApplicationModel__CInternal__CDataTransfer__CDataRequestResult": [
        "bda02fdc-81ee-52e1-adab-96ddbc948aa3",
        "bda02fdc-81ee-52e1-adab-96ddbc948aa3",
    ],
    "FIAsyncOperation_1_Windows__CApplicationModel__CInternal__CStartupTaskInternal": [
        "4bae8816-2e25-506c-a0ad-a94eeebd4c6d",
        "4bae8816-2e25-506c-a0ad-a94eeebd4c6d",
    ],
    "FIAsyncOperation_1_Windows__CApplicationModel__CUserActivities__CUserActivity": [
        "2b45acf6-4d52-582d-810b-42675866dbf9",
        "2b45acf6-4d52-582d-810b-42675866dbf9",
    ],
    "FIAsyncOperation_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CBackupProviderStatus": [
        "b888c965-f590-592f-b489-052e0a52010a",
        "b888c965-f590-592f-b489-052e0a52010a",
    ],
    "FIAsyncOperation_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CBackupScopeStatus": [
        "c708f8e0-c4bd-51eb-b8d2-39852012fd2f",
        "c708f8e0-c4bd-51eb-b8d2-39852012fd2f",
    ],
    "FIAsyncOperation_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CBackupTargetStatus": [
        "c161b828-4f48-5917-91c6-4ac0739b5b35",
        "c161b828-4f48-5917-91c6-4ac0739b5b35",
    ],
    "FIAsyncOperation_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CBackupTargetValidationResult": [
        "7cf7e020-bac5-58fb-b9b4-afb619e8de0d",
        "7cf7e020-bac5-58fb-b9b4-afb619e8de0d",
    ],
    "FIAsyncOperation_1_Windows__CInternal__CSecurity__CAuthentication__CWeb__CGetDefaultSignInAccountResult": [
        "b5a6f1bc-1641-5f4c-b946-79084e41ee35",
        "b5a6f1bc-1641-5f4c-b946-79084e41ee35",
    ],
    "FIAsyncOperation_1_Windows__CInternal__CSecurity__CAuthentication__CWeb__CHttpCookieRequestResult": [
        "4b4aca5d-6802-54ed-9f4a-f2774a1a6218",
        "4b4aca5d-6802-54ed-9f4a-f2774a1a6218",
    ],
    "FIAsyncOperation_1_Windows__CInternal__CSecurity__CSmartScreen__CAppReputationResult": [
        "377f919e-1b1a-5ca1-9ac0-70f57dcf5f61",
        "377f919e-1b1a-5ca1-9ac0-70f57dcf5f61",
    ],
    "FIAsyncOperation_1_Windows__CInternal__CSecurity__CSmartScreen__CDownload__CDownloadReputationResult": [
        "b20ac957-d4f8-5b39-887e-95c450ab5297",
        "b20ac957-d4f8-5b39-887e-95c450ab5297",
    ],
    "FIAsyncOperation_1_Windows__CInternal__CSecurity__CSmartScreen__CDownload__CFileReputationResult": [
        "0b3418c4-edbd-5275-a27d-c814665bd20b",
        "0b3418c4-edbd-5275-a27d-c814665bd20b",
    ],
    "FIAsyncOperation_1_Windows__CInternal__CSecurity__CSmartScreen__CUriReputationResult": [
        "f84b2c99-2f3d-5877-bf78-4f40f6bd25c0",
        "f84b2c99-2f3d-5877-bf78-4f40f6bd25c0",
    ],
    "FIAsyncOperation_1_Windows__CInternal__CSettingSync__CSettingSyncResult": [
        "803fa75a-585b-5a9c-9de7-d57d5c73a0a6",
        "803fa75a-585b-5a9c-9de7-d57d5c73a0a6",
    ],
    "FIAsyncOperation_1_Windows__CInternal__CShell__CViewManagerInterop__CAppRequestHandledResult": [
        "3843809c-1f21-5d40-a51f-f6963ca8d259",
        "3843809c-1f21-5d40-a51f-f6963ca8d259",
    ],
    "FIAsyncOperation_1_Windows__CSystem__CInternal__CSetUserAutologonResult": [
        "aea2997a-3b65-5d0e-a9c2-cb5af8de0470",
        "aea2997a-3b65-5d0e-a9c2-cb5af8de0470",
    ],
    "FIAsyncOperation_1_Windows__CSystem__CInternal__CSignInResult": [
        "1a5ce963-b036-5e43-90f0-b308bf841609",
        "1a5ce963-b036-5e43-90f0-b308bf841609",
    ],
    "FIAsyncOperation_1_Windows__CSystem__CInternal__CValidateCredentialsResult": [
        "c62f19f2-57ad-50bd-ae7e-2f0c53da0870",
        "c62f19f2-57ad-50bd-ae7e-2f0c53da0870",
    ],
    "FIAsyncOperation_1___FIIterable_1_Windows__CInternal__CSettingSync__CICollectionBackup": [
        "44d3441c-ad07-508a-99ca-960a8e24b99b",
        "44d3441c-ad07-508a-99ca-960a8e24b99b",
    ],
    "FIAsyncOperation_1___FIIterator_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIBackupTargetItem": [
        "5461d6c8-8df5-52bc-95fa-0281056a4a5a",
        "5461d6c8-8df5-52bc-95fa-0281056a4a5a",
    ],
    "FIAsyncOperation_1___FIMapView_2_HSTRING_Windows__CMedia__CSpeechRecognition__CVoiceCommandSet": [
        "b1e357b5-64fb-532b-803c-08799b03c4ba",
        "b1e357b5-64fb-532b-803c-08799b03c4ba",
    ],
    "FIAsyncOperation_1___FIVectorView_1_SharingPlatform__CISessionIdentifier": [
        "6292356a-5d97-5dff-825a-e0068f0b7307",
        "6292356a-5d97-5dff-825a-e0068f0b7307",
    ],
    "FIAsyncOperation_1___FIVectorView_1_Windows__CApplicationModel__CDataTransfer__CShareProvider": [
        "492446f5-66b3-58c5-964f-702135b49f62",
        "492446f5-66b3-58c5-964f-702135b49f62",
    ],
    "FIAsyncOperation_1___FIVectorView_1_Windows__CApplicationModel__CInternal__CDataTransfer__CShareAppExtension": [
        "623557a0-ae34-5139-9abf-8107438b034a",
        "623557a0-ae34-5139-9abf-8107438b034a",
    ],
    "FIAsyncOperation_1___FIVectorView_1_Windows__CApplicationModel__CInternal__CStartupTaskInternal": [
        "943a94cb-00d0-5bcd-83be-47502a6f2ccd",
        "943a94cb-00d0-5bcd-83be-47502a6f2ccd",
    ],
    "FIAsyncOperation_1___FIVectorView_1_Windows__CInternal__CApplicationModel__CWindowManagement__CAppView": [
        "c740bbb0-8003-54d9-8e09-4c66a8df3a11",
        "c740bbb0-8003-54d9-8e09-4c66a8df3a11",
    ],
    "FIAsyncOperation_1___FIVectorView_1_Windows__CInternal__CApplicationModel__CWindowManagement__CWindow": [
        "b0c625a5-c57d-564a-a4b7-e438c7fd7e15",
        "b0c625a5-c57d-564a-a4b7-e438c7fd7e15",
    ],
    "FIAsyncOperation_1___FIVectorView_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIBackupFrequency": [
        "34517b44-a23b-5580-83a7-0fc8c6d8f883",
        "34517b44-a23b-5580-83a7-0fc8c6d8f883",
    ],
    "FIAsyncOperation_1___FIVectorView_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIBackupRelatedActionItem": [
        "7a5de9a2-7141-5c56-b35b-bc15eb54c81b",
        "7a5de9a2-7141-5c56-b35b-bc15eb54c81b",
    ],
    "FIAsyncOperation_1___FIVectorView_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIFolderBackupScopeItem": [
        "924c82cf-3846-53a4-81c0-326114d00d87",
        "924c82cf-3846-53a4-81c0-326114d00d87",
    ],
    "FIAsyncOperation_1___FIVectorView_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIRetentionListItem": [
        "41a7ec32-0b42-584a-92a3-d12143e18aae",
        "41a7ec32-0b42-584a-92a3-d12143e18aae",
    ],
    "FIAsyncOperation_1___FIVectorView_1_Windows__CInternal__CStateRepository__CApplicationExtension": [
        "7a2914a8-2c2a-5531-a629-00d784d5e608",
        "7a2914a8-2c2a-5531-a629-00d784d5e608",
    ],
    "FIAsyncOperation_1___FIVectorView_1_Windows__CMedia__CSpeech__CSpeechSupportedLanguage": [
        "fca31d1e-ac32-5207-85c7-38edde1170fd",
        "fca31d1e-ac32-5207-85c7-38edde1170fd",
    ],
    "FIAsyncOperation_1___FIVectorView_1_Windows__CSecurity__CCredentials__CWebAccountProvider": [
        "3f9bd8a0-394b-54c1-baf8-5f36abe37a65",
        "3f9bd8a0-394b-54c1-baf8-5f36abe37a65",
    ],
    "FIAsyncOperation_1___FIVectorView_1_Windows__CServices__CTargetedContent__CInternal__CTargetedContentTriggerInternal": [
        "6c200718-e9a6-597e-84e2-fb5c63be8174",
        "6c200718-e9a6-597e-84e2-fb5c63be8174",
    ],
    "FIAsyncOperation_1___FIVectorView_1_Windows__CStorage__CPickers__CUpdateFilesResult": [
        "e1d250f2-a677-5437-a35d-3b3d910c29f8",
        "e1d250f2-a677-5437-a35d-3b3d910c29f8",
    ],
    "FIAsyncOperation_1___FIVector_1_IInspectable": [
        "9d1c89a9-c902-5e84-a499-fa5dffee6333",
        "9d1c89a9-c902-5e84-a499-fa5dffee6333",
    ],
    "FIAsyncOperation_1___FIVector_1_PhoneInternal__CExperiences__CSync__CAccount": [
        "9b8074aa-1ffa-5888-9d86-d57df5746904",
        "9b8074aa-1ffa-5888-9d86-d57df5746904",
    ],
    "FIAsyncOperation_1___FIVector_1_Windows__CApplicationModel__CAppointments__CAppointment": [
        "6d08b403-4fcf-5c76-82ab-5b79f0a6f5f2",
        "6d08b403-4fcf-5c76-82ab-5b79f0a6f5f2",
    ],
    "FIAsyncOperation_1___FIVector_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIBackupSettingsProvider": [
        "b4043f94-d18d-5ab6-9954-b4f172fbe7ff",
        "b4043f94-d18d-5ab6-9954-b4f172fbe7ff",
    ],
    "FIAsyncOperation_1___FIVector_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIManualCleanupOption": [
        "32f4aef0-896a-5312-8cea-2b90a4b79918",
        "32f4aef0-896a-5312-8cea-2b90a4b79918",
    ],
    "DICounterItem": ["c08c4ff2-0e2e-11cf-942c-008029004347", "c08c4ff2-0e2e-11cf-942c-008029004347"],
    "DIFsrmClassificationEvents": ["26942db0-dabf-41d8-bbdd-b129a9f70424", "26942db0-dabf-41d8-bbdd-b129a9f70424"],
    "DILogFileItem": ["8d093ffc-f777-4917-82d1-833fbc54c58f", "8d093ffc-f777-4917-82d1-833fbc54c58f"],
    "DISyncShareEvents": ["7272b32b-b31c-43c6-8e6d-dd62c94608c3"],
    "DISystemMonitor": ["13d73d81-c32e-11cf-9398-00aa00a3ddea", "13d73d81-c32e-11cf-9398-00aa00a3ddea"],
    "DISystemMonitorEvents": ["84979930-4ab3-11cf-943a-008029004347", "84979930-4ab3-11cf-943a-008029004347"],
    "DISystemMonitorInternal": ["194eb242-c32c-11cf-9398-00aa00a3ddea", "194eb242-c32c-11cf-9398-00aa00a3ddea"],
    "DShellNameSpaceEvents": ["55136806-b2de-11d1-b9f2-00a0c98bc547", "55136806-b2de-11d1-b9f2-00a0c98bc547"],
    "DataSourceObject": ["0ae9a4e4-18d4-11d1-b3b3-00aa00c1a924", "0ae9a4e4-18d4-11d1-b3b3-00aa00c1a924"],
    "DispApplicationCache": ["305900e4-98b5-11cf-bb82-00aa00bdce0b", "305900e4-98b5-11cf-bb82-00aa00bdce0b"],
    "DispCEventObj": ["3050f558-98b5-11cf-bb82-00aa00bdce0b", "3050f558-98b5-11cf-bb82-00aa00bdce0b"],
    "DispCPlugins": ["3050f54a-98b5-11cf-bb82-00aa00bdce0b", "3050f54a-98b5-11cf-bb82-00aa00bdce0b"],
    "DispCPrintManagerTemplatePrinter": [
        "305900e9-98b5-11cf-bb82-00aa00bdce0b",
        "305900e9-98b5-11cf-bb82-00aa00bdce0b",
    ],
    "DispCanvasGradient": ["3059008c-98b5-11cf-bb82-00aa00bdce0b", "3059008c-98b5-11cf-bb82-00aa00bdce0b"],
    "DispCanvasImageData": ["3059008f-98b5-11cf-bb82-00aa00bdce0b", "3059008f-98b5-11cf-bb82-00aa00bdce0b"],
    "DispCanvasPattern": ["3059008d-98b5-11cf-bb82-00aa00bdce0b", "3059008d-98b5-11cf-bb82-00aa00bdce0b"],
    "DispCanvasRenderingContext2D": ["30590082-98b5-11cf-bb82-00aa00bdce0b", "30590082-98b5-11cf-bb82-00aa00bdce0b"],
    "DispCanvasTextMetrics": ["3059008e-98b5-11cf-bb82-00aa00bdce0b", "3059008e-98b5-11cf-bb82-00aa00bdce0b"],
    "DispDOMBeforeUnloadEvent": ["305900a8-98b5-11cf-bb82-00aa00bdce0b", "305900a8-98b5-11cf-bb82-00aa00bdce0b"],
    "DispDOMChildrenCollection": ["3050f577-98b5-11cf-bb82-00aa00bdce0b", "3050f577-98b5-11cf-bb82-00aa00bdce0b"],
    "DispDOMCloseEvent": ["305900dc-98b5-11cf-bb82-00aa00bdce0b", "305900dc-98b5-11cf-bb82-00aa00bdce0b"],
    "DispDOMCompositionEvent": ["30590078-98b5-11cf-bb82-00aa00bdce0b", "30590078-98b5-11cf-bb82-00aa00bdce0b"],
    "DispDOMCustomEvent": ["3059007c-98b5-11cf-bb82-00aa00bdce0b", "3059007c-98b5-11cf-bb82-00aa00bdce0b"],
    "DispDOMDocumentType": ["30590098-98b5-11cf-bb82-00aa00bdce0b", "30590098-98b5-11cf-bb82-00aa00bdce0b"],
    "DispDOMDragEvent": ["305900a7-98b5-11cf-bb82-00aa00bdce0b", "305900a7-98b5-11cf-bb82-00aa00bdce0b"],
    "DispDOMEvent": ["3050f5a2-98b5-11cf-bb82-00aa00bdce0b", "3050f5a2-98b5-11cf-bb82-00aa00bdce0b"],
    "DispDOMException": ["30590094-98b5-11cf-bb82-00aa00bdce0b", "30590094-98b5-11cf-bb82-00aa00bdce0b"],
    "DispDOMFocusEvent": ["30590071-98b5-11cf-bb82-00aa00bdce0b", "30590071-98b5-11cf-bb82-00aa00bdce0b"],
    "DispDOMKeyboardEvent": ["30590077-98b5-11cf-bb82-00aa00bdce0b", "30590077-98b5-11cf-bb82-00aa00bdce0b"],
    "DispDOMMSAnimationEvent": ["305900bc-98b5-11cf-bb82-00aa00bdce0b", "305900bc-98b5-11cf-bb82-00aa00bdce0b"],
    "DispDOMMSManipulationEvent": ["305900e1-98b5-11cf-bb82-00aa00bdce0b", "305900e1-98b5-11cf-bb82-00aa00bdce0b"],
    "DispDOMMSTransitionEvent": ["305900bb-98b5-11cf-bb82-00aa00bdce0b", "305900bb-98b5-11cf-bb82-00aa00bdce0b"],
    "DispDOMMessageEvent": ["30590092-98b5-11cf-bb82-00aa00bdce0b", "30590092-98b5-11cf-bb82-00aa00bdce0b"],
    "DispDOMMouseEvent": ["30590073-98b5-11cf-bb82-00aa00bdce0b", "30590073-98b5-11cf-bb82-00aa00bdce0b"],
    "DispDOMMouseWheelEvent": ["30590074-98b5-11cf-bb82-00aa00bdce0b", "30590074-98b5-11cf-bb82-00aa00bdce0b"],
    "DispDOMMutationEvent": ["30590079-98b5-11cf-bb82-00aa00bdce0b", "30590079-98b5-11cf-bb82-00aa00bdce0b"],
    "DispDOMParser": ["305900ae-98b5-11cf-bb82-00aa00bdce0b", "305900ae-98b5-11cf-bb82-00aa00bdce0b"],
    "DispDOMProcessingInstruction": ["3059009b-98b5-11cf-bb82-00aa00bdce0b", "3059009b-98b5-11cf-bb82-00aa00bdce0b"],
    "DispDOMProgressEvent": ["30590091-98b5-11cf-bb82-00aa00bdce0b", "30590091-98b5-11cf-bb82-00aa00bdce0b"],
    "DispDOMSiteModeEvent": ["305900a9-98b5-11cf-bb82-00aa00bdce0b", "305900a9-98b5-11cf-bb82-00aa00bdce0b"],
    "DispDOMStorageEvent": ["30590093-98b5-11cf-bb82-00aa00bdce0b", "30590093-98b5-11cf-bb82-00aa00bdce0b"],
    "DispDOMTextEvent": ["30590076-98b5-11cf-bb82-00aa00bdce0b", "30590076-98b5-11cf-bb82-00aa00bdce0b"],
    "DispDOMUIEvent": ["30590072-98b5-11cf-bb82-00aa00bdce0b", "30590072-98b5-11cf-bb82-00aa00bdce0b"],
    "DispDOMWheelEvent": ["30590075-98b5-11cf-bb82-00aa00bdce0b", "30590075-98b5-11cf-bb82-00aa00bdce0b"],
    "DispEventException": ["30590099-98b5-11cf-bb82-00aa00bdce0b", "30590099-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTCAttachBehavior": ["3050f583-98b5-11cf-bb82-00aa00bdce0b", "3050f583-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTCDefaultDispatch": ["3050f573-98b5-11cf-bb82-00aa00bdce0b", "3050f573-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTCDescBehavior": ["3050f57e-98b5-11cf-bb82-00aa00bdce0b", "3050f57e-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTCEventBehavior": ["3050f574-98b5-11cf-bb82-00aa00bdce0b", "3050f574-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTCMethodBehavior": ["3050f587-98b5-11cf-bb82-00aa00bdce0b", "3050f587-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTCPropertyBehavior": ["3050f57f-98b5-11cf-bb82-00aa00bdce0b", "3050f57f-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLAnchorElement": ["3050f502-98b5-11cf-bb82-00aa00bdce0b", "3050f502-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLAppBehavior": ["3050f57c-98b5-11cf-bb82-00aa00bdce0b", "3050f57c-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLAreaElement": ["3050f503-98b5-11cf-bb82-00aa00bdce0b", "3050f503-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLAreasCollection": ["3050f56a-98b5-11cf-bb82-00aa00bdce0b", "3050f56a-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLAttributeCollection": ["3050f56c-98b5-11cf-bb82-00aa00bdce0b", "3050f56c-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLAudioElement": ["3059008a-98b5-11cf-bb82-00aa00bdce0b", "3059008a-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLBGsound": ["3050f53c-98b5-11cf-bb82-00aa00bdce0b", "3050f53c-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLBRElement": ["3050f53a-98b5-11cf-bb82-00aa00bdce0b", "3050f53a-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLBaseElement": ["3050f518-98b5-11cf-bb82-00aa00bdce0b", "3050f518-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLBaseFontElement": ["3050f504-98b5-11cf-bb82-00aa00bdce0b", "3050f504-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLBlockElement": ["3050f506-98b5-11cf-bb82-00aa00bdce0b", "3050f506-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLBody": ["3050f507-98b5-11cf-bb82-00aa00bdce0b", "3050f507-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLButtonElement": ["3050f51f-98b5-11cf-bb82-00aa00bdce0b", "3050f51f-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLCSSImportRule": ["3059007e-98b5-11cf-bb82-00aa00bdce0b", "3059007e-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLCSSMediaList": ["30590097-98b5-11cf-bb82-00aa00bdce0b", "30590097-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLCSSMediaRule": ["3059007f-98b5-11cf-bb82-00aa00bdce0b", "3059007f-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLCSSNamespaceRule": ["30590080-98b5-11cf-bb82-00aa00bdce0b", "30590080-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLCSSRule": ["3059007d-98b5-11cf-bb82-00aa00bdce0b", "3059007d-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLCSSStyleDeclaration": ["3059009a-98b5-11cf-bb82-00aa00bdce0b", "3059009a-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLCanvasElement": ["3059007b-98b5-11cf-bb82-00aa00bdce0b", "3059007b-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLCommentElement": ["3050f50a-98b5-11cf-bb82-00aa00bdce0b", "3050f50a-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLCurrentStyle": ["3050f557-98b5-11cf-bb82-00aa00bdce0b", "3050f557-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLDDElement": ["3050f50b-98b5-11cf-bb82-00aa00bdce0b", "3050f50b-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLDListElement": ["3050f53b-98b5-11cf-bb82-00aa00bdce0b", "3050f53b-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLDOMAttribute": ["3050f564-98b5-11cf-bb82-00aa00bdce0b", "3050f564-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLDOMImplementation": ["3050f58f-98b5-11cf-bb82-00aa00bdce0b", "3050f58f-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLDOMRange": ["3050f5a3-98b5-11cf-bb82-00aa00bdce0b", "3050f5a3-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLDOMTextNode": ["3050f565-98b5-11cf-bb82-00aa00bdce0b", "3050f565-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLDTElement": ["3050f50d-98b5-11cf-bb82-00aa00bdce0b", "3050f50d-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLDefaults": ["3050f58c-98b5-11cf-bb82-00aa00bdce0b", "3050f58c-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLDivElement": ["3050f50c-98b5-11cf-bb82-00aa00bdce0b", "3050f50c-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLDivPosition": ["3050f50f-98b5-11cf-bb82-00aa00bdce0b", "3050f50f-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLDocument": ["3050f55f-98b5-11cf-bb82-00aa00bdce0b", "3050f55f-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLDocumentCompatibleInfo": ["3050f53e-98b5-11cf-bb82-00aa00bdce0b", "3050f53e-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLDocumentCompatibleInfoCollection": [
        "3050f53f-98b5-11cf-bb82-00aa00bdce0b",
        "3050f53f-98b5-11cf-bb82-00aa00bdce0b",
    ],
    "DispHTMLElementCollection": ["3050f56b-98b5-11cf-bb82-00aa00bdce0b", "3050f56b-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLEmbed": ["3050f52e-98b5-11cf-bb82-00aa00bdce0b", "3050f52e-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLFieldSetElement": ["3050f545-98b5-11cf-bb82-00aa00bdce0b", "3050f545-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLFontElement": ["3050f512-98b5-11cf-bb82-00aa00bdce0b", "3050f512-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLFormElement": ["3050f510-98b5-11cf-bb82-00aa00bdce0b", "3050f510-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLFrameBase": ["3050f541-98b5-11cf-bb82-00aa00bdce0b", "3050f541-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLFrameElement": ["3050f513-98b5-11cf-bb82-00aa00bdce0b", "3050f513-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLFrameSetSite": ["3050f514-98b5-11cf-bb82-00aa00bdce0b", "3050f514-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLGenericElement": ["3050f563-98b5-11cf-bb82-00aa00bdce0b", "3050f563-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLHRElement": ["3050f53d-98b5-11cf-bb82-00aa00bdce0b", "3050f53d-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLHeadElement": ["3050f561-98b5-11cf-bb82-00aa00bdce0b", "3050f561-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLHeaderElement": ["3050f515-98b5-11cf-bb82-00aa00bdce0b", "3050f515-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLHistory": ["3050f549-98b5-11cf-bb82-00aa00bdce0b", "3050f549-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLHtmlElement": ["3050f560-98b5-11cf-bb82-00aa00bdce0b", "3050f560-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLIFrame": ["3050f51b-98b5-11cf-bb82-00aa00bdce0b", "3050f51b-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLImg": ["3050f51c-98b5-11cf-bb82-00aa00bdce0b", "3050f51c-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLInputElement": ["3050f57d-98b5-11cf-bb82-00aa00bdce0b", "3050f57d-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLIsIndexElement": ["3050f519-98b5-11cf-bb82-00aa00bdce0b", "3050f519-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLLIElement": ["3050f523-98b5-11cf-bb82-00aa00bdce0b", "3050f523-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLLabelElement": ["3050f522-98b5-11cf-bb82-00aa00bdce0b", "3050f522-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLLegendElement": ["3050f546-98b5-11cf-bb82-00aa00bdce0b", "3050f546-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLLinkElement": ["3050f524-98b5-11cf-bb82-00aa00bdce0b", "3050f524-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLListElement": ["3050f525-98b5-11cf-bb82-00aa00bdce0b", "3050f525-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLLocation": ["3050f54e-98b5-11cf-bb82-00aa00bdce0b", "3050f54e-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLMSCSSKeyframeRule": ["305900de-98b5-11cf-bb82-00aa00bdce0b", "305900de-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLMSCSSKeyframesRule": ["305900df-98b5-11cf-bb82-00aa00bdce0b", "305900df-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLMapElement": ["3050f526-98b5-11cf-bb82-00aa00bdce0b", "3050f526-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLMarqueeElement": ["3050f527-98b5-11cf-bb82-00aa00bdce0b", "3050f527-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLMediaElement": ["30590088-98b5-11cf-bb82-00aa00bdce0b", "30590088-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLMediaError": ["30590086-98b5-11cf-bb82-00aa00bdce0b", "30590086-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLMetaElement": ["3050f517-98b5-11cf-bb82-00aa00bdce0b", "3050f517-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLNamespace": ["3050f54f-98b5-11cf-bb82-00aa00bdce0b", "3050f54f-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLNamespaceCollection": ["3050f550-98b5-11cf-bb82-00aa00bdce0b", "3050f550-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLNavigator": ["3050f54c-98b5-11cf-bb82-00aa00bdce0b", "3050f54c-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLNextIdElement": ["3050f51a-98b5-11cf-bb82-00aa00bdce0b", "3050f51a-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLNoShowElement": ["3050f528-98b5-11cf-bb82-00aa00bdce0b", "3050f528-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLOListElement": ["3050f52a-98b5-11cf-bb82-00aa00bdce0b", "3050f52a-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLObjectElement": ["3050f529-98b5-11cf-bb82-00aa00bdce0b", "3050f529-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLOptionElement": ["3050f52b-98b5-11cf-bb82-00aa00bdce0b", "3050f52b-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLParaElement": ["3050f52c-98b5-11cf-bb82-00aa00bdce0b", "3050f52c-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLParamElement": ["3050f590-98b5-11cf-bb82-00aa00bdce0b", "3050f590-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLPerformance": ["3059009f-98b5-11cf-bb82-00aa00bdce0b", "3059009f-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLPerformanceNavigation": ["305900a0-98b5-11cf-bb82-00aa00bdce0b", "305900a0-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLPerformanceTiming": ["305900a1-98b5-11cf-bb82-00aa00bdce0b", "305900a1-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLPhraseElement": ["3050f52d-98b5-11cf-bb82-00aa00bdce0b", "3050f52d-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLPopup": ["3050f589-98b5-11cf-bb82-00aa00bdce0b", "3050f589-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLProgressElement": ["305900af-98b5-11cf-bb82-00aa00bdce0b", "305900af-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLRenderStyle": ["3050f58b-98b5-11cf-bb82-00aa00bdce0b", "3050f58b-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLRichtextElement": ["3050f54d-98b5-11cf-bb82-00aa00bdce0b", "3050f54d-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLRuleStyle": ["3050f55c-98b5-11cf-bb82-00aa00bdce0b", "3050f55c-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLScreen": ["3050f591-98b5-11cf-bb82-00aa00bdce0b", "3050f591-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLScriptElement": ["3050f530-98b5-11cf-bb82-00aa00bdce0b", "3050f530-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLSelectElement": ["3050f531-98b5-11cf-bb82-00aa00bdce0b", "3050f531-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLSemanticElement": ["305900ba-98b5-11cf-bb82-00aa00bdce0b", "305900ba-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLSourceElement": ["30590089-98b5-11cf-bb82-00aa00bdce0b", "30590089-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLSpanElement": ["3050f548-98b5-11cf-bb82-00aa00bdce0b", "3050f548-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLSpanFlow": ["3050f544-98b5-11cf-bb82-00aa00bdce0b", "3050f544-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLStorage": ["3050f59d-98b5-11cf-bb82-00aa00bdce0b", "3050f59d-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLStyle": ["3050f55a-98b5-11cf-bb82-00aa00bdce0b", "3050f55a-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLStyleElement": ["3050f511-98b5-11cf-bb82-00aa00bdce0b", "3050f511-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLStyleFontFace": ["30590081-98b5-11cf-bb82-00aa00bdce0b", "30590081-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLStyleMedia": ["3059009e-98b5-11cf-bb82-00aa00bdce0b", "3059009e-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLStyleSheet": ["3050f58d-98b5-11cf-bb82-00aa00bdce0b", "3050f58d-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLStyleSheetPage": ["3050f540-98b5-11cf-bb82-00aa00bdce0b", "3050f540-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLStyleSheetPagesCollection": [
        "3050f543-98b5-11cf-bb82-00aa00bdce0b",
        "3050f543-98b5-11cf-bb82-00aa00bdce0b",
    ],
    "DispHTMLStyleSheetRule": ["3050f50e-98b5-11cf-bb82-00aa00bdce0b", "3050f50e-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLStyleSheetRulesAppliedCollection": [
        "3050f5a6-98b5-11cf-bb82-00aa00bdce0b",
        "3050f5a6-98b5-11cf-bb82-00aa00bdce0b",
    ],
    "DispHTMLStyleSheetRulesCollection": [
        "3050f52f-98b5-11cf-bb82-00aa00bdce0b",
        "3050f52f-98b5-11cf-bb82-00aa00bdce0b",
    ],
    "DispHTMLStyleSheetsCollection": ["3050f547-98b5-11cf-bb82-00aa00bdce0b", "3050f547-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLTable": ["3050f532-98b5-11cf-bb82-00aa00bdce0b", "3050f532-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLTableCaption": ["3050f508-98b5-11cf-bb82-00aa00bdce0b", "3050f508-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLTableCell": ["3050f536-98b5-11cf-bb82-00aa00bdce0b", "3050f536-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLTableCol": ["3050f533-98b5-11cf-bb82-00aa00bdce0b", "3050f533-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLTableRow": ["3050f535-98b5-11cf-bb82-00aa00bdce0b", "3050f535-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLTableSection": ["3050f534-98b5-11cf-bb82-00aa00bdce0b", "3050f534-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLTextAreaElement": ["3050f521-98b5-11cf-bb82-00aa00bdce0b", "3050f521-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLTextElement": ["3050f537-98b5-11cf-bb82-00aa00bdce0b", "3050f537-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLTimeRanges": ["30590087-98b5-11cf-bb82-00aa00bdce0b", "30590087-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLTitleElement": ["3050f516-98b5-11cf-bb82-00aa00bdce0b", "3050f516-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLUListElement": ["3050f538-98b5-11cf-bb82-00aa00bdce0b", "3050f538-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLUnknownElement": ["3050f539-98b5-11cf-bb82-00aa00bdce0b", "3050f539-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLUrnCollection": ["3050f551-98b5-11cf-bb82-00aa00bdce0b", "3050f551-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLVideoElement": ["3059008b-98b5-11cf-bb82-00aa00bdce0b", "3059008b-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLW3CComputedStyle": ["30590070-98b5-11cf-bb82-00aa00bdce0b", "30590070-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLWindow2": ["3050f55d-98b5-11cf-bb82-00aa00bdce0b", "3050f55d-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLWindowProxy": ["3050f55e-98b5-11cf-bb82-00aa00bdce0b", "3050f55e-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLWndOptionElement": ["3050f598-98b5-11cf-bb82-00aa00bdce0b", "3050f598-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLWndSelectElement": ["3050f597-98b5-11cf-bb82-00aa00bdce0b", "3050f597-98b5-11cf-bb82-00aa00bdce0b"],
    "DispHTMLXMLHttpRequest": ["3050f596-98b5-11cf-bb82-00aa00bdce0b", "3050f596-98b5-11cf-bb82-00aa00bdce0b"],
    "DispIHTMLInputButtonElement": ["3050f51e-98b5-11cf-bb82-00aa00bdce0b", "3050f51e-98b5-11cf-bb82-00aa00bdce0b"],
    "DispIHTMLInputFileElement": ["3050f542-98b5-11cf-bb82-00aa00bdce0b", "3050f542-98b5-11cf-bb82-00aa00bdce0b"],
    "DispIHTMLInputImage": ["3050f51d-98b5-11cf-bb82-00aa00bdce0b", "3050f51d-98b5-11cf-bb82-00aa00bdce0b"],
    "DispIHTMLInputTextElement": ["3050f520-98b5-11cf-bb82-00aa00bdce0b", "3050f520-98b5-11cf-bb82-00aa00bdce0b"],
    "DispIHTMLOptionButtonElement": ["3050f509-98b5-11cf-bb82-00aa00bdce0b", "3050f509-98b5-11cf-bb82-00aa00bdce0b"],
    "DispNodeIterator": ["3059009c-98b5-11cf-bb82-00aa00bdce0b", "3059009c-98b5-11cf-bb82-00aa00bdce0b"],
    "DispRangeException": ["30590095-98b5-11cf-bb82-00aa00bdce0b", "30590095-98b5-11cf-bb82-00aa00bdce0b"],
    "DispRulesApplied": ["3050f5a5-98b5-11cf-bb82-00aa00bdce0b", "3050f5a5-98b5-11cf-bb82-00aa00bdce0b"],
    "DispRulesAppliedCollection": ["3050f5a4-98b5-11cf-bb82-00aa00bdce0b", "3050f5a4-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGAElement": ["30590033-98b5-11cf-bb82-00aa00bdce0b", "30590033-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGCircleElement": ["3059000a-98b5-11cf-bb82-00aa00bdce0b", "3059000a-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGClipPathElement": ["3059003b-98b5-11cf-bb82-00aa00bdce0b", "3059003b-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGDefsElement": ["30590003-98b5-11cf-bb82-00aa00bdce0b", "30590003-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGDescElement": ["30590005-98b5-11cf-bb82-00aa00bdce0b", "30590005-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGElement": ["30590000-98b5-11cf-bb82-00aa00bdce0b", "30590000-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGElementInstance": ["30590007-98b5-11cf-bb82-00aa00bdce0b", "30590007-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGElementInstanceList": ["30590008-98b5-11cf-bb82-00aa00bdce0b", "30590008-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGEllipseElement": ["3059000b-98b5-11cf-bb82-00aa00bdce0b", "3059000b-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGException": ["30590096-98b5-11cf-bb82-00aa00bdce0b", "30590096-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGGElement": ["30590002-98b5-11cf-bb82-00aa00bdce0b", "30590002-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGGradientElement": ["3059002e-98b5-11cf-bb82-00aa00bdce0b", "3059002e-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGImageElement": ["30590027-98b5-11cf-bb82-00aa00bdce0b", "30590027-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGLineElement": ["3059000c-98b5-11cf-bb82-00aa00bdce0b", "3059000c-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGLinearGradientElement": ["3059002a-98b5-11cf-bb82-00aa00bdce0b", "3059002a-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGMarkerElement": ["30590036-98b5-11cf-bb82-00aa00bdce0b", "30590036-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGMaskElement": ["3059003c-98b5-11cf-bb82-00aa00bdce0b", "3059003c-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGMetadataElement": ["3059002f-98b5-11cf-bb82-00aa00bdce0b", "3059002f-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGPathElement": ["30590011-98b5-11cf-bb82-00aa00bdce0b", "30590011-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGPathSegArcAbs": ["30590013-98b5-11cf-bb82-00aa00bdce0b", "30590013-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGPathSegArcRel": ["30590014-98b5-11cf-bb82-00aa00bdce0b", "30590014-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGPathSegClosePath": ["30590015-98b5-11cf-bb82-00aa00bdce0b", "30590015-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGPathSegCurvetoCubicAbs": ["30590016-98b5-11cf-bb82-00aa00bdce0b", "30590016-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGPathSegCurvetoCubicRel": ["30590017-98b5-11cf-bb82-00aa00bdce0b", "30590017-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGPathSegCurvetoCubicSmoothAbs": [
        "30590018-98b5-11cf-bb82-00aa00bdce0b",
        "30590018-98b5-11cf-bb82-00aa00bdce0b",
    ],
    "DispSVGPathSegCurvetoCubicSmoothRel": [
        "30590019-98b5-11cf-bb82-00aa00bdce0b",
        "30590019-98b5-11cf-bb82-00aa00bdce0b",
    ],
    "DispSVGPathSegCurvetoQuadraticAbs": [
        "3059001a-98b5-11cf-bb82-00aa00bdce0b",
        "3059001a-98b5-11cf-bb82-00aa00bdce0b",
    ],
    "DispSVGPathSegCurvetoQuadraticRel": [
        "3059001b-98b5-11cf-bb82-00aa00bdce0b",
        "3059001b-98b5-11cf-bb82-00aa00bdce0b",
    ],
    "DispSVGPathSegCurvetoQuadraticSmoothAbs": [
        "3059001c-98b5-11cf-bb82-00aa00bdce0b",
        "3059001c-98b5-11cf-bb82-00aa00bdce0b",
    ],
    "DispSVGPathSegCurvetoQuadraticSmoothRel": [
        "3059001d-98b5-11cf-bb82-00aa00bdce0b",
        "3059001d-98b5-11cf-bb82-00aa00bdce0b",
    ],
    "DispSVGPathSegLinetoAbs": ["3059001e-98b5-11cf-bb82-00aa00bdce0b", "3059001e-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGPathSegLinetoHorizontalAbs": [
        "3059001f-98b5-11cf-bb82-00aa00bdce0b",
        "3059001f-98b5-11cf-bb82-00aa00bdce0b",
    ],
    "DispSVGPathSegLinetoHorizontalRel": [
        "30590020-98b5-11cf-bb82-00aa00bdce0b",
        "30590020-98b5-11cf-bb82-00aa00bdce0b",
    ],
    "DispSVGPathSegLinetoRel": ["30590021-98b5-11cf-bb82-00aa00bdce0b", "30590021-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGPathSegLinetoVerticalAbs": ["30590022-98b5-11cf-bb82-00aa00bdce0b", "30590022-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGPathSegLinetoVerticalRel": ["30590023-98b5-11cf-bb82-00aa00bdce0b", "30590023-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGPathSegMovetoAbs": ["30590024-98b5-11cf-bb82-00aa00bdce0b", "30590024-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGPathSegMovetoRel": ["30590025-98b5-11cf-bb82-00aa00bdce0b", "30590025-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGPatternElement": ["3059002c-98b5-11cf-bb82-00aa00bdce0b", "3059002c-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGPolygonElement": ["3059000d-98b5-11cf-bb82-00aa00bdce0b", "3059000d-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGPolylineElement": ["3059000e-98b5-11cf-bb82-00aa00bdce0b", "3059000e-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGRadialGradientElement": ["3059002b-98b5-11cf-bb82-00aa00bdce0b", "3059002b-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGRectElement": ["30590009-98b5-11cf-bb82-00aa00bdce0b", "30590009-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGSVGElement": ["30590001-98b5-11cf-bb82-00aa00bdce0b", "30590001-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGScriptElement": ["30590039-98b5-11cf-bb82-00aa00bdce0b", "30590039-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGStopElement": ["3059002d-98b5-11cf-bb82-00aa00bdce0b", "3059002d-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGStyleElement": ["30590029-98b5-11cf-bb82-00aa00bdce0b", "30590029-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGSwitchElement": ["30590030-98b5-11cf-bb82-00aa00bdce0b", "30590030-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGSymbolElement": ["30590004-98b5-11cf-bb82-00aa00bdce0b", "30590004-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGTSpanElement": ["3059003a-98b5-11cf-bb82-00aa00bdce0b", "3059003a-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGTextContentElement": ["30590035-98b5-11cf-bb82-00aa00bdce0b", "30590035-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGTextElement": ["30590037-98b5-11cf-bb82-00aa00bdce0b", "30590037-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGTextPathElement": ["3059003d-98b5-11cf-bb82-00aa00bdce0b", "3059003d-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGTextPositioningElement": ["30590038-98b5-11cf-bb82-00aa00bdce0b", "30590038-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGTitleElement": ["30590006-98b5-11cf-bb82-00aa00bdce0b", "30590006-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGUseElement": ["30590010-98b5-11cf-bb82-00aa00bdce0b", "30590010-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGViewElement": ["30590034-98b5-11cf-bb82-00aa00bdce0b", "30590034-98b5-11cf-bb82-00aa00bdce0b"],
    "DispSVGZoomEvent": ["30590031-98b5-11cf-bb82-00aa00bdce0b", "30590031-98b5-11cf-bb82-00aa00bdce0b"],
    "DispStaticNodeList": ["3050f59b-98b5-11cf-bb82-00aa00bdce0b", "3050f59b-98b5-11cf-bb82-00aa00bdce0b"],
    "DispTreeWalker": ["3059009d-98b5-11cf-bb82-00aa00bdce0b", "3059009d-98b5-11cf-bb82-00aa00bdce0b"],
    "DispWebGeocoordinates": ["305900be-98b5-11cf-bb82-00aa00bdce0b", "305900be-98b5-11cf-bb82-00aa00bdce0b"],
    "DispWebGeolocation": ["305900bd-98b5-11cf-bb82-00aa00bdce0b", "305900bd-98b5-11cf-bb82-00aa00bdce0b"],
    "DispWebGeoposition": ["305900c1-98b5-11cf-bb82-00aa00bdce0b", "305900c1-98b5-11cf-bb82-00aa00bdce0b"],
    "DispWebGeopositionError": ["305900bf-98b5-11cf-bb82-00aa00bdce0b", "305900bf-98b5-11cf-bb82-00aa00bdce0b"],
    "DispXDomainRequest": ["3050f599-98b5-11cf-bb82-00aa00bdce0b", "3050f599-98b5-11cf-bb82-00aa00bdce0b"],
    "DispXMLHttpRequestEventTarget": ["305900e7-98b5-11cf-bb82-00aa00bdce0b", "305900e7-98b5-11cf-bb82-00aa00bdce0b"],
    "DispXMLSerializer": ["305900ad-98b5-11cf-bb82-00aa00bdce0b", "305900ad-98b5-11cf-bb82-00aa00bdce0b"],
    "HTMLDocumentEvents3": ["3050f5a0-98b5-11cf-bb82-00aa00bdce0b", "3050f5a0-98b5-11cf-bb82-00aa00bdce0b"],
    "HTMLDocumentEvents4": ["30510737-98b5-11cf-bb82-00aa00bdce0b", "30510737-98b5-11cf-bb82-00aa00bdce0b"],
    "HTMLElementEvents3": ["3050f59f-98b5-11cf-bb82-00aa00bdce0b", "3050f59f-98b5-11cf-bb82-00aa00bdce0b"],
    "HTMLElementEvents4": ["3051075e-98b5-11cf-bb82-00aa00bdce0b", "3051075e-98b5-11cf-bb82-00aa00bdce0b"],
    "HTMLFrameSiteEvents2": ["3050f7ff-98b5-11cf-bb82-00aa00bdce0b", "3050f7ff-98b5-11cf-bb82-00aa00bdce0b"],
    "HTMLPersistEvents": ["3050f4c7-98b5-11cf-bb82-00aa00bdce0b"],
    "HTMLWindowEvents3": ["3050f5a1-98b5-11cf-bb82-00aa00bdce0b", "3050f5a1-98b5-11cf-bb82-00aa00bdce0b"],
    "HTMLXMLHttpRequestEvents": ["30510498-98b5-11cf-bb82-00aa00bdce0b", "30510498-98b5-11cf-bb82-00aa00bdce0b"],
    "IMsoEnvelopeVBEvents": ["000672ad-0000-0000-c000-000000000046", "000672ad-0000-0000-c000-000000000046"],
    "IRTCDispatchEventNotification": ["176ddfbe-fec0-4d55-bc87-84cff1ef7f91", "176ddfbe-fec0-4d55-bc87-84cff1ef7f91"],
    "ISWbemSinkEvents": ["75718ca0-f029-11d1-a1ac-00c04fb6c223", "75718ca0-f029-11d1-a1ac-00c04fb6c223"],
    "ITTAPIDispatchEventNotification": ["9f34325b-7e62-11d2-9457-00c04f8ec888", "9f34325b-7e62-11d2-9457-00c04f8ec888"],
    "LayoutRectEvents": ["3050f674-98b5-11cf-bb82-00aa00bdce0b"],
    "XMLDOMDocumentEvents": ["3efaa427-272f-11d2-836f-0000f87a7782", "3efaa427-272f-11d2-836f-0000f87a7782"],
    "CommandBarButtonEvents": ["000c0351-0000-0000-c000-000000000046"],
    "CommandBarComboBoxEvents": ["000c0354-0000-0000-c000-000000000046"],
    "CommandBarsEvents": ["000c0352-0000-0000-c000-000000000046"],
    "IAntiPhishingBrowserSolutionEvents": ["9153c3ba-d311-446c-bb01-bc45cb772c27"],
    "IAppRepEvents": ["5a031e69-96a8-4a9d-802f-a5115210f1bb"],
    "IFindSimilarResults": ["96236a81-9dbc-11da-9e3f-0011114ae311", "96236a81-9dbc-11da-9e3f-0011114ae311"],
    "IRdcComparator": ["96236a77-9dbc-11da-9e3f-0011114ae311", "96236a77-9dbc-11da-9e3f-0011114ae311"],
    "IRdcFileReader": ["96236a74-9dbc-11da-9e3f-0011114ae311", "96236a74-9dbc-11da-9e3f-0011114ae311"],
    "IRdcFileWriter": ["96236a75-9dbc-11da-9e3f-0011114ae311", "96236a75-9dbc-11da-9e3f-0011114ae311"],
    "IRdcGenerator": ["96236a73-9dbc-11da-9e3f-0011114ae311", "96236a73-9dbc-11da-9e3f-0011114ae311"],
    "IRdcGeneratorFilterMaxParameters": [
        "96236a72-9dbc-11da-9e3f-0011114ae311",
        "96236a72-9dbc-11da-9e3f-0011114ae311",
    ],
    "IRdcGeneratorParameters": ["96236a71-9dbc-11da-9e3f-0011114ae311", "96236a71-9dbc-11da-9e3f-0011114ae311"],
    "IRdcLibrary": ["96236a78-9dbc-11da-9e3f-0011114ae311", "96236a78-9dbc-11da-9e3f-0011114ae311"],
    "IRdcSignatureReader": ["96236a76-9dbc-11da-9e3f-0011114ae311", "96236a76-9dbc-11da-9e3f-0011114ae311"],
    "IRdcSimilarityGenerator": ["96236a80-9dbc-11da-9e3f-0011114ae311", "96236a80-9dbc-11da-9e3f-0011114ae311"],
    "ISimilarity": ["96236a83-9dbc-11da-9e3f-0011114ae311", "96236a83-9dbc-11da-9e3f-0011114ae311"],
    "ISimilarityFileIdTable": ["96236a7f-9dbc-11da-9e3f-0011114ae311", "96236a7f-9dbc-11da-9e3f-0011114ae311"],
    "ISimilarityReportProgress": ["96236a7a-9dbc-11da-9e3f-0011114ae311", "96236a7a-9dbc-11da-9e3f-0011114ae311"],
    "ISimilarityTableDumpState": ["96236a7b-9dbc-11da-9e3f-0011114ae311", "96236a7b-9dbc-11da-9e3f-0011114ae311"],
    "ISimilarityTraitsMappedView": ["96236a7c-9dbc-11da-9e3f-0011114ae311", "96236a7c-9dbc-11da-9e3f-0011114ae311"],
    "ISimilarityTraitsMapping": ["96236a7d-9dbc-11da-9e3f-0011114ae311", "96236a7d-9dbc-11da-9e3f-0011114ae311"],
    "ISimilarityTraitsTable": ["96236a7e-9dbc-11da-9e3f-0011114ae311", "96236a7e-9dbc-11da-9e3f-0011114ae311"],
    "ADOColumns": ["0000061d-0000-0010-8000-00aa006d2ea4"],
    "ADOCommandConstruction": ["00000517-0000-0010-8000-00aa006d2ea4"],
    "ADOConnectionConstruction": ["00000551-0000-0010-8000-00aa006d2ea4"],
    "ADOConnectionConstruction15": ["00000516-0000-0010-8000-00aa006d2ea4"],
    "ADOError": ["00000500-0000-0010-8000-00aa006d2ea4"],
    "ADOErrors": ["00000501-0000-0010-8000-00aa006d2ea4"],
    "ADOField": ["00000569-0000-0010-8000-00aa006d2ea4", "00001569-0000-0010-8000-00aa006d2ea4"],
    "ADOFields": ["00000564-0000-0010-8000-00aa006d2ea4", "00001564-0000-0010-8000-00aa006d2ea4"],
    "ADOGroups": ["00000617-0000-0010-8000-00aa006d2ea4"],
    "ADOIndexes": ["00000620-0000-0010-8000-00aa006d2ea4"],
    "ADOKeys": ["00000623-0000-0010-8000-00aa006d2ea4"],
    "ADOParameters": ["0000050d-0000-0010-8000-00aa006d2ea4", "0000150d-0000-0010-8000-00aa006d2ea4"],
    "ADOProcedure": ["00000625-0000-0010-8000-00aa006d2ea4"],
    "ADOProcedures": ["00000626-0000-0010-8000-00aa006d2ea4"],
    "ADOProperties": ["00000504-0000-0010-8000-00aa006d2ea4"],
    "ADOProperty": ["00000503-0000-0010-8000-00aa006d2ea4"],
    "ADORecordConstruction": ["00000567-0000-0010-8000-00aa006d2ea4"],
    "ADORecordsetConstruction": ["00000283-0000-0010-8000-00aa006d2ea4"],
    "ADOStreamConstruction": ["00000568-0000-0010-8000-00aa006d2ea4"],
    "ADOTables": ["00000611-0000-0010-8000-00aa006d2ea4"],
    "ADOUsers": ["0000061a-0000-0010-8000-00aa006d2ea4"],
    "ADOView": ["00000613-0000-0010-8000-00aa006d2ea4"],
    "ADOViews": ["00000614-0000-0010-8000-00aa006d2ea4"],
    "ActivationBrokerManager": ["c499dffc-8907-4d47-89f3-712716a789f2"],
    "AddIns": ["50590801-d13e-4404-80c2-5ca30a4d0ee8", "50590801-d13e-4404-80c2-5ca30a4d0ee8"],
    "Adjustments": ["000c0310-0000-0000-c000-000000000046"],
    "AnalogVideoStandard": ["266eee44-6c63-11cf-8a03-00aa006ecb65"],
    "AnalyzerReferences": ["1c0a9223-df8f-4d3d-a5fc-4d4b506706e7"],
    "AnswerWizard": ["000c0360-0000-0000-c000-000000000046"],
    "AnswerWizardFiles": ["000c0361-0000-0000-c000-000000000046"],
    "AssemblyReference": ["229f3491-6e60-4e50-90e5-7db14b0dc004"],
    "AssemblyReferences": ["2c264a1a-dbfb-43fe-9434-997b5be0fccc"],
    "AsyncIApplicationLicenseManager": ["847bd310-6cee-48a3-864c-414126b9d123"],
    "AsyncIApplicationLicenseManager2": ["22ced81a-4ff4-40b2-b095-fcc1a3c093a9"],
    "AsyncIApplicationLicenseManager3": ["d86e8705-fc92-43ff-a020-bb6e9c5894cf"],
    "AsyncIAssociatedIdentityProvider": ["2834d6ed-297e-4e72-8a51-961e86f05152"],
    "AsyncIChildInfo": ["e94f5961-1516-459f-9ce7-149b53264fe8"],
    "AsyncIConnectedIdentityProvider": ["9ce55141-bce9-4e15-824d-43d79f512f93"],
    "AsyncIConnectedUser": ["5cbbc77b-b292-4184-9dce-2f98ca53434e"],
    "AsyncIConnectedUserStore": ["96125fe4-250a-41e2-a473-a49a849703c8"],
    "AsyncIDebugApplicationNodeEvents": ["a2e3aa3b-aa8d-4ebf-84cd-648b737b8c13"],
    "AsyncIERegHelperBroker": ["bfd074f8-3a54-4fb3-8771-277d3e2031c5"],
    "AsyncIEdgeManagerBroker": ["869ee45b-fece-4670-9af9-49cbd9fb0cc9"],
    "AsyncIEdgeManagerBrowsingContextBroker": ["b4c6e777-a36c-4d74-b8b2-b0af9578792a"],
    "AsyncIFtpAuthenticationProvider": ["c24efb65-9f3e-4996-8fb1-ce166916bab5"],
    "AsyncIFtpAuthorizationProvider": ["860dc339-07e5-4a5c-9c61-8820cea012bc"],
    "AsyncIFtpHomeDirectoryProvider": ["73f81638-6295-42bd-a2be-4a657f7c479c"],
    "AsyncIFtpLogProvider": ["00a0ae46-2498-48b2-95e6-df678ed7d49f"],
    "AsyncIFtpPostprocessProvider": ["a16b2542-9694-4eb1-a564-6c2e91fdc133"],
    "AsyncIFtpPreprocessProvider": ["6ff5fd8f-fd8e-48b1-a3e0-bf7073db4db5"],
    "AsyncIFtpRoleProvider": ["3e83bf99-70ec-41ca-84b6-aca7c7a62caf"],
    "AsyncIGatherNotify2": ["818b6181-1b32-48b0-8fcd-ae2e431db061"],
    "AsyncIIdentityAdvise": ["3ab4c8da-d038-4830-8dd9-3253c55a127f"],
    "AsyncIIdentityAuthentication": ["f9a2f918-feca-4e9c-9633-61cbf13ed34d"],
    "AsyncIIdentityProvider": ["c6fc9901-c433-4646-8f48-4e4687aae2a0"],
    "AsyncIIdentityStore": ["eefa1616-48de-4872-aa64-6e6206535a51"],
    "AsyncIIdentityStore2": ["4b42e09e-288e-47a9-b700-ecd1bbb02528"],
    "AsyncIIdentityStoreEx": ["fca3af9a-8a07-4eae-8632-ec3de658a36a"],
    "AsyncILicenseManager": ["d9abb5bb-ce07-40fb-9153-d974c65a1b47"],
    "AsyncILicenseManager2": ["6c91e6bb-87e7-4694-aaea-a4d906ae6068"],
    "AsyncILicenseManagerSubscriptions": ["7bbe20ca-f217-4141-813a-8241537412cd"],
    "AsyncILicenseManagerUserContext": ["f7a799a8-5fa3-4bce-be7d-c93aca367b20"],
    "AsyncILicenseProxyService": ["2af479e5-dc08-48b1-89f0-5305d8e40190"],
    "AsyncILicenseStorageService": ["b357fdb9-d1e9-4410-8483-541f5766da55"],
    "AsyncILockScreenCallBroker": ["3208cfd6-81f6-4cd3-bcbe-3ae9e7296987"],
    "AsyncIMSAdminBaseSink": ["a9e69613-b80d-11d0-b9b9-00a0c922e750"],
    "AsyncIMSAdminBaseSinkW": ["a9e69613-b80d-11d0-b9b9-00a0c922e750"],
    "AsyncIMSAdminBaseSink_W": ["a9e69613-b80d-11d0-b9b9-00a0c922e750"],
    "AsyncIMigratedIdentityConnector": ["0e9140f2-3d70-4d34-835e-4c95a7bd9618"],
    "AsyncIModernMarketplaceApplicationLicenseManager": ["0cc509d6-3e9a-4538-b909-4ff310481baa"],
    "AsyncIOfflineFilesService": ["6c8f231d-bc94-474e-95da-656b8f877af4"],
    "AsyncIOperatingSystemLicenseManager": ["7270d1d5-679d-4f8c-a152-a0b2b46d6d5f"],
    "AsyncIRemUnknown": ["000e0131-0000-0000-c000-000000000046"],
    "AsyncIRemUnknown2": ["000e0143-0000-0000-c000-000000000046"],
    "AsyncIRemUnknownN": ["000b013c-0000-0000-c000-000000000046"],
    "AsyncIRemoveLicensesForReasons": ["88cfb7d0-d255-475a-ac5b-a2b89935dd45"],
    "AsyncIRundown": ["000e0134-0000-0000-c000-000000000046"],
    "AsyncISettingsProvider": ["f152e566-e744-4a37-8b0c-ebf0e680a896"],
    "AsyncIShdocvwBroker": ["089a3fe9-9d38-4a15-91f3-9953b3b726f4"],
    "AsyncIWpnPresentationTileSink": ["8d2877bb-8a20-41d1-9f0e-89ce2db84f6b"],
    "AsyncIeAxiAdminInstaller": ["146e5396-3b32-49ac-901e-4c4a82fee8c5"],
    "AsyncIeAxiInstaller": ["5c861803-b3f1-4956-9bc2-7737ba72c606"],
    "AsyncIeAxiInstaller2": ["e0fd8b8e-66ea-45d6-a10a-81e74453733a"],
    "AsyncIeAxiService": ["4c691564-057c-430a-bc66-2120bfb048f7"],
    "AsyncIeAxiService2": ["f7084e96-d20b-444c-9381-73a273c23976"],
    "Axes": ["22813759-8bd3-11d0-b4ef-00a0c9138ca4"],
    "Axis": ["22813732-8bd3-11d0-b4ef-00a0c9138ca4"],
    "Balloon": ["000c0324-0000-0000-c000-000000000046"],
    "BalloonCheckbox": ["000c0328-0000-0000-c000-000000000046"],
    "BalloonCheckboxes": ["000c0326-0000-0000-c000-000000000046"],
    "BalloonLabel": ["000c0330-0000-0000-c000-000000000046"],
    "BalloonLabels": ["000c032e-0000-0000-c000-000000000046"],
    "BlobPlaceHolder": ["8888b46a-db7e-4f7f-a468-af8eeac7a4b3"],
    "BooleanSymbolExpressionEvaluator": ["5dadf1ee-bcbe-46ce-badf-271992c112a3"],
    "Breakpoint": ["11c5114c-bb00-11d2-8ad1-00c04f79e479"],
    "Breakpoint2": ["fbc8d85a-e449-4cb3-b026-f7808deb7792"],
    "Breakpoint3": ["81c189c5-0ef0-459c-b907-a22f6b7b355c"],
    "Breakpoints": ["25968106-bafb-11d2-8ad1-00c04f79e479"],
    "BuildDependencies": ["ead260eb-1e5b-450a-b628-4cfada11b4a1"],
    "BuildDependency": ["9c5ceaac-062f-4434-a2ed-78ab4d6134fe"],
    "BuildManager": ["c711e2b7-3c58-4c37-9359-705208a890ae"],
    "CAnchorHelper": ["30510735-98b5-11cf-bb82-00aa00bdce0b"],
    "CDefnTypeComp": ["000204f5-0000-0000-c000-000000000046"],
    "COMAddIn": ["000c033a-0000-0000-c000-000000000046"],
    "COMAddIns": ["000c0339-0000-0000-c000-000000000046"],
    "CSharpProjectConfigurationProperties3": ["f25c9ad7-e371-414d-82a0-24e8bbc25c99"],
    "CSharpProjectConfigurationProperties4": ["dd47c0d5-5095-4a44-ac96-105b2f194f11"],
    "CSharpProjectConfigurationProperties5": ["c379af13-6c05-4a91-a3bf-4c61999174b4"],
    "CSharpProjectConfigurationProperties6": ["97c0fc65-e652-44e1-8367-907fdfcf84fd"],
    "CSharpProjectProperties3": ["7c9d1773-f1f3-447c-af1a-218e5e2c2f7f"],
    "CSharpProjectProperties4": ["9c52f596-60fb-4144-be49-adca8f044790"],
    "CSharpProjectProperties6": ["531d3661-c9ce-4618-bdb4-466a4e4072c9"],
    "CSharpProjectProperties7": ["ad327414-a8f4-4e96-9a2a-3008592fd6a9"],
    "CStyleElementHelper": ["30510713-98b5-11cf-bb82-00aa00bdce0b"],
    "CTypeInfo2": ["00020433-0000-0000-c000-000000000046"],
    "CTypeLib2": ["00020432-0000-0000-c000-000000000046"],
    "CUnmappedXmlStorage": ["8a0d0bda-c266-4a4c-b270-e5f09f6339b2"],
    "CalloutFormat": ["000c0311-0000-0000-c000-000000000046"],
    "CanvasShapes": ["000c0371-0000-0000-c000-000000000046"],
    "CodeAttribute": ["0cfbc2be-0d4e-11d3-8997-00c04f688dde"],
    "CodeAttribute2": ["35187e2a-e5f6-4f89-a4ce-da254640855b"],
    "CodeAttributeArgument": ["80f4779b-835d-4873-8356-2f34a759a514"],
    "CodeClass": ["b1f42514-91cd-4d3a-8b25-a317d8032b24"],
    "CodeClass2": ["295adcd4-b052-49ee-934e-c6b36862a7c6"],
    "CodeDelegate": ["b1f42513-91cd-4d3a-8b25-a317d8032b24"],
    "CodeDelegate2": ["3b1b24ef-dd8e-4c98-8799-4efac80080e9"],
    "CodeElement": ["0cfbc2b6-0d4e-11d3-8997-00c04f688dde"],
    "CodeElement2": ["f03dcce8-233b-43d7-a66b-a66efc1f85c3"],
    "CodeElements": ["0cfbc2b5-0d4e-11d3-8997-00c04f688dde"],
    "CodeEnum": ["b1f42512-91cd-4d3a-8b25-a317d8032b24"],
    "CodeEvent": ["ce615bd2-8ed5-4f0c-a7b6-4a299d8801fd"],
    "CodeFolder": ["58b5e6e3-c2d3-4d56-97eb-26dda09323f7"],
    "CodeFolders": ["fdcad245-e468-48f3-b603-2641e020d6d0"],
    "CodeFunction": ["0cfbc2b9-0d4e-11d3-8997-00c04f688dde"],
    "CodeFunction2": ["7e20cd35-8689-466d-8ea0-a863b7ea5db9"],
    "CodeImport": ["0c9a256e-0ff9-4d4a-88e6-304acf78225f"],
    "CodeInterface": ["b1f42510-91cd-4d3a-8b25-a317d8032b24"],
    "CodeInterface2": ["860ab609-8af2-4434-b4dd-a43dee31b017"],
    "CodeModel": ["0cfbc2b4-0d4e-11d3-8997-00c04f688dde"],
    "CodeModel2": ["99b9cd0e-6c89-4bc4-bba2-ffd3529d3acb"],
    "CodeNamespace": ["0cfbc2b8-0d4e-11d3-8997-00c04f688dde"],
    "CodeParameter": ["0cfbc2bd-0d4e-11d3-8997-00c04f688dde"],
    "CodeParameter2": ["35cd9e36-7c96-4429-968f-c0c350cb1a47"],
    "CodeProperty": ["0cfbc2bb-0d4e-11d3-8997-00c04f688dde"],
    "CodeProperty2": ["33770c02-21b7-4224-a577-6877bdba60ea"],
    "CodeStruct": ["b1f42511-91cd-4d3a-8b25-a317d8032b24"],
    "CodeStruct2": ["f6dc1a01-e65a-404b-8b6d-9cdd603db4ed"],
    "CodeType": ["0cfbc2b7-0d4e-11d3-8997-00c04f688dde"],
    "CodeTypeRef": ["0cfbc2bc-0d4e-11d3-8997-00c04f688dde"],
    "CodeTypeRef2": ["9883c07a-fa07-4ce7-bd8e-01e1a3f3a3f7"],
    "CodeVariable": ["0cfbc2ba-0d4e-11d3-8997-00c04f688dde"],
    "CodeVariable2": ["f747a8a0-01b1-4da2-9259-0d5a0cb4c049"],
    "ColorFormat": ["000c0312-0000-0000-c000-000000000046"],
    "ColorableItems": ["e5d17051-d6e5-4da7-8b3a-ca888617a5e7"],
    "Command15": ["00000508-0000-0010-8000-00aa006d2ea4", "00001508-0000-0010-8000-00aa006d2ea4"],
    "Command25": ["0000054e-0000-0010-8000-00aa006d2ea4", "0000154e-0000-0010-8000-00aa006d2ea4"],
    "CommandBar": ["000c0304-0000-0000-c000-000000000046"],
    "CommandBarButton": ["000c030e-0000-0000-c000-000000000046"],
    "CommandBarComboBox": ["000c030c-0000-0000-c000-000000000046"],
    "CommandBarControl": ["000c0308-0000-0000-c000-000000000046"],
    "CommandBarControls": ["000c0306-0000-0000-c000-000000000046"],
    "CommandBarPopup": ["000c030a-0000-0000-c000-000000000046"],
    "CommandBars": ["000c0302-0000-0000-c000-000000000046"],
    "CommandWindow": ["509b9955-7303-48c9-90d4-e165b974e6ba"],
    "Commands": ["e6b96cac-b8c7-40ae-b705-5c81878c4a9e", "e6b96cac-b8c7-40ae-b705-5c81878c4a9e"],
    "Commands2": ["7eaa857b-2356-494b-9e13-0f6eefa86e43"],
    "ConfigurationManager": ["9043fda1-345b-4364-900f-bc8598eb8e4f"],
    "Configurations": ["b6b4c8d6-4d27-43b9-b45c-52bd16b6ba38"],
    "Connection15": ["00000515-0000-0010-8000-00aa006d2ea4", "00001515-0000-0010-8000-00aa006d2ea4"],
    "ConnectionEvents": ["00000400-0000-0010-8000-00aa006d2ea4", "00001400-0000-0010-8000-00aa006d2ea4"],
    "ConnectionEventsVt": ["00000402-0000-0010-8000-00aa006d2ea4", "00001402-0000-0010-8000-00aa006d2ea4"],
    "ConnectorFormat": ["000c0313-0000-0000-c000-000000000046"],
    "ContextAttribute": ["1a6e2cb3-b897-42eb-96be-ff0fdb65db2f"],
    "ContextAttributes": ["33c5ebb8-244e-449d-9cee-fad70a774e59"],
    "CubeDef": ["da16a34a-7b7a-46fd-ad9d-66df1e699fa1"],
    "CubeDef25": ["2281373e-8bd3-11d0-b4ef-00a0c9138ca4"],
    "CubeDefs": ["2281375d-8bd3-11d0-b4ef-00a0c9138ca4"],
    "DDiscFormat2DataEvents": ["2735413c-7f64-5b0f-8f00-5d77afbe261e"],
    "DDiscFormat2EraseEvents": ["2735413a-7f64-5b0f-8f00-5d77afbe261e"],
    "DDiscFormat2RawCDEvents": ["27354142-7f64-5b0f-8f00-5d77afbe261e"],
    "DDiscFormat2TrackAtOnceEvents": ["2735413f-7f64-5b0f-8f00-5d77afbe261e"],
    "DDiscMaster2Events": ["27354131-7f64-5b0f-8f00-5d77afbe261e"],
    "DEPRECATED": [
        "00732830-50f1-4d03-99ac-c6644c8ed8b5",
        "010a6306-c433-44e5-a9f2-bd84d4030a95",
        "020a16e5-6a25-40a3-8c00-50a023f619d1",
        "03bbf9b9-12d8-4bce-8835-c5df3ac0adab",
        "049c266a-93b4-478c-aeb8-70157bf0ff94",
        "08c03978-437a-4d97-a663-fd3195600249",
        "08e80a98-b8e5-41c1-a3d8-d3abfae22675",
        "091791ed-872b-4eec-9c72-ab11627b34ec",
        "0b6a985a-d59d-40be-980c-488a2ab30a83",
        "0b7ad409-ec2d-47ce-a253-732beeebcacd",
        "0bedda75-46e6-4b11-a088-5c68632899b5",
        "0c4733d2-57e0-4180-bd5e-f31a2138423e",
        "0c9d8511-5202-4dcb-8c67-abda12bb3c12",
        "112fbfc8-f235-4fde-8d41-9bf27c9e9a40",
        "13043da7-7fca-4c2b-9eca-6890f9f00185",
        "143ba4fc-e9c5-4736-91b2-e8eb9cb88356",
        "14d981a3-fc26-4ff7-abc3-48e82a512a0a",
        "164bbb60-8465-4786-8b93-2c16a89289d7",
        "172c4882-2fd9-4c4e-ba34-fdf20a73dde5",
        "191330e0-8695-438a-9545-3da4e822ddb4",
        "1a58b0e1-e91a-481e-b876-a89e2bbc6b33",
        "1adf0f65-e3b7-4155-997f-b756ef65beba",
        "1b88e52b-7787-48d6-aa12-d8e8f47ab85a",
        "1c6a52c5-ff19-471b-ba6b-f8f35694ad9a",
        "1e2ba861-8533-4fce-839b-ecb72410ac14",
        "1e33390a-3c90-4d22-b898-f42bba6418ff",
        "1ee30a1a-11b2-4558-8865-e3a516922517",
        "205f5d24-1b48-4629-a6ca-2fdfedafb75d",
        "21d39698-aa62-45ff-a5ff-8037e5433825",
        "23ca0917-cd07-4609-be15-8fe894c5e41e",
        "256bbc3d-1c5d-4260-8c75-9144cfb78ba9",
        "2a706328-da25-4f8c-9eb7-5d0fc3658bca",
        "2c846fe1-3bad-4f33-8c8b-e46fae824b4b",
        "2ca11c87-0873-4caf-8a7d-bd471e8586d1",
        "2d223d65-c4b6-4438-8d46-b96e6d0fb21f",
        "2d2d1bc6-02ce-474a-a556-a75b1cf93a03",
        "2d4cf9a5-e32f-4ab2-8748-96350a016da3",
        "2e0e1b12-d627-4fca-bad4-1faf168c7d14",
        "2f1af2e0-baf1-453b-bed4-cd9d4619154c",
        "383cff99-d70c-444d-a8b0-720c2e66fe3b",
        "387ee6aa-89cd-481e-aade-dd92f70b2ad7",
        "3ae651d6-9669-4106-9fae-4835c1b96104",
        "3bb384cb-0760-461d-907f-5138f84d44c1",
        "3bd6781b-61b8-46e2-99a5-8abcb6b9f7d6",
        "3c064fe9-2351-4248-a529-7110f464a785",
        "3c4d3046-ac4b-49f2-97d6-020e6182cb9c",
        "3c5aeb51-350b-4df8-9414-59e09815510b",
        "3cb38370-c02b-4236-b3e8-6bdca49c3129",
        "3cde9dc9-4800-46cd-869b-1973ec685bde",
        "3e53dd62-fee8-451f-b0d4-f706cca3e037",
        "3f582656-28f8-4e0f-ae8c-5898b9ae2469",
        "40e05c86-a7b4-4771-9ae7-0b5ffb12c03a",
        "4100891d-278e-4f29-859b-a9e501053e7d",
        "443d25b2-b282-4637-9173-ac978435c985",
        "44df23ae-5d6e-4068-a168-f47643182114",
        "460c92e5-4c32-4538-a4d4-b6b4400d140f",
        "4738d29f-c345-4649-8468-b8c5fc357190",
        "47bc8205-4d36-47a9-8f68-ffcb339dd0fc",
        "48b8219f-1e51-4d77-ae50-3ec164ad3480",
        "4a992832-1984-4148-9f25-382b35db087f",
        "4c24b81f-d944-4112-a98e-6a69522b7ebb",
        "4c38a7da-fdd8-4ed4-a039-2a6f9b235038",
        "4f1392ab-1f72-4d33-b695-de3e1db60317",
        "51882366-9f4b-498f-beb0-42684f6e1c29",
        "5498d33a-e686-4935-a567-7ca77ad20fa4",
        "54d571a7-8062-40f4-abe7-dedfd697b019",
        "55b08742-1808-494e-9e30-9d2a7be8f700",
        "56fec28b-e8aa-4c0f-8e4c-a559e73add88",
        "5b4d9d1d-b5f6-469c-b8c2-b97a45e6863b",
        "5bb50f15-e46d-4c82-847d-5a0304c1d53d",
        "5bf4e813-3b53-4c6e-b61a-d86a63755650",
        "5c1d0ba7-3856-48b9-8dc6-244bf107bf8c",
        "5cbf831a-3f08-497f-917f-57e09d84b141",
        "5d14e906-9266-4808-bd71-5925f2a3130a",
        "5df1cca2-01f8-4a87-b859-d5e5b7e1de47",
        "5df1cca2-01f8-4a87-b859-d5e5b7e1de48",
        "5df1cca2-01f8-4a87-b859-d5e5b7e1de49",
        "5df1cca2-01f8-4a87-b859-d5e5b7e1de4a",
        "5df1cca2-01f8-4a87-b859-d5e5b7e1de4b",
        "5df3cca2-01f8-4a87-b859-d5e5b7e1de47",
        "5df3cca2-01f8-4a87-b859-d5e5b7e1de48",
        "5df3cca2-01f8-4a87-b859-d5e5b7e1de49",
        "6040f18d-d5e5-4b60-9201-cd279cbcfed9",
        "64e6a887-3982-4f3b-ba20-6155e435325b",
        "6548ca01-86de-5be1-6582-807fcf4c95cf",
        "68c4b50f-0c20-4980-8602-58c62238d423",
        "6937ed8d-30ea-4ded-8271-4553ff02f68a",
        "6c68e068-bcf1-4ecc-b891-7625d1244b6b",
        "6d334120-95ce-4660-907a-d98035aa2b7c",
        "72245c31-4b39-42a6-8e73-7235ade16853",
        "74816d2a-2090-4670-8c48-ef39e7ff7c26",
        "752a0906-36a7-47bb-9b79-56cc6b746770",
        "75763ea3-011a-470e-8225-6f05ade25648",
        "7650f56e-b9f5-461b-83ad-f222af2aaadc",
        "76b1e67a-b045-4414-9d6d-2ad3a5fe3a7e",
        "77f3a910-48fa-489c-934e-2ae85ba8f772",
        "780e96d1-8d02-4d2b-ada4-5ba624a0eb10",
        "794f7ab9-b37d-3b33-a10d-30626419ce65",
        "7955de75-25bb-4153-a1a2-3029fcabb652",
        "7960ce18-d39b-4fc8-a04a-929734c6756c",
        "79d433d6-47fb-4df1-bfc9-f01d40bd9942",
        "79f6e96e-f50f-4015-8ba4-c2bc344ebd4e",
        "7a0c0aa7-ed89-4bd5-a8d9-15f4d9861c10",
        "7ae1fa72-029e-4dc5-a2f8-5fb763154150",
        "7bfb9e40-a6aa-45a7-9ff6-54c42105dd1f",
        "7cfe7825-54bb-4d9d-bec5-8ef66151d2ac",
        "7dd85cfe-1b99-4f68-8f82-8177f7cedf2b",
        "7dfe2088-63df-48ed-83b1-4ab829132995",
        "7f138a08-fbb7-4b09-8356-aa5f4e335c31",
        "7f68c5ed-3ccc-47a3-8c55-380d3b010892",
        "80baf614-f2f4-4c8a-8de3-065c78f6d5de",
        "81278ab5-41ab-16da-86c2-7f7bf0912f5b",
        "81b10b1c-e561-4093-9b4d-2ad482794a53",
        "856ddbc1-55f7-471f-a0f2-68ac4c904592",
        "8b2ccd7e-2ec0-446d-9285-33f07ce8ac04",
        "8f08e2e7-5a76-43e3-a13a-da3d91a9ef98",
        "8fad02d5-86f7-4d8d-b966-5a3761ba9f59",
        "90499a19-7ef2-4523-951c-a417a24acf93",
        "93a48168-8bf8-45d2-a2f8-4ac0931cc7a6",
        "93c901e8-6c78-4b4f-aec1-a6bb9e691624",
        "951ec6b1-fc83-586d-8b84-2452c8981625",
        "9572adf1-8f1d-481f-a15b-c61655f16a0e",
        "96bd1392-e667-40c4-89f9-1462dea6a9cc",
        "982b1162-3dd7-4618-af89-0c272d5d06d8",
        "9889f253-f188-4427-8d54-ce0c2423c5c1",
        "98f1fbe1-7a8d-42cb-b6fe-8fe698264f13",
        "99998653-5a3d-417f-9239-f1889e548b48",
        "9cbb5987-ef6d-4bc2-bf49-4617515a0f9a",
        "9cd8f292-98b2-4530-a1b6-2ded5fecbc26",
        "9e39b64d-ab5b-4905-acdc-787a77c6374d",
        "9e5e1bd1-90d0-4e1d-9554-844d46607f61",
        "9f4cbbb4-8cba-48b0-840d-dbb22a54c678",
        "9f77fac7-b4bd-4857-9d50-be8ef075daef",
        "9ff86872-e677-4814-9a20-5337ca732b98",
        "a0251452-4ad6-4b38-8426-c59a15493a7d",
        "a0c0cc4d-e96c-4d81-86dd-38b95e49c6df",
        "a0d009f7-8748-4ee2-ad44-afa6be997c51",
        "a234e429-3e39-494d-a37c-f462a2494514",
        "a37b81fc-9906-4ffd-9161-0024b360b657",
        "a4fe35f0-ade3-4981-af6b-ec195921682a",
        "a80f501a-9aac-4233-9784-aceaf92510b5",
        "a844cd09-5ecc-44b3-bb4e-1db07287139c",
        "a959ce07-ead3-33df-8ec1-b924abe019c4",
        "a9c86871-05dc-4a4d-8a5c-a4ecf26bbc46",
        "aa3a8dd5-b6e7-4ee2-baa9-dd6baced0a2b",
        "aab253eb-3301-4dc4-afba-b2f2ed9635a0",
        "aac2bbcf-9782-5420-b81e-7ae56af31815",
        "ae8386e6-cad9-4359-8f96-8eae51810526",
        "b0886276-849e-4c7a-8ae6-b56064532153",
        "b13df682-fc30-492b-8ea0-ed1f53c0b038",
        "b1a3c09f-299b-4612-a4f7-270f25a096ec",
        "b1cd0932-4570-4c69-8d38-89446561ace0",
        "b3161d95-1180-4376-96e1-4095568147ce",
        "b4131a82-dff5-4047-8a19-3b4d805f7176",
        "b5ded412-9d2f-5cb5-9b05-356a0b836c10",
        "b8de3f09-31cd-4d97-bd30-8d39f742bc61",
        "bae75f65-be30-4bee-964b-ff9e498fee37",
        "bb26d85f-cfd6-495f-93ab-b8566af9f8af",
        "bc792ebd-64fe-4b65-a0c0-901ce2b68636",
        "bf5eada6-88e6-445f-9d40-d9b9f8939896",
        "c1431dd3-b146-4d39-b959-0c69b096c512",
        "c167acd0-2ce6-426c-ace5-5e9275fea715",
        "c5cdc330-29df-4ec6-9da9-9fbdfcfc1b3e",
        "c8316cc0-aed2-41e0-bce0-c26ca74f85ec",
        "c89b8a2f-ac56-4460-8d2f-80023bec4fc5",
        "ca87256c-6fae-428e-bb83-25dfee51136b",
        "cca959e8-797e-4e83-9b87-036a74142fc4",
        "d0031202-cfac-4f00-ae6a-97af80b848f2",
        "d16bf4e6-da24-442c-bbd5-55549b5b94f3",
        "d277fa69-eb4c-42ef-ba4f-288f615c93c1",
        "d42df95d-a75b-47bf-8249-bc83820da38a",
        "d4a5ee56-7291-4073-bc1f-ccb8f5afdf96",
        "d4a6c425-2884-4a8f-8134-2835d7286cbf",
        "d61c904c-a495-487f-9a6f-971548c5bc9f",
        "d65405ab-3424-4833-8c9a-af5fdeb22872",
        "d720b4d4-f4b8-4530-a809-9193a571e7fc",
        "d7663702-d3a6-46e0-8f9b-50b95bb4f9c5",
        "d8f0bef8-91d2-4d47-a3f9-eaff4edb729f",
        "dbdd8b01-f1a1-46d1-9ee3-543bcc995980",
        "dc6dba7c-0b58-468d-9ca1-6db04cc0477c",
        "dcd4d798-4b0b-4300-8d85-410817faa032",
        "df25ea9f-9863-4088-8498-87a1f4686f92",
        "e0baa198-9796-41c9-8695-59437e67e66a",
        "e3685517-a584-479d-90b7-d689c7bf7c80",
        "e3d23d2e-6e2c-4e6d-91d9-704cd8dff79d",
        "e536af23-ac4f-4adc-8c66-4ff7c2702dd6",
        "e68a05d4-b60c-40f4-bcb9-f24d46467320",
        "e8019814-4a91-41b0-83a6-881a1775353e",
        "ea1a8071-7a70-4a61-af94-07303853f695",
        "f0fa3f3a-d4e8-4ad3-9c34-2308f32fcec9",
        "f237f327-5181-4f24-96a7-700a4e5fac62",
        "f52c09c6-8611-40ad-8e59-de3fd7030a40",
        "f56a206e-1b77-42ef-8f0d-b949f8d9b260",
        "f5cb0fdc-2d09-4f19-b5e1-76a0b3ee9267",
        "f8584665-64f4-44a0-ac0d-468d2b8fda83",
        "f88008e5-5631-45ed-ad98-8c6aa04cfb91",
        "f88d07ea-d815-4dd1-a234-4520ce4604a4",
        "fae3193a-0683-47d9-8df0-18cbb48984d8",
        "fdacec38-3700-4d73-91a1-2f998674238a",
        "fe621549-2cbf-4f94-9861-f817ea317747",
    ],
    "DFileSystemImageEvents": ["2c941fdf-975b-59be-a960-9a2a262853a5"],
    "DFileSystemImageImportEvents": ["d25c30f9-4087-4366-9e24-e55be286424b"],
    "DImageComboEvents": ["dd9da665-8594-11d1-b16a-00c0f0283628"],
    "DRendezvousSessionEvents": ["3fa19cf8-64c4-4f53-ae60-635b3806eca6"],
    "DTE2": ["2ee1e9fa-0afe-4348-a89f-ed9cb45c99cf"],
    "DWriteEngine2Events": ["27354137-7f64-5b0f-8f00-5d77afbe261e"],
    "Debugger2": ["8b5e2bfd-4642-4efe-8af4-0b2da9aaa23c"],
    "Debugger3": ["87dfc8da-67b4-4954-bb89-6a277a50bafc"],
    "Debugger4": ["133bad54-8e8d-451b-9db0-af38ed9819cc"],
    "Debugger5": ["c8bbaa3a-7e99-4630-942c-570f085141eb"],
    "DiagramNode": ["000c0370-0000-0000-c000-000000000046"],
    "DiagramNodeChildren": ["000c036f-0000-0000-c000-000000000046"],
    "DiagramNodes": ["000c036e-0000-0000-c000-000000000046"],
    "Dimensions": ["2281375c-8bd3-11d0-b4ef-00a0c9138ca4"],
    "DocumentProperties": ["2df8d04d-5bfa-101b-bde5-00aa0044de52"],
    "DocumentProperty": ["2df8d04e-5bfa-101b-bde5-00aa0044de52"],
    "EditPoint": ["c1ffe800-028b-4475-a907-14f51f19bb7d"],
    "EditPoint2": ["136afa9f-f243-4abb-a8f8-4c2d26c47163"],
    "Engines": ["9f998c5e-549e-4c74-9fd8-b3a93d85a248"],
    "ErrorItem": ["f49a191f-7258-493b-9310-5f7771ddf3d7"],
    "ErrorItems": ["dcf93a30-d013-42f4-8aee-9f5ba215fb8b"],
    "ExceptionGroups": ["21bdc491-f828-4846-9fd8-75c9148aea24"],
    "ExceptionSetting": ["115998bf-a603-4848-b5de-3b250a13d109"],
    "ExceptionSettings": ["0e1ab53b-4065-4884-a39f-02e16eb57f7d"],
    "Expression2": ["f15a2dad-5c82-4802-bebc-5431b6ed5557"],
    "Expressions": ["2685337a-bb9e-11d2-8ad1-00c04f79e479"],
    "FSMsoControl": ["000c0147-0000-0000-c000-000000000046"],
    "Field15": ["00000505-0000-0010-8000-00aa006d2ea4", "00001505-0000-0010-8000-00aa006d2ea4"],
    "Field20": ["0000054c-0000-0010-8000-00aa006d2ea4", "0000154c-0000-0010-8000-00aa006d2ea4"],
    "Fields15": ["00000506-0000-0010-8000-00aa006d2ea4", "00001506-0000-0010-8000-00aa006d2ea4"],
    "Fields20": ["0000054d-0000-0010-8000-00aa006d2ea4", "0000154d-0000-0010-8000-00aa006d2ea4"],
    "FileCodeModel": ["ed1a3f99-4477-11d3-89bf-00c04f688dde"],
    "FileCodeModel2": ["a65964df-3a07-45eb-882a-dd04602016b9"],
    "FileDialog": ["000c0362-0000-0000-c000-000000000046"],
    "FileDialogFilter": ["000c0364-0000-0000-c000-000000000046"],
    "FileDialogFilters": ["000c0365-0000-0000-c000-000000000046"],
    "FileDialogSelectedItems": ["000c0363-0000-0000-c000-000000000046"],
    "FileProperties": ["516bd64e-51c0-11d3-85cf-00c04f6123b3"],
    "FileProperties2": ["41be8d4d-f235-46d4-b9f8-c6d6459d503c"],
    "FileTypes": ["000c036c-0000-0000-c000-000000000046"],
    "FillFormat": ["000c0314-0000-0000-c000-000000000046"],
    "Find2": ["01568308-5b2a-4f30-8d0a-e10ee0f28f4a"],
    "FolderProperties": ["8e4aa768-51e1-11d3-85cf-00c04f6123b3"],
    "FolderProperties2": ["2aca2576-0738-466f-845f-16062ed8d1bc"],
    "FontsAndColorsItems": ["f25ae7e6-1460-4ba4-8e5e-bbbe746de353"],
    "FoundFiles": ["000c0331-0000-0000-c000-000000000046"],
    "FreeformBuilder": ["000c0315-0000-0000-c000-000000000046"],
    "GENCONNECTIONPOINT": ["6657b990-7ab3-11ce-b4fd-00aa004b9c05"],
    "GENCPCONTAINER": ["313df590-7ab3-11ce-b4fd-00aa004b9c05"],
    "Globals": ["e68a3e0e-b435-4dde-86b7-f5adefc19df2"],
    "GroupShapes": ["000c0316-0000-0000-c000-000000000046"],
    "HTMLProject": ["000c0356-0000-0000-c000-000000000046"],
    "HTMLProjectItem": ["000c0358-0000-0000-c000-000000000046"],
    "HTMLProjectItems": ["000c0357-0000-0000-c000-000000000046"],
    "Hierarchies": ["2281375b-8bd3-11d0-b4ef-00a0c9138ca4"],
    "Hierarchy": ["22813746-8bd3-11d0-b4ef-00a0c9138ca4"],
    "IADMEXT": ["51dfe970-f6f2-11d0-b9bd-00a0c922e750"],
    "IADsADSystemInfo": ["5bb11929-afd1-11d2-9cb9-0000f87a369e"],
    "IADsAccessControlEntry": ["b4f3a14c-9bdd-11d0-852c-00c04fd8d503"],
    "IADsAccessControlList": ["b7ee91cc-9bdd-11d0-852c-00c04fd8d503"],
    "IADsAcl": ["8452d3ab-0869-11d1-a377-00c04fb950dc"],
    "IADsAggregatee": ["1346ce8c-9039-11d0-8528-00c04fd8d503"],
    "IADsAggregator": ["52db5fb0-941f-11d0-8529-00c04fd8d503"],
    "IADsBackLink": ["fd1302bd-4080-11d1-a3ac-00c04fb950dc"],
    "IADsCaseIgnoreList": ["7b66b533-4680-11d1-a3b4-00c04fb950dc"],
    "IADsDNWithBinary": ["7e99c0a2-f935-11d2-ba96-00c04fb6d0d1"],
    "IADsDNWithString": ["370df02e-f934-11d2-ba96-00c04fb6d0d1"],
    "IADsDeleteOps": ["b2bd0902-8878-11d1-8c21-00c04fd8d503"],
    "IADsEmail": ["97af011a-478e-11d1-a3b4-00c04fb950dc"],
    "IADsFaxNumber": ["a910dea9-4680-11d1-a3b4-00c04fb950dc"],
    "IADsHold": ["b3eb3b37-4080-11d1-a3ac-00c04fb950dc"],
    "IADsLargeInteger": ["9068270b-0939-11d1-8be1-00c04fd8d503"],
    "IADsNameTranslate": ["b1b272a3-3625-11d1-a3a4-00c04fb950dc"],
    "IADsNetAddress": ["b21a50a9-4080-11d1-a3ac-00c04fb950dc"],
    "IADsOctetList": ["7b28b80f-4680-11d1-a3b4-00c04fb950dc"],
    "IADsPath": ["b287fcd5-4080-11d1-a3ac-00c04fb950dc"],
    "IADsPathname": ["d592aed4-f420-11d0-a36e-00c04fb950dc"],
    "IADsPostalAddress": ["7adecf29-4680-11d1-a3b4-00c04fb950dc"],
    "IADsPropertyEntry": ["05792c8e-941f-11d0-8529-00c04fd8d503"],
    "IADsPropertyValue": ["79fa9ad0-a97c-11d0-8534-00c04fd8d503"],
    "IADsPropertyValue2": ["306e831c-5bc7-11d1-a3b8-00c04fb950dc"],
    "IADsReplicaPointer": ["f60fb803-4080-11d1-a3ac-00c04fb950dc"],
    "IADsSecurityDescriptor": ["b8c787ca-9bdd-11d0-852c-00c04fd8d503"],
    "IADsTSUserEx": ["c4930e79-2989-4462-8a60-2fcf2f2955ef"],
    "IADsTimestamp": ["b2f5a901-4080-11d1-a3ac-00c04fb950dc"],
    "IADsTypedName": ["b371a349-4080-11d1-a3ac-00c04fb950dc"],
    "IADsWinNTSystemInfo": ["6c6d65dc-afd1-11d2-9cb9-0000f87a369e"],
    "IAESCheck": ["8aca8016-b08c-4c5a-99ca-c24488385828"],
    "IAICEventSink": ["70f2f87b-1319-4156-8bfb-69a35c25ec31"],
    "IAICProxy": ["c1a97c88-de59-470f-adcb-a6c916fca6c2"],
    "IAImmFnDocFeed": ["6e098993-9577-499a-a830-52344f3e200d"],
    "IAImmThreadCompartment": ["d251a968-2b44-4da5-a549-c1249ef01711"],
    "IALEventSink": ["00ab4ba8-98ad-4bff-92d9-d22a7a42d36c"],
    "IALink": ["c8e77f39-3604-4fd4-85cf-38bdeb233ad4"],
    "IALink2": ["c8e77f39-3604-4fd4-85cf-38bdeb233ad5"],
    "IALink3": ["22d4f7a0-0065-43dd-8eaf-b9fb901d8223"],
    "IAMAsyncReaderTimestampScaling": ["cf7b26fc-9a00-485b-8147-3e789d5e8f67"],
    "IAMAudioRendererStats": ["22320cb2-d41a-11d2-bf7c-d7cb9df0bf93"],
    "IAMCertifiedOutputProtection": ["6feded3e-0ff1-4901-a2f1-43f7012c8515"],
    "IAMChannelInfo": ["fa2aa8f2-8b62-11d0-a520-000000000000"],
    "IAMClockAdjust": ["4d5466b0-a49c-11d1-abe8-00a0c905f375"],
    "IAMClockSlave": ["9fd52741-176d-4b36-8f51-ca8f933223be"],
    "IAMDecoderCaps": ["c0dff467-d499-4986-972b-e1d9090fa941"],
    "IAMDeviceRemoval": ["f90a6130-b658-11d2-ae49-0000f8754b99"],
    "IAMErrorLog": ["e43e73a2-0efa-11d3-9601-00a0c9441e20"],
    "IAMExtendedErrorInfo": ["fa2aa8f6-8b62-11d0-a520-000000000000"],
    "IAMExtendedSeeking": ["fa2aa8f9-8b62-11d0-a520-000000000000"],
    "IAMFilterGraphCallback": ["56a868fd-0ad4-11ce-b0a3-0020af0ba770"],
    "IAMFilterMiscFlags": ["2dd74950-a890-11d1-abe8-00a0c905f375"],
    "IAMGraphBuilderCallback": ["4995f511-9ddb-4f12-bd3b-f04611807b79"],
    "IAMGraphStreams": ["632105fa-072e-11d3-8af9-00c04fb6bd3d"],
    "IAMLatency": ["62ea93ba-ec62-11d2-b770-00c04fb6bd3d"],
    "IAMMediaContent": ["fa2aa8f4-8b62-11d0-a520-000000000000"],
    "IAMMediaContent2": ["ce8f78c1-74d9-11d2-b09d-00a0c9a81117"],
    "IAMMediaStream": ["bebe595d-9a6f-11d0-8fde-00c04fd9189d"],
    "IAMMediaTypeSample": ["ab6b4afb-f6e4-11d0-900d-00c04fd9189d"],
    "IAMMediaTypeStream": ["ab6b4afa-f6e4-11d0-900d-00c04fd9189d"],
    "IAMMultiMediaStream": ["bebe595c-9a6f-11d0-8fde-00c04fd9189d"],
    "IAMNetShowConfig": ["fa2aa8f1-8b62-11d0-a520-000000000000"],
    "IAMNetShowExProps": ["fa2aa8f5-8b62-11d0-a520-000000000000"],
    "IAMNetShowPreroll": ["aae7e4e2-6388-11d1-8d93-006097c9a2b2"],
    "IAMNetworkStatus": ["fa2aa8f3-8b62-11d0-a520-000000000000"],
    "IAMOpenProgress": ["8e1c39a1-de53-11cf-aa63-0080c744528d"],
    "IAMOverlayFX": ["62fae250-7e65-4460-bfc9-6398b322073c"],
    "IAMParse": ["c47a3420-005c-11d2-9038-00a0c9697298"],
    "IAMPlayList": ["56a868fe-0ad4-11ce-b03a-0020af0ba770", "56a868fe-0ad4-11ce-b0a3-0020af0ba770"],
    "IAMPlayListItem": ["56a868ff-0ad4-11ce-b03a-0020af0ba770", "56a868ff-0ad4-11ce-b0a3-0020af0ba770"],
    "IAMPluginControl": ["0e26a181-f40c-4635-8786-976284b52981"],
    "IAMPushSource": ["f185fe76-e64e-11d2-b76e-00c04fb6bd3d"],
    "IAMRebuild": ["02ef04dd-7580-11d1-bece-00c04fb6e937"],
    "IAMResourceControl": ["8389d2d0-77d7-11d1-abe6-00a0c905f375"],
    "IAMSetErrorLog": ["963566da-be21-4eaf-88e9-35704f8f52a1"],
    "IAMStats": ["bc9bcf80-dcd2-11d2-abf6-00a0c905f375"],
    "IAMTimeline": ["78530b74-61f9-11d2-8cad-00a024580902"],
    "IAMTimelineComp": ["eae58536-622e-11d2-8cad-00a024580902"],
    "IAMTimelineEffect": ["bce0c264-622d-11d2-8cad-00a024580902"],
    "IAMTimelineEffectable": ["eae58537-622e-11d2-8cad-00a024580902"],
    "IAMTimelineGroup": ["9eed4f00-b8a6-11d2-8023-00c0df10d434"],
    "IAMTimelineObj": ["78530b77-61f9-11d2-8cad-00a024580902"],
    "IAMTimelineSplittable": ["a0f840a0-d590-11d2-8d55-00a0c9441e20"],
    "IAMTimelineSrc": ["78530b79-61f9-11d2-8cad-00a024580902"],
    "IAMTimelineTrack": ["eae58538-622e-11d2-8cad-00a024580902"],
    "IAMTimelineTrans": ["bce0c265-622d-11d2-8cad-00a024580902"],
    "IAMTimelineTransable": ["378fa386-622e-11d2-8cad-00a024580902"],
    "IAMTimelineVirtualTrack": ["a8ed5f80-c2c7-11d2-8d39-00a0c9441e20"],
    "IAMVideoAccelerator": ["256a6a22-fbad-11d1-82bf-00a0c9696c8f"],
    "IAMVideoAcceleratorNotify": ["256a6a21-fbad-11d1-82bf-00a0c9696c8f"],
    "IAMVideoControl": ["6a2e0670-28e4-11d0-a18c-00a0c9118956"],
    "IAMVideoDecimationProperties": ["60d32930-13da-11d3-9ec6-c4fcaef5c7be"],
    "IAMWMBufferPass": ["6dd816d7-e740-4123-9e24-2444412644d8"],
    "IAMWMBufferPassCallback": ["b25b8372-d2d2-44b2-8653-1b8dae332489"],
    "IAMWstDecoder": ["c056de21-75c2-11d3-a184-00105aef9f33"],
    "IAPOControlInternal": ["0ef25615-b134-4fba-80e3-e3ea2f74206e"],
    "IAPOWrapperSrv": ["69fed9b6-5405-48b8-3db0-4ca492fc3677"],
    "IASPError": ["f5a6893e-a0f5-11d1-8c4b-00c04fc324a4"],
    "IASTAThreadHostService": ["ba9efe23-058f-4d2c-9b2e-a567a32be176"],
    "IATSCChannelTuneRequest": ["0369b4e1-45b6-11d3-b650-00c04f79498e"],
    "IATSCComponentType": ["fc189e4d-7bd4-4125-b3b3-3a76a332cc96"],
    "IATSCLocator": ["bf8d986f-8c2b-4131-94d7-4d3d9fcc21ef"],
    "IATSCLocator2": ["612aa885-66cf-4090-ba0a-566f5312e4ca"],
    "IATSCTuningSpace": ["0369b4e2-45b6-11d3-b650-00c04f79498e"],
    "IATSC_EIT": ["d7c212d7-76a2-4b4b-aa56-846879a80096"],
    "IATSC_ETT": ["5a142cc9-b8cf-4a86-a040-e9cadf3ef3e7"],
    "IATSC_MGT": ["8877dabd-c137-4073-97e3-779407a5d87a"],
    "IATSC_STT": ["6bf42423-217d-4d6f-81e1-3a7b360ec896"],
    "IATSC_VCT": ["26879a18-32f9-46c6-91f0-fb6479270e8c"],
    "IAbandonmentNotification": ["000001de-0000-0000-c000-000000000046"],
    "IAboveLockActivationListener": ["e47e960d-799e-4d57-85a7-1784c0e17538"],
    "IAboveLockActivationManager": ["3721d4ef-bca1-418a-98e2-ec3def272b2f"],
    "IAboveLockActivationManagerMobileInternal": ["818a0a6a-4370-4977-9755-48ae570039ae"],
    "IAboveLockActivationManagerPriv": ["0b8a7d52-5a75-42b4-8b20-2355e6ef22b4"],
    "IAboveLockActivationManagerSingleViewPriv": ["dea01884-59aa-44dd-a3aa-4051599e0f44"],
    "IAboveLockViewManager": ["e3538e54-26a6-4534-96cd-7f10c89d41e2"],
    "IAboveWelcomeScreenActivationManager": ["66c98467-d867-47a9-b86e-2de58a3bb410"],
    "IAccClientDocMgr": ["4c896039-7b6d-49e6-a8c1-45116a98292b"],
    "IAccDictionary": ["1dc4cb5f-d737-474d-ade9-5ccfc9bc1cc9"],
    "IAccPropMgrInternal": ["2bd370a9-3e7f-4edd-8a85-f8fed1f8e51f"],
    "IAccProxyVersion": ["55f9c234-79cd-4699-89e7-5518fd88bcde"],
    "IAccServerDocMgr": ["ad7c73cf-6dd5-4855-abc2-b04bad5b9153"],
    "IAccStore": ["e2cd4a63-2b72-4d48-b739-95e4765195ba"],
    "IAccTimeout": ["f660d979-a938-423f-b5b9-12e4028c50b0"],
    "IAccTimeout2": ["e210ec43-d7fb-41bf-9456-c0b9f6d034f3"],
    "IAcceleratorCallback": ["8f95583e-818f-4c3b-b03d-2e6c70265f34"],
    "IAcceleratorKeyEventArgs": ["ff1c4c4a-9287-470b-836e-9086e3126ade"],
    "IAcceleratorKeyEventArgs2": ["d300a9f6-2f7e-4873-a555-166e596ee1c5"],
    "IAccelerometer": ["df184548-2711-4da7-8098-4b82205d3c7d"],
    "IAccelerometer2": ["e8f092ee-4964-401a-b602-220d7153c60a"],
    "IAccelerometer3": ["87e0022a-ed80-49eb-bf8a-a4ea31e5cd84"],
    "IAccelerometer4": ["1d373c4f-42d3-45b2-8144-ab7fb665eb59"],
    "IAccelerometer5": ["7e7e7021-def4-53a6-af43-806fd538edf6"],
    "IAccelerometerDataThreshold": ["f92c1b68-6320-5577-879e-9942621c3dd9"],
    "IAccelerometerDeviceId": ["7eac64a9-97d5-446d-ab5a-917df9b96a2c"],
    "IAccelerometerReading": ["b9fe7acb-d351-40af-8bb6-7aa9ae641fb7"],
    "IAccelerometerReading2": ["0a864aa2-15ae-4a40-be55-db58d7de7389"],
    "IAccelerometerReadingChangedEventArgs": ["0095c65b-b6ac-475a-9f44-8b32d35a3f25"],
    "IAccelerometerShakenEventArgs": ["95ff01d1-4a28-4f35-98e8-8178aae4084a"],
    "IAccelerometerStatics": ["a5e28b74-5a87-4a2d-becc-0f906ea061dd"],
    "IAccelerometerStatics2": ["c4c4842f-d86b-4685-b2d7-3396f798d57b"],
    "IAccelerometerStatics3": ["9de218cf-455d-4cf3-8200-70e1410340f8"],
    "IAcceptHeaderOptions": ["ac5c47c4-9561-49a6-a737-c3bba1d82c6b"],
    "IAccessKeyDisplayDismissedEventArgs": ["8a610dc6-d72d-4ca8-9f66-556f35b513da"],
    "IAccessKeyDisplayRequestedEventArgs": ["0c079e55-13fe-4d03-a61d-e12f06567286"],
    "IAccessKeyInvokedEventArgs": ["cfe9cd97-c718-4091-b7dd-adf1c072b1e1"],
    "IAccessKeyManager": ["ecc973b0-2ee9-4b1c-98d7-6e0e816d334b"],
    "IAccessKeyManagerStatics": ["4ca0efe6-d9c8-4ebc-b4c7-30d1838a81f1"],
    "IAccessKeyManagerStatics2": ["962bb594-2ab3-47c5-954b-7092f355f797"],
    "IAccessibilityDockingService": ["8849dc22-cedf-4c95-998d-051419dd3f76"],
    "IAccessibilityDockingServiceCallback": ["157733fd-a592-42e5-b594-248468c5a81b"],
    "IAccessibilityDockingServiceInternal": ["6d2586fd-5559-4747-9a8f-28031d259eca"],
    "IAccessibilitySettings": ["fe0e8147-c4c0-4562-b962-1327b52ad5b9"],
    "IAccessibleEx": ["f8b80ada-2c44-48d0-89be-5ff23c9cd875"],
    "IAccessibleHostingElementProviders": ["33ac331b-943e-4020-b295-db37784974a3"],
    "IAccessibleObject": ["95a391c5-9ed4-4c28-8401-ab9e06719e11"],
    "IAccessibleProxy": ["7a7d9dcf-b7a1-4019-9031-258268846980"],
    "IAccessibleServer": ["52c8fb5e-d779-4e77-ae9f-f611fa7e9d7a"],
    "IAccessibleWinSAT": ["30e6018a-94a8-4ff8-a69a-71b67413f07b"],
    "IAccessibleWindowlessSite": ["bf3abd9c-76da-4389-9eb6-1427d25abab7"],
    "IAccessor": ["0c733a8c-2a1c-11ce-ade5-00aa0044773d"],
    "IAccountingProviderConfig": ["66a2db18-d706-11d0-a37b-00c04fc9da04"],
    "IAccountsSettingsPane": ["81ea942c-4f09-4406-a538-838d9b14b7e6"],
    "IAccountsSettingsPaneCommandsRequestedEventArgs": ["3b68c099-db19-45d0-9abf-95d3773c9330"],
    "IAccountsSettingsPaneCommandsRequestedEventArgs2": ["362f7bad-4e37-4967-8c40-e78ee7a1e5bb"],
    "IAccountsSettingsPaneEventDeferral": ["cbf25d3f-e5ba-40ef-93da-65e096e5fb04"],
    "IAccountsSettingsPaneInterop": ["d3ee12ad-3865-4362-9746-b75a682df0e6"],
    "IAccountsSettingsPaneStatics": ["561f8b60-b0ec-4150-a8dc-208ee44b068a"],
    "IAccountsSettingsPaneStatics2": ["d21df7c2-ce0d-484f-b8e8-e823c215765e"],
    "IAccountsSettingsPaneStatics3": ["08410458-a2ba-4c6f-b4ac-48f514331216"],
    "IAcmWrapperConfigure": ["62f510f6-5173-49d5-8f69-56fba0b20f8d"],
    "IAcrylicBrush": ["79bbcf4e-cd66-4f1b-a8b6-cd6d2977c18d"],
    "IAcrylicBrush2": ["c9645383-b19e-5ac0-86ff-3d90506dbcda"],
    "IAcrylicBrushFactory": ["81a32568-f6cc-4013-8363-928ae23b7a61"],
    "IAcrylicBrushStatics": ["2787fd79-a3da-423f-b81a-599147971523"],
    "IAcrylicBrushStatics2": ["129188a8-bf11-5bbc-8445-8c510e5926c0"],
    "IActionCollection": ["02820e19-7b98-4ed2-b2e8-fdccceff619b"],
    "IActionHistory": ["8d5de85b-7d42-11d0-a8aa-00a0c921a4d2"],
    "IActionOnCLREvent": ["607be24b-d91b-4e28-a242-61871ce56e35"],
    "IActionSpaceFlow": ["00d0f427-ebb3-4304-b6f8-ae4fa0fa7c20"],
    "IActivatableClassInformation": ["8d80c0b8-7c1d-4a31-9d67-9395e73b7cf6"],
    "IActivatableClassRegistration": ["9bbcae23-3dd6-49c3-b63c-1c587e7a6a67"],
    "IActivateAudioInterfaceAsyncOperation": ["72a22d78-cde4-431d-b8cc-843a71199b6d"],
    "IActivateAudioInterfaceCompletionHandler": ["41d949ab-9862-444a-80f6-c261334da5eb"],
    "IActivatedDeferral": ["c3bd1978-a431-49d8-a76a-395a4e03dcf3"],
    "IActivatedEventArgs": ["cf651713-cd08-4fd8-b697-a281b6544e2e"],
    "IActivatedEventArgsDeferral": ["ca6d5f74-63c2-44a6-b97b-d9a03c20bc9b"],
    "IActivatedEventArgsWithUser": ["1cf09b9e-9962-4936-80ff-afc8e8ae5c8c"],
    "IActivatedEventHandler": ["50f1e730-c5d1-4b6b-9adb-8a11756be29c"],
    "IActivatedOperation": ["b6a0b4bc-c6ca-42fd-9818-71904e45fed7"],
    "IActivationBrokerManager": ["c499dffc-8907-4d47-89f3-712716a789f2"],
    "IActivationBrokerPlugin": ["75f91a54-fa3d-431d-8ee7-6bf000847e77"],
    "IActivationBrokerPluginDesktopAppX": ["a040189f-c2a2-4ff8-b6e1-1e628e598d26"],
    "IActivationBrokerPluginWithResult": ["b98dd1e5-633a-4266-9610-0f82ef69856e"],
    "IActivationContextInfo": ["000001a5-0000-0000-c000-000000000046"],
    "IActivationErrorPopup": ["9333bee8-82cb-475a-8801-e43f12818290"],
    "IActivationErrorPopupFactory": ["848eaf0a-4435-4d6f-bcdf-8f42ffb38400"],
    "IActivationFactory": ["00000035-0000-0000-c000-000000000046"],
    "IActivationFilter": ["00000017-0000-0000-c000-000000000046"],
    "IActivationLayoutPreferences": ["657a8842-0b5e-40e1-b8cb-9aafacc33aab"],
    "IActivationPropOutClean": ["0b0d5310-d195-42df-b9a2-83cf63f043aa"],
    "IActivationProperties": ["000001af-0000-0000-c000-000000000046"],
    "IActivationPropertiesIn": ["000001a2-0000-0000-c000-000000000046"],
    "IActivationPropertiesOut": ["000001a3-0000-0000-c000-000000000046"],
    "IActivationSecurityInfo": ["000001a6-0000-0000-c000-000000000046"],
    "IActivationSignalDetectionConfiguration": ["40d8be16-5217-581c-9ab2-ce9b2f2e8e00"],
    "IActivationSignalDetector": ["b5bf345f-a4d0-5b2b-8e65-b3c55ee756ff"],
    "IActivationStageInfo": ["000001a8-0000-0000-c000-000000000046"],
    "IActivationStoreHelper": ["a1dffaf7-0f96-44c0-a97e-507291947d64"],
    "IActivationViewSwitcher": ["dca71bb6-7350-492b-aac7-c8a13d7224ad"],
    "IActivationViewSwitcherFactory": ["a6b0e1a3-3104-4034-9baa-52ab1f8963a5"],
    "IActiveBasicDevice": ["b64d6974-6e79-49af-9933-908b6e9a160c"],
    "IActiveBasicDeviceStatics": ["6d33255d-3642-4618-9db6-43524f4deadc"],
    "IActiveDesigner": ["51aae3e0-7486-11cf-a0c2-00aa0062be57"],
    "IActiveIMMAppEx": ["d7a6f58a-d478-44ab-86c9-591c23a26534"],
    "IActiveMonitorChangedEventArgs": ["20d7186f-5c33-48d6-bea2-d9e9e5af5a95"],
    "IActiveMonitorChangedHandler": ["264e19dc-8a37-4dda-b863-d2323c263026"],
    "IActiveMonitorNotifier": ["4cafecdd-c315-464f-ab85-7d6db67b61b8"],
    "IActiveScriptContext": ["47f6bca8-8623-4b1a-9efc-5c26ba993494"],
    "IActiveScriptDataCache": ["f8d6dbd7-18ad-438d-a154-b3b1b04864a3"],
    "IActiveScriptErrorDebug110": ["516e42b6-89a8-4530-937b-5f0708431442"],
    "IActiveScriptLifecycleEventSink": ["cc1a2bea-d5e9-4161-9da7-9042b37549a7"],
    "IActiveScriptParseUTF864": ["5901662f-7138-43af-a3d3-2a854c4b8253"],
    "IActiveScriptProfilerCallback": ["740eca23-7d9d-42e5-ba9d-f8b24b1c7a9b"],
    "IActiveScriptProfilerCallback2": ["31b7f8ad-a637-409c-b22f-040995b6103d"],
    "IActiveScriptProfilerCallback3": ["6ac5ad25-2037-4687-91df-b59979d93d73"],
    "IActiveScriptProfilerControl": ["784b5ff0-69b0-47d1-a7dc-2518f4230e90"],
    "IActiveScriptProfilerControl2": ["47810165-498f-40be-94f1-653557e9e7da"],
    "IActiveScriptProfilerControl3": ["0b403015-f381-4023-a5d0-6fed076de716"],
    "IActiveScriptProfilerControl4": ["160f94fd-9dbc-40d4-9eac-2b71db3132f4"],
    "IActiveScriptProfilerControl5": ["1c01a2d1-8f0f-46a5-9720-0d7ed2c62f0a"],
    "IActiveScriptProfilerHeapEnum": ["32e4694e-0d37-419b-b93d-fa20ded6e8ea"],
    "IActiveScriptSiteDebugEx": ["bb722ccb-6ad2-41c6-b780-af9c03ee69f5"],
    "IActiveScriptSiteDebugHelper": ["eddf3210-989c-452b-bb30-bfdc338f0f32"],
    "IActiveScriptSiteUIControl": ["aedae97e-d7ee-4796-b960-7f092ae844ab"],
    "IActiveScriptStringCompare": ["58562769-ed52-42f7-8403-4963514e1f11"],
    "IActiveScriptWinRTErrorDebug": ["73a3f82a-0fe9-4b33-ba3b-fe095f697e0a"],
    "IActiveXPlugin": ["06dd38d1-d187-11cf-a80d-00c04fd74ad8"],
    "IActiveXUIHandlerSite": ["30510853-98b5-11cf-bb82-00aa00bdce0b"],
    "IActiveXUIHandlerSite2": ["7e3707b2-d087-4542-ac1f-a0d2fcd080fd"],
    "IActiveXUIHandlerSite3": ["7904009a-1238-47f4-901c-871375c34608"],
    "IActiveZBand": ["d97a25b9-e3df-444c-afc6-2d12c0ffee84"],
    "IActiveZBandNotification": ["0c40987c-7026-499e-adad-c164c0ffee84"],
    "IActiveZBandNotificationForMonitor": ["78c8b458-dd5a-4f32-9d8b-d45a19ae9e1f"],
    "IActiveZBandNotificationForMonitorService": ["0f019ffe-0388-4dcf-a2e2-f059a60a5704"],
    "IActivitySensor": ["cd7a630c-fb5f-48eb-b09b-a2708d1c61ef"],
    "IActivitySensorReading": ["85125a96-1472-40a2-b2ae-e1ef29226c78"],
    "IActivitySensorReadingChangeReport": ["4f3c2915-d93b-47bd-960a-f20fb2f322b9"],
    "IActivitySensorReadingChangedEventArgs": ["de386717-aeb6-4ec7-946a-d9cc19b951ec"],
    "IActivitySensorStatics": ["a71e0e9d-ee8b-45d1-b25b-08cc0df92ab6"],
    "IActivitySensorTrigger": ["d0dd4342-e37b-4823-a5fe-6b31dfefdeb0"],
    "IActivitySensorTriggerDetails": ["2c9e6612-b9ca-4677-b263-243297f79d3a"],
    "IActivitySensorTriggerFactory": ["a72691c3-3837-44f7-831b-0132cc872bc3"],
    "IAdapterPnpManagement": ["706f2368-4086-47f5-b913-57b76eed1a32"],
    "IAdapterPowerManagement": ["793417d0-35fe-11d1-ad08-00a0c90ab1b0"],
    "IAdapterPowerManagement2": ["e0f92e5d-67f5-48ee-b57a-7d1e90c5f43d"],
    "IAdapterPowerManagement3": ["a8c7303e-f80c-4bc9-b2e3-fb2d08be920f"],
    "IAdaptiveCard": ["72d0568c-a274-41cd-82a8-989d40b9b05e"],
    "IAdaptiveCardBuilderStatics": ["766d8f08-d3fe-4347-a0bc-b9ea9a6dc28e"],
    "IAdaptiveMediaSource": ["4c7332ef-d39f-4396-b4d9-043957a7c964"],
    "IAdaptiveMediaSource2": ["17890342-6760-4bb9-a58a-f7aa98b08c0e"],
    "IAdaptiveMediaSource3": ["ba7023fd-c334-461b-a36e-c99f54f7174a"],
    "IAdaptiveMediaSourceAdvancedSettings": ["55db1680-1aeb-47dc-aa08-9a11610ba45a"],
    "IAdaptiveMediaSourceCorrelatedTimes": ["05108787-e032-48e1-ab8d-002b0b3051df"],
    "IAdaptiveMediaSourceCreationResult": ["4686b6b2-800f-4e31-9093-76d4782013e7"],
    "IAdaptiveMediaSourceCreationResult2": ["1c3243bf-1c44-404b-a201-df45ac7898e8"],
    "IAdaptiveMediaSourceDiagnosticAvailableEventArgs": ["3af64f06-6d9c-494a-b7a9-b3a5dee6ad68"],
    "IAdaptiveMediaSourceDiagnosticAvailableEventArgs2": ["8c6dd857-16a5-4d9f-810e-00bd901b3ef9"],
    "IAdaptiveMediaSourceDiagnosticAvailableEventArgs3": ["c3650cd5-daeb-4103-84da-68769ad513ff"],
    "IAdaptiveMediaSourceDiagnostics": ["9b24ee68-962e-448c-aebf-b29b56098e23"],
    "IAdaptiveMediaSourceDownloadBitrateChangedEventArgs": ["670c0a44-e04e-4eff-816a-17399f78f4ba"],
    "IAdaptiveMediaSourceDownloadBitrateChangedEventArgs2": ["f3f1f444-96ae-4de0-b540-2b3246e6968c"],
    "IAdaptiveMediaSourceDownloadCompletedEventArgs": ["19240dc3-5b37-4a1a-8970-d621cb6ca83b"],
    "IAdaptiveMediaSourceDownloadCompletedEventArgs2": ["704744c4-964a-40e4-af95-9177dd6dfa00"],
    "IAdaptiveMediaSourceDownloadCompletedEventArgs3": ["0f8a8bd1-93b2-47c6-badc-8be2c8f7f6e8"],
    "IAdaptiveMediaSourceDownloadFailedEventArgs": ["37739048-f4ab-40a4-b135-c6dfd8bd7ff1"],
    "IAdaptiveMediaSourceDownloadFailedEventArgs2": ["70919568-967c-4986-90c5-c6fc4b31e2d8"],
    "IAdaptiveMediaSourceDownloadFailedEventArgs3": ["d0354549-1132-4a10-915a-c2211b5b9409"],
    "IAdaptiveMediaSourceDownloadRequestedDeferral": ["05c68f64-fa20-4dbd-9821-4bf4c9bf77ab"],
    "IAdaptiveMediaSourceDownloadRequestedEventArgs": ["c83fdffd-44a9-47a2-bf96-03398b4bfaaf"],
    "IAdaptiveMediaSourceDownloadRequestedEventArgs2": ["b37d8bfe-aa44-4d82-825b-611de3bcfecb"],
    "IAdaptiveMediaSourceDownloadRequestedEventArgs3": ["333c50fd-4f62-4481-ab44-1e47b0574225"],
    "IAdaptiveMediaSourceDownloadResult": ["f4afdc73-bcee-4a6a-9f0a-fec41e2339b0"],
    "IAdaptiveMediaSourceDownloadResult2": ["15552cb7-7b80-4ac4-8660-a4b97f7c70f0"],
    "IAdaptiveMediaSourceDownloadStatistics": ["a306cefb-e96a-4dff-a9b8-1ae08c01ae98"],
    "IAdaptiveMediaSourcePlaybackBitrateChangedEventArgs": ["23a29f6d-7dda-4a51-87a9-6fa8c5b292be"],
    "IAdaptiveMediaSourceStatics": ["50a6bd5d-66ef-4cd3-9579-9e660507dc3f"],
    "IAdaptiveNotificationContent": ["eb0dbe66-7448-448d-9db8-d78acd2abba9"],
    "IAdaptiveNotificationText": ["46d4a3be-609a-4326-a40b-bfde872034a3"],
    "IAdaptiveSpatialAudioRenderer": ["24bdc606-d710-4d62-be35-be665fbc3e00"],
    "IAdaptiveTrigger": ["a5f04119-0cd9-49f1-a23f-44e547ab9f1a"],
    "IAdaptiveTriggerFactory": ["c966d482-5aeb-4841-9247-c1a0bdd6f59f"],
    "IAdaptiveTriggerStatics": ["b92e29ea-1615-4350-9c3b-92b2986bf444"],
    "IAdcChannel": ["040bf414-2588-4a56-abef-73a260acc60a"],
    "IAdcController": ["2a76e4b0-a896-4219-86b6-ea8cdce98f56"],
    "IAdcControllerProvider": ["be545828-816d-4de5-a048-aba06958aaa8"],
    "IAdcControllerStatics": ["cce98e0c-01f8-4891-bc3b-be53ef279ca4"],
    "IAdcControllerStatics2": ["a2b93b1d-977b-4f5a-a5fe-a6abaffe6484"],
    "IAdcProvider": ["28953668-9359-4c57-bc88-e275e81638c9"],
    "IAddAppointmentOperation": ["ec4a9af3-620d-4c69-add7-9794e918081f"],
    "IAddDeleteThemeTransition": ["adec852e-4424-4dab-99c1-3a04e36a3c48"],
    "IAddPackageOptions": ["05cee018-f68f-422b-95a4-66679ec77fc0"],
    "IAddPagesEventArgs": ["e2e52be5-056c-4420-9795-cb3526ce0c20"],
    "IAddPagesEventHandler": ["d4b57970-57a0-4209-847c-c093b54bc729"],
    "IAddinDesigner": ["ac0714f3-3d04-11d1-ae7d-00a0c90f26f4"],
    "IAddinInstance": ["ac0714f4-3d04-11d1-ae7d-00a0c90f26f4"],
    "IAddressBand": ["22c440df-4720-4b3a-a472-0ccb6e6cdd97"],
    "IAddressBandEx": ["a695888c-e3fe-47c2-82c0-ccd5890a243f"],
    "IAddressEditBox": ["4acda08f-21cf-45ae-a5d5-75cb63d3c4ee"],
    "IAdvancedCapturedPhoto": ["f072728b-b292-4491-9d41-99807a550bbf"],
    "IAdvancedCapturedPhoto2": ["18cf6cd8-cffe-42d8-8104-017bb318f4a1"],
    "IAdvancedColorInfo": ["8797dcfb-b229-4081-ae9a-2cc85e34ad6a"],
    "IAdvancedMediaCapture": ["d0751585-d216-4344-b5bf-463b68f977bb"],
    "IAdvancedMediaCaptureInitializationSettings": ["3de21209-8ba6-4f2a-a577-2819b56ff14d"],
    "IAdvancedMediaCaptureSettings": ["24e0485f-a33e-4aa1-b564-6019b1d14f65"],
    "IAdvancedPhotoCapture": ["83ffaafa-6667-44dc-973c-a6bce596aa0f"],
    "IAdvancedPhotoCaptureSettings": ["08f3863a-0018-445b-93d2-646d1c5ed05c"],
    "IAdvancedPhotoControl": ["c5b15486-9001-4682-9309-68eae0080eec"],
    "IAdvancedSettingsWriter": ["5d703587-da7e-43c0-982c-2ba8e7ed341b"],
    "IAdvancedVideoCaptureDeviceController": ["de6ff4d3-2b96-4583-80ab-b5b01dc6a8d7"],
    "IAdvancedVideoCaptureDeviceController2": ["8bb94f8f-f11a-43db-b402-11930b80ae56"],
    "IAdvancedVideoCaptureDeviceController3": ["a98b8f34-ee0d-470c-b9f0-4229c4bbd089"],
    "IAdvancedVideoCaptureDeviceController4": ["ea9fbfaf-d371-41c3-9a17-824a87ebdfd2"],
    "IAdvancedVideoCaptureDeviceController5": ["33512b17-b9cb-4a23-b875-f9eaab535492"],
    "IAdvancedVideoCaptureDeviceController6": ["b6563a53-68a1-44b7-9f89-b5fa97ac0cbe"],
    "IAdvancedVideoCaptureDeviceController7": ["8d2927f0-a054-50e7-b7df-7c04234d10f0"],
    "IAdvancedVideoCaptureDeviceController8": ["d843f010-e7fb-595b-9a78-0e54c4532b43"],
    "IAdvertisingManagerForUser": ["928bf3d0-cf7c-4ab0-a7dc-6dc5bcd44252"],
    "IAdvertisingManagerStatics": ["add3468c-a273-48cb-b346-3544522d5581"],
    "IAdvertisingManagerStatics2": ["dd0947af-1a6d-46b0-95bc-f3f9d6beb9fb"],
    "IAdviseOplockCallback": ["68766f36-3808-42f9-a18f-0abde6391172"],
    "IAgentTransportShutdownCallback": ["1eca6ebc-4b7a-4ba6-8516-db38df0045a5"],
    "IAggregateContactManager": ["0379d5dd-db5a-4fd3-b54e-4df17917a212"],
    "IAggregateContactManager2": ["5e8cc2d8-a9cd-4430-9c4b-01348db2ca50"],
    "IAggregateMultipleValues": ["24ebb68f-764b-484f-8e96-1be0c78a45e6"],
    "IAggregatePropertyStoreFactory": ["ab0a3f41-c316-458c-92e6-6d1495590def"],
    "IAggregatedIdentity": ["00000039-0000-0000-c000-000000000046"],
    "IAggregatedInterruptResponse": ["21b98aa2-dbd8-4e6b-821c-ac9c015a0609"],
    "IAggregator": ["000001d8-0000-0000-c000-000000000046"],
    "IAgileObject": ["94ea2b94-e9cc-49e0-c0ff-ee64ca8f5b90"],
    "IAgileReference": ["c03f6a43-65a4-9818-987e-e0b810d2a6f2"],
    "IAimInterop": ["7fc7255a-3a9d-4776-9bbb-a435510ef6ea"],
    "IAlarmApplicationManagerStatics": ["ca03fa3b-cce6-4de2-b09b-9628bd33bbbe"],
    "IAlertDataCollector": ["03837516-098b-11d8-9414-505054503030"],
    "IAliasedNamespace": ["fdbee76e-f12b-408e-93ab-9be8521000d9"],
    "IAllJoynAboutData": ["e5a9bf00-1fa2-4839-93ef-f9df404890f7"],
    "IAllJoynAboutDataView": ["6823111f-6212-4934-9c48-e19ca4984288"],
    "IAllJoynAboutDataViewStatics": ["57edb688-0c5e-416e-88b5-39b32d25c47d"],
    "IAllJoynAcceptSessionJoiner": ["4da817d2-cd1d-4023-a7c4-16def89c28df"],
    "IAllJoynAcceptSessionJoinerEventArgs": ["4efb5365-3e8a-4257-8f10-539ce0d56c0f"],
    "IAllJoynAcceptSessionJoinerEventArgsFactory": ["b4435bc0-6145-429e-84db-d5bfe772b14f"],
    "IAllJoynAuthenticationCompleteEventArgs": ["97b4701c-15dc-4b53-b6a4-7d134300d7bf"],
    "IAllJoynBusAttachment": ["f309f153-1eed-42c3-a20e-436d41fe62f6"],
    "IAllJoynBusAttachment2": ["3474cb1e-2368-43b2-b43e-6a3ac1278d98"],
    "IAllJoynBusAttachmentFactory": ["642ef1a4-ad85-4ddf-90ae-604452b22288"],
    "IAllJoynBusAttachmentStateChangedEventArgs": ["d82e75f4-c02a-41ec-a8d5-eab1558953aa"],
    "IAllJoynBusAttachmentStatics": ["839d4d3d-1051-40d7-872a-8d0141115b1f"],
    "IAllJoynBusObject": ["e8fd825e-f73a-490c-8804-04e026643047"],
    "IAllJoynBusObjectFactory": ["2c2f9f0b-8e02-4f9c-ac27-ea6dad5d3b50"],
    "IAllJoynBusObjectStoppedEventArgs": ["de102115-ef8e-4d42-b93b-a2ae74519766"],
    "IAllJoynBusObjectStoppedEventArgsFactory": ["6b22fd48-d0a3-4255-953a-4772b4028073"],
    "IAllJoynCredentials": ["824650f2-a190-40b1-abab-349ec244dfaa"],
    "IAllJoynCredentialsRequestedEventArgs": ["6a87e34e-b069-4b80-9e1a-41bc837c65d2"],
    "IAllJoynCredentialsVerificationRequestedEventArgs": ["800a7612-b805-44af-a2e1-792ab655a2d0"],
    "IAllJoynMessageInfo": ["ff2b0127-2c12-4859-aa3a-c74461ee814c"],
    "IAllJoynMessageInfoFactory": ["34664c2a-8289-43d4-b4a8-3f4de359f043"],
    "IAllJoynProducer": ["9d084679-469b-495a-a710-ac50f123069f"],
    "IAllJoynProducerStoppedEventArgs": ["51309770-4937-492d-8080-236439987ceb"],
    "IAllJoynProducerStoppedEventArgsFactory": ["56529961-b219-4d6e-9f78-fa3f99fa8fe5"],
    "IAllJoynServiceInfo": ["4cbe8209-b93e-4182-999b-ddd000f9c575"],
    "IAllJoynServiceInfoFactory": ["7581dabd-fe03-4f4b-94a4-f02fdcbd11b8"],
    "IAllJoynServiceInfoRemovedEventArgs": ["3057a95f-1d3f-41f3-8969-e32792627396"],
    "IAllJoynServiceInfoRemovedEventArgsFactory": ["0dbf8627-9aff-4955-9227-6953baf41569"],
    "IAllJoynServiceInfoStatics": ["5678570a-603a-49fc-b750-0ef13609213c"],
    "IAllJoynSession": ["e8d11b0c-c0d4-406c-88a9-a93efa85d4b1"],
    "IAllJoynSessionJoinedEventArgs": ["9e9f5bd0-b5d7-47c5-8dab-b040cc192871"],
    "IAllJoynSessionJoinedEventArgsFactory": ["6824d689-d6cb-4d9e-a09e-35806870b17f"],
    "IAllJoynSessionLostEventArgs": ["e766a48a-8bb8-4954-ae67-d2fa43d1f96b"],
    "IAllJoynSessionLostEventArgsFactory": ["13bbfd32-d2f4-49c9-980e-2805e13586b1"],
    "IAllJoynSessionMemberAddedEventArgs": ["49a2798a-0dd1-46c1-9cd6-27190e503a5e"],
    "IAllJoynSessionMemberAddedEventArgsFactory": ["341de352-1d33-40a1-a1d3-e5777020e1f1"],
    "IAllJoynSessionMemberRemovedEventArgs": ["409a219f-aa4a-4893-b430-baa1b63c6219"],
    "IAllJoynSessionMemberRemovedEventArgsFactory": ["c4d355e8-42b8-4b67-b757-d0cfcad59280"],
    "IAllJoynSessionStatics": ["9e05d604-a06c-46d4-b46c-0b0b54105b44"],
    "IAllJoynStatusStatics": ["d0b7a17e-0d29-4da9-8ac6-54c554bedbc5"],
    "IAllJoynWatcherStoppedEventArgs": ["c9fca03b-701d-4aa8-97dd-a2bb0a8f5fa3"],
    "IAllJoynWatcherStoppedEventArgsFactory": ["878fa5a8-2d50-47e1-904a-20bf0d48c782"],
    "IAllUpViewHost": ["389221b7-bf28-4d25-9501-b4491d822be1"],
    "IAllUpViewInvoker": ["e053969d-e07d-482d-ae3b-17d1f01bf1ad"],
    "IAllocatorMXF": ["a5f0d62c-b30f-11d2-b7a3-0060083316c1", "a5f0d62c-b30f-11d2-b7a3-0060083316c1"],
    "IAltTabLoadSink": ["528ffb4c-0620-4c0f-ab7c-f85596896e09"],
    "IAltTabViewHost": ["405444d2-baa5-48ed-abfe-a673f70be863"],
    "IAlterIndex": ["0c733aa6-2a1c-11ce-ade5-00aa0044773d"],
    "IAlterTable": ["0c733aa5-2a1c-11ce-ade5-00aa0044773d"],
    "IAlternateWordForm": ["47396c1e-51b9-4207-9146-248e636a1d1d"],
    "IAlternativeName": ["728ab313-217d-11da-b2a4-000e7bbb2b09"],
    "IAlternativeNames": ["728ab314-217d-11da-b2a4-000e7bbb2b09"],
    "IAltimeter": ["72f057fd-8f04-49f1-b4a7-f4e363b701a2"],
    "IAltimeter2": ["c9471bf9-2add-48f5-9f08-3d0c7660d938"],
    "IAltimeterReading": ["fbe8ef73-7f5e-48c8-aa1a-f1f3befc1144"],
    "IAltimeterReading2": ["543a1bd9-6d0b-42b2-bd69-bc8fae0f782c"],
    "IAltimeterReadingChangedEventArgs": ["7069d077-446d-47f7-998c-ebc23b45e4a2"],
    "IAltimeterStatics": ["9eb4d7c3-e5ac-47ce-8eef-d3718168c01f"],
    "IAmAFiringAgent": ["0771cb93-da7c-44b5-8196-422e6a2fbc40"],
    "IAmbientLight": ["a48130a1-b7c4-46f7-b9bf-daf43a44e6ee"],
    "IAmbientLight2": ["3b64a6bf-5f97-4c94-86e5-042dd386b27d"],
    "IAmsiStream": ["3e47f2e5-81d4-4d3b-897f-545096770373"],
    "IAnalogAudioComponentType": ["2cfeb2a8-1787-4a24-a941-c6eaec39c842"],
    "IAnalogLocator": ["34d1f26b-e339-430d-abce-738cb48984dc"],
    "IAnalogRadioTuningSpace": ["2a6e293b-2595-11d3-b64c-00c04f79498e"],
    "IAnalogRadioTuningSpace2": ["39dd45da-2da8-46ba-8a8a-87e2b73d983a"],
    "IAnalogTVTuningSpace": ["2a6e293c-2595-11d3-b64c-00c04f79498e"],
    "IAnalyticsInfoStatics": ["1d5ee066-188d-5ba9-4387-acaeb0e7e305"],
    "IAnalyticsInfoStatics2": ["101704ea-a7f9-46d2-ab94-016865afdb25"],
    "IAnalyticsVersionInfo": ["926130b8-9955-4c74-bdc1-7cd0decf9b03"],
    "IAnchorRequestedEventArgs": ["5175f55d-4785-5a72-b462-eb11e9bdf897"],
    "IAnimateWindowSize": ["22e4c895-8ab9-40bb-b81a-001dd9b1f449"],
    "IAnimationController": ["c934efd2-0722-4f5f-a4e2-9510f3d43bf7"],
    "IAnimationControllerStatics": ["e71164df-651b-4800-b9e5-6a3bcfed3365"],
    "IAnimationDescription": ["7d11a549-be3d-41de-b081-05c149962f9b"],
    "IAnimationDescriptionFactory": ["c6e27abe-c1fb-48b5-9271-ecc70ac86ef0"],
    "IAnimationObject": ["e7141e0a-04b8-4fc5-a4dc-195392e57807"],
    "IAnimationPropertyInfo": ["f4716f05-ed77-4e3c-b328-5c3985b3738f"],
    "IAnnotationPatternIdentifiers": ["d475a0c1-48b2-4e40-a6cf-3dc4b638c0de"],
    "IAnnotationPatternIdentifiersStatics": ["e0e3a35d-d167-46dc-95ab-330af61aebb5"],
    "IAnnotationProvider": ["95ba1417-4437-451b-9461-050a49b59d06", "f95c7e80-bd63-4601-9782-445ebff011fc"],
    "IAntimalware": ["82d29c2e-f062-44e6-b5c9-3d9a2f24a2df"],
    "IAntimalwareProvider": ["b2cabfe3-fe04-42b1-a5df-08d483d4d125"],
    "IAntimalwareUacProvider": ["b2cabfe4-fe04-42b1-a5df-08d483d4d125"],
    "IApartmentCallback": ["178e5337-1528-4591-b1c9-1c6e484686d8"],
    "IApartmentShutdown": ["a2f05a09-27a2-42b5-bc0e-ac163ef49d9b"],
    "IApiInformationStatics": ["997439fe-f681-4a11-b416-c13a47e8ba36"],
    "IApiTracingDataCollector": ["0383751a-098b-11d8-9414-505054503030"],
    "IAppActivationFailedHandler": ["ba8e2d49-2e77-4442-bf1c-34c22bedf42e"],
    "IAppActivationRemediationInfo": ["23655ae6-d92b-416f-b4d6-7c8218038718"],
    "IAppActivationResult": ["6b528900-f46e-4eb0-aa6c-38af557cf9ed"],
    "IAppActivationUIInfo": ["abad189d-9fa3-4278-b3ca-8ca448a88dcb"],
    "IAppApplicabilityStatics": ["1664a082-0f38-5c99-83e4-48995970861c"],
    "IAppBar": ["7b0fc253-86a5-4b43-9872-0b8a6234b74b"],
    "IAppBar2": ["c3ab17b3-7ad7-4676-9910-7fe3f0e8e993"],
    "IAppBar3": ["982b001f-752e-4e7a-b055-54802c9ea749"],
    "IAppBar4": ["94ebc8cd-0a64-4da3-bf43-f13100a46605"],
    "IAppBarAutomationPeer": ["8b4acfeb-89fa-4f13-84be-35ca5b7c9590"],
    "IAppBarAutomationPeerFactory": ["8360f4e2-e396-4517-af5d-f4cf34c54edf"],
    "IAppBarButton": ["4459a451-69e8-440c-9896-4bb4f5f642d1"],
    "IAppBarButton3": ["0b282150-198b-4e84-8f1c-9f6a8ba267a7"],
    "IAppBarButton4": ["958fce6b-fd08-4414-8458-9d40866dc84e"],
    "IAppBarButton5": ["4096fc7f-1aec-4b0f-a031-ca8c4e06d2ed"],
    "IAppBarButtonAutomationPeer": ["443262b2-4f6d-4b76-9d2e-3eff777e8864"],
    "IAppBarButtonAutomationPeerFactory": ["aef0342a-acb7-42dc-97e3-847071865fd6"],
    "IAppBarButtonFactory": ["bdbb1bb6-cb2e-4276-abd6-7935130510e0"],
    "IAppBarButtonStatics": ["7ccd13e6-5301-407f-874e-dc9160aa07af"],
    "IAppBarButtonStatics3": ["4d7bf314-2ede-4328-8906-752a1f27cdfa"],
    "IAppBarButtonStatics4": ["1c0ae26a-c755-4fe6-a3b6-0e3394e952c0"],
    "IAppBarButtonTemplateSettings": ["cbc9b39d-0c95-4951-bff2-13963691c366"],
    "IAppBarElementContainer": ["1d5ba067-a990-5dab-a9c3-e6be56642a1a"],
    "IAppBarElementContainerFactory": ["b506530e-8897-5d6f-a43e-f0586338d282"],
    "IAppBarElementContainerStatics": ["ebbef840-c745-5a6f-8671-9a41eb2196e7"],
    "IAppBarFactory": ["614708d1-8e65-43cb-92d7-8eee17515f8d"],
    "IAppBarOverrides": ["f003e4e2-7b0f-4f4a-970d-ae8a0eaa9b70"],
    "IAppBarOverrides3": ["412bbbc8-51d0-4b49-ab62-a3dd6bdcb298"],
    "IAppBarSeparator": ["1b0795a1-1bc1-4d53-95ea-fb0a2cccc905"],
    "IAppBarSeparatorFactory": ["05da25cd-f407-48de-8b50-ff87d1e2818f"],
    "IAppBarSeparatorStatics": ["37f23484-5b35-4663-a75d-f2d50cb9c619"],
    "IAppBarSeparatorStatics3": ["36c753f9-7373-4e5e-9ba4-c3622a003c4e"],
    "IAppBarStatics": ["79bb7e8d-dca9-4b5f-a448-37b13238ed76"],
    "IAppBarStatics2": ["222355e9-0384-49de-8738-dfc9d409ac5d"],
    "IAppBarStatics4": ["ba02082e-1165-4451-94b3-eb3ac73e4196"],
    "IAppBarTemplateSettings": ["bcc2a863-eb35-423c-8389-d7827be3bf67"],
    "IAppBarTemplateSettings2": ["cbe66259-0399-5bcc-b925-4d5f5c9a4568"],
    "IAppBarToggleButton": ["2e914438-fd53-4b8d-858b-3644269f8e4d"],
    "IAppBarToggleButton3": ["ef9a85e5-16ff-4d72-b9e8-9b861eaf84a8"],
    "IAppBarToggleButton4": ["b86b736e-3eaf-4751-a897-00029f1f6aca"],
    "IAppBarToggleButton5": ["9dca3357-c130-4fb6-a1e2-d2b348fe43be"],
    "IAppBarToggleButtonAutomationPeer": ["8464efad-9655-4aff-9550-63ae9ec8fe9c"],
    "IAppBarToggleButtonAutomationPeerFactory": ["d6f9139d-02c1-4221-9591-7d4efeb74701"],
    "IAppBarToggleButtonFactory": ["028aa7d4-8f54-45a6-9f90-13605656d793"],
    "IAppBarToggleButtonStatics": ["fe5aaf96-7929-4da1-aa67-cddf73a3e4b5"],
    "IAppBarToggleButtonStatics3": ["bd4c65bf-2edd-44d1-acd5-35c00e2f21bc"],
    "IAppBarToggleButtonStatics4": ["a478b984-e916-4137-bdbd-95bd46ff3ce6"],
    "IAppBarToggleButtonTemplateSettings": ["aaf99c48-d8f4-40d9-9fa3-3a64f0fec5d8"],
    "IAppBridgeData": ["d7bcecce-d68c-405d-b48f-fd7e70ad1e05"],
    "IAppBroadcastBackgroundService": ["bad1e72a-fa94-46f9-95fc-d71511cda70b"],
    "IAppBroadcastBackgroundService2": ["fc8ccbbf-5549-4b87-959f-23ca401fd473"],
    "IAppBroadcastBackgroundServiceSignInInfo": ["5e735275-88c8-4eca-89ba-4825985db880"],
    "IAppBroadcastBackgroundServiceSignInInfo2": ["9104285c-62cf-4a3c-a7ee-aeb507404645"],
    "IAppBroadcastBackgroundServiceStreamInfo": ["31dc02bc-990a-4904-aa96-fe364381f136"],
    "IAppBroadcastBackgroundServiceStreamInfo2": ["bd1e9f6d-94dc-4fce-9541-a9f129596334"],
    "IAppBroadcastCameraCaptureStateChangedEventArgs": ["1e334cd0-b882-4b88-8692-05999aceb70f"],
    "IAppBroadcastGlobalSettings": ["b2cb27a5-70fc-4e17-80bd-6ba0fd3ff3a0"],
    "IAppBroadcastHeartbeatRequestedEventArgs": ["cea54283-ee51-4dbf-9472-79a9ed4e2165"],
    "IAppBroadcastManagerStatics": ["364e018b-1e4e-411f-ab3e-92959844c156"],
    "IAppBroadcastMicrophoneCaptureStateChangedEventArgs": ["a86ad5e9-9440-4908-9d09-65b7e315d795"],
    "IAppBroadcastPlugIn": ["520c1e66-6513-4574-ac54-23b79729615b"],
    "IAppBroadcastPlugInManager": ["e550d979-27a1-49a7-bbf4-d7a9e9d07668"],
    "IAppBroadcastPlugInManagerStatics": ["f2645c20-5c76-4cdc-9364-82fe9eb6534d"],
    "IAppBroadcastPlugInStateChangedEventArgs": ["4881d0f2-abc5-4fc6-84b0-89370bb47212"],
    "IAppBroadcastPreview": ["14b60f5a-6e4a-4b80-a14f-67ee77d153e7"],
    "IAppBroadcastPreviewStateChangedEventArgs": ["5a57f2de-8dea-4e86-90ad-03fc26b9653c"],
    "IAppBroadcastPreviewStreamReader": ["92228d50-db3f-40a8-8cd4-f4e371ddab37"],
    "IAppBroadcastPreviewStreamVideoFrame": ["010fbea1-94fe-4499-b8c0-8d244279fb12"],
    "IAppBroadcastPreviewStreamVideoHeader": ["8bef6113-da84-4499-a7ab-87118cb4a157"],
    "IAppBroadcastProviderSettings": ["c30bdf62-9948-458f-ad50-aa06ec03da08"],
    "IAppBroadcastServices": ["8660b4d6-969b-4e3c-ac3a-8b042ee4ee63"],
    "IAppBroadcastSignInStateChangedEventArgs": ["02b692a4-5919-4a9e-8d5e-c9bb0dd3377a"],
    "IAppBroadcastState": ["ee08056d-8099-4ddd-922e-c56dac58abfb"],
    "IAppBroadcastStreamAudioFrame": ["efab4ac8-21ba-453f-8bb7-5e938a2e9a74"],
    "IAppBroadcastStreamAudioHeader": ["bf21a570-6b78-4216-9f07-5aff5256f1b7"],
    "IAppBroadcastStreamReader": ["b338bcf9-3364-4460-b5f1-3cc2796a8aa2"],
    "IAppBroadcastStreamStateChangedEventArgs": ["5108a733-d008-4a89-93be-58aed961374e"],
    "IAppBroadcastStreamVideoFrame": ["0f97cf2b-c9e4-4e88-8194-d814cbd585d8"],
    "IAppBroadcastStreamVideoHeader": ["0b9ebece-7e32-432d-8ca2-36bf10b9f462"],
    "IAppBroadcastTrigger": ["74d4f496-8d37-44ec-9481-2a0b9854eb48"],
    "IAppBroadcastTriggerDetails": ["deebab35-ec5e-4d8f-b1c0-5da6e8c75638"],
    "IAppBroadcastTriggerFactory": ["280b9f44-22f4-4618-a02e-e7e411eb7238"],
    "IAppBroadcastTriggerProviderInfo": ["f219352d-9de8-4420-9ce2-5eff8f17376b"],
    "IAppBroadcastViewerCountChangedEventArgs": ["e6e11825-5401-4ade-8bd2-c14ecee6807d"],
    "IAppBroadcastingMonitor": ["00f95a68-8907-48a0-b8ef-24d208137542"],
    "IAppBroadcastingStatus": ["1225e4df-03a1-42f8-8b80-c9228cd9cf2e"],
    "IAppBroadcastingStatusDetails": ["069dada4-b573-4e3c-8e19-1bafacd09713"],
    "IAppBroadcastingUI": ["e56f9f8f-ee99-4dca-a3c3-70af3db44f5f"],
    "IAppBroadcastingUIStatics": ["55a8a79d-23cb-4579-9c34-886fe02c045a"],
    "IAppCapability": ["4c49d915-8a2a-4295-9437-2df7c396aff4"],
    "IAppCapabilityAccessChangedEventArgs": ["0a578d15-bdd7-457e-8cca-6f53bd2e5944"],
    "IAppCapabilityStatics": ["7c353e2a-46ee-44e5-af3d-6ad3fc49bd22"],
    "IAppCapture": ["9749d453-a29a-45ed-8f29-22d09942cff7"],
    "IAppCaptureAlternateShortcutKeys": ["19e8e0ef-236c-40f9-b38f-9b7dd65d1ccc"],
    "IAppCaptureAlternateShortcutKeys2": ["c3669090-dd17-47f0-95e5-ce42286cf338"],
    "IAppCaptureAlternateShortcutKeys3": ["7b81448c-418e-469c-a49a-45b597c826b6"],
    "IAppCaptureDurationGeneratedEventArgs": ["c1f5563b-ffa1-44c9-975f-27fbeb553b35"],
    "IAppCaptureFileGeneratedEventArgs": ["4189fbf4-465e-45bf-907f-165b3fb23758"],
    "IAppCaptureManagerStatics": ["7d9e3ea7-6282-4735-8d4e-aa45f90f6723"],
    "IAppCaptureMetadataWriter": ["e0ce4877-9aaf-46b4-ad31-6a60b441c780"],
    "IAppCaptureMicrophoneCaptureStateChangedEventArgs": ["324d249e-45bc-4c35-bc35-e469fc7a69e0"],
    "IAppCaptureRecordOperation": ["c66020a9-1538-495c-9bbb-2ba870ec5861"],
    "IAppCaptureRecordingStateChangedEventArgs": ["24fc8712-e305-490d-b415-6b1c9049736b"],
    "IAppCaptureServices": ["44fec0b5-34f5-4f18-ae8c-b9123abbfc0d"],
    "IAppCaptureSettings": ["14683a86-8807-48d3-883a-970ee4532a39"],
    "IAppCaptureSettings2": ["fcb8cee7-e26b-476f-9b1a-ec342d2a8fde"],
    "IAppCaptureSettings3": ["a93502fe-88c2-42d6-aaaa-40feffd75aec"],
    "IAppCaptureSettings4": ["07c2774c-1a81-482f-a244-049d95f25b0b"],
    "IAppCaptureSettings5": ["18894522-b0e8-4ba0-8f13-3eaa5fa4013b"],
    "IAppCaptureState": ["73134372-d4eb-44ce-9538-465f506ac4ea"],
    "IAppCaptureStatics": ["f922dd6c-0a7e-4e74-8b20-9c1f902d08a1"],
    "IAppCaptureStatics2": ["b2d881d4-836c-4da4-afd7-facc041e1cf3"],
    "IAppDataPaths": ["7301d60a-79a2-48c9-9ec0-3fda092f79e1"],
    "IAppDataPathsStatics": ["d8eb2afe-a9d9-4b14-b999-e3921379d903"],
    "IAppDiagnosticInfo": ["e348a69a-8889-4ca3-be07-d5ffff5f0804"],
    "IAppDiagnosticInfo2": ["df46fbd7-191a-446c-9473-8fbc2374a354"],
    "IAppDiagnosticInfo3": ["c895c63d-dd61-4c65-babd-81a10b4f9815"],
    "IAppDiagnosticInfoStatics": ["ce6925bf-10ca-40c8-a9ca-c5c96501866e"],
    "IAppDiagnosticInfoStatics2": ["05b24b86-1000-4c90-bb9f-7235071c50fe"],
    "IAppDiagnosticInfoWatcher": ["75575070-01d3-489a-9325-52f9cc6ede0a"],
    "IAppDiagnosticInfoWatcherEventArgs": ["7017c716-e1da-4c65-99df-046dff5be71a"],
    "IAppDisplayInfo": ["1aeb1103-e4d4-41aa-a4f6-c4a276e79eac"],
    "IAppDomainBinding": ["5c2b07a7-1e98-11d3-872f-00c04f79ed0d"],
    "IAppDomainInfo110": ["585dbb5b-a542-4296-bec6-29d12a7b016c"],
    "IAppExecutionStateChangeResult": ["6f039bf0-f91b-4df8-ae77-3033ccb69114"],
    "IAppExtension": ["8450902c-15ed-4faf-93ea-2237bbf8cbd6"],
    "IAppExtensionCatalog": ["97872032-8426-4ad1-9084-92e88c2da200"],
    "IAppExtensionCatalogStatics": ["3c36668a-5f18-4f0b-9ce5-cab61d196f11"],
    "IAppExtensionPackageInstalledEventArgs": ["39e59234-3351-4a8d-9745-e7d3dd45bc48"],
    "IAppExtensionPackageStatusChangedEventArgs": ["1ce17433-1153-44fd-87b1-8ae1050303df"],
    "IAppExtensionPackageUninstallingEventArgs": ["60f160c5-171e-40ff-ae98-ab2c20dd4d75"],
    "IAppExtensionPackageUpdatedEventArgs": ["3a83c43f-797e-44b5-ba24-a4c8b5a543d7"],
    "IAppExtensionPackageUpdatingEventArgs": ["7ed59329-1a65-4800-a700-b321009e306a"],
    "IAppHostAdminManager": ["9be77978-73ed-4a9a-87fd-13f09fec1b13"],
    "IAppHostChangeHandler": ["09829352-87c2-418d-8d79-4133969a489d"],
    "IAppHostChildElementCollection": ["08a90f5f-0702-48d6-b45f-02a9885a9768"],
    "IAppHostCollectionSchema": ["de095db1-5368-4d11-81f6-efef619b7bcf"],
    "IAppHostConfigException": ["4dfa1df3-8900-4bc7-bbb5-d1a458c52410"],
    "IAppHostConfigFile": ["ada4e6fb-e025-401e-a5d0-c3134a281f07"],
    "IAppHostConfigLocation": ["370af178-7758-4dad-8146-7391f6e18585"],
    "IAppHostConfigLocationCollection": ["832a32f7-b3ea-4b8c-b260-9a2923001184"],
    "IAppHostConfigManager": ["8f6d760f-f0cb-4d69-b5f6-848b33e9bdc6"],
    "IAppHostConstantValue": ["0716caf8-7d05-4a46-8099-77594be91394"],
    "IAppHostConstantValueCollection": ["5b5a68e6-8b9f-45e1-8199-a95ffccdffff"],
    "IAppHostElement": ["64ff8ccc-b287-4dae-b08a-a72cbf45f453"],
    "IAppHostElementCollection": ["c8550bff-5281-4b1e-ac34-99b6fa38464d"],
    "IAppHostElementExtension": ["518eb37d-1ff4-42dd-86c3-3140bc35b823"],
    "IAppHostElementSchema": ["ef13d885-642c-4709-99ec-b89561c6bc69"],
    "IAppHostElementSchemaCollection": ["0344cdda-151e-4cbf-82da-66ae61e97754"],
    "IAppHostMappingExtension": ["31a83ea0-c0e4-4a2c-8a01-353cc2a4c60a"],
    "IAppHostMethod": ["7883ca1c-1112-4447-84c3-52fbeb38069d"],
    "IAppHostMethodCollection": ["d6c7cd8f-bb8d-4f96-b591-d3a5f1320269"],
    "IAppHostMethodExtension": ["70184ac9-7673-4770-96b1-445ce035cf70"],
    "IAppHostMethodInstance": ["b80f3c42-60e0-4ae0-9007-f52852d3dbed"],
    "IAppHostMethodSchema": ["2d9915fb-9d42-4328-b782-1b46819fab9e"],
    "IAppHostPathMapper": ["e7927575-5cc3-403b-822e-328a6b904bee"],
    "IAppHostPathMapper2": ["0f80e901-8f4c-449a-bf90-13d5d082f187"],
    "IAppHostProperty": ["ed35f7a1-5024-4e7b-a44d-07ddaf4b524d"],
    "IAppHostPropertyCollection": ["0191775e-bcff-445a-b4f4-3bdda54e2816"],
    "IAppHostPropertyException": ["eafe4895-a929-41ea-b14d-613e23f62b71"],
    "IAppHostPropertyExtension": ["88e220f3-33e8-4534-afac-b4a98eccf9ae"],
    "IAppHostPropertySchema": ["450386db-7409-4667-935e-384dbbee2a9e"],
    "IAppHostPropertySchemaCollection": ["8bed2c68-a5fb-4b28-8581-a0dc5267419f"],
    "IAppHostSectionDefinition": ["c5c04795-321c-4014-8fd6-d44658799393"],
    "IAppHostSectionDefinitionCollection": ["b7d381ee-8860-47a1-8af4-1f33b2b1f325"],
    "IAppHostSectionGroup": ["0dd8a158-ebe6-4008-a1d9-b7ecc8f1104b"],
    "IAppHostWritableAdminManager": ["fa7660f6-7b3f-4237-a8bf-ed0ad0dcbbd9"],
    "IAppIdAuthority": ["8c87810c-2541-4f75-b2d0-9af515488e23"],
    "IAppInfo": ["cf7f59b3-6a09-4de8-a6c0-5792d56880d1"],
    "IAppInfo2": ["be4b1f5a-2098-431b-bd25-b30878748d47"],
    "IAppInfoStatics": ["cf1f782a-e48b-4f0c-9b0b-79c3f8957dd7"],
    "IAppInstallItem": ["49d3dfab-168a-4cbf-a93a-9e448c82737d"],
    "IAppInstallItem2": ["d3972af8-40c0-4fd7-aa6c-0aa13ca6188c"],
    "IAppInstallItem3": ["6f3dc998-dd47-433c-9234-560172d67a45"],
    "IAppInstallItem4": ["c2d1ce12-71ff-4fc8-b540-453d4b37e1d1"],
    "IAppInstallItem5": ["5510e7cc-4076-4a0b-9472-c21d9d380e55"],
    "IAppInstallManager": ["9353e170-8441-4b45-bd72-7c2fa925beee"],
    "IAppInstallManager2": ["16937851-ed37-480d-8314-52e27c03f04a"],
    "IAppInstallManager3": ["95b24b17-e96a-4d0e-84e1-c8cb417a0178"],
    "IAppInstallManager4": ["260a2a16-5a9e-4ebd-b944-f2ba75c31159"],
    "IAppInstallManager5": ["3cd7be4c-1be9-4f7f-b675-aa1d64a529b2"],
    "IAppInstallManager6": ["c9e7d408-f27a-4471-b2f4-e76efcbebcca"],
    "IAppInstallManager7": ["a5ee7b30-d5e4-49a3-9853-3db03203321d"],
    "IAppInstallManagerItemEventArgs": ["bc505743-4674-4dd1-957e-c25682086a14"],
    "IAppInstallOptions": ["c9808300-1cb8-4eb6-8c9f-6a30c64a5b51"],
    "IAppInstallOptions2": ["8a04c0d7-c94b-425e-95b4-bf27faeaee89"],
    "IAppInstallStatus": ["936dccfa-2450-4126-88b1-6127a644dd5c"],
    "IAppInstallStatus2": ["96e7818a-5e92-4aa9-8edc-58fed4b87e00"],
    "IAppInstallStatus3": ["cb880c56-837b-4b4c-9ebb-6d44a0a96307"],
    "IAppInstallerInfo": ["29ab2ac0-d4f6-42a3-adcd-d6583c659508"],
    "IAppInstance": ["675f2b47-f25f-4532-9fd6-3633e0634d01"],
    "IAppInstanceStatics": ["9d11e77f-9ea6-47af-a6ec-46784c5ba254"],
    "IAppLayoutCache": ["e511e73c-cad4-40aa-bf1a-b9938ac75ff0"],
    "IAppLicenseManagerInternal": ["5f909710-d28c-4a6c-9a2e-bcf284836e80"],
    "IAppListEntry": ["ef00f07f-2108-490a-877a-8a9f17c25fad"],
    "IAppListEntry2": ["d0a618ad-bf35-42ac-ac06-86eeeb41d04b"],
    "IAppListEntry3": ["6099f28d-fc32-470a-bc69-4b061a76ef2e"],
    "IAppMemoryReport": ["6d65339b-4d6f-45bc-9c5e-e49b3ff2758d"],
    "IAppMemoryReport2": ["5f7f3738-51b7-42dc-b7ed-79ba46d28857"],
    "IAppMemoryUsageLimitChangingEventArgs": ["79f86664-feca-4da5-9e40-2bc63efdc979"],
    "IAppReadinessFirstLogonApps": ["71810574-b03b-49ca-a1d6-9ca263536563"],
    "IAppReadinessService": ["29b6a139-cf48-4840-8d2f-e08c7c949b44"],
    "IAppReadinessServiceForUser": ["300fdaa3-4ddf-4bf3-9122-2bb0c7f71d7a"],
    "IAppReadinessTask": ["96080be3-6332-4825-92ef-ba6c9ac6d91d"],
    "IAppReadinessTaskCallback": ["de8ed432-fd92-47a6-9c73-738c7b466c69"],
    "IAppRecordingManager": ["e7e26076-a044-48e2-a512-3094d574c7cc"],
    "IAppRecordingManagerStatics": ["50e709f7-38ce-4bd3-9db2-e72bbe9de11d"],
    "IAppRecordingResult": ["3a900864-c66d-46f9-b2d9-5bc2dad070d7"],
    "IAppRecordingSaveScreenshotResult": ["9c5b8d0a-0abb-4457-aaee-24f9c12ec778"],
    "IAppRecordingSavedScreenshotInfo": ["9b642d0a-189a-4d00-bf25-e1bb1249d594"],
    "IAppRecordingStatus": ["1d0cc82c-bc18-4b8a-a6ef-127efab3b5d9"],
    "IAppRecordingStatusDetails": ["b538a9b0-14ed-4412-ac45-6d672c9c9949"],
    "IAppRep2": ["11a95ac9-bd61-4e16-8c56-c654268488bf"],
    "IAppRepParm2": ["8ca16e67-129f-489f-84cf-a8e317a2263b"],
    "IAppResolverPinToStart": ["6b1d7151-7a17-4c66-abc4-c9b1bc6c0e8d"],
    "IAppResourceGroupBackgroundTaskReport": ["2566e74e-b05d-40c2-9dc1-1a4f039ea120"],
    "IAppResourceGroupInfo": ["b913f77a-e807-49f4-845e-7b8bdcfe8ee7"],
    "IAppResourceGroupInfo2": ["ee9b236d-d305-4d6b-92f7-6afdad72dedc"],
    "IAppResourceGroupInfoWatcher": ["d9b0a0fd-6e5a-4c72-8b17-09fec4a212bd"],
    "IAppResourceGroupInfoWatcherEventArgs": ["7a787637-6302-4d2f-bf89-1c12d0b2a6b9"],
    "IAppResourceGroupInfoWatcherExecutionStateChangedEventArgs": ["1bdbedd7-fee6-4fd4-98dd-e92a2cc299f3"],
    "IAppResourceGroupMemoryReport": ["2c8c06b1-7db1-4c51-a225-7fae2d49e431"],
    "IAppResourceGroupStateReport": ["52849f18-2f70-4236-ab40-d04db0c7b931"],
    "IAppServiceCatalogStatics": ["ef0d2507-d132-4c85-8395-3c31d5a1e941"],
    "IAppServiceClosedEventArgs": ["de6016f6-cb03-4d35-ac8d-cc6303239731"],
    "IAppServiceConnection": ["9dd474a2-871f-4d52-89a9-9e090531bd27"],
    "IAppServiceConnection2": ["8bdfcd5f-2302-4fbd-8061-52511c2f8bf9"],
    "IAppServiceConnectionExtendedExecution": ["65219584-f9cb-4ae3-81f9-a28a6ca450d9"],
    "IAppServiceConnectionStatics": ["adc56ce9-d408-5673-8637-827a4b274168"],
    "IAppServiceDeferral": ["7e1b5322-eab0-4248-ae04-fdf93838e472"],
    "IAppServiceRequest": ["20e58d9d-18de-4b01-80ba-90a76204e3c8"],
    "IAppServiceRequestReceivedEventArgs": ["6e122360-ff65-44ae-9e45-857fe4180681"],
    "IAppServiceResponse": ["8d503cec-9aa3-4e68-9559-9de63e372ce4"],
    "IAppServiceTriggerDetails": ["88a2dcac-ad28-41b8-80bb-bdf1b2169e19"],
    "IAppServiceTriggerDetails2": ["e83d54b2-28cc-43f2-b465-c0482e59e2dc"],
    "IAppServiceTriggerDetails3": ["fbd71e21-7939-4e68-9e3c-7780147aabb6"],
    "IAppServiceTriggerDetails4": ["1185b180-8861-5e30-ab55-1cf4d08bbf6d"],
    "IAppSwitcherNotificationService": ["24677459-c19e-43f9-8ea8-984d017abafa"],
    "IAppSwitchingTestability": ["8332fbec-5803-4461-be72-91b106e7af8a"],
    "IAppSyncChangeHandler": ["8fdd23b4-904d-4070-b59f-976f3caf4ed9"],
    "IAppSyncDEHOperation": ["fb2c85f8-002f-48fb-8eae-be8254f790df"],
    "IAppSyncFilter": ["e84d2995-21f2-42cc-b2ba-07a6115ea592"],
    "IAppSyncHandler": ["ca316713-a41f-4b7e-831c-6c5f6b5cbfb5"],
    "IAppSyncRepository": ["c9483bce-7350-4b0d-a2d5-5aedd637af1b"],
    "IAppSyncSetting": ["4bc233cb-d491-4822-87dc-e9921088cbab"],
    "IAppUpdateOptions": ["26f0b02f-c2f3-4aea-af8c-6308dd9db85f"],
    "IAppUpdateOptions2": ["f4646e08-ed26-4bf9-9679-48f628e53df8"],
    "IAppUriHandlerHost": ["5d50cac5-92d2-5409-b56f-7f73e10ea4c3"],
    "IAppUriHandlerHostFactory": ["257c3c96-ce04-5f98-96bb-3ebd3e9275bb"],
    "IAppUriHandlerRegistration": ["6f73aeb1-4569-5c3f-9ba0-99123eea32c3"],
    "IAppUriHandlerRegistrationManager": ["e62c9a52-ac94-5750-ac1b-6cfb6f250263"],
    "IAppUriHandlerRegistrationManagerStatics": ["d5cedd9f-5729-5b76-a1d4-0285f295c124"],
    "IAppViewManager": ["24fdf66c-aad4-4512-b94b-3480c0ffee84"],
    "IAppVisibility": ["2246ea2d-caea-4444-a3c4-6de827e44313"],
    "IAppVisibilityEvents": ["6584ce6b-7d82-49c2-89c9-c6bc02ba8c38"],
    "IAppWindow": ["663014a6-b75e-5dbd-995c-f0117fa3fb61"],
    "IAppWindowChangedEventArgs": ["1de1f3be-a655-55ad-b2b6-eb240f880356"],
    "IAppWindowCloseRequestedEventArgs": ["e9ff01da-e7a2-57a8-8b5e-39c4003afdbb"],
    "IAppWindowClosedEventArgs": ["cc7df816-9520-5a06-821e-456ad8b358aa"],
    "IAppWindowFrame": ["9ee22601-7e5d-52af-846b-01dc6c296567"],
    "IAppWindowFrameStyle": ["ac412946-e1ac-5230-944a-c60873dcf4a9"],
    "IAppWindowPlacement": ["03dc815e-e7a9-5857-9c03-7d670594410e"],
    "IAppWindowPresentationConfiguration": ["b5a43ee3-df33-5e67-bd31-1072457300df"],
    "IAppWindowPresentationConfigurationFactory": ["fd3606a6-7875-5de8-84ff-6351ee13dd0d"],
    "IAppWindowPresenter": ["5ae9ed73-e1fd-5317-ad78-5a3ed271bbde"],
    "IAppWindowStatics": ["ff1f3ea3-b769-50ef-9873-108cd0e89746"],
    "IAppWindowTitleBar": ["6e932c84-f644-541d-a2d7-0c262437842d"],
    "IAppWindowTitleBarOcclusion": ["fea3cffd-2ccf-5fc3-aeae-f843876bf37e"],
    "IAppWindowTitleBarVisibility": ["a215a4e3-6e7e-5651-8c3b-624819528154"],
    "IApplication2": ["019104be-522a-5904-f52f-de72010429e0"],
    "IApplication3": ["b775ad7c-18b8-45ca-a1b0-dc483e4b1028"],
    "IApplicationActivationBroker": ["d98fd14a-522a-4d59-b875-811e83919a9e"],
    "IApplicationActivationClient": ["f7dd9e5a-4aaa-4898-abb4-27e4047d61b6"],
    "IApplicationActivationClient2": ["9f8ecbb6-9790-493b-ac99-8c80fbe51d5e"],
    "IApplicationActivationHistory": ["268b7798-2d57-434c-b84f-eabec0ffee84"],
    "IApplicationActivationImpl": ["e52e6467-ad3b-4df0-8267-b09f7cf57da5"],
    "IApplicationActivationManager": ["2e941141-7f97-4756-ba1d-9decde894a3d"],
    "IApplicationActivationManagerPriv": ["54e4c428-d1d4-47d4-ade6-46c829114a7d"],
    "IApplicationActivationManagerPriv2": ["88022cb7-9496-4d1d-9425-6231cc1842ba"],
    "IApplicationActivationPhone": ["dfcaacc1-90d6-4b33-b437-e29d4cfad8a6"],
    "IApplicationActivationPhonePriv": ["e7a5f14e-0650-44f2-9168-35cd1d04fe20"],
    "IApplicationActivationTypeProvider": ["601b41d9-ad89-4414-a63b-479a512021eb"],
    "IApplicationActivator": ["68e58421-f1ee-4c21-9612-c643798734ae"],
    "IApplicationAddOn": ["738d940f-b2c9-4dff-9b1c-6e06720f921a"],
    "IApplicationAssociationRegistration": ["4e530b0a-e611-4c77-a3ac-9031d022281b"],
    "IApplicationAssociationRegistrationInternal": ["14ebcc88-2831-4fc8-a5df-9f36a81db12c"],
    "IApplicationAssociationRegistrationUI": ["1f76a169-f994-40ac-8fc8-0959e8874710"],
    "IApplicationContentInfo": ["19a543ba-bad2-4739-83c8-177b3beac2ef"],
    "IApplicationContentInfo2": ["cb5b47a9-6537-451f-8dd7-d305ae3dea57"],
    "IApplicationData": ["c3da6fb7-b744-4b45-b0b8-223a0938d0dc"],
    "IApplicationData2": ["9e65cd69-0ba3-4e32-be29-b02de6607638"],
    "IApplicationData3": ["dc222cf4-2772-4c1d-aa2c-c9f743ade8d1"],
    "IApplicationDataContainer": ["c5aefd1e-f467-40ba-8566-ab640a441e1d"],
    "IApplicationDataManager": ["74d10432-2e99-4000-9a3a-64307e858129"],
    "IApplicationDataManagerStatics": ["1e1862e3-698e-49a1-9752-dee94925b9b3"],
    "IApplicationDataSetVersionHandler": ["a05791e6-cc9f-4687-acab-a364fd785463"],
    "IApplicationDataStatics": ["5612147b-e843-45e3-94d8-06169e3c8e17"],
    "IApplicationDataStatics2": ["cd606211-cf49-40a4-a47c-c7f0dbba8107"],
    "IApplicationDesignModeSettings": ["2a3dee9a-e31d-46d6-8508-bcc597db3557"],
    "IApplicationDesignModeSettings2": ["490514e1-675a-4d6e-a58d-e54901b4ca2f"],
    "IApplicationDestinations": ["12337d35-94c6-48a0-bce7-6a9c69d4d600"],
    "IApplicationDocumentLists": ["3c594f9f-9f30-47a1-979a-c9e83d3d0a06"],
    "IApplicationEvictionBroker": ["5bde7cd0-c973-4c6e-894f-290cf8307148"],
    "IApplicationExtension": ["7aecc259-7014-4482-8f56-bb3cd72b8250"],
    "IApplicationFactory": ["93bbe361-be5a-4ee3-b4a3-95118dc97a89"],
    "IApplicationFrame": ["143715d9-a015-40ea-b695-d5cc267e36ee"],
    "IApplicationFrameEventHandler": ["ea5d0de4-770d-4da0-a9f8-d7f9a140ff79"],
    "IApplicationFrameInputPaneEventHandler": ["fb45dabf-22c2-43b2-b887-af34b3a857f1"],
    "IApplicationFrameManager": ["d6defab3-dbb9-4413-8af9-554586fdff94"],
    "IApplicationFrameTitleBar": ["3ec723e8-3a72-4627-b3fb-aafbcc8837b8"],
    "IApplicationGlomBroker": ["63d0af21-aec2-40fd-8550-0f4c75f35b0f"],
    "IApplicationHost": ["c34c8544-811b-440d-b273-263c5d1cb130"],
    "IApplicationIdentifier": ["d934aab5-496b-4b08-ada0-a00931bc1315"],
    "IApplicationInitializationCallback": ["b6351c55-c284-46e4-8310-fb0967fab76f"],
    "IApplicationInitializationCallbackParams": ["751b792e-5772-4488-8b87-f547faa64474"],
    "IApplicationInstanceViewTest": ["e2ad0e73-3233-4421-b69c-df1bd1f9efc4"],
    "IApplicationInvocableFlow": ["f230b678-5fc3-49f4-94b4-afdc0ef9fa13"],
    "IApplicationLanguagesStatics": ["75b40847-0a4c-4a92-9565-fd63c95f7aed"],
    "IApplicationLanguagesStatics2": ["1df0de4f-072b-4d7b-8f06-cb2db40f2bb5"],
    "IApplicationLicenseManager": ["90e2000c-b946-42fa-892f-94506f30ca4f"],
    "IApplicationLicenseManager2": ["0375a9ac-cd24-49c0-9ac7-4f6337576180"],
    "IApplicationLicenseManager3": ["2f6b16bf-23b2-4e78-988f-7bdd0c3358b0"],
    "IApplicationLifecycleEvent": ["72d5424d-6eb2-4735-b36d-c9c3c6f038ce"],
    "IApplicationObject": ["d97a6da0-a866-11cf-83ae-10a0c90c2bd8"],
    "IApplicationOverrides": ["25f99ff7-9347-459a-9fac-b2d0e11c1a0f"],
    "IApplicationOverrides2": ["db5cd2b9-d3b4-558c-c64e-0434fd1bd889"],
    "IApplicationPlugin": ["b05651c2-9b10-425e-b616-1fcd828db3b1"],
    "IApplicationPlugins": ["b05651c1-9b10-425e-b616-1fcd828db3b1"],
    "IApplicationPositionPersistence": ["f876b69a-7b8e-4f46-864c-a0b0ea3e49c2"],
    "IApplicationPreLaunch": ["e87e2bc9-ec45-4ddb-95e1-b275d66cbeaa"],
    "IApplicationStateChangeHandler": ["b755e6e0-b048-49cc-8911-11a041216f5f"],
    "IApplicationStateChangeOutOfProcNotificationService": ["48f4e2d1-eeba-461e-8f8f-6353da1a3aca"],
    "IApplicationStatics": ["06499997-f7b4-45fe-b763-7577d1d3cb4a"],
    "IApplicationStreamDownload": ["4afdbf7a-60f4-4ca2-966c-c1b1086ac2e8"],
    "IApplicationTargetingChanges": ["45f9fb05-8122-433d-a807-b7cfbb411af5"],
    "IApplicationTileActivationBroker": ["c735d7d4-b88a-41f2-b35d-da0141e7348a"],
    "IApplicationTileActivationBroker2": ["1a91faba-b93c-456b-a10d-0036d2a68be6"],
    "IApplicationTrigger": ["0b468630-9574-492c-9e93-1a3ae6335fe9"],
    "IApplicationTriggerDetails": ["97dc6ab2-2219-4a9e-9c5e-41d047f76e82"],
    "IApplicationView": ["9ac0b5c8-1484-4c5b-9533-4134a0f97cea", "d222d519-4361-451e-96c4-60f4f9742db0"],
    "IApplicationView2": ["e876b196-a545-40dc-b594-450cba68cc00"],
    "IApplicationView3": ["903c9ce5-793a-4fdf-a2b2-af1ac21e3108"],
    "IApplicationView4": ["15e5cbec-9e0f-46b5-bc3f-9bf653e74b5e"],
    "IApplicationView7": ["a0369647-5faf-5aa6-9c38-befbb12a071e"],
    "IApplicationView9": ["9c6516f9-021a-5f01-93e5-9bdad2647574"],
    "IApplicationViewActivatedEventArgs": ["930cef4b-b829-40fc-88f4-8513e8a64738"],
    "IApplicationViewArrangePosition": ["3fc0257d-21c2-4ad3-8fb0-fd481cd204e2"],
    "IApplicationViewBroker": ["d4351e8c-208e-4c24-88ac-6e2add5f4bb1"],
    "IApplicationViewChangeListener": ["727f9e97-76ee-497b-a942-b6371328485c"],
    "IApplicationViewCollection": ["2c08adf0-a386-4b35-9250-0fe183476fcc"],
    "IApplicationViewCollectionManagement": ["b644fe9d-3090-4a41-9f18-465a5f445272"],
    "IApplicationViewCollectionTestHook": ["0afd5bce-d688-4973-ad54-ad0ce775f26b"],
    "IApplicationViewCompatibilityManager": ["203e0af6-3e82-4224-9e81-1cd9a6fe638b"],
    "IApplicationViewCompatiblityNotification": ["91d1aa6a-3b5d-42d1-a056-683271cbd488"],
    "IApplicationViewConsolidatedEventArgs": ["514449ec-7ea2-4de7-a6a6-7dfbaaebb6fb"],
    "IApplicationViewConsolidatedEventArgs2": ["1c199ecc-6dc1-40f4-afee-07d9ea296430"],
    "IApplicationViewDataProvider": ["3c0475b6-e2a8-44aa-be98-1b0d31f44d6f"],
    "IApplicationViewInteropStatics": ["c446fb5d-4793-4896-a8e2-be57a8bb0f50"],
    "IApplicationViewPosition": ["f9b8d4b3-64da-447c-b1ba-68861510eed6"],
    "IApplicationViewScaling": ["1d0ddc23-23f3-4b2d-84fe-74bf37b48b66"],
    "IApplicationViewScalingStatics": ["b08fecf0-b946-45c8-a5e3-71f5aa78f861"],
    "IApplicationViewStatics2": ["af338ae5-cf64-423c-85e5-f3e72448fb23"],
    "IApplicationViewStatics3": ["a28d7594-8c41-4e13-9719-5164796fe4c7"],
    "IApplicationViewStatics4": ["08fd8d33-2611-5336-a315-d98e6366c9db"],
    "IApplicationViewSwitcher": ["e0fe7384-5482-4659-ab2c-4ff038948779"],
    "IApplicationViewSwitcherStatics": ["975f2f1e-e656-4c5e-a0a1-717c6ffa7d64"],
    "IApplicationViewSwitcherStatics2": ["60e995cd-4fc2-48c4-b8e3-395f2b9f0fc1"],
    "IApplicationViewSwitcherStatics3": ["92059420-80a7-486d-b21f-c7a4a242a383"],
    "IApplicationViewTitleBar": ["00924ac0-932b-4a6b-9c4b-dc38c82478ce"],
    "IApplicationViewTransferContext": ["8574bc63-3c17-408e-9408-8a1a9ea81bfa"],
    "IApplicationViewTransferContextStatics": ["15a89d92-dd79-4b0b-bc47-d5f195f14661"],
    "IApplicationViewVisibilityDebouncedNotificationService": ["af6eec2f-c097-4f4a-b536-3cb918550cb3"],
    "IApplicationViewWithContext": ["bd55d512-9dc1-44fc-8501-666625df60dc"],
    "IAppointment": ["dd002f2f-2bdd-4076-90a3-22c275312965"],
    "IAppointment2": ["5e85983c-540f-3452-9b5c-0dd7ad4c65a2"],
    "IAppointment3": ["bfcc45a9-8961-4991-934b-c48768e5a96c"],
    "IAppointmentCalendar": ["5273819d-8339-3d4f-a02f-64084452bb5d"],
    "IAppointmentCalendar2": ["18e7e422-2467-4e1c-a459-d8a29303d092"],
    "IAppointmentCalendar3": ["eb23d22b-a685-42ae-8495-b3119adb4167"],
    "IAppointmentCalendarCancelMeetingRequest": ["49460f8d-6434-40d7-ad46-6297419314d1"],
    "IAppointmentCalendarCancelMeetingRequestEventArgs": ["1a79be16-7f30-4e35-beef-9d2c7b6dcae1"],
    "IAppointmentCalendarCreateOrUpdateAppointmentRequest": ["2e62f2b2-ca96-48ac-9124-406b19fefa70"],
    "IAppointmentCalendarCreateOrUpdateAppointmentRequestEventArgs": ["cf8ded28-002e-4bf7-8e9d-5e20d49aa3ba"],
    "IAppointmentCalendarForwardMeetingRequest": ["82e5ee56-26b6-4253-8a8f-6cf5f2ff7884"],
    "IAppointmentCalendarForwardMeetingRequestEventArgs": ["3109151a-23a2-42fd-9c82-c9a60d59f8a8"],
    "IAppointmentCalendarProposeNewTimeForMeetingRequest": ["ce1c63f5-edf6-43c3-82b7-be6b368c6900"],
    "IAppointmentCalendarProposeNewTimeForMeetingRequestEventArgs": ["d2d777d8-fed1-4280-a3ba-2e1f47609aa2"],
    "IAppointmentCalendarSyncManager": ["2b21b3a0-4aff-4392-bc5f-5645ffcffb17"],
    "IAppointmentCalendarSyncManager2": ["647528ad-0d29-4c7c-aaa7-bf996805537c"],
    "IAppointmentCalendarSyncManagerSyncRequest": ["12ab382b-7163-4a56-9a4e-7223a84adf46"],
    "IAppointmentCalendarSyncManagerSyncRequestEventArgs": ["ca17c6f7-0284-4edd-87ba-4d8f69dcf5c0"],
    "IAppointmentCalendarUpdateMeetingResponseRequest": ["a36d608c-c29d-4b94-b086-7e9ff7bd84a0"],
    "IAppointmentCalendarUpdateMeetingResponseRequestEventArgs": ["88759883-97bf-479d-aed5-0be8ce567d1e"],
    "IAppointmentConflictResult": ["d5cdf0be-2f2f-3b7d-af0a-a7e20f3a46e3"],
    "IAppointmentDataProviderConnection": ["f3dd9d83-3254-465f-abdb-928046552cf4"],
    "IAppointmentDataProviderTriggerDetails": ["b3283c01-7e12-4e5e-b1ef-74fb68ac6f2a"],
    "IAppointmentException": ["a2076767-16f6-4bce-9f5a-8600b8019fcb"],
    "IAppointmentInvitee": ["13bf0796-9842-495b-b0e7-ef8f79c0701d"],
    "IAppointmentManagerForUser": ["70261423-73cc-4660-b318-b01365302a03"],
    "IAppointmentManagerStatics": ["3a30fa01-5c40-499d-b33f-a43050f74fc4"],
    "IAppointmentManagerStatics2": ["0a81f60d-d04f-4034-af72-a36573b45ff0"],
    "IAppointmentManagerStatics3": ["2f9ae09c-b34c-4dc7-a35d-cafd88ae3ec6"],
    "IAppointmentParticipant": ["615e2902-9718-467b-83fb-b293a19121de"],
    "IAppointmentPropertiesStatics": ["25141fe9-68ae-3aae-855f-bc4441caa234"],
    "IAppointmentPropertiesStatics2": ["dffc434b-b017-45dd-8af5-d163d10801bb"],
    "IAppointmentRecurrence": ["d87b3e83-15a6-487b-b959-0c361e60e954"],
    "IAppointmentRecurrence2": ["3df3a2e0-05a7-4f50-9f86-b03f9436254d"],
    "IAppointmentRecurrence3": ["89ff96d9-da4d-4a17-8dd2-1cebc2b5ff9d"],
    "IAppointmentStore": ["a461918c-7a47-4d96-96c9-15cd8a05a735"],
    "IAppointmentStore2": ["25c48c20-1c41-424f-8084-67c1cfe0a854"],
    "IAppointmentStore3": ["4251940b-b078-470a-9a40-c2e01761f72f"],
    "IAppointmentStoreChange": ["a5a6e035-0a33-3654-8463-b543e90c3b79"],
    "IAppointmentStoreChange2": ["b37d0dce-5211-4402-a608-a96fe70b8ee2"],
    "IAppointmentStoreChangeReader": ["8b2409f1-65f3-42a0-961d-4c209bf30370"],
    "IAppointmentStoreChangeTracker": ["1b25f4b1-8ece-4f17-93c8-e6412458fd5c"],
    "IAppointmentStoreChangeTracker2": ["b66aaf45-9542-4cf7-8550-eb370e0c08d3"],
    "IAppointmentStoreChangedDeferral": ["4cb82026-fedb-4bc3-9662-95a9befdf4df"],
    "IAppointmentStoreChangedEventArgs": ["2285f8b9-0791-417e-bfea-cc6d41636c8c"],
    "IAppointmentStoreNotificationTrigger": ["64d4040c-c201-42ad-aa2a-e21ba3425b6d"],
    "IAppointmentStoreNotificationTriggerDetails": ["9b33cb11-c301-421e-afef-047ecfa76adb"],
    "IAppointmentsProviderActivatedEventArgs": ["3364c405-933c-4e7d-a034-500fb8dcd9f3"],
    "IAppointmentsProviderAddAppointmentActivatedEventArgs": ["a2861367-cee5-4e4d-9ed7-41c34ec18b02"],
    "IAppointmentsProviderInternalActivatedEventArgs": ["7d590f6f-94e7-4178-a253-24493fcade4f"],
    "IAppointmentsProviderLaunchActionVerbsStatics": ["36dbba28-9e2e-49c6-8ef7-3ab7a5dcc8b8"],
    "IAppointmentsProviderLaunchActionVerbsStatics2": ["ef9049a4-af21-473c-88dc-76cd89f60ca5"],
    "IAppointmentsProviderRemoveAppointmentActivatedEventArgs": ["751f3ab8-0b8e-451c-9f15-966e699bac25"],
    "IAppointmentsProviderReplaceAppointmentActivatedEventArgs": ["1551b7d4-a981-4067-8a62-0524e4ade121"],
    "IAppointmentsProviderShowAppointmentDetailsActivatedEventArgs": ["3958f065-9841-4ca5-999b-885198b9ef2a"],
    "IAppointmentsProviderShowTimeFrameActivatedEventArgs": ["9baeaba6-0e0b-49aa-babc-12b1dc774986"],
    "IAppxBaseExtension": ["893ac9e5-23a5-4561-9500-c27ef5a058ac"],
    "IAppxBlockMapBlock": ["75cf3930-3244-4fe0-a8c8-e0bcb270b889"],
    "IAppxBlockMapBlocksEnumerator": ["6b429b5b-36ef-479e-b9eb-0c1482b49e16"],
    "IAppxBlockMapFile": ["277672ac-4f63-42c1-8abc-beae3600eb59"],
    "IAppxBlockMapFilesEnumerator": ["02b856a2-4262-4070-bacb-1a8cbbc42305"],
    "IAppxBlockMapReader": ["5efec991-bca3-42d1-9ec2-e92d609ec22a"],
    "IAppxBundleFactory": ["bba65864-965f-4a5f-855f-f074bdbf3a7b"],
    "IAppxBundleManifestOptionalBundleInfo": ["515bf2e8-bcb0-4d69-8c48-e383147b6e12"],
    "IAppxBundleManifestOptionalBundleInfoEnumerator": ["9a178793-f97e-46ac-aaca-dd5ba4c177c8"],
    "IAppxBundleManifestPackageInfo": ["54cd06c1-268f-40bb-8ed2-757a9ebaec8d"],
    "IAppxBundleManifestPackageInfo2": ["44c2acbc-b2cf-4ccb-bbdb-9c6da8c3bc9e"],
    "IAppxBundleManifestPackageInfo3": ["6ba74b98-bb74-4296-80d0-5f4256a99675"],
    "IAppxBundleManifestPackageInfo4": ["5da6f13d-a8a7-4532-857c-1393d659371d"],
    "IAppxBundleManifestPackageInfoEnumerator": ["f9b856ee-49a6-4e19-b2b0-6a2406d63a32"],
    "IAppxBundleManifestReader": ["cf0ebbc1-cc99-4106-91eb-e67462e04fb0"],
    "IAppxBundleManifestReader2": ["5517df70-033f-4af2-8213-87d766805c02"],
    "IAppxBundleReader": ["dd75b8c0-ba76-43b0-ae0f-68656a1dc5c8"],
    "IAppxBundleWriter": ["ec446fe8-bfec-4c64-ab4f-49f038f0c6d2"],
    "IAppxBundleWriter2": ["6d8fe971-01cc-49a0-b685-233851279962"],
    "IAppxBundleWriter3": ["ad711152-f969-4193-82d5-9ddf2786d21a"],
    "IAppxBundleWriter4": ["9cd9d523-5009-4c01-9882-dc029fbd47a3"],
    "IAppxContentGroup": ["328f6468-c04f-4e3c-b6fa-6b8d27f3003a"],
    "IAppxContentGroupFilesEnumerator": ["1a09a2fd-7440-44eb-8c84-848205a6a1cc"],
    "IAppxContentGroupMapReader": ["418726d8-dd99-4f5d-9886-157add20de01"],
    "IAppxContentGroupMapWriter": ["d07ab776-a9de-4798-8c14-3db31e687c78"],
    "IAppxContentGroupsEnumerator": ["3264e477-16d1-4d63-823e-7d2984696634"],
    "IAppxEncryptedBundleWriter": ["80b0902f-7bf0-4117-b8c6-4279ef81ee77"],
    "IAppxEncryptedBundleWriter2": ["e644be82-f0fa-42b8-a956-8d1cb48ee379"],
    "IAppxEncryptedBundleWriter3": ["0d34deb3-5cae-4dd3-977c-504932a51d31"],
    "IAppxEncryptedPackageWriter": ["f43d0b0b-1379-40e2-9b29-682ea2bf42af"],
    "IAppxEncryptedPackageWriter2": ["3e475447-3a25-40b5-8ad2-f953ae50c92d"],
    "IAppxEncryptionFactory": ["80e8e04d-8c88-44ae-a011-7cadf6fb2e72"],
    "IAppxEncryptionFactory2": ["c1b11eee-c4ba-4ab2-a55d-d015fe8ff64f"],
    "IAppxEncryptionFactory3": ["09edca37-cd64-47d6-b7e8-1cb11d4f7e05"],
    "IAppxEncryptionFactory4": ["a879611f-12fd-41fe-85d5-06ae779bbaf5"],
    "IAppxFactory": ["beb94909-e451-438b-b5a7-d79e767b75d8"],
    "IAppxFactory2": ["f1346df2-c282-4e22-b918-743a929a8d55"],
    "IAppxFile": ["91df827b-94fd-468f-827b-57f41b2f6f2e"],
    "IAppxFileOpenPickerExtension": ["01b7617f-b00a-4290-870e-d329b5a43033"],
    "IAppxFilesEnumerator": ["f007eeaf-9831-411c-9847-917cdc62d1fe"],
    "IAppxManifestApplication": ["5da89bf4-3773-46be-b650-7e744863b7e8"],
    "IAppxManifestApplicationsEnumerator": ["9eb8a55a-f04b-4d0d-808d-686185d4847a"],
    "IAppxManifestCapabilitiesEnumerator": ["11d22258-f470-42c1-b291-8361c5437e41"],
    "IAppxManifestDesignerService": ["11d31ba1-480f-435f-b711-8f192a1c226e"],
    "IAppxManifestDeviceCapabilitiesEnumerator": ["30204541-427b-4a1c-bacf-655bf463a540"],
    "IAppxManifestDocument": ["80cad0de-8ecc-48fc-b81e-d11b13ab9e8a"],
    "IAppxManifestDriverConstraint": ["c031bee4-bbcc-48ea-a237-c34045c80a07"],
    "IAppxManifestDriverConstraintsEnumerator": ["d402b2d1-f600-49e0-95e6-975d8da13d89"],
    "IAppxManifestDriverDependenciesEnumerator": ["fe039db2-467f-4755-8404-8f5eb6865b33"],
    "IAppxManifestDriverDependency": ["1210cb94-5a92-4602-be24-79f318af4af9"],
    "IAppxManifestHostRuntimeDependenciesEnumerator": ["6427a646-7f49-433e-b1a6-0da309f6885a"],
    "IAppxManifestHostRuntimeDependency": ["3455d234-8414-410d-95c7-7b35255b8391"],
    "IAppxManifestMainPackageDependenciesEnumerator": ["a99c4f00-51d2-4f0f-ba46-7ed5255ebdff"],
    "IAppxManifestMainPackageDependency": ["05d0611c-bc29-46d5-97e2-84b9c79bd8ae"],
    "IAppxManifestOSPackageDependenciesEnumerator": ["b84e2fc3-f8ec-4bc1-8ae2-156346f5ffea"],
    "IAppxManifestOSPackageDependency": ["154995ee-54a6-4f14-ac97-d8cf0519644b"],
    "IAppxManifestOptionalPackageInfo": ["2634847d-5b5d-4fe5-a243-002ff95edc7e"],
    "IAppxManifestPackageDependenciesEnumerator": ["b43bbcf9-65a6-42dd-bac0-8c6741e7f5a4"],
    "IAppxManifestPackageDependency": ["e4946b59-733e-43f0-a724-3bde4c1285a0"],
    "IAppxManifestPackageDependency2": ["dda0b713-f3ff-49d3-898a-2786780c5d98"],
    "IAppxManifestPackageDependency3": ["1ac56374-6198-4d6b-92e4-749d5ab8a895"],
    "IAppxManifestPackageId": ["283ce2d7-7153-4a91-9649-7a0f7240945f"],
    "IAppxManifestPackageId2": ["2256999d-d617-42f1-880e-0ba4542319d5"],
    "IAppxManifestProperties": ["03faf64d-f26f-4b2c-aaf7-8fe7789b8bca"],
    "IAppxManifestQualifiedResource": ["3b53a497-3c5c-48d1-9ea3-bb7eac8cd7d4"],
    "IAppxManifestQualifiedResourcesEnumerator": ["8ef6adfe-3762-4a8f-9373-2fc5d444c8d2"],
    "IAppxManifestReader": ["4e1bd148-55a0-4480-a3d1-15544710637c"],
    "IAppxManifestReader2": ["d06f67bc-b31d-4eba-a8af-638e73e77b4d"],
    "IAppxManifestReader3": ["c43825ab-69b7-400a-9709-cc37f5a72d24"],
    "IAppxManifestReader4": ["4579bb7c-741d-4161-b5a1-47bd3b78ad9b"],
    "IAppxManifestReader5": ["8d7ae132-a690-4c00-b75a-6aae1feaac80"],
    "IAppxManifestReader6": ["34deaca4-d3c0-4e3e-b312-e42625e3807e"],
    "IAppxManifestReader7": ["8efe6f27-0ce0-4988-b32d-738eb63db3b7"],
    "IAppxManifestResourcesEnumerator": ["de4dfbbd-881a-48bb-858c-d6f2baeae6ed"],
    "IAppxManifestTargetDeviceFamiliesEnumerator": ["36537f36-27a4-4788-88c0-733819575017"],
    "IAppxManifestTargetDeviceFamily": ["9091b09b-c8d5-4f31-8687-a338259faefb"],
    "IAppxPackageEditor": ["e2adb6dc-5e71-4416-86b6-86e5f5291a6b"],
    "IAppxPackageReader": ["b5c49650-99bc-481c-9a34-3d53a4106708"],
    "IAppxPackageReader2": ["37e8d3d5-1aea-4204-9c50-ff715932c249"],
    "IAppxPackageWriter": ["9099e33b-246f-41e4-881a-008eb613f858"],
    "IAppxPackageWriter2": ["2cf5c4fd-e54c-4ea5-ba4e-f8c4b105a8c8"],
    "IAppxPackageWriter3": ["a83aacd3-41c0-4501-b8a3-74164f50b2fd"],
    "IAppxPackagingDiagnosticEventSink": ["17239d47-6adb-45d2-80f6-f9cbc3bf059d"],
    "IAppxPackagingDiagnosticEventSinkManager": ["369648fa-a7eb-4909-a15d-6954a078f18a"],
    "IAppxShareExtension": ["1323d2e8-a6e1-498d-93b9-16ca249c9306"],
    "IAppxSourceContentGroupMapReader": ["f329791d-540b-4a9f-bc75-3282b7d73193"],
    "IArbiterBroker": ["edb9ef13-045c-4c0a-808e-3294c59703b4"],
    "IArcSegment": ["07940c5f-63fb-4469-91be-f1097c168052"],
    "IArcSegmentStatics": ["82348f6e-8a69-4204-9c12-7207df317643"],
    "IArcadeStick": ["b14a539d-befb-4c81-8051-15ecf3b13036"],
    "IArcadeStickStatics": ["5c37b8c8-37b1-4ad8-9458-200f1a30018e"],
    "IArcadeStickStatics2": ["52b5d744-bb86-445a-b59c-596f0e2a49df"],
    "IAssemblyCache": ["e707dcde-d1cd-11d2-bab9-00c04f8eceae"],
    "IAssemblyCacheItem": ["9e3aaeb4-d1cd-11d2-bab9-00c04f8eceae"],
    "IAssemblyEnum": ["21b8916c-f28e-11d2-a473-00c04f8ef448"],
    "IAssemblyName": ["cd193bc0-b4bc-11d2-9833-00c04fc31d2e"],
    "IAssignedAccessSettings": ["1bc57f1c-e971-5757-b8e0-512f8b8c46d2"],
    "IAssignedAccessSettingsStatics": ["34a81d0d-8a29-5ef3-a7be-618e6ac3bd01"],
    "IAssocHandler": ["f04061ac-1659-4a3f-a954-775aa57fc083"],
    "IAssocHandlerInvoker": ["92218cab-ecaa-4335-8133-807fd234c2ee"],
    "IAssociatedIdentityProvider": ["2af066b3-4cbb-4cba-a798-204b6af68cc0"],
    "IAssociationArray": ["c35f777c-5fa8-4293-bd69-4636ff366f22"],
    "IAssociationElement": ["d8f6ad5b-b44f-4bcc-88fd-eb3473db7502"],
    "IAsymmetricAlgorithmNamesStatics": ["caf6fce4-67c0-46aa-84f9-752e77449f9b"],
    "IAsymmetricAlgorithmNamesStatics2": ["f141c0d6-4bff-4f23-ba66-6045b137d5df"],
    "IAsymmetricKeyAlgorithmProvider": ["e8d2ff37-6259-4e88-b7e0-94191fde699e"],
    "IAsymmetricKeyAlgorithmProvider2": ["4e322a7e-7c4d-4997-ac4f-1b848b36306e"],
    "IAsymmetricKeyAlgorithmProviderStatics": ["425bde18-a7f3-47a6-a8d2-c48d6033a65c"],
    "IAsyncAction": ["5a648006-843a-4da9-865b-9d26e5dfad7b"],
    "IAsyncActionCompletedHandler": ["a4ed5c81-76c9-40bd-8be6-b1d90fb20ae7"],
    "IAsyncAllowed": ["f5f2893a-ba9e-11d0-abb9-00c04fc29f8f"],
    "IAsyncCallback": ["ea8a389b-437d-4791-aa14-5dca004bc92a"],
    "IAsyncCallbackDispatcher": ["7702e77c-66f6-479b-af2b-e316cff5f814"],
    "IAsyncCausalityTracerStatics": ["50850b26-267e-451b-a890-ab6a370245ee"],
    "IAsyncDebugEngineOperation": ["08c85523-1f56-4ccd-8315-df2c657a245f"],
    "IAsyncDebugEngineOperation158": ["0fddd94e-01da-4409-844c-36c63aad3fc9"],
    "IAsyncDebugEngineOperationWorkList": ["4401b380-016e-4b61-8532-b3b0f41a3b47"],
    "IAsyncDebugEngineOperationWorkList158": ["44dff079-4364-4d72-9997-cd3fe128ce39"],
    "IAsyncDebugEvaluateCompletionHandler": ["df75ac59-e3cf-456b-a5a2-b8b8fbdfb7a7"],
    "IAsyncDebugGetFramesCompletionHandler": ["15c89f68-17d2-4c34-9714-e5a1e0824904"],
    "IAsyncDebugGetPropertiesCompletionHandler": ["5c9afc5d-fd11-43f9-a6aa-345625dea2a3"],
    "IAsyncDebugGetThreadPropertiesCompletionHandler": ["00eb372d-8dc7-404a-af65-17262fd3b330"],
    "IAsyncDebugPropertyInfoProvider": ["bb7e4dec-d761-41e6-8281-8976641efe90"],
    "IAsyncDebugWorkListFactory": ["119cd2bc-74ec-4510-a0cd-6276a8a87737"],
    "IAsyncDragUIContentCompletionCallbackPriv": ["9c19e0bc-7d95-426d-a994-5aec39d45a90"],
    "IAsyncDragUIContentPriv": ["a8996fdb-5dd0-4cdc-bc77-9da61d2174df"],
    "IAsyncInfo": ["00000036-0000-0000-c000-000000000046"],
    "IAsyncLoadablePackageInitialize": ["3ec4d7f6-4036-4406-a393-2fff7b2e78a1"],
    "IAsyncNotifyServerReferral": ["87be5d60-2ab8-4340-a475-8ce1541d63f9"],
    "IAsyncOperationCompletion": ["4c378512-fa50-4242-b162-d08222cbc405"],
    "IAsyncProgressCallback": ["c3a2d62e-64be-4008-924f-7e303e2b0001"],
    "IAsyncSecurityStatus": ["e31af1ec-96b2-4635-b0ba-f1431e82ba92"],
    "IAsyncServiceProvider": ["257b63fa-8388-4feb-9db8-3db22f4405de"],
    "IAsyncServiceProvider2": ["4edcc64c-4f4e-47bb-9364-cf04348aec1e"],
    "IAsyncWPNInit": ["f84eb939-b961-ba76-565f-857c29a88131"],
    "IAsynchronousDataRetriever": ["9fc7e470-61ea-4a88-9be4-df56a27cfef2"],
    "IAtomPubClient": ["35392c38-cded-4d4c-9637-05f15c1c9406"],
    "IAtomPubClientFactory": ["49d55012-57cb-4bde-ab9f-2610b172777b"],
    "IAtscContentAdvisoryDescriptor": ["ff76e60c-0283-43ea-ba32-b422238547ee"],
    "IAtscPsipParser": ["b2c98995-5eb2-4fb1-b406-f3e8e2026a9a"],
    "IAttachableInputObject": ["9b822734-a3c1-542a-b2f4-0e32b773fb07"],
    "IAttachableInputObjectFactory": ["a4c54c4e-42bc-58fa-a640-ea1516f4c06b"],
    "IAttributeGet": ["52dbd1ec-e48f-4528-9232-f442a68f0ae1"],
    "IAttributeSet": ["583ec3cc-4960-4857-982b-41a33ea0a006"],
    "IAttributedNetworkUsage": ["f769b039-eca2-45eb-ade1-b0368b756c49"],
    "IAudioAccessibility": ["a99be094-a808-4cfb-a658-29d5a3858300"],
    "IAudioAmbisonicsControl": ["28724c91-df35-4856-9f76-d6a26413f3df"],
    "IAudioAutoGainControl": ["85401fd4-6de4-4b9d-9869-2d6753a82f3c"],
    "IAudioBass": ["a2b1a1d9-4db3-425d-a2b2-bd335cb3e2e5"],
    "IAudioBuffer": ["35175827-724b-4c6a-b130-f6537f9ae0d0"],
    "IAudioCaptureClient": ["c8adbd64-e71e-48a0-a4de-185c395cd317"],
    "IAudioCaptureEffectsManager": ["8f85c271-038d-4393-8298-540110608eef"],
    "IAudioChannelConfig": ["bb11c46f-ec28-493c-b88a-5db88062ce98"],
    "IAudioCleanup": ["2bee5823-6cbb-4b32-9861-be5c604c4f87"],
    "IAudioClient": ["1cb9ad4c-dbfa-4c32-b178-c2f568a703b2"],
    "IAudioClient2": ["726778cd-f60a-4eda-82de-e47610cd78aa"],
    "IAudioClient3": ["7ed4ee07-8e67-4cd4-8c1a-2b7a5987ad42"],
    "IAudioClock": ["cd63314f-3fba-4a1b-812c-ef96358728e7"],
    "IAudioClock2": ["6f49ff73-6727-49ac-a008-d98cf5e70048"],
    "IAudioClockAdjustment": ["f6e4c0a0-46d9-4fb8-be21-57a3ef2b626c"],
    "IAudioConstrictor": ["6b54b2b5-45ee-4f11-9935-9ec3183ad534"],
    "IAudioCopy": ["adf7583d-f947-4311-83fb-066ad4e5e7c2"],
    "IAudioData": ["54c719c0-af60-11d0-8212-00c04fc32c45"],
    "IAudioDeviceController": ["edd4a388-79c7-4f7c-90e8-ef934b21580a"],
    "IAudioDeviceEndpoint": ["d4952f5a-a0b2-4cc4-8b82-9358488dd8ac"],
    "IAudioDeviceGraph": ["3c169ff7-37b2-484c-b199-c3155590f316"],
    "IAudioDeviceInputNode": ["b01b6be1-6f4e-49e2-ac01-559d62beb3a9"],
    "IAudioDeviceModule": ["86cfac36-47c1-4b33-9852-8773ec4be123"],
    "IAudioDeviceModuleNotificationEventArgs": ["e3e3ccaf-224c-48be-956b-9a13134e96e8"],
    "IAudioDeviceModulesClient": ["98f37dac-d0b6-49f5-896a-aa4d169a4c48"],
    "IAudioDeviceModulesManager": ["6aa40c4d-960a-4d1c-b318-0022604547ed"],
    "IAudioDeviceModulesManagerFactory": ["8db03670-e64d-4773-96c0-bc7ebf0e063f"],
    "IAudioDeviceOutputNode": ["362edbff-ff1c-4434-9e0f-bd2ef522ac82"],
    "IAudioDither": ["6bb6a944-7352-4327-ab91-d92607b25656"],
    "IAudioEffect": ["34aafa51-9207-4055-be93-6e5734a86ae4"],
    "IAudioEffectDefinition": ["e4d7f974-7d80-4f73-9089-e31c9db9c294"],
    "IAudioEffectDefinitionFactory": ["8e1da646-e705-45ed-8a2b-fc4e4f405a97"],
    "IAudioEffectsManagerStatics": ["66406c04-86fa-47cc-a315-f489d8c3fe10"],
    "IAudioEncodingProperties": ["62bc7a16-005c-4b3b-8a0b-0a090e9687f3"],
    "IAudioEncodingProperties2": ["c45d54da-80bd-4c23-80d5-72d4a181e894"],
    "IAudioEncodingProperties3": ["87600341-748c-4f8d-b0fd-10caf08ff087"],
    "IAudioEncodingPropertiesStatics": ["0cad332c-ebe9-4527-b36d-e42a13cf38db"],
    "IAudioEncodingPropertiesStatics2": ["7489316f-77a0-433d-8ed5-4040280e8665"],
    "IAudioEncodingPropertiesWithFormatUserData": ["98f10d79-13ea-49ff-be70-2673db69702c"],
    "IAudioEndpoint": ["30a99515-1527-4451-af9f-00c5f0234daf"],
    "IAudioEndpointControl": ["c684b72a-6df4-4774-bdf9-76b77509b653"],
    "IAudioEndpointFormatControl": ["784cfd40-9f89-456e-a1a6-873b006a664e"],
    "IAudioEndpointLastBufferControl": ["f8520dd3-8f9d-4437-9861-62f584c33dd6"],
    "IAudioEndpointOffloadStreamMeter": ["e1546dce-9dd1-418b-9ab2-348ced161c86"],
    "IAudioEndpointOffloadStreamMute": ["dfe21355-5ec2-40e0-8d6b-710ac3c00249"],
    "IAudioEndpointOffloadStreamVolume": ["64f1dd49-71ca-4281-8672-3a9eddd1d0b6"],
    "IAudioEndpointRT": ["dfd2005f-a6e5-4d39-a265-939ada9fbb4d"],
    "IAudioEndpointVolume": ["5cdf2c82-841e-4546-9722-0cf74078229a"],
    "IAudioEndpointVolumeCallback": ["657804fa-d6ad-4496-8a60-352752af4f89"],
    "IAudioEndpointVolumeEx": ["66e11784-f695-4f28-a505-a7080081a78f"],
    "IAudioFileInputNode": ["905b67c8-6f65-4cd4-8890-4694843c276d"],
    "IAudioFileOutputNode": ["50e01980-5166-4093-80f8-ada00089e9cf"],
    "IAudioFlyoutController": ["41f9d2fb-7834-4ab6-8b1b-73e74064b465"],
    "IAudioFormatConverter": ["fc7dff56-6b8d-45a9-b4ca-266f9ac21693"],
    "IAudioFormatEnumerator": ["dcdaa858-895a-4a22-a5eb-67bda506096d"],
    "IAudioFrame": ["e36ac304-aab2-4277-9ed0-43cedf8e29c6"],
    "IAudioFrameCompletedEventArgs": ["dc7c829e-0208-4504-a5a8-f0f268920a65"],
    "IAudioFrameFactory": ["91a90ade-2422-40a6-b9ad-30d02404317d"],
    "IAudioFrameInputNode": ["01b266c7-fd96-4ff5-a3c5-d27a9bf44237"],
    "IAudioFrameNative": ["20be1e2e-930f-4746-9335-3c332f255093"],
    "IAudioFrameNativeFactory": ["7bd67cf8-bf7d-43e6-af8d-b170ee0c0110"],
    "IAudioFrameOutputNode": ["b847371b-3299-45f5-88b3-c9d12a3f1cc8"],
    "IAudioGraph": ["1ad46eed-e48c-4e14-9660-2c4f83e9cdd8"],
    "IAudioGraph2": ["4e4c3bd5-4fc1-45f6-a947-3cd38f4fd839"],
    "IAudioGraph3": ["ddcd25ae-1185-42a7-831d-6a9b0fc86820"],
    "IAudioGraphCallback": ["2f732065-eff0-4c7c-8fc1-363851b1f1d7"],
    "IAudioGraphConnection": ["763070ed-d04e-4fac-b233-600b42edd469"],
    "IAudioGraphSettings": ["1d59647f-e6fe-4628-84f8-9d8bdba25785"],
    "IAudioGraphSettings2": ["72919787-4dab-46e3-b4c9-d8e1a2636062"],
    "IAudioGraphSettingsFactory": ["a5d91cc6-c2eb-4a61-a214-1d66d75f83da"],
    "IAudioGraphStatics": ["76ec3132-e159-4ab7-a82a-17beb4b31e94"],
    "IAudioGraphUnrecoverableErrorOccurredEventArgs": ["c3d9cbe0-3ff6-4fb3-b262-50d435c55423"],
    "IAudioInputEndpointRT": ["8026ab61-92b2-43c1-a1df-5c37ebd08d82"],
    "IAudioInputNode": ["d148005c-8428-4784-b7fd-a99d468c5d20"],
    "IAudioInputNode2": ["905156b7-ca68-4c6d-a8bc-e3ee17fe3fd2"],
    "IAudioInputSelector": ["4f03dc02-5e6e-4653-8f72-a030c123d598"],
    "IAudioLfxControl": ["076a6922-d802-4f83-baf6-409d9ca11bfe"],
    "IAudioLimiter": ["7df8824c-aec7-4119-9425-e6979172a8ae"],
    "IAudioLoudness": ["7d8b1437-dd53-4350-9c1b-1ee2890bd938"],
    "IAudioMatrix": ["bb8b2f5d-2af0-473f-bd94-f55a77587d3f"],
    "IAudioMediaFrame": ["a3a9feff-8021-441b-9a46-e7f0137b7981"],
    "IAudioMediaStream": ["f7537560-a3be-11d0-8212-00c04fc32c45"],
    "IAudioMediaType": ["4e997f73-b71f-4798-873b-ed7dfcf15b4d"],
    "IAudioMeter": ["419b26e3-fa99-4408-83de-cc1276efa489"],
    "IAudioMeterInformation": ["c02216f6-8c67-4b5b-9d00-d008e73e0064"],
    "IAudioMidrange": ["5e54b6d7-b44b-40d9-9a9e-e691d9ce6edf"],
    "IAudioMixer": ["c23bdc7a-47f8-49a1-b750-692c35b532c3"],
    "IAudioMute": ["df45aeea-b74a-4b6b-afad-2366b6aa012e"],
    "IAudioMuteAPO": ["885c7b80-3fa2-4e5a-be07-cf01e1d6e2cd"],
    "IAudioNode": ["15389d7f-dbd8-4819-bf03-668e9357cd6d"],
    "IAudioNodeEmitter": ["3676971d-880a-47b8-adf7-1323a9d965be"],
    "IAudioNodeEmitter2": ["4ab6eecb-ec29-47f8-818c-b6b660a5aeb1"],
    "IAudioNodeEmitterConeProperties": ["e99b2cee-02ca-4375-9326-0c6ae4bcdfb5"],
    "IAudioNodeEmitterDecayModel": ["1d1d5af7-0d53-4fa9-bd84-d5816a86f3ff"],
    "IAudioNodeEmitterDecayModelStatics": ["c7787ca8-f178-462f-bc81-8dd5cbe5dae8"],
    "IAudioNodeEmitterFactory": ["fdc8489a-6ad6-4ce4-b7f7-a99370df7ee9"],
    "IAudioNodeEmitterNaturalDecayModelProperties": ["48934bcf-cf2c-4efc-9331-75bd22df1f0c"],
    "IAudioNodeEmitterShape": ["ea0311c5-e73d-44bc-859c-45553bbc4828"],
    "IAudioNodeEmitterShapeStatics": ["57bb2771-ffa5-4b86-a779-e264aeb9145f"],
    "IAudioNodeListener": ["d9722e16-0c0a-41da-b755-6c77835fb1eb"],
    "IAudioNodeWithListener": ["0e0f907c-79ff-4544-9eeb-01257b15105a"],
    "IAudioOutputEndpointRT": ["8fa906e4-c31c-4e31-932e-19a66385e9aa"],
    "IAudioOutputSelector": ["bb515f69-94a7-429e-8b9c-271b3f11a3ab"],
    "IAudioPeakMeter": ["dd79923c-0599-45e0-b8b6-c8df7db6e796"],
    "IAudioPlaybackConnection": ["1a4c1dea-cafc-50e7-8718-ea3f81cbfa51"],
    "IAudioPlaybackConnectionOpenResult": ["4e656aef-39f9-5fc9-a519-a5bbfd9fe921"],
    "IAudioPlaybackConnectionStatics": ["e60963a2-69e6-5ffc-9e13-824a85213daf"],
    "IAudioProcessingObject": ["fd7f2b29-24d0-4b5c-b177-592c39f9ca10"],
    "IAudioProcessingObjectConfiguration": ["0e5ed805-aba6-49c3-8f9a-2b8c889c4fa8"],
    "IAudioProcessingObjectInternal": ["69e1f79f-6eae-4517-be9f-13aa90e30014"],
    "IAudioProcessingObjectRT": ["9e1d6a6d-ddbc-4e95-a4c7-ad64ba37846c"],
    "IAudioProcessingObjectVBR": ["7ba1db8f-78ad-49cd-9591-f79d80a17c81"],
    "IAudioProcessor": ["6683b02d-3931-487c-ac86-a0f42493c3c3"],
    "IAudioProtectedOutput": ["69a95a38-c637-46a0-9fb2-1c939aebf2e8"],
    "IAudioProtectedOutputController": ["6ec153c1-371e-47e1-a896-2f7f80eb7842"],
    "IAudioPump": ["5945c28d-52af-41ae-abf3-5776f2ea9fc8"],
    "IAudioRateConvert": ["788f7be2-9c40-41c0-af05-4393fbf409f9"],
    "IAudioRenderClient": ["f294acfc-3146-4483-a7bf-addca7c260e2"],
    "IAudioRenderEffectsManager": ["4dc98966-8751-42b2-bfcb-39ca7864bd47"],
    "IAudioSessionControl": ["f4b1a599-7266-4319-a8ca-e70acb11e8cd"],
    "IAudioSessionControl2": ["bfb7ff88-7239-4fc9-8fa2-07c950be9c6d"],
    "IAudioSessionEnumerator": ["e2f5bb11-0570-40ca-acdd-3aa01277dee8"],
    "IAudioSessionEvents": ["24918acc-64b3-37c1-8ca9-74a66e9957a8"],
    "IAudioSessionManager": ["bfa971f1-4d5e-40bb-935e-967039bfbee4"],
    "IAudioSessionManager2": ["77aa99a0-1bd6-484f-8bc7-2c654c9a9b6f"],
    "IAudioSessionNotification": ["641dd20b-4d41-49cc-aba3-174b9477bb08"],
    "IAudioSessionSite": ["d7d8b684-d02d-4517-b6b7-19e3dfe29c45"],
    "IAudioSilenceMonitor": ["22150b0d-ab8e-4f85-bd9a-8580e3b290f1"],
    "IAudioSourceProvider": ["ebbaf249-afc2-4582-91c6-b60df2e84954"],
    "IAudioStateMonitor": ["1d13d136-0199-4cdc-b84e-e72c2b581ece"],
    "IAudioStateMonitorStatics": ["6374ea4c-1b3b-4001-94d9-dd225330fa40"],
    "IAudioStreamDescriptor": ["1e3692e4-4027-4847-a70b-df1d9a2a7b04"],
    "IAudioStreamDescriptor2": ["2e68f1f6-a448-497b-8840-85082665acf9"],
    "IAudioStreamDescriptor3": ["4d220da1-8e83-44ef-8973-2f63e993f36b"],
    "IAudioStreamDescriptorFactory": ["4a86ce9e-4cb1-4380-8e0c-83504b7f5bf3"],
    "IAudioStreamSample": ["345fee00-aba5-11d0-8212-00c04fc32c45"],
    "IAudioStreamVolume": ["93014887-242d-4068-8a15-cf5e93b90fe3"],
    "IAudioSystemEffects": ["5fa00f27-add6-499a-8a9d-6b98521fa75b"],
    "IAudioSystemEffects2": ["bafe99d2-7436-44ce-9e0e-4d89afbfff56"],
    "IAudioSystemEffectsCustomFormats": ["b1176e34-bb7f-4f05-bebd-1b18a534e097"],
    "IAudioTrack": ["f23b6e77-3ef7-40de-b943-068b1321701d"],
    "IAudioTrackOpenFailedEventArgs": ["eeddb9b9-bb7c-4112-bf76-9384676f824b"],
    "IAudioTrackSupportInfo": ["178beff7-cc39-44a6-b951-4a5653f073fa"],
    "IAudioTreble": ["0a717812-694e-4907-b74b-bafa5cfdca7b"],
    "IAudioVirtualProtectedOutput": ["562462dd-4f9a-4110-9d6a-c3ca0407ff76"],
    "IAudioVolume": ["d81229b1-5a43-480c-92f7-be0f7f4eab60"],
    "IAudioVolumeDuckNotification": ["c3b284d4-6d39-4359-b3cf-b56ddb3bb39c"],
    "IAudioVolumeLevel": ["7fb7b48f-531d-44a2-bcb3-5ad5a134b3dc"],
    "IAumidNotificationSettings": ["71d10a03-f4b1-4603-b214-e79834d10082"],
    "IAuthLockScreenImageEx": ["7093134e-768e-47b0-ace0-b2ccd7124ec6"],
    "IAuthUIBumpDialog": ["eeee1dfc-8e6f-4e81-b03e-2873867beb11"],
    "IAuthenticateEx": ["2ad1edaf-d83d-48b5-9adf-03dbe19f53bd"],
    "IAuthenticateHostUI": ["ac78490a-ea21-4757-87d2-12bf26030d30"],
    "IAuthenticateHostUISite": ["aeb7815f-926e-485f-8ea1-43047a9b7984"],
    "IAuthenticationProviderConfig": ["66a2db17-d706-11d0-a37b-00c04fc9da04"],
    "IAutoCompleteHost": ["a85871f1-3167-491f-9642-a11c3f5ce52a"],
    "IAutoExpandInNSC": ["498175a5-67a8-4e7d-b666-b0fb9d029b6b"],
    "IAutoListDescription": ["607c87f7-0696-4558-a368-de5e59cfe456"],
    "IAutoPlayDirect": ["b7d1e57c-4276-4c21-9bfe-6f02fbfd67d3"],
    "IAutoRepeatModeChangeRequestedEventArgs": ["ea137efa-d852-438e-882b-c990109a78f4"],
    "IAutoRetry": ["56887418-c996-4ee6-95e2-fa03776e10b3"],
    "IAutoSuggestBox": ["103e9b13-3400-4a16-90b9-6912bf06974f"],
    "IAutoSuggestBox2": ["aa87ddde-e679-45b2-a7c9-9aedc39db886"],
    "IAutoSuggestBox3": ["9bbbfcef-f32d-402e-9009-05bdbaf6336e"],
    "IAutoSuggestBox4": ["c22df897-a3e8-5051-b3cc-b5f0f5262950"],
    "IAutoSuggestBoxAutomationPeer": ["2f32c302-f99b-491d-9726-a5e181643efa"],
    "IAutoSuggestBoxAutomationPeerFactory": ["80046849-18e7-4475-b362-4bbd53d24562"],
    "IAutoSuggestBoxQuerySubmittedEventArgs": ["78dcb116-818a-4cb5-bca7-382ce6ddc90d"],
    "IAutoSuggestBoxStatics": ["ee22c7f4-c15d-4ff3-8a94-f50dfdfbe89a"],
    "IAutoSuggestBoxStatics2": ["1cd297a8-8e6a-41ef-a95d-7157dc0c7106"],
    "IAutoSuggestBoxStatics3": ["2cead2dd-c4d5-4ab2-8a13-afddcf067c86"],
    "IAutoSuggestBoxStatics4": ["d63efaae-b9df-58d8-a00a-dbfe9ffdedd0"],
    "IAutoSuggestBoxSuggestionChosenEventArgs": ["396f7254-1ed5-4bc5-a060-655530bca6ba"],
    "IAutoSuggestBoxTextChangedEventArgs": ["3a6f7254-1ed5-4bc5-a060-655530bca6ba"],
    "IAutoSuggestBoxTextChangedEventArgsStatics": ["fef7772b-9f45-44db-8c27-bda3f933e7b5"],
    "IAutomaticDestinationList": ["e9c5ef8d-fd41-4f72-ba87-eb03bad5817c"],
    "IAutomaticDestinationList2": ["e014d578-d95e-4757-bffb-3bda010fe68a"],
    "IAutomaticUpdates": ["673425bf-c082-4c7c-bdfd-569464b8e0ce"],
    "IAutomaticUpdates2": ["4a2f5c31-cfd9-410e-b7fb-29a653973a0f"],
    "IAutomaticUpdatesResults": ["e7a4d634-7942-4dd9-a111-82228ba33901"],
    "IAutomaticUpdatesSettings": ["2ee48f22-af3c-405f-8970-f71be12ee9a2"],
    "IAutomaticUpdatesSettings2": ["6abc136a-c3ca-4384-8171-cb2b1e59b8dc"],
    "IAutomaticUpdatesSettings3": ["b587f5c3-f57e-485f-bbf5-0d181c5cd0dc"],
    "IAutomationAnnotation": ["fb3c30ca-03d8-4618-91bf-e4d84f4af318"],
    "IAutomationAnnotationFactory": ["4906fa52-ddc0-4e69-b76b-019d928d822f"],
    "IAutomationAnnotationStatics": ["e503eab7-4ee5-48cb-b5b8-bbcd46c9d1da"],
    "IAutomationElementIdentifiers": ["e68a63cf-4345-4e2d-8a6a-49cce1fa2dcc"],
    "IAutomationElementIdentifiersStatics": ["4549399f-8340-4d67-b9bf-8c2ac6a0773a"],
    "IAutomationElementIdentifiersStatics2": ["b5cbb1e2-d55f-46a9-9eda-1a4742515dc3"],
    "IAutomationElementIdentifiersStatics3": ["0f5cbebd-b3eb-4083-adc7-0c2f39bb3543"],
    "IAutomationElementIdentifiersStatics4": ["5af51f75-5913-4d78-b330-a6f50b73ed9b"],
    "IAutomationElementIdentifiersStatics5": ["986a8206-de59-42f9-a1e7-62b8af9e756d"],
    "IAutomationElementIdentifiersStatics6": ["de52b00d-8328-4eae-8035-f8db99c8bac4"],
    "IAutomationElementIdentifiersStatics7": ["00f1abb2-742c-446a-a8f6-1672b10d2874"],
    "IAutomationElementIdentifiersStatics8": ["8517b060-806c-5dc5-bc41-891bb5a47adf"],
    "IAutomationPeer": ["35aac87a-62ee-4d3e-a24c-2bc8432d68b7"],
    "IAutomationPeer2": ["ea1f89c7-ebf5-4ab8-88f7-680d821dac61"],
    "IAutomationPeer3": ["d3cfb977-0084-41d7-a221-28158d3bc32c"],
    "IAutomationPeer4": ["761ce752-73c1-4f44-be75-43c49ec0d4d5"],
    "IAutomationPeer5": ["f632e1c6-0a3f-4574-9fef-cdc151765674"],
    "IAutomationPeer6": ["caf8608f-13ff-42fb-866d-22206434cc6b"],
    "IAutomationPeer7": ["796b3287-e642-48ab-b223-5208b41da9d6"],
    "IAutomationPeer8": ["5c6a1fe6-9a55-4d7f-9498-cfe429e92da8"],
    "IAutomationPeer9": ["df2e0265-1d74-57fa-8094-f81c2f626b8c"],
    "IAutomationPeerAnnotation": ["0c456061-52cf-43fa-82f8-07f137351e5a"],
    "IAutomationPeerAnnotationFactory": ["f59c439e-c65b-43cd-9009-03fc023363a7"],
    "IAutomationPeerAnnotationStatics": ["8809a87d-09b2-4d45-b78b-1d3b3b09f661"],
    "IAutomationPeerFactory": ["20c27545-a88b-43c8-bc24-cea9dafd04a3"],
    "IAutomationPeerOverrides": ["bea93e67-dbee-4f7b-af0d-a79aae5333bf"],
    "IAutomationPeerOverrides2": ["2603682a-9da6-4023-b496-496e5ef228d2"],
    "IAutomationPeerOverrides3": ["b6f0c4ad-4d39-49e6-bb91-d924eefd8538"],
    "IAutomationPeerOverrides4": ["b186cda2-5d46-4bcd-a811-269ad15b3aee"],
    "IAutomationPeerOverrides5": ["2c847c85-781e-49f7-9fef-b9e14d014707"],
    "IAutomationPeerOverrides6": ["e98babe7-f6ff-444c-9c0d-277eaf0ad9c0"],
    "IAutomationPeerOverrides8": ["0e1ebbd4-a003-4936-8175-f5457c07f0c6"],
    "IAutomationPeerOverrides9": ["f3709e8b-091a-5db5-b896-ff78f01990c9"],
    "IAutomationPeerProtected": ["f4b40e52-642f-4629-a54a-ea5d2349c448"],
    "IAutomationPeerStatics": ["562f7fb0-a331-4a9c-9dec-bfb7586fffff"],
    "IAutomationPeerStatics3": ["572c5714-7f87-4271-819f-6cf4c4d022d0"],
    "IAutomationProperties": ["68d7232c-e622-48e9-af0b-1ffa33cc5cba"],
    "IAutomationPropertiesStatics": ["b618fd7b-32d0-4970-9c42-7c039ac7be78"],
    "IAutomationPropertiesStatics2": ["3976547f-7089-4801-8f1d-aab78090d1a0"],
    "IAutomationPropertiesStatics3": ["7b75d735-5cb1-42ad-9b57-5faba8c1867f"],
    "IAutomationPropertiesStatics4": ["f7d62655-311a-4b7c-a131-524e89cd3cf9"],
    "IAutomationPropertiesStatics5": ["0be35b26-c8f9-41a2-b4db-e6a7a32b0c34"],
    "IAutomationPropertiesStatics6": ["c61e030f-eb49-4e5d-b012-4c1c96c3901b"],
    "IAutomationPropertiesStatics7": ["f7e98bf3-8f91-4068-a4ad-b7b402d10a2c"],
    "IAutomationPropertiesStatics8": ["432eca20-171a-560d-8524-3e651d3ad6ca"],
    "IAutomationProperty": ["b627195b-3227-4e16-9534-ddece30ddb46"],
    "IAutomationProviderRequestedEventArgs": ["961ff258-21bf-4b42-a298-fa479d4c52e2"],
    "IAutoplayHandlerList": ["f68dde6d-ae8c-4047-bfae-65bb5173d4d9"],
    "IAuxInTuningSpace": ["e48244b8-7e17-4f76-a763-5090ff1e2f30"],
    "IAuxInTuningSpace2": ["b10931ed-8bfe-4ab0-9dce-e469c29a9729"],
    "IAvailableCategory": ["87f5fad1-d143-44d3-a835-834473cbc292"],
    "IAvailableCategoryNotifySink": ["14a821a3-97e8-11d9-8309-000d9dff97d3"],
    "IAvailableNetwork": ["14a82193-97e8-11d9-8309-000d9dff97d3"],
    "IAvailableNetworkCustomUI": ["14a82196-97e8-11d9-8309-000d9dff97d3"],
    "IAvailableNetworkDataUsage": ["54fda6e7-864f-4a59-bdea-42f77cba1952"],
    "IAvailableNetworkDiagnostic": ["14a821a1-97e8-11d9-8309-000d9dff97d3"],
    "IAvailableNetworkMediaManager": ["cbe511f1-0829-4db1-adee-2e681476c896"],
    "IAvailableNetworkMediaManagerDiagnostic": ["14a821a0-97e8-11d9-8309-000d9dff97d3"],
    "IAvailableNetworkMediaManagerNotifySink": ["14a82195-97e8-11d9-8309-000d9dff97d3"],
    "IAvailableNetworkNotifySink": ["14a82199-97e8-11d9-8309-000d9dff97d3"],
    "IAvailableNetworkSettings": ["14a821a4-97e8-11d9-8309-000d9dff97d3"],
    "IAvailableNetworkUiDUIElements": ["260677a6-dfe4-4834-a932-bc4ebefc7975"],
    "IAvailableNetworkUiDUIElementsNotifySink": ["7c86dfa9-1407-4c9d-beb4-9d85a9764fd3"],
    "IAvailableNetworkUiElements": ["3807204c-c211-49a4-8db1-711ff2c732b4"],
    "IAvailableNetworkUiElementsContextMenu": ["7c8b80c6-1e4a-4a6b-9e5e-87a44151f233"],
    "IAzApplication": ["987bc7c7-b813-4d27-bede-6ba5ae867e95"],
    "IAzApplication2": ["086a68af-a249-437c-b18d-d4d86d6a9660"],
    "IAzApplication3": ["181c845e-7196-4a7d-ac2e-020c0bb7a303"],
    "IAzApplicationGroup": ["f1b744cd-58a6-4e06-9fbf-36f6d779e21e"],
    "IAzApplicationGroup2": ["3f0613fc-b71a-464e-a11d-5b881a56cefa"],
    "IAzApplicationGroups": ["4ce66ad5-9f3c-469d-a911-b99887a7e685"],
    "IAzApplications": ["929b11a9-95c5-4a84-a29a-20ad42c2f16c"],
    "IAzAuthorizationStore": ["edbd9ca9-9b82-4f6a-9e8b-98301e450f14"],
    "IAzAuthorizationStore2": ["b11e5584-d577-4273-b6c5-0973e0f8e80d"],
    "IAzAuthorizationStore3": ["abc08425-0c86-4fa0-9be3-7189956c926e"],
    "IAzBizRuleContext": ["e192f17d-d59f-455e-a152-940316cd77b2"],
    "IAzBizRuleInterfaces": ["e94128c7-e9da-44cc-b0bd-53036f3aab3d"],
    "IAzBizRuleParameters": ["fc17685f-e25d-4dcd-bae1-276ec9533cb5"],
    "IAzClientContext": ["eff1f00b-488a-466d-afd9-a401c5f9eef5"],
    "IAzClientContext2": ["2b0c92b8-208a-488a-8f81-e4edb22111cd"],
    "IAzClientContext3": ["11894fde-1deb-4b4b-8907-6d1cda1f5d4f"],
    "IAzNameResolver": ["504d0f15-73e2-43df-a870-a64f40714f53"],
    "IAzObjectPicker": ["63130a48-699a-42d8-bf01-c62ac3fb79f9"],
    "IAzOperation": ["5e56b24f-ea01-4d61-be44-c49b5e4eaf74"],
    "IAzOperation2": ["1f5ea01f-44a2-4184-9c48-a75b4dcc8ccc"],
    "IAzOperations": ["90ef9c07-9706-49d9-af80-0438a5f3ec35"],
    "IAzPrincipalLocator": ["e5c3507d-ad6a-4992-9c7f-74ab480b44cc"],
    "IAzRole": ["859e0d8d-62d7-41d8-a034-c0cd5d43fdfa"],
    "IAzRoleAssignment": ["55647d31-0d5a-4fa3-b4ac-2b5f9ad5ab76"],
    "IAzRoleAssignments": ["9c80b900-fceb-4d73-a0f4-c83b0bbf2481"],
    "IAzRoleDefinition": ["d97fcea1-2599-44f1-9fc3-58e9fbe09466"],
    "IAzRoleDefinitions": ["881f25a5-d755-4550-957a-d503a3b34001"],
    "IAzRoles": ["95e0f119-13b4-4dae-b65f-2f7d60d822e4"],
    "IAzScope": ["00e52487-e08d-4514-b62e-877d5645f5ab"],
    "IAzScope2": ["ee9fe8c9-c9f3-40e2-aa12-d1d8599727fd"],
    "IAzScopes": ["78e14853-9f5e-406d-9b91-6bdba6973510"],
    "IAzTask": ["cb94e592-2e0e-4a6c-a336-b89a6dc1e388"],
    "IAzTask2": ["03a9a5ee-48c8-4832-9025-aad503c46526"],
    "IAzTasks": ["b338ccab-4c85-4388-8c0a-c58592bad398"],
    "IBDAComparable": ["b34505e0-2f0e-497b-80bc-d43f3b24ed7f"],
    "IBDACreateTuneRequestEx": ["c0a4a1d4-2b3c-491a-ba22-499fbadd4d12"],
    "IBDA_AUX": ["7def4c09-6e66-4567-a819-f0e17f4a81ab"],
    "IBDA_AutoDemodulate": ["ddf15b12-bd25-11d2-9ca0-00c04f7971e0"],
    "IBDA_AutoDemodulateEx": ["34518d13-1182-48e6-b28f-b24987787326"],
    "IBDA_ConditionalAccess": ["cd51f1e0-7be9-4123-8482-a2a796c0a6b0"],
    "IBDA_ConditionalAccessEx": ["497c3418-23cb-44ba-bb62-769f506fcea7"],
    "IBDA_DRIDRMService": ["1f9bc2a5-44a3-4c52-aab1-0bbce5a1381d"],
    "IBDA_DRIWMDRMSession": ["05c690f8-56db-4bb2-b053-79c12098bb26"],
    "IBDA_DRM": ["f98d88b0-1992-4cd6-a6d9-b9afab99330d"],
    "IBDA_DRMService": ["bff6b5bb-b0ae-484c-9dca-73528fb0b46e"],
    "IBDA_DeviceControl": ["fd0a5af3-b41d-11d2-9c95-00c04f7971e0"],
    "IBDA_DiagnosticProperties": ["20e80cb5-c543-4c1b-8eb3-49e719eee7d4"],
    "IBDA_DigitalDemodulator": ["ef30f379-985b-4d10-b640-a79d5e04e1e0"],
    "IBDA_DigitalDemodulator2": ["525ed3ee-5cf3-4e1e-9a06-5368a84f9a6e"],
    "IBDA_DigitalDemodulator3": ["13f19604-7d32-4359-93a2-a05205d90ac9"],
    "IBDA_DiseqCommand": ["f84e2ab0-3c6b-45e3-a0fc-8669d4b81f11"],
    "IBDA_EasMessage": ["d806973d-3ebe-46de-8fbb-6358fe784208"],
    "IBDA_Encoder": ["3a8bad59-59fe-4559-a0ba-396cfaa98ae3"],
    "IBDA_EthernetFilter": ["71985f43-1ca1-11d3-9cc8-00c04f7971e0"],
    "IBDA_EventingService": ["207c413f-00dc-4c61-bad6-6fee1ff07064"],
    "IBDA_FDC": ["138adc7e-58ae-437f-b0b4-c9fe19d5b4ac"],
    "IBDA_FrequencyFilter": ["71985f47-1ca1-11d3-9cc8-00c04f7971e0"],
    "IBDA_GuideDataDeliveryService": ["c0afcb73-23e7-4bc6-bafa-fdc167b4719f"],
    "IBDA_IPSinkControl": ["3f4dc8e2-4050-11d3-8f4b-00c04f7971e2"],
    "IBDA_IPSinkInfo": ["a750108f-492e-4d51-95f7-649b23ff7ad7"],
    "IBDA_IPV4Filter": ["71985f44-1ca1-11d3-9cc8-00c04f7971e0"],
    "IBDA_IPV6Filter": ["e1785a74-2a23-4fb3-9245-a8f88017ef33"],
    "IBDA_ISDBConditionalAccess": ["5e68c627-16c2-4e6c-b1e2-d00170cdaa0f"],
    "IBDA_LNBInfo": ["992cf102-49f9-4719-a664-c4f23e2408f4"],
    "IBDA_MUX": ["942aafec-4c05-4c74-b8eb-8706c2a4943f"],
    "IBDA_NameValueService": ["7f0b3150-7b81-4ad4-98e3-7e9097094301"],
    "IBDA_NetworkProvider": ["fd501041-8ebe-11ce-8183-00aa00577da2"],
    "IBDA_NullTransform": ["ddf15b0d-bd25-11d2-9ca0-00c04f7971e0"],
    "IBDA_PinControl": ["0ded49d5-a8b7-4d5d-97a1-12b0c195874d"],
    "IBDA_SignalProperties": ["d2f1644b-b409-11d2-bc69-00a0c9ee9e16"],
    "IBDA_SignalStatistics": ["1347d106-cf3a-428a-a5cb-ac0d9a2a4338"],
    "IBDA_TIF_REGISTRATION": ["dfef4a68-ee61-415f-9ccb-cd95f2f98a3a"],
    "IBDA_Topology": ["79b56888-7fea-4690-b45d-38fd3c7849be"],
    "IBDA_TransportStreamInfo": ["8e882535-5f86-47ab-86cf-c281a72a0549"],
    "IBDA_TransportStreamSelector": ["1dcfafe9-b45e-41b3-bb2a-561eb129ae98"],
    "IBDA_UserActivityService": ["53b14189-e478-4b7a-a1ff-506db4b99dfe"],
    "IBDA_VoidTransform": ["71985f46-1ca1-11d3-9cc8-00c04f7971e0"],
    "IBDA_WMDRMSession": ["4be6fa3d-07cd-4139-8b80-8c18ba3aec88"],
    "IBDA_WMDRMTuner": ["86d979cf-a8a7-4f94-b5fb-14c0aca68fe6"],
    "IBFCacheable": ["30510861-98b5-11cf-bb82-00aa00bdce0b"],
    "IBITSExtensionSetup": ["29cfbbf7-09e4-4b97-b0bc-f2287e3d8eb3"],
    "IBITSExtensionSetupFactory": ["d5d2d542-5503-4e64-8b48-72ef91a32ee1"],
    "IBackClickEventArgs": ["2ae6146c-477e-48c9-8830-2c464b7c7104"],
    "IBackClickEventHandler": ["fa9bc21f-9892-482e-abf6-eb2d607d32de"],
    "IBackComponentService": ["d00fe662-58ee-4068-9eb9-f5bc39972ef4"],
    "IBackEase": ["e47796e7-f805-4a8f-81c9-38e6472caa94"],
    "IBackEaseStatics": ["3c70a2ff-a0a0-4786-926c-22321f8f25b7"],
    "IBackReferencedObject": ["c938b119-d3ad-4d02-b5ee-164c2ec8160e"],
    "IBackRequestedEventArgs": ["d603d28a-e411-4a4e-ba41-6a327a8675bc"],
    "IBackStackApplicationNotification": ["a64a6c35-3367-439e-a713-93f78e365b7b"],
    "IBackgroundAccessManagerBroker": ["934aa191-7986-46f0-ae1e-bbe6e4c7aa90"],
    "IBackgroundAccessManagerService": ["428d4ddd-3462-43df-9395-1eff13ae7a4b"],
    "IBackgroundAccessStateChangeHandler": ["43c6b434-c1be-4ad2-af03-c0deaccebd1f"],
    "IBackgroundAccessStateChangeHandler2": ["a15f35d4-56f1-482a-a9c5-5f77d1abe30a"],
    "IBackgroundActivatedEventArgs": ["ab14bee0-e760-440e-a91c-44796de3a92d"],
    "IBackgroundActivatedEventHandler": ["edb19fbb-0761-47cc-9a77-24d7072965ca"],
    "IBackgroundActivationContext": ["a2add09a-fb9b-4e6e-bc69-0b810eeb0ab4"],
    "IBackgroundActivationSessionManagerEvents": ["e7fb793d-3581-4b54-a798-ab8e9d69c963"],
    "IBackgroundAudioTrack": ["4b91b3bd-9e21-4266-a9c2-67dd011a2357"],
    "IBackgroundAudioTrackStatics": ["d9b1c0d7-d018-42a8-a559-cb4d9e97e664"],
    "IBackgroundCondition": ["ae48a1ee-8951-400a-8302-9c9c9a2a3a3b"],
    "IBackgroundContextMenuInvoked": ["2c68bdea-fe5e-4c78-9008-44c026994ca6"],
    "IBackgroundCopyCallback1": ["084f6593-3800-4e08-9b59-99fa59addf82"],
    "IBackgroundCopyCallback2": ["659cdeac-489e-11d9-a9cd-000d56965251"],
    "IBackgroundCopyCallback3": ["98c97bd2-e32b-4ad8-a528-95fd8b16bd42"],
    "IBackgroundCopyFile3": ["659cdeaa-489e-11d9-a9cd-000d56965251"],
    "IBackgroundCopyFile4": ["ef7e0655-7888-4960-b0e5-730846e03492"],
    "IBackgroundCopyFile5": ["85c1657f-dafc-40e8-8834-df18ea25717e"],
    "IBackgroundCopyFile6": ["cf6784f7-d677-49fd-9368-cb47aee9d1ad"],
    "IBackgroundCopyGroup": ["1ded80a7-53ea-424f-8a04-17fea9adc4f5"],
    "IBackgroundCopyJob1": ["59f5553c-2031-4629-bb18-2645a6970947"],
    "IBackgroundCopyJob4": ["659cdeae-489e-11d9-a9cd-000d56965251"],
    "IBackgroundCopyJob5": ["e847030c-bbba-4657-af6d-484aa42bf1fe"],
    "IBackgroundCopyJobHttpOptions": ["f1bd1079-9f01-4bdc-8036-f09b70095066"],
    "IBackgroundCopyJobHttpOptions2": ["b591a192-a405-4fc3-8323-4c5c542578fc"],
    "IBackgroundCopyJobHttpOptions3": ["8a9263d3-fd4c-4eda-9b28-30132a4d4e3c"],
    "IBackgroundCopyQMgr": ["16f41c69-09f5-41d2-8cd8-3c08c47bc8a8"],
    "IBackgroundCopyServerCertificateValidationCallback": ["4cec0d02-def7-4158-813a-c32a46945ff7"],
    "IBackgroundDownloader": ["c1c79333-6649-4b1d-a826-a4b3dd234d0b"],
    "IBackgroundDownloader2": ["a94a5847-348d-4a35-890e-8a1ef3798479"],
    "IBackgroundDownloader3": ["d11a8c48-86e8-48e2-b615-6976aabf861d"],
    "IBackgroundDownloaderFactory": ["26836c24-d89e-46f4-a29a-4f4d4f144155"],
    "IBackgroundDownloaderStaticMethods": ["52a65a35-c64e-426c-9919-540d0d21a650"],
    "IBackgroundDownloaderStaticMethods2": ["2faa1327-1ad4-4ca5-b2cd-08dbf0746afe"],
    "IBackgroundEventDetailsFactory": ["853d138c-29ca-42d1-8287-1b797d86f21a"],
    "IBackgroundExecutionManagerStatics": ["e826ea58-66a9-4d41-83d4-b4c18c87b846"],
    "IBackgroundExecutionManagerStatics2": ["469b24ef-9bbb-4e18-999a-fd6512931be9"],
    "IBackgroundTask": ["6a14295b-4900-49c8-8269-2c5686cecd16", "7d13d534-fd12-43ce-8c22-ea1ff13c06df"],
    "IBackgroundTaskBuilder": ["0351550e-3e64-4572-a93a-84075a37c917"],
    "IBackgroundTaskBuilder2": ["6ae7cfb1-104f-406d-8db6-844a570f42bb"],
    "IBackgroundTaskBuilder3": ["28c74f4a-8ba9-4c09-a24f-19683e2c924c"],
    "IBackgroundTaskBuilder4": ["4755e522-cba2-4e35-bd16-a6da7f1c19aa"],
    "IBackgroundTaskBuilder5": ["077103f6-99f5-4af4-bcad-4731d0330d43"],
    "IBackgroundTaskCanceledEventHandler": ["a6c4bac0-51f8-4c57-ac3f-156dd1680c4f"],
    "IBackgroundTaskCapabilityInternal": ["445289d9-2bba-4b3d-9f41-09683cc27200"],
    "IBackgroundTaskCompletedEventArgs": ["565d25cf-f209-48f4-9967-2b184f7bfbf0"],
    "IBackgroundTaskCompletedEventHandler": ["5b38e929-a086-46a7-a678-439135822bcf"],
    "IBackgroundTaskDeferral": ["93cc156d-af27-4dd3-846e-24ee40cadd25"],
    "IBackgroundTaskInstance": ["865bda7a-21d8-4573-8f32-928a1b0641f6"],
    "IBackgroundTaskInstance2": ["4f7d0176-0c76-4fb4-896d-5de1864122f6"],
    "IBackgroundTaskInstance4": ["7f29f23c-aa04-4b08-97b0-06d874cdabf5"],
    "IBackgroundTaskProgressEventArgs": ["fb1468ac-8332-4d0a-9532-03eae684da31"],
    "IBackgroundTaskProgressEventHandler": ["46e0683c-8a88-4c99-804c-76897f6277a6"],
    "IBackgroundTaskRegistration": ["10654cc2-a26e-43bf-8c12-1fb40dbfbfa0"],
    "IBackgroundTaskRegistration2": ["6138c703-bb86-4112-afc3-7f939b166e3b"],
    "IBackgroundTaskRegistration3": ["fe338195-9423-4d8b-830d-b1dd2c7badd5"],
    "IBackgroundTaskRegistrationGroup": ["2ab1919a-871b-4167-8a76-055cd67b5b23"],
    "IBackgroundTaskRegistrationGroupFactory": ["83d92b69-44cf-4631-9740-03c7d8741bc5"],
    "IBackgroundTaskRegistrationStatics": ["4c542f69-b000-42ba-a093-6a563c65e3f8"],
    "IBackgroundTaskRegistrationStatics2": ["174b671e-b20d-4fa9-ad9a-e93ad6c71e01"],
    "IBackgroundTransferBase": ["2a9da250-c769-458c-afe8-feb8d4d3b2ef"],
    "IBackgroundTransferCompletionGroup": ["2d930225-986b-574d-7950-0add47f5d706"],
    "IBackgroundTransferCompletionGroupTriggerDetails": ["7b6be286-6e47-5136-7fcb-fa4389f46f5b"],
    "IBackgroundTransferContentPart": ["e8e15657-d7d1-4ed8-838e-674ac217ace6"],
    "IBackgroundTransferContentPartFactory": ["90ef98a9-7a01-4a0b-9f80-a0b0bb370f8d"],
    "IBackgroundTransferErrorStaticMethods": ["aad33b04-1192-4bf4-8b68-39c5add244e2"],
    "IBackgroundTransferGroup": ["d8c3e3e4-6459-4540-85eb-aaa1c8903677"],
    "IBackgroundTransferGroupStatics": ["02ec50b2-7d18-495b-aa22-32a97d45d3e2"],
    "IBackgroundTransferOperation": ["ded06846-90ca-44fb-8fb1-124154c0d539"],
    "IBackgroundTransferOperationPriority": ["04854327-5254-4b3a-915e-0aa49275c0f9"],
    "IBackgroundTransferRangesDownloadedEventArgs": ["3ebc7453-bf48-4a88-9248-b0c165184f5c"],
    "IBackgroundTrigger": ["84b3a058-6027-4b87-9790-bdf3f757dbd7"],
    "IBackgroundUploader": ["c595c9ae-cead-465b-8801-c55ac90a01ce"],
    "IBackgroundUploader2": ["8e0612ce-0c34-4463-807f-198a1b8bd4ad"],
    "IBackgroundUploader3": ["b95e9439-5bf0-4b3a-8c47-2c6199a854b9"],
    "IBackgroundUploaderFactory": ["736203c7-10e7-48a0-ac3c-1ac71095ec57"],
    "IBackgroundUploaderStaticMethods": ["f2875cfb-9b05-4741-9121-740a83e247df"],
    "IBackgroundUploaderStaticMethods2": ["e919ac62-ea08-42f0-a2ac-07e467549080"],
    "IBackgroundWorkCostStatics": ["c740a662-c310-4b82-b3e3-3bcfb9e4c77d"],
    "IBackgroundWorkItemInstanceEvents": ["c21a025f-497a-47ce-abb5-dd7cf34d04cb"],
    "IBackgroundWorkItemInstanceRemote": ["0166231b-fd21-4e33-a713-75eb3207a138"],
    "IBackupDataLossDetector": ["3e2d05ac-3aa5-46fc-b7a4-8b14b9b1b59b"],
    "IBackupDataLossInfo": ["a7e443ae-8414-4853-bd79-dc8d6dfa063c"],
    "IBackupRestoreServices": ["f5f7bf38-0c0f-4b31-9dc0-fd925995cb68"],
    "IBackupSettings": ["cdfe1d93-f8c7-4236-b52c-b3eeec640576"],
    "IBadgeNotification": ["075cb4ca-d08a-4e2f-9233-7e289c1f7722"],
    "IBadgeNotificationFactory": ["edf255ce-0618-4d59-948a-5a61040c52f9"],
    "IBadgeUpdateManagerForUser": ["996b21bc-0386-44e5-ba8d-0c1077a62e92"],
    "IBadgeUpdateManagerStatics": ["33400faa-6dd5-4105-aebc-9b50fca492da"],
    "IBadgeUpdateManagerStatics2": ["979a35ce-f940-48bf-94e8-ca244d400b41"],
    "IBadgeUpdater": ["b5fa1fd4-7562-4f6c-bfa3-1b6ed2e57f2f"],
    "IBandHost": ["b9075c7c-d48e-403f-ab99-d6c77a1084ac"],
    "IBandwidthEstimation": ["6aebc7c5-323b-485e-8e25-fa49e68b72df"],
    "IBannerNotificationHandler": ["8d7b2ba7-db05-46a8-823c-d2b6de08ee91"],
    "IBannerUI": ["355ac7b4-0db5-460c-9a7e-263cf9cb801a"],
    "IBarcodeScanner": ["bea33e06-b264-4f03-a9c1-45b20f01134f"],
    "IBarcodeScanner2": ["89215167-8cee-436d-89ab-8dfb43bb4286"],
    "IBarcodeScannerCapabilities": ["c60691e4-f2c8-4420-a307-b12ef6622857"],
    "IBarcodeScannerCapabilities1": ["8e5ab3e9-0e2c-472f-a1cc-ee8054b6a684"],
    "IBarcodeScannerCapabilities2": ["f211cfec-e1a1-4ea8-9abc-92b1596270ab"],
    "IBarcodeScannerDataReceivedEventArgs": ["4234a7e2-ed97-467d-ad2b-01e44313a929"],
    "IBarcodeScannerDisableScannerRequest": ["88ecf7c0-37b9-4275-8e77-c8e52ae5a9c8"],
    "IBarcodeScannerDisableScannerRequest2": ["ccdfe625-65c3-4ccc-b457-f39c7a9ea60d"],
    "IBarcodeScannerDisableScannerRequestEventArgs": ["7006e142-e802-46f5-b604-352a15ce9232"],
    "IBarcodeScannerEnableScannerRequest": ["c0b3e9ba-816a-452b-bd77-b7e453ec446d"],
    "IBarcodeScannerEnableScannerRequest2": ["71a4f2a8-9905-41ac-9121-b645916a84a1"],
    "IBarcodeScannerEnableScannerRequestEventArgs": ["956c9419-7b4e-4451-8c41-8e10cfbc5b41"],
    "IBarcodeScannerErrorOccurredEventArgs": ["2cd2602f-cf3a-4002-a75a-c5ec468f0a20"],
    "IBarcodeScannerFrameReader": ["dbc72b07-64c3-482b-93c8-65fb33c22208"],
    "IBarcodeScannerFrameReaderFrameArrivedEventArgs": ["b0bbd604-54fd-436d-8629-712e787223dd"],
    "IBarcodeScannerGetSymbologyAttributesRequest": ["9774c46a-58e4-4c5f-b8e9-e41467632700"],
    "IBarcodeScannerGetSymbologyAttributesRequest2": ["6a6a2b13-75a8-49fb-b852-bfb93d760af7"],
    "IBarcodeScannerGetSymbologyAttributesRequestEventArgs": ["7f89de3e-fb5d-493c-b402-356b24d574a6"],
    "IBarcodeScannerHideVideoPreviewRequest": ["fa4ebe7f-6670-40e1-b90b-bb10d8d425fa"],
    "IBarcodeScannerHideVideoPreviewRequest2": ["7e28435d-9814-431d-a2f2-d6248c5ad4b5"],
    "IBarcodeScannerHideVideoPreviewRequestEventArgs": ["16a281fc-d6be-4bc7-9df1-33741f3eadea"],
    "IBarcodeScannerImagePreviewReceivedEventArgs": ["f3b7de85-6e8b-434e-9f58-06ef26bc4baf"],
    "IBarcodeScannerPreviewActivatedEventArgs": ["6772797c-99bf-4349-af22-e4123560371c"],
    "IBarcodeScannerProviderConnection": ["b44acbed-0b3a-4fa3-86c5-491ea30780eb"],
    "IBarcodeScannerProviderConnection2": ["be9b53cd-1134-418c-a06b-04423a73f3d7"],
    "IBarcodeScannerProviderTriggerDetails": ["50856d82-24e3-48ce-99c7-70aac1cbc9f7"],
    "IBarcodeScannerReport": ["5ce4d8b0-a489-4b96-86c4-f0bf8a37753d"],
    "IBarcodeScannerReportFactory": ["a2547326-2013-457c-8963-49c15dca78ce"],
    "IBarcodeScannerSetActiveSymbologiesRequest": ["db3f32b9-f7da-41a1-9f79-07bcd95f0bdf"],
    "IBarcodeScannerSetActiveSymbologiesRequest2": ["f5ff6edf-fa9a-4749-b11b-e8fccb75bc6b"],
    "IBarcodeScannerSetActiveSymbologiesRequestEventArgs": ["06305afa-7bf6-4d52-801a-330272f60ae1"],
    "IBarcodeScannerSetSymbologyAttributesRequest": ["32fb814f-a37f-48b0-acea-dce1480f12ae"],
    "IBarcodeScannerSetSymbologyAttributesRequest2": ["dffbbfc1-dba8-4b77-be1e-b56cd72f65b3"],
    "IBarcodeScannerSetSymbologyAttributesRequestEventArgs": ["b2b89809-9824-47d4-85bd-d0077baa7bd2"],
    "IBarcodeScannerStartSoftwareTriggerRequest": ["e3fa7b27-ff62-4454-af4a-cb6144a3e3f7"],
    "IBarcodeScannerStartSoftwareTriggerRequest2": ["eb72a25c-6658-4765-a68e-327482653deb"],
    "IBarcodeScannerStartSoftwareTriggerRequestEventArgs": ["2305d843-c88f-4f3b-8c3b-d3df071051ec"],
    "IBarcodeScannerStatics": ["5d115f6f-da49-41e8-8c8c-f0cb62a9c4fc"],
    "IBarcodeScannerStatics2": ["b8652473-a36f-4007-b1d0-279ebe92a656"],
    "IBarcodeScannerStatusUpdatedEventArgs": ["355d8586-9c43-462b-a91a-816dc97f452c"],
    "IBarcodeScannerStopSoftwareTriggerRequest": ["6f9faf35-e287-4ca8-b70d-5a91d694f668"],
    "IBarcodeScannerStopSoftwareTriggerRequest2": ["cb57c5dd-fe50-49f8-a0b4-bdc230814da2"],
    "IBarcodeScannerStopSoftwareTriggerRequestEventArgs": ["eac34450-4eb7-481a-9273-147a273b99b8"],
    "IBarcodeScannerVideoFrame": ["7e585248-9df7-4121-a175-801d8000112e"],
    "IBarcodeSymbologiesStatics": ["ca8549bb-06d2-43f4-a44b-c620679fd8d0"],
    "IBarcodeSymbologiesStatics2": ["8b7518f4-99d0-40bf-9424-b91d6dd4c6e0"],
    "IBarcodeSymbologyAttributes": ["66413a78-ab7a-4ada-8ece-936014b2ead7"],
    "IBarcodeSymbologyAttributesBuilder": ["c57b0cbf-e4f5-40b9-84cf-e63fbaea42b4"],
    "IBarometer": ["934475a8-78bf-452f-b017-f0209ce6dab4"],
    "IBarometer2": ["32bcc418-3eeb-4d04-9574-7633a8781f9f"],
    "IBarometer3": ["0e35f0ea-02b5-5a04-b03d-822084863a54"],
    "IBarometerDataThreshold": ["076b952c-cb62-5a90-a0d1-f85e4a936394"],
    "IBarometerReading": ["f5b9d2e6-1df6-4a1a-a7ad-321d4f5db247"],
    "IBarometerReading2": ["85a244eb-90c5-4875-891c-3865b4c357e7"],
    "IBarometerReadingChangedEventArgs": ["3d84945f-037b-404f-9bbb-6232d69543c3"],
    "IBarometerStatics": ["286b270a-02e3-4f86-84fc-fdd892b5940f"],
    "IBarometerStatics2": ["8fc6b1e7-95ff-44ac-878e-d65c8308c34c"],
    "IBasicAudioEffect": ["8c062c53-6bc0-48b8-a99a-4b41550f1359"],
    "IBasicBitmapOps": ["327abdaf-072b-11d3-9d7b-0000f81ef32e"],
    "IBasicConnectedAnimationConfiguration": ["e675f9b5-a4d6-5353-83e6-c89e7cf8d456"],
    "IBasicConnectedAnimationConfigurationFactory": ["95e6844a-4377-503c-bee2-11dfcd5570e6"],
    "IBasicDevice": ["f4f26cbb-7962-48b7-80f7-c3a5d753bcb0"],
    "IBasicPositioner": ["474124e2-17d8-4eaa-b9b7-08baf8878ae7"],
    "IBasicProperties": ["d05d55db-785e-4a66-be02-9beec58aea81"],
    "IBasicVideo2": ["329bb360-f6ea-11d1-9038-00a0c9697298"],
    "IBasicVideoEffect": ["8262c7ef-b360-40be-949b-2ff42ff35693"],
    "IBattery": ["bc894fc6-0072-47c8-8b5d-614aaa7a437e"],
    "IBatteryNotificationManager": ["529e1404-8b51-11e6-ae22-56b6b6499611"],
    "IBatteryReport": ["c9858c3a-4e13-420a-a8d0-24f18f395401"],
    "IBatteryStatics": ["79cd72b6-9e5e-4452-bea6-dfcd541e597f"],
    "IBeginStoryboard": ["64189fcd-49ec-4e52-a6f6-55324c921053"],
    "IBeginStoryboardStatics": ["12cff18c-aa91-4c4a-b82f-df34fc57f94b"],
    "IBezierSegment": ["af4bb9ee-8984-49b7-81df-3f35994b95eb"],
    "IBezierSegmentStatics": ["c0287bac-1410-4530-8452-1c9d0ad1f341"],
    "IBidiAsyncNotifyChannel": ["532818f7-921b-4fb2-bff8-2f4fd52ebebf"],
    "IBidiAsyncNotifyRegistration": ["a8fe383c-c22f-4790-88cd-d9fe0f0addf9"],
    "IBidiRequestContainer": ["d752f6c0-94a8-4275-a77d-8f1d1a1121ae"],
    "IBidiSpl": ["d580dc0e-de39-4649-baa8-bf0b85a03a97"],
    "IBidiSpl2": ["0e8f51b8-8273-4906-8e7b-be453ffd2e2b"],
    "IBinaryConverter": ["728ab302-217d-11da-b2a4-000e7bbb2b09"],
    "IBinaryConverter2": ["8d7928b4-4e17-428d-9a17-728df00d1b2b"],
    "IBindCallbackRedirect": ["11c81bc2-121e-4ed5-b9c4-b430bd54f2c0"],
    "IBindHttpSecurity": ["a9eda967-f50e-4a33-b358-206f6ef3086d"],
    "IBindResource": ["0c733ab1-2a1c-11ce-ade5-00aa0044773d"],
    "IBindStatusCallbackEx": ["aaa74ef9-8ee7-4659-88d9-f8c504da73cc"],
    "IBindStatusCallbackEx2": ["32445657-606b-11e0-9ebd-18a905c16311"],
    "IBindStatusCallbackHolderSink": ["bb81f1d9-5fa7-4941-a57c-1f5c24eff5ad"],
    "IBindableIterable": ["036d2c08-df29-41af-8aa2-d774be62ba6f"],
    "IBindableIterator": ["6a1d6c07-076d-49f2-8314-f52c9c9a8331"],
    "IBindableObservableVector": ["fe1eb536-7e7f-4f90-ac9a-474984aae512"],
    "IBindableVector": ["393de7de-6fd0-4c0d-bb71-47244a113e93"],
    "IBindableVectorChangedEventHandler": ["624cd4e1-d007-43b1-9c03-af4d3e6258c4"],
    "IBindableVectorView": ["346dd6e7-976e-4bc3-815d-ece243bc0f33"],
    "IBinding2": ["34f96fcb-0406-48b3-9e82-f333ec4c6910"],
    "IBindingBase": ["1589a2ab-3d15-49bc-a447-8a5448e58870"],
    "IBindingBaseFactory": ["22dafc3a-7701-4666-a1ba-9859bdcfec34"],
    "IBindingExInternal": ["f3d8f080-a5eb-476f-9d19-a5ef24e5c2e6"],
    "IBindingExpression": ["516a19a5-c2fd-4a9e-9fd3-9aa42f995a3c"],
    "IBindingExpressionBase": ["fded3154-e954-4f67-8fb6-6ed79b3a1cb3"],
    "IBindingExpressionBaseFactory": ["ea7116a7-c2d9-4375-b471-66b9c48c7930"],
    "IBindingExpressionFactory": ["1cb55cd9-db72-40b3-a2b5-24ee6ea5c328"],
    "IBindingFactory": ["ff42bb08-c39e-4f7e-8434-a1569083883c"],
    "IBindingFailedEventArgs": ["32c1d013-4dbd-446d-bbb8-0de35048a449"],
    "IBindingFailedEventHandler": ["136b1782-54ba-420d-a1aa-82828721cde6"],
    "IBindingOperations": ["6fffd738-9839-419c-a17a-4b3604e1524e"],
    "IBindingOperationsStatics": ["e155ef73-95a0-4aab-8c7d-2a47da073c79"],
    "IBitBltVideoDevice": ["2891e8a0-6058-4b93-9923-f7d8d03ea472"],
    "IBitmapBuffer": ["a53e04c4-399c-438c-b28f-a63a6b83d1a1"],
    "IBitmapCache": ["79c2219e-44d2-4610-9735-9bec83809ecf"],
    "IBitmapCodecInformation": ["400caaf2-c4b0-4392-a3b0-6f6f9ba95cb4"],
    "IBitmapData": ["d1a34ef2-cad8-4635-a3d2-fcda8d3f3caf"],
    "IBitmapDecoder": ["acef22ba-1d74-4c91-9dfc-9620745233e6"],
    "IBitmapDecoderStatics": ["438ccb26-bcef-4e95-bad6-23a822e58d01"],
    "IBitmapDecoderStatics2": ["50ba68ea-99a1-40c4-80d9-aef0dafa6c3f"],
    "IBitmapEncoder": ["2bc468e3-e1f8-4b54-95e8-32919551ce62"],
    "IBitmapEncoderStatics": ["a74356a7-a4e4-4eb9-8e40-564de7e1ccb2"],
    "IBitmapEncoderStatics2": ["33cbc259-fe31-41b1-b812-086d21e87e16"],
    "IBitmapEncoderWithSoftwareBitmap": ["686cd241-4330-4c77-ace4-0334968b1768"],
    "IBitmapFrame": ["72a49a1c-8081-438d-91bc-94ecfc8185c6"],
    "IBitmapFrameWithSoftwareBitmap": ["fe287c9a-420c-4963-87ad-691436e08383"],
    "IBitmapIcon": ["e8fe17cb-35f7-40f3-a185-48b397b73e68"],
    "IBitmapIcon2": ["0624a20a-9dd1-4201-bb20-42863da15658"],
    "IBitmapIconFactory": ["46d64b1d-7a49-4f66-9729-2848c788e402"],
    "IBitmapIconSource": ["c8e33dc7-d4ae-4a87-947f-ac4d0bcf5af4"],
    "IBitmapIconSourceFactory": ["6509e5c6-44b6-4cd1-86cd-c3189b12c43c"],
    "IBitmapIconSourceStatics": ["5a105887-e494-4d2b-8528-39472296133f"],
    "IBitmapIconStatics": ["e072d117-e4e7-4e0c-9470-53ff1ce84f67"],
    "IBitmapIconStatics2": ["9745026b-b742-4a89-a5d7-a0e5fb809af1"],
    "IBitmapImage": ["31af3271-e3b4-442d-a341-4c0226b2725b", "327abdaa-072b-11d3-9d7b-0000f81ef32e"],
    "IBitmapImage2": ["1069c1b6-8c9b-4762-be3d-759f5698f2b3"],
    "IBitmapImage3": ["f1de6f26-3c73-453f-a7ba-9b85c18b3733"],
    "IBitmapImageFactory": ["c9132978-4810-4e5e-8087-03671ee60d85"],
    "IBitmapImageStatics": ["9e282143-70e8-437c-9fa4-2cbf295cff84"],
    "IBitmapImageStatics2": ["c5f5576a-75af-41a4-b893-8fe91fee2882"],
    "IBitmapImageStatics3": ["2b44e30d-f6d5-4411-a8cd-bf7603c4faa0"],
    "IBitmapProperties": ["ea9f4f1b-b505-4450-a4d1-e8ca94529d8d"],
    "IBitmapPropertiesView": ["7e0fe87a-3a70-48f8-9c55-196cf5a545f5"],
    "IBitmapSource": ["23d86411-202f-41b2-8c5b-a8a3b333800b"],
    "IBitmapSourceFactory": ["e240420e-d4a7-49a4-a0b4-a59fdd77e508"],
    "IBitmapSourceStatics": ["9a9c9981-827b-4e51-891b-8a15b511842d"],
    "IBitmapTransform": ["ae755344-e268-4d35-adcf-e995d31a8d34"],
    "IBitmapTypedValue": ["cd8044a9-2443-4000-b0cd-79316c56f589"],
    "IBitmapTypedValueFactory": ["92dbb599-ce13-46bb-9545-cb3a3f63eb8b"],
    "IBitsPeer": ["659cdea2-489e-11d9-a9cd-000d56965251"],
    "IBitsPeerCacheAdministration": ["659cdead-489e-11d9-a9cd-000d56965251"],
    "IBitsPeerCacheRecord": ["659cdeaf-489e-11d9-a9cd-000d56965251"],
    "IBitsTokenOptions": ["9a2584c3-f7d2-457a-9a5e-22b67bffc7d2"],
    "IBln": ["e0b1c713-e991-11d0-9ea7-00c04fd7081f"],
    "IBlock2": ["5ec7bdf3-1333-4a92-8318-6caedc12ef89"],
    "IBlockFactory": ["07110532-4f59-4f3b-9ce5-25784c430507"],
    "IBlockNotificationChannelsCallback": ["aae55411-1b10-4d55-a5dc-88f6d03a72f8"],
    "IBlockRange": ["b507ca25-2204-11dd-966a-001aa01bbc58"],
    "IBlockRangeList": ["b507ca26-2204-11dd-966a-001aa01bbc58"],
    "IBlockStatics": ["f86a8c34-8d18-4c53-aebd-91e610a5e010"],
    "IBlockStatics2": ["af01a4d6-03e3-4cee-9b02-2bfc308b27a9"],
    "IBluetoothAdapter": ["7974f04c-5f7a-4a34-9225-a855f84b1a8b"],
    "IBluetoothAdapter2": ["ac94cecc-24d5-41b3-916d-1097c50b102b"],
    "IBluetoothAdapter3": ["8f8624e0-cba9-5211-9f89-3aac62b4c6b8"],
    "IBluetoothAdapterStatics": ["8b02fb6a-ac4c-4741-8661-8eab7d17ea9f"],
    "IBluetoothClassOfDevice": ["d640227e-d7d7-4661-9454-65039ca17a2b"],
    "IBluetoothClassOfDeviceStatics": ["e46135bd-0fa2-416c-91b4-c1e48ca061c1"],
    "IBluetoothDevice": ["2335b156-90d2-4a04-aef5-0e20b9e6b707"],
    "IBluetoothDevice2": ["0133f954-b156-4dd0-b1f5-c11bc31a5163"],
    "IBluetoothDevice3": ["57fff78b-651a-4454-b90f-eb21ef0b0d71"],
    "IBluetoothDevice4": ["817c34ad-0e9c-42b2-a8dc-3e8094940d12"],
    "IBluetoothDevice5": ["b5e0b385-5e85-4559-a10d-1c7281379f96"],
    "IBluetoothDeviceId": ["c17949af-57c1-4642-bcce-e6c06b20ae76"],
    "IBluetoothDeviceIdStatics": ["a7884e67-3efb-4f31-bbc2-810e09977404"],
    "IBluetoothDeviceStatics": ["0991df51-57db-4725-bbd7-84f64327ec2c"],
    "IBluetoothDeviceStatics2": ["c29e8e2f-4e14-4477-aa1b-b8b47e5b7ece"],
    "IBluetoothLEAdvertisement": ["066fb2b7-33d1-4e7d-8367-cf81d0f79653"],
    "IBluetoothLEAdvertisementBytePattern": ["fbfad7f2-b9c5-4a08-bc51-502f8ef68a79"],
    "IBluetoothLEAdvertisementBytePatternFactory": ["c2e24d73-fd5c-4ec3-be2a-9ca6fa11b7bd"],
    "IBluetoothLEAdvertisementDataSection": ["d7213314-3a43-40f9-b6f0-92bfefc34ae3"],
    "IBluetoothLEAdvertisementDataSectionFactory": ["e7a40942-a845-4045-bf7e-3e9971db8a6b"],
    "IBluetoothLEAdvertisementDataTypesStatics": ["3bb6472f-0606-434b-a76e-74159f0684d3"],
    "IBluetoothLEAdvertisementFilter": ["131eb0d3-d04e-47b1-837e-49405bf6f80f"],
    "IBluetoothLEAdvertisementPublisher": ["cde820f9-d9fa-43d6-a264-ddd8b7da8b78"],
    "IBluetoothLEAdvertisementPublisher2": ["fbdb545e-56f1-510f-a434-217fbd9e7bd2"],
    "IBluetoothLEAdvertisementPublisherFactory": ["5c5f065e-b863-4981-a1af-1c544d8b0c0d"],
    "IBluetoothLEAdvertisementPublisherStatusChangedEventArgs": ["09c2bd9f-2dff-4b23-86ee-0d14fb94aeae"],
    "IBluetoothLEAdvertisementPublisherStatusChangedEventArgs2": ["8f62790e-dc88-5c8b-b34e-10b321850f88"],
    "IBluetoothLEAdvertisementPublisherTrigger": ["ab3e2612-25d3-48ae-8724-d81877ae6129"],
    "IBluetoothLEAdvertisementPublisherTrigger2": ["aa28d064-38f4-597d-b597-4e55588c6503"],
    "IBluetoothLEAdvertisementPublisherTriggerDetails": ["610eca86-3480-41c9-a918-7ddadf207e00"],
    "IBluetoothLEAdvertisementPublisherTriggerDetails2": ["d4a3d025-c601-42d6-9829-4ccb3f5cd77f"],
    "IBluetoothLEAdvertisementReceivedEventArgs": ["27987ddf-e596-41be-8d43-9e6731d4a913"],
    "IBluetoothLEAdvertisementReceivedEventArgs2": ["12d9c87b-0399-5f0e-a348-53b02b6b162e"],
    "IBluetoothLEAdvertisementWatcher": ["a6ac336f-f3d3-4297-8d6c-c81ea6623f40"],
    "IBluetoothLEAdvertisementWatcher2": ["01bf26bc-b164-5805-90a3-e8a7997ff225"],
    "IBluetoothLEAdvertisementWatcherFactory": ["9aaf2d56-39ac-453e-b32a-85c657e017f1"],
    "IBluetoothLEAdvertisementWatcherStoppedEventArgs": ["dd40f84d-e7b9-43e3-9c04-0685d085fd8c"],
    "IBluetoothLEAdvertisementWatcherTrigger": ["1aab1819-bce1-48eb-a827-59fb7cee52a6"],
    "IBluetoothLEAdvertisementWatcherTrigger2": ["39b56799-eb39-5ab6-9932-aa9e4549604d"],
    "IBluetoothLEAdvertisementWatcherTriggerDetails": ["a7db5ad7-2257-4e69-9784-fee645c1dce0"],
    "IBluetoothLEAppearance": ["5d2079f2-66a8-4258-985e-02b4d9509f18"],
    "IBluetoothLEAppearanceCategoriesStatics": ["6d4d54fe-046a-4185-aab6-824cf0610861"],
    "IBluetoothLEAppearanceStatics": ["a193c0c7-4504-4f4a-9ba5-cd1054e5e065"],
    "IBluetoothLEAppearanceSubcategoriesStatics": ["e57ba606-2144-415a-8312-71ccf291f8d1"],
    "IBluetoothLEDevice": ["b5ee2f7b-4ad8-4642-ac48-80a0b500e887"],
    "IBluetoothLEDevice2": ["26f062b3-7aee-4d31-baba-b1b9775f5916"],
    "IBluetoothLEDevice3": ["aee9e493-44ac-40dc-af33-b2c13c01ca46"],
    "IBluetoothLEDevice4": ["2b605031-2248-4b2f-acf0-7cee36fc5870"],
    "IBluetoothLEDevice5": ["9d6a1260-5287-458e-95ba-17c8b7bb326e"],
    "IBluetoothLEDeviceStatics": ["c8cf1a19-f0b6-4bf0-8689-41303de2d9f4"],
    "IBluetoothLEDeviceStatics2": ["5f12c06b-3bac-43e8-ad16-563271bd41c2"],
    "IBluetoothLEManufacturerData": ["912dba18-6963-4533-b061-4694dafb34e5"],
    "IBluetoothLEManufacturerDataFactory": ["c09b39f8-319a-441e-8de5-66a81e877a6c"],
    "IBluetoothSignalStrengthFilter": ["df7b7391-6bb5-4cfe-90b1-5d7324edcf7f"],
    "IBluetoothUuidHelperStatics": ["17df0cd8-cf74-4b21-afe6-f57a11bcdea0"],
    "IBodyPart": ["cd000021-8b95-11d1-82db-00c04fb1625d"],
    "IBodyParts": ["cd000023-8b95-11d1-82db-00c04fb1625d"],
    "IBold": ["ade73784-1b59-4da4-bb23-0f20e885b4bf"],
    "IBooleanExpression": ["0519dace-f446-4ecb-bc0c-bbcdff6bb952"],
    "IBooleanKeyFrameAnimation": ["95e23a08-d1f4-4972-9770-3efe68d82e14"],
    "IBooleanSetting": ["18d72473-cd4a-411d-a73e-6b212cec6ca8"],
    "IBootOptions": ["2c941fd4-975b-59be-a960-9a2a262853a5"],
    "IBootTrigger": ["2a9c35da-d357-41f4-bbc1-207ac1b1f3cb"],
    "IBorder": ["797c4539-45bd-4633-a044-bfb02ef5170f"],
    "IBorder2": ["a1efbd9d-cb8b-56b5-878d-3a7f43bc9730"],
    "IBorderStatics": ["b81d1639-e911-4fd7-a4c4-b9c7f008b7fc"],
    "IBorderStatics2": ["a26d4476-803f-5040-a0f3-e66db3733166"],
    "IBounceEase": ["2bf1464e-fc71-47ed-85a1-3ba9577718b4"],
    "IBounceEaseStatics": ["c0701da2-4f73-41c9-b2cb-2ea3105107ff"],
    "IBounceScalarNaturalMotionAnimation": ["baa30dcc-a633-4618-9b06-7f7c72c87cff"],
    "IBounceVector2NaturalMotionAnimation": ["da344196-2154-4b3c-88aa-47361204eccd"],
    "IBounceVector3NaturalMotionAnimation": ["47dabc31-10d3-4518-86f1-09caf742d113"],
    "IBreadcrumbBar": ["02305531-f76f-4a4d-a760-b1192e72c6d5"],
    "IBrightnessOverride": ["96c9621a-c143-4392-bedd-4a7e9574c8fd"],
    "IBrightnessOverrideSettings": ["d112ab2a-7604-4dba-bcf8-4b6f49502cb0"],
    "IBrightnessOverrideSettingsStatics": ["d487dc90-6f74-440b-b383-5fe96cf00b0f"],
    "IBrightnessOverrideStatics": ["03a7b9ed-e1f1-4a68-a11f-946ad8ce5393"],
    "IBringIntoViewOptions": ["19bdd1b5-c7cb-46d9-a4dd-a1bbe83ef2fb"],
    "IBringIntoViewOptions2": ["e855e08e-64b6-1211-bddb-1fddbb6e8231"],
    "IBringIntoViewRequestedEventArgs": ["0e629ec4-2206-4c8b-94ae-bdb66a4ebfd1"],
    "IBroadcastDVRCommand": ["5a4c52f1-92a1-4f7d-9010-60dc2a06d6af"],
    "IBroadcastDVRComponent": ["82467e7f-e743-4e2f-bf0b-20adcadf3217"],
    "IBroadcastEvent": ["3b21263f-26e8-489d-aac4-924f7efd9511"],
    "IBroadcastEventEx": ["3d9e3887-1929-423f-8021-43682de95448"],
    "IBrokeredTask": ["3a22e38b-9e68-4cdf-ade9-a25bc040c520"],
    "IBrokeredTaskNotify": ["56cfe922-3560-40a7-a40c-d6d40f1f1b34"],
    "IBrowserActivationEvent": ["7bc9fc77-d85a-4220-b7dd-7b22cf22d0ed"],
    "IBrowserApplicationState": ["e66a412d-14b3-425c-82ac-5b7716cca5a7"],
    "IBrowserBandProxy": ["cbd8776e-43df-43b1-b533-948983fd037b"],
    "IBrowserBrokerFactory": ["7179e7f6-4fe0-48b3-8b6a-bb413bf6ea0d"],
    "IBrowserConnectionPointCB": ["c14c0111-c86c-4b2f-af17-5a62731dd48e"],
    "IBrowserEmulationControl": ["254e52a5-428f-4170-bf66-8b9d42536f20"],
    "IBrowserEvents": ["33614250-dfea-46cc-8347-9a655bcf1a08"],
    "IBrowserExtension": ["32bb8320-b41b-11cf-a6bb-0080c7b2d682"],
    "IBrowserFrameHostServices": ["75f5a2c0-b905-4f5e-aa34-b68b335c5e09"],
    "IBrowserFrameTestHelper": ["cb8e9baf-8f6a-4931-85c0-bb6db9b9c4d1"],
    "IBrowserHTMLWindowSupport": ["6379d68c-df01-4b71-9f38-effb828557fc"],
    "IBrowserHost": ["b965e203-2a6a-4e2e-a15d-cecd736f12b2"],
    "IBrowserHostEvents": ["7d722cee-1797-44e0-a992-1a3c7fd9ddd1"],
    "IBrowserImageStore": ["e62a8160-909d-49fd-b771-2766c574af93"],
    "IBrowserImageStoreEvents": ["615e31b1-2b6e-4222-aa41-170150c516ec"],
    "IBrowserProgressAggregator": ["5ea8eec4-c34b-4de0-9b56-0e15fd8c8f80"],
    "IBrowserProgressConnection": ["20174539-b2c7-4ec7-970b-04201f9cdbad"],
    "IBrowserProgressSessionProvider": ["18140cbd-aa23-4384-a38d-6a8d3e2be505"],
    "IBrowserService": ["02ba3b52-0547-11d1-b833-00c04fc9b31f"],
    "IBrowserService2": ["68bd21cc-438b-11d2-a560-00a0c92dbfe8"],
    "IBrowserService3": ["27d7ce21-762d-48f3-86f3-40e2fd3749c4"],
    "IBrowserService4": ["639f1bff-e135-4096-abd8-e0f504d649a4"],
    "IBrowserSettings": ["dd1e21cc-e2c7-402c-bf05-10328d3f6bad"],
    "IBrowserStreamImageStore": ["e97b1e92-e9fd-419d-b08f-c64466a0784c"],
    "IBrowserTabComponentRemotable": ["ebfc36ec-6683-460c-81f6-0384894a32ed"],
    "IBrowserThreadState": ["ccd6f2eb-d12a-40c7-8683-509f1c818eae"],
    "IBrowserTrackEventsCallback": ["3934e4c2-8143-4e4c-a1dc-718f8563f337"],
    "IBrowserWindows": ["6312f983-7c1b-4080-98b1-98e463b5ec74"],
    "IBrowserWithActivationNotification": ["05a89298-6246-4c63-bb0d-9bdaf140bf3b"],
    "IBrowsingContextCOMReceptor": ["561ae8b0-f775-497b-b441-100120851784"],
    "IBrush": ["8806a321-1e06-422c-a1cc-01696559e021"],
    "IBrushFactory": ["399658a2-14fb-4b8f-83e6-6e3dab12069b"],
    "IBrushOverrides2": ["d092b151-d83b-5a81-a71e-a1c7f8ad6963"],
    "IBrushStatics": ["e70c3102-0225-47f5-b22e-0467619f6a22"],
    "IBrushTransition": ["1116972c-9dad-5429-a7dd-b2b7d061ab8e"],
    "IBrushTransitionFactory": ["3dbe7368-13d4-510c-a215-7539f4787b52"],
    "IBuffer": ["000001b4-0000-0000-c000-000000000046", "905a0fe0-bc53-11df-8c49-001e4fc686da"],
    "IBufferFactory": ["71af914d-c10f-484b-bc50-14bc623b3a27"],
    "IBufferMediaFrame": ["b5b153c7-9b84-4062-b79c-a365b2596854"],
    "IBufferProtectUnprotectResult": ["47995edc-6cec-4e3a-b251-9e7485d79e7a"],
    "IBufferStatics": ["e901e65b-d716-475a-a90a-af7229b1e741"],
    "IBufferedTimedTextDataSourceFactory": ["0bd09785-1035-426b-b34d-3111ee270f7c"],
    "IBufferingTime": ["1e00486a-78dd-11d2-8dd3-006097c9a2b2"],
    "IBuilderWizardManager": ["95fc88c3-9fcb-11cf-a405-00aa00c00940"],
    "IBuiltMenu": ["3a57684a-3480-4d0b-920a-c21912455d94"],
    "IBulkParser": ["193215bf-3815-441a-98bc-589db62452a6"],
    "IBurnVerification": ["d2ffd834-958b-426d-8470-2a13879c6a91"],
    "IButton": ["280335ae-5570-46c7-8e0b-602be71229a2", "66833fe9-8583-11d1-b16a-00c0f0283628"],
    "IButtonAutomationPeer": ["fb77efbe-39ec-4508-8ac3-51a1424027d7"],
    "IButtonAutomationPeerFactory": ["3fdb9f49-f4ab-4780-8644-03376299a175"],
    "IButtonBase": ["fa002c1a-494e-46cf-91d4-e14a8d798674"],
    "IButtonBaseAutomationPeer": ["a4f3b5b6-7585-4e0b-96d2-08cf6f28befa"],
    "IButtonBaseAutomationPeerFactory": ["8a04091e-e6b2-4c60-a759-c13ca45165ed"],
    "IButtonBaseFactory": ["389b7c71-5220-42b2-9992-2690c1a6702f"],
    "IButtonBaseStatics": ["67ef17e1-fe37-474f-9e97-3b5e0b30f2df"],
    "IButtonFactory": ["80a13c19-843a-451c-8cf5-44c701b0e216"],
    "IButtonMenu": ["66833fed-8583-11d1-b16a-00c0f0283628"],
    "IButtonMenus": ["66833feb-8583-11d1-b16a-00c0f0283628"],
    "IButtonStaticsWithFlyout": ["90143898-a16c-4759-b2f0-a5f7e625169e"],
    "IButtonWithFlyout": ["09108f87-df6c-4180-9b3a-e60845825811"],
    "IButtons": ["66833fe7-8583-11d1-b16a-00c0f0283628"],
    "ICAT": ["7c6995fb-2a31-4bd7-953e-b1ad7fb7d31c"],
    "ICCSubStreamFiltering": ["4b2bd7ea-8347-467b-8dbf-62f784929cc3"],
    "ICDBurnGlobalSettingsDialog": ["1deecab6-1cff-4923-9a53-bc2c5d199544"],
    "ICDBurnPriv": ["9cfd6c07-1992-47bd-9b83-830b358b2df4"],
    "ICDPAFSUserSettings": ["df33603d-5e58-4a7e-986a-cd6ea2125a7c"],
    "ICDPAccount": ["290ee677-8899-4721-add0-56df4fee0bdd"],
    "ICDPAccountProvider": ["4b22fba5-d1ea-4e3c-86ff-df3ed0e81d90"],
    "ICDPAccountProviderCallback": ["0e9c4de9-954d-4444-8521-508484e0c649"],
    "ICDPActivity": ["a6437fc1-d521-4b4c-b986-add26ee93986"],
    "ICDPActivityAsset": ["147cbf37-7b07-4981-87ca-fcc4b45ca8eb"],
    "ICDPActivityStore": ["c96b69cd-c73b-4ce4-a85b-26defafc1916"],
    "ICDPActivityStoreManagement": ["9f0c9868-f343-4b67-b5b0-d59464ff3abc"],
    "ICDPAppControlClient": ["7427f25f-dd26-474d-b5f2-9372a028da32"],
    "ICDPAppId": ["7eb7f6de-2c88-4249-93c7-e9d31f4dc273"],
    "ICDPAuthInfo": ["e071e9a9-5a5e-4753-9995-37f362e398a0"],
    "ICDPAuxiliaryStreamClient": ["b80758b4-e519-4920-b2a6-067cd7654ffd"],
    "ICDPAuxiliaryStreamHost": ["41ad4428-d8e3-4ab0-b880-06b0c421fcc8"],
    "ICDPBinaryClient": ["dc1cf076-da95-472e-81a2-ef55fc2865e5"],
    "ICDPBinaryHost": ["834497dc-f3ca-4f30-a30e-e91bd7f515ad"],
    "ICDPCallbackNotifier": ["75bc530f-ff1e-45d5-9482-a2b907ff3b51"],
    "ICDPClientAuthorizationProvider": ["4d578e0a-ae33-403f-bd68-97a4b2eaf886"],
    "ICDPClientAuthorizationProviderCallback": ["f0e42f8a-6b3a-447e-b358-f861b5260dfd"],
    "ICDPComAFSUserSettings": ["683d7fc9-8697-4309-994e-e8a2c5628884"],
    "ICDPComAccountProvider": ["ed642470-bbf6-4d03-ad85-5dddb2889113"],
    "ICDPComAccountProviderCallback": ["b6fa2e6a-4552-43a6-9569-1d7b83406c06"],
    "ICDPComActivityStore": ["611b5064-4ea8-4edf-8734-64da92fc8e44"],
    "ICDPComActivityStoreManagementControl": ["8dd85454-2ca5-4099-9412-f471edac4253"],
    "ICDPComAppControlClient": ["8b2e9458-f2b6-4c79-bfd3-4ec9434d8b02"],
    "ICDPComAppControlSystemHandler": ["e40333dd-4915-43ad-b02c-5a0a9dbf9b14"],
    "ICDPComAppControlSystemHandlerCallback": ["952c7c44-3704-48a5-952d-fd3cdb111811"],
    "ICDPComAuthenticationHandler": ["427ee032-ef0b-4fc5-a247-52a625121243"],
    "ICDPComAuthenticationHandlerCallback": ["31eb73d2-3bc4-435d-b733-b30bdf09dee9"],
    "ICDPComAuxiliaryStreamClient": ["6d51013b-d4ec-4f37-a339-f71656e0b43e"],
    "ICDPComAuxiliaryStreamClientHandler": ["debf86c3-e72b-463e-af42-1921156482eb"],
    "ICDPComAuxiliaryStreamHost": ["373eb506-7ff2-4322-a6cd-5248189b85f4"],
    "ICDPComAuxiliaryStreamHostHandler": ["6cf26be1-51c8-41e3-aba6-22b7a479ca69"],
    "ICDPComBinaryClient": ["3ee35a36-2887-474e-9b0e-d615dacf2d1b"],
    "ICDPComBinaryHost": ["0dbd6b2a-fefc-4554-ac3e-9930474f7c6f"],
    "ICDPComClientAuthorizationProviderCallback": ["e9a8e362-9e3d-4278-858f-695972deba49"],
    "ICDPComDevice": ["cab19a95-482b-4720-99a5-a9232995b595"],
    "ICDPComDeviceCache": ["343b9da0-7a25-4bf2-9542-1178bff18518"],
    "ICDPComDeviceQuery": ["f6dead79-25e8-43ea-8016-04929d87602d"],
    "ICDPComDirectNotificationHost": ["75165041-c9ce-4302-a9b2-873dded43b7f"],
    "ICDPComEnumDevice": ["1ca240ac-72a6-470d-8b1a-1d97087d0f05"],
    "ICDPComGameDvrSystemHandler": ["c7f208a4-c8cd-4689-983b-a2babae6a460"],
    "ICDPComGamepadSystemHandler": ["e95754ca-b1d4-4a0b-afe2-0c051752d9fb"],
    "ICDPComHostAuthorizationProviderCallback": ["05f48c01-49d5-4ead-9248-04553bcbdda8"],
    "ICDPComLegacyHost": ["014e0fcf-0f61-4507-b3c0-8a9834be5fee"],
    "ICDPComLegacyHostHandler": ["70ca8280-3125-47c5-9480-c8cc17559e7e"],
    "ICDPComMediaClient": ["d11e298a-2917-4d15-95fd-daf81c3311ac"],
    "ICDPComMediaClientHandler": ["424c73cb-0665-4a1a-b92a-c186fa8e45ff"],
    "ICDPComMediaHost": ["39c3c91e-bb09-4cd6-8e5f-60bae8a1df2a"],
    "ICDPComMediaHostHandler": ["5fee7e2b-f82e-4f2d-bd08-e9bebc5de158"],
    "ICDPComMediaSystemHandler": ["e51a7c0a-3ef2-4f08-a23a-621ccb11aa28"],
    "ICDPComMediaSystemHandlerCallback": ["4ca8a94f-6526-4b64-923e-89244ad356ba"],
    "ICDPComMessagingClient": ["7a8ac8c3-adb0-4612-b94b-923e8714b2fc"],
    "ICDPComMessagingClientHandler": ["3f21a112-53f6-437e-ba5b-2ff3e1e02887"],
    "ICDPComMessagingHost": ["e2f79687-9075-4b3b-b6c1-7234a4079e35"],
    "ICDPComMessagingHostHandler": ["070996bf-13e3-4008-86a9-dfa7af5d5a27"],
    "ICDPComMessagingSystemHandler": ["a24213ae-acf9-4c9d-8156-c4777ddaf7b1"],
    "ICDPComMessagingSystemHandlerCallback": ["e4466e0f-c942-4c9c-98ef-b31a17aeaf1e"],
    "ICDPComNearShareBroker": ["6b8007ae-4dd7-46f3-9bec-06f777d78864"],
    "ICDPComNearShareHandler": ["a7224b82-30f6-497a-be79-58e991488b67"],
    "ICDPComParticipantHandler": ["db94c387-16e8-43dd-a3e3-e4af33b14d3c"],
    "ICDPComRemoteTextSystemHandler": ["0324a68b-60f3-4f90-a69d-d21936cc8234"],
    "ICDPComRemoteTextSystemHandlerCallback": ["942e69c7-b708-4388-8343-240ef11ca4ea"],
    "ICDPComResourceHandler": ["50d91478-da2d-496b-be08-6447349f1fb4"],
    "ICDPComResourceHandlerCallback": ["43e8615a-47ef-49db-a79f-d7cd208b3039"],
    "ICDPComResourceManager": ["0de562ea-dd2c-4786-b32e-2600d09399e5"],
    "ICDPComResourcePolicyBroker": ["aa5555f2-8825-4d5d-a35e-df73844c0806"],
    "ICDPComResourcePolicyCallback": ["b2b38398-bc32-437b-81c3-a2f6d8697568"],
    "ICDPComResourcePolicyHandler": ["5a2703ae-70a3-4757-a2ae-d141f9248a3d"],
    "ICDPComSensorClient": ["ea0fcfe7-f386-4ba5-83df-8e8747948398"],
    "ICDPComSensorHost": ["bdb44ba0-22e1-4822-9944-a0e81de3d1a0"],
    "ICDPComSensorHostHandler": ["ba9f4490-70a6-4655-b3e0-742a5af33e44"],
    "ICDPComSensorSystemHandler": ["0eb5a8ad-7da9-4830-bcdb-21eadfc638fa"],
    "ICDPComTouchClient": ["bf7c0b76-dae0-4637-a5c2-c218033983e6"],
    "ICDPComTouchHost": ["728ae251-e94f-4306-a7bb-e9b3287efbcd"],
    "ICDPComTouchHostHandler": ["5f502cc5-e475-46dc-a455-a84278f4c577"],
    "ICDPComTouchSystemHandler": ["f73605e1-e491-4012-90be-f8aaf1a8d179"],
    "ICDPComUserActivitySettings": ["7f66e6eb-4f9d-4780-adb0-2dcdf798415a"],
    "ICDPComUserServiceNotificationHost": ["50c3f242-5793-4bf5-bb83-e662f04b9e63"],
    "ICDPComUserSettingsProvider": ["8cb134c6-72c3-4c94-859f-c1f2d40ddd13"],
    "ICDPComWebAccountProviderCallback": ["e43e21e4-34c1-4769-9ce8-93aebb6da4f9"],
    "ICDPCrossPlatformAppId": ["bbee2a22-80df-4fe0-a652-e3e2329aeb91"],
    "ICDPCrossPlatformAppIdEnumerator": ["8eb672e9-6d0f-44c0-87ca-e00ff32acb3b"],
    "ICDPDevice": ["77064fe7-6a61-42da-beb5-e2ad8ddb609b"],
    "ICDPDeviceCache": ["4d4636f1-62f8-4bda-95ea-a4ef18278c8a"],
    "ICDPDeviceInfo": ["b61b414b-0342-4770-b528-fb317e440f4d"],
    "ICDPDeviceQuery": ["b18f823d-c907-4211-9068-62d284d0afd8"],
    "ICDPDirectNotificationHost": ["3d0ed931-c089-4a3b-802b-0861cad8099f"],
    "ICDPEndpoint": ["a2114e07-d8d3-4b28-8fb5-68467f02b005"],
    "ICDPEndpointAccount": ["8a5d3949-11e9-42e3-9ed9-e54a086a632b"],
    "ICDPEnumDevice": ["f9a6294f-7353-4416-bf9d-82dfbaedba48"],
    "ICDPHost": ["033feb2f-5f4a-4152-a0af-00d5ad2a7649"],
    "ICDPHostAuthorizationProvider": ["c22976d1-7d42-4d70-b97a-625cd5d52589"],
    "ICDPHostAuthorizationProviderCallback": ["9af0344f-71c8-4be3-84d7-febdc4b9e2af"],
    "ICDPLegacyHost": ["27ae0d19-90e2-466e-a4bc-956647b512ef"],
    "ICDPLogger": ["fddcc7fb-0be6-4927-9c29-a878b8b28309"],
    "ICDPMediaClient": ["cb7dfb0b-985f-4963-b1c0-42ba417b746e"],
    "ICDPMediaHost": ["3bf1eb2f-d95d-4075-a6a1-3739160e9349"],
    "ICDPMessagingClient": ["2b68b9d5-ca21-44aa-8b94-b58253a6ee04"],
    "ICDPMessagingHost": ["b39f7bb0-9984-4012-8511-b2f0a8d80e24"],
    "ICDPParticipant": ["75543a6b-8bde-43e6-88b1-dcbb09c2d54d"],
    "ICDPParticipantDeviceInfo": ["88a8e526-0c23-401a-9cfe-9e92e21ac218"],
    "ICDPParticipantHandler": ["c8bb91c8-7571-473b-a2b2-22d5819cd0c2"],
    "ICDPResourceHandler": ["b972db8e-ca3d-4e6e-aa00-2cd72f9b10ed"],
    "ICDPResourceManager": ["bb74860e-7746-436f-889e-5e8186af346c"],
    "ICDPResourcePolicyHandler": ["9764b4ed-9b49-4a68-9ab0-3862d3f7c22b"],
    "ICDPSensorClient": ["f84714eb-f838-49d6-b7a9-dbaf3c63264a"],
    "ICDPSensorHost": ["5f606a0f-863c-4c35-b822-28b3e2fc7237"],
    "ICDPTask": ["14258db5-14cc-48f8-8641-15e951b3a60f"],
    "ICDPTouchClient": ["452f8c7a-077f-4b43-9b80-e6144fa7b89c"],
    "ICDPTouchHost": ["3a20c162-2f00-4795-b672-8b8e85513fc6"],
    "ICDPUserActivitySettings": ["a53bd71d-a5d9-4d71-b4dc-49be8bcb1a52"],
    "ICDPUserNotificationClient": ["92f1c068-4b1d-4c95-b302-2c29f10bba16"],
    "ICDPUserServiceNotificationClient": ["3d4fe8cf-04b4-422a-8345-1d611dbfc82f"],
    "ICDPWebAccountProviderCallback": ["c1cf6049-f869-4bc0-8ac9-2c9fdee17023"],
    "ICLAPI_CLIENT": ["08fd99d1-cfb6-11cf-bc03-00aa006111e0"],
    "ICLRAppDomainResourceMonitor": ["c62de18c-2e23-4aea-8423-b40c1fc59eae"],
    "ICLRAssemblyIdentityManager": ["15f0a9da-3ff6-4393-9da9-fdfd284e6972"],
    "ICLRAssemblyReferenceList": ["1b2c9750-2e66-4bda-8b44-0a642c5cd733"],
    "ICLRControl": ["9065597e-d1a1-4fb2-b6ba-7e1fce230f61"],
    "ICLRDataEnumMemoryRegions": ["471c35b4-7c2f-4ef0-a945-00f8c38056f1"],
    "ICLRDataEnumMemoryRegionsCallback": ["bcdd6908-ba2d-4ec5-96cf-df4d5cdcb4a4"],
    "ICLRDataEnumMemoryRegionsCallback2": ["3721a26f-8b91-4d98-a388-db17b356fadb"],
    "ICLRDataTarget": ["3e11ccee-d08b-43e5-af01-32717a64da03"],
    "ICLRDataTarget2": ["6d05fae3-189c-4630-a6dc-1c251e1c01ab"],
    "ICLRDataTarget3": ["a5664f95-0af4-4a1b-960e-2f3346b4214c"],
    "ICLRDebugManager": ["00dcaec6-2ac0-43a9-acf9-1e36c139b10d"],
    "ICLRDebugging": ["d28f3c5a-9634-4206-a509-477552eefb10"],
    "ICLRDebuggingLibraryProvider": ["3151c08d-4d09-4f9b-8838-2880bf18fe51"],
    "ICLRDomainManager": ["270d00a2-8e15-4d0b-adeb-37bc3e47df77"],
    "ICLRErrorReportingManager": ["980d2f1a-bf79-4c08-812a-bb9778928f78"],
    "ICLRGCManager": ["54d9007e-a8e2-4885-b7bf-f998deee4f2a"],
    "ICLRGCManager2": ["0603b793-a97a-4712-9cb4-0cd1c74c0f7c"],
    "ICLRHostBindingPolicyManager": ["4b3545e7-1856-48c9-a8ba-24b21a753c09"],
    "ICLRHostProtectionManager": ["89f25f5c-ceef-43e1-9cfa-a68ce863aaac"],
    "ICLRIoCompletionManager": ["2d74ce86-b8d6-4c84-b3a7-9768933b3c12"],
    "ICLRMemoryNotificationCallback": ["47eb8e57-0846-4546-af76-6f42fcfc2649"],
    "ICLRMetaHost": ["d332db9e-b9b3-4125-8207-a14884f53216"],
    "ICLRMetaHostPolicy": ["e2190695-77b2-492e-8e14-c4b3a7fdd593"],
    "ICLRMetadataLocator": ["aa8fa804-bc05-4642-b2c5-c353ed22fc63"],
    "ICLROnEventManager": ["1d0e0132-e64f-493d-9260-025c0e32c175"],
    "ICLRPolicyManager": ["7d290010-d781-45da-a6f8-aa5d711a730e"],
    "ICLRProbingAssemblyEnum": ["d0c5fb1f-416b-4f97-81f4-7ac7dc24dd5d"],
    "ICLRProfiling": ["b349abe3-b56f-4689-bfcd-76bf39d888ea"],
    "ICLRReferenceAssemblyEnum": ["d509cb5d-cf32-4876-ae61-67770cf91973"],
    "ICLRRuntimeHost": ["90f1a06c-7712-4762-86b5-7a5eba6bdb02"],
    "ICLRRuntimeInfo": ["bd39d1d2-ba2f-486a-89b0-b4b0cb466891"],
    "ICLRStrongName": ["9fd93ccf-3280-4391-b3a9-96e1cde77c8d"],
    "ICLRStrongName2": ["c22ed5c5-4b59-4975-90eb-85ea55c0069b"],
    "ICLRStrongName3": ["22c7089b-bbd3-414a-b698-210f263f1fed"],
    "ICLRSyncManager": ["55ff199d-ad21-48f9-a16c-f24ebbb8727d"],
    "ICLRTask": ["28e66a4a-9906-4225-b231-9187c3eb8611"],
    "ICLRTask2": ["28e66a4a-9906-4225-b231-9187c3eb8612"],
    "ICLRTaskManager": ["4862efbe-3ae5-44f8-8feb-346190ee8a34"],
    "ICLRValidator": ["63df8730-dc81-4062-84a2-1ff943f59fdd"],
    "ICache": ["06faeb05-191c-11d3-9573-00c04fa31a86"],
    "ICacheContext": ["3004ead6-8fe4-44b1-a732-af9b71c97938"],
    "ICacheManager": ["9b9027a3-4350-484e-b96e-ed4e5a5c9069"],
    "ICacheMode": ["98dc8b11-c6f9-4dab-b838-5fd5ec8c7350"],
    "ICacheModeFactory": ["eb1f8c5b-0abb-4e70-b8a8-620d0d953ab2"],
    "ICacheObjectCleanup": ["c96a8701-dee2-4682-bda3-e36f6540ab05"],
    "ICacheProperty": ["57eb5a03-0dc8-4959-87d5-83826cdfb724"],
    "ICacheRefresh": ["000002ff-0000-0000-c000-000000000046"],
    "ICacheableObject": ["771e5917-5788-4a36-a276-b0ddbf8e4abf"],
    "ICachedFileManagerStatics": ["8ffc224a-e782-495d-b614-654c4f0b2370"],
    "ICachedFileUpdaterActivatedEventArgs": ["d06eb1c7-3805-4ecb-b757-6cf15e26fef3"],
    "ICachedFileUpdaterHost": ["6be3cdf4-613c-4eb4-b5d5-03abc11b34b4"],
    "ICachedFileUpdaterStatics": ["9fc90920-7bcf-4888-a81e-102d7034d7ce"],
    "ICachedFileUpdaterTrigger": ["e21caeeb-32f2-4d31-b553-b9e01bde37e0"],
    "ICachedFileUpdaterTriggerDetails": ["71838c13-1314-47b4-9597-dc7e248c17cc"],
    "ICachedFileUpdaterUI": ["9e6f41e6-baf2-4a97-b600-9333f5df80fd"],
    "ICachedFileUpdaterUI2": ["8856a21c-8699-4340-9f49-f7cad7fe8991"],
    "ICachedPrivateProfile": ["b57046bc-32e5-428a-9887-19f712b907bf"],
    "ICalendar": ["ca30221d-86d9-40fb-a26b-d44eb7cf08ea"],
    "ICalendarDatePicker": ["63c9c16f-668c-4491-9444-d45d8bf4fa29"],
    "ICalendarDatePicker2": ["b216c159-2411-4a60-a7aa-27416b49481e"],
    "ICalendarDatePicker3": ["645856c0-db7b-5e75-85e9-f623e3457ea6"],
    "ICalendarDatePickerAutomationPeer": ["40d8938e-db5e-4b03-beba-d10f62419787"],
    "ICalendarDatePickerAutomationPeerFactory": ["ab705dd2-d293-45bf-9f19-26f7603a5e9b"],
    "ICalendarDatePickerDateChangedEventArgs": ["60d90db2-5010-46ba-842d-a4152c6504e7"],
    "ICalendarDatePickerFactory": ["107aad5d-38be-42af-a957-fc86a5cf1e9a"],
    "ICalendarDatePickerStatics": ["39a3d291-afab-4b94-8395-ba7b874e3c8c"],
    "ICalendarDatePickerStatics2": ["30206b58-a2f6-4a00-8d13-33c46b6b8e0d"],
    "ICalendarDatePickerStatics3": ["b188741d-cf69-568c-9707-baaaec2b64db"],
    "ICalendarFactory": ["83f58412-e56b-4c75-a66e-0f63d57758a6"],
    "ICalendarFactory2": ["b44b378c-ca7e-4590-9e72-ea2bec1a5115"],
    "ICalendarIdentifiersStatics": ["80653f68-2cb2-4c1f-b590-f0f52bf4fd1a"],
    "ICalendarIdentifiersStatics2": ["7df4d488-5fd0-42a7-95b5-7d98d823075f"],
    "ICalendarIdentifiersStatics3": ["2c225423-1fad-40c0-9334-a8eb90db04f5"],
    "ICalendarPanel": ["fcd55a2d-02d3-4ee6-9a90-9df3ead00994"],
    "ICalendarView": ["cd639203-dfb5-4312-ac07-c0391824607b"],
    "ICalendarViewDayItem": ["0fdb2dc5-32c1-4b8f-befc-017b555b32d2"],
    "ICalendarViewDayItemChangingEventArgs": ["73146666-1fb1-44f9-b7ad-4de859ecc565"],
    "ICalendarViewDayItemChangingEventHandler": ["8d745891-4de3-49cb-974b-083871a3afe6"],
    "ICalendarViewDayItemFactory": ["62112bdc-1d2f-4e44-9baf-1665749521f2"],
    "ICalendarViewDayItemStatics": ["c3a1dbbf-bd88-488b-b916-d00d69b1735a"],
    "ICalendarViewFactory": ["3d8f82e3-6cc6-423e-8d7c-7014d954ddef"],
    "ICalendarViewSelectedDatesChangedEventArgs": ["ee6069f6-13ef-4896-8ffc-5302b1b17539"],
    "ICalendarViewStatics": ["7260f1c4-2f5d-41bd-99bb-4571b20b79a8"],
    "ICalendarViewTemplateSettings": ["56c71483-64e1-477c-8a0b-cb2f3334b9b0"],
    "ICallAnswerEventArgs": ["61f132aa-f92a-48fa-aa8f-4f3a17662980", "fd789617-2dd7-4c8c-b2bd-95d17a5bb733"],
    "ICallControl": ["a520d0d6-ae8d-45db-8011-ca49d3b3e578"],
    "ICallControlEventHandler": ["596f759f-50df-4454-bc63-4d3d01b61958"],
    "ICallControlStatics": ["03945ad5-85ab-40e1-af19-56c94303b019"],
    "ICallInfo": ["000001dc-0000-0000-c000-000000000046"],
    "ICallRejectEventArgs": ["3e04061a-ce7d-49c2-a2b8-7f49b6eaebc5", "da47fad7-13d4-4d92-a1c2-b77811ee37ec"],
    "ICallStateChangeEventArgs": ["1f3e87b0-d371-4395-8b6c-1786a42e2f18", "eab2349e-66f5-47f9-9fb5-459c5198c720"],
    "ICallWaitingSettingsCompletion": ["f9581718-2283-4336-9397-1c6c067299d2"],
    "ICallbackWithNoReentrancyToApplicationSTA": ["0a299774-3e4e-fc42-1d9d-72cee105ca57"],
    "ICallingProcessInfo": ["68c6a1b9-de39-42c3-8d28-bf40a5126541"],
    "ICameraCaptureUI": ["48587540-6f93-4bb4-b8f3-e89e48948c91"],
    "ICameraCaptureUIPhotoCaptureSettings": ["b9f5be97-3472-46a8-8a9e-04ce42ccc97d"],
    "ICameraCaptureUIVideoCaptureSettings": ["64e92d1f-a28d-425a-b84f-e568335ff24e"],
    "ICameraControl": ["2ba1785d-4d1b-44ef-85e8-c7f1d3f20184"],
    "ICameraIntrinsics": ["0aa6ed32-6589-49da-afde-594270ca0aac"],
    "ICameraIntrinsics2": ["0cdaa447-0798-4b4d-839f-c5ec414db27a"],
    "ICameraIntrinsicsFactory": ["c0ddc486-2132-4a34-a659-9bfe2a055712"],
    "ICameraOptionsUIStatics": ["3b0d5e34-3906-4b7d-946c-7bde844499ae"],
    "ICameraSettingsActivatedEventArgs": ["fb67a508-2dad-490a-9170-dca036eb114b"],
    "ICameraSoundPlayback": ["6ae0038b-c4d8-4fbf-9931-b0ec2db17423"],
    "ICameraUIControl": ["b8733adf-3d68-4b8f-bb08-e28a0bed0376"],
    "ICameraUIControlEventCallback": ["1bfa0c2c-fbcd-4776-bda4-88bf974e74f4"],
    "ICanExecuteRequestedEventArgs": ["c8e75256-1950-505d-993b-75907ef96830"],
    "ICanHandleException": ["c5598e60-b307-11d1-b27d-006008c3fbfb"],
    "ICanInfoCompletion": ["b5bb6a5e-8d3f-4203-b58b-26c3d4e8eedc"],
    "ICandidateWindowBoundsChangedEventArgs": ["8a946458-83b0-4c32-9450-5169a5838b55"],
    "ICanvas": ["79190e19-cd38-4823-aeae-64a77132f519"],
    "ICanvasFactory": ["1b328bd1-b400-4a8e-943b-5ad2c45be0df"],
    "ICanvasGradient": ["30510714-98b5-11cf-bb82-00aa00bdce0b"],
    "ICanvasImageData": ["3051071a-98b5-11cf-bb82-00aa00bdce0b"],
    "ICanvasPattern": ["30510716-98b5-11cf-bb82-00aa00bdce0b"],
    "ICanvasPixelArray": ["3051071c-98b5-11cf-bb82-00aa00bdce0b"],
    "ICanvasPixelArrayData": ["305107f9-98b5-11cf-bb82-00aa00bdce0b"],
    "ICanvasRenderingContext2D": ["305106ff-98b5-11cf-bb82-00aa00bdce0b"],
    "ICanvasStatics": ["40ce5c46-2962-446f-aafb-4cdc486939c9"],
    "ICanvasTextMetrics": ["30510718-98b5-11cf-bb82-00aa00bdce0b"],
    "ICapabilities": ["5f6942bb-61c5-4fe5-9956-f7c99812f95c"],
    "ICaptionServiceDescriptor": ["40834007-6834-46f0-bd45-d5f6a6be258c"],
    "ICaptureElement": ["31a5c0e7-f307-4d4a-b626-e978863f5b74"],
    "ICaptureElementAutomationPeer": ["dcc44ee0-fa45-45c6-8bb7-320d808f5958"],
    "ICaptureElementAutomationPeerFactory": ["9b92ef48-85e9-4869-b175-8f7cf45a6d9f"],
    "ICaptureElementStatics": ["1e438ded-7da6-409e-806e-305ae4ad9b3f"],
    "ICapturedFrame": ["1dd2de1f-571b-44d8-8e80-a08a1578766e"],
    "ICapturedFrame2": ["543fa6d1-bd78-4866-adda-24314bc65dea"],
    "ICapturedFrameControlValues": ["90c65b7f-4e0d-4ca4-882d-7a144fed0a90"],
    "ICapturedFrameControlValues2": ["500b2b88-06d2-4aa7-a7db-d37af73321d8"],
    "ICapturedFrameWithSoftwareBitmap": ["b58e8b6e-8503-49b5-9e86-897d26a3ff3d"],
    "ICapturedPhoto": ["b0ce7e5a-cfcc-4d6c-8ad1-0869208aca16"],
    "ICardAddedEventArgs": ["18bbef98-f18b-4dd3-b118-dfb2c8e23cc6"],
    "ICardRemovedEventArgs": ["15331aaf-22d7-4945-afc9-03b46f42a6cd"],
    "ICaretPositionProvider": ["58da43a2-108e-4d5b-9f75-e5f74f93fff5"],
    "ICarouselPanel": ["deab78b2-373b-4151-8785-e544d0d9362b"],
    "ICarouselPanelFactory": ["c1109404-9ae1-440e-a0dd-bbb6e2293cbe"],
    "ICashDrawer": ["9f88f5c8-de54-4aee-a890-920bcbfe30fc"],
    "ICashDrawerCapabilities": ["0bc6de0b-e8e7-4b1f-b1d1-3e501ad08247"],
    "ICashDrawerCloseAlarm": ["6bf88cc7-6f63-430e-ab3b-95d75ffbe87f"],
    "ICashDrawerEventSource": ["e006e46c-f2f9-442f-8dd6-06c10a4227ba"],
    "ICashDrawerEventSourceEventArgs": ["69cb3bc1-147f-421c-9c23-090123bb786c"],
    "ICashDrawerStatics": ["dfa0955a-d437-4fff-b547-dda969a4f883"],
    "ICashDrawerStatics2": ["3e818121-8c42-40e8-9c0e-40297048104c"],
    "ICashDrawerStatus": ["6bbd78bf-dca1-4e06-99eb-5af6a5aec108"],
    "ICashDrawerStatusUpdatedEventArgs": ["30aae98a-0d70-459c-9553-87e124c52488"],
    "ICastingConnection": ["cd951653-c2f1-4498-8b78-5fb4cd3640dd"],
    "ICastingConnectionErrorOccurredEventArgs": ["a7fb3c69-8719-4f00-81fb-961863c79a32"],
    "ICastingController": ["f0a56423-a664-4fbd-8b43-409a45e8d9a1"],
    "ICastingDevice": ["de721c83-4a43-4ad1-a6d2-2492a796c3f2"],
    "ICastingDevicePicker": ["dcd39924-0591-49be-aacb-4b82ee756a95"],
    "ICastingDevicePickerFilter": ["be8c619c-b563-4354-ae33-9fdaad8c6291"],
    "ICastingDeviceSelectedEventArgs": ["dc439e86-dd57-4d0d-9400-af45e4fb3663"],
    "ICastingDeviceStatics": ["e7d958d7-4d13-4237-a365-4c4f6a4cfd2f"],
    "ICastingEventHandler": ["c79a6cb7-bebd-47a6-a2ad-4d45ad79c7bc"],
    "ICastingSource": ["f429ea72-3467-47e6-a027-522923e9d727"],
    "ICastingSourceInfo": ["45101ab7-7c3a-4bce-9500-12c09024b298"],
    "ICatBandManager": ["8d79a7d3-6397-48ee-bc1f-1f021f8fff1c"],
    "ICatalog64BitSupport": ["1d118904-94b3-4a64-9fa6-ed432666a7b9"],
    "ICatalogFileInfo2Priv": ["ec7985d9-5d5f-45cb-9e91-3d7d6406fb1d"],
    "ICatalogServices": ["04c6be1e-1db1-4058-ab7a-700cccfbf254"],
    "ICatalogSession": ["182c40fa-32e4-11d0-818b-00a0c9231c29"],
    "ICatalogSetup2": ["d66375aa-132d-43fa-881c-3ebff2ca8e24"],
    "ICatalogTableInfo": ["a8927a41-d3ce-11d1-8472-006008b0e5ca"],
    "ICategorizableItem": ["d607ad44-e038-4501-861d-d9a6d52a2105"],
    "ICategorizeProperties": ["4d07fc10-f931-11ce-b001-00aa006884e5"],
    "ICategorizerFactory": ["7b9cee5b-bc27-4480-92f8-65222afd2bf9"],
    "ICategoryCollection": ["3a56bfb8-576c-43f7-9335-fe4838fd7e37"],
    "ICategoryDescription": ["d8074769-99fe-4b5e-8ca1-afc6bcd17d44"],
    "ICategoryDescriptionArray": ["406a66e8-0dc2-49e4-81e2-1f7a7da666db"],
    "ICategoryInfo": ["f8c3e22d-db97-4090-9729-76d84e10f7e8"],
    "ICategoryInfoArray": ["a6564d5e-75b8-40ac-a23c-ab9ba01b9cdd"],
    "ICbeTaskCompletionBroker": ["0e84b395-a286-455b-8202-a069be0b2571"],
    "ICellset": ["2281372a-8bd3-11d0-b4ef-00a0c9138ca4"],
    "ICellularApnContext": ["6fa529f4-effd-4542-9ab2-705bbf94943a"],
    "ICellularApnContext2": ["76b0eb1a-ac49-4350-b1e5-dc4763bc69c7"],
    "ICentennialLifetimeManagerConsoleOperator": ["749413f7-bd96-4017-88d7-e22797a95c62"],
    "ICertAdmin": ["34df6950-7fb6-11d0-8817-00a0c903b83c"],
    "ICertAdmin2": ["f7c3ac41-b8ce-4fb4-aa58-3d1dc0e36b39"],
    "ICertConfig": ["372fce34-4324-11d0-8810-00a0c903b83c"],
    "ICertConfig2": ["7a18edde-7e78-4163-8ded-78e2c9cee924"],
    "ICertEncodeAltName": ["1c9a8c70-1271-11d1-9bd4-00c04fb683fa"],
    "ICertEncodeAltName2": ["f67fe177-5ef1-4535-b4ce-29df15e2e0c3"],
    "ICertEncodeBitString": ["6db525be-1278-11d1-9bd4-00c04fb683fa"],
    "ICertEncodeBitString2": ["e070d6e7-23ef-4dd2-8242-ebd9c928cb30"],
    "ICertEncodeCRLDistInfo": ["01958640-bbff-11d0-8825-00a0c903b83c"],
    "ICertEncodeCRLDistInfo2": ["b4275d4b-3e30-446f-ad36-09d03120b078"],
    "ICertEncodeDateArray": ["2f9469a0-a470-11d0-8821-00a0c903b83c"],
    "ICertEncodeDateArray2": ["99a4edb5-2b8e-448d-bf95-bba8d7789dc8"],
    "ICertEncodeLongArray": ["15e2f230-a0a2-11d0-8821-00a0c903b83c"],
    "ICertEncodeLongArray2": ["4efde84a-bd9b-4fc2-a108-c347d478840f"],
    "ICertEncodeStringArray": ["12a88820-7494-11d0-8816-00a0c903b83c"],
    "ICertEncodeStringArray2": ["9c680d93-9b7d-4e95-9018-4ffe10ba5ada"],
    "ICertExit": ["e19ae1a0-7364-11d0-8816-00a0c903b83c"],
    "ICertExit2": ["0abf484b-d049-464d-a7ed-552e7529b0ff"],
    "ICertGetConfig": ["c7ea09c0-ce17-11d0-8833-00a0c903b83c"],
    "ICertPolicy": ["38bb5a00-7636-11d0-b413-00a0c91bbf8c"],
    "ICertPolicy2": ["3db4910e-8001-4bf1-aa1b-f43a808317a0"],
    "ICertProperties": ["728ab32f-217d-11da-b2a4-000e7bbb2b09"],
    "ICertProperty": ["728ab32e-217d-11da-b2a4-000e7bbb2b09"],
    "ICertPropertyArchived": ["728ab337-217d-11da-b2a4-000e7bbb2b09"],
    "ICertPropertyArchivedKeyHash": ["728ab33b-217d-11da-b2a4-000e7bbb2b09"],
    "ICertPropertyAutoEnroll": ["728ab332-217d-11da-b2a4-000e7bbb2b09"],
    "ICertPropertyBackedUp": ["728ab338-217d-11da-b2a4-000e7bbb2b09"],
    "ICertPropertyDescription": ["728ab331-217d-11da-b2a4-000e7bbb2b09"],
    "ICertPropertyEnrollment": ["728ab339-217d-11da-b2a4-000e7bbb2b09"],
    "ICertPropertyEnrollmentPolicyServer": ["728ab34a-217d-11da-b2a4-000e7bbb2b09"],
    "ICertPropertyFriendlyName": ["728ab330-217d-11da-b2a4-000e7bbb2b09"],
    "ICertPropertyKeyProvInfo": ["728ab336-217d-11da-b2a4-000e7bbb2b09"],
    "ICertPropertyRenewal": ["728ab33a-217d-11da-b2a4-000e7bbb2b09"],
    "ICertPropertyRequestOriginator": ["728ab333-217d-11da-b2a4-000e7bbb2b09"],
    "ICertPropertySHA1Hash": ["728ab334-217d-11da-b2a4-000e7bbb2b09"],
    "ICertRequest": ["014e4840-5523-11d0-8812-00a0c903b83c"],
    "ICertRequest2": ["a4772988-4a85-4fa9-824e-b5cf5c16405a"],
    "ICertRequest3": ["afc8f92b-33a2-4861-bf36-2933b7cd67b3"],
    "ICertRequestD": ["d99e6e70-fc88-11d0-b498-00a0c90312f3"],
    "ICertRequestD2": ["5422fd3a-d4b8-4cef-a12e-e87d4ca22e90"],
    "ICertServerExit": ["4ba9eb90-732c-11d0-8816-00a0c903b83c"],
    "ICertServerPolicy": ["aa000922-ffbe-11cf-8800-00a0c903b83c"],
    "ICertSrvSetup": ["b760a1bb-4784-44c0-8f12-555f0780ff25"],
    "ICertSrvSetupKeyInformation": ["6ba73778-36da-4c39-8a85-bcfa7d000793"],
    "ICertSrvSetupKeyInformationCollection": ["e65c8b00-e58f-41f9-a9ec-a28d7427c844"],
    "ICertView": ["c3fac344-1e84-11d1-9bd6-00c04fb683fa"],
    "ICertView2": ["d594b282-8851-4b61-9c66-3edadf848863"],
    "ICertificate": ["333f740c-04d8-43b3-b278-8c5fcc9be5a0"],
    "ICertificate2": ["17b8374c-8a25-4d96-a492-8fc29ac4fda6"],
    "ICertificate3": ["be51a966-ae5f-4652-ace7-c6d7e7724cf3"],
    "ICertificateAttestationChallenge": ["6f175a7c-4a3a-40ae-9dba-592fd6bbf9b8"],
    "ICertificateAttestationChallenge2": ["4631334d-e266-47d6-bd79-be53cb2e2753"],
    "ICertificateChain": ["20bf5385-3691-4501-a62c-fd97278b31ee"],
    "ICertificateEnrollmentManagerStatics": ["8846ef3f-a986-48fb-9fd7-9aec06935bf1"],
    "ICertificateEnrollmentManagerStatics2": ["dc5b1c33-6429-4014-999c-5d9735802d1d"],
    "ICertificateEnrollmentManagerStatics3": ["fdec82be-617c-425a-b72d-398b26ac7264"],
    "ICertificateEnrollmentPolicyServerSetup": ["859252cc-238c-4a88-b8fd-a37e7d04e68b"],
    "ICertificateEnrollmentServerSetup": ["70027fdb-9dd9-4921-8944-b35cb31bd2ec"],
    "ICertificateExtension": ["84cf0656-a9e6-454d-8e45-2ea7c4bcd53b"],
    "ICertificateFactory": ["17b4221c-4baf-44a2-9608-04fb62b16942"],
    "ICertificateKeyUsages": ["6ac6206f-e1cf-486a-b485-a69c83e46fd1"],
    "ICertificatePolicies": ["728ab31f-217d-11da-b2a4-000e7bbb2b09"],
    "ICertificatePolicy": ["728ab31e-217d-11da-b2a4-000e7bbb2b09"],
    "ICertificateQuery": ["5b082a31-a728-4916-b5ee-ffcb8acf2417"],
    "ICertificateQuery2": ["935a0af7-0bd9-4f75-b8c2-e27a7f74eecd"],
    "ICertificateRequestProperties": ["487e84f6-94e2-4dce-8833-1a700a37a29a"],
    "ICertificateRequestProperties2": ["3da0c954-d73f-4ff3-a0a6-0677c0ada05b"],
    "ICertificateRequestProperties3": ["e687f616-734d-46b1-9d4c-6edfdbfc845b"],
    "ICertificateRequestProperties4": ["4e429ad2-1c61-4fea-b8fe-135fb19cdce4"],
    "ICertificateStore": ["b0bff720-344e-4331-af14-a7f7a7ebc93a"],
    "ICertificateStore2": ["c7e68e4a-417d-4d1a-babd-15687e549974"],
    "ICertificateStoresStatics": ["fbecc739-c6fe-4de7-99cf-74c3e596e032"],
    "ICertificateStoresStatics2": ["fa900b79-a0d4-4b8c-bc55-c0a37eb141ed"],
    "ICertificationAuthorities": ["13b79005-2181-11da-b2a4-000e7bbb2b09"],
    "ICertificationAuthority": ["835d1f61-1e95-4bc8-b4d3-976c42b968f7"],
    "IChainBuildingParameters": ["422ba922-7c8d-47b7-b59b-b12703733ac3"],
    "IChainValidationParameters": ["c4743b4a-7eb0-4b56-a040-b9c8e655ddf3"],
    "IChangeConflict": ["014ebf97-9f20-4f7a-bdd4-25979c77c002"],
    "IChangeNotifySink": ["320cf551-8e59-49bb-93d5-cf5ad5c29299"],
    "IChangeUnitException": ["0cd7ee7c-fec0-4021-99ee-f0e5348f2a5f"],
    "IChangeUnitListFilterInfo": ["f2837671-0bdf-43fa-b502-232375fb50c2"],
    "IChannelAudioVolume": ["1c158861-b533-4b30-b1cf-e853e51c59b8"],
    "IChannelCredentials": ["181b448c-c17c-4b17-ac6d-06699b93198f"],
    "IChannelHandleMarshal": ["f17737fe-2a97-4514-8507-f21abf6ffb16"],
    "IChannelIDTuneRequest": ["156eff60-86f4-4e28-89fc-109799fd57ee"],
    "IChannelTuneRequest": ["0369b4e0-45b6-11d3-b650-00c04f79498e"],
    "IChapterCue": ["72a98001-d38a-4c0a-8fa6-75cddaf4664c"],
    "IChapteredRowset": ["0c733a93-2a1c-11ce-ade5-00aa0044773d"],
    "ICharacterGrouping": ["fae761bb-805d-4bb0-95bb-c1f7c3e8eb8e"],
    "ICharacterGroupings": ["b8d20a75-d4cf-4055-80e5-ce169c226496"],
    "ICharacterGroupingsFactory": ["99ea9fd9-886d-4401-9f98-69c82d4c2f78"],
    "ICharacterReceivedEventArgs": ["c584659f-99b2-4bcc-bd33-04e63f42902e"],
    "ICharacterReceivedRoutedEventArgs": ["7849fd82-48e4-444d-9419-93ab8892c107"],
    "ICharmBarAction": ["b2ec85ee-0d21-4b56-a460-e4aa92ee2283"],
    "IChatCapabilities": ["3aff77bc-39c9-4dd1-ad2d-3964dd9d403f"],
    "IChatCapabilitiesManagerStatics": ["b57a2f30-7041-458e-b0cf-7c0d9fea333a"],
    "IChatCapabilitiesManagerStatics2": ["e30d4274-d5c1-4ac9-9ffc-40e69184fec8"],
    "IChatConversation": ["a58c080d-1a6f-46dc-8f3d-f5028660b6ee"],
    "IChatConversation2": ["0a030cd1-983a-47aa-9a90-ee48ee997b59"],
    "IChatConversationReader": ["055136d2-de32-4a47-a93a-b3dc0833852b"],
    "IChatConversationThreadingInfo": ["331c21dc-7a07-4422-a32c-24be7c6dab24"],
    "IChatItem": ["8751d000-ceb1-4243-b803-15d45a1dd428"],
    "IChatMessage": ["4b39052a-1142-5089-76da-f2db3d17cd05"],
    "IChatMessage2": ["86668332-543f-49f5-ac71-6c2afc6565fd"],
    "IChatMessage3": ["74eb2fb0-3ba7-459f-8e0b-e8af0febd9ad"],
    "IChatMessage4": ["2d144b0f-d2bf-460c-aa68-6d3f8483c9bf"],
    "IChatMessageAttachment": ["c7c4fd74-bf63-58eb-508c-8b863ff16b67"],
    "IChatMessageAttachment2": ["5ed99270-7dd1-4a87-a8ce-acdd87d80dc8"],
    "IChatMessageAttachmentFactory": ["205852a2-a356-5b71-6ca9-66c985b7d0d5"],
    "IChatMessageBlockingStatic": ["f6b9a380-cdea-11e4-8830-0800200c9a66"],
    "IChatMessageChange": ["1c18c355-421e-54b8-6d38-6b3a6c82fccc"],
    "IChatMessageChangeReader": ["14267020-28ce-5f26-7b05-9a5c7cce87ca"],
    "IChatMessageChangeTracker": ["60b7f066-70a0-5224-508c-242ef7c1d06f"],
    "IChatMessageChangedDeferral": ["fbc6b30c-788c-4dcc-ace7-6282382968cf"],
    "IChatMessageChangedEventArgs": ["b6b73e2d-691c-4edf-8660-6eb9896892e3"],
    "IChatMessageManager2Statics": ["1d45390f-9f4f-4e35-964e-1b9ca61ac044"],
    "IChatMessageManagerStatic": ["f15c60f7-d5e8-5e92-556d-e03b60253104"],
    "IChatMessageManagerStatics3": ["208b830d-6755-48cc-9ab3-fd03c463fc92"],
    "IChatMessageNotificationTrigger": ["513b43bf-1d40-5c5d-78f5-c923fee3739e"],
    "IChatMessageNotificationTriggerDetails": ["fd344dfb-3063-4e17-8586-c6c08262e6c0"],
    "IChatMessageNotificationTriggerDetails2": ["6bb522e0-aa07-4fd1-9471-77934fb75ee6"],
    "IChatMessageReader": ["b6ea78ce-4489-56f9-76aa-e204682514cf"],
    "IChatMessageReader2": ["89643683-64bb-470d-9df4-0de8be1a05bf"],
    "IChatMessageReceivedNotificationTrigger": ["3ea3760e-baf5-4077-88e9-060cf6f0c6d5"],
    "IChatMessageStore": ["31f2fd01-ccf6-580b-4976-0a07dd5d3b47"],
    "IChatMessageStore2": ["ad4dc4ee-3ad4-491b-b311-abdf9bb22768"],
    "IChatMessageStore3": ["9adbbb09-4345-4ec1-8b74-b7338243719c"],
    "IChatMessageStoreChangedEventArgs": ["65c66fac-fe8c-46d4-9119-57b8410311d5"],
    "IChatMessageTransport": ["63a9dbf8-e6b3-5c9a-5f85-d47925b9bd18"],
    "IChatMessageTransport2": ["90a75622-d84a-4c22-a94d-544444edc8a1"],
    "IChatMessageTransportConfiguration": ["879ff725-1a08-4aca-a075-3355126312e6"],
    "IChatMessageValidationResult": ["25e93a03-28ec-5889-569b-7e486b126f18"],
    "IChatQueryOptions": ["2fd364a6-bf36-42f7-b7e7-923c0aabfe16"],
    "IChatRecipientDeliveryInfo": ["ffc7b2a2-283c-4c0a-8a0e-8c33bdbf0545"],
    "IChatSearchReader": ["4665fe49-9020-4752-980d-39612325f589"],
    "IChatSyncConfiguration": ["09f869b2-69f4-4aff-82b6-06992ff402d2"],
    "IChatSyncManager": ["7ba52c63-2650-486f-b4b4-6bd9d3d63c84"],
    "ICheckBoxAutomationPeer": ["eb15bc42-c0a9-46c6-ac24-b83de429c733"],
    "ICheckBoxAutomationPeerFactory": ["b75c775d-eb8f-44ef-a27c-e26ac7de8333"],
    "ICheckBoxFactory": ["4fa6aabb-3f4b-4301-be07-1172ea61eefb"],
    "ICheckDiskDialog": ["504b27aa-001f-4179-9ad0-663a37c317a9"],
    "IChildId": ["c412bf5b-91ea-4904-b34a-855504fbbf0b"],
    "IChildInfo": ["31140cb5-6b64-48ff-b872-660441ce9e51"],
    "IChoosingGroupHeaderContainerEventArgs": ["67db44d6-d201-4d72-beac-5e8e58afd8c7"],
    "IChoosingItemContainerEventArgs": ["9bb43bce-ae67-4a80-8363-e3fe1b244f2c"],
    "ICiQueryServer": ["2cf34970-2fe7-11d3-b880-00805f85d78c"],
    "ICiSecurityStore": ["a28e816a-dbc1-11d2-9a8c-00c04f6888ed"],
    "ICiSecurityStore2": ["77881d91-be5d-4b91-94b2-5c7b474d00ef"],
    "ICircleEase": ["53a3bdb2-9177-4e6e-a043-5082d889ab1f"],
    "ICivicAddress": ["a8567a1a-64f4-4d48-bcea-f6b008eca34c"],
    "ICivicAddressReport": ["c0b19f70-4adf-445d-87f2-cad8fd711792"],
    "ICivicAddressReportFactory": ["bf773b93-c64f-4bee-beb2-67c0b8df66e0"],
    "IClaimedBarcodeScanner": ["4a63b49c-8fa4-4332-bb26-945d11d81e0f"],
    "IClaimedBarcodeScanner1": ["f61aad0c-8551-42b4-998c-970c20210a22"],
    "IClaimedBarcodeScanner2": ["e3b59e8c-2d8b-4f70-8af3-3448bedd5fe2"],
    "IClaimedBarcodeScanner3": ["e6ceb430-712e-45fc-8b86-cd55f5aef79d"],
    "IClaimedBarcodeScanner4": ["5d501f97-376a-41a8-a230-2f37c1949dde"],
    "IClaimedBarcodeScannerClosedEventArgs": ["cf7d5489-a22c-4c65-a901-88d77d833954"],
    "IClaimedCashDrawer": ["ca3f99af-abb8-42c1-8a84-5c66512f5a75"],
    "IClaimedCashDrawer2": ["9cbab5a2-de42-4d5b-b0c1-9b57a2ba89c3"],
    "IClaimedCashDrawerClosedEventArgs": ["cc573f33-3f34-4c5c-baae-deadf16cd7fa"],
    "IClaimedJournalPrinter": ["67ea0630-517d-487f-9fdf-d2e0a0a264a5"],
    "IClaimedLineDisplay": ["120ac970-9a75-4acf-aae7-09972bcf8794"],
    "IClaimedLineDisplay2": ["a31c75ed-41f5-4e76-a074-795e47a46e97"],
    "IClaimedLineDisplay3": ["642ecd92-e9d4-4ecc-af75-329c274cd18f"],
    "IClaimedLineDisplayClosedEventArgs": ["f915f364-d3d5-4f10-b511-90939edfacd8"],
    "IClaimedLineDisplayStatics": ["78ca98fb-8b6b-4973-86f0-3e570c351825"],
    "IClaimedMagneticStripeReader": ["475ca8f3-9417-48bc-b9d7-4163a7844c02"],
    "IClaimedMagneticStripeReader2": ["236fafdf-e2dc-4d7d-9c78-060df2bf2928"],
    "IClaimedMagneticStripeReaderClosedEventArgs": ["14ada93a-adcd-4c80-acda-c3eaed2647e1"],
    "IClaimedPosPrinter": ["6d64ce0c-e03e-4b14-a38e-c28c34b86353"],
    "IClaimedPosPrinter2": ["5bf7a3d5-5198-437a-82df-589993fa77e1"],
    "IClaimedPosPrinterClosedEventArgs": ["e2b7a27b-4d40-471d-92ed-63375b18c788"],
    "IClaimedReceiptPrinter": ["9ad27a74-dd61-4ee2-9837-5b5d72d538b9"],
    "IClaimedSlipPrinter": ["bd5deff2-af90-4e8a-b77b-e3ae9ca63a7f"],
    "IClassActivityInfo": ["000001e5-0000-0000-c000-000000000046"],
    "IClassBabyJitActivationInfo": ["a2d9cfd2-2bc9-4f56-88f2-c515a6d31d8d"],
    "IClassClassicInfo": ["000001e2-0000-0000-c000-000000000046"],
    "IClassClassicInfo2": ["000001df-0000-0000-c000-000000000046"],
    "IClassClassicInfo3": ["0318b242-d086-4de9-b10c-2824a6ca1019"],
    "IClassComTIIntrinsics": ["000001f4-0000-0000-c000-000000000046"],
    "IClassDesigner": ["94a0f6f1-10bc-11d0-8d09-00a0c90f2732"],
    "IClassFactory3": ["342d1ea0-ae25-11d1-89c5-006008c3fbfc"],
    "IClassIISIntrinsics": ["000001f3-0000-0000-c000-000000000046"],
    "IClassJitActivationInfo": ["000001e7-0000-0000-c000-000000000046"],
    "IClassLoadBalancingInfo": ["000001ea-0000-0000-c000-000000000046"],
    "IClassObjectPoolingInfo": ["000001eb-0000-0000-c000-000000000046"],
    "IClassRetInfo": ["000001e9-0000-0000-c000-000000000046"],
    "IClassSecurityInfo": ["000001e8-0000-0000-c000-000000000046"],
    "IClassTrackingInfo": ["000001f6-0000-0000-c000-000000000046"],
    "IClassTransactionInfo": ["000001e6-0000-0000-c000-000000000046"],
    "IClassTransactionInfo2": ["bda21d55-c681-44bc-998b-35731155ca82"],
    "IClassicAppManagerStatics": ["e2fad668-882c-4f33-b035-0df7b90d67e6"],
    "IClassicApplicationView": ["7a05f995-6242-440e-a64e-34b7ed3413d3"],
    "IClassicApplicationViewFactory": ["ecc62f5d-14aa-4971-9f06-b2159b1ffd40"],
    "IClassicWindowManager": ["6c6cbabd-6e36-4f9d-a349-c8852d0e7ee5"],
    "ICleanUpVirtualizedItemEventArgs": ["ea05cce9-937c-4120-8406-792185784338"],
    "ICleanUpVirtualizedItemEventHandler": ["cacad0d6-0f0d-4870-884d-f2dedf674288"],
    "IClearCancel": ["4a235d38-01a3-44fe-87ce-2a3afb4b5ee0"],
    "IClickNote": ["f9fe368b-8033-43a5-9e71-17f6f5385832"],
    "IClipServiceNotificationHelper": ["c39948f0-6142-44fd-98ca-e1681a8d68b5"],
    "IClipboardBroker": ["ac57caff-e1cb-4325-8d0a-0da256c83284"],
    "IClipboardBrokerInternal": ["51c971b4-0504-4933-af4e-64e3ee0a7be5"],
    "IClipboardContentChangedCallback": ["2f55d587-f8cb-427d-968a-5412ed551f7e"],
    "IClipboardContentOptions": ["e888a98c-ad4b-5447-a056-ab3556276d2b"],
    "IClipboardHistoryChangedEventArgs": ["c0be453f-8ea2-53ce-9aba-8d2212573452"],
    "IClipboardHistoryItem": ["0173bd8a-afff-5c50-ab92-3d19f481ec58"],
    "IClipboardHistoryItemsResult": ["e6dfdee6-0ee2-52e3-852b-f295db65939a"],
    "IClipboardNotificationClient": ["69f490d3-555d-4c08-8f93-b3b39246a3e1"],
    "IClipboardProtectionServices": ["fed95700-f716-4950-bcac-8e2e1ca1b307"],
    "IClipboardServer": ["b3d86f99-514b-4fb3-bc0b-e77a1a717abc"],
    "IClipboardStatics": ["c627e291-34e2-4963-8eed-93cbb0ea3d70"],
    "IClipboardStatics2": ["d2ac1b6a-d29f-554b-b303-f0452345fe02"],
    "IClipboardTaskCompletion": ["c58bdf0c-86c7-4fbc-90ae-94c73629ce74"],
    "IClockIdentifiersStatics": ["523805bb-12ec-4f83-bc31-b1b4376b0808"],
    "IClockVector": ["14b2274a-8698-4cc6-9333-f89bd1d47bc4"],
    "IClockVectorElement": ["e71c4250-adf8-4a07-8fae-5669596909c1"],
    "IClonableWrapper": ["b33e75ff-e84c-4dca-a25c-33b8dc003374"],
    "ICloneViewHelper": ["f6a3d4c4-5632-4d83-b0a1-fb88712b1eb7"],
    "IClosable": ["30d5a829-7fa4-4026-83bb-d75bae4ea99e"],
    "ICloseRequestBroker": ["128badf9-175b-44f1-86ec-7dd47c93dac4"],
    "ICloseRequestedArgsPrivate": ["682ac0ef-3263-4190-ba9e-2526278dcd04"],
    "ICloseRequestedService": ["cd2d3dc4-03e6-49c5-9acf-ad01ab648e99"],
    "IClosedCaptionPropertiesStatics": ["10aa1f84-cc30-4141-b503-5272289e0c20"],
    "IClosedTabManager": ["c10dbf75-c96b-4a7d-af1a-ba4c6d9e80fc"],
    "IClosestInteractiveBoundsRequestedEventArgs": ["347c11d7-f6f8-40e3-b29f-ae50d3e86486"],
    "ICloudChangeWnfMonitor": ["8fe8483d-8533-4ec9-8572-7453008d57b0"],
    "ICloudManageAppBackups": ["ed0bf9c6-539f-11e3-9262-ba9b6188709b"],
    "ICloudManageDeviceBackups": ["5ed6404c-ca2b-4994-9fcd-3a271b5af8d2"],
    "ICloudManageSystemSettingBackups": ["45171f48-f800-4bf4-994a-736678325610"],
    "ICloudStorageInfo": ["07c996ae-9cc3-11e2-9f8f-d7f06188709b"],
    "ICloudStorageUsage": ["323fdf42-6140-11e2-8178-c6316188709b"],
    "ICloudStorageWizard": ["38ff3dc2-9d96-415d-bce7-92162743fee4"],
    "ICloudSyncEngine": ["66b600ce-def5-4d28-a6fc-58dce1cd68cb"],
    "ICloudSyncEngineCallback": ["ad9fb40a-82a8-4c15-bd8d-5944200c2c03"],
    "ICloudSyncPolicyManager": ["05b48acc-9426-11e2-96f0-797e6188709b"],
    "IClrTrksBroker": ["2ac06f23-3274-4224-ae7e-f897edf15fe9"],
    "IClusterDetector": ["3f07f7b7-c680-41d9-9423-915107ec9ff9"],
    "ICmProxyResolver": ["542efef0-28e9-4b84-9adf-a908d2be0abc"],
    "ICmProxyResult": ["d8109ad1-31a0-4dda-831d-b3106a659646"],
    "ICmsAttachedSignature": ["61899d9d-3757-4ecb-bddc-0ca357d7a936"],
    "ICmsAttachedSignatureFactory": ["d0c8fc15-f757-4c64-a362-52cc1c77cffb"],
    "ICmsAttachedSignatureStatics": ["87989c8e-b0ad-498d-a7f5-78b59bce4b36"],
    "ICmsDetachedSignature": ["0f1ef154-f65e-4536-8339-5944081db2ca"],
    "ICmsDetachedSignatureFactory": ["c4ab3503-ae7f-4387-ad19-00f150e48ebb"],
    "ICmsDetachedSignatureStatics": ["3d114cfd-bf9b-4682-9be6-91f57c053808"],
    "ICmsSignerInfo": ["50d020db-1d2f-4c1a-b5c5-d0188ff91f47"],
    "ICmsTimestampInfo": ["2f5f00f2-2c18-4f88-8435-c534086076f5"],
    "ICoCreateLocally": ["03de00aa-f272-41e3-99cb-03c5e8114ea0"],
    "ICoCreatedLocally": ["0a53eb6c-1908-4742-8cff-2cee2e93f94c"],
    "ICodeNavigate": ["6d5140c4-7436-11ce-8034-00aa006009fa"],
    "ICodeNavigate2": ["2702ad60-3459-11d1-88fd-00a0c9110049"],
    "ICodecAPI": ["901db4c7-31ce-41a2-85dc-8fa0bf41b8da"],
    "ICodecInfo": ["51e89f85-ea97-499c-86ac-4ce5e73f3a42"],
    "ICodecQuery": ["222a953a-af61-4e04-808a-a4634e2f3ac4"],
    "ICodecSubtypesStatics": ["a66ac4f2-888b-4224-8cf6-2a8d4eb02382"],
    "ICollectionAnchor": ["84ba9c75-6c22-4590-9bdc-5584eade039e"],
    "ICollectionEventSink": ["ab481469-2d98-42d2-9ddf-9161e8bd44b1"],
    "ICollectionNotify": ["97312c82-d4c2-11d1-b682-00805fc79216"],
    "ICollectionProvider": ["2d2bfaee-31a8-4613-8bc2-bb7c3020f788"],
    "ICollectionStagingManager": ["95a1f9ea-4032-11e3-95fe-65f56188709b"],
    "ICollectionStagingProgressSink": ["ff56a010-ffb0-491e-bdb1-b387cccab33d"],
    "ICollectionStagingState": ["88a9d820-1c0b-4148-89d9-6b1b4784233a"],
    "ICollectionSyncState": ["beb5d41e-0e4f-4915-ba6d-362d052c96fa"],
    "ICollectionSyncStateStore": ["f549f78a-c20d-456a-8c42-a457d5435de6"],
    "ICollectionSyncStateStoreProvider": ["51f07ca4-2bde-42c3-a0a2-379a1b718332"],
    "ICollectionUniqueCount": ["932cb17b-02b9-4adc-964f-54e5eae22582"],
    "ICollectionView": ["8be8bfe4-dbef-44df-8126-a31a89121ddc"],
    "ICollectionViewFactory": ["34d4aaf4-8e72-4950-9192-ecd07d399d0a"],
    "ICollectionViewGroup": ["7e01b9d8-d7b5-48b6-b31c-5bb5bdf5f09b"],
    "ICollectionViewSource": ["a66a1146-d2fb-4ead-be9f-3578a466dcfe"],
    "ICollectionViewSourceStatics": ["173a0710-46af-4c0c-818b-21b6ef81bf65"],
    "IColorAnimation": ["b8ae8a15-0f63-4694-9467-bdafac1253ea"],
    "IColorAnimationStatics": ["55eaf6e2-87e3-4f48-958f-855b2f9ea9ec"],
    "IColorAnimationUsingKeyFrames": ["f5c82640-13c3-42aa-9ae2-7e6b51c92f95"],
    "IColorAnimationUsingKeyFramesStatics": ["b4723cdc-96e9-48f9-8d92-9b648b2f1cc6"],
    "IColorChangedEventArgs": ["34f7201f-aad0-4c3a-b97b-2abf36455539"],
    "IColorDirectory": ["00000303-a8f2-4877-ba0a-fd2b6645fb94"],
    "IColorHelper": ["193cfbe7-65c7-4540-ad08-6283ba76879a"],
    "IColorHelperStatics": ["8504dbea-fb6a-4144-a6c2-33499c9284f5"],
    "IColorHelperStatics2": ["24d9af02-6eb0-4b94-855c-fcf0818d9a16"],
    "IColorKeyFrame": ["b51d82d9-0910-4589-a284-b0c9205858e9"],
    "IColorKeyFrameAnimation": ["93adb5e9-8e05-4593-84a3-dca152781e56"],
    "IColorKeyFrameFactory": ["769bd88a-9cfb-4a7d-96c4-a1e7de6fdb4b"],
    "IColorKeyFrameStatics": ["c043ae99-210c-430f-9da5-df1082692055"],
    "IColorOverrideSettings": ["fbefa134-4a81-4c4d-a5b6-7d1b5c4bd00b"],
    "IColorOverrideSettingsStatics": ["b068e05f-c41f-4ac9-afab-827ab6248f9a"],
    "IColorPaletteResources": ["258088c4-aef2-5d3f-833b-c36db6278ed9"],
    "IColorPaletteResourcesFactory": ["a57f0783-1876-5cc0-8ea5-bc77b17e0f7e"],
    "IColorPicker": ["6232e371-5c64-43cb-8b35-7f82dde36740"],
    "IColorPickerFactory": ["abae07ff-aecf-481d-9204-201c3894cd1b"],
    "IColorPickerSlider": ["94394d83-e0df-4c5f-bbcd-8155f4020440"],
    "IColorPickerSliderAutomationPeer": ["a514215a-7293-4577-924c-47d4e0bf9b90"],
    "IColorPickerSliderAutomationPeerFactory": ["1a55c77e-9dd6-45a3-9042-b40200fea1a9"],
    "IColorPickerSliderFactory": ["06d879a2-8c07-4b1e-a940-9fbce8f49639"],
    "IColorPickerSliderStatics": ["22eafc6a-9fe3-4eee-8734-a1398ec4413a"],
    "IColorPickerStatics": ["67ca9be7-1574-451a-b6df-fe57d9d07b46"],
    "IColorSpectrum": ["ce46f271-f509-4f98-8288-e4942fb385df"],
    "IColorSpectrumAutomationPeer": ["15d5ba03-010d-4ff7-9087-f4dd09f831b7"],
    "IColorSpectrumAutomationPeerFactory": ["0ac400e1-b743-4496-837a-8889e6ac6497"],
    "IColorSpectrumFactory": ["90c7e61e-904d-42ab-b44f-e68dbf0cdee9"],
    "IColorSpectrumStatics": ["906bee7c-2cee-4e90-968b-f0a5bd691b4a"],
    "IColors": ["9b8c9326-4ca6-4ce5-8994-9eff65cabdcc"],
    "IColorsStatics": ["cff52e04-cca6-4614-a17e-754910c84a99"],
    "IColumnDefinition": ["f7f1b229-f024-467f-970a-7e705615db7b"],
    "IColumnDefinitionStatics": ["06b0d728-d044-40c6-942e-ae60eac74851"],
    "IColumnHeader": ["bdd1f051-858b-11d1-b16a-00c0f0283628"],
    "IColumnHeaders": ["bdd1f050-858b-11d1-b16a-00c0f0283628"],
    "IColumnList": ["c92f9791-754f-4205-9d3d-3ec1e04b03f9"],
    "IColumnManager": ["d8ec27bb-3f3b-4042-b10a-4acfd924d453"],
    "IColumnPreference": ["08727c66-4a04-456d-8c9a-cc1f65490753"],
    "IColumnsInfo": ["0c733a11-2a1c-11ce-ade5-00aa0044773d"],
    "IColumnsInfo2": ["0c733ab8-2a1c-11ce-ade5-00aa0044773d"],
    "IColumnsRowset": ["0c733a10-2a1c-11ce-ade5-00aa0044773d"],
    "IComApplInfo": ["000001ec-0000-0000-c000-000000000046"],
    "IComApplInfo2": ["000001e3-0000-0000-c000-000000000046"],
    "IComCatalog": ["000001e0-0000-0000-c000-000000000046"],
    "IComCatalog2": ["000001fa-0000-0000-c000-000000000046"],
    "IComCatalog2Internal": ["3310dab4-edc0-4ce9-8a9c-8fea2980fd89"],
    "IComCatalogInternal": ["a6304910-4115-11d2-8133-0060089f5fed"],
    "IComCatalogLocation": ["fae51051-9887-47f2-af44-7392bf90039b"],
    "IComCatalogSCM": ["000001fd-0000-0000-c000-000000000046"],
    "IComCatalogSettings": ["000001ff-0000-0000-c000-000000000046"],
    "IComClassInfo": ["000001e1-0000-0000-c000-000000000046"],
    "IComClassInfo2": ["000001e4-0000-0000-c000-000000000046"],
    "IComComputerInfo": ["1684441e-e922-4882-863f-4c87138e6423"],
    "IComDispatchInfo": ["000001d9-0000-0000-c000-000000000046"],
    "IComHandlerAction": ["6d2fd252-75c5-4f66-90ba-2a7d8cc3039f"],
    "IComLTxEvents": ["605cf82c-578e-4298-975d-82babcd9e053"],
    "IComObjIdentity": ["000001d7-0000-0000-c000-000000000046"],
    "IComProcessInfo": ["000001ed-0000-0000-c000-000000000046"],
    "IComProcessInfo2": ["6acfc1bf-3882-45b1-96a3-ab948a267d38"],
    "IComProcessInfo3": ["5b0300bc-3a64-4bfe-9a06-ee2bcce72680"],
    "IComServices": ["000001f5-0000-0000-c000-000000000046"],
    "IComServices2": ["61a7d610-42eb-43d2-a55f-1904d3294daa"],
    "IComSoapPublisher": ["d8013eee-730b-45e2-ba24-874b7242c425"],
    "IComWrapper": ["cbd71f2c-6bc5-4932-b851-b93eb3151386"],
    "IComWrapperFactory": ["436b402a-a479-41a8-a093-9713ce3ad111"],
    "IComWrapperFactory2": ["cb4bb619-abd5-459c-ac9f-88844c610bc9"],
    "ICombinedFilterInfo": ["11f9de71-2818-4779-b2ac-42d450565f45"],
    "IComboBox": ["b9a8d05c-ac97-47f1-a5f4-3f9f4d4b116c"],
    "IComboBox2": ["ea0cbf91-ca36-4fad-972a-2e53a6718b9f"],
    "IComboBox3": ["52400a63-476c-4bb6-b781-019324d3fed9"],
    "IComboBox4": ["b7974f49-b05c-47f9-9aaf-d6f9187be5fd"],
    "IComboBox5": ["ab79d646-800a-4a28-969b-34bb8fb458cf"],
    "IComboBox6": ["61aad6a5-81fb-5f87-bae3-369fbe2ea1f3"],
    "IComboBoxAutomationPeer": ["7eb40d0b-75c5-4263-ba6a-d4a54fb0f239"],
    "IComboBoxAutomationPeerFactory": ["098e5b0d-1b90-40b9-9be3-b23267eb13cf"],
    "IComboBoxFactory": ["ac0d0444-a65b-4abd-86df-3016049efedc"],
    "IComboBoxItem": ["993fd6d2-2aae-4f3b-b44d-5648f4d06114"],
    "IComboBoxItemAutomationPeer": ["12ddc76e-9552-446a-82ee-938cc371800f"],
    "IComboBoxItemAutomationPeerFactory": ["134ac7fc-397a-403f-a6ec-1ce8beda15e5"],
    "IComboBoxItemDataAutomationPeer": ["4fef6df2-289c-4c04-831b-5a668c6d7104"],
    "IComboBoxItemDataAutomationPeerFactory": ["14a8d4f6-469a-41ba-9d93-44a1a55da872"],
    "IComboBoxItemFactory": ["8fffe867-d94c-4e87-8fc4-6ebcd63c5ac2"],
    "IComboBoxOverrides": ["4f016541-bcfe-4a22-8932-c914981c2240"],
    "IComboBoxStatics": ["3e14c9b1-d15b-4dc9-8110-cf3a117b96e7"],
    "IComboBoxStatics2": ["93988a11-402c-4b13-96d1-7220266b9220"],
    "IComboBoxStatics3": ["949e140f-ce7f-4e41-bdc5-d1d3388ad0a6"],
    "IComboBoxStatics4": ["d9f58358-f7b0-46ce-8061-ad83ec2f2dd4"],
    "IComboBoxStatics5": ["b802cef1-a264-444a-9a61-aa8867b7a63c"],
    "IComboBoxStatics6": ["516c88e0-ec6b-54ac-8c57-5ec080ee05c8"],
    "IComboBoxTemplateSettings": ["83285c4e-17f6-4aa3-b61b-e87c718604ea"],
    "IComboBoxTemplateSettings2": ["00e90cd7-68be-449d-b5a7-76e26f703e9b"],
    "IComboBoxTextSubmittedEventArgs": ["cb698cbb-6879-558e-af82-df1d08f62afa"],
    "IComboItem": ["dd9da660-8594-11d1-b16a-00c0f0283628"],
    "IComboItems": ["dd9da662-8594-11d1-b16a-00c0f0283628"],
    "ICommDlgBrowser3": ["c8ad25a1-3294-41ee-8165-71174bd01c57"],
    "ICommand": ["0c733a63-2a1c-11ce-ade5-00aa0044773d", "e5af3542-ca67-4081-995b-709dd13792df"],
    "ICommandBar": ["98bc4280-4a3d-4cee-bd07-22ce94c5af76"],
    "ICommandBar2": ["57662f58-5b32-475d-be64-4ca36e7b97d4"],
    "ICommandBar3": ["40ebbc23-2a79-48b3-9a67-649b852d8589"],
    "ICommandBarButtonEvents": ["55f88890-7708-11d1-aceb-006008961da5"],
    "ICommandBarComboBoxEvents": ["55f88896-7708-11d1-aceb-006008961da5"],
    "ICommandBarElement": ["67918e1b-f2d5-44d1-8b84-92b87f80a350"],
    "ICommandBarElement2": ["a9bf1236-4402-4688-b987-9d2b9b7bf2bd"],
    "ICommandBarFactory": ["67bdeb44-20e1-4177-ad44-f617b374e8e8"],
    "ICommandBarFlyout": ["fecd2c4d-f16a-58cd-8aca-db0f046f25c3"],
    "ICommandBarFlyoutCommandBar": ["14146e7c-38c4-55c4-b706-ce18f6061e7e"],
    "ICommandBarFlyoutCommandBarFactory": ["f8236f9f-5559-5697-8e6f-20d70ca17dd0"],
    "ICommandBarFlyoutCommandBarTemplateSettings": ["47642c44-26ff-5d14-9cfc-77dc64f3a447"],
    "ICommandBarFlyoutFactory": ["dd6441b3-6df1-593d-b80c-daf5c1daee41"],
    "ICommandBarOverflowPresenter": ["6e7a9427-58ef-4366-a017-18c193d56b14"],
    "ICommandBarOverflowPresenterFactory": ["8323f774-5aaa-4049-b78f-218c6a19c37e"],
    "ICommandBarStatics": ["5bd981ea-e278-409c-b522-f946ca253b44"],
    "ICommandBarStatics2": ["3d9ec8e3-51a9-4e34-956c-7081d06f26f8"],
    "ICommandBarStatics3": ["b45a24a4-8af1-4843-b319-e03fc45ab726"],
    "ICommandBarTemplateSettings": ["61c8f92c-05aa-414a-a2ae-482c5a46c08e"],
    "ICommandBarTemplateSettings2": ["fbb24f93-c2e2-4177-a2b6-3cd705073cf6"],
    "ICommandBarTemplateSettings3": ["3bd71eba-3403-4bfe-842d-2ce8c511d245"],
    "ICommandBarTemplateSettings4": ["f2562dd3-aa58-59c5-853b-828a19d1214e"],
    "ICommandBarsEvents": ["55f88892-7708-11d1-aceb-006008961da5"],
    "ICommandButtonInfo": ["8a49a5ea-5e80-46d0-8506-285496e4592e"],
    "ICommandCollection": ["156a0971-f6e2-4767-b7ce-d33e2798037e"],
    "ICommandCost": ["0c733a4e-2a1c-11ce-ade5-00aa0044773d"],
    "ICommandDescriptor": ["0323648f-ff62-48cc-a9de-abbda1550caa"],
    "ICommandDescriptorEx": ["768b08be-40a0-44be-a52c-65211d3f93a8"],
    "ICommandExtManager": ["25a161e8-96fb-49f5-af56-93b4bae5a01b"],
    "ICommandLineActivatedEventArgs": ["4506472c-006a-48eb-8afb-d07ab25e3366"],
    "ICommandLineActivationOperation": ["994b2841-c59e-4f69-bcfd-b61ed4e622eb"],
    "ICommandPersist": ["0c733aa7-2a1c-11ce-ade5-00aa0044773d"],
    "ICommandPrepare": ["0c733a26-2a1c-11ce-ade5-00aa0044773d"],
    "ICommandProperties": ["0c733a79-2a1c-11ce-ade5-00aa0044773d"],
    "ICommandSearch": ["48b37235-b7e4-4617-a3f1-d5bb6ad5d78f"],
    "ICommandStream": ["0c733abf-2a1c-11ce-ade5-00aa0044773d"],
    "ICommandText": ["0c733a27-2a1c-11ce-ade5-00aa0044773d"],
    "ICommandTree": ["0c733a87-2a1c-11ce-ade5-00aa0044773d"],
    "ICommandValidate": ["0c733a18-2a1c-11ce-ade5-00aa0044773d"],
    "ICommandWithParameters": ["0c733a64-2a1c-11ce-ade5-00aa0044773d"],
    "ICommonClaimedPosPrinterStation": ["b7eb66a8-fe8a-4cfb-8b42-e35b280cb27c"],
    "ICommonLayoutDefinition": ["d72ff553-ae8f-4dae-9ee8-833a9e025cb0"],
    "ICommonLayoutModifier": ["d783f427-3c66-4cff-87b6-b0db2305736c"],
    "ICommonNavigationTransitionInfo": ["50345692-a555-4624-a361-0a91c1706473"],
    "ICommonNavigationTransitionInfoStatics": ["1e3efe33-50be-4443-883c-e5627201c2e5"],
    "ICommonPosPrintStationCapabilities": ["de5b52ca-e02e-40e9-9e5e-1b488e6aacfc"],
    "ICommonReceiptSlipCapabilities": ["09286b8b-9873-4d05-bfbe-4727a6038f69"],
    "ICommunicationBlockingAccessManagerStatics": ["1c969998-9d2a-5db7-edd5-0ce407fc2595"],
    "ICommunicationBlockingAppManagerStatics": ["77db58ec-14a6-4baa-942a-6a673d999bf2"],
    "ICommunicationBlockingAppSetAsActiveTrigger": ["fb91f28a-16a5-486d-974c-7835a8477be2"],
    "ICompactOverlayBroker": ["173c883a-9329-4c9e-a204-94c620ee69a3"],
    "ICompactOverlayPresentationConfiguration": ["a7e5750f-5730-56c6-8e1f-d63ff4d7980d"],
    "IComparableConcept": ["a7830646-9f0c-4a31-ba19-503f33e6c8a3"],
    "ICompass": ["292ffa94-1b45-403c-ba06-b106dba69a64"],
    "ICompass2": ["36f26d09-c7d7-434f-b461-979ddfc2322f"],
    "ICompass3": ["a424801b-c5ea-4d45-a0ec-4b791f041a89"],
    "ICompass4": ["291e7f11-ec32-5dcc-bfcb-0bb39eba5774"],
    "ICompassDataThreshold": ["d15b52b3-d39d-5ec8-b2e4-f193e6ab34ed"],
    "ICompassDeviceId": ["d181ca29-b085-4b1d-870a-4ff57ba74fd4"],
    "ICompassReading": ["82911128-513d-4dc9-b781-5eedfbf02d0c"],
    "ICompassReading2": ["b13a661e-51bb-4a12-bedd-ad47ff87d2e8"],
    "ICompassReadingChangedEventArgs": ["8f1549b0-e8bc-4c7e-b009-4e41df137072"],
    "ICompassReadingHeadingAccuracy": ["e761354e-8911-40f7-9e16-6ecc7daec5de"],
    "ICompassStatics": ["9abc97df-56ec-4c25-b54d-40a68bb5b269"],
    "ICompassStatics2": ["0ace0ead-3baa-4990-9ce4-be0913754ed2"],
    "ICompatContextMenu": ["4b11d5ae-62f5-4ce2-9767-c54aa2eba7b3"],
    "IComponentActivation": ["70df5e3a-726c-4b53-818d-fa24a8292132"],
    "IComponentAuthenticate": ["a9889c00-6d2b-11d3-8496-00c04f79dbc0"],
    "IComponentConnector": ["f6790987-e6e5-47f2-92c6-eccce4ba159a"],
    "IComponentConnector2": ["dc8f368b-eccc-498e-b139-91142254d7ae"],
    "IComponentHandles": ["d4ca8951-1981-4813-b663-4df5afd111fd"],
    "IComponentLoadFailedEventArgs": ["95972e93-7746-417e-8495-f031bbc5862c"],
    "IComponentLoadFailedEventHandler": ["95da643c-6db9-424b-86ca-091af432081c"],
    "IComponentReceiveHandle": ["c697bd11-01e0-4fc0-b6ff-1934243a02ee"],
    "IComponentRegistrarControl": ["6e803fc2-a423-11d2-b943-00c04f79d22f"],
    "IComponentRenewalStatics": ["6ffbcd67-b795-48c5-8b7b-a7c4efe202e3"],
    "IComponentSitePrivate": ["4f43b367-57d8-4e5b-94e2-805fee4e1faa"],
    "IComponentType": ["6a340dc0-0311-11d3-9d8e-00c04f72d980"],
    "IComponentTypes": ["0dc13d4a-0313-11d3-9d8e-00c04f72d980"],
    "IComponentUIExperienceBroker": ["7d0a51a2-edd8-43ac-88e0-8c37279db21a"],
    "IComponentUIPlugin": ["9f0f63f2-6657-4dfd-92ae-ef7abc80fddd"],
    "IComponentUtil": ["6eb22873-8a19-11d0-81b6-00a0c9231c29"],
    "IComponents": ["39a48091-fffe-4182-a161-3ff802640e26"],
    "IComponentsOld": ["fcd01846-0e19-11d3-9d8e-00c04f72d980"],
    "ICompositeTransform": ["c8a4385b-f24a-4701-a265-a78846f142b9"],
    "ICompositeTransform3D": ["8977cb01-af8d-4af5-b084-c08eb9704abe"],
    "ICompositeTransform3DStatics": ["ddbf4d67-2a25-48f3-9808-c51ec3d55bec"],
    "ICompositeTransformStatics": ["2f190c08-8266-496f-9653-a18bd4f836aa"],
    "ICompositeVideoFrameContext": ["6c30024b-f514-4278-a5f7-b9188049d110"],
    "ICompositionAnimation": ["464c4c2c-1caa-4061-9b40-e13fde1503ca"],
    "ICompositionAnimation2": ["369b603e-a80f-4948-93e3-ed23fb38c6cb"],
    "ICompositionAnimation3": ["d51e030d-7da4-4bd7-bc2d-f4517529f43a"],
    "ICompositionAnimation4": ["770137be-76bc-4e23-bfed-fe9cc20f6ec9"],
    "ICompositionAnimationBase": ["1c2c2999-e818-48d3-a6dd-d78c82f8ace9"],
    "ICompositionAnimationFactory": ["10f6c4fb-6e51-4c25-bbd3-586a9bec3ef4"],
    "ICompositionAnimationGroup": ["5e7cc90c-cd14-4e07-8a55-c72527aabdac"],
    "ICompositionBackdropBrush": ["c5acae58-3898-499e-8d7f-224e91286a5d"],
    "ICompositionBatchCompletedEventArgs": ["0d00dad0-9464-450a-a562-2e2698b0a812"],
    "ICompositionBrush": ["ab0d7608-30c0-40e9-b568-b60a6bd1fb46"],
    "ICompositionBrushFactory": ["da53fb4c-4650-47c4-ad76-765379607ed6"],
    "ICompositionCapabilities": ["8253353e-b517-48bc-b1e8-4b3561a2e181"],
    "ICompositionCapabilitiesStatics": ["f7b7a86e-6416-49e5-8ddf-afe949e20562"],
    "ICompositionClip": ["1ccd2a52-cfc7-4ace-9983-146bb8eb6a3c"],
    "ICompositionClip2": ["5893e069-3516-40e1-89e0-5ba924927235"],
    "ICompositionClipFactory": ["b9484caf-20c7-4aed-ac4a-9c78ba1302cf"],
    "ICompositionColorBrush": ["2b264c5e-bf35-4831-8642-cf70c20fff2f"],
    "ICompositionColorGradientStop": ["6f00ca92-c801-4e41-9a8f-a53e20f57778"],
    "ICompositionColorGradientStopCollection": ["9f1d20ec-7b04-4b1d-90bc-9fa32c0cfd26"],
    "ICompositionCommitBatch": ["0d00dad0-ca07-4400-8c8e-cb5db08559cc"],
    "ICompositionConditionalValue": ["43250538-eb73-4561-a71d-1a43eaeb7a9b"],
    "ICompositionConditionalValueStatics": ["090c4b72-8467-4d0a-9065-ac46b80a5522"],
    "ICompositionContainerShape": ["4f5e859b-2e5b-44a8-982c-aa0f69c16059"],
    "ICompositionDebugHeatMaps": ["e49c90ac-2ff3-5805-718c-b725ee07650f"],
    "ICompositionDebugSettings": ["2831987e-1d82-4d38-b7b7-efd11c7bc3d1"],
    "ICompositionDebugSettingsStatics": ["64ec1f1e-6af8-4af8-b814-c870fd5a9505"],
    "ICompositionDrawingSurface": ["a166c300-fad0-4d11-9e67-e433162ff49e"],
    "ICompositionDrawingSurface2": ["fad0e88b-e354-44e8-8e3d-c4880d5a213f"],
    "ICompositionDrawingSurfaceFactory": ["9497b00a-312d-46b9-9db3-412fd79464c8"],
    "ICompositionEasingFunction": ["5145e356-bf79-4ea8-8cc2-6b5b472e6c9a"],
    "ICompositionEasingFunctionFactory": ["60840774-3da0-4949-8200-7206c00190a0"],
    "ICompositionEffectBrush": ["bf7f795e-83cc-44bf-a447-3e3c071789ec"],
    "ICompositionEffectFactory": ["be5624af-ba7e-4510-9850-41c0b4ff74df"],
    "ICompositionEffectSourceParameter": ["858ab13a-3292-4e4e-b3bb-2b6c6544a6ee"],
    "ICompositionEffectSourceParameterFactory": ["b3d9f276-aba3-4724-acf3-d0397464db1c"],
    "ICompositionEllipseGeometry": ["4801f884-f6ad-4b93-afa9-897b64e57b1f"],
    "ICompositionGeometricClip": ["c840b581-81c9-4444-a2c1-ccaece3a50e5"],
    "ICompositionGeometry": ["e985217c-6a17-4207-abd8-5fd3dd612a9d"],
    "ICompositionGeometryFactory": ["bffebfe1-8c25-480b-9f56-fed6b288055d"],
    "ICompositionGradientBrush": ["1d9709e0-ffc6-4c0e-a9ab-34144d4c9098"],
    "ICompositionGradientBrush2": ["899dd5a1-b4c7-4b33-a1b6-264addc26d10"],
    "ICompositionGradientBrushFactory": ["56d765d7-f189-48c9-9c8d-94daf1bec010"],
    "ICompositionGraphicsDevice": ["fb22c6e1-80a2-4667-9936-dbeaf6eefe95"],
    "ICompositionGraphicsDevice2": ["0fb8bdf6-c0f0-4bcc-9fb8-084982490d7d"],
    "ICompositionGraphicsDevice3": ["37f67514-d3ef-49d1-b69d-0d8eabeb3626"],
    "ICompositionInteractionSource": ["043b2431-06e3-495a-ba54-409f0017fac0"],
    "ICompositionInteractionSourceCollection": ["1b468e4b-a5bf-47d8-a547-3894155a158c"],
    "ICompositionLight": ["41a6d7c2-2e5d-4bc1-b09e-8f0a03e3d8d3"],
    "ICompositionLight2": ["a7bcda72-f35d-425d-9b98-23f4205f6669"],
    "ICompositionLight3": ["4b0b00e4-df07-4959-b7a4-4f7e4233f838"],
    "ICompositionLightFactory": ["069cf306-da3c-4b44-838a-5e03d51ace55"],
    "ICompositionLineGeometry": ["dd7615a4-0c9a-4b67-8dce-440a5bf9cdec"],
    "ICompositionLinearGradientBrush": ["983bc519-a9db-413c-a2d8-2a9056fc525e"],
    "ICompositionMaskBrush": ["522cf09e-be6b-4f41-be49-f9226d471b4a"],
    "ICompositionMipmapSurface": ["4863675c-cf4a-4b1c-9ece-c5ec0c2b2fe6"],
    "ICompositionNineGridBrush": ["f25154e4-bc8c-4be7-b80f-8685b83c0186"],
    "ICompositionObject": ["bcb4ad45-7609-4550-934f-16002a68fded"],
    "ICompositionObject2": ["ef874ea1-5cff-4b68-9e30-a1519d08ba03"],
    "ICompositionObject3": ["4bc27925-dacd-4cf2-98b1-986b76e7ebe6"],
    "ICompositionObject4": ["0bb3784c-346b-4a7c-966b-7310966553d5"],
    "ICompositionObjectFactory": ["51205c5e-558a-4f2a-8d39-37bfe1e20ddd"],
    "ICompositionObjectStatics": ["c1ed052f-1ba2-44ba-a904-6a882a0a5adb"],
    "ICompositionPath": ["66da1d5f-2e10-4f22-8a06-0a8151919e60"],
    "ICompositionPathFactory": ["9c1e8c6a-0f33-4751-9437-eb3fb9d3ab07"],
    "ICompositionPathGeometry": ["0b6a417e-2c77-4c23-af5e-6304c147bb61"],
    "ICompositionProcessor": ["ea69859a-db5b-4c4a-8a8f-ae9759027534"],
    "ICompositionProjectedShadow": ["285b8e72-4328-523f-bcf2-5557c52c3b25"],
    "ICompositionProjectedShadowCaster": ["b1d7d426-1e36-5a62-be56-a16112fdd148"],
    "ICompositionProjectedShadowCasterCollection": ["d2525c0c-e07f-58a3-ac91-37f73ee91740"],
    "ICompositionProjectedShadowCasterCollectionStatics": ["56fbb136-e94f-5299-ab5b-6e15e38bd899"],
    "ICompositionProjectedShadowReceiver": ["1377985a-6a49-536a-9be4-a96a8e5298a9"],
    "ICompositionProjectedShadowReceiverUnorderedCollection": ["02b3e3b7-27d2-599f-ac4b-ab787cdde6fd"],
    "ICompositionPropertySet": ["c9d6d202-5f67-4453-9117-9eadd430d3c2"],
    "ICompositionPropertySet2": ["de80731e-a211-4455-8880-7d0f3f6a44fd"],
    "ICompositionRadialGradientBrush": ["3d3b50c5-e3fa-4ce2-b9fc-3ee12561788f"],
    "ICompositionRectangleGeometry": ["0cd51428-5356-4246-aecf-7a0b76975400"],
    "ICompositionRoundedRectangleGeometry": ["8770c822-1d50-4b8b-b013-7c9a0e46935f"],
    "ICompositionScopedBatch": ["0d00dad0-fb07-46fd-8c72-6280d1a3d1dd"],
    "ICompositionShadow": ["329e52e2-4335-49cc-b14a-37782d10f0c4"],
    "ICompositionShadowFactory": ["221f492f-dcba-4b91-999e-1dc217a01530"],
    "ICompositionShape": ["b47ce2f7-9a88-42c4-9e87-2e500ca8688c"],
    "ICompositionShapeFactory": ["1dfc36d0-b05a-44ef-82b0-12118bcd4cd0"],
    "ICompositionSpriteShape": ["401b61bb-0007-4363-b1f3-6bcc003fb83e"],
    "ICompositionSurface": ["1527540d-42c7-47a6-a408-668f79a90dfb"],
    "ICompositionSurfaceBrush": ["ad016d79-1e4c-4c0d-9c29-83338c87c162"],
    "ICompositionSurfaceBrush2": ["d27174d5-64f5-4692-9dc7-71b61d7e5880"],
    "ICompositionSurfaceBrush3": ["550bb289-1fe0-42e5-8195-1eefa87ff08e"],
    "ICompositionTarget": ["26cfbff0-713c-4bec-8803-e101f7b14ed3", "a1bea8ba-d726-4663-8129-6b5e7927ffa6"],
    "ICompositionTargetFactory": ["93cd9d2b-8516-4b14-a8ce-f49e2119ec42"],
    "ICompositionTargetStatics": ["2b1af03d-1ed2-4b59-bd00-7594ee92832b"],
    "ICompositionTargetStatics3": ["bc0a7cd9-6750-4708-994c-2028e0312ac8"],
    "ICompositionTransform": ["7cd54529-fbed-4112-abc5-185906dd927c"],
    "ICompositionTransformFactory": ["aaaeca26-c149-517a-8f72-6bff7a65ce08"],
    "ICompositionViewBox": ["b440bf07-068f-4537-84c6-4ecbe019e1f4"],
    "ICompositionVirtualDrawingSurface": ["a9c384db-8740-4f94-8b9d-b68521e7863d"],
    "ICompositionVirtualDrawingSurfaceFactory": ["6766106c-d56b-4a49-b1df-5076a0620768"],
    "ICompositionVisualSurface": ["b224d803-4f6e-4a3f-8cae-3dc1cda74fc6"],
    "ICompositor": ["b403ca50-7f8c-4e83-985f-cc45060036d8"],
    "ICompositor2": ["735081dc-5e24-45da-a38f-e32cc349a9a0"],
    "ICompositor3": ["c9dd8ef0-6eb1-4e3c-a658-675d9c64d4ab"],
    "ICompositor4": ["ae47e78a-7910-4425-a482-a05b758adce9"],
    "ICompositor5": ["48ea31ad-7fcd-4076-a79c-90cc4b852c9b"],
    "ICompositor6": ["7a38b2bd-cec8-4eeb-830f-d8d07aedebc3"],
    "ICompositorController": ["2d75f35a-70a7-4395-ba2d-cef0b18399f9"],
    "ICompositorStatics": ["080db93e-121e-4d97-8b74-1dfcf91987ea"],
    "ICompositorWithProjectedShadow": ["a2e6330e-8a60-5a38-bb85-b44ea901677c"],
    "ICompositorWithRadialGradient": ["98b9c1a7-8e71-4b53-b4a8-69ba5d19dc5b"],
    "ICompositorWithVisualSurface": ["cfa1658b-0123-4551-8891-89bdcc40322b"],
    "IComprehensiveSpellCheckProvider": ["0c58f8de-8e94-479e-9717-70c42c4ad2c3"],
    "ICompressor": ["0ac3645a-57ac-4ee1-b702-84d39d5424e0"],
    "ICompressorFactory": ["5f3d96a4-2cfb-442c-a8ba-d7d11b039da0"],
    "IComputerAccountNotify": ["f0009734-e8de-48e5-b603-bfa5966a8f7c"],
    "IComputerAccounts": ["3c708557-c99d-4fa3-9231-56518418b4e4"],
    "IComputerAccounts2": ["fde873d4-e2de-427c-89bd-c234b5f2dc43"],
    "IComputerAccountsEnumerationOption": ["6584ab60-75df-46ce-a8ca-fe0ea7882370"],
    "IComputerInfoAdvise": ["4623bd61-5603-444f-824a-aaebceed93fa"],
    "IComputerInfoChangeNotify": ["0df60d92-6818-46d6-b358-d66170dde466"],
    "ICondition": ["0fc988d4-c935-4b97-a973-46282ea175c8"],
    "ICondition2": ["0db8851d-2e5b-47eb-9208-d28c325a01d7"],
    "IConditionFactory": ["a5efe073-b16f-474f-9f3e-9f8b497a3e08"],
    "IConditionFactory2": ["71d222e1-432f-429e-8c13-b6dafde5077a"],
    "IConditionForceEffect": ["32d1ea68-3695-4e69-85c0-cd1944189140"],
    "IConditionForceEffectFactory": ["91a99264-1810-4eb6-a773-bfd3b8cddbab"],
    "IConditionGenerator": ["92d2cc58-4386-45a3-b98c-7e0ce64a4117"],
    "IConfigAsfWriter": ["45086030-f7e4-486a-b504-826bb5792a3b"],
    "IConfigAsfWriter2": ["7989ccaa-53f0-44f0-884a-f3b03f6ae066"],
    "IConfiguration": ["cd000022-8b95-11d1-82db-00c04fb1625d"],
    "IConfigurationDataCollector": ["03837514-098b-11d8-9414-505054503030"],
    "IConfigureHostedCoreWindow": ["34e7b726-59fc-4ace-a7cd-d4ad43a0751f"],
    "IConfigureRetailDemoInternal": ["0e64bb19-ed60-458d-a97f-e65843ad2bc2"],
    "IConfigureWindowFactory": ["601d51e3-801e-49c9-bbfa-fe29a662aead"],
    "IConfigureWindowFactory2": ["dbcc81cc-d31a-4e70-9632-fc3fdd4325c0"],
    "IConfirmOnlyAssociationResponse": ["6bbc32a7-290f-4bce-888a-4b1b42b59952"],
    "IConfirmPinMatchAssociationResponse": ["f869dea6-824d-4f26-b594-deccb2a44ecd"],
    "IConfirmationInterrupt": ["47e7bb4d-2d83-4604-905c-0ee8eab077a4"],
    "IConflictDialogData": ["106fe53d-7a09-42d0-862a-cc5b126e979a"],
    "IConflictDialogDataResponse": ["caaaca0f-9b02-4565-b3c5-9b20fc4da566"],
    "IConflictInterrupt": ["6faf1156-8855-47b5-bdc8-4555d13c095f"],
    "IConflictInterruptFilter": ["cd904a72-e610-47b1-af43-2e47adb17c70"],
    "IConflictItemDataCallback": ["c7c67cb1-44ae-4e71-9e69-2c92f8d732fc"],
    "IConflictOperationScheduler": ["6b1aa9d9-a942-432d-904d-f215fd09f1c6"],
    "IConnectableCredentialProviderCredential": ["9387928b-ac75-4bf9-8ab2-2b93c4a55290"],
    "IConnectedAccountServices": ["ec242d06-492e-4a29-9757-0e84dd7852c0"],
    "IConnectedAccountServicesFactory": ["e07a4796-33a3-4b2c-9584-c5411f166a2a"],
    "IConnectedAccountStateChange": ["b5b0b6cf-ea52-4922-9376-695634758329"],
    "IConnectedAccountStatus": ["b09911a6-44de-42db-81fb-70411c593cd9"],
    "IConnectedAccountStatusEvents": ["939e6c49-eef5-4fd5-ab5e-ea1f13e424f9"],
    "IConnectedAnimation": ["3518628c-f387-4c25-ac98-44e86c3cadf0"],
    "IConnectedAnimation2": ["5d2f8e5c-584b-4ddd-b668-973891431459"],
    "IConnectedAnimation3": ["6e3040c6-0430-59c0-a80c-cceed2e778dd"],
    "IConnectedAnimationConfiguration": ["00218aae-cd8c-5651-92a0-c1db95c03998"],
    "IConnectedAnimationConfigurationFactory": ["30f9b84b-dd7e-593e-bf75-e959dc0ec52a"],
    "IConnectedAnimationService": ["1c6875c9-19bb-4d47-b9aa-66c802dcb9ff"],
    "IConnectedAnimationServiceStatics": ["c7078ea5-d688-40e8-8f90-96a6279273d2"],
    "IConnectedIdentityProvider": ["b7417b54-e08c-429b-96c8-678d1369ecb1"],
    "IConnectedSearchRegionInfo": ["ce41758b-10c6-4880-8275-3ed1bd9d4cfb"],
    "IConnectedSearchSettingsManager": ["20cde598-4740-410c-a167-98b764ffcb19"],
    "IConnectedSharePlatform": ["a8a81ca8-3d93-416f-b1f9-08113f0b873e"],
    "IConnectedUser": ["9d5f2149-de8c-45f2-b313-6587a04f771d"],
    "IConnectedUserStore": ["9ec044bc-b01d-4c18-8634-59bd3ff5dcc1"],
    "IConnectionCost": ["bad7d829-3416-4b10-a202-bac0b075bdae"],
    "IConnectionCost2": ["8e113a05-e209-4549-bb25-5e0db691cb05"],
    "IConnectionCreatedCallback": ["4bfddeb8-130e-41d1-8e6e-670e469dc9cd"],
    "IConnectionFactory": ["6fe2b64c-5012-4b88-bb9d-7ce4f45e3751"],
    "IConnectionManagerCallbacks2": ["5911f583-53a1-4c74-8592-6312178c3a14"],
    "IConnectionManagerFactory": ["a6311d38-813c-46c8-9929-89d3b6e14515"],
    "IConnectionManagerUI": ["007c9001-33be-46b7-b86c-eff659c26d4b"],
    "IConnectionManagerUICategory": ["007c9002-33be-46b7-b86c-eff659c26d4b"],
    "IConnectionManagerUIItem": ["66e03284-572f-4834-bb1a-1e5423de2b3c"],
    "IConnectionManagerUIItemContextMenu": ["d3a80e73-0ebd-40bd-859a-1429e0c3204e"],
    "IConnectionManagerUIQueue": ["007c9053-33be-46b7-b86c-eff659c26d4b"],
    "IConnectionProfile": ["71ba143c-598e-49d0-84eb-8febaedcc195"],
    "IConnectionProfile2": ["e2045145-4c9f-400c-9150-7ec7d6e2888a"],
    "IConnectionProfile3": ["578c2528-4cd9-4161-8045-201cfd5b115c"],
    "IConnectionProfile4": ["7a2d42cd-81e0-4ae6-abed-ab9ca13eb714"],
    "IConnectionProfile5": ["85361ec7-9c73-4be0-8f14-578eec71ee0e"],
    "IConnectionProfileFilter": ["204c7cc8-bd2d-4e8d-a4b3-455ec337388a"],
    "IConnectionProfileFilter2": ["cd068ee1-c3fc-4fad-9ddc-593faa4b7885"],
    "IConnectionProfileFilter3": ["0aaa09c0-5014-447c-8809-aee4cb0af94a"],
    "IConnectionProvider": ["9a7ddec7-6e6d-11df-86f8-18a905160fe0"],
    "IConnectionProvider2": ["bb130446-f2cc-4e8f-a303-71093415e323"],
    "IConnectionProviderEvents": ["46938fd0-251f-4231-ae8f-a16d80b934d5"],
    "IConnectionRequestCallback": ["272c9ae0-7161-4ae0-91bd-9f448ee9c427"],
    "IConnectionRequestedEventArgs": ["eb6891ae-4f1e-4c66-bd0d-46924a942e08"],
    "IConnectionSession": ["ff905d4c-f83b-41b0-8a0c-1462d9c56b73"],
    "IConnectionStatusHandler": ["b571c28c-a472-48d5-88d2-8adcaf1b8813"],
    "IConnectivityInterval": ["4faa3fff-6746-4824-a964-eed8e87f8709"],
    "IConnectivityManagerStatics": ["5120d4b1-4fb1-48b0-afc9-42e0092a8164"],
    "IConnector": ["9c2c4058-23f5-41de-877a-df3af236a09e"],
    "IConstantForceEffect": ["9bfa0140-f3c7-415c-b068-0f068734bce0"],
    "IConstraintConflict": ["00d2302e-1cf8-4835-b85f-b7ca4f799e0a"],
    "IConstructReplicaKeyMap": ["ded10970-ec85-4115-b52c-4405845642a5"],
    "IConstructString": ["000001f9-0000-0000-c000-000000000046"],
    "IContact": ["ec0072f3-2118-4049-9ebc-17f0ab692b64", "f941b671-bda7-4f77-884a-f46462f226a7"],
    "IContact2": ["f312f365-bb77-4c94-802d-8328cee40c08"],
    "IContact3": ["48201e67-e08e-42a4-b561-41d08ca9575d"],
    "IContactActivatedEventArgs": ["d627a1c4-c025-4c41-9def-f1eafad075e7"],
    "IContactAddress": ["9739d39a-42ce-4872-8d70-3063aa584b70"],
    "IContactAddressMarshal": ["cc3088b9-45e7-462f-8bea-6a3ffd87db74"],
    "IContactAggregationAggregate": ["7ed1c814-cd30-43c8-9b8d-2e489e53d54b"],
    "IContactAggregationAggregateCollection": ["2359f3a6-3a68-40af-98db-0f9eb143c3bb"],
    "IContactAggregationContact": ["1eb22e86-4c86-41f0-9f9f-c251e9fda6c3"],
    "IContactAggregationContactCollection": ["826e66fa-81de-43ca-a6fb-8c785cd996c6"],
    "IContactAggregationGroup": ["c93c545f-1284-499b-96af-07372af473e0"],
    "IContactAggregationGroupCollection": ["20a19a9c-d2f3-4b83-9143-beffd2cc226d"],
    "IContactAggregationLink": ["b6813323-a183-4654-8627-79b30de3a0ec"],
    "IContactAggregationLinkCollection": ["f8bc0e93-fb55-4f28-b9fa-b1c274153292"],
    "IContactAggregationManager": ["1d865989-4b1f-4b60-8f34-c2ad468b2b50"],
    "IContactAggregationServerPerson": ["7fdc3d4b-1b82-4334-85c5-25184ee5a5f2"],
    "IContactAggregationServerPersonCollection": ["4f730a4a-6604-47b6-a987-669ecf1e5751"],
    "IContactAnnotation2": ["b691ecf3-4ab7-4a1f-9941-0c9cf3171b75"],
    "IContactAnnotationList": ["92a486aa-5c88-45b9-aad0-461888e68d8a"],
    "IContactAnnotationStore": ["23acf4aa-7a77-457d-8203-987f4b31af09"],
    "IContactAnnotationStore2": ["7ede23fd-61e7-4967-8ec5-bdf280a24063"],
    "IContactBatch": ["35d1972d-bfce-46bb-93f8-a5b06ec5e201"],
    "IContactCallActivatedEventArgs": ["c2df14c7-30eb-41c6-b3bc-5b1694f9dab3"],
    "IContactCardDelayedDataLoader": ["b60af902-1546-434d-869c-6e3520760ef3"],
    "IContactCardOptions": ["8c0a4f7e-6ab6-4f3f-be72-817236eeea5b"],
    "IContactCardOptions2": ["8f271ba0-d74b-4cc6-9f53-1b0eb5d1273c"],
    "IContactChange": ["951d4b10-6a59-4720-a4e1-363d98c135d5"],
    "IContactChangeReader": ["217319fa-2d0c-42e0-a9da-3ecd56a78a47"],
    "IContactChangeTracker": ["6e992952-309b-404d-9712-b37bd30278aa"],
    "IContactChangeTracker2": ["7f8ad0fc-9321-4d18-9c09-d708c63fcd31"],
    "IContactChangedDeferral": ["c5143ae8-1b03-46f8-b694-a523e83cfcb6"],
    "IContactChangedEventArgs": ["525e7fd1-73f3-4b7d-a918-580be4366121"],
    "IContactCollection": ["b6afa338-d779-11d9-8bde-f66bad1e3f3a"],
    "IContactConnectedServiceAccount": ["f6f83553-aa27-4731-8e4a-3dec5ce9eec9"],
    "IContactConnectedServiceAccountMarshal": ["28072957-925d-11e2-9952-b4b52fe06527"],
    "IContactContentLinkProvider": ["f92fd29b-589b-4abd-9d37-35a1468f021e"],
    "IContactDataProviderConnection": ["1a398a52-8c9d-4d6f-a4e0-111e9a125a30"],
    "IContactDataProviderConnection2": ["a1d327b0-196c-4bfd-8f0f-c68d67f249d3"],
    "IContactDataProviderTriggerDetails": ["527104be-3c62-43c8-9ae7-db531685cd99"],
    "IContactDate": ["fe98ae66-b205-4934-9174-0ff2b0565707"],
    "IContactDateMarshal": ["28072955-925d-11e2-9952-b4b52fe06527"],
    "IContactEmail": ["90a219a9-e3d3-4d63-993b-05b9a5393abf"],
    "IContactEmailMarshal": ["28072954-925d-11e2-9952-b4b52fe06527"],
    "IContactField": ["b176486a-d293-492c-a058-db575b3e3c0f"],
    "IContactFieldFactory": ["85e2913f-0e4a-4a3e-8994-406ae7ed646e"],
    "IContactGroup": ["59bdeb01-9e9a-475d-bfe5-a37b806d852c"],
    "IContactInformation": ["275eb6d4-6a2e-4278-a914-e460d5f088f6"],
    "IContactInstantMessageField": ["cce33b37-0d85-41fa-b43d-da599c3eb009"],
    "IContactInstantMessageFieldFactory": ["ba0b6794-91a3-4bb2-b1b9-69a5dff0ba09"],
    "IContactInternal": ["896ab8bf-b6c5-444a-a5f3-ffd4f71f69ba"],
    "IContactJobInfo": ["6d117b4c-ce50-4b43-9e69-b18258ea5315"],
    "IContactJobInfoMarshal": ["28072956-925d-11e2-9952-b4b52fe06527"],
    "IContactLaunchActionVerbsStatics": ["fb1232d6-ee73-46e7-8761-11cd0157728f"],
    "IContactList": ["16ddec75-392c-4845-9dfb-51a3e7ef3e42"],
    "IContactList2": ["cb3943b4-4550-4dcb-9229-40ff91fb0203"],
    "IContactList3": ["1578ee57-26fc-41e8-a850-5aa32514aca9"],
    "IContactListCreateOrUpdateContactRequest": ["b4af411f-c849-47d0-b119-91cf605b2f2a"],
    "IContactListCreateOrUpdateContactRequestEventArgs": ["851c1690-1a51-4b0c-aeef-1240ac5bed75"],
    "IContactListDeleteContactRequest": ["5e114687-ce03-4de5-8557-9ccf552d472a"],
    "IContactListDeleteContactRequestEventArgs": ["b22054a1-e8fa-4db5-9389-2d12ee7d15ee"],
    "IContactListLimitedWriteOperations": ["e19813da-4a0b-44b8-9a1f-a0f3d218175f"],
    "IContactListServerSearchReadBatchRequest": ["ba776a97-4030-4925-9fb4-143b295e653b"],
    "IContactListServerSearchReadBatchRequestEventArgs": ["1a27e87b-69d7-4e4e-8042-861cba61471e"],
    "IContactListSyncConstraints": ["b2b0bf01-3062-4e2e-969d-018d1987f314"],
    "IContactListSyncManager": ["146e83be-7925-4acc-9de5-21ddd06f8674"],
    "IContactListSyncManager2": ["a9591247-bb55-4e23-8128-370134a85d0d"],
    "IContactListSyncManagerSyncRequest": ["3c0e57a4-c4e7-4970-9a8f-9a66a2bb6c1a"],
    "IContactListSyncManagerSyncRequestEventArgs": ["158e4dac-446d-4f10-afc2-02683ec533a6"],
    "IContactLocationField": ["9ec00f82-ab6e-4b36-89e3-b23bc0a1dacc"],
    "IContactLocationFieldFactory": ["f79932d7-2fdf-43fe-8f18-41897390bcfe"],
    "IContactManager": ["ad553d98-deb1-474a-8e17-fc0c2075b738"],
    "IContactManagerForUser": ["b74bba57-1076-4bef-aef3-54686d18387d"],
    "IContactManagerForUser2": ["4d469c2e-3b75-4a73-bb30-736645472256"],
    "IContactManagerInterop": ["99eacba7-e073-43b6-a896-55afe48a0833"],
    "IContactManagerStatics": ["81f21ac0-f661-4708-ba4f-d386bd0d622e"],
    "IContactManagerStatics2": ["a178e620-47d8-48cc-963c-9592b6e510c6"],
    "IContactManagerStatics3": ["c4cc3d42-7586-492a-930b-7bc138fc2139"],
    "IContactManagerStatics4": ["24982272-347b-46dc-8d95-51bd41e15aaf"],
    "IContactManagerStatics5": ["f7591a87-acb7-4fad-90f2-a8ab64cdbba4"],
    "IContactMapActivatedEventArgs": ["b32bf870-eee7-4ad2-aaf1-a87effcf00a4"],
    "IContactMarshal": ["28072958-925d-11e2-9952-b4b52fe06527"],
    "IContactMatchReason": ["bc922504-e7d8-413e-95f4-b75c54c74077"],
    "IContactMessageActivatedEventArgs": ["de598db2-0e03-43b0-bf56-bcc40b3162df"],
    "IContactName": ["f404e97b-9034-453c-8ebf-140a38c86f1d"],
    "IContactPanel": ["41bf1265-d2ee-4b97-a80a-7d8d64cca6f5"],
    "IContactPanelActivatedEventArgs": ["52bb63e4-d3d4-4b63-8051-4af2082cab80"],
    "IContactPanelClosingEventArgs": ["222174d3-cf4b-46d7-b739-6edc16110bfb"],
    "IContactPanelLaunchFullAppRequestedEventArgs": ["88d61c0e-23b4-4be8-8afc-072c25a4190d"],
    "IContactPhone": ["467dab65-2712-4f52-b783-9ea8111c63cd"],
    "IContactPhoneMarshal": ["28072952-925d-11e2-9952-b4b52fe06527"],
    "IContactPicker": ["0e09fd91-42f8-4055-90a0-896f96738936"],
    "IContactPicker2": ["b35011cf-5cef-4d24-aa0c-340c5208725d"],
    "IContactPicker3": ["0e723315-b243-4bed-8516-22b1a7ac0ace"],
    "IContactPickerActivatedEventArgs": ["ce57aae7-6449-45a7-971f-d113be7a8936"],
    "IContactPickerStatics": ["7488c029-6a53-4258-a3e9-62dff6784b6c"],
    "IContactPickerUI": ["e2cc1366-cf66-43c4-a96a-a5a112db4746"],
    "IContactPickerUI2": ["6e449e28-7b25-4999-9b0b-875400a1e8c8"],
    "IContactPostActivatedEventArgs": ["b35a3c67-f1e7-4655-ad6e-4857588f552f"],
    "IContactProperties": ["70dd27dd-5cbd-46e8-bef0-23b6b346288f"],
    "IContactPropertyCollection": ["ffd3adf8-fa64-4328-b1b6-2e0db509cb3c"],
    "IContactQueryOptions": ["4408cc9e-7d7c-42f0-8ac7-f50733ecdbc1"],
    "IContactQueryOptionsFactory": ["543fba47-8ce7-46cb-9dac-9aa42a1bc8e2"],
    "IContactQueryTextSearch": ["f7e3f9cb-a957-439b-a0b7-1c02a1963ff0"],
    "IContactReader": ["d397e42e-1488-42f2-bf64-253f4884bfed"],
    "IContactRemovedEventArgs": ["6f354338-3302-4d13-ad8d-adcc0ff9e47c"],
    "IContactSignificantOther": ["8873b5ab-c5fb-46d8-93fe-da3ff1934054"],
    "IContactSignificantOther2": ["8d7bd474-3f03-45f8-ba0f-c4ed37d64219"],
    "IContactSignificantOtherMarshal": ["28072951-925d-11e2-9952-b4b52fe06527"],
    "IContactStore": ["2c220b10-3a6c-4293-b9bc-fe987f6e0d52"],
    "IContactStore2": ["18ce1c22-ebd5-4bfb-b690-5f4f27c4f0e8"],
    "IContactStore3": ["cb882c6c-004e-4050-87f0-840407ee6818"],
    "IContactStoreNotificationTrigger": ["c833419b-4705-4571-9a16-06b997bf9c96"],
    "IContactStoreNotificationTriggerDetails": ["abb298d6-878a-4f8b-a9ce-46bb7d1c84ce"],
    "IContactVideoCallActivatedEventArgs": ["61079db8-e3e7-4b4f-858d-5c63a96ef684"],
    "IContactWebsite": ["9f130176-dc1b-4055-ad66-652f39d990e8"],
    "IContactWebsite2": ["f87ee91e-5647-4068-bb5e-4b6f437ce308"],
    "IContactWebsiteMarshal": ["28072950-925d-11e2-9952-b4b52fe06527"],
    "IContactsHelper": ["289e924c-9fa1-4b1f-b8ae-a8b7ad9d74a7"],
    "IContactsProviderActivatedEventArgs": ["4580dca8-5750-4916-aa52-c0829521eb94"],
    "IContainerActivationHelper": ["b524f93f-80d5-4ec7-ae9e-d66e93ade1fa"],
    "IContainerContentChangingEventArgs": ["07deeaa7-018f-4dda-b399-fd4e13a31bea"],
    "IContainerEncodingProperties": ["59ac2a57-b32a-479e-8a61-4b7f2e9e7ea0"],
    "IContainerEncodingProperties2": ["b272c029-ae26-4819-baad-ad7a49b0a876"],
    "IContainerVisual": ["02f6bc74-ed20-4773-afe6-d49b4a93db32"],
    "IContainerVisualFactory": ["0363a65b-c7da-4d9a-95f4-69b5c8df670b"],
    "IContainsDeletedItems": ["7ffb5080-d7ea-42d9-8ee4-a5dd03fe0ec6"],
    "IContentBlock": ["d8619504-d70e-4717-9bfb-4e62ee02eb5d"],
    "IContentControl": ["a26dd1dc-cd44-435c-be94-01d6241c231c"],
    "IContentControl2": ["652c208c-8ccf-4399-bd3e-5a015aa1bc03"],
    "IContentControlFactory": ["ab017b19-196e-4ed5-a27f-55c58fb1673f"],
    "IContentControlOverrides": ["5f4c0b10-e38e-4b5d-be1a-5ed04246a635"],
    "IContentControlStatics": ["116982a4-5cf5-4c05-a53f-15e4876c85ec"],
    "IContentDialog": ["38dc4404-d24e-40d8-9415-349464c1afdc"],
    "IContentDialog2": ["2f93eb45-ee43-4303-9b38-3fe1a111ecbf"],
    "IContentDialog3": ["9d9a089e-f954-4ede-b07f-6b069a9c0180"],
    "IContentDialogButtonClickDeferral": ["bd0d3637-19ce-4946-8e77-bd03fe8ebe03"],
    "IContentDialogButtonClickEventArgs": ["5f34c205-8afa-4cf2-8ca0-264d73bed63d"],
    "IContentDialogClosedEventArgs": ["905522ef-2cba-4af8-b666-cc36c22732fb"],
    "IContentDialogClosingDeferral": ["215d4d11-7e30-4cb9-a710-5a4f9cca8b42"],
    "IContentDialogClosingEventArgs": ["db3c1c34-3bbf-47d4-be4f-c9ec115918b9"],
    "IContentDialogFactory": ["05557178-9d8e-4315-b37d-680c14012c35"],
    "IContentDialogOpenedEventArgs": ["0966b315-5f59-4999-9e3e-374c0f174b04"],
    "IContentDialogStatics": ["23ab47a6-508a-4f33-b786-f2fa96d869af"],
    "IContentDialogStatics2": ["329825b2-8fb0-4125-bb07-e79a5a03819f"],
    "IContentIndexer": ["b1767f8d-f698-4982-b05f-3a6e8cab01a2"],
    "IContentIndexerQuery": ["70e3b0f8-4bfc-428a-8889-cc51da9a7b9d"],
    "IContentIndexerQueryOperations": ["28823e10-4786-42f1-9730-792b3566b150"],
    "IContentIndexerStatics": ["8c488375-b37e-4c60-9ba8-b760fda3e59d"],
    "IContentLink": ["6c60c3e1-528c-42f8-92be-34b8c68be304"],
    "IContentLinkChangedEventArgs": ["64f3f1de-89fb-4b77-8b9b-191b6d19290a"],
    "IContentLinkInfo": ["1ed52525-1c5f-48cb-b335-78b50a2ee642"],
    "IContentLinkInvokedEventArgs": ["546717c1-e8df-4593-9639-97595fdf8310"],
    "IContentLinkProvider": ["730587fd-bfdc-4cb3-904d-b65ab339bbf5"],
    "IContentLinkProviderCollection": ["f5b84d0c-a9f4-4d1a-a13c-10def1843734"],
    "IContentLinkProviderFactory": ["57d60d3b-ef1a-4e8e-839b-d36ef3a503e0"],
    "IContentLinkStatics": ["a34e3063-eb16-484e-a3df-522b9a832e6e"],
    "IContentPrefetchTrigger": ["710627ee-04fa-440b-80c0-173202199e5d"],
    "IContentPrefetchTriggerFactory": ["c2643eda-8a03-409e-b8c4-88814c28ccb6"],
    "IContentPrefetcher": ["a8d6f754-7dc1-4cd9-8810-2a6aa9417e11"],
    "IContentPrefetcherTaskTrigger": ["1b35a14a-6094-4799-a60e-e474e15d4dc9"],
    "IContentPrefetcherTime": ["e361fd08-132a-4fde-a7cc-fcb0e66523af"],
    "IContentPresenter": ["79fde5b4-cd37-491c-8845-daf472defff6"],
    "IContentPresenter2": ["5138e958-335d-4210-8bbb-0aa2b4b5c29e"],
    "IContentPresenter3": ["b038876a-9c4d-4402-ac56-a223487dc6c8"],
    "IContentPresenter4": ["997b1b17-3bf8-432b-8fd9-68c7bab21f9d"],
    "IContentPresenter5": ["d248970c-b785-5e7f-9c11-8a6cd3d5929b"],
    "IContentPresenterFactory": ["3339d4f7-4815-44c4-9f76-68c83880ef10"],
    "IContentPresenterOverrides": ["a76339ed-32ff-438b-aad5-1d68fae93426"],
    "IContentPresenterStatics": ["18c2893b-da2e-4426-b85a-2c7e2171bedf"],
    "IContentPresenterStatics2": ["c7d89dd9-06e6-46be-a8a0-9c117d3024a3"],
    "IContentPresenterStatics3": ["cbe6cf5b-38b1-4d5d-b098-bc94b35c8ddf"],
    "IContentPresenterStatics4": ["ff8be292-af28-47eb-a5c3-dc44ced40fd2"],
    "IContentPresenterStatics5": ["169e700f-e8e6-5f6a-b97e-7ef8f7006f49"],
    "IContentRestrictionsBrowsePolicy": ["8c0133a4-442e-461a-8757-fad2f5bd37e4"],
    "IContentThemeTransition": ["f66fc5c3-5915-437d-8e3b-adf8e7f0ab57"],
    "IContentThemeTransitionStatics": ["0e8ee385-9a42-4459-afa9-337dc41e1587"],
    "IContentTypeProvider": ["97d098a5-3b99-4de9-88a5-e11d2f50c795"],
    "IContextMarshaler": ["000001d8-0000-0000-c000-000000000046"],
    "IContextMenuCB": ["3409e930-5a39-11d1-83fa-00a0c90dc849"],
    "IContextMenuEventArgs": ["1f7df263-c14b-4528-b6f0-637999d83cc6"],
    "IContextMenuFactory": ["47d9e2b2-cbb3-4fe3-a925-f49978685982"],
    "IContextMenuForProgInvoke": ["649e2263-dc09-466f-9d66-3eb133ee8f81"],
    "IContextMenuOpeningEventHandler": ["df945151-745c-4446-b2fc-216d765847a0"],
    "IContextNotify": ["15f936f5-a3fa-11d2-aec3-00c04f79d1eb"],
    "IContextRegisterNotify": ["15f936f6-a3fa-11d2-aec3-00c04f79d1eb"],
    "IContextRequestedEventArgs": ["42618e0a-1cb6-46fb-8374-0aec68aa5e51"],
    "IContextSecurityPerimeter": ["a7549a29-a7c4-42e1-8dc1-7e3d748dc24a"],
    "IContextTransactionInfo": ["7d40fcc8-f81e-462e-bba1-8a99ebdc826c"],
    "IContinuationActivatedEventArgs": ["e58106b5-155f-4a94-a742-c7e08f4e188c"],
    "IContinuumNavigationTransitionInfo": ["4be1dbad-8ba6-4004-8438-8a9017978543"],
    "IContinuumNavigationTransitionInfoStatics": ["3e25dd53-b18f-4bf1-b3bc-92f516f29903"],
    "IContractActivation": ["85a098aa-ef5a-451b-b332-c1b795431bc3"],
    "IContractBrokerGetStream": ["4bb67095-515f-4e53-b6bb-ddeb70df3cc4"],
    "IContractBrokerGetStreamReadyEvent": ["c218afae-7884-4151-873f-631e82388d0d"],
    "IContractBrokerHandleMarshal": ["ca20a226-daaa-4093-813a-f639ee1eaf18"],
    "IControl2": ["43e0fe10-14ec-427e-8c57-dee60df60aa8"],
    "IControl3": ["077b29e4-dade-4f55-9b96-09e21b28eb1c"],
    "IControl4": ["0e18aeee-5f2e-44ea-8513-d3875c0a7513"],
    "IControl5": ["5ebb51d5-9e58-49b7-bc2d-0155ff118664"],
    "IControl7": ["3550dbe1-e561-5934-a3ef-7db8bf6e3b45"],
    "IControlChangeDelegate": ["dc73b98f-ac0d-4e1e-b9fe-13f6378b1219"],
    "IControlChangeNotify": ["a09513ed-c709-4d21-bd7b-5f34c47f3947"],
    "IControlChannelTrigger": ["7d1431a7-ee96-40e8-a199-8703cd969ec3"],
    "IControlChannelTrigger2": ["af00d237-51be-4514-9725-3556e1879580"],
    "IControlChannelTriggerEventDetails": ["1b36e047-89bb-4236-96ac-71d012bb4869"],
    "IControlChannelTriggerFactory": ["da4b7cf0-8d71-446f-88c3-b95184a2d6cd"],
    "IControlChannelTriggerResetEventDetails": ["6851038e-8ec4-42fe-9bb2-21e91b7bfcb1"],
    "IControlEvents": ["9a4bbf53-4e46-101b-8bbd-00aa003e3b29"],
    "IControlFactory": ["b12b1d5a-6419-4e16-b212-a45336b75778"],
    "IControlInterface": ["45d37c3f-5140-444a-ae24-400789f3cbf3"],
    "IControlMarkup": ["d6d2fbae-f116-458c-8c34-03569877a2d2"],
    "IControlOverrides": ["a09691df-9824-41fe-b530-b0d8990e64c1"],
    "IControlOverrides6": ["e194c96a-d8cc-4339-a0e1-2e9c420879ec"],
    "IControlPanelGrepEnumerator": ["f93f9470-36a7-4a92-afdb-aed751464f32"],
    "IControlPanelNavPaneProvider": ["9c708890-41f3-43f2-98d7-b610256ed61c"],
    "IControlPanelPrivate": ["f11cbea6-468c-4247-9726-6c75dcd1604c"],
    "IControlProtected": ["1791587a-2a7c-4981-a2d8-ab99fffc65b9"],
    "IControlStatics": ["473b305b-877d-4c35-8fca-46a05f96607a"],
    "IControlStatics2": ["32233e36-ab74-4a25-a556-45293135b2c5"],
    "IControlStatics3": ["aad15e61-e4b9-4d72-b653-934149aa5003"],
    "IControlStatics4": ["59fda728-c05a-4ec2-8a4b-06ad69b66e15"],
    "IControlStatics5": ["f635b5a3-ef8e-404f-877b-5580473710a6"],
    "IControlStatics7": ["aee1ca45-c910-5dab-a266-fdf50c0bedd2"],
    "IControlTemplate": ["efd2418e-41e0-48bb-8b82-91eda1ba3fe2"],
    "IControls": ["c8a3dc00-8593-11d1-b16a-00c0f0283628"],
    "IConversationalAgentDetectorManager": ["de94fbb0-597a-5df8-8cfb-9dbb583ba3ff"],
    "IConversationalAgentDetectorManagerStatics": ["36a8d283-fa0e-5693-8489-0fb2f0ab40d3"],
    "IConversationalAgentSession": ["daaae09a-b7ba-57e5-ad13-df520f9b6fa7"],
    "IConversationalAgentSessionInterruptedEventArgs": ["9766591f-f63d-5d3e-9bf2-bd0760552686"],
    "IConversationalAgentSessionStatics": ["a005166e-e954-576e-be04-11b8ed10f37b"],
    "IConversationalAgentSignal": ["20ed25f7-b120-51f2-8603-265d6a47f232"],
    "IConversationalAgentSignalDetectedEventArgs": ["4d57eb8f-f88a-599b-91d3-d604876708bc"],
    "IConversationalAgentSystemStateChangedEventArgs": ["1c2c6e3e-2785-59a7-8e71-38adeef79928"],
    "IConvertToSidString": ["6dac21b6-e2ce-45b1-aeb7-afea6ada2977"],
    "IConvertType": ["0c733a88-2a1c-11ce-ade5-00aa0044773d"],
    "ICookieJarRecoveryData": ["8fd276bb-5a9d-4fc0-b0bd-90fa7cf1283d"],
    "ICookieJarSessionData": ["4dd0da1f-9587-448c-b960-5148806cc7a0"],
    "ICopyHookA": ["000214ef-0000-0000-c000-000000000046"],
    "ICopyHookW": ["000214fc-0000-0000-c000-000000000046"],
    "ICorConfiguration": ["5c2b07a5-1e98-11d3-872f-00c04f79ed0d"],
    "ICorDebug": ["3d6f5f61-7538-11d3-8d5b-00104b35e7ef"],
    "ICorDebug2": ["eccccf2e-b286-4b3e-a983-860a8793d105"],
    "ICorDebugAppDomain": ["3d6f5f63-7538-11d3-8d5b-00104b35e7ef"],
    "ICorDebugAppDomain2": ["096e81d5-ecda-4202-83f5-c65980a9ef75"],
    "ICorDebugAppDomain3": ["8cb96a16-b588-42e2-b71c-dd849fc2eccc"],
    "ICorDebugAppDomain4": ["fb99cc40-83be-4724-ab3b-768e796ebac2"],
    "ICorDebugAppDomainEnum": ["63ca1b24-4359-4883-bd57-13f815f58744"],
    "ICorDebugArrayValue": ["0405b0df-a660-11d2-bd02-0000f80849bd"],
    "ICorDebugAssembly": ["df59507c-d47a-459e-bce2-6427eac8fd06"],
    "ICorDebugAssembly2": ["426d1f9e-6dd4-44c8-aec7-26cdbaf4e398"],
    "ICorDebugAssembly3": ["76361ab2-8c86-4fe9-96f2-f73d8843570a"],
    "ICorDebugAssemblyEnum": ["4a2a1ec9-85ec-4bfb-9f15-a89fdfe0fe83"],
    "ICorDebugBlockingObjectEnum": ["976a6278-134a-4a81-81a3-8f277943f4c3"],
    "ICorDebugBoxValue": ["cc7bcafc-8a68-11d2-983c-0000f808342d"],
    "ICorDebugBreakpoint": ["cc7bcae8-8a68-11d2-983c-0000f808342d"],
    "ICorDebugBreakpointEnum": ["cc7bcb03-8a68-11d2-983c-0000f808342d"],
    "ICorDebugChain": ["cc7bcaee-8a68-11d2-983c-0000f808342d"],
    "ICorDebugChainEnum": ["cc7bcb08-8a68-11d2-983c-0000f808342d"],
    "ICorDebugClass": ["cc7bcaf5-8a68-11d2-983c-0000f808342d"],
    "ICorDebugClass2": ["b008ea8d-7ab1-43f7-bb20-fbb5a04038ae"],
    "ICorDebugCode": ["cc7bcaf4-8a68-11d2-983c-0000f808342d"],
    "ICorDebugCode2": ["5f696509-452f-4436-a3fe-4d11fe7e2347"],
    "ICorDebugCode3": ["d13d3e88-e1f2-4020-aa1d-3d162dcbe966"],
    "ICorDebugCode4": ["18221fa4-20cb-40fa-b19d-9f91c4fa8c14"],
    "ICorDebugCodeEnum": ["55e96461-9645-45e4-a2ff-0367877abcde"],
    "ICorDebugComObjectValue": ["5f69c5e5-3e12-42df-b371-f9d761d6ee24"],
    "ICorDebugContext": ["cc7bcb00-8a68-11d2-983c-0000f808342d"],
    "ICorDebugController": ["3d6f5f62-7538-11d3-8d5b-00104b35e7ef"],
    "ICorDebugDataTarget": ["fe06dc28-49fb-4636-a4a3-e80db4ae116c"],
    "ICorDebugDataTarget2": ["2eb364da-605b-4e8d-b333-3394c4828d41"],
    "ICorDebugDataTarget3": ["d05e60c3-848c-4e7d-894e-623320ff6afa"],
    "ICorDebugDebugEvent": ["41bd395d-de99-48f1-bf7a-cc0f44a6d281"],
    "ICorDebugEditAndContinueErrorInfo": ["8d600d41-f4f6-4cb3-b7ec-7bd164944036"],
    "ICorDebugEditAndContinueSnapshot": ["6dc3fa01-d7cb-11d2-8a95-0080c792e5d8"],
    "ICorDebugEnum": ["cc7bcb01-8a68-11d2-983c-0000f808342d"],
    "ICorDebugErrorInfoEnum": ["f0e18809-72b5-11d2-976f-00a0c9b4d50c"],
    "ICorDebugEval": ["cc7bcaf6-8a68-11d2-983c-0000f808342d"],
    "ICorDebugEval2": ["fb0d9ce7-be66-4683-9d32-a42a04e2fd91"],
    "ICorDebugExceptionDebugEvent": ["af79ec94-4752-419c-a626-5fb1cc1a5ab7"],
    "ICorDebugExceptionObjectCallStackEnum": ["ed775530-4dc4-41f7-86d0-9e2def7dfc66"],
    "ICorDebugExceptionObjectValue": ["ae4ca65d-59dd-42a2-83a5-57e8a08d8719"],
    "ICorDebugFrame": ["cc7bcaef-8a68-11d2-983c-0000f808342d"],
    "ICorDebugFrameEnum": ["cc7bcb07-8a68-11d2-983c-0000f808342d"],
    "ICorDebugFunction": ["cc7bcaf3-8a68-11d2-983c-0000f808342d"],
    "ICorDebugFunction2": ["ef0c490b-94c3-4e4d-b629-ddc134c532d8"],
    "ICorDebugFunction3": ["09b70f28-e465-482d-99e0-81a165eb0532"],
    "ICorDebugFunctionBreakpoint": ["cc7bcae9-8a68-11d2-983c-0000f808342d"],
    "ICorDebugGCReferenceEnum": ["7f3c24d3-7e1d-4245-ac3a-f72f8859c80c"],
    "ICorDebugGenericValue": ["cc7bcaf8-8a68-11d2-983c-0000f808342d"],
    "ICorDebugGuidToTypeEnum": ["6164d242-1015-4bd6-8cbe-d0dbd4b8275a"],
    "ICorDebugHandleValue": ["029596e8-276b-46a1-9821-732e96bbb00b"],
    "ICorDebugHeapEnum": ["76d7dab8-d044-11df-9a15-7e29dfd72085"],
    "ICorDebugHeapSegmentEnum": ["a2fa0f8e-d045-11df-ac8e-ce2adfd72085"],
    "ICorDebugHeapValue": ["cc7bcafa-8a68-11d2-983c-0000f808342d"],
    "ICorDebugHeapValue2": ["e3ac4d6c-9cb7-43e6-96cc-b21540e5083c"],
    "ICorDebugHeapValue3": ["a69acad8-2374-46e9-9ff8-b1f14120d296"],
    "ICorDebugILCode": ["598d46c2-c877-42a7-89d2-3d0c7f1c1264"],
    "ICorDebugILCode2": ["46586093-d3f5-4db6-acdb-955bce228c15"],
    "ICorDebugILFrame": ["03e26311-4f76-11d3-88c6-006097945418"],
    "ICorDebugILFrame2": ["5d88a994-6c30-479b-890f-bcef88b129a5"],
    "ICorDebugILFrame3": ["9a9e2ed6-04df-4fe0-bb50-cab64126ad24"],
    "ICorDebugILFrame4": ["ad914a30-c6d1-4ac5-9c5e-577f3baa8a45"],
    "ICorDebugInstanceFieldSymbol": ["a074096b-3adc-4485-81da-68c7a4ea52db"],
    "ICorDebugInternalFrame": ["b92cc7f7-9d2d-45c4-bc2b-621fcc9dfbf4"],
    "ICorDebugInternalFrame2": ["c0815bdc-cfab-447e-a779-c116b454eb5b"],
    "ICorDebugLoadedModule": ["817f343a-6630-4578-96c5-d11bc0ec5ee2"],
    "ICorDebugMDA": ["cc726f2f-1db7-459b-b0ec-05f01d841b42"],
    "ICorDebugManagedCallback": ["3d6f5f60-7538-11d3-8d5b-00104b35e7ef"],
    "ICorDebugManagedCallback2": ["250e5eea-db5c-4c76-b6f3-8c46f12e3203"],
    "ICorDebugManagedCallback3": ["264ea0fc-2591-49aa-868e-835e6515323f"],
    "ICorDebugMemoryBuffer": ["677888b3-d160-4b8c-a73b-d79e6aaa1d13"],
    "ICorDebugMergedAssemblyRecord": ["faa8637b-3bbe-4671-8e26-3b59875b922a"],
    "ICorDebugMetaDataLocator": ["7cef8ba9-2ef7-42bf-973f-4171474f87d9"],
    "ICorDebugModule": ["dba2d8c1-e5c5-4069-8c13-10a7c6abf43d"],
    "ICorDebugModule2": ["7fcc5fb5-49c0-41de-9938-3b88b5b9add7"],
    "ICorDebugModule3": ["86f012bf-ff15-4372-bd30-b6f11caae1dd"],
    "ICorDebugModuleBreakpoint": ["cc7bcaea-8a68-11d2-983c-0000f808342d"],
    "ICorDebugModuleDebugEvent": ["51a15e8d-9fff-4864-9b87-f4fbdea747a2"],
    "ICorDebugModuleEnum": ["cc7bcb09-8a68-11d2-983c-0000f808342d"],
    "ICorDebugMutableDataTarget": ["a1b8a756-3cb6-4ccb-979f-3df999673a59"],
    "ICorDebugNativeFrame": ["03e26314-4f76-11d3-88c6-006097945418"],
    "ICorDebugNativeFrame2": ["35389ff1-3684-4c55-a2ee-210f26c60e5e"],
    "ICorDebugObjectEnum": ["cc7bcb02-8a68-11d2-983c-0000f808342d"],
    "ICorDebugObjectValue": ["18ad3d6e-b7d2-11d2-bd04-0000f80849bd"],
    "ICorDebugObjectValue2": ["49e4a320-4a9b-4eca-b105-229fb7d5009f"],
    "ICorDebugProcess": ["3d6f5f64-7538-11d3-8d5b-00104b35e7ef"],
    "ICorDebugProcess2": ["ad1b3588-0ef0-4744-a496-aa09a9f80371"],
    "ICorDebugProcess3": ["2ee06488-c0d4-42b1-b26d-f3795ef606fb"],
    "ICorDebugProcess5": ["21e9d9c0-fcb8-11df-8cff-0800200c9a66"],
    "ICorDebugProcess6": ["11588775-7205-4ceb-a41a-93753c3153e9"],
    "ICorDebugProcess7": ["9b2c54e4-119f-4d6f-b402-527603266d69"],
    "ICorDebugProcess8": ["2e6f28c1-85eb-4141-80ad-0a90944b9639"],
    "ICorDebugProcessEnum": ["cc7bcb05-8a68-11d2-983c-0000f808342d"],
    "ICorDebugReferenceValue": ["cc7bcaf9-8a68-11d2-983c-0000f808342d"],
    "ICorDebugRegisterSet": ["cc7bcb0b-8a68-11d2-983c-0000f808342d"],
    "ICorDebugRegisterSet2": ["6dc7ba3f-89ba-4459-9ec1-9d60937b468d"],
    "ICorDebugRemote": ["d5ebb8e2-7bbe-4c1d-98a6-a3c04cbdef64"],
    "ICorDebugRemoteTarget": ["c3ed8383-5a49-4cf5-b4b7-01864d9e582d"],
    "ICorDebugRuntimeUnwindableFrame": ["879cac0a-4a53-4668-b8e3-cb8473cb187f"],
    "ICorDebugStackWalk": ["a0647de9-55de-4816-929c-385271c64cf7"],
    "ICorDebugStaticFieldSymbol": ["cbf9da63-f68d-4bbb-a21c-15a45eaadf5b"],
    "ICorDebugStepper": ["cc7bcaec-8a68-11d2-983c-0000f808342d"],
    "ICorDebugStepper2": ["c5b6e9c3-e7d1-4a8e-873b-7f047f0706f7"],
    "ICorDebugStepperEnum": ["cc7bcb04-8a68-11d2-983c-0000f808342d"],
    "ICorDebugStringValue": ["cc7bcafd-8a68-11d2-983c-0000f808342d"],
    "ICorDebugSymbolProvider": ["3948a999-fd8a-4c38-a708-8a71e9b04dbb"],
    "ICorDebugSymbolProvider2": ["f9801807-4764-4330-9e67-4f685094165e"],
    "ICorDebugThread": ["938c6d66-7fb6-4f69-b389-425b8987329b"],
    "ICorDebugThread2": ["2bd956d9-7b07-4bef-8a98-12aa862417c5"],
    "ICorDebugThread3": ["f8544ec3-5e4e-46c7-8d3e-a52b8405b1f5"],
    "ICorDebugThread4": ["1a1f204b-1c66-4637-823f-3ee6c744a69c"],
    "ICorDebugThreadEnum": ["cc7bcb06-8a68-11d2-983c-0000f808342d"],
    "ICorDebugType": ["d613f0bb-ace1-4c19-bd72-e4c08d5da7f5"],
    "ICorDebugType2": ["e6e91d79-693d-48bc-b417-8284b4f10fb5"],
    "ICorDebugTypeEnum": ["10f27499-9df2-43ce-8333-a321d7c99cb4"],
    "ICorDebugUnmanagedCallback": ["5263e909-8cb5-11d3-bd2f-0000f80849bd"],
    "ICorDebugValue": ["cc7bcaf7-8a68-11d2-983c-0000f808342d"],
    "ICorDebugValue2": ["5e0b54e7-d88a-4626-9420-a691e0a78b49"],
    "ICorDebugValue3": ["565005fc-0f8a-4f3e-9edb-83102b156595"],
    "ICorDebugValueBreakpoint": ["cc7bcaeb-8a68-11d2-983c-0000f808342d"],
    "ICorDebugValueEnum": ["cc7bcb0a-8a68-11d2-983c-0000f808342d"],
    "ICorDebugVariableHome": ["50847b8d-f43f-41b0-924c-6383a5f2278b"],
    "ICorDebugVariableHomeEnum": ["e76b7a57-4f7a-4309-85a7-5d918c3deaf7"],
    "ICorDebugVariableSymbol": ["707e8932-1163-48d9-8a93-f5b1f480fbb7"],
    "ICorDebugVirtualUnwinder": ["f69126b7-c787-4f6b-ae96-a569786fc670"],
    "ICorProfilerAssemblyReferenceProvider": ["66a78c24-2eef-4f65-b45f-dd1d8038bf3c"],
    "ICorProfilerCallback": ["176fbed1-a55c-4796-98ca-a9da0ef883e7"],
    "ICorProfilerCallback2": ["8a8cc829-ccf2-49fe-bbae-0f022228071a"],
    "ICorProfilerCallback3": ["4fd2ed52-7731-4b8d-9469-03d2cc3086c5"],
    "ICorProfilerCallback4": ["7b63b2e3-107d-4d48-b2f6-f61e229470d2"],
    "ICorProfilerCallback5": ["8dfba405-8c9f-45f8-bffa-83b14cef78b5"],
    "ICorProfilerCallback6": ["fc13df4b-4448-4f4f-950c-ba8d19d00c36"],
    "ICorProfilerCallback7": ["f76a2dba-1d52-4539-866c-2aa518f9efc3"],
    "ICorProfilerCallback8": ["5bed9b15-c079-4d47-bfe2-215a140c07e0"],
    "ICorProfilerCallback9": ["27583ec3-c8f5-482f-8052-194b8ce4705a"],
    "ICorProfilerFunctionControl": ["f0963021-e1ea-4732-8581-e01b0bd3c0c6"],
    "ICorProfilerFunctionEnum": ["ff71301a-b994-429d-a10b-b345a65280ef"],
    "ICorProfilerInfo": ["28b5557d-3f3f-48b4-90b2-5f9eea2f6c48"],
    "ICorProfilerInfo2": ["cc0935cd-a518-487d-b0bb-a93214e65478"],
    "ICorProfilerInfo3": ["b555ed4f-452a-4e54-8b39-b5360bad32a0"],
    "ICorProfilerInfo4": ["0d8fdcaa-6257-47bf-b1bf-94dac88466ee"],
    "ICorProfilerInfo5": ["07602928-ce38-4b83-81e7-74adaf781214"],
    "ICorProfilerInfo6": ["f30a070d-bffb-46a7-b1d8-8781ef7b698a"],
    "ICorProfilerInfo7": ["9aeecc0d-63e0-4187-8c00-e312f503f663"],
    "ICorProfilerInfo8": ["c5ac80a6-782e-4716-8044-39598c60cfbf"],
    "ICorProfilerMethodEnum": ["fccee788-0088-454b-a811-c99f298d1942"],
    "ICorProfilerModuleEnum": ["b0266d75-2081-4493-af7f-028ba34db891"],
    "ICorProfilerObjectEnum": ["2c6269bd-2d13-4321-ae12-6686365fd6af"],
    "ICorProfilerThreadEnum": ["571194f7-25ed-419f-aa8b-7016b3159701"],
    "ICorPublish": ["9613a0e7-5a68-11d3-8f84-00a0c9b4d50c"],
    "ICorPublishAppDomain": ["d6315c8f-5a6a-11d3-8f84-00a0c9b4d50c"],
    "ICorPublishAppDomainEnum": ["9f0c98f5-5a6a-11d3-8f84-00a0c9b4d50c"],
    "ICorPublishEnum": ["c0b22967-5a69-11d3-8f84-00a0c9b4d50c"],
    "ICorPublishProcess": ["18d87af1-5a6a-11d3-8f84-00a0c9b4d50c"],
    "ICorPublishProcessEnum": ["a37fbd41-5a69-11d3-8f84-00a0c9b4d50c"],
    "ICorRuntimeHost": ["cb2f6722-ab3a-11d2-9c40-00c04fa30a3e"],
    "ICorSvc": ["3eef5ff0-3680-4f20-8a8f-9051aca66b22"],
    "ICorSvcManager": ["8f416a48-d663-4a7e-9732-fbca3fc46ea8"],
    "ICorThreadpool": ["84680d3a-b2c1-46e8-acc2-dbc0a359159a"],
    "ICoreAcceleratorKeys": ["9ffdf7f5-b8c9-4ef0-b7d2-1de626561fc8"],
    "ICoreAppWindowPreview": ["a4f6e665-365e-5fde-87a5-9543c3a15aa8"],
    "ICoreAppWindowPreviewStatics": ["33ac21be-423b-5db6-8a8e-4dc87353b75b"],
    "ICoreApplication": ["0aacf7a4-5e1d-49df-8034-fb6a68bc5ed1"],
    "ICoreApplication2": ["998681fb-1ab6-4b7f-be4a-9a0645224c04"],
    "ICoreApplication3": ["feec0d39-598b-4507-8a67-772632580a57"],
    "ICoreApplicationExit": ["cf86461d-261e-4b72-9acd-44ed2ace6a29"],
    "ICoreApplicationUnhandledError": ["f0e24ab0-dd09-42e1-b0bc-e0e131f78d7e"],
    "ICoreApplicationUseCount": ["518dc408-c077-475b-809e-0bc0c57e4b74"],
    "ICoreApplicationView": ["638bb2db-451d-4661-b099-414f34ffb9f1"],
    "ICoreApplicationView2": ["68eb7adf-917f-48eb-9aeb-7de53e086ab1"],
    "ICoreApplicationView3": ["07ebe1b3-a4cf-4550-ab70-b07e85330bc8"],
    "ICoreApplicationView5": ["2bc095a8-8ef0-446d-9e60-3a3e0428c671"],
    "ICoreApplicationView6": ["c119d49a-0679-49ba-803f-b79c5cf34cca"],
    "ICoreApplicationViewPrivate": ["42b83e6e-076b-4742-828c-173c723b1a81"],
    "ICoreApplicationViewTitleBar": ["006d35e3-e1f1-431b-9508-29b96926ac53"],
    "ICoreApplicationViewTitleBarInternal": ["72558910-08e1-49c4-90bd-d2c149d1c169"],
    "ICoreClosestInteractiveBoundsRequested": ["f303043a-e8bf-4e8e-ae69-c9dadd57a114"],
    "ICoreComponentFocusable": ["52f96fa3-8742-4411-ae69-79a85f29ac8b"],
    "ICoreCursor": ["96893acf-111d-442c-8a77-b87992f8e2d6"],
    "ICoreCursorFactory": ["f6359621-a79d-4ed3-8c32-a9ef9d6b76a4"],
    "ICoreDispatcher": ["60db2fa8-b705-4fde-a7d6-ebbb1891d39e"],
    "ICoreDispatcher2": ["6f5e63c7-e3aa-4eae-b0e0-dcf321ca4b2f"],
    "ICoreDispatcherWithTaskPriority": ["bafaecad-484d-41be-ba80-1d58c65263ea"],
    "ICoreDragDropManager": ["7d56d344-8464-4faf-aa49-37ea6e2d7bd1"],
    "ICoreDragDropManagerStatics": ["9542fdca-da12-4c1c-8d06-041db29733c3"],
    "ICoreDragInfo": ["48353a8b-cb50-464e-9575-cd4e3a7ab028"],
    "ICoreDragInfo2": ["c54691e5-e6fb-4d74-b4b1-8a3c17f25e9e"],
    "ICoreDragOperation": ["cc06de4f-6db0-4e62-ab1b-a74a02dc6d85"],
    "ICoreDragOperation2": ["824b1e2c-d99a-4fc3-8507-6c182f33b46a"],
    "ICoreDragUIOverride": ["89a85064-3389-4f4f-8897-7e8a3ffb3c93"],
    "ICoreDropOperationTarget": ["d9126196-4c5b-417d-bb37-76381def8db4"],
    "ICoreDropOperationTargetRequestedEventArgs": ["2aca929a-5e28-4ea6-829e-29134e665d6d"],
    "ICoreFragment": ["613b2ab5-b304-47d9-9c31-ce6c54401a15"],
    "ICoreFragmentInspector": ["f7fcc5fd-ae26-4679-ba16-96aac583c134"],
    "ICoreImmersiveApplication": ["1ada0e3e-e4a2-4123-b451-dc96bf800419"],
    "ICoreImmersiveApplication2": ["828e1e36-e9e3-4cfc-9b66-48b78ea9bb2c"],
    "ICoreImmersiveApplication3": ["34a05b2f-ee0d-41e5-8314-cf10c91bf0af"],
    "ICoreIncrementalInkStroke": ["fda015d3-9d66-4f7d-a57f-cc70b9cfaa76"],
    "ICoreIncrementalInkStrokeFactory": ["d7c59f46-8da8-4f70-9751-e53bb6df4596"],
    "ICoreInkIndependentInputSource": ["39b38da9-7639-4499-a5b5-191d00e35b16"],
    "ICoreInkIndependentInputSourceStatics": ["73e6011b-80c0-4dfb-9b66-10ba7f3f9c84"],
    "ICoreInkPresenterHost": ["396e89e6-7d55-4617-9e58-68c70c9169b9"],
    "ICoreInputInterop": ["40bfe3e3-b75a-4479-ac96-475365749bb8"],
    "ICoreInputSourceBase": ["9f488807-4580-4be8-be68-92a9311713bb"],
    "ICoreInputView": ["c770cd7a-7001-4c32-bf94-25c1f554cbf1"],
    "ICoreInputView2": ["0ed726c1-e09a-4ae8-aedf-dfa4857d1a01"],
    "ICoreInputView3": ["bc941653-3ab9-4849-8f58-46e7f0353cfc"],
    "ICoreInputView4": ["002863d6-d9ef-57eb-8cef-77f6ce1b7ee7"],
    "ICoreInputViewHidingEventArgs": ["eada47bd-bac5-5336-848d-41083584daad"],
    "ICoreInputViewOcclusion": ["cc36ce06-3865-4177-b5f5-8b65e0b9ce84"],
    "ICoreInputViewOcclusionsChangedEventArgs": ["be1027e8-b3ee-4df7-9554-89cdc66082c2"],
    "ICoreInputViewShowingEventArgs": ["ca52261b-fb9e-5daf-a98c-262b8b76af50"],
    "ICoreInputViewStatics": ["7d9b97cd-edbe-49cf-a54f-337de052907f"],
    "ICoreInputViewStatics2": ["7ebc0862-d049-4e52-87b0-1e90e98c49ed"],
    "ICoreInputViewTransferringXYFocusEventArgs": ["04de169f-ba02-4850-8b55-d82d03ba6d7f"],
    "ICoreKeyboardInputSource": ["231c9088-e469-4df1-b208-6e490d71cb90"],
    "ICoreKeyboardInputSource2": ["fa24cb94-f963-47a5-8778-207c482b0afd"],
    "ICorePerceptionAutomationStatics": ["0bb04541-4ce2-4923-9a76-8187ecc59112"],
    "ICorePointerInputSource": ["bbf1bb18-e47a-48eb-8807-f8f8d3ea4551"],
    "ICorePointerInputSource2": ["d703708a-4516-4786-b1e5-2751d563f997"],
    "ICorePointerRedirector": ["8f9d0c94-5688-4b0c-a9f1-f931f7fa3dc3"],
    "ICoreSelectionChangedEventArgs": ["c2941949-3955-4ec2-8f88-3f2bfc04d0f1"],
    "ICoreTextChangedEventArgs": ["7e3c9572-60e4-4feb-8683-4cf0e0fa7659"],
    "ICoreTextCompositionCompletedEventArgs": ["1f34ebb6-b79f-4121-a5e7-fda9b8616e30"],
    "ICoreTextCompositionSegment": ["776c6bd9-4ead-4da7-8f47-3a88b523cc34"],
    "ICoreTextCompositionStartedEventArgs": ["276b16a9-64e7-4ab0-bc4b-a02d73835bfb"],
    "ICoreTextEditContext": ["bf6608af-4041-47c3-b263-a918eb5eaef2"],
    "ICoreTextEditContext2": ["b1867dbb-083b-49e1-b281-2b35d62bf466"],
    "ICoreTextFormatUpdatingEventArgs": ["7310bd33-b4a8-43b1-b37b-0724d4aca7ab"],
    "ICoreTextLayoutBounds": ["e972c974-4436-4917-80d0-a525e4ca6780"],
    "ICoreTextLayoutRequest": ["2555a8cc-51fd-4f03-98bf-ac78174d68e0"],
    "ICoreTextLayoutRequest2": ["676de624-cd3d-4bcd-bf01-7f7110954511"],
    "ICoreTextLayoutRequestedEventArgs": ["b1dc6ae0-9a7b-4e9e-a566-4a6b5f8ad676"],
    "ICoreTextSelectionRequest": ["f0a70403-208b-4301-883c-74ca7485fd8d"],
    "ICoreTextSelectionRequestedEventArgs": ["13c6682b-f614-421a-8f4b-9ec8a5a37fcd"],
    "ICoreTextSelectionUpdatingEventArgs": ["d445839f-fe7f-4bd5-8a26-0922c1b3e639"],
    "ICoreTextServicesManager": ["c2507d83-6e0a-4a8a-bdf8-1948874854ba"],
    "ICoreTextServicesManagerStatics": ["1520a388-e2cf-4d65-aeb9-b32d86fe39b9"],
    "ICoreTextServicesStatics": ["91859a46-eccf-47a4-8ae7-098a9c6fbb15"],
    "ICoreTextTextRequest": ["50d950a9-f51e-4cc1-8ca1-e6346d1a61be"],
    "ICoreTextTextRequestedEventArgs": ["f096a2d0-41c6-4c02-8b1a-d953b00cabb3"],
    "ICoreTextTextUpdatingEventArgs": ["eea7918d-cc2b-4f03-8ff6-02fd217db450"],
    "ICoreTouchHitTesting": ["b1d8a289-3acf-4124-9fa3-ea8aba353c21"],
    "ICoreUserActivityManagerStatics": ["ca3adb02-a4be-4d4d-bfa8-6795f4264efb"],
    "ICoreWebViewPrivate": ["f26091c4-5805-4cc0-bcc9-0f078b86949d"],
    "ICoreWetStrokeUpdateEventArgs": ["fb07d14c-3380-457a-a987-991357896c1b"],
    "ICoreWetStrokeUpdateSource": ["1f718e22-ee52-4e00-8209-4c3e5b21a3cc"],
    "ICoreWetStrokeUpdateSourceStatics": ["3dad9cba-1d3d-46ae-ab9d-8647486c6f90"],
    "ICoreWindow": ["79b9d5f2-879e-4b89-b798-79e47598030c"],
    "ICoreWindow2": ["7c2b1b85-6917-4361-9c02-0d9e3a420b95"],
    "ICoreWindow3": ["32c20dd8-faef-4375-a2ab-32640e4815c7"],
    "ICoreWindow4": ["35caf0d0-47f0-436c-af97-0dd88f6f5f02"],
    "ICoreWindow5": ["4b4ae1e1-2e6d-4eaa-bda1-1c5cc1bee141"],
    "ICoreWindowAdapterInterop": ["7a5b6fd1-cd73-4b6c-9cf4-2e869eaf470a"],
    "ICoreWindowComponentInterop": ["0576ab31-a310-4c40-ba31-fd37e0298dfa"],
    "ICoreWindowComponentUIBridge": ["49a4b96a-169e-4d7f-8070-91ac8360ff5e"],
    "ICoreWindowDialog": ["e7392ce0-c78d-427e-8b2c-01ff420c69d5"],
    "ICoreWindowDialogFactory": ["cfb2a855-1c59-4b13-b1e5-16e29805f7c4"],
    "ICoreWindowEventArgs": ["272b1ef3-c633-4da5-a26c-c6d0f56b29da"],
    "ICoreWindowFactory": ["cd292360-2763-4085-8a9f-74b224a29175"],
    "ICoreWindowFactoryPriv": ["087ca5a4-8cfc-4264-b39d-da2bb2583a11"],
    "ICoreWindowFactoryPrivCallbackProvider": ["4208d435-b020-4346-ae40-2a4796084296"],
    "ICoreWindowFactoryPrivCallbackSink": ["91f0a4af-1ba8-461d-b57d-6d24d7c96a42"],
    "ICoreWindowFlyout": ["e89d854d-2050-40bb-b344-f6f355eeb314"],
    "ICoreWindowFlyoutFactory": ["dec4c6c4-93e8-4f7c-be27-cefaa1af68a7"],
    "ICoreWindowInterop": ["45d64a29-a63e-4cb6-b498-5781d298cb4f"],
    "ICoreWindowKeyboardInput": ["196b175e-1a33-4b17-9935-338ef6443477"],
    "ICoreWindowPopupShowingEventArgs": ["26155fa2-5ba5-4ea4-a3b4-2dc7d63c8e26"],
    "ICoreWindowResizeManager": ["b8f0b925-b350-48b3-a198-5c1a84700243"],
    "ICoreWindowResizeManagerLayoutCapability": ["bb74f27b-a544-4301-80e6-0ae033ef4536"],
    "ICoreWindowResizeManagerStatics": ["ae4a9045-6d70-49db-8e68-46ffbd17d38d"],
    "ICoreWindowStatic": ["4d239005-3c2a-41b1-9022-536bb9cf93b1"],
    "ICoreWindowWithContext": ["9ac40241-3575-4c3b-af66-e8c529d4d06c"],
    "ICornerRadiusHelper": ["fd7be182-1cdb-4288-b8c8-85ee79297bfc"],
    "ICornerRadiusHelperStatics": ["f4a1f659-d4d4-451f-a387-d6bf4b2451d4"],
    "ICorrelationEngine": ["a188440e-db11-45b8-b42c-b2149fa71453"],
    "ICorrelationVectorInformation": ["83c78b3c-d88b-4950-aa6e-22b8d22aabd3"],
    "ICorrelationVectorSource": ["152b8a3b-b9b9-4685-b56e-974847bc7545"],
    "ICortanaActionableInsights": ["951ec6b1-fc83-586d-8b84-2452c8981625"],
    "ICortanaActionableInsightsOptions": ["aac2bbcf-9782-5420-b81e-7ae56af31815"],
    "ICortanaActionableInsightsStatics": ["b5ded412-9d2f-5cb5-9b05-356a0b836c10"],
    "ICortanaExperienceFlow": ["37c30b2c-2c34-45bc-bb87-62126979a511"],
    "ICortanaPermissionsManager": ["191330e0-8695-438a-9545-3da4e822ddb4"],
    "ICortanaPermissionsManagerStatics": ["76b1e67a-b045-4414-9d6d-2ad3a5fe3a7e"],
    "ICortanaSettings": ["54d571a7-8062-40f4-abe7-dedfd697b019"],
    "ICortanaSettingsStatics": ["8b2ccd7e-2ec0-446d-9285-33f07ce8ac04"],
    "ICounterItem": ["771a9520-ee28-11ce-941e-008029004347"],
    "ICounterItem2": ["eefcd4e1-ea1c-4435-b7f4-e341ba03b4f9"],
    "ICounters": ["79167962-28fc-11cf-942f-008029004347"],
    "ICplSpellCheckerFactory": ["91f68443-3842-4df6-baee-f505c923360f"],
    "ICreateAudioDeviceInputNodeResult": ["16eec7a8-1ca7-40ef-91a4-d346e0aa1bba"],
    "ICreateAudioDeviceInputNodeResult2": ["921c69ce-3f35-41c7-9622-79f608baedc2"],
    "ICreateAudioDeviceOutputNodeResult": ["f7776d27-1d9a-47f7-9cd4-2859cc1b7bff"],
    "ICreateAudioDeviceOutputNodeResult2": ["4864269f-bdce-4ab1-bd38-fbae93aedaca"],
    "ICreateAudioFileInputNodeResult": ["ce83d61c-e297-4c50-9ce7-1c7a69d6bd09"],
    "ICreateAudioFileInputNodeResult2": ["f9082020-3d80-4fe0-81c1-768fea7ca7e0"],
    "ICreateAudioFileOutputNodeResult": ["47d6ba7b-e909-453f-866e-5540cda734ff"],
    "ICreateAudioFileOutputNodeResult2": ["9f01b50d-3318-47b3-a60a-1b492be7fc0d"],
    "ICreateAudioGraphResult": ["5453ef7e-7bde-4b76-bb5d-48f79cfc8c0b"],
    "ICreateAudioGraphResult2": ["6d738dfc-88c6-4fcb-a534-85cedd4050a1"],
    "ICreateDefaultValueCallback": ["d6ecb12c-15b5-4ec8-b95c-cdd208f08153"],
    "ICreateDeviceAccessAsync": ["3474628f-683d-42d2-abcb-db018c6503bc"],
    "ICreateLibraryCallback": ["10c0729b-efd1-49b9-aa7a-db81386a8cf7"],
    "ICreateMediaSourceAudioInputNodeResult": ["46a658a3-53c0-4d59-9e51-cc1d1044a4c4"],
    "ICreateMediaSourceAudioInputNodeResult2": ["63514ce8-6a1a-49e3-97ec-28fd5be114e5"],
    "ICreateNewLink": ["b5ab9c96-c11d-43e7-b44c-79b13ee7ac6f"],
    "ICreateObject": ["75121952-e0d0-43e5-9380-1d80483acf72"],
    "ICreateObjectEx": ["b13b9a9e-0e4d-4669-9f10-4889129a5d41"],
    "ICreatePerInterfacePSFactory": ["0d3acec7-6972-1380-e40a-77e59ab56400"],
    "ICreateProcessInputs": ["f6ef6140-e26f-4d82-bac4-e9ba5fd239a8"],
    "ICreatePropBagOnRegKey": ["8a674b48-1f63-11d3-b64c-00c04f79498e"],
    "ICreateRestrictedErrorInfo": ["66818b96-dc17-4c12-8ca1-8e1fbaa5bf80"],
    "ICreateResultSetsCallback": ["2e9d9dca-dd6e-4fee-b704-ff1e06001f6e"],
    "ICreateRow": ["0c733ab2-2a1c-11ce-ade5-00aa0044773d"],
    "ICreateStorageFile": ["4dac8671-4d47-42df-a831-54e268dd0da1"],
    "ICreateStreamedFileFromUriDelegate": ["4fddeaf4-d857-4b54-9f71-36b1ce2b5c7c"],
    "ICreateWithLocalTransaction": ["227ac7a8-8423-42ce-b7cf-03061ec9aaa3"],
    "ICreatedProcess": ["c2b937aa-3110-4398-8a56-f34c6342d244"],
    "ICreatingProcess": ["c2b937a9-3110-4398-8a56-f34c6342d244"],
    "ICreatingProcessError": ["515e6577-fe07-457b-bae3-6bd0fa8e3c84"],
    "ICredProviderCredentialSerialization": ["b1534289-3c01-41d3-bb58-ff279bf807a3"],
    "ICredUIBroker": ["0129ca94-3d53-4386-bcef-f773d0e46cc1"],
    "ICredUILocalServiceBroker": ["c76cd2e4-1e90-440a-8e08-1cd1812d9bed"],
    "ICredentialBroker": ["2e3bd64b-6a82-4da0-b49e-92a8b4bd59f4"],
    "ICredentialCacheSessionData": ["7096c91c-c33e-427a-b7cc-de5dc12b298b"],
    "ICredentialCommand": ["a5f665e6-6143-4a7a-a971-b017ba978ce2"],
    "ICredentialCommandCredentialDeletedHandler": ["61c0e185-0977-4678-b4e2-98727afbeed9"],
    "ICredentialCommandFactory": ["27e88c17-bc3e-4b80-9495-4ed720e48a91"],
    "ICredentialFactory": ["54ef13a1-bf26-47b5-97dd-de779b7cad58"],
    "ICredentialPickerOptions": ["965a0b4c-95fa-467f-992b-0b22e5859bf6"],
    "ICredentialPickerResults": ["1948f99a-cc30-410c-9c38-cc0884c5b3d7"],
    "ICredentialPickerStatics": ["aa3a5c73-c9ea-4782-99fb-e6d7e938e12d"],
    "ICredentialPromptOption": ["6f2e6c03-6d22-44b4-b08a-0b9c49e023c1"],
    "ICredentialProvider": ["d27c3481-5a1c-45b2-8aaa-c20ebbe8229e"],
    "ICredentialProviderCredential": ["63913a93-40c1-481a-818d-4072ff8c70cc"],
    "ICredentialProviderCredential2": ["fd672c54-40ea-4d6e-9b49-cfb1a7507bd7"],
    "ICredentialProviderCredentialEvents": ["fa6fa76b-66b7-4b11-95f1-86171118e816"],
    "ICredentialProviderCredentialEvents2": ["b53c00b6-9922-4b78-b1f4-ddfe774dc39b"],
    "ICredentialProviderCredentialWithFieldOptions": ["dbc6fb30-c843-49e3-a645-573e6f39446a"],
    "ICredentialProviderEvents": ["34201e5a-a787-41a3-a5a4-bd6dcf2a854e"],
    "ICredentialProviderFilter": ["a5da53f9-d475-4080-a120-910c4a739880"],
    "ICredentialProviderSetUserArray": ["095c1484-1c0c-4388-9c6d-500e61bf84bd"],
    "ICredentialProviderUser": ["13793285-3ea6-40fd-b420-15f47da41fbb"],
    "ICredentialProviderUserArray": ["90c119ae-0f18-4520-a1f1-114366a40fe8"],
    "ICredentialRecoveryData": ["239d58cc-793c-4b64-8320-b51380087c0b"],
    "ICrossApartmentProtocolHandler": ["7daf9908-8415-4005-95ae-bd27f6e3dc00"],
    "ICrossSlidingEventArgs": ["e9374738-6f88-41d9-8720-78e08e398349"],
    "ICrossSlidingEventArgs2": ["eefb7d48-c070-59f3-8dab-bcaf621d8687"],
    "ICryptAttribute": ["728ab32c-217d-11da-b2a4-000e7bbb2b09"],
    "ICryptAttributes": ["728ab32d-217d-11da-b2a4-000e7bbb2b09"],
    "ICryptographicBufferStatics": ["320b7e22-3cb0-4cdf-8663-1d28910065eb"],
    "ICryptographicEngineStatics": ["9fea0639-6ff7-4c85-a095-95eb31715eb9"],
    "ICryptographicEngineStatics2": ["675948fe-df9f-4191-92c7-6ce6f58420e0"],
    "ICryptographicKey": ["ed2a3b70-8e7b-4009-8401-ffd1a62eeb27"],
    "ICspAlgorithm": ["728ab305-217d-11da-b2a4-000e7bbb2b09"],
    "ICspAlgorithms": ["728ab306-217d-11da-b2a4-000e7bbb2b09"],
    "ICspInformation": ["728ab307-217d-11da-b2a4-000e7bbb2b09"],
    "ICspInformations": ["728ab308-217d-11da-b2a4-000e7bbb2b09"],
    "ICspStatus": ["728ab309-217d-11da-b2a4-000e7bbb2b09"],
    "ICspStatuses": ["728ab30a-217d-11da-b2a4-000e7bbb2b09"],
    "ICubicBezierEasingFunction": ["32350666-c1e8-44f9-96b8-c98acf0ae698"],
    "ICubicEase": ["1b94fc76-dad7-4354-b1a2-7969fbf6a70d"],
    "ICurrencyAmount": ["74b49942-eb75-443a-95b3-7d723f56f93c"],
    "ICurrencyAmountFactory": ["48d7168f-ef3b-4aee-a6a1-4b036fe03ff0"],
    "ICurrencyFormatter": ["11730ca5-4b00-41b2-b332-73b12a497d54"],
    "ICurrencyFormatter2": ["072c2f1d-e7ba-4197-920e-247c92f7dea6"],
    "ICurrencyFormatterFactory": ["86c7537e-b938-4aa2-84b0-2c33dc5b1450"],
    "ICurrencyIdentifiersStatics": ["9f1d091b-d586-4913-9b6a-a9bd2dc12874"],
    "ICurrencyIdentifiersStatics2": ["1814797f-c3b2-4c33-9591-980011950d37"],
    "ICurrencyIdentifiersStatics3": ["4fb23bfa-ed25-4f4d-857f-237f1748c21c"],
    "ICurrentApp": ["d52dc065-da3f-4685-995e-9b482eb5e603"],
    "ICurrentApp2Statics": ["df4e6e2d-3171-4ad3-8614-2c61244373cb"],
    "ICurrentAppSimulator": ["f17f9db1-74cd-4787-9787-19866e9a5559"],
    "ICurrentAppSimulatorStaticsWithFiltering": ["617e70e2-f86f-4b54-9666-dde285092c68"],
    "ICurrentAppSimulatorWithCampaignId": ["84678a43-df00-4672-a43f-b25b1441cfcf"],
    "ICurrentAppSimulatorWithConsumables": ["4e51f0ab-20e7-4412-9b85-59bb78388667"],
    "ICurrentAppStaticsWithFiltering": ["d36d6542-9085-438e-97ba-a25c976be2fd"],
    "ICurrentAppWithCampaignId": ["312f4cd0-36c1-44a6-b32b-432d608e4dd6"],
    "ICurrentAppWithConsumables": ["844e0071-9e4f-4f79-995a-5f91172e6cef"],
    "ICurrentChangingEventArgs": ["f9891e29-51cc-47dd-a5b9-35dc4914af69"],
    "ICurrentChangingEventArgsFactory": ["153bbeee-62f3-48cf-8183-8be26de3a66e"],
    "ICurrentChangingEventHandler": ["f3888db8-139f-4dce-8dc9-f7f1444d1185"],
    "ICurrentItem": ["240a7174-d653-4a1d-a6d3-d4943cfbfe3d"],
    "ICurrentMediaPlaybackItemChangedEventArgs": ["1743a892-5c43-4a15-967a-572d2d0f26c6"],
    "ICurrentMediaPlaybackItemChangedEventArgs2": ["1d80a51e-996e-40a9-be48-e66ec90b2b7d"],
    "ICurrentRecordInstance": ["3050f328-98b5-11cf-bb82-00aa00bdce0b"],
    "ICurrentSessionChangedEventArgs": ["6969cb39-0bfa-5fe0-8d73-09cc5e5408e1"],
    "ICurrentTimeChangeRequestedEventArgs": ["99711324-edc7-4bf5-91f6-3c8627db59e5"],
    "ICustomDelegateCallback": ["07d7b3d2-6f11-48d3-9fda-abfc644fd9bf"],
    "ICustomDestinationList": ["6332debf-87b5-4670-90c0-5e57b408a49e"],
    "ICustomDevice": ["dd30251f-c48b-43bd-bcb1-dec88f15143e"],
    "ICustomDeviceStatics": ["c8220312-ef4c-46b1-a58e-eeb308dc8917"],
    "ICustomDialog": ["e000160d-dd29-4f11-b56f-4f2fdf75bc8b"],
    "ICustomFilterInfo": ["1d335dff-6f88-4e4d-91a8-a3f351cfd473"],
    "ICustomGameControllerFactory": ["69a0ae5e-758e-4cbe-ace6-62155fe9126f"],
    "ICustomIconManager": ["7e23d323-36d6-4eb2-a654-387832868ea3"],
    "ICustomMapTileDataSource": ["65da384a-2db1-4be1-b155-3d0c9ecf4799"],
    "ICustomMapTileDataSourceFactory": ["c8477947-c955-4f22-9444-a1d8d744af11"],
    "ICustomNavigationProvider": ["2062a28a-8c07-4b94-8e12-7037c622aeb8", "2bd8a6d0-2fa3-4717-b28c-4917ce54928d"],
    "ICustomProperty": ["30da92c0-23e8-42a0-ae7c-734a0e5d2782"],
    "ICustomPropertyProvider": ["7c925755-3e48-42b4-8677-76372267033f"],
    "ICustomSensor": ["a136f9ad-4034-4b4d-99dd-531aac649c09"],
    "ICustomSensor2": ["20db3111-ec58-4d9f-bfbd-e77825088510"],
    "ICustomSensorReading": ["64004f4d-446a-4366-a87a-5f963268ec53"],
    "ICustomSensorReading2": ["223c98ea-bf73-4992-9a48-d3c897594ccb"],
    "ICustomSensorReadingChangedEventArgs": ["6b202023-cffd-4cc1-8ff0-e21823d76fcc"],
    "ICustomSensorStatics": ["992052cf-f422-4c7d-836b-e7dc74a7124b"],
    "ICustomShellManager": ["0b86d836-f65d-4516-a7e9-5ba7c2681877"],
    "ICustomSystemEventTrigger": ["f3596798-cf6b-4ef4-a0ca-29cf4a278c87"],
    "ICustomSystemEventTriggerFactory": ["6bcb16c5-f2dc-41b2-9efd-b96bdcd13ced"],
    "ICustomXamlResourceLoader": ["511a84ab-4a88-419f-852e-54083b90b078"],
    "ICustomXamlResourceLoaderFactory": ["5bfd7e49-7886-44f3-8ed3-6fec0463ed69"],
    "ICustomXamlResourceLoaderOverrides": ["f851e991-af02-46e8-9af8-427b7ebfe9f8"],
    "ICustomXamlResourceLoaderStatics": ["224ff617-e4dc-4c27-ad32-db93d5d0e5da"],
    "ICustomizeInfoTip": ["da22171f-70b4-43db-b38f-296741d1494c"],
    "ID2D1AnalysisTransform": ["0359dc30-95e6-4568-9055-27720d130e93"],
    "ID2D1Bitmap": ["a2296057-ea42-4099-983b-539fb6505426"],
    "ID2D1Bitmap1": ["a898a84c-3873-4588-b08b-ebbf978df041"],
    "ID2D1BitmapBrush": ["2cd906aa-12e2-11dc-9fed-001143a055f9"],
    "ID2D1BitmapBrush1": ["41343a53-e41a-49a2-91cd-21793bbb62e5"],
    "ID2D1BitmapRenderTarget": ["2cd90695-12e2-11dc-9fed-001143a055f9"],
    "ID2D1BlendTransform": ["63ac0b32-ba44-450f-8806-7f4ca1ff2f1b"],
    "ID2D1BorderTransform": ["4998735c-3a19-473c-9781-656847e3a347"],
    "ID2D1BoundsAdjustmentTransform": ["90f732e2-5092-4606-a819-8651970baccd"],
    "ID2D1Brush": ["2cd906a8-12e2-11dc-9fed-001143a055f9"],
    "ID2D1ColorContext": ["1c4820bb-5771-4518-a581-2fe4dd0ec657"],
    "ID2D1ColorContext1": ["1ab42875-c57f-4be9-bd85-9cd78d6f55ee"],
    "ID2D1CommandList": ["b4f34a19-2383-4d76-94f6-ec343657c3dc"],
    "ID2D1CommandSink": ["54d7898a-a061-40a7-bec7-e465bcba2c4f"],
    "ID2D1CommandSink1": ["9eb767fd-4269-4467-b8c2-eb30cb305743"],
    "ID2D1CommandSink2": ["3bab440e-417e-47df-a2e2-bc0be6a00916"],
    "ID2D1CommandSink3": ["18079135-4cf3-4868-bc8e-06067e6d242d"],
    "ID2D1CommandSink4": ["c78a6519-40d6-4218-b2de-beeeb744bb3e"],
    "ID2D1CommandSink5": ["7047dd26-b1e7-44a7-959a-8349e2144fa8"],
    "ID2D1ComputeInfo": ["5598b14b-9fd7-48b7-9bdb-8f0964eb38bc"],
    "ID2D1ComputeTransform": ["0d85573c-01e3-4f7d-bfd9-0d60608bf3c3"],
    "ID2D1ConcreteTransform": ["1a799d8a-69f7-4e4c-9fed-437ccc6684cc"],
    "ID2D1DCRenderTarget": ["1c51bc64-de61-46fd-9899-63a5d8f03950"],
    "ID2D1Device": ["47dd575d-ac05-4cdd-8049-9b02cd16f44c"],
    "ID2D1Device1": ["d21768e1-23a4-4823-a14b-7c3eba85d658"],
    "ID2D1Device2": ["a44472e1-8dfb-4e60-8492-6e2861c9ca8b"],
    "ID2D1Device3": ["852f2087-802c-4037-ab60-ff2e7ee6fc01"],
    "ID2D1Device4": ["d7bdb159-5683-4a46-bc9c-72dc720b858b"],
    "ID2D1Device5": ["d55ba0a4-6405-4694-aef5-08ee1a4358b4"],
    "ID2D1Device6": ["7bfef914-2d75-4bad-be87-e18ddb077b6d"],
    "ID2D1DeviceContext": ["e8f7fe7a-191c-466d-ad95-975678bda998"],
    "ID2D1DeviceContext1": ["d37f57e4-6908-459f-a199-e72f24f79987"],
    "ID2D1DeviceContext2": ["394ea6a3-0c34-4321-950b-6ca20f0be6c7"],
    "ID2D1DeviceContext3": ["235a7496-8351-414c-bcd4-6672ab2d8e00"],
    "ID2D1DeviceContext4": ["8c427831-3d90-4476-b647-c4fae349e4db"],
    "ID2D1DeviceContext5": ["7836d248-68cc-4df6-b9e8-de991bf62eb7"],
    "ID2D1DeviceContext6": ["985f7e37-4ed0-4a19-98a3-15b0edfde306"],
    "ID2D1DrawInfo": ["693ce632-7f2f-45de-93fe-18d88b37aa21"],
    "ID2D1DrawTransform": ["36bfdcb6-9739-435d-a30d-a653beff6a6f"],
    "ID2D1DrawingStateBlock": ["28506e39-ebf6-46a1-bb47-fd85565ab957"],
    "ID2D1DrawingStateBlock1": ["689f1f85-c72e-4e33-8f19-85754efd5ace"],
    "ID2D1Effect": ["28211a43-7d89-476f-8181-2d6159b220ad"],
    "ID2D1EffectContext": ["3d9f916b-27dc-4ad7-b4f1-64945340f563"],
    "ID2D1EffectContext1": ["84ab595a-fc81-4546-bacd-e8ef4d8abe7a"],
    "ID2D1EffectContext2": ["577ad2a0-9fc7-4dda-8b18-dab810140052"],
    "ID2D1EffectImpl": ["a248fd3f-3e6c-4e63-9f03-7f68ecc91db9"],
    "ID2D1EllipseGeometry": ["2cd906a4-12e2-11dc-9fed-001143a055f9"],
    "ID2D1Factory": ["06152247-6f50-465a-9245-118bfd3b6007"],
    "ID2D1Factory1": ["bb12d362-daee-4b9a-aa1d-14ba401cfa1f"],
    "ID2D1Factory2": ["94f81a73-9212-4376-9c58-b16a3a0d3992"],
    "ID2D1Factory3": ["0869759f-4f00-413f-b03e-2bda45404d0f"],
    "ID2D1Factory4": ["bd4ec2d2-0662-4bee-ba8e-6f29f032e096"],
    "ID2D1Factory5": ["c4349994-838e-4b0f-8cab-44997d9eeacc"],
    "ID2D1Factory6": ["f9976f46-f642-44c1-97ca-da32ea2a2635"],
    "ID2D1Factory7": ["bdc2bdd3-b96c-4de6-bdf7-99d4745454de"],
    "ID2D1GdiInteropRenderTarget": ["e0db51c3-6f77-4bae-b3d5-e47509b35838"],
    "ID2D1GdiMetafile": ["2f543dc3-cfc1-4211-864f-cfd91c6f3395"],
    "ID2D1GdiMetafile1": ["2e69f9e8-dd3f-4bf9-95ba-c04f49d788df"],
    "ID2D1GdiMetafileSink": ["82237326-8111-4f7c-bcf4-b5c1175564fe"],
    "ID2D1GdiMetafileSink1": ["fd0ecb6b-91e6-411e-8655-395e760f91b4"],
    "ID2D1Geometry": ["2cd906a1-12e2-11dc-9fed-001143a055f9"],
    "ID2D1GeometryGroup": ["2cd906a6-12e2-11dc-9fed-001143a055f9"],
    "ID2D1GeometryRealization": ["a16907d7-bc02-4801-99e8-8cf7f485f774"],
    "ID2D1GeometrySink": ["2cd9069f-12e2-11dc-9fed-001143a055f9"],
    "ID2D1GradientMesh": ["f292e401-c050-4cde-83d7-04962d3b23c2"],
    "ID2D1GradientStopCollection": ["2cd906a7-12e2-11dc-9fed-001143a055f9"],
    "ID2D1GradientStopCollection1": ["ae1572f4-5dd0-4777-998b-9279472ae63b"],
    "ID2D1HwndRenderTarget": ["2cd90698-12e2-11dc-9fed-001143a055f9"],
    "ID2D1Image": ["65019f75-8da2-497c-b32c-dfa34e48ede6"],
    "ID2D1ImageBrush": ["fe9e984d-3f95-407c-b5db-cb94d4e8f87c"],
    "ID2D1ImageSource": ["c9b664e5-74a1-4378-9ac2-eefc37a3f4d8"],
    "ID2D1ImageSourceFromWic": ["77395441-1c8f-4555-8683-f50dab0fe792"],
    "ID2D1ImageSourceFromWicHardware": ["9c1c9525-dd79-432a-b941-5456bf07284d"],
    "ID2D1Ink": ["b499923b-7029-478f-a8b3-432c7c5f5312"],
    "ID2D1InkStyle": ["bae8b344-23fc-4071-8cb5-d05d6f073848"],
    "ID2D1Layer": ["2cd9069b-12e2-11dc-9fed-001143a055f9"],
    "ID2D1LinearGradientBrush": ["2cd906ab-12e2-11dc-9fed-001143a055f9"],
    "ID2D1LookupTable3D": ["53dd9855-a3b0-4d5b-82e1-26e25c5e5797"],
    "ID2D1Mesh": ["2cd906c2-12e2-11dc-9fed-001143a055f9"],
    "ID2D1Multithread": ["31e6e7bc-e0ff-4d46-8c64-a0a8c41c15d3"],
    "ID2D1OffsetTransform": ["3fe6adea-7643-4f53-bd14-a0ce63f24042"],
    "ID2D1PathGeometry": ["2cd906a5-12e2-11dc-9fed-001143a055f9"],
    "ID2D1PathGeometry1": ["62baa2d2-ab54-41b7-b872-787e0106a421"],
    "ID2D1PrintControl": ["2c1d867d-c290-41c8-ae7e-34a98702e9a5"],
    "ID2D1PrivateTestDevice": ["5f1729fe-8904-42b2-bca3-d96a703cb445"],
    "ID2D1Properties": ["483473d7-cd46-4f9d-9d3a-3112aa80159d"],
    "ID2D1RadialGradientBrush": ["2cd906ac-12e2-11dc-9fed-001143a055f9"],
    "ID2D1RectangleGeometry": ["2cd906a2-12e2-11dc-9fed-001143a055f9"],
    "ID2D1RenderInfo": ["519ae1bd-d19a-420d-b849-364f594776b7"],
    "ID2D1RenderTarget": ["2cd90694-12e2-11dc-9fed-001143a055f9"],
    "ID2D1Resource": ["2cd90691-12e2-11dc-9fed-001143a055f9"],
    "ID2D1ResourceTexture": ["688d15c3-02b0-438d-b13a-d1b44c32c39a"],
    "ID2D1ResourceWeakReference": ["e2379834-a3b5-46e0-871b-e74a145c8f45"],
    "ID2D1RoundedRectangleGeometry": ["2cd906a3-12e2-11dc-9fed-001143a055f9"],
    "ID2D1SimplifiedGeometrySink": ["2cd9069e-12e2-11dc-9fed-001143a055f9"],
    "ID2D1SolidColorBrush": ["2cd906a9-12e2-11dc-9fed-001143a055f9"],
    "ID2D1SourceTransform": ["db1800dd-0c34-4cf9-be90-31cc0a5653e1"],
    "ID2D1SpriteBatch": ["4dc583bf-3a10-438a-8722-e9765224f1f1"],
    "ID2D1StrokeStyle": ["2cd9069d-12e2-11dc-9fed-001143a055f9"],
    "ID2D1StrokeStyle1": ["10a72a66-e91c-43f4-993f-ddf4b82b0b4a"],
    "ID2D1SvgAttribute": ["c9cdb0dd-f8c9-4e70-b7c2-301c80292c5e"],
    "ID2D1SvgDocument": ["86b88e4d-afa4-4d7b-88e4-68a51c4a0aec"],
    "ID2D1SvgElement": ["ac7b67a6-183e-49c1-a823-0ebe40b0db29"],
    "ID2D1SvgGlyphStyle": ["af671749-d241-4db8-8e41-dcc2e5c1a438"],
    "ID2D1SvgPaint": ["d59bab0a-68a2-455b-a5dc-9eb2854e2490"],
    "ID2D1SvgPathData": ["c095e4f4-bb98-43d6-9745-4d1b84ec9888"],
    "ID2D1SvgPointCollection": ["9dbe4c0d-3572-4dd9-9825-5530813bb712"],
    "ID2D1SvgStrokeDashArray": ["f1c0ca52-92a3-4f00-b4ce-f35691efd9d9"],
    "ID2D1TessellationSink": ["2cd906c1-12e2-11dc-9fed-001143a055f9"],
    "ID2D1Transform": ["ef1a287d-342a-4f76-8fdb-da0d6ea9f92b"],
    "ID2D1TransformGraph": ["13d29038-c3e6-4034-9081-13b53a417992"],
    "ID2D1TransformNode": ["b2efe1e7-729f-4102-949f-505fa21bf666"],
    "ID2D1TransformedGeometry": ["2cd906bb-12e2-11dc-9fed-001143a055f9"],
    "ID2D1TransformedImageSource": ["7f1f79e5-2796-416c-8f55-700f911445e5"],
    "ID2D1VertexBuffer": ["9b8b1336-00a5-4668-92b7-ced5d8bf9b7b"],
    "ID3D10BlendState1": ["edad8d99-8a35-4d6d-8566-2ea276cde161"],
    "ID3D10Blob": ["8ba5fb08-5195-40e2-ac58-0d989c3a0102"],
    "ID3D10Device1": ["9b7e4c8f-342c-4106-a19f-4f2704f689f0"],
    "ID3D10EffectPool": ["9537ab04-3250-412e-8213-fcd2f8677933"],
    "ID3D10ShaderReflection1": ["c3457783-a846-47ce-9520-cea6f66e7447"],
    "ID3D10ShaderResourceView1": ["9b7e4c87-342c-4106-a19f-4f2704f689f0"],
    "ID3D11Asynchronous": ["4b35d0cd-1e15-4258-9c98-1b1333f6dd3b"],
    "ID3D11AuthenticatedChannel": ["3015a308-dcbd-47aa-a747-192486d14d4a"],
    "ID3D11BlendState": ["75b68faa-347d-4159-8f45-a0640f01cd9a"],
    "ID3D11BlendState1": ["cc86fabe-da55-401d-85e7-e3c9de2877e9"],
    "ID3D11Buffer": ["48570b85-d1ee-4fcd-a250-eb350722b037"],
    "ID3D11ClassInstance": ["a6cd7faa-b0b7-4a2f-9436-8662a65797cb"],
    "ID3D11ClassLinkage": ["ddf57cba-9543-46e4-a12b-f207a0fe7fed"],
    "ID3D11CommandList": ["a24bc4d1-769e-43f7-8013-98ff566c18e2"],
    "ID3D11ComputeShader": ["4f5b196e-c2bd-495e-bd01-1fded38e4969"],
    "ID3D11Counter": ["6e8c49fb-a371-4770-b440-29086022b741"],
    "ID3D11CryptoSession": ["9b32f9ad-bdcc-40a6-a39d-d5c865845720"],
    "ID3D11Debug": ["79cf2233-7536-4948-9d36-1e4692dc5760"],
    "ID3D11DepthStencilState": ["03823efb-8d8f-4e1c-9aa2-f64bb2cbfdf1"],
    "ID3D11DepthStencilView": ["9fdac92a-1876-48c3-afad-25b94f84a9b6"],
    "ID3D11Device": ["db6f6ddb-ac77-4e88-8253-819df9bbf140"],
    "ID3D11Device1": ["a04bfb29-08ef-43d6-a49c-a9bdbdcbe686"],
    "ID3D11Device2": ["9d06dffa-d1e5-4d07-83a8-1bb123f2f841"],
    "ID3D11Device3": ["a05c8c37-d2c6-4732-b3a0-9ce0b0dc9ae6"],
    "ID3D11Device4": ["8992ab71-02e6-4b8d-ba48-b056dcda42c4"],
    "ID3D11Device5": ["8ffde202-a0e7-45df-9e01-e837801b5ea0"],
    "ID3D11DeviceChild": ["1841e5c8-16b0-489b-bcc8-44cfb0d5deae"],
    "ID3D11DeviceContext": ["c0bfa96c-e089-44fb-8eaf-26f8796190da"],
    "ID3D11DeviceContext1": ["bb2c6faa-b5fb-4082-8e6b-388b8cfa90e1"],
    "ID3D11DeviceContext2": ["420d5b32-b90c-4da4-bef0-359f6a24a83a"],
    "ID3D11DeviceContext3": ["b4e3c01d-e79e-4637-91b2-510e9f4c9b8f"],
    "ID3D11DeviceContext4": ["917600da-f58c-4c33-98d8-3e15b390fa24"],
    "ID3D11DomainShader": ["f582c508-0f36-490c-9977-31eece268cfa"],
    "ID3D11Fence": ["affde9d1-1df7-4bb7-8a34-0f46251dab80"],
    "ID3D11FunctionLinkingGraph": ["54133220-1ce8-43d3-8236-9855c5ceecff"],
    "ID3D11FunctionParameterReflection": ["42757488-334f-47fe-982e-1a65d08cc462"],
    "ID3D11FunctionReflection": ["207bcecb-d683-4a06-a8a3-9b149b9f73a4"],
    "ID3D11GeometryShader": ["38325b96-effb-4022-ba02-2e795b70275c"],
    "ID3D11HullShader": ["8e5c6061-628a-4c8e-8264-bbe45cb3d5dd"],
    "ID3D11InfoQueue": ["6543dbb6-1b48-42f5-ab82-e97ec74326f6"],
    "ID3D11InputLayout": ["e4819ddc-4cf0-4025-bd26-5de82a3e07b7"],
    "ID3D11LibraryReflection": ["54384f1b-5b3e-4bb7-ae01-60ba3097cbb6"],
    "ID3D11Linker": ["59a6cd0e-e10d-4c1f-88c0-63aba1daf30e"],
    "ID3D11LinkingNode": ["d80dd70c-8d2f-4751-94a1-03c79b3556db"],
    "ID3D11Module": ["cac701ee-80fc-4122-8242-10b39c8cec34"],
    "ID3D11ModuleInstance": ["469e07f7-045a-48d5-aa12-68a478cdf75d"],
    "ID3D11Multithread": ["9b7e4e00-342c-4106-a19f-4f2704f689f0"],
    "ID3D11On12Device": ["85611e73-70a9-490e-9614-a9e302777904"],
    "ID3D11On12Device1": ["bdb64df4-ea2f-4c70-b861-aaab1258bb5d"],
    "ID3D11On12Device2": ["dc90f331-4740-43fa-866e-67f12cb58223"],
    "ID3D11PixelShader": ["ea82e40d-51dc-4f33-93d4-db7c9125ae8c"],
    "ID3D11Predicate": ["9eb576dd-9f77-4d86-81aa-8bab5fe490e2"],
    "ID3D11Query": ["d6c00747-87b7-425e-b84d-44d108560afd"],
    "ID3D11Query1": ["631b4766-36dc-461d-8db6-c47e13e60916"],
    "ID3D11RasterizerState": ["9bb4ab81-ab1a-4d8f-b506-fc04200b6ee7"],
    "ID3D11RasterizerState1": ["1217d7a6-5039-418c-b042-9cbe256afd6e"],
    "ID3D11RasterizerState2": ["6fbd02fb-209f-46c4-b059-2ed15586a6ac"],
    "ID3D11RefDefaultTrackingOptions": ["03916615-c644-418c-9bf4-75db5be63ca0"],
    "ID3D11RefTrackingOptions": ["193dacdf-0db2-4c05-a55c-ef06cac56fd9"],
    "ID3D11RenderTargetView": ["dfdba067-0b8d-4865-875b-d7b4516cc164"],
    "ID3D11RenderTargetView1": ["ffbe2e23-f011-418a-ac56-5ceed7c5b94b"],
    "ID3D11Resource": ["dc8e63f3-d12b-4952-b47b-5e45026a862d"],
    "ID3D11SamplerState": ["da6fea51-564c-4487-9810-f0d0f9b4e3a5"],
    "ID3D11ShaderReflection": ["8d536ca1-0cca-4956-a837-786963755584"],
    "ID3D11ShaderReflectionConstantBuffer": ["eb62d63d-93dd-4318-8ae8-c6f83ad371b8"],
    "ID3D11ShaderReflectionType": ["6e6ffa6a-9bae-4613-a51e-91652d508c21"],
    "ID3D11ShaderReflectionVariable": ["51f23923-f3e5-4bd1-91cb-606177d8db4c"],
    "ID3D11ShaderResourceView": ["b0e06fe0-8192-4e1a-b1ca-36d7414710b2"],
    "ID3D11ShaderResourceView1": ["91308b87-9040-411d-8c67-c39253ce3802"],
    "ID3D11ShaderTrace": ["36b013e6-2811-4845-baa7-d623fe0df104"],
    "ID3D11ShaderTraceFactory": ["1fbad429-66ab-41cc-9617-667ac10e4459"],
    "ID3D11SwitchToRef": ["1ef337e3-58e7-4f83-a692-db221f5ed47e"],
    "ID3D11Texture1D": ["f8fb5c27-c6b3-4f75-a4c8-439af2ef564c"],
    "ID3D11Texture2D": ["6f15aaf2-d208-4e89-9ab4-489535d34f9c"],
    "ID3D11Texture2D1": ["51218251-1e33-4617-9ccb-4d3a4367e7bb"],
    "ID3D11Texture3D": ["037e866e-f56d-4357-a8af-9dabbe6e250e"],
    "ID3D11Texture3D1": ["0c711683-2853-4846-9bb0-f3e60639e46a"],
    "ID3D11TracingDevice": ["1911c771-1587-413e-a7e0-fb26c3de0268"],
    "ID3D11UnorderedAccessView": ["28acf509-7f5c-48f6-8611-f316010a6380"],
    "ID3D11UnorderedAccessView1": ["7b3b6153-a886-4544-ab37-6537c8500403"],
    "ID3D11VertexShader": ["3b301d64-d678-4289-8897-22f8928b72f3"],
    "ID3D11VideoContext": ["61f21c45-3c0e-4a74-9cea-67100d9ad5e4"],
    "ID3D11VideoContext1": ["a7f026da-a5f8-4487-a564-15e34357651e"],
    "ID3D11VideoContext2": ["c4e7374c-6243-4d1b-ae87-52b4f740e261"],
    "ID3D11VideoContext3": ["a9e2faa0-cb39-418f-a0b7-d8aad4de672e"],
    "ID3D11VideoDecoder": ["3c9c5b51-995d-48d1-9b8d-fa5caeded65c"],
    "ID3D11VideoDecoderOutputView": ["c2931aea-2a85-4f20-860f-fba1fd256e18"],
    "ID3D11VideoDevice": ["10ec4d5b-975a-4689-b9e4-d0aac30fe333"],
    "ID3D11VideoDevice1": ["29da1d51-1321-4454-804b-f5fc9f861f0f"],
    "ID3D11VideoDevice2": ["59c0cb01-35f0-4a70-8f67-87905c906a53"],
    "ID3D11VideoProcessor": ["1d7b0652-185f-41c6-85ce-0c5be3d4ae6c"],
    "ID3D11VideoProcessorEnumerator": ["31627037-53ab-4200-9061-05faa9ab45f9"],
    "ID3D11VideoProcessorEnumerator1": ["465217f2-5568-43cf-b5b9-f61d54531ca1"],
    "ID3D11VideoProcessorInputView": ["11ec5a5f-51dc-4945-ab34-6e8c21300ea5"],
    "ID3D11VideoProcessorOutputView": ["a048285e-25a9-4527-bd93-d68b68c44254"],
    "ID3D11View": ["839d1216-bb2e-412b-b7f4-a9dbebe08ed1"],
    "ID3D12CommandAllocator": ["6102dee4-af59-4b09-b999-b44d73f09b24"],
    "ID3D12CommandList": ["7116d91c-e7e4-47ce-b8c6-ec8168f437e5"],
    "ID3D12CommandQueue": ["0ec870a6-5d7e-4c22-8cfc-5baae07616ed"],
    "ID3D12CommandSignature": ["c36a797c-ec80-4f0a-8985-a7b2475082d1"],
    "ID3D12Debug": ["344488b7-6846-474b-b989-f027448245e0"],
    "ID3D12Debug1": ["affaa4ca-63fe-4d8e-b8ad-159000af4304"],
    "ID3D12Debug2": ["93a665c4-a3b2-4e5d-b692-a26ae14e3374"],
    "ID3D12Debug3": ["5cf4e58f-f671-4ff1-a542-3686e3d153d1"],
    "ID3D12DebugCommandList": ["09e0bf36-54ac-484f-8847-4baeeab6053f"],
    "ID3D12DebugCommandList1": ["102ca951-311b-4b01-b11f-ecb83e061b37"],
    "ID3D12DebugCommandList2": ["aeb575cf-4e06-48be-ba3b-c450fc96652e"],
    "ID3D12DebugCommandQueue": ["09e0bf36-54ac-484f-8847-4baeeab6053a"],
    "ID3D12DebugDevice": ["3febd6dd-4973-4787-8194-e45f9e28923e"],
    "ID3D12DebugDevice1": ["a9b71770-d099-4a65-a698-3dee10020f88"],
    "ID3D12DebugDevice2": ["60eccbc1-378d-4df1-894c-f8ac5ce4d7dd"],
    "ID3D12DescriptorHeap": ["8efb471d-616c-4f49-90f7-127bb763fa51"],
    "ID3D12Device": ["189819f1-1db6-4b57-be54-1821339b85f7"],
    "ID3D12Device1": ["77acce80-638e-4e65-8895-c1f23386863e"],
    "ID3D12Device2": ["30baa41e-b15b-475c-a0bb-1af5c5b64328"],
    "ID3D12Device3": ["81dadc15-2bad-4392-93c5-101345c4aa98"],
    "ID3D12Device4": ["e865df17-a9ee-46f9-a463-3098315aa2e5"],
    "ID3D12Device5": ["8b4f173b-2fea-4b80-8f58-4307191ab95d"],
    "ID3D12Device6": ["c70b221b-40e4-4a17-89af-025a0727a6dc"],
    "ID3D12Device7": ["5c014b53-68a1-4b9b-8bd1-dd6046b9358b"],
    "ID3D12Device8": ["9218e6bb-f944-4f7e-a75c-b1b2c7b701f3"],
    "ID3D12DeviceChild": ["905db94b-a00c-4140-9df5-2b64ca9ea357"],
    "ID3D12DeviceRemovedExtendedData": ["98931d33-5ae8-4791-aa3c-1a73a2934e71"],
    "ID3D12DeviceRemovedExtendedData1": ["9727a022-cf1d-4dda-9eba-effa653fc506"],
    "ID3D12DeviceRemovedExtendedDataSettings": ["82bc481c-6b9b-4030-aedb-7ee3d1df1e63"],
    "ID3D12DeviceRemovedExtendedDataSettings1": ["dbd5ae51-3317-4f0a-adf9-1d7cedcaae0b"],
    "ID3D12Fence": ["0a753dcf-c4d8-4b91-adf6-be5a60d95a76"],
    "ID3D12Fence1": ["433685fe-e22b-4ca0-a8db-b5b4f4dd0e4a"],
    "ID3D12FunctionParameterReflection": ["ec25f42d-7006-4f2b-b33e-02cc3375733f"],
    "ID3D12FunctionReflection": ["1108795c-2772-4ba9-b2a8-d464dc7e2799"],
    "ID3D12GraphicsCommandList": ["5b160d0f-ac1b-4185-8ba8-b3ae42a5a455"],
    "ID3D12GraphicsCommandList1": ["553103fb-1fe7-4557-bb38-946d7d0e7ca7"],
    "ID3D12GraphicsCommandList2": ["38c3e585-ff17-412c-9150-4fc6f9d72a28"],
    "ID3D12GraphicsCommandList3": ["6fda83a7-b84c-4e38-9ac8-c7bd22016b3d"],
    "ID3D12GraphicsCommandList4": ["8754318e-d3a9-4541-98cf-645b50dc4874"],
    "ID3D12GraphicsCommandList5": ["55050859-4024-474c-87f5-6472eaee44ea"],
    "ID3D12GraphicsCommandList6": ["c3827890-e548-4cfa-96cf-5689a9370f80"],
    "ID3D12Heap": ["6b3b2502-6e51-45b3-90ee-9884265e8df3"],
    "ID3D12Heap1": ["572f7389-2168-49e3-9693-d6df5871bf6d"],
    "ID3D12InfoQueue": ["0742a90b-c387-483f-b946-30a7e4e61458"],
    "ID3D12LibraryReflection": ["8e349d19-54db-4a56-9dc9-119d87bdb804"],
    "ID3D12LifetimeOwner": ["e667af9f-cd56-4f46-83ce-032e595d70a8"],
    "ID3D12LifetimeTracker": ["3fd03d36-4eb1-424a-a582-494ecb8ba813"],
    "ID3D12MetaCommand": ["dbb84c27-36ce-4fc9-b801-f048c46ac570"],
    "ID3D12Object": ["c4fec28f-7966-4e95-9f94-f431cb56c3b8"],
    "ID3D12Pageable": ["63ee58fb-1268-4835-86da-f008ce62f0d6"],
    "ID3D12PipelineLibrary": ["c64226a8-9201-46af-b4cc-53fb9ff7414f"],
    "ID3D12PipelineLibrary1": ["80eabf42-2568-4e5e-bd82-c37f86961dc3"],
    "ID3D12PipelineState": ["765a30f3-f624-4c6f-a828-ace948622445"],
    "ID3D12ProtectedResourceSession": ["6cd696f4-f289-40cc-8091-5a6c0a099c3d"],
    "ID3D12ProtectedResourceSession1": ["d6f12dd6-76fb-406e-8961-4296eefc0409"],
    "ID3D12ProtectedSession": ["a1533d18-0ac1-4084-85b9-89a96116806b"],
    "ID3D12QueryHeap": ["0d9658ae-ed45-469e-a61d-970ec583cab4"],
    "ID3D12Resource": ["696442be-a72e-4059-bc79-5b5c98040fad"],
    "ID3D12Resource1": ["9d5e227a-4430-4161-88b3-3eca6bb16e19"],
    "ID3D12Resource2": ["be36ec3b-ea85-4aeb-a45a-e9d76404a495"],
    "ID3D12RootSignature": ["c54a6b66-72df-4ee8-8be5-a946a1429214"],
    "ID3D12RootSignatureDeserializer": ["34ab647b-3cc8-46ac-841b-c0965645c046"],
    "ID3D12ShaderReflection": ["5a58797d-a72c-478d-8ba2-efc6b0efe88e"],
    "ID3D12ShaderReflectionConstantBuffer": ["c59598b4-48b3-4869-b9b1-b1618b14a8b7"],
    "ID3D12ShaderReflectionType": ["e913c351-783d-48ca-a1d1-4f306284ad56"],
    "ID3D12ShaderReflectionVariable": ["8337a8a6-a216-444a-b2f4-314733a73aea"],
    "ID3D12SharingContract": ["0adf7d52-929c-4e61-addb-ffed30de66ef"],
    "ID3D12StateObject": ["47016943-fca8-4594-93ea-af258b55346d"],
    "ID3D12StateObjectProperties": ["de5fa827-9bf9-4f26-89ff-d7f56fde3860"],
    "ID3D12SwapChainAssistant": ["f1df64b6-57fd-49cd-8807-c0eb88b45c8f"],
    "ID3D12Tools": ["7071e1f0-e84b-4b33-974f-12fa49de65c5"],
    "ID3D12VersionedRootSignatureDeserializer": ["7f91ce67-090c-4bb7-b78e-ed8ff2e31da0"],
    "ID3D12VideoDecodeCommandList": ["3b60536e-ad29-4e64-a269-f853837e5e53"],
    "ID3D12VideoDecodeCommandList1": ["d52f011b-b56e-453c-a05a-a7f311c8f472"],
    "ID3D12VideoDecodeCommandList2": ["6e120880-c114-4153-8036-d247051e1729"],
    "ID3D12VideoDecoder": ["c59b6bdc-7720-4074-a136-17a156037470"],
    "ID3D12VideoDecoder1": ["79a2e5fb-ccd2-469a-9fde-195d10951f7e"],
    "ID3D12VideoDecoderHeap": ["0946b7c9-ebf6-4047-bb73-8683e27dbb1f"],
    "ID3D12VideoDecoderHeap1": ["da1d98c5-539f-41b2-bf6b-1198a03b6d26"],
    "ID3D12VideoDevice": ["1f052807-0b46-4acc-8a89-364f793718a4"],
    "ID3D12VideoDevice1": ["981611ad-a144-4c83-9890-f30e26d658ab"],
    "ID3D12VideoDevice2": ["f019ac49-f838-4a95-9b17-579437c8f513"],
    "ID3D12VideoEncodeCommandList": ["8455293a-0cbd-4831-9b39-fbdbab724723"],
    "ID3D12VideoEncodeCommandList1": ["94971eca-2bdb-4769-88cf-3675ea757ebc"],
    "ID3D12VideoExtensionCommand": ["554e41e8-ae8e-4a8c-b7d2-5b4f274a30e4"],
    "ID3D12VideoMotionEstimator": ["33fdae0e-098b-428f-87bb-34b695de08f8"],
    "ID3D12VideoMotionVectorHeap": ["5be17987-743a-4061-834b-23d22daea505"],
    "ID3D12VideoProcessCommandList": ["aeb2543a-167f-4682-acc8-d159ed4a6209"],
    "ID3D12VideoProcessCommandList1": ["542c5c4d-7596-434f-8c93-4efa6766f267"],
    "ID3D12VideoProcessCommandList2": ["db525ae4-6ad6-473c-baa7-59b2e37082e4"],
    "ID3D12VideoProcessor": ["304fdb32-bede-410a-8545-943ac6a46138"],
    "ID3D12VideoProcessor1": ["f3cfe615-553f-425c-86d8-ee8c1b1fb01c"],
    "ID3DBlob": ["8ba5fb08-5195-40e2-ac58-0d989c3a0102"],
    "ID3DDestructionNotifier": ["a06eb39a-50da-425b-8c31-4eecd6c270f3"],
    "ID3DDeviceContextState": ["5c1e0d8a-7c23-48f9-8c59-a92958ceff11"],
    "ID3DUserDefinedAnnotation": ["b2daad8b-03d4-4dbf-95eb-32ab4b63d0ab"],
    "ID3DX11FFT": ["b3f7a938-4c93-4310-a675-b30d6de50553"],
    "ID3DX11Scan": ["5089b68f-e71d-4d38-be8e-f363b95a9405"],
    "ID3DX11SegmentedScan": ["a915128c-d954-4c79-bfe1-64db923194d6"],
    "IDATASRCListener": ["3050f380-98b5-11cf-bb82-00aa00bdce0b"],
    "IDBAsynchNotify": ["0c733a96-2a1c-11ce-ade5-00aa0044773d"],
    "IDBAsynchStatus": ["0c733a95-2a1c-11ce-ade5-00aa0044773d"],
    "IDBBinderProperties": ["0c733ab3-2a1c-11ce-ade5-00aa0044773d"],
    "IDBCreateCommand": ["0c733a1d-2a1c-11ce-ade5-00aa0044773d"],
    "IDBCreateSession": ["0c733a5d-2a1c-11ce-ade5-00aa0044773d"],
    "IDBDataSourceAdmin": ["0c733a7a-2a1c-11ce-ade5-00aa0044773d"],
    "IDBFolderPriv": ["1af4b01d-4a4a-489c-8f9f-243612300d24"],
    "IDBInfo": ["0c733a89-2a1c-11ce-ade5-00aa0044773d"],
    "IDBInitialize": ["0c733a8b-2a1c-11ce-ade5-00aa0044773d"],
    "IDBPromptInitialize": ["2206ccb0-19c1-11d1-89e0-00c04fd7a829"],
    "IDBProperties": ["0c733a8a-2a1c-11ce-ade5-00aa0044773d"],
    "IDBSchemaCommand": ["0c733a50-2a1c-11ce-ade5-00aa0044773d"],
    "IDBSchemaRowset": ["0c733a7b-2a1c-11ce-ade5-00aa0044773d"],
    "IDBSecurityInfo": ["0c733a62-2a1c-11ce-ade5-00aa0044773d"],
    "IDCompositionAnimation": ["cbfd91d9-51b2-45e4-b3de-d19ccfb863c5"],
    "IDCompositionDeviceInterop": ["2f4688bd-7f61-4b95-adcf-248d89e971bc"],
    "IDCompositionVisualInterop": ["33f8a013-5341-40c9-86ca-273ac031c7f6"],
    "IDDEConnected": ["5815aebe-69a9-4352-a91d-d805b44879da"],
    "IDDEInitializer": ["30dc931f-33fc-4ffd-a168-942258cf3ca4"],
    "IDDOResourceInfo": ["03e05342-07f2-4dee-98f7-c4ec68370cf4"],
    "IDDrawExclModeVideo": ["153acc21-d83b-11d1-82bf-00a0c9696c8f"],
    "IDDrawExclModeVideoCallback": ["913c24a0-20ab-11d2-9038-00a0c9697298"],
    "IDLLHost": ["00000141-0000-0000-c000-000000000046"],
    "IDMOQualityControl": ["65abea96-cf36-453f-af8a-705e98f16260"],
    "IDMOVideoOutputOptimizations": ["be8f4f4e-5b16-4d29-b350-7f6b5d9298ac"],
    "IDMOWrapperFilter": ["52d6f586-9f0f-4824-8fc8-e32ca04930c2"],
    "IDOMBeforeUnloadEvent": ["30510763-98b5-11cf-bb82-00aa00bdce0b"],
    "IDOMCloseEvent": ["305107ff-98b5-11cf-bb82-00aa00bdce0b"],
    "IDOMCompositionEvent": ["305106d8-98b5-11cf-bb82-00aa00bdce0b"],
    "IDOMCustomEvent": ["305106de-98b5-11cf-bb82-00aa00bdce0b"],
    "IDOMDocumentType": ["30510738-98b5-11cf-bb82-00aa00bdce0b"],
    "IDOMDragEvent": ["30510761-98b5-11cf-bb82-00aa00bdce0b"],
    "IDOMEvent": ["305104ba-98b5-11cf-bb82-00aa00bdce0b"],
    "IDOMEventRegistrationCallback": ["3051083b-98b5-11cf-bb82-00aa00bdce0b"],
    "IDOMException": ["3051072b-98b5-11cf-bb82-00aa00bdce0b"],
    "IDOMFocusEvent": ["305106cc-98b5-11cf-bb82-00aa00bdce0b"],
    "IDOMKeyboardEvent": ["305106d6-98b5-11cf-bb82-00aa00bdce0b"],
    "IDOMMSAnimationEvent": ["305107b7-98b5-11cf-bb82-00aa00bdce0b"],
    "IDOMMSManipulationEvent": ["30510816-98b5-11cf-bb82-00aa00bdce0b"],
    "IDOMMSTransitionEvent": ["305107b5-98b5-11cf-bb82-00aa00bdce0b"],
    "IDOMMessageEvent": ["30510720-98b5-11cf-bb82-00aa00bdce0b"],
    "IDOMMouseEvent": ["305106ce-98b5-11cf-bb82-00aa00bdce0b"],
    "IDOMMouseWheelEvent": ["305106d0-98b5-11cf-bb82-00aa00bdce0b"],
    "IDOMMutationEvent": ["305106da-98b5-11cf-bb82-00aa00bdce0b"],
    "IDOMNodeIterator": ["30510746-98b5-11cf-bb82-00aa00bdce0b"],
    "IDOMParser": ["30510781-98b5-11cf-bb82-00aa00bdce0b"],
    "IDOMParserFactory": ["30510783-98b5-11cf-bb82-00aa00bdce0b"],
    "IDOMProcessingInstruction": ["30510742-98b5-11cf-bb82-00aa00bdce0b"],
    "IDOMProgressEvent": ["3051071e-98b5-11cf-bb82-00aa00bdce0b"],
    "IDOMSiteModeEvent": ["30510765-98b6-11cf-bb82-00aa00bdce0b"],
    "IDOMStorageEvent": ["30510722-98b5-11cf-bb82-00aa00bdce0b"],
    "IDOMTextEvent": ["305106d4-98b5-11cf-bb82-00aa00bdce0b"],
    "IDOMTreeWalker": ["30510748-98b5-11cf-bb82-00aa00bdce0b"],
    "IDOMUIEvent": ["305106ca-98b5-11cf-bb82-00aa00bdce0b"],
    "IDOMWheelEvent": ["305106d2-98b5-11cf-bb82-00aa00bdce0b"],
    "IDOMXmlSerializer": ["3051077d-98b5-11cf-bb82-00aa00bdce0b"],
    "IDOMXmlSerializerFactory": ["3051077f-98b5-11cf-bb82-00aa00bdce0b"],
    "IDSOControl": ["310afa62-0575-11d2-9ca9-0060b0ec3d39"],
    "IDSRefConsumer": ["ab36de42-2bf4-11ce-ab3c-00aa004404fb"],
    "IDSRefProvider": ["ab36de41-2bf4-11ce-ab3c-00aa004404fb"],
    "IDShowPlugin": ["4746b7c8-700e-11d1-becc-00c04fb6e937"],
    "IDTCommandTarget": ["7ef39a3e-590d-4879-88d4-c9be5bcfd92e"],
    "IDTFilter": ["c4c4c4b2-0049-4e2b-98fb-9537f6ce516d"],
    "IDTFilter2": ["c4c4c4b4-0049-4e2b-98fb-9537f6ce516d"],
    "IDTFilter3": ["513998cc-e929-4cdf-9fbd-bad1e0314866"],
    "IDTFilterConfig": ["c4c4c4d2-0049-4e2b-98fb-9537f6ce516d"],
    "IDTFilterEvents": ["c4c4c4c2-0049-4e2b-98fb-9537f6ce516d"],
    "IDTFilterLicenseRenewal": ["8a78b317-e405-4a43-994a-620d8f5ce25e"],
    "IDTToolsOptionsPage": ["bdcaf240-2692-4713-902a-b110b1d0f100"],
    "IDTWizard": ["e914bbe1-03a4-11d1-bbcd-00a0c90f2744"],
    "IDUIElementProviderInit": ["e1f5ec9f-f933-492b-a242-c3cdac6ecfbd"],
    "IDUIFrameworkClientInitializer": ["05b2f74e-2712-46ba-bca3-f65a46bf0e00"],
    "IDVBCLocator": ["6e42f36e-1dd2-43c4-9f78-69d25ae39034"],
    "IDVBSLocator": ["3d7c353c-0d04-45f1-a742-f97cc1188dc8"],
    "IDVBSLocator2": ["6044634a-1733-4f99-b982-5fb12afce4f0"],
    "IDVBSTuningSpace": ["cdf7be60-d954-42fd-a972-78971958e470"],
    "IDVBTLocator": ["8664da16-dda2-42ac-926a-c18f9127c302"],
    "IDVBTLocator2": ["448a2edf-ae95-4b43-a3cc-747843c453d4"],
    "IDVBTuneRequest": ["0d6f567e-a636-42bb-83ba-ce4c1704afa2"],
    "IDVBTuningSpace": ["ada0b268-3b19-4e5b-acc4-49f852be13ba"],
    "IDVBTuningSpace2": ["843188b4-ce62-43db-966b-8145a094e040"],
    "IDVB_BAT": ["ece9bb0c-43b6-4558-a0ec-1812c34cd6ca"],
    "IDVB_DIT": ["91bffdf9-9432-410f-86ef-1c228ed0ad70"],
    "IDVB_EIT": ["442db029-02cb-4495-8b92-1c13375bce99"],
    "IDVB_EIT2": ["61a389e0-9b9e-4ba0-aeea-5ddd159820ea"],
    "IDVB_NIT": ["c64935f4-29e4-4e22-911a-63f7f55cb097"],
    "IDVB_RST": ["f47dcd04-1e23-4fb7-9f96-b40eead10b2b"],
    "IDVB_SDT": ["02cad8d3-fe43-48e2-90bd-450ed9a8a5fd"],
    "IDVB_SIT": ["68cdce53-8bea-45c2-9d9d-acf575a089b5"],
    "IDVB_ST": ["4d5b9f23-2a02-45de-bcda-5d5dbfbfbe62"],
    "IDVB_TDT": ["0780dc7d-d55c-4aef-97e6-6b75906e2796"],
    "IDVB_TOT": ["83295d6a-faba-4ee1-9b15-8067696910ae"],
    "IDVEnc": ["d18e17a0-aacb-11d0-afb0-00aa00b67a42"],
    "IDVRGB219": ["58473a19-2bc8-4663-8012-25f81babddd1"],
    "IDVSplitter": ["92a3a302-da7c-4a1f-ba7e-1802bb5d2d02"],
    "IDXCoreAdapter": ["f0db4c7f-fe5a-42a2-bd62-f2a6cf6fc83e"],
    "IDXCoreAdapterFactory": ["78ee5945-c36e-4b13-a669-005dd11c0f06"],
    "IDXCoreAdapterList": ["526c7776-40e9-459b-b711-f32ad76dfc28"],
    "IDXGIAdapter1": ["29038f61-3839-4626-91fd-086879011a05"],
    "IDXGIAdapter2": ["0aa1ae0a-fa0e-4b84-8644-e05ff8e5acb5"],
    "IDXGIAdapter3": ["645967a4-1392-4310-a798-8053ce3e93fd"],
    "IDXGIAdapter4": ["3c8d99d1-4fbf-4181-a82c-af66bf7bd24e"],
    "IDXGIDebug": ["119e7452-de9e-40fe-8806-88f90c12b441"],
    "IDXGIDebug1": ["c5a05f0c-16f2-4adf-9f4d-a8c4d58ac550"],
    "IDXGIDecodeSwapChain": ["2633066b-4514-4c7a-8fd8-12ea98059d18"],
    "IDXGIDevice1": ["77db970f-6276-48ba-ba28-070143b4392c"],
    "IDXGIDevice2": ["05008617-fbfd-4051-a790-144884b4f6a9"],
    "IDXGIDevice3": ["6007896c-3244-4afd-bf18-a6d3beda5023"],
    "IDXGIDevice4": ["95b4f95f-d8da-4ca4-9ee6-3b76d5968a10"],
    "IDXGIDisplayControl": ["ea9dbf1a-c88e-4486-854a-98aa0138f30c"],
    "IDXGIFactory1": ["770aae78-f26f-4dba-a829-253c83d1b387"],
    "IDXGIFactory2": ["50c83a1c-e072-4c48-87b0-3630fa36a6d0"],
    "IDXGIFactory3": ["25483823-cd46-4c7d-86ca-47aa95b837bd"],
    "IDXGIFactory4": ["1bc6ea02-ef36-464f-bf0c-21ca39e5168a"],
    "IDXGIFactory5": ["7632e1f5-ee65-4dca-87fd-84cd75f8838d"],
    "IDXGIFactory6": ["c1b6694f-ff09-44a9-b03c-77900a0a1d17"],
    "IDXGIFactory7": ["a4966eed-76db-44da-84c1-ee9a7afb20a8"],
    "IDXGIFactoryMedia": ["41e7d1f2-a591-4f7b-a2e5-fa9c843e1c12"],
    "IDXGIInfoQueue": ["d67441c7-672a-476f-9e82-cd55b44949ce"],
    "IDXGIKeyedMutex": ["9d8e1289-d7b3-465f-8126-250e349af85d"],
    "IDXGIOutput1": ["00cddea8-939b-4b83-a340-a685226666cc"],
    "IDXGIOutput2": ["595e39d1-2724-4663-99b1-da969de28364"],
    "IDXGIOutput3": ["8a6bb301-7e7e-41f4-a8e0-5b32f7f99b18"],
    "IDXGIOutput4": ["dc7dca35-2196-414d-9f53-617884032a60"],
    "IDXGIOutput5": ["80a07424-ab52-42eb-833c-0c42fd282d98"],
    "IDXGIOutput6": ["068346e8-aaec-4b84-add7-137f513f77a1"],
    "IDXGIOutputDuplication": ["191cfac3-a341-470d-b26e-a864f428319c"],
    "IDXGIResource1": ["30961379-4609-4a41-998e-54fe567ee0c1"],
    "IDXGISurface1": ["4ae63092-6327-4c1b-80ae-bfe12ea32b86"],
    "IDXGISurface2": ["aba496dd-b617-4cb8-a866-bc44d7eb1fa2"],
    "IDXGISwapChain1": ["790a45f7-0d42-4876-983a-0a55cfe6f4aa"],
    "IDXGISwapChain2": ["a8be2ac4-199f-4946-b331-79599fb98de7"],
    "IDXGISwapChain3": ["94d99bdb-f1f8-4ab0-b236-7da0170edab1"],
    "IDXGISwapChain4": ["3d585d5a-bd4a-489e-b1f4-3dbcb6452ffb"],
    "IDXGISwapChainMedia": ["dd95b90b-f05f-4f6a-bd65-25bfb264bd84"],
    "IDXSurfacePick": ["30a5fb79-e11f-11d1-9064-00c04fd9189d"],
    "IDXVAHD_Device": ["95f12dfd-d77e-49be-815f-57d579634d6d"],
    "IDXVAHD_VideoProcessor": ["95f4edf4-6e03-4cd7-be1b-3075d665aa52"],
    "IDailyTrigger": ["126c5cd8-b288-41d5-8dbf-e491446adc5c"],
    "IDataChanged": ["fd216d21-456e-4621-bbde-68cc15bb0654"],
    "IDataCollector": ["038374ff-098b-11d8-9414-505054503030"],
    "IDataCollectorCollection": ["03837502-098b-11d8-9414-505054503030"],
    "IDataCollectorSet": ["03837520-098b-11d8-9414-505054503030"],
    "IDataCollectorSetCollection": ["03837524-098b-11d8-9414-505054503030"],
    "IDataContextChangedEventArgs": ["7da68e21-0b8f-4f9f-a143-f8e7780136a2"],
    "IDataCue": ["7c7f676d-1fbc-4e2d-9a87-ee38bd1dc637"],
    "IDataCue2": ["bc561b15-95f2-49e8-96f1-8dd5dac68d93"],
    "IDataInitialize": ["2206ccb1-19c1-11d1-89e0-00c04fd7a829"],
    "IDataItemCommandHandler": ["b451532e-89ac-4fc0-a057-c61e79b1fb40"],
    "IDataItemEventHandler": ["836e0f2d-d28b-4bae-9fcc-ef5b46c65d89"],
    "IDataManager": ["03837541-098b-11d8-9414-505054503030"],
    "IDataModelCB": ["43efc137-1403-4e73-89fc-a49fdbfc09ec"],
    "IDataModelConcept": ["fcb98d1d-1114-4fbf-b24c-effcb5def0d3"],
    "IDataModelManager": ["73fe19f4-a110-4500-8ed9-3c28896f508c"],
    "IDataModelManager2": ["f412c5ea-2284-4622-a660-a697160d3312"],
    "IDataModelNameBinder": ["af352b7b-8292-4c01-b360-2dc3696c65e7"],
    "IDataModelScript": ["7b4d30fc-b14a-49f8-8d87-d9a1480c97f7"],
    "IDataModelScriptClient": ["3b362b0e-89f0-46c6-a663-dfdc95194aef"],
    "IDataModelScriptDebug": ["de8e0945-9750-4471-ab76-a8f79d6ec350"],
    "IDataModelScriptDebug2": ["cbb10ed3-839e-426c-9243-e23535c1ae1a"],
    "IDataModelScriptDebugBreakpoint": ["6bb27b35-02e6-47cb-90a0-5371244032de"],
    "IDataModelScriptDebugBreakpointEnumerator": ["39484a75-b4f3-4799-86da-691afa57b299"],
    "IDataModelScriptDebugClient": ["53159b6d-d4c4-471b-a863-5b110ca800ca"],
    "IDataModelScriptDebugStack": ["051364dd-e449-443e-9762-fe578f4a5473"],
    "IDataModelScriptDebugStackFrame": ["dec6ed5e-6360-4941-ab4c-a26409de4f82"],
    "IDataModelScriptDebugVariableSetEnumerator": ["0f9feed7-d045-4ac3-98a8-a98942cf6a35"],
    "IDataModelScriptHostContext": ["014d366a-1f23-4981-9219-b2db8b402054"],
    "IDataModelScriptManager": ["6fd11e33-e5ad-410b-8011-68c6bc4bf80d"],
    "IDataModelScriptProvider": ["513461e0-4fca-48ce-8658-32f3e2056f3b"],
    "IDataModelScriptProviderEnumerator": ["95ba00e2-704a-4fe2-a8f1-a7e7d8fb0941"],
    "IDataModelScriptTemplate": ["1303dec4-fa3b-4f1b-9224-b953d16babb5"],
    "IDataModelScriptTemplateEnumerator": ["69ce6ae2-2268-4e6f-b062-20ce62bfe677"],
    "IDataObjectAsyncCapability": ["3d8b0590-f691-11d2-8ea9-006097df5bd4"],
    "IDataObjectProvider": ["3d25f6d6-4b2a-433c-9184-7c33ad35d001"],
    "IDataPackage": ["61ebf5c7-efea-4346-9554-981d7e198ffe"],
    "IDataPackage2": ["041c1fe9-2409-45e1-a538-4c53eeee04a7"],
    "IDataPackage3": ["88f31f5d-787b-4d32-965a-a9838105a056"],
    "IDataPackage4": ["13a24ec8-9382-536f-852a-3045e1b29a3b"],
    "IDataPackageHostEventDetails": ["03a8e14f-039b-4ebb-aa77-5c2a992a9000"],
    "IDataPackagePostProcessor": ["3557af0e-d460-4113-ba67-6cf66d5595f1"],
    "IDataPackagePriv": ["cd1c0ba1-0ccb-4a33-9652-fe27a738c219"],
    "IDataPackagePropertySet": ["cd1c93eb-4c4c-443a-a8d3-f5c241e91689"],
    "IDataPackagePropertySet2": ["eb505d4a-9800-46aa-b181-7b6f0f2b919a"],
    "IDataPackagePropertySet3": ["9e87fd9b-5205-401b-874a-455653bd39e8"],
    "IDataPackagePropertySet4": ["6390ebf5-1739-4c74-b22f-865fab5e8545"],
    "IDataPackagePropertySetView": ["b94cec01-0c1a-4c57-be55-75d01289735d"],
    "IDataPackagePropertySetView2": ["6054509b-8ebe-4feb-9c1e-75e69de54b84"],
    "IDataPackagePropertySetView3": ["db764ce5-d174-495c-84fc-1a51f6ab45d7"],
    "IDataPackagePropertySetView4": ["4474c80d-d16f-40ae-9580-6f8562b94235"],
    "IDataPackagePropertySetView5": ["6f0a9445-3760-50bb-8523-c4202ded7d78"],
    "IDataPackageView": ["7b840471-5900-4d85-a90b-10cb85fe3552"],
    "IDataPackageView2": ["40ecba95-2450-4c1d-b6b4-ed45463dee9c"],
    "IDataPackageView3": ["d37771a8-ddad-4288-8428-d1cae394128b"],
    "IDataPackageView4": ["dfe96f1f-e042-4433-a09f-26d6ffda8b85"],
    "IDataPackageViewPriv": ["6f9bf6c5-569e-4980-b12a-596a08bef5a8"],
    "IDataPlanStatus": ["977a8b8c-3885-40f3-8851-42cd2bd568bb"],
    "IDataPlanUsage": ["b921492d-3b44-47ff-b361-be59e69ed1b0"],
    "IDataProtectionInfo": ["8420b0c1-5e31-4405-9540-3f943af0cb26"],
    "IDataProtectionManagerStatics": ["b6149b74-9144-4ee4-8a8a-30b5f361430e"],
    "IDataProtectionProvider": ["09639948-ed22-4270-bd1c-6d72c00f8787"],
    "IDataProtectionProviderFactory": ["adf33dac-4932-4cdf-ac41-7214333514ca"],
    "IDataProvider": ["5ebc8d33-d04e-4576-ae40-0a8631f319e6"],
    "IDataProviderDeferral": ["c2cf2373-2d26-43d9-b69d-dcb86d03f6da"],
    "IDataProviderHandler": ["e7ecd720-f2f4-4a2d-920e-170a2f482a27"],
    "IDataProviderRequest": ["ebbc7157-d3c8-47da-acde-f82388d5f716"],
    "IDataReader": ["e2b50029-b4c1-4314-a4b8-fb813a2f275e"],
    "IDataReaderFactory": ["d7527847-57da-4e15-914c-06806699a098"],
    "IDataReaderStatics": ["11fcbfc8-f93a-471b-b121-f379e349313c"],
    "IDataRequest": ["4341ae3b-fc12-4e53-8c02-ac714c415a27"],
    "IDataRequestDeferral": ["6dc4b89f-0386-4263-87c1-ed7dce30890e"],
    "IDataRequestedEventArgs": ["cb8ba807-6ac5-43c9-8ac5-9ba232163182"],
    "IDataRetrieverCallback": ["71b4863b-f969-4676-bbc3-3d9fdc3fb2c7"],
    "IDataSourceLocator": ["2206ccb2-19c1-11d1-89e0-00c04fd7a829"],
    "IDataTemplate": ["9910aec7-8ab5-4118-9bc6-09f45a35073d"],
    "IDataTemplateComponent": ["08429dc8-8ab0-4747-aa9a-feadfc8da8e1"],
    "IDataTemplateExtension": ["595e9547-cdff-4b92-b773-ab396878f353"],
    "IDataTemplateFactory": ["51ed9d7e-2b53-475b-9c88-0c1832c8351a"],
    "IDataTemplateKey": ["873b6c28-cceb-4b61-86fa-b2cec39cc2fa"],
    "IDataTemplateKeyFactory": ["e96b2959-d982-4152-91cb-de0e4dfd7693"],
    "IDataTemplateSelector": ["a907d496-46a0-4cd7-8dbe-f9a581df60b1"],
    "IDataTemplateSelector2": ["3792bc47-8c4b-4257-a5ae-cc3f8ed786eb"],
    "IDataTemplateSelectorFactory": ["511baad0-210a-457d-9521-433d2b11b7d2"],
    "IDataTemplateSelectorOverrides": ["2d162925-5966-4bfa-8638-4d345689f6cf"],
    "IDataTemplateSelectorOverrides2": ["6c3fb5fc-8e84-4c91-ac15-04a1d885500f"],
    "IDataTemplateStatics2": ["8af77d73-aa01-471e-bedd-8bad86219b77"],
    "IDataTransfer": ["86fa2fd1-a5ed-11cf-b57d-00aa00a71d1a"],
    "IDataTransferManager": ["a5caee9b-8708-49d1-8d36-67d25a8da00c"],
    "IDataTransferManager2": ["30ae7d71-8ba8-4c02-8e3f-ddb23b388715"],
    "IDataTransferManagerInterop": ["3a3dcd6c-3eab-43dc-bcde-45671ce800c8"],
    "IDataTransferManagerStatics": ["a9da01aa-e00e-4cfe-aa44-2dd932dca3d8"],
    "IDataTransferManagerStatics2": ["c54ec2ec-9f97-4d63-9868-395e271ad8f5"],
    "IDataTransferManagerStatics3": ["05845473-6c82-4f5c-ac23-62e458361fac"],
    "IDataWriter": ["64b89265-d341-4922-b38a-dd4af8808c4e"],
    "IDataWriterFactory": ["338c67c2-8b84-4c2b-9c50-7b8767847a1f"],
    "IDatagramSocket": ["7fe25bbb-c3bc-4677-8446-ca28a465a3af"],
    "IDatagramSocket2": ["d83ba354-9a9d-4185-a20a-1424c9c2a7cd"],
    "IDatagramSocket3": ["37544f09-ab92-4306-9ac1-0c381283d9c6"],
    "IDatagramSocketControl": ["52ac3f2e-349a-4135-bb58-b79b2647d390"],
    "IDatagramSocketControl2": ["33ead5c2-979c-4415-82a1-3cfaf646c192"],
    "IDatagramSocketControl3": ["d4eb8256-1f6d-4598-9b57-d42a001df349"],
    "IDatagramSocketInformation": ["5f1a569a-55fb-48cd-9706-7a974f7b1585"],
    "IDatagramSocketMessageReceivedEventArgs": ["9e2ddca2-1712-4ce4-b179-8c652c6d107e"],
    "IDatagramSocketStatics": ["e9c62aee-1494-4a21-bb7e-8589fc751d9d"],
    "IDatePickedEventArgs": ["a1527b12-59c1-4521-b28c-b176675e7c5a"],
    "IDatePicker": ["06da3946-08b8-4103-8b8a-093efd6a7657"],
    "IDatePicker2": ["bb28b475-2c1f-4340-9e30-948f99c9e57a"],
    "IDatePicker3": ["7da12a3b-a764-5ae1-abae-6affc1428e1e"],
    "IDatePickerAutomationPeer": ["d07d357f-a0b9-45dc-991a-76c505e7d0f5"],
    "IDatePickerAutomationPeerFactory": ["e5667d19-9157-4436-9f4d-7fb99174b48e"],
    "IDatePickerFactory": ["eec3ca84-9896-4a7d-bb35-6fb21eaeca11"],
    "IDatePickerFlyout": ["fbf33b1a-a3a4-4df8-9228-23a5ac27df4e"],
    "IDatePickerFlyout2": ["cfb18dbb-9931-4119-8bda-54a86fdfac84"],
    "IDatePickerFlyoutItem": ["9d9bc289-00d2-4aac-9c85-d74f06367887"],
    "IDatePickerFlyoutItemStatics": ["aa9c91da-07f6-4cdf-89b4-dda3bdb0ea6b"],
    "IDatePickerFlyoutPresenter": ["7c62f70e-2ddc-4381-832f-54cbdfaa849a"],
    "IDatePickerFlyoutPresenter2": ["c5b2578f-96d8-55cc-97ee-3f88fc85e479"],
    "IDatePickerFlyoutPresenterAutomationPeer": ["752aed38-c2bf-4880-82b2-a6c05e90c135"],
    "IDatePickerFlyoutPresenterStatics2": ["4dc0c49e-1f8e-5966-bbdb-215750c73aba"],
    "IDatePickerFlyoutStatics": ["cd570377-5845-4c12-8c10-592d9fcc7cd9"],
    "IDatePickerFlyoutStatics2": ["afd3e569-81e6-4b54-84a9-68079b73e34e"],
    "IDatePickerSelectedValueChangedEventArgs": ["564dceed-744a-5c3a-9bd2-4dcd9919a7b7"],
    "IDatePickerStatics": ["182e7c69-2116-4c67-b513-713364831d79"],
    "IDatePickerStatics2": ["f1076df6-fba6-4550-8b88-a6420847f60d"],
    "IDatePickerStatics3": ["a9f80afe-a30a-5f26-a446-fec2075d4a0e"],
    "IDatePickerValueChangedEventArgs": ["1ae661b2-b1b4-4273-96e0-19daff187446"],
    "IDateTimeFormatter": ["95eeca10-73e0-4e4b-a183-3d6ad0ba35ec"],
    "IDateTimeFormatter2": ["27c91a86-bdaa-4fd0-9e36-671d5aa5ee03"],
    "IDateTimeFormatterFactory": ["ec8d8a53-1a2e-412d-8815-3b745fb1a2a0"],
    "IDateTimeFormatterStatics": ["bfcde7c0-df4c-4a2e-9012-f47daf3f1212"],
    "IDateTimeSettingsStatics": ["5d2150d1-47ee-48ab-a52b-9f1954278d82"],
    "IDebugAD1Program2_V7": ["b7bdab6c-9077-43d0-87c4-96d1fd851446"],
    "IDebugActivateDocumentEvent2": ["58f36c3d-7d07-4eba-a041-62f63e188037"],
    "IDebugAddress": ["c2e34ebb-8b9d-11d2-9014-00c04fa38338"],
    "IDebugAddress2": ["877a0da6-a43e-4046-9be3-f916aff4fa7b"],
    "IDebugAdvanced": ["f2df5f53-071f-47bd-9de6-5734c3fed689"],
    "IDebugAdvanced2": ["716d14c9-119b-4ba5-af1f-0890e672416a"],
    "IDebugAdvanced3": ["cba4abb4-84c4-444d-87ca-a04e13286739"],
    "IDebugAdvanced4": ["d1069067-2a65-4bf0-ae97-76184b67856b"],
    "IDebugAlias": ["de7ccb92-94ac-4841-b354-5827b68217e7"],
    "IDebugApplication110": ["2039d958-4eeb-496a-87bb-2e5201eadeef", "bdb3b5de-89f2-4e11-84a5-97445f941c7d"],
    "IDebugApplication11032": ["bdb3b5de-89f2-4e11-84a5-97445f941c7d"],
    "IDebugApplication11064": ["2039d958-4eeb-496a-87bb-2e5201eadeef"],
    "IDebugApplicationNode100": ["90a7734e-841b-4f77-9384-a2891e76e7e2"],
    "IDebugApplicationThread110": ["2194ac5c-6561-404a-a2e9-f57d72de3702", "420aa4cc-efd8-4dac-983b-47127826917d"],
    "IDebugApplicationThread11032": ["2194ac5c-6561-404a-a2e9-f57d72de3702"],
    "IDebugApplicationThread11064": ["420aa4cc-efd8-4dac-983b-47127826917d"],
    "IDebugApplicationThreadEvents110": ["84e5e468-d5da-48a8-83f4-40366429007b"],
    "IDebugArrayField": ["c2e34eb7-8b9d-11d2-9014-00c04fa38338"],
    "IDebugArrayObject": ["29ecd774-75ae-11d2-b74e-0000f87572ef"],
    "IDebugArrayObject2": ["41487e33-9a10-42fe-ba3b-15fde59d09d5"],
    "IDebugAsyncTask120": ["7eab8ebe-0f51-4cc1-b69c-a379a31c6847"],
    "IDebugAttachCompleteEvent2": ["fe1fd9ea-6413-4183-a67d-588870014e97"],
    "IDebugAttachSecurityCallback2": ["a19e7faf-cb6f-43ba-ac16-bde9823d6dd1"],
    "IDebugBeforeSymbolSearchEvent2": ["b15c8149-2b81-40ae-9388-62fa276ae14c"],
    "IDebugBinder": ["c077c833-476c-11d2-b73c-0000f87572ef"],
    "IDebugBinder2": ["dcf3c6ee-7c7d-4e1f-aeeb-646902af0723"],
    "IDebugBinder3": ["bbcd7263-b415-40f6-942a-4a9a8599b708"],
    "IDebugBinderDirect": ["9db3e3b8-84f5-488e-93eb-b3ce3e33edab"],
    "IDebugBinderDirect100": ["00ca5803-6adc-49b3-adcb-a2b538b5665e"],
    "IDebugBitField": ["c2e34eba-8b9d-11d2-9014-00c04fa38338"],
    "IDebugBoundBreakpoint110": ["f7d19258-7aed-45c5-bb5a-1657b035360d"],
    "IDebugBoundBreakpoint2": ["d533d975-3f32-4876-abd0-6d37fda563e7"],
    "IDebugBoundBreakpoint3": ["60f49115-ce92-4f96-8d0a-81cccae4ab77"],
    "IDebugBreakEvent2": ["c7405d1d-e24b-44e0-b707-d8a5a4e1641b"],
    "IDebugBreakpoint": ["5bd9d474-5975-423a-b88b-65a8e7110e65"],
    "IDebugBreakpoint2": ["1b278d20-79f2-426e-a3f9-c1ddf375d48e"],
    "IDebugBreakpoint3": ["38f5c249-b448-43bb-9835-579d4ec02249"],
    "IDebugBreakpointBoundEvent2": ["1dddb704-cf99-4b8a-b746-dabb01dd13a0"],
    "IDebugBreakpointChecksumRequest2": ["0ea91cf7-8542-4780-8d6b-7bd686cd2471"],
    "IDebugBreakpointErrorEvent2": ["abb0ca42-f82b-4622-84e4-6903ae90f210"],
    "IDebugBreakpointEvent2": ["501c1e21-c557-48b8-ba30-a1eab0bc4a74"],
    "IDebugBreakpointFileUpdateNotification110": ["a87ab572-49c1-4bf5-9f1b-e0a3f94ca27b"],
    "IDebugBreakpointRequest110": ["8ab88b04-2586-47ce-8a23-e3130f86296f"],
    "IDebugBreakpointRequest2": ["6015fd18-8257-4df3-ac42-f074dedd4cbd"],
    "IDebugBreakpointRequest3": ["5c18a5fe-7150-4e66-8246-27bfb0e7bfd9"],
    "IDebugBreakpointResolution2": ["b7e66f28-035a-401a-afc7-2e300bd29711"],
    "IDebugBreakpointUnboundEvent2": ["78d1db4f-c557-4dc5-a2dd-5369d21b1c8c"],
    "IDebugCOMPlusProgramNode2": ["d6f7d3d0-506a-448f-8702-46eb2745e4fc"],
    "IDebugCallbackNotificationHandler": ["30510842-98b5-11cf-bb82-00aa00bdce0b"],
    "IDebugCanStopEvent2": ["b5b0d747-d4d2-4e2d-872d-74da22037826"],
    "IDebugClassField": ["c2e34eb5-8b9d-11d2-9014-00c04fa38338"],
    "IDebugClient": ["27fe5639-8407-4f47-8364-ee118fb08ac8"],
    "IDebugClient2": ["edbed635-372e-4dab-bbfe-ed0d2f63be81"],
    "IDebugClient3": ["dd492d7f-71b8-4ad6-a8dc-1c887479ff91"],
    "IDebugClient4": ["ca83c3de-5089-4cf8-93c8-d892387f2a5e"],
    "IDebugClient5": ["e3acb9d7-7ec2-4f0c-a0da-e81e0cbbe628"],
    "IDebugClient6": ["fd28b4c5-c498-4686-a28e-62cad2154eb3"],
    "IDebugClient7": ["13586be3-542e-481e-b1f2-8497ba74f9a9"],
    "IDebugCodeContext100": ["653f13a7-7e53-4f48-bde8-8ef8d3bc3c57"],
    "IDebugCodeContext120A": ["98a98e96-a59a-4580-925f-4e7ff5a49cfe"],
    "IDebugCodeContext150": ["0eb39b6b-8eff-4b9d-8cbd-eda45d5c588f"],
    "IDebugCodeContext2": ["ac17b76b-2b09-419a-ad5f-7d7402da8875"],
    "IDebugCodeContext3": ["17c106b9-0925-42f5-ae32-1fc019649c10"],
    "IDebugCodeContextInfoCompletionRoutine150": ["bf4cd6e7-7ad0-45a4-b1bf-d94bbbf0b0e5"],
    "IDebugCodePath90": ["7372dce0-f816-4e35-8b42-64b7f50e6395"],
    "IDebugComPlusSnapshot2": ["f6f94d20-78c2-11d2-8ffe-00c04fa38314"],
    "IDebugComPlusSymbolProvider": ["c2e34eaf-8b9d-11d2-9014-00c04fa38338"],
    "IDebugComPlusSymbolProvider2": ["29d97d99-2c50-4855-bc74-b3e372ddd602"],
    "IDebugComPlusSymbolSearchInfo": ["f96f4d16-e799-492d-b33d-2325e63d4135"],
    "IDebugCompiledExpression110": ["a528d84a-06d7-48b0-8825-614f4c5c1f68"],
    "IDebugComputeKernel110": ["ed1847bc-ef75-459f-a1da-5042cf83f229"],
    "IDebugComputeKernelDispatchEvent110": ["e157b5e4-7380-4516-9624-c5ba188d8431"],
    "IDebugComputeThread110": ["e50a6e8d-74ba-4f69-956d-9c27d86f5922"],
    "IDebugComputeThreadPropertyChangedEvent110": ["9daaccd8-4368-4391-b8d5-3e4a6b794a20"],
    "IDebugContainerField": ["c2e34eb2-8b9d-11d2-9014-00c04fa38338"],
    "IDebugControl": ["5182e668-105e-416e-ad92-24ef800424ba"],
    "IDebugControl2": ["d4366723-44df-4bed-8c7e-4c05424f4588"],
    "IDebugControl3": ["7df74a86-b03f-407f-90ab-a20dadcead08"],
    "IDebugControl4": ["94e60ce9-9b41-4b19-9fc0-6d9eb35272b3"],
    "IDebugControl5": ["b2ffe162-2412-429f-8d1d-5bf6dd824696"],
    "IDebugControl6": ["bc0d583f-126d-43a1-9cc4-a860ab1d537b"],
    "IDebugControl7": ["b86fb3b1-80d4-475b-aea3-cf06539cf63a"],
    "IDebugCoreServer2": ["17bf8fa3-4c5a-49a3-b2f8-5942e1ea287e"],
    "IDebugCoreServer3": ["12c1180e-c257-4485-9800-af484b699713"],
    "IDebugCoreServer90": ["1a1b5760-fe45-4958-aa3f-819060b16de9"],
    "IDebugCurrentThreadChangedEvent100": ["8764364b-0c52-4c7c-af6a-8b19a8c98226"],
    "IDebugCustomAttribute": ["a3a37c5e-8d71-487d-a9e1-b9a1b3ba9cbb"],
    "IDebugCustomAttributeQuery": ["dfd37b5a-1e3a-4f15-8098-220abadc620b"],
    "IDebugCustomAttributeQuery2": ["7d257f89-ef56-43c4-80ff-c89b064e4680"],
    "IDebugCustomENCModule100": ["a39a3ddd-af4d-48fa-bc0d-7afd3fcdee9b"],
    "IDebugCustomEvent110": ["2615d9bc-1948-4d21-81ee-7a963f20cf59"],
    "IDebugCustomViewer": ["6306e526-9e02-4696-bff9-48338a27f8af"],
    "IDebugDataGrid": ["411f3e08-e6b1-4789-ab29-755c52e52ac4"],
    "IDebugDataSpaces": ["88f7dfab-3ea7-4c3a-aefb-c4e8106173aa"],
    "IDebugDataSpaces2": ["7a5e852f-96e9-468f-ac1b-0b3addc4a049"],
    "IDebugDataSpaces3": ["23f79d6c-8aaf-4f7c-a607-9995f5407e63"],
    "IDebugDataSpaces4": ["d98ada1f-29e9-4ef5-a6c0-e53349883212"],
    "IDebugDefaultPort110": ["690ffd4f-6336-4689-9bc6-c8f87c1d333c"],
    "IDebugDefaultPort2": ["302f0f55-1ede-4777-9b38-115e1f229d56"],
    "IDebugDisassemblyStream2": ["e5b017fe-dfb0-411c-8266-7c64d6f519f8"],
    "IDebugDoNotUseThisInterface165": ["d2d94ae8-5ee6-4ed2-bcea-eae8cbf261fb"],
    "IDebugDocument120": ["54271ecb-d88e-42c5-b8af-137f851e57e2"],
    "IDebugDocument2": ["1606dd73-5d5f-405c-b4f4-ce32baba2501"],
    "IDebugDocumentChecksum2": ["c1c74db7-a3a7-40a2-a279-a63ba756b8b0"],
    "IDebugDocumentContext150": ["3cfd5762-425b-4a0b-a962-3a6cacbcaef5"],
    "IDebugDocumentContext155": ["e8111c77-5764-498d-9e48-5f1d37c5b538"],
    "IDebugDocumentContext2": ["931516ad-b600-419c-88fc-dcf5183b5fa9"],
    "IDebugDocumentPosition110": ["d3376546-5c4b-46f4-9e38-2cc7c0c2eb41"],
    "IDebugDocumentPosition2": ["bdde0eee-3b8d-4c82-b529-33f16b42832e"],
    "IDebugDocumentPositionOffset2": ["037edd0f-8551-4f7f-8ca0-04d9e29f532d"],
    "IDebugDocumentText2": ["4b0645aa-08ef-4cb9-adb9-0395d6edad35"],
    "IDebugDocumentTextEvents2": ["33ec72e3-002f-4966-b91c-5ce2f7ba5124"],
    "IDebugDumpModule100": ["12e0c541-6479-4c3c-a48d-8ffa223208c2"],
    "IDebugDynamicField": ["b5a2a5ea-d5ab-11d2-9033-00c04fa302a1"],
    "IDebugDynamicFieldCOMPlus": ["b5b20820-e233-11d2-9037-00c04fa302a1"],
    "IDebugENC": ["b104d8b7-af19-11d2-922c-00a02448799a"],
    "IDebugENC110": ["fcca721f-237b-4f21-9b63-976babab3aae"],
    "IDebugENC2": ["54b61a02-4823-42ec-9648-a9ae80cda270"],
    "IDebugENCBuildInfo2": ["ea70281b-bd58-11d2-9238-00a02448799a"],
    "IDebugENCDocumentContextUpdate": ["f5637291-d779-4580-a82c-0d523e7fdcf0"],
    "IDebugENCInfo2": ["6b56106f-bd51-11d2-9238-00a02448799a"],
    "IDebugENCLineMap": ["8706233b-bd4c-11d2-9238-00a02448799a"],
    "IDebugENCModule": ["95b8097d-3201-4b21-887c-239ee0a0d589"],
    "IDebugENCModule2": ["a58ff1f1-1fff-44b4-a311-55d6675f4a0f"],
    "IDebugENCRelinkInfo2": ["cbb63a8d-bd57-11d2-9238-00a02448799a"],
    "IDebugENCSnapshot2": ["f6f94d0e-78c2-11d2-8ffe-00c04fa38314"],
    "IDebugENCSnapshot3": ["3f50c7d0-d1af-4a97-ad81-7fdd5934ad32"],
    "IDebugENCStackFrame2": ["b3c64d7f-db9d-47c7-b479-c579c7f07103"],
    "IDebugENCStateEvents": ["ec80d064-102e-435f-aafb-d37e2a4ef654"],
    "IDebugENCSymbolProvider2": ["ff6d3520-e8d9-4e8c-bb75-cffa7b03c633"],
    "IDebugENCUpdate": ["978baee7-bd4c-11d2-9238-00a02448799a"],
    "IDebugENCUpdateOnRelinkEvent2": ["0ebf1959-bd57-11d2-9238-00a02448799a"],
    "IDebugENCUpdateOnStaleCodeEvent2": ["2f01eb29-bd57-11d2-9238-00a02448799a"],
    "IDebugEncNotify": ["347c45e1-5c42-4e0e-9e15-deff9cfc7841"],
    "IDebugEngine110": ["6f274ec0-3772-415c-969f-58bac0e2c5a9"],
    "IDebugEngine150": ["0c6c8422-1241-4fb1-8106-5762c7e27e59"],
    "IDebugEngine2": ["ba105b52-12f1-4038-ae64-d95785874c47"],
    "IDebugEngine3": ["a60384f6-3712-4cb3-bc46-81e6402fee99"],
    "IDebugEngineCreateEvent2": ["fe5b734c-759d-4e59-ab04-f103343bdd06"],
    "IDebugEngineJITSettings2": ["b9f3fdf1-7b6d-4899-bd94-72e4d4acd2e1"],
    "IDebugEngineLaunch100": ["1ac3d265-c50c-4c12-9b1a-c93f7291fc12"],
    "IDebugEngineLaunch2": ["c7c1462f-9736-466c-b2c1-b6b2dedbf4a7"],
    "IDebugEngineProgram140": ["e74b9a86-4fdd-4ad6-995e-38977ff3ad15"],
    "IDebugEngineProgram2": ["7ce3e768-654d-4ba7-8d95-cdaac642b141"],
    "IDebugEngineStepFilterManager90": ["de74abe1-c625-4768-81b3-8eddab72ca20"],
    "IDebugEngineSymbolProviderServices": ["83919262-acd6-11d2-9028-00c04fa302a1"],
    "IDebugEngineSymbolProviderServices2": ["d318e959-22ab-4eea-9a06-962b11afdc29"],
    "IDebugEntryPointEvent2": ["e8414a3e-1642-48ec-829e-5f4040e16da9"],
    "IDebugEnumField": ["c2e34eb9-8b9d-11d2-9014-00c04fa38338"],
    "IDebugErrorBreakpoint2": ["74570ef7-2486-4089-800c-56e3829b5ca4"],
    "IDebugErrorBreakpointResolution2": ["603aedf8-9575-4d30-b8ca-124d1c98ebd8"],
    "IDebugErrorEvent2": ["fdb7a36c-8c53-41da-a337-8bd86b14d5cb"],
    "IDebugEvent2": ["423238d6-da42-4989-96fb-6bba26e72e09"],
    "IDebugEventCallback2": ["ade2eeb9-fc85-4f5b-b5d9-d431b4aac31a"],
    "IDebugEventCallbacks": ["337be28b-5036-4d72-b6bf-c45fbb9f2eaa"],
    "IDebugEventCallbacksT": ["0690e046-9c23-45ac-a04f-987ac29ad0d3", "337be28b-5036-4d72-b6bf-c45fbb9f2eaa"],
    "IDebugEventCallbacksWide": ["0690e046-9c23-45ac-a04f-987ac29ad0d3"],
    "IDebugEventContextCallbacks": ["61a4905b-23f9-4247-b3c5-53d087529ab7"],
    "IDebugExceptionCallback2": ["6f5cfda4-47d3-4a90-a882-14427237bcee"],
    "IDebugExceptionCondition": ["fbfd0196-b9a4-48fc-ab5e-77e4a2efd887"],
    "IDebugExceptionConditionList": ["14fb02ff-2d1b-496a-96c7-2f565bbfcea4"],
    "IDebugExceptionDetails": ["15030210-d2c0-410d-9044-9f8091b992d8"],
    "IDebugExceptionDetails164": ["766a0544-ae86-4c9a-8dfb-bd0d71f30d9a"],
    "IDebugExceptionEvent120": ["9c954ace-8041-4c57-ad2a-d9e2cf2e565e"],
    "IDebugExceptionEvent150": ["a91ad17c-1174-4563-9c1e-56c837c2adee"],
    "IDebugExceptionEvent2": ["51a94113-8788-4a54-ae15-08b74ff922d0"],
    "IDebugExceptionSettingsChangeNotification140": ["95a6c633-4a5f-46a0-b1a9-85145b163955"],
    "IDebugExceptionSettingsChangeNotification150": ["acc93823-3cb2-421e-af29-272777ae8180"],
    "IDebugExceptionSettingsManager140": ["73ea578a-d148-4b71-b894-58fc82451450"],
    "IDebugExceptionSettingsManager150": ["791019de-09c3-4438-9a74-078511727a09"],
    "IDebugExpression157": ["15fa3968-a6eb-481d-a55d-eb6927dac066"],
    "IDebugExpression2": ["f7473fd0-7f75-478d-8d85-a485204e7a2d"],
    "IDebugExpressionCompilationContext110": ["3de09ace-d2b6-4054-b17b-1120b0160283"],
    "IDebugExpressionContext2": ["37a44580-d5fc-473e-a048-21702ebfc466"],
    "IDebugExpressionEvaluationCompleteEvent2": ["c0e13a85-238a-4800-8315-d947c960a843"],
    "IDebugExpressionEvaluator": ["c077c822-476c-11d2-b73c-0000f87572ef"],
    "IDebugExpressionEvaluator100": ["643cd3d4-043d-410c-8201-7e83c8918a91"],
    "IDebugExpressionEvaluator2": ["2de1d5e0-ca57-456f-815c-5902825a2795"],
    "IDebugExpressionEvaluator3": ["4c7ec6f5-bb6c-43a2-853c-80ff48b7a8a6"],
    "IDebugExtendedField": ["20f22571-aa1c-4724-ad0a-bde2d19d6163"],
    "IDebugField": ["c2e34eb1-8b9d-11d2-9014-00c04fa38338"],
    "IDebugFirewallConfigurationCallback2": ["ba3288db-224a-4fd6-a37e-64e7abe9c4a1"],
    "IDebugFuncEvalAbortedEvent2": ["3f3be369-0b78-4511-91e5-08f9fc5cae0d"],
    "IDebugFunctionObject": ["f71d9ea0-4269-48dc-9e8d-f86defa042b3"],
    "IDebugFunctionObject2": ["8e861cc7-d21c-43e7-ab7b-947921689b88"],
    "IDebugFunctionPosition2": ["1ede3b4b-35e7-4b97-8133-02845d600174"],
    "IDebugGenericFieldDefinition": ["c5717d6c-8dbf-4852-b7d8-c003ee09541f"],
    "IDebugGenericFieldInstance": ["c93c9dd0-0a65-4966-bceb-633eeee2e096"],
    "IDebugGenericParamField": ["941105e9-760a-49ec-995f-7668cb60216c"],
    "IDebugGroupEvaluationCompleteEvent110": ["ba675acf-e798-4b06-a843-c0ed2631e015"],
    "IDebugHost": ["b8c74943-6b2c-4eeb-b5c5-35d378a6d99d"],
    "IDebugHostBaseClass": ["b94d57d2-390b-40f7-b5b4-b6db897d974b"],
    "IDebugHostConstant": ["62787edc-fa76-4690-bd71-5e8c3e2937ec"],
    "IDebugHostContext": ["a68c70d8-5ec0-46e5-b775-3134a48ea2e3"],
    "IDebugHostData": ["a3d64993-826c-44fa-897d-926f2fe7ad0b"],
    "IDebugHostErrorSink": ["c8ff0f0b-fce9-467e-8bb3-5d69ef109c00"],
    "IDebugHostEvaluator": ["0fef9a21-577e-4997-ac7b-1c4883241d99"],
    "IDebugHostEvaluator2": ["a117a435-1fb4-4092-a2ab-a929576c1e87"],
    "IDebugHostExtensibility": ["3c2b24e1-11d0-4f86-8ae5-4df166f73253"],
    "IDebugHostField": ["e06f6495-16bc-4cc9-b11d-2a6b23fa72f3"],
    "IDebugHostMemory": ["212149c9-9183-4a3e-b00e-4fd1dc95339b"],
    "IDebugHostMemory2": ["eea033de-38f6-416b-a251-1d3771001270"],
    "IDebugHostModule": ["c9ba3e18-d070-4378-bbd0-34613b346e1e"],
    "IDebugHostModule2": ["b51887e8-bcd0-4e8f-a8c7-434398b78c37"],
    "IDebugHostModuleSignature": ["31e53a5a-01ee-4bbb-b899-4b46ae7d595c"],
    "IDebugHostPublic": ["6c597ac9-fb4d-4f6d-9f39-22488539f8f4"],
    "IDebugHostScriptHost": ["b70334a4-b92c-4570-93a1-d3eb686649a0"],
    "IDebugHostStatus": ["4f3e1ce2-86b2-4c7a-9c65-d0a9d0eecf44"],
    "IDebugHostSymbol": ["0f819103-87de-4e96-8277-e05cd441fb22"],
    "IDebugHostSymbol2": ["21515b67-6720-4257-8a68-077dc944471c"],
    "IDebugHostSymbolEnumerator": ["28d96c86-10a3-4976-b14e-eaef4790aa1f"],
    "IDebugHostSymbols": ["854fd751-c2e1-4eb2-b525-6619cb97a588"],
    "IDebugHostType": ["f219b848-63b2-4a43-a6c9-72abf25a9711"],
    "IDebugHostType2": ["b28632b9-8506-4676-87ce-8f7e05e59876"],
    "IDebugHostTypeSignature": ["3aadc353-2b14-4abb-9893-5e03458e07ee"],
    "IDebugIDBInfo2": ["9b7de9a9-bd59-11d2-9238-00a02448799a"],
    "IDebugIDECallback": ["b78c9e91-dd39-4e5b-bb7b-30b88149b2fe"],
    "IDebugIDEJIT2": ["b2f73449-98ea-4866-90a0-425837fc5e23"],
    "IDebugInputCallbacks": ["9f50e42c-f136-499e-9a97-73036c94ed2d"],
    "IDebugInterceptExceptionCompleteEvent2": ["44fceaca-7f56-4d2c-a637-60052b1b9cbe"],
    "IDebugIteratorFrameProvider": ["a38ef241-af3e-49a9-8533-0e35b6794d40"],
    "IDebugJIT2": ["2ea4c00d-7156-4f8e-b990-fb4271147617"],
    "IDebugJMCWarningEvent140": ["bc87fb3f-20a5-432c-88e3-de67d0ed86b1"],
    "IDebugLaunchCustomTelemetryProvider": ["f63a5f5c-de4e-4361-8361-3178dbc0e675"],
    "IDebugLaunchedProcessAttachRequestEvent110": ["7a529a0a-d8ed-4abd-8218-f216b081ef3e"],
    "IDebugLoadCompleteEvent2": ["b1844850-1349-45d4-9f12-495212f5eb0b"],
    "IDebugLogicalThread120": ["fca685e7-45f2-4c36-beb8-be982087479f"],
    "IDebugLogicalThread2": ["88d2f75b-d329-4e03-9b75-201f7782d8bd"],
    "IDebugLostBreakStateEvent150": ["33b3c3d1-9a81-4d9a-ad69-14d66148d818"],
    "IDebugMDMUtil2_V7": ["f3062547-43d8-4dc2-b18e-e1460ff2c422"],
    "IDebugMDMUtil3_V7": ["af598dea-ce92-443b-a0b5-9992ff660bc4"],
    "IDebugMachine2_V7": ["17bf8fa3-4c5a-49a3-b2f8-5942e1ea287e"],
    "IDebugMachineEx2_V7": ["ae27b230-a0bf-47ff-a2d1-22c29a178eac"],
    "IDebugManagedENC": ["12dcd8b7-ebfc-4dbe-a72c-3e44cdd3cbaf"],
    "IDebugManagedExceptionInfo2": ["d288564a-edb2-4214-8690-ff9a82870379"],
    "IDebugManagedObject": ["71af87c9-66c5-49e4-a602-b9012115afd5"],
    "IDebugMemoryBytes2": ["925837d1-3aa1-451a-b7fe-cc04bb42cfb8"],
    "IDebugMemoryContext2": ["1ab276dd-f27b-4445-825d-5df0b4a04a3a"],
    "IDebugMessageEvent2": ["3bdb28cf-dbd2-4d24-af03-01072b67eb9e"],
    "IDebugMetaDataDebugEmit2": ["f6f94d22-78c2-11d2-8ffe-00c04fa38314"],
    "IDebugMetaDataEmit2": ["f6f94d21-78c2-11d2-8ffe-00c04fa38314"],
    "IDebugMethodField": ["c2e34eb4-8b9d-11d2-9014-00c04fa38338"],
    "IDebugModOpt": ["b90282fc-2d44-4050-a7b2-bf3bcff8baf1"],
    "IDebugModule2": ["0fc1cd9a-b912-405c-a04c-43ce02cd7df2"],
    "IDebugModule3": ["245f9d6a-e550-404d-82f1-fdb68281607a"],
    "IDebugModuleLoadEvent2": ["989db083-0d7c-40d1-a9d9-921bf611a4b2"],
    "IDebugModuleManaged": ["232397f8-b232-479d-b1bb-2f044c70a0f9"],
    "IDebugModuleReloadOperationCompleteEvent100": ["e72b36e9-8ec2-4dee-b96b-c18b752c98c8"],
    "IDebugNativeExceptionInfo": ["3d320710-06c0-437b-a55f-826f48cc7ee7"],
    "IDebugNativePort2": ["521b4726-04e9-47e7-b3a5-cd93a7f74f5b"],
    "IDebugNativeSnapshot2": ["461fda3e-bba5-11d2-b10f-00c04f72dc32"],
    "IDebugNativeSymbolProvider": ["c2e34eb0-8b9d-11d2-9014-00c04fa38338"],
    "IDebugNoSymbolsEvent2": ["3ad4fb48-647e-4b03-9c1e-52754e80c880"],
    "IDebugObject": ["c077c823-476c-11d2-b73c-0000f87572ef"],
    "IDebugObject2": ["3ff130fc-b14f-4bae-ae44-46b1cd3928cc"],
    "IDebugObject90": ["2b8f1709-ec30-48ac-9baa-23867a5076dc"],
    "IDebugOptionList120A": ["bd0e4180-eeb9-45cf-9341-1cb4ca98ce07"],
    "IDebugOutputCallbacks": ["4bf58045-d654-4c40-b0af-683090f356dc"],
    "IDebugOutputCallbacks2": ["67721fe9-56d2-4a44-a325-2b65513ce6eb"],
    "IDebugOutputCallbacksT": ["4bf58045-d654-4c40-b0af-683090f356dc", "4c7fd663-c394-4e26-8ef1-34ad5ed3764c"],
    "IDebugOutputCallbacksWide": ["4c7fd663-c394-4e26-8ef1-34ad5ed3764c"],
    "IDebugOutputStream": ["7782d8f2-2b85-4059-ab88-28ceddca1c80"],
    "IDebugOutputStringEvent2": ["569c4bb1-7b82-46fc-ae28-4536ddad753e"],
    "IDebugParsedExpression": ["7895c94c-5a3f-11d2-b742-0000f87572ef"],
    "IDebugPendingBreakpoint2": ["6e215ef3-e44c-44d1-b7ba-b2401f7dc23d"],
    "IDebugPendingBreakpoint3": ["96643d32-2624-479a-9f1a-25d02030dd3b"],
    "IDebugPlmClient": ["a02b66c4-aea3-4234-a9f7-fe4c383d4e29"],
    "IDebugPlmClient2": ["597c980d-e7bd-4309-962c-9d9b69a7372c"],
    "IDebugPlmClient3": ["cdf48669-901f-4791-b868-7d2cb3a2d7fc"],
    "IDebugPointerField": ["c2e34eb8-8b9d-11d2-9014-00c04fa38338"],
    "IDebugPointerObject": ["112756a1-3f04-4ccd-bfd6-acb4bca614c9"],
    "IDebugPointerObject2": ["bf032216-2c7f-4682-84c1-76ef432d840b"],
    "IDebugPointerObject3": ["b69d88f9-bc5a-4eb3-a43c-9af3155f0632"],
    "IDebugPort2": ["79293cc8-d9d9-43f5-97ad-0bcc5a688776"],
    "IDebugPortEvents2": ["564fa275-12e1-4b5f-8316-4d79bcef7246"],
    "IDebugPortEventsEx2": ["608a5912-e66b-4278-b6ed-847ac9318405"],
    "IDebugPortEx2": ["e2314ee1-5c8c-4a9d-ad32-0c9a3574f685"],
    "IDebugPortNotify2": ["fb8d2032-2858-414c-83d9-f732664e0c7a"],
    "IDebugPortPicker": ["8d6eed60-2737-4425-b38a-490ef273acbb"],
    "IDebugPortRequest2": ["8d36beb8-9bfe-47dd-a11b-7ba1de18e449"],
    "IDebugPortSupplier2": ["53f68191-7b2f-4f14-8e55-40b1b6e5df66"],
    "IDebugPortSupplier3": ["5b5eec44-51aa-4210-b84f-1938b8576d8d"],
    "IDebugPortSupplierDescription2": ["d0785faa-91d7-4ca2-a302-6555487719f7"],
    "IDebugPortSupplierEx2": ["c1f9ba1d-f70f-49f8-839e-5e0caa230306"],
    "IDebugPortSupplierLocale2": ["1bbab55e-6d13-4a5e-8c81-34ab2a3a6269"],
    "IDebugPrimitiveTypeField": ["7a739554-3fc6-43ee-981d-f49171151393"],
    "IDebugProcess2": ["43286fea-6997-4543-803e-60a20c473de5"],
    "IDebugProcess3": ["83ab1712-18a6-47a1-8da6-8c7b0f96092e"],
    "IDebugProcessContinueEvent100": ["c703ebea-42e7-4768-85a9-692eecba567b"],
    "IDebugProcessCreateEvent2": ["bac3780f-04da-4726-901c-ba6a4633e1ca"],
    "IDebugProcessDestroyEvent2": ["3e2a0832-17e1-4886-8c0e-204da242995f"],
    "IDebugProcessEnhancedStep90": ["c446ca51-979a-4096-b996-5934b7ab0455"],
    "IDebugProcessEx2": ["82d71df5-6597-48c4-b5d5-b8b697fa36b5"],
    "IDebugProcessInfoUpdatedEvent158": ["96c242fc-f584-4c3e-8fed-384d3d13ef36"],
    "IDebugProcessQueryProperties": ["230a0071-62ef-4cae-aac0-8988c37024bf"],
    "IDebugProcessSecurity2": ["fca0c35c-4c02-432b-88f7-eb277be2ba55"],
    "IDebugProcessStartTime140": ["a385590e-f94c-47a5-bc29-84bd01526171"],
    "IDebugProgram110": ["007d8d53-acbe-4fc6-99be-6bbf13d9f8d3"],
    "IDebugProgram150": ["6ec6f085-ffbe-41b8-979f-f885a86ea181"],
    "IDebugProgram2": ["69d172ef-f2c4-44e1-89f7-c86231e706e9"],
    "IDebugProgram3": ["7cf3ec7f-ac62-4cd6-bb30-39a464cb52cb"],
    "IDebugProgramCreateEvent2": ["96cd11ee-ecd4-4e89-957e-b5d496fc4139"],
    "IDebugProgramDestroyEvent2": ["e147e9e3-6440-4073-a7b7-a65592c714b5"],
    "IDebugProgramDestroyEventFlags2": ["7e072bee-24e7-43eb-9bce-06402c70e018"],
    "IDebugProgramEngines2": ["fda24a6b-b142-447d-bbbc-8654a3d84f80"],
    "IDebugProgramEnhancedStep90": ["6d07112f-b30d-47b4-b5ce-45b26c29205a"],
    "IDebugProgramEx2": ["2959618a-a692-48ff-8cef-7a28a4f50954"],
    "IDebugProgramHost2": ["c99d588f-778c-44fe-8b2e-40124a738891"],
    "IDebugProgramJIT2": ["87379803-2fad-4801-abdf-218b5d2f076f"],
    "IDebugProgramNameChangedEvent2": ["e05c2dfd-59d5-46d3-a71c-5d07665d85af"],
    "IDebugProgramNode2": ["426e255c-f1ce-4d02-a931-f9a254bf7f0f"],
    "IDebugProgramNodeAttach2": ["73faa608-5f87-4d2b-9551-8440b1cbf54c"],
    "IDebugProgramProvider2": ["1959530a-8e53-4e09-ad11-1b7334811cad"],
    "IDebugProgramPublisher2": ["a3dddf26-7792-4544-a9a4-d4dfb11cd8f3"],
    "IDebugProperty110": ["9119092a-be6b-44f0-914a-c9e83b9223cf"],
    "IDebugProperty150": ["6f4e34da-6b2b-4624-93c5-93a058cd95de"],
    "IDebugProperty157": ["790d60a3-2f26-426f-8a3c-53db57d4cd29"],
    "IDebugProperty158": ["e02453b1-f68a-47c1-b243-25760004a4b9"],
    "IDebugProperty160": ["c6c64271-4fde-485a-899b-d00e628f6a82"],
    "IDebugProperty164": ["b66d2821-1aed-489d-b376-42270d737c78"],
    "IDebugProperty2": ["a7ee3e7e-2dd2-4ad7-9697-f4aae3427762"],
    "IDebugProperty3": ["94e1e004-0672-423d-ad62-78783def1e76"],
    "IDebugPropertyBag110": ["574f2363-bd5b-43d4-a30f-3a0c562d5bef"],
    "IDebugPropertyClose2": ["852c7d42-794f-43cd-a18f-cd40e83e67cd"],
    "IDebugPropertyCreateEvent2": ["ded6d613-a3db-4e35-bb5b-a92391133f03"],
    "IDebugPropertyDestroyEvent2": ["f3765f18-f395-4b8c-8e95-dcb3fe8e7ec8"],
    "IDebugPropertyField": ["c2e34eb6-8b9d-11d2-9014-00c04fa38338"],
    "IDebugPropertySafetyWrapper": ["7031886b-61d2-4cb5-b909-00386090733b"],
    "IDebugProviderProgramNode2": ["afdba726-047a-4b83-b8c7-d812fe9caa5c"],
    "IDebugQueryEngine2": ["c989adc9-f305-4ef5-8ca2-20898e8d0e28"],
    "IDebugQueryPerformanceCountersCompletionRoutine150": ["442fbf28-fa75-4697-aa4f-41dc1e9b7777"],
    "IDebugReference2": ["10b793ac-0c47-4679-8454-adb36f29f802"],
    "IDebugRefreshBreakStateEvent162": ["4966ee8b-ef5c-4aa4-b4ba-7217ff345cbe"],
    "IDebugRefreshNotification140": ["23d9a2f7-d25a-4963-a59e-4828cb4fecab"],
    "IDebugRegisters": ["ce289126-9e84-45a7-937e-67bb18691493"],
    "IDebugRegisters2": ["1656afa9-19c6-4e3a-97e7-5dc9160cf9c4"],
    "IDebugRemoteServer2": ["3d3ce5c4-1508-4711-a5eb-f848f6e10072"],
    "IDebugRemoteServerFactory2": ["4a5af829-ca32-4b01-aae4-4c53d260e75c"],
    "IDebugRestrictedExceptionInfo110": ["24ef7776-1eb8-42f6-8146-ec673fbce5b4"],
    "IDebugReturnValueEvent2": ["0da4d4cc-2d0b-410f-8d5d-b6b73a5d35d8"],
    "IDebugReversibleEngineProgram160": ["7f7a3651-e3d2-4137-8367-56fcccaab4dc"],
    "IDebugReversibleSessionProcess160": ["a9bf4fb5-c25e-4fad-bdc4-ab9d9c72dce9"],
    "IDebugRuntimeJITServerProvider2": ["e7f35f78-362c-4d8a-8f76-3a7dbae0a237"],
    "IDebugSQLCLRProgramNode2": ["f617dfcb-0045-4024-837b-7acad8f4d67b"],
    "IDebugSession150": ["6b762667-eb09-4b7e-ac1a-5baabccc412a"],
    "IDebugSession2": ["8948300f-8bd5-4728-a1d8-83d172295a9d"],
    "IDebugSession3": ["bbf74db9-39d5-406e-8bc3-3ba9dd34c02e"],
    "IDebugSessionCreateEvent2": ["2c2b15b7-fc6d-45b3-9622-29665d964a76"],
    "IDebugSessionDestroyEvent2": ["f199b2c2-88fe-4c5d-a0fd-aa046b0dc0dc"],
    "IDebugSessionEvent2": ["fd1a378c-f117-4f43-917c-dadca1308606"],
    "IDebugSessionProcess110": ["e0b1eeac-4cb1-4421-a46b-c7a42f89ab67"],
    "IDebugSessionProcess120": ["c80129aa-876a-4f3b-81bb-8497ade9d47a"],
    "IDebugSessionProperty2": ["72ff2712-0bc3-4308-a99d-26ac7ec68c5f"],
    "IDebugSetJITEventCallback2": ["92dca9c3-37a3-4498-8466-4c57ea885e49"],
    "IDebugSetValueCallback": ["e0284f01-eda1-11d0-b452-00a0244a1dd2"],
    "IDebugSettings": ["3d451f98-c6a7-4d17-8398-d83a067183d8"],
    "IDebugSettings2": ["48d37585-e1a6-469b-83c8-30825037119e"],
    "IDebugSettings3": ["e6bb5022-0625-479f-8e32-4b583d73b7ac"],
    "IDebugSettings4": ["c9001e45-e824-5a5f-866c-e20cec88a8fc"],
    "IDebugSettingsCallback110": ["712b9487-3492-42a4-87f4-a676ed3707ce"],
    "IDebugSettingsCallback2": ["050b1813-91db-47a0-8987-fc55bdd6362b"],
    "IDebugSourceLinkDocumentContext150": ["667f17de-b438-4ada-a1e5-5517db9f6533"],
    "IDebugSourceLinkInfo150": ["6a31f3f2-bf97-452d-888b-cd526d1e9d80"],
    "IDebugSourceServerModule": ["492e5541-215b-4f67-ad73-20f48614912e"],
    "IDebugStackFrame110": ["4b509611-b6ea-4b24-adcb-d0ccfd1a7e33", "5cfcaf33-9b58-49b3-9be3-e47bec9fa20c"],
    "IDebugStackFrame120": ["94967a8a-5c7b-42df-9415-d6896a51de6a"],
    "IDebugStackFrame157": ["3c0fe564-2dfa-40d4-842e-1b7747c4c3ea"],
    "IDebugStackFrame2": ["1412926f-5dd6-4e58-b648-e1c63e013d51"],
    "IDebugStackFrame3": ["60de844b-38b1-4d87-afe1-8cf49677d3b0"],
    "IDebugStepCompleteEvent2": ["0f7f24c1-74d9-4ea6-a3ea-7edb2d81441d"],
    "IDebugStepCompleteEvent90": ["82d3f946-c2f8-495b-8b5f-9c30acdc6c81"],
    "IDebugStepper90": ["c0aa96a2-ae7c-4d80-8831-c7c720f14cca"],
    "IDebugStopCompleteEvent2": ["3dca9dcd-fb09-4af1-a926-45f293d48b2d"],
    "IDebugSymbolGroup": ["f2528316-0f1a-4431-aeed-11d096e1e2ab"],
    "IDebugSymbolGroup2": ["6a7ccc5f-fb5e-4dcc-b41c-6c20307bccc7"],
    "IDebugSymbolProvider": ["c2e34eae-8b9d-11d2-9014-00c04fa38338"],
    "IDebugSymbolProviderDirect": ["533a62e9-fddd-4fef-b7c3-be4117773087"],
    "IDebugSymbolProviderGroup": ["2b226a06-ff61-44f3-9add-b34bd9f72fcb"],
    "IDebugSymbolSearchEvent2": ["638f7c54-c160-4c7b-b2d0-e0337bc61f8c"],
    "IDebugSymbolSettings100": ["142a0821-8b28-49af-bd41-eabd00a88f57"],
    "IDebugSymbols": ["8c31e98c-983a-48a5-9016-6fe5d667a950"],
    "IDebugSymbols2": ["3a707211-afdd-4495-ad4f-56fecdf8163f"],
    "IDebugSymbols3": ["f02fbecc-50ac-4f36-9ad9-c975e8f32ff8"],
    "IDebugSymbols4": ["e391bbd8-9d8c-4418-840b-c006592a1752"],
    "IDebugSymbols5": ["c65fa83e-1e69-475e-8e0e-b5d79e9cc17e"],
    "IDebugSystemObjects": ["6b86fe2c-2c4f-4f0c-9da2-174311acc327"],
    "IDebugSystemObjects2": ["0ae9f5ff-1852-4679-b055-494bee6407ee"],
    "IDebugSystemObjects3": ["e9676e2f-e286-4ea3-b0f9-dfe5d9fc330e"],
    "IDebugSystemObjects4": ["489468e6-7d0f-4af5-87ab-25207454d553"],
    "IDebugTelemetryDetailsEvent150": ["8f2652b2-cd3c-4aed-a946-a3db6f379412"],
    "IDebugThisAdjust": ["49473e34-d4cc-49c8-bf62-79a08d2134a5"],
    "IDebugThread100": ["8590dd4c-bf52-4aef-8348-e0dac9c65268"],
    "IDebugThread120": ["daabf75d-aed6-4857-83c9-aaf589057c3d"],
    "IDebugThread156": ["f6cd61c6-b706-488a-96c0-1fc3f10ae514"],
    "IDebugThread157": ["43c7542b-f624-4e1f-9761-bb5a9396caff"],
    "IDebugThread2": ["d5168050-a57a-465c-bea9-974f405eba13"],
    "IDebugThread3": ["43d24196-0000-467f-8c6b-9c006922d02f"],
    "IDebugThread90": ["8fd7f3bb-c09e-4c0c-830f-114ffa8bf4f8"],
    "IDebugThreadCreateEvent2": ["2090ccfc-70c5-491d-a5e8-bad2dd9ee3ea"],
    "IDebugThreadDestroyEvent2": ["2c3b7532-a36f-4a6e-9072-49be649b8541"],
    "IDebugThreadDisplayNameChangeEvent100": ["39cbd675-bdf9-423a-884f-7ab36bf51af9"],
    "IDebugThreadFlagChangeEvent100": ["a4f87f48-d3c4-4694-a1a3-1969e3639ee7"],
    "IDebugThreadNameChangedEvent2": ["1ef4ef78-2c44-4b7a-8473-8f4357611729"],
    "IDebugThreadProperties": ["30ffaec1-c24c-440a-a9c5-1cc1cfd99dc8"],
    "IDebugThreadSuspendChangeEvent100": ["bd20393d-6d0c-44fb-a5e3-7bd5d1b640d1"],
    "IDebugTimedEvent140": ["5e1c7abd-5ebf-462c-866a-8fdcd3678250"],
    "IDebugTracepoint162": ["4be935f2-82c9-460c-8221-846e5147685e"],
    "IDebugTypeFieldBuilder": ["796ae40b-6cda-4f05-a663-d282a93ac7d4"],
    "IDebugTypeFieldBuilder2": ["eed3392e-c13a-42a9-932f-145c12b4fb5c"],
    "IDebugUpdateInMemoryPE": ["9e2bd568-7cee-4166-abc9-495ba8d3054a"],
    "IDebugUpdateInMemoryPE2": ["8a9e5aae-bef6-47a8-879b-690463516d73"],
    "IDebugUpdateInMemoryPE3": ["ae2ff3a4-2fa6-487c-ae74-9fb3d9276742"],
    "IDebugUserNotificationUI110": ["43fee995-53cd-41aa-9ec9-ca1281378788"],
    "IDebugUserNotificationUI120": ["e2e3aee2-9e39-40e5-8609-d43260630766"],
    "IDebugWindowsComputerPort2": ["5fbb8ed3-ecdb-412a-bfa3-3a54beb5b2d1"],
    "IDebugWrappedJITDebugger2": ["4dfa78ac-43c1-4de5-8179-3c3ec9010a31"],
    "IDebugWrappedMessageEvent140": ["d4a891bb-3f73-4964-a599-8b1210bcbc95"],
    "IDebuggerInfo": ["bf24142d-a47d-4d24-a66d-8c2141944e44"],
    "IDebuggerThreadControl": ["23d86786-0bb5-4774-8fb5-e3522add6246"],
    "IDecimalFormatterFactory": ["0d018c9a-e393-46b8-b830-7a69c8f89fbb"],
    "IDecimateVideoImage": ["2e5ea3e0-e924-11d2-b6da-00a0c995e8df"],
    "IDecompressor": ["b883fe46-d68a-4c8b-ada0-4ee813fc5283"],
    "IDecompressorFactory": ["5337e252-1da2-42e1-8834-0379d28d742f"],
    "IDedupBackupSupport": ["c719d963-2b2d-415e-acf7-7eb7ca596ff4"],
    "IDedupChunkLibrary": ["bb5144d7-2720-4dcc-8777-78597416ec23"],
    "IDedupDataPort": ["7963d734-40a9-4ea3-bbf6-5a89d26f7ae8"],
    "IDedupDataPortManager": ["44677452-b90a-445e-8192-cdcfe81511fb"],
    "IDedupIterateChunksHash32": ["90b584d3-72aa-400f-9767-cad866a5a2d8"],
    "IDedupReadFileCallback": ["7bacc67a-2f1d-42d0-897e-6ff62dd533bb"],
    "IDefaultAudioDeviceChangedEventArgs": ["110f882f-1c05-4657-a18e-47c9b69f07ab"],
    "IDefaultBrowserSyncSettings": ["7a27faad-5ae6-4255-9030-c530936292e3"],
    "IDefaultDeviceChangeNotification": ["af089eb5-4c6f-463b-bc06-dd5bf098b39d"],
    "IDefaultDeviceFactory": ["2972cef7-7f0f-41db-926f-d2ee5fca715b"],
    "IDefaultDeviceProvider": ["aaad6f87-9f5e-4a20-9cd7-8e2682315fb4"],
    "IDefaultExtractIconInit": ["41ded17d-d6b3-4261-997d-88c60e4b1d58"],
    "IDefaultFolderMenuInitialize": ["7690aa79-f8fc-4615-a327-36f7d18f5d91"],
    "IDefaultLocation": ["a65af77e-969a-4a2e-8aca-33bb7cbb1235"],
    "IDefaultPresentationConfiguration": ["d8c2b53b-2168-5703-a853-d525589fe2b9"],
    "IDeferral": ["d6269732-3b7f-46a7-b40b-4fdca2a2c693"],
    "IDeferralCompletedHandler": ["ed32a372-f3c8-4faa-9cfb-470148da3888"],
    "IDeferralFactory": ["65a1ecc5-3fb5-4832-8ca9-f061b281d13a"],
    "IDeferredInvoke": ["5edd2d9b-be4e-40b1-b783-b6e30a18c70b"],
    "IDefinitionAppId": ["d91e12d8-98ed-47fa-9936-39421283d59b"],
    "IDefinitionIdentity": ["587bf538-4d90-4a3c-9ef1-58a200a8a9e7"],
    "IDelayedPropertyStoreFactory": ["40d4577f-e237-4bdb-bd69-58f089431b6a"],
    "IDelayedVisibility": ["68a4fdba-a48a-4a86-a329-1b69b9b19e89"],
    "IDelegateHostItemContainer": ["02468693-e7e5-4c6b-9995-64ce5f51cec4"],
    "IDelegateItem": ["3c5a1c94-c951-4cb7-bb6d-3b93f30cce93"],
    "IDeleteBrowsingHistory": ["cf38ed4b-2be7-4461-8b5e-9a466dc82ae3"],
    "IDeleteLibraryCallback": ["234c2b44-4ea4-4114-ae7d-0f2e65622544"],
    "IDeliveryOptimizationCleanup": ["6692fd56-3b9b-433a-ac04-3ffb442556dd"],
    "IDeliveryOptimizationJob": ["ee2584cf-a69c-4848-b633-2649962b3ef7"],
    "IDeliveryOptimizationJobNotify": ["9787568a-71ff-42c8-8717-c40ec82f9185"],
    "IDeliveryOptimizationMgmt": ["baab12a9-fc1a-43e4-a915-ad826aeec8d8"],
    "IDeliveryOptimizationMgmtAdmin": ["eef3a6ae-ff2a-4a62-825b-060202082f12"],
    "IDeliveryOptimizationMgr": ["00aa9211-f3d0-4f46-9080-78bebff98836"],
    "IDeliveryOptimizationNotify": ["4ee9204b-6b39-4651-8529-98e848e45667"],
    "IDeliveryOptimizationOptions": ["90970731-fd64-4e53-9960-fe11b8fb8a2f"],
    "IDeliveryOptimizationPolicy": ["6a1c005c-ec79-4bbb-88b5-188bc45611ca"],
    "IDeliveryOptimizationSettings": ["1810fda0-e853-565e-b874-7a8a7b9a0e0f"],
    "IDeliveryOptimizationSettingsStatics": ["5c817caf-aed5-5999-b4c9-8c60898bc4f3"],
    "IDemuxRender": ["8f7c48e9-e418-456f-9265-a922135b0d49"],
    "IDependencyObject": ["5c526665-f60e-4912-af59-5fe0680f089d"],
    "IDependencyObject2": ["29fed85d-3d22-43a1-add0-17027c08b212"],
    "IDependencyObjectCollectionFactory": ["051e79ff-b3a8-49ee-b5af-ac8f68b649e4"],
    "IDependencyObjectFactory": ["9a03af92-7d8a-4937-884f-ecf34fe02acb"],
    "IDependencyProperty": ["85b13970-9bc4-4e96-acf1-30c8fd3d55c8"],
    "IDependencyPropertyChangedCallback": ["45883d16-27bf-4bc1-ac26-94c1601f3a49"],
    "IDependencyPropertyChangedEventArgs": ["81212c2b-24d0-4957-abc3-224470a93a4e"],
    "IDependencyPropertyChangedEventHandler": ["09223e5a-75be-4499-8180-1ddc005421c0"],
    "IDependencyPropertyStatics": ["49e5f28f-8259-4d5c-aae0-83d56dbb68d9"],
    "IDeploymentResult": ["2563b9ae-b77d-4c1f-8a7b-20e6ad515ef3"],
    "IDeploymentResult2": ["fc0e715c-5a01-4bd7-bcf1-381c8c82e04a"],
    "IDepthCorrelatedCoordinateMapper": ["f95d89fb-8af0-4cb0-926d-696866e5046a"],
    "IDepthMediaFrame": ["47135e4f-8549-45c0-925b-80d35efdb10a"],
    "IDepthMediaFrame2": ["6cca473d-c4a4-4176-b0cd-33eae3b35aa3"],
    "IDepthMediaFrameFormat": ["c312cf40-d729-453e-8780-2e04f140d28e"],
    "IDesignModeStatics": ["2c3893cc-f81a-4e7a-b857-76a80887e185"],
    "IDesignModeStatics2": ["80cf8137-b064-4858-bec8-3eba22357535"],
    "IDesignerAppExitedEventArgs": ["f6aac86a-0cad-410c-8f62-dc2936151c74"],
    "IDesignerAppManager": ["a6272caa-d5c6-40cb-abd9-27ba43831bb7"],
    "IDesignerAppManagerFactory": ["8f9d633b-1266-4c0e-8499-0db85bbd4c43"],
    "IDesignerAppView": ["5c777cea-dd71-4a84-a56f-dacb4b14706f"],
    "IDeskBand2": ["79d16de4-abee-4021-8d9d-9169b261d657"],
    "IDeskBandEx": ["5dd6b79a-3ab7-49c0-ab82-6b2da7d78d75"],
    "IDeskBandInfo": ["77e425fc-cbf9-4307-ba6a-bb5727745661"],
    "IDeskBarClient": ["eb0fe175-1a3a-11d0-89b3-00a0c90a90ac"],
    "IDesktopGadget": ["c1646bc4-f298-4f91-a204-eb2dd1709d1a"],
    "IDesktopNotificationActivator": ["1a7e31ea-c744-4ac4-a0f6-d274c9314863"],
    "IDesktopTileActivator": ["17541a17-f509-4cb6-8d08-651dc68d8227"],
    "IDesktopVisibilityChangesNotification": ["fc413902-2a24-4522-ad1f-2d27c0ffee84"],
    "IDesktopVisibilityService": ["2af0421a-a7bc-4b7e-be85-7e17c0ffee84"],
    "IDesktopWallpaper": ["b92b56a9-8b55-4e14-9a89-0199bbb6f93b"],
    "IDesktopWallpaperPrivate": ["c182461f-dfac-4375-ab6e-4cc45aa7f9cc"],
    "IDesktopWindowTarget": ["6329d6ca-3366-490e-9db3-25312929ac51"],
    "IDesktopWindowXamlSource": ["d585bfe1-00ff-51be-ba1d-a1329956ea0a"],
    "IDesktopWindowXamlSourceFactory": ["5cd61dc0-2561-56e1-8e75-6e44173805e3"],
    "IDesktopWindowXamlSourceGotFocusEventArgs": ["39be4849-d9cc-5b70-8f05-1ad9a4aaa342"],
    "IDesktopWindowXamlSourceNative": ["3cbcf1bf-2f76-4e9c-96ab-e84b37972554"],
    "IDesktopWindowXamlSourceNative2": ["e3dcd8c7-3057-4692-99c3-7b7720afda31"],
    "IDesktopWindowXamlSourceTakeFocusRequestedEventArgs": ["fe61e4b9-a7af-52b3-bdb9-c3305c0b8df2"],
    "IDestInfo": ["000001cd-0000-0000-c000-000000000046"],
    "IDestinationStreamFactory": ["8a87781b-39a7-4a1f-aab3-a39b9c34a7d9"],
    "IDetectedFace": ["8200d454-66bc-34df-9410-e89400195414"],
    "IDetectionConfigurationAvailabilityChangedEventArgs": ["5129c9fb-4be8-5f14-af2b-88d62b1b4462"],
    "IDetectionConfigurationAvailabilityInfo": ["b5affeb0-40f0-5398-b838-91979c2c6208"],
    "IDevToolbarDownloadInitiatorInfo": ["6a29b837-5c21-4665-8df2-ee993760e2e1"],
    "IDeveloperConsoleMessageReceiver": ["30510808-98b5-11cf-bb82-00aa00bdce0b"],
    "IDeviceAccessChangedEventArgs": ["deda0bcc-4f9d-4f58-9dba-a9bc800408d5"],
    "IDeviceAccessChangedEventArgs2": ["82523262-934b-4b30-a178-adc39f2f2be3"],
    "IDeviceAccessInformation": ["0baa9a73-6de5-4915-8ddd-9a0554a6f545"],
    "IDeviceAccessInformationStatics": ["574bd3d3-5f30-45cd-8a94-724fe5973084"],
    "IDeviceAccessPolicyManager": ["02a175a2-f59b-4490-8008-da0592239633"],
    "IDeviceAccountConfiguration": ["ad0123a3-fbdc-4d1b-be43-5a27ea4a1b63"],
    "IDeviceAccountConfiguration2": ["f2b2e5a6-728d-4a4a-8945-2bf8580136de"],
    "IDeviceActivatedEventArgs": ["cd50b9a9-ce10-44d2-8234-c355a073ef33"],
    "IDeviceAgentTransport": ["a28f4830-7032-44fe-9038-c215ac298c22"],
    "IDeviceArrivedEventHandler": ["efa9da69-f6e1-49c9-a49e-8e0fc58fb911"],
    "IDeviceAssociationBroker": ["2b0796b2-0d8b-4022-a6b7-7ca7d79364d4"],
    "IDeviceAssociationBrokerCallback": ["49891994-b7ba-4a1f-b979-6bd1a43e6c5f"],
    "IDeviceAssociationBrokerCustomHandler": ["527c7d30-422d-4b52-a22c-832314bcf459"],
    "IDeviceAssociationCallback": ["aa035573-c122-420a-a2b5-557ebb4bdeb9"],
    "IDeviceAssociationSettings": ["036eb567-8c67-4ade-9555-3bd7ab6d69a2"],
    "IDeviceBroker": ["8604b268-34a6-4b1a-a59f-cdbd8379fd98"],
    "IDeviceConnectionChangeTrigger": ["90875e64-3cdd-4efb-ab1c-5b3b6a60ce34"],
    "IDeviceConnectionChangeTriggerDetails": ["b8578c0c-bbc1-484b-bffa-7b31dcc200b2"],
    "IDeviceConnectionChangeTriggerStatics": ["c3ea246a-4efd-4498-aa60-a4e4e3b17ab9"],
    "IDeviceController": ["4feeb26d-50a7-402b-896a-be95064d6bff"],
    "IDeviceControllerFinderHandler": ["a88a7d06-988c-4403-9d8a-015bed140b34"],
    "IDeviceDepartedEventHandler": ["efa9da69-f6e2-49c9-a49e-8e0fc58fb911"],
    "IDeviceDisconnectButtonClickedEventArgs": ["8e44b56d-f902-4a00-b536-f37992e6a2a7"],
    "IDeviceDiscoveryAndPairingBroker": ["c01664c1-4973-43b5-98eb-1b4af20bcb3a"],
    "IDeviceDiscoveryContext": ["999aa7de-6880-4676-bb24-8788a8f3badb"],
    "IDeviceDisplayPropertiesCallback": ["91867751-3d57-4614-b938-7065b758a035"],
    "IDeviceDisplayPropertiesProvider": ["ef05e46f-6730-40c6-bab1-96f2a8076226"],
    "IDeviceDisplayStatusFactory": ["db4b2731-7a52-4923-a603-908f7fa1eedc"],
    "IDeviceDisplayStatusFactory2": ["f167b5a5-cb97-48d7-a0ff-4e736240df46"],
    "IDeviceEnumerationHelper": ["6cf5b075-a9ca-44b3-999b-994304844d46"],
    "IDeviceGraphObjectCache": ["ce70eb76-c767-4c4a-bf83-322a29cec581"],
    "IDeviceGraphObjectCacheManager": ["97ecdc10-b3b5-4dff-8dcc-abd71ac23c33"],
    "IDeviceIcon": ["8ffb1a1e-023d-4de1-b556-ab5abf01929c"],
    "IDeviceIdentity": ["f2dc8b0c-0447-4e0c-909f-2a6d94390f6a"],
    "IDeviceInformation": ["aba0fb95-4398-489d-8e44-e6130927011f"],
    "IDeviceInformation2": ["f156a638-7997-48d9-a10c-269d46533f48"],
    "IDeviceInformationCustomPairing": ["85138c02-4ee6-4914-8370-107a39144c0e"],
    "IDeviceInformationPairing": ["2c4769f5-f684-40d5-8469-e8dbaab70485"],
    "IDeviceInformationPairing2": ["f68612fd-0aee-4328-85cc-1c742bb1790d"],
    "IDeviceInformationPairingStatics": ["e915c408-36d4-49a1-bf13-514173799b6b"],
    "IDeviceInformationPairingStatics2": ["04de5372-b7b7-476b-a74f-c5836a704d98"],
    "IDeviceInformationStatics": ["c17f100e-3a46-4a78-8013-769dc9b97390"],
    "IDeviceInformationStatics2": ["493b4f34-a84f-45fd-9167-15d1cb1bd1f9"],
    "IDeviceInformationUpdate": ["8f315305-d972-44b7-a37e-9e822c78213b"],
    "IDeviceInformationUpdate2": ["5d9d148c-a873-485e-baa6-aa620788e3cc"],
    "IDeviceIoControl": ["9eefe161-23ab-4f18-9b49-991b586ae970"],
    "IDeviceMetadataHelper": ["2c6d8250-3e48-4218-935a-e7a094879d96"],
    "IDeviceMetadataParser": ["6a8e8546-71d2-4c33-8cc8-62882f541d54"],
    "IDeviceModelPlugIn": ["1cd63475-07c4-46fe-a903-d655316d11fd"],
    "IDeviceNotificationCallback": ["a7eb8f00-ae98-4be6-b50f-49b933c7455d"],
    "IDevicePacketStream": ["bd6a1f9f-086e-41df-bad2-6c7b24825dcf"],
    "IDevicePair": ["f1a423f1-b7b4-449c-a90d-aea8e17c5e5f"],
    "IDevicePairingActivatedEventArgs": ["eba0d1e4-ecc6-4148-94ed-f4b37ec05b3e"],
    "IDevicePairingContext": ["16bd01cf-9e2c-4a71-a4b0-f720703231e0"],
    "IDevicePairingManager": ["81053590-ce20-472a-88d9-653eb4ea6473"],
    "IDevicePairingManagerCallback": ["948e7465-38f6-4d1d-8b6e-8d194fcb0cbd"],
    "IDevicePairingRequestedEventArgs": ["f717fc56-de6b-487f-8376-0180aca69963"],
    "IDevicePairingRequestedEventArgs2": ["c83752d9-e4d3-4db0-a360-a105e437dbdc"],
    "IDevicePairingResult": ["072b02bf-dd95-4025-9b37-de51adba37b7"],
    "IDevicePairingSettings": ["482cb27c-83bb-420e-be51-6602b222de54"],
    "IDevicePicker": ["84997aa2-034a-4440-8813-7d0bd479bf5a"],
    "IDevicePickerAppearance": ["e69a12c6-e627-4ed8-9b6c-460af445e56d"],
    "IDevicePickerFilter": ["91db92a2-57cb-48f1-9b59-a59b7a1f02a2"],
    "IDevicePortalConnection": ["0f447f51-1198-4da1-8d54-bdef393e09b6"],
    "IDevicePortalConnectionClosedEventArgs": ["fcf70e38-7032-428c-9f50-945c15a9f0cb"],
    "IDevicePortalConnectionRequestReceivedEventArgs": ["64dae045-6fda-4459-9ebd-ecce22e38559"],
    "IDevicePortalConnectionStatics": ["4bbe31e7-e9b9-4645-8fed-a53eea0edbd6"],
    "IDevicePortalWebSocketConnection": ["67657920-d65a-42f0-aef4-787808098b7b"],
    "IDevicePortalWebSocketConnectionRequestReceivedEventArgs": ["79fdcaba-175c-4739-9f74-dda797c35b3f"],
    "IDeviceRequestCompletionCallback": ["999bad24-9acd-45bb-8669-2a2fc0288b04"],
    "IDeviceSelectedEventArgs": ["269edade-1d2f-4940-8402-4156b81d3c77"],
    "IDeviceServicingDetails": ["4aabee29-2344-4ac4-8527-4a8ef6905645"],
    "IDeviceServicingTrigger": ["1ab217ad-6e34-49d3-9e6f-17f1b6dfa881"],
    "IDeviceSpecificProperty": ["3b22bcbf-2586-4af0-8583-205d391b807c"],
    "IDeviceStream": ["48956b2c-47f3-45ee-8ab3-b7b09220f8ac"],
    "IDeviceTicketManager": ["efce55bb-e93a-4478-ad33-edb7a0782dbe"],
    "IDeviceTopology": ["2a07407e-6497-4a18-9787-32f79bd0d98f"],
    "IDeviceTopologyTest": ["b9cacc9c-6879-4988-a3ce-ffd38e08ab93"],
    "IDeviceUnpairingResult": ["66f44ad3-79d9-444b-92cf-a92ef72571c7"],
    "IDeviceUseDetails": ["7d565141-557e-4154-b994-e4f7a11fb323"],
    "IDeviceUseTrigger": ["0da68011-334f-4d57-b6ec-6dca64b412e4"],
    "IDeviceWatcher": ["c9eab97d-8f6b-4f96-a9f4-abc814e22271"],
    "IDeviceWatcher2": ["ff08456e-ed14-49e9-9a69-8117c54ae971"],
    "IDeviceWatcherEvent": ["74aa9c0b-1dbd-47fd-b635-3cc556d0ff8b"],
    "IDeviceWatcherTrigger": ["a4617fdd-8573-4260-befc-5bec89cb693d"],
    "IDeviceWatcherTriggerDetails": ["38808119-4cb7-4e57-a56d-776d07cbfef9"],
    "IDevicesFlow": ["5b0d0ad4-9dcd-48c0-bfa0-7a407d50664d"],
    "IDevicesFlowController": ["1a94ebd6-6e02-4715-a74b-de718a1bc1b2"],
    "IDevicesFlowNotification": ["0f0a074d-1c9c-4668-b20f-c90f8818672f"],
    "IDiaAddressMap": ["b62a2e7a-067a-4ea3-b598-04c09717502c"],
    "IDiaDataSource": ["79f1bb5f-b66e-48e5-b6a9-1545c323ca3d"],
    "IDiaDataSource2": ["6d31cb3b-edd4-4c3e-ab44-12b9f7a3828e"],
    "IDiaDataSource3": ["65a23c15-bab3-45da-8639-f06de86b9ea8"],
    "IDiaDataSource4": ["27b468a6-229c-4248-8f5e-f326e7c62ba4"],
    "IDiaEnumDebugStreamData": ["486943e8-d187-4a6b-a3c4-291259fff60d"],
    "IDiaEnumDebugStreams": ["08cbb41e-47a6-4f87-92f1-1c9c87ced044"],
    "IDiaEnumFrameData": ["9fc77a4b-3c1c-44ed-a798-6c1deea53e1f"],
    "IDiaEnumInjectedSources": ["d5612573-6925-4468-8883-98cdec8c384a"],
    "IDiaEnumInputAssemblyFiles": ["1c7ff653-51f7-457e-8419-b20f57ef7e4d"],
    "IDiaEnumLineNumbers": ["fe30e878-54ac-44f1-81ba-39de940f6052"],
    "IDiaEnumSectionContribs": ["1994deb2-2c82-4b1d-a57f-aff424d54a68"],
    "IDiaEnumSegments": ["e8368ca9-01d1-419d-ac0c-e31235dbda9f"],
    "IDiaEnumSourceFiles": ["10f3dbd9-664f-4469-b808-9471c7a50538"],
    "IDiaEnumStackFrames": ["ec9d461d-ce74-4711-a020-7d8f9a1dd255"],
    "IDiaEnumSymbols": ["cab72c48-443b-48f5-9b0b-42f0820ab29a"],
    "IDiaEnumSymbolsByAddr": ["624b7d9c-24ea-4421-9d06-3b577471c1fa"],
    "IDiaEnumTables": ["c65c2b0a-1150-4d7a-afcc-e05bf3dee81e"],
    "IDiaFrameData": ["a39184b7-6a36-42de-8eec-7df9f3f59f33"],
    "IDiaImageData": ["c8e40ed2-a1d9-4221-8692-3ce661184b44"],
    "IDiaInjectedSource": ["ae605cdc-8105-4a23-b710-3259f1e26112"],
    "IDiaInputAssemblyFile": ["3bfe56b0-390c-4863-9430-1f3d083b7684"],
    "IDiaLineNumber": ["b388eb14-be4d-421d-a8a1-6cf7ab057086"],
    "IDiaLoadCallback": ["c32adb82-73f4-421b-95d5-a4706edf5dbe"],
    "IDiaLoadCallback2": ["4688a074-5a4d-4486-aea8-7b90711d9f7c"],
    "IDiaPropertyStorage": ["9d416f9c-e184-45b2-a4f0-ce517f719e9b"],
    "IDiaReadExeAtOffsetCallback": ["587a461c-b80b-4f54-9194-5032589a6319"],
    "IDiaReadExeAtRVACallback": ["8e3f80ca-7517-432a-ba07-285134aaea8e"],
    "IDiaSectionContrib": ["0cf4b60e-35b1-4c6c-bdd8-854b9c8e3857"],
    "IDiaSegment": ["0775b784-c75b-4449-848b-b7bd3159545b"],
    "IDiaSession": ["2f609ee1-d1c8-4e24-8288-3326badcd211", "6fc5d63f-011e-40c2-8dd2-e6486e9d6b68"],
    "IDiaSourceFile": ["a2ef5353-f5a8-4eb3-90d2-cb526acb3cdd"],
    "IDiaStackFrame": ["5edbc96d-cdd6-4792-afbe-cc89007d9610"],
    "IDiaStackWalkFrame": ["07c590c1-438d-4f47-bdcd-4397bc81ad75"],
    "IDiaStackWalkHelper": ["21f81b1b-c5bb-42a3-bc4f-ccbaa75b9f19"],
    "IDiaStackWalkHelper2": ["8222c490-507b-4bef-b3bd-41dca7b5934c"],
    "IDiaStackWalker": ["5485216b-a54c-469f-9670-52b24d5229bb"],
    "IDiaStackWalker2": ["7c185885-a015-4cac-9411-0f4fb39b1f3a"],
    "IDiaSymbol": ["cb787b2f-bd6c-4635-ba52-933126bd2dcd"],
    "IDiaTable": ["4a59fb77-abac-469b-a30b-9ecc85bfef14"],
    "IDiagnosticActionResult": ["c265a296-e73b-4097-b28f-3442f03dd831"],
    "IDiagnosticInvoker": ["187b270a-02e3-4f86-84fc-fdd892b5940f"],
    "IDiagnosticInvoker2": ["e3bf945c-155a-4b52-a8ec-070c44f95000"],
    "IDiagnosticInvokerStatics": ["5cfad8de-f15c-4554-a813-c113c3881b09"],
    "IDiagnosticsScriptEngine": ["30510859-98b5-11cf-bb82-00aa00bdce0b"],
    "IDiagnosticsScriptEngineProvider": ["3051085a-98b5-11cf-bb82-00aa00bdce0b"],
    "IDiagnosticsScriptEngineSite": ["30510858-98b5-11cf-bb82-00aa00bdce0b"],
    "IDiagnosticsSettings": ["e5e9eccd-2711-44e0-973c-491d78048d24"],
    "IDiagnosticsSettingsStatics": ["72d2e80f-5390-4793-990b-3ccc7d6ac9c8"],
    "IDialApp": ["555ffbd3-45b7-49f3-bbd7-302db6084646"],
    "IDialAppStateDetails": ["ddc4a4a1-f5de-400d-bea4-8c8466bb2961"],
    "IDialDevice": ["fff0edaf-759f-41d2-a20a-7f29ce0b3784"],
    "IDialDevice2": ["bab7f3d5-5bfb-4eba-8b32-b57c5c5ee5c9"],
    "IDialDevicePicker": ["ba7e520a-ff59-4f4b-bdac-d89f495ad6e1"],
    "IDialDevicePickerFilter": ["c17c93ba-86c0-485d-b8d6-0f9a8f641590"],
    "IDialDeviceSelectedEventArgs": ["480b92ad-ac76-47eb-9c06-a19304da0247"],
    "IDialDeviceStatics": ["aa69cc95-01f8-4758-8461-2bbd1cdc3cf3"],
    "IDialDisconnectButtonClickedEventArgs": ["52765152-9c81-4e55-adc2-0ebe99cde3b6"],
    "IDialReceiverActivatedEventArgs": ["fb777ed7-85ee-456e-a44d-85d730e70aed"],
    "IDialReceiverApp": ["fd3e7c57-5045-470e-b304-4dd9b13e7d11"],
    "IDialReceiverApp2": ["530c5805-9130-42ac-a504-1977dcb2ea8a"],
    "IDialReceiverAppStatics": ["53183a3c-4c36-4d02-b28a-f2a9da38ec52"],
    "IDialRequestedEventArgs": ["037b929e-953c-4286-8866-4f0f376c855a"],
    "IDialRequestedEventHandler": ["5abbffdb-c21f-4bc4-891b-257e28c1b1a4"],
    "IDialogWindowBroker": ["163e219f-16d9-4706-8b04-9f2852e153a6"],
    "IDigitalCableLocator": ["48f66a11-171a-419a-9525-beeecd51584c"],
    "IDigitalCableTuneRequest": ["bad7753b-6b37-4810-ae57-3ce0c4a9e6cb"],
    "IDigitalCableTuningSpace": ["013f9f9c-b449-4ec7-a6d2-9d4f2fc70ae5"],
    "IDigitalLocator": ["19b595d8-839a-47f0-96df-4f194f3c768c"],
    "IDirect3D11CaptureFrame": ["fa50c623-38da-4b32-acf3-fa9734ad800e"],
    "IDirect3D11CaptureFramePool": ["24eb6d22-1975-422e-82e7-780dbd8ddf24"],
    "IDirect3D11CaptureFramePoolStatics": ["7784056a-67aa-4d53-ae54-1088d5a8ca21"],
    "IDirect3D11CaptureFramePoolStatics2": ["589b103f-6bbc-5df5-a991-02e28b3b66d5"],
    "IDirect3D9ExEnumerationSettings": ["9dce9370-e1b7-43ed-9b77-908e62396cde"],
    "IDirect3D9ExOverlayExtension": ["187aeb13-aaf5-4c59-876d-e059088c0df8"],
    "IDirect3DAuthenticatedChannel9": ["ff24beee-da21-4beb-98b5-d2f899f98af9"],
    "IDirect3DCaptureContainer9": ["ab04a269-1f6b-422c-940f-d1a1d94f7d06"],
    "IDirect3DCryptoSession9": ["fa0ab799-7a9c-48ca-8c5b-237e71a54434"],
    "IDirect3DDXVA2Container9": ["126d0349-4787-4aa6-8e1b-40c177c60a01"],
    "IDirect3DDXVADevice9": ["9f00c3d3-5ab6-465f-b955-9f0ebb2c5606"],
    "IDirect3DDXVAExtensionDevice9": ["d54b57b4-4cdb-4ad6-97df-eab7aed7d3b7"],
    "IDirect3DDXVAHDDevice9": ["babba640-5592-48d9-8a84-07671b5534e4"],
    "IDirect3DDXVAHDVideoProcessor9": ["cb129961-b008-47d2-817b-5d2ff10e1ec1"],
    "IDirect3DDecodeDevice9": ["41f9cb11-d633-40bb-abf1-229262d7c3af"],
    "IDirect3DDevice9On12": ["e7fda234-b589-4049-940d-8878977531c8"],
    "IDirect3DDevice9Video": ["26dc4561-a1ee-4ae7-96da-118a36c0ec95"],
    "IDirect3DDeviceManager9": ["a0cade0f-06d5-4cf4-a1c7-f3cdd725aa75"],
    "IDirect3DShaderValidator9": ["814d5a8f-5a68-47f4-bcc6-d4d910b2a9e5"],
    "IDirect3DVideoDevice9": ["694036ac-542a-4a3a-9a32-53bc20002c1b"],
    "IDirect3DVideoProcessDevice9": ["74c5b367-a31f-4669-bcdd-e9547717dcbe"],
    "IDirectConnectedAnimationConfiguration": ["ee5d736f-5738-5d86-b770-151948cf365e"],
    "IDirectConnectedAnimationConfigurationFactory": ["059263e9-d2b3-5a77-9cf4-e26d8b542608"],
    "IDirectDraw3": ["618f8ad4-8b7a-11d0-8fcc-00c04fd9189d"],
    "IDirectDrawMediaSample": ["ab6b4afe-f6e4-11d0-900d-00c04fd9189d"],
    "IDirectDrawMediaSampleAllocator": ["ab6b4afc-f6e4-11d0-900d-00c04fd9189d"],
    "IDirectDrawMediaStream": ["f4104fce-9a70-11d0-8fde-00c04fd9189d"],
    "IDirectDrawStreamSample": ["f4104fcf-9a70-11d0-8fde-00c04fd9189d"],
    "IDirectManipulationAutoScrollBehavior": ["6d5954d4-2003-4356-9b31-d051c9ff0af7"],
    "IDirectManipulationCompositor": ["537a0825-0387-4efa-b62f-71eb1f085a7e"],
    "IDirectManipulationCompositor2": ["d38c7822-f1cb-43cb-b4b9-ac0c767a412e"],
    "IDirectManipulationCompositorPartner": ["59f4c99d-084e-46b9-ad3b-c9776f453163"],
    "IDirectManipulationContent": ["b89962cb-3d89-442b-bb58-5098fa0f9f16"],
    "IDirectManipulationContent2": ["2386312c-0b34-4383-a23d-24d45c125a9d"],
    "IDirectManipulationCrossProcessEventHandler": ["51484e62-a674-11e4-89d3-123b93f75cba"],
    "IDirectManipulationDeferContactService": ["652d5c71-fe60-4a98-be70-e5f21291e7f1"],
    "IDirectManipulationDelegatedViewportEventHandler": ["8779d548-148d-4cb0-abe0-5c084d0d1ae8"],
    "IDirectManipulationDragDropBehavior": ["814b5af5-c2c8-4270-a9b7-a198ce8d02fa"],
    "IDirectManipulationDragDropEventHandler": ["1fa11b10-701b-41ae-b5f2-49e36bd595aa"],
    "IDirectManipulationFrameInfoProvider": ["fb759dba-6f4c-4c01-874e-19c8a05907f9"],
    "IDirectManipulationInteractionEventHandler": ["e43f45b8-42b4-403e-b1f2-273b8f510830"],
    "IDirectManipulationManager": ["fbf5d3b4-70c7-4163-9322-5a6f660d6fbc"],
    "IDirectManipulationManager2": ["fa1005e9-3d16-484c-bfc9-62b61e56ec4e"],
    "IDirectManipulationManager3": ["2cb6b33d-ffe8-488c-b750-fbdfe88dca8c"],
    "IDirectManipulationManagerPartner": ["0a467fda-2a21-4b04-bb41-b3482d087b23"],
    "IDirectManipulationParametricMotionBehavior": ["820c0b62-45be-41dd-a2dc-6ccaf6ae0f04"],
    "IDirectManipulationParametricMotionCurve": ["cca6498e-f33f-4bf5-a344-c08067a863e4"],
    "IDirectManipulationParametricRestPointBehavior": ["b9a34d22-6f1f-4f81-92e6-02612316aea1"],
    "IDirectManipulationParametricRestPointList": ["ada8a4c4-1694-4f03-854e-0d118c451dd6"],
    "IDirectManipulationPrimaryContent": ["c12851e4-1698-4625-b9b1-7ca3ec18630b"],
    "IDirectManipulationPrimaryContent2": ["d8042f40-a051-4fee-875e-243b7b38d66e"],
    "IDirectManipulationSnapPointsBehavior": ["f170ddfd-6190-4dfa-a44e-e2c7235f06df"],
    "IDirectManipulationSnapPointsInertiaBehavior": ["5a775dd9-9ab2-4ba4-bdcb-1fcc46c1766b"],
    "IDirectManipulationUpdateHandler": ["790b6337-64f8-4ff5-a269-b32bc2af27a7"],
    "IDirectManipulationUpdateManager": ["b0ae62fd-be34-46e7-9caa-d361facbb9cc"],
    "IDirectManipulationViewport": ["28b85a3d-60a0-48bd-9ba1-5ce8d9ea3a6d"],
    "IDirectManipulationViewport2": ["923ccaac-61e1-4385-b726-017af189882a"],
    "IDirectManipulationViewport3": ["b3b92295-a421-41e3-a6b2-07922a217cad"],
    "IDirectManipulationViewportEventHandler": ["952121da-d69f-45f9-b0f9-f23944321a6d"],
    "IDirectManipulationViewportPartner": ["b0908968-2c5d-4d78-9607-c3c006df6f19"],
    "IDirectMusicCollection8": ["d2ac287c-b39b-11d1-8704-00600893b1bd"],
    "IDirectMusicDownload8": ["d2ac287b-b39b-11d1-8704-00600893b1bd"],
    "IDirectMusicDownloadedInstrument8": ["d2ac287e-b39b-11d1-8704-00600893b1bd"],
    "IDirectMusicInstrument8": ["d2ac287d-b39b-11d1-8704-00600893b1bd"],
    "IDirectMusicPort8": ["08f2d8c9-37c2-11d2-b9f9-0000f875ac12"],
    "IDirectMusicPortDownload8": ["d2ac287a-b39b-11d1-8704-00600893b1bd"],
    "IDirectMusicSynth": ["09823661-5c85-11d2-afa6-00aa0024d8b6"],
    "IDirectMusicSynth8": ["53cab625-2711-4c9f-9de7-1b7f925f6fc8"],
    "IDirectMusicSynthSink": ["09823663-5c85-11d2-afa6-00aa0024d8b6"],
    "IDirectMusicThru8": ["ced153e7-3606-11d2-b9f9-0000f875ac12"],
    "IDirectSound3DBuffer8": ["279afa86-4981-11ce-a521-0020af0be560"],
    "IDirectSound3DListener8": ["279afa84-4981-11ce-a521-0020af0be560"],
    "IDirectSoundCapture8": ["b0210781-89cd-11d0-af08-00a0c925cd16"],
    "IDirectSoundCaptureFXAec8": ["ad74143d-903d-4ab7-8066-28d363036d65"],
    "IDirectSoundCaptureFXNoiseSuppress8": ["ed311e41-fbae-4175-9625-cd0854f693ca"],
    "IDirectSoundFXChorus8": ["880842e3-145f-43e6-a934-a71806e50547"],
    "IDirectSoundFXCompressor8": ["4bbd1154-62f6-4e2c-a15c-d3b6c417f7a0"],
    "IDirectSoundFXDistortion8": ["8ecf4326-455f-4d8b-bda9-8d5d3e9e3e0b"],
    "IDirectSoundFXEcho8": ["8bd28edf-50db-4e92-a2bd-445488d1ed42"],
    "IDirectSoundFXFlanger8": ["903e9878-2c92-4072-9b2c-ea68f5396783"],
    "IDirectSoundFXGargle8": ["d616f352-d622-11ce-aac5-0020af0b99a3"],
    "IDirectSoundFXI3DL2Reverb8": ["4b166a6a-0d66-43f3-80e3-ee6280dee1a4"],
    "IDirectSoundFXParamEq8": ["c03ca9fe-fe90-4204-8078-82334cd177da"],
    "IDirectSoundFXWavesReverb8": ["46858c3a-0dc6-45e3-b760-d4eef16cb325"],
    "IDirectSoundFullDuplex8": ["edcb4c7a-daab-4216-a42e-6c50596ddc1d"],
    "IDirectSoundNotify8": ["b0210783-89cd-11d0-af08-00a0c925cd16"],
    "IDirectXVideoAccelerationService": ["fc51a550-d5e7-11d9-af55-00054e43ff02"],
    "IDirectXVideoDecoder": ["f2b0810a-fd00-43c9-918c-df94e2d8ef7d"],
    "IDirectXVideoDecoderService": ["fc51a551-d5e7-11d9-af55-00054e43ff02"],
    "IDirectXVideoMemoryConfiguration": ["b7f916dd-db3b-49c1-84d7-e45ef99ec726"],
    "IDirectXVideoProcessor": ["8c3a39f0-916e-4690-804f-4c8001355d25"],
    "IDirectXVideoProcessorService": ["fc51a552-d5e7-11d9-af55-00054e43ff02"],
    "IDiscFormat2": ["27354152-8f64-5b0f-8f00-5d77afbe261e"],
    "IDiscFormat2Data": ["27354153-9f64-5b0f-8f00-5d77afbe261e"],
    "IDiscFormat2DataEventArgs": ["2735413d-7f64-5b0f-8f00-5d77afbe261e"],
    "IDiscFormat2Erase": ["27354156-8f64-5b0f-8f00-5d77afbe261e"],
    "IDiscFormat2RawCD": ["27354155-8f64-5b0f-8f00-5d77afbe261e"],
    "IDiscFormat2RawCDEventArgs": ["27354143-7f64-5b0f-8f00-5d77afbe261e"],
    "IDiscFormat2TrackAtOnce": ["27354154-8f64-5b0f-8f00-5d77afbe261e"],
    "IDiscFormat2TrackAtOnceEventArgs": ["27354140-7f64-5b0f-8f00-5d77afbe261e"],
    "IDiscMaster2": ["27354130-7f64-5b0f-8f00-5d77afbe261e"],
    "IDiscRecorder2": ["27354133-7f64-5b0f-8f00-5d77afbe261e"],
    "IDiscRecorder2Ex": ["27354132-7f64-5b0f-8f00-5d77afbe261e"],
    "IDisconnectSink": ["0000014a-0000-0000-c000-000000000046"],
    "IDiscoverRecentItem": ["dd910131-9c55-48a4-8fa7-f00d062b10f2"],
    "IDiscoverUrlCallBack": ["0eea651c-b208-4ede-96ce-5194f4dc4e4a"],
    "IDiscoveryClientResult": ["fc5e8b09-ff17-4da6-ba39-eb8dfc314bc1"],
    "IDiscoveryClientResultCollection": ["bceb2c6c-e0d1-4fa5-8ddc-977d68e8d50b"],
    "IDiscoveryResult": ["b9a32c91-b14d-4ae3-a955-5cbc3e75fca5"],
    "IDiscoveryResult2": ["9947783d-b173-4fd9-8e6e-91482cf9e239"],
    "IDiscoveryResult3": ["6e1073e5-a112-441a-8386-232cecc0c29b"],
    "IDiscoverySession": ["d622fe99-2087-4d78-8b49-7b46460475fd"],
    "IDiscoverySession2": ["182b5eb4-9a58-47b7-a3fe-ac7ed8b891ff"],
    "IDiscreteColorKeyFrame": ["230c08f4-e062-4cb1-8e2a-14093d73ed8c"],
    "IDiscreteDoubleKeyFrame": ["f5f51f3a-ad11-49ce-8e1c-08fdf1447446"],
    "IDiscreteObjectKeyFrame": ["c7dcde89-f12d-4a9c-8199-e7a9ece3a473"],
    "IDiscretePointKeyFrame": ["e0a9070d-4c42-4a90-983a-75f5a83a2fbe"],
    "IDiskCleanupMgr": ["eb025082-257d-4a9e-a402-1468bc2868ec"],
    "IDiskQuotaControl": ["7988b572-ec89-11cf-9c00-00aa00a14f56"],
    "IDiskQuotaEvents": ["7988b579-ec89-11cf-9c00-00aa00a14f56"],
    "IDiskQuotaUser": ["7988b574-ec89-11cf-9c00-00aa00a14f56"],
    "IDiskQuotaUserBatch": ["7988b576-ec89-11cf-9c00-00aa00a14f56"],
    "IDispCivicAddressReport": ["16ff1a34-9e30-42c3-b44d-e22513b5767a"],
    "IDispLatLongReport": ["8ae32723-389b-4a11-9957-5bdd48fc9617"],
    "IDispatchExInternal": ["db113cdd-aba5-4ae7-ac40-b9a10d341fa9"],
    "IDispatchVerifyUntrusted": ["c78d010b-c706-4a74-9e8e-4a634be760fc"],
    "IDispatch_In_Memory": ["83fb5d85-2339-11d2-b89d-00c04fb9618a"],
    "IDispatchedHandler": ["d1f276c4-98d8-4636-bf49-eb79507548e9"],
    "IDispatcherQueue": ["603e88e4-a338-4ffe-a457-a5cfb9ceb899"],
    "IDispatcherQueue2": ["c822c647-30ef-506e-bd1e-a647ae6675ff"],
    "IDispatcherQueueController": ["22f34e66-50db-4e36-a98d-61c01b384d20"],
    "IDispatcherQueueControllerStatics": ["0a6c98e0-5198-49a2-a313-3f70d1f13c27"],
    "IDispatcherQueueHandler": ["dfa2dc9c-1a2d-4917-98f2-939af1d6e0c8"],
    "IDispatcherQueueShutdownStartingEventArgs": ["c4724c4c-ff97-40c0-a226-cc0aaa545e89"],
    "IDispatcherQueueStatics": ["a96d83d7-9371-4517-9245-d0824ac12c74"],
    "IDispatcherQueueTimer": ["5feabb1d-a31c-4727-b1ac-37454649d56a"],
    "IDispatcherTimer": ["d160ce46-cd22-4f5f-8c97-40e61da3e2dc"],
    "IDispatcherTimerFactory": ["e9961e6e-3626-403a-afe0-040d58165632"],
    "IDispenserManagerDriver": ["aa5839c0-7c77-11cf-9489-00aa00bf9397"],
    "IDispenserManagerDriver2": ["b7ed6e1a-d984-11d1-939b-00aa00ba3258"],
    "IDisplayDeviceInterop": ["64338358-366a-471b-bd56-dd8ef48e439b"],
    "IDisplayEnhancementOverride": ["429594cf-d97a-4b02-a428-5c4292f7f522"],
    "IDisplayEnhancementOverrideCapabilities": ["457060de-ee5a-47b7-9918-1e51e812ccc8"],
    "IDisplayEnhancementOverrideCapabilitiesChangedEventArgs": ["db61e664-15fa-49da-8b77-07dbd2af585d"],
    "IDisplayEnhancementOverrideStatics": ["cf5b7ec1-9791-4453-b013-29b6f778e519"],
    "IDisplayInformation": ["bed112ae-adc3-4dc9-ae65-851f4d7d4799"],
    "IDisplayInformation2": ["4dcd0021-fad1-4b8e-8edf-775887b8bf19"],
    "IDisplayInformation3": ["db15011d-0f09-4466-8ff3-11de9a3c929a"],
    "IDisplayInformation4": ["c972ce2f-1242-46be-b536-e1aafe9e7acf"],
    "IDisplayInformation5": ["3a5442dc-2cde-4a8d-80d1-21dc5adcc1aa"],
    "IDisplayInformationStatics": ["c6a02a6c-d452-44dc-ba07-96f3c6adf9d1"],
    "IDisplayItem": ["c6fd5997-9f6b-4888-8703-94e80e8cde3f"],
    "IDisplayMonitor": ["1f6b15d4-1d01-4c51-87e2-6f954a772b59"],
    "IDisplayMonitor2": ["023018e6-cb23-5830-96df-a7bf6e602577"],
    "IDisplayMonitorStatics": ["6eae698f-a228-4c05-821d-b695d667de8e"],
    "IDisplayPathInterop": ["a6ba4205-e59e-4e71-b25b-4e436d21ee3d"],
    "IDisplayPinAssociationResponse": ["25e8275b-fa36-4097-b189-cb7228d80b4d"],
    "IDisplayRegion": ["db50c3a2-4094-5f47-8cb1-ea01ddafaa94"],
    "IDisplayRequest": ["e5732044-f49f-4b60-8dd4-5e7e3a632ac0"],
    "IDisplayServices2": ["a39531fe-a534-4a08-8b9f-a356097beedd"],
    "IDisplayTreeDumper": ["30510415-98b5-11cf-bb82-00aa00bdce0b"],
    "IDistantLight": ["318cfafc-5ce3-4b55-ab5d-07a00353ac99"],
    "IDistantLight2": ["dbcdaa1c-294b-48d7-b60e-76df64aa392b"],
    "IDllServerActivatableClassRegistration": ["c8aa04f6-66c6-46a3-8fe6-f56be7ddc091"],
    "IDmaChannel": ["22c6ac61-851b-11d0-9a7f-00aa0038acfe"],
    "IDmaChannelSlave": ["22c6ac62-851b-11d0-9a7f-00aa0038acfe"],
    "IDnssdRegistrationResult": ["3d786ad2-e606-5350-73ea-7e97f066162f"],
    "IDnssdServiceInstance": ["e246db7e-98a5-4ca1-b9e4-c253d33c35ff"],
    "IDnssdServiceInstanceFactory": ["6cb061a1-c478-4331-9684-4af2186c0a2b"],
    "IDnssdServiceWatcher": ["cc34d9c1-db7d-4b69-983d-c6f83f205682"],
    "IDoNothingUsefulAtAll": ["c55bc3fd-a465-cbe4-5d7a-5199030da400"],
    "IDocHostObject": ["67431840-c511-11cf-89a9-00a0c9054129"],
    "IDocHostUIAppProtocol": ["f0895e2e-8929-43d0-b2cb-386aeb0c5dbe"],
    "IDocHostUIControlPriv": ["bf9d04bf-dbad-40ef-b1a1-e4cc38fa8995"],
    "IDocHostUIHandlerPriv": ["f0d241d1-5d0e-4e85-bcb4-fad7f7c5528c"],
    "IDocNavigate": ["131a6950-7f78-11d0-a979-00c04fd705a2"],
    "IDocObjectService": ["3050f801-98b5-11cf-bb82-00aa00bdce0b"],
    "IDocObjectStatus": ["fbece6c9-48d7-4a37-8fe3-6ad4272fddac"],
    "IDocWrap": ["dcd285fe-0be0-43bd-99c9-aaaec513c555"],
    "IDocfileAsyncConnectionPoint": ["4a8df970-8d9a-11cf-8827-00aa00b569f5"],
    "IDockPatternIdentifiers": ["ccd7f4e6-e4f9-47ff-bde7-378b11f78e09"],
    "IDockPatternIdentifiersStatics": ["2b87245c-ed80-4fe5-8eb4-708a39c841e5"],
    "IDockProvider": ["159bc72c-4ad3-485e-9637-d7052edf0146", "48c243f8-78b1-44a0-ac5f-750757bcde3c"],
    "IDocumentEvent": ["305104bc-98b5-11cf-bb82-00aa00bdce0b"],
    "IDocumentProperties": ["482d7eaf-45f5-4ccd-b707-7bea5967d1d5", "7eab19bc-1821-4923-b4a9-0aea404d0070"],
    "IDocumentRange": ["305104af-98b5-11cf-bb82-00aa00bdce0b"],
    "IDocumentSelector": ["30510462-98b5-11cf-bb82-00aa00bdce0b"],
    "IDocumentSite": ["94a0f6f1-10bc-11d0-8d09-00a0c90f2732"],
    "IDocumentSite2": ["61d4a8a1-2c90-11d2-ade4-00c04f98f417"],
    "IDocumentSuggestedSitesPriv": ["df464bcd-318b-46eb-9162-adde9c786f32"],
    "IDocumentTraversal": ["30510744-98b5-11cf-bb82-00aa00bdce0b"],
    "IDontSupportEventSubscription": ["784121f1-62a6-4b89-855f-d65f296de83a"],
    "IDot11AdHocInterface": ["8f10cc2b-cf0d-42a0-acbe-e2de7007384d"],
    "IDot11AdHocInterfaceNotificationSink": ["8f10cc2f-cf0d-42a0-acbe-e2de7007384d"],
    "IDot11AdHocManager": ["8f10cc26-cf0d-42a0-acbe-e2de7007384d"],
    "IDot11AdHocManagerNotificationSink": ["8f10cc27-cf0d-42a0-acbe-e2de7007384d"],
    "IDot11AdHocNetwork": ["8f10cc29-cf0d-42a0-acbe-e2de7007384d"],
    "IDot11AdHocNetworkNotificationSink": ["8f10cc2a-cf0d-42a0-acbe-e2de7007384d"],
    "IDot11AdHocSecuritySettings": ["8f10cc2e-cf0d-42a0-acbe-e2de7007384d"],
    "IDoubleAnimation": ["7e9f3d59-0f07-4bc9-977d-03763ff8154f"],
    "IDoubleAnimationStatics": ["e27a935d-f111-43b7-b824-832b58d7786b"],
    "IDoubleAnimationUsingKeyFrames": ["4fee628f-bfee-4f75-83c2-a93b39488473"],
    "IDoubleAnimationUsingKeyFramesStatics": ["109bf2f6-c60f-49aa-abf6-f696d492116b"],
    "IDoubleKeyFrame": ["674456fd-e81e-4f4e-b4ad-0acfed9ecd68"],
    "IDoubleKeyFrameFactory": ["ac97dec3-7538-40b9-b152-696f7fbf4722"],
    "IDoubleKeyFrameStatics": ["324641b0-7d37-427a-adeb-43f38bb61a4d"],
    "IDoubleTappedEventHandler": ["3124d025-04a7-4d45-825e-8204a624dbf4"],
    "IDoubleTappedRoutedEventArgs": ["af404424-26df-44f4-8714-9359249b62d3"],
    "IDownloadBar": ["3edcb28e-e026-4d7b-bf1b-4c200268fd3b"],
    "IDownloadBroadcaster": ["e0a3dcc6-bb71-4a76-bd8e-f24b9d9a48c0"],
    "IDownloadCallback": ["9329e39d-0445-4cbf-a14f-f1df49a57e76"],
    "IDownloadCompletedCallback": ["77254866-9f5b-4c8e-b9e2-c77a8530d64b"],
    "IDownloadCompletedCallbackArgs": ["fa565b23-498c-47a0-979d-e7d5b1813360"],
    "IDownloadCounterProvider": ["33973ac4-dbf2-4d1c-9468-a282a9146c0b"],
    "IDownloadExecutionBroker": ["58062ea0-b932-4785-8239-84eea4914482"],
    "IDownloadExecutionOptions": ["0d574e62-2784-49d0-804d-361f804caa1d"],
    "IDownloadHistoryDatabase": ["8a445657-f50d-11e0-9240-18a905c16311"],
    "IDownloadHistoryEnum": ["86445657-f50d-11e0-9240-18a905c16311"],
    "IDownloadInitiatorProvider": ["7c733a3d-f21f-41fc-8a61-032659d720d1"],
    "IDownloadJob": ["c574de85-7358-43f6-aae8-8697e62d8ba7"],
    "IDownloadLaunch": ["a11e36f5-d54c-4cad-bef1-c2ddae7be6a3"],
    "IDownloadListener": ["5b2ae522-f16f-40ce-a7ca-ff6d78aea699"],
    "IDownloadModeHandleCallback": ["8f0f47d6-abbe-4489-b124-ca0cee8ec202"],
    "IDownloadNotificationStack": ["48b8014a-9bf5-42ad-9bed-eeeee9514d21"],
    "IDownloadOperation": ["bd87ebb0-5714-4e09-ba68-bef73903b0d7"],
    "IDownloadOperation2": ["a3cced40-8f9c-4353-9cd4-290dee387c38"],
    "IDownloadOperation3": ["5027351c-7d5e-4adc-b8d3-df5c6031b9cc"],
    "IDownloadOperation4": ["0cdaaef4-8cef-404a-966d-f058400bed80"],
    "IDownloadOperation5": ["a699a86f-5590-463a-b8d6-1e491a2760a5"],
    "IDownloadPrivacy": ["04b0d606-b925-44f8-8a6c-fe2a4b0f32b9"],
    "IDownloadProgress": ["d31a5bac-f719-4178-9dbb-5e2cb47fd18a"],
    "IDownloadProgressChangedCallback": ["8c3f1cdd-6173-4591-aebd-a56a53ca77c1"],
    "IDownloadProgressChangedCallbackArgs": ["324ff2c6-4981-4b04-9412-57481745ab24"],
    "IDownloadProgressEventArgs": ["7311e0d4-fe94-4e70-9b90-cdd47ac23afb"],
    "IDownloadProgressEventHandler": ["1abaee23-74ee-4cc7-99ba-b171e3cda61e"],
    "IDownloadRateCalculator": ["fd6237bf-0c1e-4a4f-9963-30409b3bad80"],
    "IDownloadResult": ["daa4fdd0-4727-4dbe-a1e7-745dca317144"],
    "IDownloadSecurity": ["b5d1318c-89ba-4166-af8b-76b0df8e7d46"],
    "IDownloadUIManager": ["ccfb755f-13b4-4d15-84c7-92d241425a5c"],
    "IDownloadWindow": ["84650f00-1345-4045-9aa4-44df59f5eba9"],
    "IDownloadWindowContainer": ["e6129efb-a4e2-4504-a5a0-865d751ab37a"],
    "IDownloadsFolderStatics": ["27862ed0-404e-47df-a1e2-e37308be7b37"],
    "IDownloadsFolderStatics2": ["e93045bd-8ef8-4f8e-8d15-ac0e265f390d"],
    "IDpxContainer": ["ddc1b712-0e55-452f-838e-d1505b866e2b"],
    "IDpxContainer2": ["c8e1e004-3a8d-45c7-a6aa-8c8f2f2ed1e1"],
    "IDpxContainer3": ["582f768c-fe7d-4bf5-b0b8-3ab01d53b0d0"],
    "IDpxContainerDirectoryEntry": ["ddc1b715-0e55-452f-838e-d1505b866e2b"],
    "IDpxDownloadCallback": ["ddc1b717-0e55-452f-838e-d1505b866e2b"],
    "IDpxDownloadProvider": ["ddc1b716-0e55-452f-838e-d1505b866e2b"],
    "IDpxEncryptedContainer": ["ddc1b726-0e55-452f-838e-d1505b866e2b"],
    "IDpxFile": ["ddc1b713-0e55-452f-838e-d1505b866e2b"],
    "IDpxFile2": ["c249cc11-c1f5-428e-acbf-e1b78b30b971"],
    "IDpxJob": ["ddc1b711-0e55-452f-838e-d1505b866e2b"],
    "IDpxJob2": ["e1c292c8-919a-4f1b-b85a-9c542932fc8d"],
    "IDragCompletedEventArgs": ["b04f29a1-bd16-48f6-a511-9c2763641331"],
    "IDragCompletedEventArgsFactory": ["36a7d99d-148c-495f-a0fc-afc871d62f33"],
    "IDragCompletedEventHandler": ["36b28888-19ac-4b4e-9137-a6cf2b023883"],
    "IDragDeltaEventArgs": ["2c2dd73c-2806-49fc-aae9-6d792b572b6a"],
    "IDragDeltaEventArgsFactory": ["46e7a1ef-ae15-44a6-8a04-95b0bf9ab876"],
    "IDragDeltaEventHandler": ["4ac24f9f-ac28-49e9-9189-dccffeb66472"],
    "IDragDropArgsPriv": ["079f88f0-6801-479c-9129-40d02c7b1d42"],
    "IDragDropBroker": ["ff87c9a7-7870-4152-8bb6-743a05cede09"],
    "IDragDropHelper": ["0000012d-0000-0000-c000-000000000046"],
    "IDragDropManagerInterop": ["5ad8cba7-4c01-4dac-9074-827894292d63"],
    "IDragDropViewCreationHandler": ["800d4c3a-a217-4177-b228-04cfef8c1dc3"],
    "IDragEventArgs": ["b440c7c3-02b4-4980-9342-25dae1c0f188"],
    "IDragEventArgs2": ["26336658-2917-411d-bfc3-2f22471cbbe7"],
    "IDragEventArgs3": ["d04fc3c6-8119-427a-8152-5f9550cc0416"],
    "IDragEventHandler": ["2ab1a205-1e73-4bcf-aabc-57b97e21961d"],
    "IDragItemThemeAnimation": ["0c7d5db5-7ed6-4949-b4e6-a78c9f4f978d"],
    "IDragItemThemeAnimationStatics": ["6218b9f5-013a-4fb1-86fc-92bc4e8d0241"],
    "IDragItemsCompletedEventArgs": ["af05f22f-9e78-4b21-9a8e-41c2d1367a2a"],
    "IDragItemsStartingEventArgs": ["71cf215c-daed-4783-aa11-dc574d2713e9"],
    "IDragItemsStartingEventHandler": ["3aaeab4c-14cb-4434-becc-88a8585c2f89"],
    "IDragOperationDeferral": ["ba73ecba-1b73-4086-b3d3-c223beea1633"],
    "IDragOperationPriv": ["3d678ff8-6adf-4aad-ba71-117cf9baa0ae"],
    "IDragOverThemeAnimation": ["72f762f7-7e51-4a6b-b937-dc4b4c1c5458"],
    "IDragOverThemeAnimationStatics": ["146ffe57-3c9d-41d9-a5ff-8d7239516810"],
    "IDragPatternIdentifiers": ["6266e985-4d07-4e80-82eb-8f96690a1a0c"],
    "IDragPatternIdentifiersStatics": ["2a05379d-1755-4082-9d90-46f1411d7986"],
    "IDragProvider": ["2e7786a9-7ffc-4f57-b965-1ef1f373f546", "6aa7bbbb-7ff9-497d-904f-d20b897929d8"],
    "IDragSourceHelper2": ["83e07d0d-0c5f-4163-bf1a-60b274051e40"],
    "IDragStartedEventArgs": ["9f915dd0-a124-4366-bd85-2408214aeed4"],
    "IDragStartedEventArgsFactory": ["5eefe579-c706-4781-a308-c9e7f4c6a1d7"],
    "IDragStartedEventHandler": ["d2eea48a-c65a-495d-a2f1-72c66989142d"],
    "IDragStartingEventArgs": ["6800d3fa-90b8-46f9-8e30-5ac25f73f0f9"],
    "IDragStartingEventArgs2": ["d855e08e-44b6-4211-bd0b-7fddbb6e8231"],
    "IDragUI": ["2d9bd838-7c60-4842-9170-346fe10a226a"],
    "IDragUIContentProviderPriv": ["3d7e959f-4290-45be-905e-b452996dc701"],
    "IDragUIOverride": ["bd6c9dfa-c961-4861-b7a5-bf4fe4a8a6ef"],
    "IDragUIOverridePriv": ["3058ba43-74d3-4f1d-b251-5dea99b75f57"],
    "IDragViewEventHandler": ["cdc15432-c344-4d81-a416-b5fdeec8cb04"],
    "IDragViewTracker": ["d14b56bb-6137-487c-9b58-2ca634c0a99a"],
    "IDraggingEventArgs": ["1c905384-083c-4bd3-b559-179cddeb33ec"],
    "IDraggingEventArgs2": ["71efdbf9-382a-55ca-b4b9-008123c1bf1a"],
    "IDrawVideoImage": ["48efb120-ab49-11d2-aed2-00a0c995e8d5"],
    "IDrillInNavigationTransitionInfo": ["3b86201a-45d3-463b-939e-c8595f439bcc"],
    "IDrillInThemeAnimation": ["b090b824-f1d2-41b8-87ba-78034126594c"],
    "IDrillInThemeAnimationStatics": ["c61fe488-a17a-4b11-b53b-a4f1a07d4ba9"],
    "IDrillOutThemeAnimation": ["d890ccdf-06d3-4f7e-8e4a-4fb76e256139"],
    "IDrillOutThemeAnimationStatics": ["beb5db9b-2617-4888-80dd-72fa7bb6fac3"],
    "IDriveFolderExt": ["3ec36f3e-5ba3-4c3d-bf39-10f76c3f7cc6"],
    "IDriverConfigModule": ["61487bd7-94b5-4e4b-8dda-a555a2b77bc1"],
    "IDriverEntry": ["1bec7499-8881-4f2b-b01c-a1a907304afc"],
    "IDrmAudioStream": ["1915c967-3299-48cb-a3e4-69fd1d1b306e"],
    "IDrmPort": ["286d3df8-ca22-4e2e-b9bc-20b4f0e201ce"],
    "IDrmPort2": ["1acce59c-7311-4b6b-9fba-cc3ba59acdce"],
    "IDropCompletedEventArgs": ["6c4fc188-95bc-4261-9ec5-21cab677b734"],
    "IDropController": ["b55e4d76-2743-4b4e-af8d-18817545de74"],
    "IDropDirectory": ["cd000024-8b95-11d1-82db-00c04fb1625d"],
    "IDropDownButton": ["671f74e6-2a27-5fa8-b0a2-79b2e71ebd87"],
    "IDropDownButtonAutomationPeer": ["72f294f1-bff6-5d07-9db4-54134506bc80"],
    "IDropDownButtonAutomationPeerFactory": ["b8c449b2-6354-5c0c-9e95-e0c99a293a44"],
    "IDropDownButtonFactory": ["0d9f8ab5-e70d-52bd-9ca0-36ceecaa642a"],
    "IDropOperationTargetPriv": ["e86f28a0-42a8-43c7-af4a-ba1d3cc77cc4"],
    "IDropShadow": ["cb977c07-a154-4851-85e7-a8924c84fad8"],
    "IDropShadow2": ["6c4218bc-15b9-4c2d-8d4a-0767df11977a"],
    "IDropSourceMarshallable": ["e8e8d427-ef1b-4491-8e0d-3bae38974c3e"],
    "IDropSourceNotify": ["0000012b-0000-0000-c000-000000000046"],
    "IDropTargetFactory": ["504c9f82-0f68-47f4-8f63-083e58c88412"],
    "IDropTargetHwnd": ["0f8ebe91-5169-4306-b495-09f55d460333"],
    "IDropTargetItemThemeAnimation": ["1881c968-1824-462b-87e8-c357212b977b"],
    "IDropTargetItemThemeAnimationStatics": ["ae80f486-2e56-4513-bf18-d77470164ae5"],
    "IDropTargetPatternIdentifiers": ["11865133-a6fe-4634-bd18-0ef612b7b208"],
    "IDropTargetPatternIdentifiersStatics": ["1b693304-89fb-4b0a-9452-ca2c66aaf9f3"],
    "IDropTargetProvider": ["7a245bdd-b458-4fe0-98c8-aac89df56d61", "bae82bfd-358a-481c-85a0-d8b4d90a5d61"],
    "IDropTargetProviderPriv": ["dadef92c-227e-46c0-93c0-9fffa4dc07d9"],
    "IDropTargetWithDADSupport": ["b0061660-b231-11d2-963e-00c04f79adf0"],
    "IDsAdminCreateObj": ["53554a38-f902-11d2-82b9-00c04f68928b"],
    "IDsAdminNewObj": ["f2573587-e6fc-11d2-82af-00c04f68928b"],
    "IDsAdminNewObjExt": ["6088eae2-e7bf-11d2-82af-00c04f68928b"],
    "IDsAdminNewObjPrimarySite": ["be2b487e-f904-11d2-82b9-00c04f68928b"],
    "IDsAdminNotifyHandler": ["e4a2b8b3-5a18-11d2-97c1-00a0c9a06d2d"],
    "IDsDisplaySpecifier": ["1ab4a8c0-6a0b-11d2-ad49-00c04fa31a86"],
    "IDsObjectPicker": ["0c87e64e-3b7a-11d2-b9e0-00c04fd8dbf7"],
    "IDsPrinterProperties": ["8a58bc16-410e-11d1-a9c2-080036af3f03"],
    "IDtcLuConfigure": ["4131e760-1aea-11d0-944b-00a0c905416e"],
    "IDtcLuRecovery": ["ac2b8ad2-d6f0-11d0-b386-00a0c9083365"],
    "IDtcLuRecoveryFactory": ["4131e762-1aea-11d0-944b-00a0c905416e"],
    "IDtcLuRecoveryInitiatedByDtc": ["4131e764-1aea-11d0-944b-00a0c905416e"],
    "IDtcLuRecoveryInitiatedByDtcStatusWork": ["4131e766-1aea-11d0-944b-00a0c905416e"],
    "IDtcLuRecoveryInitiatedByDtcTransWork": ["4131e765-1aea-11d0-944b-00a0c905416e"],
    "IDtcLuRecoveryInitiatedByLu": ["4131e768-1aea-11d0-944b-00a0c905416e"],
    "IDtcLuRecoveryInitiatedByLuWork": ["ac2b8ad1-d6f0-11d0-b386-00a0c9083365"],
    "IDtcLuRmEnlistment": ["4131e769-1aea-11d0-944b-00a0c905416e"],
    "IDtcLuRmEnlistmentFactory": ["4131e771-1aea-11d0-944b-00a0c905416e"],
    "IDtcLuRmEnlistmentSink": ["4131e770-1aea-11d0-944b-00a0c905416e"],
    "IDtcLuSubordinateDtc": ["4131e773-1aea-11d0-944b-00a0c905416e"],
    "IDtcLuSubordinateDtcFactory": ["4131e775-1aea-11d0-944b-00a0c905416e"],
    "IDtcLuSubordinateDtcSink": ["4131e774-1aea-11d0-944b-00a0c905416e"],
    "IDtcNetworkAccessConfig": ["9797c15d-a428-4291-87b6-0995031a678d"],
    "IDtcNetworkAccessConfig2": ["a7aa013b-eb7d-4f42-b41c-b2dec09ae034"],
    "IDtcNetworkAccessConfig3": ["76e4b4f3-2ca5-466b-89d5-fd218ee75b49"],
    "IDtcToXaHelper": ["a9861611-304a-11d1-9813-00a0c905416e", "adefc46b-cb1d-11d0-b135-00c04fc2f3ef"],
    "IDtcToXaHelperFactory": ["a9861610-304a-11d1-9813-00a0c905416e", "adefc46a-cb1d-11d0-b135-00c04fc2f3ef"],
    "IDtcToXaHelperSinglePipe": ["47ed4971-53b3-11d1-bbb9-00c04fd658f6"],
    "IDtcToXaMapper": ["64ffabe0-7ce9-11d0-8ce6-00c04fdc877e"],
    "IDtdEntity": ["6a0b5ffc-63b4-480f-9e6a-8a92816aade4"],
    "IDtdNotation": ["8cb4e04d-6d46-4edb-ab73-df83c51ad397"],
    "IDualSimTile": ["143ab213-d05f-4041-a18c-3e3fcb75b41e"],
    "IDualSimTileStatics": ["50567c9e-c58f-4dc9-b6e8-fa6777eeeb37"],
    "IDummyMBNUCMExt": ["dcbbbab6-ffff-4bbb-aaee-338e368af6fa"],
    "IDuplicateHandleProvider": ["fa9812c4-0b34-47d0-9b0b-157fb5b5fdf2"],
    "IDurationHelper": ["25c1659f-4497-4135-940f-ee96f4d6e934"],
    "IDurationHelperStatics": ["bc88093e-3547-4ec0-b519-ffa8f9c4838c"],
    "IDvbCableDeliverySystemDescriptor": ["dfb98e36-9e1a-4862-9946-993a4e59017b"],
    "IDvbComponentDescriptor": ["91e405cf-80e7-457f-9096-1b9d1ce32141"],
    "IDvbContentDescriptor": ["2e883881-a467-412a-9d63-6f2b6da05bf0"],
    "IDvbContentIdentifierDescriptor": ["05e0c1ea-f661-4053-9fbf-d93b28359838"],
    "IDvbDataBroadcastDescriptor": ["d1ebc1d6-8b60-4c20-9caf-e59382e7c400"],
    "IDvbDataBroadcastIDDescriptor": ["5f26f518-65c8-4048-91f2-9290f59f7b90"],
    "IDvbDefaultAuthorityDescriptor": ["05ec24d1-3a31-44e7-b408-67c60a352276"],
    "IDvbExtendedEventDescriptor": ["c9b22eca-85f4-499f-b1db-efa93a91ee57"],
    "IDvbFrequencyListDescriptor": ["1cadb613-e1dd-4512-afa8-bb7a007ef8b1"],
    "IDvbHDSimulcastLogicalChannelDescriptor": ["1ea8b738-a307-4680-9e26-d0a908c824f4"],
    "IDvbLinkageDescriptor": ["1cdf8b31-994a-46fc-acfd-6a6be8934dd5"],
    "IDvbLogicalChannel2Descriptor": ["f69c3747-8a30-4980-998c-01fe7f0ba35a"],
    "IDvbLogicalChannelDescriptor": ["cf1edaff-3ffd-4cf7-8201-35756acbf85f"],
    "IDvbLogicalChannelDescriptor2": ["43aca974-4be8-4b98-bc17-9eafd788b1d7"],
    "IDvbMultilingualServiceNameDescriptor": ["2d80433b-b32c-47ef-987f-e78ebb773e34"],
    "IDvbNetworkNameDescriptor": ["5b2a80cf-35b9-446c-b3e4-048b761dbc51"],
    "IDvbParentalRatingDescriptor": ["3ad9dde1-fb1b-4186-937f-22e6b5a72a10"],
    "IDvbPrivateDataSpecifierDescriptor": ["5660a019-e75a-4b82-9b4c-ed2256d165a2"],
    "IDvbSatelliteDeliverySystemDescriptor": ["02f2225a-805b-4ec5-a9a6-f9b5913cd470"],
    "IDvbServiceAttributeDescriptor": ["0f37bd92-d6a1-4854-b950-3a969d27f30e"],
    "IDvbServiceDescriptor": ["f9c7fbcf-e2d6-464d-b32d-2ef526e49290"],
    "IDvbServiceDescriptor2": ["d6c76506-85ab-487c-9b2b-36416511e4a2"],
    "IDvbServiceListDescriptor": ["05db0d8f-6008-491a-acd3-7090952707d0"],
    "IDvbShortEventDescriptor": ["b170be92-5b75-458e-9c6e-b0008231491a"],
    "IDvbSiParser": ["b758a7bd-14dc-449d-b828-35909acb3b1e"],
    "IDvbSiParser2": ["0ac5525f-f816-42f4-93ba-4c0f32f46e54"],
    "IDvbSubtitlingDescriptor": ["9b25fe1d-fa23-4e50-9784-6df8b26f8a49"],
    "IDvbTeletextDescriptor": ["9cd29d47-69c6-4f92-98a9-210af1b7303a"],
    "IDvbTerrestrial2DeliverySystemDescriptor": ["20ee9be9-cd57-49ab-8f6e-1d07aeb8e482"],
    "IDvbTerrestrialDeliverySystemDescriptor": ["ed7e1b91-d12e-420c-b41d-a49d84fe1823"],
    "IDvdCmd": ["5a4a97e4-94ee-4a55-9751-74b5643aa27d"],
    "IDvdControl2": ["33bc7430-eec0-11d2-8201-00a0c9d74842"],
    "IDvdInfo2": ["34151510-eec0-11d2-8201-00a0c9d74842"],
    "IDvdState": ["86303d6d-1c4a-4087-ab42-f711167048ef"],
    "IDwnBindInfo": ["3050f3c3-98b5-11cf-bb82-00aa00bdce0b"],
    "IDxtAlphaSetter": ["4ee9ead9-da4d-43d0-9383-06b90c08b12b"],
    "IDxtCompositor": ["bb44391e-6abd-422f-9e2e-385c9dff51fc"],
    "IDxtJpeg": ["de75d011-7a65-11d2-8cea-00a0c9441e20"],
    "IDxtKey": ["3255de56-38fb-4901-b980-94b438010d7b"],
    "IDynamicConceptProviderConcept": ["95a7f7dd-602e-483f-9d06-a15c0ee13174"],
    "IDynamicHWHandler": ["dc2601d7-059e-42fc-a09d-2afd21b6d5f7"],
    "IDynamicKeyProviderConcept": ["e7983fa1-80a7-498c-988f-518ddc5d4025"],
    "IDynamicOverflowItemsChangingEventArgs": ["c93c736f-6f6e-4e43-90d9-9b46a0d88b9f"],
    "IDynamicRenderer": ["a079468e-7165-46f9-b7af-98ad01a93009"],
    "IDynamicStorage": ["52bbc746-9f9c-44b4-8d7c-0aaab79bc7dc"],
    "IEAPProviderConfig": ["66a2db19-d706-11d0-a37b-00c04fc9da04"],
    "IEAPProviderConfig2": ["d565917a-85c4-4466-856e-671c3742ea9a"],
    "IEAPProviderConfig3": ["b78ecd12-68bb-4f86-9bf0-8438dd3be982"],
    "IEAxInstallBrokerBroker": ["b2103bdb-b79e-4474-8424-4363161118d5"],
    "IEBrokerAttach": ["7673b35e-907a-449d-a49f-e5ce47f0b0b2"],
    "IEBrokerObjectCleanup": ["2e564fef-5bb0-4d9e-b169-b40a5117715a"],
    "IEBrokerRegisterObjectCleanup": ["c40b45c3-1518-46fb-a0f0-0c056174d555"],
    "IEContentAdvisorBroker": ["c456f893-35ed-0eb4-56f9-3e139ebe5f47"],
    "IEDPNotificationHost": ["d46fa868-2e4e-4a72-a424-ffa395eadf33"],
    "IEDPNotificationHostBroker": ["079ca8fc-5ac1-4418-b72e-eedac3978341"],
    "IEDataObjectInternal": ["196bab51-2c67-485a-a74f-557182263013"],
    "IEDataObjectWrapper": ["64eeb363-190e-428f-a801-f63615e988b1"],
    "IEDropSourceWrapper": ["c74aff92-5b45-477b-8630-61d5cbed416a"],
    "IEDropSourceWrapperInternal": ["9c627e44-7a53-4938-91c6-f60f3ecbea94"],
    "IEEAssemblyRef": ["aad20a0e-9cd9-40ab-91b9-3c1943562c84"],
    "IEEAssemblyRefResolveComparer": ["6f1a544c-e69e-4a52-9ea1-25c897b05bef"],
    "IEEDataStorage": ["dcf1f227-ec51-4680-8722-c8796a5f3483"],
    "IEEHelperObject": ["4a3bcde5-5f66-4cc8-9fa0-14275ccee688"],
    "IEEHostServices": ["bb7be481-da8f-4b9e-89cb-0a8dde6bc5d7"],
    "IEELocalObject": ["44f8f85f-5514-49a3-8173-6f9c9f1c4832"],
    "IEEMemoryManager": ["17713b61-b59f-4e13-baaf-91623dc8adc0"],
    "IEEVisualizerDataProvider": ["27ed701a-fa26-406e-ae71-00011b5ae396"],
    "IEEVisualizerService": ["82545b58-f203-4835-acd6-6d0997aa6f25"],
    "IEEVisualizerServiceProvider": ["a2f2c782-f929-4ffa-8699-88d4c4c07b17"],
    "IEFrameAuto": ["401062ac-2f9c-426e-91a2-4af5bead509f"],
    "IEInetcplRasBroker": ["7819a000-56f5-432f-bf43-662a11261696"],
    "IENCDebugInfo": ["1da15c39-7e02-4ee8-8f60-fff81275ee14"],
    "IENCSymbolReaderProvider": ["b69910a9-4ad6-475f-859a-5dc0b1072a5d"],
    "IERegHelperBroker": ["41dc24d8-6b81-41c4-832c-fe172cb3a582"],
    "IERegistryHKLMBroker": ["6cbef08d-65a6-446e-b291-255624568192"],
    "IESCloseMmiEvent": ["6b80e96f-55e2-45aa-b754-0c23c8e7d5c1"],
    "IESEvent": ["1f0e5357-af43-44e6-8547-654c645145d2"],
    "IESEventFactory": ["506a09b8-7f86-4e04-ac05-3303bfe8fc49"],
    "IESEventService": ["ed89a619-4c06-4b2f-99eb-c7669b13047c"],
    "IESEventServiceConfiguration": ["33b9daae-9309-491d-a051-bcad2a70cd66"],
    "IESEvents": ["abd414bf-cfe5-4e5e-af5b-4b4e49c5bfeb"],
    "IESFileExpiryDateEvent": ["ba9edcb6-4d36-4cfe-8c56-87a6b0ca48e1"],
    "IESIsdbCasResponseEvent": ["2017cb03-dc0f-4c24-83ca-36307b2cd19f"],
    "IESLicenseRenewalResultEvent": ["d5a48ef5-a81b-4df0-acaa-5e35e7ea45d4"],
    "IESOpenMmiEvent": ["ba4b6526-1a35-4635-8b56-3ec612746a8c"],
    "IESRequestTunerEvent": ["54c7a5e8-c3bb-4f51-af14-e0e2c0e34c6d"],
    "IESValueUpdatedEvent": ["8a24c46e-bb63-4664-8602-5d9c718c146d"],
    "IESim": ["6f6e6e26-f123-437d-8ced-dc1d2bc0c3a9"],
    "IESim2": ["bd4fd0a0-c68f-56eb-b99b-8f34b8100299"],
    "IESimAddedEventArgs": ["38bd0a58-4d5a-4d08-8da7-e73eff369ddd"],
    "IESimDiscoverEvent": ["e59ac3e3-39bc-5f6f-9321-0d4a182d261b"],
    "IESimDiscoverResult": ["56b4bb5e-ab2f-5ac6-b359-dd5a8e237926"],
    "IESimDownloadProfileMetadataResult": ["c4234d9e-5ad6-426d-8d00-4434f449afec"],
    "IESimManagerStatics": ["0bfa2c0c-df88-4631-bf04-c12e281b3962"],
    "IESimOperationResult": ["a67b63b1-309b-4e77-9e7e-cd93f1ddc7b9"],
    "IESimPolicy": ["41e1b99d-cf7e-4315-882b-6f1e74b0d38f"],
    "IESimProfile": ["ee1e7880-06a9-4027-b4f8-ddb23d7810e0"],
    "IESimProfileMetadata": ["ed25831f-90db-498d-a7b4-ebce807d3c23"],
    "IESimProfilePolicy": ["e6dd0f1d-9c5c-46c5-a289-a948999bf062"],
    "IESimRemovedEventArgs": ["dec5277b-2fd9-4ed9-8376-d9b5e41278a3"],
    "IESimServiceInfo": ["f16aabcf-7f59-4a51-8494-bd89d5ff50ee"],
    "IESimUpdatedEventArgs": ["4c125cec-508d-4b88-83cb-68bef8168d12"],
    "IESimWatcher": ["c1f84ceb-a28d-4fbf-9771-6e31b81ccf22"],
    "IETFilter": ["c4c4c4b1-0049-4e2b-98fb-9537f6ce516d"],
    "IETFilterConfig": ["c4c4c4d1-0049-4e2b-98fb-9537f6ce516d"],
    "IETFilterEvents": ["c4c4c4c1-0049-4e2b-98fb-9537f6ce516d"],
    "IEUserBroker": ["1ac7516e-e6bb-4a69-b63f-e841904dc5a6"],
    "IEVRFilterConfig": ["83e91e85-82c1-4ea7-801d-85dc50b75086"],
    "IEVRFilterConfigEx": ["aea36028-796d-454f-beee-b48071e24304"],
    "IEVRTrustedVideoPlugin": ["83a4ce40-7710-494b-a893-a472049af630"],
    "IEVRVideoStreamControl": ["d0cfe38b-93e7-4772-8957-0400c49a4485"],
    "IEasClientDeviceInformation": ["54dfd981-1968-4ca3-b958-e595d16505eb"],
    "IEasClientDeviceInformation2": ["ffb35923-bb26-4d6a-81bc-165aee0ad754"],
    "IEasClientSecurityPolicy": ["45b72362-dfba-4a9b-aced-6fe2adcb6420"],
    "IEasComplianceResults": ["463c299c-7f19-4c66-b403-cb45dd57a2b3"],
    "IEasComplianceResults2": ["2fbe60c9-1aa8-47f5-88bb-cb3ef0bffb15"],
    "IEasingColorKeyFrame": ["c733d630-f4b9-4934-9bdd-27ac5ed1cfd8"],
    "IEasingColorKeyFrameStatics": ["6f3837fc-8e3d-4522-9b0f-003db8609851"],
    "IEasingDoubleKeyFrame": ["965adb8d-9a54-4108-b4ff-b5a5212cb338"],
    "IEasingDoubleKeyFrameStatics": ["c8d3d845-dbae-4e5b-8b84-d9537398e5b1"],
    "IEasingFunctionBase": ["c108383f-2c02-4151-8ecd-68ddaa3f0d9b"],
    "IEasingFunctionBaseFactory": ["1830fe6a-f01b-43e0-b61f-b452a1c66fd2"],
    "IEasingFunctionBaseStatics": ["2a5031aa-2c50-4a1d-bb04-d75e07b71548"],
    "IEasingPointKeyFrame": ["b3c91380-6868-4225-a70b-3981cc0b2947"],
    "IEasingPointKeyFrameStatics": ["e22dbfc4-080c-402c-a6b5-f48d0a98116b"],
    "IEccCurveNamesStatics": ["b3ff930c-aeeb-409e-b7d4-9b95295aaecf"],
    "IEchoEffectDefinition": ["0e4d3faa-36b8-4c91-b9da-11f44a8a6610"],
    "IEchoEffectDefinitionFactory": ["0d4e2257-aaf2-4e86-a54c-fb79db8f6c12"],
    "IEdgeBrowserFrame": ["2689f454-ff74-47da-bdf5-397a257dddd9"],
    "IEdgeBrowserImageStoreEvents": ["cab0c4c4-5b58-4605-a101-69ba1fa96ae9"],
    "IEdgeBrowserStreamImageStore": ["d3440f35-9ed5-4103-8a34-d3ba5fdce92d"],
    "IEdgeBrowserTabComponentRemotable": ["d63f088e-bf2f-4b6c-9247-145d2cafdfad"],
    "IEdgeDataModelCB": ["32966928-6fc2-45ec-a8ac-1bc6fd428c83"],
    "IEdgeDispatchVerifyUntrusted": ["d1203147-ac90-44b4-ad8e-b0d91a4f494f"],
    "IEdgeDocNavigate": ["4cdf168a-6e3c-4004-93af-a3d5e3c8dcf9"],
    "IEdgeDownloadManager": ["846c235d-9f6d-4836-9fd0-cf5e167bcda5"],
    "IEdgeDownloadRateCalculator": ["687a3c9e-950a-490f-b706-872b5a95d701"],
    "IEdgeF12HostManagerProcessProvider": ["99961ad8-91b7-4dda-890e-69c92d68daac"],
    "IEdgeFrameHTMLWindowServices": ["0316ed71-3287-4e5b-99db-e6c9a5b8ade4"],
    "IEdgeGesture": ["580d5292-2ab1-49aa-a7f0-33bd3f8df9f1"],
    "IEdgeGestureEventArgs": ["44fa4a24-2d09-42e1-8b5e-368208796a4c"],
    "IEdgeGestureSource": ["faac0612-d697-44ca-a78e-2704f0ce6e9d"],
    "IEdgeGestureStatics": ["bc6a8519-18ee-4043-9839-4fc584d60a14"],
    "IEdgeImmersiveFrameworkInputPaneForwarder": ["5730e20b-3ed2-43e8-ae42-0e444f80b115"],
    "IEdgeLayer": ["70214387-f6ee-4258-85ce-058f03973386"],
    "IEdgeLayerCommandHandler": ["5083f441-f28c-41b2-8d92-d5a979a64ca9"],
    "IEdgeLayerDynamicStateEvents": ["5a39fa2c-96aa-4d11-860c-b354cd6fcff7"],
    "IEdgeLayerState": ["6dea5f64-a1b9-4a55-b795-16b81071924c"],
    "IEdgeLayerStateEvents": ["e2b00d43-51bf-4dd3-88c9-0f287f7b6140"],
    "IEdgeLayerStateProvider": ["24815532-89b7-4b2b-8fde-c11360a3cd94"],
    "IEdgeManagerBroker": ["26ea2529-1012-4dd2-8a8b-3d2de75d3529"],
    "IEdgeManagerBrowsingContextBroker": ["27deaf48-1129-4119-a9fe-737043d09835"],
    "IEdgeModalDialogService": ["36f19ccb-9f8d-453d-9763-4096452f431d"],
    "IEdgeNavigationTarget": ["3f3cc2bd-f4a4-4885-873b-fc0b3c85fbc9"],
    "IEdgeNewTabPageData": ["26971f15-02b9-4dae-a557-8b76afa58d03"],
    "IEdgeReadingModeExtractedContent": ["a2b687e3-e544-4588-8c14-074a7e269eef"],
    "IEdgeRecoveryDataClient": ["dbbf7661-2dda-4ba5-94cf-b67c6c691dc5"],
    "IEdgeRecoveryStore": ["e37a6272-136a-4e62-ac1c-b0817fa90512"],
    "IEdgeSecMgrCacheSeedTarget": ["cebc3bc2-7399-4c7b-a36b-279ff36e0d15"],
    "IEdgeTabBrowserService": ["42d770b2-a093-4bc5-b67f-a1faf560f8f1"],
    "IEdgeTabProtocolLaunch": ["8110d918-82d3-4106-a563-aa29a082bf42"],
    "IEdgeTabRecoveryData": ["069102a8-2d71-43ed-b16c-a19f62a174ba"],
    "IEdgeTabWindow": ["b7c1bea6-2ee2-4d40-ba95-e0cab6405008"],
    "IEdgeTabWindowEvents": ["664ca29d-42e1-4ffa-8edc-af2e8ff59551"],
    "IEdgeTabWindowManager": ["bc47c6e9-7dd7-4c49-aca6-daca4710e807"],
    "IEdgeTabWindowModalManager": ["ac6f1cd9-6942-4000-ae2a-1312ab283167"],
    "IEdgeThreadNeutralCallback": ["e5c2eefc-c0fd-44a0-9b79-dc8756cc87e0"],
    "IEdgeTravelEntry2": ["efff019e-0e50-4d66-ab2b-de5eee43d9f1"],
    "IEdgeTravelLogClientPriv": ["cade2f20-ba76-4e3d-9813-4cc286b9d303"],
    "IEdgeTravelLogClientWrapper": ["a2d6065a-23cd-45d9-8a32-39fd7ec931d5"],
    "IEdgeTravelLogRecoveryData": ["9c504ab5-86fb-4110-8a2b-3e1126b109a0"],
    "IEdgeTravelLogUI": ["3c14419c-5978-4037-9cfe-2c6c396417d0"],
    "IEdgeUIThemeTransition": ["5c86c19b-49d7-19ec-cf19-83a73c6de75e"],
    "IEdgeUIThemeTransitionStatics": ["16a2b13b-4705-302b-27c6-2aac92f645ac"],
    "IEdgeUiDeviceManager": ["b2d4644a-a026-4dde-81be-fb471fc419e8"],
    "IEdgeUiInvocationProvider": ["e42c54ae-af19-4a12-ad01-922a8663e61f"],
    "IEdgeUiManager": ["6e6c3c52-5a5e-4b4b-a0f8-7fe12621a93e"],
    "IEdgeWPCDownloadContext": ["2b45394f-79b0-44e0-93c4-82b06ad9d4c1"],
    "IEdgeWaitOnThreadsBeforeExit": ["903a9856-3dfa-4ae0-91ca-a12d85f10698"],
    "IEdgeWebBrowserPriv": ["c5f926b7-9eaa-41bd-be4a-a163d87c6e59"],
    "IEdgeWebBrowserPriv2": ["4f6ffd9c-9931-4b77-8e9f-98435d2ff223"],
    "IEdgeWebBrowserPriv3": ["8537ef7d-e7d5-4f92-b3a1-8e0f8f1baff9"],
    "IEdgeWebPageMetaInfo": ["15b0d6be-e159-4bf4-bd45-43daa8eedc96"],
    "IEditionUpgradeBroker": ["ff19cbcf-9455-4937-b872-6b7929a460af"],
    "IEditionUpgradeHelper": ["d3e9e342-5deb-43b6-849e-6913b85d503a"],
    "IEducationSettingsStatics": ["fc53f0ef-4d3e-4e13-9b23-505f4d091e92"],
    "IEffectivePermission": ["3853dc76-9f35-407c-88a1-d19344365fbc"],
    "IEffectivePermission2": ["941fabca-dd47-4fca-90bb-b0e10255f20d"],
    "IEffectiveViewportChangedEventArgs": ["55ee2e81-1c18-59ed-bd3d-c4ca8fa7d190"],
    "IElasticEase": ["ef5ba58c-b0b6-4a6c-9ca8-fb4233f12459"],
    "IElasticEaseStatics": ["a9f566ec-fe9c-4b2b-8e52-bb785d562185"],
    "IElementCompositionPreview": ["b6f1a676-cfe6-46ac-acf6-c4687bb65e60"],
    "IElementCompositionPreviewStatics": ["08c92b38-ec99-4c55-bc85-a1c180b27646"],
    "IElementCompositionPreviewStatics2": ["24148fbb-23d6-4f37-ba0c-0733e799722d"],
    "IElementCompositionPreviewStatics3": ["843bc4c3-c105-59fe-a3d1-373c1d3e6fbc"],
    "IElementFactory": ["17d2ad90-1370-55c8-80e1-78b49004a9e1"],
    "IElementFactoryGetArgs": ["fb508774-41a3-5829-9255-cf452d041df4"],
    "IElementFactoryGetArgsFactory": ["c3b6dae7-883b-5fd7-be80-2059d877e783"],
    "IElementFactoryRecycleArgs": ["86f16b14-37e8-5dd8-a90c-25d3710318b0"],
    "IElementFactoryRecycleArgsFactory": ["8d926509-ea0d-541b-8271-f9e9118f5e7c"],
    "IElementSelector": ["30510463-98b5-11cf-bb82-00aa00bdce0b"],
    "IElementSoundPlayer": ["387773a5-f036-460c-9b81-f3d6ea43f6f2"],
    "IElementSoundPlayerStatics": ["217a9004-981d-41c9-b152-ada911a4b13a"],
    "IElementSoundPlayerStatics2": ["f2505956-ed41-48d7-aae8-f2abcb444929"],
    "IElementSpy": ["318995d3-e706-4216-a6eb-560ff9e96a82"],
    "IElementTraversal": ["30510736-98b5-11cf-bb82-00aa00bdce0b"],
    "IElevatableDiscImageMount": ["3dca391f-7a6c-4240-af1c-fd209d7ec6e5"],
    "IElevatedCopyEngineCache": ["c57cc5a4-49a0-4c2c-9ce1-30e2cc589e52"],
    "IElevatedFactoryServer": ["804bd226-af47-4d71-b492-443a57610b08"],
    "IElevatedFactoryServerManager": ["36df1a3d-973d-4956-b55a-47de453e8103"],
    "IElevatedOperationEngineInfo": ["ae108cc3-7fb6-4b79-b46c-0bd2b9d4d10d"],
    "IEllipse": ["70e05ac4-d38d-4bab-831f-4a22ef52ac86"],
    "IEllipseGeometry": ["d4f61bba-4ea2-40d6-aa6c-8d38aa87651f"],
    "IEllipseGeometryStatics": ["1744db47-f635-4b16-aee6-e052a65defb2"],
    "IEmailAction": ["10f62c64-7e16-4314-a0c2-0c3683f99d40"],
    "IEmailAttachment": ["f353caf9-57c8-4adb-b992-60fceb584f54"],
    "IEmailAttachment2": ["225f1070-b0ff-4571-9d54-a706c48d55c6"],
    "IEmailAttachmentFactory": ["796eac46-ed56-4979-8708-abb8bc854b7d"],
    "IEmailAttachmentFactory2": ["23259435-51f9-427d-adcd-241023c8cfb7"],
    "IEmailConversation": ["da18c248-a0bc-4349-902d-90f66389f51b"],
    "IEmailConversationBatch": ["b8c1ab81-01c5-432a-9df1-fe85d98a279a"],
    "IEmailConversationReader": ["b4630f82-2875-44c8-9b8c-85beb3a3c653"],
    "IEmailDataProviderConnection": ["3b9c9dc7-37b2-4bf0-ae30-7b644a1c96e1"],
    "IEmailDataProviderTriggerDetails": ["8f3e4e50-341e-45f3-bba0-84a005e1319a"],
    "IEmailFolder": ["a24f7771-996c-4864-b1ba-ed1240e57d11"],
    "IEmailIrmInfo": ["90f52193-b1a0-4ebd-a6b6-ddca55606e0e"],
    "IEmailIrmInfoFactory": ["314bb18c-e3e6-4d7b-be8d-91a96311b01b"],
    "IEmailIrmTemplate": ["f327758d-546d-4bea-a963-54a38b2cc016"],
    "IEmailIrmTemplateFactory": ["3da31876-8738-4418-b9cb-471b936fe71e"],
    "IEmailItemCounts": ["5bd13321-fec8-4bab-83ba-0baf3c1f6cbd"],
    "IEmailMailbox": ["a8790649-cf5b-411b-80b1-4a6a1484ce25"],
    "IEmailMailbox2": ["14f8e404-6ca2-4ab2-9241-79cd7bf46346"],
    "IEmailMailbox3": ["3da5897b-458b-408a-8e37-ac8b05d8af56"],
    "IEmailMailbox4": ["5d1f301b-f222-48a7-b7b6-716356cd26a1"],
    "IEmailMailbox5": ["39967087-0092-49be-bd0e-5d4dc9d96d90"],
    "IEmailMailboxAction": ["ac9889fa-21fa-4927-9210-d410582fdf3e"],
    "IEmailMailboxAutoReply": ["e223254c-8ab4-485b-b31f-04d15476bd59"],
    "IEmailMailboxAutoReplySettings": ["a87a9fa8-0ac6-4b77-ba77-a6b99e9a27b8"],
    "IEmailMailboxCapabilities": ["eedec3a6-89db-4305-82c4-439e0a33da11"],
    "IEmailMailboxCapabilities2": ["69723ee4-2f21-4cbc-88ab-2e7602a4806b"],
    "IEmailMailboxCapabilities3": ["f690e944-56f2-45aa-872c-0ce9f3db0b5c"],
    "IEmailMailboxChange": ["61edf54b-11ef-400c-adde-8cde65c85e66"],
    "IEmailMailboxChangeReader": ["bdbd0ebb-c53d-4331-97be-be75a2146a75"],
    "IEmailMailboxChangeTracker": ["7ae48638-5166-42b7-8882-fd21c92bdd4b"],
    "IEmailMailboxChangedDeferral": ["779a74c1-97c5-4b54-b30d-306232623e6d"],
    "IEmailMailboxChangedEventArgs": ["3cfd5f6e-01d4-4e4a-a44c-b22dd42ec207"],
    "IEmailMailboxCreateFolderRequest": ["184d3775-c921-4c39-a309-e16c9f22b04b"],
    "IEmailMailboxCreateFolderRequestEventArgs": ["03e4c02c-241c-4ea9-a68f-ff20bc5afc85"],
    "IEmailMailboxCreateFolderResult": ["b228557f-2885-4998-b595-8a2d374ce950"],
    "IEmailMailboxDeleteFolderRequest": ["9469e88a-a931-4779-923d-09a3ea292e29"],
    "IEmailMailboxDeleteFolderRequestEventArgs": ["b4d32d06-2332-4678-8378-28b579336846"],
    "IEmailMailboxDownloadAttachmentRequest": ["0b1dbbb4-750c-48e1-bce4-8d589684ffbc"],
    "IEmailMailboxDownloadAttachmentRequestEventArgs": ["ccddc46d-ffa8-4877-9f9d-fed7bcaf4104"],
    "IEmailMailboxDownloadMessageRequest": ["497b4187-5b4d-4b23-816c-f3842beb753e"],
    "IEmailMailboxDownloadMessageRequestEventArgs": ["470409ad-d0a0-4a5b-bb2a-37621039c53e"],
    "IEmailMailboxEmptyFolderRequest": ["fe4b03ab-f86d-46d9-b4ce-bc8a6d9e9268"],
    "IEmailMailboxEmptyFolderRequestEventArgs": ["7183f484-985a-4ac0-b33f-ee0e2627a3c0"],
    "IEmailMailboxForwardMeetingRequest": ["616d6af1-70d4-4832-b869-b80542ae9be8"],
    "IEmailMailboxForwardMeetingRequestEventArgs": ["2bd8f33a-2974-4759-a5a5-58f44d3c0275"],
    "IEmailMailboxGetAutoReplySettingsRequest": ["9b380789-1e88-4e01-84cc-1386ad9a2c2f"],
    "IEmailMailboxGetAutoReplySettingsRequestEventArgs": ["d79f55c2-fd45-4004-8a91-9bacf38b7022"],
    "IEmailMailboxMoveFolderRequest": ["10ba2856-4a95-4068-91cc-67cc7acf454f"],
    "IEmailMailboxMoveFolderRequestEventArgs": ["38623020-14ba-4c88-8698-7239e3c8aaa7"],
    "IEmailMailboxPolicies": ["1f3345c5-1c3b-4dc7-b410-6373783e545d"],
    "IEmailMailboxPolicies2": ["bab58afb-a14b-497c-a8e2-55eac29cc4b5"],
    "IEmailMailboxPolicies3": ["bdd4a01f-4867-414a-81a2-803919c44191"],
    "IEmailMailboxProposeNewTimeForMeetingRequest": ["5aeff152-9799-4f9f-a399-ff07f3eef04e"],
    "IEmailMailboxProposeNewTimeForMeetingRequestEventArgs": ["fb480b98-33ad-4a67-8251-0f9c249b6a20"],
    "IEmailMailboxResolveRecipientsRequest": ["efa4cf70-7b39-4c9b-811e-41eaf43a332d"],
    "IEmailMailboxResolveRecipientsRequestEventArgs": ["260f9e02-b2cf-40f8-8c28-e3ed43b1e89a"],
    "IEmailMailboxServerSearchReadBatchRequest": ["090eebdf-5a96-41d3-8ad8-34912f9aa60e"],
    "IEmailMailboxServerSearchReadBatchRequestEventArgs": ["14101b4e-ed9e-45d1-ad7a-cc9b7f643ae2"],
    "IEmailMailboxSetAutoReplySettingsRequest": ["75a422d0-a88e-4e54-8dc7-c243186b774e"],
    "IEmailMailboxSetAutoReplySettingsRequestEventArgs": ["09da11ad-d7ca-4087-ac86-53fa67f76246"],
    "IEmailMailboxSyncManager": ["517ac55a-3591-4b5d-85bc-c71dde862263"],
    "IEmailMailboxSyncManager2": ["cd8dc97e-95c1-4f89-81b7-e6aecb6695fc"],
    "IEmailMailboxSyncManagerSyncRequest": ["4e10e8e4-7e67-405a-b673-dc60c91090fc"],
    "IEmailMailboxSyncManagerSyncRequestEventArgs": ["439a031a-8fcc-4ae5-b9b5-d434e0a65aa8"],
    "IEmailMailboxUpdateMeetingResponseRequest": ["5b99ac93-b2cf-4888-ba4f-306b6b66df30"],
    "IEmailMailboxUpdateMeetingResponseRequestEventArgs": ["6898d761-56c9-4f17-be31-66fda94ba159"],
    "IEmailMailboxValidateCertificatesRequest": ["a94d3931-e11a-4f97-b81a-187a70a8f41a"],
    "IEmailMailboxValidateCertificatesRequestEventArgs": ["2583bf17-02ff-49fe-a73c-03f37566c691"],
    "IEmailManagerForUser": ["f773de9f-3ca5-4b0f-90c1-156e40174ce5"],
    "IEmailManagerStatics": ["f5128654-55c5-4890-a824-216c2618ce7f"],
    "IEmailManagerStatics2": ["ac052da3-b194-425d-b6d9-d0f04135eda2"],
    "IEmailManagerStatics3": ["4a722395-843e-4945-b3aa-349e07a362c5"],
    "IEmailMeetingInfo": ["31c03fa9-7933-415f-a275-d165ba07026b"],
    "IEmailMeetingInfo2": ["7e59386d-b0d9-4fe5-867c-e31ed2b588b8"],
    "IEmailMessage": ["6c6d948d-80b5-48f8-b0b1-e04e430f44e5"],
    "IEmailMessage2": ["fdc8248b-9f1a-44db-bd3c-65c384770f86"],
    "IEmailMessage3": ["a1ea675c-e598-4d29-a018-fc7b7eece0a1"],
    "IEmailMessage4": ["317cf181-3e7f-4a05-8394-3e10336dd435"],
    "IEmailMessageBatch": ["605cd08f-25d9-4f1b-9e51-0514c0149653"],
    "IEmailMessageReader": ["2f4abe9f-6213-4a85-a3b0-f92d1a839d19"],
    "IEmailQueryOptions": ["45504b9b-3e7f-4d52-b6dd-d6fd4e1fbd9a"],
    "IEmailQueryOptionsFactory": ["88f1a1b8-78ab-4ee8-b4e3-046d6e2fe5e2"],
    "IEmailQueryTextSearch": ["9fa0a288-3c5d-46a5-a6e2-31d6fd17e540"],
    "IEmailRecipient": ["cae825b3-4478-4814-b900-c902b5e19b53"],
    "IEmailRecipientFactory": ["5500b84d-c79a-4ef8-b909-722e18e3935d"],
    "IEmailRecipientResolutionResult": ["918338fa-8d8d-4573-80d1-07172a34b98d"],
    "IEmailRecipientResolutionResult2": ["5e420bb6-ce5b-4bde-b9d4-e16da0b09fca"],
    "IEmailStore": ["f803226e-9137-4f8b-a470-279ac3058eb6"],
    "IEmailStoreNotificationTrigger": ["986d06da-47eb-4268-a4f2-f3f77188388a"],
    "IEmailStoreNotificationTriggerDetails": ["ce17563c-46e6-43c9-96f7-facf7dd710cb"],
    "IEmbeddedAudioTrack": ["55ee5a7a-2d30-3fba-a190-4f1a6454f88f"],
    "IEmbeddedD2DObject": ["caa99e5c-dc58-429d-bc18-390ec433000f"],
    "IEnableOpenFromScc": ["795635a1-4522-11d1-8dce-00aa00a3f593"],
    "IEnclosureLocation": ["42340a27-5810-459c-aabb-c65e1f813ecf"],
    "IEnclosureLocation2": ["2885995b-e07d-485d-8a9e-bdf29aef4f66"],
    "IEncoderAPI": ["70423839-6acc-4b23-b079-21dbf08156a5"],
    "IEncryptedAndAuthenticatedData": ["6fa42fe7-1ecb-4b00-bea5-60b83f862f17"],
    "IEndpointPair": ["33a0aa36-f8fa-4b30-b856-76517c3bd06d"],
    "IEndpointPairFactory": ["b609d971-64e0-442b-aa6f-cc8c8f181f78"],
    "IEnforceGrfMode": ["8c9ee71b-4660-49a0-926e-e97a3379cdd7"],
    "IEnhancedStorageACT": ["6e7781f4-e0f2-4239-b976-a01abab52930"],
    "IEnhancedStorageACT2": ["4da57d2e-8eb3-41f6-a07e-98b52b88242b"],
    "IEnhancedStorageACT3": ["022150a1-113d-11df-bb61-001aa01bbc58"],
    "IEnhancedStorageSilo": ["5aef78c6-2242-4703-bf49-44b29357a359"],
    "IEnhancedStorageSiloAction": ["b6f7f311-206f-4ff8-9c4b-27efee77a86f"],
    "IEnhancedWaypoint": ["ed268c74-5913-11e6-8b77-86f30ca893d3"],
    "IEnhancedWaypointFactory": ["af868477-a2aa-46dd-b645-23b31b8aa6c7"],
    "IEnhancement": ["f4e26c7b-0d88-4f41-87e2-b01bd0aa96d6"],
    "IEnlistingInProject": ["f59fd070-0063-4256-8212-e5db6fc22253"],
    "IEnteredBackgroundEventArgs": ["f722dcc2-9827-403d-aaed-ecca9ac17398"],
    "IEnteredBackgroundEventHandler": ["2b09a173-b68e-4def-88c1-8de84e5aab2f", "93a956ae-1d7f-438b-b7b8-227d96b609c0"],
    "IEnterpriseChromeManager": ["4ea5c164-584a-4ba9-b420-86aa52d1c92f"],
    "IEnterpriseChromeServiceProvider": ["b41c09aa-0e12-4da0-829e-0ba17fca01ba"],
    "IEnterpriseDropTarget": ["390e3878-fd55-4e18-819d-4682081c0cfd"],
    "IEnterpriseIdChangeNotification": ["374fdd79-cca2-4be4-a49d-0508c29743bc"],
    "IEnterpriseKeyCredentialRegistrationInfo": ["38321acc-672b-4823-b603-6b3c753daf97"],
    "IEnterpriseKeyCredentialRegistrationManager": ["83f3be3f-a25f-4cba-bb8e-bdc32d03c297"],
    "IEnterpriseKeyCredentialRegistrationManagerStatics": ["77b85e9e-acf4-4bc0-bac2-40bb46efbb3f"],
    "IEntity": ["24264891-e80b-4fd3-b7ce-4ff2fae8931f"],
    "IEntranceNavigationTransitionInfo": ["720a256b-1c8a-41ee-82ec-8a87c0cf47da"],
    "IEntranceNavigationTransitionInfoStatics": ["f948c27a-40c9-469f-8f33-bf45c8811f21"],
    "IEntranceThemeTransition": ["07698c09-a8e3-419a-a01d-7410a0ae8ec8"],
    "IEntranceThemeTransitionStatics": ["37cc0577-ff98-4aed-b86e-5ec23702f877"],
    "IEnumAccounts": ["50c852b0-c95f-4fee-be00-87dc18b2661b"],
    "IEnumActions": ["7a6335c8-7884-11d0-a8a9-00a0c921a4d2"],
    "IEnumAssocHandlers": ["973810ae-9599-4b88-9e4d-6ee98c9552da"],
    "IEnumAutoplayHandler": ["fff994dd-e785-11d6-8f9f-00065bbd32bd"],
    "IEnumAvailableCategories": ["14a821a6-97e8-11d9-8309-000d9dff97d3"],
    "IEnumAvailableNetworks": ["14a82191-97e8-11d9-8309-000d9dff97d3"],
    "IEnumBSTR": ["3d8bed7a-4fde-4149-9ffa-46e6bb9adf21"],
    "IEnumBackgroundCopyGroups": ["d993e603-4aa4-47c5-8665-c20d39c2ba4f"],
    "IEnumBackgroundCopyJobs1": ["8baeba9d-8f1c-42c4-b82c-09ae79980d25"],
    "IEnumBitsPeerCacheRecords": ["659cdea4-489e-11d9-a9cd-000d56965251"],
    "IEnumBitsPeers": ["659cdea5-489e-11d9-a9cd-000d56965251"],
    "IEnumBooleanExpression": ["8ab14053-a4a3-45d0-ae7e-1b56a81bb2f7"],
    "IEnumCATID": ["0002e000-0000-0000-c000-000000000046"],
    "IEnumCERTVIEWATTRIBUTE": ["e77db656-7653-11d1-9bde-00c04fb683fa"],
    "IEnumCERTVIEWCOLUMN": ["9c735be2-57a5-11d1-9bdb-00c04fb683fa"],
    "IEnumCERTVIEWEXTENSION": ["e7dd1466-7653-11d1-9bde-00c04fb683fa"],
    "IEnumCERTVIEWROW": ["d1157f4c-5af2-11d1-9bdc-00c04fb683fa"],
    "IEnumCLSID": ["0002e000-0000-0000-c000-000000000046"],
    "IEnumChangeUnitExceptions": ["3074e802-9319-4420-be21-1022e2e21da8"],
    "IEnumChunkEdgeTravelLogRecoveryData": ["fc8c5a10-5612-445e-a07f-8632799add20"],
    "IEnumChunkTravelLogRecoveryData": ["26115904-fdf5-4204-a8b1-800a15af91e0"],
    "IEnumClientSyncHandlers": ["30da6b29-4bb0-41d7-91c6-b88d695f4cfc"],
    "IEnumClockVector": ["525844db-2837-4799-9e80-81a66e02220c"],
    "IEnumCodePaths2": ["9b13f80d-cfc6-4b78-81ef-1f7cc33f7639"],
    "IEnumComReferences": ["46b4b7c2-11eb-4753-be4b-0e0a16e9ce53"],
    "IEnumComponentTypes": ["8a674b4a-1f63-11d3-b64c-00c04f79498e"],
    "IEnumComponents": ["2a6e2939-2595-11d3-b64c-00c04f79498e", "9a04b730-656c-11d3-85fc-00c04f6123b3"],
    "IEnumComputeThreadInfo110": ["983c0ef8-f4f3-432c-8d4a-0866c55d4b79"],
    "IEnumConnectionManagerUICategory": ["007c90e2-33be-46b7-b86c-eff659c26d4b"],
    "IEnumConnectionManagerUIItem": ["007c90e3-33be-46b7-b86c-eff659c26d4b"],
    "IEnumCookieSessionData": ["1a054188-308f-4142-8657-e8f573d904bd"],
    "IEnumCredentialSessionData": ["6c9e6e89-fb93-4148-a48a-453686cc2943"],
    "IEnumDMO": ["2c3cd98a-2bfa-4a53-9c27-5249ba64ba0f"],
    "IEnumDebugAddresses": ["c2e34ebd-8b9d-11d2-9014-00c04fa38338"],
    "IEnumDebugBoundBreakpoints2": ["0f6b37e0-fcfe-44d9-9112-394ca9b92114"],
    "IEnumDebugCodeContexts2": ["ad47a80b-eda7-459e-af82-647cc9fbaa50"],
    "IEnumDebugCodePaths90": ["0b6520fb-1417-4599-9806-0d254f3c1869"],
    "IEnumDebugComputeKernel110": ["9a663b05-dc59-41d4-bebf-a6a574d1d3ec"],
    "IEnumDebugCustomAttributes": ["d9089ef0-22d1-40b9-81d6-47cbda9dc32c"],
    "IEnumDebugENCInfo2": ["7b076ad1-bd51-11d2-9238-00a02448799a"],
    "IEnumDebugENCRelinkInfo2": ["e51be743-bd57-11d2-9238-00a02448799a"],
    "IEnumDebugENCSnapshots2": ["f6f94d1a-78c2-11d2-8ffe-00c04fa38314"],
    "IEnumDebugErrorBreakpoints2": ["e158f5aa-31fe-491b-a9f6-cff934b03a01"],
    "IEnumDebugErrorInfos2": ["f6f94d23-78c2-11d2-8ffe-00c04fa38314"],
    "IEnumDebugExceptionInfo150": ["418c94a5-23b8-461e-a117-69543ce0db36"],
    "IEnumDebugExceptionInfo2": ["8e4bbd34-a2f4-41ef-87b5-c563b4ad6ee7"],
    "IEnumDebugFields": ["c2e34ebc-8b9d-11d2-9014-00c04fa38338"],
    "IEnumDebugFrameInfo2": ["98bbba48-4c4d-4fff-8340-6097bec9c894"],
    "IEnumDebugFrameInfoFilter2": ["6cd4fb40-f954-44e0-b8a5-a614481e0831"],
    "IEnumDebugIDBInfo2": ["b34e469b-bd59-11d2-9238-00a02448799a"],
    "IEnumDebugMachines2_V7": ["61d986ec-1eac-46b6-90ff-402a008f15d1"],
    "IEnumDebugMachines2__deprecated": ["61d986ec-1eac-46b6-90ff-402a008f15d1"],
    "IEnumDebugModules2": ["4c4a2835-682e-4ce1-aebc-1e6b3a165b44"],
    "IEnumDebugObjects": ["0881751c-99f4-11d2-b767-0000f87572ef"],
    "IEnumDebugPendingBreakpoints2": ["70d2dc1e-4dcc-4786-a072-9a3b600c216b"],
    "IEnumDebugPortSuppliers2": ["59c9dc99-3eff-4ff3-b201-98acd01b0d87"],
    "IEnumDebugPorts2": ["bc827c5e-99ae-4ac8-83ad-2ea5c2034333"],
    "IEnumDebugProcesses2": ["96c74ef4-185d-4f9a-8a43-4d2723758e0a"],
    "IEnumDebugPrograms2": ["8d14bca6-34ce-4efe-ac7e-0abc61dadb20"],
    "IEnumDebugPropertyInfo2": ["6c7072c3-3ac4-408f-a680-fc5a2f96903e"],
    "IEnumDebugReferenceInfo2": ["e459dd12-864f-4aaa-abc1-dcecbc267f04"],
    "IEnumDebugSessionFrameInfo2": ["ef7262c4-4a01-42a0-8658-932667b27555"],
    "IEnumDebugStackFrames2": ["cd39102b-4b69-4495-8f29-e0b25c4a8855"],
    "IEnumDebugTelemetryProperty150": ["161ea122-d0a3-47a8-9063-f6878e0f5f9b"],
    "IEnumDebugThreads2": ["0d30dc12-c4f8-433d-9fcc-9ff117e5e5f4"],
    "IEnumDefinitionIdentity": ["f3549d9c-fc73-4793-9c00-1cd204254c0c"],
    "IEnumDiskQuotaUsers": ["7988b577-ec89-11cf-9c00-00aa00a14f56"],
    "IEnumDot11AdHocInterfaces": ["8f10cc2c-cf0d-42a0-acbe-e2de7007384d"],
    "IEnumDot11AdHocNetworks": ["8f10cc28-cf0d-42a0-acbe-e2de7007384d"],
    "IEnumDot11AdHocSecuritySettings": ["8f10cc2d-cf0d-42a0-acbe-e2de7007384d"],
    "IEnumDpxContainerDirectoryEntries": ["ddc1b725-0e55-452f-838e-d1505b866e2b"],
    "IEnumDpxContainers": ["ddc1b722-0e55-452f-838e-d1505b866e2b"],
    "IEnumDpxFiles": ["ddc1b723-0e55-452f-838e-d1505b866e2b"],
    "IEnumEnhancedStorageACT": ["09b224bd-1335-4631-a7ff-cfd3a92646d7"],
    "IEnumEnhancements": ["ecf43b3a-724a-46bb-bad3-6afe0bef0728"],
    "IEnumExplorerCommand": ["a88826f8-186f-4987-aade-ea0cef8fbfe8"],
    "IEnumFeedClockVector": ["550f763d-146a-48f6-abeb-6c88c7f70514"],
    "IEnumFontNames": ["35d81c54-6448-459c-86b4-a48d1f7746ff"],
    "IEnumFsiItems": ["2c941fda-975b-59be-a960-9a2a262853a5"],
    "IEnumFullIDList": ["d0191542-7954-4908-bc06-b2360bbe45ba"],
    "IEnumGroupEvaluationResultContext110": ["cb9d13f7-b6ec-4971-8075-7a21554d0f4b"],
    "IEnumGroupEvaluationResults110": ["b9ab98d4-0454-4093-8793-2eba79e8c66e"],
    "IEnumGuideDataProperties": ["ae44423b-4571-475c-ad2c-f40a771d80ef"],
    "IEnumHierarchies": ["bec77711-2df9-44d7-b478-a453c2e8a134"],
    "IEnumHierarchyItems": ["687396ae-252e-460f-8f54-ef2c521bb6d8"],
    "IEnumHomegroupRecords": ["2d046f31-f907-4c9e-8f8d-838f617e2975"],
    "IEnumIDENTITY_ATTRIBUTE": ["9cdaae75-246e-4b00-a26d-b9aec137a3eb"],
    "IEnumITfCompositionView": ["5efd22ba-7838-46cb-88e2-cadb14124f8f"],
    "IEnumItemIds": ["43aa3f61-4b2e-4b60-83df-b110d3e148f1"],
    "IEnumJsStackFrames": ["5e7da34b-fb51-4791-abe7-cb5bdf419755"],
    "IEnumLocalClouds": ["34f25baa-6769-485a-88c9-39fcecb9522c"],
    "IEnumMCString": ["32a3094f-0063-4370-9f1c-ca8cf131d631"],
    "IEnumMSVidGraphSegment": ["3dd2903e-e0aa-11d2-b63a-00c04f79498e"],
    "IEnumManagerFrames": ["3caa826a-9b1f-4a79-bc81-f0430ded1648"],
    "IEnumMatchedStackFrameInfo110": ["7007bef7-8a7d-4539-bd92-9b177b75aec9"],
    "IEnumMsiRecord": ["000c1023-0000-0000-c000-000000000046"],
    "IEnumMsiString": ["000c1022-0000-0000-c000-000000000046"],
    "IEnumMsiVolume": ["000c1024-0000-0000-c000-000000000046"],
    "IEnumMsmConfigurableItem": ["832c6969-4826-4c24-a397-b7002d8196e6"],
    "IEnumMsmDependency": ["0adda82c-2c26-11d2-ad65-00a0c9af11a6"],
    "IEnumMsmError": ["0adda829-2c26-11d2-ad65-00a0c9af11a6"],
    "IEnumMsmString": ["0adda826-2c26-11d2-ad65-00a0c9af11a6"],
    "IEnumMsoView": ["b722bcc8-4e68-101b-a2bc-00aa00404770"],
    "IEnumNamedWindows": ["e6b08c04-e901-43d9-ba29-05617e373bda"],
    "IEnumNetwork": ["26656eaa-54eb-4e6f-8f85-4f0ef901a406"],
    "IEnumNetworkConnections": ["dcb00006-570f-4a9b-8d69-199fdba5723b"],
    "IEnumNetworkInterface": ["bcd1de7e-2db1-418b-b047-4a74e101f8c1"],
    "IEnumNetworkSignature": ["de9a958a-a1a5-4812-bdf7-18518ffa6c86"],
    "IEnumNetworks": ["dcb00003-570f-4a9b-8d69-199fdba5723b"],
    "IEnumObjects": ["2c1c7e2e-2d0e-4059-831e-1e6f82335c2e"],
    "IEnumOfflineFilesData": ["3327e7aa-f023-4a21-b83d-c0fee2725fc7"],
    "IEnumOfflineFilesItems": ["da70e815-c361-4407-bc0b-0d7046e5f2cd"],
    "IEnumOfflineFilesSettingNames": ["8cdf4b81-ad17-43e9-ab3e-12e5c10934ad"],
    "IEnumOfflineFilesSettings": ["729680c4-1a38-47bc-9e5c-02c51562ac30"],
    "IEnumOfflineFilesSyncConflicts": ["08ccde75-0b6c-41e6-b75c-575401c7b1aa"],
    "IEnumOfflineFilesSyncContextItems": ["d35e46dc-7ac5-41b8-91aa-7660cd315eea"],
    "IEnumOpenServiceActivity": ["a436d7d2-17c3-4ef4-a1e8-5c86faff26c0"],
    "IEnumOpenServiceActivityCategory": ["33627a56-8c9a-4430-8fd1-b5f5c771afb6"],
    "IEnumPIDMap": ["afb6c2a2-2c41-11d3-8a60-0000f81e0e4a"],
    "IEnumPackages": ["9673a35f-c03a-438d-bd7e-27d9e28ac184"],
    "IEnumPortableDeviceConnectors": ["bfdef549-9247-454f-bd82-06fe80853faa"],
    "IEnumPortableDeviceObjectIDs": ["10ece955-cf41-4728-bfa0-41eedf1bbf19"],
    "IEnumPreviousVersionsCallback": ["c8f026da-8f7d-40aa-a780-41525ebdcc1f"],
    "IEnumProgressItems": ["2c941fd6-975b-59be-a960-9a2a262853a5"],
    "IEnumProgressUpdates": ["2c06eab7-1814-4def-9625-0f3ec1ef0bc7"],
    "IEnumProjectStartupServices": ["9e6f916a-3e8b-4741-8afb-5187f82b699b"],
    "IEnumPropertyUpdates": ["8c85b440-d8f7-48c3-98e0-a91513f7d829"],
    "IEnumPushedPrinterConnections": ["87f825d5-4e6c-4df2-b6b6-240745c98ff4"],
    "IEnumRangeExceptions": ["0944439f-ddb1-4176-b703-046ff22a2386"],
    "IEnumReadyCallback": ["61e00d45-8fff-4e60-924e-6537b61612dd"],
    "IEnumRecoveryCookieJar": ["036438a5-d9ac-4353-a567-69298fdaa990"],
    "IEnumRecoveryCredential": ["d358f4e1-0465-4965-9dd5-cae303d2c345"],
    "IEnumReferenceIdentity": ["b30352cf-23da-4577-9b3f-b4e6573be53b"],
    "IEnumResources": ["2dd81fe3-a83c-4da9-a330-47249d345ba1"],
    "IEnumRunningDocuments": ["d5c658c5-59a1-414f-af5e-e72e83377eae"],
    "IEnumSaDevices": ["55c82f5b-97c8-49a6-8624-8417fe7339d2"],
    "IEnumSearchFolderOutOfProc": ["d6f8ec75-a388-47de-ba3a-903b12a38e86"],
    "IEnumSearchRoots": ["ab310581-ac80-11d1-8df3-00c04fb6ef52"],
    "IEnumSearchScopeRules": ["ab310581-ac80-11d1-8df3-00c04fb6ef54"],
    "IEnumShareInfo": ["65afe70b-8d5b-4c25-9eec-7438e208e07b"],
    "IEnumShellItems": ["70629033-e363-4a28-a567-0db78006e6d7"],
    "IEnumSingleItemExceptions": ["e563381c-1b4d-4c66-9796-c86faccdcd40"],
    "IEnumSnapinNode": ["950d574d-7f36-4f37-a750-07cd3659d6bc"],
    "IEnumSpObjectTokens": ["06b64f9e-7fda-11d2-b4f2-00c04f797396"],
    "IEnumSpeechCommands": ["8c5dac4f-083c-4b85-a4c9-71746048adca"],
    "IEnumSpellingError": ["803e3bd4-2828-4410-8290-418d1d73c762"],
    "IEnumStreamBufferRecordingAttrib": ["c18a9162-1e82-4142-8c73-5690fa62fe33"],
    "IEnumStreamIdMap": ["945c1566-6202-46fc-96c7-d87f289c6534"],
    "IEnumSyncChangeUnits": ["346b35f1-8703-4c6d-ab1a-4dbca2cff97f"],
    "IEnumSyncChanges": ["5f86be4a-5e78-4e32-ac1c-c24fd223ef85"],
    "IEnumSyncMgrConflict": ["82705914-dda3-4893-ba99-49de6c8c8036"],
    "IEnumSyncMgrEventInfo": ["b979fe94-9f8b-4734-a509-7a33f75d6737"],
    "IEnumSyncMgrEvents": ["c81a1d4e-8cf7-4683-80e0-bcae88d677b6"],
    "IEnumSyncMgrFolderItemInfo": ["06091ffe-0b9b-4b2a-b933-0ab0fea8b26d"],
    "IEnumSyncMgrSyncItems": ["54b3abf3-f085-4181-b546-e29c403c726b"],
    "IEnumSyncProviderConfigUIInfos": ["f6be2602-17c6-4658-a2d7-68ed3330f641"],
    "IEnumSyncProviderInfos": ["a04ba850-5eb1-460d-a973-393fcb608a11"],
    "IEnumSystemAssemblies": ["7431fce8-8e4f-49b6-bb50-e295636cba6b"],
    "IEnumTargetFrameworks": ["d92c0b96-e08d-4268-a941-6d7d670f1820"],
    "IEnumTextBlobIds": ["5fed305e-baaf-42c6-9ed9-f25f5f53a6ec"],
    "IEnumTextTrackers": ["c78232b3-a5b8-4613-b6c3-685e5ce2d259"],
    "IEnumTfCandidates": ["defb1926-6c80-4ce8-87d4-d6b72b812bde"],
    "IEnumTfContextViews": ["f0c0f8dd-cf38-44e1-bb0f-68cf0d551c78"],
    "IEnumTfContexts": ["8f1a7ea6-1654-4502-a86e-b2902344d507"],
    "IEnumTfConversionCandidate": ["1a9fb7b5-efaf-4c0b-b59e-7b1ad1cb9f60"],
    "IEnumTfDisplayAttributeInfo": ["7cef04d7-cb75-4e80-a7ab-5f5bc7d332de"],
    "IEnumTfDocumentMgrs": ["aa80e808-2021-11d2-93e0-0060b067b86e"],
    "IEnumTfFunctionProviders": ["e4b24db0-0990-11d3-8df0-00105a2799b5"],
    "IEnumTfInputProcessorProfiles": ["71c6e74d-0f28-11d8-a82a-00065b84435c"],
    "IEnumTfLangBarItems": ["583f34d0-de25-11d2-afdd-00105a2799b5"],
    "IEnumTfLanguageProfiles": ["3d61bf11-ac5f-42c8-a4cb-931bcc28c744"],
    "IEnumTfLatticeElements": ["56988052-47da-4a05-911a-e3d941f17145"],
    "IEnumTfProperties": ["19188cb0-aca9-11d2-afc5-00105a2799b5"],
    "IEnumTfPropertyValue": ["8ed8981b-7c10-4d7d-9fb3-ab72e9c75f72"],
    "IEnumTfRanges": ["f99d3f40-8e32-11d2-bf46-00105a2799b5"],
    "IEnumTfRenderingMarkup": ["8c03d21b-95a7-4ba0-ae1b-7fce12a72930"],
    "IEnumTfUIElements": ["887aa91e-acba-4931-84da-3c5208cf543f"],
    "IEnumToolboxItems": ["5303ccde-d37a-445b-88a1-a71742f66345"],
    "IEnumToolboxTabs": ["cc81495d-3c2b-4b1e-82ce-965ea5fca2a0"],
    "IEnumTuneRequests": ["1993299c-ced6-4788-87a3-420067dce0c7"],
    "IEnumTuningSpaces": ["8b8eb248-fc2b-11d2-9d8c-00c04f72d980"],
    "IEnumUICommand": ["869447da-9f84-4e2a-b92d-00642dc8a911"],
    "IEnumVdsObject": ["118610b7-8d94-4030-b5b8-500889788e4e"],
    "IEnumVsENCRebuildableProjectCfgs": ["3909921b-bacd-11d2-bd66-00c04fa302e2"],
    "IEnumVsEmpWebResource": ["2aba4461-0c9f-11d3-85c9-00a0c9cfcc16"],
    "IEnumVsEmpWebResourceCheckouts": ["2aba4462-0c9f-11d3-85c9-00a0c9cfcc16"],
    "IEnumVsProfilerTargetInfos": ["cf9f5ea4-ce28-4dc6-b058-ee910b9171ae"],
    "IEnumWCFReferenceContracts": ["a8f120c5-e7df-465a-a7fb-711805281a3b"],
    "IEnumWCFReferenceEndpoints": ["0d66f264-c498-44c6-b08a-1a9ef57ddd63"],
    "IEnumWCFReferenceGroupMetadataItems": ["603a2aea-c925-4a8c-a273-65b3b81cd43a"],
    "IEnumWbemClassObject": ["027947e1-d731-11ce-a357-000000000001"],
    "IEnumWebServices": ["4db4e7d3-5550-41ae-a612-3d28cd0c52a8"],
    "IEnumWiaItem2": ["59970af4-cd0d-44d9-ab24-52295630e582"],
    "IEnumWindowFrames": ["8c453b03-8907-435b-96d7-573c40948f5c"],
    "IEnumXWizardHost": ["777ba8ae-2498-4875-933a-3067de883070"],
    "IEnumXWizardPage": ["777ba8ce-2498-4875-933a-3067de883070"],
    "IEnumXWizardPropertyBag": ["777ba8de-2498-4875-933a-3067de883070"],
    "IEnumXWizardTask": ["777ba8be-2498-4875-933a-3067de883070"],
    "IEnumerableBSTR": ["b887db4f-490c-415e-9ff4-f4657b757772"],
    "IEnumerableIVxContentType": ["acc50312-81c5-4da1-92b0-3f37acfa1106"],
    "IEnumerableIVxTextSnapshotLine": ["021b71e1-59bb-481a-9ac6-c9b4ad7b7446"],
    "IEnumerableView": ["8c8bf236-1aec-495f-9894-91d57c3c686f"],
    "IEnumerationBlockOptions": ["e9faf793-31c2-406a-8096-da07bf7de0a4"],
    "IEnumeratorBSTR": ["18a2071c-67fb-4543-bd62-d11e68a6785b"],
    "IEnumeratorIUnknown": ["379d6c69-25b8-413d-b58c-015f2c7a942d"],
    "IEnumeratorIVxContentType": ["d92cce42-6e23-4ce3-a633-8b76ac0826f2"],
    "IEnumeratorIVxTextBuffer": ["7a1e5f7c-6f1d-4e1e-b13d-8656b71f2f97"],
    "IEnumeratorIVxTextChange": ["a4728f3b-90ee-4783-a6af-0caeeea73147"],
    "IEnumeratorIVxTextSnapshot": ["13dc5d4f-7e53-4180-8779-1364b6ae8322"],
    "IEnumeratorIVxTextSnapshotLine": ["5ba4ea24-9310-4284-9e86-6ebec3e1818e"],
    "IEnumeratorIVxTrackingSpan": ["496727c4-5622-4889-94ae-ddd857bacea7"],
    "IEnumeratorVxSnapshotPoint": ["30ddec83-f0b5-4bd7-a4d3-2d82d51d6d70"],
    "IEnumeratorVxSnapshotSpan": ["fd6cb9a7-f2c2-450d-b14e-756b5a013591"],
    "IEnumeratorVxSpan": ["f5c3a3cb-442d-4abc-84b7-687611079c21"],
    "IEqualizerBand": ["c00a5a6a-262d-4b85-9bb7-43280b62ed0c"],
    "IEqualizerEffectDefinition": ["023f6f1f-83fe-449a-a822-c696442d16b0"],
    "IEqualizerEffectDefinitionFactory": ["d2876fc4-d410-4eb5-9e69-c9aa1277eaf0"],
    "IEquatableConcept": ["c52d5d3d-609d-4d5d-8a82-46b0acdec4f4"],
    "IErrorDetails": ["378cbb01-2cc9-428f-8c55-2c990d463e8f"],
    "IErrorDetailsStatics": ["b7703750-0b1d-46c8-aa0e-4b8178e4fce9"],
    "IErrorLookup": ["0c733a66-2a1c-11ce-ade5-00aa0044773d"],
    "IErrorMessage": ["a17b9e86-a16b-4a47-9b64-135777b44e64"],
    "IErrorReceivedEventArgs": ["fcc6bf59-1283-4d8a-bfdf-566b33ddb28f"],
    "IErrorRecords": ["0c733a67-2a1c-11ce-ade5-00aa0044773d"],
    "IErrorReportingSettings": ["16369792-b03e-4ba1-8bb8-d28f4ab4d2c0"],
    "IEtwEvent": ["07a0c227-bbeb-43fa-af86-108114187cdc"],
    "IEtwEventFactory": ["80fdee60-5888-47db-92d3-e5bc3c9f57cf"],
    "IEtwEventRecord": ["79380594-6095-49c8-82e6-65ddc099dc59"],
    "IEtwEventRecordCallback": ["8929948f-2a94-4ed4-abb6-92ef45e61b21"],
    "IEtwEventWatcher": ["012a38e6-6b29-473e-a219-caae719e9996"],
    "IEtwProvider": ["11624719-7c26-4bde-a80f-441df7670bb8"],
    "IEtwProviderStatics": ["598024f7-a743-4555-a1fd-5eb465308194"],
    "IEtwRule": ["c2205647-2fd8-43e0-92cb-0ed1a0db9e55"],
    "IEtwRuleFactory": ["363fa5d1-2e25-4cc0-8bcf-62ecd32abf9a"],
    "IEvalRat": ["c5c5c5b1-3abc-11d6-b25b-00c04fa0c026"],
    "IEventBinding": ["8e398ce0-a64e-11d0-a9ea-00aa00685c74"],
    "IEventBindingManager": ["0b4cdbc0-a64f-11d0-a9ea-00aa00685c74"],
    "IEventBindingManagerCopier": ["64bad540-f88d-11d0-aa14-00aa006bc80b"],
    "IEventBindings": ["1080b910-a636-11d0-a9ea-00aa00685c74"],
    "IEventClassInternal": ["9f83871a-195f-44b5-a46f-18fffe152f7c"],
    "IEventClassTier2": ["609b9555-4fb6-11d1-9971-00c04fbbb345"],
    "IEventComCat": ["65a70ec0-cd87-11d0-a9f8-00aa00685c74"],
    "IEventCreateOptions": ["c0287bfe-ef7f-11d1-9fff-00c04fa37348"],
    "IEventDatabase": ["bc5a3ec8-9f24-11d1-b7a3-00c04fb926af"],
    "IEventDatabaseManager": ["adc25b30-cbd8-11d0-a9f8-00aa00685c74"],
    "IEventDatabasePlugin": ["4915fb10-af97-11d0-a9eb-00aa00685c74"],
    "IEventDeliveryOptions": ["0688a660-a3ff-11d0-a9e9-00aa00685c74"],
    "IEventDispatcherChain": ["58a90754-fb15-11d1-a00c-00c04fa37348"],
    "IEventException": ["3051073a-98b5-11cf-bb82-00aa00bdce0b"],
    "IEventIsCacheable": ["22e0f830-1e81-11d1-aa29-00aa006bc80b"],
    "IEventLock": ["1b7058f0-af88-11d0-a9eb-00aa00685c74"],
    "IEventManager": ["5f6012b0-a651-11d0-a9ea-00aa00685c74"],
    "IEventNotificationCallback": ["021e0321-e397-41a1-a6f1-18600895f4b0"],
    "IEventNotifyBindingChange": ["08f4f2a0-dc5b-11d0-aa0f-00aa006bc80b"],
    "IEventNotifyBindingChangeDisp": ["dc3d83b0-e99f-11d0-aa10-00aa006bc80b"],
    "IEventObjectRow": ["ffcaa232-9f25-11d1-b7a3-00c04fb926af"],
    "IEventObjectRowCursor": ["ffcaa233-9f25-11d1-b7a3-00c04fb926af"],
    "IEventObjectTable": ["bc5a3ec9-9f24-11d1-b7a3-00c04fb926af"],
    "IEventPersistBinding": ["e9311660-1a98-11d1-aa26-00aa006bc80b"],
    "IEventPropertyBag": ["aabb23e0-a705-11d0-a9ea-00aa00685c74"],
    "IEventRouter": ["1a00b970-eda0-11d0-aa10-00aa006bc80b"],
    "IEventRuleEngine": ["da816090-f343-11d0-aa14-00aa006bc80b"],
    "IEventSinkNotify": ["bdf065b0-f346-11d0-aa14-00aa006bc80b"],
    "IEventSinkNotifyDisp": ["33a79660-f347-11d0-aa14-00aa006bc80b"],
    "IEventSourceType": ["063a62e0-a652-11d0-a9ea-00aa00685c74"],
    "IEventSourceTypes": ["caf30fd0-a651-11d0-a9ea-00aa00685c74"],
    "IEventSources": ["73e8c930-a652-11d0-a9ea-00aa00685c74"],
    "IEventSubscriptionInternal": ["9b724996-d383-4c5f-b0f6-2814708c7633"],
    "IEventSubscriptionTier2": ["609b9557-4fb6-11d1-9971-00c04fbbb345"],
    "IEventSystemInitialize": ["a0e8f27a-888c-11d1-b763-00c04fb926af"],
    "IEventSystemPersistable": ["a0e8f279-888c-11d1-b763-00c04fb926af"],
    "IEventSystemTier2": ["609b954b-4fb6-11d1-9971-00c04fbbb345"],
    "IEventSystemTier2Factory": ["64b8f404-a4ae-11d1-b7b6-00c04fb926af"],
    "IEventSystemTier2Inproc": ["dc7c5ccc-34e1-4531-941d-035e29ff8257"],
    "IEventTarget": ["305104b9-98b5-11cf-bb82-00aa00bdce0b"],
    "IEventTarget2": ["30510839-98b5-11cf-bb82-00aa00bdce0b"],
    "IEventTrigger": ["d45b0167-9653-4eef-b94f-0732ca7af251", "def8f855-0b49-4087-b1a9-b8b38488f786"],
    "IEventType": ["4a993b80-a654-11d0-a9ea-00aa00685c74"],
    "IEventTypeSinks": ["a1063f50-a654-11d0-a9ea-00aa00685c74"],
    "IEventTypes": ["cab29ef0-a64f-11d0-a9ea-00aa00685c74"],
    "IEventUtil": ["c61670e0-cd6e-11d0-a9f8-00aa00685c74"],
    "IEvtlogger": ["c1ce93d8-b59a-4037-b4b4-a5bb59e58e4f"],
    "IExceptionNotification": ["000001db-0000-0000-c000-000000000046"],
    "IExceptionRoutedEventArgs": ["dd9ff16a-4b62-4a6c-a49d-0671ef6136be"],
    "IExceptionRoutedEventArgsFactory": ["bba9826d-5d7a-44e7-b893-b2ae0dd24273"],
    "IExceptionRoutedEventHandler": ["68e0e810-f6ea-42bc-855b-5d9b67e6a262"],
    "IExchangeExportChanges": ["a3ea9cc0-d1b2-11cd-80fc-00aa004bba0b"],
    "IExeServerActivatableClassRegistration": ["9308c3c5-c2ac-49d1-a024-660a2bb5d5ac"],
    "IExeServerRegistration": ["ec734a06-0401-4317-bac1-3b7e207242e3"],
    "IExecAction": ["4c3d624d-fd6b-49a3-b9b7-09cb3cd3f047"],
    "IExecAction2": ["f2a82542-bda5-4e6b-9143-e2bf4f8987b6"],
    "IExecuteCommand": ["7f9185b0-cb92-43c5-80a9-92277a4f7b54"],
    "IExecuteCommandApplicationHostEnvironment": ["18b21aa9-e184-4ff0-9f5e-f882d03771b3"],
    "IExecuteCommandHost": ["4b6832a2-5f04-4c9d-b89d-727a15d103e7"],
    "IExecuteCommandNotify": ["cdb65641-7618-4871-a1fb-151a88db3f94"],
    "IExecuteRequestedEventArgs": ["e07fa734-a0b6-5755-9e87-24f54cca9372"],
    "IExecutionEngine": ["7af02dac-2a33-494b-a09f-25e00a93c6f8"],
    "IExpDispSupport": ["0d7d1d00-6fc0-11d0-a974-00c04fd705a2"],
    "IExpDispSupportXP": ["2f0dd58c-f789-4f14-99fb-9293b3c9c212"],
    "IExpandCollapsePatternIdentifiers": ["b006bac0-751b-4d55-92cb-613ec1bdf5d0"],
    "IExpandCollapsePatternIdentifiersStatics": ["d7816fd4-6ee0-4f38-8e14-56ef21adacfd"],
    "IExpandCollapseProvider": ["49ac8399-d626-4543-94b9-a6d9a9593af6", "d847d3a5-cab0-4a98-8c32-ecb45c59ad24"],
    "IExperimentationBroker": ["15c6aa22-55af-49de-bc43-0ac340f3a8ae"],
    "IExplorerBrowser": ["dfd3b6b5-c10c-4be9-85f6-a66969f402f6"],
    "IExplorerBrowserEvents": ["361bbdc7-e6ee-4e13-be58-58e2240c810f"],
    "IExplorerCommand": ["a08ce4d0-fa25-44ab-b57c-c7b1c323e0b9"],
    "IExplorerCommand2": ["d51836b4-8b5a-4e11-8f97-d489bd4b28c0"],
    "IExplorerCommandProvider": ["64961751-0835-43c0-8ffe-d57686530e64"],
    "IExplorerCommandState": ["bddacb60-7657-47ae-8445-d23e1acf82ae"],
    "IExplorerFrame": ["76542021-fff8-43f3-acbd-bb46a60a94ca"],
    "IExplorerFrameCallback": ["86d6986d-b7e8-4246-b823-14bee2c4232a"],
    "IExplorerFrameCallbackManager": ["e2d2f506-0441-46af-83f9-c51458e3a19e"],
    "IExplorerHost": ["50a87baa-5f79-4c31-b6b3-28f6f2d097e6"],
    "IExplorerHostCreator": ["c4de032a-d902-450a-bc43-d9df6d0fd48c"],
    "IExplorerLauncher": ["5ac8c8f7-1cc7-46cb-8d7d-3cf14b64868c"],
    "IExplorerPaneVisibility": ["e07010ec-bc17-44c0-97b0-46c7c95b9edc"],
    "IExplorerRibbonTestHook": ["9a395adf-3dc9-413e-a2d9-ddf867105efd"],
    "IExplorerToolbar": ["f80c2137-5829-4ce9-9f81-a95e159dd8d5"],
    "IExplorerWindowManager": ["f7041e23-1a6c-41bb-89b2-b3425c51ccd5"],
    "IExponentialEase": ["7cb9e41d-f0bb-4bca-9da5-9ba3a11734c4"],
    "IExponentialEaseStatics": ["f37ee7e3-a761-4352-9ad6-70794567581a"],
    "IExposureCompensationControl": ["81c8e834-dcec-4011-a610-1f3847e64aca"],
    "IExposureControl": ["09e8cbe2-ad96-4f28-a0e0-96ed7e1b5fd2"],
    "IExposurePriorityVideoControl": ["2cb240a3-5168-4271-9ea5-47621a98a352"],
    "IExpressionAnimation": ["6acc5431-7d3d-4bf3-abb6-f44bdc4888c1"],
    "IExtendedExecutionBroker": ["ba62a0e9-1bca-4e20-9da8-d748dc56a27c"],
    "IExtendedExecutionForegroundRevokedEventArgs": ["b07cd940-9557-aea4-2c99-bdd56d9be461"],
    "IExtendedExecutionForegroundSession": ["fbf440e1-9d10-4201-b01e-c83275296f2e"],
    "IExtendedExecutionRevokedEventArgs": ["bfbc9f16-63b5-4c0b-aad6-828af5373ec3"],
    "IExtendedExecutionSession": ["af908a2d-118b-48f1-9308-0c4fc41e200f"],
    "IExtendedObject": ["a575c060-5b17-11d1-ab3e-00a0c9055a90"],
    "IExtendedTypeLib": ["6d5140d6-7436-11ce-8034-00aa006009fa"],
    "IExtenderProvider": ["4db06329-23f4-443b-9abd-9cf611e8ae07"],
    "IExtenderProviderUnk": ["f69b64a3-9017-4e48-9784-e152b51aa722"],
    "IExtenderSite": ["e57c510b-968b-4a3c-a467-ee4013157dc9"],
    "IExtensibleObject": ["86c31347-5b52-4715-b454-a6e5fcab975d"],
    "IExtensibleObjectSite": ["eb5be8a7-e593-4de6-a923-c2afecb96336"],
    "IExtensionActivationContextProperties": ["071742dc-587e-4930-81d5-8a7de8547529"],
    "IExtensionValidation": ["7d33f73d-8525-4e0f-87db-830288baff44"],
    "IExtensions": ["9d0876ca-02dc-453a-95d9-f2194a656442"],
    "IExtractIconWithElevationCache": ["cb304ee1-ab41-4341-93e8-f94c0010425e"],
    "IEyesPose": ["682a9b23-8a1e-5b86-a060-906ffacb62a4"],
    "IEyesPoseStatics": ["1cff7413-b21f-54c0-80c1-e60d994ca58c"],
    "IF12HostManagerProcessProvider": ["5eb747cd-1780-4cd1-a625-9d806bd6eaf8"],
    "IFECommon": ["019f7151-e6db-11d0-83c3-00c04fddb82e"],
    "IFEDictionary": ["019f7153-e6db-11d0-83c3-00c04fddb82e"],
    "IFELanguage": ["019f7152-e6db-11d0-83c3-00c04fddb82e"],
    "IFELanguage2": ["21164102-c24a-11d1-851a-00c04fcc6b14"],
    "IFRSReplicaSet": ["c5c48050-0141-4805-b365-9ad2b06f475e"],
    "IFSClientProxy": ["7b23bf1b-785c-4170-ae58-923fd320f094"],
    "IFSPipelineMediaType": ["5f3ee6ff-f69d-409c-8e41-d51107e9bb78"],
    "IFSTraceString": ["3858aded-fdea-4e35-bd7a-f90c8e8727bf"],
    "IFSTraceStringArray": ["ae1f0687-3668-448b-9790-768b6499d509"],
    "IFTEPluginEventLogger": ["a373e885-7a87-11d3-b1c1-00c04f68155c"],
    "IFTEPluginLocator": ["e2092465-544c-4e2f-8447-adc89d122ffc"],
    "IFTEPluginLocatorClient": ["85ffaef0-8208-4c44-8072-48b1a7852ebe"],
    "IFTEStringNormalizer": ["68c6d225-77e0-11d5-8528-00c04f68155c"],
    "IFTSQLParserSessionEx": ["794f8323-0976-42ed-8999-e1e1602ac7ec"],
    "IFaceDetectedEventArgs": ["19918426-c65b-46ba-85f8-13880576c90a"],
    "IFaceDetectionEffect": ["ae15ebd2-0542-42a9-bc90-f283a29f46c1"],
    "IFaceDetectionEffectDefinition": ["43dca081-b848-4f33-b702-1fd2624fb016"],
    "IFaceDetectionEffectFrame": ["8ab08993-5dc8-447b-a247-5270bd802ece"],
    "IFaceDetector": ["16b672dc-fe6f-3117-8d95-c3f04d51630c"],
    "IFaceDetectorStatics": ["bc042d67-9047-33f6-881b-6746c1b218b8"],
    "IFaceTracker": ["6ba67d8c-a841-4420-93e6-2420a1884fcf"],
    "IFaceTrackerStatics": ["e9629198-1801-3fa5-932e-31d767af6c4d"],
    "IFadeInThemeAnimation": ["6d4bc8f5-a918-4477-8078-554c68812ab8"],
    "IFadeInThemeAnimationStatics": ["7f0117e1-bea9-4923-b23a-0ddf4d7b8737"],
    "IFadeOutThemeAnimation": ["89276ba9-ffd4-45b6-9b9a-ced48951e712"],
    "IFadeOutThemeAnimationStatics": ["fe17a81a-4168-4f68-a28c-e5dd98cf680f"],
    "IFastRundown": ["00000040-0000-0000-c000-000000000046"],
    "IFaxAccount": ["68535b33-5dc4-4086-be26-b76f9b711006"],
    "IFaxAccountFolders": ["6463f89d-23d8-46a9-8f86-c47b77ca7926"],
    "IFaxAccountIncomingArchive": ["a8a5b6ef-e0d6-4aee-955c-91625bec9db4"],
    "IFaxAccountIncomingQueue": ["dd142d92-0186-4a95-a090-cbc3eadba6b4"],
    "IFaxAccountNotify": ["0b5e5bd1-b8a9-47a0-a323-ef4a293ba06a", "b9b3bc81-ac1b-46f3-b39d-0adc30e1b788"],
    "IFaxAccountOutgoingArchive": ["5463076d-ec14-491f-926e-b3ceda5e5662"],
    "IFaxAccountOutgoingQueue": ["0f1424e9-f22d-4553-b7a5-0d24bd0d7e46"],
    "IFaxAccountSet": ["7428fbae-841e-47b8-86f4-2288946dca1b"],
    "IFaxAccounts": ["93ea8162-8be7-42d1-ae7b-ec74e2d989da"],
    "IFaxActivity": ["4b106f97-3df5-40f2-bc3c-44cb8115ebdf"],
    "IFaxActivityLogging": ["1e29078b-5a69-497b-9592-49b7e7faddb5"],
    "IFaxConfiguration": ["10f4d0f7-0994-4543-ab6e-506949128c40"],
    "IFaxDevice": ["49306c59-b52e-4867-9df4-ca5841c956d0"],
    "IFaxDeviceIds": ["2f0f813f-4ce9-443e-8ca1-738cfaeee149"],
    "IFaxDeviceProvider": ["290eac63-83ec-449c-8417-f148df8c682a"],
    "IFaxDeviceProviders": ["9fb76f62-4c7e-43a5-b6fd-502893f7e13e"],
    "IFaxDevices": ["9e46783e-f34f-482e-a360-0416becbbd96"],
    "IFaxDoc": ["fa21f4c5-5c4c-11d1-83cf-00c04fb6e984"],
    "IFaxDocument": ["b207a246-09e3-4a4e-a7dc-fea31d29458f"],
    "IFaxDocument2": ["e1347661-f9ef-4d6d-b4a5-c0a068b65cff"],
    "IFaxEventLogging": ["0880d965-20e8-42e4-8e17-944f192caad4"],
    "IFaxFolders": ["dce3b2a8-a7ab-42bc-9d0a-3149457261a0"],
    "IFaxInboundRouting": ["8148c20f-9d52-45b1-bf96-38fc12713527"],
    "IFaxInboundRoutingExtension": ["885b5e08-c26c-4ef9-af83-51580a750be1"],
    "IFaxInboundRoutingExtensions": ["2f6c9673-7b26-42de-8eb0-915dcd2a4f4c"],
    "IFaxInboundRoutingMethod": ["45700061-ad9d-4776-a8c4-64065492cf4b"],
    "IFaxInboundRoutingMethods": ["783fca10-8908-4473-9d69-f67fbea0c6b9"],
    "IFaxIncomingArchive": ["76062cc7-f714-4fbd-aa06-ed6e4a4b70f3"],
    "IFaxIncomingJob": ["207529e6-654a-4916-9f88-4d232ee8a107"],
    "IFaxIncomingJobs": ["011f04e9-4fd6-4c23-9513-b6b66bb26be9"],
    "IFaxIncomingMessage": ["7cab88fa-2ef9-4851-b2f3-1d148fed8447"],
    "IFaxIncomingMessage2": ["f9208503-e2bc-48f3-9ec0-e6236f9b509a"],
    "IFaxIncomingMessageIterator": ["fd73ecc4-6f06-4f52-82a8-f7ba06ae3108"],
    "IFaxIncomingQueue": ["902e64ef-8fd8-4b75-9725-6014df161545"],
    "IFaxJob": ["55dabfd5-5c9e-11d1-b791-000000000000"],
    "IFaxJobStatus": ["8b86f485-fd7f-4824-886b-40c5caa617cc"],
    "IFaxJobs": ["55dabfd3-5c9e-11d1-b791-000000000000"],
    "IFaxLoggingOptions": ["34e64fb9-6b31-4d32-8b27-d286c0c33606"],
    "IFaxOutboundRouting": ["25dc05a4-9909-41bd-a95b-7e5d1dec1d43"],
    "IFaxOutboundRoutingGroup": ["ca6289a1-7e25-4f87-9a0b-93365734962c"],
    "IFaxOutboundRoutingGroups": ["235cbef7-c2de-4bfd-b8da-75097c82c87f"],
    "IFaxOutboundRoutingRule": ["e1f795d5-07c2-469f-b027-acacc23219da"],
    "IFaxOutboundRoutingRules": ["dcefa1e7-ae7d-4ed6-8521-369edcca5120"],
    "IFaxOutgoingArchive": ["c9c28f40-8d80-4e53-810f-9a79919b49fd"],
    "IFaxOutgoingJob": ["6356daad-6614-4583-bf7a-3ad67bbfc71c"],
    "IFaxOutgoingJob2": ["418a8d96-59a0-4789-b176-edf3dc8fa8f7"],
    "IFaxOutgoingJobs": ["2c56d8e6-8c2f-4573-944c-e505f8f5aeed"],
    "IFaxOutgoingMessage": ["f0ea35de-caa5-4a7c-82c7-2b60ba5f2be2"],
    "IFaxOutgoingMessage2": ["b37df687-bc88-4b46-b3be-b458b3ea9e7f"],
    "IFaxOutgoingMessageIterator": ["f5ec5d4f-b840-432f-9980-112fe42a9b7a"],
    "IFaxOutgoingQueue": ["80b1df24-d9ac-4333-b373-487cedc80ce5"],
    "IFaxPort": ["d73733cc-cc80-11d0-b225-00c04fb6c2f5"],
    "IFaxPorts": ["d73733d5-cc80-11d0-b225-00c04fb6c2f5"],
    "IFaxReceiptOptions": ["378efaeb-5fcb-4afb-b2ee-e16e80614487"],
    "IFaxRecipient": ["9a3da3a0-538d-42b6-9444-aaa57d0ce2bc"],
    "IFaxRecipients": ["b9c9de5a-894e-4492-9fa3-08c627c11d5d"],
    "IFaxRoutingMethod": ["2199f5f3-cefc-11d0-a341-0000f800e68d"],
    "IFaxRoutingMethods": ["2199f5f5-cefc-11d0-a341-0000f800e68d"],
    "IFaxSecurity": ["77b508c1-09c0-47a2-91eb-fce7fdf2690e"],
    "IFaxSecurity2": ["17d851f4-d09b-48fc-99c9-8f24c4db9ab1"],
    "IFaxSender": ["0d879d7d-f57a-4cc6-a6f9-3ee5d527b46a"],
    "IFaxServer": ["475b6469-90a5-4878-a577-17a86e8e3462", "d73733c7-cc80-11d0-b225-00c04fb6c2f5"],
    "IFaxServer2": ["571ced0f-5609-4f40-9176-547e3a72ca7c"],
    "IFaxServerNotify": ["2e037b27-cf8a-4abd-b1e0-5704943bea6f"],
    "IFaxServerNotify2": ["616ca8d6-a77a-4062-abfd-0e471241c7aa", "ec9c69b9-5fe7-4805-9467-82fcd96af903"],
    "IFaxStatus": ["8b97e605-d054-11d0-b226-00c04fb6c2f5"],
    "IFaxTiff": ["b19bb45f-b91c-11d1-83e1-00c04fb6e984"],
    "IFdnAccessManagerStatics": ["f2aa4395-f1e6-4319-aa3e-477ca64b2bdf"],
    "IFeed": ["f7f915d8-2ede-42bc-98e7-a5d05063a757"],
    "IFeed2": ["33f2ea09-1398-4ab9-b6a4-f94b49d0a42e"],
    "IFeedClockVector": ["8d1d98d1-9fb8-4ec9-a553-54dd924e0f67"],
    "IFeedClockVectorElement": ["a40b46d2-e97b-4156-b6da-991f501b0f05"],
    "IFeedEnclosure": ["361c26f7-90a4-4e67-ae09-3a36a546436a"],
    "IFeedEvents": ["abf35c99-0681-47ea-9a8c-1436a375a99e"],
    "IFeedFolder": ["81f04ad1-4194-4d7d-86d6-11813cec163c"],
    "IFeedFolderEvents": ["20a59fa6-a844-4630-9e98-175f70b4d55b"],
    "IFeedItem": ["0a1e6cad-0a47-4da2-a13d-5baaa5c8bd4f"],
    "IFeedItem2": ["79ac9ef4-f9c1-4d2b-a50b-a7ffba4dcf37"],
    "IFeedRequest": ["cccf3654-f2c1-405b-b167-682e0a3e9a20"],
    "IFeedRequestCallback": ["f847e090-32df-464a-8c03-decba6ad67af"],
    "IFeedTasks": ["9df68e2d-7484-4851-9b87-f6dda1b8b446"],
    "IFeedbackHubApp": ["abb07809-a867-4c65-9598-8b8f9d5e88d6"],
    "IFeedbackHubAppInfo": ["06c1d185-6035-4728-81d9-ee4bd2bea71a"],
    "IFeedsEnum": ["e3cd0028-2eed-4c60-8fae-a3225309a836"],
    "IFeedsManager": ["a74029cc-1f1a-4906-88f0-810638d86591"],
    "IFhConfigMgr": ["6a5fea5b-bf8f-4ee5-b8c3-44d8a0d7331c"],
    "IFhReassociation": ["6544a28a-f68d-47ac-91ef-16b2b36aa3ee"],
    "IFhScopeIterator": ["3197abce-532a-44c6-8615-f3666566a720"],
    "IFhTarget": ["d87965fd-2bad-4657-bd3b-9567eb300ced"],
    "IFileActivatedEventArgs": ["bb2afc33-93b1-42ed-8b26-236dd9c78496"],
    "IFileActivatedEventArgsWithCallerPackageFamilyName": ["2d60f06b-d25f-4d25-8653-e1c5e1108309"],
    "IFileActivatedEventArgsWithNeighboringFiles": ["433ba1a4-e1e2-48fd-b7fc-b5d6eee65033"],
    "IFileBasedLogInit": ["00951e8c-1294-11d1-97e4-00c04fb9618a"],
    "IFileCallbackCleanup": ["35c5f79c-6d81-4819-aa64-d6a8939d94d6"],
    "IFileCallbackClose": ["c28fd731-f3f1-4573-97dc-620f72d013a6"],
    "IFileChangeEntry": ["d34e1a5f-5063-4dee-b9e3-2316b0a6ced3"],
    "IFileChangeEntryVector": ["d840e2e9-c794-4183-9be9-38cb358348a2"],
    "IFileChangeTracker": ["0875169b-1407-44ea-9298-20a337646785"],
    "IFileChangeTrackerForStoreApp": ["7f2be360-2a95-4574-a16e-b8ec025083ce"],
    "IFileChangeTrackerInternal": ["b77d0bb4-256d-4218-8a17-52bc66b19f4b"],
    "IFileChangeTrackerRegistrar": ["63f55b21-b33e-4d42-b614-733a96a618c0"],
    "IFileChangeTrackerState": ["e09841dd-8048-40d0-a7cf-54d78b0a9c2b"],
    "IFileChunkMap": ["0095a475-f357-475c-a5b7-cb183e48a1be"],
    "IFileClient": ["bfccd196-1244-4840-ab44-480975c4ffe4"],
    "IFileDialog": ["42f85136-db7e-439c-85f1-e4075d135fc8"],
    "IFileDialog2": ["61744fc7-85b5-4791-a9b0-272276309b13"],
    "IFileDialogControlEvents": ["36116642-d713-4b97-9b83-7484a9d00433"],
    "IFileDialogCustomize": ["e6fdd21a-163f-4975-9c8c-a69f1ba37034"],
    "IFileDialogCustomizeOld": ["8016b7b3-3d49-4504-a0aa-2a37494e606f"],
    "IFileDialogEvents": ["973510db-7d7f-452b-8975-74a85828d354"],
    "IFileDialogEventsPrivate": ["050e9e69-baea-4c08-ad6a-61666dd32e96"],
    "IFileDialogPrivate": ["18cfdf39-aa66-42c6-906b-7e4aaf8d3dfe"],
    "IFileDialogResultHandler": ["42841501-194f-478f-9b4c-78985419da53"],
    "IFileDownloadBroker": ["8b103b7a-d39e-4c3d-b1f6-913b6cae5009"],
    "IFileHandle": ["5e0ebc87-bece-4f2a-8d36-3673758f6c55"],
    "IFileHashProviderCallback": ["e9a288f7-bcfb-4466-95c6-5a388263d8fb"],
    "IFileIOStatics": ["887411eb-7f54-4732-a5f0-5e43e3b8c2f5"],
    "IFileInformationFactory": ["401d88be-960f-4d6d-a7d0-1a3861e76c83"],
    "IFileInformationFactoryFactory": ["84ea0e7d-e4a2-4f00-8afa-af5e0f826bd5"],
    "IFileIo": ["11993196-1244-4840-ab44-480975c4ffe4"],
    "IFileIsInUse": ["64a1cbf0-3a1a-4461-9158-376969693950"],
    "IFileJunctionOptions": ["72dbece7-d912-4a8f-841c-a521b7447463"],
    "IFileLoggingSession": ["24c74216-fed2-404c-895f-1f9699cb02f7"],
    "IFileLoggingSessionFactory": ["eea08dce-8447-4daa-9133-12eb46f697d4"],
    "IFileOpenDialog": ["d57c7288-d4ad-4768-be02-9d969532d960"],
    "IFileOpenDialogPrivate": ["3e481212-dfe0-4756-a033-0928214904bc"],
    "IFileOpenPicker": ["2ca8278a-12c5-4c5f-8977-94547793c241"],
    "IFileOpenPicker2": ["8ceb6cd2-b446-46f7-b265-90f8e55ad650"],
    "IFileOpenPicker3": ["d9a5c5b3-c5dc-5b98-bd80-a8d0ca0584d8"],
    "IFileOpenPickerActivatedEventArgs": ["72827082-5525-4bf2-bc09-1f5095d4964d"],
    "IFileOpenPickerActivatedEventArgs2": ["5e731f66-8d1f-45fb-af1d-73205c8fc7a1"],
    "IFileOpenPickerContinuationEventArgs": ["f0fa3f3a-d4e8-4ad3-9c34-2308f32fcec9"],
    "IFileOpenPickerStatics": ["6821573b-2f02-4833-96d4-abbfad72b67b"],
    "IFileOpenPickerStatics2": ["e8917415-eddd-5c98-b6f3-366fdfcad392"],
    "IFileOpenPickerUI": ["dda45a10-f9d4-40c4-8af5-c5b6b5a61d1d"],
    "IFileOpenPickerWithOperationId": ["3f57b569-2522-4ca5-aa73-a15509f1fcbf"],
    "IFileOperation": ["947aab5f-0a5c-4c13-b4d6-4bf7836fc9f8"],
    "IFileOperation2": ["cd8f23c1-8f61-4916-909d-55bdd0918753"],
    "IFileOperationBroker": ["d2da1efd-1dfa-43e1-911f-e18288e361b0"],
    "IFileOperationConflictItemsMetadata": ["b3cd19c7-42fc-417d-a831-9394e78705b4"],
    "IFileOperationProgressSink": ["04b0f1a7-9490-44bc-96e1-4296a31252e2"],
    "IFilePickerInternal": ["2bd6990f-2d1a-4b5a-9d61-ab6229a36caa"],
    "IFilePlaceholder": ["e6240d00-fecd-40b1-a7e4-8ed12ca335fd"],
    "IFilePlaceholderCallback": ["3bbe1335-5937-4ba2-b42e-93fc3d6227d9"],
    "IFilePlaceholderStateInternal": ["c8b34e60-6ee3-4881-9138-6b4fb6bfb461"],
    "IFilePlaceholderStreamResolver": ["cedcbd91-e5ac-4a58-8bec-f6049ef73c41"],
    "IFilePropSheetPageHelper": ["4169a239-f6cb-4924-99a4-cfada3608308"],
    "IFileProtectionInfo": ["4ee96486-147e-4dd0-8faf-5253ed91ad0c"],
    "IFileProtectionInfo2": ["82123a4c-557a-498d-8e94-944cd5836432"],
    "IFileProtectionManagerStatics": ["5846fc9b-e613-426b-bb38-88cba1dc9adb"],
    "IFileProtectionManagerStatics2": ["83d2a745-0483-41ab-b2d5-bc7f23d74ebb"],
    "IFileProtectionManagerStatics3": ["6918849a-624f-46d6-b241-e9cd5fdf3e3f"],
    "IFileRandomAccessStreamStatics": ["73550107-3b57-4b5d-8345-554d2fc621f0"],
    "IFileSaveDialog": ["84bccd23-5fde-4cdb-aea4-af64b83d78ab"],
    "IFileSaveDialogOld": ["2804b74c-ac16-4398-9dc0-db83f5b7ed14"],
    "IFileSaveDialogPrivate": ["6cb95a6a-88b6-4dc4-b3ea-3a776d1e8eff"],
    "IFileSavePicker": ["3286ffcb-617f-4cc5-af6a-b3fdf29ad145"],
    "IFileSavePicker2": ["0ec313a2-d24b-449a-8197-e89104fd42cc"],
    "IFileSavePicker3": ["698aec69-ba3c-4e51-bd90-4abcbbf4cfaf"],
    "IFileSavePicker4": ["e7d83a5a-ddfa-5de0-8b70-c842c21988ec"],
    "IFileSavePickerActivatedEventArgs": ["81c19cf1-74e6-4387-82eb-bb8fd64b4346"],
    "IFileSavePickerActivatedEventArgs2": ["6b73fe13-2cf2-4d48-8cbc-af67d23f1ce7"],
    "IFileSavePickerContinuationEventArgs": ["2c846fe1-3bad-4f33-8c8b-e46fae824b4b"],
    "IFileSavePickerStatics": ["28e3cf9e-961c-5e2c-aed7-e64737f4ce37"],
    "IFileSavePickerUI": ["9656c1e7-3e56-43cc-8a39-33c73d9d542b"],
    "IFileSettingUnit": ["40de6c67-5063-4ae0-b98e-ce4ab728512b"],
    "IFileSyncMergeHandler": ["d97b5aac-c792-433c-975d-35c4eadc7a9d"],
    "IFileSysFolderMonitor": ["edeefb76-cd88-4f17-acec-5025e85ff066"],
    "IFileSystemBindData2": ["3acf075f-71db-4afa-81f0-3fc4fdf2a5b8"],
    "IFileSystemHandlerCallback": ["e70a2df4-c48b-11e5-adac-0313bb8e7f8b"],
    "IFileSystemHandlerCallback2": ["871cd30c-6e23-4a4f-84af-e7e0446eaed6"],
    "IFileSystemHandlerState": ["8dbf0464-9922-442c-b9ee-d98258142a31"],
    "IFileSystemImage": ["2c941fe1-975b-59be-a960-9a2a262853a5"],
    "IFileSystemImage2": ["d7644b2c-1537-4767-b62f-f1387b02ddfd"],
    "IFileSystemImage3": ["7cff842c-7e97-4807-8304-910dd8f7c051"],
    "IFileSystemImageResult": ["2c941fd8-975b-59be-a960-9a2a262853a5"],
    "IFileSystemImageResult2": ["b507ca29-2204-11dd-966a-001aa01bbc58"],
    "IFileSystemStorage": ["e820910b-1910-404d-afaf-5d7298b9b28d"],
    "IFileUnprotectOptions": ["7d1312f1-3b0d-4dd8-a1f8-1ec53822e2f3"],
    "IFileUnprotectOptionsFactory": ["51aeb39c-da8c-4c3f-9bfb-cb73a7cce0dd"],
    "IFileUpdateRequest": ["40c82536-c1fe-4d93-a792-1e736bc70837"],
    "IFileUpdateRequest2": ["82484648-bdbe-447b-a2ee-7afe6a032a94"],
    "IFileUpdateRequestDeferral": ["ffcedb2b-8ade-44a5-bb00-164c4e72f13a"],
    "IFileUpdateRequestedEventArgs": ["7b0a9342-3905-438d-aaef-78ae265f8dd2"],
    "IFileUpdateResult": ["908075ae-1b69-4112-8126-42aa8074cddc"],
    "IFileUploadCallback": ["d4e43af1-5046-48d3-bde2-0f26b1d20164"],
    "IFileUploader": ["fb73269f-fd3c-4016-8366-ad855ce316d9"],
    "IFileWordlistInitializer": ["8f31dd65-05e8-4851-860e-755aff566516"],
    "IFillInfo": ["de2eacd0-9c9d-11cf-882a-00aa00b569f5"],
    "IFillPropertiesCallback": ["c9d22189-49c4-4ae5-b107-b0ce8312cdd3"],
    "IFilterChain": ["dcfbdcf6-0dc2-45f5-9ab2-7c330ea09c29"],
    "IFilterCondition": ["fca2857d-1760-4ad3-8c63-c9b602fcbaea"],
    "IFilterGraph3": ["aaf38154-b80b-422f-91e6-b66467509a07"],
    "IFilterHost": ["4f5385f1-f9a8-4536-9920-93e8d144dbd0"],
    "IFilterKeyMap": ["ca169652-07c6-4708-a3da-6e4eba8d2297"],
    "IFilterMapper3": ["b79bb0b1-33c1-11d1-abe1-00a0c905f375"],
    "IFilterProperties": ["aade1f59-6ace-43d1-8fca-42af3a5c4f3c"],
    "IFilterRequestCallback": ["82df8873-6360-463a-a8a1-ede5e1a1594d"],
    "IFilterSupport": ["0ae9278d-bae7-41d1-b555-60e8d4196bee"],
    "IFilterTrackingProvider": ["743383c0-fc4e-45ba-ad81-d9d84c7a24f8"],
    "IFilterTrackingRequestCallback": ["713ca7bb-c858-4674-b4b6-1122436587a9"],
    "IFilterTrackingSyncChangeBuilder": ["295024a0-70da-4c58-883c-ce2afb308d0b"],
    "IFilterView": ["a5da0c32-4f6c-4aaa-a6bc-a7c1fe27a059"],
    "IFilteredItemFactory": ["a4cbb5d1-b912-4bf6-a96b-b02855169492"],
    "IFind": ["000c0337-0000-0000-c000-000000000046"],
    "IFindAllAccountsResult": ["a5812b5d-b72e-420c-86ab-aac0d7b7261f"],
    "IFindAppointmentsOptions": ["55f7dc55-9942-3086-82b5-2cb29f64d5f5"],
    "IFindCompressorCB": ["f03fa8de-879a-4d59-9b2c-26bb1cf83461"],
    "IFindEngine": ["ba8f5842-e7e9-4563-86e2-bc3c43f8631f"],
    "IFindEngineCallback": ["90c7af4d-953e-438c-9af4-8977780187ec"],
    "IFindInDocument": ["4fd0599e-fcc0-4fb1-aced-6b6773199268"],
    "IFindInDocumentEvents": ["30217f3c-e8fa-416b-aba6-bf0bd3b79321"],
    "IFindNetPrinters": ["3741a885-71b8-49b4-8303-3eab8628ff8a"],
    "IFindNetPrintersCallback": ["0075f3ea-ad58-4860-ac5b-302d9334a294"],
    "IFindNextElementOptions": ["d88ae22b-46c2-41fc-897e-b5961977b89d"],
    "IFindPrinter": ["b4cd8efc-d70b-11d1-99b1-080036af3f03"],
    "IFindReferenceTargetsCallback": ["04b3486c-4687-4229-8d14-505ab584dd88"],
    "IFingerprintSettingsHandler": ["349939ac-c9dd-4d96-a299-c019379de564"],
    "IFirstLogonSync": ["775bb368-c3bb-457d-9d85-6f458f6733f8"],
    "IFirstSignInSettings": ["3e945153-3a5e-452e-a601-f5baad2a4870"],
    "IFirstSignInSettingsStatics": ["1ce18f0f-1c41-4ea0-b7a2-6f0c1c7e8438"],
    "IFixedDocument": ["f222ca9f-9968-4db9-81bd-abaebf15f93f"],
    "IFixedDocumentSequence": ["8028d181-2c32-4249-8493-1bfb22045574"],
    "IFixedPage": ["3d9f6448-7e95-4cb5-94fb-0180c2883a57"],
    "IFlashControl": ["def41dbe-7d68-45e3-8c0f-be7bb32837d0"],
    "IFlashControl2": ["7d29cc9e-75e1-4af7-bd7d-4e38e1c06cd6"],
    "IFlexibleTaskbarPinnedList": ["60274fa2-611f-4b8a-a293-f27bf103d148"],
    "IFlightSettingsAPIBroker": ["e833feb2-c58a-45e4-8d93-08874744febb"],
    "IFlightSettingsActionManager": ["1f8c32cf-794f-4c50-ad67-0009b4f999d4"],
    "IFlightSettingsValidator": ["4d7498f1-5096-45e6-9b1c-56037baf6f1e"],
    "IFlightSettingsWriter": ["4ab30937-1c1f-4ffd-b66f-b3cf3d092bd6"],
    "IFlightStick": ["b4a2c01c-b83b-4459-a1a9-97b03c33da7c"],
    "IFlightStickStatics": ["5514924a-fecc-435e-83dc-5cec8a18a520"],
    "IFlightingRing": ["960da761-e98a-4e7a-8497-52d03466318b"],
    "IFlipView": ["a1582f68-3d7d-4d3b-b71d-488eed1e3493"],
    "IFlipView2": ["c4fea4fd-7af3-4952-9fd9-9e0987fc4f29"],
    "IFlipViewAutomationPeer": ["8ec0353a-4284-4b00-aef8-a2688ea5e3c4"],
    "IFlipViewAutomationPeerFactory": ["4395ab0d-8d83-483c-88eb-e2617b0d293f"],
    "IFlipViewFactory": ["f1dea9be-9ae8-4d4b-ab43-16d31e05f4f3"],
    "IFlipViewItem": ["56196565-ce2b-4bda-a36b-82a2b8b0d4c0"],
    "IFlipViewItemAutomationPeer": ["c83034de-fa08-4bd3-aeb2-d2e5bfa04df9"],
    "IFlipViewItemAutomationPeerFactory": ["69109356-d0e5-4c10-a09c-ad0bf1b0cb01"],
    "IFlipViewItemDataAutomationPeer": ["b0986175-00bc-4118-8a6f-16ee9c15d968"],
    "IFlipViewItemDataAutomationPeerFactory": ["3c864393-0aea-4e78-bc11-b775cac4114c"],
    "IFlipViewItemFactory": ["f21d91fe-22a0-4412-a853-9d6a6e8f2aaf"],
    "IFlipViewStatics2": ["70e3d93f-4308-4ba2-bbce-e2cb0ed34476"],
    "IFlyout": ["6584ebdf-cbc7-4e19-843a-a14f24a793ea"],
    "IFlyoutBase": ["723eea0b-d12e-430d-a9f0-9bb32bbf9913"],
    "IFlyoutBase2": ["f82b435e-65b3-41c6-a9e2-77b67bc4c00c"],
    "IFlyoutBase3": ["a89c9712-48e0-4240-95b9-0dfd0826a8d3"],
    "IFlyoutBase4": ["e3897d69-a37f-4828-9b70-0ef67c03b5f8"],
    "IFlyoutBase5": ["ad3ec0c7-12bb-5a73-b78e-105192ca73d6"],
    "IFlyoutBase6": ["5399de8c-06cc-5b52-b65a-ff9322d1c940"],
    "IFlyoutBaseClosingEventArgs": ["d075852d-b09a-4fd1-b005-db2ba01206fb"],
    "IFlyoutBaseFactory": ["1c3363d7-fca7-407e-920e-70e15e9f0bf1"],
    "IFlyoutBaseOverrides": ["101dec86-6f4d-45a4-9d0e-3ece6f16977e"],
    "IFlyoutBaseOverrides4": ["a6bfd04d-5ff3-4418-add8-4042a88d2da5"],
    "IFlyoutBaseStatics": ["e2d795e3-85c0-4de2-bac1-5294ca011a78"],
    "IFlyoutBaseStatics2": ["a8e913fe-2d60-4307-aad9-56b450121b58"],
    "IFlyoutBaseStatics3": ["7ba92e4f-dd16-4be4-99db-bd9d4406c0f8"],
    "IFlyoutBaseStatics5": ["69edb25c-992a-542b-bcff-2f7f855523bd"],
    "IFlyoutBaseStatics6": ["96d49254-c91b-5246-8b39-afc2a2c50cf8"],
    "IFlyoutFactory": ["4bed4933-008e-4b03-a385-79fe5266ddba"],
    "IFlyoutPresenter": ["827d5b79-e37b-46a5-8d44-63a11a580e83"],
    "IFlyoutPresenter2": ["4f857e92-36b4-5048-9051-a992b43e8a1d"],
    "IFlyoutPresenterAutomationPeer": ["a01840b4-5fca-456f-98ea-300eb40b585e"],
    "IFlyoutPresenterAutomationPeerFactory": ["f350155f-8924-44c0-ba44-653fe79f1efb"],
    "IFlyoutPresenterFactory": ["ee4d668f-da76-469a-acd7-3060e613ade7"],
    "IFlyoutPresenterStatics2": ["1492ae4b-2727-5e8e-9105-6d7a2b1185b2"],
    "IFlyoutShowOptions": ["57d693ad-0c74-54dd-b110-1ee43fabadd9"],
    "IFlyoutShowOptionsFactory": ["ce596f61-2eb4-5b4e-af69-f9af42320eee"],
    "IFlyoutStatics": ["61364e0b-db75-47e1-b2c3-5b901c3d74b6"],
    "IFocusContainer": ["76b463ec-dde4-48ea-b9dd-1b2b13487928"],
    "IFocusControl": ["c0d889f6-5228-4453-b153-85606592b238"],
    "IFocusControl2": ["3f7cff48-c534-4e9e-94c3-52ef2afd5d07"],
    "IFocusDisengagedEventArgs": ["5e14280f-953e-4cf8-b9ea-c530a1ce02ad"],
    "IFocusEngagedEventArgs": ["a69fc352-da66-404c-823f-5358594e70bb"],
    "IFocusEngagedEventArgs2": ["4a59e0f4-87c0-4ccd-93c4-a3a01ce39265"],
    "IFocusManager": ["c843f50b-3b83-4da1-9d6f-557c1169f341"],
    "IFocusManagerGotFocusEventArgs": ["97aa5d83-535b-507a-868e-62b706f06b61"],
    "IFocusManagerLostFocusEventArgs": ["3e157e7a-9578-5cd3-aaa8-051b3d391978"],
    "IFocusManagerStatics": ["1eccd326-8182-4482-826a-0918e9ed9af7"],
    "IFocusManagerStatics2": ["a920d761-dd87-4f31-beda-ef417fe7c04a"],
    "IFocusManagerStatics3": ["60805ebf-b149-417d-83f1-baeb560e2a47"],
    "IFocusManagerStatics4": ["29276e9c-1c6c-414a-ba1c-96efd5962bcd"],
    "IFocusManagerStatics5": ["280edc61-207a-4d7b-b98f-ce165e1b2015"],
    "IFocusManagerStatics6": ["3546a1b6-20bf-5007-929d-e6d32e16afe4"],
    "IFocusManagerStatics7": ["95d6fa97-f0fc-5c32-b29d-07c04ec966b0"],
    "IFocusMovementResult": ["06dfead3-c2ae-44bb-bfab-9c73de8407a4"],
    "IFocusSettings": ["79958f6b-3263-4275-85d6-aeae891c96ee"],
    "IFolderAction": ["03837543-098b-11d8-9414-505054503030"],
    "IFolderActionCollection": ["03837544-098b-11d8-9414-505054503030"],
    "IFolderLauncherOptions": ["bb91c27d-6b87-432a-bd04-776c6f5fb2ab"],
    "IFolderPicker": ["084f7799-f3fb-400a-99b1-7b4a772fd60d"],
    "IFolderPicker2": ["8eb3ba97-dc85-4616-be94-9660881f2f5d"],
    "IFolderPicker3": ["673b1e29-d326-53c0-bd24-a25c714cee36"],
    "IFolderPickerContinuationEventArgs": ["51882366-9f4b-498f-beb0-42684f6e1c29"],
    "IFolderPickerStatics": ["9be34740-7ca1-5942-a3c8-46f2551ecff3"],
    "IFolderType": ["053b4a86-0dc9-40a3-b7ed-bc6a2e951f48"],
    "IFolderTypeDescription": ["e2ba9629-b18f-4e3a-aba5-42d879e79c80"],
    "IFolderTypeModifier": ["04ba120e-ad52-4a2d-9807-2da178d0c3e1"],
    "IFolderView2": ["1af3a467-214f-4298-908e-06b03e0b39f9"],
    "IFolderViewOptions": ["3cc974d2-b302-4d36-ad3e-06d93f695d3f"],
    "IFolderViewSettings": ["ae8c987d-8797-4ed3-be72-2a47dd938db0"],
    "IFolderWithGrepConfiguration": ["2a2407e5-1c5a-4836-a9fe-717590eb940d"],
    "IFolderWithNavigationOptions": ["d95a2970-4f52-4ee2-a438-4f1ad881f19f"],
    "IFolderWithSearchRoot": ["dc0ac42a-141e-4876-9c43-824829440de0"],
    "IFontFamily": ["92467e64-d66a-4cf4-9322-3d23b3c0c361"],
    "IFontFamilyFactory": ["d5603377-3dae-4dcd-af09-f9498e9ec659"],
    "IFontFamilyStatics2": ["52ad7af9-37e6-4297-a238-97fb6a408d9e"],
    "IFontIcon": ["d4d61391-39ac-4950-9166-3606c264418b"],
    "IFontIcon2": ["f6ebd84d-37e8-46ee-a574-41ad550482e0"],
    "IFontIcon3": ["6155d919-1c6c-4950-8794-231ef0914d94"],
    "IFontIconFactory": ["1c781b6b-37bf-4ddc-a1a8-1b77db3cf0ea"],
    "IFontIconSource": ["2211ac9a-74e3-43ed-b61c-21afc7df4d10"],
    "IFontIconSourceFactory": ["8bdcf6bd-fc06-42b8-b30b-7505082ac38f"],
    "IFontIconSourceStatics": ["8c0e422f-8269-43b1-b95a-ef070e86770d"],
    "IFontIconStatics": ["b3be7bf6-1467-4086-bbcb-4e21d97a7b4d"],
    "IFontIconStatics2": ["e6080672-08f8-43d3-8790-4604290cbebd"],
    "IFontIconStatics3": ["a4528b17-b084-4bd5-aab4-feae9d3b5d26"],
    "IFontManager": ["935ad8eb-cbf8-4fd3-8f4f-385f55258f2e"],
    "IFontManagerEvents": ["5cea2cc7-c557-480c-b44d-04172e801c7f"],
    "IFontWeights": ["7880a444-01ab-4997-8517-df822a0c45f1"],
    "IFontWeightsStatics": ["b3b579d5-1ba9-48eb-9dad-c095e8c23ba3"],
    "IForceFeedbackEffect": ["a17fba0c-2ae4-48c2-8063-eabd0777cb89"],
    "IForceFeedbackMotor": ["8d3d417c-a5ea-4516-8026-2b00f74ef6e5"],
    "IForegroundAppChangeHandler": ["21ecba5d-00f0-4ac3-974e-c0de9d935707"],
    "IForegroundAppChangeNotification": ["9c892ffb-ae7e-4e5e-af1c-9c9b74749af7"],
    "IForegroundManagerBackgroundPolicy": ["402d0f67-cd0a-4a7a-849b-068515b93866"],
    "IForegroundManagerCustomResourcePolicy": ["40a605fd-e2e5-4519-9858-c712826167b6"],
    "IForegroundManagerInternal": ["5c4e89bf-7ddc-414a-8f9a-48bd131be991"],
    "IForgottenKnowledge": ["456e0f96-6036-452b-9f9d-bcc4b4a85db2"],
    "IFormatDetectionDumper": ["3051085d-98b5-11cf-bb82-00aa00bdce0b"],
    "IFormatEngine": ["fe70304f-2b7e-4ee7-bd89-1ca62e049282"],
    "IFormatForDisplayHelper": ["679ca263-b06d-40ee-bc2f-0dd3aacecc52"],
    "IFoundFiles": ["000c0338-0000-0000-c000-000000000046"],
    "IFrame2": ["3f367f87-9f5a-4b04-b818-b554c069597a"],
    "IFrame3": ["648a2b4d-53ca-4b5a-aa8e-3cc7440f4a67"],
    "IFrame4": ["9b17c21a-bd2b-4a00-99eb-946be9618084"],
    "IFrame5": ["453fb92e-82b5-5f93-92ab-15341806c9da"],
    "IFrameControlCapabilities": ["a8ffae60-4e9e-4377-a789-e24c4ae7e544"],
    "IFrameControlCapabilities2": ["ce9b0464-4730-440f-bd3e-efe8a8f230a8"],
    "IFrameController": ["c16459d9-baef-4052-9177-48aff2af7522"],
    "IFrameController2": ["00d3bc75-d87c-485b-8a09-5c358568b427"],
    "IFrameExposureCapabilities": ["bdbe9ce3-3985-4e72-97c2-0590d61307a1"],
    "IFrameExposureCompensationCapabilities": ["b988a823-8065-41ee-b04f-722265954500"],
    "IFrameExposureCompensationControl": ["e95896c9-f7f9-48ca-8591-a26531cb1578"],
    "IFrameExposureControl": ["b1605a61-ffaf-4752-b621-f5b6f117f432"],
    "IFrameFactory": ["02ee93d4-448e-469e-9799-0a8a1f70f171"],
    "IFrameFlashCapabilities": ["bb9341a2-5ebe-4f62-8223-0e2b05bfbbd0"],
    "IFrameFlashControl": ["75d5f6c7-bd45-4fab-9375-45ac04b332c2"],
    "IFrameFocusCapabilities": ["7b25cd58-01c0-4065-9c40-c1a721425c1a"],
    "IFrameFocusControl": ["272df1d0-d912-4214-a67b-e38a8d48d8c6"],
    "IFrameFocusHost": ["e571e20c-0490-4284-a6f9-64db48921ff5"],
    "IFrameHTMLWindowServices": ["01fe3c16-443d-45e6-b793-d61f1a032065"],
    "IFrameInputNodeQuantumStartedEventArgs": ["3d9bd498-a306-4f06-bd9f-e9efc8226304"],
    "IFrameIsoSpeedCapabilities": ["16bdff61-6df6-4ac9-b92a-9f6ecd1ad2fa"],
    "IFrameIsoSpeedControl": ["1a03efed-786a-4c75-a557-7ab9a85f588c"],
    "IFrameLayoutDefinition": ["176c11b1-4302-4164-8430-d5a9f0eeacdb"],
    "IFrameLayoutDefinitionFactory": ["7e734121-f3b4-45f9-ad43-2fbe39e533e2"],
    "IFrameManager": ["31e4fa78-02b4-419f-9430-7b7585237c77"],
    "IFrameModule": ["60ce96bb-b6f9-42dc-b84e-5e5d9c370a6f"],
    "IFrameNavigationOptions": ["b539ad2a-9fb7-520a-8f41-57a50c59cf92"],
    "IFrameNavigationOptionsFactory": ["d4681e41-7e6d-5c7c-aca0-478681cc6fce"],
    "IFrameNotificationClient": ["1d3293bc-ec01-400f-8179-8de5d53abeb7"],
    "IFrameShellViewClient": ["6b353825-c58b-4f03-aec4-8de179122661"],
    "IFrameStatics": ["d5acf0e9-d967-471b-8459-c8af4341511b"],
    "IFrameStatics2": ["e4b5cdfe-42f0-4462-a1c1-5d259dd82a03"],
    "IFrameStatics5": ["53c89b25-f0e0-58f1-a06d-441075914ff8"],
    "IFrameTaskManager": ["35bd3360-1b35-4927-bae4-b10e70d99eff"],
    "IFrameWorkItem": ["7c32fa17-30a4-42d5-b7da-ffe8fcfcce45"],
    "IFrameworkElement": ["a391d09b-4a99-4b7c-9d8d-6fa5d01f6fbf"],
    "IFrameworkElement2": ["f19104be-422a-4904-a52f-ee72010429e5"],
    "IFrameworkElement3": ["c81c2720-5c52-4bbe-a199-2b1e34f00f70"],
    "IFrameworkElement4": ["6b765bb3-fba3-4404-bdee-1a45d1ca5f21"],
    "IFrameworkElement6": ["792a5d91-62a1-40bf-a0ce-f9c131fcb7a7"],
    "IFrameworkElement7": ["2263886c-c069-570f-b9cc-9e21dd028d8e"],
    "IFrameworkElementAutomationPeer": ["b90ad781-bfeb-4451-bd47-9f3a63ebd24a"],
    "IFrameworkElementAutomationPeerFactory": ["0db9b8bc-b812-48e3-af1f-dbc57600c325"],
    "IFrameworkElementAutomationPeerStatics": ["b9c0b997-2820-44a1-a5a8-9b801edc269e"],
    "IFrameworkElementFactory": ["deaee126-03ca-4966-b576-604cce93b5e8"],
    "IFrameworkElementOverrides": ["da007e54-b3c2-4b9a-aa8e-d3f071262b97"],
    "IFrameworkElementOverrides2": ["cb5cd2b9-e3b4-458c-b64e-1434fd1bd88a"],
    "IFrameworkElementProtected7": ["65aa0480-22e3-5103-ad2a-b626f88ca5ae"],
    "IFrameworkElementStatics": ["48383032-fbeb-4f8a-aed2-ee21fb27a57b"],
    "IFrameworkElementStatics2": ["9695db02-c0d8-4fa2-b100-3fa2df8b9538"],
    "IFrameworkElementStatics4": ["9c41b155-c5d8-4663-bff2-d8d54fb5dbb3"],
    "IFrameworkElementStatics5": ["525d3941-0b3c-4be6-9978-19a8025c09d8"],
    "IFrameworkElementStatics6": ["fcc1529a-69db-4582-a7be-cf6a1cfdacd0"],
    "IFrameworkInputPane": ["5752238b-24f0-495a-82f1-2fd593056796"],
    "IFrameworkInputPaneHandler": ["226c537b-1e76-4d9e-a760-33db29922f18"],
    "IFrameworkInputPanePriv": ["8d358a3b-c719-4c70-ad58-6efe8c58bd9d"],
    "IFrameworkTemplate": ["a1e254d8-a446-4a27-9a9d-a0f59e1258a5"],
    "IFrameworkTemplateFactory": ["1a78a0a5-937d-46d4-832b-94ff14dab061"],
    "IFrameworkView": ["ddba664b-b603-47aa-942d-3833174f0d80", "faab5cd0-8924-45ac-ad0f-a08fae5d0324"],
    "IFrameworkViewSource": ["cd770614-65c4-426c-9494-34fc43554862", "e3b077da-35ad-4b09-b5b2-27420041ba9f"],
    "IFreeThreadedComWrapper": ["394ab223-9fc6-4893-8943-9f6c70d51891"],
    "IFreeThreadedItemContainer": ["0c904b4a-164a-4d81-92d9-a5fc866f7fb8"],
    "IFrequencyMap": ["06fb45c1-693c-4ea7-b79f-7a6a54d8def2"],
    "IFsiDirectoryItem": ["2c941fdc-975b-59be-a960-9a2a262853a5"],
    "IFsiDirectoryItem2": ["f7fb4b9b-6d96-4d7b-9115-201b144811ef"],
    "IFsiFileItem": ["2c941fdb-975b-59be-a960-9a2a262853a5"],
    "IFsiFileItem2": ["199d0c19-11e1-40eb-8ec2-c8c822a07792"],
    "IFsiItem": ["2c941fd9-975b-59be-a960-9a2a262853a5"],
    "IFsiNamedStreams": ["ed79ba56-5294-4250-8d46-f9aecee23459"],
    "IFsrmAccessDeniedRemediationClient": ["40002314-590b-45a5-8e1b-8c05da527e52"],
    "IFsrmAction": ["6cd6408a-ae60-463b-9ef1-e117534d69dc"],
    "IFsrmActionCommand": ["12937789-e247-4917-9c20-f3ee9c7ee783"],
    "IFsrmActionEmail": ["d646567d-26ae-4caa-9f84-4e0aad207fca"],
    "IFsrmActionEmail2": ["8276702f-2532-4839-89bf-4872609a2ea4"],
    "IFsrmActionEventLog": ["4c8f96c3-5d94-4f37-a4f4-f56ab463546f"],
    "IFsrmActionReport": ["2dbe63c4-b340-48a0-a5b0-158e07fc567e"],
    "IFsrmAutoApplyQuota": ["f82e5729-6aba-4740-bfc7-c7f58f75fb7b"],
    "IFsrmClassificationManager": ["d2dc89da-ee91-48a0-85d8-cc72a56f7d04"],
    "IFsrmClassificationManager2": ["0004c1c9-127e-4765-ba07-6a3147bca112"],
    "IFsrmClassificationRule": ["afc052c2-5315-45ab-841b-c6db0e120148"],
    "IFsrmClassifierModuleDefinition": ["bb36ea26-6318-4b8c-8592-f72dd602e7a5"],
    "IFsrmClassifierModuleImplementation": ["4c968fc6-6edb-4051-9c18-73b7291ae106"],
    "IFsrmCollection": ["f76fbf3b-8ddd-4b42-b05a-cb1c3ff1fee8"],
    "IFsrmCommittableCollection": ["96deb3b5-8b91-4a2a-9d93-80a35d8aa847"],
    "IFsrmDerivedObjectsResult": ["39322a2d-38ee-4d0d-8095-421a80849a82"],
    "IFsrmExportImport": ["efcb0ab1-16c4-4a79-812c-725614c3306b"],
    "IFsrmFileCondition": ["70684ffc-691a-4a1a-b922-97752e138cc1"],
    "IFsrmFileConditionProperty": ["81926775-b981-4479-988f-da171d627360"],
    "IFsrmFileGroup": ["8dd04909-0e34-4d55-afaa-89e1f1a1bbb9"],
    "IFsrmFileGroupImported": ["ad55f10b-5f11-4be7-94ef-d9ee2e470ded"],
    "IFsrmFileGroupManager": ["426677d5-018c-485c-8a51-20b86d00bdc4"],
    "IFsrmFileManagementJob": ["0770687e-9f36-4d6f-8778-599d188461c9"],
    "IFsrmFileManagementJobManager": ["ee321ecb-d95e-48e9-907c-c7685a013235"],
    "IFsrmFileScreen": ["5f6325d3-ce88-4733-84c1-2d6aefc5ea07"],
    "IFsrmFileScreenBase": ["f3637e80-5b22-4a2b-a637-bbb642b41cfc"],
    "IFsrmFileScreenException": ["bee7ce02-df77-4515-9389-78f01c5afc1a"],
    "IFsrmFileScreenManager": ["ff4fa04e-5a94-4bda-a3a0-d5b4d3c52eba"],
    "IFsrmFileScreenTemplate": ["205bebf8-dd93-452a-95a6-32b566b35828"],
    "IFsrmFileScreenTemplateImported": ["e1010359-3e5d-4ecd-9fe4-ef48622fdf30"],
    "IFsrmFileScreenTemplateManager": ["cfe36cba-1949-4e74-a14f-f1d580ceaf13"],
    "IFsrmMutableCollection": ["1bb617b8-3886-49dc-af82-a6c90fa35dda"],
    "IFsrmObject": ["22bcef93-4a3f-4183-89f9-2f8b8a628aee"],
    "IFsrmPathMapper": ["6f4dbfff-6920-4821-a6c3-b7e94c1fd60c"],
    "IFsrmPipelineModuleConnector": ["c16014f3-9aa1-46b3-b0a7-ab146eb205f2"],
    "IFsrmPipelineModuleDefinition": ["515c1277-2c81-440e-8fcf-367921ed4f59"],
    "IFsrmPipelineModuleImplementation": ["b7907906-2b02-4cb5-84a9-fdf54613d6cd"],
    "IFsrmProperty": ["4a73fee4-4102-4fcc-9ffb-38614f9ee768"],
    "IFsrmPropertyBag": ["774589d1-d300-4f7a-9a24-f7b766800250"],
    "IFsrmPropertyBag2": ["0e46bdbd-2402-4fed-9c30-9266e6eb2cc9"],
    "IFsrmPropertyCondition": ["326af66f-2ac0-4f68-bf8c-4759f054fa29"],
    "IFsrmPropertyDefinition": ["ede0150f-e9a3-419c-877c-01fe5d24c5d3"],
    "IFsrmPropertyDefinition2": ["47782152-d16c-4229-b4e1-0ddfe308b9f6"],
    "IFsrmPropertyDefinitionValue": ["e946d148-bd67-4178-8e22-1c44925ed710"],
    "IFsrmQuota": ["377f739d-9647-4b8e-97d2-5ffce6d759cd"],
    "IFsrmQuotaBase": ["1568a795-3924-4118-b74b-68d8f0fa5daf"],
    "IFsrmQuotaManager": ["8bb68c7d-19d8-4ffb-809e-be4fc1734014"],
    "IFsrmQuotaManagerEx": ["4846cb01-d430-494f-abb4-b1054999fb09"],
    "IFsrmQuotaObject": ["42dc3511-61d5-48ae-b6dc-59fc00c0a8d6"],
    "IFsrmQuotaTemplate": ["a2efab31-295e-46bb-b976-e86d58b52e8b"],
    "IFsrmQuotaTemplateImported": ["9a2bf113-a329-44cc-809a-5c00fce8da40"],
    "IFsrmQuotaTemplateManager": ["4173ac41-172d-4d52-963c-fdc7e415f717"],
    "IFsrmReport": ["d8cc81d9-46b8-4fa4-bfa5-4aa9dec9b638"],
    "IFsrmReportJob": ["38e87280-715c-4c7d-a280-ea1651a19fef"],
    "IFsrmReportManager": ["27b899fe-6ffa-4481-a184-d3daade8a02b"],
    "IFsrmReportScheduler": ["6879caf9-6617-4484-8719-71c3d8645f94"],
    "IFsrmRule": ["cb0df960-16f5-4495-9079-3f9360d831df"],
    "IFsrmSetting": ["f411d4fd-14be-4260-8c40-03b7c95e608a"],
    "IFsrmStorageModuleDefinition": ["15a81350-497d-4aba-80e9-d4dbcc5521fe"],
    "IFsrmStorageModuleImplementation": ["0af4a0da-895a-4e50-8712-a96724bcec64"],
    "IFtpAuthenticationProvider": ["4659f95c-d5a8-4707-b2fc-6fd5794246cf"],
    "IFtpAuthorizationProvider": ["a50ae7a1-a35a-42b4-a4f3-f4f7057a05d1"],
    "IFtpHomeDirectoryProvider": ["0933b392-18dd-4097-8b9c-83325c35d9a6"],
    "IFtpLogProvider": ["a18a94cc-8299-4408-816c-7c3baca1a40e"],
    "IFtpPostprocessProvider": ["4522cbc6-16cd-49ad-8653-9a2c579e4280"],
    "IFtpPreprocessProvider": ["a3c19b60-5a28-471a-8f93-ab30411cee82"],
    "IFtpProviderConstruct": ["4d1a3f7b-412d-447c-b199-64f967e9a2da"],
    "IFtpRoleProvider": ["909c850d-8ca0-4674-96b8-cc2941535725"],
    "IFullContactCardOptions": ["8744436c-5cf9-4683-bdca-a1fdebf8dbce"],
    "IFullScreenBroker": ["796be4b3-0fb1-415d-9984-0bc8b72e5fa2"],
    "IFullScreenManager": ["f0093591-bfa3-471f-b9f0-f17f8a979c6d"],
    "IFullScreenNotification": ["7adc3cb7-307a-4f32-b2c6-c007ee409fd0"],
    "IFullScreenPositioner": ["88ed940d-d632-4b84-9529-a3110b5af527"],
    "IFullScreenPositionerNotification": ["fe917f8f-4e14-41a5-83ba-a9f9de203a07"],
    "IFullScreenPositionerPrivateNotification": ["c0d2dfdf-8b97-41f6-9f0c-13247f43abb8"],
    "IFullScreenPresentationConfiguration": ["43d3dcd8-d2a8-503d-a626-15533d6d5f62"],
    "IFullTrustProcessLauncherStatics": ["d784837f-1100-3c6b-a455-f6262cc331b6"],
    "IFunctionDiscovery": ["4df99b70-e148-4432-b004-4c9eeb535a5e"],
    "IFunctionDiscoveryNotification": ["5f6c1ba8-5330-422e-a368-572b244d3f87"],
    "IFunctionDiscoveryProvider": ["dcde394f-1478-4813-a402-f6fb10657222"],
    "IFunctionDiscoveryProviderFactory": ["86443ff0-1ad5-4e68-a45a-40c2c329de3b"],
    "IFunctionDiscoveryProviderQuery": ["6876ea98-baec-46db-bc20-75a76e267a3a"],
    "IFunctionDiscoveryProviderRefresh": ["fab03726-1da1-4ba5-aff1-d26e20e7f2f8"],
    "IFunctionDiscoveryServiceProvider": ["4c81ed02-1b04-43f2-a451-69966cbcd1c2"],
    "IFunctionInstance": ["33591c10-0bed-4f02-b0ab-1530d5533ee9"],
    "IFunctionInstanceCollection": ["f0a3d895-855c-42a2-948d-2f97d450ecb1"],
    "IFunctionInstanceCollectionQuery": ["57cc6fd2-c09a-4289-bb72-25f04142058e"],
    "IFunctionInstanceCollectionQuery2": ["24de490a-2fec-4ed0-8aa2-2cfe8c71643b"],
    "IFunctionInstanceCollectionQueryCollection": ["b3330569-bb2a-4766-8972-bbfb4f9db684"],
    "IFunctionInstanceQuery": ["6242bc6b-90ec-4b37-bb46-e229fd84ed95"],
    "IFunctionInstanceQuery2": ["766ed696-6f98-419b-8624-281f686e1d05"],
    "IGCHost2": ["a1d70cec-2dbe-4e2f-9291-fdf81438a1df"],
    "IGCHostControl": ["5513d564-8374-4cb9-aed9-0083f4160a1d"],
    "IGCThreadControl": ["f31d1788-c397-4725-87a5-6af3472c2791"],
    "IGITCookieProvider": ["61543de8-8d55-421e-8bed-99751e938bcc"],
    "IGPEInformation": ["8fc0b735-a0e1-11d1-a7d3-0000f87571e3"],
    "IGPM2": ["00238f8a-3d86-41ac-8f5e-06a6638a634a"],
    "IGPMBackupDirEx": ["f8dc55ed-3ba0-4864-aad4-d365189ee1d5"],
    "IGPMConstants2": ["05ae21b0-ac09-4032-a26f-9e7da786dc19"],
    "IGPMDomain2": ["7ca6bb8b-f1eb-490a-938d-3c4e51c768e6"],
    "IGPMDomain3": ["0077fdfe-88c7-4acf-a11d-d10a7c310a03"],
    "IGPMGPO2": ["8a66a210-b78b-4d99-88e2-c306a817c925"],
    "IGPMGPO3": ["7cf123a1-f94a-4112-bfae-6aa1db9cb248"],
    "IGPMStarterGPO": ["dfc3f61b-8880-4490-9337-d29c7ba8c2f0"],
    "IGPMStarterGPOBackup": ["51d98eda-a87e-43dd-b80a-0b66ef1938d6"],
    "IGPMStarterGPOBackupCollection": ["c998031d-add0-4bb5-8dea-298505d8423b"],
    "IGPMStarterGPOCollection": ["2e522729-2219-44ad-933a-64dfd650c423"],
    "IGPUPMitigationDevice": ["d6f70a58-e039-42b3-96db-efe033bc2eac"],
    "IGPUPVDev": ["0f4ddc9b-d683-46fb-a7e9-935dfe0b617f"],
    "IGameBarServices": ["2dbead57-50a6-499e-8c6c-d330a7311796"],
    "IGameBarServicesCommandEventArgs": ["a74226b2-f176-4fcf-8fbb-cf698b2eb8e0"],
    "IGameBarServicesManager": ["3a4b9cfa-7f8b-4c60-9dbb-0bcd262dffc6"],
    "IGameBarServicesManagerGameBarServicesCreatedEventArgs": ["ededbd9c-143e-49a3-a5ea-0b1995c8d46e"],
    "IGameBarServicesManagerStatics": ["34c1b616-ff25-4792-98f2-d3753f15ac13"],
    "IGameBarServicesTargetInfo": ["b4202f92-1611-4e05-b6ef-dfd737ae33b0"],
    "IGameBarStatics": ["1db9a292-cc78-4173-be45-b61e67283ea7"],
    "IGameChatMessageReceivedEventArgs": ["a28201f1-3fb9-4e42-a403-7afce2023b1e"],
    "IGameChatOverlay": ["fbc64865-f6fc-4a48-ae07-03ac6ed43704"],
    "IGameChatOverlayMessageSource": ["1e177397-59fb-4f4f-8e9a-80acf817743c"],
    "IGameChatOverlayStatics": ["89acf614-7867-49f7-9687-25d9dbf444d1"],
    "IGameCollection": ["620978e0-1288-48e8-94af-9ee9afe81512"],
    "IGameCompanyInfo": ["f6eae7d9-4e28-440b-8f53-f45e91578069"],
    "IGameCompanyInfoCollection": ["8b434050-b341-4a0c-a7b3-57175d2393a3"],
    "IGameController": ["1baf6522-5f64-42c5-8267-b9fe2215bfbd"],
    "IGameControllerBatteryInfo": ["dcecc681-3963-4da6-955d-553f3b6f6161"],
    "IGameControllerFactoryManagerStatics": ["36cb66e3-d0a1-4986-a24c-40b137deba9e"],
    "IGameControllerFactoryManagerStatics2": ["eace5644-19df-4115-b32a-2793e2aea3bb"],
    "IGameControllerInputSink": ["1ff6f922-c640-4c78-a820-9a715c558bcb"],
    "IGameControllerProvider": ["e6d73982-2996-4559-b16c-3e57d46e58d6"],
    "IGameControllerProviderInfoStatics": ["0be1e6c5-d9bd-44ee-8362-488b2e464bfb"],
    "IGameDescription": ["3814a6d4-60ac-4dba-9159-9bfc2ba18ca4"],
    "IGameDescriptionRating": ["4edae929-1ed1-471e-8731-20bd177dcc2b"],
    "IGameExplorer": ["e7b2fb72-d728-49b3-a5f2-18ebf5f1349e"],
    "IGameExplorer2": ["86874aa7-a1ed-450d-a7eb-b89e20b2fff3"],
    "IGameExplorerPrivate": ["e0a5897f-2381-4b2f-a38c-1ea964d1a58b"],
    "IGameListChangedEventHandler": ["25f6a421-d8f5-4d91-b40e-53d5e86fde64"],
    "IGameListEntry": ["735924d3-811f-4494-b69c-c641a0c61543"],
    "IGameListEntry2": ["d84a8f8b-8749-4a25-90d3-f6c5a427886d"],
    "IGameListRemovedEventHandler": ["10c5648f-6c8f-4712-9b38-474bc22e76d8"],
    "IGameListStatics": ["2ddd0f6f-9c66-4b05-945c-d6ed78491b8c"],
    "IGameListStatics2": ["395f2098-ea1a-45aa-9268-a83905686f27"],
    "IGameModeConfiguration": ["78e591af-b142-4ef0-8830-55bc2be4f5ea"],
    "IGameModeUserConfiguration": ["72d34af4-756b-470f-a0c2-ba62a90795db"],
    "IGameModeUserConfigurationStatics": ["6e50d97c-66ea-478e-a4a1-f57c0e8d00e7"],
    "IGameRSS": ["7c36a277-4b51-4208-8a7a-4cad5ea9a7b9"],
    "IGameRSSManager": ["e7ea03ce-d9de-441c-bbf9-d2c6c6970ee4"],
    "IGameSaveBlobGetResult": ["917281e0-7201-4953-aa2c-4008f03aef45"],
    "IGameSaveBlobInfo": ["add38034-baf0-4645-b6d0-46edaffb3c2b"],
    "IGameSaveBlobInfoGetResult": ["c7578582-3697-42bf-989c-665d923b5231"],
    "IGameSaveBlobInfoQuery": ["9fdd74b2-eeee-447b-a9d2-7f96c0f83208"],
    "IGameSaveContainer": ["c3c08f89-563f-4ecd-9c6f-33fd0e323d10"],
    "IGameSaveContainerInfo": ["b7e27300-155d-4bb4-b2ba-930306f391b5"],
    "IGameSaveContainerInfoGetResult": ["ffc50d74-c581-4f9d-9e39-30a10c1e4c50"],
    "IGameSaveContainerInfoQuery": ["3c94e863-6f80-4327-9327-ffc11afd42b3"],
    "IGameSaveOperationResult": ["cf0f1a05-24a0-4582-9a55-b1bbbb9388d8"],
    "IGameSaveProvider": ["90a60394-80fe-4211-97f8-a5de14dd95d2"],
    "IGameSaveProviderGetResult": ["3ab90816-d393-4d65-ac16-41c3e67ab945"],
    "IGameSaveProviderStatics": ["d01d3ed0-7b03-449d-8cbd-3402842a1048"],
    "IGameStatistics": ["3887c9ca-04a0-42ae-bc4c-5fa6c7721145"],
    "IGameStatisticsMgr": ["aff3ea11-e70e-407d-95dd-35e612c41ce2"],
    "IGameTask": ["b7c9034c-6ab1-415c-8a31-8374d5fb9fbb"],
    "IGameTaskCollection": ["f4902fb8-4a1f-46dc-9be6-ca69c72a168a"],
    "IGameUIProviderActivatedEventArgs": ["a7b3203e-caf7-4ded-bbd2-47de43bb6dd5"],
    "IGameVersionData": ["0d4794cb-76e2-48aa-a7b5-4923d27f58c2"],
    "IGamepad": ["bc7bb43c-0a69-3903-9e9d-a50f86a45de5"],
    "IGamepad2": ["3c1689bd-5915-4245-b0c0-c89fae0308ff"],
    "IGamepadStatics": ["8bbce529-d49c-39e9-9560-e47dde96b7c8"],
    "IGamepadStatics2": ["42676dc5-0856-47c4-9213-b395504c3a3c"],
    "IGamutMapModelPlugIn": ["2dd80115-ad1e-41f6-a219-a4f4b583d1f9"],
    "IGather": ["c206493f-3c3b-4845-ac46-9e9f5d539a34"],
    "IGatherAdmin": ["b05651f6-9b10-425e-b616-1fcd828db3b1"],
    "IGatherAdmin2": ["ba3c6251-c679-42ed-b75e-4fb81cf2ce93"],
    "IGatherAdmin3": ["fce7ec00-38e9-4837-9f8c-a0313215b86f"],
    "IGatherAdmin4": ["1953486c-8ffa-453f-a489-9f691a007f5e"],
    "IGatherAdmin5": ["2115c3b0-578b-4d31-9001-1a185200ddd1"],
    "IGatherApplication": ["b05651e2-9b10-425e-b616-1fcd828db3b1"],
    "IGatherApplication2": ["c886b1d4-dc18-48d6-8a8f-e66046fcd0cd"],
    "IGatherApplications": ["b05651e4-9b10-425e-b616-1fcd828db3b1"],
    "IGatherApplications2": ["b05651e5-9b10-425e-b616-1fcd828db3b1"],
    "IGatherDataResource": ["0b63e314-9ccc-11d0-bcdb-00805fccce04"],
    "IGatherDataSink": ["c7310559-ac80-11d1-8df3-00c04fb6ef4f"],
    "IGatherDataSite": ["c731057d-ac80-11d1-8df3-00c04fb6ef4f"],
    "IGatherLanguageResourcePool": ["c7310685-ac80-11d1-8df3-00c04fb6ef4f"],
    "IGatherLog": ["b05651d9-9b10-425e-b616-1fcd828db3b1"],
    "IGatherLogProvider": ["a373e680-7a87-11d3-b1c1-00c04f68155c"],
    "IGatherLogs": ["b05651d8-9b10-425e-b616-1fcd828db3b1"],
    "IGatherManagerAdmin": ["b05651e6-9b10-425e-b616-1fcd828db3b1"],
    "IGatherManagerAdmin2": ["b05651e7-9b10-425e-b616-1fcd828db3b1"],
    "IGatherManagerAdmin4": ["7e5e602d-98c3-4dc3-a624-610e430b3c5f"],
    "IGatherNotify": ["b05651f9-9b10-425e-b616-1fcd828db3b1"],
    "IGatherNotify2": ["a5eba07a-dae8-4d15-b12f-728efd8a9866"],
    "IGatherNotifyInline": ["9ea01e09-b0ac-4fb0-ae44-5caa8cb1502f"],
    "IGatherNotifyInline2": ["5fa6726b-3ba9-4223-810b-29a160321172"],
    "IGatherNotifyInlineInternal": ["519d6ff5-aa00-4e4f-914f-be3e10ad78ad"],
    "IGatherNotifySink": ["b056523e-9b10-425e-b616-1fcd828db3b1"],
    "IGatherPluginContext": ["c731059e-ac80-11d1-8df3-00c04fb6ef4f"],
    "IGatherProjectAdmin": ["b05651df-9b10-425e-b616-1fcd828db3b1"],
    "IGatherProjectAdmin2": ["b05651e0-9b10-425e-b616-1fcd828db3b1"],
    "IGatherProjectAdmin3": ["b05651e1-9b10-425e-b616-1fcd828db3b1"],
    "IGatherPropertyBagEnum": ["c731057f-ac80-11d1-8df3-00c04fb6ef4f"],
    "IGatherStoreAppCleanup": ["2bab5a77-7751-4955-ad37-4a27a3c3046d"],
    "IGatherStoreAppSize": ["9fd4bf75-68d1-4791-8ac3-6c757a0c7b9f"],
    "IGatherStoreAppSupport": ["e65bd7f9-275b-4aff-b384-c66ad8046d96"],
    "IGatherStoreScopeNotification": ["a20bfc65-eed8-4814-9be5-d1327a823de4"],
    "IGatherTransactionStatus": ["2c6d493f-bea1-47a6-8b3f-f6f4f0b86eda"],
    "IGatherUsn": ["2bbf221a-023a-49a8-8f67-b7d8f080815b"],
    "IGattCharacteristic": ["59cb50c1-5934-4f68-a198-eb864fa44e6b"],
    "IGattCharacteristic2": ["ae1ab578-ec06-4764-b780-9835a1d35d6e"],
    "IGattCharacteristic3": ["3f3c663e-93d4-406b-b817-db81f8ed53b3"],
    "IGattCharacteristicNotificationTrigger": ["e25f8fc8-0696-474f-a732-f292b0cebc5d"],
    "IGattCharacteristicNotificationTrigger2": ["9322a2c4-ae0e-42f2-b28c-f51372e69245"],
    "IGattCharacteristicNotificationTriggerDetails": ["9ba03b18-0fec-436a-93b1-f46c697532a2"],
    "IGattCharacteristicNotificationTriggerDetails2": ["727a50dc-949d-454a-b192-983467e3d50f"],
    "IGattCharacteristicNotificationTriggerFactory": ["57ba1995-b143-4575-9f6b-fd59d93ace1a"],
    "IGattCharacteristicNotificationTriggerFactory2": ["5998e91f-8a53-4e9f-a32c-23cd33664cee"],
    "IGattCharacteristicStatics": ["59cb50c3-5934-4f68-a198-eb864fa44e6b"],
    "IGattCharacteristicUuidsStatics": ["58fa4586-b1de-470c-b7de-0d11ff44f4b7"],
    "IGattCharacteristicUuidsStatics2": ["1855b425-d46e-4a2c-9c3f-ed6dea29e7be"],
    "IGattCharacteristicsResult": ["1194945c-b257-4f3e-9db7-f68bc9a9aef2"],
    "IGattClientNotificationResult": ["506d5599-0112-419a-8e3b-ae21afabd2c2"],
    "IGattClientNotificationResult2": ["8faec497-45e0-497e-9582-29a1fe281ad5"],
    "IGattDescriptor": ["92055f2b-8084-4344-b4c2-284de19a8506"],
    "IGattDescriptor2": ["8f563d39-d630-406c-ba11-10cdd16b0e5e"],
    "IGattDescriptorStatics": ["92055f2d-8084-4344-b4c2-284de19a8506"],
    "IGattDescriptorUuidsStatics": ["a6f862ce-9cfc-42f1-9185-ff37b75181d3"],
    "IGattDescriptorsResult": ["9bc091f3-95e7-4489-8d25-ff81955a57b9"],
    "IGattDeviceService": ["ac7b7c05-b33c-47cf-990f-6b8f5577df71"],
    "IGattDeviceService2": ["fc54520b-0b0d-4708-bae0-9ffd9489bc59"],
    "IGattDeviceService3": ["b293a950-0c53-437c-a9b3-5c3210c6e569"],
    "IGattDeviceServiceStatics": ["196d0022-faad-45dc-ae5b-2ac3184e84db"],
    "IGattDeviceServiceStatics2": ["0604186e-24a6-4b0d-a2f2-30cc01545d25"],
    "IGattDeviceServicesResult": ["171dd3ee-016d-419d-838a-576cf475a3d8"],
    "IGattLocalCharacteristic": ["aede376d-5412-4d74-92a8-8deb8526829c"],
    "IGattLocalCharacteristicParameters": ["faf73db4-4cff-44c7-8445-040e6ead0063"],
    "IGattLocalCharacteristicResult": ["7975de9b-0170-4397-9666-92f863f12ee6"],
    "IGattLocalDescriptor": ["f48ebe06-789d-4a4b-8652-bd017b5d2fc6"],
    "IGattLocalDescriptorParameters": ["5fdede6a-f3c1-4b66-8c4b-e3d2293b40e9"],
    "IGattLocalDescriptorResult": ["375791be-321f-4366-bfc1-3bc6b82c79f8"],
    "IGattLocalService": ["f513e258-f7f7-4902-b803-57fcc7d6fe83"],
    "IGattPresentationFormat": ["196d0021-faad-45dc-ae5b-2ac3184e84db"],
    "IGattPresentationFormatStatics": ["196d0020-faad-45dc-ae5b-2ac3184e84db"],
    "IGattPresentationFormatStatics2": ["a9c21713-b82f-435e-b634-21fd85a43c07"],
    "IGattPresentationFormatTypesStatics": ["faf1ba0a-30ba-409c-bef7-cffb6d03b8fb"],
    "IGattProtocolErrorStatics": ["ca46c5c5-0ecc-4809-bea3-cf79bc991e37"],
    "IGattReadClientCharacteristicConfigurationDescriptorResult": ["63a66f09-1aea-4c4c-a50f-97bae474b348"],
    "IGattReadClientCharacteristicConfigurationDescriptorResult2": ["1bf1a59d-ba4d-4622-8651-f4ee150d0a5d"],
    "IGattReadRequest": ["f1dd6535-6acd-42a6-a4bb-d789dae0043e"],
    "IGattReadRequestedEventArgs": ["93497243-f39c-484b-8ab6-996ba486cfa3"],
    "IGattReadResult": ["63a66f08-1aea-4c4c-a50f-97bae474b348"],
    "IGattReadResult2": ["a10f50a0-fb43-48af-baaa-638a5c6329fe"],
    "IGattReliableWriteTransaction": ["63a66f07-1aea-4c4c-a50f-97bae474b348"],
    "IGattReliableWriteTransaction2": ["51113987-ef12-462f-9fb2-a1a43a679416"],
    "IGattRequestStateChangedEventArgs": ["e834d92c-27be-44b3-9d0d-4fc6e808dd3f"],
    "IGattServiceProvider": ["7822b3cd-2889-4f86-a051-3f0aed1c2760"],
    "IGattServiceProviderAdvertisementStatusChangedEventArgs": ["59a5aa65-fa21-4ffc-b155-04d928012686"],
    "IGattServiceProviderAdvertisingParameters": ["e2ce31ab-6315-4c22-9bd7-781dbc3d8d82"],
    "IGattServiceProviderAdvertisingParameters2": ["ff68468d-ca92-4434-9743-0e90988ad879"],
    "IGattServiceProviderConnection": ["7fa1b9b9-2f13-40b5-9582-8eb78e98ef13"],
    "IGattServiceProviderConnectionStatics": ["3d509f4b-0b0e-4466-b8cd-6ebdda1fa17d"],
    "IGattServiceProviderResult": ["764696d8-c53e-428c-8a48-67afe02c3ae6"],
    "IGattServiceProviderStatics": ["31794063-5256-4054-a4f4-7bbe7755a57e"],
    "IGattServiceProviderTrigger": ["ddc6a3e9-1557-4bd8-8542-468aa0c696f6"],
    "IGattServiceProviderTriggerDetails": ["ae8c0625-05ff-4afb-b16a-de95f3cf0158"],
    "IGattServiceProviderTriggerResult": ["3c4691b1-b198-4e84-bad4-cf4ad299ed3a"],
    "IGattServiceProviderTriggerStatics": ["b413a36a-e294-4591-a5a6-64891a828153"],
    "IGattServiceUuidsStatics": ["6dc57058-9aba-4417-b8f2-dce016d34ee2"],
    "IGattServiceUuidsStatics2": ["d2ae94f5-3d15-4f79-9c0c-eaafa675155c"],
    "IGattSession": ["d23b5143-e04e-4c24-999c-9c256f9856b1"],
    "IGattSessionStatics": ["2e65b95c-539f-4db7-82a8-73bdbbf73ebf"],
    "IGattSessionStatusChangedEventArgs": ["7605b72e-837f-404c-ab34-3163f39ddf32"],
    "IGattSubscribedClient": ["736e9001-15a4-4ec2-9248-e3f20d463be9"],
    "IGattValueChangedEventArgs": ["d21bdb54-06e3-4ed8-a263-acfac8ba7313"],
    "IGattWriteRequest": ["aeb6a9ed-de2f-4fc2-a9a8-94ea7844f13d"],
    "IGattWriteRequestedEventArgs": ["2dec8bbe-a73a-471a-94d5-037deadd0806"],
    "IGattWriteResult": ["4991ddb1-cb2b-44f7-99fc-d29a2871dc9b"],
    "IGazeDevicePreview": ["e79e7ee9-b389-11e7-b201-c8d3ffb75721"],
    "IGazeDeviceWatcherAddedPreviewEventArgs": ["e79e7eed-b389-11e7-b201-c8d3ffb75721"],
    "IGazeDeviceWatcherPreview": ["e79e7ee7-b389-11e7-b201-c8d3ffb75721"],
    "IGazeDeviceWatcherRemovedPreviewEventArgs": ["f2631f08-0e3f-431f-a606-50b35af94a1c"],
    "IGazeDeviceWatcherUpdatedPreviewEventArgs": ["7fe830ef-7f08-4737-88e1-4a83ae4e4885"],
    "IGazeEnteredPreviewEventArgs": ["2567bf43-1225-489f-9dd1-daa7c50fbf4b"],
    "IGazeExitedPreviewEventArgs": ["5d0af07e-7d83-40ef-9f0a-fbc1bbdcc5ac"],
    "IGazeInputSourcePreview": ["e79e7ee8-b389-11e7-b201-c8d3ffb75721"],
    "IGazeInputSourcePreviewStatics": ["e79e7ee6-b389-11e7-b201-c8d3ffb75721"],
    "IGazeMovedPreviewEventArgs": ["e79e7eeb-b389-11e7-b201-c8d3ffb75721"],
    "IGazePointPreview": ["e79e7eea-b389-11e7-b201-c8d3ffb75721"],
    "IGeneralTransform": ["a06798b7-a2ec-415f-ade2-eade9333f2c7"],
    "IGeneralTransformFactory": ["7a25c930-29c4-4e31-b6f9-dedd52e4df1b"],
    "IGeneralTransformOverrides": ["4f121083-24cf-4524-90ad-8a42b1c12783"],
    "IGeneratorPositionHelper": ["cd40318d-7745-40d9-ab9d-abbda4a7ffea"],
    "IGeneratorPositionHelperStatics": ["ad4095cd-60ec-4588-8d60-39d29097a4df"],
    "IGenericDescriptor": ["6a5918f8-a77a-4f61-aed0-5702bdcda3e6"],
    "IGenericDescriptor2": ["bf02fb7e-9792-4e10-a68d-033a2cc246a5"],
    "IGenericTypeLibOLE": ["f5aa2660-ba14-1069-8aee-00dd010f7d13"],
    "IGeoboundingBox": ["0896c80b-274f-43da-9a06-cbfcdaeb4ec2"],
    "IGeoboundingBoxFactory": ["4dfba589-0411-4abc-b3b5-5bbccb57d98c"],
    "IGeoboundingBoxStatics": ["67b80708-e61a-4cd0-841b-93233792b5ca"],
    "IGeocircle": ["39e45843-a7f9-4e63-92a7-ba0c28d124b1"],
    "IGeocircleFactory": ["afd6531f-72b1-4f7d-87cc-4ed4c9849c05"],
    "IGeocoordinate": ["ee21a3aa-976a-4c70-803d-083ea55bcbc4"],
    "IGeocoordinateSatelliteData": ["c32a74d9-2608-474c-912c-06dd490f4af7"],
    "IGeocoordinateWithPoint": ["feea0525-d22c-4d46-b527-0b96066fc7db"],
    "IGeocoordinateWithPositionData": ["95e634be-dbd6-40ac-b8f2-a65c0340d9a6"],
    "IGeocoordinateWithPositionSourceTimestamp": ["8543fc02-c9f1-4610-afe0-8bc3a6a87036"],
    "IGeofence": ["9c090823-edb8-47e0-8245-5bf61d321f2d"],
    "IGeofenceFactory": ["841f624b-325f-4b90-bca7-2b8022a93796"],
    "IGeofenceMonitor": ["4c0f5f78-1c1f-4621-bbbd-833b92247226"],
    "IGeofenceMonitorStatics": ["2dd32fcf-7e75-4899-ace3-2bd0a65cce06"],
    "IGeofenceStateChangeReport": ["9a243c18-2464-4c89-be05-b3ffff5babc5"],
    "IGeographicRegion": ["01e9a621-4a64-4ed9-954f-9edeb07bd903"],
    "IGeographicRegionFactory": ["53425270-77b4-426b-859f-81e19d512546"],
    "IGeographicRegionStatics": ["29e28974-7ad9-4ef4-8799-b3b44fadec08"],
    "IGeolocator": ["a9c3bf62-4524-4989-8aa9-de019d2e551f"],
    "IGeolocator2": ["d1b42e6d-8891-43b4-ad36-27c6fe9a97b1"],
    "IGeolocatorStatics": ["9a8e7571-2df5-4591-9f87-eb5fd894e9b7"],
    "IGeolocatorStatics2": ["993011a2-fa1c-4631-a71d-0dbeb1250d9c"],
    "IGeolocatorWithScalarAccuracy": ["96f5d3c1-b80f-460a-994d-a96c47a51aa4"],
    "IGeometry": ["fa123889-0acd-417b-b62d-5ca1bf4dfc0e"],
    "IGeometryFactory": ["f65daf23-d5fd-42f9-b32a-929c5a4b54e1"],
    "IGeometryGroup": ["55225a61-8677-4c8c-8e46-ee3dc355114b"],
    "IGeometryGroupStatics": ["56c955f4-8496-4bb6-abf0-617b1fe78b45"],
    "IGeometrySource2D": ["caff7902-670c-4181-a624-da977203b845"],
    "IGeometryStatics": ["7a70aa8c-0b06-465f-b637-9a47e5a70111"],
    "IGeopath": ["e53fd7b9-2da4-4714-a652-de8593289898"],
    "IGeopathFactory": ["27bea9c8-c7e7-4359-9b9b-fca3e05ef593"],
    "IGeopoint": ["6bfa00eb-e56e-49bb-9caf-cbaa78a8bcef"],
    "IGeopointFactory": ["db6b8d33-76bd-4e30-8af7-a844dc37b7a0"],
    "IGeoposition": ["c18d0454-7d41-4ff7-a957-9dffb4ef7f5b"],
    "IGeoposition2": ["7f62f697-8671-4b0d-86f8-474a8496187c"],
    "IGeoshape": ["c99ca2af-c729-43c1-8fab-d6dec914df7e"],
    "IGeotagHelperStatics": ["41493244-2524-4655-86a6-ed16f5fc716b"],
    "IGeovisit": ["b1877a76-9ef6-41ab-a0dd-793ece76e2de"],
    "IGeovisitMonitor": ["80118aaf-5944-4591-83c1-396647f54f2c"],
    "IGeovisitMonitorStatics": ["bcf976a7-bbf2-4cdd-95cf-554c82edfb87"],
    "IGeovisitStateChangedEventArgs": ["ceb4d1ff-8b53-4968-beed-4cecd029ce15"],
    "IGeovisitTrigger": ["4818edaa-04e1-4127-9a4c-19351b8a80a4"],
    "IGeovisitTriggerDetails": ["ea770d9e-d1c9-454b-99b7-b2f8cdd2482f"],
    "IGestureRecognizer": ["ae9ef86b-7054-45e3-ae22-3174dc8811b7", "b47a37bf-3d6b-4f88-83e8-6dcb4012ffb0"],
    "IGestureRecognizer2": ["d646097f-6ef7-5746-8ba8-8ff2206e6f3b"],
    "IGetActivationFactory": ["4edb8ee2-96dd-49a7-94f7-4607ddab8e3c"],
    "IGetAppTrackerData": ["507c3ac8-3e12-4cb0-9366-653d3e050638"],
    "IGetBindHandle": ["af0ff408-129d-4b20-91f0-02bd23d88352"],
    "IGetCachedIndexAndVersion": ["4e506848-39a0-4f04-8b96-428fb9d1b523"],
    "IGetCallForwardingCompletion": ["c329148f-3374-438b-8ed4-e1b9ab28eee3"],
    "IGetCapabilitiesKey": ["a8809222-07bb-48ea-951c-33158100625b"],
    "IGetCatalogObject": ["000001fe-0000-0000-c000-000000000046"],
    "IGetContextId": ["000001dd-0000-0000-c000-000000000046"],
    "IGetCountCallback": ["e379fdde-70ae-406a-b761-06d0e508eb20"],
    "IGetDataSource": ["0c733a75-2a1c-11ce-ade5-00aa0044773d"],
    "IGetDispenser": ["c23cc370-87ef-11ce-8081-0080c758527e"],
    "IGetEntitlementResult": ["74fc843f-1a9e-4609-8e4d-819086d08a3d"],
    "IGetInterface": ["cd0ff000-8b95-11d1-82db-00c04fb1625d"],
    "IGetLibrariesCallback": ["2c9eef62-b4cb-43cc-961f-5322aae59241"],
    "IGetNAICompletion": ["4afe7f70-7d1f-45d1-bc93-908161febc58"],
    "IGetOleObject": ["8a701da0-4feb-101b-a82e-08002b2b2337"],
    "IGetPLMNwAcT": ["e9beb716-6add-492b-bbea-b2fe1068a86e"],
    "IGetPauseStateCallback": ["32674bd8-5f56-40b8-8ffc-22b3212ff021"],
    "IGetPiboStreamX": ["69f429ed-36b1-4c5c-af3e-38c128b58caf"],
    "IGetPreviewPageEventArgs": ["a43d703d-dea9-4df6-a7ed-35049cd485c7"],
    "IGetPreviewPageEventHandler": ["ccb3e9ed-9c11-4e50-ab49-e98086bbfdef"],
    "IGetProcessInfoInternal": ["eb3cae6b-6670-4b52-a0a9-d96c3b30180f"],
    "IGetProxyForUrlCompletion": ["eaf85b1b-d1a3-48b7-9d96-52f9f09c9bab"],
    "IGetProxyForUrlParameters": ["2145c3b3-ce6d-4f97-83e4-c25da5b85bf0"],
    "IGetRFStateCompletion": ["4255dd18-d829-4c04-849a-624727b990a2"],
    "IGetRFStateExCompletion": ["74e511fd-f17b-48fc-bd56-93af42e71031"],
    "IGetRecordStatusCompletion": ["2d033fa3-ae5c-495c-bcf5-459ffa07036a"],
    "IGetResultCallback": ["0e90fdd8-8f71-407c-8a44-9ce79b40b99e"],
    "IGetRow": ["0c733aaf-2a1c-11ce-ade5-00aa0044773d"],
    "IGetSIDNIDCompletion": ["e7d5d35e-a770-4adc-8bb1-a677ea6e89ac"],
    "IGetSVGDocument": ["305105ab-98b5-11cf-bb82-00aa00bdce0b"],
    "IGetSearchLaunchModeForWindow": ["f88ddd9c-e19f-4ffb-9bf7-6199f8e45940"],
    "IGetSearchPaneBroker": ["d86cf271-2d45-4831-a2fd-5b61601a1a82"],
    "IGetSelectiveSyncInformationCallback": ["889180d2-f7b3-45b4-ae53-6dc6ed89e613"],
    "IGetSession": ["0c733aba-2a1c-11ce-ade5-00aa0044773d"],
    "IGetSettingUnitPersistentID": ["e6e81559-9f2a-4842-abeb-e7641318b5db"],
    "IGetSourceRow": ["0c733abb-2a1c-11ce-ade5-00aa0044773d"],
    "IGetSyncStatusCallback": ["7b9016c4-d591-402b-bb4d-e125867a8047"],
    "IGetUniqueCountCallback": ["c034a4a8-5e06-4bfe-94c6-93899017fd8f"],
    "IGetVBAObject": ["91733a60-3f4c-101b-a3f6-00aa0034e4e9"],
    "IGettingFocusEventArgs": ["fa05b9ce-c67c-4be8-8fd4-c44d67877e0d"],
    "IGettingFocusEventArgs2": ["88754d7b-b4b9-4959-8bce-89bf212ed4eb"],
    "IGettingFocusEventArgs3": ["4e024891-db3f-5e78-b75a-62bfc3510735"],
    "IGipFirmwareUpdateResult": ["6b794d32-8553-4292-8e03-e16651a2f8bc"],
    "IGipGameControllerInputSink": ["a2108abf-09f1-43bc-a140-80f899ec36fb"],
    "IGipGameControllerProvider": ["dbcf1e19-1af5-45a8-bf02-a0ee50c823fc"],
    "IGlobalOptions": ["0000015b-0000-0000-c000-000000000046"],
    "IGlobalRudeWindowManager": ["cd7a55eb-4c97-4cdc-9163-fc1b0219e13a"],
    "IGlobalRudeWindowNotificationService": ["a240bbbd-d294-480c-8d38-3786056363f1"],
    "IGlobalRudeWindowNotifications": ["22ba7cc0-8e75-484f-844e-0b6d74105413"],
    "IGlobalServiceDS": ["217ebb8e-bc0f-413c-a4c4-87eda3e952d6"],
    "IGlobalSystemMediaTransportControlsSession": ["7148c835-9b14-5ae2-ab85-dc9b1c14e1a8"],
    "IGlobalSystemMediaTransportControlsSessionManager": ["cace8eac-e86e-504a-ab31-5ff8ff1bce49"],
    "IGlobalSystemMediaTransportControlsSessionManagerStatics": ["2050c4ee-11a0-57de-aed7-c97c70338245"],
    "IGlobalSystemMediaTransportControlsSessionMediaProperties": ["68856cf6-adb4-54b2-ac16-05837907acb6"],
    "IGlobalSystemMediaTransportControlsSessionPlaybackControls": ["6501a3e6-bc7a-503a-bb1b-68f158f3fb03"],
    "IGlobalSystemMediaTransportControlsSessionPlaybackInfo": ["94b4b6cf-e8ba-51ad-87a7-c10ade106127"],
    "IGlobalSystemMediaTransportControlsSessionTimelineProperties": ["ede34136-6f25-588d-8ecf-ea5b6735aaa5"],
    "IGlobalizationPreferencesForUser": ["150f0795-4f6e-40ba-a010-e27d81bda7f5"],
    "IGlobalizationPreferencesStatics": ["01bf4326-ed37-4e96-b0e9-c1340d1ea158"],
    "IGlobalizationPreferencesStatics2": ["fcce85f1-4300-4cd0-9cac-1a8e7b7e18f4"],
    "IGlobalizationPreferencesStatics3": ["1e059733-35f5-40d8-b9e8-aef3ef856fce"],
    "IGlyphs": ["d079498b-f2b1-4281-99a2-e4d05932b2b5"],
    "IGlyphs2": ["aa8bfe5c-3754-4bee-bbe1-4403ee9b86f0"],
    "IGlyphsStatics": ["225cf4c5-fdf1-43ed-958f-414e86f103f2"],
    "IGlyphsStatics2": ["10489aa7-1615-4a33-aa02-d7ef2aefc739"],
    "IGpioChangeCounter": ["cb5ec0de-6801-43ff-803d-4576628a8b26"],
    "IGpioChangeCounterFactory": ["147d94b6-0a9e-410c-b4fa-f89f4052084d"],
    "IGpioChangeReader": ["0abc885f-e031-48e8-8590-70de78363c6d"],
    "IGpioChangeReaderFactory": ["a9598ef3-390e-441a-9d1c-e8de0b2df0df"],
    "IGpioController": ["284012e3-7461-469c-a8bc-61d69d08a53c"],
    "IGpioControllerProvider": ["ad11cec7-19ea-4b21-874f-b91aed4a25db"],
    "IGpioControllerStatics": ["2ed6f42e-7af7-4116-9533-c43d99a1fb64"],
    "IGpioControllerStatics2": ["912b7d20-6ca4-4106-a373-fffd346b0e5b"],
    "IGpioPin": ["11d9b087-afae-4790-9ee9-e0eac942d201"],
    "IGpioPinProvider": ["42344cb7-6abc-40ff-9ce7-73b85301b900"],
    "IGpioPinProviderValueChangedEventArgs": ["32a6d6f2-3d5b-44cd-8fbe-13a69f2edb24"],
    "IGpioPinProviderValueChangedEventArgsFactory": ["3ecb0b59-568c-4392-b24a-8a59a902b1f1"],
    "IGpioPinValueChangedEventArgs": ["3137aae1-703d-4059-bd24-b5b25dffb84e"],
    "IGpioProvider": ["44e82707-08ca-434a-afe0-d61580446f7e"],
    "IGpnvsCommonBase": ["907e0b5c-e42d-4f04-91f0-26f401f36907"],
    "IGradientBrush": ["2166e69f-935a-4191-8e3c-1c8dfdfcdc78"],
    "IGradientBrushFactory": ["ed4779ca-45bd-4131-b625-be86e07c6112"],
    "IGradientBrushStatics": ["961661f9-8bb4-4e6c-b923-b5d787e0f1a9"],
    "IGradientStop": ["665f44fe-2e59-4c4a-ab53-076a100ccd81"],
    "IGradientStopStatics": ["602a6d75-6193-4fe5-8e82-c7c6f6febafd"],
    "IGraphConfig": ["03a1eb8e-32bf-4245-8502-114d08a9cb88"],
    "IGraphConfigCallback": ["ade0fd60-d19d-11d2-abf6-00a0c905f375"],
    "IGraphicsCaptureItem": ["79c3f95b-31f7-4ec2-a464-632ef5d30760"],
    "IGraphicsCaptureItemStatics": ["a87ebea5-457c-5788-ab47-0cf1d3637e74"],
    "IGraphicsCapturePicker": ["5a1711b3-ad79-4b4a-9336-1318fdde3539"],
    "IGraphicsCaptureSession": ["814e42a9-f70f-4ad7-939b-fddcc6eb880d"],
    "IGraphicsCaptureSession2": ["2c39ae40-7d2e-5044-804e-8b6799d4cf9e"],
    "IGraphicsCaptureSessionStatics": ["2224a540-5974-49aa-b232-0882536f4cb5"],
    "IGraphicsEffect": ["cb51c0ce-8fe6-4636-b202-861faa07d8f3"],
    "IGraphicsEffectSource": ["2d8f9ddc-4339-4eb9-9216-f9deb75658a2"],
    "IGravityConnectedAnimationConfiguration": ["c751a4b7-0459-5142-b891-aeaac1d41822"],
    "IGravityConnectedAnimationConfiguration2": ["62333add-aed4-5fed-95ff-d128acce8be4"],
    "IGravityConnectedAnimationConfigurationFactory": ["e822c41f-3656-5090-92f5-c217eaacb682"],
    "IGrfCache": ["ae9472be-b0c3-11d2-8d24-00a0c9441e20"],
    "IGrid": ["fd104460-2e15-4ba3-8b8f-fa693a4161e9"],
    "IGrid2": ["f76efa41-380e-45db-be87-9e1326ba4b57"],
    "IGrid3": ["12dfc5fc-2342-4dd2-9e7d-2090a171d1ef"],
    "IGrid4": ["ed02d274-81f1-5ac2-a0c3-bbdaf5a3ffee"],
    "IGridFactory": ["ae814041-c531-43b4-bf99-12f506f7b01c"],
    "IGridItemPatternIdentifiers": ["757744f1-3285-4fb1-803b-2545bd431599"],
    "IGridItemPatternIdentifiersStatics": ["217d2402-5e46-4d61-8794-b8ee8e774714"],
    "IGridItemProvider": ["d02541f1-fb81-4d64-ae32-f520f8a6dbd1", "fff3683c-7407-45bb-a936-df3ed6d3837d"],
    "IGridLengthHelper": ["7a826ce1-07a0-4083-b6d1-b1d917b976ac"],
    "IGridLengthHelperStatics": ["9d457b9b-019f-4266-8872-215f198f6a9d"],
    "IGridPatternIdentifiers": ["c902980f-96c5-450c-9044-7e52c24f9e94"],
    "IGridPatternIdentifiersStatics": ["7bc452f3-a181-4137-8de9-1f9b1a8320ed"],
    "IGridProvider": ["8b62b7a0-932c-4490-9a13-02fdb39a8f5b", "b17d6187-0907-464b-a168-0ef17a1572b1"],
    "IGridStatics": ["64fe2e9f-f951-42b6-a9ce-bb179af11595"],
    "IGridStatics2": ["2d666658-58b6-4a1b-841b-875ba93b5d6a"],
    "IGridStatics3": ["c3fba437-5a0c-407a-9621-79545386d811"],
    "IGridStatics4": ["691af349-1f63-57aa-8726-9cdcc1b14c02"],
    "IGridView": ["026ae934-b67e-4d80-8f72-8aa64b4d827b"],
    "IGridViewAutomationPeer": ["1c4401a4-d951-49ca-8f82-c7f3c60681b0"],
    "IGridViewAutomationPeerFactory": ["8aca59dd-22a7-4800-894b-c1f485f38953"],
    "IGridViewFactory": ["d9bcca89-09f9-4c6e-a83e-f199146f0e7d"],
    "IGridViewHeaderItem": ["72d75d7e-5dc3-4ffc-9b1c-939b5c37161c"],
    "IGridViewHeaderItemAutomationPeer": ["e3dcef3a-e08a-48e7-b23a-2be5b66e474e"],
    "IGridViewHeaderItemAutomationPeerFactory": ["2c80b4d2-ffc2-4157-88dd-59cd92e39715"],
    "IGridViewHeaderItemFactory": ["36e0c96e-b56a-4b3b-8bac-7aef5e6f9945"],
    "IGridViewItem": ["7d9901f1-e7c1-4e83-b470-c9d6d7bda9f5"],
    "IGridViewItemAutomationPeer": ["93ef2d07-346c-4166-a4ba-bc6a181e7f33"],
    "IGridViewItemAutomationPeerFactory": ["fafec376-f22e-466d-913c-ae24ccdb160f"],
    "IGridViewItemDataAutomationPeer": ["f3f4868f-29d4-4094-8c54-ea61a88294a4"],
    "IGridViewItemDataAutomationPeerFactory": ["a65e7a88-770d-402c-996f-67506af2a4af"],
    "IGridViewItemFactory": ["229b00af-3fa6-43e9-979d-07ea0d6280dc"],
    "IGridViewItemPresenter": ["214f9010-56e2-4821-8a1c-2305709af94b"],
    "IGridViewItemPresenterFactory": ["53c12178-63bb-4a65-a3f1-ab114cfc6ffe"],
    "IGridViewItemPresenterStatics": ["e958f8c4-277e-4a72-a01e-9e1688980178"],
    "IGridViewItemTemplateSettings": ["9e30baaf-165d-4267-a45e-1a43a75706ac"],
    "IGripperHost": ["7b684b1a-3563-4ebe-b541-f2a1d4e85a9f"],
    "IGripperHost2": ["9afb662d-c536-42d5-9a82-638d5f4c23ec"],
    "IGroupItem": ["4ae8d5d1-7228-4a16-a61f-88c0e8f45c76"],
    "IGroupItemAutomationPeer": ["1914fe6d-0740-4236-9ee1-38cf19c1c388"],
    "IGroupItemAutomationPeerFactory": ["56a64567-f21c-4c90-b379-15a27c7f8409"],
    "IGroupItemFactory": ["d9a1d53e-b1e0-4319-9808-7a9e887e13b0"],
    "IGroupPolicyObject": ["ea502723-a23d-11d1-a7d3-0000f87571e3"],
    "IGroupStyle": ["71ca300b-b89e-4184-b0df-a9e95447de8d"],
    "IGroupStyle2": ["69f90679-3a11-4fe7-b4df-2a0139d4018b"],
    "IGroupStyleFactory": ["56ff664f-e2d7-4f49-803d-c727cdf9372d"],
    "IGroupStyleSelector": ["6dda119e-9a74-478f-a339-5bb52de6c51e"],
    "IGroupStyleSelectorFactory": ["bf570d33-b2f6-481f-a450-c80c291fb22d"],
    "IGroupStyleSelectorOverrides": ["f691cab2-77ad-4d3d-a51c-8ef9c3836456"],
    "IGuardableStream": ["dd62ff99-d359-4b64-9ba1-b8d01dc351d2"],
    "IGuidCollection": ["a22f4113-46d1-478f-ab7e-e66f319ad46f"],
    "IGuidHelperStatics": ["59c7966b-ae52-5283-ad7f-a1b9e9678add"],
    "IGuidanceAudioNotificationRequestedEventArgs": ["ca2aa24a-c7c2-4d4c-9d7c-499576bceddb"],
    "IGuidanceLaneInfo": ["8404d114-6581-43b7-ac15-c9079bf90df1"],
    "IGuidanceManeuver": ["fc09326c-ecc9-4928-a2a1-7232b99b94a1"],
    "IGuidanceMapMatchedCoordinate": ["b7acb168-2912-4a99-aff1-798609b981fe"],
    "IGuidanceNavigator": ["08f17ef7-8e3f-4d9a-be8a-108f9a012c67"],
    "IGuidanceNavigator2": ["6cdc50d1-041c-4bf3-b633-a101fc2f6b57"],
    "IGuidanceNavigatorStatics": ["00fd9513-4456-4e66-a143-3add6be08426"],
    "IGuidanceNavigatorStatics2": ["54c5c3e2-7784-4c85-8c95-d0c6efb43965"],
    "IGuidanceReroutedEventArgs": ["115d4008-d528-454e-bb94-a50341d2c9f1"],
    "IGuidanceRoadSegment": ["b32758a6-be78-4c63-afe7-6c2957479b3e"],
    "IGuidanceRoadSegment2": ["2474a61d-1723-49f1-895b-47a2c4aa9c55"],
    "IGuidanceRoadSignpost": ["f1a728b6-f77a-4742-8312-53300f9845f0"],
    "IGuidanceRoute": ["3a14545d-801a-40bd-a286-afb2010cce6c"],
    "IGuidanceRouteStatics": ["f56d926a-55ed-49c1-b09c-4b8223b50db3"],
    "IGuidanceTelemetryCollector": ["db1f8da5-b878-4d92-98dd-347d23d38262"],
    "IGuidanceTelemetryCollectorStatics": ["36532047-f160-44fb-b578-94577ca05990"],
    "IGuidanceUpdatedEventArgs": ["fdac160b-9e8d-4de3-a9fa-b06321d18db9"],
    "IGuideData": ["61571138-5b01-43cd-aeaf-60b784a0bf93"],
    "IGuideDataEvent": ["efda0c80-f395-42c3-9b3c-56b37dec7bb7"],
    "IGuideDataLoader": ["4764ff7c-fa95-4525-af4d-d32236db9e38"],
    "IGuideDataProperty": ["88ec5e58-bb73-41d6-99ce-66c524b8b591"],
    "IGyrometer": ["fdb9a9c4-84b1-4ca2-9763-9b589506c70c"],
    "IGyrometer2": ["63df2443-8ce8-41c3-ac44-8698810b557f"],
    "IGyrometer3": ["5d6f88d5-8fbc-4484-914b-528adfd947b1"],
    "IGyrometer4": ["0628a60c-4c4b-5096-94e6-c356df68bef7"],
    "IGyrometerDataThreshold": ["8648b31e-6e52-5259-bbad-242a69dc38c8"],
    "IGyrometerDeviceId": ["1ee5e978-89a2-4275-9e95-7126f4708760"],
    "IGyrometerReading": ["b3d6de5c-1ee4-456f-9de7-e2493b5c8e03"],
    "IGyrometerReading2": ["16afe13c-2b89-44bb-822b-d1e1556ff09b"],
    "IGyrometerReadingChangedEventArgs": ["0fdf1895-6f9e-42ce-8d58-388c0ab8356d"],
    "IGyrometerStatics": ["83b6e7c9-e49d-4b39-86e6-cd554be4c5c1"],
    "IGyrometerStatics2": ["ef83f7a1-d700-4204-9613-79c6b161df4e"],
    "IH264ProfileIdsStatics": ["38654ca7-846a-4f97-a2e5-c3a15bbf70fd"],
    "IHCAction": ["e90aad8b-7f0c-480d-b33e-16779c4cf59d"],
    "IHCCheck": ["fae9ce59-7621-4208-8bc3-2acecd58fed2"],
    "IHCCheckCollection": ["db62c52c-dbae-476c-aeac-fa9966e85326"],
    "IHCCheckInternalP": ["0cc6fe25-a88b-480d-956a-a9a20bd2c65a"],
    "IHCCheckProvider": ["418ee892-56f0-4c3b-9238-696ba0cef799"],
    "IHCCommand": ["3d2eafc0-96d0-4925-9f7d-ff80b168f243"],
    "IHCCommandCollection": ["58d879fe-5b40-46aa-ab68-d146ff6a68a0"],
    "IHCDescriptionAndIcon": ["7cbc33db-7a53-45c3-a0cc-610292bd7b9e"],
    "IHCIconP": ["014a1425-828b-482a-a386-5763b23531c3"],
    "IHCNotification": ["8025d477-47d3-449c-9350-c676140ee829"],
    "IHCNotificationCollection": ["1cf5e433-3cf8-498e-8b5a-f47e23200e07"],
    "IHCNotificationInternalP": ["8db6ae56-7ea1-421c-9c22-d3247c12c6c4"],
    "IHCNotificationManager": ["01afc156-f2eb-4c1c-a722-8550417d396f"],
    "IHCNotificationManagerEventsP": ["0acabbb8-8f37-4605-9d41-eec1c33eeb95"],
    "IHCNotificationManagerP": ["b066dde3-445d-45dc-bf2a-bc7baa74c5c5"],
    "IHCObjectWithCanonicalName": ["824f0d64-069c-4383-9107-f18fc40c3ca6"],
    "IHCStatus": ["b387c51b-7fe4-4252-8cd4-585592b4dc7e"],
    "IHTML5AttributeSelectorCI": ["30510767-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLAnchorElement3": ["3051041d-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLApplicationCache": ["30510828-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLAreaElement2": ["3051041f-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLAreasCollection4": ["30510492-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLAttributeCollection3": ["30510469-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLAttributeCollection4": ["305106fa-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLAudioElement": ["30510708-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLAudioElementFactory": ["305107eb-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLBaseElement2": ["30510420-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLBlockElement3": ["30510494-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLBodyElement3": ["30510422-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLBodyElement4": ["30510795-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLBodyElement5": ["30510822-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLButtonElement2": ["305106f3-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLCSSImportRule": ["305106ea-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLCSSMediaList": ["30510731-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLCSSMediaRule": ["305106eb-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLCSSNamespaceRule": ["305106ee-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLCSSRule": ["305106e9-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLCSSStyleDeclaration": ["30510740-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLCSSStyleDeclaration2": ["305107d1-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLCSSStyleDeclaration3": ["3051085c-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLCSSStyleDeclaration4": ["d6100f3b-27c8-4132-afea-f0e4b1e00060"],
    "IHTMLCanvasElement": ["305106e4-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLCommentElement3": ["3051073f-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLCurrentStyle4": ["3050f33b-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLCurrentStyle5": ["30510481-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLDOMAttribute3": ["30510468-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLDOMAttribute4": ["305106f9-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLDOMChildrenCollection2": ["30510791-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLDOMConstructor": ["3051049b-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLDOMConstructorCollection": ["3051049c-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLDOMImplementation2": ["3051073c-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLDOMNode3": ["305106e0-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLDOMRange": ["305104ae-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLDOMTextNode3": ["3051073e-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLDocument6": ["30510417-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLDocument7": ["305104b8-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLDocument8": ["305107d0-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLDocumentCompatibleInfo": ["3051041a-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLDocumentCompatibleInfoCollection": ["30510418-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLEditorPrivate": ["e9ee444d-1d03-41be-ba81-3a9a3539835f"],
    "IHTMLEditorViewManager": ["53a2d5b0-d2fc-11d0-84e0-006097c9987d"],
    "IHTMLElemCtxStream": ["85da4432-40ba-4221-8ca0-730b85e615ae"],
    "IHTMLElement5": ["3051045d-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLElement6": ["305106f8-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLElement7": ["305107aa-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLElementAppliedStyles": ["305104bd-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLElementCollection4": ["30510425-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLElementDynamicCrawlerExt": ["f39d947b-30a0-4974-90e0-a6f10c3318b5"],
    "IHTMLEmbedElement2": ["30510493-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLEventObj5": ["30510478-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLEventObj6": ["30510734-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLFormElement4": ["3051042c-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLFrameElement3": ["3051042d-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLFrameSetElement3": ["30510796-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLHeadElement2": ["3051042f-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLIFrameElement3": ["30510433-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLImgElement3": ["30510434-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLImgElement4": ["305107f6-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLInputElement3": ["30510435-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLInputRangeElement": ["3050f2d4-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLInputTextElement2": ["3050f2d2-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLLinkElement4": ["3051043a-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLLinkElement5": ["30510726-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLMSCSSKeyframeRule": ["3051080c-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLMSCSSKeyframesRule": ["3051080d-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLMSImgElement": ["30510793-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLMSMediaElement": ["30510792-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLMediaElement": ["30510706-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLMediaElement2": ["30510809-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLMediaElementPrivate": ["44dc7214-50f9-485d-8187-0480a06aab66"],
    "IHTMLMediaError": ["30510704-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLMetaElement3": ["30510495-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLObjectElement4": ["3051043e-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLObjectElement5": ["305104b5-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLOptionElement4": ["305107b4-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLPaintSitePriv": ["372978fb-b349-4d03-a4ff-85b83de3ce06"],
    "IHTMLPainterDispSurface": ["667a4437-dfdc-45ea-b713-d22667f9ab63"],
    "IHTMLParamElement2": ["30510444-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLPerformance": ["3051074e-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLPerformanceNavigation": ["30510750-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLPerformanceTiming": ["30510752-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLPhraseElement3": ["3051043d-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLPlayToPrivate": ["56f69a1a-5a67-4590-9bdf-ed1a4c4ed651"],
    "IHTMLPlayToPrivate2": ["0b06c8ca-867a-4c1a-adf4-bfb3c192b501"],
    "IHTMLPrivateCanvasElement": ["3051085b-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLPrivateDocument": ["305106f5-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLPrivateDocument2": ["30510733-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLPrivateDocument3": ["30510862-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLPrivateDocument4": ["30510835-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLPrivateInputElement": ["6a8ea653-6278-47be-82f6-20d4823f3449"],
    "IHTMLPrivateWindow4": ["30510836-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLPrivateWindow5": ["3051083d-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLPrivateWindow6": ["c1c89ad8-11a3-45a1-a26e-689f3f5add5a"],
    "IHTMLPrivateWindowAccessible": ["3051085e-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLPrivateXMLHttpRequest": ["f7283e06-d006-4376-81d9-88cd3457c774"],
    "IHTMLProgressElement": ["3050f2d6-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLRect2": ["3051076c-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLRuleStyle5": ["3050f335-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLRuleStyle6": ["30510471-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLScreen3": ["305104a1-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLScreen4": ["3051076b-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLScriptElement3": ["30510447-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLScriptElement4": ["30510801-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLSelectElement5": ["3051049d-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLSelectElement6": ["30510760-98b6-11cf-bb82-00aa00bdce0b"],
    "IHTMLSelectElementEx": ["3050f2d1-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLSourceElement": ["30510707-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLStorage": ["30510474-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLStorage2": ["30510799-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLStyle5": ["3050f33a-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLStyle6": ["30510480-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLStyleElement2": ["3051072a-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLStyleEnabled": ["305104c2-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLStyleFontFace2": ["305106ec-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLStyleMedia": ["3051074b-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLStyleSheet3": ["30510496-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLStyleSheet4": ["305106f4-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLStyleSheetPage2": ["305106ed-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLStyleSheetPagePrivate": ["305104a7-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLStyleSheetRule2": ["305106fd-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLStyleSheetRuleApplied": ["305104c1-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLStyleSheetRulePriv": ["3051049f-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLStyleSheetRulesAppliedCollection": ["305104c0-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLStyleSheetRulesCollection2": ["305106e8-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLStyleSheetsCollection2": ["305106e7-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLTable4": ["305106c2-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLTableCell3": ["305106c7-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLTableCol3": ["305106c4-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLTableRow4": ["305106c6-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLTableSection4": ["305106c5-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLTextAreaElement2": ["3050f2d3-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLTimeRanges": ["30510705-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLTimeRanges2": ["3051080b-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLTxtRangeInternal": ["305107c4-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLVideoElement": ["30510709-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLWindow5": ["3051040e-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLWindow6": ["30510453-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLWindow7": ["305104b7-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLWindow8": ["305107ab-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLWindowServicesBroker": ["806d58df-ee78-4630-9475-f9b337a2dfcb"],
    "IHTMLXDomainRequest": ["30510454-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLXDomainRequestFactory": ["30510456-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLXMLHttpRequest": ["3051040a-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLXMLHttpRequest2": ["30510482-98b5-11cf-bb82-00aa00bdce0b"],
    "IHTMLXMLHttpRequestFactory": ["3051040c-98b5-11cf-bb82-00aa00bdce0b"],
    "IHWContainerEventHandler": ["ed7cc9ee-2c17-4912-8fa0-e3ce911e225d"],
    "IHWDeviceCustomProperties": ["77d5d69c-d6ce-4026-b625-26964eec733f"],
    "IHWEventHandler2": ["cfcc809f-295d-42e8-9ffc-424b33c487e6"],
    "IHandMeshObserver": ["85ae30cb-6fc3-55c4-a7b4-29e33896ca69"],
    "IHandMeshVertexState": ["046c5fef-1d8b-55de-ab2c-1cd424886d8f"],
    "IHandPose": ["4d98e79a-bb08-5d09-91de-df0dd3fae46c"],
    "IHandleCloudChangeNotification": ["f3965cb9-a6da-45aa-845b-0b1cb0121820"],
    "IHandleDuplicator": ["24a0bf18-6849-4d99-9fc8-48bcabace467"],
    "IHandlerActivationHost": ["35094a87-8bb1-4237-96c6-c417eebdb078"],
    "IHandlerAsset": ["7629162a-c94d-4f88-8ad4-537c65756c16"],
    "IHandlerAssetCollection": ["7d9c497e-4b9d-444d-85c6-1f1190ade7c3"],
    "IHandlerInfo": ["997706ef-f880-453b-8118-39e1a2d2655a"],
    "IHandlerInfo2": ["31cca04c-04d3-4ea9-90de-97b15e87a532"],
    "IHandwritingPanelClosedEventArgs": ["4fb91c73-192d-4dd2-a1a2-80ed01125876"],
    "IHandwritingPanelOpenedEventArgs": ["fc15b16d-9f15-47b0-b97a-94a68cc61345"],
    "IHandwritingView": ["c44204a7-31e0-44bc-a38b-4bee64ecd99f"],
    "IHandwritingViewFactory": ["e00c873f-0012-475c-890c-97ae308642de"],
    "IHandwritingViewStatics": ["bb7ceed0-cc5f-4004-b8c8-142e195f0618"],
    "IHandwrittenTextInsertion": ["56fdea97-ecd6-43e7-aa3a-816be7785860"],
    "IHardwareAudioEngineBase": ["eddce3e4-f3c1-453a-b461-223563cbd886"],
    "IHardwareDevices": ["3b0f86b5-8113-439d-b2a3-2766c839d073"],
    "IHardwareDevicesEnum": ["553a4a55-681c-440e-b109-597b9219cfb2"],
    "IHardwareDevicesMountPointsEnum": ["ee93d145-9b4e-480c-8385-1e8119a6f7b2"],
    "IHardwareDevicesVolumesEnum": ["1c0eb79b-2cde-44ec-bb35-fc471024c13c"],
    "IHardwareIdentificationStatics": ["971260e0-f170-4a42-bd55-a900b212dae2"],
    "IHardwareToken": ["28f6d4c0-fb12-40a4-8167-7f4e03d2724c"],
    "IHashAlgorithmNamesStatics": ["6b5e0516-de96-4f0a-8d57-dcc9dae36c76"],
    "IHashAlgorithmProvider": ["be9b3080-b2c3-422b-bce1-ec90efb5d7b5"],
    "IHashAlgorithmProviderStatics": ["9fac9741-5cc4-4336-ae38-6212b75a915a"],
    "IHashComputation": ["5904d1b6-ad31-4603-a3a4-b1bda98e2562"],
    "IHdcpSession": ["718845e9-64d7-426d-809b-1be461941a2a"],
    "IHdmiDisplayInformation": ["130b3c0a-f565-476e-abd5-ea05aee74c69"],
    "IHdmiDisplayInformationStatics": ["6ce6b260-f42a-4a15-914c-7b8e2a5a65df"],
    "IHdmiDisplayMode": ["0c06d5ad-1b90-4f51-9981-ef5a1c0ddf66"],
    "IHdmiDisplayMode2": ["07cd4e9f-4b3c-42b8-84e7-895368718af2"],
    "IHdrVideoControl": ["55d8e2d0-30c0-43bf-9b9a-9799d70ced94"],
    "IHeadPose": ["7f5ac5a5-49db-379f-9429-32a2faf34fa6"],
    "IHeaderFooter2": ["305104a5-98b5-11cf-bb82-00aa00bdce0b"],
    "IHeadset": ["3fd156ef-6925-3fa8-9181-029c5223ae3b"],
    "IHidBooleanControl": ["524df48a-3695-408c-bba2-e2eb5abfbc20"],
    "IHidBooleanControlDescription": ["6196e543-29d8-4a2a-8683-849e207bbe31"],
    "IHidBooleanControlDescription2": ["c8eed2ea-8a77-4c36-aa00-5ff0449d3e73"],
    "IHidCollection": ["7189f5a3-32f1-46e3-befd-44d2663b7e6a"],
    "IHidDevice": ["5f8a14e7-2200-432e-95da-d09b87d574a8"],
    "IHidDeviceStatics": ["9e5981e4-9856-418c-9f73-77de0cd85754"],
    "IHidFeatureReport": ["841d9b79-5ae5-46e3-82ef-1fec5c8942f4"],
    "IHidGameControllerInputSink": ["f754c322-182d-40e4-a126-fcee4ffa1e31"],
    "IHidGameControllerProvider": ["95ce3af4-abf0-4b68-a081-3b7de73ff0e7"],
    "IHidInputReport": ["c35d0e50-f7e7-4e8d-b23e-cabbe56b90e9"],
    "IHidInputReportReceivedEventArgs": ["7059c5cb-59b2-4dc2-985c-0adc6136fa2d"],
    "IHidNumericControl": ["e38a12a5-35a7-4b75-89c8-fb1f28b10823"],
    "IHidNumericControlDescription": ["638d5e86-1d97-4c75-927f-5ff58ba05e32"],
    "IHidOutputReport": ["62cb2544-c896-4463-93c1-df9db053c450"],
    "IHighDynamicRangeControl": ["55f1a7ae-d957-4dc9-9d1c-8553a82a7d99"],
    "IHighDynamicRangeOutput": ["0f57806b-253b-4119-bb40-3a90e51384f7"],
    "IHighlightRenderingServicesPriv": ["3051049e-98b5-11cf-bb82-00aa00bdce0b"],
    "IHingeAngleReading": ["a3cd45b9-1bf1-4f65-a704-e2da04f182c0"],
    "IHingeAngleSensor": ["e9d3be02-bfdf-437f-8c29-88c77393d309"],
    "IHingeAngleSensorReadingChangedEventArgs": ["24d9558b-fad0-42b8-a854-78923049a1ba"],
    "IHingeAngleSensorStatics": ["b7b63910-fbb1-4123-89ce-4ea34eb0dfca"],
    "IHist": ["06faeb04-191c-11d3-9573-00c04fa31a86"],
    "IHlinkSource": ["79eac9c4-baf9-11ce-8c82-00aa004ba90b"],
    "IHolderDriver": ["bf6a1851-2b45-11cf-be10-00aa00a2fa25"],
    "IHoldingEventArgs": ["2bf755c5-e799-41b4-bb40-242f40959b71"],
    "IHoldingEventArgs2": ["141da9ea-4c79-5674-afea-493fdeb91f19"],
    "IHoldingEventHandler": ["ecae8ccd-8e5e-4fbe-9846-30a6370afcdf"],
    "IHoldingRoutedEventArgs": ["c246ff23-d80d-44de-8db9-0d815e269ac0"],
    "IHolographicApplicationPreviewStatics": ["fe038691-2a3a-45a9-a208-7bed691919f3"],
    "IHolographicCamera": ["e4e98445-9bed-4980-9ba0-e87680d1cb74"],
    "IHolographicCamera2": ["b55b9f1a-ba8c-4f84-ad79-2e7e1e2450f3"],
    "IHolographicCamera3": ["45aa4fb3-7b59-524e-4a3f-4a6ad6650477"],
    "IHolographicCamera4": ["9a2531d6-4723-4f39-a9a5-9d05181d9b44"],
    "IHolographicCamera5": ["229706f2-628d-4ef5-9c08-a63fdd7787c6"],
    "IHolographicCamera6": ["0209194f-632d-5154-ab52-0b5d15b12505"],
    "IHolographicCameraInterop": ["7cc1f9c5-6d02-41fa-9500-e1809eb48eec"],
    "IHolographicCameraPose": ["0d7d7e30-12de-45bd-912b-c7f6561599d1"],
    "IHolographicCameraPose2": ["232be073-5d2d-4560-814e-2697c4fce16b"],
    "IHolographicCameraRenderingParameters": ["8eac2ed1-5bf4-4e16-8236-ae0800c11d0d"],
    "IHolographicCameraRenderingParameters2": ["261270e3-b696-4634-94d6-be0681643599"],
    "IHolographicCameraRenderingParameters3": ["b1aa513f-136d-4b06-b9d4-e4b914cd0683"],
    "IHolographicCameraRenderingParametersInterop": ["f75b68d6-d1fd-4707-aafd-fa6f4c0e3bf4"],
    "IHolographicCameraViewportParameters": ["80cdf3f7-842a-41e1-93ed-5692ab1fbb10"],
    "IHolographicDesktopViewBroker": ["63713e6e-7503-4369-bfc4-1d1cd78e4931"],
    "IHolographicDisplay": ["9acea414-1d9f-4090-a388-90c06f6eae9c"],
    "IHolographicDisplay2": ["75ac3f82-e755-436c-8d96-4d32d131473e"],
    "IHolographicDisplay3": ["fc4c6ac6-6480-5008-b29e-157d77c843f7"],
    "IHolographicDisplayStatics": ["cb374983-e7b0-4841-8355-3ae5b536e9a4"],
    "IHolographicFrame": ["c6988eb6-a8b9-3054-a6eb-d624b6536375"],
    "IHolographicFrame2": ["283f37bf-3bf2-5e91-6633-870574e6f217"],
    "IHolographicFrame3": ["e5e964c9-8a27-55d3-9f98-94530d369052"],
    "IHolographicFramePrediction": ["520f4de1-5c0a-4e79-a81e-6abe02bb2739"],
    "IHolographicFramePresentationMonitor": ["ca87256c-6fae-428e-bb83-25dfee51136b"],
    "IHolographicFramePresentationReport": ["80baf614-f2f4-4c8a-8de3-065c78f6d5de"],
    "IHolographicFrameRenderingReport": ["05f32de4-e384-51b3-b934-f0d3a0f78606"],
    "IHolographicFrameScanoutMonitor": ["7e83efa9-843c-5401-8095-9bc1b8b08638"],
    "IHolographicFrameScanoutReport": ["0ebbe606-03a0-5ca0-b46e-bba068d7233f"],
    "IHolographicKeyboardPlacementOverridePreview": ["c8a8ce3a-dfde-5a14-8d5f-182c526dd9c4"],
    "IHolographicKeyboardPlacementOverridePreviewStatics": ["202e6039-1ff6-5a06-aac4-a5e24fa3ec4b"],
    "IHolographicQuadLayer": ["903460c9-c9d9-5d5c-41ac-a2d5ab0fd331"],
    "IHolographicQuadLayerFactory": ["a67538f3-5a14-5a10-489a-455065b37b76"],
    "IHolographicQuadLayerInterop": ["cfa688f0-639e-4a47-83d7-6b7f5ebf7fed"],
    "IHolographicQuadLayerUpdateParameters": ["2b0ea3b0-798d-5bca-55c2-2c0c762ebb08"],
    "IHolographicQuadLayerUpdateParameters2": ["4f33d32d-82c1-46c1-8980-3cb70d98182b"],
    "IHolographicQuadLayerUpdateParametersInterop": ["e5f549cd-c909-444f-8809-7cc18a9c8920"],
    "IHolographicSpace": ["4380dba6-5e78-434f-807c-3433d1efe8b7"],
    "IHolographicSpace2": ["4f81a9a8-b7ff-4883-9827-7d677287ea70"],
    "IHolographicSpace3": ["df1733d1-f224-587e-8d71-1e8fc8f07b1f"],
    "IHolographicSpaceCameraAddedEventArgs": ["58f1da35-bbb3-3c8f-993d-6c80e7feb99f"],
    "IHolographicSpaceCameraRemovedEventArgs": ["805444a8-f2ae-322e-8da9-836a0a95a4c1"],
    "IHolographicSpaceInterop": ["5c4ee536-6a98-4b86-a170-587013d6fd4b"],
    "IHolographicSpaceStatics": ["364e6064-c8f2-3ba1-8391-66b8489e67fd"],
    "IHolographicSpaceStatics2": ["0e777088-75fc-48af-8758-0652f6f07c59"],
    "IHolographicSpaceStatics3": ["3b00de3d-b1a3-4dfe-8e79-fec5909e6df8"],
    "IHolographicViewConfiguration": ["5c1de6e6-67e9-5004-b02c-67a3a122b576"],
    "IHolographicViewManager": ["538317c5-5bad-4847-962d-42da294f5e0a"],
    "IHolographicViewTransitionNotification": ["76bb2cfb-c246-41ec-b9c3-671e5347cf51"],
    "IHolographicViewTransitionNotificationService": ["5090de35-ed23-43be-9714-586c5041026a"],
    "IHomeGroup": ["7a3bd1d9-35a9-4fb3-a467-f48cac35e2d0"],
    "IHomeGroupAdvise": ["3d169692-8af5-489f-bb02-faa22d08d824"],
    "IHomeGroupAutoCreateJoin": ["31abd3e1-5ec3-4056-9e80-ec591dc302af"],
    "IHomeGroupCollection": ["c042fb2f-bc74-4636-95b1-2bbe308f7391"],
    "IHomeGroupComponentList": ["3a6dd474-de86-4b4a-b44f-ae9aa8ff432c"],
    "IHomeGroupCplUpdate": ["2edfba4a-2ec9-4b2e-b133-40624a784bec"],
    "IHomeGroupCtrl": ["9642ab2b-2198-4234-8f68-c3f55e5e9247"],
    "IHomeGroupDesktopNotify": ["2fadc3ab-778a-4fce-a62a-05249965e62d"],
    "IHomeGroupDevice": ["2be10a43-bf34-4cc0-b172-3c16761c4384"],
    "IHomeGroupEncryption": ["b852dd46-c3e4-493b-8cd2-a9b3a9f0ff08"],
    "IHomeGroupFunctionDiscoveryQuery": ["e64ffd21-0b4e-4883-a13a-0e23d67549dd"],
    "IHomeGroupInitialize": ["d75646d9-47c4-4b4f-99b8-dacac8401713"],
    "IHomeGroupListener": ["010d0200-d513-4a39-adc7-db57f22b7490"],
    "IHomeGroupListenerManager": ["127592fb-9caf-4411-bd99-a62b924a5d39"],
    "IHomeGroupListenerNotify": ["44bcca94-fd00-4782-8068-847e18ed552d"],
    "IHomeGroupListenerNotifyPriv": ["98ed7fd0-a34a-4d79-a226-e442e7d1d452"],
    "IHomeGroupListenerSCMStatus": ["a84ce57c-1543-478e-b08b-b9c5d31c7240"],
    "IHomeGroupNetwork": ["c8b8b7c0-d585-43e4-a665-fe817bfdf561"],
    "IHomeGroupNetworkCallback": ["ff321dfb-7148-440d-bec4-bcd1f9773ca8"],
    "IHomeGroupPassword": ["06f5ad81-ac49-4557-b4a5-d7e9013329fc"],
    "IHomeGroupPeerManager": ["1991896f-9051-4be3-ba23-137d546edb46"],
    "IHomeGroupPrinterMonitor": ["389153ab-ea42-457f-9704-7ab979c9ef93"],
    "IHomeGroupPrinting": ["e4a31a22-8ad1-419e-ad99-8fabc096dd8a"],
    "IHomeGroupProvider": ["3c61788c-049e-4d13-b510-3acf82f039ee"],
    "IHomeGroupProviderInternal": ["d70b1f16-f0a1-485c-8233-f22ea411667d"],
    "IHomeGroupProviderPriv": ["1ee6d6ce-eb8b-4798-a744-89b724cef2a9"],
    "IHomeGroupProviderServiceDiagnostics": ["e04ed95d-11f8-48d6-973d-f88520dbcbb0"],
    "IHomeGroupRoamedPassword": ["58ebeb65-1e40-40d1-8f59-5130dabc8078"],
    "IHomeGroupSharing": ["30f1c3e8-3f53-47f0-a3f9-26f29a7e3be7"],
    "IHomeGroupState": ["844a53b1-a097-4d62-b58d-d3bb3b4a5dba"],
    "IHomeGroupStateInternal": ["242bf39b-b552-4e1a-be75-7c6a45dccdb6"],
    "IHomeGroupStatus": ["b0a10e19-e52b-4038-bbf7-867e5e6a51fb"],
    "IHomeGroupUIStatus": ["4977ae38-6fa8-44cd-9773-6d5e2be74121"],
    "IHomeGroupUIStatusAdvise": ["4f286628-467d-42be-a332-d7e76cf6e990"],
    "IHomeGroupWizardUpdate": ["400dc7c6-0eb0-44c7-9764-7a1262caf66f"],
    "IHomePageProtector": ["96ab1e90-828c-4b09-9b4c-8ba0b0d9bc66"],
    "IHomePageSetting": ["fdfc244f-18fa-4ff2-b08e-1d618f3ffbe4"],
    "IHostAssemblyManager": ["613dabd7-62b2-493e-9e65-c1e32a1e0c5e"],
    "IHostAssemblyStore": ["7b102a88-3f7f-496d-8fa2-c35374e01af3"],
    "IHostAutoEvent": ["50b0cfce-4063-4278-9673-e5cb4ed0bdb8"],
    "IHostControl": ["02ca073c-7079-4860-880a-c2f7a449c991"],
    "IHostCrst": ["6df710a6-26a4-4a65-8cd5-7237b8bda8dc"],
    "IHostDataModelAccess": ["f2bce54e-4835-4f8a-836e-7981e29904d1"],
    "IHostGCManager": ["5d4ec34e-f248-457b-b603-255faaba0d21"],
    "IHostIdStore": ["d7a5d1cc-fcbc-4e54-9deb-45ef67293cf8"],
    "IHostIoCompletionManager": ["8bde9d80-ec06-41d6-83e6-22580effcc20"],
    "IHostMalloc": ["1831991c-cc53-4a31-b218-04e910446479"],
    "IHostManualEvent": ["1bf4ec38-affe-4fb9-85a6-525268f15b54"],
    "IHostMemoryManager": ["7bc698d1-f9e3-4460-9cde-d04248e9fa25"],
    "IHostMemoryNeededCallback": ["47eb8e57-0846-4546-af76-6f42fcfc2649"],
    "IHostName": ["bf8ecaad-ed96-49a7-9084-d416cae88dcb"],
    "IHostNameFactory": ["458c23ed-712f-4576-adf1-c20b2c643558"],
    "IHostNameStatics": ["f68cd4bf-a388-4e8b-91ea-54dd6dd901c0"],
    "IHostPolicyManager": ["7ae49844-b1e3-4683-ba7c-1e8212ea3b79"],
    "IHostSecurityContext": ["7e573ce4-0343-4423-98d7-6318348a1d3c"],
    "IHostSecurityManager": ["75ad2468-a349-4d02-a764-76a68aee0c4f"],
    "IHostSemaphore": ["855efd47-cc09-463a-a97d-16acab882661"],
    "IHostSyncManager": ["234330c7-5f10-4f20-9615-5122dab7a0ac"],
    "IHostTask": ["c2275828-c4b1-4b55-82c9-92135f74df1a"],
    "IHostTaskManager": ["997ff24c-43b7-4352-8667-0dc04fafd354"],
    "IHostThreadpoolManager": ["983d50e2-cb15-466b-80fc-845dc6e8c5fd"],
    "IHostedApplication": ["942d3eb0-58dc-4807-bee8-c49dfa7d1452"],
    "IHostedApplicationActivationManagerPrivateCallbacks": ["171fea36-96b5-4075-a9b5-b6ede42761bc"],
    "IHostedApplicationExperienceManager": ["cc33932d-0085-4311-8c4d-281aa6501442"],
    "IHostedApplicationNotification": ["1fc98738-e0bf-4cb2-9de2-20ab31b23ce4"],
    "IHostedApplicationTaskCompletion": ["e0664d9b-649c-4b08-91f1-f2d006cd668a"],
    "IHostedApplicationView": ["7b0b9bca-d006-4c7e-8d75-9fcd1c4a7644"],
    "IHostedViewClosingEventArgs": ["d238943c-b24e-4790-acb5-3e4243c4ff87"],
    "IHostedViewDeferClose": ["f9eb9c6d-5a6a-43c7-b0d1-82d3c81e33fc"],
    "IHotPlug": ["4d16bc13-22e4-4126-8cae-705a7a9dd787"],
    "IHotspotAuthEngine": ["fc5eeaf6-1001-11df-adb9-f4ce462d9137"],
    "IHotspotAuthEvents": ["fc5eeaf6-1002-11df-adb9-f4ce462d9137"],
    "IHotspotAuthExtension": ["fc5eeaf6-1005-11df-adb9-f4ce462d9137"],
    "IHotspotAuthLaunchHandler": ["fc5eeaf6-1003-11df-adb9-f4ce462d9137"],
    "IHotspotAuthLaunchStatus": ["fc5eeaf6-1004-11df-adb9-f4ce462d9137"],
    "IHotspotAuthenticationContext": ["e756c791-1003-4de5-83c7-de61d88831d0"],
    "IHotspotAuthenticationContext2": ["e756c791-1004-4de5-83c7-de61d88831d0"],
    "IHotspotAuthenticationContextStatics": ["e756c791-1002-4de5-83c7-de61d88831d0"],
    "IHotspotAuthenticationEventDetails": ["e756c791-1001-4de5-83c7-de61d88831d0"],
    "IHotspotCredentialsAuthenticationResult": ["e756c791-1005-4de5-83c7-de61d88831d0"],
    "IHtmlFormatHelperStatics": ["e22e7749-dd70-446f-aefc-61cee59f655e"],
    "IHtmlLocalFileResolver": ["882381c6-21f5-4299-ae9e-7f1bb75ed7d3"],
    "IHtmlPrintDocumentSource": ["cea6469a-0e05-467a-abc9-36ec1d4cdcb6"],
    "IHtmlUtilities": ["fec00add-2399-4fac-b5a7-05e9acd7181d"],
    "IHttpBaseProtocolFilter": ["71c89b09-e131-4b54-a53c-eb43ff37e9bb"],
    "IHttpBaseProtocolFilter2": ["2ec30013-9427-4900-a017-fa7da3b5c9ae"],
    "IHttpBaseProtocolFilter3": ["d43f4d4c-bd42-43ae-8717-ad2c8f4b2937"],
    "IHttpBaseProtocolFilter4": ["9fe36ccf-2983-4893-941f-eb518ca8cef9"],
    "IHttpBaseProtocolFilter5": ["416e4993-31e3-4816-bf09-e018ee8dc1f5"],
    "IHttpBaseProtocolFilterStatics": ["6d4dee0c-e908-494e-b5a3-1263c9b8242a"],
    "IHttpBufferContentFactory": ["bc20c193-c41f-4ff7-9123-6435736eadc2"],
    "IHttpCacheControl": ["c77e1cb4-3cea-4eb5-ac85-04e186e63ab7"],
    "IHttpCacheDirectiveHeaderValueCollection": ["9a586b89-d5d0-4fbe-bd9d-b5b3636811b4"],
    "IHttpChallengeHeaderValue": ["393361af-0f7d-4820-9fdd-a2b956eeaeab"],
    "IHttpChallengeHeaderValueCollection": ["ca9e5f81-aee0-4353-a10b-e625babd64c2"],
    "IHttpChallengeHeaderValueFactory": ["c452c451-d99c-40aa-9399-90eeb98fc613"],
    "IHttpChallengeHeaderValueStatics": ["f3d38a72-fc01-4d01-a008-fcb7c459d635"],
    "IHttpClient": ["7fda1151-3574-4880-a8ba-e6b1e0061f3d"],
    "IHttpClient2": ["cdd83348-e8b7-4cec-b1b0-dc455fe72c92"],
    "IHttpClientFactory": ["c30c4eca-e3fa-4f99-afb4-63cc65009462"],
    "IHttpConnectionOptionHeaderValue": ["cb4af27a-4e90-45eb-8dcd-fd1408f4c44f"],
    "IHttpConnectionOptionHeaderValueCollection": ["e4f56c1d-5142-4e00-8e0f-019509337629"],
    "IHttpConnectionOptionHeaderValueFactory": ["d93ccc1e-0b7d-4c3f-a58d-a2a1bdeabc0a"],
    "IHttpConnectionOptionHeaderValueStatics": ["aaa75d37-a946-4b1f-85af-48b68b3c50bd"],
    "IHttpContent": ["6b14a441-fba7-4bd2-af0a-839de7c295da"],
    "IHttpContentCodingHeaderValue": ["bcf7f92a-9376-4d85-bccc-9f4f9acab434"],
    "IHttpContentCodingHeaderValueCollection": ["7d221721-a6db-436e-8e83-91596192819c"],
    "IHttpContentCodingHeaderValueFactory": ["c53d2bd7-332b-4350-8510-2e67a2289a5a"],
    "IHttpContentCodingHeaderValueStatics": ["94d8602e-f9bf-42f7-aa46-ed272a41e212"],
    "IHttpContentCodingWithQualityHeaderValue": ["94531cd5-8b13-4d73-8651-f76b38f88495"],
    "IHttpContentCodingWithQualityHeaderValueCollection": ["7c0d753e-e899-4378-b5c8-412d820711cc"],
    "IHttpContentCodingWithQualityHeaderValueFactory": ["c45eee1a-c553-46fc-ade2-d75c1d53df7b"],
    "IHttpContentCodingWithQualityHeaderValueStatics": ["e8c9357c-8f89-4801-8e75-4c9abfc3de71"],
    "IHttpContentDispositionHeaderValue": ["f2a2eedc-2629-4b49-9908-96a168e9365e"],
    "IHttpContentDispositionHeaderValueFactory": ["9915bbc4-456c-4e81-8295-b2ab3cbcf545"],
    "IHttpContentDispositionHeaderValueStatics": ["29c56067-5a37-46e4-b074-c5177d69ca66"],
    "IHttpContentHeaderCollection": ["40612a44-47ae-4b7e-9124-69628b64aa18"],
    "IHttpContentRangeHeaderValue": ["04d967d3-a4f6-495c-9530-8579fcba8aa9"],
    "IHttpContentRangeHeaderValueFactory": ["3f5bd691-a03c-4456-9a6f-ef27ecd03cae"],
    "IHttpContentRangeHeaderValueStatics": ["80a346ca-174c-4fae-821c-134cd294aa38"],
    "IHttpCookie": ["1f5488e2-cc2d-4779-86a7-88f10687d249"],
    "IHttpCookieFactory": ["6a0585a9-931c-4cd1-a96d-c21701785c5f"],
    "IHttpCookieManager": ["7a431780-cd4f-4e57-a84a-5b0a53d6bb96"],
    "IHttpCookiePairHeaderValue": ["cbd46217-4b29-412b-bd90-b3d814ab8e1b"],
    "IHttpCookiePairHeaderValueCollection": ["f3f44350-581e-4ecc-9f59-e507d04f06e6"],
    "IHttpCookiePairHeaderValueFactory": ["635e326f-146f-4f56-aa21-2cb7d6d58b1e"],
    "IHttpCookiePairHeaderValueStatics": ["6e866d48-06af-4462-8158-99388d5dca81"],
    "IHttpCredentialsHeaderValue": ["c34cc3cb-542e-4177-a6c7-b674ce193fbf"],
    "IHttpCredentialsHeaderValueFactory": ["f21d9e91-4d1c-4182-bfd1-34470a62f950"],
    "IHttpCredentialsHeaderValueStatics": ["a69b2be6-ce8c-4443-a35a-1b727b131036"],
    "IHttpDateOrDeltaHeaderValue": ["eafcaa6a-c4dc-49e2-a27d-043adf5867a3"],
    "IHttpDateOrDeltaHeaderValueStatics": ["7c2659a8-6672-4e90-9a9a-f39766f7f576"],
    "IHttpDiagnosticProvider": ["bd811501-a056-4d39-b174-833b7b03b02c"],
    "IHttpDiagnosticProviderRequestResponseCompletedEventArgs": ["735f98ee-94f6-4532-b26e-61e1b1e4efd4"],
    "IHttpDiagnosticProviderRequestResponseTimestamps": ["e0afde10-55cf-4c01-91d4-a20557d849f0"],
    "IHttpDiagnosticProviderRequestSentEventArgs": ["3f5196d0-4c1f-4ebe-a57a-06930771c50d"],
    "IHttpDiagnosticProviderResponseReceivedEventArgs": ["a0a2566c-ab5f-4d66-bb2d-084cf41635d0"],
    "IHttpDiagnosticProviderStatics": ["5b824ec1-6a6c-47cc-afec-1e86bc26053b"],
    "IHttpDiagnosticSourceLocation": ["54a9d260-8860-423f-b6fa-d77716f647a7"],
    "IHttpExpectationHeaderValue": ["4ce585cd-3a99-43af-a2e6-ec232fea9658"],
    "IHttpExpectationHeaderValueCollection": ["e78521b3-a0e2-4ac4-9e66-79706cb9fd58"],
    "IHttpExpectationHeaderValueFactory": ["4ea275cb-d53e-4868-8856-1e21a5030dc0"],
    "IHttpExpectationHeaderValueStatics": ["3019abe2-cfe5-473b-a57f-fba5b14eb257"],
    "IHttpFilter": ["a4cb6dd5-0902-439e-bfd7-e12552b165ce"],
    "IHttpFormUrlEncodedContentFactory": ["43f0138c-2f73-4302-b5f3-eae9238a5e01"],
    "IHttpGetBufferResult": ["53d08e7c-e209-404e-9a49-742d8236fd3a"],
    "IHttpGetInputStreamResult": ["d5d63463-13aa-4ee0-be95-a0c39fe91203"],
    "IHttpGetStringResult": ["9bac466d-8509-4775-b16d-8953f47a7f5f"],
    "IHttpLanguageHeaderValueCollection": ["9ebd7ca3-8219-44f6-9902-8c56dfd3340c"],
    "IHttpLanguageRangeWithQualityHeaderValue": ["7256e102-0080-4db4-a083-7de7b2e5ba4c"],
    "IHttpLanguageRangeWithQualityHeaderValueCollection": ["885d5abd-4b4f-480a-89ce-8aedcee6e3a0"],
    "IHttpLanguageRangeWithQualityHeaderValueFactory": ["7bb83970-780f-4c83-9fe4-dc3087f6bd55"],
    "IHttpLanguageRangeWithQualityHeaderValueStatics": ["2541e146-f308-46f5-b695-42f54024ec68"],
    "IHttpMapTileDataSource": ["9d03cb5c-fd79-4795-87be-7e54ca0b37d0"],
    "IHttpMapTileDataSourceFactory": ["53b4b107-84dc-4291-89f8-6d0bb612a055"],
    "IHttpMediaTypeHeaderValue": ["16b28533-e728-4fcb-bdb0-08a431a14844"],
    "IHttpMediaTypeHeaderValueFactory": ["bed747a8-cd17-42dd-9367-ab9c5b56dd7d"],
    "IHttpMediaTypeHeaderValueStatics": ["e04d83df-1d41-4d8c-a2de-6fd2ed87399b"],
    "IHttpMediaTypeWithQualityHeaderValue": ["188d5e32-76be-44a0-b1cd-2074bded2dde"],
    "IHttpMediaTypeWithQualityHeaderValueCollection": ["3c0c6b73-1342-4587-a056-18d02ff67165"],
    "IHttpMediaTypeWithQualityHeaderValueFactory": ["4c6d20f4-9457-44e6-a323-d122b958780b"],
    "IHttpMediaTypeWithQualityHeaderValueStatics": ["5b070cd9-b560-4fc8-9835-7e6c0a657b24"],
    "IHttpMethod": ["728d4022-700d-4fe0-afa5-40299c58dbfd"],
    "IHttpMethodFactory": ["3c51d10d-36d7-40f8-a86d-e759caf2f83f"],
    "IHttpMethodHeaderValueCollection": ["43bc3ff4-6119-4adf-938c-34bfffcf92ed"],
    "IHttpMethodStatics": ["64d171f0-d99a-4153-8dc6-d68cc4cce317"],
    "IHttpMultipartContent": ["df916aff-9926-4ac9-aaf1-e0d04ef09bb9"],
    "IHttpMultipartContentFactory": ["7eb42e62-0222-4f20-b372-47d5db5d33b4"],
    "IHttpMultipartFormDataContent": ["64d337e2-e967-4624-b6d1-cf74604a4a42"],
    "IHttpMultipartFormDataContentFactory": ["a04d7311-5017-4622-93a8-49b24a4fcbfc"],
    "IHttpNameValueHeaderValue": ["d8ba7463-5b9a-4d1b-93f9-aa5b44ecfddf"],
    "IHttpNameValueHeaderValueFactory": ["770e2267-cbf8-4736-a925-93fbe10c7ca8"],
    "IHttpNameValueHeaderValueStatics": ["ffd4030f-1130-4152-8659-256909a9d115"],
    "IHttpNegotiate3": ["57b6c80a-34c2-4602-bc26-66a02fc57153"],
    "IHttpProductHeaderValue": ["f4feee03-ebd4-4160-b9ff-807c5183b6e6"],
    "IHttpProductHeaderValueFactory": ["611aa4f5-82bc-42fb-977b-dc00536e5e86"],
    "IHttpProductHeaderValueStatics": ["90c33e29-befc-4337-be62-49f097975f53"],
    "IHttpProductInfoHeaderValue": ["1b1a8732-4c35-486a-966f-646489198e4d"],
    "IHttpProductInfoHeaderValueCollection": ["877df74a-d69b-44f8-ad4f-453af9c42ed0"],
    "IHttpProductInfoHeaderValueFactory": ["24220fbe-eabe-4464-b460-ec010b7c41e2"],
    "IHttpProductInfoHeaderValueStatics": ["db7fd857-327a-4e73-81e5-7059a302b042"],
    "IHttpRequestHeaderCollection": ["af40329b-b544-469b-86b9-ac3d466fea36"],
    "IHttpRequestMessage": ["f5762b3c-74d4-4811-b5dc-9f8b4e2f9abf"],
    "IHttpRequestMessageFactory": ["5bac994e-3886-412e-aec3-52ec7f25616f"],
    "IHttpRequestResult": ["6acf4da8-b5eb-4a35-a902-4217fbe820c5"],
    "IHttpResponseHeaderCollection": ["7a990969-fa3f-41ed-aac6-bf957975c16b"],
    "IHttpResponseMessage": ["fee200fb-8664-44e0-95d9-42696199bffc"],
    "IHttpResponseMessageFactory": ["52a8af99-f095-43da-b60f-7cfc2bc7ea2f"],
    "IHttpServerCustomValidationRequestedEventArgs": ["3165fe32-e7dd-48b7-a361-939c750e63cc"],
    "IHttpStreamContentFactory": ["f3e64d9d-f725-407e-942f-0eda189809f4"],
    "IHttpStringContentFactory": ["46649d5b-2e93-48eb-8e61-19677878e57f"],
    "IHttpTransferCodingHeaderValue": ["436f32f9-3ded-42bd-b38a-5496a2511ce6"],
    "IHttpTransferCodingHeaderValueCollection": ["202c8c34-2c03-49b8-9665-73e27cb2fc79"],
    "IHttpTransferCodingHeaderValueFactory": ["bb62dffc-e361-4f08-8e4f-c9e723de703b"],
    "IHttpTransferCodingHeaderValueStatics": ["6ab8892a-1a98-4d32-a906-7470a9875ce5"],
    "IHttpTransportInformation": ["70127198-c6a7-4ed0-833a-83fd8b8f178d"],
    "IHub": ["ae692e82-7314-4f51-ab11-2af1ed4a19f8"],
    "IHubAutomationPeer": ["4ddee056-4ebc-4620-a05d-903e3c9a4ead"],
    "IHubAutomationPeerFactory": ["c762d43f-79dd-43ee-8777-8d08b39aa065"],
    "IHubFactory": ["dca6b2ba-c6f5-4961-9953-c51873db5424"],
    "IHubSection": ["a4e66cb7-7fdd-4fe0-ab49-c246639dccf9"],
    "IHubSectionAutomationPeer": ["16d91ff7-7431-4d82-83ce-cfa3192b0f18"],
    "IHubSectionAutomationPeerFactory": ["c68e27e8-17ec-4329-91ae-2d0b2339d498"],
    "IHubSectionFactory": ["fff55fa2-ece4-4bba-aa3b-9804aef47883"],
    "IHubSectionHeaderClickEventArgs": ["e1c5ef04-1edd-4112-aeeb-996c96400698"],
    "IHubSectionHeaderClickEventHandler": ["afe17b9b-9c63-4583-88e4-c59019b7f49d"],
    "IHubSectionStatics": ["12d2d85a-ea27-42d1-998b-61e52aed842b"],
    "IHubStatics": ["0e6fa034-ad3c-4f32-b701-e24fab562028"],
    "IHxHelpPane": ["8cec5884-07a1-11d9-b15e-000d56bfe6ee"],
    "IHxInteractiveUser": ["8cec595b-07a1-11d9-b15e-000d56bfe6ee"],
    "IHyperlink": ["0fe2363b-14e9-4152-9e58-5aea5b21f08d"],
    "IHyperlink2": ["4ce9da5f-7cff-4291-b78f-dfec72490576"],
    "IHyperlink3": ["c3f157d9-e5d3-4fb7-8702-4f6d85dd9e0a"],
    "IHyperlink4": ["f7d02959-82fb-400a-a407-5a4ee677988a"],
    "IHyperlink5": ["607dd7d2-0945-4328-91ee-94ccec2ea6c3"],
    "IHyperlinkButton": ["ccebaca3-3b5c-4f4c-9bfd-86887bc79772"],
    "IHyperlinkButtonAutomationPeer": ["aa7afcb1-0edf-46d9-aa9e-0eb21d140097"],
    "IHyperlinkButtonAutomationPeerFactory": ["59bc1661-c182-49af-9526-44b88e628455"],
    "IHyperlinkButtonFactory": ["43521bad-4e97-4da9-a64d-935dfd8cedf2"],
    "IHyperlinkButtonStatics": ["fbaeb5c7-cdb7-4263-b7d6-3c0d2904ed98"],
    "IHyperlinkClickEventArgs": ["c755916b-7bdc-4be7-b373-9240a503d870"],
    "IHyperlinkStatics": ["3a44d3d4-fd41-41db-8c72-3b790acd9fd3"],
    "IHyperlinkStatics2": ["5028d8b7-7adf-43ee-a4ae-9c925f755716"],
    "IHyperlinkStatics3": ["3e15dea0-205e-4947-99a5-74e757e8e1b4"],
    "IHyperlinkStatics4": ["0476b378-8faa-4e24-b3b6-e9de4d3c708c"],
    "IHyperlinkStatics5": ["59308cea-1e49-4921-bd88-a2878d07e30e"],
    "II2cConnectionSettings": ["f2db1307-ab6f-4639-a767-54536dc3460f"],
    "II2cConnectionSettingsFactory": ["81b586b3-9693-41b1-a243-ded4f6e66926"],
    "II2cController": ["c48ab1b2-87a0-4166-8e3e-b4b8f97cd729"],
    "II2cControllerProvider": ["61c2bb82-4510-4163-a87c-4e15a9558980"],
    "II2cControllerStatics": ["40fc0365-5f05-4e7e-84bd-100db8e0aec5"],
    "II2cDevice": ["8636c136-b9c5-4f70-9449-cc46dc6f57eb"],
    "II2cDeviceProvider": ["ad342654-57e8-453e-8329-d1e447d103a9"],
    "II2cDeviceStatics": ["91a33be3-7334-4512-96bc-fbae9459f5f6"],
    "II2cProvider": ["6f13083e-bf62-4fe2-a95a-f08999669818"],
    "IICCSVGColor": ["305104d6-98b5-11cf-bb82-00aa00bdce0b"],
    "IIE70DispatchEx": ["3051046b-98b5-11cf-bb82-00aa00bdce0b"],
    "IIE80DispatchEx": ["3051046c-98b5-11cf-bb82-00aa00bdce0b"],
    "IIEDownloadManager": ["15f6b27f-70f6-46d9-bc53-8d274c2d74d6"],
    "IIEEventHandler": ["01985350-df2a-473f-9bc9-ceb4d0ca10ef"],
    "IIEObjectWithProgID": ["f6a76981-4245-4415-8a38-d2790017ad73"],
    "IIETravelEntry2": ["21e1115f-0dde-45b5-8eb5-773054644299"],
    "IIETravelEntry3": ["b3e0e6ed-dc8c-4161-9f13-d8be42f4cba9"],
    "IIETravelEntry4": ["5464942c-6a4b-4a4b-81ba-cc0d17c3c090"],
    "IIETravelEntryEvents": ["39b21fe4-d4d3-47d1-98ba-262c28bf3e2c"],
    "IIETravelLog2": ["19bb515b-da44-4bcc-8625-6ad1be065692"],
    "IIETravelLogClientWrapper": ["671ecd53-3291-4eab-9fb4-079e11e4e894"],
    "IIETravelLogEx": ["dd9e2b32-4d78-44f1-b59b-8ca4c9392140"],
    "IIEWebDriverManager": ["bd1dc630-6590-4ca2-a293-6bc72b2438d8"],
    "IIEWebDriverSite": ["ffb84444-453d-4fbc-9f9d-8db5c471ec75"],
    "IIISApplicationAdmin": ["7c4e1804-e342-483d-a43e-a850cfcc8d18"],
    "IIISApplicationAdmin2": ["d643717a-fc87-4260-88ac-6ce35f0ec14e"],
    "IIMContactHandler": ["eb17d9f5-2eee-4d4a-9cfe-c954689ea7e8"],
    "IIMSICompletion": ["a9342324-da50-46b2-ba1c-2b1cb60c3817"],
    "IINETLOG_INFORMATION": ["cc557a71-f61a-11cf-bc0f-00aa006111e0"],
    "IIOCancelInformation": ["f5b0bf81-8cb5-4b1b-9449-1a159e0c733c"],
    "IIOControlCode": ["0e9559e7-60c8-4375-a761-7f8808066c60"],
    "IIOControlCodeFactory": ["856a7cf0-4c11-44ae-afc6-b8d4a212788f"],
    "IIPDVDec": ["b8e8bd60-0bfe-11d0-af91-00aa00b67a42"],
    "IIPInformation": ["d85145e0-138f-47d7-9b3a-36bb488cef33"],
    "IIRawElementProviderSimple": ["ec752224-9b77-4720-bb21-4ac89fdb1afd"],
    "IISApp": ["46fbbb80-0192-11d1-9c39-00a0c922e703"],
    "IISApp2": ["603dcbea-7350-11d2-a7be-0000f8085b95"],
    "IISApp3": ["2812b639-8fac-4510-96c5-71ddbd1f54fc"],
    "IISApplicationPool": ["0b3cb1e1-829a-4c06-8b09-f56da1894c88"],
    "IISApplicationPools": ["587f123f-49b4-49dd-939e-f4547aa3fa75"],
    "IISComputer": ["cf87a2e0-078b-11d1-9c3d-00a0c922e703"],
    "IISComputer2": ["63d89839-5762-4a68-b1b9-3507ea76cbbf"],
    "IISDBSLocator": ["c9897087-e29c-473f-9e4b-7072123dea14"],
    "IISDB_BIT": ["537cd71e-0e46-4173-9001-ba043f3e49e2"],
    "IISDB_CDT": ["25fa92c2-8b80-4787-a841-3a0e8f17984b"],
    "IISDB_EMM": ["0edb556d-43ad-4938-9668-321b2ffecfd3"],
    "IISDB_LDT": ["141a546b-02ff-4fb9-a3a3-2f074b74a9a9"],
    "IISDB_NBIT": ["1b1863ef-08f1-40b7-a559-3b1eff8cafa6"],
    "IISDB_SDT": ["3f3dc9a2-bb32-4fb9-ae9e-d856848927a3"],
    "IISDB_SDTT": ["ee60ef2d-813a-4dc7-bf92-ea13dac85313"],
    "IISDsCrMap": ["edcd6a60-b053-11d0-a62f-00a0c922e752"],
    "IISWebService": ["ee46d40c-1b38-4a02-898d-358e74dfc9d2"],
    "IITBuildCollect": ["8fa0d5a5-dedf-11d0-9a61-00c04fb68bf7"],
    "IITCmdInt": ["4cf34c30-9bf9-11d0-8764-00a0c913f764"],
    "IITDatabase": ["8fa0d5a2-dedf-11d0-9a61-00c04fb68bf7"],
    "IITPropList": ["1f403bb1-9997-11d0-a850-00aa006c7d01"],
    "IITResultSet": ["3bb91d41-998b-11d0-a850-00aa006c7d01"],
    "IITStopWordList": ["8fa0d5ad-dedf-11d0-9a61-00c04fb68bf7"],
    "IITSvMgr": ["4e7da031-9c11-11d0-8764-00a0c913f764"],
    "IITWordWheel": ["8fa0d5a4-dedf-11d0-9a61-00c04fb68bf7"],
    "IIconElement": ["9af0803b-d04c-467a-bbd5-9b81f02d9a56"],
    "IIconElementFactory": ["cf37a562-0424-43c7-8bea-720fba973ef1"],
    "IIconElementStatics": ["be19a623-77cf-472f-82ea-047801d12012"],
    "IIconSource": ["92ec8d55-45eb-47a4-863c-91b224044f9b"],
    "IIconSourceElement": ["d7a64502-ddda-55cd-b4c9-e79abc8b0ea4"],
    "IIconSourceElementFactory": ["26b59fab-2092-5b95-b59e-f27f210689e7"],
    "IIconSourceElementStatics": ["f37cfd45-f3d8-50ff-a1b8-0fba4ae61d79"],
    "IIconSourceFactory": ["4d117cf1-1fd6-49d7-b483-02ec3de997d6"],
    "IIconSourceStatics": ["1d389dbe-1cd3-4f4f-83b0-55dc6387685b"],
    "IIdentifyHive": ["f75ceccd-5a36-474b-a324-07f57a1ed9d2"],
    "IIdentityAdvise": ["4e982fed-d14b-440c-b8d6-bb386453d386"],
    "IIdentityAuthentication": ["5e7ef254-979f-43b5-b74e-06e4eb7df0f9"],
    "IIdentityAuthority": ["261a6983-c35d-4d0d-aa5b-7867259e77bc"],
    "IIdentityName": ["7d903fca-d6f9-4810-8332-946c0177e247"],
    "IIdentityPath": ["52958b02-bcca-41cf-a447-d24f460b24e9"],
    "IIdentityProvider": ["0d1b9e0c-e8ba-4f55-a81b-bce934b948f5"],
    "IIdentityStore": ["df586fa5-6f35-44f1-b209-b38e169772eb"],
    "IIdentityStore2": ["7c0c01e3-b1d3-4823-8441-c39e08bf02fa"],
    "IIdentityStoreEx": ["f9f9eb98-8f7f-4e38-9577-6980114ce32b"],
    "IIdleDispatchedHandler": ["a42b0c24-7f21-4abc-99c1-8f01007f0880"],
    "IIdleDispatchedHandlerArgs": ["98bb6a24-dc1c-43cb-b4ed-d1c0eb2391f3"],
    "IIdleSettings": ["84594461-0053-4342-a8fd-088fabf11f32"],
    "IIdleTask": ["f08ce0d0-c2d0-4d54-a6ad-d32646f54aa0"],
    "IIdleTaskHost": ["d9befc84-f21e-4166-874b-a8d3010dc764"],
    "IIdleTrigger": ["d537d2b0-9fb3-4d34-9739-1ff5ce7b1ef3"],
    "IIisServiceControl": ["e8fb8620-588f-11d2-9d61-00c04f79c5fe"],
    "IImage2": ["f445119e-881f-48bb-873a-64417ca4f002"],
    "IImage3": ["06ebe792-47c2-4d92-a488-8cd685d06aca"],
    "IImageAutomationPeer": ["9b0bbf8c-60a2-48bf-ab2c-1a52a451d2d4"],
    "IImageAutomationPeerFactory": ["90304003-687d-47bf-b3a2-4babcad8ef50"],
    "IImageBrush": ["9fd11377-c12a-4493-bf7d-f3a8ad74b554"],
    "IImageBrushStatics": ["1255b1b2-dd18-42e5-892c-eae30c305b8c"],
    "IImageBytes": ["025d1823-6c7d-447b-bbdb-a3cbc3dfa2fc"],
    "IImageCombo": ["dd9da664-8594-11d1-b16a-00c0f0283628"],
    "IImageCue": ["52828282-367b-440b-9116-3c84570dd270"],
    "IImageDecodeEventSink2": ["8ebd8a57-8a96-48c9-84a6-962e2db9c931"],
    "IImageDecoder": ["327abdab-072b-11d3-9d7b-0000f81ef32e"],
    "IImageDisplayProperties": ["cd0bc7ef-54e7-411f-9933-f0e98b0a96d2"],
    "IImageDownload": ["6266a09e-5af8-4024-aa55-429eeab0e85c"],
    "IImageDownloadSink": ["96c5be7f-88d5-40df-a8bc-e9e39e006eae"],
    "IImageEncoder": ["327abdac-072b-11d3-9d7b-0000f81ef32e"],
    "IImageEncodingProperties": ["78625635-f331-4189-b1c3-b48d5ae034f1"],
    "IImageEncodingProperties2": ["c854a2df-c923-469b-ac8e-6a9f3c1cd9e3"],
    "IImageEncodingPropertiesStatics": ["257c68dc-8b99-439e-aa59-913a36161297"],
    "IImageEncodingPropertiesStatics2": ["f6c25b29-3824-46b0-956e-501329e1be3c"],
    "IImageEncodingPropertiesStatics3": ["48f4814d-a2ff-48dc-8ea0-e90680663656"],
    "IImageFeatureDescriptor": ["365585a5-171a-4a2a-985f-265159d3895a"],
    "IImageFeatureValue": ["f0414fd9-c9aa-4405-b7fb-94f87c8a3037"],
    "IImageFeatureValueStatics": ["1bc317fd-23cb-4610-b085-c8e1c87ebaa0"],
    "IImageFilter": ["cdbf2040-c624-11cf-b584-00aa00a71d1a"],
    "IImageHandle": ["b4d44e85-fcf6-481e-bfbf-cdf3a573e298"],
    "IImageInformation": ["7c907864-346c-4aeb-8f3f-57da289f969f"],
    "IImageList2": ["192b9d83-50fc-457b-90a0-2b82a8b5dae1"],
    "IImageProcessorForRoaming": ["d14e769b-4502-48a7-99af-0fc558ef35c7"],
    "IImageProperties": ["523c9424-fcff-4275-afee-ecdb9ab47973"],
    "IImageQueueManager": ["f9e87849-b323-eefa-3204-8a2d2d2b4432"],
    "IImageSanitizationBroker": ["06765610-54ea-4db8-a9c6-0d0f8d1e73d4"],
    "IImageSanitizationValidator": ["3a05b5ea-527e-4c9b-ba53-58aca78d0b56"],
    "IImageScanner": ["53a88f78-5298-48a0-8da3-8087519665e0"],
    "IImageScannerFeederConfiguration": ["74bdacee-fa97-4c17-8280-40e39c6dcc67"],
    "IImageScannerFormatConfiguration": ["ae275d11-dadf-4010-bf10-cca5c83dcbb0"],
    "IImageScannerPreviewResult": ["08b7fe8e-8891-441d-be9c-176fa109c8bb"],
    "IImageScannerScanResult": ["c91624cd-9037-4e48-84c1-ac0975076bc5"],
    "IImageScannerSourceConfiguration": ["bfb50055-0b44-4c82-9e89-205f9c234e59"],
    "IImageScannerStatics": ["bc57e70e-d804-4477-9fb5-b911b5473897"],
    "IImageSink": ["327abdae-072b-11d3-9d7b-0000f81ef32e"],
    "IImageSource": ["737ef309-ea41-4d96-a71c-98e98efcab07"],
    "IImageSourceFactory": ["297ec001-2540-4e5a-ab66-88035dd3ddb5"],
    "IImageStatics": ["89903772-c336-43d1-9d51-c3bbd5d5d691"],
    "IImageTransform": ["732b4749-8d28-4cc2-8b9e-b4a7583d488b"],
    "IImageTransformParameters": ["cd589afd-9a50-4594-8b52-797029577be5"],
    "IImages": ["2c247f24-8591-11d1-b16a-00c0f0283628"],
    "IImePad": ["5d8e643a-c3a9-11d1-afef-00805f0c8b6d"],
    "IImePadApplet": ["5d8e643b-c3a9-11d1-afef-00805f0c8b6d"],
    "IImePlugInDictDictionaryList": ["98752974-b0a6-489b-8f6f-bff3769c8eeb"],
    "IImeSpecifyApplets": ["5d8e643c-c3a9-11d1-afef-00805f0c8b6d"],
    "IImgCreateErrorInfo": ["1c55a64c-07cd-4fb5-90f7-b753d91f0c9e"],
    "IImgErrorInfo": ["2bce4ece-d30e-445a-9423-6829be945ad8"],
    "IImgFileItem": ["bf29a939-56cf-44e3-bf31-8007dd67a517"],
    "IImgFilePool": ["2947feb1-c585-4d69-bd63-5ff0effec831"],
    "IImgFilePoolX": ["90d1bbb2-2421-4034-b30d-d774e2d3fb3b"],
    "IImgWriterFileItem": ["c01f00b2-147a-4027-9fa6-b5430da48d77"],
    "IImgWriterFileItemX": ["2d9a89a9-0449-4dab-8300-842860d60aa7"],
    "IImmersiveAccountsSettings": ["82cfe484-6292-4c11-8260-b36817031c9b"],
    "IImmersiveAppCrusher": ["55c8429b-3f9e-4736-96a2-1c56e2dfc883"],
    "IImmersiveAppCrusherNotification": ["1bf3dc4c-07a0-4f3f-87f8-5a625cd2e7ad"],
    "IImmersiveAppCrusherNotificationService": ["0c0f0f3c-7bab-426c-84fc-c682fc0375d0"],
    "IImmersiveAppPositioner": ["8faec766-bd4b-4c16-9dce-a7d4226c66b6"],
    "IImmersiveApplication": ["8b14e88b-5663-4caf-b196-c31479262831"],
    "IImmersiveApplicationArray": ["c6ed6dac-8fac-4598-a74c-69020137149c"],
    "IImmersiveApplicationArrayService": ["a3c23ab7-6be2-4778-8eb0-1adb7977f76a"],
    "IImmersiveApplicationDebugControlInternal": ["683906e1-1771-40a1-bbd6-409cc4c8e268"],
    "IImmersiveApplicationDebugControlInternal2": ["f63c57d3-03a2-40a9-ab07-7fc0d51184b2"],
    "IImmersiveApplicationHolographic": ["f4921d4f-67d4-4ca9-9ec4-0bc577bb904e"],
    "IImmersiveApplicationManager": ["bf63999f-7411-40da-861c-df72c0ffee84"],
    "IImmersiveApplicationNotification": ["e23730be-13f1-4f0b-88ab-76d5e3beb5b7"],
    "IImmersiveApplicationNotificationService": ["7860c098-fb29-49aa-a512-adacc0ffee84"],
    "IImmersiveApplicationTitleBarManager": ["ef50bc9f-87d2-4ec5-a007-d94d7ff66f24"],
    "IImmersiveApplicationVisibilityOverride": ["53f83578-492b-4e8f-8096-3d3dd1260aa6"],
    "IImmersiveApplicationWindow": ["c6636ec2-eba1-4e6d-a995-8fa14b8b2891"],
    "IImmersiveBackstackManager": ["dbea162d-04e8-460f-8a0b-4a431715d9a3"],
    "IImmersiveBackstackManagerPriv": ["c68619de-d7bf-4586-aa6c-02f2177708e9"],
    "IImmersiveBackstackSettings": ["8d294980-9ce1-42ac-8f77-11fa93d47324"],
    "IImmersiveCharmsWindowManager": ["351c9530-3568-4ec4-bb33-9e2dc0ffee84"],
    "IImmersiveExpressionSanitizationBroker": ["dd864693-2f00-4cf9-a4c7-2f7c386a8a1d"],
    "IImmersiveFrameworkInputPaneForwarder": ["87da1e67-cafa-4fab-99f5-9427b2d5b2de"],
    "IImmersiveHomeGroupCPLCallback": ["c16411cb-4c7c-4384-9776-1ebb10d50c6d"],
    "IImmersiveLauncher": ["d8d60399-a0f1-f987-5551-321fd1b49864"],
    "IImmersiveLauncherCortana": ["5ef7890f-319b-4259-8d0f-36e5ff0916ce"],
    "IImmersiveLauncherSearchTaskEvent": ["7f9bad1e-c1c4-46b4-a9ea-c8ec56d20357"],
    "IImmersiveLauncherTrayNotify": ["bcf1f74f-2413-46b3-8707-ec2fca11965d"],
    "IImmersiveLayout": ["d770b2ad-8f5e-4b8e-b3df-f05a2ab5287c"],
    "IImmersiveLayoutChanges": ["6a5e657d-223a-4875-838b-c311ed73523b"],
    "IImmersiveLayoutClient": ["05088755-ef51-4684-8f7c-b07c8d5d5f39"],
    "IImmersiveMonitor": ["880b26f8-9197-43d0-8045-8702d0d72000"],
    "IImmersiveMonitorManager": ["4d4c1e64-e410-4faa-bafa-59ca069bfec2"],
    "IImmersiveMonitorNotification": ["940c223d-5bdc-49db-968c-e4f3ef9b9270"],
    "IImmersiveMonitorNotificationService": ["7c7a3e75-4362-4d12-860d-68ee72909f83"],
    "IImmersiveSessionIdleDetector": ["a340ae45-86bf-4c9c-b6c8-6109ca1e2f29"],
    "IImmersiveSessionIdleNotification": ["985c98a3-21f6-4585-9e13-f708cb0de4f2"],
    "IImmersiveSettings": ["7665c60a-c9a7-4306-ae31-bf520214fa71"],
    "IImmersiveSettingsCache": ["4214f6fa-eb36-4e2f-9ca2-23fdc1832df7"],
    "IImmersiveSettingsCacheNotification": ["0b40e4e6-2749-461f-9a84-29491c297f86"],
    "IImmersiveShellBroker": ["9767060c-9476-42e2-8f7b-2f10fd13765c"],
    "IImmersiveShellComponent": ["e67ad469-a445-4371-82a5-7a5cefa85fc4"],
    "IImmersiveShellCreationBehavior": ["5d6c0d20-18bb-403c-becf-46e01ee3bfe4"],
    "IImmersiveShellHookNotification": ["4b25b8ee-6129-45e4-b527-f376f89c9c8c"],
    "IImmersiveShellHookService": ["914d9b3a-5e53-4e14-bbba-46062acb35a4"],
    "IImmersiveShellTracingHandler": ["dded82e1-c4f9-43f0-93f0-76dd2375caea"],
    "IImmersiveShellTracingService": ["6c36f018-4d3d-427c-8136-ea21290abd5c"],
    "IImmersiveSystemMode": ["ea9aac7d-0cac-4ceb-981c-4545a28bada2"],
    "IImmersiveSystemModeNotification": ["8ec4fc3a-ddb1-4e84-a7fc-210ec0ffee84"],
    "IImmersiveSystemModeNotificationService": ["ac2af908-82b1-40b3-a94d-18c2c0ffee84"],
    "IImmersiveWindowManager": ["611aa8fe-b694-4129-86af-2c2553fff785"],
    "IImmersiveWindowMessageService": ["bf8b6ede-2069-4010-a9e7-4480e24c01ca"],
    "IImpersonateCallback": ["99b01d17-9fbd-4aa6-b16d-82dab6a4107f"],
    "IImpersonateClipboardOwner": ["b6fb7c7c-0bb2-4c59-b866-d6b153521af6"],
    "IImplicitAnimationCollection": ["0598a3ff-0a92-4c9d-a427-b25519250dbf"],
    "IImportBroker": ["01463365-9a8d-4602-9aac-40754a8c0750"],
    "IInclinometer": ["2648ca6f-2286-406f-9161-f0c4bd806ebf"],
    "IInclinometer2": ["029f3393-28b2-45f8-bb16-61e86a7fae6e"],
    "IInclinometer3": ["3a095004-d765-4384-a3d7-0283f3abe6ae"],
    "IInclinometer4": ["43852618-8fca-548e-bbf5-5c50412b6aa4"],
    "IInclinometerDataThreshold": ["f80a4783-7bfe-545e-bb60-a0ebc47bd2fb"],
    "IInclinometerDeviceId": ["01e91982-41ff-4406-ae83-62210ff16fe3"],
    "IInclinometerReading": ["9f44f055-b6f6-497f-b127-1a775e501458"],
    "IInclinometerReading2": ["4f164781-e90b-4658-8915-0103e08a805a"],
    "IInclinometerReadingChangedEventArgs": ["4ae91dc1-e7eb-4938-8511-ae0d6b440438"],
    "IInclinometerReadingYawAccuracy": ["b453e880-1fe3-4986-a257-e6ece2723949"],
    "IInclinometerStatics": ["f22ec551-9c30-453a-8b49-3c3eeb33cb61"],
    "IInclinometerStatics2": ["043f9775-6a1e-499c-86e0-638c1a864b00"],
    "IInclinometerStatics3": ["bd9a4280-b91a-4829-9392-abc0b6bdf2b4"],
    "IInclinometerStatics4": ["e8ba96f9-6e85-4a83-aed0-d7cdcc9856c8"],
    "IIncrementNumberRounder": ["70a64ff8-66ab-4155-9da1-739e46764543"],
    "IIncrementalFillCallback": ["72eb0e17-af29-425e-a698-613587058a9a"],
    "IIndexDefinition": ["0c733a68-2a1c-11ce-ade5-00aa0044773d"],
    "IIndexPerfCounters": ["8e4225c5-886c-4a40-914f-01765e175def"],
    "IIndexableConcept": ["d1fad99f-3f53-4457-850c-8051df2d3fb5"],
    "IIndexableContent": ["ccf1a05f-d4b5-483a-b06e-e0db1ec420e4"],
    "IIndexedResourceCandidate": ["0e619ef3-faec-4414-a9d7-54acd5953f29"],
    "IIndexedResourceQualifier": ["dae3bb9b-d304-497f-a168-a340042c8adb"],
    "IIndexerPlugIn": ["b0565244-9b10-425e-b616-1fcd828db3b1"],
    "IIndexerTasks": ["817b682b-5d96-4c97-9d71-1cb8d5478201"],
    "IInertiaExpansionBehavior": ["751d87e5-8d42-44c5-965e-3cd30cc9d6f7"],
    "IInertiaProcessor": ["18b00c6d-c5ee-41b1-90a9-9d4a929095ad"],
    "IInertiaRotationBehavior": ["424cfb2e-bbfd-4625-ae78-20c65bf1efaf"],
    "IInertiaTranslationBehavior": ["45d3a512-3b32-4882-a4c2-ecfa2d4b6df0"],
    "IInfoBarHost": ["e38fe0f3-3db0-47ee-a314-25cf7f4bf521"],
    "IInfoBarManager": ["9040e4e1-1ef9-4949-a379-36bc095d1ce4"],
    "IInfoPaneProvider": ["38698b65-1ca7-458c-b4d6-e0a51379c1d2"],
    "IInfraredMediaFrame": ["3fd13503-004b-4f0e-91ac-465299b41658"],
    "IInfraredTorchControl": ["1cba2c83-6cb6-5a04-a6fc-3be7b33ff056"],
    "IInitActivationPropertiesIn": ["000001a1-0000-0000-c000-000000000046"],
    "IInitCategoryEnum": ["46187751-37c4-4bd0-be08-7f954c2fd0d0"],
    "IInitCollection": ["1f074b83-6468-453b-82ab-1f4889934437"],
    "IInitEnumExplorerCommandOnMenu": ["974fc285-a627-490d-a293-0f5e8ab987fe"],
    "IInitViewLinkedWebOC": ["e787f2c0-3d21-4d98-85c8-a038195ba649"],
    "IInitializeCommand": ["85075acf-231f-40ea-9610-d26b7b58f638"],
    "IInitializeFolderInfoTip": ["cafec873-94b2-47a4-aa4a-6a54f2df865d"],
    "IInitializeIdentity": ["68d92253-f390-4036-bb23-05a5b4d90737"],
    "IInitializeMediaStreamSourceRequestedEventArgs": ["25bc45e1-9b08-4c2e-a855-4542f1a75deb"],
    "IInitializeNetworkFolder": ["6e0f9881-42a8-4f2a-97f8-8af4e026d92d"],
    "IInitializePropertyStore": ["de9c1991-1891-491c-b3a2-ee89c467c584"],
    "IInitializeProviderConfig": ["628880f3-0dc6-4359-a29b-15ef9aecbd23"],
    "IInitializeQueryResult": ["4eea50c7-78d0-47c2-b585-3b7c026ccc15"],
    "IInitializeResultSetFactory": ["c7858b50-f6b7-4bd4-a645-8a86c3fb9f52"],
    "IInitializeResultSetManager": ["d6effa92-c1ad-4416-b077-84d5e448bdb8"],
    "IInitializeResultShape": ["42c9f529-ac7b-45d3-a320-c2f23f250b94"],
    "IInitializeSettingHandler": ["6dbbd4c5-2cbb-4875-b22a-0ad7458894d9"],
    "IInitializeSettingHandlerFactory": ["c3f22887-8214-43bd-b660-ca604ac1264d"],
    "IInitializeSettingSyncProvider": ["908270d5-5fbe-4170-9504-fb7554d2e589"],
    "IInitializeSortColumnArray": ["e70c4a71-a5a1-40f2-84eb-9a9081e246a9"],
    "IInitializeWindowsPackageSettingHandler": ["6ffb50eb-65dc-4a8e-b417-4572ec1729a9"],
    "IInitializeWithBindCtx": ["71c0d2bc-726d-45cc-a6c0-2e31c1db2159"],
    "IInitializeWithCoreWindow": ["188f20d6-9873-464a-ace5-57e010f465e6"],
    "IInitializeWithDelegate": ["465a756d-45ad-4305-85fd-d3321650f3b7"],
    "IInitializeWithFile": ["b7d14566-0509-4cce-a71f-0a554233bd9b"],
    "IInitializeWithItem": ["7f73be3f-fb79-493c-a6c7-7ee14e245841"],
    "IInitializeWithItemArrayAndGPSFlags": ["8c59322f-f915-4757-9925-4fb4df1dd7d7"],
    "IInitializeWithPopupPersonality": ["6a193f22-6d3e-4803-b595-a581906c929b"],
    "IInitializeWithPropertyFactory": ["cb6d939d-7dfe-4e1e-aa08-d3bec4a0f1c6"],
    "IInitializeWithPropertyKeys": ["3bd82d8d-fb97-462a-b942-4bdfe8811a0c"],
    "IInitializeWithPropertyStore": ["c3e12eb5-7d8d-44f8-b6dd-0e77b34d6de4"],
    "IInitializeWithPropertyStores": ["b8158717-9161-46fd-b8d2-26d42185bc69"],
    "IInitializeWithQueryCancel": ["3f1cc7a7-1457-4810-adbd-33fb78a36bf8"],
    "IInitializeWithStream": ["b824b49d-22ac-4161-ac8a-9916e8fa3f7f"],
    "IInitializeWithWindow": ["3e68d4bd-7135-4d10-8018-9fb6d9f33fa1"],
    "IInitiateWinSATAssessment": ["d983fc50-f5bf-49d5-b5ed-cccb18aa7fc1"],
    "IInjectedInputGamepadInfo": ["20ae9a3f-df11-4572-a9ab-d75b8a5e48ad"],
    "IInjectedInputGamepadInfoFactory": ["59596876-6c39-4ec4-8b2a-29ef7de18aca"],
    "IInjectedInputKeyboardInfo": ["4b46d140-2b6a-5ffa-7eae-bd077b052acd"],
    "IInjectedInputMouseInfo": ["96f56e6b-e47a-5cf4-418d-8a5fb9670c7d"],
    "IInjectedInputPenInfo": ["6b40ad03-ca1e-5527-7e02-2828540bb1d4"],
    "IInjectedInputTouchInfo": ["224fd1df-43e8-5ef5-510a-69ca8c9b4c28"],
    "IInk": ["03f8e511-43a1-11d3-8bb6-0080c7d6bad5"],
    "IInkAnalysisInkBullet": ["ee049368-6110-4136-95f9-ee809fc20030"],
    "IInkAnalysisInkDrawing": ["6a85ed1f-1fe4-4e15-898c-8e112377e021"],
    "IInkAnalysisInkWord": ["4bd228ad-83af-4034-8f3b-f8687dfff436"],
    "IInkAnalysisLine": ["a06d048d-2b8d-4754-ad5a-d0871193a956"],
    "IInkAnalysisListItem": ["b4e3c23f-c4c3-4c3a-a1a6-9d85547ee586"],
    "IInkAnalysisNode": ["30831f05-5f64-4a2c-ba37-4f4887879574"],
    "IInkAnalysisParagraph": ["d9ad045c-0cd1-4dd4-a68b-eb1f12b3d727"],
    "IInkAnalysisResult": ["8948ba79-a243-4aa3-a294-1f98bd0ff580"],
    "IInkAnalysisRoot": ["3fb6a3c4-2fde-4061-8502-a90f32545b84"],
    "IInkAnalysisWritingRegion": ["dd6d6231-bd16-4663-b5ae-941d3043ef5b"],
    "IInkAnalyzer": ["f12b8f95-0866-4dc5-8c77-f88614dfe38c"],
    "IInkAnalyzerFactory": ["29138686-1963-49d8-9589-e14384c769e3"],
    "IInkCanvas": ["29443c28-8e48-4fc8-a473-35b0ba12acea"],
    "IInkCanvasFactory": ["924ac2de-ab04-48f0-9653-e0f2da4dbf1a"],
    "IInkCollector": ["f0f060b5-8b1f-4a7c-89ec-880692588a4f"],
    "IInkCommitRequestHandler": ["fabea3fc-b108-45b6-a9fc-8d08fa9f85cf"],
    "IInkCursor": ["ad30c630-40c5-4350-8405-9c71012fc558"],
    "IInkCursorButton": ["85ef9417-1d59-49b2-a13c-702c85430894"],
    "IInkCursorButtons": ["3671cc40-b624-4671-9fa0-db119d952d54"],
    "IInkCursors": ["a248c1ac-c698-4e06-9e5c-d57f77c7e647"],
    "IInkCustomStrokes": ["7e23a88f-c30e-420f-9bdb-28902543f0c1"],
    "IInkD2DRenderer": ["407fb1de-f85a-4150-97cf-b7fb274fb4f8"],
    "IInkD2DRenderer2": ["0a95dcd9-4578-4b71-b20b-bf664d4bfeee"],
    "IInkDesktopHost": ["4ce7d875-a981-4140-a1ff-ad93258e8d59"],
    "IInkDisp": ["9d398fa0-c4e2-4fcd-9973-975caaf47ea6"],
    "IInkDivider": ["5de00405-f9a4-4651-b0c5-c317defd58b9"],
    "IInkDivisionResult": ["2dbec0a7-74c7-4b38-81eb-aa8ef0c24900"],
    "IInkDivisionUnit": ["85aee342-48b0-4244-9dd5-1ed435410fab"],
    "IInkDivisionUnits": ["1bb5ddc2-31cc-4135-ab82-2c66c9f00c41"],
    "IInkDrawingAttributes": ["97a2176c-6774-48ad-84f0-48f5a9be74f9", "bf519b75-0a15-4623-adc9-c00d436a8092"],
    "IInkDrawingAttributes2": ["7cab6508-8ec4-42fd-a5a5-e4b7d1d5316d"],
    "IInkDrawingAttributes3": ["72020002-7d5b-4690-8af4-e664cbe2b74f"],
    "IInkDrawingAttributes4": ["ef65dc25-9f19-456d-91a3-bc3a3d91c5fb"],
    "IInkDrawingAttributes5": ["d11aa0bb-0775-4852-ae64-41143a7ae6c9"],
    "IInkDrawingAttributesPencilProperties": ["4f2534cb-2d86-41bb-b0e8-e4c2a0253c52"],
    "IInkDrawingAttributesStatics": ["f731e03f-1a65-4862-96cb-6e1665e17f6d"],
    "IInkEdit": ["f2127a19-fbfb-4aed-8464-3f36d78cfefb"],
    "IInkExtendedProperties": ["89f2a8be-95a9-4530-8b8f-88e971e3e25f"],
    "IInkExtendedProperty": ["db489209-b7c3-411d-90f6-1548cfff271e"],
    "IInkGesture": ["3bdc0a97-04e5-4e26-b813-18f052d41def"],
    "IInkHostWorkItem": ["ccda0a9a-1b78-4632-bb96-97800662e26c"],
    "IInkInputConfiguration": ["93a68dc4-0b7b-49d7-b34f-9901e524dcf2"],
    "IInkInputProcessingConfiguration": ["2778d85e-33ca-4b06-a6d3-ac3945116d37"],
    "IInkLineInfo": ["9c1c5ad6-f22f-4de4-b453-a2cc482e7c33"],
    "IInkManager": ["4744737d-671b-4163-9c95-4e8d7a035fe1"],
    "IInkModelerAttributes": ["bad31f27-0cd9-4bfd-b6f3-9e03ba8d7454"],
    "IInkModelerAttributes2": ["86d1d09a-4ef8-5e25-b7bc-b65424f16bb3"],
    "IInkOverlay": ["b82a463b-c1c5-45a3-997c-deab5651b67a"],
    "IInkPicture": ["e85662e0-379a-40d7-9b5c-757d233f9923"],
    "IInkPoint": ["9f87272b-858c-46a5-9b41-d195970459fd"],
    "IInkPoint2": ["fba9c3f7-ae56-4d5c-bd2f-0ac45f5e4af9"],
    "IInkPointFactory": ["29e5d51c-c98f-405d-9f3b-e53e31068d4d"],
    "IInkPointFactory2": ["e0145e85-daff-45f2-ad69-050d8256a209"],
    "IInkPresenter": ["a69b70e2-887b-458f-b173-4fe4438930a3"],
    "IInkPresenter2": ["cf53e612-9a34-11e6-9f33-a24fc0d9649c"],
    "IInkPresenter3": ["51e1ce89-d37d-4a90-83fc-7f5e9dfbf217"],
    "IInkPresenterDesktop": ["73f3c0d9-2e8b-48f3-895e-20cbd27b723b"],
    "IInkPresenterProtractor": ["7de3f2aa-ef6c-4e91-a73b-5b70d56fbd17"],
    "IInkPresenterProtractorFactory": ["320103c9-68fa-47e9-8127-8370711fc46c"],
    "IInkPresenterRuler": ["6cda7d5a-dec7-4dd7-877a-2133f183d48a"],
    "IInkPresenterRuler2": ["45130dc1-bc61-44d4-a423-54712ae671c4"],
    "IInkPresenterRulerFactory": ["34361beb-9001-4a4b-a690-69dbaf63e501"],
    "IInkPresenterStencil": ["30d12d6d-3e06-4d02-b116-277fb5d8addc"],
    "IInkRecognitionAlternate": ["b7e660ad-77e4-429b-adda-873780d1fc4a"],
    "IInkRecognitionAlternates": ["286a167f-9f19-4c61-9d53-4f07be622b84"],
    "IInkRecognitionResult": ["36461a94-5068-40ef-8a05-2c2fb60908a2", "3bc129a8-86cd-45ad-bde8-e0d32d61c16d"],
    "IInkRecognizer": ["077ccea3-904d-442a-b151-aaca3631c43b", "782bf7cf-034b-4396-8a32-3a1833cf6b56"],
    "IInkRecognizer2": ["6110118a-3a75-4ad6-b2aa-04b2b72bbe65"],
    "IInkRecognizerContainer": ["a74d9a31-8047-4698-a912-f82a5085012f"],
    "IInkRecognizerContext": ["c68f52f9-32a3-4625-906c-44fc23b40958"],
    "IInkRecognizerContext2": ["d6f0e32f-73d8-408e-8e9f-5fea592c363f"],
    "IInkRecognizerGuide": ["d934be07-7b84-4208-9136-83c20994e905"],
    "IInkRecognizers": ["9ccc4f12-b0b7-4a8b-bf58-4aeca4e8cefd"],
    "IInkRectangle": ["9794ff82-6071-4717-8a8b-6ac7c64a686e"],
    "IInkRenderer": ["e6257a9c-b511-4f4c-a8b0-a7dbc9506b83"],
    "IInkStroke": ["15144d60-cce3-4fcf-9d52-11518ab6afd4"],
    "IInkStroke2": ["5db9e4f4-bafa-4de1-89d3-201b1ed7d89b"],
    "IInkStroke3": ["4a807374-9499-411d-a1c4-68855d03d65f"],
    "IInkStrokeBuilder": ["82bbd1dc-1c63-41dc-9e07-4b4a70ced801"],
    "IInkStrokeBuilder2": ["bd82bc27-731f-4cbc-bbbf-6d468044f1e5"],
    "IInkStrokeBuilder3": ["b2c71fcd-5472-46b1-a81d-c37a3d169441"],
    "IInkStrokeContainer": ["22accbc6-faa9-4f14-b68c-f6cee670ae16"],
    "IInkStrokeContainer2": ["8901d364-da36-4bcf-9e5c-d195825995b4"],
    "IInkStrokeContainer3": ["3d07bea5-baea-4c82-a719-7b83da1067d2"],
    "IInkStrokeDisp": ["43242fea-91d1-4a72-963e-fbb91829cfa2"],
    "IInkStrokeInput": ["cf2ffe7b-5e10-43c6-a080-88f26e1dc67d"],
    "IInkStrokeRenderingSegment": ["68510f1f-88e3-477a-a2fa-569f5f1f9bd5"],
    "IInkStrokes": ["f1f4c9d8-590a-4963-b3ae-1935671bb6f3"],
    "IInkStrokesCollectedEventArgs": ["c4f3f229-1938-495c-b4d9-6de4b08d4811"],
    "IInkStrokesErasedEventArgs": ["a4216a22-1503-4ebf-8ff5-2de84584a8aa"],
    "IInkSynchronizer": ["9b9ea160-ae9b-45f9-8407-4b493b163661"],
    "IInkTablet": ["2de25eaa-6ef8-42d5-aee9-185bc81b912d"],
    "IInkTablet2": ["90c91ad2-fa36-49d6-9516-ce8d570f6f85"],
    "IInkTablet3": ["7e313997-1327-41dd-8ca9-79f24be17250"],
    "IInkTablets": ["112086d9-7779-4535-a699-862b43ac1863"],
    "IInkToolbar": ["3ddd0cca-51f0-486f-a03e-4ee13dc12bcb"],
    "IInkToolbar2": ["86f0c111-b484-454a-ae78-1d25a33d1c67"],
    "IInkToolbar3": ["a8a6def0-7aa8-5326-b7c4-88ae25013362"],
    "IInkToolbarAutomationPeer": ["123baaa4-f2e8-4bcb-9382-5dfdd11fe45f"],
    "IInkToolbarBallpointPenButton": ["158329f8-1e99-3acc-910f-9da2d872ae12"],
    "IInkToolbarBallpointPenButtonFactory": ["2f0bd3e4-d754-4255-8ec4-00cd101296ab"],
    "IInkToolbarCustomPen": ["4082207b-2f3d-4e6a-8c27-fe61ef7e70eb"],
    "IInkToolbarCustomPenButton": ["46024401-2b2a-4f3c-a53c-1a045a408efa"],
    "IInkToolbarCustomPenButtonFactory": ["0f2ef0ba-c8b9-4c36-8987-94d3dafede18"],
    "IInkToolbarCustomPenButtonStatics": ["373c25f4-e555-4e85-a80d-da6b8433dbde"],
    "IInkToolbarCustomPenFactory": ["d214d636-f1aa-4f48-bf2c-a926caae4c60"],
    "IInkToolbarCustomPenOverrides": ["9d22eb6c-1255-4256-b6bd-82c2fd273488"],
    "IInkToolbarCustomToggleButton": ["550c4d84-4f54-4fbe-b12b-e0a50aab0d05"],
    "IInkToolbarCustomToggleButtonFactory": ["4a00374d-4cd2-4ed9-863e-83b8cf3fd2af"],
    "IInkToolbarCustomToolButton": ["9f98acd7-c605-4105-be10-3943a7c0da3c"],
    "IInkToolbarCustomToolButtonFactory": ["c295fe4e-30eb-4130-a6b6-8c85d8e26e89"],
    "IInkToolbarCustomToolButtonStatics": ["11fe4cb9-bbac-4314-9344-92c6693ddeaf"],
    "IInkToolbarEraserButton": ["4cbdb92e-5f5e-4b35-a41c-16ffb0283bc0"],
    "IInkToolbarEraserButton2": ["e7a59257-5ae8-436d-b2e2-93c200900ca0"],
    "IInkToolbarEraserButtonFactory": ["fd40611d-d1ba-4d67-af00-148036ad492c"],
    "IInkToolbarEraserButtonStatics2": ["038a1736-c5cd-4311-83f4-38cbf07c2066"],
    "IInkToolbarFactory": ["3947aa99-36b1-4374-ab5c-98bf07a4320b"],
    "IInkToolbarFlyoutItem": ["92b68786-37ee-4915-9e89-e187564a889a"],
    "IInkToolbarFlyoutItemFactory": ["352e7b93-803b-4f0e-8c72-9dfc0329329f"],
    "IInkToolbarFlyoutItemStatics": ["1fe54b64-4063-4a5f-b89c-9f58935ee379"],
    "IInkToolbarHighlighterButton": ["0b3cc15b-7abf-487e-acc1-5b5048fee6d2"],
    "IInkToolbarHighlighterButtonFactory": ["7c334add-42ca-4943-94a4-23b5a6e55cf1"],
    "IInkToolbarIsStencilButtonCheckedChangedEventArgs": ["026edd26-d32b-4e28-a033-d5097662b292"],
    "IInkToolbarMenuButton": ["860ecae5-7633-4ea1-a209-50392d1aebd1"],
    "IInkToolbarMenuButtonFactory": ["7a463a9d-5dc7-44a7-afd0-2b685cb9a96c"],
    "IInkToolbarMenuButtonStatics": ["f03b17a6-b8b0-4a87-a961-37cd05d83137"],
    "IInkToolbarPenButton": ["e0b80c21-b032-40ee-a2b9-507f6ccb827b"],
    "IInkToolbarPenButtonFactory": ["b1463d21-59cb-4a83-92e1-692842797b2e"],
    "IInkToolbarPenButtonStatics": ["b922ce42-09f0-453d-8026-44daf2753f65"],
    "IInkToolbarPenConfigurationControl": ["601ae5f6-28a5-44cc-89a6-380e91a572dd"],
    "IInkToolbarPenConfigurationControlFactory": ["67f065ee-f5e7-46eb-9187-8d3ca3af891b"],
    "IInkToolbarPenConfigurationControlStatics": ["48a61bef-19ce-41bb-abe0-7c8726fae75e"],
    "IInkToolbarPencilButton": ["5b112832-1984-4148-9f25-382b35db087f"],
    "IInkToolbarPencilButtonFactory": ["db66d85f-cfd6-495f-93ab-b8566af9f8af"],
    "IInkToolbarStatics": ["a3b493bb-cb4f-4e6b-a33d-f11e7a295efa"],
    "IInkToolbarStatics2": ["aac1f8f2-2c1f-4e9c-b3f3-31ff22b51c7a"],
    "IInkToolbarStatics3": ["a0ee663d-b63f-516e-a0a4-0704c4544d62"],
    "IInkToolbarStencilButton": ["306a2616-5b40-4bf3-92b7-f1df936aeff5"],
    "IInkToolbarStencilButtonFactory": ["a20701d1-8a70-4d77-89d4-1730a3a58edf"],
    "IInkToolbarStencilButtonStatics": ["4748c07f-63e4-420d-939a-6b7243e9d124"],
    "IInkToolbarToggleButton": ["b4a278fa-f5f0-4b1f-beb0-0b8a29905a4a"],
    "IInkToolbarToggleButtonFactory": ["b2f90710-e5a1-4365-9d1a-e5b7ad8b9668"],
    "IInkToolbarToolButton": ["5c5af41e-ccb7-4458-8064-a9849d31561b"],
    "IInkToolbarToolButtonFactory": ["6293bf4b-89fe-4ed0-a1a6-88d3eba917b2"],
    "IInkToolbarToolButtonStatics": ["9e097d18-d136-4ef6-b0fd-1a78c2884a01"],
    "IInkTransform": ["615f1d43-8703-4565-88e2-8201d2ecd7b7"],
    "IInkUnprocessedInput": ["db4445e0-8398-4921-ac3b-ab978c5ba256"],
    "IInkWordList": ["76ba3491-cb2f-406b-9961-0e0c4cdaaef2"],
    "IInkWordList2": ["14542586-11bf-4f5f-b6e7-49d0744aab6e"],
    "IInkWorkspaceHostedAppBroker": ["3e75d5ee-bd10-4119-84b9-959626f49ab0"],
    "IInkWorkspaceHostedAppManager": ["fe0a7990-5e59-4bb7-8a63-7d218cd96300"],
    "IInkWorkspaceHostedAppManagerStatics": ["cbfd8cc5-a162-4bc4-84ee-e8716d5233c5"],
    "IInline": ["0c92712d-1bc9-4931-8cb1-1aeadf1cc685"],
    "IInlineFactory": ["4058acd1-2f90-4b8f-99dd-4218ef5f03de"],
    "IInlineUIContainer": ["1416ce81-28ee-452e-b121-5fc4f60b86a6"],
    "IInplaceShareEngine": ["cdf7745a-45b2-456e-8646-ab0c204404f9"],
    "IInputActivationListener": ["5d6d4ed2-28c7-5ae3-aa74-c918a9f243ca"],
    "IInputActivationListenerActivationChangedEventArgs": ["7699b465-1dcf-5791-b4b9-6cafbeed2056"],
    "IInputActivationListenerPreviewStatics": ["f0551ce5-0de6-5be0-a589-f737201a4582"],
    "IInputEnabledEventArgs": ["80371d4f-2fd8-4c24-aa86-3163a87b4e5a"],
    "IInputHostLayout": ["3a67c20b-df2d-4437-a761-0c41b441ac25"],
    "IInputHostLayoutCallback": ["624eeb56-662c-4406-a5a2-124f9ee9ee39"],
    "IInputHostLayoutChanges": ["4fb9f2b9-bdd6-47b9-9ebe-703eacdc1c8e"],
    "IInputHostManager": ["260b6f30-f9bc-452d-be7e-d8bdc0ea3a0a"],
    "IInputHostManagerBroker": ["2166ee67-71df-4476-8394-0ced2ed05274"],
    "IInputInjector": ["8ec26f84-0b02-4bd2-ad7a-3d4658be3e18"],
    "IInputInjector2": ["8e7a905d-1453-43a7-9bcb-06d6d7b305f7"],
    "IInputInjectorStatics": ["deae6943-7402-4141-a5c6-0c01aa57b16a"],
    "IInputInjectorStatics2": ["a4db38fb-dd8c-414f-95ea-f87ef4c0ae6c"],
    "IInputModeChangeNotifier": ["60aaa1e2-9cf9-4fdd-b24f-1b8988ab3603"],
    "IInputModeChangedEventArgs": ["15c6e4ab-dc40-400b-8ab3-3ce61f67df93"],
    "IInputModeChangedHandler": ["6ba4b426-dd10-47c8-a023-c22f13a5f596"],
    "IInputObject2": ["6915c085-510b-44cd-94af-28dfa56cf92b"],
    "IInputPane": ["640ada70-06f3-4c87-a678-9829c9127c28"],
    "IInputPane2": ["8a6b3f26-7090-4793-944c-c3f2cde26276"],
    "IInputPaneAnimationCoordinator": ["2af16ba9-2de5-4b75-82d9-01372afbffb4"],
    "IInputPaneControl": ["088bb24f-962f-489d-aa6e-c6be1a0a6e52"],
    "IInputPaneEventHandler": ["87482e5d-0157-459a-bd7c-cb18085be80f"],
    "IInputPaneInterop": ["75cf2c57-9195-4931-8332-f0b409e916af"],
    "IInputPaneStatics": ["95f4af3a-ef47-424a-9741-fd2815eba2bd"],
    "IInputPaneStatics2": ["1b63529b-d9ec-4531-8445-71bab9fb828e"],
    "IInputPaneVisibilityEventArgs": ["d243e016-d907-4fcc-bb8d-f77baa5028f1"],
    "IInputPanelConfiguration": ["41c81592-514c-48bd-a22e-e6af638521a6"],
    "IInputPanelInvocationConfiguration": ["a213f136-3b45-4362-a332-efb6547cd432"],
    "IInputPanelWindowHandle": ["4af81847-fdc4-4fc3-ad0b-422479c1b935"],
    "IInputScope": ["5c0f85f3-f9d8-4220-b666-045d074d9bfa"],
    "IInputScopeName": ["fd3e6997-08fb-4cba-a021-792d7589fd5a"],
    "IInputScopeNameFactory": ["4a40bb52-4bd7-4e54-8617-1cda8a1eda7f"],
    "IInputSequenceCheckerContainer": ["02d887fa-4358-11d2-be22-080009dc0a8d"],
    "IInputStream": ["905a0fe2-bc53-11df-8c49-001e4fc686da"],
    "IInputStreamReference": ["43929d18-5ec9-4b5a-919c-4205b0c804b6"],
    "IInputSwitchCallback": ["b9bc2a50-43c3-41aa-a083-5db14e184bae"],
    "IInputSwitchControl": ["b9bc2a50-43c3-41aa-a082-5db14e184bae"],
    "IInsertionPanel": ["6b8de08f-6527-4d39-bcbf-58b01da923d7"],
    "IInsetClip": ["1e73e647-84c7-477a-b474-5880e0442e15"],
    "IInspectable": ["af86e2e0-b12d-4c6a-9c5a-d7aa65101e90"],
    "IInstallReferenceEnum": ["56b1a988-7c0c-4aa2-8639-c3eb5a90226f"],
    "IInstallReferenceItem": ["582dac66-e678-449f-aba6-6faaec8a9394"],
    "IInstallationAgent": ["925cbc18-a2ea-4648-bf1c-ec8badcfe20a"],
    "IInstallationBehavior": ["d9a59339-e245-4dbd-9686-4d5763e39624"],
    "IInstallationCompletedCallback": ["45f4f6f3-d602-4f98-9a8a-3efa152ad2d3"],
    "IInstallationCompletedCallbackArgs": ["250e2106-8efb-4705-9653-ef13c581b6a1"],
    "IInstallationJob": ["5c209f0b-bad5-432a-9556-4699bed2638a"],
    "IInstallationProgress": ["345c8244-43a3-4e32-a368-65f073b76f36"],
    "IInstallationProgressChangedCallback": ["e01402d5-f8da-43ba-a012-38894bd048f1"],
    "IInstallationProgressChangedCallbackArgs": ["e4f14e1e-689d-4218-a0b9-bc189c484a01"],
    "IInstallationResult": ["a43c56d6-7451-48d4-af96-b6cd2d0d9b7a"],
    "IInstalledClassicAppInfo": ["0a7d3da3-65d0-4086-80d6-0610d760207d"],
    "IInstalledDesktopApp": ["75eab8ed-c0bc-5364-4c28-166e0545167a"],
    "IInstalledDesktopAppStatics": ["264cf74e-21cd-5f9b-6056-7866ad72489a"],
    "IInstalledVoicesStatic": ["7d526ecc-7533-4c3f-85be-888c2baeebdc"],
    "IInstalledVoicesStatic2": ["64255f2e-358d-4058-be9a-fd3fcb423530"],
    "IInstanceInfo": ["000001ad-0000-0000-c000-000000000046"],
    "IInstantiationInfo": ["000001ab-0000-0000-c000-000000000046"],
    "IInterFilterCommunicator": ["4daf1e69-81fd-462d-940f-8cd3ddf56fca"],
    "IInteractionSourceConfiguration": ["a78347e5-a9d1-4d02-985e-b930cd0b9da4"],
    "IInteractionTracker": ["2a8e8cb1-1000-4416-8363-cc27fb877308"],
    "IInteractionTracker2": ["25769a3e-ce6d-448c-8386-92620d240756"],
    "IInteractionTracker3": ["e6c5d7a2-5c4b-42c6-84b7-f69441b18091"],
    "IInteractionTracker4": ["ebd222bc-04af-4ac7-847d-06ea36e80a16"],
    "IInteractionTracker5": ["d3ef5da2-a254-40e4-88d5-44e4e16b5809"],
    "IInteractionTrackerCustomAnimationStateEnteredArgs": ["8d1c8cf1-d7b0-434c-a5d2-2d7611864834"],
    "IInteractionTrackerCustomAnimationStateEnteredArgs2": ["47d579b7-0985-5e99-b024-2f32c380c1a4"],
    "IInteractionTrackerIdleStateEnteredArgs": ["50012faa-1510-4142-a1a5-019b09f8857b"],
    "IInteractionTrackerIdleStateEnteredArgs2": ["f2e771ed-b803-5137-9435-1c96e48721e9"],
    "IInteractionTrackerInertiaModifier": ["a0e2c920-26b4-4da2-8b61-5e683979bbe2"],
    "IInteractionTrackerInertiaModifierFactory": ["993818fe-c94e-4b86-87f3-922665ba46b9"],
    "IInteractionTrackerInertiaMotion": ["04922fdc-f154-4cb8-bf33-cc1ba611e6db"],
    "IInteractionTrackerInertiaMotionStatics": ["8cc83dd6-ba7b-431a-844b-6eac9130f99a"],
    "IInteractionTrackerInertiaNaturalMotion": ["70acdaae-27dc-48ed-a3c3-6d61c9a029d2"],
    "IInteractionTrackerInertiaNaturalMotionStatics": ["cfda55b0-5e3e-4289-932d-ee5f50e74283"],
    "IInteractionTrackerInertiaRestingValue": ["86f7ec09-5096-4170-9cc8-df2fe101bb93"],
    "IInteractionTrackerInertiaRestingValueStatics": ["18ed4699-0745-4096-bcab-3a4e99569bcf"],
    "IInteractionTrackerInertiaStateEnteredArgs": ["87108cf2-e7ff-4f7d-9ffd-d72f1e409b63"],
    "IInteractionTrackerInertiaStateEnteredArgs2": ["b1eb32f6-c26c-41f6-a189-fabc22b323cc"],
    "IInteractionTrackerInertiaStateEnteredArgs3": ["48ac1c2f-47bd-59af-a58c-79bd2eb9ef71"],
    "IInteractionTrackerInteractingStateEnteredArgs": ["a7263939-a17b-4011-99fd-b5c24f143748"],
    "IInteractionTrackerInteractingStateEnteredArgs2": ["509652d6-d488-59cd-819f-f52310295b11"],
    "IInteractionTrackerOwner": ["db2e8af3-4deb-4e53-b29c-b06c9f96d651"],
    "IInteractionTrackerRequestIgnoredArgs": ["80dd82f1-ce25-488f-91dd-cb6455ccff2e"],
    "IInteractionTrackerStatics": ["bba5d7b7-6590-4498-8d6c-eb62b514c92a"],
    "IInteractionTrackerStatics2": ["35e53720-46b7-5cb0-b505-f3d6884a6163"],
    "IInteractionTrackerValuesChangedArgs": ["cf1578ef-d3df-4501-b9e6-f02fb22f73d0"],
    "IInteractionTrackerVector2InertiaModifier": ["87e08ab0-3086-4853-a4b7-77882ad5d7e3"],
    "IInteractionTrackerVector2InertiaModifierFactory": ["7401d6c4-6c6d-48df-bc3e-171e227e7d7f"],
    "IInteractionTrackerVector2InertiaNaturalMotion": ["5f17695c-162d-4c07-9400-c282b28276ca"],
    "IInteractionTrackerVector2InertiaNaturalMotionStatics": ["82001a48-09c0-434f-8189-141c66df362f"],
    "IInteractiveSessionStatics": ["60884631-dd3a-4576-9c8d-e8027618bdce"],
    "IInterfaceFromWindowProp": ["00000135-0000-0000-c000-000000000046"],
    "IInterfaceInfo": ["000001f7-0000-0000-c000-000000000046"],
    "IInterleavedSerializeCallback": ["e0a98c5b-4965-4f4b-87f9-33efba6e85fc"],
    "IInternalApplicationPermissions": ["c0d179ae-689b-4eb5-8008-6ec45eed03b0"],
    "IInternalBrowserService": ["6bd38a1c-7310-4e76-8567-927d8f72ef27"],
    "IInternalCustomDestinationList": ["507101cd-f6ad-46c8-8e20-eeb9e6bac47f"],
    "IInternalDocWrap": ["e1aa6466-9db4-40ba-be03-77c38e8e60b2"],
    "IInternalExtenderProvider": ["b85f43c4-c765-4984-ae3d-695e8cd8e992"],
    "IInternetBindInfoEx": ["a3e015b7-a82c-4dcd-a150-569aeeed36ab"],
    "IInternetBindInfoInternal": ["8fd4c3a8-e3e8-4b62-9f2f-483e5c09661d"],
    "IInternetExplorerManager": ["acc84351-04ff-44f9-b23f-655ed168c6d5"],
    "IInternetExplorerManager2": ["dfbb5136-9259-4895-b4a7-c1934429919a"],
    "IInternetPriorityInfoInternal": ["d5ae15f6-2032-488e-8f96-f92406d8d8b4"],
    "IInternetPriorityInternal": ["eb5cda44-5086-44fe-a9b1-c6421353a546"],
    "IInternetProtocolEx": ["c7a98e66-1010-492c-a1c8-c809e1f75905"],
    "IInternetSecurityManagerEx2": ["f1e50292-a795-4117-8e09-2b560a72ac60"],
    "IInternetZoneManagerEx2": ["edc17559-dd5d-4846-8eef-8becba5a4abf"],
    "IInterruptCommand": ["51525841-daae-4204-bef4-e7628582450f"],
    "IInterruptItem": ["388eed6a-df36-4009-b5ea-609d3309cc5d"],
    "IInterruptSync": ["22c6ac63-851b-11d0-9a7f-00aa0038acfe"],
    "IInterruptedOperationHandler": ["036b4fc7-6a11-4c07-8046-22d268c37721"],
    "IInterval": ["6bf0a714-3c18-430b-8b5d-83b1c234d3db"],
    "IInvalidProductLicenseException": ["a37d00f5-7bb0-4953-b414-f9e98326f2e8"],
    "IInvocationLocation": ["831d1dff-7f57-4720-87e4-cb57d6214428"],
    "IInvokeProvider": ["54fcb24b-e18e-47a2-b4d3-eccbe77599a2", "f7d1a187-b13c-4540-b09e-6778e2dc9ba5"],
    "IInvokeSettingSyncSSO": ["36ec7e1f-64ae-4220-8526-f95769ab6388"],
    "IIsMappingValidCallback": ["0f2ad8fa-bab1-4ad8-a41f-952db538a247"],
    "IIsTextTrimmedChangedEventArgs": ["16f597cd-ebff-4fb4-8714-26147418b945"],
    "IIsWebBrowserSB": ["b8a9c381-19df-11d1-9193-006097df5bd4"],
    "IIsdbAudioComponentDescriptor": ["679d2002-2425-4be4-a4c7-d6632a574f4d"],
    "IIsdbCAContractInformationDescriptor": ["08e18b25-a28f-4e92-821e-4fced5cc2291"],
    "IIsdbCADescriptor": ["0570aa47-52bc-42ae-8ca5-969f41e81aea"],
    "IIsdbCAServiceDescriptor": ["39cbeb97-ff0b-42a7-9ab9-7b9cfe70a77a"],
    "IIsdbComponentGroupDescriptor": ["a494f17f-c592-47d8-8943-64c9a34be7b9"],
    "IIsdbDataContentDescriptor": ["a428100a-e646-4bd6-aa14-6087bdc08cd5"],
    "IIsdbDigitalCopyControlDescriptor": ["1a28417e-266a-4bb8-a4bd-d782bcfb8161"],
    "IIsdbDownloadContentDescriptor": ["5298661e-cb88-4f5f-a1de-5f440c185b92"],
    "IIsdbEmergencyInformationDescriptor": ["ba6fa681-b973-4da1-9207-ac3e7f0341eb"],
    "IIsdbEventGroupDescriptor": ["94b06780-2e2a-44dc-a966-cc56fdabc6c2"],
    "IIsdbHierarchicalTransmissionDescriptor": ["b7b3ae90-ee0b-446d-8769-f7e2aa266aa6"],
    "IIsdbLogoTransmissionDescriptor": ["e0103f49-4ae1-4f07-9098-756db1fa88cd"],
    "IIsdbSIParameterDescriptor": ["f837dc36-867c-426a-9111-f62093951a45"],
    "IIsdbSeriesDescriptor": ["07ef6370-1660-4f26-87fc-614adab24b11"],
    "IIsdbSiParser2": ["900e4bb7-18cd-453f-98be-3be6aa211772"],
    "IIsdbTSInformationDescriptor": ["d7ad183e-38f5-4210-b55f-ec8d601bbd47"],
    "IIsdbTerrestrialDeliverySystemDescriptor": ["39fae0a6-d151-44dd-a28a-765de5991670"],
    "IIsoImageManager": ["6ca38be5-fbbb-4800-95a1-a438865eb0d4"],
    "IIsoSpeedControl": ["27b6c322-25ad-4f1b-aaab-524ab376ca33"],
    "IIsoSpeedControl2": ["6f1578f2-6d77-4f8a-8c2f-6130b6395053"],
    "IIsolatedAppLauncher": ["f686878f-7b42-4cc4-96fb-f4f3b6e3d24d"],
    "IIsolatedWindowsEnvironment": ["41d24597-c328-4467-b37f-4dfc6f60b6bc"],
    "IIsolatedWindowsEnvironmentCreateResult": ["ef9a5e58-dcd7-45c2-9c85-ab642a715e8e"],
    "IIsolatedWindowsEnvironmentFactory": ["1aca93e7-e804-454d-8466-f9897c20b0f6"],
    "IIsolatedWindowsEnvironmentFile": ["4d5ae1ef-029f-4101-8c35-fe91bf9cd5f0"],
    "IIsolatedWindowsEnvironmentHostStatics": ["2c0e22c7-05a0-517a-b81c-6ee8790c381f"],
    "IIsolatedWindowsEnvironmentLaunchFileResult": ["685d4176-f6e0-4569-b1aa-215c0ff5b257"],
    "IIsolatedWindowsEnvironmentOptions": ["b71d98f7-61f0-4008-b207-0bf9eb2d76f2"],
    "IIsolatedWindowsEnvironmentOwnerRegistrationData": ["f888ec22-e8cf-56c0-b1df-90af4ad80e84"],
    "IIsolatedWindowsEnvironmentOwnerRegistrationResult": ["6dab9451-6169-55df-8f51-790e99d7277d"],
    "IIsolatedWindowsEnvironmentOwnerRegistrationStatics": ["10951754-204b-5ec9-9de3-df792d074a61"],
    "IIsolatedWindowsEnvironmentProcess": ["a858c3ef-8172-4f10-af93-cbe60af88d09"],
    "IIsolatedWindowsEnvironmentShareFolderRequestOptions": ["c405eb7d-7053-4f6a-9b87-746846ed19b2"],
    "IIsolatedWindowsEnvironmentShareFolderResult": ["556ba72e-ca9d-4211-b143-1cedc86eb2fe"],
    "IIsolatedWindowsEnvironmentStartProcessResult": ["8fa1dc2f-57da-4bb5-9c06-fa072d2032e2"],
    "IIsolatedWindowsEnvironmentTelemetryParameters": ["ebdb3cab-7a3a-4524-a0f4-f96e284d33cd"],
    "IIsolatedWindowsHostMessengerStatics": ["06e444bb-53c0-4889-8fa3-53592e37cf21"],
    "IItalic": ["91f4619c-fcbb-4157-802c-76f63b5fb657"],
    "IItemAutomationPeer": ["953c34f6-3b31-47a7-b3bf-25d3ae99c317"],
    "IItemAutomationPeerFactory": ["29065073-de3d-4d3f-97b4-4d6f9d53444d"],
    "IItemCategorizer": ["b669937f-94c3-45d8-a950-38c43c9be7a8"],
    "IItemChangeArray": ["8550419b-ac9d-4dc8-8019-534fdc3e86ce"],
    "IItemClickEventArgs": ["9c314242-f29a-494d-a3a5-d4c7b2a46852"],
    "IItemClickEventHandler": ["3df6d14e-e18a-4a75-9395-627c5f3cd489"],
    "IItemCollection": ["39651294-8f5c-452a-9dcb-75ea630399e4"],
    "IItemCollectionFactory": ["56028b02-396d-4bf4-ad8d-03494890aee0"],
    "IItemContainerGenerator": ["40765f00-83f0-4d7f-b1b8-f19de4f1d5da"],
    "IItemContainerMapping": ["53c9f23a-f25d-446a-99b8-c7aeb839050f"],
    "IItemContainerProvider": ["e747770b-39ce-4382-ab30-d8fb3f336f24", "ef5cd845-e1d4-40f4-bad5-c7fad44a703e"],
    "IItemDevirtualizerSpy": ["6f2d1a66-13f0-40c9-ac0b-5d2e8f6376a8"],
    "IItemEnumerator": ["9f7d7bb7-20b3-11da-81a5-0030f1642e3c"],
    "IItemEventSink": ["9d6dcf9e-4068-46ea-9ac3-ef709bb2fe1c"],
    "IItemFilter": ["7fcbeb25-ed60-45c9-9f5e-57b48493c4dd"],
    "IItemFilterOwner": ["7e1af054-83a6-47fc-ab27-a58ae8d9c705"],
    "IItemHandlerCache": ["ddb6beda-0406-404d-8a91-177e92f5c6d0"],
    "IItemIndexRange": ["83b834be-0583-4a26-9b64-8bf4a2f65704"],
    "IItemIndexRangeFactory": ["86e2c440-2e7a-4c7d-a664-e8abf07bfc7e"],
    "IItemKeyArray": ["7e56debf-4e4a-4ce3-9d33-d62909685063"],
    "IItemPropertyCache": ["2ad6c81c-42dc-46b8-931b-ee0db2a20d1b"],
    "IItemRemovedEventArgs": ["59677e5c-55be-4c66-ba66-5eaea79d2631"],
    "IItemSetOperationCallback": ["30176cfe-6f36-4ea4-be65-a4b728fece39"],
    "IItemSetOperations": ["32ae3a1f-d90e-4417-9dd9-23b0dfa4621d"],
    "IItemStore": ["df44cd5d-9ae9-4935-980a-e8add2246d41"],
    "IItemStoreOwner": ["35c22fea-79f6-4d3d-ae15-1699cbf54721"],
    "IItemTaskScheduler": ["c1884f8b-2db6-40b6-9e90-b9876b75ffe0"],
    "IItemThumbnailCallback": ["099ab00e-1fe6-4460-9e1b-4b2567da41ca"],
    "IItemTranslation": ["59d6f31b-fa6b-4fba-8af3-197ff140c714"],
    "IItemsChangedEventArgs": ["e8b45568-7d10-421e-be29-81839a91de20"],
    "IItemsChangedEventHandler": ["178257be-a304-482f-8bf0-b9d2e39612a3"],
    "IItemsControl": ["f4a91dd8-d979-4381-8652-bda0342a765e"],
    "IItemsControl2": ["754c3266-0529-45e3-8748-bf747d158357"],
    "IItemsControl3": ["502b7489-aee4-4de3-a2ab-195ac20c4212"],
    "IItemsControlAutomationPeer": ["96e76bf1-37f7-4088-925d-65268e83e34d"],
    "IItemsControlAutomationPeer2": ["c48d8917-95a8-47b8-a517-bf891a6c039b"],
    "IItemsControlAutomationPeerFactory": ["4038a259-2e1a-49ca-a533-c64f181577e6"],
    "IItemsControlAutomationPeerOverrides2": ["361dc0e8-b56f-45e9-80fe-10a0fb0fe177"],
    "IItemsControlFactory": ["f7bbc359-f8fd-471c-bcb2-2c74be8ebf8c"],
    "IItemsControlOverrides": ["c79bb41b-a084-4301-a496-72971f364ed1"],
    "IItemsControlStatics": ["37dabd89-dcfb-45b8-9afe-874df097905e"],
    "IItemsPanelTemplate": ["14ead768-34b2-4b97-bf3c-e8d73230a2aa"],
    "IItemsPickedEventArgs": ["f95b9aac-a621-488e-9156-8ee31165be04"],
    "IItemsPresenter": ["c271569b-6dca-4e2b-8e14-c55136b02a71"],
    "IItemsPresenter2": ["5c04aa33-1df3-4731-a4c9-da818378d63d"],
    "IItemsPresenterStatics": ["18de66cd-4a6c-4b2e-aa86-cb126c9a2920"],
    "IItemsPresenterStatics2": ["8971632e-7867-4d66-9630-29f1c5f7403f"],
    "IItemsRangeInfo": ["f05f5665-71fd-45a2-be13-a081d294a68d"],
    "IItemsStackPanel": ["df7ab79d-7ad5-4b58-9363-919af90226e6"],
    "IItemsStackPanel2": ["eeeecdb0-00b4-4534-937b-56318b293e92"],
    "IItemsStackPanelStatics": ["ca25d63f-044f-4b6b-b315-0b60e0b4f87d"],
    "IItemsStackPanelStatics2": ["3972eb2c-384a-48bf-adfd-772e2572c504"],
    "IItemsViewSpy": ["2691d091-02c2-4096-b45d-a29fef234940"],
    "IItemsViewSpyClient": ["def89b4a-5804-456b-af09-a8e4c80de58d"],
    "IItemsWrapGrid": ["ddfe6b5f-ba88-4a7d-8a5b-e58caf0f4e2d"],
    "IItemsWrapGrid2": ["80c21c0f-63ec-4258-bd61-d4a6956c864a"],
    "IItemsWrapGridStatics": ["4ec5427d-24a0-449a-b763-3077ba0f2dd5"],
    "IItemsWrapGridStatics2": ["2e27d3f7-feaa-478d-bfd1-29338adc5a03"],
    "IIterableConcept": ["f5d49d0c-0b02-4301-9c9b-b3a6037628f3"],
    "IJITDebuggingHost2": ["42ef9f29-7777-42ed-ba74-944aefd663da"],
    "IJapanesePhoneme": ["2f6a9300-e85b-43e6-897d-5d82f862df21"],
    "IJapanesePhoneticAnalyzerStatics": ["88ab9e90-93de-41b2-b4d5-8edb227fd1c2"],
    "IJavascriptDispatchRemoteProxy": ["c20ed5c4-0a2e-4f66-9be2-86a1c823dd68"],
    "IJavascriptLocalProxy": ["ebade2e2-a8cc-4797-a430-2e863867efd0"],
    "IJetEngine": ["9f63d980-ff25-11d1-bb6f-00c04fae22da"],
    "IJournalPrintJob": ["9f4f2864-f3f0-55d0-8c39-74cc91783eed"],
    "IJournalPrinterCapabilities": ["3b5ccc43-e047-4463-bb58-17b5ba1d8056"],
    "IJournalPrinterCapabilities2": ["03b0b645-33b8-533b-baaa-a4389283ab0a"],
    "IJsArguments": ["09eef2f5-bc32-4a88-8d18-225edc4dc04f"],
    "IJsArray": ["e34507b0-f19a-11d0-9349-00a0c90dcaa9"],
    "IJsDebug": ["be0e89da-2ac5-4c04-ac5e-59956aae3613"],
    "IJsDebugBreakPoint": ["df6773e3-ed8d-488b-8a3e-5812577d1542"],
    "IJsDebugDataTarget": ["53b28977-53a1-48e5-9000-5d0dfa893931"],
    "IJsDebugFrame": ["c9196637-ab9d-44b2-bad2-13b95b3f390e"],
    "IJsDebugProcess": ["3d587168-6a2d-4041-bd3b-0de674502862"],
    "IJsDebugProperty": ["f8ffcf2b-3aa4-4320-85c3-52a312ba9633"],
    "IJsDebugStackWalker": ["db24b094-73c4-456c-a4ec-e90ea00bdfe3"],
    "IJsEnumDebugProperty": ["4092432f-2f0f-4fe1-b638-5b74a52cdcbe"],
    "IJsonArray": ["08c1ddb6-0cbd-4a9a-b5d3-2f852dc37e81"],
    "IJsonArrayStatics": ["db1434a9-e164-499f-93e2-8a8f49bb90ba"],
    "IJsonErrorStatics2": ["404030da-87d0-436c-83ab-fc7b12c0cc26"],
    "IJsonObject": ["064e24dd-29c2-4f83-9ac1-9ee11578beb3"],
    "IJsonObjectStatics": ["2289f159-54de-45d8-abcc-22603fa066a0"],
    "IJsonObjectWithDefaultValues": ["d960d2a2-b7f0-4f00-8e44-d82cf415ea13"],
    "IJsonValue": ["a3219ecb-f0b3-4dcd-beee-19d48cd3ed1e"],
    "IJsonValueStatics": ["5f6b544a-2f53-48e1-91a3-f78b50a6345c"],
    "IJsonValueStatics2": ["1d9ecbe4-3fe8-4335-8392-93d8e36865f0"],
    "IJumpList": ["b0234c3e-cd6f-4cb6-a611-61fd505f3ed1"],
    "IJumpListItem": ["7adb6717-8b5d-4820-995b-9b418dbe48b0"],
    "IJumpListItemBackgroundConverter": ["81177858-d224-410c-b16c-c5b6bb6188b2"],
    "IJumpListItemBackgroundConverterStatics": ["20e7c3dd-6f27-4808-b0be-83e0e9b5cc45"],
    "IJumpListItemForegroundConverter": ["1590ed38-c504-4796-a63a-5bfc9eefaae8"],
    "IJumpListItemForegroundConverterStatics": ["474e7352-210c-4673-ac6a-413f0e2c7750"],
    "IJumpListItemStatics": ["f1bfc4e8-c7aa-49cb-8dde-ecfccd7ad7e4"],
    "IJumpListStatics": ["a7e0c681-e67e-4b74-8250-3f322c4d92c3"],
    "IJumpViewContextMenuWrapper": ["dcf1427b-9f2f-4bb5-8aa2-ec625e2b2082"],
    "IJumpViewExecuteHelper": ["8a4427de-b11b-4a61-8977-844a3a7bc63b"],
    "IJumpViewItemInfoInternal": ["b1e3d1df-81ce-4b9f-ac99-048a4f42a73c"],
    "IKernelTransaction": ["79427a2b-f895-40e0-be79-b57dc82ed231"],
    "IKeyAdviseSink": ["8ebd3263-d48c-4093-91b2-45ba9368e6f2"],
    "IKeyAlgorithmNamesStatics": ["479065d7-7ac7-4581-8c3b-d07027140448"],
    "IKeyAlgorithmNamesStatics2": ["c99b5686-e1fd-4a4a-893d-a26f33dd8bb4"],
    "IKeyAttestationHelperStatics": ["1648e246-f644-4326-88be-3af102d30e0c"],
    "IKeyAttestationHelperStatics2": ["9c590b2c-a6c6-4a5e-9e64-e85d5279df97"],
    "IKeyChangeProvider": ["28d0f38c-2f49-4683-b4bf-002cdaffc682"],
    "IKeyCredential": ["9585ef8d-457b-4847-b11a-fa960bbdb138"],
    "IKeyCredentialAttestationResult": ["78aab3a1-a3c1-4103-b6cc-472c44171cbb"],
    "IKeyCredentialManagerStatics": ["6aac468b-0ef1-4ce0-8290-4106da6a63b5"],
    "IKeyCredentialOperationResult": ["f53786c1-5261-4cdd-976d-cc909ac71620"],
    "IKeyCredentialRetrievalResult": ["58cd7703-8d87-4249-9b58-f6598cc9644e"],
    "IKeyDerivationAlgorithmNamesStatics": ["7b6e363e-94d2-4739-a57b-022e0c3a402a"],
    "IKeyDerivationAlgorithmNamesStatics2": ["57953fab-6044-466f-97f4-337b7808384d"],
    "IKeyDerivationAlgorithmProvider": ["e1fba83b-4671-43b7-9158-763aaa98b6bf"],
    "IKeyDerivationAlgorithmProviderStatics": ["0a22097a-0a1c-443b-9418-b9498aeb1603"],
    "IKeyDerivationParameters": ["7bf05967-047b-4a8c-964a-469ffd5522e2"],
    "IKeyDerivationParameters2": ["cd4166d1-417e-4f4c-b666-c0d879f3f8e0"],
    "IKeyDerivationParametersStatics": ["ea961fbe-f37f-4146-9dfe-a456f1735f4b"],
    "IKeyDerivationParametersStatics2": ["a5783dd5-58e3-4efb-b283-a1653126e1be"],
    "IKeyEnumerator": ["345fa92e-5e00-4319-9cae-971f7601cdcf"],
    "IKeyEventArgs": ["5ff5e930-2544-4a17-bd78-1f2fdebb106b"],
    "IKeyEventArgs2": ["583add98-0790-4571-9b12-645ef9d79e42"],
    "IKeyEventHandler": ["7c63d2e5-7a0e-4e12-b96a-7715aa6ff1c8"],
    "IKeyFrameAnimation": ["126e7f22-3ae9-4540-9a8a-deae8a4a4a84"],
    "IKeyFrameAnimation2": ["f4b488bb-2940-4ec0-a41a-eb6d801a2f18"],
    "IKeyFrameAnimation3": ["845bf0b4-d8de-462f-8753-c80d43c6ff5a"],
    "IKeyFrameAnimationFactory": ["bf0803f8-712a-4fc1-8c87-970859ed8d2e"],
    "IKeyRoutedEventArgs": ["d4cd3dfe-4079-42e9-a39a-3095d3f049c6"],
    "IKeyRoutedEventArgs2": ["1b02d57a-9634-4f14-91b2-133e42fdb3cd"],
    "IKeyRoutedEventArgs3": ["2779f5b4-ca41-411b-a8ef-f4fc78e78057"],
    "IKeySpline": ["77a163bb-d5ca-4a32-ba0b-7dff988e58a0"],
    "IKeyStorageProviderNamesStatics": ["af186ae0-5529-4602-bd94-0aab91957b5c"],
    "IKeyStorageProviderNamesStatics2": ["262d743d-9c2e-41cc-8812-c4d971dd7c60"],
    "IKeyStore": ["0fc7557d-401d-4fca-9365-da1e9850697c"],
    "IKeyTimeHelper": ["3643e480-4823-466a-abe5-5e79c8ed77ed"],
    "IKeyTimeHelperStatics": ["7fa2612c-22a9-45e9-9af7-c7416efff7a5"],
    "IKeyboardAccelerator": ["92e6181e-19ae-465a-9b3c-a71ee9ea7420"],
    "IKeyboardAcceleratorFactory": ["44d88a99-4bfd-4a47-a893-515f388623f6"],
    "IKeyboardAcceleratorInvokedEventArgs": ["c00b03f2-04e7-4415-b17d-d76b9490de2b"],
    "IKeyboardAcceleratorInvokedEventArgs2": ["befca4b8-5907-48ee-8e21-9c969078fa11"],
    "IKeyboardAcceleratorStatics": ["3bd43d51-9bb3-456d-bf15-804adfb86261"],
    "IKeyboardCapabilities": ["3a3f9b56-6798-4bbc-833e-0f34b17c65ff"],
    "IKeyboardDeliveryInterceptor": ["b4baf068-8f49-446c-8db5-8c0ffe85cc9e"],
    "IKeyboardDeliveryInterceptorStatics": ["f9f63ba2-ceba-4755-8a7e-14c0ffecd239"],
    "IKeyboardInputBuffer": ["3776ee93-8079-40cc-8c2f-a7a997cf9d6e"],
    "IKeypadPressedEventArgs": ["d3a43900-b4fa-49cd-9442-89af6568f601"],
    "IKeypadPressedEventHandler": ["e637a454-c527-422c-8926-c9af83b559a0"],
    "IKeywordDetectorOemAdapter": ["a13f4e6a-3bc5-46b4-88fb-f39014b51ac9"],
    "IKindDescriptionFactory": ["fdada2fa-894d-47d8-ae78-adf1fd7f28df"],
    "IKnowledgeSyncProvider": ["43434a49-8da4-47f2-8172-ad7b8b024978"],
    "IKnownAdaptiveNotificationHintsStatics": ["06206598-d496-497d-8692-4f7d7c2770df"],
    "IKnownAdaptiveNotificationTextStylesStatics": ["202192d7-8996-45aa-8ba1-d461d72c2a1b"],
    "IKnownAutoListManager": ["a768a74d-ae70-45d6-9997-ea0c0bd5513e"],
    "IKnownCSimFilePathsStatics": ["b458aeed-49f1-4c22-b073-96d511bf9c35"],
    "IKnownDeviceTypesStatics": ["ee5479c2-5448-45da-ad1b-24948c239094"],
    "IKnownFolder": ["3aa7af7e-9b36-420c-a8e3-f77d4674a488"],
    "IKnownFolderAllowPrivateFlags": ["700ea002-ec3d-4976-9a08-964b8bba3927"],
    "IKnownFolderManager": ["8be2d872-86aa-4d47-b776-32cca40c7018"],
    "IKnownFolderManagerPriv": ["2fc35761-0f20-4ab5-80c7-856e9679f228"],
    "IKnownFolderProperties": ["0e207e42-dc38-440d-9b00-2e8cf0e23c8d"],
    "IKnownFoldersCameraRollStatics": ["5d115e66-27e8-492f-b8e5-2f90896cd4cd"],
    "IKnownFoldersPlaylistsStatics": ["dad5ecd6-306f-4d6a-b496-46ba8eb106ce"],
    "IKnownFoldersSavedPicturesStatics": ["055c93ea-253d-467c-b6ca-a97da1e9a18d"],
    "IKnownFoldersStatics": ["5a2a7520-4802-452d-9ad9-4351ada7ec35"],
    "IKnownFoldersStatics2": ["194bd0cd-cf6e-4d07-9d53-e9163a2536e9"],
    "IKnownFoldersStatics3": ["c5194341-9742-4ed5-823d-fc1401148764"],
    "IKnownFoldersStatics4": ["1722e6bf-9ff9-4b21-bed5-90ecb13a192e"],
    "IKnownNotificationBindingsStatics": ["79427bae-a8b7-4d58-89ea-76a7b7bccded"],
    "IKnownRemoteSystemCapabilitiesStatics": ["8108e380-7f8a-44e4-92cd-03b6469b94a3"],
    "IKnownRetailInfoPropertiesStatics": ["99571178-500f-487e-8e75-29e551728712"],
    "IKnownRuimFilePathsStatics": ["3883c8b9-ff24-4571-a867-09f960426e14"],
    "IKnownScopeFiller": ["295c3011-e9b9-43de-a04c-4800da69f4d3"],
    "IKnownSimFilePathsStatics": ["80cd1a63-37a5-43d3-80a3-ccd23e8fecee"],
    "IKnownSimpleHapticsControllerWaveformsStatics": ["3d577ef7-4cee-11e6-b535-001bdc06ab3b"],
    "IKnownSmartCardAppletIds": ["7b04d8d8-95b4-4c88-8cea-411e55511efc"],
    "IKnownUSimFilePathsStatics": ["7c34e581-1f1b-43f4-9530-8b092d32d71f"],
    "IKnownUserPropertiesStatics": ["7755911a-70c5-48e5-b637-5ba3441e4ee4"],
    "IKsComponentId": ["1136a91a-2bef-45b3-91d9-0a58472ee8a7"],
    "IKsDeviceFunctions": ["e234f2e2-bd69-4f8c-b3f2-7cd79ed466bd", "e234f2e2-bd69-4f8c-b3f2-7cd79ed466bd"],
    "IKsFastClock": ["c9902485-c180-11d2-8473-d42394459e5e", "c9902485-c180-11d2-8473-d42394459e5e"],
    "IKsFormatSupport": ["3cb4a69d-bb6f-4d2b-95b7-452d2c155db5"],
    "IKsJackContainerId": ["c99af463-d629-4ec4-8c00-e54d68154248"],
    "IKsJackDescription": ["4509f757-2d46-4637-8e62-ce7db944f57b"],
    "IKsJackDescription2": ["478f3a9b-e0c9-4827-9228-6f5505ffe76a"],
    "IKsJackSinkInformation": ["d9bd72ed-290f-4581-9ff3-61027a8fe532"],
    "IKsNodeControl": ["11737c14-24a7-4bb5-81a0-0d003813b0c4"],
    "IKsPinFactory": ["cd5ebe6b-8b6e-11d1-8ae0-00a0c9223196"],
    "IKsTopologyInfo": ["720d4ac0-7533-11d0-a5d6-28db04c10000"],
    "IL2CacheEntry": ["5769d5a6-d3fd-49a8-8a34-ffe4f8a26ea2"],
    "ILCIEComponent": ["d2649e5e-e1a3-4255-b764-d7531a794042"],
    "ILCIEParentComponent": ["c00fc1fe-fa95-4d94-b79c-0c13f0a03c78"],
    "ILCIEProxyControl": ["5df06db2-c1c2-48b6-8bb6-9cd88eac5015"],
    "ILCIESerializable": ["0acb838f-a152-4108-ab65-06e73c92ee5f"],
    "ILCIESerializableContainer": ["5a3dd708-20d3-4c5c-a470-44ffbb24a72d"],
    "ILCIESharedMemoryObject": ["29c3390d-b55c-482e-9e92-1e0064b5ca54"],
    "ILCIEShowInternetSecurity": ["4db066e1-93a3-496f-9ad8-d86b4aaecd68"],
    "ILCIEThreadRef": ["3e322340-e4a8-4292-9d52-24e5b7b08253"],
    "ILLTDEnumerationEvents": ["480611c4-18d1-4be9-92bd-0918605ec39f"],
    "ILLTDEnumerator": ["b9d905d7-aa24-4208-ba33-010c8c1bd200"],
    "ILLTDEventProperties": ["47bde00f-00c7-4b5b-b6fe-ff276d0cfbe3"],
    "ILLTDGlobalEvents": ["e485b5dd-ca2d-45de-a300-215c7a1dee54"],
    "ILLTDMap": ["bc190dff-8708-4488-bf62-b94bef994f44"],
    "ILLTDMapper": ["2fa7433a-62e8-4a41-921b-3dccc6a763a6"],
    "ILLTDMappingEvents": ["efa8a829-0b92-44ea-a882-eac405cf768b"],
    "ILLTDNode": ["ce6aeb1f-fcbb-4a7f-a384-73d1656bae70"],
    "ILSCSlideshowCallback": ["ba07f11c-ca4d-4c42-8646-7fa9e260b31d"],
    "ILSCSlideshowDCompDirectHost": ["00d33981-e83f-4e0c-b7d6-f7c0ee32d2fe"],
    "ILSCSlideshowFeedManager": ["cc74a6af-371a-4fef-ba16-ee26f317db03"],
    "ILSCSlideshowHandleExchange": ["36913c75-97ec-4583-b266-c5be3033c4cb"],
    "ILSCSlideshowManager": ["94190d6c-fa27-4714-b422-02ee93b8025e"],
    "ILSCSlideshowServer": ["805760ce-ce47-4c6f-abac-9c932730d0d6"],
    "ILVRange": ["96a23e16-a1bc-11d1-b084-00c04fc33aa5"],
    "ILamp": ["047d5b9a-ea45-4b2b-b1a2-14dff00bde7b"],
    "ILampArray": ["7ace9787-c8a0-4e95-a1e0-d58676538649"],
    "ILampArrayBitmapEffect": ["3238e065-d877-4627-89e5-2a88f7052fa6"],
    "ILampArrayBitmapEffectFactory": ["13608090-e336-4c8f-9053-a92407ca7b1d"],
    "ILampArrayBitmapRequestedEventArgs": ["c8b4af9e-fe63-4d51-babd-619defb454ba"],
    "ILampArrayBlinkEffect": ["ebbf35f6-2fc5-4bb3-b3c3-6221a7680d13"],
    "ILampArrayBlinkEffectFactory": ["879f1d97-9f50-49b2-a56f-013aa08d55e0"],
    "ILampArrayColorRampEffect": ["2b004437-40a7-432e-a0b9-0d570c2153ff"],
    "ILampArrayColorRampEffectFactory": ["520bd133-0c74-4df5-bea7-4899e0266b0f"],
    "ILampArrayCustomEffect": ["ec579170-3c34-4876-818b-5765f78b0ee4"],
    "ILampArrayCustomEffectFactory": ["68b4774d-63e5-4af0-a58b-3e535b94e8c9"],
    "ILampArrayEffect": ["11d45590-57fb-4546-b1ce-863107f740df"],
    "ILampArrayEffectPlaylist": ["7de58bfe-6f61-4103-98c7-d6632f7b9169"],
    "ILampArrayEffectPlaylistStatics": ["fb15235c-ea35-4c7f-a016-f3bfc6a6c47d"],
    "ILampArraySolidEffect": ["441f8213-43cc-4b33-80eb-c6ddde7dc8ed"],
    "ILampArraySolidEffectFactory": ["f862a32c-5576-4341-961b-aee1f13cf9dd"],
    "ILampArrayStatics": ["7bb8c98d-5fc1-452d-bb1f-4ad410d398ff"],
    "ILampArrayUpdateRequestedEventArgs": ["73560d6a-576a-48af-8539-67ffa0ab3516"],
    "ILampAvailabilityChangedEventArgs": ["4f6e3ded-07a2-499d-9260-67e304532ba4"],
    "ILampInfo": ["30bb521c-0acf-49da-8c10-150b9cf62713"],
    "ILampStatics": ["a822416c-8885-401e-b821-8e8b38a8e8ec"],
    "ILanIdentifier": ["48aa53aa-1108-4546-a6cb-9a74da4b7ba0"],
    "ILanIdentifierData": ["a74e83c3-d639-45be-a36a-c4e4aeaf6d9b"],
    "ILangToolsBroker": ["b39f0f46-e68f-42aa-8646-19145c75e708"],
    "ILanguage": ["ea79a752-f7c2-4265-b1bd-c4dec4e4f080"],
    "ILanguage2": ["6a47e5b5-d94d-4886-a404-a5a5b9d5b494"],
    "ILanguage3": ["c6af3d10-641a-5ba4-bb43-5e12aed75954"],
    "ILanguageComponentType": ["b874c8ba-0fa2-11d3-9d8e-00c04f72d980"],
    "ILanguageExceptionErrorInfo": ["04a2dbf3-df83-116c-0946-0812abf6e07d"],
    "ILanguageExceptionErrorInfo2": ["5746e5c4-5b97-424c-b620-2822915734dd"],
    "ILanguageExceptionStackBackTrace": ["cbe53fb5-f967-4258-8d34-42f5e25833de"],
    "ILanguageExceptionTransform": ["feb5a271-a6cd-45ce-880a-696706badc65"],
    "ILanguageExtensionSubtags": ["7d7daf45-368d-4364-852b-dec927037b85"],
    "ILanguageFactory": ["9b0252ac-0c27-44f8-b792-9793fb66c63e"],
    "ILanguageFont": ["b12e5c3a-b76d-459b-beeb-901151cd77d1"],
    "ILanguageFontGroup": ["f33a7fc3-3a5c-4aea-b9ff-b39fb242f7f6"],
    "ILanguageFontGroupFactory": ["fcaeac67-4e77-49c7-b856-dde934fc735b"],
    "ILanguageResources": ["fb8026e2-3572-11d3-b282-00c04fa3027b"],
    "ILanguageStatics": ["b23cd557-0865-46d4-89b8-d59be8990f0d"],
    "ILanguageStatics2": ["30199f6e-914b-4b2a-9d6e-e3b0e27dbe4f"],
    "ILanguageStatics3": ["d15ecb5a-71de-5752-9542-fac5b4f27261"],
    "ILastResourceManager": ["4d964ad4-5b33-11d3-8a91-00c04f79eb6d"],
    "ILatLongReport": ["7fed806d-0ef8-4f07-80ac-36a0beae3134"],
    "ILatLongReportFactory": ["3f0804cb-b114-447d-83dd-390174ebb082"],
    "ILateRestoreHelper": ["de897046-8eb9-4f78-bb3c-c1cb10b1a8e7"],
    "ILaunchActivatedEventArgs": ["fbc93e26-a14a-4b4f-82b0-33bed920af52"],
    "ILaunchActivatedEventArgs2": ["0fd37ebc-9dc9-46b5-9ace-bd95d4565345"],
    "ILaunchOperationWorker": ["28317368-4896-454b-aa95-032914fc45b5"],
    "ILaunchSourceAppUserModelId": ["989191ac-28ff-4cf0-9584-e0d078bc2396"],
    "ILaunchSourceViewSizePreference": ["e5aa01f7-1fb8-4830-8720-4e6734cbd5f3"],
    "ILaunchTargetMonitor": ["266fbc7e-490d-46ed-a96b-2274db252003"],
    "ILaunchTargetViewSizePreference": ["2f0666c6-12f7-4360-b511-a394a0553725"],
    "ILaunchUIContext": ["1791e8f6-21c7-4340-882a-a6a93e3fd73b"],
    "ILaunchUIContextProvider": ["0d12c4c8-a3d9-4e24-94c1-0e20c5a956c4"],
    "ILaunchUriResult": ["ec27a8df-f6d5-45ca-913a-70a40c5c8221"],
    "ILaunchableShellExperience": ["471241bb-09e6-4418-a245-867813d3771c"],
    "ILauncherOptions": ["bafa21d8-b071-4cd8-853e-341203e557d3"],
    "ILauncherOptions2": ["3ba08eb4-6e40-4dce-a1a3-2f53950afb49"],
    "ILauncherOptions3": ["f0770655-4b63-4e3a-9107-4e687841923a"],
    "ILauncherOptions4": ["ef6fd10e-e6fb-4814-a44e-57e8b9d9a01b"],
    "ILauncherOutsideHolographic": ["d10ec26d-1c68-45e9-a5a7-a5b314fdb672"],
    "ILauncherStatics": ["277151c3-9e3e-42f6-91a4-5dfdeb232451"],
    "ILauncherStatics2": ["59ba2fbb-24cb-4c02-a4c4-8294569d54f1"],
    "ILauncherStatics3": ["234261a8-9db3-4683-aa42-dc6f51d33847"],
    "ILauncherStatics4": ["b9ec819f-b5a5-41c6-b3b3-dd1b3178bcf2"],
    "ILauncherStatics5": ["5b24ef84-d895-5fea-9153-1ac49aed9ba9"],
    "ILauncherTipContextMenu": ["b8c1db5f-cbb3-48bc-afd9-ce6b880c79ed"],
    "ILauncherTipContextMenuSettingChangeListener": ["5c616abc-7341-4100-950b-69f3b00f548c"],
    "ILauncherUIOptions": ["1b25da6e-8aa6-41e9-8251-4165f5985f49"],
    "ILauncherViewOptions": ["8a9b29f1-7ca7-49de-9bd3-3c5b7184f616"],
    "ILayer": ["b32fbf42-effb-4862-b164-6565c2ef32f4"],
    "ILayerCommandHandler": ["0f2d35b3-db34-4966-bea6-59c7cd203862"],
    "ILayerDynamicStateEvents": ["72c94cf1-f24c-4c2e-9a4f-b23439babd5e"],
    "ILayerState": ["a4fc45c4-abdd-47cb-af94-8697249a8558"],
    "ILayerStateEvents": ["55cf8fa7-7035-4b80-80ce-51aeb5de7cfc"],
    "ILayerStateProvider": ["739cbf5d-5aed-49f8-ad1c-540094411664"],
    "ILayerUIPropPage": ["d3075f87-a7bd-4231-9f6a-60c5e07374a7"],
    "ILayerVisual": ["af843985-0444-4887-8e83-b40b253f822c"],
    "ILayerVisual2": ["98f9aeeb-6f23-49f1-90b1-1f59a14fbce3"],
    "ILayoutDumper": ["30510464-98b5-11cf-bb82-00aa00bdce0b"],
    "ILayoutInformation": ["b5384c9b-c8cf-41b3-bf16-18c8420e72c9"],
    "ILayoutInformationStatics": ["cf06cf99-58e9-4682-8326-50caab65ed7c"],
    "ILayoutInformationStatics2": ["760315b5-6d4e-4939-ac61-639863cea36b"],
    "ILayoutModifier": ["90b4135a-95ba-46ea-8caa-e05b45cd801e"],
    "ILayoutPreferencesOnAppLaunch": ["a2b8c352-914a-45ae-9f86-46236719c5c8"],
    "ILayoutProperties": ["ba1439cb-6514-4152-8a5a-9b9b5000e591"],
    "ILayoutType": ["50f4aa22-3684-4837-ab29-9485f697a0d1"],
    "ILearningModel": ["5b8e4920-489f-4e86-9128-265a327b78fa"],
    "ILearningModelBinding": ["ea312f20-168f-4f8c-94fe-2e7ac31b4aa8"],
    "ILearningModelBindingFactory": ["c95f7a7a-e788-475e-8917-23aa381faf0b"],
    "ILearningModelDevice": ["f5c2c8fe-3f56-4a8c-ac5f-fdb92d8b8252"],
    "ILearningModelDeviceFactory": ["9cffd74d-b1e5-4f20-80ad-0a56690db06b"],
    "ILearningModelDeviceFactoryNative": ["1e9b31a1-662e-4ae0-af67-f63bb337e634"],
    "ILearningModelDeviceStatics": ["49f32107-a8bf-42bb-92c7-10b12dc5d21f"],
    "ILearningModelEvaluationResult": ["b2f9bfcd-960e-49c0-8593-eb190ae3eee2"],
    "ILearningModelFeatureDescriptor": ["bc08cf7c-6ed0-4004-97ba-b9a2eecd2b4f"],
    "ILearningModelFeatureValue": ["f51005db-4085-4dfe-9fed-95eb0c0cf75c"],
    "ILearningModelOperatorProvider": ["2a222e5d-afb1-47ed-bfad-b5b3a459ec04"],
    "ILearningModelSession": ["8e58f8f6-b787-4c11-90f0-7129aeca74a9"],
    "ILearningModelSessionFactory": ["0f6b881d-1c9b-47b6-bfe0-f1cf62a67579"],
    "ILearningModelSessionFactory2": ["4e5c88bf-0a1f-5fec-ade0-2fd91e4ef29b"],
    "ILearningModelSessionOptions": ["b8f63fa1-134d-5133-8cff-3a5c3c263beb"],
    "ILearningModelSessionOptions2": ["6fcd1dc4-175f-5bd2-8de5-2f2006a25adf"],
    "ILearningModelStatics": ["e3b977e8-6952-4e47-8ef4-1f7f07897c6d"],
    "ILeavingBackgroundEventArgs": ["39c6ec9a-ae6e-46f9-a07a-cfc23f88733e"],
    "ILeavingBackgroundEventHandler": ["00b4ccd9-7a9c-4b6b-9ac4-13474f268bc4", "aaad5dad-4fc6-4aa4-b7cf-877e36ada4f6"],
    "ILegacyFindFiles": ["2946cccb-31c6-4323-92d4-b418f3e40b77"],
    "ILegacyIAccessibleProvider": ["e44c3566-915d-4070-99c6-047bff5a08f5"],
    "ILegacyInfo": ["000001ac-0000-0000-c000-000000000046"],
    "ILegacyPrintUI": ["81966513-2d8a-4056-99c4-b59ff186f2d2"],
    "ILegacyViewWrapper": ["2dd4e662-f456-4daf-aeff-84a1c012e15f"],
    "ILibraryDescription": ["86187c37-e662-4d1e-a122-7478676d7e6e"],
    "ILibraryFactory": ["12929ca2-37e4-440a-815a-759d7df24ec6"],
    "ILibraryFolderInit": ["09bec583-5e66-4457-a5f3-98302db60e12"],
    "ILibraryFolderValidationCallback": ["a7810c5d-2077-49c8-a08f-a23b17893e43"],
    "ILibraryShareEngine": ["659ad78f-1608-4a89-97d3-c8d741fdd0bc"],
    "ILicAgent": ["00194002-d9c3-11d3-8d59-0050048384e3"],
    "ILicValidator": ["919aa22c-b9ad-11d3-8d59-0050048384e3"],
    "ILicWizExternal": ["4cac6328-b9b0-11d3-8d59-0050048384e3"],
    "ILicenseChangedCallback": ["14985706-bc03-4a60-974e-1a7512567c5b"],
    "ILicenseChangedEventHandler": ["d4a50255-1369-4c36-832f-6f2d88e3659b"],
    "ILicenseIdentityContext": ["da85c393-2379-496d-a405-4def5e31f0aa"],
    "ILicenseIdentityContextSnapshot": ["0bd7b327-541e-4069-9e90-a1f2f9dd1ae5"],
    "ILicenseIdentityContextSnapshotRemediation": ["7f3fa025-e5e7-4d1d-82bc-3226aace4a1d"],
    "ILicenseInformation": ["8eb7dc30-f170-4ed5-8e21-1516da3fd367"],
    "ILicenseInstance": ["54d34ad6-0013-417b-9bb9-1dca63cab256"],
    "ILicenseInstanceInternal": ["03f4bb06-6c67-473a-8971-74761b3acf09"],
    "ILicenseManager": ["0c8de26f-bc3e-473a-ba3d-68cad2bf533f"],
    "ILicenseManager2": ["72ce0451-d460-4e78-b0ab-21890caf047c"],
    "ILicenseManagerFactory": ["8b79d867-8c47-4277-bc08-a51f22d951f1"],
    "ILicenseManagerStatics": ["b5ac3ae0-da47-4f20-9a23-09182c9476ff"],
    "ILicenseManagerStatics2": ["ab2ec47b-1f79-4480-b87e-2c499e601ba3"],
    "ILicenseManagerSubscriptions": ["d2a977cd-dfda-4162-ac48-e69d2820e81b"],
    "ILicenseManagerUserContext": ["ec241ad6-34c1-43cd-a349-d375905fc1e3"],
    "ILicenseProxyService": ["835af12e-4e5d-4ef6-bea7-09cb00dc8075"],
    "ILicenseProxyServiceTest": ["0362300c-886c-4a51-bfe0-63e0a7a8181a"],
    "ILicenseProxyServiceWithUserTicket": ["2f955a33-0cb0-4688-b365-d1a312aaaef3"],
    "ILicenseRemediationInfo": ["2082cf4e-067d-42a8-a528-43cfc302c067"],
    "ILicenseRequestData": ["1d9d0f8b-da81-424c-8f7e-92f3862ad1ad"],
    "ILicenseResponseData": ["9ed52611-9781-48a7-9bbf-61231feab825"],
    "ILicenseRootRequestData": ["bc38866e-eb56-4778-9757-a7e2cd8f4b7f"],
    "ILicenseRootResponseData": ["19bc68d4-8e48-41d6-966e-c4fd915f8143"],
    "ILicenseSatisfactionInfo": ["3ccbb08f-db31-48d5-8384-fa17c81474e2"],
    "ILicenseSatisfactionResult": ["3c674f73-3c87-4ee1-8201-f428359bd3af"],
    "ILicenseStorageService": ["6378598d-0ce5-4c84-8e31-ec14ede3b998"],
    "ILicenseStorageServiceTest": ["d5a7212c-a3e2-473f-a0ca-4a4e76a5601c"],
    "ILicenseTimerService": ["29c14b44-390b-40cb-9ccd-05a4cea88526"],
    "ILicenseTimerServiceCallback": ["5cdd240a-d2ab-4ef2-acf5-1ff2d460d0d9"],
    "ILicensedClassManager": ["6d5140d4-7436-11ce-8034-00aa006009fa"],
    "ILifetimeManagerRemote": ["fc99c60d-d59b-4b2b-b73d-3a1cc9f2aafa"],
    "ILightDismissNotification": ["8d4d1ec2-4740-4fc5-b4b1-6dc3722a2eeb"],
    "ILightDismissProvider": ["b849acb5-8ac5-4fb8-88b6-55c749d25a44"],
    "ILightDismissProviderTest": ["aadfb5d0-90e7-488d-a04c-271e59b564fd"],
    "ILightSensor": ["f84c0718-0c54-47ae-922e-789f57fb03a0"],
    "ILightSensor2": ["486b24e8-a94c-4090-8f48-09f782a9f7d5"],
    "ILightSensor3": ["4876d0ff-9f4c-5f72-adbd-a3471b063c00"],
    "ILightSensorDataThreshold": ["b160afd1-878f-5492-9f2c-33dc3ae584a3"],
    "ILightSensorDeviceId": ["7fee49f8-0afb-4f51-87f0-6c26375ce94f"],
    "ILightSensorReading": ["ffdf6300-227c-4d2b-b302-fc0142485c68"],
    "ILightSensorReading2": ["b7512185-44a3-44c9-8190-9ef6de0a8a74"],
    "ILightSensorReadingChangedEventArgs": ["a3a2f4cf-258b-420c-b8ab-8edd601ecf50"],
    "ILightSensorStatics": ["45db8c84-c3a8-471e-9a53-6457fad87c0e"],
    "ILightSensorStatics2": ["0ec0a650-ddc6-40ab-ace3-ec3359d42c51"],
    "ILimitedAccessFeatureRequestResult": ["d45156a6-1e24-5ddd-abb4-6188aba4d5bf"],
    "ILimitedAccessFeaturesStatics": ["8be612d4-302b-5fbf-a632-1a99e43e8925"],
    "ILimitedItemsView": ["d92e45a1-c7c0-4380-bea1-10beb57d9610"],
    "ILimiterEffectDefinition": ["6b755d19-2603-47ba-bdeb-39055e3486dc"],
    "ILimiterEffectDefinitionFactory": ["ecbae6f1-61ff-45ef-b8f5-48659a57c72d"],
    "ILineBreak": ["645589c4-f769-41ed-895b-8a1b2fb31562"],
    "ILineDisplay": ["24f5df4e-3c99-44e2-b73f-e51be3637a8c"],
    "ILineDisplay2": ["c296a628-ef44-40f3-bd1c-b04c6a5cdc7d"],
    "ILineDisplayAttributes": ["c17de99c-229a-4c14-a6f1-b4e4b1fead92"],
    "ILineDisplayCapabilities": ["5a15b5d1-8dc5-4b9c-9172-303e47b70c55"],
    "ILineDisplayCursor": ["ecdffc45-754a-4e3b-ab2b-151181085605"],
    "ILineDisplayCursorAttributes": ["4e2d54fe-4ffd-4190-aae1-ce285f20c896"],
    "ILineDisplayCustomGlyphs": ["2257f63c-f263-44f1-a1a0-e750a6a0ec54"],
    "ILineDisplayMarquee": ["a3d33e3e-f46a-4b7a-bc21-53eb3b57f8b4"],
    "ILineDisplayStatics": ["022dc0b6-11b0-4690-9547-0b39c5af2114"],
    "ILineDisplayStatics2": ["600c3f1c-77ab-4968-a7de-c02ff169f2cc"],
    "ILineDisplayStatisticsCategorySelector": ["b521c46b-9274-4d24-94f3-b6017b832444"],
    "ILineDisplayStatusUpdatedEventArgs": ["ddd57c1a-86fb-4eba-93d1-6f5eda52b752"],
    "ILineDisplayStoredBitmap": ["f621515b-d81e-43ba-bf1b-bcfa3c785ba0"],
    "ILineDisplayWindow": ["d21feef4-2364-4be5-bee1-851680af4964"],
    "ILineDisplayWindow2": ["a95ce2e6-bdd8-4365-8e11-de94de8dff02"],
    "ILineGeometry": ["30edd4a2-8fc5-40af-a7a2-c27fe7aa1363"],
    "ILineGeometryStatics": ["578ae763-5562-4ee4-8703-ea4036d891e3"],
    "ILineScrollerSpy": ["d294970d-48f2-48e7-9487-ab7a05a0bcfe"],
    "ILineSegment": ["ef6a2e25-3ff0-4420-a411-7182a4cecb15"],
    "ILineSegmentStatics": ["9fcab141-04c0-4afb-87b3-e800b969b894"],
    "ILineStatics": ["267c123d-6ea4-4c50-8b1d-50207aff1e8a"],
    "ILinearColorKeyFrame": ["66fdb6ef-ac81-4611-b1d2-61f545983f03"],
    "ILinearDoubleKeyFrame": ["8efdf265-9a7b-431d-8f0c-14c56b5ea4d9"],
    "ILinearEasingFunction": ["9400975a-c7a6-46b3-acf7-1a268a0a117d"],
    "ILinearGradientBrush": ["8e96d16b-bb84-4c6f-9dbf-9d6c5c6d9c39"],
    "ILinearGradientBrushFactory": ["0ae0861c-1e7a-4fed-9857-ea8caa798490"],
    "ILinearGradientBrushStatics": ["7af6e504-2dc3-40e3-be0b-b314c13cb991"],
    "ILinearPointKeyFrame": ["e7c9b8ef-af24-49ee-84f1-a86600a4e319"],
    "ILinguisticService": ["9d36af1e-bb5a-4d46-a8c3-a5eff90c28d0"],
    "ILink": ["22827db0-8266-4e0f-8172-9c169b813d28"],
    "ILinkItem": ["6e576dc2-4ba0-4351-95c0-8836295dcea6"],
    "ILinkItemHandler": ["dcfab355-c289-4b38-8f72-a360f4f2bf54"],
    "ILinkTarget": ["95e2a960-a4e4-4a71-bb4b-b07775b69cdd"],
    "ILinkTrackingInfo": ["f80759f1-8fcf-4244-8324-cf29513cec29"],
    "ILinksBand": ["d91b8947-f8ca-4508-a58a-2d8a49bf6111"],
    "ILinksMonitor": ["8b63fee2-ae22-40cc-85bc-45ccb7578289"],
    "ILinksMonitorEvents": ["765eb303-124e-4e48-a6bd-601eb5bc5950"],
    "ILinksToolbar": ["9f8f5a55-2564-4e24-902d-83c7d096d3d7"],
    "IListBox": ["e9f3b9ff-8e91-4ecf-a707-c927f694f881"],
    "IListBox2": ["70572aba-8ad1-4085-9350-deee359294e3"],
    "IListBoxAutomationPeer": ["8cd0d608-b402-4a6e-bd9a-343f8845eb32"],
    "IListBoxAutomationPeerFactory": ["e2362185-7df6-49f7-8abc-4c33f1a3d46e"],
    "IListBoxFactory": ["60cdfda2-2f44-444b-9c94-b8c9fda46f59"],
    "IListBoxItem": ["43c13323-6edf-4e4b-b6b2-3a93eec41d95"],
    "IListBoxItemAutomationPeer": ["1bc6e1c6-2997-42df-99eb-92bc1dd149fb"],
    "IListBoxItemAutomationPeerFactory": ["509f9dd8-b0aa-443f-a110-41209af44f1c"],
    "IListBoxItemDataAutomationPeer": ["fd7d5fee-fde0-482a-8084-dcebba5b9806"],
    "IListBoxItemDataAutomationPeerFactory": ["d7924e16-bd8d-4662-a995-20ff9a056093"],
    "IListBoxItemFactory": ["4398b8d4-a3de-402c-b23d-190384b27ca8"],
    "IListBoxStatics": ["6d3f7f73-706a-4e53-a9aa-c9a53c9cdd70"],
    "IListBoxStatics2": ["0089adeb-b709-4c8d-b1ed-4a7d97ee7716"],
    "IListControlProvider": ["16770868-239c-445b-a01d-f26c7fbbf26c"],
    "IListDebugFrameInfo": ["11d2710f-2e6f-4931-8fc8-936bfb5938a3"],
    "IListDebugPropertyInfo": ["2a9ddad2-bf0f-4406-b57d-be93ad78ee05"],
    "IListDescription": ["077386d3-344c-4e33-aa67-31408b2ee7a8"],
    "IListIUnknown": ["fdc0603f-f733-49c9-aad2-ac3e0ae513bb"],
    "IListIVxTextBuffer": ["121811be-de48-4320-b7c6-1237c0d2ff3b"],
    "IListIVxTextChange": ["7627a97f-187f-428e-bba9-07183f73a088"],
    "IListIVxTextSnapshot": ["b886572e-8f74-43c8-b8c1-f8bc0bdb5d1c"],
    "IListIVxTrackingSpan": ["fb17674f-3e6c-4ad2-9d17-e605c3f45262"],
    "IListItem": ["bdd1f04e-858b-11d1-b16a-00c0f0283628"],
    "IListItems": ["bdd1f04c-858b-11d1-b16a-00c0f0283628"],
    "IListPickerFlyout": ["0f0cb9d7-e5f3-45e6-9063-ff7bbb193c47"],
    "IListPickerFlyoutPresenter": ["68155fb3-883e-417a-80d0-e2fd88410084"],
    "IListPickerFlyoutPresenterAutomationPeer": ["56dfdc58-2395-4060-8047-8ea463698a24"],
    "IListPickerFlyoutStatics": ["fee25b97-8b96-4602-81d2-82fd8e0f7ea8"],
    "IListSubItem": ["bdd1f055-858b-11d1-b16a-00c0f0283628"],
    "IListSubItems": ["bdd1f053-858b-11d1-b16a-00c0f0283628"],
    "IListView": [
        "bdd1f049-858b-11d1-b16a-00c0f0283628",
        "e5b16af2-3990-4681-a609-1f060cd14269",
        "f6ce8c6d-fe96-41ad-a64a-c2b81c4af7f8",
    ],
    "IListViewAutomationPeer": ["73cecc87-c0dc-4260-9148-75e9864a7230"],
    "IListViewAutomationPeerFactory": ["65f39174-eaa2-4e44-8be6-4cca28cd0288"],
    "IListViewBase": ["3d0813ba-6890-4537-bfe5-796d9458edd6"],
    "IListViewBase2": ["d1c2a4f7-78a3-4491-86e0-2ddebc007ac5"],
    "IListViewBase3": ["b364c035-0a13-406f-a3fb-f30e7ddca94c"],
    "IListViewBase4": ["18b7792b-11dc-4eb6-a7bc-741adb3eeb79"],
    "IListViewBase5": ["1a9c6e99-1719-4b80-b335-628331a07019"],
    "IListViewBase6": ["f8a42637-965b-483b-94e5-e5c9fef0e352"],
    "IListViewBaseAutomationPeer": ["87ec7649-b83d-4e55-9afd-bd835e748f5c"],
    "IListViewBaseAutomationPeerFactory": ["70d3c2be-8950-4647-9362-fd002f8ff82e"],
    "IListViewBaseFactory": ["e67e6c7f-150f-46d0-a6ac-c5002bd9ca53"],
    "IListViewBaseHeaderItem": ["6d0ded27-0d19-4091-8917-ce7c85c1e630"],
    "IListViewBaseHeaderItemAutomationPeer": ["7cb8b732-c1f0-4a3c-bc14-85dd48dedb85"],
    "IListViewBaseHeaderItemAutomationPeerFactory": ["40ec995f-d631-4004-832e-6d8643e51561"],
    "IListViewBaseHeaderItemFactory": ["3872a6a1-ea19-455f-9df7-147cc41d329c"],
    "IListViewBaseStatics": ["8532b8f7-3e16-455b-89a8-c1346223f6d3"],
    "IListViewBaseStatics2": ["821c00c8-78cc-411f-9f2e-a55758227f3e"],
    "IListViewBaseStatics3": ["3b539091-31c6-4d0c-90af-5dc1d6ae9c05"],
    "IListViewBaseStatics4": ["ad13258b-fbd0-4f18-8bf8-9b8613951c22"],
    "IListViewBaseStatics5": ["40346fcf-0476-4259-895f-a6569738620f"],
    "IListViewFactory": ["bdff696d-3f22-41f9-97a6-883134a76113"],
    "IListViewFooter": ["f0034da8-8a22-4151-8f16-2eba76565bcc"],
    "IListViewFooterCallback": ["88eb9442-913b-4ab4-a741-dd99dcb7558b"],
    "IListViewHeaderItem": ["1b61baeb-e196-4b3b-a5f9-1ed636f3f79b"],
    "IListViewHeaderItemAutomationPeer": ["67ab1e4b-ad61-4c88-ba45-0f3a8d061f8f"],
    "IListViewHeaderItemAutomationPeerFactory": ["07668694-2ca5-4be4-a8b9-592d48f76087"],
    "IListViewHeaderItemFactory": ["68d2c96a-96b0-4f08-a7a5-f1086720a0fa"],
    "IListViewItem": ["b7bb4305-3dd9-43de-a8c0-c472f085bc11"],
    "IListViewItemAutomationPeer": ["ca114e70-a16d-4d09-a1cf-1856ef98a9ec"],
    "IListViewItemAutomationPeerFactory": ["c47dfbc0-facc-4024-a73b-17ec4e662654"],
    "IListViewItemDataAutomationPeer": ["15a8d7fd-d7a5-4a6c-963c-6f7ce464671a"],
    "IListViewItemDataAutomationPeerFactory": ["d0db12bb-d715-4523-acc0-1e1072d8e32b"],
    "IListViewItemFactory": ["f431073d-9cac-42a2-82df-0f4490bc4e2e"],
    "IListViewItemPresenter": ["fc8946bd-a3a2-4969-8174-25b5d3c28033"],
    "IListViewItemPresenter2": ["f5dc5496-e122-4c57-a625-ac4b08fb2d4c"],
    "IListViewItemPresenter3": ["36620013-0390-4e30-ad97-8744404f7010"],
    "IListViewItemPresenterFactory": ["e0777cfd-f7e4-4a67-9ac0-a994fcacd020"],
    "IListViewItemPresenterStatics": ["6504a55a-15dd-42fb-aa5d-2d8ce2e9c294"],
    "IListViewItemPresenterStatics2": ["4cb3b945-d24d-42a3-9e83-a86d0618bf1b"],
    "IListViewItemPresenterStatics3": ["c3d3d11e-fa26-4ce7-a4ed-ff948f01b7c0"],
    "IListViewItemTemplateSettings": ["67af84bf-8279-4686-9326-cd189f27575d"],
    "IListViewItemToKeyHandler": ["6af5da76-7e8b-4a91-9a56-460cb47d523f"],
    "IListViewKeyToItemHandler": ["26fd5855-b530-4688-b9f0-428249178ef8"],
    "IListViewPersistenceHelper": ["05bde8a6-2191-4b4b-8c22-9b25676e806e"],
    "IListViewPersistenceHelperStatics": ["6d0c2b08-bb9b-44f9-8063-5c3f9c21884b"],
    "IListVxSnapshotPoint": ["587a5a1a-4b4e-43f8-896f-7d61716a33cb"],
    "IListVxSnapshotSpan": ["75970b1d-36b9-419b-bf43-ec2a66776955"],
    "IListVxSpan": ["f265752d-e60c-4c02-a3d4-9200a936b1b4"],
    "IListingInformation": ["588b4abf-bc74-4383-b78c-99606323dece"],
    "IListingInformation2": ["c0fd2c1d-b30e-4384-84ea-72fefa82223e"],
    "ILoadChangeContext": ["44a4aaca-ec39-46d5-b5c9-d633c0ee67e2"],
    "ILoadCompletedEventHandler": ["aebaf785-43fc-4e2c-95c3-97ae84eabc8e"],
    "ILoadFilter": ["c7310722-ac80-11d1-8df3-00c04fb6ef4f"],
    "ILoadFilterWithPrivateComActivation": ["40bdbd34-780b-48d3-9bb6-12ebd4ad2e75"],
    "ILoadedImageSourceLoadCompletedEventArgs": ["1ac60b1e-7837-4489-b3e5-d0d5ad0a56c4"],
    "ILoadedImageSurface": ["050c8313-6737-45ba-8531-33094febef55"],
    "ILoadedImageSurfaceStatics": ["22b8edf6-84ad-40ab-937d-4871613e765d"],
    "ILoadedStorageViewInternal": ["f3f052bf-4de6-46aa-995b-69f14322b099"],
    "ILocalAccountManager": ["ce6af879-5386-4daf-83fd-850b56486428"],
    "ILocalAccountManagerAuthBufferHelpers": ["4c939908-0198-4da2-bd62-ed4938edb44f"],
    "ILocalAccountManagerNgcHelpers": ["c42d0c9d-19d2-4480-995c-976ccd8de49d"],
    "ILocalAccountTaskPrivate": ["7006713f-0333-463d-889e-2314bcd790ec"],
    "ILocalCategoriesStatics": ["f49399f5-8261-4321-9974-ef92d49a8dca"],
    "ILocalConnectionListener": ["b8482f5b-c1cb-4cfb-a1e3-86618cc8067e"],
    "ILocalContentSuggestionSettings": ["eeaeb062-743d-456e-84a3-23f06f2d15d7"],
    "ILocalCopy": ["d5ab5937-4a2a-4c16-85b3-56bbed37487b"],
    "ILocalCopyDownloadSettings": ["667708d1-a931-4a85-9999-609eaa7dd85a"],
    "ILocalFileBroker": ["0fbfe6c9-3b4c-4d47-a5b7-159b55534d66"],
    "ILocalLocation": ["bb0fe9ab-4502-4f2c-94a9-0d60de0e2163"],
    "ILocalLocation2": ["6e9e307c-ecb5-4ffc-bb8c-ba50ba8c2dc6"],
    "ILocalLocationFinderResult": ["d09b6cc6-f338-4191-9fd8-5440b9a68f52"],
    "ILocalLocationFinderStatics": ["d2ef7344-a0de-48ca-81a8-07c7dcfd37ab"],
    "ILocalLocationHoursOfOperationItem": ["23548c72-a1c7-43f1-a4f0-1091c39ec640"],
    "ILocalLocationRatingInfo": ["cb1dab56-3354-4311-8bc0-a2d4d5eb806e"],
    "ILocalMachineNames": ["0000015a-0000-0000-c000-000000000046"],
    "ILocalMapTileDataSource": ["616257b5-9108-4f12-8bf4-bb3c8f6274e5"],
    "ILocalMapTileDataSourceFactory": ["c5cfe9fc-72ac-4839-8a0d-011f24693c79"],
    "ILocalProvider": ["b2e4eb94-e61f-478b-9fa4-d415cae5a5fd"],
    "ILocalRankerGroup": ["d7861d14-42f7-41f5-8068-bc5d23fc6415"],
    "ILocalRegistry": ["6d5140d3-7436-11ce-8034-00aa006009fa"],
    "ILocalRegistry2": ["77bb19b0-0462-11d1-aaf6-00a0c9055a90"],
    "ILocalRegistry3": ["1b01f13f-abee-4761-91af-76ce6b4c9e7a"],
    "ILocalRegistry4": ["5c45b909-e820-4acc-b894-0a013c6da212"],
    "ILocalRegistry5": ["d5f528b9-e492-43a7-afc0-f98a8fb0516d"],
    "ILocalRoamedMachine": ["9834fd4a-c5e2-4efa-b7d4-5a7af4859feb"],
    "ILocalRoamedTabs": ["efe15d70-16fc-41c9-8d9d-e32714dab88f"],
    "ILocalServerInfo": ["c835ea86-8854-4ab8-9e2b-77e29dab4c75"],
    "ILocalSettingSyncProvider": ["4d2e63e3-ec0b-4227-93ba-8ed2d9525512"],
    "ILocalSystemActivator": ["00000132-0000-0000-c000-000000000046"],
    "ILocalVideoStream": ["54024241-6c0b-49bb-b200-e4a6ec2bdeed"],
    "ILocalWeightGroup": ["bfd28008-b2a5-48bb-b0dc-a54de4d003e0"],
    "ILocalizedPropertyStore": ["cb072faa-cf74-45ab-afb0-fe3d89ffdd94"],
    "ILocallyCachedItem": ["f8bc0f33-bd7c-4872-a6fe-8dab9ed2cf44"],
    "ILocation": ["ab2ece69-56d9-4f28-b525-de1b0ee44237"],
    "ILocationCreator": ["08687bd9-c16d-4592-ae76-56c852cab45c"],
    "ILocationDescription": ["51016709-f127-43d9-a644-6d60bbd83cb6"],
    "ILocationDescription2": ["f8e6532b-c735-4517-bf1d-cbe30df8fe1c"],
    "ILocationEvents": ["cae02bbf-798b-4508-a207-35a7906dc73d"],
    "ILocationPermissions": ["d5fb0a7f-e74e-44f5-8e02-4806863a274f"],
    "ILocationPower": ["193e7729-ab6b-4b12-8617-7596e1bb191c"],
    "ILocationReport": ["c8b7f7ee-75d0-4db9-b62d-7a0f369ca456"],
    "ILocationReportFactory": ["2daec322-90b2-47e4-bb08-0da841935a6b"],
    "ILocationTrigger": ["47666a1c-6877-481e-8026-ff7e14a811a0"],
    "ILocationTriggerFactory": ["1106bb07-ff69-4e09-aa8b-1384ea475e98"],
    "ILocator": ["286d7f89-760c-4f89-80c4-66841d2507aa"],
    "ILockAppHostShellInterop": ["72163aa1-8a18-436a-9067-3a86aa7460dc"],
    "ILockApplicationHost": ["38ee31ad-d94f-4e7c-81fa-4f4436506281"],
    "ILockApplicationHostStatics": ["f48fab8e-23d7-4e63-96a1-666ff52d3b2c"],
    "ILockScreenActivatedEventArgs": ["3ca77966-6108-4a41-8220-ee7d133c8532"],
    "ILockScreenAppPositioner": ["7437db22-fcaa-4d0b-ad90-2f4cd133f967"],
    "ILockScreenBadge": ["e95105d9-2bff-4db0-9b4f-3824778b9c9a"],
    "ILockScreenCallActivatedEventArgs": ["06f37fbe-b5f2-448b-b13e-e328ac1c516a"],
    "ILockScreenCallBroker": ["bef9ea75-773f-4f44-81c1-6ef017b52802"],
    "ILockScreenCallBrokerPriv": ["a7c2344c-80d3-46af-9538-aa7b5aad574d"],
    "ILockScreenCallEndCallDeferral": ["2dd7ed0d-98ed-4041-9632-50ff812b773f"],
    "ILockScreenCallEndRequestedEventArgs": ["8190a363-6f27-46e9-aeb6-c0ae83e47dc7"],
    "ILockScreenCallUI": ["c596fd8d-73c9-4a14-b021-ec1c50a3b727"],
    "ILockScreenContentionFlyout": ["991cc8d2-5bdb-4ad5-bbb8-5eecb53a9c49"],
    "ILockScreenCreativeConfig": ["fb37854f-513a-4ca8-9a06-4adab5968a23"],
    "ILockScreenImageFeedStatics": ["2c0d73f6-03a9-41a6-9b01-495251ff51d5"],
    "ILockScreenInfo": ["f59aa65c-9711-4dc9-a630-95b6cb8cdad0"],
    "ILockScreenStatics": ["3ee9d3ad-b607-40ae-b426-7631d9821269"],
    "ILockScreenToastEndpoint": ["dbbf74d0-f031-47af-bb04-91ec3bad0adc"],
    "ILockScreenToastSink": ["856859e3-ce2b-4a92-a45b-5c5d66950baa"],
    "ILockScreenUnlockingDeferral": ["7e7d1ad6-5203-43e7-9bd6-7c3947d1e3fe"],
    "ILockScreenUnlockingEventArgs": ["44e6c007-75fb-4abb-9f8b-824748900c71"],
    "ILockScreenViewManager": ["8bb5da34-1b62-4c69-b17e-da7c688aa451"],
    "ILockScreenViewManagerNotificationCallback": ["989e63bd-43c5-4815-b192-2251e9a6e452"],
    "ILogFileGeneratedEventArgs": ["269e976f-0d38-4c1a-b53f-b395d881df84"],
    "ILogFileItem": ["d6b518dd-05c7-418a-89e6-4f9ce8c6841e"],
    "ILogFiles": ["6a2a97e6-6851-41ea-87ad-2a8225335865"],
    "ILogPlugin": ["08fd99d1-cfb6-11cf-bc03-00aa006111e0"],
    "ILogPluginEx": ["3710e192-9c25-11d1-8b9a-080009dcc2fa"],
    "ILogRecover": ["b992fa57-128c-11d1-97e4-00c04fb9618a"],
    "ILoggingActivity": ["bc032941-b766-4cb5-9848-97ac6ba6d60c"],
    "ILoggingActivity2": ["26c29808-6322-456a-af82-80c8642f178b"],
    "ILoggingActivityFactory": ["6b33b483-e10a-4c58-97d5-10fb451074fb"],
    "ILoggingChannel": ["e9a50343-11d7-4f01-b5ca-cf495278c0a8"],
    "ILoggingChannel2": ["9f4c3cf3-0bac-45a5-9e33-baf3f3a246a5"],
    "ILoggingChannelFactory": ["4edc5b9c-af80-4a9b-b0dc-398f9ae5207b"],
    "ILoggingChannelFactory2": ["4c6ef5dd-3b27-4dc9-99f0-299c6e4603a1"],
    "ILoggingChannelOptions": ["c3e847ff-0ebb-4a53-8c54-dec24926cb2c"],
    "ILoggingChannelOptionsFactory": ["a93151da-7faf-4191-8755-5e86dc65d896"],
    "ILoggingFields": ["d7f6b7af-762d-4579-83bd-52c23bc333bc"],
    "ILoggingOptions": ["90bc7850-0192-4f5d-ac26-006adaca12d8"],
    "ILoggingOptionsFactory": ["d713c6cb-98ab-464b-9f22-a3268478368a"],
    "ILoggingSession": ["6221f306-9380-4ad7-baf5-41ea9310d768"],
    "ILoggingSessionFactory": ["4e937ee5-58fd-45e0-8c2f-a132eff95c1e"],
    "ILoggingTarget": ["65f16c35-e388-4e26-b17a-f51cd3a83916"],
    "ILoginCallback": ["711db9ba-3317-4234-afa9-6bdd67047626"],
    "ILogonErrorRedirector": ["2344718b-40d0-4cb0-9a92-78c3c3ae7fb0"],
    "ILogonTrigger": ["72dade38-fae4-4b3e-baf4-5d009af02b1c"],
    "ILoopingSelector": ["4c9a3e04-4827-49d9-8806-093957b0fd21"],
    "ILoopingSelectorAutomationPeer": ["50b406ca-bae9-4816-8a3a-0cb4f96478a2"],
    "ILoopingSelectorItem": ["c69714b9-27c6-4433-9d7c-0dbfb2f4344f"],
    "ILoopingSelectorItemAutomationPeer": ["d3fa68bf-04cf-4f4c-8d3e-4780a19d4788"],
    "ILoopingSelectorItemDataAutomationPeer": ["ef567e32-7cd2-4d32-9590-1f588d5ef38d"],
    "ILoopingSelectorPanel": ["40a9ba70-1011-4778-87f7-6bfd20d6377d"],
    "ILoopingSelectorStatics": ["03e8bafa-8c7d-4fc5-b92a-f049fb933cc5"],
    "ILoriEvents": ["07ab1e58-91a0-450f-b4a5-a4c775e67359"],
    "ILosingFocusEventArgs": ["f9f683c7-d789-472b-aa93-6d4105e6dabe"],
    "ILosingFocusEventArgs2": ["0493fad9-c27f-469f-8e62-52b3a4f7cd54"],
    "ILosingFocusEventArgs3": ["c98900bd-0b79-566e-ad1f-436fa513ae22"],
    "ILowLagMediaRecording": ["41c8baf7-ff3f-49f0-a477-f195e3ce5108"],
    "ILowLagMediaRecording2": ["6369c758-5644-41e2-97af-8ef56a25e225"],
    "ILowLagMediaRecording3": ["5c33ab12-48f7-47da-b41e-90880a5fe0ec"],
    "ILowLagPhotoCapture": ["a37251b7-6b44-473d-8f24-f703d6c0ec44"],
    "ILowLagPhotoControl": ["6d5c4dd0-fadf-415d-aee6-3baa529300c9"],
    "ILowLagPhotoSequenceCapture": ["7cc346bb-b9a9-4c91-8ffa-287e9c668669"],
    "ILowLagPhotoSequenceControl": ["3dcf909d-6d16-409c-bafe-b9a594c6fde6"],
    "ILowLevelDevicesAggregateProvider": ["a73e561c-aac1-4ec7-a852-479f7060d01f"],
    "ILowLevelDevicesAggregateProviderFactory": ["9ac4aaf6-3473-465e-96d5-36281a2c57af"],
    "ILowLevelDevicesController": ["2ec23dd4-179b-45de-9b39-3ae02527de52"],
    "ILowLevelDevicesControllerStatics": ["093e926a-fccb-4394-a697-19de637c2db3"],
    "ILowLightFusionResult": ["78edbe35-27a0-42e0-9cd3-738d2089de9c"],
    "ILowLightFusionStatics": ["5305016d-c29e-40e2-87a9-9e1fd2f192f5"],
    "ILowMicHelper": ["3ed4ec4c-9931-432b-bffd-b8e13c2e6dad"],
    "IMAOAdminBroker": ["dd3d809a-0d91-4c71-856d-096877d72b7a"],
    "IMCISMessageFilter": ["f174e5b0-9046-11d0-a9e8-00aa00685c74"],
    "IMDDataset": ["a07cccd1-8148-11d0-87bb-00c04fc33942"],
    "IMDEConnectionManager": ["120c85a1-1764-437e-93bf-40d5cdac64cb"],
    "IMDEDatapath": ["479af05b-ffb9-4227-bc12-cb5d601ba5f2"],
    "IMDEExternalSessionState": ["57bed9a8-e93e-4c2c-84e7-cbfb57d61958"],
    "IMDEMiracastConnection": ["bd35fc34-a301-4a54-bfc9-679b2c5bdb8b"],
    "IMDEMiracastEventHandler": ["e1f07147-64b7-43dc-9605-91b0e6e9300a"],
    "IMDEOpCenter": ["b08701d0-0568-4010-83cd-52215d6238e1"],
    "IMDEOpCenter2": ["9adf3b82-5d26-4061-8ac3-3605be2c3e52"],
    "IMDEOpCenterWithSessionFactory": ["d4418574-611a-47f9-8681-405034dd4c94"],
    "IMDEOutputProfileManager": ["da03f4a9-d4d8-4769-a0e3-3591ba6adfb9"],
    "IMDEOutputProfileManager2": ["d73e04b3-3408-42d8-9bb1-f988ac79c57e"],
    "IMDEOutputProfileManager3": ["d9247f7b-1aa7-407f-8952-62709b79b66f"],
    "IMDETranscodeManager": ["3d5cd812-9a2f-4bc0-9ff1-5a2bbf3766c0"],
    "IMDFind": ["a07cccd2-8148-11d0-87bb-00c04fc33942"],
    "IMDRangeRowset": ["0c733aa0-2a1c-11ce-ade5-00aa0044773d"],
    "IMDSPDevice": ["1dcb3a12-33ed-11d3-8470-00c04f79dbc0"],
    "IMDSPDevice2": ["420d16ad-c97d-4e00-82aa-00e9f4335ddd"],
    "IMDSPDevice3": ["1a839845-fc55-487c-976f-ee38ac0e8c4e"],
    "IMDSPDeviceControl": ["1dcb3a14-33ed-11d3-8470-00c04f79dbc0"],
    "IMDSPDirectTransfer": ["c2fe57a8-9304-478c-9ee4-47e397b912d7"],
    "IMDSPEnumDevice": ["1dcb3a11-33ed-11d3-8470-00c04f79dbc0"],
    "IMDSPEnumStorage": ["1dcb3a15-33ed-11d3-8470-00c04f79dbc0"],
    "IMDSPObject": ["1dcb3a18-33ed-11d3-8470-00c04f79dbc0"],
    "IMDSPObject2": ["3f34cd3e-5907-4341-9af9-97f4187c3aa5"],
    "IMDSPObjectInfo": ["1dcb3a19-33ed-11d3-8470-00c04f79dbc0"],
    "IMDSPRevoked": ["a4e8f2d4-3f31-464d-b53d-4fc335998184"],
    "IMDSPStorage": ["1dcb3a16-33ed-11d3-8470-00c04f79dbc0"],
    "IMDSPStorage2": ["0a5e07a5-6454-4451-9c36-1c6ae7e2b1d6"],
    "IMDSPStorage3": ["6c669867-97ed-4a67-9706-1c5529d2a414"],
    "IMDSPStorage4": ["3133b2c4-515c-481b-b1ce-39327ecb4f74"],
    "IMDSPStorageGlobals": ["1dcb3a17-33ed-11d3-8470-00c04f79dbc0"],
    "IMDServiceProvider": ["1dcb3a10-33ed-11d3-8470-00c04f79dbc0"],
    "IMDServiceProvider2": ["b2fa24b7-cda3-4694-9862-413ae1a34819"],
    "IMDServiceProvider3": ["4ed13ef3-a971-4d19-9f51-0e1826b2da57"],
    "IMF2DBuffer": ["7dc9d5f9-9ed9-44ec-9bbf-0600bb589fbb"],
    "IMF2DBuffer2": ["33ae5ea6-4316-436f-8ddd-d73d22f829ec"],
    "IMF2DBuffer2Internal": ["1482b536-399f-4472-90a3-c7384d77558d"],
    "IMF2DBuffer3Internal": ["c106c57d-d856-4fc1-88ac-26c43da36c4b"],
    "IMFASFContentInfo": ["b1dca5cd-d5da-4451-8e9e-db5c59914ead"],
    "IMFASFIndexer": ["53590f48-dc3b-4297-813f-787761ad7b3e"],
    "IMFASFMultiplexer": ["57bdd80a-9b38-4838-b737-c58f670d7d4f"],
    "IMFASFMutualExclusion": ["12558291-e399-11d5-bc2a-00b0d0f3f4ab"],
    "IMFASFProfile": ["d267bf6a-028b-4e0d-903d-43f0ef82d0d4"],
    "IMFASFSplitter": ["12558295-e399-11d5-bc2a-00b0d0f3f4ab"],
    "IMFASFStreamConfig": ["9e8ae8d2-dbbd-4200-9aca-06e6df484913"],
    "IMFASFStreamPrioritization": ["699bdc27-bbaf-49ff-8e38-9c39c9b5e088"],
    "IMFASFStreamSelector": ["d01bad4a-4fa0-4a60-9349-c27e62da9d41"],
    "IMFActivate": ["7fee9e9a-4a89-47a6-899c-b6a53a70fb67"],
    "IMFAppStateChangeNotify": ["4461eda8-0cb4-4fce-88b9-a5e62a74fdaa"],
    "IMFAsyncCallback": ["a27003cf-2354-4f2a-8d6a-ab7cff15437e"],
    "IMFAsyncCallbackLogging": ["c7a4dca1-f5f0-47b6-b92b-bf0106d25791"],
    "IMFAsyncResult": ["ac6b7889-0740-4d51-8619-905994a55cc6"],
    "IMFAttributes": ["2cd2d921-c447-44a7-a13c-4adabfc247e3"],
    "IMFAudioMediaType": ["26a0adc3-ce26-4672-9304-69552edd3faf"],
    "IMFAudioPolicy": ["a0638c2b-6465-4395-9ae7-a321a9fd2856"],
    "IMFAudioRenderPrivate": ["413ed6d4-9acd-4118-9cca-f2a39675e4d8"],
    "IMFAudioStatistics": ["b0f2fc5d-a724-4709-b629-2fa6912683f2"],
    "IMFAudioStreamVolume": ["76b1bbdb-4ec8-4f36-b106-70a9316df593"],
    "IMFAuthenticationContext": ["0feb8e8f-aa79-4de8-a928-d1b4de0552d5"],
    "IMFBfrHandler": ["672b333c-077b-4f68-b4b6-c116bb1f947b"],
    "IMFBufferListNotify": ["24cd47f7-81d8-4785-adb2-af697a963cd2"],
    "IMFBufferReleaseCallback": ["e0e43df5-dd2f-4241-8a9f-9bc6e9619ebe"],
    "IMFByteStream": ["ad4c1b00-4bf7-422f-9175-756693d9130d"],
    "IMFByteStreamBuffering": ["6d66d782-1d4f-4db7-8c63-cb8c77f1ef5e"],
    "IMFByteStreamCacheControl": ["f5042ea4-7a96-4a75-aa7b-2be1ef7f88d5"],
    "IMFByteStreamCacheControl2": ["71ce469c-f34b-49ea-a56b-2d2a10e51149"],
    "IMFByteStreamDownloadRateControl": ["82dd62b7-bfe3-44cb-a195-9d8e3ea3e161"],
    "IMFByteStreamHandler": ["bb420aa4-765b-4a1f-91fe-d6a8a143924c"],
    "IMFByteStreamProgressiveDownload": ["ef92650a-d0e5-40a4-8ea2-1fe69e8ad6ac"],
    "IMFByteStreamProxyClassFactory": ["a6b43f84-5c0a-42e8-a44d-b1857a76992f"],
    "IMFByteStreamReplace": ["adf0be72-70e2-4bab-8028-8aa842fa28ba"],
    "IMFByteStreamReservation": ["1a37165b-2079-402c-9e2c-ebcdede8c12f"],
    "IMFByteStreamReuse": ["8484e72a-cd3d-40b6-a4d2-0c8a262a18cc"],
    "IMFByteStreamTimeSeek": ["64976bfa-fb61-4041-9069-8c9a5f659beb"],
    "IMFCDM": ["fc9460f5-d471-429f-a8f8-fdf0fe9b45f5"],
    "IMFCDM2": ["b614e03a-cdab-4ed4-b10d-c65657d20cbf"],
    "IMFCDM3": ["83489f3d-d123-4f3e-883c-69430789c228"],
    "IMFCDMAccess": ["c2e03abd-858a-4458-9633-c76b6134118f"],
    "IMFCDMFactory": ["51731d73-7e90-4546-bc0c-d7ea67a61896"],
    "IMFCDMFactory2": ["1a5d4d24-14f3-4fea-b3a5-c62bf6fdaa9d"],
    "IMFCDMFactory3": ["3c023cf8-4a3b-455c-8e97-3e40ecfd6f88"],
    "IMFCDMSession": ["5fae84c7-5d75-4a07-b7b2-197435509e54"],
    "IMFCDMSession2": ["14475fce-a45b-45ba-87a0-d10ead6765f8"],
    "IMFCDMSessionCallbacks": ["9a956fcd-3e32-407f-a896-86922d354ed0"],
    "IMFCDMSessionCallbacks2": ["ef28f579-1abb-4ca7-85f1-565c91154a01"],
    "IMFCameraProfile": ["6764318a-8018-41b6-b65a-ab48f8aed212"],
    "IMFCameraProfileCollection": ["1a59dd98-e38b-491a-972b-e3f6de172a20"],
    "IMFCameraProfileConcurrency": ["40473867-e26d-4e58-b32c-7694cf359197"],
    "IMFCameraProfilePin": ["f0c55e3a-c722-4e72-be3c-7a7a590fe799"],
    "IMFCameraProfilePinMedia": ["1cd040e7-21de-4a74-947d-064266d65e4f"],
    "IMFCameraProfilePinMedia2": ["41571254-67a7-464b-84f8-2cd7f8556281"],
    "IMFCameraProfileValidation": ["1f7b8766-18f9-41bf-b03a-d2a8cdba0c06"],
    "IMFCameraStreamStateShutdown": ["a7c2f0d6-86e8-469b-b22e-be9caba350b5"],
    "IMFCaptureEngine": ["a6bba433-176b-48b2-b375-53aa03473207"],
    "IMFCaptureEngine2": ["dbc97bd4-eeb1-48b4-859b-9db001a05e26"],
    "IMFCaptureEngineClassFactory": ["8f02d140-56fc-4302-a705-3a97c78be779"],
    "IMFCaptureEngineNotify": ["74890190-092f-4db7-b255-a21f3b2b6e36"],
    "IMFCaptureEngineOnEventCallback": ["aeda51c0-9025-4983-9012-de597b88b089"],
    "IMFCaptureEngineOnPeekingSampleCallback": ["fdea8535-707a-4022-9983-428f669e0896"],
    "IMFCaptureEngineOnSampleCallback": ["52150b82-ab39-4467-980f-e48bf0822ecd"],
    "IMFCaptureEngineOnSampleCallback2": ["e37ceed7-340f-4514-9f4d-9c2ae026100b"],
    "IMFCaptureFrameReaderSink": ["d309a0a1-5b67-44ba-93e0-66f8222614d6"],
    "IMFCapturePhotoConfirmation": ["19f68549-ca8a-4706-a4ef-481dbc95e12c"],
    "IMFCapturePhotoSink": ["d2d43cc8-48bb-4aa7-95db-10c06977e777"],
    "IMFCapturePreviewSink": ["77346cfd-5b49-4d73-ace0-5b52a859f2e0"],
    "IMFCapturePreviewSinkInternal": ["2a3995fa-f92c-4ac7-b969-4c5cb8b67af7"],
    "IMFCapturePreviewSinkInternal2": ["8d503bbc-a19d-4dda-9028-d0738695cdf6"],
    "IMFCaptureRecordSink": ["3323b55a-f92a-4fe2-8edc-e9bfc0634d77"],
    "IMFCaptureRecordSinkInternal": ["11ae1897-f7f8-4334-b8a9-3a190fa8dcea"],
    "IMFCaptureSink": ["72d6135b-35e9-412c-b926-fd5265f2a885"],
    "IMFCaptureSink2": ["f9e4219e-6197-4b5e-b888-bee310ab2c59"],
    "IMFCaptureSource": ["439a42a8-0d2c-4505-be83-f79b2a05d5c4"],
    "IMFCaptureSourceAsyncDeviceControl": ["dc0861ea-3d09-4d42-ac77-22e9202a4298"],
    "IMFCaptureSourceBasicDeviceControl": ["00029279-2dd8-4e97-ac7d-b3da0d129a48"],
    "IMFCaptureSourceDeviceControl": ["6bb90109-1928-4855-b37f-cf8af0d07de6"],
    "IMFCaptureSourceDeviceControl2": ["b8ab84fa-2e3e-4353-b792-a3d15872a340"],
    "IMFCaptureSourceDeviceController": ["d3989299-5ea3-40f3-9c87-7f83d68990a1"],
    "IMFCaptureSourceInternal": ["44ac72a8-9183-4214-b128-044ff537f0cf"],
    "IMFCaptureSourceInternal2": ["2ad90d27-1361-4271-91d2-1e47c365c9d9"],
    "IMFCdmSuspendNotify": ["7a5645d2-43bd-47fd-87b7-dcd24cc7d692"],
    "IMFChannelAccelerator": ["2d188d37-0418-44d2-b8d1-e06f0a9db3dc"],
    "IMFClock": ["2eb1e945-18b8-4139-9b1a-d5d584818530"],
    "IMFClockConsumer": ["6ef2a662-47c0-4666-b13d-cbb717f2fa2c"],
    "IMFClockRateMatch": ["828e7c7e-84f2-4b45-8cee-5bb3d827fcf5"],
    "IMFClockStateSink": ["f6696e82-74f7-4f3d-a178-8a5e09c3659f"],
    "IMFCodecAPIRemoting": ["12c96fba-0004-45d8-8674-52a37917699c"],
    "IMFCollection": ["5bc8a76b-869a-46a3-9b03-fa218a66aebe"],
    "IMFComponentCreator": ["97ec2ea2-0e42-4937-97ac-9d6d328824e1"],
    "IMFCongestionHandler": ["051268b6-eba3-4123-973d-6cb63fb4cc75"],
    "IMFContentDecryptionModule": ["87be986c-10be-4943-bf48-4b54ce1983a2"],
    "IMFContentDecryptionModuleAccess": ["a853d1f4-e2a0-4303-9edc-f1a68ee43136"],
    "IMFContentDecryptionModuleFactory": ["7d5abf16-4cbb-4e08-b977-9ba59049943e"],
    "IMFContentDecryptionModuleSession": ["4e233efd-1dd2-49e8-b577-d63eee4c0d33"],
    "IMFContentDecryptionModuleSessionCallbacks": ["3f96ee40-ad81-4096-8470-59a4b770f89a"],
    "IMFContentDecryptorContext": ["7ec4b1bd-43fb-4763-85d2-64fcb5c5f4cb"],
    "IMFContentEnabler": ["d3c4ef59-49ce-4381-9071-d5bcd044c770"],
    "IMFContentProtectionDevice": ["e6257174-a060-4c9a-a088-3b1b471cad28"],
    "IMFContentProtectionManager": ["acf92459-6a61-42bd-b57c-b43e51203cb0"],
    "IMFD3D12SynchronizationObject": ["802302b0-82de-45e1-b421-f19ee5bdaf23"],
    "IMFD3D12SynchronizationObjectCommands": ["09d0f835-92ff-4e53-8efa-40faa551f233"],
    "IMFDLNAProfileInfo": ["62e536d0-e618-4735-ae4c-14ed5d74ba50"],
    "IMFDLNASinkInit": ["0c012799-1b61-4c10-bda9-04445be5f561"],
    "IMFDRMNetHelper": ["3d1ff0ea-679a-4190-8d46-7fa69e8c7e15"],
    "IMFDShowTransformWrapperConfig": ["334dad59-5bc3-4506-8f0b-e5f314295036"],
    "IMFDXGIBuffer": ["e7174cfa-1c9e-48b1-8866-626226bfc258"],
    "IMFDXGIBufferInternal": ["9405913d-ba9b-49b6-a644-e36fb231a3e5"],
    "IMFDXGIDeviceManager": ["eb533d5d-2db6-40f8-97a9-494692014f07"],
    "IMFDXGIDeviceManager2": ["63f95bf0-737a-444b-a1a6-333ba0d56bc2"],
    "IMFDXGIDeviceManager3": ["44e8e468-8c57-4126-a886-49c000a90b6f"],
    "IMFDXGIDeviceManagerSource": ["20bc074b-7a8d-4609-8c3b-64a0a3b5d7ce"],
    "IMFDXGIScheduledObjectIterator": ["07f5b7d3-b315-4fc2-a5f3-74d65250bc5e"],
    "IMFDXGIScheduler": ["df681668-70ec-457b-9aa3-caa60910a710"],
    "IMFDebugNetSource": ["e9cd0380-a268-4bb4-82de-658d53574d41"],
    "IMFDebugPMPSession": ["ed597033-a68b-4522-999f-44d4f9dea2f5"],
    "IMFDescriptorInterpreter": ["e6d7cd50-2a95-4698-89e4-0d6420704440"],
    "IMFDesiredSample": ["56c294d0-753e-4260-8d61-a3d8820b1d54"],
    "IMFDeviceControl": ["c2574938-0314-4ef5-81de-da3503afb832"],
    "IMFDeviceController": ["a1f58958-a5aa-412f-af20-1b7f1242dba0"],
    "IMFDeviceController2": ["2032c7ef-76f6-492a-94f3-4a81f69380cc"],
    "IMFDeviceController3": ["37ab888c-9d3e-46eb-9d5c-ac1ec00e2729"],
    "IMFDeviceMFTInternal": ["0c3502fb-f1b2-4155-b990-dd8a5fc34f93"],
    "IMFDeviceMFTInternal2": ["59cd78a0-0dbf-4815-9a9e-3430dce51feb"],
    "IMFDeviceMFTInternal3": ["76fcc99a-7a67-4192-9168-0022cfe4c7e1"],
    "IMFDeviceMFTInternal4": ["4022ffa6-aff9-4d42-84b5-a939f431d4f9"],
    "IMFDeviceMFTInternal5": ["b77cd8e4-43d2-4dea-acba-b76878aa41ef"],
    "IMFDeviceMFTInternal6": ["39d78038-24e3-412d-bd5a-58515412ee0f"],
    "IMFDevicePhotoStreamInternal": ["d9b9a781-6c81-4f40-aa29-fae2bdcc4615"],
    "IMFDevicePhotoStreamInternal2": ["92f6ec9b-c1db-4c01-b6f6-4984ee848f05"],
    "IMFDeviceSourceInternal": ["7f02a37e-4e81-11e0-8f3e-d057dfd72085"],
    "IMFDeviceSourceInternal2": ["c47d95d5-9685-4bf6-b6fb-772dc58d8e3b"],
    "IMFDeviceSourceStatus": ["43937dc1-0be6-4add-8a14-9ea68ff31252"],
    "IMFDeviceSourceStatus2": ["862be468-b94b-42a0-b2b0-2cf1d36969b3"],
    "IMFDeviceSourceStreamState": ["fbc717dc-3589-4cd7-af7d-23361e2e0fce"],
    "IMFDeviceStreamInternal": ["d4587da3-2380-4947-ac63-7ad5968a3953"],
    "IMFDeviceTransform": ["d818fbd8-fc46-42f2-87ac-1ea2d1f9bf32"],
    "IMFDeviceTransformCallback": ["6d5cb646-29ec-41fb-8179-8c4c6d750811"],
    "IMFDeviceTransformManager": ["70212999-c449-4b9d-b1a4-b358e1490121"],
    "IMFEMEMediaSource": ["a67cc551-6d6d-4351-9b57-ace41114d2c4"],
    "IMFExtendedCameraControl": ["38e33520-fca1-4845-a27a-68b7c6ab3789"],
    "IMFExtendedCameraController": ["b91ebfee-ca03-4af4-8a82-a31752f4a0fc"],
    "IMFExtendedCameraIntrinsicModel": ["5c595e64-4630-4231-855a-12842f733245"],
    "IMFExtendedCameraIntrinsics": ["687f6dac-6987-4750-a16a-734d1e7a10fe"],
    "IMFExtendedCameraIntrinsicsDistortionModel6KT": ["74c2653b-5f55-4eb1-9f0f-18b8f68b7d3d"],
    "IMFExtendedCameraIntrinsicsDistortionModelArcTan": ["812d5f95-b572-45dc-bafc-ae24199ddda8"],
    "IMFExtendedDRMTypeSupport": ["332ec562-3758-468d-a784-e38f23552128"],
    "IMFFieldOfUseMFTUnlock": ["508e71d3-ec66-4fc3-8775-b4b9ed6ba847"],
    "IMFFinalizableMediaSink": ["eaecb74a-9a50-42ce-9541-6a7f57aa4ad7"],
    "IMFFrameReader": ["b9f9f8c2-4f3a-4524-8c54-809e616cabd4"],
    "IMFFrameReader2": ["e07ab612-625d-4aef-8d7d-6ffdcd473603"],
    "IMFGetCaptureEngine": ["08a11708-b216-4b2a-9253-acf3c90c155d"],
    "IMFGetMultipleServiceProviders": ["6ca60d7e-e98d-4c2d-b25e-d4b7cf394185"],
    "IMFGetProtectionSystemIds": ["97e60041-b4d1-452e-9af3-88964bd0c15d"],
    "IMFGetService": ["fa993888-4383-415a-a930-dd472a8cf6f7"],
    "IMFHDCPManager": ["3ab81598-962b-4834-bfe5-4426ac1294c1"],
    "IMFHDCPSender": ["659c02d6-03fe-4f39-96ca-ef19ff7ae599"],
    "IMFHDCPStatus": ["de400f54-5bf1-40cf-8964-0bea136b1e3d"],
    "IMFHdcpDecrypt": ["2f389830-1f76-42e3-b0ae-eff133e7097b"],
    "IMFHdcpReceiverControl": ["62abe66a-48fb-4073-967f-3a73d1236d82"],
    "IMFHttpDownloadRequest": ["f779fddf-26e7-4270-8a8b-b983d1859de0"],
    "IMFHttpDownloadRequestOptions": ["397e26e9-6122-48a7-a73e-d6bb0a82666f"],
    "IMFHttpDownloadResponseOptions": ["a6fa17b4-be6c-4371-a451-d354bce14a57"],
    "IMFHttpDownloadSession": ["71fa9a2c-53ce-4662-a132-1a7e8cbf62db"],
    "IMFHttpDownloadSessionProvider": ["1b4cf4b9-3a16-4115-839d-03cc5c99df01"],
    "IMFImageFactory": ["d9daae21-f3cb-4ffa-aab5-a6c1015fec80"],
    "IMFImageFactoryInternal": ["b70259f1-7868-40ea-8002-57f0e09ec33d"],
    "IMFImageSharingEngine": ["cfa0ae8e-7e1c-44d2-ae68-fc4c148a6354"],
    "IMFImageSharingEngineClassFactory": ["1fc55727-a7fb-4fc8-83ae-8af024990af1"],
    "IMFInputTrustAuthority": ["d19f8e98-b126-4446-890c-5dcb7ad71453"],
    "IMFLPCMSinkActivate": ["9781e33c-d4af-4092-887c-34d58ba530f1"],
    "IMFLicenseManager": ["6e0bb04d-2f34-4004-857c-855c1f586934"],
    "IMFLicenseValidator": ["c68f77cc-c5c0-43d1-9eec-fab78b822a84"],
    "IMFLocalMFTRegistration": ["149c4d73-b4be-4f8d-8b87-079e926b6add"],
    "IMFLocalMFTRegistrationInternal": ["38b47b3a-d1dd-4f74-b61b-892398042a7b"],
    "IMFLock": ["97ec2ea3-0e42-4937-97ac-9d6d328824e1"],
    "IMFMP3ContentInfo": ["cc6c6949-c8ec-4def-911c-67098f786aa2"],
    "IMFMP4FragmentInfo": ["c394a8d6-454a-4b9c-8d8a-a5d3dbcfba38"],
    "IMFMP4InitSegmentGenerator": ["192837ee-294f-480a-97e0-6f6328ee8f7b"],
    "IMFMP4MediaSourcePluginFactory": ["17d8d95c-d765-4597-9372-9607dd8fcb7b"],
    "IMFMP4SegmentGeneratorFactory": ["cc88e5ee-92d3-4759-8af8-0e64a023a259"],
    "IMFMPEG2SinkActivate": ["30982126-392d-44a0-b426-cc250f4beda4"],
    "IMFMediaBuffer": ["045fa593-8799-42b8-bc8d-8968c6453507"],
    "IMFMediaBufferInternal": ["17648318-a670-4651-8129-768ac1f99041"],
    "IMFMediaBufferMultiSample": ["045fa594-8799-42b8-bc8d-8968c6453507"],
    "IMFMediaBufferWrapper": ["a0c691f0-6d1d-4138-887f-b2d3ecaf0a3d"],
    "IMFMediaEngine": ["98a1b0bb-03eb-4935-ae7c-93c1fa0e1c93"],
    "IMFMediaEngineAudioEndpointId": ["7a3bac98-0e76-49fb-8c20-8a86fd98eaf2"],
    "IMFMediaEngineClassFactory": ["4d645ace-26aa-4688-9be1-df3516990b93"],
    "IMFMediaEngineClassFactory2": ["09083cef-867f-4bf6-8776-dee3a7b42fca"],
    "IMFMediaEngineClassFactory3": ["3787614f-65f7-4003-b673-ead8293a0e60"],
    "IMFMediaEngineClassFactory4": ["fbe256c1-43cf-4a9b-8cb8-ce8632a34186"],
    "IMFMediaEngineClassFactoryEx": ["c56156c6-ea5b-48a5-9df8-fbe035d0929e"],
    "IMFMediaEngineClassFactoryInternal": ["d21b5617-2e6f-4987-baef-b5576626c970"],
    "IMFMediaEngineEME": ["50dc93e4-ba4f-4275-ae66-83e836e57469"],
    "IMFMediaEngineEMENotify": ["9e184d15-cdb7-4f86-b49e-566689f4a601"],
    "IMFMediaEngineEx": ["83015ead-b1e6-40d0-a98a-37145ffe1ad1"],
    "IMFMediaEngineExtension": ["2f69d622-20b5-41e9-afdf-89ced1dda04e"],
    "IMFMediaEngineInternal": ["703dc3bf-e96d-4881-8ef3-aed201c8898b"],
    "IMFMediaEngineMediaBreakCallback": ["d7126fef-79d7-4394-90c1-baf8b90626ea"],
    "IMFMediaEngineMediaBreakSupport": ["22407c47-3820-44dc-87c7-59a1b26d5293"],
    "IMFMediaEngineNeedKeyNotify": ["46a30204-a696-4b18-8804-246b8f031bb1"],
    "IMFMediaEngineNotify": ["fee7c112-e776-42b5-9bbf-0048524e2bd5"],
    "IMFMediaEngineNotifyArgs": ["1ade2303-ff47-481c-9916-410ead13e427"],
    "IMFMediaEngineOPMInfo": ["765763e6-6c01-4b01-bb0f-b829f60ed28c"],
    "IMFMediaEnginePlaylistSupport": ["3423a1a9-47db-4a61-91ea-d7b88d56cb92"],
    "IMFMediaEngineProtectedContent": ["9f8021e8-9c8c-487e-bb5c-79aa4779938c"],
    "IMFMediaEngineSourceResolver": ["695323e8-cf7c-4a81-8c51-9ce818d90518"],
    "IMFMediaEngineSphericalVideoSupport": ["e50f5c6b-29aa-4794-b4af-f779a86900f5"],
    "IMFMediaEngineSrcElements": ["7a5e5354-b114-4c72-b991-3131d75032ea"],
    "IMFMediaEngineSrcElementsEx": ["654a6bb3-e1a3-424a-9908-53a43a0dfda0"],
    "IMFMediaEngineSupportsSourceTransfer": ["a724b056-1b2e-4642-a6f3-db9420c52908"],
    "IMFMediaEngineTest": ["1f985a61-bc76-488c-87ba-e9b54b67b2dd"],
    "IMFMediaEngineTimelineControllerSupport": ["d36d82ca-5183-49e7-87b5-e20d6ed4ab62"],
    "IMFMediaEngineTransferSource": ["24230452-fe54-40cc-94f3-fcc394c340d6"],
    "IMFMediaEngineWebSupport": ["ba2743a1-07e0-48ef-84b6-9a2ed023ca6c"],
    "IMFMediaError": ["fc0e10d2-ab2a-4501-a951-06bb1075184c"],
    "IMFMediaEvent": ["df598932-f10c-4e39-bba2-c308f101daa3"],
    "IMFMediaEventGenerator": ["2cd0bd52-bcd5-4b89-b62c-eadc0c031e7d"],
    "IMFMediaEventQueue": ["36f846fc-2256-48b6-b58e-e2b638316581"],
    "IMFMediaKeySession": ["24fa67d5-d1d0-4dc5-995c-c0efdc191fb5"],
    "IMFMediaKeySession2": ["e9707e05-6d55-4636-b185-3de21210bd75"],
    "IMFMediaKeySessionNotify": ["6a0083f9-8947-4c1d-9ce0-cdee22b23135"],
    "IMFMediaKeySessionNotify2": ["c3a9e92a-da88-46b0-a110-6cf953026cb9"],
    "IMFMediaKeySystemAccess": ["aec63fda-7a97-4944-b35c-6c6df8085cc3"],
    "IMFMediaKeys": ["5cb31c05-61ff-418f-afda-caaf41421a38"],
    "IMFMediaKeys2": ["45892507-ad66-4de2-83a2-acbb13cd8d43"],
    "IMFMediaKeysPrivate": ["25991c64-f64e-4be8-93b7-1f13fbbceb3f"],
    "IMFMediaPlaylistInternal": ["b194e5a3-eac1-4caf-b33f-f4e9fd8d3c54"],
    "IMFMediaProcessor": ["7bc6644e-2146-4122-833c-27d74d37121f"],
    "IMFMediaProcessorEx": ["fe3de6ec-1e5d-4741-9c4d-2a348a43f9fc"],
    "IMFMediaProcessorStream": ["7bc6644f-2146-4122-833c-27d74d37121f"],
    "IMFMediaSegmentIndex": ["6b2370bb-72df-41c7-b680-6fd4ebd9e5eb"],
    "IMFMediaSegmentIndexParser": ["f1d4744a-bf9d-4e1d-8731-9c0d5a040363"],
    "IMFMediaSession": ["90377834-21d0-4dee-8214-ba2e3e6c1127"],
    "IMFMediaSessionFactory": ["09c6d01f-94bd-4551-83cb-1002d012c139"],
    "IMFMediaSharingEngine": ["8d3ce1bf-2367-40e0-9eee-40d377cc1b46"],
    "IMFMediaSharingEngineClassFactory": ["524d2bc4-b2b1-4fe5-8fac-fa4e4512b4e0"],
    "IMFMediaSharingEngineInternal": ["7efe543f-150a-4ffc-9d7e-e4c9549d82df"],
    "IMFMediaSink": ["6ef2a660-47c0-4666-b13d-cbb717f2fa2c"],
    "IMFMediaSinkPreroll": ["5dfd4b2a-7674-4110-a4e6-8a68fd5f3688"],
    "IMFMediaSource": ["279a808d-aec7-40c8-9c6b-a6b492c78a66"],
    "IMFMediaSource2": ["fbb03414-d13b-4786-8319-5ac51fc0a136"],
    "IMFMediaSourceActivate": ["f00374d1-c2f9-4a3f-913e-13c0984deec5"],
    "IMFMediaSourceEx": ["3c9b2eb9-86d5-4514-a394-f56664f9f0d8"],
    "IMFMediaSourceExtension": ["e467b94e-a713-4562-a802-816a42e9008a"],
    "IMFMediaSourceExtensionLiveSeekableRange": ["5d1abfd6-450a-4d92-9efc-d6b6cbc1f4da"],
    "IMFMediaSourceExtensionNotify": ["a7901327-05dd-4469-a7b7-0e01979e361d"],
    "IMFMediaSourcePresentationProvider": ["0e1d600a-c9f3-442d-8c51-a42d2d49452f"],
    "IMFMediaSourceTopologyProvider": ["0e1d6009-c9f3-442d-8c51-a42d2d49452f"],
    "IMFMediaStream": ["d182108f-4ec6-443f-aa42-a71106ec825f"],
    "IMFMediaStream2": ["c5bc37d6-75c7-46a1-a132-81b5f723c20f"],
    "IMFMediaStreamSourceSampleRequest": ["380b9af9-a85b-4e78-a2af-ea5ce645c6b4"],
    "IMFMediaTimeRange": ["db71a2fc-078a-414e-9df9-8c2531b0aa6c"],
    "IMFMediaTimelineControllerInternal": ["d5481ef2-b4b9-47b3-bf5d-8dc1d0740a3d"],
    "IMFMediaType": ["44ae0fa8-ea31-4109-8d2e-4cae4997c555"],
    "IMFMediaTypeChangeRemoting": ["e68b7f1b-751a-45a9-b767-c664c65f2a21"],
    "IMFMediaTypeHandler": ["e93dcf6c-4b07-4e1e-8123-aa16ed6eadf5"],
    "IMFMetadata": ["f88cfb8c-ef16-4991-b450-cb8c69e51704"],
    "IMFMetadataProvider": ["56181d2d-e221-4adb-b1c8-3cee6a53f76f"],
    "IMFMiracastConnectionCallback": ["891616ab-29d9-4475-8699-995c640d1454"],
    "IMFMiracastConnectionRegistrar": ["d91061d2-ee59-43f7-b44e-c6d15a04b794"],
    "IMFMiracastControlCallback": ["e54fb38b-37c7-4a63-a6ac-c12a154e5dd9"],
    "IMFMiracastStatsCallback": ["aa878e6c-46a2-4ae2-9282-f24ad9d7e1fc"],
    "IMFMultiReaderWriterLock": ["c413c0b4-2b66-4a47-b6cb-ad49b0c1e4a9"],
    "IMFMuxActivate": ["cf118367-09ae-45fb-af4d-be4a2b2e0e77"],
    "IMFMuxStreamAttributesManager": ["ce8bd576-e440-43b3-be34-1e53f565f7e8"],
    "IMFMuxStreamMediaTypeManager": ["505a2c72-42f7-4690-aeab-8f513d0ffdb8"],
    "IMFMuxStreamSampleManager": ["74abbc19-b1cc-4e41-bb8b-9d9b86a8f6ca"],
    "IMFNackHandler": ["e7f6a364-168c-4965-862c-b190a1c7c5f0"],
    "IMFNetBufferControl": ["d99849fc-41d3-4bbf-aacd-ffb94ec48c2b"],
    "IMFNetCardeaLicenseRequestEvent": ["674eff6a-5144-487a-a01d-013fc23d0353"],
    "IMFNetChangeProfileEvent": ["f181ed81-0b84-413c-8daf-290142d1a168"],
    "IMFNetChannel": ["a990f0fa-60bb-454b-a3bc-b4fb11054697"],
    "IMFNetChannelActivate": ["8780ed4c-a3d9-4ada-9489-023ddb3bd1d6"],
    "IMFNetChannelBandwidthEstimation": ["9cc607ab-64fc-44ed-bec7-cee7eb700cab"],
    "IMFNetChannelRIO": ["91b7b3e3-6286-4871-9a29-47d122cb5cbf"],
    "IMFNetCloseEvent": ["19006102-92b7-4263-953c-b84c24bedcce"],
    "IMFNetCredential": ["5b87ef6a-7ed8-434f-ba0e-184fac1628d1"],
    "IMFNetCredentialCache": ["5b87ef6c-7ed8-434f-ba0e-184fac1628d1"],
    "IMFNetCredentialManager": ["5b87ef6b-7ed8-434f-ba0e-184fac1628d1"],
    "IMFNetCrossOriginSupport": ["bc2b7d44-a72d-49d5-8376-1480dee58b22"],
    "IMFNetDescribeEvent": ["8e2f2316-0036-4f47-b6fd-b86c67ec1ab3"],
    "IMFNetDownloadEvent": ["f983790b-e48d-4eda-ab16-9df3681ce27e"],
    "IMFNetEosEvent": ["7c1411a3-4133-4d4e-bf38-276dbf9bb48a"],
    "IMFNetEvent": ["8e2f2315-0036-4f47-b6fd-b86c67ec1ab3"],
    "IMFNetEventHandler": ["6e2b250a-f1a7-46be-b2d1-38a762a2bff7"],
    "IMFNetHeaderCollection": ["8e2f2314-0036-4f47-b6fd-b86c67ec1ab3"],
    "IMFNetListener": ["1752bc20-967f-443a-8731-981b923e2bfd"],
    "IMFNetLogEvent": ["0d5ebc6b-6a6c-4f5c-8507-22c5eb1aead7"],
    "IMFNetPlayEvent": ["bbc20c5b-c228-4ab3-b188-e5d00d31475b"],
    "IMFNetPresentationTarget": ["c0b35174-11ff-43c9-9360-6dcf46db4404"],
    "IMFNetProfilesEvent": ["8420d5e8-eb2a-4323-afd7-f8ae2a62ead0"],
    "IMFNetProxyLocator": ["e9cd0383-a268-4bb4-82de-658d53574d41"],
    "IMFNetProxyLocatorFactory": ["e9cd0384-a268-4bb4-82de-658d53574d41"],
    "IMFNetRawEvent": ["efda1ed6-dc24-48c1-b7c5-f1e45ca5a14b"],
    "IMFNetResourceFilter": ["091878a3-bf11-4a5c-bc9f-33995b06ef2d"],
    "IMFNetSchemeHandlerConfig": ["7be19e73-c9bf-468a-ac5a-a5e8653bec87"],
    "IMFNetSelectStreamsEvent": ["117509a5-4509-40c9-ad4c-f47f18a78f77"],
    "IMFNetSession": ["fe5a22ac-a78c-441f-a5ce-24d31f0d45b4"],
    "IMFNetSessionFactory": ["19be6242-215d-4916-b2ae-3c86a9117348"],
    "IMFNetSessionHandler": ["2196c5fd-0f8c-4c90-b92a-c4029130650c"],
    "IMFNetSetHDCPContextEvent": ["6bb9f6b3-df61-4fff-8fb0-631f35443a9e"],
    "IMFNetSinkConfig": ["9e18a897-0fb9-44bd-b41d-d391a7fb31be"],
    "IMFNetSinkControlConnection": ["20a32133-518c-422a-a95a-691f9772c3ae"],
    "IMFNetUrlTransformEvent": ["b0a495af-a4a3-4b28-b15b-c98dc2f4b092"],
    "IMFNetVRoot": ["9c4c3fcd-a6f3-4b43-8eec-c7ea60c54887"],
    "IMFNetworkCongestionControl": ["d0db51ba-d166-4ee8-b68f-0083304c88d6"],
    "IMFObjectInformation": ["ce6be8e7-d757-435f-9de9-be3ef330b805"],
    "IMFObjectReferenceStream": ["09ef5be3-c8a7-469e-8b70-73bf25bb193f"],
    "IMFOutputPolicy": ["7f00f10a-daed-41af-ab26-5fdfa4dfba3c"],
    "IMFOutputSchema": ["7be0fc5b-abd9-44fb-a5c8-f50136e71599"],
    "IMFOutputTrustAuthority": ["d19f8e94-b126-4446-890c-5dcb7ad71453"],
    "IMFPMPClient": ["6c4e655d-ead8-4421-b6b9-54dcdbbdf820"],
    "IMFPMPClientApp": ["c004f646-be2c-48f3-93a2-a0983eba1108"],
    "IMFPMPHost": ["f70ca1a9-fdc7-4782-b994-adffb1c98606"],
    "IMFPMPHostApp": ["84d2054a-3aa1-4728-a3b0-440a418cf49c"],
    "IMFPMPHostInternal": ["f2b256ec-b3c7-4c9a-b20c-af31bdc375fd"],
    "IMFPMPServer": ["994e23af-1cc2-493c-b9fa-46f1cb040fa4"],
    "IMFPMPServerInternal": ["772ff18d-138b-4257-873c-1b8e0ce1d183"],
    "IMFPMPServerLock": ["994e23b0-1cc2-493c-b9fa-46f1cb040fa4"],
    "IMFPMediaItem": ["90eb3e6b-ecbf-45cc-b1da-c6fe3ea70d57"],
    "IMFPMediaPlayer": ["a714590a-58af-430a-85bf-44f5ec838d85"],
    "IMFPMediaPlayerCallback": ["766c8ffb-5fdb-4fea-a28d-b912996f51bd"],
    "IMFPersistStreamMap": ["5aac5312-a48a-4688-a7a0-b78c43fef031"],
    "IMFPluginControl": ["5c6c44bf-1db6-435b-9249-e8cd10fdec96"],
    "IMFPluginControl2": ["c6982083-3ddc-45cb-af5e-0f7a8ce4de77"],
    "IMFPluginControlInternal": ["e4d88afb-01b8-4965-985f-36122c3fc6fb"],
    "IMFPluginControlTestHook": ["68ff4224-8650-4cbc-8d9e-8cc724000100"],
    "IMFPresentationClock": ["868ce85c-8ea9-4f55-ab82-b009a910a805"],
    "IMFPresentationClockAggregate": ["90ebee9a-6a1e-405d-9a9a-3753ba6d247c"],
    "IMFPresentationClockAggregateClient": ["3bbf4b1c-f423-42eb-9d95-94676ea9e221"],
    "IMFPresentationClockAggregateClientNotify": ["f993f031-75e0-4eac-913a-479bee16e22b"],
    "IMFPresentationDescriptor": ["03cb2711-24d7-4db6-a17f-f3a7a479a536"],
    "IMFPresentationTimeSource": ["7ff12cce-f76f-41c2-863b-1666c8e5e139"],
    "IMFPropertyTranslator": ["d185ef97-da72-4d73-94ec-397645950444"],
    "IMFProtectedEnvironmentAccess": ["ef5dc845-f0d9-4ec9-b00c-cb5183d38434"],
    "IMFProtectedInputCreator": ["f79948fc-9e1f-447d-93b7-c580db2ddd8d"],
    "IMFProtectionSystemHeader": ["f466234a-428e-4cc2-8a15-cca350b914f7"],
    "IMFProtectionSystemHeaderCollection": ["54a8ee28-7a53-4b52-9aa4-ceccd6080023"],
    "IMFPsiFilterConfig": ["f6ea8518-63e9-4f2e-82bf-90057fc680d6"],
    "IMFQualityAdvise": ["ec15e2e9-e36b-4f7c-8758-77d452ef4ce7"],
    "IMFQualityAdvise2": ["f3706f0d-8ea2-4886-8000-7155e9ec2eae"],
    "IMFQualityAdviseInternal": ["3041c46c-9a45-47c7-9e23-9c9e1e4d4d50"],
    "IMFQualityAdviseLimits": ["dfcd8e4d-30b5-4567-acaa-8eb5b7853dc9"],
    "IMFQualityManager": ["8d009d86-5b9f-4115-b1fc-9f80d52ab8ab"],
    "IMFRateControl": ["88ddcd21-03c3-4275-91ed-55ee3929328f"],
    "IMFRateSupport": ["0a9ccdbc-d797-4563-9667-94ec5d79292d"],
    "IMFRatelessTimeSource": ["ab8dbcbe-2eb8-4080-a6d0-cfa3b846efd4"],
    "IMFReadWriteClassFactory": ["e7fe2e12-661c-40da-92f9-4f002ab67627"],
    "IMFRealTimeClient": ["2347d60b-3fb5-480c-8803-8df3adcd3ef0"],
    "IMFRealTimeClientEx": ["03910848-ab16-4611-b100-17b88ae2f248"],
    "IMFRelativePanelReport": ["f25362ea-2c0e-447f-81e2-755914cdc0c3"],
    "IMFRelativePanelWatcher": ["421af7f6-573e-4ad0-8fda-2e57cedb18c6"],
    "IMFRemoteAsyncCallback": ["a27003d0-2354-4f2a-8d6a-ab7cff15437e"],
    "IMFRemoteDesktopPlugin": ["1cde6309-cae0-4940-907e-c1ec9c3d1d4a"],
    "IMFRemoteProxy": ["994e23ad-1cc2-493c-b9fa-46f1cb040fa4"],
    "IMFRequestHandler": ["2196c5fd-0f8c-4c90-b92a-c4029130650c"],
    "IMFRrHandler": ["a9014b8b-0ed4-4a19-a06f-5d42c751d42d"],
    "IMFRtspSinkActivate": ["032b3adc-569b-48aa-ae08-62bcc3c5266b"],
    "IMFSAMIStyle": ["a7e025dd-5303-4a62-89d6-e747e1efac73"],
    "IMFSSLCertificateManager": ["61f7d887-1230-4a8b-aeba-8ad434d1a64d"],
    "IMFSample": ["c40a00f2-b93a-4d80-ae8c-5a1c634f58e4"],
    "IMFSampleAllocatorControl": ["da62b958-3a38-4a97-bd27-149c640c0771"],
    "IMFSampleGrabberSinkCallback": ["8c7b80bf-ee42-4b59-b1df-55668e1bdca8"],
    "IMFSampleGrabberSinkCallback2": ["ca86aa50-c46e-429e-ab27-16d6ac6844cb"],
    "IMFSampleGrabberSinkCallback3": ["28c92d4e-ff6c-4c0b-8c31-7b64a96d65fd"],
    "IMFSampleGrabberSinkCallback4": ["dd6c883b-d4d5-4496-9951-b50a0de24f87"],
    "IMFSampleGrabberSinkInternal": ["647aab17-3579-43a0-a188-45658b223a41"],
    "IMFSampleOutputStream": ["8feed468-6f7e-440d-869a-49bdd283ad0d"],
    "IMFSampleProtection": ["8e36395f-c7b9-43c4-a54d-512b4af63c95"],
    "IMFSaveJob": ["e9931663-80bf-4c6e-98af-5dcf58747d1f"],
    "IMFSchemeHandler": ["6d4c7b74-52a0-4bb7-b0db-55f29f47a668"],
    "IMFSdpTemplate": ["03271c24-dc86-4b41-8c47-76f9c2bf347c"],
    "IMFSeamlessAudioEffect": ["b92ae852-b308-41be-99ee-689a7bed9179"],
    "IMFSecureBuffer": ["c1209904-e584-4752-a2d6-7f21693f8b21"],
    "IMFSecureBufferAllocator": ["2975243e-23eb-419f-8385-84b1f597b0ea"],
    "IMFSecureChannel": ["d0ae555d-3b12-4d97-b060-0990bc5aeb67"],
    "IMFSeekInfo": ["26afea53-d9ed-42b5-ab80-e64f9ee34779"],
    "IMFSendRateHandler": ["6b947dfb-13ff-4a9b-83ef-2f3b49b13513"],
    "IMFSensorActivitiesReport": ["683f7a5e-4a19-43cd-b1a9-dbf4ab3f7777"],
    "IMFSensorActivitiesReportCallback": ["de5072ee-dbe3-46dc-8a87-b6f631194751"],
    "IMFSensorActivitiesReportCallbackInternal": ["40386096-6aa4-4bc6-a705-ad34eeb756a6"],
    "IMFSensorActivitiesReportInternal": ["e7481594-cf55-4101-979d-5bb7c9ad1c3b"],
    "IMFSensorActivityMonitor": ["d0cef145-b3f4-4340-a2e5-7a5080ca05cb"],
    "IMFSensorActivityMonitorInternal": ["ffae9683-35df-488b-aada-3418a53d8bcb"],
    "IMFSensorActivityReport": ["3e8c4be1-a8c2-4528-90de-2851bde5fead"],
    "IMFSensorActivityReportInternal": ["edc45026-2f8c-47b1-b22e-b0d00d8089b5"],
    "IMFSensorDevice": ["fb9f48f2-2a18-4e28-9730-786f30f04dc4"],
    "IMFSensorDeviceIdInternal": ["f2db1e0c-e35f-4819-9efe-b6f9e10ad74a"],
    "IMFSensorDeviceInternal": ["9a928955-c75a-4c2a-b41a-aa48c5834b1c"],
    "IMFSensorGroup": ["4110243a-9757-461f-89f1-f22345bcab4e"],
    "IMFSensorGroupCollection": ["560a0c60-5e50-4429-8c59-c7de0812096c"],
    "IMFSensorGroupId": ["006e0e79-a511-436e-83be-fce6990f258d"],
    "IMFSensorGroupIdInternal": ["1725de0f-cf7a-4075-9365-d8c5d1eea8d7"],
    "IMFSensorGroupIdManager": ["95b1b946-4630-42f8-8bb6-f347b1c5bfe7"],
    "IMFSensorGroupInternal": ["8e3196f0-ce22-4599-a16a-886bb13a7966"],
    "IMFSensorGroupPlugin": ["29fa81ab-e0f7-4abc-b00f-fb2e520b4595"],
    "IMFSensorProcessActivity": ["39dc7f4a-b141-4719-813c-a7f46162a2b8"],
    "IMFSensorProfile": ["22f765d1-8dab-4107-846d-56baf72215e7"],
    "IMFSensorProfileCollection": ["c95ea55b-0187-48be-9353-8d2507662351"],
    "IMFSensorProfileValidationCallback": ["55fb476f-cd01-4763-97b7-174ecdd7cc5a"],
    "IMFSensorStream": ["e9a42171-c56e-498a-8b39-eda5a070b7fc"],
    "IMFSensorStreamInternal": ["30acfa70-af94-4ad4-be36-14e23900c104"],
    "IMFSensorStreamInternal2": ["cfa380d0-f3e1-43ca-a35a-3c7b19d27304"],
    "IMFSensorTransformFactory": ["eed9c2ee-66b4-4f18-a697-ac7d3960215c"],
    "IMFSequencerRemoteStreamCallback": ["994e23ae-19cb-4de1-a64c-acf2edcbe59e"],
    "IMFSequencerSource": ["197cd219-19cb-4de1-a64c-acf2edcbe59e"],
    "IMFSetServiceProvider": ["54fc6d3d-5f42-47db-86c0-4e062d2685e2"],
    "IMFShared2DBuffer": ["a9e12d87-98fa-4e1f-9039-d1767191ad4b"],
    "IMFSharedBufferInternal": ["49c1c9a1-aa28-4209-95fe-c83df82d791e"],
    "IMFSharedMediaBuffer": ["41b8567f-c042-477a-ac5a-e964dc526f4c"],
    "IMFSharingEngineClassFactory": ["2ba61f92-8305-413b-9733-faf15f259384"],
    "IMFShutdown": ["97ec2ea4-0e42-4937-97ac-9d6d328824e1"],
    "IMFSignedLibrary": ["4a724bca-ff6a-4c07-8e0d-7a358421cf06"],
    "IMFSimpleAudioVolume": ["089edf13-cf71-4338-8d13-9e569dbdc319"],
    "IMFSinkClassFactory": ["37aa1c3b-620f-477e-bef9-ac4aa85be95d"],
    "IMFSinkWriter": ["3137f1cd-fe5e-4805-a5d8-fb477448cb3d"],
    "IMFSinkWriterCallback": ["666f76de-33d2-41b9-a458-29ed0a972c58"],
    "IMFSinkWriterCallback2": ["2456bd58-c067-4513-84fe-8d0c88ffdc61"],
    "IMFSinkWriterEncoderConfig": ["17c3779e-3cde-4ede-8c60-3899f5f53ad6"],
    "IMFSinkWriterEx": ["588d72ab-5bc1-496a-8714-b70617141b25"],
    "IMFSource": ["00f5e896-8813-44e3-8789-7e520e0de873"],
    "IMFSourceBuffer": ["e2cd3a4b-af25-4d3d-9110-da0e6f8ee877"],
    "IMFSourceBufferAppendMode": ["19666fb4-babe-4c55-bc03-0a074da37e2a"],
    "IMFSourceBufferList": ["249981f8-8325-41f3-b80c-3b9e3aad0cbe"],
    "IMFSourceBufferNotify": ["87e47623-2ceb-45d6-9b88-d8520c4dcbbc"],
    "IMFSourceDataParserPlugin": ["d7914b2f-a9c9-4b19-b840-dd3b6d0440d4"],
    "IMFSourceExtendedAttributesPlugin": ["f6176336-b5f0-4775-b948-0ad96eb1626f"],
    "IMFSourceFilterConfig": ["7bb552d6-cbd8-42cc-bc1a-7b87a0a3a969"],
    "IMFSourceHeaderParserPlugin": ["030c27d4-7ab9-462a-ade2-eac788549db7"],
    "IMFSourceHeaderParserPlugin2": ["2e1777ad-e9cc-444c-9fd8-90078502ffe9"],
    "IMFSourceIndexParserPlugin": ["3133e934-0981-40cd-9ce8-461bc0e414f0"],
    "IMFSourceOpenMonitor": ["059054b3-027c-494c-a27d-9113291cf87f"],
    "IMFSourceParserControl": ["350ad0d2-d168-4b24-b19d-068c1c4a102e"],
    "IMFSourcePropertyPlugin": ["294ac6b2-4eec-4d5f-a965-046c4e75abe6"],
    "IMFSourceProtectedContentPlugin": ["7b54e044-748b-4900-a63b-8a0ddd50c767"],
    "IMFSourceReader": ["70ae66f2-c809-4e4f-8915-bdcb406b7993"],
    "IMFSourceReaderCallback": ["deec8d99-fa1d-4d82-84c2-2c8969944867"],
    "IMFSourceReaderCallback2": ["cf839fe6-8c2a-4dd2-b6ea-c22d6961af05"],
    "IMFSourceReaderEx": ["7b981cf0-560e-4116-9875-b099895f23d7"],
    "IMFSourceReaderInternal": ["b7dd0143-6276-4459-bc4c-ad9acc9bf815"],
    "IMFSourceResolver": ["fbe5a32d-a497-4b61-bb85-97b1a848a6e3"],
    "IMFSpatialAudioObjectBuffer": ["d396ec8c-605e-4249-978d-72ad1c312872"],
    "IMFSpatialAudioSample": ["abf28a9b-3393-4290-ba79-5ffc46d986b2"],
    "IMFStallableTimeSource": ["3215d3aa-d9bd-4c96-8119-ed089594af2a"],
    "IMFStatistics": ["294eb3fb-94dd-42c2-a12e-374bbf1098f8"],
    "IMFStatisticsCollection": ["294eb3fc-94dd-42c2-a12e-374bbf1098f8"],
    "IMFStatisticsSite": ["294eb3fd-94dd-42c2-a12e-374bbf1098f8"],
    "IMFStreamDescriptor": ["56c03d9c-9dbb-45f5-ab4b-d80f47c05938"],
    "IMFStreamSampleInternal": ["b8db6a81-0228-47de-a17f-7d3c85217efd"],
    "IMFStreamSignalHandler": ["875d3d43-5fee-4f37-b3d8-23454e99a4d2"],
    "IMFStreamSink": ["0a97b3cf-8e7c-4a3d-8f8c-0c843dc247fb"],
    "IMFStreamingSinkConfig": ["9db7aa41-3cc5-40d4-8509-555804ad34cc"],
    "IMFStreamingSinkConfig2": ["fde164d1-1655-4f6e-9ec0-132d31e16e9a"],
    "IMFSystemId": ["fff4af3a-1fc1-4ef9-a29b-d26c49e2f31a"],
    "IMFTMuxSinkClassFactory": ["f49ce537-7fd6-420a-bea5-f286c390d255"],
    "IMFTelemetryComponent": ["0b5e1c7e-bd76-46bc-896c-b2edb40dd803"],
    "IMFTelemetrySession": ["627d2ca6-e1cd-4898-999d-101308f1d431"],
    "IMFTimecodeTranslate": ["ab9d8661-f7e8-4ef4-9861-89f334f94e74"],
    "IMFTimedText": ["1f2a94c9-a3df-430d-9d0f-acd85ddc29af"],
    "IMFTimedTextBinary": ["4ae3a412-0545-43c4-bf6f-6b97a5c6c432"],
    "IMFTimedTextClassFactory": ["02768674-7409-43af-bf7b-af276fda04d2"],
    "IMFTimedTextCue": ["1e560447-9a2b-43e1-a94c-b0aaabfbfbc9"],
    "IMFTimedTextCueBuilder": ["fc7b1bb6-c22e-4b46-8585-ef1429acc18e"],
    "IMFTimedTextCueInternal": ["2c118a1b-9cf4-4181-bcb6-4a986711e88a"],
    "IMFTimedTextCueList": ["ad128745-211b-40a0-9981-fe65f166d0fd"],
    "IMFTimedTextDataSource": ["5a0d8439-09d0-40f3-8dc3-d8b695bb1ecc"],
    "IMFTimedTextDataSourceHost": ["2de804cc-9128-4653-93b2-a511d1fd22e8"],
    "IMFTimedTextDataSourceHostServices": ["6704bce6-20b1-4ca4-8afc-63d3cd6dbd7b"],
    "IMFTimedTextFormattedText": ["e13af3c1-4d47-4354-b1f5-e83ae0ecae60"],
    "IMFTimedTextNotify": ["df6b87b6-ce12-45db-aba7-432fe054e57d"],
    "IMFTimedTextRegion": ["c8d22afc-bc47-4bdf-9b04-787e49ce3f58"],
    "IMFTimedTextRenderer": ["96535dc0-a5d7-4bb6-817d-c052242258ca"],
    "IMFTimedTextStyle": ["09b2455d-b834-4f01-a347-9052e21c450e"],
    "IMFTimedTextTrack": ["8822c32d-654e-4233-bf21-d7f2e67d30d4"],
    "IMFTimedTextTrackInternal": ["a7ddf8ee-a8d9-447a-9e48-791052d93495"],
    "IMFTimedTextTrackList": ["23ff334c-442c-445f-bccc-edc438aa11e2"],
    "IMFTimer": ["e56e4cbd-8f70-49d8-a0f8-edb3d6ab9bf2"],
    "IMFTopoConnector": ["de9a6158-f660-4643-b56a-df9f7998c7cd"],
    "IMFTopoLoader": ["de9a6157-f660-4643-b56a-df9f7998c7cd"],
    "IMFTopology": ["83cf873a-f6da-4bc8-823f-bacfd55dc433"],
    "IMFTopologyNode": ["83cf873a-f6da-4bc8-823f-bacfd55dc430"],
    "IMFTopologyNodeAttributeEditor": ["676aa6dd-238a-410d-bb99-65668d01605a"],
    "IMFTopologyPriv": ["47bae55e-80da-4046-a454-90520b5bc9a4"],
    "IMFTopologyServiceLookup": ["fa993889-4383-415a-a930-dd472a8cf6f7"],
    "IMFTopologyServiceLookupClient": ["fa99388a-4383-415a-a930-dd472a8cf6f7"],
    "IMFTrackedSample": ["245bf8e9-0755-40f7-88a5-ae0f18d55e17"],
    "IMFTrackedSampleInternal": ["6dc5a5a6-e640-4328-9c05-41a2c952d409"],
    "IMFTranscodeEngine": ["e9150228-6355-477f-88b5-a3098c1eaabb"],
    "IMFTranscodeProfile": ["4adfdba3-7ab0-4953-a62b-461e7ff3da1e"],
    "IMFTranscodeSinkInfoProvider": ["8cffcd2e-5a03-4a3a-aff7-edcd107c620e"],
    "IMFTransform": ["bf94c121-5b05-4e6f-8000-ba598961414d"],
    "IMFTransformFieldOfUse": ["6f2b8556-0dbc-41a9-8c10-e7fcaec4dbbe"],
    "IMFTransformProxy": ["654322dd-57f1-4660-b035-645775434005"],
    "IMFTransformRemote": ["212ff881-ffc0-48db-b083-057a109386d8"],
    "IMFTransformRemotePrivate": ["f42cf93e-51a9-4877-85bd-7ee81e39ae83"],
    "IMFTransformViaAppService": ["13bc074b-1b97-4059-ac54-5c710fc846cc"],
    "IMFTransformWrapper": ["506d9f5c-78ea-4055-8274-3073fb140f3f"],
    "IMFTrustedInput": ["542612c4-a1b8-4632-b521-de11ea64a0b0"],
    "IMFTrustedOutput": ["d19f8e95-b126-4446-890c-5dcb7ad71453"],
    "IMFVideoCaptureSampleAllocator": ["725b77c7-ca9f-4fe5-9d72-9946bf9b3c70"],
    "IMFVideoCaptureStatistics": ["0a678416-2c5b-4848-864e-05a698702f5c"],
    "IMFVideoDeviceAsyncExtendedControl": ["5011768d-9445-43f6-b94e-5f16bba99da4"],
    "IMFVideoDeviceBasicControl": ["2cc6bca7-f195-404d-b466-754947710729"],
    "IMFVideoDeviceExtendedControl": ["6b2fe609-cad1-46ec-b2b3-e3ac744a4a52"],
    "IMFVideoDeviceExtendedControlTraceCallback": ["ccc3b1e1-f3de-4dcc-80a7-604b5fe914de"],
    "IMFVideoDeviceFrameSettingControl": ["0a26cfcb-c784-4a14-8b9a-d6e990e5f476"],
    "IMFVideoDeviceID": ["a38d9567-5a9c-4f3c-b293-8eb415b279ba"],
    "IMFVideoDeviceVidCapControl": ["ea4a25c4-e4d5-4f9a-8ba7-80f41bdfd345"],
    "IMFVideoDisplayControl": ["a490b1e4-ab84-4d31-a1b2-181e03b1077a"],
    "IMFVideoMediaType": ["b99f381f-a8f9-47a2-a5af-ca3a225a3890"],
    "IMFVideoMixerBitmap": ["814c7b20-0fdb-4eec-af8f-f957c8f69edc"],
    "IMFVideoMixerControl": ["a5c6c53f-c202-4aa5-9695-175ba8c508a5"],
    "IMFVideoMixerControl2": ["8459616d-966e-4930-b658-54fa7e5a16d3"],
    "IMFVideoPositionMapper": ["1f6a9f17-e70b-4e24-8ae4-0b2c3ba7a4ae"],
    "IMFVideoPresenter": ["29aff080-182a-4a5d-af3b-448f3a6346cb"],
    "IMFVideoProcessor": ["6ab0000c-fece-4d1f-a2ac-a9573530656e"],
    "IMFVideoProcessorControl": ["a3f675d5-6119-4f7f-a100-1d8b280f0efb"],
    "IMFVideoProcessorControl2": ["bde633d3-e1dc-4a7f-a693-bbae399c4a20"],
    "IMFVideoProcessorControl3": ["2424b3f2-eb23-40f1-91aa-74bddeea0883"],
    "IMFVideoProcessorControlInternal": ["44f18199-7981-4f93-abe8-287ff0cccd7a"],
    "IMFVideoRenderer": ["dfdfd197-a9ca-43d8-b341-6af3503792cd"],
    "IMFVideoRendererEffectControl": ["604d33d7-cf23-41d5-8224-5bbbb1a87475"],
    "IMFVideoSampleAllocator": ["86cbc910-e533-4751-8e3b-f19b5b806a03"],
    "IMFVideoSampleAllocatorCallback": ["992388b4-3372-4f67-8b6f-c84c071f4751"],
    "IMFVideoSampleAllocatorCallbackEx": ["fe8d56d8-4f2f-45d8-b420-e5e5776bf51a"],
    "IMFVideoSampleAllocatorEx": ["545b3a48-3283-4f62-866f-a62d8f598f9f"],
    "IMFVideoSampleAllocatorEx2": ["9cbab028-f709-4950-ab0c-02b36a40880e"],
    "IMFVideoSampleAllocatorEx3": ["ef4ce6b9-5094-4f68-a748-9ed30f74f34f"],
    "IMFVideoSampleAllocatorNotify": ["a792cdbe-c374-4e89-8335-278e7b9956a4"],
    "IMFVideoSampleAllocatorNotifyEx": ["3978aa1a-6d5b-4b7f-a340-90899189ae34"],
    "IMFWMDRMITACreator": ["abdf559f-c509-404e-a562-d30ad351e6d1"],
    "IMFWorkQueueServices": ["35fe1bb8-a3a9-40fe-bbec-eb569c9ccca3"],
    "IMFWorkQueueServicesEx": ["96bf961b-40fe-42f1-ba9d-320238b49700"],
    "IMFWrappableTimeSource": ["125dfc8d-ba2c-4bf1-8b18-388c038140c5"],
    "IMILBitmap": ["b1784d3f-8115-4763-13aa-32eddb68294a"],
    "IMILBitmapEffect": ["8a6ff321-c944-4a1b-9944-9954af301258"],
    "IMILBitmapEffectConnections": ["c2b5d861-9b1a-4374-89b0-dec4874d6a81"],
    "IMILBitmapEffectConnectionsInfo": ["476b538a-c765-4237-ba4a-d6a880ff0cfc"],
    "IMILBitmapEffectConnector": ["f59567b3-76c1-4d47-ba1e-79f955e350ef"],
    "IMILBitmapEffectConnectorInfo": ["f66d2e4b-b46b-42fc-859e-3da0ecdb3c43"],
    "IMILBitmapEffectEvents": ["2e880dd8-f8ce-457b-8199-d60bb3d7ef98"],
    "IMILBitmapEffectFactory": ["33a9df34-a403-4ec7-b07e-bc0682370845"],
    "IMILBitmapEffectGroup": ["2f952360-698a-4ac6-81a1-bcfdf08eb8e8"],
    "IMILBitmapEffectGroupImpl": ["78fed518-1cfc-4807-8b85-6b6e51398f62"],
    "IMILBitmapEffectImpl": ["cc2468f2-9936-47be-b4af-06b5df5dbcbb"],
    "IMILBitmapEffectInputConnector": ["a9b4ecaa-7a3c-45e7-8573-f4b81b60dd6c"],
    "IMILBitmapEffectInteriorInputConnector": ["20287e9e-86a2-4e15-953d-eb1438a5b842"],
    "IMILBitmapEffectInteriorOutputConnector": ["00bbb6dc-acc9-4bfc-b344-8bee383dfefa"],
    "IMILBitmapEffectOutputConnector": ["92957aad-841b-4866-82ec-8752468b07fd"],
    "IMILBitmapEffectOutputConnectorImpl": ["21fae777-8b39-4bfa-9f2d-f3941ed36913"],
    "IMILBitmapEffectPrimitive": ["67e31025-3091-4dfc-98d6-dd494551461d"],
    "IMILBitmapEffectPrimitiveImpl": ["ce41e00b-efa6-44e7-b007-dd042e3ae126"],
    "IMILBitmapEffectRenderContext": ["12a2ec7e-2d33-44b2-b334-1abb7846e390"],
    "IMILBitmapEffectRenderContextImpl": ["4d25accb-797d-4fd2-b128-dffeff84fcc3"],
    "IMILBitmapEffects": ["51ac3dce-67c5-448b-9180-ad3eabddd5dd"],
    "IMILBitmapLock": ["a67b2b53-8fa1-4155-8f64-0c247a8f84cd"],
    "IMILBitmapScaler": ["a767b0f0-1c8c-4aef-568f-adf96dcfd5cb"],
    "IMILBitmapSource": ["7543696a-bc8d-46b0-5f81-8d95728972be"],
    "IMILCBitmapLock": ["64cd1766-561c-4379-857a-ff70f36cd82c"],
    "IMILCJpegDecoderFrame": ["21b7f576-9999-41d0-af2c-807cda3863f8"],
    "IMILCMemoryStream": ["43328a0a-f657-4ae4-ad64-f0db70eace67"],
    "IMILCStreamBase": ["c3933843-c24b-45a2-8298-b462f59daaf2"],
    "IMILCSubStream": ["c42d55d5-53be-4aa5-a11b-e250d404289c"],
    "IMILFormatConverter": ["7e2a746f-25c5-4851-b3af-443b79639ec0"],
    "IMILPalette": ["ca8e206f-f22c-4af7-6fba-7bed5eb1c92f"],
    "IMILResourceCache": ["181fa62c-0133-43d4-8d5c-639c3487783f"],
    "IMMDevice": ["d666063f-1587-4e43-81f1-b948e807363f"],
    "IMMDeviceActivator": ["3b0d0ea4-d0a9-4b0e-935b-09516746fac0"],
    "IMMDeviceCollection": ["0bd7a1be-7a1a-44db-8397-cc5392387b5e"],
    "IMMDeviceEnumerator": ["a95664d2-9614-4f35-a746-de8db63617e6"],
    "IMMEndpoint": ["1be09788-6894-4089-8586-9a2a6c265ac5"],
    "IMMNotificationClient": ["7991eec9-7e89-4d85-8390-6c703cec60c0"],
    "IMPEG2Component": ["1493e353-1eb6-473c-802d-8e6b8ec9d2a9"],
    "IMPEG2ComponentType": ["2c073d84-b51c-48c9-aa9f-68971e1f6e38"],
    "IMPEG2PIDMap": ["afb6c2a1-2c41-11d3-8a60-0000f81e0e4a"],
    "IMPEG2StreamIdMap": ["d0e04c47-25b8-4369-925a-362a01d95444"],
    "IMPEG2TuneRequest": ["eb7d987f-8a01-42ad-b8ae-574deee44d1a"],
    "IMPEG2TuneRequestFactory": ["14e11abd-ee37-4893-9ea1-6964de933e39"],
    "IMPEG2TuneRequestSupport": ["1b9d5fc3-5bbc-4b6c-bb18-b9d10e3eeebf"],
    "IMPEG2_TIF_CONTROL": ["f9bac2f9-4149-4916-b2ef-faa202326862"],
    "IMRTResourceBroker": ["59d87252-b4a0-f62b-50ab-4990760e1a45"],
    "IMRU": ["1011fa30-69da-11d2-8599-006097df8c11"],
    "IMSACredentialManager": ["b98f965f-1e46-45a2-b8e6-4454bc0a0ca5"],
    "IMSAdminBase": ["70b51430-b6ca-11d0-b9b9-00a0c922e750"],
    "IMSAdminBase2": ["8298d101-f992-43b7-8eca-5052d885b995"],
    "IMSAdminBase2W": ["8298d101-f992-43b7-8eca-5052d885b995"],
    "IMSAdminBase2_W": ["8298d101-f992-43b7-8eca-5052d885b995"],
    "IMSAdminBase3": ["f612954d-3b0b-4c56-9563-227b7be624b4"],
    "IMSAdminBase3W": ["f612954d-3b0b-4c56-9563-227b7be624b4"],
    "IMSAdminBase3_W": ["f612954d-3b0b-4c56-9563-227b7be624b4"],
    "IMSAdminBaseSink": ["a9e69612-b80d-11d0-b9b9-00a0c922e750"],
    "IMSAdminBaseSinkW": ["a9e69612-b80d-11d0-b9b9-00a0c922e750"],
    "IMSAdminBaseSink_W": ["a9e69612-b80d-11d0-b9b9-00a0c922e750"],
    "IMSAdminBaseW": ["70b51430-b6ca-11d0-b9b9-00a0c922e750"],
    "IMSAdminBase_W": ["70b51430-b6ca-11d0-b9b9-00a0c922e750"],
    "IMSCEPSetup": ["4f7761bb-9f3b-4592-9ee0-9a73259c313e"],
    "IMSEObjectURLWrapper": ["6f955783-4d3d-4007-a10d-bc94698ab8f5"],
    "IMSEventBinder": ["c3a9f406-2222-436d-86d5-ba3229279efb"],
    "IMSFeedsPriv": ["3a2f8555-8498-4dd5-bab9-dba681c5cf4e"],
    "IMSFolderPriv": ["be7101b4-73ff-4acf-a472-b74c4fb5f45d"],
    "IMSImpExpHelp": ["29ff67ff-8050-480f-9f30-cc41635f2f9d"],
    "IMSImpExpHelpW": ["29ff67ff-8050-480f-9f30-cc41635f2f9d"],
    "IMSImpExpHelp_W": ["29ff67ff-8050-480f-9f30-cc41635f2f9d"],
    "IMSMQApplication": ["d7d6e085-dccd-11d0-aa4b-0060970debae"],
    "IMSMQApplication2": ["12a30900-7300-11d2-b0e6-00e02c074f6b"],
    "IMSMQApplication3": ["eba96b1f-2168-11d3-898c-00e02c074f6b"],
    "IMSMQCollection": ["0188ac2f-ecb3-4173-9779-635ca2039c72"],
    "IMSMQCoordinatedTransactionDispenser": ["d7d6e081-dccd-11d0-aa4b-0060970debae"],
    "IMSMQCoordinatedTransactionDispenser2": ["eba96b10-2168-11d3-898c-00e02c074f6b"],
    "IMSMQCoordinatedTransactionDispenser3": ["eba96b14-2168-11d3-898c-00e02c074f6b"],
    "IMSMQDestination": ["eba96b16-2168-11d3-898c-00e02c074f6b"],
    "IMSMQEvent": ["d7d6e077-dccd-11d0-aa4b-0060970debae"],
    "IMSMQEvent2": ["eba96b12-2168-11d3-898c-00e02c074f6b"],
    "IMSMQEvent3": ["eba96b1c-2168-11d3-898c-00e02c074f6b"],
    "IMSMQManagement": ["be5f0241-e489-4957-8cc4-a452fcf3e23e"],
    "IMSMQMessage": ["d7d6e074-dccd-11d0-aa4b-0060970debae"],
    "IMSMQMessage2": ["d9933be0-a567-11d2-b0f3-00e02c074f6b"],
    "IMSMQMessage3": ["eba96b1a-2168-11d3-898c-00e02c074f6b"],
    "IMSMQMessage4": ["eba96b23-2168-11d3-898c-00e02c074f6b"],
    "IMSMQOutgoingQueueManagement": ["64c478fb-f9b0-4695-8a7f-439ac94326d3"],
    "IMSMQPrivateDestination": ["eba96b17-2168-11d3-898c-00e02c074f6b"],
    "IMSMQPrivateEvent": ["d7ab3341-c9d3-11d1-bb47-0080c7c5a2c0"],
    "IMSMQQuery": ["d7d6e072-dccd-11d0-aa4b-0060970debae"],
    "IMSMQQuery2": ["eba96b0e-2168-11d3-898c-00e02c074f6b"],
    "IMSMQQuery3": ["eba96b19-2168-11d3-898c-00e02c074f6b"],
    "IMSMQQuery4": ["eba96b24-2168-11d3-898c-00e02c074f6b"],
    "IMSMQQueue2": ["ef0574e0-06d8-11d3-b100-00e02c074f6b"],
    "IMSMQQueue3": ["eba96b1b-2168-11d3-898c-00e02c074f6b"],
    "IMSMQQueue4": ["eba96b20-2168-11d3-898c-00e02c074f6b"],
    "IMSMQQueueInfo": ["d7d6e07b-dccd-11d0-aa4b-0060970debae"],
    "IMSMQQueueInfo2": ["fd174a80-89cf-11d2-b0f2-00e02c074f6b"],
    "IMSMQQueueInfo3": ["eba96b1d-2168-11d3-898c-00e02c074f6b"],
    "IMSMQQueueInfo4": ["eba96b21-2168-11d3-898c-00e02c074f6b"],
    "IMSMQQueueInfos": ["d7d6e07d-dccd-11d0-aa4b-0060970debae"],
    "IMSMQQueueInfos2": ["eba96b0f-2168-11d3-898c-00e02c074f6b"],
    "IMSMQQueueInfos3": ["eba96b1e-2168-11d3-898c-00e02c074f6b"],
    "IMSMQQueueInfos4": ["eba96b22-2168-11d3-898c-00e02c074f6b"],
    "IMSMQQueueManagement": ["7fbe7759-5760-444d-b8a5-5e7ab9a84cce"],
    "IMSMQTransaction": ["d7d6e07f-dccd-11d0-aa4b-0060970debae"],
    "IMSMQTransaction2": ["2ce0c5b0-6e67-11d2-b0e6-00e02c074f6b"],
    "IMSMQTransaction3": ["eba96b13-2168-11d3-898c-00e02c074f6b"],
    "IMSMQTransactionDispenser": ["d7d6e083-dccd-11d0-aa4b-0060970debae"],
    "IMSMQTransactionDispenser2": ["eba96b11-2168-11d3-898c-00e02c074f6b"],
    "IMSMQTransactionDispenser3": ["eba96b15-2168-11d3-898c-00e02c074f6b"],
    "IMSVidAnalogTuner": ["1c15d47e-911d-11d2-b632-00c04f79498e"],
    "IMSVidAnalogTuner2": ["37647bf7-3dde-4cc8-a4dc-0d534d3d0037"],
    "IMSVidAnalogTunerEvent": ["1c15d486-911d-11d2-b632-00c04f79498e"],
    "IMSVidAudioRenderer": ["37b0353f-a4c8-11d2-b634-00c04f79498e"],
    "IMSVidAudioRendererDevices": ["c5702cd4-9b79-11d3-b654-00c04f79498e"],
    "IMSVidAudioRendererEvent": ["37b03541-a4c8-11d2-b634-00c04f79498e"],
    "IMSVidAudioRendererEvent2": ["e3f55729-353b-4c43-a028-50f79aa9a907"],
    "IMSVidClosedCaptioning": ["99652ea1-c1f7-414f-bb7b-1c967de75983"],
    "IMSVidClosedCaptioning2": ["e00cb864-a029-4310-9987-a873f5887d97"],
    "IMSVidClosedCaptioning3": ["c8638e8a-7625-4c51-9366-2f40a9831fc0"],
    "IMSVidCompositionSegment": ["1c15d483-911d-11d2-b632-00c04f79498e"],
    "IMSVidCtl": ["b0edf162-910a-11d2-b632-00c04f79498e"],
    "IMSVidDataServices": ["334125c1-77e5-11d3-b653-00c04f79498e"],
    "IMSVidDataServicesEvent": ["334125c2-77e5-11d3-b653-00c04f79498e"],
    "IMSVidDevice": ["1c15d47c-911d-11d2-b632-00c04f79498e"],
    "IMSVidDevice2": ["87bd2783-ebc0-478c-b4a0-e8e7f43ab78e"],
    "IMSVidDeviceEvent": ["1c15d480-911d-11d2-b632-00c04f79498e"],
    "IMSVidEVR": ["15e496ae-82a8-4cf9-a6b6-c561dc60398f"],
    "IMSVidEVREvent": ["349abb10-883c-4f22-8714-cecaeee45d62"],
    "IMSVidEncoder": ["c0020fd4-bee7-43d9-a495-9f213117103d"],
    "IMSVidFeature": ["37b03547-a4c8-11d2-b634-00c04f79498e"],
    "IMSVidFeatureEvent": ["3dd2903c-e0aa-11d2-b63a-00c04f79498e"],
    "IMSVidFeatures": ["c5702cd5-9b79-11d3-b654-00c04f79498e"],
    "IMSVidFilePlayback": ["37b03539-a4c8-11d2-b634-00c04f79498e"],
    "IMSVidFilePlayback2": ["2f7e44af-6e52-4660-bc08-d8d542587d72"],
    "IMSVidFilePlaybackEvent": ["37b0353a-a4c8-11d2-b634-00c04f79498e"],
    "IMSVidGenericSink": ["6c29b41d-455b-4c33-963a-0d28e5e555ea"],
    "IMSVidGenericSink2": ["6b5a28f3-47f1-4092-b168-60cabec08f1c"],
    "IMSVidGraphSegment": ["238dec54-adeb-4005-a349-f772b9afebc4"],
    "IMSVidGraphSegmentContainer": ["3dd2903d-e0aa-11d2-b63a-00c04f79498e"],
    "IMSVidGraphSegmentUserInput": ["301c060e-20d9-4587-9b03-f82ed9a9943c"],
    "IMSVidInputDevice": ["37b0353d-a4c8-11d2-b634-00c04f79498e"],
    "IMSVidInputDeviceEvent": ["37b0353e-a4c8-11d2-b634-00c04f79498e"],
    "IMSVidInputDevices": ["c5702cd1-9b79-11d3-b654-00c04f79498e"],
    "IMSVidOutputDevice": ["37b03546-a4c8-11d2-b634-00c04f79498e"],
    "IMSVidOutputDeviceEvent": ["2e6a14e2-571c-11d3-b652-00c04f79498e"],
    "IMSVidOutputDevices": ["c5702cd2-9b79-11d3-b654-00c04f79498e"],
    "IMSVidPlayback": ["37b03538-a4c8-11d2-b634-00c04f79498e"],
    "IMSVidPlaybackEvent": ["37b0353b-a4c8-11d2-b634-00c04f79498e"],
    "IMSVidRect": ["7f5000a6-a440-47ca-8acc-c0e75531a2c2"],
    "IMSVidStreamBufferRecordingControl": ["160621aa-bbbc-4326-a824-c395aebc6e74"],
    "IMSVidStreamBufferSink": ["159dbb45-cd1b-4dab-83ea-5cb1f4f21d07"],
    "IMSVidStreamBufferSink2": ["2ca9fc63-c131-4e5a-955a-544a47c67146"],
    "IMSVidStreamBufferSink3": ["4f8721d7-7d59-4d8b-99f5-a77775586bd5"],
    "IMSVidStreamBufferSinkEvent": ["f798a36b-b05b-4bbe-9703-eaea7d61cd51"],
    "IMSVidStreamBufferSinkEvent2": ["3d7a5166-72d7-484b-a06f-286187b80ca1"],
    "IMSVidStreamBufferSinkEvent3": ["735ad8d5-c259-48e9-81e7-d27953665b23"],
    "IMSVidStreamBufferSinkEvent4": ["1b01dcb0-daf0-412c-a5d1-590c7f62e2b8"],
    "IMSVidStreamBufferSource": ["eb0c8cf9-6950-4772-87b1-47d11cf3a02f"],
    "IMSVidStreamBufferSource2": ["e4ba9059-b1ce-40d8-b9a0-d4ea4a9989d3"],
    "IMSVidStreamBufferSourceEvent": ["50ce8a7d-9c28-4da8-9042-cdfa7116f979"],
    "IMSVidStreamBufferSourceEvent2": ["7aef50ce-8e22-4ba8-bc06-a92a458b4ef2"],
    "IMSVidStreamBufferSourceEvent3": ["ceabd6ab-9b90-4570-adf1-3ce76e00a763"],
    "IMSVidStreamBufferV2SourceEvent": ["49c771f9-41b2-4cf7-9f9a-a313a8f6027e"],
    "IMSVidTuner": ["1c15d47d-911d-11d2-b632-00c04f79498e"],
    "IMSVidTunerEvent": ["1c15d485-911d-11d2-b632-00c04f79498e"],
    "IMSVidVMR9": ["d58b0015-ebef-44bb-bbdd-3f3699d76ea1"],
    "IMSVidVRGraphSegment": ["dd47de3f-9874-4f7b-8b22-7cb2688461e7"],
    "IMSVidVideoInputDevice": ["1c15d47f-911d-11d2-b632-00c04f79498e"],
    "IMSVidVideoRenderer": ["37b03540-a4c8-11d2-b634-00c04f79498e"],
    "IMSVidVideoRenderer2": ["6bdd5c1e-2810-4159-94bc-05511ae8549b"],
    "IMSVidVideoRendererDevices": ["c5702cd3-9b79-11d3-b654-00c04f79498e"],
    "IMSVidVideoRendererEvent": ["37b03545-a4c8-11d2-b634-00c04f79498e"],
    "IMSVidVideoRendererEvent2": ["7145ed66-4730-4fdb-8a53-fde7508d3e5e"],
    "IMSVidWebDVD": ["cf45f88b-ac56-4ee2-a73a-ed04e2885d3c"],
    "IMSVidWebDVD2": ["7027212f-ee9a-4a7c-8b67-f023714cdaff"],
    "IMSVidWebDVDAdm": ["b8be681a-eb2c-47f0-b415-94d5452f0e05"],
    "IMSVidWebDVDEvent": ["b4f7a674-9b83-49cb-a357-c63b871be958"],
    "IMSVidXDS": ["11ebc158-e712-4d1f-8bb3-01ed5274c4ce"],
    "IMSVidXDSEvent": ["6db2317d-3b23-41ec-ba4b-701f407eaf3a"],
    "IMXF": ["c096df9e-fb09-11d1-81b0-0060083316c1", "c096df9e-fb09-11d1-81b0-0060083316c1"],
    "IMXRAttributes": ["6147fa3b-2790-4069-aad8-9502fc4a1416"],
    "IMXRContentHandler": ["bac05b74-cf58-4b65-bd61-0aca1d0bc08e"],
    "IMXXMLFilter": ["c90352f7-643c-4fbc-bb23-e996eb2d51fd"],
    "IMacAlgorithmNamesStatics": ["41412678-fb1e-43a4-895e-a9026e4390a3"],
    "IMacAlgorithmProvider": ["4a3fc5c3-1cbd-41ce-a092-aa0bc5d2d2f5"],
    "IMacAlgorithmProvider2": ["6da32a15-d931-42ed-8e7e-c301caee119c"],
    "IMacAlgorithmProviderStatics": ["c9bdc147-cc77-4df0-9e4e-b921e080644c"],
    "IMagneticStripeReader": ["1a92b015-47c3-468a-9333-0c6517574883"],
    "IMagneticStripeReaderAamvaCardDataReceivedEventArgs": ["0a4bbd51-c316-4910-87f3-7a62ba862d31"],
    "IMagneticStripeReaderBankCardDataReceivedEventArgs": ["2e958823-a31a-4763-882c-23725e39b08e"],
    "IMagneticStripeReaderCapabilities": ["7128809c-c440-44a2-a467-469175d02896"],
    "IMagneticStripeReaderCardTypesStatics": ["528f2c5d-2986-474f-8454-7ccd05928d5f"],
    "IMagneticStripeReaderEncryptionAlgorithmsStatics": ["53b57350-c3db-4754-9c00-41392374a109"],
    "IMagneticStripeReaderErrorOccurredEventArgs": ["1fedf95d-2c84-41ad-b778-f2356a789ab1"],
    "IMagneticStripeReaderReport": ["6a5b6047-99b0-4188-bef1-eddf79f78fe6"],
    "IMagneticStripeReaderStatics": ["c45fab4a-efd7-4760-a5ce-15b0e47e94eb"],
    "IMagneticStripeReaderStatics2": ["8cadc362-d667-48fa-86bc-f5ae1189262b"],
    "IMagneticStripeReaderStatusUpdatedEventArgs": ["09cc6bb0-3262-401d-9e8a-e80d6358906b"],
    "IMagneticStripeReaderTrackData": ["104cf671-4a9d-446e-abc5-20402307ba36"],
    "IMagneticStripeReaderVendorSpecificCardDataReceivedEventArgs": ["af0a5514-59cc-4a60-99e8-99a53dace5aa"],
    "IMagnetometer": ["484f626e-d3c9-4111-b3f6-2cf1faa418d5"],
    "IMagnetometer2": ["b4656c85-26f6-444b-a9e2-a23f966cd368"],
    "IMagnetometer3": ["be93db7c-a625-48ef-acf7-fac104832671"],
    "IMagnetometer4": ["dfb17901-3e0f-508f-b24b-f2bb75015f40"],
    "IMagnetometerDataThreshold": ["d177cb01-9063-5fa5-b596-b445e9dc3401"],
    "IMagnetometerDeviceId": ["58b498c2-7e4b-404c-9fc5-5de8b40ebae3"],
    "IMagnetometerReading": ["0c2cc40d-ebfd-4e5c-bb11-afc29b3cae61"],
    "IMagnetometerReading2": ["d4c95c61-61d9-404b-a328-066f177a1409"],
    "IMagnetometerReadingChangedEventArgs": ["17eae872-2eb9-4ee7-8ad0-3127537d949b"],
    "IMagnetometerStatics": ["853c64cc-0698-4dda-a6df-9cb9cc4ab40a"],
    "IMagnetometerStatics2": ["2c0819f0-ffc6-4f89-a06f-18fa10792933"],
    "IMaintenanceSettings": ["a6024fa8-9652-4adb-a6bf-5cfcd877a7ba"],
    "IMaintenanceTrigger": ["68184c83-fc22-4ce5-841a-7239a9810047"],
    "IMaintenanceTriggerFactory": ["4b3ddb2e-97dd-4629-88b0-b06cf9482ae5"],
    "IManageWritableSharedStream": ["df0ef230-197e-4b83-ac0f-2381219c46ac"],
    "IManagedStream": ["3a55501a-bdcc-4e63-96bc-4ddb6f44ccdd"],
    "IManagedViewerHost": ["5968d43d-d21e-437c-9c71-77c52c3e287a"],
    "IManagerForAlm": ["8f930e5f-019b-461f-aa10-6c3df1d01e5a"],
    "IManeuverWarning": ["c1a36d8a-2630-4378-9e4a-6e44253dceba"],
    "IManipulationCompletedEventArgs": ["b34ab22b-d19b-46ff-9f38-dec7754bb9e7"],
    "IManipulationCompletedEventArgs2": ["f0c0dce7-30a9-5b96-886f-6560a85e4757"],
    "IManipulationCompletedEventHandler": ["38ef4b0f-14f8-42df-9a1e-a4bcc4af77f4"],
    "IManipulationCompletedRoutedEventArgs": ["b5ad9b23-2f41-498e-8319-015ee8a75346"],
    "IManipulationDeltaEventHandler": ["aa1160cb-dfb9-4c56-abdc-711b63c8eb94"],
    "IManipulationDeltaRoutedEventArgs": ["400d5794-4c6f-491d-82d6-3517109399c6"],
    "IManipulationInertiaStartingEventArgs": ["dd37a898-26bf-467a-9ce5-ccf3fb11371e"],
    "IManipulationInertiaStartingEventArgs2": ["c25409b8-f9fa-5a45-bd97-dcbbb2201860"],
    "IManipulationInertiaStartingEventHandler": ["d39d6322-7c9c-481b-827b-c8b2d9bb6fc7"],
    "IManipulationInertiaStartingRoutedEventArgs": ["246a91a9-ca43-4c0b-acef-81e8b8147520"],
    "IManipulationPivot": ["2e3838a5-e6c2-4998-82ac-18748b141666"],
    "IManipulationPivotFactory": ["6d05b039-3702-4396-ad9b-a825efa63a3b"],
    "IManipulationProcessor": ["a22ac519-8300-48a0-bef4-f1be8737dba4"],
    "IManipulationStartedEventArgs": ["ddec873e-cfce-4932-8c1d-3c3d011a34c0"],
    "IManipulationStartedEventArgs2": ["2da3db4e-e583-5055-afaa-16fd986531a6"],
    "IManipulationStartedEventHandler": ["f88345f8-e0a3-4be2-b90c-dc20e6d8beb0"],
    "IManipulationStartedRoutedEventArgs": ["5db1aa05-9f80-48b6-ae6c-4f119de8ff13"],
    "IManipulationStartedRoutedEventArgsFactory": ["84c1daa7-7272-4463-b6c3-a40b9ba151fc"],
    "IManipulationStartingEventHandler": ["10d0b04e-bfe4-42cb-823c-3fecd8770ef8"],
    "IManipulationStartingRoutedEventArgs": ["18d636b7-53a4-4c15-a498-f3a9ca212a42"],
    "IManipulationUpdatedEventArgs": ["cb354ce5-abb8-4f9f-b3ce-8181aa61ad82"],
    "IManipulationUpdatedEventArgs2": ["f3dfb96a-3306-5903-a1c5-ff9757a8689e"],
    "IMapActualCameraChangedEventArgs": ["daa080da-b7f4-422c-a618-bbaa7c1d814c"],
    "IMapActualCameraChangedEventArgs2": ["7ba4c7e5-10dc-455a-9d04-1d72fb6d9b93"],
    "IMapActualCameraChangingEventArgs": ["6b0dbed6-93f7-4682-8de5-a47a1cc7a945"],
    "IMapActualCameraChangingEventArgs2": ["f2867897-40ac-4e8a-a927-510f3846a47e"],
    "IMapAddress": ["cfa7a973-a3b4-4494-b3ff-cba94db69699"],
    "IMapAddress2": ["75cd6df1-e5ad-45a9-bf40-6cf256c1dd13"],
    "IMapBillboard": ["1694259d-0ae2-4f42-a02e-292ca835d39d"],
    "IMapBillboardFactory": ["be45a4c5-8f09-4b86-ae28-783740eb8b31"],
    "IMapBillboardStatics": ["fdf839fe-e1f7-4fb0-8887-7da68c647333"],
    "IMapCamera": ["53a6b623-c0f8-4d8b-ad1e-a59598ea840b"],
    "IMapCameraFactory": ["ea3b0f16-83af-4ace-8e71-10ad9f1e9e7f"],
    "IMapContextRequestedEventArgs": ["fdd1b423-c961-4df2-bb57-82ee0f0bb591"],
    "IMapControl": ["42d0b851-5256-4747-9e6c-0d11e966141e"],
    "IMapControl2": ["e1fd644d-96ec-4065-b0f0-75281da3654d"],
    "IMapControl3": ["586328f8-8cdd-40ae-9338-af2a7be845e5"],
    "IMapControl4": ["068f132a-1817-466d-b7ce-419b3f8e248b"],
    "IMapControl5": ["dd9b0ffd-7823-46a2-82c9-65ddac4f365f"],
    "IMapControl6": ["b0da89a2-1041-4bea-b88a-12ac9a82e0e2"],
    "IMapControl7": ["0d86e453-0c1f-4f7e-ae66-4ad0b4987857"],
    "IMapControl8": ["009e9c46-724d-53ca-9421-7a48fc731523"],
    "IMapControlAutomationPeer": ["425beee4-f2e8-4bcb-9382-5dfdd11fe45f"],
    "IMapControlBusinessLandmarkClickEventArgs": ["5e464922-4a1a-4797-beb7-5cf7754cb867"],
    "IMapControlBusinessLandmarkPointerEnteredEventArgs": ["5e4081a6-ea98-4f95-8caf-5b42696ff504"],
    "IMapControlBusinessLandmarkPointerExitedEventArgs": ["2bb52caf-f24a-46d0-b463-65f719731057"],
    "IMapControlBusinessLandmarkRightTappedEventArgs": ["59ab8ae7-f184-4ab1-b0b0-35c8bf0654b2"],
    "IMapControlDataHelper": ["8bb0f09c-14ab-486c-9de5-5a5def0205a2"],
    "IMapControlDataHelper2": ["59ce429e-562f-4c21-a674-0f11decf0fb3"],
    "IMapControlDataHelperFactory": ["3b70aa8e-02ef-469c-bbaf-dc2158d4289b"],
    "IMapControlDataHelperStatics": ["7a6632d6-e944-4110-83cf-314d0722e2e5"],
    "IMapControlStatics": ["c2c61795-2147-4f0a-942a-5493a85de807"],
    "IMapControlStatics2": ["04852b93-b446-4d31-9752-1ec69a5996ae"],
    "IMapControlStatics4": ["fe785d97-5d13-4fa1-bf1d-84061768c183"],
    "IMapControlStatics5": ["09626f00-b7dd-4189-a7f7-830c412deea3"],
    "IMapControlStatics6": ["3ccfdd7f-24d1-40a2-8351-b3063a8c95a4"],
    "IMapControlStatics7": ["55f1ac4d-72c2-46b2-b7ae-790260be641b"],
    "IMapControlStatics8": ["adb7a7b0-0605-592c-bf9d-d10bdc2be47b"],
    "IMapControlTransitFeatureClickEventArgs": ["76179969-b765-4622-b08a-3072745a4541"],
    "IMapControlTransitFeaturePointerEnteredEventArgs": ["73911a4e-ec4f-479e-94a1-36e081d0d897"],
    "IMapControlTransitFeaturePointerExitedEventArgs": ["6a11258d-448d-44e7-bc69-d13d497154e9"],
    "IMapControlTransitFeatureRightTappedEventArgs": ["aea1cc49-a729-4eae-a59a-3ec9a125a028"],
    "IMapCustomExperience": ["64592866-14a3-4e5f-8883-8e9c500eeede"],
    "IMapCustomExperienceChangedEventArgs": ["b9e6fb9b-8fc1-4042-ac34-a61b38bb7514"],
    "IMapCustomExperienceFactory": ["7a403fb5-a1b1-4e7f-921e-3e6b8d8ebed6"],
    "IMapElement": ["d61fc4df-b245-47f2-9ac2-43c058b1c903"],
    "IMapElement2": ["6619f261-fba6-4964-a7ff-f1af63ab9cb0"],
    "IMapElement3": ["13efbc59-45ed-48b4-93ad-e3f78f8cf218"],
    "IMapElement3D": ["827af8d5-3843-48e2-bd00-0f0644fbe6a5"],
    "IMapElement3DStatics": ["6128011a-450f-442a-b9d9-aa815c71907a"],
    "IMapElement4": ["645883b6-1fc1-4ceb-93bd-dc2c960072e9"],
    "IMapElementClickEventArgs": ["40168a11-d080-4519-99a1-3149fb8999d0"],
    "IMapElementFactory": ["4a30d007-0bd6-47a5-860b-7e7cf5f0c573"],
    "IMapElementPointerEnteredEventArgs": ["ab85dd4e-91d7-4b31-8f0a-d390c7d3a2ef"],
    "IMapElementPointerExitedEventArgs": ["c1a45af9-60c9-4679-9119-20abc75d931f"],
    "IMapElementStatics": ["e8c71cf2-bfef-4b49-8e99-41b5e3789fd2"],
    "IMapElementStatics2": ["9bf72f30-80fe-4f30-bcc1-fa894050f676"],
    "IMapElementStatics3": ["e11ee92f-9742-49aa-aad8-2e466bff3796"],
    "IMapElementStatics4": ["a4296f0b-dff8-467c-9315-6f6db93ee2ba"],
    "IMapElementsLayer": ["de79689a-01ef-46f4-ac60-7c200b552610"],
    "IMapElementsLayerClickEventArgs": ["2ca7cf66-af1b-4c05-8c85-f74ae3d4677f"],
    "IMapElementsLayerContextRequestedEventArgs": ["da45d0b3-7a0e-4758-808b-3a637627eb0d"],
    "IMapElementsLayerPointerEnteredEventArgs": ["757fc032-4694-4404-8c89-348b6b76c5e6"],
    "IMapElementsLayerPointerExitedEventArgs": ["92f3c6ad-03ed-4c39-af20-2a07ee1ccea6"],
    "IMapElementsLayerStatics": ["34005727-f509-4d28-9180-911c03411d74"],
    "IMapFeatureDescriptor": ["530424bd-a257-436d-9e60-c2981f7cc5c4"],
    "IMapIcon": ["d2096872-23d9-4a2b-8be0-69f3a85482ab"],
    "IMapIcon2": ["611254b9-d8aa-4bbd-a316-badf06911d63"],
    "IMapIconStatics": ["dcbc9e56-1190-4b5d-9e56-e5b6724aa328"],
    "IMapIconStatics2": ["ff4c306a-cf76-46ab-a12f-b603b986c696"],
    "IMapInputEventArgs": ["9fc503a0-a8a2-4394-92e9-2247764f2f49"],
    "IMapItemsControl": ["94c2c4d3-b335-42c5-b660-e6a07ec3bddc"],
    "IMapItemsControlStatics": ["33a859c7-789b-425c-8a0a-32385896cb4a"],
    "IMapLayer": ["6d0ff9c1-a14d-4f97-8f57-46715b57683a"],
    "IMapLayerFactory": ["e02a2207-dee3-47c8-9825-bd029c5752f7"],
    "IMapLayerStatics": ["9ca4a26b-5db9-4f0c-bdd5-b1bffdcce946"],
    "IMapLibraryCallback": ["8da15fe7-5eeb-44e2-912f-039c51348136"],
    "IMapLocation": ["3c073f57-0da4-42e8-9ee2-a96fcf2371dc"],
    "IMapLocationFinderResult": ["43f1f179-e8cc-45f6-bed2-54ccbf965d9a"],
    "IMapLocationFinderStatics": ["318adb5d-1c5d-4f35-a2df-aaca94959517"],
    "IMapLocationFinderStatics2": ["959a8b96-6485-4dfd-851a-33ac317e3af6"],
    "IMapManagerStatics": ["37e3e515-82b4-4d54-8fd9-af2624b3011c"],
    "IMapModel3D": ["f8c541a1-ca27-4968-a2bf-9c20f06a0468"],
    "IMapModel3DFactory": ["df7f0bcc-580a-498b-939b-0119a9dadb9e"],
    "IMapModel3DStatics": ["4834a480-8e56-4b0f-872d-7ead103187cd"],
    "IMapPolygon": ["abda2285-4926-4c3a-a5f9-19df7f69db3d"],
    "IMapPolygon2": ["96c8a11e-636b-4018-9c2e-acc9122a01b2"],
    "IMapPolygonStatics": ["37f573be-097b-424c-87cc-2ee042fda6d2"],
    "IMapPolyline": ["fbad24a2-24df-4a86-8ffa-0f8f4d9ec17d"],
    "IMapPolylineStatics": ["61fde44b-1ddf-4303-b809-ec87f58ad065"],
    "IMapRightTappedEventArgs": ["20943171-6fe8-40a6-ad0e-297379b575a7"],
    "IMapRoute": ["fb07b732-584d-4583-9c60-641fea274349"],
    "IMapRoute2": ["d1c5d40c-2213-4ab0-a260-46b38169beac"],
    "IMapRoute3": ["858d1eae-f2ad-429f-bb37-cd21094ffc92"],
    "IMapRoute4": ["366c8ca5-3053-4fa1-80ff-d475f3ed1e6e"],
    "IMapRouteDrivingOptions": ["6815364d-c6dc-4697-a452-b18f8f0b67a1"],
    "IMapRouteDrivingOptions2": ["35dc8670-c298-48d0-b5ad-825460645603"],
    "IMapRouteFinderResult": ["a868a31a-9422-46ac-8ca1-b1614d4bfbe2"],
    "IMapRouteFinderResult2": ["20709c6d-d90c-46c8-91c6-7d4be4efb215"],
    "IMapRouteFinderStatics": ["b8a5c50f-1c64-4c3a-81eb-1f7c152afbbb"],
    "IMapRouteFinderStatics2": ["afcc2c73-7760-49af-b3bd-baf135b703e1"],
    "IMapRouteFinderStatics3": ["f6098134-5913-11e6-8b77-86f30ca893d3"],
    "IMapRouteLeg": ["96f8b2f6-5bba-4d17-9db6-1a263fec7471"],
    "IMapRouteLeg2": ["02e2062d-c9c6-45b8-8e54-1a10b57a17e8"],
    "IMapRouteManeuver": ["ed5c17f0-a6ab-4d65-a086-fa8a7e340df2"],
    "IMapRouteManeuver2": ["5d7bcd9c-7c9b-41df-838b-eae21e4b05a9"],
    "IMapRouteManeuver3": ["a6a138df-0483-4166-85be-b99336c11875"],
    "IMapRouteView": ["740eaec5-bacc-41e1-a67e-dd6513832049"],
    "IMapRouteViewFactory": ["f083addf-0066-4628-82fe-ea78c23cec1e"],
    "IMapScene": ["8bba10a9-50e7-482c-9789-c688b178ac24"],
    "IMapSceneStatics": ["03e4ad6c-86ec-44d9-9597-fb75b7deba0a"],
    "IMapServiceStatics": ["0144ad85-c04c-4cdd-871a-a0726d097cd4"],
    "IMapServiceStatics2": ["f8193eed-9c85-40a9-8896-0fc3fd2b7c2a"],
    "IMapServiceStatics3": ["0a11ce20-63a7-4854-b355-d6dcda223d1b"],
    "IMapServiceStatics4": ["088a2862-6abc-420e-945f-4cfd89c67356"],
    "IMapStyleSheet": ["ae54b2bf-8991-42ed-8d58-20473deede1d"],
    "IMapStyleSheetEntriesStatics": ["c9636345-ef1a-41a4-a757-bd4f43e1e4d1"],
    "IMapStyleSheetEntryStatesStatics": ["23ac5532-866d-4bfa-b481-39bea1de3506"],
    "IMapStyleSheetStatics": ["abbd00ad-0a1c-4335-82f4-61d936aa197d"],
    "IMapTargetCameraChangedEventArgs": ["dbf00472-e953-4fa8-97d0-ea86359057cf"],
    "IMapTargetCameraChangedEventArgs2": ["97c0b332-f2b6-460b-8d91-ac020a2383dd"],
    "IMapTileBitmapRequest": ["46733fbc-d89d-472b-b5f6-d7066b0584f4"],
    "IMapTileBitmapRequestDeferral": ["fe370542-a4ac-4efa-9665-0490b0cafdd2"],
    "IMapTileBitmapRequestedEventArgs": ["337f691d-9b02-4aa2-8b1e-cc4d91719bf3"],
    "IMapTileBitmapRequestedEventArgs2": ["0261d114-246a-5296-bc85-590f53aa39c8"],
    "IMapTileDataSource": ["c03d9f5e-be1f-4c69-9969-79467a513c38"],
    "IMapTileDataSourceFactory": ["a3920fbd-e446-4648-a74d-fd2c5d557c06"],
    "IMapTileSource": ["88a76e4e-2fdf-4567-9255-1100519c8d62"],
    "IMapTileSource2": ["8e65ebbd-4095-5c15-99f1-1260b4e8b0a9"],
    "IMapTileSourceFactory": ["cd7f811f-77fa-482b-9d34-71d31d465c48"],
    "IMapTileSourceStatics": ["93fcc93c-7035-4603-99b1-e659921b6093"],
    "IMapTileSourceStatics2": ["75cdd47e-669c-50fd-ad85-5ea5174cf59b"],
    "IMapTileUriRequest": ["17402335-3127-45b8-87a7-99f87d4e2745"],
    "IMapTileUriRequestDeferral": ["c117ade0-bf3e-4c51-8faa-4b593cf68eb2"],
    "IMapTileUriRequestedEventArgs": ["d2147b43-1bbf-4b98-8dd3-b7834e407e0d"],
    "IMapTileUriRequestedEventArgs2": ["2302185d-33b5-5a55-92f5-74a86a22efa6"],
    "IMapiOutOfProcHandler": ["8da6db1c-8114-40c6-9d97-d2e7e9757d67"],
    "IMapiOutOfProcHandler2": ["38004ea6-ecfd-4da2-a68f-d76ff85da38f"],
    "IMappableObjectRequestContext": ["d8af269b-0b07-461a-8986-19cf28ca0517"],
    "IMappedStream": ["7d747d7f-a49e-11d1-b28e-00c04fb9386d"],
    "IMapping": ["b05651d4-9b10-425e-b616-1fcd828db3b1"],
    "IMappings": ["b05651d3-9b10-425e-b616-1fcd828db3b1"],
    "IMarkupCallback": ["4440306e-d79a-48d0-88e6-a42692279bfb"],
    "IMarkupExtension": ["1ee3416d-562b-486e-9ee5-0f0cbcc8048c"],
    "IMarkupExtensionFactory": ["65329c05-fb5a-4567-9d55-5cdfbada2739"],
    "IMarkupExtensionOverrides": ["393779bf-b9c0-4ffb-a57f-58e7356e425f"],
    "IMarkupServicesPriv": ["3051073d-98b5-11cf-bb82-00aa00bdce0b"],
    "IMarshalEnvoy": ["000001c8-0000-0000-c000-000000000046"],
    "IMarshalOptions": ["4c1e39e1-e3e3-4296-aa86-ec938d896e92"],
    "IMarshalingDirectionAndLocality": ["7d8bce82-7493-4c5d-a54c-8427a03e4972"],
    "IMarshalingStream": ["d8f2f5e6-6102-4863-9f26-389a4676efde"],
    "IMarshallingManager": ["f6ebeb2b-c8de-11d1-b88e-00c04fb9618a"],
    "IMathInputControl": ["eba615aa-fac6-4738-ba5f-ff09e9fe473e"],
    "IMatrix3DHelper": ["e48c10ef-9927-4c9b-8213-07775512ba04"],
    "IMatrix3DHelperStatics": ["9264545e-e158-4e74-8899-689160bd2f8c"],
    "IMatrix3DProjection": ["6f03e149-bfc9-4c01-b578-50338cec97fc"],
    "IMatrix3DProjectionStatics": ["ae9d5895-41ec-4e37-abaa-69f41d2f876b"],
    "IMatrixHelper": ["f3cf4882-06b5-48c8-9eb2-1763e9364038"],
    "IMatrixHelperStatics": ["c18606a6-39f4-4b8a-8403-28e5e5f033b4"],
    "IMatrixTransform": ["edfdd551-5fed-45fc-ae62-92a4b6cf9707"],
    "IMatrixTransformStatics": ["43e02e47-15b8-4758-bb97-7d52420acc5b"],
    "IMbnConnection": ["dcbbbab6-200d-4bbb-aaee-338e368af6fa"],
    "IMbnConnectionContext": ["dcbbbab6-200b-4bbb-aaee-338e368af6fa"],
    "IMbnConnectionContextEvents": ["dcbbbab6-200c-4bbb-aaee-338e368af6fa"],
    "IMbnConnectionEvents": ["dcbbbab6-200e-4bbb-aaee-338e368af6fa"],
    "IMbnConnectionManager": ["dcbbbab6-201d-4bbb-aaee-338e368af6fa"],
    "IMbnConnectionManagerEvents": ["dcbbbab6-201e-4bbb-aaee-338e368af6fa"],
    "IMbnConnectionProfile": ["dcbbbab6-2010-4bbb-aaee-338e368af6fa"],
    "IMbnConnectionProfileEvents": ["dcbbbab6-2011-4bbb-aaee-338e368af6fa"],
    "IMbnConnectionProfileManager": ["dcbbbab6-200f-4bbb-aaee-338e368af6fa"],
    "IMbnConnectionProfileManagerEvents": ["dcbbbab6-201f-4bbb-aaee-338e368af6fa"],
    "IMbnDeviceService": ["b3bb9a71-dc70-4be9-a4da-7886ae8b191b"],
    "IMbnDeviceServiceStateEvents": ["5d3ff196-89ee-49d8-8b60-33ffddffc58d"],
    "IMbnDeviceServicesContext": ["fc5ac347-1592-4068-80bb-6a57580150d8"],
    "IMbnDeviceServicesEvents": ["0a900c19-6824-4e97-b76e-cf239d0ca642"],
    "IMbnDeviceServicesManager": ["20a26258-6811-4478-ac1d-13324e45e41c"],
    "IMbnInterface": ["dcbbbab6-2001-4bbb-aaee-338e368af6fa"],
    "IMbnInterfaceEvents": ["dcbbbab6-2002-4bbb-aaee-338e368af6fa"],
    "IMbnInterfaceManager": ["dcbbbab6-201b-4bbb-aaee-338e368af6fa"],
    "IMbnInterfaceManagerEvents": ["dcbbbab6-201c-4bbb-aaee-338e368af6fa"],
    "IMbnMultiCarrier": ["dcbbbab6-2020-4bbb-aaee-338e368af6fa"],
    "IMbnMultiCarrierEvents": ["dcdddab6-2021-4bbb-aaee-338e368af6fa"],
    "IMbnPin": ["dcbbbab6-2007-4bbb-aaee-338e368af6fa"],
    "IMbnPinEvents": ["dcbbbab6-2008-4bbb-aaee-338e368af6fa"],
    "IMbnPinManager": ["dcbbbab6-2005-4bbb-aaee-338e368af6fa"],
    "IMbnPinManagerEvents": ["dcbbbab6-2006-4bbb-aaee-338e368af6fa"],
    "IMbnRadio": ["dccccab6-201f-4bbb-aaee-338e368af6fa"],
    "IMbnRadioEvents": ["dcdddab6-201f-4bbb-aaee-338e368af6fa"],
    "IMbnRegistration": ["dcbbbab6-2009-4bbb-aaee-338e368af6fa"],
    "IMbnRegistrationEvents": ["dcbbbab6-200a-4bbb-aaee-338e368af6fa"],
    "IMbnServiceActivation": ["dcbbbab6-2017-4bbb-aaee-338e368af6fa"],
    "IMbnServiceActivationEvents": ["dcbbbab6-2018-4bbb-aaee-338e368af6fa"],
    "IMbnSignal": ["dcbbbab6-2003-4bbb-aaee-338e368af6fa"],
    "IMbnSignalEvents": ["dcbbbab6-2004-4bbb-aaee-338e368af6fa"],
    "IMbnSms": ["dcbbbab6-2015-4bbb-aaee-338e368af6fa"],
    "IMbnSmsConfiguration": ["dcbbbab6-2012-4bbb-aaee-338e368af6fa"],
    "IMbnSmsEvents": ["dcbbbab6-2016-4bbb-aaee-338e368af6fa"],
    "IMbnSmsReadMsgPdu": ["dcbbbab6-2013-4bbb-aaee-338e368af6fa"],
    "IMbnSmsReadMsgTextCdma": ["dcbbbab6-2014-4bbb-aaee-338e368af6fa"],
    "IMbnSubscriberInformation": ["459ecc43-bcf5-11dc-a8a8-001321f1405f"],
    "IMbnVendorSpecificEvents": ["dcbbbab6-201a-4bbb-aaee-338e368af6fa"],
    "IMbnVendorSpecificOperation": ["dcbbbab6-2019-4bbb-aaee-338e368af6fa"],
    "IMceBurnerControl": ["5a86b91a-e71e-46c1-88a9-9bb338710552"],
    "IMdmAlert": ["b0fbc327-28c1-4b52-a548-c5807caf70b6"],
    "IMdmAllowPolicyStatics": ["c39709e7-741c-41f2-a4b6-314c31502586"],
    "IMdmPolicyStatics2": ["c99c7526-03d4-49f9-a993-43efccd265c4"],
    "IMdmSession": ["fe89314c-8f64-4797-a9d7-9d88f86ae166"],
    "IMdmSessionManagerStatics": ["cf4ad959-f745-4b79-9b5c-de0bf8efe44b"],
    "IMediaActivityNotifySite": ["8165cfef-179d-46c2-bc71-3fa726dc1f8d"],
    "IMediaBinder": ["2b7e40aa-de07-424f-83f1-f1de46c4fa2e"],
    "IMediaBindingEventArgs": ["b61cb25a-1b6d-4630-a86d-2f0837f712e5"],
    "IMediaBindingEventArgs2": ["0464cceb-bb5a-482f-b8ba-f0284c696567"],
    "IMediaBindingEventArgs3": ["f8eb475e-19be-44fc-a5ed-7aba315037f9"],
    "IMediaBreak": ["714be270-0def-4ebc-a489-6b34930e1558"],
    "IMediaBreakEndedEventArgs": ["32b93276-1c5d-4fee-8732-236dc3a88580"],
    "IMediaBreakFactory": ["4516e002-18e0-4079-8b5f-d33495c15d2e"],
    "IMediaBreakManager": ["a854ddb1-feb4-4d9b-9d97-0fdbe58e5e39"],
    "IMediaBreakSchedule": ["a19a5813-98b6-41d8-83da-f971d22b7bba"],
    "IMediaBreakSeekedOverEventArgs": ["e5aa6746-0606-4492-b9d3-c3c8fde0a4ea"],
    "IMediaBreakSkippedEventArgs": ["6ee94c05-2f54-4a3e-a3ab-24c3b270b4a3"],
    "IMediaBreakStartedEventArgs": ["a87efe71-dfd4-454a-956e-0a4a648395f8"],
    "IMediaBuffer": ["59eff8b9-938c-4a26-82f2-95cb84cdc837"],
    "IMediaCapture": ["c61afbb4-fb10-4a34-ac18-ca80d9c8e7ee"],
    "IMediaCapture2": ["9cc68260-7da1-4043-b652-21b8878daff9"],
    "IMediaCapture3": ["d4136f30-1564-466e-bc0a-af94e02ab016"],
    "IMediaCapture4": ["bacd6fd6-fb08-4947-aea2-ce14eff0ce13"],
    "IMediaCapture5": ["da787c22-3a9b-4720-a71e-97900a316e5a"],
    "IMediaCapture6": ["228948bd-4b20-4bb1-9fd6-a583212a1012"],
    "IMediaCapture7": ["9169f102-8888-541a-95bc-24e4d462542a"],
    "IMediaCaptureDeviceExclusiveControlStatusChangedEventArgs": ["9d2f920d-a588-43c6-89d6-5ad322af006a"],
    "IMediaCaptureFailedEventArgs": ["80fde3f4-54c4-42c0-8d19-cea1a87ca18b"],
    "IMediaCaptureFailedEventHandler": ["2014effb-5cd8-4f08-a314-0d360da59f14"],
    "IMediaCaptureFocusChangedEventArgs": ["81e1bc7f-2277-493e-abee-d3f44ff98c04"],
    "IMediaCaptureInitializationSettings": ["9782ba70-ea65-4900-9356-8ca887726884"],
    "IMediaCaptureInitializationSettings2": ["404e0626-c9dc-43e9-aee4-e6bf1b57b44c"],
    "IMediaCaptureInitializationSettings3": ["4160519d-be48-4730-8104-0cf6e9e97948"],
    "IMediaCaptureInitializationSettings4": ["f502a537-4cb7-4d28-95ed-4f9f012e0518"],
    "IMediaCaptureInitializationSettings5": ["d5a2e3b8-2626-4e94-b7b3-5308a0f64b1a"],
    "IMediaCaptureInitializationSettings6": ["b2e26b47-3db1-4d33-ab63-0ffa09056585"],
    "IMediaCaptureInitializationSettings7": ["41546967-f58a-5d82-9ef4-ed572fb5e34e"],
    "IMediaCapturePauseResult": ["aec47ca3-4477-4b04-a06f-2c1c5182fe9d"],
    "IMediaCaptureRelativePanelWatcher": ["7d896566-04be-5b89-b30e-bd34a9f12db0"],
    "IMediaCaptureSettings": ["1d83aafe-6d45-4477-8dc4-ac5bc01c4091"],
    "IMediaCaptureSettings2": ["6f9e7cfb-fa9f-4b13-9cbe-5ab94f1f3493"],
    "IMediaCaptureSettings3": ["303c67c2-8058-4b1b-b877-8c2ef3528440"],
    "IMediaCaptureStatics": ["acef81ff-99ed-4645-965e-1925cfc63834"],
    "IMediaCaptureStopResult": ["f9db6a2a-a092-4ad1-97d4-f201f9d082db"],
    "IMediaCaptureVideoPreview": ["27727073-549e-447f-a20a-4f03c479d8c0"],
    "IMediaCaptureVideoProfile": ["21a073bf-a3ee-4ecf-9ef6-50b0bc4e1305"],
    "IMediaCaptureVideoProfile2": ["97ddc95f-94ce-468f-9316-fc5bc2638f6b"],
    "IMediaCaptureVideoProfileMediaDescription": ["8012afef-b691-49ff-83f2-c1e76eaaea1b"],
    "IMediaCaptureVideoProfileMediaDescription2": ["c6a6ef13-322d-413a-b85a-68a88e02f4e9"],
    "IMediaClip": ["53f25366-5fba-3ea4-8693-24761811140a"],
    "IMediaClipStatics": ["fa402b68-928f-43c4-bc6e-783a1a359656"],
    "IMediaClipStatics2": ["5b1dd7b3-854e-4d9b-877d-4774a556cd12"],
    "IMediaComposition": ["2e06e605-dc71-41d6-b837-2d2bc14a2947"],
    "IMediaComposition2": ["a59e5372-2366-492c-bec8-e6dfba6d0281"],
    "IMediaCompositionStatics": ["87a08f04-e32a-45ce-8f66-a30df0766224"],
    "IMediaCue": ["c7d15e5d-59dc-431f-a0ee-27744323b36d"],
    "IMediaCueEventArgs": ["d12f47f7-5fa4-4e68-9fe5-32160dcee57e"],
    "IMediaDet": ["65bd0710-24d2-4ff7-9324-ed2e5d3abafa"],
    "IMediaDeviceControl": ["efa8dfa9-6f75-4863-ba0b-583f3036b4de"],
    "IMediaDeviceControlCapabilities": ["23005816-eb85-43e2-b92b-8240d5ee70ec"],
    "IMediaDeviceController": ["f6f8f5ce-209a-48fb-86fc-d44578f317e6"],
    "IMediaDeviceStatics": ["aa2d9a40-909f-4bba-bf8b-0c0d296f14f0"],
    "IMediaElement": ["a38ed2cf-13de-4299-ade2-ae18f74ed353"],
    "IMediaElement2": ["fd53da65-b186-4654-bfdb-180ed26cad07"],
    "IMediaElement3": ["479f6f13-0fdb-4ed8-928a-4d39169c3cd2"],
    "IMediaElementAutomationPeer": ["ba0b9fc2-a6e2-41a5-b17a-d1594613efba"],
    "IMediaElementAutomationPeerFactory": ["b2ad3b28-7575-4173-9bc7-80367a164ed2"],
    "IMediaElementStatics": ["dccd2cb9-7568-4682-a72a-8ddf2a2665ca"],
    "IMediaElementStatics2": ["9ee7f826-f154-4dc6-8014-a6eba987f847"],
    "IMediaEncodingProfile": ["e7dbf5a8-1db9-4783-876b-3dfe12acfdb3"],
    "IMediaEncodingProfile2": ["349b3e0a-4035-488e-9877-85632865ed10"],
    "IMediaEncodingProfile3": ["ba6ebe88-7570-4e69-accf-5611ad015f88"],
    "IMediaEncodingProfileStatics": ["197f352c-2ede-4a45-a896-817a4854f8fe"],
    "IMediaEncodingProfileStatics2": ["ce8de74f-6af4-4288-8fe2-79adf1f79a43"],
    "IMediaEncodingProfileStatics3": ["90dac5aa-cf76-4294-a9ed-1a1420f51f6b"],
    "IMediaEncodingProperties": ["b4002af6-acd4-4e5a-a24b-5d7498a8b8c4"],
    "IMediaEncodingSubtypesStatics": ["37b6580e-a171-4464-ba5a-53189e48c1c8"],
    "IMediaEncodingSubtypesStatics2": ["4b7cd23d-42ff-4d33-8531-0626bee4b52d"],
    "IMediaEncodingSubtypesStatics3": ["ba2414e4-883d-464e-a44f-097da08ef7ff"],
    "IMediaEncodingSubtypesStatics4": ["ddece58a-3949-4644-8a2c-59ef02c642fa"],
    "IMediaEncodingSubtypesStatics5": ["5ad4a007-ffce-4760-9828-5d0c99637e6a"],
    "IMediaEncodingSubtypesStatics6": ["a1252973-a984-5912-93bb-54e7e569e053"],
    "IMediaEngineByteStream": ["8553efe9-667a-4bc6-a59e-448fa2ec1478"],
    "IMediaExtension": ["07915118-45df-442b-8a3f-f7826a6370ab"],
    "IMediaExtensionManager": ["4a25eaf5-242d-4dfb-97f4-69b7c42576ff"],
    "IMediaExtensionManager2": ["5bcebf47-4043-4fed-acaf-54ec29dfb1f7"],
    "IMediaFailedRoutedEventArgs": ["46d1fa8d-5149-4153-ba3c-b03e64ee531e"],
    "IMediaFrame": ["bfb52f8c-5943-47d8-8e10-05308aa5fbd0"],
    "IMediaFrameArrivedEventArgs": ["0b430add-a490-4435-ada1-9affd55239f7"],
    "IMediaFrameFormat": ["71902b4e-b279-4a97-a9db-bd5a2fb78f39"],
    "IMediaFrameFormat2": ["63856340-5e87-4c10-86d1-6df097a6c6a8"],
    "IMediaFrameReader": ["e4c94395-2028-48ed-90b0-d1c1b162e24c"],
    "IMediaFrameReader2": ["871127b3-8531-4050-87cc-a13733cf3e9b"],
    "IMediaFrameReference": ["f6b88641-f0dc-4044-8dc9-961cedd05bad"],
    "IMediaFrameReference2": ["ddbc3ecc-d5b2-49ef-836a-947d989b80c1"],
    "IMediaFrameSource": ["d6782953-90db-46a8-8add-2aa884a8d253"],
    "IMediaFrameSourceController": ["6d076635-316d-4b8f-b7b6-eeb04a8c6525"],
    "IMediaFrameSourceController2": ["efc49fd4-fcf2-4a03-b4e4-ac9628739bee"],
    "IMediaFrameSourceController3": ["1f0cf815-2464-4651-b1e8-4a82dbdb54de"],
    "IMediaFrameSourceGetPropertyResult": ["088616c2-3a64-4bd5-bd2b-e7c898d2f37a"],
    "IMediaFrameSourceGroup": ["7f605b87-4832-4b5f-ae3d-412faab37d34"],
    "IMediaFrameSourceGroupStatics": ["1c48bfc5-436f-4508-94cf-d5d8b7326445"],
    "IMediaFrameSourceInfo": ["87bdc9cd-4601-408f-91cf-038318cd0af3"],
    "IMediaFrameSourceInfo2": ["195a7855-6457-42c6-a769-19b65bd32e6e"],
    "IMediaFrameSourceInfo3": ["ca824ab6-66ea-5885-a2b6-26c0eeec3c7b"],
    "IMediaHolder": ["79eac9ce-baf9-11ce-8c82-00aa004ba90b"],
    "IMediaItemDisplayProperties": ["1e3c1b48-7097-4384-a217-c1291dfa8c16"],
    "IMediaLocator": ["288581e0-66ce-11d2-918f-00c0df10d434"],
    "IMediaMarker": ["1803def8-dca5-4b6f-9c20-e3d3c0643625"],
    "IMediaMarkerTypesStatics": ["bb198040-482f-4743-8832-45853821ece0"],
    "IMediaMarkers": ["afeab189-f8dd-466e-aa10-920b52353fdf"],
    "IMediaObject": ["d8ad0f58-5494-4102-97c5-ec798e59bcf4"],
    "IMediaObjectInPlace": ["651b9ad0-0fc7-4aa9-9538-d89931010741"],
    "IMediaOverlay": ["a902ae5d-7869-4830-8ab1-94dc01c05fa4"],
    "IMediaOverlayFactory": ["b584828a-6188-4f8f-a2e0-aa552d598e18"],
    "IMediaOverlayLayer": ["a6d9ba57-eeda-46c6-bbe5-e398c84168ac"],
    "IMediaOverlayLayerFactory": ["947cb473-a39e-4362-abbf-9f8b5070a062"],
    "IMediaParamInfo": ["6d6cbb60-a223-44aa-842f-a2f06750be6d"],
    "IMediaParams": ["6d6cbb61-a223-44aa-842f-a2f06750be6e"],
    "IMediaPlaybackCommandManager": ["5acee5a6-5cb6-4a5a-8521-cc86b1c1ed37"],
    "IMediaPlaybackCommandManagerAutoRepeatModeReceivedEventArgs": ["3d6f4f23-5230-4411-a0e9-bad94c2a045c"],
    "IMediaPlaybackCommandManagerCommandBehavior": ["786c1e78-ce78-4a10-afd6-843fcbb90c2e"],
    "IMediaPlaybackCommandManagerFastForwardReceivedEventArgs": ["30f064d9-b491-4d0a-bc21-3098bd1332e9"],
    "IMediaPlaybackCommandManagerNextReceivedEventArgs": ["e1504433-a2b0-45d4-b9de-5f42ac14a839"],
    "IMediaPlaybackCommandManagerPauseReceivedEventArgs": ["5ceccd1c-c25c-4221-b16c-c3c98ce012d6"],
    "IMediaPlaybackCommandManagerPlayReceivedEventArgs": ["9af0004e-578b-4c56-a006-16159d888a48"],
    "IMediaPlaybackCommandManagerPositionReceivedEventArgs": ["5591a754-d627-4bdd-a90d-86a015b24902"],
    "IMediaPlaybackCommandManagerPreviousReceivedEventArgs": ["525e3081-4632-4f76-99b1-d771623f6287"],
    "IMediaPlaybackCommandManagerRateReceivedEventArgs": ["18ea3939-4a16-4169-8b05-3eb9f5ff78eb"],
    "IMediaPlaybackCommandManagerRewindReceivedEventArgs": ["9f085947-a3c0-425d-aaef-97ba7898b141"],
    "IMediaPlaybackCommandManagerShuffleReceivedEventArgs": ["50a05cef-63ee-4a96-b7b5-fee08b9ff90c"],
    "IMediaPlaybackDataChangedEventHandler": ["d22f448d-39dc-415f-8325-91eddf0d5264"],
    "IMediaPlaybackDataSource": ["0f4521be-a0b8-4116-b3b1-bfecebaeebe6"],
    "IMediaPlaybackItem": ["047097d2-e4af-48ab-b283-6929e674ece2"],
    "IMediaPlaybackItem2": ["d859d171-d7ef-4b81-ac1f-f40493cbb091"],
    "IMediaPlaybackItem3": ["0d328220-b80a-4d09-9ff8-f87094a1c831"],
    "IMediaPlaybackItemError": ["69fbef2b-dcd6-4df9-a450-dbf4c6f1c2c2"],
    "IMediaPlaybackItemFactory": ["7133fce1-1769-4ff9-a7c1-38d2c4d42360"],
    "IMediaPlaybackItemFactory2": ["d77cdf3a-b947-4972-b35d-adfb931a71e6"],
    "IMediaPlaybackItemFailedEventArgs": ["7703134a-e9a7-47c3-862c-c656d30683d4"],
    "IMediaPlaybackItemOpenedEventArgs": ["cbd9bd82-3037-4fbe-ae8f-39fc39edf4ef"],
    "IMediaPlaybackItemStatics": ["4b1be7f4-4345-403c-8a67-f5de91df4c86"],
    "IMediaPlaybackList": ["7f77ee9c-dc42-4e26-a98d-7850df8ec925"],
    "IMediaPlaybackList2": ["0e09b478-600a-4274-a14b-0b6723d0f48b"],
    "IMediaPlaybackList3": ["dd24bba9-bc47-4463-aa90-c18b7e5ffde1"],
    "IMediaPlaybackSession": ["c32b683d-0407-41ba-8946-8b345a5a5435"],
    "IMediaPlaybackSession2": ["f8ba7c79-1fc8-4097-ad70-c0fa18cc0050"],
    "IMediaPlaybackSession3": ["7ba2b41a-a3e2-405f-b77b-a4812c238b66"],
    "IMediaPlaybackSessionBufferingStartedEventArgs": ["cd6aafed-74e2-43b5-b115-76236c33791a"],
    "IMediaPlaybackSessionOutputDegradationPolicyState": ["558e727d-f633-49f9-965a-abaa1db709be"],
    "IMediaPlaybackSource": ["ef9dc2bc-9317-4696-b051-2bad643177b5"],
    "IMediaPlaybackSphericalVideoProjection": ["d405b37c-6f0e-4661-b8ee-d487ba9752d5"],
    "IMediaPlaybackTimedMetadataTrackList": ["72b41319-bbfb-46a3-9372-9c9c744b9438"],
    "IMediaPlayer": ["381a83cb-6fff-499b-8d64-2885dfc1249e"],
    "IMediaPlayer2": ["3c841218-2123-4fc5-9082-2f883f77bdf5"],
    "IMediaPlayer3": ["ee0660da-031b-4feb-bd9b-92e0a0a8d299"],
    "IMediaPlayer4": ["80035db0-7448-4770-afcf-2a57450914c5"],
    "IMediaPlayer5": ["cfe537fd-f86a-4446-bf4d-c8e792b7b4b3"],
    "IMediaPlayer6": ["e0caa086-ae65-414c-b010-8bc55f00e692"],
    "IMediaPlayer7": ["5d1dc478-4500-4531-b3f4-777a71491f7f"],
    "IMediaPlayerDataReceivedEventArgs": ["c75a9405-c801-412a-835b-83fc0e622a8e"],
    "IMediaPlayerEffects": ["85a1deda-cab6-4cc0-8be3-6035f4de2591"],
    "IMediaPlayerEffects2": ["fa419a79-1bbe-46c5-ae1f-8ee69fb3c2c7"],
    "IMediaPlayerElement": ["3b4ca526-2e25-4598-bc71-d491f8e8de39"],
    "IMediaPlayerElementAutomationPeer": ["02bed209-3f65-4fdd-b5ca-c4750d4e6ea4"],
    "IMediaPlayerElementAutomationPeerFactory": ["08848077-82af-4d19-b170-282a9e0e7f37"],
    "IMediaPlayerElementFactory": ["77e525c3-eb17-4b8d-889d-1ea8abdbd4ef"],
    "IMediaPlayerElementStatics": ["1e7c4020-ac57-42dd-ad1c-3ebc2d7f08ba"],
    "IMediaPlayerFailedEventArgs": ["2744e9b9-a7e3-4f16-bac4-7914ebc08301"],
    "IMediaPlayerPresenter": ["77a92326-0c5b-41fc-bf49-15f6c3524b6b"],
    "IMediaPlayerPresenterFactory": ["e6766fb7-d96f-4b95-b33c-59e81cb1e9ba"],
    "IMediaPlayerPresenterStatics": ["84d774fe-ead4-4957-b42b-223158ca0de7"],
    "IMediaPlayerRateChangedEventArgs": ["40600d58-3b61-4bb2-989f-fc65608b6cab"],
    "IMediaPlayerSource": ["bd4f8897-1423-4c3e-82c5-0fb1af94f715"],
    "IMediaPlayerSource2": ["82449b9f-7322-4c0b-b03b-3e69a48260c5"],
    "IMediaPlayerSurface": ["0ed653bc-b736-49c3-830b-764a3845313a"],
    "IMediaProcessingTrigger": ["9a95be65-8a52-4b30-9011-cf38040ea8b0"],
    "IMediaProcessingTriggerDetails": ["eb8564ac-a351-4f4e-b4f0-9bf2408993db"],
    "IMediaPropertiesChangedEventArgs": ["7d3741cb-adf0-5cef-91ba-cfabcdd77678"],
    "IMediaProtectionManager": ["45694947-c741-434b-a79e-474c12d93d2f"],
    "IMediaProtectionPMPServer": ["0c111226-7b26-4d31-95bb-9c1b08ef7fc0"],
    "IMediaProtectionPMPServerFactory": ["602c8e5e-f7d2-487e-af91-dbc4252b2182"],
    "IMediaProtectionServiceCompletion": ["8b5cca18-cfd5-44ee-a2ed-df76010c14b5"],
    "IMediaProtectionServiceRequest": ["b1de0ea6-2094-478d-87a4-8b95200f85c6"],
    "IMediaQuery": ["30510749-98b5-11cf-bb82-00aa00bdce0b"],
    "IMediaRadioManager": ["6cfdcab5-fc47-42a5-9241-074b58830e73"],
    "IMediaRadioManagerNotifySink": ["89d81f5f-c147-49ed-a11c-77b20c31e7c9"],
    "IMediaRatio": ["d2d0fee5-8929-401d-ac78-7d357e378163"],
    "IMediaRenderer": ["2c012ec3-d975-47fb-96ac-a6418b326d2b"],
    "IMediaRendererActionInformation": ["66fbbfee-5ab0-4a4f-8d15-e5056b26beda"],
    "IMediaRendererBrokerStatics": ["19974cb1-9a1d-45c0-87cf-2c1e835a981c"],
    "IMediaRendererFactory": ["657ab43d-b909-42b2-94d0-e3a0b134e8c9"],
    "IMediaSample2Config": ["68961e68-832b-41ea-bc91-63593f3e70e3"],
    "IMediaSource": ["e7bfb599-a09d-4c21-bcdf-20af4f86b3d9"],
    "IMediaSource2": ["2eb61048-655f-4c37-b813-b4e45dfa0abe"],
    "IMediaSource3": ["b59f0d9b-4b6e-41ed-bbb4-7c7509a994ad"],
    "IMediaSource4": ["bdafad57-8eff-4c63-85a6-84de0ae3e4f2"],
    "IMediaSource5": ["331a22ae-ed2e-4a22-94c8-b743a92b3022"],
    "IMediaSourceAppServiceConnection": ["61e1ea97-1916-4810-b7f4-b642be829596"],
    "IMediaSourceAppServiceConnectionFactory": ["65b912eb-80b9-44f9-9c1e-e120f6d92838"],
    "IMediaSourceAudioInputNode": ["99d8983b-a88a-4041-8e4f-ddbac0c91fd3"],
    "IMediaSourceError": ["5c0a8965-37c5-4e9d-8d21-1cdee90cecc6"],
    "IMediaSourceOpenOperationCompletedEventArgs": ["fc682ceb-e281-477c-a8e0-1acd654114c8"],
    "IMediaSourceStateChangedEventArgs": ["0a30af82-9071-4bac-bc39-ca2a93b717a9"],
    "IMediaSourceStatics": ["f77d6fa4-4652-410e-b1d8-e9a5e245a45c"],
    "IMediaSourceStatics2": ["eee161a4-7f13-4896-b8cb-df0de5bcb9f1"],
    "IMediaSourceStatics3": ["453a30d6-2bea-4122-9f73-eace04526e35"],
    "IMediaSourceStatics4": ["281b3bfc-e50a-4428-a500-9c4ed918d3f0"],
    "IMediaStream": ["b502d1bd-9a57-11d0-8fde-00c04fd9189d"],
    "IMediaStreamDescriptor": ["80f16e6e-92f7-451e-97d2-afd80742da70"],
    "IMediaStreamDescriptor2": ["5073010f-e8b2-4071-b00b-ebf337a76b58"],
    "IMediaStreamFilter": ["bebe595e-9a6f-11d0-8fde-00c04fd9189d"],
    "IMediaStreamSample": ["5c8db627-4b80-4361-9837-6cb7481ad9d6"],
    "IMediaStreamSample2": ["45078691-fce8-4746-a1c8-10c25d3d7cd3"],
    "IMediaStreamSampleProtectionProperties": ["4eb88292-ecdf-493e-841d-dd4add7caca2"],
    "IMediaStreamSampleStatics": ["dfdf218f-a6cf-4579-be41-73dd941ad972"],
    "IMediaStreamSampleStatics2": ["9efe9521-6d46-494c-a2f8-d662922e2dd7"],
    "IMediaStreamSource": ["3712d543-45eb-4138-aa62-c01e26f3843f"],
    "IMediaStreamSource2": ["ec55d0ad-2e6a-4f74-adbb-b562d1533849"],
    "IMediaStreamSource3": ["6a2a2746-3ddd-4ddf-a121-94045ecf9440"],
    "IMediaStreamSource4": ["1d0cfcab-830d-417c-a3a9-2454fd6415c7"],
    "IMediaStreamSourceClosedEventArgs": ["cd8c7eb2-4816-4e24-88f0-491ef7386406"],
    "IMediaStreamSourceClosedRequest": ["907c00e9-18a3-4951-887a-2c1eebd5c69e"],
    "IMediaStreamSourceFactory": ["ef77e0d9-d158-4b7a-863f-203342fbfd41"],
    "IMediaStreamSourceSampleRenderedEventArgs": ["9d697b05-d4f2-4c7a-9dfe-8d6cd0b3ee84"],
    "IMediaStreamSourceSampleRequest": ["4db341a9-3501-4d9b-83f9-8f235c822532"],
    "IMediaStreamSourceSampleRequestDeferral": ["7895cc02-f982-43c8-9d16-c62d999319be"],
    "IMediaStreamSourceSampleRequestedEventArgs": ["10f9bb9e-71c5-492f-847f-0da1f35e81f8"],
    "IMediaStreamSourceStartingEventArgs": ["f41468f2-c274-4940-a5bb-28a572452fa7"],
    "IMediaStreamSourceStartingRequest": ["2a9093e4-35c4-4b1b-a791-0d99db56dd1d"],
    "IMediaStreamSourceStartingRequestDeferral": ["3f1356a5-6340-4dc4-9910-068ed9f598f8"],
    "IMediaStreamSourceSwitchStreamsRequest": ["41b8808e-38a9-4ec3-9ba0-b69b85501e90"],
    "IMediaStreamSourceSwitchStreamsRequestDeferral": ["bee3d835-a505-4f9a-b943-2b8cb1b4bbd9"],
    "IMediaStreamSourceSwitchStreamsRequestedEventArgs": ["42202b72-6ea1-4677-981e-350a0da412aa"],
    "IMediaTimelineController": ["8ed361f3-0b78-4360-bf71-0c841999ea1b"],
    "IMediaTimelineController2": ["ef74ea38-9e72-4df9-8355-6e90c81bbadd"],
    "IMediaTimelineControllerFailedEventArgs": ["8821f81d-3e77-43fb-be26-4fc87a044834"],
    "IMediaTrack": ["03e1fafc-c931-491a-b46b-c10ee8c256b7"],
    "IMediaTranscoder": ["190c99d2-a0aa-4d34-86bc-eed1b12c2f5b", "59007c49-cb25-4bd5-aad9-6943f08f4f9e"],
    "IMediaTranscoder2": ["40531d74-35e0-4f04-8574-ca8bc4e5a082"],
    "IMediaTransportControls": ["d6f69e7d-0825-49a9-9fce-5586d8694f0c"],
    "IMediaTransportControls2": ["2b89efec-1bea-451e-8bcd-cfe2d9423262"],
    "IMediaTransportControls3": ["5086430e-0940-11e7-93ae-92361f002671"],
    "IMediaTransportControls4": ["0fb17c58-9f23-11e7-abc4-cec278b6b50a"],
    "IMediaTransportControlsAutomationPeer": ["a3ad8d93-79f8-4958-a3c8-980defb83d15"],
    "IMediaTransportControlsAutomationPeerFactory": ["f41cb003-e103-4ab0-812a-a08fbdb570ce"],
    "IMediaTransportControlsFactory": ["1da2015a-a8e4-4c1b-88c9-0b183ecc62e3"],
    "IMediaTransportControlsHelper": ["3d41d509-ff44-4420-807e-8f7a2e2c4251"],
    "IMediaTransportControlsHelperStatics": ["5a772047-a9a1-4625-9270-7f49875d4394"],
    "IMediaTransportControlsStatics": ["590ea907-d2ef-4c1a-9429-b4b15d64fd56"],
    "IMediaTransportControlsStatics2": ["1728cfdc-561f-4386-a7f8-090d95f68d96"],
    "IMediaTransportControlsStatics3": ["5fe05542-0940-11e7-93ae-92361f002671"],
    "IMediaTransportControlsStatics4": ["0fb18144-9f23-11e7-abc4-cec278b6b50a"],
    "IMediaTransportControlsThumbnailRequestedEventArgs": ["e4a8b21c-e3c2-485c-ae69-f1537b76755a"],
    "IMemAllocatorCallbackTemp": ["379a0cf0-c1de-11d2-abf5-00a0c905f375"],
    "IMemAllocatorNotifyCallbackTemp": ["92980b30-c1de-11d2-abf5-00a0c905f375"],
    "IMemberOfIESession": ["0e4e1084-4290-4e24-bb44-31f0b9f9f9c4"],
    "IMemoryBuffer": ["fbc4dd2a-245b-11e4-af98-689423260cf8"],
    "IMemoryBufferFactory": ["fbc4dd2b-245b-11e4-af98-689423260cf8"],
    "IMemoryBufferReference": ["fbc4dd29-245b-11e4-af98-689423260cf8"],
    "IMemoryData": ["327fc560-af60-11d0-8212-00c04fc32c45"],
    "IMemoryManagerStatics": ["5c6c279c-d7ca-4779-9188-4057219ce64c"],
    "IMemoryManagerStatics2": ["6eee351f-6d62-423f-9479-b01f9c9f7669"],
    "IMemoryManagerStatics3": ["149b59ce-92ad-4e35-89eb-50dfb4c0d91c"],
    "IMemoryManagerStatics4": ["c5a94828-e84e-4886-8a0d-44b3190e3b72"],
    "IMemoryMappedCache": ["13a1f996-c8d8-4bb9-99f2-6e499e692736"],
    "IMemoryMappedCacheMgr": ["ecf31d61-e474-453c-bee7-de68e441c6d0"],
    "IMemoryMappedHeap": ["8f2b137c-34bb-490d-9cf8-c8c4e8184de6"],
    "IMemoryViewLangServiceInterop": ["e5776e42-0966-11d3-b87f-00c04f79e479"],
    "IMenuBar": ["c8f67b0c-0e76-5af2-bade-785049c80a41"],
    "IMenuBarAutomationPeer": ["4b6adcf1-f274-5592-85a8-7b099e99b320"],
    "IMenuBarAutomationPeerFactory": ["2a094871-4a9b-5a0b-9fda-7bc3ae957c53"],
    "IMenuBarFactory": ["dc619e50-72ba-513f-80aa-ddd093825dde"],
    "IMenuBarItem": ["bf643b4c-8125-5b53-a454-06e896a5acee"],
    "IMenuBarItemAutomationPeer": ["0fce49b4-cff5-5c4b-98ee-e75fdddf799a"],
    "IMenuBarItemAutomationPeerFactory": ["c9c77746-130f-5b19-83a6-61db584613aa"],
    "IMenuBarItemFactory": ["ecf86f62-c394-50e2-a568-17af8cf26874"],
    "IMenuBarItemFlyout": ["ed00d2d8-b686-55fe-8dbb-f04a640e42ef"],
    "IMenuBarItemFlyoutFactory": ["1d24f9bd-bd19-5d95-b573-711f649fcbe9"],
    "IMenuBarItemStatics": ["60a9e3fb-b405-50d0-bb78-d396a34da267"],
    "IMenuBarStatics": ["bed31c25-7db8-51cc-9706-1d79327daf93"],
    "IMenuFlyout": ["ad3210f1-985b-4171-bbba-67bcc729649b"],
    "IMenuFlyout2": ["507c7bad-d9d1-4c05-9d4b-cda8de9ab242"],
    "IMenuFlyoutFactory": ["644533ab-bbb9-499b-9ff3-30d40e2c56d8"],
    "IMenuFlyoutItem": ["160775cf-b598-44af-a488-c3ce2af6d3f0"],
    "IMenuFlyoutItem2": ["0ae266eb-028c-4423-a8e3-989fd9dd7126"],
    "IMenuFlyoutItem3": ["9727b2e3-b2b6-49dc-8c22-e0138b941559"],
    "IMenuFlyoutItemAutomationPeer": ["1fc19462-21df-456e-aa11-8fac6b4b2af6"],
    "IMenuFlyoutItemAutomationPeerFactory": ["d08bfcb8-20d1-45d8-a2c2-2f130df714e0"],
    "IMenuFlyoutItemBase": ["f9b56047-8da6-4730-9208-144125c6b396"],
    "IMenuFlyoutItemBaseFactory": ["83e6dbad-fc67-41d5-8797-60acd1ceb1d9"],
    "IMenuFlyoutItemFactory": ["c5aa39e2-44f3-455e-9c5b-62bb6afce3ad"],
    "IMenuFlyoutItemStatics": ["4950b424-a43a-41f7-aa3a-9ce9619747d5"],
    "IMenuFlyoutItemStatics2": ["aca4f564-1790-4601-916e-5ae1f01f4bd6"],
    "IMenuFlyoutItemStatics3": ["d83fd7c3-0aeb-4ef3-8270-8b9b95f2b298"],
    "IMenuFlyoutItemTemplateSettings": ["56ad1809-3a16-4147-81cb-d0b35c834e0f"],
    "IMenuFlyoutPresenter": ["906e0304-254e-413f-b219-c7b97f003752"],
    "IMenuFlyoutPresenter2": ["895894df-5a9f-4a1f-85ec-6f3c1b6dcb89"],
    "IMenuFlyoutPresenter3": ["6afd4e16-aee0-584a-9849-edaa323a484f"],
    "IMenuFlyoutPresenterAutomationPeer": ["e244a871-fcbb-48fc-8a93-41ea134b53ce"],
    "IMenuFlyoutPresenterAutomationPeerFactory": ["07b5172d-761d-452b-9e6d-fa2a8be0ad26"],
    "IMenuFlyoutPresenterFactory": ["b88b5091-101c-41f8-aac1-1b105c14fb99"],
    "IMenuFlyoutPresenterStatics3": ["3772a818-825a-520c-80ae-4d39a2d59ab5"],
    "IMenuFlyoutPresenterTemplateSettings": ["d68fd00d-629d-4349-ac51-b877c80983b8"],
    "IMenuFlyoutSeparator": ["71fa2b7d-0b51-4950-a1a4-bbc42eac4c12"],
    "IMenuFlyoutSeparatorFactory": ["c159dcc8-b437-44e0-b24b-5720aea1dbac"],
    "IMenuFlyoutStatics": ["3dbefba1-9522-4045-9e58-c99b13aab9b9"],
    "IMenuFlyoutSubItem": ["e5386550-fe2c-43e2-a73f-62168f619973"],
    "IMenuFlyoutSubItem2": ["ac935626-190a-4de2-8d71-7cc4747da580"],
    "IMenuFlyoutSubItemStatics": ["ddb27a36-1874-4aef-837d-6fec9da4e681"],
    "IMenuFlyoutSubItemStatics2": ["ac14d09b-3e93-4785-94ef-fdb23baba965"],
    "IMessageDialog": ["33f59b01-5325-43ab-9ab3-bdae440e4121"],
    "IMessageDialogFactory": ["2d161777-a66f-4ea5-bb87-793ffa4941f2"],
    "IMessageDispatcher": ["f5f84c8f-cfd0-4cd6-b66b-c5d26ff1689d"],
    "IMessageRaw": ["0002038a-0000-0000-c000-000000000046"],
    "IMessageReceivedCallback": ["f5b4c8ff-1d9d-4995-9fea-4d15257c0757"],
    "IMessageReceivedHandler": ["efab0782-f6e2-4675-a045-d8e320c24808"],
    "IMessageTransmittedHandler": ["efaa0b4a-f6e2-4d7d-856c-78fc8efc021e"],
    "IMessageWebSocket": ["33727d08-34d5-4746-ad7b-8dde5bc2ef88"],
    "IMessageWebSocket2": ["bed0cee7-f9c8-440a-9ad5-737281d9742e"],
    "IMessageWebSocket3": ["59d9defb-71af-4349-8487-911fcf681597"],
    "IMessageWebSocketControl": ["8118388a-c629-4f0a-80fb-81fc05538862"],
    "IMessageWebSocketControl2": ["e30fd791-080c-400a-a712-27dfa9e744d8"],
    "IMessageWebSocketMessageReceivedEventArgs": ["478c22ac-4c4b-42ed-9ed7-1ef9f94fa3d5"],
    "IMessageWebSocketMessageReceivedEventArgs2": ["89ce06fd-dd6f-4a07-87f9-f9eb4d89d83d"],
    "IMessages": ["cd000025-8b95-11d1-82db-00c04fb1625d"],
    "IMetaDataInfo": ["7998ea64-7f95-48b8-86fc-17caf48bf5cb"],
    "IMetaDataRegEmit": ["601c95b9-7398-11d2-9771-00a0c9b4d50c"],
    "IMetaDataRegEmitOld": ["f28f419b-62ca-11d2-8f2c-00a0c9a6186d"],
    "IMetaDataRegImport": ["4398b4fd-7399-11d2-9771-00a0c9b4d50c"],
    "IMetaDataRegImportOld": ["f28f419a-62ca-11d2-8f2c-00a0c9a6186d"],
    "IMetaDataWinMDImport": ["969ea0c5-964e-411b-a807-b0f3c2dfcbd4"],
    "IMethodMalloc": ["a0efb28b-6ee2-4d7b-b983-a75ef7beedb8"],
    "IMicrosoftAccountMultiFactorAuthenticationManager": ["0fd340a5-f574-4320-a08e-0a19a82322aa"],
    "IMicrosoftAccountMultiFactorAuthenticatorStatics": ["d964c2e6-f446-4c71-8b79-6ea4024aa9b8"],
    "IMicrosoftAccountMultiFactorGetSessionsResult": ["4e23a9a0-e9fa-497a-95de-6d5747bf974c"],
    "IMicrosoftAccountMultiFactorOneTimeCodedInfo": ["82ba264b-d87c-4668-a976-40cfae547d08"],
    "IMicrosoftAccountMultiFactorSessionInfo": ["5f7eabb4-a278-4635-b765-b494eb260af4"],
    "IMicrosoftAccountMultiFactorUnregisteredAccountsAndSessionInfo": ["aa7ec5fb-da3f-4088-a20d-5618afadb2e5"],
    "IMidiChannelPressureMessage": ["be1fa860-62b4-4d52-a37e-92e54d35b909"],
    "IMidiChannelPressureMessageFactory": ["6218ed2f-2284-412a-94cf-10fb04842c6c"],
    "IMidiControlChangeMessage": ["b7e15f83-780d-405f-b781-3e1598c97f40"],
    "IMidiControlChangeMessageFactory": ["2ab14321-956c-46ad-9752-f87f55052fe3"],
    "IMidiInPort": ["d5c1d9db-971a-4eaf-a23d-ea19fe607ff9"],
    "IMidiInPortStatics": ["44c439dc-67ff-4a6e-8bac-fdb6610cf296"],
    "IMidiMessage": ["79767945-1094-4283-9be0-289fc0ee8334"],
    "IMidiMessageReceivedEventArgs": ["76566e56-f328-4b51-907d-b3a8ce96bf80"],
    "IMidiNoteOffMessage": ["16fd8af4-198e-4d8f-a654-d305a293548f"],
    "IMidiNoteOffMessageFactory": ["a6b240e0-a749-425f-8af4-a4d979cc15b5"],
    "IMidiNoteOnMessage": ["e0224af5-6181-46dd-afa2-410004c057aa"],
    "IMidiNoteOnMessageFactory": ["9b4280a0-59c1-420e-b517-15a10aa9606b"],
    "IMidiOutPort": ["931d6d9f-57a2-4a3a-adb8-4640886f6693"],
    "IMidiOutPortStatics": ["065cc3e9-0f88-448b-9b64-a95826c65b8f"],
    "IMidiPitchBendChangeMessage": ["29df4cb1-2e9f-4faf-8c2b-9cb82a9079ca"],
    "IMidiPitchBendChangeMessageFactory": ["f5eedf55-cfc8-4926-b30e-a3622393306c"],
    "IMidiPolyphonicKeyPressureMessage": ["1f7337fe-ace8-48a0-868e-7cdbf20f04d6"],
    "IMidiPolyphonicKeyPressureMessageFactory": ["e98f483e-c4b3-4dd2-917c-e349815a1b3b"],
    "IMidiProgramChangeMessage": ["9cbb3c78-7a3e-4327-aa98-20b8e4485af8"],
    "IMidiProgramChangeMessageFactory": ["d6b04387-524b-4104-9c99-6572bfd2e261"],
    "IMidiSongPositionPointerMessage": ["4ca50c56-ec5e-4ae4-a115-88dc57cc2b79"],
    "IMidiSongPositionPointerMessageFactory": ["9c00e996-f10b-4fea-b395-f5d6cf80f64e"],
    "IMidiSongSelectMessage": ["49f0f27f-6d83-4741-a5bf-4629f6be974f"],
    "IMidiSongSelectMessageFactory": ["848878e4-8748-4129-a66c-a05493f75daa"],
    "IMidiSynthesizer": ["f0da155e-db90-405f-b8ae-21d2e17f2e45"],
    "IMidiSynthesizerStatics": ["4224eaa8-6629-4d6b-aa8f-d4521a5a31ce"],
    "IMidiSystemExclusiveMessageFactory": ["083de222-3b74-4320-9b42-0ca8545f8a24"],
    "IMidiTimeCodeMessage": ["0bf7087d-fa63-4a1c-8deb-c0e87796a6d7"],
    "IMidiTimeCodeMessageFactory": ["eb3099c5-771c-40de-b961-175a7489a85e"],
    "IMigratedIdentityConnector": ["da13a187-4301-43be-85b4-e385699d3099"],
    "IMiniHwndProxy": ["393f766c-d5ef-4cba-bb23-935166dc30b8"],
    "IMiniport": ["b4c90a24-5791-11d0-86f9-00a0c911b544"],
    "IMiniportAudioEngineNode": ["2ebf536c-ef57-4c64-bedc-25c1a6d668e6"],
    "IMiniportAudioSignalProcessing": ["b532678c-be50-472d-9973-8a6f16594989"],
    "IMiniportDMus": ["c096df9d-fb09-11d1-81b0-0060083316c1", "c096df9d-fb09-11d1-81b0-0060083316c1"],
    "IMiniportMidi": ["b4c90a41-5791-11d0-86f9-00a0c911b544"],
    "IMiniportMidiStream": ["b4c90a42-5791-11d0-86f9-00a0c911b544"],
    "IMiniportPnpNotify": ["6b735365-9487-464c-93e3-fa2c6391d5a4"],
    "IMiniportStreamAudioEngineNode": ["bd6eeb4b-e6e5-40fd-8d5a-5b1dcde20c42"],
    "IMiniportStreamAudioEngineNode2": ["aeb7f86a-6cba-44cf-a2d2-b3fa5b696817"],
    "IMiniportTopology": ["b4c90a31-5791-11d0-86f9-00a0c911b544"],
    "IMiniportWaveCyclic": ["b4c90a27-5791-11d0-86f9-00a0c911b544"],
    "IMiniportWaveCyclicStream": ["b4c90a28-5791-11d0-86f9-00a0c911b544"],
    "IMiniportWavePci": ["b4c90a52-5791-11d0-86f9-00a0c911b544"],
    "IMiniportWavePciStream": ["b4c90a53-5791-11d0-86f9-00a0c911b544"],
    "IMiniportWaveRT": ["0f9fc4d6-6061-4f3c-b1fc-075e35f7960a"],
    "IMiniportWaveRTInputStream": ["cd8e756a-5fc7-4624-984b-2af02925b91f"],
    "IMiniportWaveRTOutputStream": ["831fc7bc-6347-44bc-b47b-c0c657b5bf73"],
    "IMiniportWaveRTStream": ["000ac9ab-faab-4f3d-9455-6ff8306a74a0"],
    "IMiniportWaveRTStreamNotification": ["23759128-96f1-423b-ab4d-81635bcf8ca1"],
    "IMiracastReceiver": ["7a315258-e444-51b4-aff7-b88daa1229e0"],
    "IMiracastReceiverApplySettingsResult": ["d0aa6272-09cd-58e1-a4f2-5d5143d312f9"],
    "IMiracastReceiverConnection": ["704b2f36-d2e5-551f-a854-f822b7917d28"],
    "IMiracastReceiverConnectionCreatedEventArgs": ["7d8dfa39-307a-5c0f-94bd-d0c69d169982"],
    "IMiracastReceiverCursorImageChannel": ["d9ac332d-723a-5a9d-b90a-81153efa2a0f"],
    "IMiracastReceiverCursorImageChannelSettings": ["ccdbedff-bd00-5b9c-8e4c-00cacf86b634"],
    "IMiracastReceiverDisconnectedEventArgs": ["d9a15e5e-5fee-57e6-b4b0-04727db93229"],
    "IMiracastReceiverGameControllerDevice": ["2d7171e8-bed4-5118-a058-e2477eb5888d"],
    "IMiracastReceiverInputDevices": ["da35bb02-28aa-5ee8-96f5-a42901c66f00"],
    "IMiracastReceiverKeyboardDevice": ["beb67272-06c0-54ff-ac96-217464ff2501"],
    "IMiracastReceiverMediaSourceCreatedEventArgs": ["17cf519e-1246-531d-945a-6b158e39c3aa"],
    "IMiracastReceiverSession": ["1d2bcdb4-ef8b-5209-bfc9-c32116504803"],
    "IMiracastReceiverSessionStartResult": ["b7c573ee-40ca-51ff-95f2-c9de34f2e90e"],
    "IMiracastReceiverSettings": ["57cd2f24-c55a-5fbe-9464-eb05307705dd"],
    "IMiracastReceiverStatus": ["c28a5591-23ab-519e-ad09-90bff6dcc87e"],
    "IMiracastReceiverStreamControl": ["38ea2d8b-2769-5ad7-8a8a-254b9df7ba82"],
    "IMiracastReceiverVideoStreamSettings": ["169b5e1b-149d-52d0-b126-6f89744e4f50"],
    "IMiracastTelemetryJournal": ["c2e800c0-6294-4548-862a-365d4ccb30c0"],
    "IMiracastTestRemoteCommandSender": ["a0722be2-1b15-4061-b208-5907b163fb98"],
    "IMiracastTestRemoteCommandSender2": ["e1994a4e-b751-4e9a-add7-29ac397541cc"],
    "IMiracastTransmitter": ["342d79fd-2e64-5508-8a30-833d1eac70d0"],
    "IMixerOCX": ["81a3bd32-dee1-11d1-8508-00a0c91f9ca0"],
    "IMixerOCXNotify": ["81a3bd31-dee1-11d1-8508-00a0c91f9ca0"],
    "IMixerPinConfig2": ["ebf47182-8764-11d1-9e69-00c04fd7c15b"],
    "IMnemonics": ["d6d9aabf-5336-425a-a4b1-d0ff94bddf75"],
    "IMobileBroadbandAccount": ["36c24ccd-cee2-43e0-a603-ee86a36d6570"],
    "IMobileBroadbandAccount2": ["38f52f1c-1136-4257-959f-b658a352b6d4"],
    "IMobileBroadbandAccount3": ["092a1e21-9379-4b9b-ad31-d5fee2f748c6"],
    "IMobileBroadbandAccountEventArgs": ["3853c880-77de-4c04-bead-a123b08c9f59"],
    "IMobileBroadbandAccountStatics": ["aa7f4d24-afc1-4fc8-ae9a-a9175310faad"],
    "IMobileBroadbandAccountUpdatedEventArgs": ["7bc31d88-a6bd-49e1-80ab-6b91354a57d4"],
    "IMobileBroadbandAccountWatcher": ["6bf3335e-23b5-449f-928d-5e0d3e04471d"],
    "IMobileBroadbandAntennaSar": ["b9af4b7e-cbf9-4109-90be-5c06bfd513b6"],
    "IMobileBroadbandAntennaSarFactory": ["a91e1716-c04d-4a21-8698-1459dc672c6e"],
    "IMobileBroadbandCellCdma": ["0601b3b4-411a-4f2e-8287-76f5650c60cd"],
    "IMobileBroadbandCellGsm": ["cc917f06-7ee0-47b8-9e1f-c3b48df9df5b"],
    "IMobileBroadbandCellLte": ["9197c87b-2b78-456d-8b53-aaa25d0af741"],
    "IMobileBroadbandCellTdscdma": ["0eda1655-db0e-4182-8cda-cc419a7bde08"],
    "IMobileBroadbandCellUmts": ["77b4b5ae-49c8-4f15-b285-4c26a7f67215"],
    "IMobileBroadbandCellsInfo": ["89a9562a-e472-4da5-929c-de61711dd261"],
    "IMobileBroadbandDeviceInformation": ["e6d08168-e381-4c6e-9be8-fe156969a446"],
    "IMobileBroadbandDeviceInformation2": ["2e467af1-f932-4737-a722-03ba72370cb8"],
    "IMobileBroadbandDeviceInformation3": ["e08bb4bd-5d30-4b5a-92cc-d54df881d49e"],
    "IMobileBroadbandDeviceService": ["22be1a52-bd80-40ac-8e1f-2e07836a3dbd"],
    "IMobileBroadbandDeviceServiceCommandResult": ["b0f46abb-94d6-44b9-a538-f0810b645389"],
    "IMobileBroadbandDeviceServiceCommandSession": ["fc098a45-913b-4914-b6c3-ae6304593e75"],
    "IMobileBroadbandDeviceServiceDataReceivedEventArgs": ["b6aa13de-1380-40e3-8618-73cbca48138c"],
    "IMobileBroadbandDeviceServiceDataSession": ["dad62333-8bcf-4289-8a37-045c2169486a"],
    "IMobileBroadbandDeviceServiceInformation": ["53d69b5b-c4ed-45f0-803a-d9417a6d9846"],
    "IMobileBroadbandDeviceServiceTriggerDetails": ["4a055b70-b9ae-4458-9241-a6a5fbf18a0c"],
    "IMobileBroadbandModem": ["d0356912-e9f9-4f67-a03d-43189a316bf1"],
    "IMobileBroadbandModem2": ["12862b28-b9eb-4ee2-bbe3-711f53eea373"],
    "IMobileBroadbandModem3": ["e9fec6ea-2f34-4582-9102-c314d2a87eec"],
    "IMobileBroadbandModemConfiguration": ["fce035a3-d6cd-4320-b982-be9d3ec7890f"],
    "IMobileBroadbandModemConfiguration2": ["320ff5c5-e460-42ae-aa51-69621e7a4477"],
    "IMobileBroadbandModemIsolation": ["b5618fec-e661-4330-9bb4-3480212ec354"],
    "IMobileBroadbandModemIsolationFactory": ["21d7ec58-c2b1-4c2f-a030-72820a24ecd9"],
    "IMobileBroadbandModemStatics": ["f99ed637-d6f1-4a78-8cbc-6421a65063c8"],
    "IMobileBroadbandNetwork": ["cb63928c-0309-4cb6-a8c1-6a5a3c8e1ff6"],
    "IMobileBroadbandNetwork2": ["5a55db22-62f7-4bdd-ba1d-477441960ba0"],
    "IMobileBroadbandNetwork3": ["33670a8a-c7ef-444c-ab6c-df7ef7a390fe"],
    "IMobileBroadbandNetworkRegistrationStateChange": ["beaf94e1-960f-49b4-a08d-7d85e968c7ec"],
    "IMobileBroadbandNetworkRegistrationStateChangeTriggerDetails": ["89135cff-28b8-46aa-b137-1c4b0f21edfe"],
    "IMobileBroadbandPco": ["d4e4fcbe-e3a3-43c5-a87b-6c86d229d7fa"],
    "IMobileBroadbandPcoDataChangeTriggerDetails": ["263f5114-64e0-4493-909b-2d14a01962b1"],
    "IMobileBroadbandPin": ["e661d709-e779-45bf-8281-75323df9e321"],
    "IMobileBroadbandPinLockStateChange": ["be16673e-1f04-4f95-8b90-e7f559dde7e5"],
    "IMobileBroadbandPinLockStateChangeTriggerDetails": ["d338c091-3e91-4d38-9036-aee83a6e79ad"],
    "IMobileBroadbandPinOperationResult": ["11dddc32-31e7-49f5-b663-123d3bef0362"],
    "IMobileBroadbandRadioStateChange": ["b054a561-9833-4aed-9717-4348b21a24b3"],
    "IMobileBroadbandRadioStateChangeTriggerDetails": ["71301ace-093c-42c6-b0db-ad1f75a65445"],
    "IMobileBroadbandSarManager": ["e5b26833-967e-40c9-a485-19c0dd209e22"],
    "IMobileBroadbandTransmissionStateChangedEventArgs": ["612e3875-040a-4f99-a4f9-61d7c32da129"],
    "IMobileBroadbandUicc": ["e634f691-525a-4ce2-8fce-aa4162579154"],
    "IMobileBroadbandUiccApp": ["4d170556-98a1-43dd-b2ec-50c90cf248df"],
    "IMobileBroadbandUiccAppReadRecordResult": ["64c95285-358e-47c5-8249-695f383b2bdb"],
    "IMobileBroadbandUiccAppRecordDetailsResult": ["d919682f-be14-4934-981d-2f57b9ed83e6"],
    "IMobileBroadbandUiccAppsResult": ["744930eb-8157-4a41-8494-6bf54c9b1d2b"],
    "IMobileShareFlow": ["6fff3c95-3a4c-408c-8054-d67cde86aa43"],
    "IMobilityCenterButtonTile": ["c76ea1c8-6979-4df4-8866-4ccde9afbfde"],
    "IMobilityCenterDropDownTile": ["fffa805b-896a-41ff-9fe0-840da6476686"],
    "IMobilityCenterSliderTile": ["1b0120c9-73ab-4249-91e0-ca3e61924b7f"],
    "IMobilityCenterTile": ["4494508a-f2e7-4600-9ce6-aa52c57efc05"],
    "IModalDialogService": ["64177068-b7fd-4fd2-aba3-e041634bb85a"],
    "IModelIterator": ["e4622136-927d-4490-874f-581f3e4e3688"],
    "IModelKeyReference": ["5253dcf8-5aff-4c62-b302-56a289e00998"],
    "IModelKeyReference2": ["80e2f7c5-7159-4e92-887e-7e0347e88406"],
    "IModelMethod": ["80600c1f-b90b-4896-82ad-1c00207909e8"],
    "IModelObject": ["e28c7893-3f4b-4b96-baca-293cdc55f45d"],
    "IModelPropertyAccessor": ["5a0c63d9-0526-42b8-960c-9516a3254c85"],
    "IModemOpaqueCommandCompletion": ["c9b4415b-0643-4855-bb04-a5354f038e62"],
    "IModernApplicationCollectionView": ["e0cbedef-1a1d-4338-af89-b15a4a20cbeb"],
    "IModernMarketplaceApplicationLicenseManager": ["6de824ea-5f9e-486f-aa10-fbf12f5efe30"],
    "IModernShareAccount": ["fff6575a-ee9f-4268-b48c-c8e7dd7edad8"],
    "IModernSyncEngine": ["199b4637-68e1-4ddc-aab8-171120786182"],
    "IModernSyncEngine2": ["3b781a45-c8e2-4bb6-9777-1e735db697c5"],
    "IModernSyncEngineCB": ["ffee12ba-6343-444e-9f57-a96a08393bff"],
    "IModernSyncEngineCB2": ["6e18ec30-eeaf-467f-a175-0b8f7ae7e589"],
    "IModernSyncEngineEvents": ["07c11194-95da-4287-af03-4f4eb210f0d9"],
    "IModifyPropertyStoreCapabilities": ["5235f504-ff8f-462d-8dcb-d2fadb54cb60"],
    "IModuleCommandResult": ["520d1eb4-1374-4c7d-b1e4-39dcdf3eae4e"],
    "IMofCompiler": ["6daf974e-2e37-11d2-aec9-00c04fb68820"],
    "IMonthlyDOWTrigger": ["77d025a3-90fa-43aa-b52e-cda5499b946a"],
    "IMonthlyTrigger": ["97c45ef1-6b02-4a1a-9c0e-1ebfba1500ac"],
    "IMountPointRename": ["92f8d886-ab61-4113-bd4f-2e894397386f"],
    "IMouseCapabilities": ["bca5e023-7dd9-4b6b-9a92-55d43cb38f73"],
    "IMouseDevice": ["88edf458-f2c8-49f4-be1f-c256b388bc11"],
    "IMouseDeviceStatics": ["484a9045-6d70-49db-8e68-46ffbd17d38d"],
    "IMouseEventArgs": ["f625aa5d-2354-4cc7-9230-96941c969fde"],
    "IMouseWheelParameters": ["ead0ca44-9ded-4037-8149-5e4cc2564468"],
    "IMpeg2Data": ["9b396d40-f380-4e3c-a514-1a82bf6ebfe6"],
    "IMpeg2Demultiplexer": ["436eee9c-264f-4242-90e1-4e330c107512"],
    "IMpeg2DemultiplexerModeConfig": ["3eb1ddcf-2265-4caa-b0cc-35ac60774f6f"],
    "IMpeg2ProfileIdsStatics": ["a461ff85-e57a-4128-9b21-d5331b04235c"],
    "IMpeg2Stream": ["400cc286-32a0-4ce4-9041-39571125a635"],
    "IMpeg2TSPsiParser": ["c5d0dd45-05e2-4703-938f-4abbc6e3dee0"],
    "IMpeg2TableFilter": ["bdcdd913-9ecd-4fb2-81ae-adf747ea75a5"],
    "IMrtResourceManager": ["130a2f65-2be7-4309-9a58-a9052ff2b61c"],
    "IMrtResourceManager2": ["439dd7c9-0eeb-4715-baa7-f0877694e616"],
    "IMrtResourceManager3": ["76fdfec5-e7df-473b-891b-02453923b247"],
    "IMrtStringResolver": ["cfa81e06-a062-4e18-a62d-925397413383"],
    "IMsaWindowManager": ["6932b003-ec34-43d7-9cbf-12a1e5a4ed24"],
    "IMsaWindowManagerAppCloseNotification": ["4027fb1b-e493-4d38-8f6b-1df5d343987b"],
    "IMsaWindowManagerBroker": ["365e356c-9c2e-42bf-9a92-5e4e017d0575"],
    "IMseSourceBuffer": ["0c1aa3e3-df8d-4079-a3fe-6849184b4e2f"],
    "IMseSourceBufferList": ["95fae8e7-a8e7-4ebf-8927-145e940ba511"],
    "IMseStreamSource": ["b0b4198d-02f4-4923-88dd-81bc3f360ffa"],
    "IMseStreamSource2": ["66f57d37-f9e7-418a-9cde-a020e956552b"],
    "IMseStreamSourceStatics": ["465c679d-d570-43ce-ba21-0bff5f3fbd0a"],
    "IMsiConfigurationManager": ["000c101b-0000-0000-c000-000000000046"],
    "IMsiCostAdjuster": ["000c101a-0000-0000-c000-000000000046"],
    "IMsiCursor": ["000c1009-0000-0000-c000-000000000046"],
    "IMsiCustomAction": ["000c1025-0000-0000-c000-000000000046"],
    "IMsiCustomActionLocalConfig": ["000c1038-0000-0000-c000-000000000046"],
    "IMsiData": ["000c1001-0000-0000-c000-000000000046"],
    "IMsiDatabase": ["000c100d-0000-0000-c000-000000000046"],
    "IMsiDirectoryManager": ["000c1019-0000-0000-c000-000000000046"],
    "IMsiExecute": ["000c101e-0000-0000-c000-000000000046"],
    "IMsiFileCopy": ["000c1006-0000-0000-c000-000000000046"],
    "IMsiFilePatch": ["000c101f-0000-0000-c000-000000000046"],
    "IMsiHandler": ["000c100f-0000-0000-c000-000000000046"],
    "IMsiMalloc": ["000c1017-0000-0000-c000-000000000046"],
    "IMsiMemoryStream": ["000c100a-0000-0000-c000-000000000046"],
    "IMsiMessage": ["000c101d-0000-0000-c000-000000000046"],
    "IMsiPath": ["000c1005-0000-0000-c000-000000000046"],
    "IMsiRecord": ["000c1003-0000-0000-c000-000000000046"],
    "IMsiRegKey": ["000c1007-0000-0000-c000-000000000046"],
    "IMsiRemoteAPI": ["000c1033-0000-0000-c000-000000000046"],
    "IMsiSelectionManager": ["000c1018-0000-0000-c000-000000000046"],
    "IMsiServer": ["000c101c-0000-0000-c000-000000000046"],
    "IMsiStorage": ["000c1014-0000-0000-c000-000000000046"],
    "IMsiStream": ["000c1015-0000-0000-c000-000000000046"],
    "IMsiString": ["000c1002-0000-0000-c000-000000000046"],
    "IMsiTable": ["000c1008-0000-0000-c000-000000000046"],
    "IMsiView": ["000c100c-0000-0000-c000-000000000046"],
    "IMsiVolume": ["000c1004-0000-0000-c000-000000000046"],
    "IMsmConfigurableItem": ["4d6e6284-d21d-401e-84f6-909e00b50f71"],
    "IMsmConfigurableItems": ["55bf723c-9a0d-463e-b42b-b4fbc7be3c7c"],
    "IMsmConfigureModule": ["ac013209-18a7-4851-8a21-2353443d70a0"],
    "IMsmDependencies": ["0adda82d-2c26-11d2-ad65-00a0c9af11a6"],
    "IMsmDependency": ["0adda82b-2c26-11d2-ad65-00a0c9af11a6"],
    "IMsmError": ["0adda828-2c26-11d2-ad65-00a0c9af11a6"],
    "IMsmErrors": ["0adda82a-2c26-11d2-ad65-00a0c9af11a6"],
    "IMsmGetFiles": ["7041ae26-2d78-11d2-888a-00a0c981b015"],
    "IMsmMerge": ["0adda82e-2c26-11d2-ad65-00a0c9af11a6"],
    "IMsmMerge2": ["351a72ab-21cb-47ab-b7aa-c4d7b02ea305"],
    "IMsmStrings": ["0adda827-2c26-11d2-ad65-00a0c9af11a6"],
    "IMsoAcquisitionMgr": ["f6df8bfb-833d-4848-8a10-75aa32a18982"],
    "IMsoAcquisitionTarget": ["f6df8bfa-833d-4848-8a10-75aa32a18982"],
    "IMsoCommandBarControl": ["000c013a-0000-0000-c000-000000000046"],
    "IMsoCommandTarget": ["b722bccb-4e68-101b-a2bc-00aa00404770"],
    "IMsoComponentHost": ["000c0603-0000-0000-c000-000000000046"],
    "IMsoComponentHostEx": ["000c060e-0000-0000-c000-000000000046"],
    "IMsoComponentManagerEx": ["000c060f-0000-0000-c000-000000000046"],
    "IMsoControl": ["000c0106-0000-0000-c000-000000000046"],
    "IMsoControlContainer": ["000c0102-0000-0000-c000-000000000046"],
    "IMsoControlSite": ["000c0107-0000-0000-c000-000000000046"],
    "IMsoControlUser": ["000c0109-0000-0000-c000-000000000046"],
    "IMsoDiagram": ["000c036d-0000-0000-c000-000000000046"],
    "IMsoDispCagNotifySink": ["000c0359-0000-0000-c000-000000000046"],
    "IMsoDocument": ["b722bcc5-4e68-101b-a2bc-00aa00404770"],
    "IMsoDocumentSite": ["b722bcc7-4e68-101b-a2bc-00aa00404770"],
    "IMsoEServicesDialog": ["000c0372-0000-0000-c000-000000000046"],
    "IMsoEnvelopeVB": ["000672ac-0000-0000-c000-000000000046"],
    "IMsoFormSite": ["b722bccc-4e68-101b-a2bc-00aa00404770"],
    "IMsoGallery": ["000c012f-0000-0000-c000-000000000046"],
    "IMsoGalleryCategory": ["000c0138-0000-0000-c000-000000000046"],
    "IMsoGalleryItem": ["000c0130-0000-0000-c000-000000000046"],
    "IMsoHdrFtrClient": ["b722bcd3-4e68-101b-a2bc-00aa00404770"],
    "IMsoHdrFtrProvider": ["b722bcd2-4e68-101b-a2bc-00aa00404770"],
    "IMsoInplacePrintPreview": ["b722bcd4-4e68-101b-a2bc-00aa00404770"],
    "IMsoInplacePrintPreviewCallback": ["b722bcd5-4e68-101b-a2bc-00aa00404770"],
    "IMsoMailEditor": ["b722bcce-4e68-101b-a2bc-00aa00404770"],
    "IMsoMailEditor2": ["0006726f-0000-0000-c000-000000000046"],
    "IMsoMailSite": ["b722bccd-4e68-101b-a2bc-00aa00404770"],
    "IMsoMailSite2": ["00067063-0000-0000-c000-000000000046"],
    "IMsoNuiOcxComponent2": ["000c060d-0000-0000-c000-000000000046"],
    "IMsoPaneUser": ["000c011c-0000-0000-c000-000000000046"],
    "IMsoStdComponentMgr": ["000c0602-0000-0000-c000-000000000046"],
    "IMsoStdComponentMgr2": ["000c0602-0000-0000-c000-000000000046"],
    "IMsoString": ["000c050e-0000-0000-c000-000000000046"],
    "IMsoToolbar": ["000c0104-0000-0000-c000-000000000046"],
    "IMsoToolbarSet": ["000c0100-0000-0000-c000-000000000046"],
    "IMsoToolbarSetUnwrapped": ["000c0126-0000-0000-c000-000000000046"],
    "IMsoToolbarSetUser": ["000c0101-0000-0000-c000-000000000046"],
    "IMsoToolbarUser": ["000c0105-0000-0000-c000-000000000046"],
    "IMsoView": ["b722bcc6-4e68-101b-a2bc-00aa00404770"],
    "IMultiComplete": ["2660212b-070f-40d3-afc1-1ec7df0a995d"],
    "IMultiCompleteCallback": ["a9c3a6f2-a5a9-4a38-bd07-48e8d7ca2761"],
    "IMultiMediaStream": ["b502d1bc-9a57-11d0-8fde-00c04fd9189d"],
    "IMultiObjectElevationFactory": ["6fabda16-031e-47e3-b2a2-2339c05ccb9e"],
    "IMultiSelectDO": ["870cbf41-de8c-4e20-b351-8e61db3da168"],
    "IMultiSourceMediaFrameArrivedEventArgs": ["63115e01-cf51-48fd-aab0-6d693eb48127"],
    "IMultiSourceMediaFrameReader": ["8d144402-f763-488d-98f2-b437bcf075e7"],
    "IMultiSourceMediaFrameReader2": ["ef5c8abd-fc5c-4c6b-9d81-3cb9cc637c26"],
    "IMultiSourceMediaFrameReference": ["21964b1a-7fe2-44d6-92e5-298e6d2810e9"],
    "IMultiValueCollection": ["ed7333e1-ea7b-48d5-b5ad-55712f6a5e14"],
    "IMultipleCollectionsEventSink": ["371624e1-67d2-46d4-af7b-180bbd491afa"],
    "IMultipleResults": ["0c733a90-2a1c-11ce-ade5-00aa0044773d"],
    "IMultipleValues": ["ad4ae633-00bf-4bb6-b527-91a0e28a6c78"],
    "IMultipleViewPatternIdentifiers": ["5d5cd3b8-1e12-488b-b0ea-5e6cb89816e1"],
    "IMultipleViewPatternIdentifiersStatics": ["a9cfa66f-6b84-4d71-9e48-d764d3bcda8e"],
    "IMultipleViewProvider": ["6278cab1-b556-4a1a-b4e0-418acc523201", "d014e196-0e50-4843-a5d2-c22897c8845a"],
    "IMultiplexingSettingHandler": ["2a9d3ce2-b96f-43e3-84df-47f8d7e57429"],
    "IMultisession": ["27354150-7f64-5b0f-8f00-5d77afbe261e"],
    "IMultisessionRandomWrite": ["b507ca23-2204-11dd-966a-001aa01bbc58"],
    "IMultisessionSequential": ["27354151-7f64-5b0f-8f00-5d77afbe261e"],
    "IMultisessionSequential2": ["b507ca22-2204-11dd-966a-001aa01bbc58"],
    "IMultitaskingViewDismissCallback": ["4d596e92-c4dc-4ea6-8d58-0242b14c90b3"],
    "IMultitaskingViewForegroundStaging": ["9290b92b-b0cf-4e86-b3bc-98d456e2f29f"],
    "IMultitaskingViewHost": ["49484dfc-13ca-4d28-aa1b-981c61ed37c9"],
    "IMultitaskingViewManager": ["537b455d-1240-433b-82af-10929138b8be"],
    "IMultitaskingViewServiceProvider": ["90adbab9-cdb8-43dd-8daa-ba1180be5215"],
    "IMultitaskingViewVisibilityNotification": ["c59a7a3c-0676-4526-8192-5d0bf9b89b95"],
    "IMusicDisplayProperties": ["6bbf0c59-d0a0-4d26-92a0-f978e1d18e7b"],
    "IMusicDisplayProperties2": ["00368462-97d3-44b9-b00f-008afcefaf18"],
    "IMusicDisplayProperties3": ["4db51ac1-0681-4e8c-9401-b8159d9eefc7"],
    "IMusicProperties": ["bc8aab62-66ec-419a-bc5d-ca65a4cb46da"],
    "IMusicTechnology": ["80396c3c-cbcb-409b-9f65-4f1e7467cdaf"],
    "IMuteChangeEventArgs": ["8585e159-0c41-432c-814d-c5f1fdf530be", "f914ead4-1c94-458c-acb7-1926a233f74c"],
    "IMuteChangeRequestedEventArgs": ["e4b4f5f6-af1f-4f1e-b437-7da32400e1d4"],
    "INDESPolicy": ["13ca515d-431d-46cc-8c2e-1da269bbd625"],
    "INDFEtw": ["c0b35739-ebf5-11d8-bbe9-505054503030"],
    "INDFPropertyBag": ["91880d0a-a54a-49fd-b232-0064a885c7bf"],
    "INNTPEarlyScriptConnector": ["cd000034-8b95-11d1-82db-00c04fb1625d"],
    "INNTPFinalScriptConnector": ["cd000032-8b95-11d1-82db-00c04fb1625d"],
    "INNTPOnPost": ["cd000027-8b95-11d1-82db-00c04fb1625d"],
    "INNTPOnPostEarly": ["cd000033-8b95-11d1-82db-00c04fb1625d"],
    "INNTPOnPostFinal": ["cd000028-8b95-11d1-82db-00c04fb1625d"],
    "INNTPPostScriptConnector": ["cd000031-8b95-11d1-82db-00c04fb1625d"],
    "INSCTree": ["43a8f463-4222-11d2-b641-006097df5bd4"],
    "INSCTree2": ["8f6fc0e6-e6eb-4a03-a423-5177601d3186"],
    "INSCWinEventHandler": ["ea5f2d61-e008-11cf-99cb-00c04fd64497"],
    "INSNetSourceCreator": ["0c0e4080-9081-11d2-beec-0060082f2054"],
    "INSSBuffer": ["e1cd3524-03d7-11d2-9eed-006097d2d7cf"],
    "INSSBuffer2": ["4f528693-1035-43fe-b428-757561ad3a68"],
    "INSSBuffer3": ["c87ceaaf-75be-4bc4-84eb-ac2798507672"],
    "INSSBuffer4": ["b6b8fd5a-32e2-49d4-a910-c26cc85465ed"],
    "INameSpaceTreeAccessible": ["71f312de-43ed-4190-8477-e9536b82350b"],
    "INameSpaceTreeControl": ["028212a3-b627-47e9-8856-c14265554e4f"],
    "INameSpaceTreeControl2": ["7cc7aed8-290e-49bc-8945-c1401cc9306c"],
    "INameSpaceTreeControlCustomDraw": ["2d3ba758-33ee-42d5-bb7b-5f3431d86c78"],
    "INameSpaceTreeControlDropHandler": ["f9c665d6-c2f2-4c19-bf33-8322d7352f51"],
    "INameSpaceTreeControlEvents": ["93d77985-b3d8-4484-8318-672cdda002ce"],
    "INameSpaceTreeControlFolderCapabilities": ["e9701183-e6b3-4ff2-8568-813615fec7be"],
    "INamedEntity": ["abdbd0b1-7d54-49fb-ab5c-bff4130004cd"],
    "INamedEntityCollector": ["af2440f6-8afc-47d0-9a7f-396a0acfb43d"],
    "INamedPolicyData": ["38dcb198-95ac-4077-a643-8078cae26400"],
    "INamedPolicyStatics": ["7f793be7-76c4-4058-8cad-67662cd05f0d"],
    "INamedPropertyStore": ["71604b0f-97b0-4764-8577-2f13e98a1422"],
    "INamedResource": ["1c98c219-0b13-4240-89a5-d495dc189a00", "c2ac6f97-54f2-445a-8f62-d87b9537f9b2"],
    "INamespaceProxy": ["cf1609ec-fa4b-4818-ab01-55643367e66d"],
    "INamespaceWalkCB2": ["7ac7492b-c38e-438a-87db-68737844ff70"],
    "INaturalMotionAnimation": ["438de12d-769b-4821-a949-284a6547e873"],
    "INaturalMotionAnimationFactory": ["f53acb06-cf6a-4387-a3fe-5221f3e7e0e0"],
    "INavigate": ["bf2195a9-f4ea-4336-977c-f8fcf78b0d9e"],
    "INavigateEventSink": ["3e235cc3-44cf-4b77-8f21-a3ab2a9485f8"],
    "INavigatedEventHandler": ["7af46fe6-40ca-4e49-a7d6-dbdb330cd1a3", "7bd1cf54-23cf-4cce-b2f5-4ce78d96896e"],
    "INavigatingCancelEventArgs": ["fd1d67ae-eafb-4079-be80-6dc92a03aedf"],
    "INavigatingCancelEventArgs2": ["5407b704-8147-4343-838f-dd1ee908c137"],
    "INavigatingCancelEventHandler": ["75d6a78f-a302-4489-9898-24ea49182910"],
    "INavigationBand": ["a9e1bd38-0bbe-4ed0-9410-e9b7e5f081ec"],
    "INavigationEventArgs": ["b6aa9834-6691-44d1-bdf7-58820c27b0d0"],
    "INavigationEventArgs2": ["dbff71d9-979a-4b2e-a49b-3bb17fdef574"],
    "INavigationFailedEventArgs": ["11c1dff7-36c2-4102-b2ef-0217a97289b3"],
    "INavigationFailedEventHandler": ["4dab4671-12b2-43c7-b892-9be2dcd3e88d"],
    "INavigationRelatedItem": ["51737562-4f12-4b7a-a3a0-6e9efe465e1e"],
    "INavigationStoppedEventHandler": ["f0117ddb-12fa-4d8d-8b26-b383d09c2b3c"],
    "INavigationTarget": ["1e1760ce-126f-46ca-9734-91a6cbf8b6f3"],
    "INavigationThemeTransition": ["8833848c-4eb7-41f2-8799-9eef0a213b73"],
    "INavigationThemeTransitionStatics": ["ea2f06e0-5e60-4f8e-bcaf-431487a294ab"],
    "INavigationTransitionInfo": ["a9b05091-ae4a-4372-8625-21b7a8b98ca4"],
    "INavigationTransitionInfoFactory": ["edf4f8d5-af63-4fab-9d4a-87927f82dd6b"],
    "INavigationTransitionInfoOverrides": ["d9517e6a-a9d0-4bf7-9db0-4633a69daff2"],
    "INavigationView": ["f209ce15-391a-42ca-9fc6-f79da65aca32"],
    "INavigationView2": ["2be49737-7c13-4c44-86c3-8b25e697a80e"],
    "INavigationView3": ["8fdfab66-9bbc-5fa3-9043-a02bb4f8ef37"],
    "INavigationViewBackRequestedEventArgs": ["446700e1-9a9d-4500-a71d-25c15809b879"],
    "INavigationViewDisplayModeChangedEventArgs": ["b7c1ad35-5544-40c1-9b33-acfe1d6c8094"],
    "INavigationViewFactory": ["e50687c1-b7c2-4975-ad7a-5f4fe6a514c9"],
    "INavigationViewItem": ["8614be0f-b7b6-4851-960a-f5e3f69f624a"],
    "INavigationViewItem2": ["ee488ef9-ea9c-5e04-b26c-83bf9655342f"],
    "INavigationViewItemAutomationPeer": ["309847a5-9971-4d8d-a81c-085c7086a1b9"],
    "INavigationViewItemAutomationPeerFactory": ["0bc2835d-aa38-4f97-9664-e6fc821d81ed"],
    "INavigationViewItemBase": ["edf04eb1-37d1-471f-8570-3829ee5b2bc6"],
    "INavigationViewItemBaseFactory": ["eb014cef-7890-4ebb-8245-02e8510f321d"],
    "INavigationViewItemFactory": ["973bdb4a-7e08-4f76-923c-f12bd685e86e"],
    "INavigationViewItemHeader": ["e21df22c-da4a-4e74-9ffc-b163bd7adacd"],
    "INavigationViewItemHeaderFactory": ["f3105988-7768-45d3-8bb0-6ded9e43a98b"],
    "INavigationViewItemInvokedEventArgs": ["29496822-55d2-49fa-964b-f1dbafef85c4"],
    "INavigationViewItemInvokedEventArgs2": ["b568f2dd-515e-5770-a466-bd5f43fb6442"],
    "INavigationViewItemPresenter": ["9956d3fc-4693-59cb-b6bf-37249058be96"],
    "INavigationViewItemPresenterFactory": ["bb062c50-4a36-52e7-9459-e89d02f3fc42"],
    "INavigationViewItemPresenterStatics": ["52814604-cfc1-5ad5-a3aa-fa355be6bd76"],
    "INavigationViewItemSeparator": ["de62c951-bb9b-471e-83e3-af4791e7096a"],
    "INavigationViewItemSeparatorFactory": ["71cf3a66-db86-49e0-8154-5fd356aedec0"],
    "INavigationViewItemStatics": ["803c0081-fda5-4b90-aace-3f2306dbe5c4"],
    "INavigationViewItemStatics2": ["f4f2f77c-54b4-541d-b747-3a96e9ff3d55"],
    "INavigationViewList": ["4f726f85-5ce0-48cd-8ef2-1a29458a3404"],
    "INavigationViewListFactory": ["faee9541-c3bf-47bf-b904-6155f4df6b4f"],
    "INavigationViewPaneClosingEventArgs": ["955575ba-75f5-432d-b49b-60e47552d5ee"],
    "INavigationViewSelectionChangedEventArgs": ["5aa509a0-3a5e-4f54-896c-98b85f819508"],
    "INavigationViewSelectionChangedEventArgs2": ["fd5af806-d10a-5e8b-973f-3b8fda944625"],
    "INavigationViewStatics": ["363a86c7-72da-4420-b871-15d9d0d45756"],
    "INavigationViewStatics2": ["8cc50d74-1a42-4852-ab5a-6dc82f28a4ba"],
    "INavigationViewStatics3": ["9b6b69b7-f746-5550-91e1-ee0c9a85c05e"],
    "INavigationViewTemplateSettings": ["2956cbc4-0528-55d5-b2d1-eae807aea6da"],
    "INavigationViewTemplateSettingsFactory": ["28a6a351-64bc-5b60-8f74-e9ee908a240e"],
    "INavigationViewTemplateSettingsStatics": ["2c885e59-f7b9-5078-aeb6-8d7a03c05d02"],
    "INavigatorDoNotTrack": ["30510804-98b5-11cf-bb82-00aa00bdce0b"],
    "INavigatorGeolocation": ["305107cf-98b5-11cf-bb82-00aa00bdce0b"],
    "INcbBackgroundTask": ["1516bb9f-bef2-4b75-945b-962f072beb3a"],
    "INeighboringFilesQueryFactoryPriv": ["a9c88282-c261-4c26-ae97-21a4c8a3e19b"],
    "INetCfgClassSetup2": ["c0e8aea0-306e-11d1-aacf-00805fc1270e"],
    "INetCfgClassSetupDirect": ["7c91843f-ad56-45d9-9580-298bcea199d9"],
    "INetCfgComponentFilterBindings": ["ab469c8e-a4e1-481e-883f-2a087ee6ea78"],
    "INetCfgComponentReadOnly": ["bb4b43cb-7ee8-46d2-a6ef-22488c2939e4"],
    "INetConnectionCommonUi2": ["c08956a6-1cd3-11d1-b1c5-00805fc1270e"],
    "INetConnectionManager3": ["faedcf71-31fe-11d1-aad2-00805fc1270e"],
    "INetDiagExtensibleHelper": ["c0b35748-ebf5-11d8-bbe9-505054503030"],
    "INetDiagHelper": ["c0b35746-ebf5-11d8-bbe9-505054503030"],
    "INetDiagHelperEx": ["972dab4d-e4e3-4fc6-ae54-5f65ccde4a15"],
    "INetDiagHelperInfo": ["c0b35747-ebf5-11d8-bbe9-505054503030"],
    "INetDiagHelperUtilFactory": ["104613fb-bc57-4178-95ba-88809698354a"],
    "INetDialog": ["98133277-4b20-11d1-ab01-00805fc1270e"],
    "INetFwPolicy2": ["98325047-c671-4174-8d81-defcd3f03186"],
    "INetFwProduct": ["71881699-18f4-458b-b892-3ffce5e07f75"],
    "INetFwProducts": ["39eb36e0-2097-40bd-8af2-63a13b525362"],
    "INetFwRule": ["af230d27-baba-4e42-aced-f524f22cfce2"],
    "INetFwRule2": ["9c27c8da-189b-4dde-89f7-8b39a316782c"],
    "INetFwRule3": ["b21563ff-d696-4222-ab46-4e89b73ab34a"],
    "INetFwRules": ["9c4c6277-5027-441e-afae-ca1f542da009"],
    "INetFwServiceRestriction": ["8267bbe3-f890-491c-b7b6-2db1ef0e5d2b"],
    "INetLua": ["faedcf70-31fe-11d1-aad2-00805fc1270e"],
    "INetwork": ["dcb00002-570f-4a9b-8d69-199fdba5723b", "8a40a45d-055c-4b62-abd7-6d613e2ceaec"],
    "INetworkAdapter": ["3b542e03-5388-496c-a8a3-affd39aec2e6"],
    "INetworkCategory": ["de5c5263-a528-4a77-a112-38d26a559ff8"],
    "INetworkCategoryHint": ["4faacef3-b653-4d5e-a243-68d291a2d1a6"],
    "INetworkConnection": ["dcb00005-570f-4a9b-8d69-199fdba5723b"],
    "INetworkConnectionCost": ["dcb0000a-570f-4a9b-8d69-199fdba5723b"],
    "INetworkConnectionCostEvents": ["dcb0000b-570f-4a9b-8d69-199fdba5723b"],
    "INetworkConnectionEvents": ["dcb00007-570f-4a9b-8d69-199fdba5723b"],
    "INetworkConnectionFlowActionHandler": ["97b58fa7-9b14-484a-9883-18693ad15c1e"],
    "INetworkConnectionFlowManager": ["3a4a2476-5370-455e-9f1a-6ac4a4431481"],
    "INetworkCostManager": ["dcb00008-570f-4a9b-8d69-199fdba5723b"],
    "INetworkCostManagerEvents": ["dcb00009-570f-4a9b-8d69-199fdba5723b"],
    "INetworkDiagnostics": ["a92dfff7-67ca-439c-be88-27b4577fa57e"],
    "INetworkEvents": ["dcb00004-570f-4a9b-8d69-199fdba5723b"],
    "INetworkFolderInternal": ["ceb38218-c971-47bb-a703-f0bc99ccdb81"],
    "INetworkInformationStatics": ["5074f851-950d-4165-9c15-365619481eea"],
    "INetworkInformationStatics2": ["459ced14-2832-49b6-ba6e-e265f04786a8"],
    "INetworkInterface": ["2a1c9eb2-df62-4154-b800-63278fcb8037"],
    "INetworkItem": ["01bc4d39-f5e0-4567-a28c-42080c831b2b"],
    "INetworkListManager": ["dcb00000-570f-4a9b-8d69-199fdba5723b", "d0074ffd-570f-4a9b-8d69-199fdba5723b"],
    "INetworkListManagerEvents": ["dcb00001-570f-4a9b-8d69-199fdba5723b"],
    "INetworkOperatorDataUsageTriggerDetails": ["50e3126d-a465-4eeb-9317-28a167630cea"],
    "INetworkOperatorHotspotAuthenticationTrigger": ["e756c791-3001-4de5-83c7-de61d88831d0"],
    "INetworkOperatorNotificationEventDetails": ["bc68a9d1-82e1-4488-9f2c-1276c2468fac"],
    "INetworkOperatorNotificationTrigger": ["90089cc6-63cd-480c-95d1-6e6aef801e4a"],
    "INetworkOperatorNotificationTriggerFactory": ["0a223e00-27d7-4353-adb9-9265aaea579d"],
    "INetworkOperatorTetheringAccessPointConfiguration": ["0bcc0284-412e-403d-acc6-b757e34774a4"],
    "INetworkOperatorTetheringAccessPointConfiguration2": ["b1809142-7238-59a0-928b-74ab46fd64b6"],
    "INetworkOperatorTetheringClient": ["709d254c-595f-4847-bb30-646935542918"],
    "INetworkOperatorTetheringClientManager": ["91b14016-8dca-4225-bbed-eef8b8d718d7"],
    "INetworkOperatorTetheringEntitlementCheck": ["0108916d-9e9a-4af6-8da3-60493b19c204"],
    "INetworkOperatorTetheringManager": ["d45a8da0-0e86-4d98-8ba4-dd70d4b764d3"],
    "INetworkOperatorTetheringManagerStatics": ["3ebcbacc-f8c3-405c-9964-70a1eeabe194"],
    "INetworkOperatorTetheringManagerStatics2": ["5b235412-35f0-49e7-9b08-16d278fbaa42"],
    "INetworkOperatorTetheringManagerStatics3": ["8fdaadb6-4af9-4f21-9b58-d53e9f24231e"],
    "INetworkOperatorTetheringManagerStatics4": ["b3b9f9d0-ebff-46a4-a847-d663d8b0977e"],
    "INetworkOperatorTetheringOperationResult": ["ebd203a1-01ba-476d-b4b3-bf3d12c8f80c"],
    "INetworkSecuritySettings": ["7ca07e8d-917b-4b5f-b84d-28f7a5ac5402"],
    "INetworkSettings": ["9f7dea84-c30b-4245-80b6-00e9f646f1b4"],
    "INetworkSignature": ["cd1f6367-a1b4-4062-8e0b-1a1f4dc2e0be"],
    "INetworkStateChangeEventDetails": ["1f0cf333-d7a6-44dd-a4e9-687c476b903d"],
    "INetworkStateChangeEventDetails2": ["d643c0e8-30d3-4f6a-ad47-6a1873ceb3c1"],
    "INetworkStatus": ["5b87cf59-7028-437d-8288-6957bb4f23d2"],
    "INetworkStatusChangedEventHandler": ["71ba143f-598e-49d0-84eb-8febaedcc195"],
    "INetworkStatusNotifySink": ["b254e2aa-7042-40f8-8b4f-4017fcb223ec"],
    "INetworkTransportSettings": ["5e7abb2c-f2c1-4a61-bd35-deb7a08ab0f1"],
    "INetworkUsage": ["49da8fce-9985-4927-bf5b-072b5c65f8d9"],
    "INewItemAdvisor": ["24d16ee5-10f5-4de3-8766-d23779ba7a6d"],
    "INewMenuClient": ["dcb07fdc-3bb5-451c-90be-966644fed7b0"],
    "INewObjectHandler": ["01b8912e-05cd-4eb2-8b4b-9112e8c2a8be"],
    "INewStartButton": ["f7c40885-2506-4eb9-b4ab-0e1e3d3fd5f9"],
    "INewTabPageData": ["4fd27ce8-3614-47a1-9a17-efeddbfa02f9"],
    "INewWebUIViewCreatedEventArgs": ["e8e1b216-be2b-4c9e-85e7-083143ec4be7"],
    "INewWindowManagerCallback": ["b5ecdf5d-f3f9-4392-bac5-248961093fa2"],
    "INoFocusCandidateFoundEventArgs": ["ec3601a7-1007-48f9-b6b3-ed0bea53937d"],
    "INoMarshal": ["ecc8691b-c1db-4dc0-855e-65f6c551af49"],
    "INodes": ["c74190b7-8589-11d1-b16a-00c0f0283628"],
    "INotePlacementChangedPreviewEventArgs": ["491d57b7-f780-4e7f-a939-9a4caf965214"],
    "INoteVisibilityChangedPreviewEventArgs": ["0e34649e-3815-4ff6-83b3-a14d17120e24"],
    "INotesBroker": ["9b1b69e6-f5b0-4831-ae5f-6b77ff532823"],
    "INotesBrokerPrivate": ["e7402242-8af9-4ebb-b4c7-53bd52937868"],
    "INotesWindowManagerPreview": ["dc2ac23e-4850-4f13-9cc7-ff487efdfcde"],
    "INotesWindowManagerPreview2": ["edfe864a-1f54-4b09-9823-ff477f6fa3bc"],
    "INotesWindowManagerPreviewShowNoteOptions": ["886b09d6-a6ae-4007-a56d-1ca70c84c0d2"],
    "INotesWindowManagerPreviewStatics": ["6668cc88-0a8e-4127-a38e-995445868a78"],
    "INotificationActivationCallback": ["53e31837-6600-4a81-9395-75cffe746f94"],
    "INotificationBinding": ["f29e4b85-0370-4ad3-b4ea-da9e35e7eabf"],
    "INotificationCB": ["d782ccba-afb0-43f1-94db-fda3779eaccb"],
    "INotificationCollection": ["7c991f90-c88e-4f0b-92c9-abb197d643fc"],
    "INotificationController": ["2537d644-8c2f-4449-b8b6-10928822630c"],
    "INotificationControllerDataSink": ["13c6456c-c8eb-4f83-91b8-9d425f546210"],
    "INotificationControllerToastFilterSink": ["2ecba535-b4bf-42ed-86ee-93ac48802da9"],
    "INotificationControllerToastSink": ["4a338128-9c2f-4567-9102-06c889e19c1d"],
    "INotificationData": ["9ffd2312-9d6a-4aaf-b6ac-ff17f0c1f280"],
    "INotificationDataFactory": ["23c1e33a-1c10-46fb-8040-dec384621cf8"],
    "INotificationDataPackage": ["0cfa6cdb-5ccb-44d1-b151-fe25a66bc62e"],
    "INotificationDataProvider": ["a530e6d3-0ea0-4b6d-af89-fba0944d1a10"],
    "INotificationDataProviderSink": ["37f1423e-e93f-4aa8-a0b2-85f1320ab769"],
    "INotificationDatabase": ["531d12d8-a138-4967-b755-6f9e0d8813b9"],
    "INotificationHandler": ["54965c9d-1b45-4900-a2a7-53a5f1da97df"],
    "INotificationHandlerCollection": ["c5543b33-5c73-4dc5-9211-24077d3b06c5"],
    "INotificationHandlerSettings": ["415fdd0d-b21d-4f53-bbf5-ea05bee0793f"],
    "INotificationModifier": ["b8ae5d46-8482-4031-8f7b-0b3d0cb0fc2e"],
    "INotificationObjFactory": ["fb8935a6-863f-4bf4-8786-75c8218929cd"],
    "INotificationPayload": ["a3493838-ebf2-4e38-b405-d9e227f6a3d0"],
    "INotificationPresenter": ["23778b51-a182-40e9-bced-42df56fe5cb4"],
    "INotificationQueueManager": ["301bfd4a-31fc-4e80-b4f4-f7edb2f74d03"],
    "INotificationSettings": ["4a21fac3-37ad-45f0-ad17-bc4a303042d8"],
    "INotificationSettingsEnumerator": ["4877a2ac-5c62-4459-9e0b-185895f37b16"],
    "INotificationStatistics": ["c7310723-ac80-11d1-8df3-00c04fb6ef4f"],
    "INotificationSubscriptionRegistrar": ["2868bb7a-0f7c-11e3-a801-9bcc6188709b"],
    "INotificationTransportSync": ["79eb1402-0ab8-49c0-9e14-a1ae4ba93058"],
    "INotificationVisual": ["68835b8e-aa56-4e11-86d3-5f9a6957bc5b"],
    "INotificationsCollections": ["b0500b4a-4bff-4fd1-9202-69284de1a311"],
    "INotificationsListener": ["212e3ba4-adf0-4462-906d-febf6768bfbb"],
    "INotificationsProcessor": ["9842a180-2b02-4a57-9dd1-b109683d4db8"],
    "INotifyAppStart": ["3a77ce00-6f74-4594-9399-c4578aa4a1b6"],
    "INotifyBackupRestoreStatus": ["f54aa38f-408b-4c5a-a800-34f5494726ed"],
    "INotifyCloudChange": ["220a8a10-48c9-482f-babd-6a50592ff80f"],
    "INotifyCollectionChanged": ["28b167d5-1a31-465b-9b25-d5c3ae686c40"],
    "INotifyCollectionChangedEventArgs": ["4cf68d33-e3f2-4964-b85e-945b4f7e2f21"],
    "INotifyCollectionChangedEventArgsFactory": ["b30c3e3a-df8d-44a5-9a38-7ac0d08ce63d"],
    "INotifyCollectionChangedEventHandler": ["ca10b37c-f382-4591-8557-5e24965279b0"],
    "INotifyEventArgs": ["af0e05f7-c4b7-44c5-b09d-5cb7052b3a97"],
    "INotifyEventArgs2": ["0d140f56-1dce-4fcd-85bc-5a5572273b9c"],
    "INotifyEventHandler": ["c2fdd1f8-7105-4a74-a109-de29dff56b98"],
    "INotifyFolderChanged": ["46a2449d-60b6-451d-93d5-719a9c45ae06"],
    "INotifyLocalChangeTaskLauncher": ["fd87c267-f780-45ca-be70-3173c205aba7"],
    "INotifyLocalSettingChange": ["8f204c1d-f940-4842-af73-a7b0ee7a161c"],
    "INotifyNetworkEvents": ["22d2e146-1a68-40b8-949c-8fd848b415e6"],
    "INotifyNetworkGlobalCostEvents": ["733b7764-5c0c-4ad6-bb4b-d0585e993e0e"],
    "INotifyNetworkGlobalStateEvents": ["733b7764-5c0c-4ad6-bb4b-d0585e993e0f"],
    "INotifyNetworkInterfaceEvents": ["2abc0864-9677-42e5-882a-d415c556c284"],
    "INotifyNetworkListManagerEvents": ["1299cf18-c4f5-4b6a-bb0f-2299f0398e27"],
    "INotifyNetworkSignatureEvents": ["7d38ba91-7859-41d1-984c-835a42d7d38c"],
    "INotifyOperationComplete": ["6f78f377-be81-458a-8f03-431b29a1f097"],
    "INotifyPropertyChanged": ["cf75d69c-f2f4-486b-b302-bb4c09baebfa"],
    "INotifySyncOperationComplete": ["adf7357d-8677-42e0-bc45-28e4ea446f00"],
    "INotifyWindowsPackageSettingChange": ["a7b7fdb7-b606-4ef6-936d-6a1af05fd76c"],
    "INowPlayingSession": ["431268cf-7477-4285-950b-6f892a944712"],
    "INowPlayingSessionInfo": ["443dcf9d-ce15-408c-866e-e6d0c434548a"],
    "INowPlayingSessionManager": ["3b6a7908-ce07-4ba9-878c-6e4a15db5e5b"],
    "INowPlayingSessionManagerBroker": ["6b0fd261-c505-4ae3-b75e-2aed9854056a"],
    "INowPlayingSessionManagerEventHandler": ["d25f31a2-8cae-4058-967e-8a4497e1cdbc"],
    "INowPlayingSessionManagerRegistrar": ["211c44cc-76e9-4ea7-bd2d-10f3e77b73a3"],
    "INowPlayingSessionManagerRundown": ["266d29d0-017a-4199-be06-11444def86a3"],
    "INowPlayingSessionManagerSuspendControl": ["73943e2d-c6db-4bb2-b844-0879e39a4204"],
    "INtUserViewWrapper": ["e67b82e2-7249-4743-98e4-2ac1c012e15f"],
    "INumberFormatter": ["a5007c49-7676-4db7-8631-1b6ff265caa9"],
    "INumberFormatter2": ["d4a8c1f0-80d0-4b0d-a89e-882c1e8f8310"],
    "INumberFormatterOptions": ["80332d21-aee1-4a39-baa2-07ed8c96daf6"],
    "INumberParser": ["e6659412-4a13-4a53-83a1-392fbe4cff9f"],
    "INumberRounder": ["5473c375-38ed-4631-b80c-ef34fc48b7f5"],
    "INumberRounderOption": ["3b088433-646f-4efe-8d48-66eb2e49e736"],
    "INumeralSystemIdentifiersStatics": ["a5c662c3-68c9-4d3d-b765-972029e21dec"],
    "INumeralSystemIdentifiersStatics2": ["7f003228-9ddb-4a34-9104-0260c091a7c7"],
    "INumeralSystemTranslator": ["28f5bc2c-8c23-4234-ad2e-fa5a3a426e9b"],
    "INumeralSystemTranslatorFactory": ["9630c8da-36ef-4d88-a85c-6f0d98d620a6"],
    "IOCSPAdmin": ["322e830d-67db-4fe9-9577-4596d9f09294"],
    "IOCSPCAConfiguration": ["aec92b40-3d46-433f-87d1-b84d5c1e790d"],
    "IOCSPCAConfigurationCollection": ["2bebea0b-5ece-4f28-a91c-86b4bb20f0d3"],
    "IOCSPProperty": ["66fb7839-5f04-4c25-ad18-9ff1a8376ee0"],
    "IOCSPPropertyCollection": ["2597c18d-54e6-4b74-9fa9-a6bfda99cbbe"],
    "IOEMRegistrationInfo": ["24c16ba8-12e3-46e7-bacf-ee0242629072"],
    "IOInetBindInfo": ["79eac9e1-baf9-11ce-8c82-00aa004ba90b"],
    "IOInetBindInfoEx": ["a3e015b7-a82c-4dcd-a150-569aeeed36ab"],
    "IOInetPriority": ["79eac9eb-baf9-11ce-8c82-00aa004ba90b"],
    "IOInetProtocol": ["79eac9e4-baf9-11ce-8c82-00aa004ba90b"],
    "IOInetProtocolEx": ["c7a98e66-1010-492c-a1c8-c809e1f75905"],
    "IOInetProtocolInfo": ["79eac9ec-baf9-11ce-8c82-00aa004ba90b"],
    "IOInetProtocolRoot": ["79eac9e3-baf9-11ce-8c82-00aa004ba90b"],
    "IOInetProtocolSink": ["79eac9e5-baf9-11ce-8c82-00aa004ba90b"],
    "IOInetProtocolSinkStackable": ["79eac9f0-baf9-11ce-8c82-00aa004ba90b"],
    "IOLETargetProviderPriv": ["6db49878-a7d4-41e9-b496-3eb0503ee3e5"],
    "IOOBECancellableTask": ["5a1a910b-7401-4918-9be2-e0c6e7be2b86"],
    "IOOBECheckboxFieldItem": ["ce81b600-7b2d-4c33-90e6-2e724adffc85"],
    "IOOBEConnectedUserCallback": ["d62ea8c2-c940-4df4-9e25-bbf447ba0688"],
    "IOOBEConnectedUserPlugin": ["cd22aa71-6926-40f9-89c0-7fbb9933a228"],
    "IOOBECortanaManagerCOM": ["3834201f-64cb-49df-a5ad-6475164b06b4"],
    "IOOBECortanaPlugin": ["a1b352d5-e754-4b6c-a891-1d8411b0e05a"],
    "IOOBEDUIUIModule": ["40516246-21b0-45b5-bc2f-f4a0cac8b0e4"],
    "IOOBEDUIUIModuleManager": ["4c9c69c9-df0c-46a0-bbf9-68a69eb09cca"],
    "IOOBEDUIWizardControl": ["a9664529-f985-414d-83b9-f5012c9460df"],
    "IOOBEDUIWizardPage": ["983ce3f7-c328-4687-8237-e1cc4c2a14de"],
    "IOOBEDUIWizardPageEvents": ["0943e005-fdae-40cd-b998-213047be4a67"],
    "IOOBEEndPlugin": ["c8354380-6fa3-45ff-94ce-acddc351252f"],
    "IOOBEEnterpriseProvisioningPlugin": ["64226bf5-eb53-4a4d-92ff-397ae1b7bb1e"],
    "IOOBEEulaPlugin": ["4c2d19fb-1c77-466b-9d34-83e5049a1d02"],
    "IOOBEExperienceManager": ["ef7bed12-9337-4a18-ab1b-63f9639eac49"],
    "IOOBEExperienceNotification": ["9c5a9fa8-1be3-407c-bc15-03340707fb49"],
    "IOOBEFeatureStagingPlugin": ["ec09f941-48aa-4896-8bdf-5fd11addbaea"],
    "IOOBEGlobalSettingsCacheListener": ["b0a1c63e-e050-482c-a26e-c657e3f75fbc"],
    "IOOBEHidPairingCallback": ["6a0e5b0c-a5a2-4145-8cc7-2895826ce656"],
    "IOOBEHidPairingPlugin": ["7b91ecc3-ee0e-48af-bf3c-c83fa54ca6b8"],
    "IOOBEHost": ["eee6228a-2537-408d-b31b-5ce516fe0dd5"],
    "IOOBEHostPriv": ["d5a256aa-9d80-4621-a4a9-1e24c26a5e9c"],
    "IOOBEItem": ["e60eaa0e-1370-4fd6-9a8b-8c2be67a705a"],
    "IOOBEKeyboardItem": ["b8076798-743b-4a6a-a3b2-ec494cbb7ec5"],
    "IOOBELanguageItem": ["4cd74fcc-3992-4aab-9720-05c3da95f762"],
    "IOOBELanguagePlugin": ["763e95e0-c9c1-4a80-8496-385fe7f44824"],
    "IOOBELinkFieldItem": ["aa213e7c-7995-45db-9937-4be79363fa01"],
    "IOOBELocaleItem": ["9e43cd6c-b923-4bb2-826f-d984f38e544d"],
    "IOOBELocalizedHidAccItem": ["45218e71-485a-4452-b370-d56c93886a81"],
    "IOOBELocalizedItem": ["792cfabc-8a9c-4720-bc2d-a378c7c67a30"],
    "IOOBEOEMRegistrationPlugin": ["8f5db51b-a6ff-47f2-a292-b9b3b983d75e"],
    "IOOBEOEMRegistrationPlugin2": ["0a3241cc-aaa3-409e-b59f-7bfb2cd748fd"],
    "IOOBEOEMRegistrationPluginPrivate": ["eac20b7b-fde3-48e5-be12-96eb31bb41c5"],
    "IOOBEOneDriveOptin": ["ca6f9923-7385-403f-a567-422225d212ff"],
    "IOOBEPIDPlugin": ["e8c01c02-3d49-4a6c-b5d1-9485edc8fa21"],
    "IOOBEPasswordPlugin": ["862fce1a-d7b8-4124-8a2c-acf598df9521"],
    "IOOBEPidCallback": ["7a03f3b6-6c8c-455c-9315-bbe73c2c5232"],
    "IOOBEPlugin": ["f5858211-90ae-4b01-bb4c-43a5efd959b6"],
    "IOOBEPluginArray": ["4dae3557-3077-4b1f-a92a-ee5ca619abba"],
    "IOOBEPluginInfo": ["f21a6d3a-4f17-439a-86ef-9825449f440f"],
    "IOOBEProtectPCPlugin": ["5de6eb2f-6465-4dbd-bb91-47d95a57299b"],
    "IOOBEProvisioningItem": ["8805c4c8-0e4b-41a6-a16a-b2ebe4b9394e"],
    "IOOBEProxyConfigurationCallback": ["443c9b91-0259-466e-8c82-0cda6a523976"],
    "IOOBEProxyConfigurationPlugin": ["a6d1e182-edf1-4c3f-8512-934305c2b940"],
    "IOOBERegionItem": ["eb504b1e-fdc4-4dda-adc0-c795345ded66"],
    "IOOBERegionPlugin": ["fa817269-d8db-4da9-b910-811570bd21d3"],
    "IOOBERetailDemoPlugin": ["0fa3169a-7874-4f84-aaee-7456bb76f99a"],
    "IOOBERunnableTask": ["ea5d1f46-9103-44a7-84a9-994d2e9de48f"],
    "IOOBESettingsParser": ["de4162e0-1490-45c6-b6a7-f42cf7f8ea9d"],
    "IOOBESettingsStore": ["44b80c14-f9d3-4a93-9900-a3714aecab48"],
    "IOOBETextboxFieldItem": ["806925ad-98e5-4e7a-8200-6b83f9f8e52d"],
    "IOOBETimeZoneItem": ["2e364766-5f65-4605-97bb-86f17880900d"],
    "IOOBETimezonePlugin": ["470ca0ba-4939-4fbb-abac-1661c9774c72"],
    "IOOBEUpgradeAppsPlugin": ["6229b946-70fa-439e-927d-d072d8dc3440"],
    "IOOBEUserAuthentication": ["d9860fcb-edd8-42df-a696-4e839da5e804"],
    "IOOBEUserNamePlugin": ["be4ed640-8a86-4e6d-9b64-19264f77a432"],
    "IOOBEWebWizardHost": ["bcbe1e1a-8604-45ca-80cf-06f07cf88069"],
    "IOOBEWirelessInternetConnectedCallback": ["43c45995-914f-49e0-a89a-fd1152effb4d"],
    "IOOBEWirelessPlugin": ["2c3ebc3e-6e99-4255-bfbd-0cea2342e6eb"],
    "IOOBEWizard": ["a34e3244-6560-4c5f-bdc8-631a90189c1a"],
    "IOOBEZDPCallback": ["8546ba89-176e-4492-be58-5786035dc60f"],
    "IOOBEZDPPlugin": ["01d4f80a-0f4e-496d-b176-5ee56be028ce"],
    "IOPMCertValidator": ["675128b1-f664-4e6a-aa6d-16e57d2bcbc4"],
    "IOPMCertValidator2": ["d6f86b61-f240-4650-b9af-17ce5759e1ac"],
    "IOPMVideoOutput": ["0a15159d-41c7-4456-93e1-284cd61d4e8d"],
    "IObjectAccessControl": ["0c733aa3-2a1c-11ce-ade5-00aa0044773d"],
    "IObjectActivator": ["0000015e-0000-0000-c000-000000000046"],
    "IObjectAnimationUsingKeyFrames": ["334a2d92-b74a-4c64-b9a6-58bcfa314f22"],
    "IObjectAnimationUsingKeyFramesStatics": ["eb736182-6af1-49a3-97b6-783ed97400fe"],
    "IObjectArray": ["92ca9dcd-5622-4bba-a805-5e9f541bd8c9"],
    "IObjectArrayPriv": ["d4c5a1a7-e152-4a59-b3f6-0190a5a6d385"],
    "IObjectAssociations": ["914dcb9e-fcab-4a30-855d-d76c86b452ad"],
    "IObjectCleanup": ["244abe3a-abbc-43b1-a877-f00077550e6a"],
    "IObjectCollection": ["5632b1a4-e38a-400a-928a-d4cd63230295"],
    "IObjectHandle": ["c460e2b4-e199-412a-8456-84dc3e4838c3"],
    "IObjectIds": ["728ab301-217d-11da-b2a4-000e7bbb2b09"],
    "IObjectInitialize": ["e8069c65-8948-47b9-9ad6-7e9e17232f8e"],
    "IObjectKeyFrame": ["9852a851-8593-48ee-a6a4-d5d4720f029a"],
    "IObjectKeyFrameFactory": ["1626143e-3e6d-44d8-9b9a-04aea70f8492"],
    "IObjectKeyFrameStatics": ["2cd6ab00-5319-4286-8eed-4e755ea0cf9c"],
    "IObjectModelProvider": ["3ad86ebd-f5ef-483d-bb18-b1042a475d64", "c3ca36b9-0793-4ed0-bbf4-9ff4e0f98f80"],
    "IObjectProvider": ["a6087428-3be3-4d73-b308-7c04a540bf1a"],
    "IObjectWithAppUserModelID": ["36db0196-9665-46d1-9ba7-d3709eecf9ed"],
    "IObjectWithAssociationElement": ["e157c3a1-a532-4de2-9480-1452b7426eee"],
    "IObjectWithAssociationList": ["d8820afb-ada1-45db-bd57-cf29047ee2bf"],
    "IObjectWithAumIdOrPidForOpenWith": ["b73b4fda-9607-4b78-a728-648932e9cf09"],
    "IObjectWithBackReferences": ["321a6a6a-d61f-4bf3-97ae-14be2986bb36"],
    "IObjectWithCachedState": ["cd17328b-e4ef-4215-a92d-62a914658f82"],
    "IObjectWithCancelEvent": ["f279b885-0ae9-4b85-ac06-ddecf9408941"],
    "IObjectWithChapteredRowset": ["5e6fc0d9-166f-4342-8718-7cd52696761b"],
    "IObjectWithClassIdentity": ["37941ab6-dadc-47a5-8f42-3f9ee5966224"],
    "IObjectWithDeferredInvoke": ["40b5c5a6-8662-489f-9438-aca87ad41b60"],
    "IObjectWithDirtyState": ["5aa7437e-d4d6-4beb-b85c-0bc9c7efe80d"],
    "IObjectWithFileHandle": ["bfb02fed-4c71-40e1-b4f3-ce99c2ff0542"],
    "IObjectWithFocus": ["b5e9ed86-f7b7-4b8b-b603-01446c759c07"],
    "IObjectWithFolderEnumMode": ["6a9d9026-0e6e-464c-b000-42ecc07de673"],
    "IObjectWithGITCookie": ["527832f6-5fb1-414d-86cc-5bc1da0f4ed9"],
    "IObjectWithGroupLevelContext": ["dd7aa19c-dacf-4378-a0be-e58a18d08983"],
    "IObjectWithItemKey": ["8be10e28-6ae3-42e5-b142-8f6802e85c3f"],
    "IObjectWithListDescription": ["c9b7f729-33b5-4ab8-acdd-fd0a999d790e"],
    "IObjectWithMonitor": ["59e8345c-fd1b-4c68-82fc-abec57c127d9"],
    "IObjectWithOpenWithFlags": ["9d923edc-b7a9-4f77-9933-284e7e2b2536"],
    "IObjectWithParent": ["0b87329e-0d1c-47b2-9c75-b34fcc2077b0"],
    "IObjectWithProgID": ["71e806fb-8dee-46fc-bf8c-7748a8a1ae13"],
    "IObjectWithPropertyKey": ["fc0ca0a7-c316-4fd2-9031-3e628e6d4f23"],
    "IObjectWithPropertyStore": ["7c9d26b6-c493-49b3-b66a-80bef106286b"],
    "IObjectWithQuerySource": ["b3dcb623-4280-4eb1-84b3-8d07e84f299a"],
    "IObjectWithRWLock": ["ce17c10a-90f9-42e5-a43b-4ffee2f937a0"],
    "IObjectWithSelection": ["1c9cd5bb-98e9-4491-a60f-31aacc72b83c"],
    "IObjectWithShellItem": ["1d3db207-7ad5-4376-ad5b-56474fa7cc68"],
    "IObjectWithStorageProviderInfo": ["f2de7931-44dd-46d7-8245-0cb9de200034"],
    "IObjectWithUnmappedXml": ["a78b1ef8-6c64-4b40-8e14-1bb317a3b95c"],
    "IObjectWithUserSettings": ["0facb8d2-6ba0-487d-97b1-4d750d5cf395"],
    "IObjectWithViewStateInfo": ["69a019f5-3e72-40e3-85ed-fdf173ee2e2d"],
    "IObjectWithWindow": ["b482cd93-28d0-4f19-b018-d0bd02102dcc"],
    "IObjectWithWindowRect": ["0a080f88-554f-43ce-b7f2-5af73249dd72"],
    "IOcclusionBasedApplicationViewPosition": ["a2d5db46-2d5e-4f51-b7b2-5c713b7b9aa1"],
    "IOcrEngine": ["5a14bc41-5b76-3140-b680-8825562683ac"],
    "IOcrEngineStatics": ["5bffa85a-3384-3540-9940-699120d428a8"],
    "IOcrLine": ["0043a16f-e31f-3a24-899c-d444bd088124"],
    "IOcrResult": ["9bd235b2-175b-3d6a-92e2-388c206e2f63"],
    "IOcrWord": ["3c2a477a-5cd9-3525-ba2a-23d1e0a68a1d"],
    "IOem3GPPSupServices": ["138820c5-299d-4d1d-80b9-1664a17b1b41"],
    "IOemCan": ["a3822e4e-ffb5-4e46-8980-0182b8454e2e"],
    "IOemCanExtForIMS": ["c5310a1a-e885-4450-b823-84ad7fd15cbf"],
    "IOemCanRegistrationStateChange": ["b8e5df58-2329-400c-93c5-ffb951bf3415"],
    "IOemCellular": ["17ae6dc1-3723-4085-99ba-7160cdb8bfc1"],
    "IOemCellularCanAvailabilityChange": ["cf34841c-a795-4ec6-b1bc-c3744a2d6dca"],
    "IOemCellularDataStore": ["b470078a-2784-4d09-ad35-42b2290abc54"],
    "IOemCellularModem": ["82f4e49e-1e6b-43c9-8769-fe3d437ae8a9"],
    "IOemCellularModemEx": ["1902f624-534e-4624-a815-3546021f0854"],
    "IOemCellularModemExistenceChange": ["a2cbc3c1-79d5-4f9d-a6f9-fde497848ec1"],
    "IOemIMSStatusChange": ["7d034a18-baef-4f86-ad84-bb0bbfb9f834"],
    "IOemRegistrationStatus": ["f8c3b6d1-4629-414b-8e38-dd396febe730"],
    "IOemSlot": ["dae67de6-0c18-4158-9323-cf7fb14ec216"],
    "IOemSlotChange": ["20c4af87-bc47-4150-ba97-4f53ffd95e48"],
    "IOemSlotStateChange": ["59bb79ed-5435-456c-a8d1-6680d56aad1e"],
    "IOemSupportInfo": ["8d2eae55-87ef-4266-86d0-c4afbeb29bb9"],
    "IOemUicc": ["fd5dbcf6-810d-4ce8-ac06-1b8628808950"],
    "IOemUiccApp": ["2d00bfee-aa9f-48fd-9d2b-e8d3d3eddc60"],
    "IOemUiccAppEx": ["0c50366c-d5ed-4f00-aa54-1537a63d8a01"],
    "IOemUiccAppEx2": ["c9772450-a940-4e27-a3ea-afcc5ecc7556"],
    "IOemUiccChange": ["302739d6-299d-4b82-a12e-ef930fd8bd16"],
    "IOfficeAntiVirus": ["56ffcc30-d398-11d0-b2ae-00a0c908fa49"],
    "IOfflineFilesCache": ["855d6203-7914-48b9-8d40-4c56f5acffc5"],
    "IOfflineFilesCache2": ["8c075039-1551-4ed9-8781-56705c04d3c0"],
    "IOfflineFilesChangeInfo": ["a96e6fa4-e0d1-4c29-960b-ee508fe68c72"],
    "IOfflineFilesConnectionInfo": ["efb23a09-a867-4be8-83a6-86969a7d0856"],
    "IOfflineFilesControlPanel": ["357b663c-d9fa-4188-99af-2943920f96c5"],
    "IOfflineFilesDirectoryItem": ["2273597a-a08c-4a00-a37a-c1ae4e9a1cfd"],
    "IOfflineFilesDirtyInfo": ["0f50ce33-bac9-4eaa-a11d-da0e527d047d"],
    "IOfflineFilesErrorCount": ["39099152-d9f8-43c3-9a61-0cdd01585aa1"],
    "IOfflineFilesErrorInfo": ["7112fa5f-7571-435a-8eb7-195c7c1429bc"],
    "IOfflineFilesEvents": ["e25585c1-0caa-4eb1-873b-1cae5b77c314"],
    "IOfflineFilesEvents2": ["1ead8f56-ff76-4faa-a795-6f6ef792498b"],
    "IOfflineFilesEvents3": ["9ba04a45-ee69-42f0-9ab1-7db5c8805808"],
    "IOfflineFilesEvents4": ["dbd69b1e-c7d2-473e-b35f-9d8c24c0c484"],
    "IOfflineFilesEventsFilter": ["33fc4e1b-0716-40fa-ba65-6e62a84a846f"],
    "IOfflineFilesFileItem": ["8dfadead-26c2-4eff-8a72-6b50723d9a00"],
    "IOfflineFilesFileSysInfo": ["bc1a163f-7bfd-4d88-9c66-96ea9a6a3d6b"],
    "IOfflineFilesGhostInfo": ["2b09d48c-8ab5-464f-a755-a59d92f99429"],
    "IOfflineFilesItem": ["4a753da6-e044-4f12-a718-5d14d079a906"],
    "IOfflineFilesItemContainer": ["3836f049-9413-45dd-bf46-b5aaa82dc310"],
    "IOfflineFilesItemFilter": ["f4b5a26c-dc05-4f20-ada4-551f1077be5c"],
    "IOfflineFilesPinInfo": ["5b2b0655-b3fd-497d-adeb-bd156bc8355b"],
    "IOfflineFilesPinInfo2": ["623c58a2-42ed-4ad7-b69a-0f1b30a72d0d"],
    "IOfflineFilesProgress": ["fad63237-c55b-4911-9850-bcf96d4c979e"],
    "IOfflineFilesServerItem": ["9b1c9576-a92b-4151-8e9e-7c7b3ec2e016"],
    "IOfflineFilesService": ["ab4edee5-0f23-4619-8d33-cee9f4277dce"],
    "IOfflineFilesService2": ["3638f50e-a9b3-41cd-ab4e-eccf042571ff"],
    "IOfflineFilesSetting": ["d871d3f7-f613-48a1-827e-7a34e560fff6"],
    "IOfflineFilesSettingInit": ["6ec16988-1346-47ed-acea-6b94578357e3"],
    "IOfflineFilesShareInfo": ["7bcc43e7-31ce-4ca4-8ccd-1cff2dc494da"],
    "IOfflineFilesShareItem": ["bab7e48d-4804-41b5-a44d-0f199b06b145"],
    "IOfflineFilesSimpleProgress": ["c34f7f9b-c43d-4f9d-a776-c0eb6de5d401"],
    "IOfflineFilesSuspend": ["62c4560f-bc0b-48ca-ad9d-34cb528d99a9"],
    "IOfflineFilesSuspendInfo": ["a457c25b-4e9c-4b04-85af-8932ccd97889"],
    "IOfflineFilesSyncConflict": ["a78436d0-9a20-47ba-929c-80e8d3cd6350"],
    "IOfflineFilesSyncConflictHandler": ["b6dd5092-c65c-46b6-97b8-fadd08e7e1be"],
    "IOfflineFilesSyncContext": ["b464955c-9277-4657-a3dc-99a32c76c6f3"],
    "IOfflineFilesSyncContextItem": ["11fda1eb-ffcd-4d22-a87b-e1d046ba50ed"],
    "IOfflineFilesSyncErrorInfo": ["59f95e46-eb54-49d1-be76-de95458d01b0"],
    "IOfflineFilesSyncErrorItemInfo": ["ecdbaf0d-6a18-4d55-8017-108f7660ba44"],
    "IOfflineFilesSyncItem": ["07feab5e-0981-4a6d-89e0-d427ecb5cad4"],
    "IOfflineFilesSyncProgress": ["6931f49a-6fc7-4c1b-b265-56793fc451b7"],
    "IOfflineFilesSyncProgressInternal": ["6674835c-5244-4742-815c-8c8b318ac580"],
    "IOfflineFilesSyncStatusProviderInternal": ["bd8b4a49-5da6-442b-aebc-8e1052138837"],
    "IOfflineFilesTransparentCacheInfo": ["bcaf4a01-5b68-4b56-a6a1-8d2786ede8e3"],
    "IOfflineFilesUserSessionCallback": ["f1ffcfc0-73e1-441b-a0c5-ba94d43e1acc"],
    "IOfflineMapPackage": ["a797673b-a5b5-4144-b525-e68c8862664b"],
    "IOfflineMapPackageQueryResult": ["55585411-39e1-4e41-a4e1-5f4872bee199"],
    "IOfflineMapPackageStartDownloadResult": ["d965b918-d4d6-4afe-9378-3ec71ef11c3d"],
    "IOfflineMapPackageStatics": ["185e7922-a831-4ab0-941f-6998fa929285"],
    "IOleComponent": ["000c0600-0000-0000-c000-000000000046"],
    "IOleComponent2": ["ed0751fc-d772-4d1d-88fc-0c1aa275391b"],
    "IOleComponentManager": ["000c0601-0000-0000-c000-000000000046"],
    "IOleComponentUIManager": ["5efc7972-14bc-11cf-9b2b-00aa00573819"],
    "IOleDragDropBrokerHost": ["55000739-8cab-49b5-916e-215f9ac84e98"],
    "IOleInPlaceComponent": ["5efc7970-14bc-11cf-9b2b-00aa00573819"],
    "IOleInPlaceComponentSite": ["5efc7971-14bc-11cf-9b2b-00aa00573819"],
    "IOleInPlaceComponentUIManager": ["5efc7973-14bc-11cf-9b2b-00aa00573819"],
    "IOlePackagerLinkNotify": ["d3f69771-97b9-41ca-b7e0-85ecd117d22e"],
    "IOnlineIdAuthenticator": ["a003f58a-29ab-4817-b884-d7516dad18b9"],
    "IOnlineIdServiceTicket": ["c95c547f-d781-4a94-acb8-c59874238c26"],
    "IOnlineIdServiceTicketRequest": ["297445d3-fb63-4135-8909-4e354c061466"],
    "IOnlineIdServiceTicketRequestFactory": ["bebb0a08-9e73-4077-9614-08614c0bc245"],
    "IOnlineIdSystemAuthenticatorForUser": ["5798befb-1de4-4186-a2e6-b563f86aaf44"],
    "IOnlineIdSystemAuthenticatorStatics": ["85047792-f634-41e3-96a4-5164e902c740"],
    "IOnlineIdSystemIdentity": ["743cd20d-b6ca-434d-8124-53ea12685307"],
    "IOnlineIdSystemTicketResult": ["db0a5ff8-b098-4acd-9d13-9e640652b5b6"],
    "IOpLockStatus": ["c731065d-ac80-11d1-8df3-00c04fb6ef4f"],
    "IOpacityAnimation": ["803aabe5-ee7e-455f-84e9-2506afb8d2b4"],
    "IOpaqueModemNotifications": ["85a26f4e-cd62-4b6e-90a1-0d5e2d6ee3ff"],
    "IOpcCertificateEnumerator": ["85131937-8f24-421f-b439-59ab24d140b8"],
    "IOpcCertificateSet": ["56ea4325-8e2d-4167-b1a4-e486d24c8fa7"],
    "IOpcDigitalSignature": ["52ab21dd-1cd0-4949-bc80-0c1232d00cb4"],
    "IOpcDigitalSignatureEnumerator": ["967b6882-0ba3-4358-b9e7-b64c75063c5e"],
    "IOpcDigitalSignatureManager": ["d5e62a0b-696d-462f-94df-72e33cef2659"],
    "IOpcFactory": ["6d0b4446-cd73-4ab3-94f4-8ccdf6116154"],
    "IOpcPackage": ["42195949-3b79-4fc8-89c6-fc7fb979ee70"],
    "IOpcPart": ["42195949-3b79-4fc8-89c6-fc7fb979ee71"],
    "IOpcPartEnumerator": ["42195949-3b79-4fc8-89c6-fc7fb979ee75"],
    "IOpcPartSet": ["42195949-3b79-4fc8-89c6-fc7fb979ee73"],
    "IOpcPartUri": ["7d3babe7-88b2-46ba-85cb-4203cb016c87"],
    "IOpcRelationship": ["42195949-3b79-4fc8-89c6-fc7fb979ee72"],
    "IOpcRelationshipEnumerator": ["42195949-3b79-4fc8-89c6-fc7fb979ee76"],
    "IOpcRelationshipSelector": ["f8f26c7f-b28f-4899-84c8-5d5639ede75f"],
    "IOpcRelationshipSelectorEnumerator": ["5e50a181-a91b-48ac-88d2-bca3d8f8c0b1"],
    "IOpcRelationshipSelectorSet": ["6e34c269-a4d3-47c0-b5c4-87ff2b3b6136"],
    "IOpcRelationshipSet": ["42195949-3b79-4fc8-89c6-fc7fb979ee74"],
    "IOpcSignatureCustomObject": ["5d77a19e-62c1-44e7-becd-45da5ae51a56"],
    "IOpcSignatureCustomObjectEnumerator": ["5ee4fe1d-e1b0-4683-8079-7ea0fcf80b4c"],
    "IOpcSignatureCustomObjectSet": ["8f792ac5-7947-4e11-bc3d-2659ff046ae1"],
    "IOpcSignaturePartReference": ["e24231ca-59f4-484e-b64b-36eeda36072c"],
    "IOpcSignaturePartReferenceEnumerator": ["80eb1561-8c77-49cf-8266-459b356ee99a"],
    "IOpcSignaturePartReferenceSet": ["6c9fe28c-ecd9-4b22-9d36-7fdde670fec0"],
    "IOpcSignatureReference": ["1b47005e-3011-4edc-be6f-0f65e5ab0342"],
    "IOpcSignatureReferenceEnumerator": ["cfa59a45-28b1-4868-969e-fa8097fdc12a"],
    "IOpcSignatureReferenceSet": ["f3b02d31-ab12-42dd-9e2f-2b16761c3c1e"],
    "IOpcSignatureRelationshipReference": ["57babac6-9d4a-4e50-8b86-e5d4051eae7c"],
    "IOpcSignatureRelationshipReferenceEnumerator": ["773ba3e4-f021-48e4-aa04-9816db5d3495"],
    "IOpcSignatureRelationshipReferenceSet": ["9f863ca5-3631-404c-828d-807e0715069b"],
    "IOpcSigningOptions": ["50d2d6a5-7aeb-46c0-b241-43ab0e9b407e"],
    "IOpcUri": ["bc9c1b9b-d62c-49eb-aef0-3b4e0b28ebed"],
    "IOpenControlPanel": ["d11ad862-66de-4df4-bf6c-1f5621996af1"],
    "IOpenRowset": ["0c733a69-2a1c-11ce-ade5-00aa0044773d"],
    "IOpenSearchSource": ["f0ee7333-e6fc-479b-9f25-a860c234a38e"],
    "IOpenService": ["c2952ed1-6a89-4606-925f-1ed8b4be0630"],
    "IOpenServiceActivity": ["13645c88-221a-4905-8ed1-4f5112cfc108"],
    "IOpenServiceActivityCategory": ["850af9d6-7309-40b5-bdb8-786c106b2153"],
    "IOpenServiceActivityInput": ["75cb4db9-6da0-4da3-83ce-422b6a433346"],
    "IOpenServiceActivityInternal": ["d939737b-6370-46ed-9608-2ea1ba643fb8"],
    "IOpenServiceActivityManager": ["8a2d0a9d-e920-4bdc-a291-d30f650bc4f1"],
    "IOpenServiceActivityOutputContext": ["e289deab-f709-49a9-b99e-282364074571"],
    "IOpenServiceManager": ["5664125f-4e10-4e90-98e4-e4513d955a14"],
    "IOpenServiceManagerInternal": ["c987a3fc-a6e7-4ed2-aed8-a08c3e1cc6de"],
    "IOpenServiceUninstallable": ["a440e332-aee2-4348-bb3b-b50f17b7b849"],
    "IOpenWithLauncher": ["6a283fe2-ecfa-4599-91c4-e80957137b26"],
    "IOpenWithTypeOverride": ["94724f59-eb2c-4efb-ad2b-8538f6496f7d"],
    "IOperatingSystemLicenseManager": ["fa4a3cd4-e3f0-4875-9c69-cad5423d05f4"],
    "IOperationCompletedEventArgs": ["e7af329d-051d-4fab-b1a9-47fd77f70a41"],
    "IOperationCompletedEventArgs2": ["858fa073-1e19-4105-b2f7-c8478808d562"],
    "IOperationDataReader": ["f2a2fd13-5792-4143-9f56-38f51e2906ff"],
    "IOperationDataWriter": ["a0291063-614a-413e-bac9-d9e62deb4b92"],
    "IOperationInterrupt": ["8f45ef43-0585-4881-a90d-f55d35ce7797"],
    "IOperationStatusService": ["0c3c904a-ad89-4851-9c3d-210c080cee18"],
    "IOperationStatusSink": ["9be5f0c8-774a-4070-9c9e-0627765e6c61"],
    "IOperationStatusTile": ["4ae7498c-e1c0-475f-8573-41c26127c5d8"],
    "IOperationsProgressDialog": ["0c9fb851-e5c9-43eb-a370-f0677b13874c"],
    "IOplockBreakingHandler": ["826abe3d-3acd-47d3-84f2-88aaedcf6304"],
    "IOplockCallbackEventHandler": ["9d4966fa-dbd1-4799-a07f-6a5e1991bda4"],
    "IOpticalImageStabilizationControl": ["bfad9c1d-00bc-423b-8eb2-a0178ca94247"],
    "IOptionDescription": ["432e5f85-35cf-4606-a801-6f70277e1d7a"],
    "IOptionalReferencePhotoCapturedEventArgs": ["470f88b3-1e6d-4051-9c8b-f1d85af047b7"],
    "IOrderView": ["1f6e41e5-25b1-49ce-a00a-2da5a99ee4f5"],
    "IOrientationSensor": ["5e354635-cf6b-4c63-abd8-10252b0bf6ec"],
    "IOrientationSensor2": ["0d924cf9-2f1f-49c9-8042-4a1813d67760"],
    "IOrientationSensor3": ["2cce578d-646b-48c5-b7ee-44fdc4c6aafd"],
    "IOrientationSensorDeviceId": ["5a69b648-4c29-49ec-b28f-ea1d117b66f0"],
    "IOrientationSensorReading": ["4756c993-6595-4897-bcc6-d537ee757564"],
    "IOrientationSensorReading2": ["00576e5f-49f8-4c05-9e07-24fac79408c3"],
    "IOrientationSensorReadingChangedEventArgs": ["012c1186-c3ba-46bc-ae65-7a98996cbfb8"],
    "IOrientationSensorReadingYawAccuracy": ["d1ac9824-3f5a-49a2-bc7b-1180bc38cd2b"],
    "IOrientationSensorStatics": ["10ef8712-fb4c-428a-898b-2765e409e669"],
    "IOrientationSensorStatics2": ["59da0d0b-d40a-4c71-9276-8a272a0a6619"],
    "IOrientationSensorStatics3": ["d82ce920-2777-40ff-9f59-d654b085f12f"],
    "IOrientationSensorStatics4": ["a67feb55-2c85-4b28-a0fe-58c4b20495f5"],
    "IOrientedVirtualizingPanel": ["f077b577-39bd-46ee-bdd7-0826beed71b8"],
    "IOrientedVirtualizingPanelFactory": ["7b8eaeaf-f92f-439d-9ebf-e9919f56c94d"],
    "IOutputStream": ["905a0fe6-bc53-11df-8c49-001e4fc686da"],
    "IOverlayNotify2": ["680efa10-d535-11d1-87c8-00a0c9223196"],
    "IOverrideTargetContext": ["000001ba-0000-0000-c000-000000000046"],
    "IOwnedWindowPositionBroker": ["e4076891-6bf7-447e-bbe8-426ed719d3b5"],
    "IOwnerDataCallback": ["44c09d56-8d3b-419d-a462-7b956b105b47"],
    "IPAControl": ["000001d2-0000-0000-c000-000000000046"],
    "IPAT": ["6623b511-4b5f-43c3-9a01-e8ff84188060"],
    "IPBDAAttributesDescriptor": ["313b3620-3263-45a6-9533-968befbeac03"],
    "IPBDAEntitlementDescriptor": ["22632497-0de3-4587-aadc-d8d99017e760"],
    "IPBDASiParser": ["9de49a74-aba2-4a18-93e1-21f17f95c3c3"],
    "IPBDA_EIT": ["a35f2dea-098f-4ebd-984c-2bd4c3c8ce0a"],
    "IPBDA_Services": ["944eab37-eed4-4850-afd2-77e7efeb4427"],
    "IPC2PCSyncEnabler": ["d782a778-026d-42a4-a804-964ecb5e5dab"],
    "IPDCHandleGlobalAccess": ["5aab4912-ede6-4bab-bddb-fae699e5e47c"],
    "IPINLogonEnrollmentHandler": ["b6e72f57-a110-40db-9685-b8a1e2b567bd"],
    "IPMApplicationInfo": ["50afb58a-438c-4088-9789-f8c4899829c7"],
    "IPMApplicationInfoEnumerator": ["0ec42a96-4d46-4dc6-a3d9-a7acaac0f5fa"],
    "IPMBackgroundServiceAgentInfo": ["3a8b46da-928c-4879-998c-09dc96f3d490"],
    "IPMBackgroundServiceAgentInfoEnumerator": ["18eb2072-ab56-43b3-872c-beafb7a6b391"],
    "IPMBackgroundWorkerInfo": ["7dd4531b-d3bf-4b6b-94f3-69c098b1497d"],
    "IPMBackgroundWorkerInfoEnumerator": ["87f479f8-90d8-4ec7-92b9-72787e2f636b"],
    "IPMCFilterFolder": ["2a9ecc4e-9246-40c0-b20a-7402f91e323c"],
    "IPMCWorkItem": ["f9753ce4-b8a8-433a-977b-860f8469ee10"],
    "IPMDeploymentManager": ["35f785fa-1979-4a8b-bc8f-fd70eb0d1544"],
    "IPMEnumerationManager": ["698d57c2-292d-4cf3-b73c-d95a6922ed9a"],
    "IPMExtensionCachedFileUpdaterInfo": ["e2d77509-4e58-4ba9-af7e-b642e370e1b0"],
    "IPMExtensionContractInfo": ["e5666373-7ba1-467c-b819-b175db1c295b"],
    "IPMExtensionFileExtensionInfo": ["6b87cb6c-0b88-4989-a4ec-033714f710d4"],
    "IPMExtensionFileOpenPickerInfo": ["6dc91d25-9606-420c-9a78-e034a3418345"],
    "IPMExtensionFileSavePickerInfo": ["38005cba-f81a-493e-a0f8-922c8680da43"],
    "IPMExtensionInfo": ["49acde79-9788-4d0a-8aa0-1746afdb9e9d"],
    "IPMExtensionInfoEnumerator": ["403b9e82-1171-4573-8e6f-6f33f39b83dd"],
    "IPMExtensionProtocolInfo": ["1e3fa036-51eb-4453-baff-b8d8e4b46c8e"],
    "IPMExtensionShareTargetInfo": ["5471f48b-c65c-4656-8c70-242e31195fea"],
    "IPMLifeCycleNotification": ["e08c57ad-68c0-4851-a4b9-6a6041004b9a"],
    "IPMLiveTileJobInfo": ["6009a81f-4710-4697-b5f6-2208f6057b8e"],
    "IPMLiveTileJobInfoEnumerator": ["bc042582-9415-4f36-9f99-06f104c07c03"],
    "IPMNotificationManager": ["095bf7a5-f134-42b9-a4b0-7c5f1a9e199a"],
    "IPMT": ["01f3b398-9527-4736-94db-5195878e97a8"],
    "IPMTaskInfo": ["bf1d8c33-1bf5-4ee0-b549-6b9dd3834942"],
    "IPMTaskInfoEnumerator": ["0630b0f8-0bbc-4821-be74-c7995166ed2a"],
    "IPMTileInfo": ["d1604833-2b08-4001-82cd-183ad734f752"],
    "IPMTileInfoEnumerator": ["ded83065-e462-4b2c-acb5-e39cea61c874"],
    "IPMTilePropertyEnumerator": ["cc4cd629-9047-4250-aac8-930e47812421"],
    "IPMTilePropertyInfo": ["6c2b8017-1efa-42a7-86c0-6d4b640bf528"],
    "IPNPXAssociation": ["0bd7e521-4da6-42d5-81ba-1981b6b94075"],
    "IPNPXDeviceAssociation": ["eed366d0-35b8-4fc5-8d20-7e5bd31f6ded"],
    "IPPIAllUpViewHost": ["0cbeff0b-7751-4b77-8907-debf5cc3df7a"],
    "IPPIAllUpViewInvoker": ["f90f3d2a-ad8d-45a4-84ea-75b51334240c"],
    "IPSITables": ["919f24c5-7b14-42ac-a4b0-2ae08daf00ac"],
    "IPTFilterLicenseRenewal": ["26d836a5-0c15-44c7-ac59-b0da8728f240"],
    "IPackage2": ["a6612fb6-7688-4ace-95fb-359538e7aa01"],
    "IPackage3": ["5f738b61-f86a-4917-93d1-f1ee9d3b35d9"],
    "IPackage4": ["65aed1ae-b95b-450c-882b-6255187f397e"],
    "IPackage5": ["0e842dd4-d9ac-45ed-9a1e-74ce056b2635"],
    "IPackage6": ["8b1ad942-12d7-4754-ae4e-638cbc0e3a2e"],
    "IPackage7": ["86ff8d31-a2e4-45e0-9732-283a6d88fde1"],
    "IPackage8": ["2c584f7b-ce2a-4be6-a093-77cfbb2a7ea1"],
    "IPackageCatalog": ["230a3751-9de3-4445-be74-91fb325abefe"],
    "IPackageCatalog2": ["96a60c36-8ff7-4344-b6bf-ee64c2207ed2"],
    "IPackageCatalog3": ["96dd5c88-8837-43f9-9015-033434ba14f3"],
    "IPackageCatalog4": ["c37c399b-44cc-4b7b-8baf-796c04ead3b9"],
    "IPackageCatalogAddOptionalPackageResult": ["3bf10cd4-b4df-47b3-a963-e2fa832f7dd3"],
    "IPackageCatalogAddResourcePackageResult": ["9636ce0d-3e17-493f-aa08-ccec6fdef699"],
    "IPackageCatalogRemoveOptionalPackagesResult": ["29d2f97b-d974-4e64-9359-22cadfd79828"],
    "IPackageCatalogRemoveResourcePackagesResult": ["ae719709-1a52-4321-87b3-e5a1a17981a7"],
    "IPackageCatalogStatics": ["a18c9696-e65b-4634-ba21-5e63eb7244a7"],
    "IPackageContentGroup": ["8f62695d-120a-4798-b5e1-5800dda8f2e1"],
    "IPackageContentGroupStagingEventArgs": ["3d7bc27e-6f27-446c-986e-d4733d4d9113"],
    "IPackageContentGroupStatics": ["70ee7619-5f12-4b92-b9ea-6ccada13bc75"],
    "IPackageDebugSettings": ["f27c3930-8029-4ad1-94e3-3dba417810c1"],
    "IPackageDebugSettings2": ["6e3194bb-ab82-4d22-93f5-fabda40e7b16"],
    "IPackageExecutionStateChangeNotification": ["1bb12a62-2ad8-432b-8ccf-0c2c52afcd5b"],
    "IPackageId": ["1adb665e-37c7-4790-9980-dd7ae74e8bb2"],
    "IPackageIdWithMetadata": ["40577a7c-0c9e-443d-9074-855f5ce0a08d"],
    "IPackageInstallingEventArgs": ["97741eb7-ab7a-401a-8b61-eb0e7faff237"],
    "IPackageManager": ["9a7d4b65-5e8f-4fc7-a2e5-7f6925cb8b53"],
    "IPackageManager2": ["f7aad08d-0840-46f2-b5d8-cad47693a095"],
    "IPackageManager3": ["daad9948-36f1-41a7-9188-bc263e0dcb72"],
    "IPackageManager4": ["3c719963-bab6-46bf-8ff7-da4719230ae6"],
    "IPackageManager5": ["711f3117-1afd-4313-978c-9bb6e1b864a7"],
    "IPackageManager6": ["0847e909-53cd-4e4f-832e-57d180f6e447"],
    "IPackageManager7": ["f28654f4-2ba7-4b80-88d6-be15f9a23fba"],
    "IPackageManager8": ["b8575330-1298-4ee2-80ee-7f659c5d2782"],
    "IPackageManager9": ["1aa79035-cc71-4b2e-80a6-c7041d8579a7"],
    "IPackageManagerDebugSettings": ["1a611683-a988-4fcf-8f0f-ce175898e8eb"],
    "IPackageServicingListener": ["6f725c18-6c52-4466-9671-5c17e2e3885f"],
    "IPackageStagingEventArgs": ["1041682d-54e2-4f51-b828-9ef7046c210f"],
    "IPackageStateChangeHandler": ["b74943a0-67d2-41e7-8456-57ec2e83c367"],
    "IPackageStatics": ["4e534bdf-2960-4878-97a4-9624deb72f2d"],
    "IPackageStatus": ["5fe74f71-a365-4c09-a02d-046d525ea1da"],
    "IPackageStatus2": ["f428fa93-7c56-4862-acfa-abaedcc0694d"],
    "IPackageStatusChangedEventArgs": ["437d714d-bd80-4a70-bc50-f6e796509575"],
    "IPackageUninstallingEventArgs": ["4443aa52-ab22-44cd-82bb-4ec9b827367a"],
    "IPackageUpdateAvailabilityResult": ["114e5009-199a-48a1-a079-313c45634a71"],
    "IPackageUpdatingEventArgs": ["cd7b4228-fd74-443e-b114-23e677b0e86f"],
    "IPackageUserInformation": ["f6383423-fa09-4cbc-9055-15ca275e2e7e"],
    "IPackageUtil": ["6eb22874-8a19-11d0-81b6-00a0c9231c29"],
    "IPackageVolume": ["cf2672c3-1a40-4450-9739-2ace2e898853"],
    "IPackageVolume2": ["46abcf2e-9dd4-47a2-ab8c-c6408349bcd8"],
    "IPackageWithMetadata": ["95949780-1de9-40f2-b452-0de9f1910012"],
    "IPacket": ["2f6015cc-2710-4aa1-9408-ead056b555e1"],
    "IPage": ["c4b27075-e641-453e-824d-012fc7cf95cf"],
    "IPageFactory": ["dfa149ac-1849-445e-937c-40a9590cc076"],
    "IPageOverrides": ["230b9cb8-3419-4306-aabe-4a8e680d3627"],
    "IPageStackEntry": ["ef8814a6-9388-4aca-8572-405194069080"],
    "IPageStackEntryFactory": ["4454048a-a8b9-4f78-9b84-1f51f58851ff"],
    "IPageStackEntryStatics": ["aceff8e3-246c-4033-9f01-01cb0da5254e"],
    "IPageStatics": ["376dde71-f725-46dd-8d80-eeeaf7da74e5"],
    "IPaginateEventArgs": ["ed945fd6-79ab-42b7-930a-3d6e09011d21"],
    "IPaginateEventHandler": ["0cc05b61-811b-4a32-9965-13eb78dbb01b"],
    "IPalmRejectionDelayZonePreview": ["62b496cb-539d-5343-a65f-41f5300ec70c"],
    "IPalmRejectionDelayZonePreviewStatics": ["cdef5ee0-93d0-53a9-8f0e-9a379f8f7530"],
    "IPaneThemeTransition": ["4708eb8e-4bfc-ee46-d4f9-708def3fbb2b"],
    "IPaneThemeTransitionStatics": ["316b382f-4be4-1797-b45c-cd900bbe0caa"],
    "IPanel": ["8e3867aa-8586-11d1-b16a-00c0f0283628", "a50a4bbd-8361-469c-90da-e9a40c7474df"],
    "IPanel2": ["709133c7-38f3-5083-a4bb-06a548a1d231"],
    "IPanelBasedOptimizationControl": ["33323223-6247-5419-a5a4-3d808645d917"],
    "IPanelFactory": ["eee68111-c7cc-433f-95cd-d630c34302dd"],
    "IPanelStatics": ["f23d6b5d-8330-47a6-a046-25f509b25232"],
    "IPanels": ["8e3867a4-8586-11d1-b16a-00c0f0283628"],
    "IParagraph": ["f83ef59a-fa61-4bef-ae33-0b0ad756a84d"],
    "IParagraphStatics": ["ef08889a-535b-4e4c-8d84-283b33e98a37"],
    "IParallaxView": ["6b84fcd4-4083-5b4b-bc40-d9204e19b41a"],
    "IParallaxViewFactory": ["e4eb9642-3e8e-5a26-94f2-9121d121b916"],
    "IParallaxViewStatics": ["8836e49c-0e0e-57d8-9395-f0a9a0d1bb28"],
    "IParentAndItem": ["b3a4b685-b685-4805-99d9-5dead2873236"],
    "IParentRowset": ["0c733aaa-2a1c-11ce-ade5-00aa0044773d"],
    "IParseAndCreateItem": ["67efed0e-e827-4408-b493-78f3982b685c"],
    "IPart": ["ae2de0e4-5bca-4f2d-aa46-5d13f8fdb3a9"],
    "IPartBase": ["36d51e28-369e-43ba-a666-9540c62c3f58"],
    "IPartColorProfile": ["63cca95b-7d18-4762-b15e-98658693d24a"],
    "IPartDiscardControl": ["cc350c00-095b-42a5-bf0f-c8780edadb3c"],
    "IPartFont": ["e07fe0ab-1124-43d0-a865-e8ffb6a3ea82"],
    "IPartFont2": ["511e025f-d6cb-43be-bf65-63fe88515a39"],
    "IPartImage": ["725f2e3c-401a-4705-9de0-fe6f1353b87f"],
    "IPartPrintTicket": ["4a0f50f6-f9a2-41f0-99e7-5ae955be8e9e"],
    "IPartResourceDictionary": ["16cfce6d-e744-4fb3-b474-f1d54f024a01"],
    "IPartThumbnail": ["027ed1c9-ba39-4cc5-aa55-7ec3a0de171a"],
    "IPartialMediaFailureDetectedEventArgs": ["02b65a91-e5a1-442b-88d3-2dc127bfc59b"],
    "IPartialMediaFailureDetectedEventArgs2": ["73074875-890d-416b-b9ae-e84dfd9c4b1b"],
    "IPartitionLookup": ["000001f8-0000-0000-c000-000000000046"],
    "IPartitionProperty": ["000001f2-0000-0000-c000-000000000046"],
    "IPartsList": ["6daa848c-5eb0-45cc-aea5-998a2cda1ffb"],
    "IPasswordBox": ["02b9aa11-0b47-4e7d-ad91-3a4168ed230d"],
    "IPasswordBox2": ["5ed738df-212f-4aeb-b5b8-2c219aec3c0c"],
    "IPasswordBox3": ["6024d9d1-56b7-41f0-9558-3934c14244d6"],
    "IPasswordBox4": ["569f4343-8e6c-44bf-808d-0e03964ed32f"],
    "IPasswordBox5": ["f96c2753-e1d4-5142-86c2-7318bfbbc705"],
    "IPasswordBoxAutomationPeer": ["684f065e-3df3-4b9f-82ad-8819db3b218a"],
    "IPasswordBoxAutomationPeerFactory": ["ac3d7ede-dca4-481c-b520-4a9b3f3b179c"],
    "IPasswordBoxPasswordChangingEventArgs": ["142eda22-3552-4ab8-81a6-a48620ee9c53"],
    "IPasswordBoxStatics": ["5ee67563-2d74-4ace-bd79-fcab61a7d77b"],
    "IPasswordBoxStatics2": ["fc57935f-98fa-4066-b785-fa725ecde232"],
    "IPasswordBoxStatics3": ["a2cdd319-ad6a-4352-b590-f696ffcb8e3f"],
    "IPasswordBoxStatics5": ["4bdac1ac-6b42-55f3-bfa4-65c7235078d6"],
    "IPasswordCredential": ["6ab18989-c720-41a7-a6c1-feadb36329a0"],
    "IPasswordOnWakeSetting": ["53e78940-b62e-49f8-a69b-84cb8963a513"],
    "IPasswordVault": ["61fd2c0b-c8d4-48c1-a54f-bc5a64205af2"],
    "IPath": ["78883609-3d57-4f3c-b8a5-6cabcac9711f"],
    "IPathFactory": ["2340a4e3-5a86-4fc6-9a50-cbb93b828766"],
    "IPathFigure": ["5d955c8c-5fa9-4dda-a3cc-10fcdcaa20d7"],
    "IPathFigureStatics": ["b60591d9-2395-4317-9552-3a58526f8c7b"],
    "IPathGeometry": ["081b9df8-bae6-4bcb-813c-bde0e46dc8b7"],
    "IPathGeometryStatics": ["d9e58bba-2cba-4741-8f8d-3198cf5186b9"],
    "IPathIOStatics": ["0f2f3758-8ec7-4381-922b-8f6c07d288f3"],
    "IPathIcon": ["214c62db-c366-4a0e-b9ad-dcf168d7ec0c"],
    "IPathIconFactory": ["af9d9652-9c5d-4a37-9e1a-044abeef792b"],
    "IPathIconSource": ["1f47010e-b305-4863-8b7a-15d08d633c7a"],
    "IPathIconSourceFactory": ["8f7f85b9-5247-4f3b-833f-e384bf7e9c84"],
    "IPathIconSourceStatics": ["df7027d5-3682-43ff-80f0-afa256b2fdc3"],
    "IPathIconStatics": ["77b75db8-fb15-491a-b6e3-7dbba911bafe"],
    "IPathKeyFrameAnimation": ["9d0d18c9-1576-4b3f-be60-1d5031f5e71b"],
    "IPathSegment": ["fcfa71cf-9ce3-474f-8157-10b6435a616b"],
    "IPathSegmentFactory": ["2a1c0aae-eccd-4464-a148-6ffdb3aa281f"],
    "IPathStatics": ["f627e59d-87dc-4142-81f1-97fc7ff8641c"],
    "IPauseRealization": ["1863b779-7415-4f0b-a7a3-408e084619e5"],
    "IPaymentAddress": ["5f2264e9-6f3a-4166-a018-0a0b06bb32b5"],
    "IPaymentAppCanMakePaymentTriggerDetails": ["0ce201f0-8b93-4eb6-8c46-2e4a6c6a26f6"],
    "IPaymentAppManager": ["0e47aa53-8521-4969-a957-df2538a3a98f"],
    "IPaymentAppManagerStatics": ["a341ac28-fc89-4406-b4d9-34e7fe79dfb6"],
    "IPaymentCanMakePaymentResult": ["7696fe55-d5d3-4d3d-b345-45591759c510"],
    "IPaymentCanMakePaymentResultFactory": ["bbdcaa3e-7d49-4f69-aa53-2a0f8164b7c9"],
    "IPaymentCurrencyAmount": ["e3a3e9e0-b41f-4987-bdcb-071331f2daa4"],
    "IPaymentCurrencyAmountFactory": ["3257d338-140c-4575-8535-f773178c09a7"],
    "IPaymentDetails": ["53bb2d7d-e0eb-4053-8eae-ce7c48e02945"],
    "IPaymentDetailsFactory": ["cfe8afee-c0ea-4ca1-8bc7-6de67b1f3763"],
    "IPaymentDetailsModifier": ["be1c7d65-4323-41d7-b305-dfcb765f69de"],
    "IPaymentDetailsModifierFactory": ["79005286-54de-429c-9e4f-5dce6e10ebce"],
    "IPaymentItem": ["685ac88b-79b2-4b76-9e03-a876223dfe72"],
    "IPaymentItemFactory": ["c6ab7ad8-2503-4d1d-a778-02b2e5927b2c"],
    "IPaymentMediator": ["fb0ee829-ec0c-449a-83da-7ae3073365a2"],
    "IPaymentMediator2": ["ceef98f1-e407-4128-8e73-d93d5f822786"],
    "IPaymentMerchantInfo": ["63445050-0e94-4ed6-aacb-e6012bd327a7"],
    "IPaymentMerchantInfoFactory": ["9e89ced3-ccb7-4167-a8ec-e10ae96dbcd1"],
    "IPaymentMethodData": ["d1d3caf4-de98-4129-b1b7-c3ad86237bf4"],
    "IPaymentMethodDataFactory": ["8addd27f-9baa-4a82-8342-a8210992a36b"],
    "IPaymentOptions": ["aaa30854-1f2b-4365-8251-01b58915a5bc"],
    "IPaymentRequest": ["b74942e1-ed7b-47eb-bc08-78cc5d6896b6"],
    "IPaymentRequest2": ["b63ccfb5-5998-493e-a04c-67048a50f141"],
    "IPaymentRequestChangedArgs": ["c6145e44-cd8b-4be4-b555-27c99194c0c5"],
    "IPaymentRequestChangedHandler": ["5078b9e1-f398-4f2c-a27e-94d371cf6c7d"],
    "IPaymentRequestChangedResult": ["df699e5c-16c4-47ad-9401-8440ec0757db"],
    "IPaymentRequestChangedResultFactory": ["08740f56-1d33-4431-814b-67ea24bf21db"],
    "IPaymentRequestFactory": ["3e8a79dc-6b74-42d3-b103-f0de35fb1848"],
    "IPaymentRequestFactory2": ["e6ce1325-a506-4372-b7ef-1a031d5662d1"],
    "IPaymentRequestSubmitResult": ["7b9c3912-30f2-4e90-b249-8ce7d78ffe56"],
    "IPaymentResponse": ["e1389457-8bd2-4888-9fa8-97985545108e"],
    "IPaymentShippingOption": ["13372ada-9753-4574-8966-93145a76c7f9"],
    "IPaymentShippingOptionFactory": ["5de5f917-b2d7-446b-9d73-6123fbca3bc6"],
    "IPaymentToken": ["bbcac013-ccd0-41f2-b2a1-0a2e4b5dce25"],
    "IPaymentTokenFactory": ["988cd7aa-4753-4904-8373-dd7b08b995c1"],
    "IPaymentTransaction": ["62581da0-26a5-4e9b-a6eb-66606cf001d3"],
    "IPaymentTransactionAcceptResult": ["060e3276-d30c-4817-95a2-df7ae9273b56"],
    "IPaymentTransactionStatics": ["8d639750-ee0a-4df5-9b1e-1c0f9ec59881"],
    "IPdcController": ["631848df-24f1-4751-a1be-eed46c0b06fd"],
    "IPdfDocument": ["ac7ebedd-80fa-4089-846e-81b77ff5a86c"],
    "IPdfDocumentStatics": ["433a0b5f-c007-4788-90f2-08143d922599"],
    "IPdfPage": ["9db4b0c8-5320-4cfc-ad76-493fdad0e594"],
    "IPdfPageDimensions": ["22170471-313e-44e8-835d-63a3e7624a10"],
    "IPdfPageRenderOptions": ["3c98056f-b7cf-4c29-9a04-52d90267f425"],
    "IPdfRendererNative": ["7d9dcd91-d277-4947-8527-07a0daeda94a"],
    "IPedometer": ["9a1e013d-3d98-45f8-8920-8e4ecaca5f97"],
    "IPedometer2": ["e5a406df-2b81-4add-b2ff-77ab6c98ba19"],
    "IPedometerDataThresholdFactory": ["cbad8f50-7a54-466b-9010-77a162fca5d7"],
    "IPedometerReading": ["2245dcf4-a8e1-432f-896a-be0dd9b02d24"],
    "IPedometerReadingChangedEventArgs": ["f855e47e-abbc-4456-86a8-25cf2b333742"],
    "IPedometerStatics": ["82980a2f-4083-4dfb-b411-938ea0f4b946"],
    "IPedometerStatics2": ["79f5c6bb-ce0e-4133-b47e-8627ea72f677"],
    "IPeerFinderStatics": ["914b3b61-f6e1-47c4-a14c-148a1903d0c6"],
    "IPeerFinderStatics2": ["d6e73c65-fdd0-4b0b-9312-866408935d82"],
    "IPeerGroupManager": ["8b1a7dd9-d73b-422d-b06c-b5e0eba04234"],
    "IPeerGroupManagerCallback": ["a52d1082-cacc-4ba1-9399-10328529a693"],
    "IPeerGroupWrapper": ["bd0fe5a8-c975-41ae-a319-e21df8c7b202"],
    "IPeerInformation": ["20024f08-9fff-45f4-b6e9-408b2ebef373"],
    "IPeerInformation3": ["b20f612a-dbd0-40f8-95bd-2d4209c7836f"],
    "IPeerInformationWithHostAndService": ["ecc7ccad-1b70-4e8b-92db-bbe781419308"],
    "IPeerWatcher": ["3cee21f8-2fa6-4679-9691-03c94a420f34"],
    "IPeerWrapperCallback": ["f58a4210-6b53-4338-8a43-ab74b647b368"],
    "IPeerWrapperCommon": ["f9a5f8f0-5421-47ec-a3d0-d9a7b9f4ac02"],
    "IPeerWrapperFindBroadcastData": ["9838aa0f-12ff-41bd-be12-b0776c8c4be1"],
    "IPeerWrapperFindBroadcastDataNoParam": ["a5f020fe-85de-4463-ad34-698bfe2730e2"],
    "IPenAndInkSettings": ["bc2ceb8f-0066-44a8-bb7a-b839b3deb8f5"],
    "IPenAndInkSettingsStatics": ["ed6dd036-5708-5c3c-96db-f2f552eab641"],
    "IPenButtonListener": ["8245c376-1ee3-53f7-b1f7-8334a16f2815"],
    "IPenButtonListenerStatics": ["19a8a584-862f-5f69-bfea-05f6584f133f"],
    "IPenDevice": ["31856eba-a738-5a8c-b8f6-f97ef68d18ef"],
    "IPenDeviceStatics": ["9dfbbe01-0966-5180-bcb4-b85060e39479"],
    "IPenDockListener": ["759f4d90-1dc0-55cb-ad18-b9101456f592"],
    "IPenDockListenerStatics": ["cab75e9a-0016-5c72-969e-a97e11992a93"],
    "IPenDockedEventArgs": ["fd4277c6-ca63-5d4e-9ed3-a28a54521c8c"],
    "IPenInputPanel": ["fa7a4083-5747-4040-a182-0b0e9fd4fac7"],
    "IPenServiceTablet": ["5ee46c56-1537-4cc5-8a93-a7ed4d139387"],
    "IPenTailButtonClickedEventArgs": ["5d2fb7b6-6ad3-5d3e-ab29-05ea2410e390"],
    "IPenTailButtonDoubleClickedEventArgs": ["846321a2-618a-5478-b04c-b358231da4a7"],
    "IPenTailButtonLongPressedEventArgs": ["f37c606e-c60a-5f42-b818-a53112406c13"],
    "IPenUndockedEventArgs": ["ccd09150-261b-59e6-a5d4-c1964cd03feb"],
    "IPenWorkspaceDiscoverBroker": ["84524597-b734-4d3f-8b25-f753513d08cf"],
    "IPenWorkspaceFileSavePickerBroker": ["56abdd06-2b36-4a92-b399-90369a10ba53"],
    "IPenWorkspaceLayoutItem": ["c343e0c0-9666-444b-898f-cc498c7e521a"],
    "IPenWorkspaceLayoutPolicyManager": ["9302a129-7433-42a0-9cb8-5da5964f2756"],
    "IPenWorkspaceLockBroker": ["b4ef8573-4d06-4f91-bdf8-438252763424"],
    "IPenWorkspaceNotesThumbnailBroker": ["146b2bab-2731-40b5-b410-2628e3559dff"],
    "IPenWorkspaceScreenCaptureBroker": ["332318f2-b9a0-430e-afc9-96e7048d9858"],
    "IPendingNavigation": ["ae08cf60-0965-4901-ad25-cc79b1297fca"],
    "IPeopleBarBroker": ["49f3ebd3-3c33-4c92-86e3-10c60607a9e6"],
    "IPeopleExperienceHostManager": ["2b0567dd-ad35-4ae3-8079-c01d99593d8a"],
    "IPeoplePaneViewUpdateSink": ["45eec4f2-11f6-4f53-8724-2276133992f3"],
    "IPerChannelDbLevel": ["c2f8e001-f205-4bc9-99bc-c13b1e048ccb"],
    "IPercentFormatterFactory": ["b7828aef-fed4-4018-a6e2-e09961e03765"],
    "IPerceptionDevice": ["c8f21eb1-9411-4516-a8a1-b778cf767287"],
    "IPerceptionDeviceFactory": ["33d7a5ec-a087-4c8b-8167-67c0d6016fdb"],
    "IPerceptionDeviceFactory2": ["3f6591ae-70ec-4290-9035-760cdcecbe04"],
    "IPerceptionDeviceObjectSubscription": ["9801651f-e62b-4e19-979f-4b8c5adb80e6"],
    "IPerceptionDevicePayloadDescriptor": ["5fb106f4-a5c7-43c8-a723-232b4456dc6c"],
    "IPerceptionDevicePropertyChangedEventArgs": ["81a9d645-1d04-4778-8af0-83fa08a9d9b7"],
    "IPerceptionDevicePropertyChangedHandler": ["93d35d5f-b33f-42f3-9795-3973c6d919ae"],
    "IPerceptionDevicePropertyListener": ["0e2fae1e-c75c-4530-91b9-8f264540f8cc"],
    "IPerceptionDevicePropertyListener2": ["cdb274fa-c769-4d05-a5fc-dd96976482f8"],
    "IPerceptionDevicePropertyListenerAbortedEventArgs": ["af436745-6e52-441d-aaa5-c34c715da7ae"],
    "IPerceptionDevicePropertyListenerAbortedHandler": ["a5082165-2b1a-4c4e-a0d0-3d3d6c4091c5"],
    "IPerceptionDeviceRootObject": ["9beab621-6dcc-4dbb-ae35-c4bbc4103e74"],
    "IPerceptionDeviceRootObjectAddedEventArgs": ["b6b43fbf-92d3-4467-8fff-553ea84ed9ba"],
    "IPerceptionDeviceRootObjectAddedHandler": ["0e69dbe3-cba4-4677-98f8-e26efc983632"],
    "IPerceptionDeviceRootObjectCollection": ["65de0349-748e-4f8a-986f-ee2ac41cfdaa"],
    "IPerceptionDeviceRootObjectRemovedEventArgs": ["cb9c24bc-2778-4a5c-b7ef-91d34025bf6a"],
    "IPerceptionDeviceRootObjectRemovedHandler": ["f720bf56-3d90-4421-b1ef-4f8f5edc7a07"],
    "IPerceptionDeviceRootObjectWatcher": ["2f22b1bd-7431-4452-92d6-d31557570f33"],
    "IPerceptionDeviceRootObjectWatcher2": ["b7531e32-01ac-4e0d-b721-aff625d6a254"],
    "IPerceptionDeviceRootObjectWatcherEnumerationCompletedHandler": ["c76db9e8-7b26-4fd6-a9e9-607e361c0c9b"],
    "IPerceptionDeviceStateStream": ["c2fb5866-1c71-4b74-89e1-ea13f2709b11"],
    "IPerceptionDeviceStateStreamReader": ["3b84aab1-d2be-4d26-b285-e21cde1de058"],
    "IPerceptionTimestamp": ["87c24804-a22e-4adb-ba26-d78ef639bcf4"],
    "IPerceptionTimestamp2": ["e354b7ed-2bd1-41b7-9ed0-74a15c354537"],
    "IPerceptionTimestampHelperStatics": ["47a611d4-a9df-4edc-855d-f4d339d967ac"],
    "IPerceptionTimestampHelperStatics2": ["73d1a7fe-3fb9-4571-87d4-3c920a5e86eb"],
    "IPerfCenterEnabler": ["8c163d3c-95fb-4b8d-b9a3-878c8085efc5"],
    "IPerformanceCounterDataCollector": ["03837506-098b-11d8-9414-505054503030"],
    "IPeriodicForceEffect": ["5c5138d7-fc75-4d52-9a0a-efe4cab5fe64"],
    "IPeriodicForceEffectFactory": ["6f62eb1a-9851-477b-b318-35ecaa15070f"],
    "IPermanentInternetSecurityManagerHelper": ["1a3dc5f5-914e-42ac-ab8d-0bd48d5e911a"],
    "IPermilleFormatterFactory": ["2b37b4ac-e638-4ed5-a998-62f6b06a49ae"],
    "IPersistAltHTMLStream": ["56223fe4-d397-11cf-a42e-00aa00c00940"],
    "IPersistBinaryStream": ["c3209836-26eb-4e90-ab7a-6a7aea82d59c"],
    "IPersistFileCheckSum": ["35355da7-3eea-452e-89f3-68344278f806"],
    "IPersistFileFormat": ["3afae242-b530-11d0-8199-00a0c91bbee3"],
    "IPersistHTMLStream": ["56223fe3-d397-11cf-a42e-00aa00c00940"],
    "IPersistHistory2": ["4f77badd-a032-41c7-b32f-0b44570df139"],
    "IPersistHistoryPriv": ["6bc89924-b6e3-496d-9770-e5622a0273a9"],
    "IPersistSerializedPropStorage": ["e318ad57-0aa0-450f-aca5-6fab7103d917"],
    "IPersistSerializedPropStorage2": ["77effa68-4f98-4366-ba72-573b3d880571"],
    "IPersistStreamInitVersionPriv": ["3051083e-98b5-11cf-bb82-00aa00bdce0b"],
    "IPersistString2": ["3c44ba76-de0e-4049-b6e4-6b31a5262707"],
    "IPersistTextBlobBits": ["ed2d3f04-3735-429a-ba86-3ac3138ce470"],
    "IPersistTuneXml": ["0754cd31-8d15-47a9-8215-d20064157244"],
    "IPersistTuneXmlUtility": ["990237ae-ac11-4614-be8f-dd217a4cb4cb"],
    "IPersistTuneXmlUtility2": ["992e165f-ea24-4b2f-9a1d-009d92120451"],
    "IPersistXML": ["169db284-8361-4be4-bdb0-0b73ad8764f1"],
    "IPersistXMLFragment": ["6b0c8632-6f01-4e54-9645-ffe82a2f4fe9"],
    "IPersistedKeyProviderStatics": ["77274814-d9d4-4cf5-b668-e0457df30894"],
    "IPersonPicture": ["6c230b6d-0d75-4059-91bc-7b174d1d7315"],
    "IPersonPictureAutomationPeer": ["27156d4c-a66f-4aaf-8286-4f796d30628c"],
    "IPersonPictureAutomationPeerFactory": ["a95f1f6d-2524-44a4-97fd-1181130100ad"],
    "IPersonPictureFactory": ["4f18330d-0416-4b92-bfd3-bf5780b46ab2"],
    "IPersonPictureStatics": ["dbec0982-3c10-4639-9614-aa5b7cdc32ca"],
    "IPerspectiveTransform3D": ["9a7b532a-30f9-40a1-96c9-c59d87f95ac3"],
    "IPerspectiveTransform3DStatics": ["8e6f6400-620c-48c7-844d-3f0984da5b17"],
    "IPfxImportParameters": ["680d3511-9a08-47c8-864a-2edd4d8eb46c"],
    "IPhishingFilterManagerCallback": ["1525e844-b912-4558-85cf-b1a3fe27d354"],
    "IPhoneCallBlockedTriggerDetails": ["a4a690a2-e4c1-427f-864e-e470477ddb67"],
    "IPhoneCallBlockingStatics": ["19646f84-2b79-26f1-a46f-694be043f313"],
    "IPhoneCallHistoryEntry": ["fab0e129-32a4-4b85-83d1-f90d8c23a857"],
    "IPhoneCallHistoryEntryAddress": ["30f159da-3955-4042-84e6-66eebf82e67f"],
    "IPhoneCallHistoryEntryAddressFactory": ["fb0fadba-c7f0-4bb6-9f6b-ba5d73209aca"],
    "IPhoneCallHistoryEntryQueryOptions": ["9c5fe15c-8bed-40ca-b06e-c4ca8eae5c87"],
    "IPhoneCallHistoryEntryReader": ["61ece4be-8d86-479f-8404-a9846920fee6"],
    "IPhoneCallHistoryManagerForUser": ["d925c523-f55f-4353-9db4-0205a5265a55"],
    "IPhoneCallHistoryManagerStatics": ["f5a6da39-b31f-4f45-ac8e-1b08893c1b50"],
    "IPhoneCallHistoryManagerStatics2": ["efd474f0-a2db-4188-9e92-bc3cfa6813cf"],
    "IPhoneCallHistoryStore": ["2f907db8-b40e-422b-8545-cb1910a61c52"],
    "IPhoneCallManagerStatics": ["60edac78-78a6-4872-a3ef-98325ec8b843"],
    "IPhoneCallManagerStatics2": ["c7e3c8bc-2370-431c-98fd-43be5f03086d"],
    "IPhoneCallOriginDataRequestTriggerDetails": ["6e9b5b3f-c54b-4e82-4cc9-e329a4184592"],
    "IPhoneCallStore": ["5f610748-18a6-4173-86d1-28be9dc62dba"],
    "IPhoneCallVideoCapabilities": ["02382786-b16a-4fdb-be3b-c4240e13ad0d"],
    "IPhoneCallVideoCapabilitiesManagerStatics": ["f3c64b56-f00b-4a1c-a0c6-ee1910749ce7"],
    "IPhoneDialOptions": ["b639c4b8-f06f-36cb-a863-823742b5f2d4"],
    "IPhoneIncomingCallDismissedTriggerDetails": ["bad30276-83b6-5732-9c38-0c206546196a"],
    "IPhoneLine": ["27c66f30-6a69-34ca-a2ba-65302530c311"],
    "IPhoneLine2": ["0167f56a-5344-5d64-8af3-a31a950e916a"],
    "IPhoneLineCellularDetails": ["192601d5-147c-4769-b673-98a5ec8426cb"],
    "IPhoneLineChangedTriggerDetails": ["c6d321e7-d11d-40d8-b2b7-e40a01d66249"],
    "IPhoneLineConfiguration": ["fe265862-f64f-4312-b2a8-4e257721aa95"],
    "IPhoneLineStatics": ["f38b5f23-ceb0-404f-bcf2-ba9f697d8adf"],
    "IPhoneLineTransportDevice": ["efa8f889-cffa-59f4-97e4-74705b7dc490"],
    "IPhoneLineTransportDeviceStatics": ["0f3121ac-d609-51a1-96f3-fb00d1819252"],
    "IPhoneLineWatcher": ["8a45cd0a-6323-44e0-a6f6-9f21f64dc90a"],
    "IPhoneLineWatcherEventArgs": ["d07c753e-9e12-4a37-82b7-ad535dad6a67"],
    "IPhoneNewVoicemailMessageTriggerDetails": ["13a8c01b-b831-48d3-8ba9-8d22a6580dcf"],
    "IPhoneNumberFormatter": ["1556b49e-bad4-4b4a-900d-4407adb7c981"],
    "IPhoneNumberFormatterStatics": ["5ca6f931-84d9-414b-ab4e-a0552c878602"],
    "IPhoneNumberInfo": ["1c7ce4dd-c8b4-4ea3-9aef-b342e2c5b417"],
    "IPhoneNumberInfoFactory": ["8202b964-adaa-4cff-8fcf-17e7516a28ff"],
    "IPhoneNumberInfoStatics": ["5b3f4f6a-86a9-40e9-8649-6d61161928d4"],
    "IPhoneStartModel": ["2fe42a12-408e-402b-a475-4dab5cad28b6"],
    "IPhoneTrigger": ["8dcfe99b-d4c5-49f1-b7d3-82e87a0e9dde"],
    "IPhoneTriggerFactory": ["a0d93cda-5fc1-48fb-a546-32262040157b"],
    "IPhoneVoicemail": ["c9ce77f6-6e9f-3a8b-b727-6e0cf6998224"],
    "IPhotoAcquire": ["00f23353-e31b-4955-a8ad-ca5ebf31e2ce"],
    "IPhotoAcquireDeviceSelectionDialog": ["00f28837-55dd-4f37-aaf5-6855a9640467"],
    "IPhotoAcquireItem": ["00f21c97-28bf-4c02-b842-5e4e90139a30"],
    "IPhotoAcquireOptionsDialog": ["00f2b3ee-bf64-47ee-89f4-4dedd79643f2"],
    "IPhotoAcquirePlugin": ["00f2dceb-ecb8-4f77-8e47-e7a987c83dd0"],
    "IPhotoAcquireProgressCB": ["00f2ce1e-935e-4248-892c-130f32c45cb4"],
    "IPhotoAcquireSettings": ["00f2b868-dd67-487c-9553-049240767e91"],
    "IPhotoAcquireSource": ["00f2c703-8613-4282-a53b-6ec59c5883ac"],
    "IPhotoCapturedEventArgs": ["373bfbc1-984e-4ff0-bf85-1c00aabc5a45"],
    "IPhotoConfirmationCapturedEventArgs": ["ab473672-c28a-4827-8f8d-3636d3beb51e"],
    "IPhotoConfirmationControl": ["c8f3f363-ff5e-4582-a9a8-0550f85a4a76"],
    "IPhotoImportDeleteImportedItemsFromSourceResult": ["f4e112f8-843d-428a-a1a6-81510292b0ae"],
    "IPhotoImportFindItemsResult": ["3915e647-6c78-492b-844e-8fe5e8f6bfb9"],
    "IPhotoImportFindItemsResult2": ["fbdd6a3b-ecf9-406a-815e-5015625b0a88"],
    "IPhotoImportImportItemsResult": ["e4d4f478-d419-4443-a84e-f06a850c0b00"],
    "IPhotoImportItem": ["a9d07e76-9bfc-43b8-b356-633b6a988c9e"],
    "IPhotoImportItem2": ["f1053505-f53b-46a3-9e30-3610791a9110"],
    "IPhotoImportItemImportedEventArgs": ["42cb2fdd-7d68-47b5-bc7c-ceb73e0c77dc"],
    "IPhotoImportManagerStatics": ["2771903d-a046-4f06-9b9c-bfd662e83287"],
    "IPhotoImportOperation": ["d9f797e4-a09a-4ee4-a4b1-20940277a5be"],
    "IPhotoImportSelectionChangedEventArgs": ["10461782-fa9d-4c30-8bc9-4d64911572d5"],
    "IPhotoImportSession": ["aa63916e-ecdb-4efe-94c6-5f5cafe34cfb"],
    "IPhotoImportSession2": ["2a526710-3ec6-469d-a375-2b9f4785391e"],
    "IPhotoImportSidecar": ["46d7d757-f802-44c7-9c98-7a71f4bc1486"],
    "IPhotoImportSource": ["1f8ea35e-145b-4cd6-87f1-54965a982fef"],
    "IPhotoImportSourceStatics": ["0528e586-32d8-467c-8cee-23a1b2f43e85"],
    "IPhotoImportStorageMedium": ["f2b9b093-fc85-487f-87c2-58d675d05b07"],
    "IPhotoImportVideoSegment": ["623c0289-321a-41d8-9166-8c62a333276c"],
    "IPhotoProgressActionCB": ["00f242d0-b206-4e7d-b4c1-4755bcbb9c9f"],
    "IPhotoProgressDialog": ["00f246f9-0750-4f08-9381-2cd8e906a4ae"],
    "IPhysicalLocation": ["dfe8c7eb-651b-11d2-92ce-080036af3f03"],
    "IPickerClosingDeferral": ["7af7f71e-1a67-4a31-ae80-e907708a619b"],
    "IPickerClosingEventArgs": ["7e59f224-b332-4f12-8b9f-a8c2f06b32cd"],
    "IPickerClosingOperation": ["4ce9fb84-beee-4e39-a773-fc5f0eae328d"],
    "IPickerConfirmedEventArgs": ["447a9b51-1e23-4779-992b-986849713941"],
    "IPickerController": ["0ed2ab50-c827-4cea-adc9-2d55083b8e67"],
    "IPickerControllerUIInititalization": ["c2c2bf29-6934-400e-b060-3e559a7a2611"],
    "IPickerFlyout": ["a336ffdb-08d9-43e6-944e-f2e5c7cee630"],
    "IPickerFlyoutBase": ["e33574ea-1076-44d1-9383-dc24ac5cff2a"],
    "IPickerFlyoutBaseFactory": ["7ec27a53-9502-4beb-b342-00566c8f16b0"],
    "IPickerFlyoutBaseOverrides": ["5bfc4f4a-4822-47b4-a958-77c20ba120d3"],
    "IPickerFlyoutBaseStatics": ["5a4d0ac5-89ae-40e5-a7f1-bb702355adf3"],
    "IPickerFlyoutPresenter": ["5884c978-6b27-4b38-a9ae-677c2994652e"],
    "IPickerFlyoutPresenterAutomationPeer": ["28414bf7-8382-4eae-93c1-d6f035aa8155"],
    "IPickerFlyoutStatics": ["af18a436-f38a-4abd-b933-6286c115b07f"],
    "IPickerInitializationInfo": ["22b2c3ad-27be-4d12-a397-55af0e673d00"],
    "IPickerInternal": ["75498f52-dbd6-430b-9062-14ac08383aa9"],
    "IPickerPrivateInitialization": ["4dc10e42-52e7-46da-8ae8-92a4e8afe20c"],
    "IPickerReturnedActivatedEventArgs": ["360defb9-a9d3-4984-a4ed-9ec734604921"],
    "IPicture2": ["f5185dd8-2012-4b0b-aad9-f052c6bd482b"],
    "IPicturePasswordTaskHandler": ["561eb2ba-0c5c-4a7a-8133-eeea23007e70"],
    "IPinChangedEventArgs": ["a2bf1db0-fc9c-4607-93d0-fa5e8343ee22"],
    "IPinConnection": ["4a9a62d3-27d4-403d-91e9-89f540e55534"],
    "IPinCount": ["5dadb7dc-a2cb-4540-a4a8-425ee4ae9051"],
    "IPinFlowControl": ["c56e9858-dbf3-4f6b-8119-384af2060deb"],
    "IPinLockStateCompletion": ["3b2481a7-aee9-462f-bd38-31f15c15ff88"],
    "IPinName": ["29cc9ab1-e89d-413c-b6b2-f6d50005d063"],
    "IPinToStartService": ["9b79841a-3f0e-4d72-bd22-97aab8476be1"],
    "IPinnedContactIdsQueryResult": ["7d9b2552-1579-4ddc-871f-a30a3aea9ba1"],
    "IPinnedContactManager": ["fcbc740c-e1d6-45c3-b8b6-a35604e167a0"],
    "IPinnedContactManagerStatics": ["f65ccc7e-fdf9-486a-ace9-bc311d0ae7f0"],
    "IPinnedList2": ["53d51c3c-d7e0-4fec-b4c6-33b4f8a41c64"],
    "IPinnedPeopleBroker": ["e4a8b8e3-e27c-4c08-975f-c74369505c4a"],
    "IPinnedPeopleUpdateSink": ["4e4c4660-183f-44e4-bb5c-f15453169b39"],
    "IPivot": ["103e9b13-3400-4a16-90b9-6912bf06974e"],
    "IPivot2": ["8b8a8660-1a55-411c-a82d-18991c3f0d6f"],
    "IPivot3": ["95bcbf96-f0da-4089-8c65-e8b81354c766"],
    "IPivotAutomationPeer": ["e715a8f8-3b9d-402c-81e2-6e912ef58981"],
    "IPivotAutomationPeerFactory": ["3efe0f94-0c91-4341-b9ac-1b56b4e6b84f"],
    "IPivotFactory": ["1b0a818e-2529-4762-ba44-9abc68c3ceca"],
    "IPivotHeaderItem": ["594572c2-82aa-410b-9e55-fd8e2c98862d"],
    "IPivotHeaderItemFactory": ["14308b37-185b-4117-bc77-dda2eb261b99"],
    "IPivotHeaderPanel": ["21484ebc-9241-4203-bd37-6c08fb096612"],
    "IPivotItem": ["a4764371-a502-47a3-915e-4aa096daf87f"],
    "IPivotItemAutomationPeer": ["1a4241ad-5d55-4d27-b40f-2d37506fbe78"],
    "IPivotItemAutomationPeerFactory": ["f2810471-183f-416b-b41a-1e5a958a91f4"],
    "IPivotItemDataAutomationPeer": ["a2a3b788-ea1d-48b7-88ee-f08b6aa07fee"],
    "IPivotItemDataAutomationPeerFactory": ["517a2480-d3b6-412e-82b6-94a0a84c13b0"],
    "IPivotItemEventArgs": ["1a6f7254-1ed5-4bc5-a060-655530bca6ba"],
    "IPivotItemFactory": ["0dced981-636e-4a34-8a3f-8ee018639285"],
    "IPivotItemStatics": ["e147ad0c-488b-4a6e-becd-a5dbd9941754"],
    "IPivotPanel": ["ad4ebe80-22a9-4ca3-9212-2773b6359ff3"],
    "IPivotStatics": ["ee22c7f4-c15d-4ff3-8a94-f50dfdfbe899"],
    "IPivotStatics2": ["d7518add-be75-4023-8deb-c6513c3192a3"],
    "IPivotStatics3": ["78b6274e-6616-4600-a039-922a5d09330b"],
    "IPixelDataProvider": ["dd831f25-185c-4595-9fb9-ccbe6ec18a6f"],
    "IPlaceContentLinkProvider": ["10348a4c-2366-41be-90c8-3258b53b5483"],
    "IPlaceInfo": ["9a0810b6-31c8-4f6a-9f18-950b4c38951a"],
    "IPlaceInfoCreateOptions": ["cd33c125-67f1-4bb3-9907-ecce939b0399"],
    "IPlaceInfoHelperStatics": ["dd1ca9a7-a9c6-491b-bc09-e80fcea48ee6"],
    "IPlaceInfoStatics": ["82b9ff71-6cd0-48a4-afd9-5ed82097936b"],
    "IPlaceInfoStatics2": ["730f0249-4047-44a3-8f81-2550a5216370"],
    "IPlaneProjection": ["e6f82bfa-6726-469a-b259-a5188347ca8f"],
    "IPlaneProjectionStatics": ["ad919c67-3bdc-4855-8969-d1f9a3adc27d"],
    "IPlatformDiagnosticActionsStatics": ["c1145cfa-9292-4267-890a-9ea3ed072312"],
    "IPlatformDiagnosticTraceInfo": ["f870ed97-d597-4bf7-88dc-cf5c7dc2a1d2"],
    "IPlatformDiagnosticTraceRuntimeInfo": ["3d4d5e2d-01d8-4768-8554-1eb1ca610986"],
    "IPlatformDiagnosticsAndUsageDataSettingsStatics": ["b6e24c1b-7b1c-4b32-8c62-a66597ce723a"],
    "IPlatformFileOperationBroker": ["e4cf33ae-c114-4ab3-af50-e56b48a7c806"],
    "IPlatformTelemetryClientStatics": ["9bf3f25d-d5c3-4eea-8dbe-9c8dbb0d9d8f"],
    "IPlatformTelemetryRegistrationResult": ["4d8518ab-2292-49bd-a15a-3d71d2145112"],
    "IPlatformTelemetryRegistrationSettings": ["819a8582-ca19-415e-bb79-9c224bfa3a73"],
    "IPlayReadyContentHeader": ["9a438a6a-7f4c-452e-88bd-0148c6387a2c"],
    "IPlayReadyContentHeader2": ["359c79f4-2180-498c-965b-e754d875eab2"],
    "IPlayReadyContentHeaderFactory": ["cb97c8ff-b758-4776-bf01-217a8b510b2c"],
    "IPlayReadyContentHeaderFactory2": ["d1239cf5-ae6d-4778-97fd-6e3a2eeadbeb"],
    "IPlayReadyContentResolver": ["fbfd2523-906d-4982-a6b8-6849565a7ce8"],
    "IPlayReadyDomain": ["adcc93ac-97e6-43ef-95e4-d7868f3b16a9"],
    "IPlayReadyDomainIterableFactory": ["4df384ee-3121-4df3-a5e8-d0c24c0500fc"],
    "IPlayReadyDomainJoinServiceRequest": ["171b4a5a-405f-4739-b040-67b9f0c38758"],
    "IPlayReadyDomainLeaveServiceRequest": ["062d58be-97ad-4917-aa03-46d4c252d464"],
    "IPlayReadyITADataGenerator": ["24446b8e-10b9-4530-b25b-901a8029a9b2"],
    "IPlayReadyIndividualizationServiceRequest": ["21f5a86b-008c-4611-ab2f-aaa6c69f0e24"],
    "IPlayReadyLicense": ["ee474c4e-fa3c-414d-a9f2-3ffc1ef832d4"],
    "IPlayReadyLicense2": ["30f4e7a7-d8e3-48a0-bcda-ff9f40530436"],
    "IPlayReadyLicenseAcquisitionServiceRequest": ["5d85ff45-3e9f-4f48-93e1-9530c8d58c3e"],
    "IPlayReadyLicenseAcquisitionServiceRequest2": ["b7fa5eb5-fe0c-b225-bc60-5a9edd32ceb5"],
    "IPlayReadyLicenseAcquisitionServiceRequest3": ["394e5f4d-7f75-430d-b2e7-7f75f34b2d75"],
    "IPlayReadyLicenseIterableFactory": ["d4179f08-0837-4978-8e68-be4293c8d7a6"],
    "IPlayReadyLicenseManagement": ["aaeb2141-0957-4405-b892-8bf3ec5dadd9"],
    "IPlayReadyLicenseSession": ["a1723a39-87fa-4fdd-abbb-a9720e845259"],
    "IPlayReadyLicenseSession2": ["4909be3a-3aed-4656-8ad7-ee0fd7799510"],
    "IPlayReadyLicenseSessionFactory": ["62492699-6527-429e-98be-48d798ac2739"],
    "IPlayReadyMeteringReportServiceRequest": ["c12b231c-0ecd-4f11-a185-1e24a4a67fb7"],
    "IPlayReadyRevocationServiceRequest": ["543d66ac-faf0-4560-84a5-0e4acec939e4"],
    "IPlayReadySecureStopIterableFactory": ["5f1f0165-4214-4d9e-81eb-e89f9d294aee"],
    "IPlayReadySecureStopServiceRequest": ["b5501ee5-01bf-4401-9677-05630a6a4cc8"],
    "IPlayReadySecureStopServiceRequestFactory": ["0e448ac9-e67e-494e-9f49-6285438c76cf"],
    "IPlayReadyServiceRequest": ["8bad2836-a703-45a6-a180-76f3565aa725"],
    "IPlayReadySoapMessage": ["b659fcb5-ce41-41ba-8a0d-61df5fffa139"],
    "IPlayReadyStatics": ["5e69c00d-247c-469a-8f31-5c1a1571d9c6"],
    "IPlayReadyStatics2": ["1f8d6a92-5f9a-423e-9466-b33969af7a3d"],
    "IPlayReadyStatics3": ["3fa33f71-2dd3-4bed-ae49-f7148e63e710"],
    "IPlayReadyStatics4": ["50a91300-d824-4231-9d5e-78ef8844c7d7"],
    "IPlayReadyStatics5": ["230a7075-dfa0-4f8e-a779-cefea9c6824b"],
    "IPlayToControl": ["607574eb-f4b6-45c1-b08c-cb715122901d"],
    "IPlayToControlWithCapabilities": ["aa9dd80f-c50a-4220-91c1-332287f82a34"],
    "IPlayToManagerInterop": ["24394699-1f2c-4eb3-8cd7-0ec1da42a540"],
    "IPlayToObjectSite": ["30510863-98b5-11cf-bb82-00aa00bdce0b"],
    "IPlayToObjectSite2": ["9ce8c290-e397-4cd2-acc1-68acd9ae0756"],
    "IPlayToReceiver": ["ac15cf47-a162-4aa6-af1b-3aa35f3b9069"],
    "IPlayToSource": ["95c8147f-90f8-4558-b69e-3ce897533f46"],
    "IPlayToSourceClassFactory": ["842b32a3-9b9b-4d1c-b3f3-49193248a554"],
    "IPlayToSourceGetMediaEngine": ["68cff3ba-766c-451c-afc5-2cdbee2bd542"],
    "IPlaybackInfoChangedEventArgs": ["786756c2-bc0d-50a5-8807-054291fef139"],
    "IPlaybackMediaMarker": ["c4d22f5c-3c1c-4444-b6b9-778b0422d41a"],
    "IPlaybackMediaMarkerFactory": ["8c530a78-e0ae-4e1a-a8c8-e23f982a937b"],
    "IPlaybackMediaMarkerReachedEventArgs": ["578cd1b9-90e2-4e60-abc4-8740b01f6196"],
    "IPlaybackMediaMarkerSequence": ["f2810cee-638b-46cf-8817-1d111fe9d8c4"],
    "IPlaybackPositionChangeRequestedEventArgs": ["b4493f88-eb28-4961-9c14-335e44f3e125"],
    "IPlaybackRateChangeRequestedEventArgs": [
        "0f5661ae-2c88-4cca-8540-d586095d13a5",
        "2ce2c41f-3cd6-4f77-9ba7-eb27c26a2140",
    ],
    "IPlaylist": ["803736f5-cf44-4d97-83b3-7a089e9ab663"],
    "IPlaylistStatics": ["c5c331cd-81f9-4ff3-95b9-70b6ff046b68"],
    "IPlmActivationControl": ["38523d01-2f9c-43d4-ad90-678930bbf382"],
    "IPlmApplicationControl": ["69987202-443e-4fd2-845e-b8e8cf4237ec"],
    "IPlmDataQuery": ["2f3eca0f-a0a7-445b-8f88-f6260a7dac04"],
    "IPlmPackageServicing": ["36c8be08-bca4-4431-b5c0-b07bc0baf3c8"],
    "IPlmStateChangeNotifications": ["e12fe107-2d78-46a1-bca8-d93e4c2ab2bc"],
    "IPlmSuspendControl": ["33c255c3-1a86-45fc-9498-f60d8f56b9d3"],
    "IPlugin": ["b05651c4-9b10-425e-b616-1fcd828db3b1"],
    "IPlugin2": ["b05651c5-9b10-425e-b616-1fcd828db3b1"],
    "IPluginManager": ["c7310558-ac80-11d1-8df3-00c04fb6ef4f"],
    "IPlugins": ["b05651c3-9b10-425e-b616-1fcd828db3b1"],
    "IPnpCallback": ["27c32374-cc45-4840-857e-8e5ef7c0ebff"],
    "IPnpCallbackHardware": ["51433bd3-c7c1-4bd8-b4c1-ab1e034626cc"],
    "IPnpCallbackHardware2": ["1493cd1b-c546-46bb-bf47-b27465093393"],
    "IPnpCallbackHardwareInterrupt": ["3856fef1-a858-41fd-9be4-fa90010999b1"],
    "IPnpCallbackRemoteInterfaceNotification": ["f9d48f27-bdbe-4a96-af96-0e53e2a436ec"],
    "IPnpCallbackSelfManagedIo": ["d1c9ca4c-46aa-46f8-bd8c-6ca9deb13340"],
    "IPnpNotificationClient": ["11baae68-d8ee-45b4-b541-97d517a6f57a"],
    "IPnpObject": ["95c66258-733b-4a8f-93a3-db078ac870c1"],
    "IPnpObjectStatics": ["b3c32a3d-d168-4660-bbf3-a733b14b6e01"],
    "IPnpObjectUpdate": ["6f59e812-001e-4844-bcc6-432886856a17"],
    "IPnpObjectWatcher": ["83c95ca8-4772-4a7a-aca8-e48c42a89c44"],
    "IPointAnimation": ["30f04312-7726-4f88-b8e2-2fa54518963b"],
    "IPointAnimationStatics": ["2f99b356-e737-408b-a0fd-327826d32255"],
    "IPointAnimationUsingKeyFrames": ["9b944f72-446a-41d0-a129-41a620f4595d"],
    "IPointAnimationUsingKeyFramesStatics": ["5f454c87-2390-46ea-baa7-762f4bc30d04"],
    "IPointHelper": ["727bdd92-64b0-49cf-a321-a9793e73e2e7"],
    "IPointHelperStatics": ["015aca75-76d8-4b7e-8a33-7d79204691ee"],
    "IPointKeyFrame": ["fcc88d01-7f82-4dae-8026-7b7e086878b3"],
    "IPointKeyFrameFactory": ["cb214bdf-426a-4392-8355-c2ae52852623"],
    "IPointKeyFrameStatics": ["95cf1b27-7965-4bec-b9fb-fbe94b65518e"],
    "IPointLight": ["b18545b3-0c5a-4ab0-bedc-4f3546948272"],
    "IPointLight2": ["efe98f2c-0678-4f69-b164-a810d995bcb7"],
    "IPointLight3": ["4c0a8367-d4e9-468a-87ae-7ba43ab29485"],
    "IPointerDevice": ["93c9bafc-ebcb-467e-82c6-276feae36b5a"],
    "IPointerDevice2": ["f8a6d2a0-c484-489f-ae3e-30d2ee1ffd3e"],
    "IPointerDeviceStatics": ["d8b89aa1-d1c6-416e-bd8d-5790914dc563"],
    "IPointerDownThemeAnimation": ["b58e714e-c49d-4788-a233-0ae85d99dd5a"],
    "IPointerDownThemeAnimationStatics": ["63a7cb7b-6d46-4494-b94a-e72f3b492a61"],
    "IPointerEventArgs": ["920d9cb1-a5fc-4a21-8c09-49dfe6ffe25f"],
    "IPointerEventHandler": ["e4385929-c004-4bcf-8970-359486e39f88"],
    "IPointerPoint": ["e995317d-7296-42d9-8233-c5be73b74a4a"],
    "IPointerPointProperties": ["c79d8a4b-c163-4ee7-803f-67ce79f9972d"],
    "IPointerPointProperties2": ["22c3433a-c83b-41c0-a296-5e232d64d6af"],
    "IPointerPointStatics": ["a506638d-2a1a-413e-bc75-9f38381cc069"],
    "IPointerPointTransform": ["4d5fe14f-b87c-4028-bc9c-59e9947fb056"],
    "IPointerRoutedEventArgs": ["da628f0a-9752-49e2-bde2-49eccab9194d"],
    "IPointerRoutedEventArgs2": ["0821f294-1de6-4711-ba7c-8d4b8b0911d0"],
    "IPointerUpThemeAnimation": ["e9e9d07d-6340-4828-ad12-690694b9910b"],
    "IPointerUpThemeAnimationStatics": ["7c618f9c-7992-4139-8bfc-0883b9727a7e"],
    "IPointerVisualizationSettings": ["4d1e6461-84f7-499d-bd91-2a36e2b7aaa2"],
    "IPointerVisualizationSettingsStatics": ["68870edb-165b-4214-b4f3-584eca8c8a69"],
    "IPolicyAsync": ["000001cd-0000-0000-c000-000000000046"],
    "IPolicyMaker": ["000001c4-0000-0000-c000-000000000046"],
    "IPolicyQualifier": ["728ab31c-217d-11da-b2a4-000e7bbb2b09"],
    "IPolicyQualifiers": ["728ab31d-217d-11da-b2a4-000e7bbb2b09"],
    "IPolicySet": ["000001c3-0000-0000-c000-000000000046"],
    "IPolyBezierSegment": ["36805271-38c4-4bcf-96cd-028a6d38af25"],
    "IPolyBezierSegmentStatics": ["1d91a6da-1492-4acc-bd66-a496f3d829d6"],
    "IPolyLineSegment": ["4b397f87-a2e6-479d-bdc8-6f4464646887"],
    "IPolyLineSegmentStatics": ["d64a2c87-33f1-4e70-a47f-b4981ef648a2"],
    "IPolyQuadraticBezierSegment": ["dd5ced7d-e6db-4c96-b6a1-3fce96e987a6"],
    "IPolyQuadraticBezierSegmentStatics": ["fdf5eb75-7ad5-4c89-8169-8c9786abd9eb"],
    "IPolygon": ["e3755c19-2e4d-4bcc-8d34-86871957fa01"],
    "IPolygonStatics": ["362a8aab-d463-4366-9e1a-beba72810fb7"],
    "IPolyline": ["91dc62f8-42b3-47f3-8476-c55124a7c4c6"],
    "IPolylineStatics": ["c7aa2cd1-a26c-43b0-aaa5-822fa64a11b9"],
    "IPolymorphicFileSystemHandler": ["0dcf38ce-7728-438f-9b9a-56fbdaca74cc"],
    "IPopInThemeAnimation": ["196938c1-1c07-4c28-8847-f9f055b32855"],
    "IPopInThemeAnimationStatics": ["efaa99d3-218a-4701-977f-f1bfae8ba649"],
    "IPopOutThemeAnimation": ["4786ab49-0e48-4e81-a2e5-cc5aa19e48d3"],
    "IPopOutThemeAnimationStatics": ["1d492c09-03c1-4490-99dc-909feab357fb"],
    "IPopup": ["62418240-e6d3-4705-a1dc-39156456ee29"],
    "IPopup2": ["376a8c4c-aac0-4b20-966a-0b9364feb4b5"],
    "IPopup3": ["f9c46915-a65c-5f68-9f54-310a1b51095f"],
    "IPopupBase": ["4c747ac4-149c-46f6-b313-3f25e22ef67e"],
    "IPopupCommand": ["4452ce09-0488-4ca7-a896-c4f140907549"],
    "IPopupCommandHandler": ["4da31a12-cc32-49bc-b2cc-060dbcf2bafc"],
    "IPopupEventHandler": ["9e6d89ee-4752-465f-8001-9c7193ee62a0"],
    "IPopupKeyboardVisibilityEventHandler": ["570e8c4e-4ffc-42ff-97ee-e65f1ecd8ef9"],
    "IPopupMenu": ["4e9bc6dc-880d-47fc-a0a1-72b639e62559"],
    "IPopupStatics": ["5ae3bf1a-6e34-40d6-8a7f-ca822aaf59e3"],
    "IPopupStatics2": ["2b9ae9ec-55ef-43b6-b459-12e40ffa4302"],
    "IPopupStatics3": ["00789589-c580-558f-945a-7d02ee004d3e"],
    "IPopupThemeTransition": ["47843552-4283-545e-c791-268dca22ce4b"],
    "IPopupThemeTransitionStatics": ["e5a1640e-490d-1505-9f6b-8fafc044dec5"],
    "IPort": ["b4c90a25-5791-11d0-86f9-00a0c911b544"],
    "IPortClsEtwHelper": ["80ef6667-e8b1-4252-ab09-8f6d5ebbd19f"],
    "IPortClsNotifications": ["1e092ce2-db25-483b-8446-b0961215258b"],
    "IPortClsPnp": ["0485791b-17f5-4b73-902a-20344860b9ca"],
    "IPortClsPower": ["47ba0351-bc4b-4869-8134-b74fe17852d8"],
    "IPortClsRuntimePower": ["e057c351-0430-4dbc-b172-c711d40a2373"],
    "IPortClsStreamResourceManager": ["e1cd9915-cab1-4103-bb2f-7dc09c9be942"],
    "IPortClsStreamResourceManager2": ["0d500bae-d565-469d-a0e2-f283760d7148"],
    "IPortClsSubdeviceEx": ["c3d5e80c-7f55-40c5-88b2-6210d0cb2b59"],
    "IPortClsVersion": ["7d89a7bb-869b-4567-8dbe-1e168cc853de"],
    "IPortDMus": ["c096df9c-fb09-11d1-81b0-0060083316c1", "c096df9c-fb09-11d1-81b0-0060083316c1"],
    "IPortEvents": ["a80f29c4-5498-11d2-95d9-00c04fb925d3"],
    "IPortMidi": ["b4c90a40-5791-11d0-86f9-00a0c911b544"],
    "IPortTopology": ["b4c90a30-5791-11d0-86f9-00a0c911b544"],
    "IPortWMIRegistration": ["d80b18e7-804c-4e1e-82d3-2461ec06e7c7"],
    "IPortWaveCyclic": ["b4c90a26-5791-11d0-86f9-00a0c911b544"],
    "IPortWavePci": ["b4c90a50-5791-11d0-86f9-00a0c911b544"],
    "IPortWavePciStream": ["b4c90a51-5791-11d0-86f9-00a0c911b544"],
    "IPortWaveRT": ["339ff909-68a9-4310-b09b-274e96ee4cbd"],
    "IPortWaveRTStream": ["1809ce5a-64bc-4e62-bd7d-95bce43de393"],
    "IPortableDevice": ["625e2df8-6392-4cf0-9ad1-3cfa5f17775c"],
    "IPortableDeviceCapabilities": ["2c8c6dbf-e3dc-4061-becc-8542e810d126"],
    "IPortableDeviceClassExtension": ["bc08386a-9952-40cd-ba50-9541d64a4b4e"],
    "IPortableDeviceConnector": ["625e2df8-6392-4cf0-9ad1-3cfa5f17775c"],
    "IPortableDeviceContent": ["6a96ed84-7c73-4480-9938-bf5af477d426"],
    "IPortableDeviceContent2": ["9b4add96-f6bf-4034-8708-eca72bf10554"],
    "IPortableDeviceDataStream": ["88e04db3-1012-4d64-9996-f703a950d3f4"],
    "IPortableDeviceDispatchFactory": ["5e1eafc3-e3d7-4132-96fa-759c0f9d1e0f"],
    "IPortableDeviceEventCallback": ["a8792a31-f385-493c-a893-40f64eb45f6e"],
    "IPortableDeviceKeyCollection": ["dada2357-e0ad-492e-98db-dd61c53ba353"],
    "IPortableDeviceManager": ["a1567595-4c2f-4574-a6fa-ecef917b9a40"],
    "IPortableDevicePropVariantCollection": ["89b2e422-4f1b-4316-bcef-a44afea83eb3"],
    "IPortableDeviceProperties": ["7f6d695c-03df-4439-a809-59266beee3a6"],
    "IPortableDevicePropertiesBulk": ["482b05c0-4056-44ed-9e0f-5e23b009da93"],
    "IPortableDevicePropertiesBulkCallback": ["9deacb80-11e8-40e3-a9f3-f557986a7845"],
    "IPortableDeviceResources": ["fd8878ac-d841-4d17-891c-e6829cdb6934"],
    "IPortableDeviceService": ["d3bd3a44-d7b5-40a9-98b7-2fa4d01dec08"],
    "IPortableDeviceServiceActivation": ["e56b0534-d9b9-425c-9b99-75f97cb3d7c8"],
    "IPortableDeviceServiceCapabilities": ["24dbd89d-413e-43e0-bd5b-197f3c56c886"],
    "IPortableDeviceServiceManager": ["a8abc4e9-a84a-47a9-80b3-c5d9b172a961"],
    "IPortableDeviceServiceMethodCallback": ["c424233c-afce-4828-a756-7ed7a2350083"],
    "IPortableDeviceServiceMethods": ["e20333c9-fd34-412d-a381-cc6f2d820df7"],
    "IPortableDeviceServiceOpenCallback": ["bced49c8-8efe-41ed-960b-61313abd47a9"],
    "IPortableDeviceUnitsStream": ["5e98025f-bfc4-47a2-9a5f-bc900a507c67"],
    "IPortableDeviceValues": ["6848f6f2-3155-4f86-b6f5-263eeeab3143"],
    "IPortableDeviceValuesCollection": ["6e3f2d79-4e07-48c4-8208-d8c2e5af4a99"],
    "IPortableDeviceWebControl": ["94fc7953-5ca1-483a-8aee-df52e7747d00"],
    "IPosPrinter": ["2a03c10e-9a19-4a01-994f-12dfad6adcbf"],
    "IPosPrinter2": ["248475e8-8b98-5517-8e48-760e86f68987"],
    "IPosPrinterCapabilities": ["cde95721-4380-4985-adc5-39db30cd93bc"],
    "IPosPrinterCharacterSetIdsStatics": ["5c709eff-709a-4fe7-b215-06a748a38b39"],
    "IPosPrinterFontProperty": ["a7f4e93a-f8ac-5f04-84d2-29b16d8a633c"],
    "IPosPrinterJob": ["9a94005c-0615-4591-a58f-30f87edfe2e4"],
    "IPosPrinterPrintOptions": ["0a2e16fd-1d02-5a58-9d59-bfcde76fde86"],
    "IPosPrinterReleaseDeviceRequestedEventArgs": ["2bcba359-1cef-40b2-9ecb-f927f856ae3c"],
    "IPosPrinterStatics": ["8ce0d4ea-132f-4cdf-a64a-2d0d7c96a85b"],
    "IPosPrinterStatics2": ["eecd2c1c-b0d0-42e7-b137-b89b16244d41"],
    "IPosPrinterStatus": ["d1f0c730-da40-4328-bf76-5156fa33b747"],
    "IPosPrinterStatusUpdatedEventArgs": ["2edb87df-13a6-428d-ba81-b0e7c3e5a3cd"],
    "IPositionChangedEventArgs": ["37859ce5-9d1e-46c5-bf3b-6ad8cac1a093"],
    "IPositionInfoCompletion": ["03569923-a28f-47bd-9315-38d8fb11717d"],
    "IPostMessageFromScriptMSAppView": ["30510860-9860-11cf-bb82-00aa00bdce0b"],
    "IPowerCplApi": ["278c33b5-a0e9-4cf7-a4b6-3ce41f94fcd6"],
    "IPowerEase": ["69c80579-eedf-405b-8680-d9606880c937"],
    "IPowerEaseStatics": ["a5955103-91a2-460c-9c41-d28f6a939bda"],
    "IPowerManagerStatics": ["1394825d-62ce-4364-98d5-aa28c7fbd15b"],
    "IPowerNotify": ["3dd648b8-969f-11d1-95a9-00c04fb925d3"],
    "IPowerPolicyCallbackWakeFromS0": ["7ee9f0fa-5a1a-48df-a35e-8db42f519b66"],
    "IPowerPolicyCallbackWakeFromSx": ["3ab1426d-689c-4220-901e-03c6d909b5f5"],
    "IPowerStateChange": ["0e7d938e-d7fb-49a4-8cac-4db70d952c03"],
    "IPowrProfApi": ["5bff4e01-d379-4050-a382-c6504a980d46"],
    "IPreBinding": ["0ddb6f46-82f6-4d1b-8017-4b4535341918"],
    "IPreBindingSupport": ["dc8c6098-d9fc-406a-bb3e-44ecef436847"],
    "IPreFetchOffset": ["7000f480-ed44-4e8b-b38a-412f8d7a504d"],
    "IPreNavigationContext": ["2449e3e6-f3a2-4c94-a5cf-fcea147bb128"],
    "IPreallocatedWorkItem": ["b6daa9fc-bc5b-401a-a8b2-6e754d14daa6"],
    "IPreallocatedWorkItemFactory": ["e3d32b45-dfea-469b-82c5-f6e3cefdeafb"],
    "IPreferPropertyPagesWithTreeControl": ["03aefcea-62a9-4606-8e17-7cb0fc13d5e0"],
    "IPreferredRuntimeTypeConcept": ["9d6c1d7b-a76f-4618-8068-5f76bd9a4e8a"],
    "IPrelaunchActivatedEventArgs": ["0c44717b-19f7-48d6-b046-cf22826eaa74"],
    "IPrepareInfo": ["80c7bfd0-87ee-11ce-8081-0080c758527e"],
    "IPrepareInfo2": ["5fab2547-9779-11d1-b886-00c04fb9618a"],
    "IPrepareTranscodeResult": ["05f25dce-994f-4a34-9d68-97ccce1730d6"],
    "IPrepareUserOOBETask": ["4566d31c-0a79-4a61-aa8a-9df6c80b9937"],
    "IPreparedOwnerDrawPopup": ["edd019a1-dd0d-422f-9915-66e7c244bc81"],
    "IPreviewBuildsManager": ["fa07dd61-7e4f-59f7-7c9f-def9051c5f62"],
    "IPreviewBuildsManagerStatics": ["3e422887-b112-5a70-7da1-97d78d32aa29"],
    "IPreviewBuildsState": ["a2f2903e-b223-5f63-7546-3e8eac070a2e"],
    "IPreviewHandler": ["8895b1c6-b41f-4c1c-a562-0d564250836f"],
    "IPreviewHandlerFrame": ["fec87aaf-35f9-447a-adb7-20234491401a"],
    "IPreviewHandlerVisuals": ["196bf9a5-b346-4ef0-aa1e-5dcdb76768b1"],
    "IPreviewHost": ["10d3a76c-dee7-413a-9654-e56cb31ec7d1"],
    "IPreviewHostCallback": ["7a77ffe8-53ba-4a10-be4f-255489a49451"],
    "IPreviewItem": ["36149969-0a8f-49c8-8b00-4aecb20222fb"],
    "IPreviousSetAndState": ["75857678-e107-4273-af75-d2b6e5a0911b"],
    "IPreviousVersionsInfo": ["76e54780-ad74-48e3-a695-3ba9a0aff10d"],
    "IPreviousVersionsUpdate": ["ff8c9b9c-c90f-4f30-b5b2-77c3d56bd125"],
    "IPrincipal": ["d98d51e5-c9b4-496a-a9c1-18980261cf0f"],
    "IPrincipal2": ["248919ae-e345-4a6d-8aeb-e0d3165c904e"],
    "IPrint3DDevice": ["041c3d19-9713-42a2-9813-7dc3337428d3"],
    "IPrint3DDeviceStatics": ["fde3620a-67cd-41b7-a344-5150a1fd75b5"],
    "IPrint3DFlowBroker": ["7b767303-5d81-4c25-a817-45373b77ec9e"],
    "IPrint3DManager": ["4d2fcb0a-7366-4971-8bd5-17c4e3e8c6c0"],
    "IPrint3DManagerStatics": ["0ef1cafe-a9ad-4c08-a917-1d1f863eabcb"],
    "IPrint3DTask": ["8ce3d080-2118-4c28-80de-f426d70191ae"],
    "IPrint3DTaskCompletedEventArgs": ["cc1914af-2614-4f1d-accc-d6fc4fda5455"],
    "IPrint3DTaskRequest": ["2595c46f-2245-4c5a-8731-0d604dc6bc3c"],
    "IPrint3DTaskRequestedEventArgs": ["150cb77f-18c5-40d7-9f40-fab3096e05a9"],
    "IPrint3DTaskSourceChangedEventArgs": ["5bcd34af-24e9-4c10-8d07-14c346ba3fcf"],
    "IPrint3DTaskSourceRequestedArgs": ["c77c9aba-24af-424d-a3bf-92250c355602"],
    "IPrint3DTaskSourceRequestedHandler": ["e9175e70-c917-46de-bb51-d9a94db3711f"],
    "IPrint3DWorkflow": ["c56f74bd-3669-4a66-ab42-c8151930cd34"],
    "IPrint3DWorkflow2": ["a2a6c54f-8ac1-4918-9741-e34f3004239e"],
    "IPrint3DWorkflowActivatedEventArgs": ["3f57e78b-f2ac-4619-8302-ef855e1c9b90"],
    "IPrint3DWorkflowPrintRequestedEventArgs": ["19f8c858-5ac8-4b55-8a5f-e61567dafb4d"],
    "IPrint3DWorkflowPrinterChangedEventArgs": ["45226402-95fc-4847-93b3-134dbf5c60f7"],
    "IPrintAsyncNotify": ["532818f7-921b-4fb2-bff8-2f4fd52ebebf"],
    "IPrintAsyncNotifyCallback": ["7def34c1-9d92-4c99-b3b3-db94a9d4191b"],
    "IPrintAsyncNotifyChannel": ["4a5031b1-1f3f-4db0-a462-4530ed8b0451"],
    "IPrintAsyncNotifyDataObject": ["77cf513e-5d49-4789-9f30-d0822b335c0d"],
    "IPrintAsyncNotifyRegistration": ["0f6f27b6-6f86-4591-9203-64c3bfadedfe"],
    "IPrintBindingOptionDetails": ["c3f4cc98-9564-4f16-a055-a98b9a49e9d3"],
    "IPrintBorderingOptionDetails": ["4d73bc8f-fb53-4eb2-985f-1d91de0b7639"],
    "IPrintClassObjectFactory": ["9af593dd-9b02-48a8-9bad-69ace423f88b"],
    "IPrintCollationOptionDetails": ["d6abb166-a5a6-40dc-acc3-739f28f1e5d3"],
    "IPrintColorModeOptionDetails": ["dba97704-f1d6-4843-a484-9b447cdcf3b6"],
    "IPrintConnectedBufferState": ["4ba60553-fef6-4806-af71-4ccff69a2a5d"],
    "IPrintCopiesOptionDetails": ["42053099-4339-4343-898d-2c47b5e0c341"],
    "IPrintCoreHelper": ["a89ec53e-3905-49c6-9c1a-c0a88117fdb6"],
    "IPrintCoreHelperPS": ["c2c14f6f-95d3-4d63-96cf-6bd9e6c907c2"],
    "IPrintCoreHelperUni": ["7e8e51d6-e5ee-4426-817b-958b9444eb79"],
    "IPrintCoreHelperUni2": ["6c8afdfc-ead0-4d2d-8071-9bf0175a6c3a"],
    "IPrintCorePS2": ["cdbb0b0b-a917-40d7-9fbf-483b3be7ef22"],
    "IPrintCoreUI2": ["085ccfca-3adf-4c9e-b491-d851a6edc997"],
    "IPrintCustomItemDetails": ["5704b637-5c3a-449a-aa36-b3291b1192fd"],
    "IPrintCustomItemListOptionDetails": ["a5fafd88-58f2-4ebd-b90f-51e4f2944c5d"],
    "IPrintCustomItemListOptionDetails2": ["c9d6353d-651c-4a39-906e-1091a1801bf1"],
    "IPrintCustomItemListOptionDetails3": ["4fa1b53f-3c34-4868-a407-fc5eab259b21"],
    "IPrintCustomOptionDetails": ["e32bde1c-28af-4b90-95da-a3acf320b929"],
    "IPrintCustomTextOptionDetails": ["2ad171f8-c8bd-4905-9192-0d75136e8b31"],
    "IPrintCustomTextOptionDetails2": ["cea70b54-b977-4718-8338-7ed2b0d86fe3"],
    "IPrintCustomToggleOptionDetails": ["9db4d514-e461-4608-8ee9-db6f5ed073c6"],
    "IPrintDirectSpoolFileAccess": ["811557ea-96d7-46ae-92ad-08089d81459a"],
    "IPrintDocument": ["e44327c3-a999-485b-b1d8-72dc517821e6"],
    "IPrintDocumentFactory": ["fb87b18f-2606-4a2f-99d4-a7cdbc35d7c7"],
    "IPrintDocumentPackageStatusEvent": ["ed90c8ad-5c34-4d05-a1ec-0e8a9b3ad7af"],
    "IPrintDocumentPackageTarget": ["1b8efec4-3019-4c27-964e-367202156906"],
    "IPrintDocumentPackageTargetFactory": ["d2959bf7-b31b-4a3d-9600-712eb1335ba4"],
    "IPrintDocumentPageSource": ["a96bb1db-172e-4667-82b5-ad97a252318f"],
    "IPrintDocumentSource": ["dedc0c30-f1eb-47df-aae6-ed5427511f01"],
    "IPrintDocumentStatics": ["fd970a3c-b152-49e0-a6bd-6aa6477e43c7"],
    "IPrintDuplexOptionDetails": ["fcd94591-d4a4-44fa-b3fe-42e0ba28d5ad"],
    "IPrintExtensionContextStatic": ["e70d9fc1-ff79-4aa4-8c9b-0c93aedfde8a"],
    "IPrintFilterFinishCallback": ["c8c09a6a-94a6-4ce9-9708-50e546102d92"],
    "IPrintFilterSequence": ["1132ae07-c7f4-4b6c-b8ab-21da59eba141"],
    "IPrintFilterSequenceFactoryX": ["49aa4218-38a2-4ac8-93ea-290a387a6522"],
    "IPrintFlowBroker": ["db3a076b-8419-4719-9904-a0c0fdf2ee3f"],
    "IPrintHolePunchOptionDetails": ["a6de1f18-482c-4657-9d71-8ddddbea1e1e"],
    "IPrintItemListOptionDetails": ["9a2257bf-fe61-43d8-a24f-a3f6ab7320e7"],
    "IPrintJob": ["b771dab8-1282-41b7-858c-f206e4d20577"],
    "IPrintJobCollection": ["72b82a24-a598-4e87-895f-cdb23a49e9dc"],
    "IPrintManager": ["ff2a9694-8c99-44fd-ae4a-19d9aa9a0f0a"],
    "IPrintManagerEventHandler": ["d2e11572-b3d8-4218-8320-b49c6b2e19cc"],
    "IPrintManagerInterop": ["c5435a42-8d43-4e7b-a68a-ef311e392087"],
    "IPrintManagerOptions": ["49944775-f997-4e3c-b83f-3abb4fad387d"],
    "IPrintManagerStatic": ["58185dcd-e634-4654-84f0-e0152a8217ac"],
    "IPrintManagerStatic2": ["35a99955-e6ab-4139-9abd-b86a729b3598"],
    "IPrintManagerTemplatePrinter": ["f633be14-9eff-4c4d-929e-05717b21b3e6"],
    "IPrintManagerTemplatePrinter2": ["c6403497-7493-4f09-8016-54b03e9bda69"],
    "IPrintMediaSizeOptionDetails": ["6c8d5bcf-c0bf-47c8-b84a-628e7d0d1a1d"],
    "IPrintMediaTypeOptionDetails": ["f8c7000b-abf3-4abc-8e86-22abc5744a43"],
    "IPrintNotificationEventDetails": ["e00e4c8a-4828-4da1-8bb8-8672df8515e7"],
    "IPrintNumberOptionDetails": ["4d01bbaf-645c-4de9-965f-6fc6bbc47cab"],
    "IPrintOemCommon": ["7f42285e-91d5-11d1-8820-00c04fb961ec"],
    "IPrintOemDriverPS": ["d90060c7-8e1a-11d1-881f-00c04fb961ec"],
    "IPrintOemDriverUI": ["92b05d50-78bc-11d1-9480-00a0c90640b8"],
    "IPrintOemDriverUni": ["d67ebbf1-78bf-11d1-9480-00a0c90640b8"],
    "IPrintOemEngine": ["63d17590-91d8-11d1-8820-00c04fb961ec"],
    "IPrintOemPS": ["688342b5-8e1a-11d1-881f-00c04fb961ec"],
    "IPrintOemPS2": ["becf7f34-51b3-46c9-8a1c-18679bd21f36"],
    "IPrintOemPrintTicketProvider": ["bcf5e011-f60a-49ff-ab2f-e06f4abdf281"],
    "IPrintOemUI": ["c6a7a9d0-774c-11d1-947f-00a0c90640b8"],
    "IPrintOemUI2": ["292515f9-b54b-489b-9275-bab56821395e"],
    "IPrintOemUIMXDC": ["7349d725-e2c1-4dca-afb5-c13e91bc9306"],
    "IPrintOemUni": ["d67ebbf0-78bf-11d1-9480-00a0c90640b8"],
    "IPrintOemUni2": ["b91220ac-15cc-4e7a-a21e-9591f34d6f6c"],
    "IPrintOemUni3": ["4e4a7747-bc76-4aed-acc8-c76af22aad43"],
    "IPrintOptionDetails": ["390686cf-d682-495f-adfe-d7333f5c1808"],
    "IPrintOrientationOptionDetails": ["46c38879-66e0-4da0-87b4-d25457824eb7"],
    "IPrintPageInfo": ["dd4be9c9-a6a1-4ada-930e-da872a4f23d3"],
    "IPrintPageRange": ["f8a06c54-6e7c-51c5-57fd-0660c2d71513"],
    "IPrintPageRangeFactory": ["408fd45f-e047-5f85-7129-fb085a4fad14"],
    "IPrintPageRangeOptionDetails": ["5a19e4b7-2be8-4aa7-9ea5-defbe8713b4e"],
    "IPrintPageRangeOptions": ["ce6db728-1357-46b2-a923-79f995f448fc"],
    "IPrintPipelineDoneNotify": ["3286bc23-43cd-43f9-9d75-efa9d1815878"],
    "IPrintPipelineFilter": ["cdb62fc0-8bed-434e-86fb-a2cae55f19ea"],
    "IPrintPipelineManager": ["cd281a82-6042-44b5-b4f9-0e2b651c0384"],
    "IPrintPipelineManagerControl": ["aa3e4910-5889-4681-91ef-823ad4ed4e44"],
    "IPrintPipelineManagerX": ["fc5130ab-a341-428d-88f5-c79ac13954e8"],
    "IPrintPipelineProgressReport": ["edc12c7c-ed40-4ea5-96a6-5e4397497a61"],
    "IPrintPipelinePropertyBag": ["8b8c99dc-7892-4a95-8a04-57422e9fbb47"],
    "IPrintPipelinePropertyBagX": ["9116d344-f828-4fd0-9d00-53db261a7833"],
    "IPrintPreviewDxgiPackageTarget": ["1a6dd0ad-1e2a-4e99-a5ba-91f17818290e"],
    "IPrintPreviewPageCollection": ["0b31cc62-d7ec-4747-9d6e-f2537d870f2b"],
    "IPrintProcessorExecute": ["c9ba64a5-e56d-453f-ac64-7a6dff796579"],
    "IPrintProcessorQuery": ["510c4e33-05d5-438b-9852-e8406eff033d"],
    "IPrintQualityOptionDetails": ["2dd06ba1-ce1a-44e6-84f9-3a92ea1e3044"],
    "IPrintQueueDT": ["a27271fd-176d-4c34-8fdb-326dc79c6b78"],
    "IPrintReadStream": ["4d47a67c-66cc-4430-850e-daf466fe5bc4"],
    "IPrintReadStreamFactory": ["acb971e3-df8d-4fc2-bee6-0609d15f3cf9"],
    "IPrintReadStreamX": ["1a154b45-354b-44d1-b171-e3d357bf041e"],
    "IPrintSandbox": ["301642e7-a111-4bb7-b14b-d590a55403af"],
    "IPrintSandboxFactory": ["f47e1b73-d682-4715-a684-305ebffaafe2"],
    "IPrintSchema": ["c2b98316-26b8-4bfb-8138-9f962c22a35b"],
    "IPrintSchemaAsyncOperation": ["143c8dcb-d37f-47f7-88e8-6b1d21f2c5f7"],
    "IPrintSchemaAsyncOperationEvent": ["23adbb16-0133-4906-b29a-1dce1d026379"],
    "IPrintSchemaCapabilities": ["5a577640-501d-4927-bcd0-5ef57a7ed175"],
    "IPrintSchemaCapabilities2": ["b58845f4-9970-4d87-a636-169fb82ed642"],
    "IPrintSchemaDisplayableElement": ["af45af49-d6aa-407d-bf87-3912236e9d94"],
    "IPrintSchemaElement": ["724c1646-e64b-4bbf-8eb4-d45e4fd580da"],
    "IPrintSchemaFeature": ["ef189461-5d62-4626-8e57-ff83583c4826"],
    "IPrintSchemaNUpOption": ["1f6342f2-d848-42e3-8995-c10a9ef9a3ba"],
    "IPrintSchemaOption": ["66bb2f51-5844-4997-8d70-4b7cc221cf92"],
    "IPrintSchemaOptionCollection": ["baecb0bd-a946-4771-bc30-e8b24f8d45c1"],
    "IPrintSchemaPageImageableSize": ["7c85bf5e-dc7c-4f61-839b-4107e1c9b68e"],
    "IPrintSchemaPageMediaSizeOption": ["68746729-f493-4830-a10f-69028774605d"],
    "IPrintSchemaParameterDefinition": ["b5ade81e-0e61-4fe1-81c6-c333e4ffe0f1"],
    "IPrintSchemaParameterInitializer": ["52027082-0b74-4648-9564-828cc6cb656c"],
    "IPrintSchemaTicket": ["e480b861-4708-4e6d-a5b4-a2b4eeb9baa4"],
    "IPrintSchemaTicket2": ["2ec1f844-766a-47a1-91f4-2eeb6190f80c"],
    "IPrintSource": ["6a22767e-614f-42e0-b7cb-5ddd0a6ee2aa"],
    "IPrintStapleOptionDetails": ["d43175bd-9c0b-44e0-84f6-ceebce653800"],
    "IPrintTask": ["61d80247-6cf6-4fad-84e2-a5e82e2d4ceb"],
    "IPrintTask2": ["36234877-3e53-4d9d-8f5e-316ac8dedae1"],
    "IPrintTaskCompletedEventArgs": ["5bcd34af-24e9-4c10-8d07-14c346ba3fce"],
    "IPrintTaskConfiguration": ["e3c22451-3aa4-4885-9240-311f5f8fbe9d"],
    "IPrintTaskConfigurationSaveRequest": ["eeaf2fcb-621e-4b62-ac77-b281cce08d60"],
    "IPrintTaskConfigurationSaveRequestedDeferral": ["e959d568-f729-44a4-871d-bd0628696a33"],
    "IPrintTaskConfigurationSaveRequestedEventArgs": ["e06c2879-0d61-4938-91d0-96a45bee8479"],
    "IPrintTaskOptionChangedEventArgs": ["65197d05-a5ee-4307-9407-9acad147679c"],
    "IPrintTaskOptionDetails": ["f5720af1-a89e-42a6-81af-f8e010b38a68"],
    "IPrintTaskOptionDetails2": ["53730a09-f968-4692-a177-c074597186db"],
    "IPrintTaskOptionDetailsStatic": ["135da193-0961-4b6e-8766-f13b7fbccd58"],
    "IPrintTaskOptions": ["5a0a66bb-d289-41bb-96dd-57e28338ae3f"],
    "IPrintTaskOptions2": ["eb9b1606-9a36-4b59-8617-b217849262e1"],
    "IPrintTaskOptionsCore": ["1bdbb474-4ed1-41eb-be3c-72d18ed67337"],
    "IPrintTaskOptionsCoreProperties": ["c1b71832-9e93-4e55-814b-3326a59efce1"],
    "IPrintTaskOptionsCoreUIConfiguration": ["62e69e23-9a1e-4336-b74f-3cc7f4cff709"],
    "IPrintTaskProgressingEventArgs": ["810cd3cb-b410-4282-a073-5ac378234174"],
    "IPrintTaskRequest": ["6ff61e2e-2722-4240-a67c-f364849a17f3"],
    "IPrintTaskRequestFactory": ["bb516745-8c34-4f8b-9605-684dcb144be5"],
    "IPrintTaskRequestHandler": ["191cd340-cf36-44ff-bd53-d1b701799d9b"],
    "IPrintTaskRequestedDeferral": ["cfefb3f0-ce3e-42c7-9496-64800c622c44"],
    "IPrintTaskRequestedEventArgs": ["d0aff924-a31b-454c-a7b6-5d0cc522fc16"],
    "IPrintTaskSettingsActivatedEventArgs": ["ee30a0c9-ce56-4865-ba8e-8954ac271107"],
    "IPrintTaskSourceRequestedArgs": ["f9f067be-f456-41f0-9c98-5ce73e851410"],
    "IPrintTaskSourceRequestedDeferral": ["4a1560d1-6992-4d9d-8555-4ca4563fb166"],
    "IPrintTaskSourceRequestedHandler": ["6c109fa8-5cb6-4b3a-8663-f39cb02dc9b4"],
    "IPrintTaskTargetDeviceSupport": ["295d70c0-c2cb-4b7d-b0ea-93095091a220"],
    "IPrintTextOptionDetails": ["ad75e563-5ce4-46bc-9918-ab9fad144c5b"],
    "IPrintTicketCapabilities": ["8c45508b-bbdc-4256-a142-2fd615ecb416"],
    "IPrintTicketFeature": ["e7607d6a-59f5-4103-8858-b97710963d39"],
    "IPrintTicketOption": ["b086cf90-b367-4e4b-bd48-9c78a0bb31ce"],
    "IPrintTicketParameterDefinition": ["d6bab4e4-2962-4c01-b7f3-9a9294eb8335"],
    "IPrintTicketParameterInitializer": ["5e3335bb-a0a5-48b1-9d5c-07116ddc597a"],
    "IPrintTicketProvider": ["bb5116db-0a23-4c3a-a6b6-89e5558dfb5d"],
    "IPrintTicketProvider2": ["b8a70ab2-3dfc-4fec-a074-511b13c651cb"],
    "IPrintTicketValue": ["66b30a32-244d-4e22-a98b-bb3cf1f2dd91"],
    "IPrintUIServices": ["2e4599e1-be2c-436a-b0ad-3d0e347f34b3"],
    "IPrintWorkflowBackgroundSession": ["5b7913ba-0c5e-528a-7458-86a46cbddc45"],
    "IPrintWorkflowBackgroundSetupRequestedEventArgs": ["43e97342-1750-59c9-61fb-383748a20362"],
    "IPrintWorkflowConfiguration": ["d0aac4ed-fd4b-5df5-4bb6-8d0d159ebe3f"],
    "IPrintWorkflowConfigurationNative": ["c056be0a-9ee2-450a-9823-964f0006f2bb"],
    "IPrintWorkflowForegroundSession": ["c79b63d0-f8ec-4ceb-953a-c8876157dd33"],
    "IPrintWorkflowForegroundSetupRequestedEventArgs": ["bbe38247-9c1b-4dd3-9b2b-c80468d941b3"],
    "IPrintWorkflowObjectModelSourceFileContent": ["c36c8a6a-8a2a-419a-b3c3-2090e6bfab2f"],
    "IPrintWorkflowObjectModelSourceFileContentNative": ["68c9e477-993e-4052-8ac6-454eff58db9d"],
    "IPrintWorkflowObjectModelTargetPackage": ["7d96bc74-9b54-4ca1-ad3a-979c3d44ddac"],
    "IPrintWorkflowSourceContent": ["1a28c641-ceb1-4533-bb73-fbe63eefdb18"],
    "IPrintWorkflowSpoolStreamContent": ["72e55ece-e406-4b74-84e1-3ff3fdcdaf70"],
    "IPrintWorkflowStreamTarget": ["b23bba84-8565-488b-9839-1c9e7c7aa916"],
    "IPrintWorkflowSubmittedEventArgs": ["3add0a41-3794-5569-5c87-40e8ff720f83"],
    "IPrintWorkflowSubmittedOperation": ["2e4e6216-3be1-5f0f-5c81-a5a2bd4eab0e"],
    "IPrintWorkflowTarget": ["29da276c-0a73-5aed-4f3d-970d3251f057"],
    "IPrintWorkflowTriggerDetails": ["5739d868-9d86-4052-b0cb-f310becd59bb"],
    "IPrintWorkflowUIActivatedEventArgs": ["bc8a844d-09eb-5746-72a6-8dc8b5edbe9b"],
    "IPrintWorkflowXpsDataAvailableEventArgs": ["4d11c331-54d1-434e-be0e-82c5fa58e5b2"],
    "IPrintWorkflowXpsObjectModelTargetPackageNative": ["7d96bc74-9b54-4ca1-ad3a-979c3d44ddac"],
    "IPrintWorkflowXpsReceiver": ["04097374-77b8-47f6-8167-aae29d4cf84b"],
    "IPrintWriteStream": ["65bb7f1b-371e-4571-8ac7-912f510c1a38"],
    "IPrintWriteStreamFlush": ["07d11ff8-1753-4873-b749-6cdaf068e4c3"],
    "IPrintWriteStreamX": ["d844c928-05fb-4450-9d07-fb29e4397bde"],
    "IPrinterBidiSetRequestCallback": ["c52d32dd-f2b4-4052-8502-ec4305ecb71f"],
    "IPrinterExtensionAsyncOperation": ["108d6a23-6a4b-4552-9448-68b427186acd"],
    "IPrinterExtensionContext": ["39843bf2-c4d2-41fd-b4b2-aedbee5e1900"],
    "IPrinterExtensionContextCollection": ["fb476970-9bab-4861-811e-3e98b0c5addf"],
    "IPrinterExtensionEvent": ["c093cb63-5ef5-4585-af8e-4d5637487b57"],
    "IPrinterExtensionEventArgs": ["39843bf4-c4d2-41fd-b4b2-aedbee5e1900"],
    "IPrinterExtensionManager": ["93c6eb8c-b001-4355-9629-8e8a1b3f8e77"],
    "IPrinterExtensionRequest": ["39843bf3-c4d2-41fd-b4b2-aedbee5e1900"],
    "IPrinterFolder": ["aee53265-5b70-401d-89e1-65ddba58518e"],
    "IPrinterPropertyBag": ["fea77364-df95-4a23-a905-019b79a8e481"],
    "IPrinterQueue": ["3580a828-07fe-4b94-ac1a-757d9d2d3056"],
    "IPrinterQueue2": ["8cd444e8-c9bb-49b3-8e38-e03209416131"],
    "IPrinterQueueEvent": ["214685f6-7b78-4681-87e0-495f739273d1"],
    "IPrinterQueueView": ["476e2969-3b2b-4b3f-8277-cff6056042aa", "b65116d3-0f51-4af8-93e4-a769af51ad2c"],
    "IPrinterQueueViewEvent": ["c5b6042b-fd21-404a-a0ef-e2fbb52b9080"],
    "IPrinterQueueViewExtension": ["720f1ef7-d142-434f-aa36-f61b54da0b56"],
    "IPrinterScriptContext": ["066acbca-8881-49c9-bb98-fae16b4889e1"],
    "IPrinterScriptablePropertyBag": ["91c7765f-ed57-49ad-8b01-dc24816a5294"],
    "IPrinterScriptablePropertyBag2": ["2a1c53c4-8638-4b3e-b518-2773c94556a3"],
    "IPrinterScriptableSequentialStream": ["2072838a-316f-467a-a949-27f68c44a854"],
    "IPrinterScriptableStream": ["7edf9a92-4750-41a5-a17f-879a6f4f7dcb"],
    "IPrintersBindInfo": ["4ef59929-6c53-4934-b4f4-af65ec42aab4"],
    "IPrinting3D3MFPackage": ["f64dd5c8-2ab7-45a9-a1b7-267e948d5b18"],
    "IPrinting3D3MFPackage2": ["965c7ac4-93cb-4430-92b8-789cd454f883"],
    "IPrinting3D3MFPackageStatics": ["7058d9af-7a9a-4787-b817-f6f459214823"],
    "IPrinting3DBaseMaterial": ["d0f0e743-c50c-4bcb-9d04-fc16adcea2c9"],
    "IPrinting3DBaseMaterialGroup": ["94f070b8-2515-4a8d-a1f0-d0fc13d06021"],
    "IPrinting3DBaseMaterialGroupFactory": ["5c1546dc-8697-4193-976b-84bb4116e5bf"],
    "IPrinting3DBaseMaterialStatics": ["815a47bc-374a-476d-be92-3ecfd1cb9776"],
    "IPrinting3DColorMaterial": ["e1899928-7ce7-4285-a35d-f145c9510c7b"],
    "IPrinting3DColorMaterial2": ["fab0e852-0aef-44e9-9ddd-36eeea5acd44"],
    "IPrinting3DColorMaterialGroup": ["001a6bd0-aadf-4226-afe9-f369a0b45004"],
    "IPrinting3DColorMaterialGroupFactory": ["71d38d6d-b1ea-4a5b-bc54-19c65f3df044"],
    "IPrinting3DComponent": ["7e287845-bf7f-4cdb-a27f-30a01437fede"],
    "IPrinting3DComponentWithMatrix": ["3279f335-0ef0-456b-9a21-49bebe8b51c2"],
    "IPrinting3DCompositeMaterial": ["462238dd-562e-4f6c-882d-f4d841fd63c7"],
    "IPrinting3DCompositeMaterialGroup": ["8d946a5b-40f1-496d-a5fb-340a5a678e30"],
    "IPrinting3DCompositeMaterialGroup2": ["06e86d62-7d3b-41e1-944c-bafde4555483"],
    "IPrinting3DCompositeMaterialGroupFactory": ["d08ecd13-92ff-43aa-a627-8d43c22c817e"],
    "IPrinting3DFaceReductionOptions": ["bbfed397-2d74-46f7-be85-99a67bbb6629"],
    "IPrinting3DManagerInterop": ["9ca31010-1484-4587-b26b-dddf9f9caecd"],
    "IPrinting3DMaterial": ["378db256-ed62-4952-b85b-03567d7c465e"],
    "IPrinting3DMesh": ["192e90dc-0228-2e01-bc20-c5290cbf32c4"],
    "IPrinting3DMeshVerificationResult": ["195671ba-e93a-4e8a-a46f-dea8e852197e"],
    "IPrinting3DModel": ["2d012ef0-52fb-919a-77b0-4b1a3b80324f"],
    "IPrinting3DModel2": ["c92069c7-c841-47f3-a84e-a149fd08b657"],
    "IPrinting3DModelTexture": ["5dafcf01-b59d-483c-97bb-a4d546d1c75c"],
    "IPrinting3DMultiplePropertyMaterial": ["25a6254b-c6e9-484d-a214-a25e5776ba62"],
    "IPrinting3DMultiplePropertyMaterialGroup": ["f0950519-aeb9-4515-a39b-a088fbbb277c"],
    "IPrinting3DMultiplePropertyMaterialGroupFactory": ["323e196e-d4c6-451e-a814-4d78a210fe53"],
    "IPrinting3DTexture2CoordMaterial": ["8d844bfb-07e9-4986-9833-8dd3d48c6859"],
    "IPrinting3DTexture2CoordMaterialGroup": ["627d7ca7-6d90-4fb9-9fc4-9feff3dfa892"],
    "IPrinting3DTexture2CoordMaterialGroup2": ["69fbdbba-b12e-429b-8386-df5284f6e80f"],
    "IPrinting3DTexture2CoordMaterialGroupFactory": ["cbb049b0-468a-4c6f-b2a2-8eb8ba8dea48"],
    "IPrinting3DTextureResource": ["a70df32d-6ab1-44ae-bc45-a27382c0d38c"],
    "IPrivActivationContextInfo": ["000001ae-0000-0000-c000-000000000046"],
    "IPrivActivationPropertiesIn": ["000001b5-0000-0000-c000-000000000046"],
    "IPrivActivationPropertiesOut": ["000001b0-0000-0000-c000-000000000046"],
    "IPrivDragDrop": ["00000160-0000-0000-c000-000000000046"],
    "IPrivEnumSyncMgrEvents": ["85db95df-8879-4ef3-b9bd-86ce79737d5a"],
    "IPrivProxyBuffer": ["30d2aa8a-daf8-cfc7-3a70-9e26a8c5c6ad"],
    "IPrivStubBuffer": ["3e0ac23f-eff6-41f3-b44b-fbfa4544265f"],
    "IPrivSyncDelegatingProxyBuffer": ["6a874cbd-f57e-4c39-84c0-00bf64093245"],
    "IPrivSyncDelegatingStubBuffer": ["438a7f0f-3a06-4fa8-8d18-c266daf72abd"],
    "IPrivSyncMgrHandlerDataStore": ["1df997e7-21c2-4258-a795-49c5d8869bd2"],
    "IPrivacIEAdvisor": ["b6cf3f5c-fad7-47af-9c5f-9404991b5c65"],
    "IPrivacIEContentLog": ["af11d3db-81a6-4b88-ae07-96eccf46d076"],
    "IPrivacIEDatabase": ["0199568a-f46d-4b53-99f6-f637e08314b2"],
    "IPrivateAcceleratorArgs": ["6e7dd78c-1107-4193-8168-4be44e97778c"],
    "IPrivateCoreInput": ["b8a2acd7-a0f0-40ee-8ee7-c82f59cc5cd4"],
    "IPrivateCoreWindow": ["cd98a184-5273-44ac-bf52-d62342a94bd5"],
    "IPrivateCursor": ["491d7888-4df3-41a1-bf52-49378b53f1b1"],
    "IPrivateDirectManipulationContentBehavior": ["8f9d2584-5a86-47ff-a29b-5aae5d522626"],
    "IPrivateDirectManipulationViewportTelemetryInfo": ["c645c48c-242a-496d-83fa-177eb03c154c"],
    "IPrivateDispatch": ["86ab4bbe-65f6-11d1-8c13-00c04fd8d503"],
    "IPrivateDispatcher": ["ef9cc6e1-96c2-4027-9120-78444953bf6f"],
    "IPrivateInterFilterCommunicator": ["596afff3-f0a6-47cd-92a3-161151455fd1"],
    "IPrivateManipulationConfigurationBehavior": ["48369fdc-b219-45b9-adb8-2c8d2f4f4f4e"],
    "IPrivateNavigationFocusEventArgs": ["a506a3df-9b2c-4d4b-97d5-cde7c37b1304"],
    "IPrivateOleObject": ["afd971e0-c870-11d0-a3a5-00c04fd706ec"],
    "IPrivatePointerDevice": ["8d2338d7-3cfa-4708-ad65-415eda5baa9d"],
    "IPrivatePointerPointProperties": ["cb6c13be-5733-4408-8e0d-92e17a7adb08"],
    "IPrivateTilingManagerCallback": ["9d7f4f2d-f808-439a-9ae9-a2dfe11dc784"],
    "IPrivateUnknown": ["89126bab-6ead-11d1-8c18-00c04fd8d503"],
    "IPrnStream": ["a24c1d62-75f5-11d2-b899-00c04f86ae55"],
    "IProcessAudioFrameContext": ["4cd92946-1222-4a27-a586-fb3e20273255"],
    "IProcessCpuUsage": ["0bbb2472-c8bf-423a-a810-b559ae4354e2"],
    "IProcessCpuUsageReport": ["8a6d9cac-3987-4e2f-a119-6b5fa214f1b4"],
    "IProcessDiagnosticInfo": ["e830b04b-300e-4ee6-a0ab-5b5f5231b434"],
    "IProcessDiagnosticInfo2": ["9558cb1a-3d0b-49ec-ab70-4f7a112805de"],
    "IProcessDiagnosticInfoStatics": ["2f41b260-b49f-428c-aa0e-84744f49ca95"],
    "IProcessDiagnosticInfoStatics2": ["4a869897-9899-4a44-a29b-091663be09b6"],
    "IProcessDiskUsage": ["5ad78bfd-7e51-4e53-bfaa-5a6ee1aabbf8"],
    "IProcessDiskUsageReport": ["401627fd-535d-4c1f-81b8-da54e1be635e"],
    "IProcessDump2": ["d313515f-d178-40bc-85b8-2b8c9467b276"],
    "IProcessKeyboardAcceleratorEventArgs": ["fb79c216-972b-440c-9b83-2b4198dcf09d"],
    "IProcessLauncherOptions": ["3080b9cf-f444-4a83-beaf-a549a0f3229c"],
    "IProcessLauncherResult": ["544c8934-86d8-4991-8e75-ece8a43b6b6d"],
    "IProcessLauncherStatics": ["33ab66e7-2d0e-448b-a6a0-c13c3836d09c"],
    "IProcessLifetimeManagerControl": ["69c083b1-7f6f-490d-9d77-c0219a95b25d"],
    "IProcessLifetimeManagerTestHook": ["df5320e1-2666-463d-8f34-e35a0afc2680"],
    "IProcessMemoryReport": ["087305a8-9b70-4782-8741-3a982b6ce5e4"],
    "IProcessMemoryUsage": ["f50b229b-827c-42b7-b07c-0e32627e6b3e"],
    "IProcessMemoryUsageReport": ["c2c77cba-1951-4685-8532-7e749ecf8eeb"],
    "IProcessServerInfo": ["000001ee-0000-0000-c000-000000000046"],
    "IProcessSubmix": ["5d857e80-f074-4ad8-a9ce-0ddca68d8212"],
    "IProcessVideoFrameContext": ["276f0e2b-6461-401e-ba78-0fdad6114eec"],
    "IProduceAggregateMultipleValues": ["9206e9dc-8c77-4d4b-adf0-4e5fe5f204ab"],
    "IProductLicense": ["363308c7-2bcf-4c0e-8f2f-e808aaa8f99d"],
    "IProductLicenseWithFulfillment": ["fc535c8a-f667-40f3-ba3c-045a63abb3ac"],
    "IProductListing": ["45a7d6ad-c750-4d9c-947c-b00dcbf9e9c2"],
    "IProductListing2": ["f89e290f-73fe-494d-a939-08a9b2495abe"],
    "IProductListingWithConsumables": ["eb9e9790-8f6b-481f-93a7-5c3a63068149"],
    "IProductListingWithMetadata": ["124da567-23f8-423e-9532-189943c40ace"],
    "IProductPurchaseDisplayProperties": ["d70b7420-bc92-401b-a809-c9b2e5dbbdaf"],
    "IProductPurchaseDisplayPropertiesFactory": ["6f491df4-32d6-4b40-b474-b83038a4d9cf"],
    "IProfSect": ["00020304-0000-0000-c000-000000000046"],
    "IProfferAsyncService": ["5fdd1fe6-898b-4d51-b2bc-4c936760c572"],
    "IProfferTypeLib": ["718cc500-0a76-11cf-8045-00aa006009fa"],
    "IProfileNotify": ["e10f6c3a-f1ae-4adc-aa9d-2fe65525666e"],
    "IProgressBar": ["35053a20-8589-11d1-b16a-00c0f0283628", "ae752c89-0067-4963-bf4c-29db0c4a507e"],
    "IProgressBarAutomationPeer": ["93f48f86-d840-4fb6-ac2f-5f779b854b0d"],
    "IProgressBarAutomationPeerFactory": ["364679ab-b80f-41b4-8eea-2f5251bc739c"],
    "IProgressBarEvents": ["35053a21-8589-11d1-b16a-00c0f0283628"],
    "IProgressBarFactory": ["da9a8c11-1591-400b-a993-0f1c5cc12f3b"],
    "IProgressBarStatics": ["7a129fda-5837-4e26-b3b4-e1c092cebbec"],
    "IProgressBarTemplateSettings": ["3fe2ea2a-e3f2-4c2b-9488-918d77d2bbe4"],
    "IProgressItem": ["2c941fd5-975b-59be-a960-9a2a262853a5"],
    "IProgressItems": ["2c941fd7-975b-59be-a960-9a2a262853a5"],
    "IProgressRing": ["6da5e49e-6e9d-425c-bd7c-02173e39763f"],
    "IProgressRingAutomationPeer": ["bc305eee-39d3-4eeb-ac33-2394de123e2e"],
    "IProgressRingAutomationPeerFactory": ["f3db204b-157e-40bc-9593-55bc5c71a4f6"],
    "IProgressRingStatics": ["e8b62507-4e2c-47d5-a54a-c6c48a5e6989"],
    "IProgressRingTemplateSettings": ["b9b675ec-c723-42e6-83e9-9826272bdc0e"],
    "IProjection": ["b3443557-7f39-4d04-a89c-844338cac897"],
    "IProjectionFactory": ["c4f29cab-60ad-4f24-bd27-9d69c3127c9a"],
    "IProjectionManager": ["d9cd01a5-a926-412d-a6cd-c3b51c2a9bc8"],
    "IProjectionManagerStatics": ["b65f913d-e2f0-4ffd-ba95-34241647e45c"],
    "IProjectionManagerStatics2": ["f33d2f43-2749-4cde-b977-c0c41e7415d1"],
    "IProjectionUI": ["483c2fd8-0508-47a0-8ab5-69ff5162c0fb"],
    "IProjects": ["b05651e9-9b10-425e-b616-1fcd828db3b1"],
    "IProjects2": ["b05651ea-9b10-425e-b616-1fcd828db3b1"],
    "IProofOfPossessionCookieInfoManager": ["cdaece56-4edf-43df-b113-88e4556fa1bb"],
    "IProofOfPossessionCookieInfoManager2": ["15e41407-b42f-4ae7-9966-34a087b2d713"],
    "IPropertyAnimation": ["3a01b4da-4d8c-411e-b615-1ade683a9903"],
    "IPropertyChange": ["f917bc8a-1bba-4478-a245-1bde03eb9431"],
    "IPropertyChangeArray": ["380f5cad-1b5e-42f2-805d-637fd392d31e"],
    "IPropertyChangePriv": ["076750e4-b009-49bd-aa85-b7938456ce10"],
    "IPropertyChangedCallback": ["5a9f8a25-d142-44a4-8231-fd676724f29b"],
    "IPropertyChangedEventArgs": ["4f33a9a0-5cf4-47a4-b16f-d7faaf17457e"],
    "IPropertyChangedEventArgsFactory": ["6dcc9c03-e0c7-4eee-8ea9-37e3406eeb1c"],
    "IPropertyChangedEventHandler": ["50f19c16-0a22-4d8e-a089-1ea9951657d2"],
    "IPropertyDescription": ["6f79d558-3e96-4549-a1d1-7d75d2288814"],
    "IPropertyDescription2": ["57d2eded-5062-400e-b107-5dae79fe57a6"],
    "IPropertyDescriptionAliasInfo": ["f67104fc-2af9-46fd-b32d-243c1404f3d1"],
    "IPropertyDescriptionList": ["1f9fc1d0-c39b-4b26-817f-011967d3440e"],
    "IPropertyDescriptionListInit": ["1c943eb9-337c-46de-a85a-77942b039099"],
    "IPropertyDescriptionRelatedPropertyInfo": ["507393f4-2a3d-4a60-b59e-d9c75716c2dd"],
    "IPropertyDescriptionSearchInfo": ["078f91bd-29a2-440f-924e-46a291524520"],
    "IPropertyDescriptionSearchInfoPriv": ["9f955849-3f10-4e39-bd18-0c0dbf82c8b0"],
    "IPropertyEnumType": ["11e1fbf9-2d56-4a6b-8db3-7cd193a471f2"],
    "IPropertyEnumType2": ["9b6e051c-5ddd-4321-9070-fe2acb55e794"],
    "IPropertyEnumTypeList": ["a99400f4-3d84-4557-94ba-1242fb2cc9a6"],
    "IPropertyEnumTypePriv": ["bb776487-a7a1-425b-8983-31ed23455b68"],
    "IPropertyInfoProvider": ["089f3011-bb5c-4f9c-9b8f-9a67ed446e91"],
    "IPropertyKeyStore": ["75bd59aa-f23b-4963-aba4-0b355752a91b"],
    "IPropertyMetadata": ["814ef30d-8d18-448a-8644-f2cb51e70380"],
    "IPropertyMetadataFactory": ["c1b81cc0-57cd-4f2f-b0a9-e1801b28f76b"],
    "IPropertyMetadataStatics": ["3b01077a-6e06-45e9-8b5c-af243458c062"],
    "IPropertyPageUndoString": ["33c0c1db-33cf-11d3-bff2-00c04f990235"],
    "IPropertyPath": ["300e5d8a-1ff3-4d2c-95ec-27f81debacb8"],
    "IPropertyPathFactory": ["4e4cdf99-9826-4e56-847c-ca055f162905"],
    "IPropertyProvider": ["44140b42-9155-4d7a-b952-55779d778b7b"],
    "IPropertyProxyEESide": ["579919d2-1b10-4584-969c-3e065bd3e22d"],
    "IPropertyProxyProvider": ["30e6c90e-757e-48cf-8db8-20b061afbbae"],
    "IPropertySchemaIterator": ["b0565248-9b10-425e-b616-1fcd828db3b1"],
    "IPropertySetter": ["ae9472bd-b0c3-11d2-8d24-00a0c9441e20"],
    "IPropertySheetHandler": ["b0371994-3fa6-4ab5-bd72-b3479fe90894"],
    "IPropertyStore": ["886d8eeb-8cf2-4446-8d02-cdba1dbdcf99"],
    "IPropertyStoreCache": ["3017056d-9a91-4e90-937d-746c72abbf4f"],
    "IPropertyStoreCapabilities": ["c8e2d566-186e-4d49-bf41-6909ead56acc"],
    "IPropertyStoreCollection": ["d14d9c30-12d2-42d8-bce4-c60c2bb226fa"],
    "IPropertyStoreContainer": ["dc6044c7-1606-4b00-b43d-a5f461c76766"],
    "IPropertyStoreFactory": ["bc110b6d-57e8-4148-a9c6-91015ab2f3a5"],
    "IPropertyStoreFlagAccess": ["227deb48-13be-42a1-a8ab-b241d29f4829"],
    "IPropertyStoreInit": ["f06a4b42-ca85-47fd-a35c-cc3c458938db"],
    "IPropertyStoreLanguage": ["2281d369-36df-4c3b-92a7-0b572c422d11"],
    "IPropertyStoreWithDiagnostic": ["cd0188d2-aec9-4c3b-8b58-b79ce800d0b6"],
    "IPropertySystem": ["ca724e8a-c3e6-442b-88a4-6fb0db8035a3"],
    "IPropertySystemChangeNotify": ["fa955fd9-38be-4879-a6ce-824cf52d609f"],
    "IPropertySystemPriv": ["9e1c40f8-a6da-4fae-a275-c7df51ccbe01"],
    "IPropertyValue": ["7af7f355-1066-4e17-b1f2-19fe2f099cd2"],
    "IPropertyValueStatics": ["629bdbc8-d932-4ff4-96b9-8d96c5c1e858"],
    "IProtectFocus": ["d81f90a3-8156-44f7-ad28-5abb87003274"],
    "IProtectedAccessResumedEventArgs": ["ac4dca59-5d80-4e95-8c5f-8539450eebe0"],
    "IProtectedAccessSuspendingEventArgs": ["75a193e0-a344-429f-b975-04fc1f88c185"],
    "IProtectedContainerExportResult": ["3948ef95-f7fb-4b42-afb0-df70b41543c1"],
    "IProtectedContainerImportResult": ["cdb780d1-e7bb-4d1a-9339-34dc41149f9b"],
    "IProtectedContentRevokedEventArgs": ["63686821-58b9-47ee-93d9-f0f741cf43f0"],
    "IProtectedFileCreateResult": ["28e3ed6a-e9e7-4a03-9f53-bdb16172699b"],
    "IProtectedModeAPI": ["3853eab3-adb3-4be8-9c96-c883b98e76ad"],
    "IProtectedModeMenuServices": ["73c105ee-9dff-4a07-b83c-7eff290c266e"],
    "IProtectionCapabilities": ["c7ac5d7e-7480-4d29-a464-7bcd913dd8e4"],
    "IProtectionPolicyAuditInfo": ["425ab7e4-feb7-44fc-b3bb-c3c4d7ecbebb"],
    "IProtectionPolicyAuditInfoFactory": ["7ed4180b-92e8-42d5-83d4-25440b423549"],
    "IProtectionPolicyManager": ["d5703e18-a08d-47e6-a240-9934d7165eb5"],
    "IProtectionPolicyManager2": ["abf7527a-8435-417f-99b6-51beaf365888"],
    "IProtectionPolicyManagerInterop": ["4652651d-c1fe-4ba1-9f0a-c0f56596f721"],
    "IProtectionPolicyManagerInterop2": ["157cfbe4-a78d-4156-b384-61fdac41e686"],
    "IProtectionPolicyManagerInterop3": ["c1c03933-b398-4d93-b0fd-2972adf802c2"],
    "IProtectionPolicyManagerStatics": ["c0bffc66-8c3d-4d56-8804-c68f0ad32ec5"],
    "IProtectionPolicyManagerStatics2": ["b68f9a8c-39e0-4649-b2e4-070ab8a579b3"],
    "IProtectionPolicyManagerStatics3": ["48ff9e8c-6a6f-4d9f-bced-18ab537aa015"],
    "IProtectionPolicyManagerStatics4": ["20b794db-ccbd-490f-8c83-49ccb77aea6c"],
    "IProtocol": ["b05651d6-9b10-425e-b616-1fcd828db3b1"],
    "IProtocolActivatedEventArgs": ["6095f4dd-b7c0-46ab-81fe-d90f36d00d24"],
    "IProtocolActivatedEventArgsWithCallerPackageFamilyNameAndData": ["d84a0c12-5c8f-438c-83cb-c28fcc0b2fdb"],
    "IProtocolForResultsActivatedEventArgs": ["e75132c2-7ae7-4517-80ac-dbe8d7cc5b9c"],
    "IProtocolForResultsOperation": ["d581293a-6de9-4d28-9378-f86782e182bb"],
    "IProtocolHandlerSite": ["0b63e385-9ccc-11d0-bcdb-00805fccce04"],
    "IProtocolHandlerValidator": ["672d1926-acec-4c20-8826-aec02d2e7209"],
    "IProtocolWebRequestContext": ["5b7ebc0c-f630-4cea-89d3-5af038ed055c"],
    "IProtocols": ["b05651d5-9b10-425e-b616-1fcd828db3b1"],
    "IProvideAltHTML": ["33c0c1dd-33cf-11d3-bff2-00c04f990235"],
    "IProvideDefaultVerbDescription": ["7bb0eee4-836d-4045-970e-9b82e7c17d9a"],
    "IProvideDynamicClassInfo": ["468cfb80-b4f9-11cf-80dd-00aa00614895"],
    "IProvideMoniker": ["0c733a4d-2a1c-11ce-ade5-00aa0044773d"],
    "IProvidePinAssociationResponse": ["47e6b30d-1d88-483b-8e41-26bf91c09c24"],
    "IProvidePropertyBuilder": ["33c0c1d8-33cf-11d3-bff2-00c04f990235"],
    "IProvideRuntimeHTML": ["33c0c1dc-33cf-11d3-bff2-00c04f990235"],
    "IProvideUserNameAndPasswordAssociationResponse": ["1853a283-130e-427e-bed0-acdea5872ddd"],
    "IProvideWinSATAssessmentInfo": ["0cd1c380-52d3-4678-ac6f-e929e480be9e"],
    "IProvideWinSATResultsInfo": ["f8334d5d-568e-4075-875f-9df341506640"],
    "IProvideWinSATVisuals": ["a9f4ade0-871a-42a3-b813-3078d25162c9"],
    "IProviderAttributes": ["0d96fc4e-2ee9-47a4-9459-67771ad57ba3"],
    "IProviderConfig": ["b445e1e5-d442-4865-9faf-36a64be62b09"],
    "IProviderConverter": ["809b7276-98cf-4957-93a5-0ebdd3dddffd"],
    "IProviderI2cConnectionSettings": ["e9db4e34-e510-44b7-809d-f2f85b555339"],
    "IProviderNetworkUsage": ["5ec69e04-7931-48c8-b8f3-46300fa42728"],
    "IProviderProperties": ["cf986ea6-3b5f-4c5f-b88a-2f8b20ceef17"],
    "IProviderPropertyConstraintCollection": ["f4fae42f-5778-4a13-8540-b5fd8c1398dd"],
    "IProviderPublishing": ["cd1b9a04-206c-4a05-a0c8-1635a21a2b7c"],
    "IProviderQueryConstraintCollection": ["9c243e11-3261-4bcd-b922-84a873d460ae"],
    "IProviderResolver": ["bf2d36d6-72a6-4ee1-8553-3d90aa88800f"],
    "IProviderResolver2": ["8cd129fd-2158-49df-96a6-9eb9dbe5c40c"],
    "IProviderSpiConnectionSettings": ["f6034550-a542-4ec0-9601-a4dd68f8697b"],
    "IProviderSpiConnectionSettingsFactory": ["66456b5a-0c79-43e3-9f3c-e59780ac18fa"],
    "IProvisionFromXmlDocumentResults": ["217700e0-8203-11df-adb9-f4ce462d9137"],
    "IProvisionedProfile": ["217700e0-8202-11df-adb9-f4ce462d9137"],
    "IProvisioningAgent": ["217700e0-8201-11df-adb9-f4ce462d9137"],
    "IProvisioningAgentStaticMethods": ["217700e0-8101-11df-adb9-f4ce462d9137"],
    "IProvisioningDocument": ["217700e0-1002-11df-adb9-f4ce462d9137"],
    "IProvisioningEngine": ["217700e0-1001-11df-adb9-f4ce462d9137"],
    "IProvisioningNotificationProcessor": ["217700e0-1003-11df-adb9-f4ce462d9137"],
    "IProximityDevice": ["efa8a552-f6e1-4329-a0fc-ab6b0fd28262"],
    "IProximityDeviceStatics": ["914ba01d-f6e1-47c4-a14c-148a1903d0c6"],
    "IProximityMessage": ["efab0782-f6e1-4675-a045-d8e320c24808"],
    "IProximitySensor": ["54c076b8-ecfb-4944-b928-74fc504d47ee"],
    "IProximitySensorDataThresholdFactory": ["905ac121-6d27-4ad3-9db5-6467f2a5ad9d"],
    "IProximitySensorReading": ["71228d59-132d-4d5f-8ff9-2f0db8751ced"],
    "IProximitySensorReadingChangedEventArgs": ["cfc2f366-c3e8-40fd-8cc3-67e289004938"],
    "IProximitySensorStatics": ["29186649-6269-4e57-a5ad-82be80813392"],
    "IProximitySensorStatics2": ["cbf473ae-e9ca-422f-ad67-4c3d25df350c"],
    "IProxyConfiguration": ["ef3a60b4-9004-4dd6-b7d8-b3e502f4aad0"],
    "IProxyList": ["7c3bcf70-2ee1-11e2-81c1-0800200c9a66"],
    "IProxyObject": ["cd000083-8b95-11d1-82db-00c04fb1625d"],
    "IProxyOperation": ["cac9d2da-d20f-4001-a970-0401be841928"],
    "IProxyProviderWinEventHandler": ["89592ad4-f4e0-43d5-a3b6-bad7e111b435"],
    "IProxyProviderWinEventSink": ["4fd82b78-a43e-46ac-9803-0a6969c7c183"],
    "IProxyResolver": ["cac9d2d8-d20f-4001-a970-0401be841928"],
    "IProxyResolverEx": ["cac9d2d9-d20f-4001-a970-0401be841928"],
    "IProxyResolverState": ["1c29b060-5999-4c20-b5bf-6486c4064806"],
    "IProxyResult": ["b62d5224-5301-4183-91dc-b3051a9c388f"],
    "IProxyServerIdentity": ["5524fe34-8da7-40a8-8165-e8b37a8b4a4b"],
    "IProxyStoreObject": ["29f3ab10-554d-11d0-a97c-00a0c911f50a"],
    "IProxySupport": ["2d9a0ee3-a8de-4af7-9044-114d1791e269"],
    "IPublicationServices": ["c3821a62-080a-497b-99e6-78b0dec38c08"],
    "IPublicationServicesCache": ["e536abf2-f7a1-4f84-9c34-a5c73d954465"],
    "IPublicationServicesCallback": ["c647feaa-1777-4559-8759-d45fb8fd903b"],
    "IPublicationServicesChangeData": ["a3596f58-338b-49a0-9fd7-0810b0ed4d3a"],
    "IPublicationServicesData": ["68ddcbb6-ca89-40a1-9b57-070b5cc2af2a"],
    "IPublicationServicesListener": ["af61e1bc-1bca-45ec-8563-f557a9b8ef68"],
    "IPublicationServicesManagement": ["a2ea29b9-fd7f-4d82-800e-cd9bc346cf56"],
    "IPublicationServicesPublisher": ["6feba27b-4c2e-4f9f-a5b0-ea0f5ceebfa2"],
    "IPublishedApp2": ["12b81347-1b3a-4a04-aa61-3f768b67fd7e"],
    "IPurchaseResults": ["ed50b37e-8656-4f65-b8c8-ac7e0cb1a1c2"],
    "IPushNotificationChannel": ["2b28102e-ef0b-4f39-9b8a-a3c194de7081"],
    "IPushNotificationChannelManagerForUser": ["a4c45704-1182-42c7-8890-f563c4890dc4"],
    "IPushNotificationChannelManagerForUser2": ["c38b066a-7cc1-4dac-87fd-be6e920414a4"],
    "IPushNotificationChannelManagerStatics": ["8baf9b65-77a1-4588-bd19-861529a9dcf0"],
    "IPushNotificationChannelManagerStatics2": ["b444a65d-a7e9-4b28-950e-f375a907f9df"],
    "IPushNotificationChannelManagerStatics3": ["4701fefe-0ede-4a3f-ae78-bfa471496925"],
    "IPushNotificationChannelManagerStatics4": ["bc540efb-7820-5a5b-9c01-b4757f774025"],
    "IPushNotificationChannelsRevokedEventArgs": ["20e1a24c-1a34-5beb-aae2-40c232c8c140"],
    "IPushNotificationReceivedEventArgs": ["d1065e0c-36cd-484c-b935-0a99b753cf00"],
    "IPushNotificationTriggerFactory": ["6dd8ed1b-458e-4fc2-bc2e-d5664f77ed19"],
    "IPushedPrinterConnection": ["8ea79ad0-d2ec-4b37-b014-335f55bd7e90"],
    "IPwmController": ["c45f5c85-d2e8-42cf-9bd6-cf5ed029e6a7"],
    "IPwmControllerProvider": ["1300593b-e2e3-40a4-b7d9-48dff0377a52"],
    "IPwmControllerStatics": ["4263bda1-8946-4404-bd48-81dd124af4d9"],
    "IPwmControllerStatics2": ["44fc5b1f-f119-4bdd-97ad-f76ef986736d"],
    "IPwmControllerStatics3": ["b2581871-0229-4344-ae3f-9b7cd0e66b94"],
    "IPwmPin": ["22972dc8-c6cf-4821-b7f9-c6454fb6af79"],
    "IPwmProvider": ["a3301228-52f1-47b0-9349-66ba43d25902"],
    "IQosRecorder": ["1b4a6cd1-9a58-4194-a596-84a787caf9eb"],
    "IQuadraticBezierSegment": ["2c509a5b-bf18-455a-a078-914b5232d8af"],
    "IQuadraticBezierSegmentStatics": ["69c78278-3c0b-4b4f-b7a2-f003ded41bb0"],
    "IQuadraticEase": ["e1510e91-ef6d-44f0-803d-68d16de0ddfc"],
    "IQuarticEase": ["e8698814-fe42-4a05-b5b8-081f41157815"],
    "IQuaternionKeyFrameAnimation": ["404e5835-ecf6-4240-8520-671279cf36bc"],
    "IQueryAllWinSATAssessments": ["0b89ed1d-6398-4fea-87fc-567d8d19176f"],
    "IQueryCodePage": ["c7b236ce-ee80-11d0-985f-006008059382"],
    "IQueryComputeThreadInfo110": ["14a2adde-1f63-41b5-ad3e-06f6f8e4c0d5"],
    "IQueryContinueWithStatus": ["9090be5b-502b-41fb-bccc-0049a6c7254b"],
    "IQueryEnhancements": ["fece3dd3-b657-4fc1-b2df-532a1bdf43ac"],
    "IQueryFormulationView": ["784fe898-8e00-4b28-a276-03cccaf470f7"],
    "IQueryJobAttributes": ["e05174e1-584f-43da-97f9-f307b57e186e"],
    "IQueryLinks": ["2d2cc27b-e2fc-4abd-909f-d1401da6e82f"],
    "IQueryLinksNotify": ["a88e90a6-dd82-437a-b89c-dc2977eb7ba9"],
    "IQueryOEMWinSATCustomization": ["bc9a6a9f-ad4e-420e-9953-b34671e9df22"],
    "IQueryOptions": ["1e5e46ee-0f45-4838-a8e9-d0479d446c30"],
    "IQueryOptionsFactory": ["032e1f8c-a9c1-4e71-8011-0dee9d4811a3"],
    "IQueryOptionsInternal": ["b026df12-fcc7-421f-ba6a-bad2b5639447"],
    "IQueryOptionsWithProviderFilter": ["5b9d1026-15c4-44dd-b89a-47a59b7d7c4f"],
    "IQueryParser": ["2ebdee67-3505-43f8-9946-ea44abc8e5b0"],
    "IQueryParserManager": ["a879e3c4-af77-44fb-8f37-ebd1487cf920"],
    "IQueryPlan": ["40dc2ae8-7f2c-11d2-a3f3-3078302c2030"],
    "IQueryPopupMgr": ["ae3080f6-74c7-4329-a26d-5ee5b9cc48aa"],
    "IQueryRecentWinSATAssessment": ["f8ad5d1f-3b47-4bdc-9375-7c6b1da4eca7"],
    "IQueryResult": ["656c5e34-f857-40d6-9d5c-9c5e6873e160"],
    "IQueryResultCount": ["56342576-1259-43db-8fc9-463fbe9e8cc0"],
    "IQueryResultSet": ["09f253f1-e604-473b-8565-266feff0e004"],
    "IQueryResultSetAdvise": ["b593b6dc-51a4-48e9-9613-7097bd0d2ccb"],
    "IQueryResultSetEventSink": ["a976f595-49fb-4313-bc1a-a7df7fd4bbfa"],
    "IQueryRowSetAttributes": ["7877af56-4f6c-4668-8bf2-82f01406ce1d"],
    "IQuerySeamlessUpgradeSupportOperation": ["7e7adcce-cf2b-4ea0-8475-e1bdb4140379"],
    "IQuerySolution": ["d6ebc66b-8921-4193-afdd-a1789fb7ff57"],
    "IQuerySource": ["7bc28ac2-0d9c-4941-bb9a-72becb184fac"],
    "IQueryWithLinguisticAlternatives": ["8ffa42ad-f8c4-44c9-b7d6-67f5f63b90d7"],
    "IQueueCallbackCreate": ["7d8899f0-8da9-435f-983c-7e17d4356997"],
    "IQueueCallbackDefaultIoHandler": ["15fb6d38-fdd8-4005-8e55-eb0b98313499"],
    "IQueueCallbackDeviceIoControl": ["c5411408-0f1e-4ed6-a412-36dd15eee707"],
    "IQueueCallbackIoCanceledOnQueue": ["746383c4-00a7-4200-8073-c02d076976be"],
    "IQueueCallbackIoResume": ["bee9fd3c-3dda-4d9d-a8fc-02c38d79f663"],
    "IQueueCallbackIoStop": ["3de3b961-88fb-435a-9c14-0868fb4fc623"],
    "IQueueCallbackRead": ["c3072620-1da6-48fb-b4fe-ed652b16aeb2"],
    "IQueueCallbackStateChange": ["e7ece381-7cb1-468a-bc43-abd5948ffc75"],
    "IQueueCallbackWrite": ["4888cbc5-3fa2-4ea3-89a3-c20ed6e04778"],
    "IQueueItem2": ["c3a1bc2b-ef1f-4256-afac-ba61a543781b"],
    "IQuickLink": ["603e4308-f0be-4adc-acc9-8b27ab9cf556"],
    "IQuietHoursPolicy": ["35c5cdb8-978e-42f8-bb8e-37d7e7fe7b2e"],
    "IQuinticEase": ["92ee793b-3c49-4108-aa11-ab786603da21"],
    "IQuotaUIHelper": ["9a50588e-fa80-4509-b345-664110225322"],
    "IRDPSRAPIApplication": ["41e7a09d-eb7a-436e-935d-780ca2628324"],
    "IRDPSRAPIApplicationFilter": ["d20f10ca-6637-4f06-b1d5-277ea7e5160d"],
    "IRDPSRAPIApplicationList": ["d4b4aeb3-22dc-4837-b3b6-42ea2517849a"],
    "IRDPSRAPIAttendee": ["ec0671b3-1b78-4b80-a464-9132247543e3"],
    "IRDPSRAPIAttendeeDisconnectInfo": ["c187689f-447c-44a1-9c14-fffbb3b7ec17"],
    "IRDPSRAPIAttendeeManager": ["ba3a37e8-33da-4749-8da0-07fa34da7944"],
    "IRDPSRAPIAudioStream": ["e3e30ef9-89c6-4541-ba3b-19336ac6d31c"],
    "IRDPSRAPIClipboardUseEvents": ["d559f59a-7a27-4138-8763-247ce5f659a8"],
    "IRDPSRAPIDebug": ["aa1e42b5-496d-4ca4-a690-348dcb2ec4ad"],
    "IRDPSRAPIFrameBuffer": ["3d67e7d2-b27b-448e-81b3-c6110ed8b4be"],
    "IRDPSRAPIInvitation": ["4fac1d43-fc51-45bb-b1b4-2b53aa562fa3"],
    "IRDPSRAPIInvitationManager": ["4722b049-92c3-4c2d-8a65-f7348f644dcf"],
    "IRDPSRAPIPerfCounterLogger": ["071c2533-0fa4-4e8f-ae83-9c10b4305ab5"],
    "IRDPSRAPIPerfCounterLoggingManager": ["9a512c86-ac6e-4a8e-b1a4-fcef363f6e64"],
    "IRDPSRAPISessionProperties": ["339b24f2-9bc0-4f16-9aac-f165433d13d4"],
    "IRDPSRAPISharingSession": ["eeb20886-e470-4cf6-842b-2739c0ec5cfb"],
    "IRDPSRAPISharingSession2": ["fee4ee57-e3e8-4205-8fb0-8fd1d0675c21"],
    "IRDPSRAPITcpConnectionInfo": ["f74049a4-3d06-4028-8193-0a8c29bc2452"],
    "IRDPSRAPITransportStream": ["36cfa065-43bb-4ef7-aed7-9b88a5053036"],
    "IRDPSRAPITransportStreamBuffer": ["81c80290-5085-44b0-b460-f865c39cb4a9"],
    "IRDPSRAPITransportStreamEvents": ["ea81c254-f5af-4e40-982e-3e63bb595276"],
    "IRDPSRAPIViewer": ["c6bfcd38-8ce9-404d-8ae8-f31d00c65cb5"],
    "IRDPSRAPIVirtualChannel": ["05e12f95-28b3-4c9a-8780-d0248574a1e0"],
    "IRDPSRAPIVirtualChannelManager": ["0d11c661-5d0d-4ee4-89df-2166ae1fdfed"],
    "IRDPSRAPIWindow": ["beafe0f9-c77b-4933-ba9f-a24cddcc27cf"],
    "IRDPSRAPIWindowList": ["8a05ce44-715a-4116-a189-a118f30a07bd"],
    "IRDPViewerInputSink": ["bb590853-a6c5-4a7b-8dd4-76b69eea12d5"],
    "IRDPViewerRenderingSurface": ["56bfce32-83e9-414d-82e8-f31d01c62cb5"],
    "IRMHelper": ["e793f6d1-f53d-11cf-a60d-00a0c905416e"],
    "IRSOPInformation": ["9a5a81b5-d9c7-49ef-9d11-ddf50968c48d"],
    "IRWLock": ["63cd65b3-2f42-45e6-96a6-12ebcdee0a38"],
    "IRacingWheel": ["f546656f-e106-4c82-a90f-554012904b85"],
    "IRacingWheelStatics": ["3ac12cd5-581b-4936-9f94-69f1e6514c7d"],
    "IRacingWheelStatics2": ["e666bcaa-edfd-4323-a9f6-3c384048d1ed"],
    "IRadialController": ["3055d1c8-df51-43d4-b23b-0e1037467a09"],
    "IRadialController2": ["3d577eff-4cee-11e6-b535-001bdc06ab3b"],
    "IRadialControllerButtonClickedEventArgs": ["206aa438-e651-11e5-bf62-2c27d7404e85"],
    "IRadialControllerButtonClickedEventArgs2": ["3d577ef3-3cee-11e6-b535-001bdc06ab3b"],
    "IRadialControllerButtonHoldingEventArgs": ["3d577eee-3cee-11e6-b535-001bdc06ab3b"],
    "IRadialControllerButtonPressedEventArgs": ["3d577eed-4cee-11e6-b535-001bdc06ab3b"],
    "IRadialControllerButtonReleasedEventArgs": ["3d577eef-3cee-11e6-b535-001bdc06ab3b"],
    "IRadialControllerConfiguration": ["a6b79ecb-6a52-4430-910c-56370a9d6b42"],
    "IRadialControllerConfiguration2": ["3d577ef7-3cee-11e6-b535-001bdc06ab3b"],
    "IRadialControllerConfigurationInterop": ["787cdaac-3186-476d-87e4-b9374a7b9970"],
    "IRadialControllerConfigurationStatics": ["79b6b0e5-069a-4486-a99d-8db772b9642f"],
    "IRadialControllerConfigurationStatics2": ["53e08b17-e205-48d3-9caf-80ff47c4d7c7"],
    "IRadialControllerControlAcquiredEventArgs": ["206aa439-e651-11e5-bf62-2c27d7404e85"],
    "IRadialControllerControlAcquiredEventArgs2": ["3d577ef4-3cee-11e6-b535-001bdc06ab3b"],
    "IRadialControllerIndependentInputSource": ["3d577ef6-4cee-11e6-b535-001bdc06ab3b"],
    "IRadialControllerIndependentInputSource2": ["7073aad8-35f3-4eeb-8751-be4d0a66faf4"],
    "IRadialControllerIndependentInputSourceInterop": ["3d577eff-4cee-11e6-b535-001bdc06ab3b"],
    "IRadialControllerIndependentInputSourceStatics": ["3d577ef5-4cee-11e6-b535-001bdc06ab3b"],
    "IRadialControllerInterop": ["1b0535c9-57ad-45c1-9d79-ad5c34360513"],
    "IRadialControllerMenu": ["8506b35d-f640-4412-aba0-bad077e5ea8a"],
    "IRadialControllerMenuItem": ["c80fc98d-ad0b-4c9c-8f2f-136a2373a6ba"],
    "IRadialControllerMenuItemStatics": ["249e0887-d842-4524-9df8-e0d647edc887"],
    "IRadialControllerMenuItemStatics2": ["0cbb70be-7e3e-48bd-be04-2c7fcaa9c1ff"],
    "IRadialControllerRotationChangedEventArgs": ["206aa435-e651-11e5-bf62-2c27d7404e85"],
    "IRadialControllerRotationChangedEventArgs2": ["3d577eec-4cee-11e6-b535-001bdc06ab3b"],
    "IRadialControllerScreenContact": ["206aa434-e651-11e5-bf62-2c27d7404e85"],
    "IRadialControllerScreenContactContinuedEventArgs": ["206aa437-e651-11e5-bf62-2c27d7404e85"],
    "IRadialControllerScreenContactContinuedEventArgs2": ["3d577ef1-3cee-11e6-b535-001bdc06ab3b"],
    "IRadialControllerScreenContactEndedEventArgs": ["3d577ef2-3cee-11e6-b535-001bdc06ab3b"],
    "IRadialControllerScreenContactStartedEventArgs": ["206aa436-e651-11e5-bf62-2c27d7404e85"],
    "IRadialControllerScreenContactStartedEventArgs2": ["3d577ef0-3cee-11e6-b535-001bdc06ab3b"],
    "IRadialControllerStatics": ["faded0b7-b84c-4894-87aa-8f25aa5f288b"],
    "IRadioButtonAutomationPeer": ["7e6a5ed8-0b30-4743-b102-dcdf548e3131"],
    "IRadioButtonAutomationPeerFactory": ["4940c4fd-3d88-49ca-8f31-924187af0bfe"],
    "IRadioButtonFactory": ["f1d04933-34e1-4a5c-b2ae-ca3b1c0b20de"],
    "IRadioButtonStatics": ["6b149293-f50f-4bd8-b0ac-5c162f33a208"],
    "IRadioInstance": ["70aa1c9e-f2b4-4c61-86d3-6b9fb75fd1a2"],
    "IRadioInstanceCollection": ["e5791fae-5665-4e0c-95be-5fde31644185"],
    "IRadioInstanceInternal": ["9fcae3ac-129e-4fcf-8c3b-3509d05c0fb7"],
    "IRadioStatics": ["5fb6a12e-67cb-46ae-aae9-65919f86eff4"],
    "IRampForceEffect": ["f1f81259-1ca6-4080-b56d-b43f3354d052"],
    "IRandomAccessStream": ["905a0fe1-bc53-11df-8c49-001e4fc686da"],
    "IRandomAccessStreamFileAccessMode": ["332e5848-2e15-458e-85c4-c911c0c3d6f4"],
    "IRandomAccessStreamMode": ["ba433434-2f07-4f5e-94ae-35c82fe1708a"],
    "IRandomAccessStreamModeWithOpenOptions": ["2a33a3b1-21c9-4d11-bc6f-54f3f88d4190"],
    "IRandomAccessStreamPrivate": ["2fb0e49b-e48c-47aa-a4cc-2e2816fff0fe"],
    "IRandomAccessStreamReference": ["33ee3134-1dd6-4e3a-8067-d1c162e8642b"],
    "IRandomAccessStreamReferenceStatics": ["857309dc-3fbf-4e7d-986f-ef3b1a07a964"],
    "IRandomAccessStreamStatics": ["524cedcf-6e29-4ce5-9573-6b753db66c3a"],
    "IRandomAccessStreamWithContentType": ["cc254827-4b3d-438f-9232-10c76bc7e038"],
    "IRangeBase": ["fa002c1a-494e-46cf-91d4-e14a8d798675"],
    "IRangeBaseAutomationPeer": ["e454b549-4b2c-42ad-b04b-d35947d1ee50"],
    "IRangeBaseAutomationPeerFactory": ["827c7601-3078-4479-95ea-91374ca06207"],
    "IRangeBaseFactory": ["389b7c71-5220-42b2-9992-2690c1a67030"],
    "IRangeBaseOverrides": ["4291af39-7f0b-4bc2-99c4-06e7062682d8"],
    "IRangeBaseStatics": ["67ef17e1-fe37-474f-9e97-3b5e0b30f2e0"],
    "IRangeBaseValueChangedEventArgs": ["a1921777-d5c1-4f9c-a7b0-0401b7e6dc5c"],
    "IRangeBaseValueChangedEventHandler": ["e3906fd9-4d1b-4ac8-a43c-c3b908742799"],
    "IRangeException": ["3051072d-98b5-11cf-bb82-00aa00bdce0b", "75ae8777-6848-49f7-956c-a3a92f5096e8"],
    "IRangeValuePatternIdentifiers": ["f8760f45-33c9-467d-bc9e-d1515263ace1"],
    "IRangeValuePatternIdentifiersStatics": ["ce23450f-1c27-457f-b815-7a5e46863dbb"],
    "IRangeValueProvider": ["36dc7aef-33e6-4691-afe1-2be7274b3d33", "838a34a8-7d5f-4079-af03-c3d015e93413"],
    "IRateChangedRoutedEventArgs": ["9016aa6f-3ca8-4c80-8e2f-8851a68f131f"],
    "IRateChangedRoutedEventHandler": ["08e9a257-ae05-489b-8839-28c6225d2349"],
    "IRatedContentDescription": ["694866df-66b2-4dc3-96b1-f090eedee255"],
    "IRatedContentDescriptionFactory": ["2e38df62-9b90-4fa6-89c1-4b8d2ffb3573"],
    "IRatedContentRestrictions": ["3f7f23cb-ba07-4401-a49d-8b9222205723"],
    "IRatedContentRestrictionsFactory": ["fb4b2996-c3bd-4910-9619-97cfd0694d56"],
    "IRatingControl": ["a7d91ca7-e5cf-4963-a24e-9673fe5ffdd5"],
    "IRatingControlAutomationPeer": ["3d14349a-9963-4a47-823c-f457cb3209d5"],
    "IRatingControlAutomationPeerFactory": ["f179f272-9846-4632-8b9c-be6fa8d3c9bb"],
    "IRatingControlFactory": ["18d81716-c542-4ccb-b347-5e62c5db782e"],
    "IRatingControlStatics": ["d062d399-ad85-4c1c-b2c4-35dd4432275e"],
    "IRatingItemFontInfo": ["054723e9-7989-4d5c-9d01-a7eb876f1071"],
    "IRatingItemFontInfoFactory": ["9603fe56-9e9f-40b5-bae1-4481bb73bcd3"],
    "IRatingItemFontInfoStatics": ["fb214f01-6434-4eeb-82ff-7ce5d40bf510"],
    "IRatingItemImageInfo": ["25240e8c-e0d2-490e-b8f8-96c8ee0512b9"],
    "IRatingItemImageInfoFactory": ["269e03f2-da79-4787-9f4a-24a6fa56cde2"],
    "IRatingItemImageInfoStatics": ["8438486b-4b1c-4123-ba0b-73484d68c338"],
    "IRatingItemInfo": ["9ccbe6a2-591e-47a0-a318-6a1f7947da2d"],
    "IRatingItemInfoFactory": ["b0fd43d6-cfec-43c8-9ac5-0b0d5e25d862"],
    "IRawCDImageCreator": ["25983550-9d65-49ce-b335-40630d901227"],
    "IRawCDImageTrackInfo": ["25983551-9d65-49ce-b335-40630d901227"],
    "IRawElementProviderAdviseEvents": ["a407b27b-0f6d-4427-9292-473c7bf93258"],
    "IRawElementProviderFragment": ["f7063da8-8359-439c-9297-bbc5299a7d87"],
    "IRawElementProviderFragmentRoot": ["620ce2a5-ab8f-40a9-86cb-de3c75599b58"],
    "IRawElementProviderHostingAccessibles": ["24be0b07-d37d-487a-98cf-a13ed465e9b3"],
    "IRawElementProviderHwndOverride": ["1d5df27c-8947-4425-b8d9-79787bb460b8"],
    "IRawElementProviderSimple": ["d6dd68d1-86fd-4332-8666-9abedea2d24c"],
    "IRawElementProviderSimple2": ["a0a839a9-8da1-4a82-806a-8e0d44e79f56"],
    "IRawElementProviderSimple3": ["fcf5d820-d7ec-4613-bdf6-42a84ce7daaf"],
    "IRawElementProviderWindowlessSite": ["0a2a93cc-bfad-42ac-9b2e-0991fb0d3ea0"],
    "IRawEnumerator": ["e13613f9-3a3c-40b5-8f48-1e5ebfb9b21b"],
    "IRawGameController": ["7cad6d91-a7e1-4f71-9a78-33e9c5dfea62"],
    "IRawGameController2": ["43c0c035-bb73-4756-a787-3ed6bea617bd"],
    "IRawGameControllerStatics": ["eb8d0792-e95a-4b19-afc7-0a59f8bf759e"],
    "IRawNotification": ["1a227281-3b79-42ac-9963-22ab00d4f0b7"],
    "IRawNotification2": ["e6d0cf19-0c6f-4cdd-9424-eec5be014d26"],
    "IRawNotification3": ["62737dde-8a73-424c-ab44-5635f40a96e5"],
    "IRcsAddress": ["ece4fa8c-c015-42d1-a77c-35171f4684e1"],
    "IRcsCapabilitiesReceivedArgs": ["024fd9e5-c187-4a69-9225-5774404ea1f3"],
    "IRcsEndUserMessage": ["d7cda5eb-cbd7-4f3b-8526-b506dec35c53"],
    "IRcsEndUserMessageAction": ["92378737-9b42-46d3-9d5e-3c1b2dae7cb8"],
    "IRcsEndUserMessageAvailableEventArgs": ["2d45ae01-3f89-41ea-9702-9e9ed411aa98"],
    "IRcsEndUserMessageAvailableTrigger": ["986d0d6a-b2f6-467f-a978-a44091c11a66"],
    "IRcsEndUserMessageAvailableTriggerDetails": ["5b97742d-351f-4692-b41e-1b035dc18986"],
    "IRcsEndUserMessageManager": ["3054ae5a-4d1f-4b59-9433-126c734e86a6"],
    "IRcsManagerStatics": ["7d270ac5-0abd-4f31-9b99-a59e71a7b731"],
    "IRcsManagerStatics2": ["cd49ad18-ad8a-42aa-8eeb-a798a8808959"],
    "IRcsPresenceService": ["9394d478-7c0b-4493-9b99-3a1d9244981d"],
    "IRcsPresenceSettings": ["dd7b70d0-8c2c-41d9-92d9-8ff63499342a"],
    "IRcsPresenceSettings2": ["d38bac8a-4af0-4b59-b6be-08fd640ab9b9"],
    "IRcsPublishCapabilitiesRequestedArgs": ["1f062f50-8973-4cb9-be29-dfa18ad1cac4"],
    "IRcsResource": ["c37fa519-ab14-462d-91c9-3242d174fc72"],
    "IRcsResourceInstance": ["71381418-c4d2-424c-b35c-340e6306785e"],
    "IRcsResourceList": ["79f2a52b-0c12-483a-a06b-5d88f2edfd4b"],
    "IRcsResponse": ["b7ebcf86-6640-4bb4-8192-feb1baa17872"],
    "IRcsService": ["b57094fd-74da-4273-9039-f489abc6ff8d"],
    "IRcsServiceAvailabilityChangedArgs": ["433108b4-1b3f-4033-8d0b-768d78f658a7"],
    "IRcsServiceDescription": ["416437de-e78b-44c9-990f-7ede1f2a0c91"],
    "IRcsServiceKindSupportedChangedEventArgs": ["f47ea244-e783-4866-b3a7-4e5ccf023070"],
    "IRcsServiceStatusChangedArgs": ["661ae45a-412a-460d-bdd4-dd8ea3c15583"],
    "IRcsServiceTuple": ["ce17a39b-2e8b-41af-b5a9-5cb072cc373c"],
    "IRcsSubscriptionReceivedArgs": ["04eaf06d-42bc-46cc-a637-eeb3a8723fe4"],
    "IRcsTransport": ["fea34759-f37c-4319-8546-ec84d21d30ff"],
    "IRcsTransportConfiguration": ["1fccb102-2472-4bb9-9988-c1211c83e8a9"],
    "IReadCookie": ["71eaf260-0ce0-11d0-a53e-00a0c90c2091"],
    "IReadData": ["0c733a6a-2a1c-11ce-ade5-00aa0044773d"],
    "IReadRecordCompletion": ["5a8c7c5f-aace-47b8-b38b-41785a9fc090"],
    "IReaderSetPosition": ["327e23a0-0396-4844-bebe-c253cd98a7f2"],
    "IReadingModeExtractedContent": ["4b1e9ec3-4e15-49d2-a473-885c5f2340fc"],
    "IRealTimeStylus": ["a8bb5d22-3144-4a7b-93cd-f34a16be513a"],
    "IRealTimeStylus2": ["b5f2a6cd-3179-4a3e-b9c4-bb5865962be2"],
    "IRealTimeStylus3": ["d70230a3-6986-4051-b57a-1cf69f4d9db5"],
    "IRealTimeStylusSynchronization": ["aa87eab8-ab4a-4cea-b5cb-46d84c6a2509"],
    "IRealizedItemArray": ["e5a09dd9-fd24-4686-b610-dc9961f8c4f1"],
    "IRealmActivationHistory": ["67136e8b-6914-43f0-8f25-05619927d22e"],
    "IRebootNeededEventHandler": ["64e12a45-973b-4a3a-b260-91898a49a82c"],
    "IReceiptOrSlipJob": ["532199be-c8c3-4dc2-89e9-5c4a37b34ddc"],
    "IReceiptPrintJob": ["aa96066e-acad-4b79-9d0f-c0cfc08dc77b"],
    "IReceiptPrintJob2": ["0cbc12e3-9e29-5179-bcd8-1811d3b9a10e"],
    "IReceiptPrinterCapabilities": ["b8f0b58f-51a8-43fc-9bd5-8de272a6415b"],
    "IReceiptPrinterCapabilities2": ["20030638-8a2c-55ac-9a7b-7576d8869e99"],
    "IRecordLimitationExceededEventHandler": ["3fae8f2e-4fe1-4ffd-aaba-e1f1337d4e53"],
    "IRecordQueueManager": ["2cf750a1-1bc2-44ed-a4ac-6e5ca3ae99de"],
    "IRecoverableError": ["0f5625e8-0a7b-45ee-9637-1ce13645909e"],
    "IRecoverableErrorData": ["b37c4a0a-4b7d-4c2d-9711-3b00d119b1c8"],
    "IRecoveryDataClient": ["79e40311-0a9d-4507-a351-aa290a3e18c5"],
    "IRecoveryStore": ["5c333b75-a015-4564-8bf3-998ccc4ff9f5"],
    "IRectHelper": ["a38781e2-4bfb-4ee2-afe5-89f31b37478d"],
    "IRectHelperStatics": ["5ee163e4-c17e-494f-b580-2f0574fc3a15"],
    "IRectangle": ["855bc230-8a11-4e18-a136-4bc21c7827b0"],
    "IRectangleGeometry": ["a25a1f58-c575-4196-91cf-9fdfb10445c3"],
    "IRectangleGeometryStatics": ["377f8dba-7902-48e3-83be-7c8002a6653c"],
    "IRectangleStatics": ["9f25aa53-bb3a-4c3c-89db-6fbc0d1fa0cc"],
    "IRedialRequestedEventArgs": ["7eb55209-76ab-4c31-b40e-4b58379d580c"],
    "IRedialRequestedEventHandler": ["baf257d1-4ebd-4b84-9f47-6ec43d75d8b1"],
    "IRedirectVisual": ["8cc6e340-8b75-5422-b06f-09ffe9f8617e"],
    "IRedirectedMoniker": ["bdebbf02-c265-11d0-bced-00a0c90ab50f"],
    "IReentrancyModelProvider": ["ca2fd3fd-f4f1-489a-8c67-a0695632105f"],
    "IRefCountedClosable": ["f4ee3175-aba2-4df7-b53c-93c4e4e2b0a3"],
    "IReferenceAppId": ["054f0bef-9e45-4363-8f5a-2f8e142d9a3b"],
    "IReferenceClockTimerControl": ["ebec459c-2eca-4d42-a8af-30df557614b8"],
    "IReferenceIdentity": ["6eaf5ace-7917-4f3c-b129-e046a9704766"],
    "IReferenceInfo": ["b9a32c92-b14d-4ae3-a955-5cbc3e75fca5"],
    "IReferenceInfo2": ["e316ff6d-ca00-49dd-969f-441399132ac7"],
    "IReferenceTracker": ["11d3b13a-180e-4789-a8be-7712882893e6"],
    "IReferenceTrackerExtension": ["4e897caa-59d5-4613-8f8c-f7ebd1f399b0"],
    "IReferenceTrackerHost": ["29a71c6a-3c42-4416-a39d-e2825a07a773"],
    "IReferenceTrackerManager": ["3cf184b4-7ccb-4dda-8455-7e6ce99a3298"],
    "IReferenceTrackerTarget": ["64bd43f8-bfee-4ec4-b7eb-2935158dae21"],
    "IRefreshCompletion": ["ffecd0a8-9c64-464b-ae2b-6613a71c812b"],
    "IRefreshContainer": ["535dc413-b1d5-43c1-b057-8658ce1e0ba2"],
    "IRefreshContainerFactory": ["0a04777f-089e-4239-baeb-c4641484c37e"],
    "IRefreshContainerStatics": ["a20af5a5-7015-475d-9de3-81a0479dda38"],
    "IRefreshInteractionRatioChangedEventArgs": ["d7e47820-dc47-4b8e-bb27-7f0a83f29a07"],
    "IRefreshRequestedEventArgs": ["1b089f43-cfcf-4ac6-b31f-8dab6eefdd93"],
    "IRefreshStateChangedEventArgs": ["bb6c901e-21fe-4109-af80-73ec661b678a"],
    "IRefreshTileNotifications": ["cf7a6ffc-5a5d-4153-9d9d-9946b57e45fa"],
    "IRefreshVisualizer": ["c0e30122-f3eb-4baa-a11f-c3f87342cbf4"],
    "IRefreshVisualizerFactory": ["6f5c6132-6e09-4c10-824a-127d36672715"],
    "IRefreshVisualizerStatics": ["afea56af-362a-4015-b155-733a1f869831"],
    "IRegNode": ["578b6a8e-628c-11cf-9dd9-00aa00b6770a"],
    "IRegNodeDispenser": ["578b6a92-628c-11cf-9dd9-00aa00b6770a"],
    "IRegionOfInterest": ["e5ecc834-ce66-4e05-a78f-cf391a5ec2d1"],
    "IRegionOfInterest2": ["19fe2a91-73aa-4d51-8a9d-56ccf7db7f54"],
    "IRegionsOfInterestControl": ["c323f527-ab0b-4558-8b5b-df5693db0378"],
    "IRegisterPackageOptions": ["677112a7-50d4-496c-8415-0602b4c6d3bf"],
    "IRegisterProvider": ["0c733ab9-2a1c-11ce-ade5-00aa0044773d"],
    "IRegisterServiceProvider": ["7b3a2f01-0751-48dd-b556-004785171c54"],
    "IRegisterSuspendNotify": ["953c92df-3741-4bb4-9979-c618d6fe0af2"],
    "IRegisterTuner": ["359b3901-572c-4854-bb49-cdef66606a25"],
    "IRegisteredClientInfo": ["a065f92a-d9d3-4c99-b8b2-f20a2585a93c"],
    "IRegisteredSyncProvider": ["913bcf76-47c1-40b5-a896-5e8a9c414c14"],
    "IRegisteredTask": ["9c86f320-dee3-4dd1-b972-a303f26b061e"],
    "IRegisteredTaskCollection": ["86627eb4-42a7-41e4-a4d9-ac33a72f2d52"],
    "IRegistrarBase": ["e21f8a85-b05d-4243-8183-c7cb405588f7"],
    "IRegistration": ["430be197-0244-2f7b-80fd-c7c473983ad0"],
    "IRegistrationInfo": ["416d8b73-cb41-4ea1-805c-9be9a5ac4a74"],
    "IRegistrationTrigger": ["4c8fec3a-c218-4e0c-b23d-629024db91a2"],
    "IRegistryHandlerCallback": ["dc2d1459-6b4d-4bb6-a6a3-ecd1d85a0436"],
    "IRegistrySettingMonitor": ["da20a234-8556-4f31-8c0e-c6818228c262"],
    "IRelatedItem": ["a73ce67a-8ab1-44f1-8d43-d2fcbf6b1cd0"],
    "IRelationship": ["2769280b-5108-498c-9c7f-a51239b63147"],
    "IRelativePanel": ["2eabfaeb-b35a-4035-acea-3c4a3730683f"],
    "IRelativePanel2": ["c09bd88c-1e82-53b3-8c01-7d0432f5f7db"],
    "IRelativePanelFactory": ["8460193c-361b-44ba-a17e-b84c9dcdc772"],
    "IRelativePanelStatics": ["15903c27-f18c-4c35-8e19-6a7459d907b6"],
    "IRelativePanelStatics2": ["8d6b3444-5fbc-5d8b-8b46-22176f21fa8e"],
    "IRelativeSource": ["2397ce84-2822-483a-b499-d0f031e06c6b"],
    "IRelativeSourceFactory": ["ef8392cd-446e-4f93-aacb-9b1255577460"],
    "IRelocateFolderInNamespace": ["cd9617e6-e67f-4f7b-8b64-11b05f507868"],
    "IRemUnknown": ["00000131-0000-0000-c000-000000000046"],
    "IRemUnknown2": ["00000143-0000-0000-c000-000000000046"],
    "IRemUnknownN": ["0000013c-0000-0000-c000-000000000046"],
    "IRemoteAppBrokerFactory": ["8982be9d-1779-4400-a6ab-c69244842534"],
    "IRemoteAppImmersiveIconBroker": ["ed2a7c9d-e4ee-4bb9-8d5d-9aca0a60486e"],
    "IRemoteAppPrivilegedOperationBroker": ["f9dbd15e-c7b9-4992-9ebe-b4fb20bc4235"],
    "IRemoteComponentUtil": ["6eb22875-8a19-11d0-81b6-00a0c9231c29"],
    "IRemoteDebugApplication110": ["d5fe005b-2836-485e-b1f9-89d91aa24fd4"],
    "IRemoteDebugCriticalErrorEvent110": ["2f69c611-6b14-47e8-9260-4bb7c52f504b"],
    "IRemoteDebugInfoEvent110": ["9ff56bb6-eb89-4c0f-8823-cc2a4c0b7f26"],
    "IRemoteDesktopClient": ["57d25668-625a-4905-be4e-304caa13f89c"],
    "IRemoteDesktopClientActions": ["7d54bc4e-1028-45d4-8b0a-b9b6bffba176"],
    "IRemoteDesktopClientSettings": ["48a0f2a7-2713-431f-bbac-6f4558e7d64d"],
    "IRemoteDesktopClientTouchPointer": ["260ec22d-8cbc-44b5-9e88-2a37f6c93ae9"],
    "IRemoteHelper": ["cb46e850-fc2f-11d2-b126-00805fc73204"],
    "IRemoteInterfaceCallbackEvent": ["c50a4804-7a31-4c81-9ab7-e66082f79956"],
    "IRemoteInterfaceCallbackRemoval": ["ee9baeed-b8d7-4097-be80-042df78ffbfd"],
    "IRemoteLauncherOptions": ["9e3a2788-2891-4cdf-a2d6-9dff7d02e693"],
    "IRemoteLauncherStatics": ["d7db7a93-a30c-48b7-9f21-051026a4e517"],
    "IRemoteParticipantComposingChangedEventArgs": ["1ec045a7-cfc9-45c9-9876-449f2bc180f5"],
    "IRemoteProviderSyncPolicy": ["c712098b-a0d3-402c-bd23-bbd36d670067"],
    "IRemoteProviderSyncSetup": ["0a4bb2df-8295-4fe0-a3b1-dbd1f4700d31"],
    "IRemoteProviderSystemSyncPolicy": ["b611c37e-7728-4a08-ad93-aa853ce21c7b"],
    "IRemoteProxyFactory": ["8628f27d-64a2-4ed6-906b-e6155314c16a"],
    "IRemoteSystem": ["ed5838cd-1e10-4a8c-b4a6-4e5fd6f97721"],
    "IRemoteSystem2": ["09dfe4ec-fb8b-4a08-a758-6876435d769e"],
    "IRemoteSystem3": ["72b4b495-b7c6-40be-831b-73562f12ffa8"],
    "IRemoteSystem4": ["f164ffe5-b987-4ca5-9926-fa0438be6273"],
    "IRemoteSystem5": ["eb2ad723-e5e2-4ae2-a7a7-a1097a098e90"],
    "IRemoteSystem6": ["d4cda942-c027-533e-9384-3a19b4f7eef3"],
    "IRemoteSystemAddedEventArgs": ["8f39560f-e534-4697-8836-7abea151516e"],
    "IRemoteSystemAdditionalInfoProvider": ["eeaa3d5f-ec63-4d27-af38-e86b1d7292cb"],
    "IRemoteSystemApp": ["80e5bcbd-d54d-41b1-9b16-6810a871ed4f"],
    "IRemoteSystemApp2": ["6369bf15-0a96-577a-8ff6-c35904dfa8f3"],
    "IRemoteSystemAppRegistration": ["b47947b5-7035-4a5a-b8df-962d8f8431f4"],
    "IRemoteSystemAppRegistrationStatics": ["01b99840-cfd2-453f-ae25-c2539f086afd"],
    "IRemoteSystemAuthorizationKindFilter": ["6b0dde8e-04d0-40f4-a27f-c2acbbd6b734"],
    "IRemoteSystemAuthorizationKindFilterFactory": ["ad65df4d-b66a-45a4-8177-8caed75d9e5a"],
    "IRemoteSystemConnectionInfo": ["23278bc3-0d09-52cb-9c6a-eed2940bee43"],
    "IRemoteSystemConnectionInfoStatics": ["ac831e2d-66c5-56d7-a4ce-705d94925ad6"],
    "IRemoteSystemConnectionRequest": ["84ed4104-8d5e-4d72-8238-7621576c7a67"],
    "IRemoteSystemConnectionRequest2": ["12df6d6f-bffc-483a-8abe-d34a6c19f92b"],
    "IRemoteSystemConnectionRequest3": ["de86c3e7-c9cc-5a50-b8d9-ba7b34bb8d0e"],
    "IRemoteSystemConnectionRequestFactory": ["aa0a0a20-baeb-4575-b530-810bb9786334"],
    "IRemoteSystemConnectionRequestStatics": ["86ca143d-8214-425c-8932-db49032d1306"],
    "IRemoteSystemConnectionRequestStatics2": ["460f1027-64ec-598e-a800-4f2ee58def19"],
    "IRemoteSystemDiscoveryTypeFilter": ["42d9041f-ee5a-43da-ac6a-6fee25460741"],
    "IRemoteSystemDiscoveryTypeFilterFactory": ["9f9eb993-c260-4161-92f2-9c021f23fe5d"],
    "IRemoteSystemEnumerationCompletedEventArgs": ["c6e83d5f-4030-4354-a060-14f1b22c545d"],
    "IRemoteSystemFilter": ["4a3ba9e4-99eb-45eb-ba16-0367728ff374"],
    "IRemoteSystemKindFilter": ["38e1c9ec-22c3-4ef6-901a-bbb1c7aad4ed"],
    "IRemoteSystemKindFilterFactory": ["a1fb18ee-99ea-40bc-9a39-c670aa804a28"],
    "IRemoteSystemKindStatics": ["f6317633-ab14-41d0-9553-796aadb882db"],
    "IRemoteSystemKindStatics2": ["b9e3a3d0-0466-4749-91e8-65f9d19a96a5"],
    "IRemoteSystemRemovedEventArgs": ["8b3d16bb-7306-49ea-b7df-67d5714cb013"],
    "IRemoteSystemSession": ["69476a01-9ada-490f-9549-d31cb14c9e95"],
    "IRemoteSystemSessionAddedEventArgs": ["d585d754-bc97-4c39-99b4-beca76e04c3f"],
    "IRemoteSystemSessionController": ["e48b2dd2-6820-4867-b425-d89c0a3ef7ba"],
    "IRemoteSystemSessionControllerFactory": ["bfcc2f6b-ac3d-4199-82cd-6670a773ef2e"],
    "IRemoteSystemSessionCreationResult": ["a79812c2-37de-448c-8b83-a30aa3c4ead6"],
    "IRemoteSystemSessionDisconnectedEventArgs": ["de0bc69b-77c5-461c-8209-7c6c5d3111ab"],
    "IRemoteSystemSessionInfo": ["ff4df648-8b0a-4e9a-9905-69e4b841c588"],
    "IRemoteSystemSessionInvitation": ["3e32cc91-51d7-4766-a121-25516c3b8294"],
    "IRemoteSystemSessionInvitationListener": ["08f4003f-bc71-49e1-874a-31ddff9a27b9"],
    "IRemoteSystemSessionInvitationReceivedEventArgs": ["5e964a2d-a10d-4edb-8dea-54d20ac19543"],
    "IRemoteSystemSessionJoinRequest": ["20600068-7994-4331-86d1-d89d882585ee"],
    "IRemoteSystemSessionJoinRequestedEventArgs": ["dbca4fc3-82b9-4816-9c24-e40e61774bd8"],
    "IRemoteSystemSessionJoinResult": ["ce7b1f04-a03e-41a4-900b-1e79328c1267"],
    "IRemoteSystemSessionMessageChannel": ["9524d12a-73d9-4c10-b751-c26784437127"],
    "IRemoteSystemSessionMessageChannelFactory": ["295e1c4a-bd16-4298-b7ce-415482b0e11d"],
    "IRemoteSystemSessionOptions": ["740ed755-8418-4f01-9353-e21c9ecc6cfc"],
    "IRemoteSystemSessionParticipant": ["7e90058c-acf9-4729-8a17-44e7baed5dcc"],
    "IRemoteSystemSessionParticipantAddedEventArgs": ["d35a57d8-c9a1-4bb7-b6b0-79bb91adf93d"],
    "IRemoteSystemSessionParticipantRemovedEventArgs": ["866ef088-de68-4abf-88a1-f90d16274192"],
    "IRemoteSystemSessionParticipantWatcher": ["dcdd02cc-aa87-4d79-b6cc-4459b3e92075"],
    "IRemoteSystemSessionRemovedEventArgs": ["af82914e-39a1-4dea-9d63-43798d5bbbd0"],
    "IRemoteSystemSessionStatics": ["8524899f-fd20-44e3-9565-e75a3b14c66e"],
    "IRemoteSystemSessionUpdatedEventArgs": ["16875069-231e-4c91-8ec8-b3a39d9e55a3"],
    "IRemoteSystemSessionValueSetReceivedEventArgs": ["06f31785-2da5-4e58-a78f-9e8d0784ee25"],
    "IRemoteSystemSessionWatcher": ["8003e340-0c41-4a62-b6d7-bdbe2b19be2d"],
    "IRemoteSystemStatics": ["a485b392-ff2b-4b47-be62-743f2f140f30"],
    "IRemoteSystemStatics2": ["0c98edca-6f99-4c52-a272-ea4f36471744"],
    "IRemoteSystemStatics3": ["9995f16f-0b3c-5ac5-b325-cc73f437dfcd"],
    "IRemoteSystemStatusTypeFilter": ["0c39514e-cbb6-4777-8534-2e0c521affa2"],
    "IRemoteSystemStatusTypeFilterFactory": ["33cf78fa-d724-4125-ac7a-8d281e44c949"],
    "IRemoteSystemUpdatedEventArgs": ["7502ff0e-dbcb-4155-b4ca-b30a04f27627"],
    "IRemoteSystemWatcher": ["5d600c7e-2c07-48c5-889c-455d2b099771"],
    "IRemoteSystemWatcher2": ["73436700-19ca-48f9-a4cd-780f7ad58c71"],
    "IRemoteSystemWatcher3": ["f79c0fcf-a913-55d3-8413-418fcf15ba54"],
    "IRemoteSystemWatcherErrorOccurredEventArgs": ["74c5c6af-5114-4426-9216-20d81f8519ae"],
    "IRemoteSystemWebAccountFilter": ["3fb75873-87c8-5d8f-977e-f69f96d67238"],
    "IRemoteSystemWebAccountFilterFactory": ["348a2709-5f4d-5127-b4a7-bf99d5252b1b"],
    "IRemoteTargetCallbackRemoval": ["b3a0d163-c4dd-49cc-aed2-ff5205c67ce1"],
    "IRemoteVideoStream": ["71ec305f-7cad-4bbf-953a-810db7d68d4c"],
    "IRemoveAppointmentOperation": ["08b66aba-fe33-46cd-a50c-a8ffb3260537"],
    "IRemoveLicensesForReasons": ["793dd932-318d-449b-b9b0-4bd2dfa146d9"],
    "IRenMailEditor": ["000670ba-0000-0000-c000-000000000046"],
    "IRenVersionCheck": ["3f9df312-78ee-11d2-83b9-0060b0ec0dff"],
    "IRenderEngine": ["6bee3a81-66c9-11d2-918f-00c0df10d434"],
    "IRenderEngine2": ["6bee3a82-66c9-11d2-918f-00c0df10d434"],
    "IRenderTargetBitmap": ["500dee81-893c-4c0a-8fec-4678ac717589"],
    "IRenderTargetBitmapStatics": ["f0a1efee-c131-4d40-9c47-f7d7cf2b077f"],
    "IRenderedEventArgs": ["e349817d-81c7-4938-828c-a7e2797b35a6"],
    "IRenderingDeviceReplacedEventArgs": ["3a31ac7d-28bf-4e7a-8524-71679d480f38"],
    "IRenderingEventArgs": ["5bf7d30d-9748-4aed-8380-d7890eb776a0"],
    "IRenderingParametersUpdateHandler": ["3a2d9d45-72e9-4311-b46c-27c8bb7e6cb3"],
    "IRendezvousApplication": ["4f4d070b-a275-49fb-b10d-8ec26387b50d"],
    "IRendezvousSession": ["9ba4b1dd-8b0c-48b7-9e7c-2f25857c8df5"],
    "IRenewComponent": ["2c574fa0-483f-42bc-8d18-79d00c1b5190"],
    "IRenewalStatusCallback": ["496bca77-fea8-40b7-be65-90d9502c45fe"],
    "IReorderThemeTransition": ["f2065c6c-d052-4ad1-8362-b71b36df7497"],
    "IRepeatBehaviorHelper": ["6863ab72-4997-47f9-87ad-37efb75993ea"],
    "IRepeatBehaviorHelperStatics": ["7a795033-79f3-4dd9-b267-9cf50fb51f84"],
    "IRepeatButton": ["02200df9-021a-484a-a93b-0f31020314e5"],
    "IRepeatButtonAutomationPeer": ["29e41ad5-a8ac-4e8a-83d8-09e37e054257"],
    "IRepeatButtonAutomationPeerFactory": ["6a6ff9d4-575e-4e60-bdd6-ec14419b4ff6"],
    "IRepeatButtonStatics": ["3914ac4e-f462-4f73-8197-e8846639c682"],
    "IRepetitionPattern": ["7fb9acf1-26be-400e-85b5-294b9c75dfd6"],
    "IReplaceAppointmentOperation": ["f4903d9b-9e61-4de2-a732-2687c07d1de8"],
    "IReplaceClassInfo": ["000001fb-0000-0000-c000-000000000046"],
    "IReplica": ["d2d139e0-b6ca-11d1-9f31-00c04fc29d52"],
    "IReplicaKeyMap": ["2209f4fc-fd10-4ff0-84a8-f0a1982e440e"],
    "IRepositionThemeAnimation": ["ecda24e8-8945-4949-a1bf-62109965a7e9"],
    "IRepositionThemeAnimationStatics": ["4d92b1b1-860b-4bf9-a59d-1eb1ccbe8fe0"],
    "IRepositionThemeTransition": ["88329b82-98f3-455a-ac53-2e7083b6e22c"],
    "IRepositionThemeTransition2": ["cebfe864-dbea-4404-8e6e-de55ada75239"],
    "IRepositionThemeTransitionStatics2": ["9240e930-0a19-468b-8c2a-68fab4500027"],
    "IRequestCallbackCancel": ["4e9f1a77-4587-4235-81c4-e6d24545a656"],
    "IRequestCallbackRequestCompletion": ["8a7cc8cb-ceb2-46f6-9851-77bd347a15c2"],
    "IRequestDictionary": ["d97a6da0-a85f-11df-83ae-00a0c90c2bd8"],
    "IRequestFilteredSync": ["2e020184-6d18-46a7-a32a-da4aeb06696c"],
    "IRequestTrustedComponentForegroundControlInitialization": ["2a239388-fc85-4077-981e-9e4205cf9451"],
    "IRequireClasses": ["6d5140d0-7436-11ce-8034-00aa006009fa"],
    "IResetUserProfileCallback": ["4d725739-9aa4-4006-bbbe-109cc5a9a68a"],
    "IResizable": ["04c419df-6369-4b13-8d6f-25992cb3feeb"],
    "IResize": ["4ada63a0-72d5-11d2-952a-0060081840bc"],
    "IResolutionChangeEventArgs": ["01f51655-5e82-4d53-bed4-ee2551467495"],
    "IResolveSettingConflict": ["89b59b87-4e36-4bdb-88ff-0fd2982bb5e4"],
    "IResolveSidToUserName": ["d550d193-668c-47e2-a512-fbed58fd82bc"],
    "IResourceCandidate": ["af5207d9-c433-4764-b3fd-8fa6bfbcbadc", "f98ce1cb-901b-41f4-bf42-83d51895e1e2"],
    "IResourceCandidate2": ["69e5b468-f6fc-4013-aaa2-d53f1757d3b5", "8c09fa9c-1846-4e32-b36c-93e2b94395cf"],
    "IResourceCandidate3": ["08ae97f8-517a-4674-958c-4a3c7cd2cc6b"],
    "IResourceCandidateCollection": ["5ec76092-dc01-4023-94f5-2000564d2c47"],
    "IResourceCollection": ["7f5fd609-bc88-41d4-88fa-3de6704d428e"],
    "IResourceContext": ["2fa22f4b-707e-4b27-ad0d-d0d8cd468fd2", "e3c22b30-8502-4b2f-9133-559674587e51"],
    "IResourceContext2": ["50c5bea6-0bf1-4829-9945-920c64f27eb5"],
    "IResourceContext3": ["998cae81-2106-4253-9c01-1c0db7b69f84"],
    "IResourceContextStatics": ["98be9d6c-6338-4b31-99df-b2b442f17149"],
    "IResourceContextStatics2": ["41f752ef-12af-41b9-ab36-b1eb4b512460"],
    "IResourceContextStatics3": ["20cf492c-af0f-450b-9da6-106dd0c29a39"],
    "IResourceContextStatics4": ["22eb9ccd-fb31-4bfa-b86b-df9d9d7bdc39"],
    "IResourceDictionary": ["c1ea4f24-d6de-4191-8e3a-f48601f7489c"],
    "IResourceDictionaryFactory": ["ea3639b5-31b7-4271-92c9-7c9584a91c22"],
    "IResourceDispenserEvents": ["5ecd5352-f4bb-11d1-93ae-00aa00ba3258"],
    "IResourceGates": ["7a0ddd93-7198-4e15-bbd7-427c77b6907a"],
    "IResourceList": ["22c6ac60-851b-11d0-9a7f-00aa0038acfe"],
    "IResourceLoader": ["08524908-16ef-45ad-a602-293637d7e61a"],
    "IResourceLoader2": ["10eb6ec6-8138-48c1-bc65-e1f14207367c"],
    "IResourceLoaderFactory": ["c33a3603-69dc-4285-a077-d5c0e47ccbe8"],
    "IResourceLoaderStatics": ["bf777ce1-19c8-49c2-953c-47e9227b334e"],
    "IResourceLoaderStatics2": ["0cc04141-6466-4989-9494-0b82dfc53f1f"],
    "IResourceLoaderStatics3": ["64609dfb-64ac-491b-8100-0e558d61c1d0"],
    "IResourceManager2": ["9d66fe6c-a4d7-4c23-9e85-675f304c252d", "d136c69a-f749-11d1-8f47-00c04f8ee57d"],
    "IResourceManagerFactory": ["13741d20-87eb-11ce-8081-0080c758527e"],
    "IResourceManagerFactory2": ["6b369c21-fbd2-11d1-8f47-00c04f8ee57d"],
    "IResourceManagerQueue": ["db3c3f20-e4c9-4dca-81a9-a69ebe2a0b2b"],
    "IResourceManagerRejoinable": ["6f6de620-b5df-4f3e-9cfa-c8aebd05172b"],
    "IResourceManagerSink": ["0d563181-defb-11ce-aed1-00aa0051e2c4"],
    "IResourceManagerStatics": ["1cc0fdfc-69ee-4e43-9901-47f12687baf7"],
    "IResourceMap": ["6e21e72b-b9b0-42ae-a686-983cf784edcd", "72284824-db8c-42f8-b08c-53ff357dad82"],
    "IResourceMap2": ["2fe6ec6e-da7e-4b2a-a8f9-90b289061f20"],
    "IResourceMap3": ["cd192776-f66c-42d8-a549-2c5ae0f3a348"],
    "IResourcePolicySite": ["30510867-98b5-11cf-bb82-00aa00bdce0b"],
    "IResourceQualifier": ["785da5b2-4afd-4376-a888-c5f9a6b7a05c"],
    "IResourceReferenceHandler": ["bff55471-5bc4-4a95-a700-38bfa4b897ef"],
    "IResourceString": ["cd75217d-5bf1-4056-9253-71d9c57d2b06"],
    "IResourceStringFactory": ["111ba2ad-ece9-4fee-8168-e94f290cc451"],
    "IResourceStringView": ["e433a2d7-aab7-4749-a66c-1530941ac47b"],
    "IResourceValidator": ["7bb324ba-6dfe-4551-945f-935e101ecb96"],
    "IResponse": ["d97a6da0-a864-11cf-83be-00a0c90c2bd8"],
    "IResponseInformation": ["f8bb9a12-f713-4792-8b68-d9d297f91d2e"],
    "IRestrictedErrorInfo": ["82ba7092-4c88-427d-a7bc-16dd93feb67e"],
    "IRestrictedErrorInfoContext": ["22bf789e-94f7-460f-a389-d1fa18649749"],
    "IRestrictedErrorInfoTelemetry": ["085d9604-befe-4508-a81c-a2d5a0b2b9e0"],
    "IRestrictedLaunchActivatedEventArgs": ["e0b7ac81-bfc3-4344-a5da-19fd5a27baae"],
    "IResultHandlerFactory": ["19a7b8ee-98ad-46f2-960e-db2d07b6e415"],
    "IResultSetFactory": ["8e621d2b-5a4c-450c-8b78-c7f52c1f1d9b"],
    "IResultSetManager": ["d3b521a9-64fb-463e-b2cd-6ebbd1c50330"],
    "IResultShape": ["6bc63938-8254-4965-9680-565933185060"],
    "IResultsDialogService": ["1bb76738-1855-4f57-9ff6-67dc3d945bb6"],
    "IResultsFolder": ["96e5ae6d-6ae1-4b1c-900c-c6480eaa8828"],
    "IResultsFolderEx": ["5597a5cf-8f40-4609-9027-8923aad78bee"],
    "IResumingEventHandler": ["26599ba9-a22d-4806-a728-acadc1d075fa"],
    "IRetQueueInfo": ["000001f1-0000-0000-c000-000000000046"],
    "IRetailDemoHost": ["7ccad97f-82ef-4058-b847-a0c5b8a300f6"],
    "IRetailInfoStatics": ["0712c6b8-8b92-4f2a-8499-031f1798d6ef"],
    "IRetrieveViewCUIEventHandle": ["c627f5bc-391f-403b-9af5-7f749012fddb"],
    "IReuseContext": ["41cf3777-6dc4-4999-83a7-b229b8326d67"],
    "IRevealBackgroundBrush": ["261dcc0e-1991-4cdf-aee0-6350a3f90bb9"],
    "IRevealBackgroundBrushFactory": ["8c56bcaa-02a5-4f45-8506-8d39228f5d3f"],
    "IRevealBorderBrush": ["060ba115-c542-483c-8202-5f03331866c9"],
    "IRevealBorderBrushFactory": ["94c25298-f5f8-4482-a25c-6758501a8626"],
    "IRevealBrush": ["2036a0ed-8271-4398-9019-25872093f13f"],
    "IRevealBrushFactory": ["9d9379ce-e3a0-4aaf-be37-ea9d9dd43105"],
    "IRevealBrushStatics": ["190f2625-7209-4d42-a847-1ac4bbbb3499"],
    "IReverbEffectDefinition": ["4606aa89-f563-4d0a-8f6e-f0cddff35d84"],
    "IReverbEffectDefinitionFactory": ["a7d5cbfe-100b-4ff0-9da6-dc4e05a759f0"],
    "IRevocationAndRenewalInformation": ["f3a1937b-2501-439e-a6e7-6fc95e175fcf"],
    "IRevocationAndRenewalItem": ["3099c20c-3cf0-49ea-902d-caf32d2dde2c"],
    "IRfcommConnectionTrigger": ["e8c4cae2-0b53-4464-9394-fd875654de64"],
    "IRfcommConnectionTriggerDetails": ["f922734d-2e3c-4efc-ab59-fc5cf96f97e3"],
    "IRfcommDeviceService": ["ae81ff1f-c5a1-4c40-8c28-f3efd69062f3"],
    "IRfcommDeviceService2": ["536ced14-ebcd-49fe-bf9f-40efc689b20d"],
    "IRfcommDeviceService3": ["1c22ace6-dd44-4d23-866d-8f3486ee6490"],
    "IRfcommDeviceServiceStatics": ["a4a149ef-626d-41ac-b253-87ac5c27e28a"],
    "IRfcommDeviceServiceStatics2": ["aa8cb1c9-e78d-4be4-8076-0a3d87a0a05f"],
    "IRfcommDeviceServicesResult": ["3b48388c-7ccf-488e-9625-d259a5732d55"],
    "IRfcommInboundConnectionInformation": ["6d3e75a8-5429-4059-92e3-1e8b65528707"],
    "IRfcommOutboundConnectionInformation": ["b091227b-f434-4cb0-99b1-4ab8cedaedd7"],
    "IRfcommServiceId": ["22629204-7e02-4017-8136-da1b6a1b9bbf"],
    "IRfcommServiceIdStatics": ["2a179eba-a975-46e3-b56b-08ffd783a5fe"],
    "IRfcommServiceProvider": ["eadbfdc4-b1f6-44ff-9f7c-e7a82ab86821"],
    "IRfcommServiceProvider2": ["736bdfc6-3c81-4d1e-baf2-ddbb81284512"],
    "IRfcommServiceProviderStatics": ["98888303-69ca-413a-84f7-4344c7292997"],
    "IRibbonTabsetCallBack": ["f66724ea-ae8f-41a2-b3f3-3d6581ea891c"],
    "IRichChunk": ["4fdef69c-dbc9-454e-9910-b34f3c64b510"],
    "IRichEditBox": ["90a57a40-80b6-4fce-b1ec-e3c616284b6a"],
    "IRichEditBox2": ["bbea6ead-e805-47a4-bbe7-47e59b8f74a7"],
    "IRichEditBox3": ["6b17a462-fbb6-4fff-9991-9399cb9c0b90"],
    "IRichEditBox4": ["5caa8d35-c838-4bad-a07c-204183bb751f"],
    "IRichEditBox5": ["a66d9cea-6391-4f3b-9fd3-1fd01f49f327"],
    "IRichEditBox6": ["0c89d500-e8d8-4eae-8804-33649205d7d2"],
    "IRichEditBox7": ["980c93ea-241f-4f6a-a539-9d185c8cf18a"],
    "IRichEditBox8": ["a098e0b8-18e2-513e-9d8d-4e9703410c03"],
    "IRichEditBoxAutomationPeer": ["c69f5c04-16ee-467a-a833-c3da8458ad64"],
    "IRichEditBoxAutomationPeerFactory": ["752c8399-d296-4d87-9020-a4750e885b3c"],
    "IRichEditBoxFactory": ["61a1df62-2806-41ed-88ed-ae21f47ab422"],
    "IRichEditBoxSelectionChangingEventArgs": ["90e0035c-e8b8-5c33-9896-4e989d65829c"],
    "IRichEditBoxStatics": ["f5e03a74-88ea-479b-9a05-37089ff30ede"],
    "IRichEditBoxStatics2": ["e3eb26de-2748-420b-b1fc-ce95b6e85eec"],
    "IRichEditBoxStatics3": ["6d17eec5-1fb3-4c8b-aa23-f5e15d6ab64e"],
    "IRichEditBoxStatics4": ["f5d54fd7-7796-42a5-a5e5-2cd211ee8176"],
    "IRichEditBoxStatics5": ["4b5c4568-43d5-43e6-bbb9-cb4e6250f45a"],
    "IRichEditBoxStatics6": ["fe40e287-82ed-4f7e-92ba-66f67bc1ff44"],
    "IRichEditBoxStatics7": ["59fa898f-f861-43da-a7ce-4b9c21d835f9"],
    "IRichEditBoxStatics8": ["58045172-106b-56a9-a8e4-4b74bf347d4e"],
    "IRichEditBoxTextChangingEventArgs": ["54065018-2813-4922-9f8e-b6bbafd995d8"],
    "IRichEditBoxTextChangingEventArgs2": ["395b0db5-636e-413e-9eb4-fc22ebfa3628"],
    "IRichEditDO": ["21bc3b20-e5d5-11cf-93e1-00aa00b65ea1"],
    "IRichEditTextRange": ["374e3515-ba8a-4a6e-8c59-0dde3d0cf5cd"],
    "IRichEditUiaInformation": ["23969a9d-8546-4032-a1bb-73750cbf3333"],
    "IRichTextBlock": ["e5fff9e2-b968-49e7-97d4-8cca2ac3ae7c"],
    "IRichTextBlock2": ["3f209013-03e7-4508-964a-91aedab3d11e"],
    "IRichTextBlock3": ["7d39ae83-8918-4613-b007-7c898ba2950e"],
    "IRichTextBlock4": ["3577c1ea-24fd-4f50-bbe4-3fb654ea58c5"],
    "IRichTextBlock5": ["9c7dc0c6-7a9f-45b6-8818-822c549ba094"],
    "IRichTextBlock6": ["ae9010cd-e899-526e-927e-88e0eed693c8"],
    "IRichTextBlockAutomationPeer": ["93a01a9c-9609-41fa-82f3-909c09f49a72"],
    "IRichTextBlockAutomationPeerFactory": ["2038ae61-1389-467a-aed6-37334da9622b"],
    "IRichTextBlockOverflow": ["4f93749b-dac3-4a42-9cbb-99f0de37c071"],
    "IRichTextBlockOverflow2": ["8742624e-a882-4826-b929-4d5c3905b9a1"],
    "IRichTextBlockOverflow3": ["7f69587b-5c7f-4b5f-bdbc-fb95c90e10de"],
    "IRichTextBlockOverflowAutomationPeer": ["8c9a409a-2736-437b-ab36-a16a202f105d"],
    "IRichTextBlockOverflowAutomationPeerFactory": ["bd5eb663-2c14-4665-adef-f2b033947beb"],
    "IRichTextBlockOverflowStatics": ["041ac2f7-4f2b-43c3-a122-3fea9ca9dc87"],
    "IRichTextBlockOverflowStatics2": ["b5ebed4c-f8c4-4a3a-907f-e53e78279fa3"],
    "IRichTextBlockOverflowStatics3": ["d1d4a705-eb0b-4ecb-b9b7-e65d03087c8e"],
    "IRichTextBlockStatics": ["492d883c-adea-433c-be1c-208a164262be"],
    "IRichTextBlockStatics2": ["0d6131e1-af29-48ce-8aaf-74ecc28bfbb0"],
    "IRichTextBlockStatics3": ["073f7ef4-ca2b-4b49-a59a-31d8fa743332"],
    "IRichTextBlockStatics4": ["80155bc4-6d96-4b08-ad57-13db0f046412"],
    "IRichTextBlockStatics5": ["ac9283a1-4f25-4280-8868-3eeee82821e8"],
    "IRichTextBlockStatics6": ["073057e7-91c5-5857-be7c-e72621239786"],
    "IRichTextProvider2": ["8aff9d99-873f-4292-aab6-62c37adb3dbc"],
    "IRicheditUiaNotificationOverrides": ["a6bf39f8-11de-48ea-8780-9950bc13949d"],
    "IRicheditUiaOverrides": ["f2fb5cc0-b5a9-437f-9ba2-47632082269f"],
    "IRicheditWindowlessAccessibility": ["983e572d-20cd-460b-9104-83111592dd10"],
    "IRightTappedEventArgs": ["4cbf40bd-af7a-4a36-9476-b1dce141709a"],
    "IRightTappedEventArgs2": ["61c7b7bb-9f57-5857-a33c-c58c3dfa959e"],
    "IRightTappedEventHandler": ["2532a062-f447-4950-9c46-f1e34a2c2238"],
    "IRightTappedRoutedEventArgs": ["6834869d-7bd5-4033-b237-172f79abe393"],
    "IRoamDiag": ["12dd4000-f764-4dcb-a60d-41d8425746c4"],
    "IRoamWizard": ["709d476b-6346-4085-aeca-21229553d396"],
    "IRoamedMachineId": ["c9d21600-2b59-4938-b7f4-8fa3f375e7c6"],
    "IRoamingControl": ["f03acd30-8bce-458d-a157-efdad1933416"],
    "IRoamingControlProgress": ["81cc6389-10e8-4949-b533-4a814174f99c"],
    "IRoamingOptionsValues": ["d38c05b3-ada2-4c7e-b2ba-39e0639a117c"],
    "IRoamingSecurityFactory": ["f90f9024-0052-43e8-aa5d-8aa7b16204ba"],
    "IRoleAssociationUtil": ["6eb22876-8a19-11d0-81b6-00a0c9231c29"],
    "IRoleInfo": ["000001ef-0000-0000-c000-000000000046"],
    "IRootAndRelativeParsingFolder": ["52b14a6a-58f1-45bd-b00a-dce7403d951e"],
    "IRootScope": ["bb15caac-019b-4065-a1c3-37c4fc1c599a"],
    "IRotateTransform": ["688ea9b9-1e4e-4596-86e3-428b27334faf"],
    "IRotateTransformStatics": ["a131eb8a-51a3-41b6-b9d3-a10e429054ab"],
    "IRotationChangeEventArgs": ["16df4e9d-fb47-40b7-b8b8-55cffaea4251"],
    "IRotationManager": ["02a0cd62-e7c3-439d-bf3b-3cf380fe353c"],
    "IRoutePolicy": ["11abc4ac-0fc7-42e4-8742-569923b1ca11"],
    "IRoutePolicyFactory": ["36027933-a18e-4db5-a697-f58fa7364e44"],
    "IRoutedEvent": ["a6b25818-43c1-4c70-865c-7bdd5a32e327"],
    "IRoutedEventArgs": ["5c985ac6-d802-4b38-a223-bf070c43fedf"],
    "IRoutedEventArgsFactory": ["b61c4d87-70e5-412e-b520-1a41ee76bbf4"],
    "IRoutedEventHandler": ["a856e674-b0b6-4bc3-bba8-1ba06e40d4b5"],
    "IRouterProtocolConfig": ["66a2db16-d706-11d0-a37b-00c04fc9da04"],
    "IRowChange": ["0c733ab5-2a1c-11ce-ade5-00aa0044773d"],
    "IRowDefinition": ["4abae829-d80c-4a5e-a48c-f8b3d3b6533d"],
    "IRowDefinitionStatics": ["5adf3fe5-2056-4724-94d6-e4812b022ec8"],
    "IRowPosition": ["0c733a94-2a1c-11ce-ade5-00aa0044773d"],
    "IRowPositionChange": ["0997a571-126e-11d0-9f8a-00a0c9a0631e"],
    "IRowSchemaChange": ["0c733aae-2a1c-11ce-ade5-00aa0044773d"],
    "IRowsetAsynch": ["0c733a0f-2a1c-11ce-ade5-00aa0044773d"],
    "IRowsetBookmark": ["0c733ac2-2a1c-11ce-ade5-00aa0044773d"],
    "IRowsetChange": ["0c733a05-2a1c-11ce-ade5-00aa0044773d"],
    "IRowsetChangeExtInfo": ["0c733a8f-2a1c-11ce-ade5-00aa0044773d"],
    "IRowsetChapterMember": ["0c733aa8-2a1c-11ce-ade5-00aa0044773d"],
    "IRowsetCopyRows": ["0c733a6b-2a1c-11ce-ade5-00aa0044773d"],
    "IRowsetCurrentIndex": ["0c733abd-2a1c-11ce-ade5-00aa0044773d"],
    "IRowsetEvents": ["1551aea5-5d66-4b11-86f5-d5634cb211b9"],
    "IRowsetExactScroll": ["0c733a7f-2a1c-11ce-ade5-00aa0044773d"],
    "IRowsetExactStatistics": ["21c3f4c2-02df-404f-9d50-070cee79540f"],
    "IRowsetFastLoad": ["5cf4ca13-ef21-11d0-97e7-00c04fc2ad98"],
    "IRowsetFind": ["0c733a0d-2a1c-11ce-ade5-00aa0044773d", "0c733a9d-2a1c-11ce-ade5-00aa0044773d"],
    "IRowsetFindIndices": ["6b657501-b6ab-45b4-9344-2f86e4834886"],
    "IRowsetIdentity": ["0c733a09-2a1c-11ce-ade5-00aa0044773d"],
    "IRowsetIndex": ["0c733a82-2a1c-11ce-ade5-00aa0044773d"],
    "IRowsetInfo": ["0c733a55-2a1c-11ce-ade5-00aa0044773d"],
    "IRowsetKeys": ["0c733a12-2a1c-11ce-ade5-00aa0044773d"],
    "IRowsetLocate": ["0c733a7d-2a1c-11ce-ade5-00aa0044773d"],
    "IRowsetNewRowAfter": ["0c733a71-2a1c-11ce-ade5-00aa0044773d"],
    "IRowsetNextRowset": ["0c733a72-2a1c-11ce-ade5-00aa0044773d"],
    "IRowsetNotify": ["0c733a83-2a1c-11ce-ade5-00aa0044773d"],
    "IRowsetPrioritization": ["42811652-079d-481b-87a2-09a69ecc5f44"],
    "IRowsetRefresh": ["0c733aa9-2a1c-11ce-ade5-00aa0044773d"],
    "IRowsetResynch": ["0c733a84-2a1c-11ce-ade5-00aa0044773d"],
    "IRowsetScroll": ["0c733a7e-2a1c-11ce-ade5-00aa0044773d"],
    "IRowsetStatistics": ["bedba8d9-c93a-4c0b-97ba-40bdb5a2b4c1"],
    "IRowsetUpdate": ["0c733a6d-2a1c-11ce-ade5-00aa0044773d"],
    "IRowsetView": ["0c733a99-2a1c-11ce-ade5-00aa0044773d"],
    "IRowsetWatchAll": ["0c733a73-2a1c-11ce-ade5-00aa0044773d"],
    "IRowsetWatchNotify": ["0c733a44-2a1c-11ce-ade5-00aa0044773d"],
    "IRowsetWatchRegion": ["0c733a45-2a1c-11ce-ade5-00aa0044773d"],
    "IRowsetWithParameters": ["0c733a6e-2a1c-11ce-ade5-00aa0044773d"],
    "IRpcCall": ["000001c5-0000-0000-c000-000000000046"],
    "IRpcChannelBufferMarshalingContext": ["e7e33439-973f-4ca3-a813-ae2668df7b52"],
    "IRudeWindowManager": ["d29c946b-4f1c-425a-bb5b-d4e2e6e2993c"],
    "IRudeWindowManagerEvents": ["0797989b-6eb2-4c73-a6f2-a4f865b6849f"],
    "IRule": ["155eb649-1f41-465f-8c13-d49dfd8eb7d4"],
    "IRuleTriggeredEventArgs": ["e60d2d49-19d8-4614-a526-5bc97efa72cb"],
    "IRuleTriggeredEventArgsFactory": ["b6090e2b-d71f-42ee-80da-3393da4038fd"],
    "IRulesApplied": ["305104bf-98b5-11cf-bb82-00aa00bdce0b"],
    "IRulesAppliedCollection": ["305104be-98b5-11cf-bb82-00aa00bdce0b"],
    "IRulesEnum": ["ff7f1ddc-e8e2-487c-b944-da4c185447e2"],
    "IRunAsClipboard": ["c76c0834-6556-435e-903c-8c0a33484afa"],
    "IRunStatics": ["e9303cef-65a0-4b8d-a7f7-8fdb287b46f3"],
    "IRundown": ["00000134-0000-0000-c000-000000000046"],
    "IRunningShareEntry": ["edac98a6-b1f5-4e3f-85ec-506cb775b0ec"],
    "IRunningShareManager": ["9c3b7f41-b036-42d5-8634-e7da8b1bc329"],
    "IRunningShareSink": ["b72da6a3-b010-4375-9e97-085637763b3c"],
    "IRunningTask": ["653758fb-7b9a-4f1e-a471-beeb8e9b834e"],
    "IRunningTaskCollection": ["6a67614b-6828-4fec-aa54-6d52e8f1f2db"],
    "IRuntimeBroker": ["6040ec14-6557-41f9-a3f7-b1cab7b42120"],
    "ISBE2Crossbar": ["547b6d26-3226-487e-8253-8aa168749434"],
    "ISBE2EnumStream": ["f7611092-9fbc-46ec-a7c7-548ea78b71a4"],
    "ISBE2FileScan": ["3e2bf5a5-4f96-4899-a1a3-75e8be9a5ac0"],
    "ISBE2GlobalEvent": ["caede759-b6b1-11db-a578-0018f3fa24c6"],
    "ISBE2GlobalEvent2": ["6d8309bf-00fe-4506-8b03-f8c65b5c9b39"],
    "ISBE2MediaTypeProfile": ["f238267d-4671-40d7-997e-25dc32cfed2a"],
    "ISBE2SpanningEvent": ["caede760-b6b1-11db-a578-0018f3fa24c6"],
    "ISBE2StreamMap": ["667c7745-85b1-4c55-ae55-4e25056159fc"],
    "ISCMLocalActivator": ["00000136-0000-0000-c000-000000000046"],
    "ISCPSecureAuthenticate": ["1dcb3a0f-33ed-11d3-8470-00c04f79dbc0"],
    "ISCPSecureAuthenticate2": ["b580cfae-1672-47e2-acaa-44bbecbcae5b"],
    "ISCPSecureExchange": ["1dcb3a0e-33ed-11d3-8470-00c04f79dbc0"],
    "ISCPSecureExchange2": ["6c62fc7b-2690-483f-9d44-0a20cb35577c"],
    "ISCPSecureExchange3": ["ab4e77e4-8908-4b17-bd2a-b1dbe6dd69e1"],
    "ISCPSecureQuery": ["1dcb3a0d-33ed-11d3-8470-00c04f79dbc0"],
    "ISCPSecureQuery2": ["ebe17e25-4fd7-4632-af46-6d93d4fcc72e"],
    "ISCPSecureQuery3": ["b7edd1a2-4dab-484b-b3c5-ad39b8b4c0b1"],
    "ISCPSession": ["88a3e6ed-eee4-4619-bbb3-fd4fb62715d1"],
    "ISCTE_EAS": ["1ff544d6-161d-4fae-9faa-4f9f492ae999"],
    "ISClusApplication": ["f2e606e6-2631-11d1-89f1-00a0c90d061e"],
    "ISClusCryptoKeys": ["f2e6072c-2631-11d1-89f1-00a0c90d061e"],
    "ISClusDisk": ["f2e60724-2631-11d1-89f1-00a0c90d061e"],
    "ISClusDisks": ["f2e60726-2631-11d1-89f1-00a0c90d061e"],
    "ISClusNetInterface": ["f2e606ee-2631-11d1-89f1-00a0c90d061e"],
    "ISClusNetInterfaces": ["f2e606f0-2631-11d1-89f1-00a0c90d061e"],
    "ISClusNetwork": ["f2e606f2-2631-11d1-89f1-00a0c90d061e"],
    "ISClusNetworkNetInterfaces": ["f2e606f6-2631-11d1-89f1-00a0c90d061e"],
    "ISClusNetworks": ["f2e606f4-2631-11d1-89f1-00a0c90d061e"],
    "ISClusNode": ["f2e606f8-2631-11d1-89f1-00a0c90d061e"],
    "ISClusNodeNetInterfaces": ["f2e606fc-2631-11d1-89f1-00a0c90d061e"],
    "ISClusNodes": ["f2e606fa-2631-11d1-89f1-00a0c90d061e"],
    "ISClusPartition": ["f2e60720-2631-11d1-89f1-00a0c90d061e"],
    "ISClusPartitionEx": ["8802d4fe-b32e-4ad1-9dbd-64f18e1166ce"],
    "ISClusPartitions": ["f2e60722-2631-11d1-89f1-00a0c90d061e"],
    "ISClusProperties": ["f2e60700-2631-11d1-89f1-00a0c90d061e"],
    "ISClusProperty": ["f2e606fe-2631-11d1-89f1-00a0c90d061e"],
    "ISClusPropertyValue": ["f2e6071a-2631-11d1-89f1-00a0c90d061e"],
    "ISClusPropertyValueData": ["f2e6071e-2631-11d1-89f1-00a0c90d061e"],
    "ISClusPropertyValues": ["f2e6071c-2631-11d1-89f1-00a0c90d061e"],
    "ISClusRefObject": ["f2e60702-2631-11d1-89f1-00a0c90d061e"],
    "ISClusRegistryKeys": ["f2e6072a-2631-11d1-89f1-00a0c90d061e"],
    "ISClusResDependencies": ["f2e60704-2631-11d1-89f1-00a0c90d061e"],
    "ISClusResDependents": ["f2e6072e-2631-11d1-89f1-00a0c90d061e"],
    "ISClusResGroup": ["f2e60706-2631-11d1-89f1-00a0c90d061e"],
    "ISClusResGroupPreferredOwnerNodes": ["f2e606e8-2631-11d1-89f1-00a0c90d061e"],
    "ISClusResGroupResources": ["f2e606ea-2631-11d1-89f1-00a0c90d061e"],
    "ISClusResGroups": ["f2e60708-2631-11d1-89f1-00a0c90d061e"],
    "ISClusResPossibleOwnerNodes": ["f2e6070e-2631-11d1-89f1-00a0c90d061e"],
    "ISClusResType": ["f2e60710-2631-11d1-89f1-00a0c90d061e"],
    "ISClusResTypePossibleOwnerNodes": ["f2e60718-2631-11d1-89f1-00a0c90d061e"],
    "ISClusResTypeResources": ["f2e60714-2631-11d1-89f1-00a0c90d061e"],
    "ISClusResTypes": ["f2e60712-2631-11d1-89f1-00a0c90d061e"],
    "ISClusResource": ["f2e6070a-2631-11d1-89f1-00a0c90d061e"],
    "ISClusResources": ["f2e6070c-2631-11d1-89f1-00a0c90d061e"],
    "ISClusScsiAddress": ["f2e60728-2631-11d1-89f1-00a0c90d061e"],
    "ISClusVersion": ["f2e60716-2631-11d1-89f1-00a0c90d061e"],
    "ISCluster": ["f2e606e4-2631-11d1-89f1-00a0c90d061e"],
    "ISClusterNames": ["f2e606ec-2631-11d1-89f1-00a0c90d061e"],
    "ISDomainNames": ["f2e606e2-2631-11d1-89f1-00a0c90d061e"],
    "ISEOBindingConverter": ["ee4e64d0-31f1-11d0-a9d0-00aa00685c74"],
    "ISEOBindingRuleEngine": ["f2d1daf0-2236-11d0-a9ce-00aa00685c74"],
    "ISEODictionary": ["d8177b40-7bac-11d0-a9e0-00aa00685c74"],
    "ISEODictionaryItem": ["16d63630-83ae-11d0-a9e3-00aa00685c74"],
    "ISEODispatcher": ["8ca89880-31f1-11d0-a9d0-00aa00685c74"],
    "ISEOEventSink": ["1cab4c20-94f4-11d0-a9e8-00aa00685c74"],
    "ISEOInitObject": ["9bb6aab0-af6d-11d0-8bd2-00c04fd42e37"],
    "ISEORegDictionary": ["347cacb0-2d1e-11d0-a9cf-00aa00685c74"],
    "ISEORouter": ["2b6ac0f0-7e03-11d0-a9e0-00aa00685c74"],
    "ISIInbandEPG": ["f90ad9d0-b854-4b68-9cc1-b2cc96119d85"],
    "ISIInbandEPGEvent": ["7e47913a-5a89-423d-9a2b-e15168858934"],
    "ISLTracker": ["7c9e512f-41d7-11d1-8e2e-00c04fb9386d"],
    "ISMBShare": ["914aa662-1b3b-47fc-b9d3-634dd16ac179"],
    "ISMTPOnArrival": ["cd000026-8b95-11d1-82db-00c04fb1625d"],
    "ISMTPScriptConnector": ["cd000030-8b95-11d1-82db-00c04fb1625d"],
    "ISQLErrorInfo": ["0c733a74-2a1c-11ce-ade5-00aa0044773d"],
    "ISQLGetDiagField": ["228972f1-b5ff-11d0-8a80-00c04fd611cd"],
    "ISQLRequestDiagFields": ["228972f0-b5ff-11d0-8a80-00c04fd611cd"],
    "ISQLServerErrorInfo": ["5cf4ca12-ef21-11d0-97e7-00c04fc2ad98"],
    "ISUDAdvancedViewNavigate": ["fb4900e5-6cd4-4a43-ad86-946c5bf29617"],
    "ISVGAElement": ["3051054b-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGAngle": ["305104d3-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGAnimatedAngle": ["305104d4-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGAnimatedBoolean": ["305104c6-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGAnimatedEnumeration": ["305104c9-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGAnimatedInteger": ["305104ca-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGAnimatedLength": ["305104d0-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGAnimatedLengthList": ["305104d2-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGAnimatedNumber": ["305104cc-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGAnimatedNumberList": ["305104ce-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGAnimatedPathData": ["30510511-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGAnimatedPoints": ["30510517-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGAnimatedPreserveAspectRatio": ["305104fb-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGAnimatedRect": ["305104d8-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGAnimatedString": ["305104c7-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGAnimatedTransformList": ["305104f9-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGCircleElement": ["30510514-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGClipPathElement": ["3051052d-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGDefsElement": ["305104e9-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGDescElement": ["305104ea-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGDocument": ["305104e6-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGElement": ["305104c5-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGElementInstance": ["305104ee-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGElementInstanceList": ["305104ef-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGEllipseElement": ["30510515-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGException": ["3051072f-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGExternalResourcesRequired": ["305104df-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGFitToViewBox": ["305104e0-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGGElement": ["305104e8-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGGradientElement": ["30510528-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGImageElement": ["305104f0-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGLangSpace": ["305104de-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGLength": ["305104cf-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGLengthList": ["305104d1-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGLineElement": ["30510516-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGLinearGradientElement": ["30510529-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGLocatable": ["305104db-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGMarkerElement": ["30510525-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGMaskElement": ["3051052e-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGMatrix": ["305104f6-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGMetadataElement": ["30510560-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGNumber": ["305104cb-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGNumberList": ["305104cd-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGPaint": ["30510524-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGPathElement": ["30510512-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGPathSeg": ["305104fc-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGPathSegArcAbs": ["30510506-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGPathSegArcRel": ["30510507-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGPathSegClosePath": ["305104fd-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGPathSegCurvetoCubicAbs": ["30510502-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGPathSegCurvetoCubicRel": ["30510503-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGPathSegCurvetoCubicSmoothAbs": ["3051050c-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGPathSegCurvetoCubicSmoothRel": ["3051050d-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGPathSegCurvetoQuadraticAbs": ["30510504-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGPathSegCurvetoQuadraticRel": ["30510505-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGPathSegCurvetoQuadraticSmoothAbs": ["3051050e-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGPathSegCurvetoQuadraticSmoothRel": ["3051050f-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGPathSegLinetoAbs": ["30510500-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGPathSegLinetoHorizontalAbs": ["30510508-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGPathSegLinetoHorizontalRel": ["30510509-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGPathSegLinetoRel": ["30510501-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGPathSegLinetoVerticalAbs": ["3051050a-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGPathSegLinetoVerticalRel": ["3051050b-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGPathSegList": ["30510510-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGPathSegMovetoAbs": ["305104fe-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGPathSegMovetoRel": ["305104ff-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGPatternElement": ["3051052c-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGPoint": ["305104f4-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGPointList": ["305104f5-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGPolygonElement": ["30510519-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGPolylineElement": ["30510518-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGPreserveAspectRatio": ["305104fa-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGRadialGradientElement": ["3051052a-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGRect": ["305104d7-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGRectElement": ["30510513-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGSVGElement": ["305104e7-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGScriptElement": ["3051054d-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGStopElement": ["3051052b-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGStringList": ["305104c8-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGStylable": ["305104da-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGStyleElement": ["305104f3-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGSwitchElement": ["305104f1-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGSymbolElement": ["305104ec-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGTSpanElement": ["3051051d-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGTests": ["305104dd-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGTextContentElement": ["3051051a-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGTextElement": ["3051051c-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGTextPathElement": ["3051051f-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGTextPositioningElement": ["3051051b-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGTitleElement": ["305104eb-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGTransform": ["305104f7-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGTransformList": ["305104f8-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGTransformable": ["305104dc-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGURIReference": ["305104e3-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGUseElement": ["305104ed-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGViewElement": ["3051054c-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGViewSpec": ["305104e2-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGZoomAndPan": ["305104e1-98b5-11cf-bb82-00aa00bdce0b"],
    "ISVGZoomEvent": ["3051054e-98b5-11cf-bb82-00aa00bdce0b"],
    "ISWbemDateTime": ["5e97458a-cf77-11d3-b38f-00105a1f473a"],
    "ISWbemEventSource": ["27d54d92-0ebe-11d2-8b22-00600806d9b6"],
    "ISWbemLastError": ["d962db84-d4bb-11d1-8b09-00600806d9b6"],
    "ISWbemLocator": ["76a6415b-cb41-11d1-8b02-00600806d9b6"],
    "ISWbemMethod": ["422e8e90-d955-11d1-8b09-00600806d9b6"],
    "ISWbemMethodSet": ["c93ba292-d955-11d1-8b09-00600806d9b6"],
    "ISWbemNamedValue": ["76a64164-cb41-11d1-8b02-00600806d9b6"],
    "ISWbemNamedValueSet": ["cf2376ea-ce8c-11d1-8b05-00600806d9b6"],
    "ISWbemObject": ["76a6415a-cb41-11d1-8b02-00600806d9b6"],
    "ISWbemObjectEx": ["269ad56a-8a67-4129-bc8c-0506dcfe9880"],
    "ISWbemObjectPath": ["5791bc27-ce9c-11d1-97bf-0000f81e849c"],
    "ISWbemObjectSet": ["76a6415f-cb41-11d1-8b02-00600806d9b6"],
    "ISWbemPrivilege": ["26ee67bd-5804-11d2-8b4a-00600806d9b6"],
    "ISWbemPrivilegeSet": ["26ee67bf-5804-11d2-8b4a-00600806d9b6"],
    "ISWbemProperty": ["1a388f98-d4ba-11d1-8b09-00600806d9b6"],
    "ISWbemPropertySet": ["dea0a7b2-d4ba-11d1-8b09-00600806d9b6"],
    "ISWbemQualifier": ["79b05932-d3b7-11d1-8b06-00600806d9b6"],
    "ISWbemQualifierSet": ["9b16ed16-d3df-11d1-8b08-00600806d9b6"],
    "ISWbemRefreshableItem": ["5ad4bf92-daab-11d3-b38f-00105a1f473a"],
    "ISWbemRefresher": ["14d8250e-d9c2-11d3-b38f-00105a1f473a"],
    "ISWbemSecurity": ["b54d66e6-2287-11d2-8b33-00600806d9b6"],
    "ISWbemServices": ["76a6415c-cb41-11d1-8b02-00600806d9b6"],
    "ISWbemServicesEx": ["d2f68443-85dc-427e-91d8-366554cc754c"],
    "ISWbemSink": ["75718c9f-f029-11d1-a1ac-00c04fb6c223"],
    "ISaDeviceCallback": ["f611f516-4f04-4f1f-b833-623b47af2a12"],
    "ISafeSaveHandleManager": ["bb94daad-7836-4d62-9557-2a7b83839b7b"],
    "ISampleGrabber": ["6b652fff-11fe-4fce-92ad-0266b5d7c78f"],
    "ISampleGrabberCB": ["0579154a-2b53-4994-b0d0-e773148eff85"],
    "IScalarKeyFrameAnimation": ["ae288fa9-252c-4b95-a725-bf85e38000a1"],
    "IScalarNaturalMotionAnimation": ["94a94581-bf92-495b-b5bd-d2c659430737"],
    "IScalarNaturalMotionAnimationFactory": ["835aa4fc-671c-41dd-af48-ae8def8b1529"],
    "IScalarTransition": ["4cb68238-e15d-524e-a73c-9d4dcfbea226"],
    "IScalarTransitionFactory": ["c9b1e9ee-90da-5ddd-be64-3e47977ea280"],
    "IScaleAnimation": ["023552c7-71ab-428c-9c9f-d31780964995"],
    "IScaleChangeSink": ["abadfe7f-04c1-4a9f-9b3c-a323f1c80178"],
    "IScaleTransform": ["ed67f18d-936e-43ab-929a-e9cd0a511e52"],
    "IScaleTransformStatics": ["9d9436f4-40a7-46dd-975a-07d337cd852e"],
    "IScanningTuner": ["1dfd0a5c-0284-11d3-9d8e-00c04f72d980"],
    "IScanningTunerEx": ["04bbd195-0e2d-4593-9bd5-4f908bc33cf5"],
    "ISccManagerLoaded": ["795635a0-4522-11d1-8dce-00aa00a3f593"],
    "ISceSvcAttachmentData": ["17c35fde-200d-11d1-affb-00c04fb984f9"],
    "ISceSvcAttachmentPersistInfo": ["6d90e0d0-200d-11d1-affb-00c04fb984f9"],
    "ISceneAnalysisEffect": ["c04ba319-ca41-4813-bffd-7b08b0ed2557"],
    "ISceneAnalysisEffectFrame": ["d8b10e4c-7fd9-42e1-85eb-6572c297c987"],
    "ISceneAnalysisEffectFrame2": ["2d4e29be-061f-47ae-9915-02524b5f9a5f"],
    "ISceneAnalyzedEventArgs": ["146b9588-2851-45e4-ad55-44cf8df8db4d"],
    "ISceneBoundingBox": ["5d8ffc70-c618-4083-8251-9962593114aa"],
    "ISceneComponent": ["ae20fc96-226c-44bd-95cb-dd5ed9ebe9a5"],
    "ISceneComponentCollection": ["c483791c-5f46-45e4-b666-a3d2259f9b2e"],
    "ISceneComponentFactory": ["5fbc5574-ddd8-5889-ab5b-d8fa716e7c9e"],
    "ISceneLightingEffect": ["91bb5e52-95d1-4f8b-9a5a-6408b24b8c6a"],
    "ISceneLightingEffect2": ["9e270e81-72f0-4c5c-95f8-8a6e0024f409"],
    "ISceneMaterial": ["8ca74b7c-30df-4e07-9490-37875af1a123"],
    "ISceneMaterialFactory": ["67536c19-a707-5254-a495-7fdc799893b9"],
    "ISceneMaterialInput": ["422a1642-1ef1-485c-97e9-ae6f95ad812f"],
    "ISceneMaterialInputFactory": ["a88feb74-7d0a-5e4c-a748-1015af9ca74f"],
    "ISceneMesh": ["ee9a1530-1155-4c0c-92bd-40020cf78347"],
    "ISceneMeshMaterialAttributeMap": ["ce843171-3d43-4855-aa69-31ff988d049d"],
    "ISceneMeshRendererComponent": ["9929f7e3-6364-477e-98fe-74ed9fd4c2de"],
    "ISceneMeshRendererComponentStatics": ["4954f37a-4459-4521-bd6e-2b38b8d711ea"],
    "ISceneMeshStatics": ["8412316c-7b57-473f-966b-81dc277b1751"],
    "ISceneMetallicRoughnessMaterial": ["c1d91446-799c-429e-a4e4-5da645f18e61"],
    "ISceneMetallicRoughnessMaterialStatics": ["3bddca50-6d9d-4531-8dc4-b27e3e49b7ab"],
    "ISceneModeControl": ["d48e5af7-8d59-4854-8c62-12c70ba89b7c"],
    "ISceneModelTransform": ["c05576c2-32b1-4269-980d-b98537100ae4"],
    "ISceneNode": ["acf2c247-f307-4581-9c41-af2e29c3b016"],
    "ISceneNodeCollection": ["29ada101-2dd9-4332-be63-60d2cf4269f2"],
    "ISceneNodeStatics": ["579a0faa-be9d-4210-908c-93d15feed0b7"],
    "ISceneObject": ["1e94249b-0f1b-49eb-a819-877d8450005b"],
    "ISceneObjectFactory": ["14fe799a-33e4-52ef-956c-44229d21f2c1"],
    "IScenePbrMaterial": ["aab6ebbe-d680-46df-8294-b6800a9f95e7"],
    "IScenePbrMaterialFactory": ["2e3f3dfe-0b85-5727-b5be-b7d3cbac37fa"],
    "ISceneRendererComponent": ["f1acb857-cf4f-4025-9b25-a2d1944cf507"],
    "ISceneRendererComponentFactory": ["1db6ed6c-aa2c-5967-9035-56352dc69658"],
    "ISceneSurfaceMaterialInput": ["9937da5c-a9ca-4cfc-b3aa-088356518742"],
    "ISceneSurfaceMaterialInputStatics": ["5a2394d3-6429-4589-bbcf-b84f4f3cfbfe"],
    "ISceneVisual": ["8e672c1e-d734-47b1-be14-3d694ffa4301"],
    "ISceneVisualStatics": ["b8347e9a-50aa-4527-8d34-de4cb8ea88b4"],
    "IScheduleCollection": ["0383753d-098b-11d8-9414-505054503030"],
    "IScheduledNotification": ["819a0567-85e9-4b09-ba5f-fd91a344ea09"],
    "IScheduledNotificationCollection": ["fbce05c1-6b39-44e5-af47-c07aadd0de7a"],
    "IScheduledTileNotification": ["0abca6d5-99dc-4c78-a11c-c9e7f86d7ef7"],
    "IScheduledTileNotificationFactory": ["3383138a-98c0-4c3b-bbd6-4a633c7cfc29"],
    "IScheduledToastNotification": ["79f577f8-0de7-48cd-9740-9b370490c838"],
    "IScheduledToastNotification2": ["a66ea09c-31b4-43b0-b5dd-7a40e85363b1"],
    "IScheduledToastNotification3": ["98429e8b-bd32-4a3b-9d15-22aea49462a1"],
    "IScheduledToastNotification4": ["1d4761fd-bdef-4e4a-96be-0101369b58d2"],
    "IScheduledToastNotificationFactory": ["e7bed191-0bb9-4189-8394-31761b476fd7"],
    "IScheduledToastNotificationShowingEventArgs": ["6173f6b4-412a-5e2c-a6ed-a0209aef9a09"],
    "ISchedulingAgent": ["148bd527-a2ab-11ce-b11f-00aa00530503"],
    "ISchemaLocalizerSupport": ["ca3fdca2-bfbe-4eed-90d7-0caef0a1bda1"],
    "ISchemaLock": ["4c2389fb-2511-11d4-b258-00c04f7971ce"],
    "ISchemaProvider": ["8cf89bcb-394c-49b2-ae28-a59dd4ed7f68"],
    "ISchemaReferenceInfo": ["b9a32c92-b14d-4ae3-a955-5cbc3e75fca8"],
    "ISchemaView": ["a8765599-6915-4a84-ab8c-3bf8927b06c6"],
    "IScmReplyInfo": ["000001b6-0000-0000-c000-000000000046"],
    "IScmRequestInfo": ["000001aa-0000-0000-c000-000000000046"],
    "IScopeDialog": ["709a7be5-63f9-4568-a1ee-2f4c4a38978e"],
    "IScopeDialogEvents": ["15d93b62-9918-4e4c-857e-d1ad2d143f4f"],
    "IScopeDialogUIInfo": ["c1bedcbf-1fc9-4a2f-bf7a-f26b1ab02a38"],
    "IScopeFactory": ["54410b83-6787-4418-9735-5aaaabe83a9a"],
    "IScopeItem": ["dd400ff4-a119-405f-970e-a9a5e7e828c0"],
    "IScopeResolver": ["5ad5cef9-97d2-481b-84a9-c34f061716b8"],
    "IScopedOperations": ["0c733ab0-2a1c-11ce-ade5-00aa0044773d"],
    "IScreenReaderPositionChangedEventArgs": ["557eb5e5-54d0-5ccd-9fc5-ed33357f8a9f"],
    "IScreenReaderService": ["19475427-eac0-50d3-bdd9-9b487a226256"],
    "IScriptEventHandler": ["3051083a-98b5-11cf-bb82-00aa00bdce0b"],
    "IScriptEventHandlerSourceInfo": ["30510841-98b5-11cf-bb82-00aa00bdce0b"],
    "IScriptFile": ["4e9bb406-061e-4362-af01-37bf0cd8d767"],
    "IScriptInvocationContext": ["5d7741b7-af7e-4a2a-85e5-c77f4d0659fb"],
    "IScriptTypeInfo": ["c59c6b12-f6c1-11cf-8835-00a0c911e8b2"],
    "IScriptTypeLib": ["c59c6b11-f6c1-11cf-8835-00a0c911e8b2"],
    "IScriptedDiagnosticClient": ["3e905a60-e7b1-466c-8878-fd06c668336a"],
    "IScriptedDiagnosticExecution": ["6d5e9074-62ef-4f05-902a-46ecdff1ef68"],
    "IScriptedDiagnosticInformation": ["2db48474-d18b-4315-b552-dc6cf5f651d5"],
    "IScriptingContext": ["d97a6da0-a868-11cf-83ae-00b0c90c2bd8"],
    "IScrollAnchorProvider": ["6ae99a0f-478c-5440-b2c6-ead4378ef8e4"],
    "IScrollBarAutomationPeer": ["69e0c369-bbe7-41f2-87ca-aad813fe550e"],
    "IScrollBarAutomationPeerFactory": ["e1302110-afeb-4595-8e3d-edc0844a2b21"],
    "IScrollBarStatics": ["45eaf38d-b814-48cf-97f2-539eb16dfd4d"],
    "IScrollContentPresenter": ["5712ee2b-0eeb-46d3-aa31-5f6801b8de20"],
    "IScrollContentPresenter2": ["5f9f2737-2318-5999-8a62-c3ed3c0e98b6"],
    "IScrollContentPresenterStatics2": ["e172ff1a-c676-524b-8f20-96152149d05e"],
    "IScrollEventArgs": ["c57e5168-3afe-448d-b752-2f364c75d743"],
    "IScrollEventHandler": ["8860b0a4-a383-4c83-b306-a1c39d7db87f"],
    "IScrollItemProvider": ["2360c714-4bf1-4b26-ba65-9b21316127eb", "9a3ec090-5d2c-4e42-9ee6-9d58db100b55"],
    "IScrollPatternIdentifiers": ["366b1003-425c-4951-ae83-d521e73bc696"],
    "IScrollPatternIdentifiersStatics": ["4bf8e0a1-fb7f-4fa4-83b3-cfaeb103a685"],
    "IScrollProvider": ["374bf581-7716-4bbc-82eb-d997006ea999", "b38b8077-1fc3-42a5-8cae-d40c2215055a"],
    "IScrollSnapPointsInfo": ["1b5d1336-e61b-4d51-be41-fd8ddc55c58c"],
    "IScrollViewer": ["64e9be00-4dc1-493d-abe7-cbd3c577490d"],
    "IScrollViewer2": ["64e9be10-4dd1-494d-abf7-cbd3c577491d"],
    "IScrollViewer3": ["74e9be21-5de2-595e-bc08-dbd3c577492c"],
    "IScrollViewer4": ["786fb0c4-50a9-5a45-8a92-7bf372e19098"],
    "IScrollViewerAutomationPeer": ["d985f259-1b09-4e88-88fd-421750dc6b45"],
    "IScrollViewerAutomationPeerFactory": ["270dff7d-d96d-48f9-a36a-c252aa9c4670"],
    "IScrollViewerStatics": ["33d1299d-8d6e-4290-bf22-905cccd04d31"],
    "IScrollViewerStatics2": ["33d129ad-8d7e-42a0-bf32-905cccd04d41"],
    "IScrollViewerStatics4": ["220cf7cc-4f46-59f1-af9b-67fa8eb33d01"],
    "IScrollViewerView": ["64e9be01-4dc2-493e-abe8-cbd3c577490e"],
    "IScrollViewerViewChangedEventArgs": ["4dd04f7e-7a11-4b2e-9933-577df39252b6"],
    "IScrollViewerViewChangingEventArgs": ["4dd04f7f-7a11-4b2e-9933-577df39252b6"],
    "IScrollableContextMenu": ["30510854-98b5-11cf-bb82-00aa00bdce0b"],
    "IScrollableContextMenu2": ["f77e9056-8674-4936-924c-0e4a06fa634a"],
    "ISdoMachine2": ["518e5ffe-d8ce-4f7e-a5db-b40a35419d3b"],
    "ISearchAccessList": ["b05651da-9b10-425e-b616-1fcd828db3b1"],
    "ISearchActivatedEventArgs": ["8cb36951-58c8-43e3-94bc-41d33f8b630e"],
    "ISearchActivatedEventArgsWithLinguisticDetails": ["c09f33da-08ab-4931-9b7c-451025f21f81"],
    "ISearchBox": ["f89ecc5a-99ba-4bd4-966c-f11fa443d13c"],
    "ISearchBoxAutomationPeer": ["854011a4-18a6-4f30-939b-8871afa3f5e9"],
    "ISearchBoxAutomationPeerFactory": ["b3c01430-7faa-41bb-8e91-7c761c5267f1"],
    "ISearchBoxFactory": ["cd743f6d-8685-46b4-9ddd-202f6941b701"],
    "ISearchBoxInfo": ["6af6e03f-d664-4ef4-9626-f7e0ed36755e"],
    "ISearchBoxInternal": ["3eaa2376-2c33-430a-ae87-d665d7335ea5"],
    "ISearchBoxQueryChangedEventArgs": ["a9a70f8f-0cb0-4bd2-9998-2fb57ad5e731"],
    "ISearchBoxQuerySubmittedEventArgs": ["126e90fd-3c4e-4ccb-9aef-4705d19fe548"],
    "ISearchBoxResultSuggestionChosenEventArgs": ["18918c23-e4c3-4662-a03b-d054ffd0f905"],
    "ISearchBoxSettings": ["9838aab6-32fd-455a-823d-83cfe06e4d48"],
    "ISearchBoxStatics": ["b123634f-6871-48cd-92df-4cff22459082"],
    "ISearchBoxSuggestionsRequestedEventArgs": ["da15170e-e566-48cb-bd11-fe4b0f30a44d"],
    "ISearchCatalogManager": ["ab310581-ac80-11d1-8df3-00c04fb6ef50"],
    "ISearchCatalogManager2": ["7ac3286d-4d1d-4817-84fc-c1c85e3af0d9"],
    "ISearchCatalogManagerInternal": ["5f4b60f2-c6f6-4007-bce2-297f1c5766b6"],
    "ISearchCompletedCallback": ["88aee058-d4b0-4725-a2f1-814a67ae964c"],
    "ISearchCompletedCallbackArgs": ["a700a634-2850-4c47-938a-9e4b6e5af9a6"],
    "ISearchControlBroker": ["1382fca2-6ff7-4775-b1af-87d3b3507e95"],
    "ISearchControlBrokerLocal": ["cfac4e7e-0aec-4b8f-a1e3-70bec876d886"],
    "ISearchControlClient": ["510e2e14-c900-4b1b-a81c-a5ddb0dfa079"],
    "ISearchCrawlScopeManager": ["ab310581-ac80-11d1-8df3-00c04fb6ef55"],
    "ISearchCrawlScopeManager2": ["6292f7ad-4e19-4717-a534-8fc22bcd5ccd"],
    "ISearchCrawlScopeManagerInternal": ["ca4baeb3-e924-4832-b39a-f30a81144b41"],
    "ISearchFolderItemFactory": ["a0ffbc28-5482-4366-be27-3e81e78e06c2"],
    "ISearchIDListFactory": ["c0a6c367-c264-4385-a704-9088bdc3640e"],
    "ISearchItemsChangedSink": ["ab310581-ac80-11d1-8df3-00c04fb6ef58"],
    "ISearchJob": ["7366ea16-7a1a-4ea2-b042-973d3e9cd99b"],
    "ISearchLanguageSupport": ["24c3cbaa-ebc1-491a-9ef1-9f6d8deb1b8f"],
    "ISearchManager": ["ab310581-ac80-11d1-8df3-00c04fb6ef69"],
    "ISearchManager2": ["dbab3f73-db19-4a79-bfc0-a61a93886ddf"],
    "ISearchManagerVolume": ["f461256b-3c3f-4d5a-8b9f-a39b8caf5e73"],
    "ISearchNotifyInlineSite": ["b5702e61-e75c-4b64-82a1-6cb4f832fccf"],
    "ISearchPaneBroker": ["edac73e0-7bd0-4a38-b4dd-f2d0d4eb9da6"],
    "ISearchPaneClient": ["c4421717-b698-44ba-9829-65ae55405b8f"],
    "ISearchPanePriv": ["f2c3e3d7-1f80-434b-aec8-ddfed4e3d00e"],
    "ISearchPaneQueryLinguisticDetails": ["82fb460e-0940-4b6d-b8d0-642b30989e15"],
    "ISearchPaneWindow": ["d40c105c-f466-4997-9d89-db0fbd8b8577"],
    "ISearchPersistentItemsChangedSink": ["a2ffdf9b-4758-4f84-b729-df81a1a0612f"],
    "ISearchProtocol": ["c73106ba-ac80-11d1-8df3-00c04fb6ef4f"],
    "ISearchProtocol2": ["7789f0b2-b5b2-4722-8b65-5dbd150697a9"],
    "ISearchProtocolThreadContext": ["c73106e1-ac80-11d1-8df3-00c04fb6ef4f"],
    "ISearchProtocolUrl": ["09bc8657-d9b4-4267-a2ba-39e348fb0f4e"],
    "ISearchQueryCondition": ["69563521-c154-4b45-b884-035872e3f96a"],
    "ISearchQueryHelper": ["ab310581-ac80-11d1-8df3-00c04fb6ef63"],
    "ISearchQueryHelperPriv": ["1b217815-e578-4c96-8a2d-1b30392f0f91"],
    "ISearchQueryLinguisticDetails": ["46a1205b-69c9-4745-b72f-a8a4fc8f24ae"],
    "ISearchQueryLinguisticDetailsFactory": ["cac6c3b8-3c64-4dfd-ad9f-479e4d4065a4"],
    "ISearchQueryLinguisticDetailsPriv": ["1a5e818e-c4f7-424b-84e4-c1a8ee4302c6"],
    "ISearchResult": ["d40cff62-e08c-4498-941a-01e25f0fd33c"],
    "ISearchRoot": ["04c18ccf-1f57-4cbd-88cc-3900f5195ce3"],
    "ISearchScope": ["aba130b9-19e4-42a2-bf1e-218bbf4c71f5"],
    "ISearchScopeProtector": ["fbd7e543-eb5e-4041-95fa-492be05d1093"],
    "ISearchScopeRule": ["ab310581-ac80-11d1-8df3-00c04fb6ef53"],
    "ISearchScopeSelector": ["52f077cc-10e3-40ea-ad6d-9313803f91f3"],
    "ISearchServices": ["3b228825-95e7-4ad9-8616-5f94bf6ea1fd"],
    "ISearchServicesProvider": ["fbf07608-d086-41c9-b25f-2d19e507aa05"],
    "ISearchSuggestionCollection": ["323a8a4b-fbea-4446-abbc-3da7915fdd3a"],
    "ISearchSuggestionsRequest": ["4e4e26a7-44e5-4039-9099-6000ead1f0c6"],
    "ISearchSuggestionsRequestDeferral": ["b71598a9-c065-456d-a845-1eccec5dc28b"],
    "ISearchViewChangedSink": ["ab310581-ac80-11d1-8df3-00c04fb6ef65"],
    "ISecMgrCacheSeedTarget": ["fc8afc62-f788-4b36-8889-fd073fdd2fd9"],
    "ISecondaryAuthenticationFactorAuthentication": ["020a16e5-6a25-40a3-8c00-50a023f619d1"],
    "ISecondaryAuthenticationFactorAuthenticationResult": ["9cbb5987-ef6d-4bc2-bf49-4617515a0f9a"],
    "ISecondaryAuthenticationFactorAuthenticationStageChangedEventArgs": ["d4a5ee56-7291-4073-bc1f-ccb8f5afdf96"],
    "ISecondaryAuthenticationFactorAuthenticationStageInfo": ["56fec28b-e8aa-4c0f-8e4c-a559e73add88"],
    "ISecondaryAuthenticationFactorAuthenticationStatics": ["3f582656-28f8-4e0f-ae8c-5898b9ae2469"],
    "ISecondaryAuthenticationFactorAuthenticationTrigger": ["f237f327-5181-4f24-96a7-700a4e5fac62"],
    "ISecondaryAuthenticationFactorDevicePresenceMonitoringRegistrationStatics": [
        "90499a19-7ef2-4523-951c-a417a24acf93"
    ],
    "ISecondaryAuthenticationFactorInfo": ["1e2ba861-8533-4fce-839b-ecb72410ac14"],
    "ISecondaryAuthenticationFactorInfo2": ["14d981a3-fc26-4ff7-abc3-48e82a512a0a"],
    "ISecondaryAuthenticationFactorRegistration": ["9f4cbbb4-8cba-48b0-840d-dbb22a54c678"],
    "ISecondaryAuthenticationFactorRegistrationResult": ["a4fe35f0-ade3-4981-af6b-ec195921682a"],
    "ISecondaryAuthenticationFactorRegistrationStatics": ["1adf0f65-e3b7-4155-997f-b756ef65beba"],
    "ISecondaryTile": ["9e9e51e0-2bb5-4bc0-bb8d-42b23abcc88d"],
    "ISecondaryTile2": ["b2f6cc35-3250-4990-923c-294ab4b694dd"],
    "ISecondaryTileFactory": ["57f52ca0-51bc-4abf-8ebf-627a0398b05a"],
    "ISecondaryTileFactory2": ["274b8a3b-522d-448e-9eb2-d0672ab345c8"],
    "ISecondaryTileStatics": ["99908dae-d051-4676-87fe-9ec242d83c74"],
    "ISecondaryTileVisualElements": ["1d8df333-815e-413f-9f50-a81da70a96b2"],
    "ISecondaryTileVisualElements2": ["fd2e31d0-57dc-4794-8ecf-5682f5f3e6ef"],
    "ISecondaryTileVisualElements3": ["56b55ad6-d15c-40f4-81e7-57ffd8f8a4e9"],
    "ISecondaryTileVisualElements4": ["66566117-b544-40d2-8d12-74d4ec24d04c"],
    "ISectionList": ["afec1eb5-2a64-46c6-bf4b-ae3ccb6afdb0"],
    "ISectionsInViewChangedEventArgs": ["dd49ee6b-d165-430f-a37d-b807064f85e1"],
    "ISectionsInViewChangedEventArgsFactory": ["557f5244-92f8-4150-b730-e6346e8f50d1"],
    "ISectionsInViewChangedEventHandler": ["6becaa6a-63f8-47ff-b6ac-76e7da247d67"],
    "ISecurityAppManager": ["96ac500c-aed4-561d-bde8-953520343a2d"],
    "ISecurityEditor": ["14b2c619-d07a-46ef-8b62-31b64f3b845c"],
    "ISecurityInfo": ["0c733aa4-2a1c-11ce-ade5-00aa0044773d"],
    "ISecurityInformation": ["965fc360-16ff-11d0-91cb-00aa00bbb723"],
    "ISecurityInformation2": ["c3ccfdb4-6f88-11d2-a3ce-00c04fb1782a"],
    "ISecurityInformation3": ["e2cdc9cc-31bd-4f8f-8c8b-b641af516a1a"],
    "ISecurityInformation4": ["ea961070-cd14-4621-ace4-f63c03e583e4"],
    "ISecurityObjectTypeInfo": ["fc3066eb-79ef-444b-9111-d18a75ebf2fa"],
    "ISecurityOptions": ["0000015f-0000-0000-c000-000000000046"],
    "ISecurityProxyFactory": ["c731056f-ac80-11d1-8df3-00c04fb6ef4f"],
    "ISelectableWordSegment": ["916a4cb7-8aa7-4c78-b374-5dedb752e60b"],
    "ISelectableWordSegmentsTokenizingHandler": ["3a3dfc9c-aede-4dc7-9e6c-41c044bd3592"],
    "ISelectableWordsSegmenter": ["f6dc31e7-4b13-45c5-8897-7d71269e085d"],
    "ISelectableWordsSegmenterFactory": ["8c7a7648-6057-4339-bc70-f210010a4150"],
    "ISelectionChangedEventArgs": ["c972d2dc-b609-4758-851e-a799c21de97d"],
    "ISelectionChangedEventArgsFactory": ["11a8b6b5-2830-4517-84cd-5524c8b88b45"],
    "ISelectionChangedEventHandler": ["e1a05352-5aa0-42ca-9cd9-068a14db6e68"],
    "ISelectionContainer": ["6d5140c6-7436-11ce-8034-00aa006009fa"],
    "ISelectionInfo": ["2e12ca86-e1ed-4245-be49-207e42aec524"],
    "ISelectionItemPatternIdentifiers": ["2dafa41a-3ef8-4bb5-a02b-3ee1b2274740"],
    "ISelectionItemPatternIdentifiersStatics": ["a918d163-487e-4e3e-9f86-7b44acbe27ce"],
    "ISelectionItemProvider": ["2acad808-b2d4-452d-a407-91ff1ad167b2", "6a4977c1-830d-42d2-bf62-042ebddecc19"],
    "ISelectionManagerSpy": ["c93eec36-f800-4c33-9ee8-aa8613382c55"],
    "ISelectionPatternIdentifiers": ["4aa66fb0-e3f7-475f-b78d-f8a83bb730c4"],
    "ISelectionPatternIdentifiersStatics": ["93035b4c-6b50-40a1-b23f-5c78ddbd479a"],
    "ISelectionProvider": ["1f018fca-b944-4395-8de1-88f674af51d3", "fb8b03af-3bdf-48d4-bd36-1a65793be168"],
    "ISelectionProvider2": ["14f68475-ee1c-44f6-a869-d239381f0fe7"],
    "ISelectionServices2": ["30510490-98b5-11cf-bb82-00aa00bdce0b"],
    "ISelectionServices3": ["305106e6-98b5-11cf-bb82-00aa00bdce0b"],
    "ISelectionServicesListener2": ["30510489-98b5-11cf-bb82-00aa00bdce0b"],
    "ISelectionStateSpy": ["769964ba-41ca-41ac-a744-3586e355be23"],
    "ISelector": ["1abdaeca-68b6-4f83-9371-b413907c7b9f", "e30eb3a5-b36b-42dc-8527-cd25136c083c"],
    "ISelectorAutomationPeer": ["162ac829-7115-43ec-b383-a7b71644069d"],
    "ISelectorAutomationPeerFactory": ["7b525646-829b-4dcc-bd52-5a8d0399387a"],
    "ISelectorFactory": ["c9be2995-d136-4600-b187-8ad56079b48a"],
    "ISelectorItem": ["541c8d6c-0283-4581-b945-2a64c28a0646"],
    "ISelectorItemAutomationPeer": ["ae8b3477-860a-45bb-bf7c-e1b27419d1dd"],
    "ISelectorItemAutomationPeerFactory": ["66d7edfb-786d-4362-a964-ebfb21776c30"],
    "ISelectorItemFactory": ["b9363945-c86a-4b1e-9440-1879378d5313"],
    "ISelectorItemStatics": ["2a353ab8-cbe9-4303-92e7-c8906e218392"],
    "ISelectorStatics": ["13300b06-bd10-4e09-bff7-71efb8bbb42b"],
    "ISemanticNamedEntity": ["a3025981-c987-46f3-80f4-f838b51d4fe4"],
    "ISemanticTextQuery": ["6a1cab51-1fb2-4909-80b8-35731a2b3e7f"],
    "ISemanticTextQueryFactory": ["238c0503-f995-4587-8777-a2b7d80acfef"],
    "ISemanticType": ["788fa229-4290-4ce4-9b8e-eb1df4bed428"],
    "ISemanticZoom": ["019fff21-ece6-4fbc-bf40-8938d4813e27"],
    "ISemanticZoomAutomationPeer": ["3c2fac6c-a977-47fc-b44e-2754c0b2bea9"],
    "ISemanticZoomAutomationPeerFactory": ["f518d44d-a493-4496-b077-9674c7f4c5fa"],
    "ISemanticZoomInformation": ["a76a3b63-229b-4dc5-aa11-9d922fbf8a98"],
    "ISemanticZoomLocation": ["42011736-e3c2-496b-bc4e-d750d4375b9a"],
    "ISemanticZoomStatics": ["8ef17ef2-9898-4666-b285-3ed38a07910e"],
    "ISemanticZoomViewChangedEventArgs": ["47dfc068-b569-4b19-842d-8e6cf90989af"],
    "ISemanticZoomViewChangedEventHandler": ["1fa9161d-5d73-44fb-81ac-d1c9384919d4"],
    "ISensor": ["5fa08f80-2657-458e-af75-46f73fa6ac5c"],
    "ISensorClassExtension": ["a31253ba-6f73-4bc9-abaa-26c8833c58ff"],
    "ISensorCollection": ["23571e11-e545-4dd8-a337-b89bf44b10df"],
    "ISensorDataReport": ["0ab9df9b-c4b5-4796-8898-0470706a2e1d"],
    "ISensorDataThreshold": ["54daec61-fe4b-4e07-b260-3a4cdfbe396e"],
    "ISensorDataThresholdTrigger": ["5bc0f372-d48b-4b7f-abec-15f9bacc12e2"],
    "ISensorDataThresholdTriggerDetails": ["9106f1b7-e88d-48b1-bc90-619c7b349391"],
    "ISensorDataThresholdTriggerFactory": ["921fe675-7df0-4da3-97b3-e544ee857fe6"],
    "ISensorDriver": ["d262b6ba-87cc-495d-b639-939ef853bd3b"],
    "ISensorEvents": ["5d8dcc91-4641-47e7-b7c3-b74f48a6c391"],
    "ISensorManager": ["bd77db67-45a8-42dc-8d00-6dcf15f8377a"],
    "ISensorManagerEvents": ["9b3b0b86-266a-4aad-b21f-fde5501001b7"],
    "ISensorQuaternion": ["c9c5c827-c71c-46e7-9da3-36a193b232bc"],
    "ISensorRotationMatrix": ["0a3d5a67-22f4-4392-9538-65d0bd064aa6"],
    "ISequenceFeatureDescriptor": ["84f6945a-562b-4d62-a851-739aced96668"],
    "ISerialDevice": ["e187ccc6-2210-414f-b65a-f5553a03372a"],
    "ISerialDeviceStatics": ["058c4a70-0836-4993-ae1a-b61ae3be056b"],
    "ISerializable": ["000001b2-0000-0000-c000-000000000046"],
    "ISerializableParent": ["000001b1-0000-0000-c000-000000000046"],
    "IServerLocationInfo": ["000001a4-0000-0000-c000-000000000046"],
    "IServerMessageWebSocket": ["e3ac9240-813b-5efd-7e11-ae2305fc77f1"],
    "IServerMessageWebSocketControl": ["69c2f051-1c1f-587a-4519-2181610192b7"],
    "IServerMessageWebSocketInformation": ["fc32b45f-4448-5505-6cc9-09afa8915f5d"],
    "IServerState": ["8c4ec45c-a86d-4bf5-9ef8-77309de21a29"],
    "IServerStreamWebSocket": ["2ced5bbf-74f6-55e4-79df-9132680dfee8"],
    "IServerStreamWebSocketInformation": ["fc32b45f-4448-5505-6cc9-09aba8915f5d"],
    "IServiceDeviceStatics": ["a88214e1-59c7-4a20-aba6-9f6707937230"],
    "IServiceDocument": ["8b7ec771-2ab3-4dbe-8bcc-778f92b75e51"],
    "IServiceGroup": ["22c6ac65-851b-11d0-9a7f-00aa0038acfe"],
    "IServiceHostBrokerProvider": ["0f4accb1-d8f9-4011-ba37-2557925a78cf"],
    "IServiceHostComponent": ["a4b478cf-3ccf-4df0-a436-4b3b1474998b"],
    "IServiceHostCreationBehavior": ["dd540896-9b6f-4faa-8f9c-e5c39f983bde"],
    "IServiceLocationDescriptor": ["58c3c827-9d91-4215-bff3-820a49f0904c"],
    "IServiceProperties": ["eef35581-7b0a-11d0-ad6b-00a0c9055d8f"],
    "IServiceRequestedEventArgs": ["34283baf-abb4-4fc1-bd89-93f106573a49"],
    "IServiceRequestedEventArgs2": ["553c69d6-fafe-4128-8dfa-130e398a13a7"],
    "IServiceRequestedEventHandler": ["d2d690ba-cac9-48e1-95c0-d38495a84055"],
    "IServiceSink": ["22c6ac64-851b-11d0-9a7f-00aa0038acfe"],
    "IServiceSysTxnConfig": ["33caf1a1-fcb8-472b-b45e-967448ded6d8"],
    "IServicesSink": ["000001d3-0000-0000-c000-000000000046"],
    "IServicesSink2": ["00000200-0000-0000-c000-000000000046"],
    "ISessionInformation": ["666abe7d-4ae9-4f82-b443-2d56be8c44dd"],
    "ISessionObject": ["d97a6da0-a865-11cf-83af-00a0c90c2bd8"],
    "ISessionProperties": ["0c733a85-2a1c-11ce-ade5-00aa0044773d"],
    "ISessionStateChangeTrigger": ["754da71b-4385-4475-9dd9-598294fa3641"],
    "ISessionsChangedEventArgs": ["bbf0cd32-42c4-5a58-b317-f34bbfbd26e0"],
    "ISetCancelObject": ["81f36328-caf0-4be8-9e98-3fe08e778c0c"],
    "ISetDefaultSpatialAudioFormatResult": ["1c2aa511-1400-5e70-9ea9-ae151241e8ea"],
    "ISetFileChangeSourceInfo": ["82ded34b-5e4c-48c8-8f58-c58064db7f41"],
    "ISetModifiedTime": ["72e861d4-bcaa-4120-8aaa-cca1bb47de05"],
    "ISetNextStatement": ["51973c03-cb0c-11d0-b5c9-00a0244a0e7a"],
    "ISetOptionValue_Private": ["b84e7a64-3b29-4cbf-82e7-44a5f378586d"],
    "ISetPLMNwAcT": ["4e331477-f454-4de7-8b18-5130b891b012"],
    "ISetRFStateCompletion": ["340b4a01-07ce-4334-b367-05c87085cbb0"],
    "ISetSelectiveSyncInformationCallback": ["9035ffe3-646d-4014-ae41-98322af876f1"],
    "ISetShellForeground": ["bf0d821f-486c-49c4-8a3d-86e990047d65"],
    "ISetVersionDeferral": ["033508a2-781a-437a-b078-3f32badcfe47"],
    "ISetVersionRequest": ["b9c76b9b-1056-4e69-8330-162619956f9b"],
    "ISetViewSQMInfo": ["f6b2a97c-4b90-499c-84ca-2ba6dfccb8ef"],
    "ISetVsWeb": ["6b33dbd9-1ddd-11d3-85cf-00a0c9cfcc16"],
    "ISetWindowWithWindowFactory": ["5af48779-f000-493c-99f1-982fbbf305e0"],
    "ISetter": ["a73ded29-b4ae-4a81-be85-e690ba0d3b6e"],
    "ISetter2": ["70169561-05b1-4fa3-9d53-8e0c8c747afc"],
    "ISetterBase": ["418be27c-2ac4-4f22-8097-dea3aeeb2fb3"],
    "ISetterBaseCollection": ["03c40ca8-909e-4117-811c-a4529496bdf1"],
    "ISetterBaseFactory": ["81f8ad60-1ce8-469d-a667-16e37cef8ba9"],
    "ISetterFactory": ["d3ca3d42-09b1-49d5-8891-e7b5648e02a2"],
    "ISetting": ["a7bf3d4e-07b2-44a9-a422-5aaab468891e"],
    "ISettingChangePublisher": ["774a82b0-e36a-45e9-aed3-8b37c27db374"],
    "ISettingChangePublisherCallback": ["3524cafb-03a0-4b6d-a3ab-5c726940b34e"],
    "ISettingChangedEventHandler": ["d399e891-895f-4063-8c38-8eb5592513c6"],
    "ISettingCollectionConfig": ["c51a5d0d-7cc9-4317-b347-9c5de653668c"],
    "ISettingCollectionInfo": ["e6893277-8163-4859-a365-c514eb3bcb3c"],
    "ISettingCollectionInfoTest": ["4e1076dd-544c-47a7-8e18-72ffd562bd83"],
    "ISettingDBCollectionMap": ["c6d82ad7-d418-4977-b212-4a672f50c177"],
    "ISettingGroupInfo": ["b0902a1f-f69c-4607-a368-815dce8fc98f"],
    "ISettingHandler": ["0cb6e812-bd37-4416-bfae-e44a7c15b453"],
    "ISettingHandler2": ["9a9ec2f4-0fd1-482a-bf1c-09da712beff9"],
    "ISettingHandler3": ["25d925fc-26e0-4c49-bf2f-98f75937e361"],
    "ISettingHandler4": ["c5577898-f020-44b3-9f39-80c2ee410b81"],
    "ISettingHandler5": ["504796d0-ae81-4b72-8ee7-cc7c1cbe550c"],
    "ISettingHandlerEx": ["c0c083bc-6ec4-4349-96e9-20080fc304fc"],
    "ISettingHandlerFactory": ["5a84e371-30c3-4e32-b083-26cd77466980"],
    "ISettingHandlerFactory2": ["f8ece13c-e384-11e2-bc07-32066288709b"],
    "ISettingHandlerFactory3": ["1d7be3ff-126a-43f1-be41-8c8174e855a8"],
    "ISettingHandlerSession": ["22ffbb0c-954e-47e9-86ee-f94fb719d76b"],
    "ISettingHandlerWithConsistencyValidation": ["416ce172-a83d-4212-ae2f-f899050b4788"],
    "ISettingMonitor": ["6cfb0db1-727a-47c0-86e3-96538542f6a3"],
    "ISettingMonitorSink": ["7f5709f9-a78a-4f09-aa95-3d1b8e6842f8"],
    "ISettingSyncBackupManager": ["fca63a84-e61c-484c-94d2-2562abb9507d"],
    "ISettingSyncBackupNotificationSink": ["dffa04d0-887e-405c-92b5-b57da3db01df"],
    "ISettingSyncChangeDetectionCallback": ["e534977f-2bd2-44e5-bb86-16606a010591"],
    "ISettingSyncCloudService": ["3d8a9689-0461-4c7e-b394-720bcd534f06"],
    "ISettingSyncDiagnostics": ["02bc5ae1-dbf9-4a35-ab9c-08574ccc0a1f"],
    "ISettingSyncEngine": ["40497dc8-369c-4036-b022-43255225663b"],
    "ISettingSyncEngineEvents": ["a537f9ba-bf13-4faa-a187-16bbdb1f62ad"],
    "ISettingSyncGetBackupStatus": ["f4866150-9414-43e6-98b9-2bee241027a4"],
    "ISettingSyncParameters": ["5063f37d-4c87-4b40-a7b9-0b623eb567e4"],
    "ISettingSyncProvider": ["8fd41fd7-e8ec-48c0-a2b6-8a2b9076b4a6"],
    "ISettingSyncRemoteChangeDetection": ["63e1f8e4-465b-4ba7-a5e7-07466ad5b904"],
    "ISettingSyncRestore": ["ebb42bbb-2ad3-468f-b0ef-1839c3bed8f9"],
    "ISettingSyncServices": ["d5af044c-4a00-48dd-8f4d-e884eeca8652"],
    "ISettingSyncSettings": ["1950b812-a405-496d-aa3c-324417c11c7b"],
    "ISettingSyncSettingsEvents": ["b50e73be-5556-4afd-baa2-8e3e420428f2"],
    "ISettingSyncStateReporter": ["8256dd9b-bdaf-4b0e-aaf6-f4b179563c78"],
    "ISettingSyncTask": ["9c0ce862-0b63-46bc-b252-03904d16286b"],
    "ISettingSyncTaskBatch": ["9a34df69-1040-4a56-ab59-b35fc49d150a"],
    "ISettingSyncTaskProgressSink": ["57335c96-df8f-48e8-a5d8-8c598fa9ce88"],
    "ISettingUnit": ["1462ab8c-7a04-4481-a347-de71203fb380"],
    "ISettingUnit2": ["49fdacf5-e7cb-4b27-9efd-9126ec80da35"],
    "ISettingUnitAttributes": ["a2c446fb-55c8-4a0a-8f6a-2a54d67c0a8e"],
    "ISettingUnitDataStreamCallback": ["9f3b31df-ce39-4da3-a2f0-f240c1e10f06"],
    "ISettingUnitFactory": ["5d60bb5b-4edc-4bb8-adfa-7b2b49d6f126"],
    "ISettingUnitMetadata": ["b1f3cb6e-6889-46d6-8729-d9b5e8abb15b"],
    "ISettingUnitMetadataArray": ["7a2509e2-43c7-48f9-b21b-a9221eb944d8"],
    "ISettingUnitResolver": ["2722245e-02ff-4a98-953d-c2446dae762e"],
    "ISettingUnitWithChangeTracking": ["6a9cb13d-50cf-4ff0-bdd8-6a69ddfca9f4"],
    "ISettingUnitWithVersion": ["23f870ed-4023-4e74-afbc-14f0acea53cd"],
    "ISettingsBroker": ["ea77e0bc-3ce7-4cc1-928f-6f50a0ce5487"],
    "ISettingsCollection": ["62948522-8857-4c63-9b85-8fff20128f6a"],
    "ISettingsCommandFactory": ["68e15b33-1c83-433a-aa5a-ceeea5bd4764"],
    "ISettingsCommandStatics": ["749ae954-2f69-4b17-8aba-d05ce5778e46"],
    "ISettingsContext": ["9f7d7bbd-20b3-11da-81a5-0030f1642e3c"],
    "ISettingsEngine": ["9f7d7bb9-20b3-11da-81a5-0030f1642e3c"],
    "ISettingsFlow": ["ce05d854-a9d8-481b-9807-4e67534b33cd"],
    "ISettingsFlowBroker": ["cf1fbb8d-8ee6-4a22-a80a-38a9403ed361"],
    "ISettingsFlowController": ["87324ffd-bd0a-4de8-840a-b60e345a336f"],
    "ISettingsFlyout": ["830ba82b-c55b-4e32-a51c-5791e024c8af"],
    "ISettingsFlyoutAutomationPeer": ["d0de0cdb-30cf-47a6-a5eb-9c77f0b0d6dd"],
    "ISettingsFlyoutAutomationPeerFactory": ["f94762bd-8a14-40e4-94a7-3f33c922e945"],
    "ISettingsFlyoutFactory": ["480c7011-57aa-4db6-b6fd-ec676f6d414e"],
    "ISettingsFlyoutStatics": ["d0e3b535-9157-4be4-a42a-f591698846ac"],
    "ISettingsFlyoutTemplateSettings": ["bcf14c10-cea7-43f1-9d68-57605ded69d4"],
    "ISettingsIdentity": ["9f7d7bb6-20b3-11da-81a5-0030f1642e3c"],
    "ISettingsItem": ["9f7d7bbb-20b3-11da-81a5-0030f1642e3c"],
    "ISettingsNamespace": ["9f7d7bba-20b3-11da-81a5-0030f1642e3c"],
    "ISettingsProvider": ["5fc0f146-1b06-44ca-a568-283acd690e00"],
    "ISettingsResult": ["9f7d7bbc-20b3-11da-81a5-0030f1642e3c"],
    "IShadow": ["6813a583-f3b4-5fcf-8694-2cd0aefc2fad"],
    "IShadowFactory": ["19899f25-d28b-51e6-94b0-d7e709686305"],
    "IShape": ["786f2b75-9aa0-454d-ae06-a2466e37c832"],
    "IShape2": ["97248dba-49f2-49a4-a5dd-164df824db14"],
    "IShapeFactory": ["4b717613-f6aa-48d5-9588-e1d188eacbc9"],
    "IShapeStatics": ["1d7b4c55-9df3-48dc-9194-9d306faa6089"],
    "IShapeVisual": ["f2bd13c3-ba7e-4b0f-9126-ffb7536b8176"],
    "IShareAndDevicesFlow": ["b9b939fe-429a-45a0-8934-247a0c66348f"],
    "IShareCompletedEventArgs": ["4574c442-f913-4f60-9df7-cc4060ab1916"],
    "IShareEngine": ["559b1911-d3af-486e-b8bc-242b24df0114"],
    "IShareInfo": ["98ab8446-e195-42ec-b4fc-5f8d1891a4ad"],
    "IShareInvocableFlow": ["a14ef0a2-443d-4f30-9fba-872f634027f4"],
    "IShareManager": ["5bb62628-92e7-4f54-81a5-29c579341e13"],
    "IShareOperation": ["2246bab8-d0f8-41c1-a82a-4137db6504fb"],
    "IShareOperation2": ["0ffb97c1-9778-4a09-8e5b-cb5e482d0555"],
    "IShareOperation3": ["5ef6b382-b7a7-4571-a2a6-994a034988b2"],
    "ISharePermissionList": ["4c62a9fa-2437-49ca-8eb4-5238205afeaa"],
    "IShareProgressSink": ["781f154c-cd96-4b43-ac45-52f8858611fb"],
    "IShareProvider": ["2fabe026-443e-4cda-af25-8d81070efd80"],
    "IShareProviderFactory": ["172a174c-e79e-4f6d-b07d-128f469e0296"],
    "IShareProviderHandler": ["e7f9d9ba-e1ba-4e4d-bd65-d43845d3212f"],
    "IShareProviderOperation": ["19cef937-d435-4179-b6af-14e0492b69f6"],
    "IShareProvidersRequestedCallback": ["bb0446bf-4e86-444d-8859-48cd00622624"],
    "IShareProvidersRequestedEventArgs": ["f888f356-a3f8-4fce-85e4-8826e63be799"],
    "IShareSourceService": ["6522fd7c-7fd3-41a5-8e36-1f6324a7a1b1"],
    "IShareTargetActivatedEventArgs": ["4bdaf9c8-cdb2-4acb-bfc3-6648563378ec"],
    "IShareTargetInfo": ["385be607-c6e8-4114-b294-28f3bb6f9904"],
    "IShareUIOptions": ["72fa8a80-342f-4d90-9551-2ae04e37680c"],
    "ISharedBitmap": ["091162a4-bc96-411f-aae8-c5122cd03363"],
    "ISharedHandler": ["9b39439c-051e-4654-a0d0-7c03d67b17c6"],
    "ISharedHandlerAdviseSink": ["2a960141-45f5-4bf2-9634-f5ba1baf495f"],
    "ISharedModeSettingsStatics": ["893df40e-cad6-4d50-8c49-6fcfc03edb29"],
    "ISharedModeSettingsStatics2": ["608988a4-ccf1-4ee8-a5e2-fd6a1d0cfac8"],
    "ISharedStorageAccessManagerStatics": ["c6132ada-34b1-4849-bd5f-d09fee3158c5"],
    "ISharingConfigurationManager": ["b4cd448a-9c86-4466-9201-2e62105b87ae"],
    "ISharingConfigurationManagerPriv": ["a4341687-7593-47aa-9554-4b0ffc8b2214"],
    "ISharingConfigurationUI": ["14aa4ab8-abe3-4a07-a290-1d5dccdd2fc2"],
    "ISharingHandler": ["d774a009-5a9a-4b52-80b9-daa2deaf9bb3"],
    "ISharingRequestPriv": ["5655e471-f1fc-4dfd-adff-787a35cae468"],
    "ISharingSourcePriv": ["252e6571-8157-4809-8e2a-94aaa9e5de60"],
    "IShdocvwBroker": ["cd45afe8-9a64-402a-8cfd-22bb4ebd8b42"],
    "IShellACLCustomMRU": ["f729fc5e-8769-4f3e-bdb2-d7b50fd2275b"],
    "IShellBandProxy": ["924502a7-cc8e-4f60-ae1f-f70c0a2b7a7c"],
    "IShellBrokeredOperations": ["bde1d4ef-5c0e-4479-bdf2-beae34ee3a72"],
    "IShellBrowserService": ["dfbc7e30-f9e5-455f-88f8-fa98c1e494ca"],
    "IShellDispatch5": ["866738b9-6cf2-4de8-8767-f794ebe74f4e"],
    "IShellDispatch6": ["286e6f1b-7113-4355-9562-96b7e9d64c54"],
    "IShellDropTarget": ["e1a2097b-bd37-48bb-99d3-a3b80035fb57"],
    "IShellExperienceBroker": ["fec0a504-8e6c-40ff-8a92-f7d693afdcf0"],
    "IShellExperienceBrokerCoreShell": ["ec487044-45a9-42ef-874b-ac3faeaf9060"],
    "IShellExperienceLaunchBroker": ["54d853f6-fe65-4367-879e-8e31d47164c5"],
    "IShellExperienceNotification": ["eba2a855-d888-444c-9550-aeff9e8a45ad"],
    "IShellFolder3": ["711b2cfd-93d1-422b-bdf4-69be923f2449"],
    "IShellFolderItemFactory": ["ff314a1e-06fa-4f3a-84be-7aa1c6be2470"],
    "IShellFolderPropertyInformation": ["124bae2c-cb94-42cd-b5b8-4358789684ef"],
    "IShellFolderSearchable": ["4e1ae66c-204b-11d2-8db3-0000f87a556c"],
    "IShellFolderViewDual3": ["29ec8e6c-46d3-411f-baaa-611a6c9cac66"],
    "IShellFolderViewType": ["49422c1e-1c03-11d2-8dab-0000f87a556c"],
    "IShellIndexerAdmin": ["2ed326ed-c4c0-434a-b4ce-fb0318d725a7"],
    "IShellItem2": ["7e9fb0d3-919f-4307-ab2e-9b1860310c93"],
    "IShellItemArray": ["b63ea76d-1f85-456f-a19c-48159efa858b"],
    "IShellItemBrowser": ["9536ca39-1acb-4ae6-ad27-2403d04ca28f"],
    "IShellItemFilter": ["2659b475-eeb8-48b7-8f07-b378810f48cf"],
    "IShellItemImageFactory": ["bcc18b79-ba16-442f-80c4-8a59c30c463b"],
    "IShellItemImageFactoryPriv": ["8a322201-0a87-46c1-9c77-7620e0cc5bbc"],
    "IShellItemResources": ["ff5693be-2ce0-4d48-b5c5-40817d1acdb9"],
    "IShellLauncherDisambiguationHelper": ["d5fd04a5-15f2-4907-8888-c2e3b5141fa3"],
    "IShellLauncherDisambiguationUI": ["f43411e1-c021-44f5-938a-9d7d9ee11172"],
    "IShellLibrary": ["11a66efa-382e-451a-9234-1e0e12ef3085"],
    "IShellNavigationBand": ["e93d4057-b9a2-42a5-8af8-e5bbf177d365"],
    "IShellNavigationTarget": ["2ce15729-376f-4372-ad30-4148a6326ee8"],
    "IShellOverrideActivatorProvider": ["9a36f71d-38f0-4da3-a83e-2418b08d6a02"],
    "IShellPlaylist": ["50ef8e5b-67da-4683-83d6-3176ea154382"],
    "IShellPositionerActivationHandler": ["ff964f56-8baf-4947-9c46-f227ec68ff34"],
    "IShellPositionerCallback": ["4592c51d-a431-45e0-aa71-833dbadb3234"],
    "IShellPositionerFrameworkViewTypeChangedHandler": ["d452bf19-b505-4b1c-8182-1cc821a13092"],
    "IShellPositionerManager": ["ff62716a-0bd0-4105-a6ec-83b09d864267"],
    "IShellPositionerProxy": ["95e1216b-c9d8-4d0c-aa1b-19a86de9aa5b"],
    "IShellPropSheetTransaction": ["777ba802-2498-4875-933a-3067de883070"],
    "IShellQosRecorder2": ["92aa9ac8-ea08-4331-a3c4-0e46890f7cfd"],
    "IShellRunDll": ["fce4bde0-4b68-4b80-8e9c-7426315a7388"],
    "IShellSearchScope": ["617d2621-623d-4028-ac22-291b21826b86"],
    "IShellSearchTarget": ["9a7a94f5-fbf1-49a8-b0d9-44667635fe97"],
    "IShellSearchTargetServices": ["dda3a58a-43da-4a43-a5f2-f7abf6e3c026"],
    "IShellService": ["5836fb00-8187-11cf-a12b-00aa004ae837"],
    "IShellServiceObject": ["8e282aae-ace9-4821-83ad-849c1d08939d"],
    "IShellTargetingBackContractNotification": ["a24745fc-7a2e-4b7c-b092-8cb224694bbf"],
    "IShellTargetingChangeNotification": ["2c1448e1-7540-41b2-9b0d-188c012da2f1"],
    "IShellTargetingContractManager": ["c59a546b-412b-40f3-b151-9b3202e2835f"],
    "IShellTargetingContractNotification": ["2754a354-56cd-4a4a-a0ed-ec256a88d6b7"],
    "IShellTravelLogUI": ["db126a9b-7868-43a3-82e7-5364a3a1a541"],
    "IShellTreeWalker": ["95ce8410-7027-11d1-b879-006008059382"],
    "IShellTreeWalkerCallBack": ["9e213bcb-6682-426b-be24-e58a54d06f1e"],
    "IShellUIHelper2": ["a7fe6eda-1932-4281-b881-87b31b8bc52c"],
    "IShellUIHelper3": ["528df2ec-d419-40bc-9b6d-dcdbf9c1b25d"],
    "IShellUIHelper4": ["b36e6a53-8073-499e-824c-d776330a333e"],
    "IShellUIHelper5": ["a2a08b09-103d-4d3f-b91c-ea455ca82efa"],
    "IShellUIHelper6": ["987a573e-46ee-4e89-96ab-ddf7f8fdc98c"],
    "IShellUIHelper7": ["60e567c8-9573-4ab2-a264-637c6c161cb1"],
    "IShellUIHelper8": ["66debcf2-05b0-4f07-b49b-b96241a65db2"],
    "IShellUIHelper9": ["6cdf73b0-7f2f-451f-bc0f-63e0f3284e54"],
    "IShellUserAssist": ["49b36d57-5fd2-45a7-981b-06028d577a47"],
    "IShellUserAssist2": ["1f052fa3-7a76-4bec-96c4-e865cf1b55f1"],
    "IShellView3": ["ec39fa88-f8af-41c5-8421-38bed28f4673"],
    "IShellWebBrowserPriv": ["bde26d2e-140b-4aee-a4ce-0c4e7df6c1b1"],
    "IShellWebBrowserPriv2": ["9439c693-9c23-4a4c-b269-301f15ee64b5"],
    "IShouldSwitchToDesktop": ["23710692-92e0-4a33-a781-a81596a4cd7d"],
    "IShowHideAppInSearchPane": ["9632e2df-b52c-4ddf-a671-4821289d8ec5"],
    "IShowMessageAction": ["505e9e68-af89-46b8-a30f-56162a83d537"],
    "IShowModalDialog": ["20076c7e-4851-41ed-9eb8-f4e5f2bb0286"],
    "IShownTileNotification": ["342d8988-5af2-481a-a6a3-f2fdc78de88e"],
    "IShuffleEnabledChangeRequestedEventArgs": ["49b593fe-4fd0-4666-a314-c0e01940d302"],
    "IShutdownComponent": ["9a6de5fb-28ac-4e3c-898e-9cbf007719d8"],
    "IShutdownManagerStatics": ["72e247ed-dd5b-4d6c-b1d0-c57a7bbb5f94"],
    "IShutdownManagerStatics2": ["0f69a02f-9c34-43c7-a8c3-70b30a7f7504"],
    "ISideShowBulkCapabilities": ["3a2b7fbc-3ad5-48bd-bbf1-0e6cfbd10807"],
    "ISideShowCapabilities": ["535e1379-c09e-4a54-a511-597bab3a72b8"],
    "ISideShowCapabilitiesCollection": ["50305597-5e0d-4ff7-b3af-33d0d9bd52dd"],
    "ISideShowClassExtension": ["27e78451-41c1-47fd-a50d-4d3e97d35b30"],
    "ISideShowClassExtension2": ["1a6c8124-03e3-4a9a-afd3-cedd39e426b5"],
    "ISideShowContent": ["c18552ed-74ff-4fec-be07-4cfed29d4887"],
    "ISideShowContentManager": ["a5d5b66b-eef9-41db-8d7e-e17c33ab10b0"],
    "ISideShowDriver": ["2082260d-0e28-4c57-b5c2-67fa091daa91"],
    "ISideShowEvents": ["61feca4c-deb4-4a7e-8d75-51f1132d615b"],
    "ISideShowKeyCollection": ["045473bc-a37b-4957-b144-68105411ed8e"],
    "ISideShowNotification": ["03c93300-8ab2-41c5-9b79-46127a30e148"],
    "ISideShowNotificationManager": ["63cea909-f2b9-4302-b5e1-c68e6d9ab833"],
    "ISideShowPropVariantCollection": ["2ea7a549-7bff-4aae-bab0-22d43111de49"],
    "ISideShowSession": ["e22331ee-9e7d-4922-9fc2-ab7aa41ce491"],
    "ISignalHandler": ["923c402e-4721-440e-9dda-55b6f2e07710"],
    "ISignalNotifier": ["14285e06-63a7-4713-b6d9-62f64b56fb8b"],
    "ISignalNotifierStatics": ["1c4e4566-8400-46d3-a115-7d0c0dfc9f62"],
    "ISignalableNotifier": ["46305c32-09c6-45b2-b032-c12e467d7c7e"],
    "ISignedZeroOption": ["fd1cdd31-0a3c-49c4-a642-96a1564f4f30"],
    "ISignerCertificate": ["728ab33d-217d-11da-b2a4-000e7bbb2b09"],
    "ISignerCertificates": ["728ab33e-217d-11da-b2a4-000e7bbb2b09"],
    "ISignificantDigitsNumberRounder": ["f5941bca-6646-4913-8c76-1b191ff94dfd"],
    "ISignificantDigitsOption": ["1d4dfcdd-2d43-4ee8-bbf1-c1b26a711a58"],
    "ISimpleAudioRendererPrivate": ["c9019651-61b2-4389-b15d-5e48dfd7ffbf"],
    "ISimpleAudioVolume": ["87ce5498-68d6-44e5-9215-6da47ef883d8"],
    "ISimpleCPC": ["50162d8c-2cc0-49cf-ac69-5756696ddedd"],
    "ISimpleClientTableOptimizer": ["0d911f10-daee-11d1-8476-006008b0e5ca"],
    "ISimpleDataConverter": ["78667670-3c3d-11d2-91f9-006097c97f9b"],
    "ISimpleDataTableDispenser": ["4915a36c-0138-11d1-8d56-00c04fc2e0c7"],
    "ISimpleHapticsController": ["3d577ef9-4cee-11e6-b535-001bdc06ab3b"],
    "ISimpleHapticsControllerFeedback": ["3d577ef8-4cee-11e6-b535-001bdc06ab3b"],
    "ISimpleLogicTableDispenser": ["4915a36d-0138-11d1-8d56-00c04fc2e0c7"],
    "ISimpleMarshal": ["777ba8d1-2498-4875-933a-3067de883070"],
    "ISimpleModemCompletion": ["9a189741-ded1-4535-b116-b6d287bf70d2"],
    "ISimpleOrientationSensor": ["5ff53856-214a-4dee-a3f9-616f1ab06ffd"],
    "ISimpleOrientationSensor2": ["a277a798-8870-453e-8bd6-b8f5d8d7941b"],
    "ISimpleOrientationSensorDeviceId": ["fbc00acb-3b76-41f6-8091-30efe646d3cf"],
    "ISimpleOrientationSensorOrientationChangedEventArgs": ["bcd5c660-23d4-4b4c-a22e-ba81ade0c601"],
    "ISimpleOrientationSensorStatics": ["72ed066f-70aa-40c6-9b1b-3433f7459b4e"],
    "ISimpleOrientationSensorStatics2": ["848f9c7f-b138-4e11-8910-a2a2a3b56d83"],
    "ISimplePropertyChangeInit": ["b81da65e-6fc6-4995-86ba-7a113815ae3a"],
    "ISimpleTableControl": ["e3432b0c-c31f-11d1-8dec-00c04fc2e0c7"],
    "ISimpleTableDispenser": ["4915a36f-0138-11d1-8d56-00c04fc2e0c7"],
    "ISimpleTableDispenserWiring": ["a8927a44-d3ce-11d1-8472-006008b0e5ca"],
    "ISimpleTableMarshall": ["e7073790-bbc6-11d1-9d31-006008b0e5ca"],
    "ISimpleTableRead": ["958b6db6-ae2f-11d1-8de1-00c04fc2e0c7"],
    "ISimpleTableWrite": ["0032d55a-c320-11d1-8dec-00c04fc2e0c7"],
    "ISimpleUnknown": ["000c0500-0000-0000-c000-000000000046"],
    "ISineEase": ["a9382962-230b-49da-9e0d-664987892343"],
    "ISingleItemException": ["892fb9b0-7c55-4a18-9316-fdf449569b64"],
    "ISingleSelectMediaTrackList": ["77206f1f-c34f-494f-8077-2bad9ff4ecf1"],
    "ISitePath": ["b05651ca-9b10-425e-b616-1fcd828db3b1"],
    "ISitePath2": ["b05651cb-9b10-425e-b616-1fcd828db3b1"],
    "ISitePath3": ["751e8295-1700-416b-9f29-114920800dc9"],
    "ISitePaths": ["b05651c9-9b10-425e-b616-1fcd828db3b1"],
    "ISitePaths2": ["5bca4a22-fbdd-4ed0-8c36-30d53286d774"],
    "ISiteRestriction": ["b05651c7-9b10-425e-b616-1fcd828db3b1"],
    "ISiteRestriction2": ["b05651c8-9b10-425e-b616-1fcd828db3b1"],
    "ISiteRestrictions": ["b05651c6-9b10-425e-b616-1fcd828db3b1"],
    "ISizeChangedEventArgs": ["d5312e60-5cc1-42a1-920c-1af46be2f986"],
    "ISizeChangedEventHandler": ["1115b13c-25d2-480b-89dc-eb3dcbd6b7fa"],
    "ISizeHelper": ["e7225a94-5d03-4a03-ba94-967fc68fcefe"],
    "ISizeHelperStatics": ["6286c5b2-cf78-4915-aa40-76004a165f5e"],
    "ISketchInk": ["b4563688-98eb-4646-b279-44da14d45748"],
    "ISkewTransform": ["4e8a3b15-7a0f-4617-9e98-1e65bdc92115"],
    "ISkewTransformStatics": ["ecd11d73-5614-4b31-b6af-beae10105624"],
    "ISlideNavigationTransitionInfo": ["d6ac9d77-2e03-405f-80ed-e62beef3668f"],
    "ISlideNavigationTransitionInfo2": ["90e2d9c0-5c81-5001-8013-4fbfea4bf139"],
    "ISlideNavigationTransitionInfoStatics2": ["8a861baa-981a-5ace-9f85-cb7fde648a67"],
    "ISlider2": ["40a3c50e-87d6-4d2f-b1cf-b279cc996f26"],
    "ISliderAutomationPeer": ["ec30015a-d611-46d0-ae4f-6ecf27dfbaa5"],
    "ISliderAutomationPeerFactory": ["971b8056-9a7a-4df9-95fa-6f5c04c91cac"],
    "ISliderEvents": ["f08df953-8592-11d1-b16a-00c0f0283628"],
    "ISliderFactory": ["03a67b37-c7bf-437c-848f-8cb5b753eab4"],
    "ISliderStatics": ["8a4363d7-7fdf-4d30-98fe-ce78c05b31cf"],
    "ISliderStatics2": ["00e7935d-79a5-4759-96a6-29e0a94add33"],
    "ISlipPrintJob": ["5d88f95d-6131-5a4b-b7d5-8ef2da7b4165"],
    "ISlipPrinterCapabilities": ["99b16399-488c-4157-8ac2-9f57f708d3db"],
    "ISlipPrinterCapabilities2": ["6ff89671-2d1a-5000-87c2-b0851bfdf07e"],
    "ISmartCard": ["1b718871-6434-43f4-b55a-6a29623870aa"],
    "ISmartCardAppletIdGroup": ["7db165e6-6264-56f4-5e03-c86385395eb1"],
    "ISmartCardAppletIdGroup2": ["6b0ef9dc-9956-4a62-8d4e-d37a68ebc3a6"],
    "ISmartCardAppletIdGroupFactory": ["9105eb4d-4a65-4e41-8061-cbe83f3695e5"],
    "ISmartCardAppletIdGroupRegistration": ["df1208d1-31bb-5596-43b1-6d69a0257b3a"],
    "ISmartCardAppletIdGroupRegistration2": ["5f5508d8-98a7-4f2e-91d9-6cfcceda407f"],
    "ISmartCardAppletIdGroupStatics": ["ab2899a9-e76c-45cf-bf1d-90eaa6205927"],
    "ISmartCardAutomaticResponseApdu": ["52152bab-c63e-4531-a857-d756d99b986a"],
    "ISmartCardAutomaticResponseApdu2": ["44aebb14-559d-4531-4e51-89db6fa8a57a"],
    "ISmartCardAutomaticResponseApdu3": ["bf43da74-6576-4392-9367-fe3bc9e2d496"],
    "ISmartCardAutomaticResponseApduFactory": ["e97ea2fa-d02c-4c55-b02a-8cff7fa9f05b"],
    "ISmartCardChallengeContext": ["192a5319-c9c4-4947-81cc-44794a61ef91"],
    "ISmartCardConnect": ["2fdf87e5-028d-491e-a058-3382c3986f40"],
    "ISmartCardConnection": ["7edb991a-a81a-47bc-a649-156be6b7f231"],
    "ISmartCardCryptogramGenerator": ["e39f587b-edd3-4e49-b594-0ff5e4d0c76f"],
    "ISmartCardCryptogramGenerator2": ["7116aa34-5d6d-4b4a-96a3-efa47d2a7e25"],
    "ISmartCardCryptogramGeneratorStatics": ["09933910-cb9c-4015-967d-5234f3b02900"],
    "ISmartCardCryptogramGeneratorStatics2": ["09bdf5e5-b4bd-4e23-a588-74469204c128"],
    "ISmartCardCryptogramGetAllCryptogramMaterialCharacteristicsResult": ["2798e029-d687-4c92-86c6-399e9a0ecb09"],
    "ISmartCardCryptogramGetAllCryptogramMaterialPackageCharacteristicsResult": [
        "4e6a8a5c-9773-46c4-a32f-b1e543159e04"
    ],
    "ISmartCardCryptogramGetAllCryptogramStorageKeyCharacteristicsResult": ["8c7ce857-a7e7-489d-b9d6-368061515012"],
    "ISmartCardCryptogramMaterialCharacteristics": ["fc9ac5cc-c1d7-4153-923b-a2d43c6c8d49"],
    "ISmartCardCryptogramMaterialPackageCharacteristics": ["ffb58e1f-0692-4c47-93cf-34d91f9dcd00"],
    "ISmartCardCryptogramMaterialPossessionProof": ["e5b9ab8c-a141-4135-9add-b0d2e3aa1fc9"],
    "ISmartCardCryptogramPlacementStep": ["947b03eb-8342-4792-a2e5-925636378a53"],
    "ISmartCardCryptogramStorageKeyCharacteristics": ["8552546e-4457-4825-b464-635471a39f5c"],
    "ISmartCardCryptogramStorageKeyInfo": ["77b0f00d-b097-4f61-a26a-9561639c9c3a"],
    "ISmartCardCryptogramStorageKeyInfo2": ["000440f9-f7fd-417d-89e1-fbb0382adc4d"],
    "ISmartCardEmulator": ["dfb906b2-875e-47e5-8077-e8bff1b1c6fb"],
    "ISmartCardEmulator2": ["fe3fc0b8-8529-411a-807b-48edc2a0ab44"],
    "ISmartCardEmulatorApduReceivedEventArgs": ["d55d1576-69d2-5333-5b5f-f8c0d6e9f09f"],
    "ISmartCardEmulatorApduReceivedEventArgs2": ["8bf93df0-22e1-4238-8610-94ce4a965425"],
    "ISmartCardEmulatorApduReceivedEventArgsWithCryptograms": ["d550bac7-b7bf-4e29-9294-0c4ac3c941bd"],
    "ISmartCardEmulatorConnectionDeactivatedEventArgs": ["2186d8d3-c5eb-5262-43df-62a0a1b55557"],
    "ISmartCardEmulatorConnectionProperties": ["4e2ca5ee-f969-507d-6cf9-34e2d18df311"],
    "ISmartCardEmulatorStatics": ["7a9bfc4b-c4d3-494f-b8a2-6215d81e85b2"],
    "ISmartCardEmulatorStatics2": ["69ae9f8a-b775-488b-8436-6c1e28ed731f"],
    "ISmartCardEmulatorStatics3": ["59ea142a-9f09-43f5-8565-cfa8148e4cb2"],
    "ISmartCardPinPolicy": ["183ce184-4db6-4841-ac9e-2ac1f39b7304"],
    "ISmartCardPinResetDeferral": ["18c94aac-7805-4004-85e4-bbefac8f6884"],
    "ISmartCardPinResetHandler": ["138d5e40-f3bc-4a5c-b41d-4b4ef684e237"],
    "ISmartCardPinResetRequest": ["12fe3c4d-5fb9-4e8e-9ff6-61f475124fef"],
    "ISmartCardProvisioning": ["19eeedbd-1fab-477c-b712-1a2c5af1fd6e"],
    "ISmartCardProvisioning2": ["10fd28eb-3f79-4b66-9b7c-11c149b7d0bc"],
    "ISmartCardProvisioningStatics": ["13882848-0d13-4e70-9735-51daeca5254f"],
    "ISmartCardProvisioningStatics2": ["3447c6a8-c9a0-4bd6-b50d-251f4e8d3a62"],
    "ISmartCardReader": ["1074b4e0-54c2-4df0-817a-14c14378f06c"],
    "ISmartCardReaderStatics": ["103c04e1-a1ca-48f2-a281-5b6f669af107"],
    "ISmartCardTrigger": ["f53bc5ac-84ca-4972-8ce9-e58f97b37a50"],
    "ISmartCardTriggerDetails": ["5f9bf11e-39ef-4f2b-b44f-0a9155b177bc"],
    "ISmartCardTriggerDetails2": ["2945c569-8975-4a51-9e1a-5f8a76ee51af"],
    "ISmartCardTriggerDetails3": ["b3e2c27d-18c6-4ba8-8376-ef03d4912666"],
    "ISmartCardTriggerFactory": ["63bf54c3-89c1-4e00-a9d3-97c629269dad"],
    "ISmartRenderEngine": ["f03fa8ce-879a-4d59-9b2c-26bb1cf83461"],
    "ISmbiosInformationStatics": ["080cca7c-637c-48c4-b728-f9273812db8e"],
    "ISmimeCapabilities": ["728ab31a-217d-11da-b2a4-000e7bbb2b09"],
    "ISmimeCapability": ["728ab319-217d-11da-b2a4-000e7bbb2b09"],
    "ISmsAppMessage": ["e8bb8494-d3a0-4a0a-86d7-291033a8cf54"],
    "ISmsBroadcastMessage": ["75aebbf1-e4b7-4874-a09c-2956e592f957"],
    "ISmsDevice2": ["bd8a5c13-e522-46cb-b8d5-9ead30fb6c47"],
    "ISmsDevice2Statics": ["65c78325-1031-491e-8fb6-ef9991afe363"],
    "ISmsFilterRule": ["40e32fae-b049-4fbc-afe9-e2a610eff55c"],
    "ISmsFilterRuleFactory": ["00c36508-6296-4f29-9aad-8920ceba3ce8"],
    "ISmsFilterRules": ["4e47eafb-79cd-4881-9894-55a4135b23fa"],
    "ISmsFilterRulesFactory": ["a09924ed-6e2e-4530-9fde-465d02eed00e"],
    "ISmsMessage": ["ed3c5e28-6984-4b07-811d-8d5906ed3cea"],
    "ISmsMessageBase": ["2cf0fe30-fe50-4fc6-aa88-4ccfe27a29ea"],
    "ISmsMessageReceivedTriggerDetails": ["2bcfcbd4-2657-4128-ad5f-e3877132bdb1"],
    "ISmsMessageReceivedTriggerFactory": ["ea3ad8c8-6ba4-4ab2-8d21-bc6b09c77564"],
    "ISmsMessageRegistration": ["1720503e-f34f-446b-83b3-0ff19923b409"],
    "ISmsMessageRegistrationStatics": ["63a05464-2898-4778-a03c-6f994907d63a"],
    "ISmsSendMessageResult": ["db139af2-78c9-4feb-9622-452328088d62"],
    "ISmsStatusMessage": ["e6d28342-b70b-4677-9379-c9783fdff8f4"],
    "ISmsTextMessage2": ["22a0d893-4555-4755-b5a1-e7fd84955f8d"],
    "ISmsVoicemailMessage": ["271aa0a6-95b1-44ff-bcb8-b8fdd7e08bc3"],
    "ISmsWapMessage": ["cd937743-7a55-4d3b-9021-f22e022d09c5"],
    "ISnapAssistCallback": ["76d7759a-857c-46bd-ba0c-841904e0fc8d"],
    "ISnapAssistViewHost": ["b63cb15a-d1aa-4a39-bc06-78e9843bf5c4"],
    "ISnapServiceProvider": ["fff59320-db70-4865-8fed-8b502d692f12"],
    "ISnapinNode": ["2f3be7c5-bbfc-4db0-a305-ea42b8c8bc9c"],
    "ISnapinNodeDetails": ["338f8b06-ab58-4e0f-ad8e-58429a006bd7"],
    "ISnapinNotify": ["8af97d5e-b474-423a-81b8-2c434228446d"],
    "ISnapinRegistration": ["86685dba-b5a3-4cbb-8bee-0eac3b11605b"],
    "ISnapinScopeNode": ["d139c6a2-12d0-4f70-92d6-6a07a9d26e3f"],
    "ISnapinState": ["992be79a-7969-4406-bb21-3eff61985a92"],
    "ISocketActivityContext": ["43b04d64-4c85-4396-a637-1d973f6ebd49"],
    "ISocketActivityContextFactory": ["b99fc3c3-088c-4388-83ae-2525138e049a"],
    "ISocketActivityInformation": ["8d8a42e4-a87e-4b74-9968-185b2511defe"],
    "ISocketActivityInformationStatics": ["8570b47a-7e7d-4736-8041-1327a6543c56"],
    "ISocketActivityTrigger": ["a9bbf810-9dde-4f8a-83e3-b0e0e7a50d70"],
    "ISocketActivityTriggerDetails": ["45f406a7-fc9f-4f81-acad-355fef51e67b"],
    "ISocketErrorStatics": ["828337f4-7d56-4d8e-b7b4-a07dd7c1bca9"],
    "ISoftKbd": ["3cb00755-7536-4b0a-a213-572efcaf93cd"],
    "ISoftKbdWindowEventSink": ["e4283da5-d425-4f97-8b6a-061a03556e95"],
    "ISoftKeyboardEventSink": ["3ea2bb1d-66e7-47f7-8795-cc03d388f887"],
    "ISoftwareBitmap": ["689e0708-7eef-483f-963f-da938818e073"],
    "ISoftwareBitmapFactory": ["c99feb69-2d62-4d47-a6b3-4fdb6a07fdf8"],
    "ISoftwareBitmapNative": ["94bc8415-04ea-4b2e-af13-4de95aa898eb"],
    "ISoftwareBitmapNativeFactory": ["c3c181ec-2914-4791-af02-02d224a10b43"],
    "ISoftwareBitmapSource": ["d2dd9ed0-d3c5-4056-91b5-b7c1d1e8130e"],
    "ISoftwareBitmapStatics": ["df0385db-672f-4a9d-806e-c2442f343e86"],
    "ISolidColorBrush": ["9d850850-66f3-48df-9a8f-824bd5e070af"],
    "ISolidColorBrushFactory": ["d935ce0c-86f5-4da6-8a27-b1619ef7f92b"],
    "ISolidColorBrushStatics": ["e1a65efa-2b23-41ba-b9ba-7094ec8e4e9f"],
    "ISortColumnArray": ["6dfc60fb-f2e9-459b-beb5-288f1a7c7d54"],
    "ISortHintProvider": ["b1784ab0-04ae-4387-9bc8-0ca614fbe454"],
    "ISortPropertyArray": ["7c063b2e-1d24-40b4-ac0b-d349a6dbf779"],
    "ISoundLevelBrokerStatics": ["6a633961-dbed-464c-a09a-33412f5caa3f"],
    "ISourceChangeRequestedEventArgs": ["fb3f3a96-7aa6-4a8b-86e7-54f6c6d34f64"],
    "ISourcesRowset": ["0c733a1e-2a1c-11ce-ade5-00aa0044773d"],
    "ISpAudio": ["c05c768f-fae8-4ec2-8e07-338321c12452"],
    "ISpCFGInterpreter": ["f3d3f926-11fc-11d3-bb97-00c04f8ee6c0"],
    "ISpCFGInterpreterSite": ["6a6ffad8-78b6-473d-b844-98152e4fb16b"],
    "ISpContainerLexicon": ["8565572f-c094-41cc-b56e-10bd9c3ff044"],
    "ISpDataKey": ["14056581-e16c-11d2-bb90-00c04f8ee6c0"],
    "ISpDisplayAlternates": ["c8d7c7e2-0dde-44b7-afe3-b0c991fbeb5e"],
    "ISpEnginePronunciation": ["c360ce4b-76d1-4214-ad68-52657d5083da"],
    "ISpErrorLog": ["f4711347-e608-11d2-a086-00c04f8ef9b5"],
    "ISpEventSink": ["be7a9cc9-5f9e-11d2-960f-00c04f8ee628"],
    "ISpEventSource": ["be7a9cce-5f9e-11d2-960f-00c04f8ee628"],
    "ISpEventSource2": ["2373a435-6a4b-429e-a6ac-d4231a61975b"],
    "ISpGramCompBackend": ["3ddca27c-665c-4786-9f97-8c90c3488b61"],
    "ISpGrammarBuilder": ["8137828f-591a-4a42-be58-49ea7ebaac68"],
    "ISpGrammarBuilder2": ["8ab10026-20cc-4b20-8c22-a49c9ba78f60"],
    "ISpGrammarCompiler": ["b1e29d58-a675-11d2-8302-00c04f8ee6c0"],
    "ISpITNProcessor": ["12d7360f-a1c9-11d3-bc90-00c04f72df9f"],
    "ISpLexicon": ["da41a7c2-5383-4db2-916b-6c1719e3db58"],
    "ISpMMSysAudio": ["15806f6e-1d70-4b48-98e6-3b1a007509ab"],
    "ISpNotifySink": ["259684dc-37c3-11d2-9603-00c04f8ee628"],
    "ISpNotifyTranslator": ["aca16614-5d3d-11d2-960e-00c04f8ee628"],
    "ISpObjectToken": ["14056589-e16c-11d2-bb90-00c04f8ee6c0"],
    "ISpObjectTokenCategory": ["2d3d3845-39af-4850-bbf9-40b49780011d"],
    "ISpObjectTokenEnumBuilder": ["06b64f9f-7fda-11d2-b4f2-00c04f797396"],
    "ISpObjectTokenInit": ["b8aab0cf-346f-49d8-9499-c8b03f161d51"],
    "ISpObjectWithToken": ["5b559f40-e952-11d2-bb91-00c04f8ee6c0"],
    "ISpPhoneConverter": ["8445c581-0cac-4a38-abfe-9b2ce2826455"],
    "ISpPhoneticAlphabetConverter": ["133adcd4-19b4-4020-9fdc-842e78253b17"],
    "ISpPhoneticAlphabetSelection": ["b2745efd-42ce-48ca-81f1-a96e02538a90"],
    "ISpPhrase": ["1a5c0354-b621-4b5a-8791-d306ed379e53"],
    "ISpPhrase2": ["f264da52-e457-4696-b856-a737b717af79"],
    "ISpPhraseAlt": ["8fcebc98-4e49-4067-9c6c-d86a0e092e3d"],
    "ISpPhraseBuilder": ["88a3342a-0bed-4834-922b-88d43173162f"],
    "ISpPrivateEngineCallEx": ["defd682a-fe0a-42b9-bfa1-56d3d6cecfaf"],
    "ISpProperties": ["5b4fb971-b115-4de1-ad97-e482e3bf6ee4"],
    "ISpRecoCategory": ["da0cd0f9-14a2-4f09-8c2a-85cc48979345"],
    "ISpRecoContext": ["f740a62f-7c15-489e-8234-940a33d9272d"],
    "ISpRecoContext2": ["bead311c-52ff-437f-9464-6b21054ca73d"],
    "ISpRecoGrammar": ["2177db29-7f45-47d0-8554-067e91c80502"],
    "ISpRecoGrammar2": ["4b37bc9e-9ed6-44a3-93d3-18f022b79ec3"],
    "ISpRecoResult": ["20b053be-e235-43cd-9a2a-8d17a48b7842"],
    "ISpRecoResult2": ["27cac6c4-88f2-41f2-8817-0c95e59f1e6e"],
    "ISpRecognizer": ["c2b5f241-daa0-4507-9e16-5a1eaa2b7a5c"],
    "ISpRecognizer2": ["8fc6d974-c81e-4098-93c5-0147f61ed4d3"],
    "ISpRecognizer3": ["df1b943c-5838-4aa2-8706-d7cd5b333499"],
    "ISpRegDataKey": ["92a66e2b-c830-4149-83df-6fc2ba1e7a5b"],
    "ISpResourceManager": ["93384e18-5014-43d5-adbb-a78e055926bd"],
    "ISpSRAlternates": ["fece8294-2be1-408f-8e68-2de377092f0e"],
    "ISpSRAlternates2": ["f338f437-cb33-4020-9cab-c71ff9ce12d3"],
    "ISpSREngine": ["2f472991-854b-4465-b613-fbafb3ad8ed8"],
    "ISpSREngine2": ["7ba627d8-33f9-4375-90c5-9985aee5ede5"],
    "ISpSREngineSite": ["3b414aec-720c-4883-b9ef-178cd394fb3a"],
    "ISpSREngineSite2": ["7bc6e012-684a-493e-bdd4-2bf5fbf48cfe"],
    "ISpSerializeState": ["21b501a0-0ec7-46c9-92c3-a2bc784c54b9"],
    "ISpShortcut": ["3df681e2-ea56-11d9-8bde-f66bad1e3f3a"],
    "ISpStream": ["12e3cca9-7518-44c5-a5e7-ba5a79cb929e"],
    "ISpStreamFormat": ["bed530be-2606-4f4d-a1c0-54c5cda5566f"],
    "ISpStreamFormatConverter": ["678a932c-ea71-4446-9b41-78fda6280a29"],
    "ISpTTSEngine": ["a74d7c8e-4cc5-4f2f-a6eb-804dee18500e"],
    "ISpTTSEngineSite": ["9880499b-cce9-11d2-b503-00c04f797396"],
    "ISpTabWindowVisibilityChangedEvent": ["ec16b858-0d6e-47d2-bfb3-04683ed1e87d"],
    "ISpTaskManager": ["2baeef81-2ca3-4331-98f3-26ec5abefb03"],
    "ISpThreadControl": ["a6be4d73-4403-4358-b22d-0346e23b1764"],
    "ISpTokenUI": ["f8e690f0-39cb-4843-b8d7-c84696e1119d"],
    "ISpTranscript": ["10f63bce-201a-11d3-ac70-00c04f8ee6c0"],
    "ISpVoice": ["6c44df74-72b9-4992-a1ec-ef996e0422d4"],
    "ISpXMLRecoResult": ["ae39362b-45a8-4074-9b9e-ccf49aa2d0b6"],
    "ISpan": ["9839d4a9-02af-4811-aa15-6bef3acac97a"],
    "ISpanFactory": ["5b916f5c-cd2d-40c0-956a-386448322f79"],
    "ISpatialAnchor": ["0529e5ce-1d34-3702-bcec-eabff578a869"],
    "ISpatialAnchor2": ["ed17c908-a695-4cf6-92fd-97263ba71047"],
    "ISpatialAnchorExportSufficiency": ["77c25b2b-3409-4088-b91b-fdfd05d1648f"],
    "ISpatialAnchorExporter": ["9a2a4338-24fb-4269-89c5-88304aeef20f"],
    "ISpatialAnchorExporterStatics": ["ed2507b8-2475-439c-85ff-7fed341fdc88"],
    "ISpatialAnchorManagerStatics": ["88e30eab-f3b7-420b-b086-8a80c07d910d"],
    "ISpatialAnchorRawCoordinateSystemAdjustedEventArgs": ["a1e81eb8-56c7-3117-a2e4-81e0fcf28e00"],
    "ISpatialAnchorStatics": ["a9928642-0174-311c-ae79-0e5107669f16"],
    "ISpatialAnchorStore": ["b0bc3636-486a-3cb0-9e6f-1245165c4db6"],
    "ISpatialAudioClient": ["bbf8e066-aaaa-49be-9a4d-fd2a858ea27f"],
    "ISpatialAudioDeviceConfiguration": ["ee830034-61cf-5749-9da4-10f0fe028199"],
    "ISpatialAudioDeviceConfigurationStatics": ["3ec37f7b-936d-4e04-9728-2827d9f758c4"],
    "ISpatialAudioDevicePropertyReader": ["2d0bc81a-3c62-460c-a025-3c2e7a1b5e1a"],
    "ISpatialAudioEncoderProperties": ["b090ccfb-2d8c-416b-bfef-598bca3c91a9"],
    "ISpatialAudioFormatConfiguration": ["32df09a8-50f0-5395-9923-7d44ca71ed6d"],
    "ISpatialAudioFormatConfigurationStatics": ["2b5fef71-67c9-4e5f-a35b-41680711f8c7"],
    "ISpatialAudioFormatSubtypeStatics": ["b3de8a47-83ee-4266-a945-bedf507afeed"],
    "ISpatialAudioMetadataClient": ["777d4a3b-f6ff-4a26-85dc-68d7cdeda1d4"],
    "ISpatialAudioMetadataCommandVerifier": ["7b16f20c-3fd9-4de9-b236-8fc0f5a80caa"],
    "ISpatialAudioMetadataCopier": ["d224b233-e251-4fd0-9ca2-d5ecf9a68404"],
    "ISpatialAudioMetadataDictionary": ["7175fd87-aec9-42ed-ad43-364817a8ed7a"],
    "ISpatialAudioMetadataDictionaryData": ["af467d4d-6b91-4cca-a7ab-7470879192bf"],
    "ISpatialAudioMetadataItemMerger": ["31a40a90-394c-4613-92f6-2fe425a3f940"],
    "ISpatialAudioMetadataItemReader": ["7c3239ef-8ded-4cb2-a1e5-c29fdfbf8dcb"],
    "ISpatialAudioMetadataItemWriter": ["62b7144b-22a3-4efe-98b9-d6a00bcf1949"],
    "ISpatialAudioMetadataItems": ["bcd7c78f-3098-4f22-b547-a2f25a381269"],
    "ISpatialAudioMetadataItemsBuffer": ["42640a16-e1bd-42d9-9ff6-031ab71a2dba"],
    "ISpatialAudioMetadataItemsPrivate": ["273136f1-d298-4e6e-9fee-33f89b73f18b"],
    "ISpatialAudioMetadataReader": ["b78e86a2-31d9-4c32-94d2-7df40fc7ebec"],
    "ISpatialAudioMetadataWriter": ["1b17ca01-2955-444d-a430-537dc589a844"],
    "ISpatialAudioObject": ["dde28967-521b-46e5-8f00-bd6f2bc8ab1d"],
    "ISpatialAudioObjectBase": ["cce0b8f2-8d4d-4efb-a8cf-3d6ecf1c30e0"],
    "ISpatialAudioObjectForHrtf": ["d7436ade-1978-4e14-aba0-555bd8eb83b4"],
    "ISpatialAudioObjectForMetadataCommands": ["0df2c94b-f5f9-472d-af6b-c46e0ac9cd05"],
    "ISpatialAudioObjectForMetadataItems": ["ddea49ff-3bc0-4377-8aad-9fbcfd808566"],
    "ISpatialAudioObjectRenderStream": ["bab5f473-b423-477b-85f5-b5a332a04153"],
    "ISpatialAudioObjectRenderStreamBase": ["feaaf403-c1d8-450d-aa05-e0ccee7502a8"],
    "ISpatialAudioObjectRenderStreamForHrtf": ["e08deef9-5363-406e-9fdc-080ee247bbe0"],
    "ISpatialAudioObjectRenderStreamForMetadata": ["bbc9c907-48d5-4a2e-a0c7-f7f0d67c1fb1"],
    "ISpatialAudioObjectRenderStreamNotify": ["dddf83e6-68d7-4c70-883f-a1836afb4a50"],
    "ISpatialAudioPositionCalc": ["ea0e3fe9-ee0e-40e5-9eb2-28a576108545"],
    "ISpatialAudioStreamProcessor": ["ff4fd0e7-dae6-4f9f-b627-53d3bfbc611a"],
    "ISpatialBoundingVolume": ["fb2065da-68c3-33df-b7af-4c787207999c"],
    "ISpatialBoundingVolumeStatics": ["05889117-b3e1-36d8-b017-566181a5b196"],
    "ISpatialCoordinateSystem": ["69ebca4b-60a3-3586-a653-59a7bd676d07"],
    "ISpatialEntity": ["166de955-e1eb-454c-ba08-e6c0668ddc65"],
    "ISpatialEntityAddedEventArgs": ["a397f49b-156a-4707-ac2c-d31d570ed399"],
    "ISpatialEntityFactory": ["e1f1e325-349f-4225-a2f3-4b01c15fe056"],
    "ISpatialEntityRemovedEventArgs": ["91741800-536d-4e9f-abf6-415b5444d651"],
    "ISpatialEntityStore": ["329788ba-e513-4f06-889d-1be30ecf43e6"],
    "ISpatialEntityStoreStatics": ["6b4b389e-7c50-4e92-8a62-4d1d4b7ccd3e"],
    "ISpatialEntityUpdatedEventArgs": ["e5671766-627b-43cb-a49f-b3be6d47deed"],
    "ISpatialEntityWatcher": ["b3b85fa0-6d5e-4bbc-805d-5fe5b9ba1959"],
    "ISpatialGestureRecognizer": ["71605bcc-0c35-4673-adbd-cc04caa6ef45"],
    "ISpatialGestureRecognizerFactory": ["77214186-57b9-3150-8382-698b24e264d0"],
    "ISpatialGraphInteropFrameOfReferencePreview": ["a8271b23-735f-5729-a98e-e64ed189abc5"],
    "ISpatialGraphInteropPreviewStatics": ["c042644c-20d8-4ed0-aef7-6805b8e53f55"],
    "ISpatialGraphInteropPreviewStatics2": ["2490b15f-6cbd-4b1e-b765-31e462a32df2"],
    "ISpatialHoldCanceledEventArgs": ["5dfcb667-4caa-4093-8c35-b601a839f31b"],
    "ISpatialHoldCompletedEventArgs": ["3f64470b-4cfd-43da-8dc4-e64552173971"],
    "ISpatialHoldStartedEventArgs": ["8e343d79-acb6-4144-8615-2cfba8a3cb3f"],
    "ISpatialInteraction": ["fc967639-88e6-4646-9112-4344aaec9dfa"],
    "ISpatialInteractionController": ["5f0e5ba3-0954-4e97-86c5-e7f30b114dfd"],
    "ISpatialInteractionController2": ["35b6d924-c7a2-49b7-b72e-5436b2fb8f9c"],
    "ISpatialInteractionController3": ["628466a0-9d91-4a0b-888d-165e670a8cd5"],
    "ISpatialInteractionControllerProperties": ["61056fb1-7ba9-4e35-b93f-9272cba9b28b"],
    "ISpatialInteractionDetectedEventArgs": ["075878e4-5961-3b41-9dfb-cea5d89cc38a"],
    "ISpatialInteractionDetectedEventArgs2": ["7b263e93-5f13-419c-97d5-834678266aa6"],
    "ISpatialInteractionManager": ["32a64ea8-a15a-3995-b8bd-80513cb5adef"],
    "ISpatialInteractionManagerInterop": ["5c4ee536-6a98-4b86-a170-587013d6fd4b"],
    "ISpatialInteractionManagerStatics": ["00e31fa6-8ca2-30bf-91fe-d9cb4a008990"],
    "ISpatialInteractionManagerStatics2": ["93f16c52-b88a-5929-8d7c-48cb948b081c"],
    "ISpatialInteractionSource": ["fb5433ba-b0b3-3148-9f3b-e9f5de568f5d"],
    "ISpatialInteractionSource2": ["e4c5b70c-0470-4028-88c0-a0eb44d34efe"],
    "ISpatialInteractionSource3": ["0406d9f9-9afd-44f9-85dc-700023a962e3"],
    "ISpatialInteractionSource4": ["0073bc4d-df66-5a91-a2ba-cea3e5c58a19"],
    "ISpatialInteractionSourceEventArgs": ["23b786cf-ec23-3979-b27c-eb0e12feb7c7"],
    "ISpatialInteractionSourceEventArgs2": ["d8b4b467-e648-4d52-ab49-e0d227199f63"],
    "ISpatialInteractionSourceLocation": ["ea4696c4-7e8b-30ca-bcc5-c77189cea30a"],
    "ISpatialInteractionSourceLocation2": ["4c671045-3917-40fc-a9ac-31c9cf5ff91b"],
    "ISpatialInteractionSourceLocation3": ["6702e65e-e915-4cfb-9c1b-0538efc86687"],
    "ISpatialInteractionSourceProperties": ["05604542-3ef7-3222-9f53-63c9cb7e3bc7"],
    "ISpatialInteractionSourceState": ["d5c475ef-4b63-37ec-98b9-9fc652b9d2f2"],
    "ISpatialInteractionSourceState2": ["45f6d0bd-1773-492e-9ba3-8ac1cbe77c08"],
    "ISpatialInteractionSourceState3": ["f2f00bc2-bd2b-4a01-a8fb-323e0158527c"],
    "ISpatialLocation": ["1d81d29d-24a1-37d5-8fa1-39b4f9ad67e2"],
    "ISpatialLocation2": ["117f2416-38a7-4a18-b404-ab8fabe1d78b"],
    "ISpatialLocator": ["f6478925-9e0c-3bb6-997e-b64ecca24cf4"],
    "ISpatialLocatorAttachedFrameOfReference": ["e1774ef6-1f4f-499c-9625-ef5e6ed7a048"],
    "ISpatialLocatorPositionalTrackingDeactivatingEventArgs": ["b8a84063-e3f4-368b-9061-9ea9d1d6cc16"],
    "ISpatialLocatorStatics": ["b76e3340-a7c2-361b-bb82-56e93b89b1bb"],
    "ISpatialManipulationCanceledEventArgs": ["2d40d1cb-e7da-4220-b0bf-819301674780"],
    "ISpatialManipulationCompletedEventArgs": ["05086802-f301-4343-9250-2fbaa5f87a37"],
    "ISpatialManipulationDelta": ["a7ec967a-d123-3a81-a15b-992923dcbe91"],
    "ISpatialManipulationStartedEventArgs": ["a1d6bbce-42a5-377b-ada6-d28e3d384737"],
    "ISpatialManipulationUpdatedEventArgs": ["5f230b9b-60c6-4dc6-bdc9-9f4a6f15fe49"],
    "ISpatialNavigationCanceledEventArgs": ["ce503edc-e8a5-46f0-92d4-3c122b35112a"],
    "ISpatialNavigationCompletedEventArgs": ["012e80b7-af3b-42c2-9e41-baaa0e721f3a"],
    "ISpatialNavigationStartedEventArgs": ["754a348a-fb64-4656-8ebd-9deecaafe475"],
    "ISpatialNavigationUpdatedEventArgs": ["9b713fd7-839d-4a74-8732-45466fc044b5"],
    "ISpatialPointerInteractionSourcePose": ["a7104307-2c2b-4d3a-92a7-80ced7c4a0d0"],
    "ISpatialPointerInteractionSourcePose2": ["eccd86b8-52db-469f-9e3f-80c47f74bce9"],
    "ISpatialPointerPose": ["6953a42e-c17e-357d-97a1-7269d0ed2d10"],
    "ISpatialPointerPose2": ["9d202b17-954e-4e0c-96d1-b6790b6fc2fd"],
    "ISpatialPointerPose3": ["6342f3f0-ec49-5b4b-b8d1-d16cbb16be84"],
    "ISpatialPointerPoseStatics": ["a25591a9-aca1-3ee0-9816-785cfb2e3fb8"],
    "ISpatialRecognitionEndedEventArgs": ["0e35f5cb-3f75-43f3-ac81-d1dc2df9b1fb"],
    "ISpatialRecognitionStartedEventArgs": ["24da128f-0008-4a6d-aa50-2a76f9cfb264"],
    "ISpatialStageFrameOfReference": ["7a8a3464-ad0d-4590-ab86-33062b674926"],
    "ISpatialStageFrameOfReferenceStatics": ["f78d5c4d-a0a4-499c-8d91-a8c965d40654"],
    "ISpatialStationaryFrameOfReference": ["09dbccb9-bcf8-3e7f-be7e-7edccbb178a8"],
    "ISpatialSurfaceInfo": ["f8e9ebe7-39b7-3962-bb03-57f56e1fb0a1"],
    "ISpatialSurfaceMesh": ["108f57d9-df0d-3950-a0fd-f972c77c27b4"],
    "ISpatialSurfaceMeshBuffer": ["93cf59e0-871f-33f8-98b2-03d101458f6f"],
    "ISpatialSurfaceMeshOptions": ["d2759f89-3572-3d2d-a10d-5fee9394aa37"],
    "ISpatialSurfaceMeshOptionsStatics": ["9b340abf-9781-4505-8935-013575caae5e"],
    "ISpatialSurfaceObserver": ["10b69819-ddca-3483-ac3a-748fe8c86df5"],
    "ISpatialSurfaceObserverStatics": ["165951ed-2108-4168-9175-87e027bc9285"],
    "ISpatialSurfaceObserverStatics2": ["0f534261-c55d-4e6b-a895-a19de69a42e3"],
    "ISpatialTappedEventArgs": ["296d83de-f444-4aa1-b2bf-9dc88d567da6"],
    "ISpatializer": ["1cfdfbb6-d1cc-4b8c-8e78-e9281f547eec"],
    "ISpecifyParticularPages": ["4c437b91-6e9e-11d1-a704-006097c4e476"],
    "ISpeechAudio": ["cff8e175-019e-11d3-a08e-00c04f8ef9b5"],
    "ISpeechAudioBufferInfo": ["11b103d8-1142-4edf-a093-82fb3915f8cc"],
    "ISpeechAudioFormat": ["e6e9c590-3e18-40e3-8299-061f98bde7c7"],
    "ISpeechAudioStatus": ["c62d9c91-7458-47f6-862d-1ef86fb0b278"],
    "ISpeechBaseStream": ["6450336f-7d49-4ced-8097-49d6dee37294"],
    "ISpeechCommandProvider": ["38e09d4c-586d-435a-b592-c8a86691dec6"],
    "ISpeechContinuousRecognitionCompletedEventArgs": ["e3d069bb-e30c-5e18-424b-7fbe81f8fbd0"],
    "ISpeechContinuousRecognitionResultGeneratedEventArgs": ["19091e1e-6e7e-5a46-40fb-76594f786504"],
    "ISpeechContinuousRecognitionSession": ["6a213c04-6614-49f8-99a2-b5e9b3a085c8"],
    "ISpeechCue": ["aee254dc-1725-4bad-8043-a98499b017a2"],
    "ISpeechCustomStream": ["1a9e9f4f-104f-4db8-a115-efd7fd0c97ae"],
    "ISpeechDataKey": ["ce17c09b-4efa-44d5-a4c9-59d9585ab0cd"],
    "ISpeechFileStream": ["af67f125-ab39-4e93-b4a2-cc2e66e182a7"],
    "ISpeechGrammarRule": ["afe719cf-5dd1-44f2-999c-7a399f1cfccc"],
    "ISpeechGrammarRuleState": ["d4286f2c-ee67-45ae-b928-28d695362eda"],
    "ISpeechGrammarRuleStateTransition": ["cafd1db1-41d1-4a06-9863-e2e81da17a9a"],
    "ISpeechGrammarRuleStateTransitions": ["eabce657-75bc-44a2-aa7f-c56476742963"],
    "ISpeechGrammarRules": ["6ffa3b44-fc2d-40d1-8afc-32911c7f1ad1"],
    "ISpeechLexicon": ["3da7627a-c7ae-4b23-8708-638c50362c25"],
    "ISpeechLexiconPronunciation": ["95252c5d-9e43-4f4a-9899-48ee73352f9f"],
    "ISpeechLexiconPronunciations": ["72829128-5682-4704-a0d4-3e2bb6f2ead3"],
    "ISpeechLexiconWord": ["4e5b933c-c9be-48ed-8842-1ee51bb1d4ff"],
    "ISpeechLexiconWords": ["8d199862-415e-47d5-ac4f-faa608b424e6"],
    "ISpeechMMSysAudio": ["3c76af6d-1fd7-4831-81d1-3b71d5a13c44"],
    "ISpeechMemoryStream": ["eeb14b68-808b-4abe-a5ea-b51da7588008"],
    "ISpeechObjectToken": ["c74a3adc-b727-4500-a84a-b526721c8b8c"],
    "ISpeechObjectTokenCategory": ["ca7eac50-2d01-4145-86d4-5ae7d70f4469"],
    "ISpeechObjectTokens": ["9285b776-2e7b-4bc0-b53e-580eb6fa967f"],
    "ISpeechPhoneConverter": ["c3e4f353-433f-43d6-89a1-6a62a7054c3d"],
    "ISpeechPhraseAlternate": ["27864a2a-2b9f-4cb8-92d3-0d2722fd1e73"],
    "ISpeechPhraseAlternates": ["b238b6d5-f276-4c3d-a6c1-2974801c3cc2"],
    "ISpeechPhraseElement": ["e6176f96-e373-4801-b223-3b62c068c0b4"],
    "ISpeechPhraseElements": ["0626b328-3478-467d-a0b3-d0853b93dda3"],
    "ISpeechPhraseInfo": ["961559cf-4e67-4662-8bf0-d93f1fcd61b3"],
    "ISpeechPhraseInfoBuilder": ["3b151836-df3a-4e0a-846c-d2adc9334333"],
    "ISpeechPhraseProperties": ["08166b47-102e-4b23-a599-bdb98dbfd1f4"],
    "ISpeechPhraseProperty": ["ce563d48-961e-4732-a2e1-378a42b430be"],
    "ISpeechPhraseReplacement": ["2890a410-53a7-4fb5-94ec-06d4998e3d02"],
    "ISpeechPhraseReplacements": ["38bc662f-2257-4525-959e-2069d2596c05"],
    "ISpeechPhraseRule": ["a7bfe112-a4a0-48d9-b602-c313843f6964"],
    "ISpeechPhraseRules": ["9047d593-01dd-4b72-81a3-e4a0ca69f407"],
    "ISpeechRecoContext": ["580aa49d-7e1e-4809-b8e2-57da806104b8"],
    "ISpeechRecoGrammar": ["b6d6f79f-2158-4e50-b5bc-9a9ccd852a09"],
    "ISpeechRecoResult": ["ed2879cf-ced9-4ee6-a534-de0191d5468d"],
    "ISpeechRecoResult2": ["8e0a246d-d3c8-45de-8657-04290c458c3c"],
    "ISpeechRecoResultDispatch": ["6d60eb64-aced-40a6-bbf3-4e557f71dee2"],
    "ISpeechRecoResultTimes": ["62b3b8fb-f6e7-41be-bdcb-056b1c29efc0"],
    "ISpeechRecognitionCompilationResult": ["407e6c5d-6ac7-4da4-9cc1-2fce32cf7489"],
    "ISpeechRecognitionConstraint": ["79ac1628-4d68-43c4-8911-40dc4101b55b"],
    "ISpeechRecognitionGrammarFileConstraint": ["b5031a8f-85ca-4fa4-b11a-474fc41b3835"],
    "ISpeechRecognitionGrammarFileConstraintFactory": ["3da770eb-c479-4c27-9f19-89974ef392d1"],
    "ISpeechRecognitionHypothesis": ["7a7b25b0-99c5-4f7d-bf84-10aa1302b634"],
    "ISpeechRecognitionHypothesisGeneratedEventArgs": ["55161a7a-8023-5866-411d-1213bb271476"],
    "ISpeechRecognitionListConstraint": ["09c487e9-e4ad-4526-81f2-4946fb481d98"],
    "ISpeechRecognitionListConstraintFactory": ["40f3cdc7-562a-426a-9f3b-3b4e282be1d5"],
    "ISpeechRecognitionQualityDegradingEventArgs": ["4fe24105-8c3a-4c7e-8d0a-5bd4f5b14ad8"],
    "ISpeechRecognitionResult": ["4e303157-034e-4652-857e-d0454cc4beec"],
    "ISpeechRecognitionResult2": ["af7ed1ba-451b-4166-a0c1-1ffe84032d03"],
    "ISpeechRecognitionSemanticInterpretation": ["aae1da9b-7e32-4c1f-89fe-0c65f486f52e"],
    "ISpeechRecognitionTopicConstraint": ["bf6fdf19-825d-4e69-a681-36e48cf1c93e"],
    "ISpeechRecognitionTopicConstraintFactory": ["6e6863df-ec05-47d7-a5df-56a3431e58d2"],
    "ISpeechRecognitionVoiceCommandDefinitionConstraint": ["f2791c2b-1ef4-4ae7-9d77-b6ff10b8a3c2"],
    "ISpeechRecognizer": ["0bc3c9cb-c26a-40f2-aeb5-8096b2e48073", "2d5f1c0c-bd75-4b08-9478-3b11fea2586c"],
    "ISpeechRecognizer2": ["63c9baf1-91e3-4ea4-86a1-7c3867d084a6"],
    "ISpeechRecognizerFactory": ["60c488dd-7fb8-4033-ac70-d046f64818e1"],
    "ISpeechRecognizerStateChangedEventArgs": ["563d4f09-ba03-4bad-ad81-ddc6c4dab0c3"],
    "ISpeechRecognizerStatics": ["87a35eac-a7dc-4b0b-bcc9-24f47c0b7ebf"],
    "ISpeechRecognizerStatics2": ["1d1b0d95-7565-4ef9-a2f3-ba15162a96cf"],
    "ISpeechRecognizerStatus": ["bff9e781-53ec-484e-bb8a-0e1b5551e35c"],
    "ISpeechRecognizerTimeouts": ["2ef76fca-6a3c-4dca-a153-df1bc88a79af"],
    "ISpeechRecognizerUIOptions": ["7888d641-b92b-44ba-a25f-d1864630641f"],
    "ISpeechResourceLoader": ["b9ac5783-fcd0-4b21-b119-b4f8da8fd2c3"],
    "ISpeechSynthesisStream": ["83e46e93-244c-4622-ba0b-6229c4d0d65d"],
    "ISpeechSynthesizer": ["ce9f7c76-97f4-4ced-ad68-d51c458e45c6"],
    "ISpeechSynthesizer2": ["a7c5ecb2-4339-4d6a-bbf8-c7a4f1544c2e"],
    "ISpeechSynthesizerOptions": ["a0e23871-cc3d-43c9-91b1-ee185324d83d"],
    "ISpeechSynthesizerOptions2": ["1cbef60e-119c-4bed-b118-d250c3a25793"],
    "ISpeechSynthesizerOptions3": ["401ed877-902c-4814-a582-a5d0c0769fa8"],
    "ISpeechTextSelectionInformation": ["3b9c7e7a-6eee-4ded-9092-11657279adbe"],
    "ISpeechVoice": ["269316d8-57bd-11d2-9eee-00c04f797396"],
    "ISpeechVoiceStatus": ["8be47b07-57f6-11d2-9eee-00c04f797396"],
    "ISpeechWaveFormatEx": ["7a1ef0d5-1581-4741-88e4-209a49f11a10"],
    "ISpeechXMLRecoResult": ["aaec54af-8f85-4924-944d-b79d39d72e19"],
    "ISpellCheckHost": ["382d337f-8ad7-41bd-9eef-e5811c3cae8a"],
    "ISpellCheckProvider": ["73e976e0-8ed4-4eb1-80d7-1be0a16b0c38"],
    "ISpellCheckProviderFactory": ["9f671e11-77d6-4c92-aefb-615215e3a4be"],
    "ISpellChecker": ["b6fd0b71-e2bc-4653-8d05-f197e412770b"],
    "ISpellChecker2": ["e7ed1c71-87f7-4378-a840-c9200dacee47"],
    "ISpellCheckerChangedEventHandler": ["0b83a5b0-792f-4eab-9799-acf52c5ed08a"],
    "ISpellCheckerFactory": ["8e018a9d-2415-4677-bf08-794ea61f94bb"],
    "ISpellingBrokeredActivator": ["838253a5-307d-45b3-bf54-6c83e1b431e2"],
    "ISpellingError": ["b7c82d61-fbe8-4b47-9b27-6c0d2e0de0a3"],
    "ISpiBusInfo": ["9929444a-54f2-48c6-b952-9c32fc02c669"],
    "ISpiConnectionSettings": ["5283a37f-f935-4b9f-a7a7-3a7890afa5ce"],
    "ISpiConnectionSettingsFactory": ["ff99081e-10c4-44b7-9fea-a748b5a46f31"],
    "ISpiController": ["a8d3c829-9895-4159-a934-8741f1ee6d27"],
    "ISpiControllerProvider": ["c1686504-02ce-4226-a385-4f11fb04b41b"],
    "ISpiControllerStatics": ["0d5229e2-138b-4e48-b964-4f2f79b9c5a2"],
    "ISpiDevice": ["05d5356d-11b6-4d39-84d5-95dfb4c9f2ce"],
    "ISpiDeviceProvider": ["0d1c3443-304b-405c-b4f7-f5ab1074461e"],
    "ISpiDeviceStatics": ["a278e559-5720-4d3f-bd93-56f5ff5a5879"],
    "ISpiProvider": ["96b461e2-77d4-48ce-aaa0-75715a8362cf"],
    "ISplashScreen": ["0e0da070-2224-4934-8090-041f7ff223eb", "ca4d975c-d4d6-43f0-97c0-0833c6391c24"],
    "ISplashScreenIconicBitmap": ["7c48d08b-0da5-4ba4-9c6e-4bb65deb2005"],
    "ISplashScreenPriv": ["0e8c8da1-11b5-4fad-975a-14f51015e07a"],
    "ISplashScreenUI": ["0f64855d-c4ad-4801-8a03-2ab1bec2ad7f"],
    "ISplineColorKeyFrame": ["1a4a5941-1fe0-473a-8efe-4316d8c86229"],
    "ISplineColorKeyFrameStatics": ["61d1d997-8589-4f2f-8fbb-7d03edc98dd3"],
    "ISplineDoubleKeyFrame": ["00d72d38-6b2b-4843-838e-c8b115eec801"],
    "ISplineDoubleKeyFrameStatics": ["060a8ffc-975f-4e4e-9ec7-13c5aee02062"],
    "ISplinePointKeyFrame": ["0f19f306-7036-494f-bc3c-780df0cc524a"],
    "ISplinePointKeyFrameStatics": ["e97a32c2-0a7a-4766-95cb-0d692611cb4c"],
    "ISplitButton": ["58bbb066-c2ea-5499-8150-40faa75f6bb5"],
    "ISplitButtonAutomationPeer": ["c46a58b8-3828-5c36-aa13-f79f02c12f34"],
    "ISplitButtonAutomationPeerFactory": ["d63a2534-77dc-5361-8422-4ad8750f45f4"],
    "ISplitButtonClickEventArgs": ["c227c2ca-26f4-5960-98d5-919149d1b525"],
    "ISplitButtonFactory": ["3201c32f-4d55-589d-97dd-617fa3642137"],
    "ISplitButtonStatics": ["8df07a81-0b1f-5ea9-be42-152ab9a4bc5e"],
    "ISplitCloseThemeAnimation": ["4f799518-ff39-4e90-bb74-2abd56027402"],
    "ISplitCloseThemeAnimationStatics": ["7aa94de9-cc9b-4e90-a11a-0050a2216a9e"],
    "ISplitOpenThemeAnimation": ["785fd7aa-5456-4639-8fd2-26bae6a5ffe4"],
    "ISplitOpenThemeAnimationStatics": ["8d4cfa89-3a91-458d-b0fb-4cad625cbf8d"],
    "ISplitView": ["97222f31-3844-429e-939c-1673155322a1"],
    "ISplitView2": ["5ea7dc10-cc83-409a-82f9-3e91d6d7084f"],
    "ISplitView3": ["0ea12d8d-1171-407b-96d3-5e1b470c3ec5"],
    "ISplitViewFactory": ["f101773a-084e-4fb9-8442-63221b44533f"],
    "ISplitViewPaneClosingEventArgs": ["93cf494e-7a95-44d8-9562-1b348248da9f"],
    "ISplitViewStatics": ["859b4f6f-44ab-4e4b-91c1-17b7056d9b5f"],
    "ISplitViewStatics2": ["14b7cd7a-dfbc-422c-80a9-585871297113"],
    "ISplitViewTemplateSettings": ["c16ab5a7-4996-4443-b199-6b6b89124eab"],
    "ISpotLight": ["5a9fe273-44a1-4f95-a422-8fa5116bdb44"],
    "ISpotLight2": ["64ee615e-0686-4dea-a9e8-bc3a8c701459"],
    "ISpotLight3": ["e4d03eea-131f-480e-859e-b82705b74360"],
    "ISppArrayParamsReadOnly": ["bb5dfafc-1ef2-436e-bdfb-b2024aafabf7"],
    "ISppArrayParamsReadWrite": ["7df9a4e0-fcab-4525-a420-78753d41605c"],
    "ISppNamedParamsReadOnly": ["22f58556-c467-43cd-98ff-7dbcadb2f661"],
    "ISppNamedParamsReadWrite": ["dca42645-c410-4859-ab3c-9e9c563c57bb"],
    "ISppParamStream": ["da2137a2-dea9-4c5c-a7ce-7ee1435890d6"],
    "ISppParamsReadOnly": ["be73dd34-4dad-4ac5-bbe0-7930f45ced73"],
    "ISppParamsReadWrite": ["96b97320-ed0e-4d9f-b390-6c17eaf67277"],
    "ISpreadsheetItemPatternIdentifiers": ["84347e19-ca4b-46a2-a794-c87928a3b1ab"],
    "ISpreadsheetItemPatternIdentifiersStatics": ["43658779-5380-4f12-b468-b4f368ad4499"],
    "ISpreadsheetItemProvider": ["eaed4660-7b3d-4879-a2e6-365ce603f3d0", "ebde8f92-6015-4826-b719-47521a81c67e"],
    "ISpreadsheetProvider": ["15359093-bd99-4cfd-9f07-3b14b315e23d", "6f6b5d35-5525-4f80-b758-85473832ffc7"],
    "ISpringScalarNaturalMotionAnimation": ["0572a95f-37f9-4fbe-b87b-5cd03a89501c"],
    "ISpringVector2NaturalMotionAnimation": ["23f494b5-ee73-4f0f-a423-402b946df4b3"],
    "ISpringVector3NaturalMotionAnimation": ["6c8749df-d57b-4794-8e2d-cecb11e194e5"],
    "ISpriteVisual": ["08e05581-1ad1-4f97-9757-402d76e4233b"],
    "ISpriteVisual2": ["588c9664-997a-4850-91fe-53cb58f81ce9"],
    "IStackPanel": ["b8ae8fe2-d641-4fd7-80b4-7439207d2798"],
    "IStackPanel2": ["36f23359-040e-48f7-9a98-f2664591959c"],
    "IStackPanel4": ["43ebf7f6-3196-412e-8a95-add002ff43f0"],
    "IStackPanel5": ["f73e3117-61a8-5a01-865e-88511c04a992"],
    "IStackPanelFactory": ["63d8248a-8b34-445a-808f-b6ecd62a27d9"],
    "IStackPanelStatics": ["f0d0cd93-4dbc-48a7-9914-954924657771"],
    "IStackPanelStatics2": ["d97e6257-080d-412e-a91a-ce6e5d02aad3"],
    "IStackPanelStatics4": ["279cdd71-067b-459f-815f-ecd85c5e4843"],
    "IStackPanelStatics5": ["87287490-bff2-5347-8787-fb5aec942878"],
    "IStackWalker": ["00000159-0000-0000-c000-000000000046"],
    "IStagePackageOptions": ["0b110c9c-b95d-4c56-bd36-6d656800d06b"],
    "IStagedSettingUnit": ["9c4c4516-4348-11e3-b7b1-662a6288709b"],
    "IStagingHandler": ["d44103ba-b648-41c2-8d54-66a929a98e83"],
    "IStandardCertificateStoreNamesStatics": ["0c154adb-a496-41f8-8fe5-9e96f36efbf8"],
    "IStandardDataFormatsStatics": ["7ed681a1-a880-40c9-b4ed-0bee1e15f549"],
    "IStandardDataFormatsStatics2": ["42a254f4-9d76-42e8-861b-47c25dd0cf71"],
    "IStandardDataFormatsStatics3": ["3b57b069-01d4-474c-8b5f-bc8e27f38b21"],
    "IStandardPrintTaskOptionsStatic": ["b4483d26-0dd0-4cd4-baff-930fc7d6a574"],
    "IStandardPrintTaskOptionsStatic2": ["3be38bf4-7a44-4269-9a52-81261e289ee9"],
    "IStandardPrintTaskOptionsStatic3": ["bbf68e86-3858-41b3-a799-55dd9888d475"],
    "IStandardUICommand": ["d2bf7f43-0504-52d0-8aa6-0cb0f756eb27"],
    "IStandardUICommand2": ["e3666069-f9e4-51eb-885b-7a620a0782ea"],
    "IStandardUICommandFactory": ["8f1a7590-dce1-56e4-ab63-f5ce3ce4ebf6"],
    "IStandardUICommandStatics": ["7ea87ed9-2978-5533-9b2e-6759ce88569f"],
    "IStartAddress": ["b05651d0-9b10-425e-b616-1fcd828db3b1"],
    "IStartAddress2": ["b7825b95-d726-4aeb-b668-02a2600ec828"],
    "IStartAddress3": ["b05651d2-9b10-425e-b616-1fcd828db3b1"],
    "IStartAddress4": ["2fba1c3b-0476-4950-a19e-51a485e08e4e"],
    "IStartAddress5": ["b059425d-1d83-4e36-afa2-161ad6e2a951"],
    "IStartAddresses": ["b05651ce-9b10-425e-b616-1fcd828db3b1"],
    "IStartAddresses2": ["b05651cf-9b10-425e-b616-1fcd828db3b1"],
    "IStartDismissalPolicy": ["3f48d9d3-200d-4446-bb9d-dae2a43781a2"],
    "IStartMenuPinnedList": ["4cd19ada-25a5-4a32-b3b7-347bee5be36b"],
    "IStartMenuQueryCache": ["b99d542e-cabe-4ad8-ade5-aebccddb1509"],
    "IStartMenuQuerySink": ["7d61fb0f-8ecb-4bf2-a196-b32c2545cdc4"],
    "IStartMenuRankManager": ["ffd2cca4-adfb-46e9-9a02-49d019db2a68"],
    "IStartMenuXAMLViewActivationEventHandler": ["c77c8baf-3273-4451-be32-22e8da094710"],
    "IStartMenuXAMLViewService": ["f08daf65-a8fb-40e8-a732-6f34ebb60827"],
    "IStartModel": ["a774fb51-f263-466a-b635-a3cb10e36ca1"],
    "IStartModelTemporary": ["d77f0a03-6464-4494-82ab-c0432e46d5a5"],
    "IStartScreenManager": ["4a1dcbcb-26e9-4eb4-8933-859eb6ecdb29"],
    "IStartScreenManager2": ["08a716b6-316b-4ad9-acb8-fe9cf00bd608"],
    "IStartScreenManagerStatics": ["7865ef0f-b585-464e-8993-34e8f8738d48"],
    "IStartViewInitializer": ["1bb8e5ca-69ff-454a-9cb6-6dd9569925e4"],
    "IStartViewInitializerFlush": ["502436b2-4e78-3e04-e905-ba8236647cf3"],
    "IStartupTask": ["f75c23c8-b5f2-4f6c-88dd-36cb1d599d17"],
    "IStartupTaskActivatedEventArgs": ["03b11a58-5276-4d91-8621-54611864d5fa"],
    "IStartupTaskStatics": ["ee5b60bd-a148-41a7-b26e-e8b88a1e62f8"],
    "IStateTrigger": ["67adef2e-d8d9-49f7-a1fd-2e35eedd23cd"],
    "IStateTriggerBase": ["48b20698-af06-466c-8052-93666dde0e49"],
    "IStateTriggerBaseFactory": ["970e2c4b-bfaf-47b0-be42-c1d711bb2e9f"],
    "IStateTriggerBaseProtected": ["3c41e253-8d14-4216-994c-f9930429f6e5"],
    "IStateTriggerStatics": ["71e95c90-b3fe-4dd3-a8a8-44a2ce25e0b8"],
    "IStatelessAppServiceResponse": ["43754af7-a9ec-52fe-82e7-939b68dc9388"],
    "IStaticFileSettingHandlerHelper": ["76b9d7b6-8ae5-42f0-9d6e-c1622e1564dd"],
    "IStaticSettingHandlerHelper": ["d11a7681-d088-4626-aab0-0d6c8aebbe21"],
    "IStatusBar": ["0ffcc5bf-98d0-4864-b1e8-b3f4020be8b4", "8e3867a1-8586-11d1-b16a-00c0f0283628"],
    "IStatusBarEvents": ["8e3867a2-8586-11d1-b16a-00c0f0283628"],
    "IStatusBarProgressIndicator": ["76cb2670-a3d7-49cf-8200-4f3eedca27bb"],
    "IStatusBarStatics": ["8b463fdf-422f-4561-8806-fb1289cadfb7"],
    "IStatusChangedEventArgs": ["3453d2da-8c93-4111-a205-9aecfc9be5c0"],
    "IStdCallObject": ["00000154-0000-0000-c000-000000000046"],
    "IStdCallback": ["abf011b6-a2ba-40f7-a588-4af5c7bc2367"],
    "IStdCallbackInfoset": ["9696b84c-6b39-4e0f-ad95-32ed6019e2b0"],
    "IStdCallbackUnknown": ["fe044f1c-ea33-4633-8090-1fa8afd10398"],
    "IStdCtxChnl": ["000001cc-0000-0000-c000-000000000046"],
    "IStdFreeMarshal": ["000001d0-0000-0000-c000-000000000046"],
    "IStdIDObject": ["000001d1-0000-0000-c000-000000000046"],
    "IStdIdentity": ["0000001b-0000-0000-c000-000000000046"],
    "IStdObjectContext": ["000001c9-0000-0000-c000-000000000046"],
    "IStdPolicySet": ["000001c7-0000-0000-c000-000000000046"],
    "IStdWrapper": ["000001ca-0000-0000-c000-000000000046"],
    "IStemSink": ["fe77c330-7f42-11ce-be57-00aa0051fe20"],
    "IStemmerConfig": ["8fa0d5a7-dedf-11d0-9a61-00c04fb68bf7"],
    "IStepEasingFunction": ["d0caa74b-560c-4a0b-a5f6-206ca8c3ecd6"],
    "IStiDeviceControl": ["128a9860-52dc-11d0-9edf-444553540000"],
    "IStiUSD": ["0c9bb460-51ac-11d0-90ea-00aa0060f86c"],
    "IStorageApplicationPermissionsStatics": ["4391dfaa-d033-48f9-8060-3ec847d2e3f1"],
    "IStorageApplicationPermissionsStatics2": ["072716ec-aa05-4294-9a11-1a3d04519ad0"],
    "IStorageDeviceStatics": ["5ece44ee-1b23-4dd2-8652-bc164f003128"],
    "IStorageFile": ["fa3f6186-4214-428c-a64c-14c9ac7315ea"],
    "IStorageFile2": ["954e4bcf-0a77-42fb-b777-c2ed58a52e44"],
    "IStorageFileInternal": ["2a3c71ec-1ede-449c-898d-ec71de350ed7"],
    "IStorageFilePropertiesWithAvailability": ["afcbbe9b-582b-4133-9648-e44ca46ee491"],
    "IStorageFileQueryResult": ["52fda447-2baa-412c-b29f-d4b1778efa1e"],
    "IStorageFileQueryResult2": ["4e5db9dd-7141-46c4-8be3-e9dc9e27275c"],
    "IStorageFileStatics": ["5984c710-daf2-43c8-8bb4-a4d3eacfd03f"],
    "IStorageFileStatics2": ["5c76a781-212e-4af9-8f04-740cae108974"],
    "IStorageFileStaticsPrivate": ["90c5260f-df18-4049-bf47-35d736af4a3e"],
    "IStorageFolder": ["72d1cb78-b3ef-4f75-a80b-6fd9dae2944b"],
    "IStorageFolder2": ["e827e8b9-08d9-4a8e-a0ac-fe5ed3cbbbd3"],
    "IStorageFolder3": ["9f617899-bde1-4124-aeb3-b06ad96f98d4"],
    "IStorageFolderHandleAccess": ["df19938f-5462-48a0-be65-d2a3271a08d6"],
    "IStorageFolderInternalAvailableCrossProcess": ["44f2c7e9-a2ca-4cbd-aa65-61ac09315e2c"],
    "IStorageFolderQueryOperations": ["cb43ccc9-446b-4a4f-be97-757771be5203"],
    "IStorageFolderQueryResult": ["6654c911-7d66-46fa-aecf-e4a4baa93ab8"],
    "IStorageFolderStatics": ["08f327ff-85d5-48b9-aee9-28511e339f9f"],
    "IStorageFolderStatics2": ["b4656dc3-71d2-467d-8b29-371f0f62bf6f"],
    "IStorageFolderStaticsPrivate": ["6ca9bd66-f046-48a3-9a11-992afeb34e2d"],
    "IStorageItem": ["4207a996-ca2f-42f7-bde8-8b10457a7f30"],
    "IStorageItem2": ["53f926d2-083c-4283-b45b-81c007237e44"],
    "IStorageItemAccessList": ["2caff6ad-de90-47f5-b2c3-dd36c9fdd453"],
    "IStorageItemContentProperties": ["05294bad-bc38-48bf-85d7-770e0e2ae0ba"],
    "IStorageItemExtraProperties": ["c54361b2-54cd-432b-bdbc-4b19c4b470d7"],
    "IStorageItemHandleAccess": ["5ca296b2-2c25-4d22-b785-b885c8201e6a"],
    "IStorageItemHandleInternal": ["0466739e-e710-4fb9-92dc-14ef1d8baf8b"],
    "IStorageItemInformation": ["87a5cb8b-8972-4f40-8de0-d86fb179d8fa"],
    "IStorageItemInternal": ["714862e5-50aa-406e-917a-bc894277d255"],
    "IStorageItemInternalAvailableCrossProcess": ["d75c13bb-3883-4bd2-9b7a-334ff6d83066"],
    "IStorageItemInternalProvider": ["0ffdc04d-9214-43bf-a479-1f2caadc59fb"],
    "IStorageItemMostRecentlyUsedList": ["016239d5-510d-411e-8cf1-c3d1effa4c33"],
    "IStorageItemMostRecentlyUsedList2": ["da481ea0-ed8d-4731-a1db-e44ee2204093"],
    "IStorageItemProperties": ["86664478-8029-46fe-a789-1c2f3e2ffb5c"],
    "IStorageItemProperties2": ["8e86a951-04b9-4bd2-929d-fef3f71621d0"],
    "IStorageItemPropertiesInternalAvailableCrossProcess": ["b2840a40-6a3f-4566-9d96-2f4da0b79c1b"],
    "IStorageItemPropertiesWithProvider": ["861bf39b-6368-4dee-b40e-74684a5ce714"],
    "IStorageItemQueryResult": ["e8948079-9d58-47b8-b2b2-41b07f4795f9"],
    "IStorageItemsConverter": ["5a96b562-f7c2-4089-9a43-009ff690d08e"],
    "IStorageLibrary": ["1edd7103-0e5e-4d6c-b5e8-9318983d6a03"],
    "IStorageLibrary2": ["5b0ce348-fcb3-4031-afb0-a68d7bd44534"],
    "IStorageLibrary3": ["8a281291-2154-4201-8113-d2c05ce1ad23"],
    "IStorageLibraryChange": ["00980b23-2be2-4909-aa48-159f5203a51e"],
    "IStorageLibraryChangeReader": ["f205bc83-fca2-41f9-8954-ee2e991eb96f"],
    "IStorageLibraryChangeTracker": ["9e157316-6073-44f6-9681-7492d1286c90"],
    "IStorageLibraryChangeTrackerTriggerDetails": ["1dc7a369-b7a3-4df2-9d61-eba85a0343d2"],
    "IStorageLibraryChangeTrackerTriggerFactory": ["1eb0ffd0-5a85-499e-a888-824607124f50"],
    "IStorageLibraryContentChangedTrigger": ["1637e0a7-829c-45bc-929b-a1e7ea78d89b"],
    "IStorageLibraryContentChangedTriggerDetails": ["2a371977-abbf-4e1d-8aa5-6385d8884799"],
    "IStorageLibraryContentChangedTriggerStatics": ["7f9f1b39-5f90-4e12-914e-a7d8e0bbfb18"],
    "IStorageLibraryStatics": ["4208a6db-684a-49c6-9e59-90121ee050d6"],
    "IStorageLibraryStatics2": ["ffb08ddc-fa75-4695-b9d1-7f81f97832e3"],
    "IStorageProvider": ["e705eed4-d478-47d6-ba46-1a8ebe114a20"],
    "IStorageProvider2": ["010d1917-3404-414b-9fd7-cd44472eaa39"],
    "IStorageProviderBanners": ["5efb46d7-47c0-4b68-acda-ded47c90ec91"],
    "IStorageProviderFileTypeInfo": ["1955b9c1-0184-5a88-87df-4544f464365d"],
    "IStorageProviderFileTypeInfoFactory": ["3fa12c6f-cce6-5d5d-80b1-389e7cf92dbf"],
    "IStorageProviderGetContentInfoForPathResult": ["2564711d-aa89-4d12-82e3-f72a92e33966"],
    "IStorageProviderGetPathForContentUriResult": ["63711a9d-4118-45a6-acb6-22c49d019f40"],
    "IStorageProviderHandler": ["162c6fb5-44d3-435b-903d-e613fa093fb5"],
    "IStorageProviderHandlerPriv": ["1b317651-e01a-4d23-bcf5-ec4db0fe6c84"],
    "IStorageProviderItemPropertiesStatics": ["2d2c1c97-2704-4729-8fa9-7e6b8e158c2f"],
    "IStorageProviderItemProperty": ["476cb558-730b-4188-b7b5-63b716ed476d"],
    "IStorageProviderItemPropertyDefinition": ["c5b383bb-ff1f-4298-831e-ff1c08089690"],
    "IStorageProviderItemPropertySource": ["8f6f9c3e-f632-4a9b-8d99-d2d7a11df56a"],
    "IStorageProviderPropertyCapabilities": ["658d2f0e-63b7-4567-acf9-51abe301dda5"],
    "IStorageProviderPropertyHandler": ["301dfbe5-524c-4b0f-8b2d-21c40b3a2988"],
    "IStorageProviderSyncRootInfo": ["7c1305c4-99f9-41ac-8904-ab055d654926"],
    "IStorageProviderSyncRootInfo2": ["cf51b023-7cf1-5166-bdba-efd95f529e31"],
    "IStorageProviderSyncRootInfo3": ["507a6617-bef6-56fd-855e-75ace2e45cf5"],
    "IStorageProviderSyncRootManagerStatics": ["3e99fbbf-8fe3-4b40-abc7-f6fc3d74c98e"],
    "IStorageProviderSyncRootManagerStatics2": ["efb6cfee-1374-544e-9df1-5598d2e9cfdd"],
    "IStorageProviderUriResolver": ["5b7e29bc-9802-4da9-a54b-2d4b60a44e11"],
    "IStorageProviderUriSource": ["b29806d1-8be0-4962-8bb6-0d4c2e14d47a"],
    "IStorageQueryItemArray": ["ac736759-22c6-4dba-b09e-04fd1889348f"],
    "IStorageQueryResultBase": ["c297d70d-7353-47ab-ba58-8c61425dc54b"],
    "IStorageQueryResultBaseInternalMarshalable": ["96190410-7f83-4ee1-98e7-b720709e49b3"],
    "IStorageQueryServer": ["d79df790-8b00-4420-8f46-30c61e5ff610"],
    "IStorageQueryServerCallback": ["4e067469-7262-432b-9177-f7c6447e8c9d"],
    "IStorageStreamTransaction": ["f67cf363-a53d-4d94-ae2c-67232d93acdd"],
    "IStoreAcquireLicenseResult": ["fbd7946d-f040-4cb3-9a39-29bcecdbe22d"],
    "IStoreAppLicense": ["f389f9de-73c0-45ce-9bab-b2fe3e5eafd3"],
    "IStoreAppLicense2": ["b4666e91-4443-40b3-993f-28904435bdc6"],
    "IStoreAvailability": ["fa060325-0ffd-4493-ad43-f1f9918f69fa"],
    "IStoreCanAcquireLicenseResult": ["3a693db3-0088-482f-86d5-bd46522663ad"],
    "IStoreCollectionData": ["8aa4c3b3-5bb3-441a-2ab4-4dab73d5ce67"],
    "IStoreConfigurationStatics": ["728f7fc0-8628-42ec-84a2-07780eb44d8b"],
    "IStoreConfigurationStatics2": ["657c4595-c8b7-4fe9-9f4c-4d71027d347e"],
    "IStoreConfigurationStatics3": ["6d45f57c-f144-4cb5-9d3f-4eb05e30b6d3"],
    "IStoreConfigurationStatics4": ["20ff56d2-4ee3-4cf0-9b12-552c03310f75"],
    "IStoreConfigurationStatics5": ["f7613191-8fa9-49db-822b-0160e7e4e5c5"],
    "IStoreConsumableResult": ["ea5dab72-6a00-4052-be5b-bfdab4433352"],
    "IStoreContext": ["ac98b6be-f4fd-4912-babd-5035e5e8bcab"],
    "IStoreContext2": ["18bc54da-7bd9-452c-9116-3bbd06ffc63a"],
    "IStoreContext3": ["e26226ca-1a01-4730-85a6-ecc896e4ae38"],
    "IStoreContext4": ["af9c6f69-bea1-4bf4-8e74-ae03e206c6b0"],
    "IStoreContextStatics": ["9c06ee5f-15c0-4e72-9330-d6191cebd19c"],
    "IStoreHardwareManufacturerInfo": ["f292dc08-c654-43ac-a21f-34801c9d3388"],
    "IStoreImage": ["081fd248-adb4-4b64-a993-784789926ed5"],
    "IStoreLicense": ["26dc9579-4c4f-4f30-bc89-649f60e36055"],
    "IStorePackageInstallOptions": ["1d3d630c-0ccd-44dd-8c59-80810a729973"],
    "IStorePackageLicense": ["0c465714-14e1-4973-bd14-f77724271e99"],
    "IStorePackageUpdate": ["140fa150-3cbf-4a35-b91f-48271c31b072"],
    "IStorePackageUpdateResult": ["e79142ed-61f9-4893-b4fe-cf191603af7b"],
    "IStorePackageUpdateResult2": ["071d012e-bc62-4f2e-87ea-99d801aeaf98"],
    "IStorePreview": ["8a157241-840e-49a9-bc01-5d5b01fbc8e9"],
    "IStorePreviewProductInfo": ["1937dbb3-6c01-4c9d-85cd-5babaac2b351"],
    "IStorePreviewPurchaseResults": ["b0daaed1-d6c5-4e53-a043-fba0d8e61231"],
    "IStorePreviewSkuInfo": ["81fd76e2-0b26-48d9-98ce-27461c669d6c"],
    "IStorePrice": ["55ba94c4-15f1-407c-8f06-006380f4df0b"],
    "IStoreProduct": ["320e2c52-d760-450a-a42b-67d1e901ac90"],
    "IStoreProductOptions": ["5b34a0f9-a113-4811-8326-16199c927f31"],
    "IStoreProductPagedQueryResult": ["c92718c5-4dd5-4869-a462-ecc6872e43c5"],
    "IStoreProductQueryResult": ["d805e6c5-d456-4ff6-8049-9076d5165f73"],
    "IStoreProductResult": ["b7674f73-3c87-4ee1-8201-f428359bd3af"],
    "IStorePurchaseProperties": ["836278f3-ff87-4364-a5b4-fd2153ebe43b"],
    "IStorePurchasePropertiesFactory": ["a768f59e-fefd-489f-9a17-22a593e68b9d"],
    "IStorePurchaseResult": ["add28552-f96a-463d-a7bb-c20b4fca6952"],
    "IStoreQueueItem": ["56d5c32b-f830-4293-9188-cad2dcde7357"],
    "IStoreQueueItem2": ["69491ca8-1ad4-447c-ad8c-a95035f64d82"],
    "IStoreQueueItemCompletedEventArgs": ["1247df6c-b44a-439b-bb07-1d3003d005c2"],
    "IStoreQueueItemStatus": ["9bd6796f-9cc3-4ec3-b2ef-7be433b30174"],
    "IStoreRateAndReviewResult": ["9d209d56-a6b5-4121-9b61-ee6d0fbdbdbb"],
    "IStoreRequestHelperStatics": ["6ce5e5f9-a0c9-4b2c-96a6-a171c630038d"],
    "IStoreSendRequestResult": ["c73abe60-8272-4502-8a69-6e75153a4299"],
    "IStoreSendRequestResult2": ["2901296f-c0b0-49d0-8e8d-aa940af9c10b"],
    "IStoreSku": ["397e6f55-4440-4f03-863c-91f3fec83d79"],
    "IStoreSubscriptionInfo": ["4189776a-0559-43ac-a9c6-3ab0011fb8eb"],
    "IStoreUninstallStorePackageResult": ["9fca39fd-126f-4cda-b801-1346b8d0a260"],
    "IStoreVideo": ["f26cb184-6f5e-4dc2-886c-3c63083c2f94"],
    "IStoredKeyDocument": ["450650a1-f019-4d2e-a24a-7346b7cf9b21"],
    "IStoredLeaseDocument": ["dc44f1df-dc28-4036-8f9f-30978f2ed4db"],
    "IStoredLicenseDocument": ["7707ef39-3a55-4265-a422-5bad081541ec"],
    "IStoredLicenseDocumentUserBinding": ["4c02ff79-8ad6-4de9-8d55-a29f4dfb679c"],
    "IStoredPassRootDocument": ["f37c3d8d-6082-46c0-b22d-96bc5ec87fd9"],
    "IStoredUserRootDocument": ["90f85d02-7b24-45c2-826a-98fc8db9bcc7"],
    "IStoryboard": ["d45c1e6e-3594-460e-981a-32271bd3aa06"],
    "IStoryboardStatics": ["d82f07d8-73d5-4379-bd48-7e05184a8bad"],
    "IStreamAsync": ["fe0b6665-e0ca-49b9-a178-2b5cb48d92a5"],
    "IStreamBufferConfigure": ["ce14dfae-4098-4af7-bbf7-d6511f835414"],
    "IStreamBufferConfigure2": ["53e037bf-3992-4282-ae34-2487b4dae06b"],
    "IStreamBufferConfigure3": ["7e2d2a1e-7192-4bd7-80c1-061fd1d10402"],
    "IStreamBufferDataCounters": ["9d2a2563-31ab-402e-9a6b-adb903489440"],
    "IStreamBufferInitialize": ["9ce50f2d-6ba7-40fb-a034-50b1a674ec78"],
    "IStreamBufferMediaSeeking": ["f61f5c26-863d-4afa-b0ba-2f81dc978596"],
    "IStreamBufferMediaSeeking2": ["3a439ab0-155f-470a-86a6-9ea54afd6eaf"],
    "IStreamBufferRecComp": ["9e259a9b-8815-42ae-b09f-221970b154fd"],
    "IStreamBufferRecordControl": ["ba9b6c99-f3c7-4ff2-92db-cfdd4851bf31"],
    "IStreamBufferRecordingAttribute": ["16ca4e03-fe69-4705-bd41-5b7dfc0c95f3"],
    "IStreamBufferSink": ["afd1f242-7efd-45ee-ba4e-407a25c9a77a"],
    "IStreamBufferSink2": ["db94a660-f4fb-4bfa-bcc6-fe159a4eea93"],
    "IStreamBufferSink3": ["974723f2-887a-4452-9366-2cff3057bc8f"],
    "IStreamBufferSource": ["1c5bd776-6ced-4f44-8164-5eab0e98db12"],
    "IStreamConcatenate": ["27354146-7f64-5b0f-8f00-5d77afbe261e"],
    "IStreamDataNotificationCallback": ["9b2b34ce-f800-4fab-9fd3-e34aa1dc5787"],
    "IStreamGroup": ["816e5b3e-5523-4efc-9223-98ec4214c3a0"],
    "IStreamInterleave": ["27354147-7f64-5b0f-8f00-5d77afbe261e"],
    "IStreamPseudoRandomBased": ["27354145-7f64-5b0f-8f00-5d77afbe261e"],
    "IStreamReferencePrivate": ["3fe8e0e3-eb50-4682-b91d-21028012a049"],
    "IStreamSample": ["b502d1be-9a57-11d0-8fde-00c04fd9189d"],
    "IStreamSelectorStatics": ["8a4cd4a1-ed85-4e0f-bd68-8a6862e4636d"],
    "IStreamSocket": ["69a22cf3-fc7b-4857-af38-f6e7de6a5b49"],
    "IStreamSocket2": ["29d0e575-f314-4d09-adf0-0fbd967fbd9f"],
    "IStreamSocket3": ["3f430b00-9d28-4854-bac3-2301941ec223"],
    "IStreamSocketControl": ["fe25adf1-92ab-4af3-9992-0f4c85e36cc4"],
    "IStreamSocketControl2": ["c2d09a56-060f-44c1-b8e2-1fbf60bd62c5"],
    "IStreamSocketControl3": ["c56a444c-4e74-403e-894c-b31cae5c7342"],
    "IStreamSocketControl4": ["964e2b3d-ec27-4888-b3ce-c74b418423ad"],
    "IStreamSocketInformation": ["3b80ae30-5e68-4205-88f0-dc85d2e25ded"],
    "IStreamSocketInformation2": ["12c28452-4bdc-4ee4-976a-cf130e9d92e3"],
    "IStreamSocketListener": ["ff513437-df9f-4df0-bf82-0ec5d7b35aae"],
    "IStreamSocketListener2": ["658dc13e-bb3e-4458-b232-ed1088694b98"],
    "IStreamSocketListener3": ["4798201c-bdf8-4919-8542-28d450e74507"],
    "IStreamSocketListenerConnectionReceivedEventArgs": ["0c472ea9-373f-447b-85b1-ddd4548803ba"],
    "IStreamSocketListenerControl": ["20d8c576-8d8a-4dba-9722-a16c4d984980"],
    "IStreamSocketListenerControl2": ["948bb665-2c3e-404b-b8b0-8eb249a2b0a1"],
    "IStreamSocketListenerInformation": ["e62ba82f-a63a-430b-bf62-29e93e5633b4"],
    "IStreamSocketStatics": ["a420bc4a-6e2e-4af5-b556-355ae0cd4f29"],
    "IStreamUnbufferedInfo": ["8a68fdda-1fdc-4c20-8ceb-416643b5a625"],
    "IStreamWebSocket": ["bd4a49d8-b289-45bb-97eb-c7525205a843"],
    "IStreamWebSocket2": ["aa4d08cb-93f5-4678-8236-57cce5417ed5"],
    "IStreamWebSocketControl": ["b4f478b1-a45a-48db-953a-645b7d964c07"],
    "IStreamWebSocketControl2": ["215d9f7e-fa58-40da-9f11-a48dafe95037"],
    "IStreamWithDataNotification": ["2f68429a-199a-4043-9311-f2fe7c13ccb9"],
    "IStreamWithReadAtPosition": ["ae9d26fb-2297-4a4a-9930-5e4d91f29882"],
    "IStreamWithReadProgress": ["8dbdcde9-ac36-4855-8e09-e98512c3f2b0"],
    "IStreamedFileDataRequest": ["1673fcce-dabd-4d50-beee-180b8a8191b6"],
    "IStreamedFileDataRequestedCallback": ["fd1cd0ec-09b7-43e3-845d-69f6b4b02922"],
    "IStreamedFileDataRequestedHandler": ["fef6a824-2fe1-4d07-a35b-b77c50b5f4cc"],
    "IStreamedObject": ["30510843-98b5-11cf-bb82-00aa00bdce0b"],
    "IStreetsideExperience": ["a558aec9-e30c-46c8-8116-484691675558"],
    "IStreetsideExperienceFactory": ["7a5bcf3c-649e-4342-9995-68a6cf5961a7"],
    "IStreetsidePanorama": ["6fe00fd8-ad60-4664-b539-b1069f16c5af"],
    "IStreetsidePanoramaStatics": ["d3b47f69-54b3-4ec5-b2a0-4f8204576507"],
    "IStringCollection": ["eff90582-2ddc-480f-a06d-60f3fbc362c3"],
    "IStringDisplayableConcept": ["d28e8d70-6c00-4205-940d-501016601ea3"],
    "IStringList": ["d97a6da0-a85d-11cf-83ae-00a0c90c2bd8"],
    "IStringMru": ["c8f945cb-327a-4330-bb2f-c04122959488"],
    "IStringable": ["96369f54-8eb6-48f0-abce-c1b211e627c3"],
    "IStrokeBuilder": ["a5fd4e2d-c44b-4092-9177-260905eb672b"],
    "IStyle": ["c4a9f225-9db7-4a7d-b6d1-f74edb9293c2"],
    "IStyleFactory": ["a36824e3-3d81-4ce5-aa51-8b410f602fcd"],
    "IStyleSelector": ["d1113f67-d8c1-4ae4-98f0-d8504502f08b"],
    "IStyleSelectorFactory": ["9e942ae7-3761-447f-8f97-29e39d5eb310"],
    "IStyleSelectorOverrides": ["08add66d-0e2e-43a0-aeca-8faa94b9d017"],
    "IStylesPatternIdentifiers": ["b0e4e201-e89d-436b-8287-4f7903466879"],
    "IStylesPatternIdentifiersStatics": ["528a457a-bc3c-4d48-94af-1f68703ca296"],
    "IStylesProvider": ["19b6b649-f5d7-4a6d-bdcb-129252be588a", "1a5b7a17-7c01-4bec-9cd4-2dfa7dc246cd"],
    "IStylusAsyncPlugin": ["a7cca85a-31bc-4cd2-aadc-3289a3af11c8"],
    "IStylusPlugin": ["a81436d8-4757-4fd1-a185-133f97c6c545"],
    "IStylusSyncPlugin": ["a157b174-482f-4d71-a3f6-3a41ddd11be9"],
    "ISubItemCallback": ["11a66240-5489-42c2-aebf-286fc831524c"],
    "ISubjectAlternativeNameInfo": ["582859f1-569d-4c20-be7b-4e1c9a0bc52b"],
    "ISubjectAlternativeNameInfo2": ["437a78c6-1c51-41ea-b34a-3d654398a370"],
    "ISubmix": ["51181bd2-bd3f-43ae-b0d1-1cf3dfda303a"],
    "ISubscribeDialog": ["d80c5d22-f56b-477d-80c1-f019c08e6d22"],
    "ISubscriberNumbersCompletion": ["be6d7c2a-ba04-4fcc-a611-d33000643d4f"],
    "ISubunit": ["82149a85-dba6-4487-86bb-ea8f7fefcc71"],
    "ISuggestFilterCallback": ["8da59cdf-b8c0-4223-adc2-8228ebbbe8bd"],
    "ISuggestFilterWorker": ["1b155f51-7593-4458-b3bc-b196a750c014"],
    "ISuggestMRUCallback": ["92bb8651-64e5-4650-9377-500bb29d92fb"],
    "ISuggestMRUWorker": ["5da060a7-16b1-4048-9394-015cf674a1e0"],
    "ISuggestPopup": ["9dd5c44e-8d20-45a9-bfe3-645ceebc2c9f"],
    "ISuggestPopupInfo": ["7e8fa6f3-a8bb-4bc6-a30c-89b6eebb448c"],
    "ISuggestionLayoutItem": ["f095bb3f-8acc-4200-9ae8-254f5475c877"],
    "ISupplyCompositeMetadata": ["5c326331-9508-4abd-93d2-b7407206463d"],
    "ISupportFilteredSync": ["3d128ded-d555-4e0d-bf4b-fb213a8a9302"],
    "ISupportIncrementalLoading": ["7f5ee992-7694-4e6c-a51b-e34bf43de743"],
    "ISupportLastWriteTime": ["eadf816f-d0bd-43ca-8f40-5acdc6c06f7a"],
    "ISupportVSProperties": ["6659ed14-2ab6-47f3-a890-00c8aba43b84"],
    "ISupportsPhoneNativeIdentifier": ["8c897024-16d4-4985-87ae-bb17e49563cb"],
    "ISupportsPhoneNativeTile": ["059566ac-bd74-4026-abb0-e76a64a7a369"],
    "ISuppressNavigationTransitionInfo": ["244d7b0c-b1b7-4871-9d3e-d56203a3a5b4"],
    "ISurfaceImageSource": ["62f7d416-c714-4c4c-8273-f839bc58135c"],
    "ISurfaceImageSourceFactory": ["3ab2212a-ef65-4a5f-bfac-73993e8c12c9"],
    "ISurfaceImageSourceManagerNative": ["4c8798b7-1d88-4a0f-b59b-b93f600de8c8"],
    "ISurfaceImageSourceNative": ["f2e9edc1-d307-4525-9886-0fafaa44163c"],
    "ISurfaceImageSourceNativeWithD2D": ["54298223-41e1-4a41-9c08-02e8256864a1"],
    "ISurfacePresenter": ["305106e2-98b5-11cf-bb82-00aa00bdce0b"],
    "ISurfacePresenterFlip": ["30510848-98b5-11cf-bb82-00aa00bdce0b"],
    "ISurfacePresenterFlip2": ["30510865-98b5-11cf-bb82-00aa00bdce0b"],
    "ISurfacePresenterFlipBuffer": ["e43f4a08-8bbc-4665-ac92-c55ce61fd7e7"],
    "ISuspendingDeferral": ["59140509-8bc9-4eb4-b636-dabdc4f46f66"],
    "ISuspendingEventArgs": ["96061c05-2dba-4d08-b0bd-2b30a131c6aa"],
    "ISuspendingEventHandler": ["23429465-e36a-40e2-b139-a4704602a6e1", "509c429c-78e2-4883-abc8-8960dcde1b5c"],
    "ISuspendingOperation": ["9da4ca41-20e1-4e9b-9f65-a9f435340c3a"],
    "ISuspensionDependencyBroker": ["c7f67a34-b58f-451c-8626-2eb426a1f205"],
    "ISuspensionDependencyManager": ["52b83a42-2543-416a-81d9-c0de7969c8b3"],
    "ISuspensionDependencyManagerInternal": ["0677b271-7d50-4c31-a108-ef4df4a6910a"],
    "ISvgImageSource": ["03e1cec3-0ca8-4a4e-8d7c-c808a0838586"],
    "ISvgImageSourceFactory": ["c794e9e7-cf23-4d72-bf1a-dfaa16d8ea52"],
    "ISvgImageSourceFailedEventArgs": ["68bb3170-3ccc-4035-ac01-9834543d744e"],
    "ISvgImageSourceOpenedEventArgs": ["85ef4c16-748e-4008-95c7-6a23dd7316db"],
    "ISvgImageSourceStatics": ["9c6638ce-bed1-4aab-acbb-d3e2185d315a"],
    "ISwapChainBackgroundPanel": ["1c59db48-8233-4c0c-bcf5-02a5fb35ae00"],
    "ISwapChainBackgroundPanel2": ["21e672f2-2592-4c38-870f-28fbcf52c095"],
    "ISwapChainBackgroundPanelFactory": ["198289d4-c89b-49b2-896c-5917bf8adcae"],
    "ISwapChainBackgroundPanelNative": ["43bebd4e-add5-4035-8f85-5608d08e9dc9"],
    "ISwapChainPanel": ["c589644f-eba8-427a-b75a-9f1f93a11ae9"],
    "ISwapChainPanelFactory": ["f38f8d7f-1a48-49cb-86d2-10eaaaf6fd70"],
    "ISwapChainPanelNative": ["f92f19d2-3ade-45a6-a20c-f6f1ea90554b"],
    "ISwapChainPanelNative2": ["d5a2f60c-37b2-44a2-937b-8d8eb9726821"],
    "ISwapChainPanelStatics": ["f89c0297-eea8-498c-99c4-257e3660df7e"],
    "ISwipeBackThemeAnimation": ["a38a4214-0bca-4d2d-95f7-ceba57fbaf60"],
    "ISwipeBackThemeAnimationStatics": ["693f31bf-4da6-468a-8ce0-996c9aad42e0"],
    "ISwipeControl": ["9ee3d96f-6704-4823-aa15-1c143bc53cf7"],
    "ISwipeControlFactory": ["c0aaa3ae-d141-4e12-a728-5f95b507e7ab"],
    "ISwipeControlStatics": ["e57ae83c-2216-4717-9ef6-4662334c6501"],
    "ISwipeHintThemeAnimation": ["cdd067c0-580e-4e40-be98-f202d3d84365"],
    "ISwipeHintThemeAnimationStatics": ["23d61a57-9115-4d63-b04a-b89f1c744dc0"],
    "ISwipeItem": ["836edadc-45c8-4a00-90a0-7107fa894a1b"],
    "ISwipeItemFactory": ["844bd61a-1716-4097-bba2-7526da22de39"],
    "ISwipeItemInvokedEventArgs": ["c5b025f5-cb32-4733-8011-5d0d37f4550a"],
    "ISwipeItemStatics": ["d0b44e96-2766-4d93-b5db-f5e1be832c2d"],
    "ISwipeItems": ["b01726ff-969a-40d0-9f04-76084ce6d7b7"],
    "ISwipeItemsFactory": ["47c460ee-d5aa-445f-b31e-50c076c011b9"],
    "ISwipeItemsStatics": ["376250df-48db-43e3-b0e9-089e5da9a114"],
    "ISwitchController": ["15328f88-3846-45be-ac4b-e083dca20ec2"],
    "ISwitchToAppCallback": ["12ba4720-3588-44ab-abf8-a81f28f8807f"],
    "ISwpadSupport": ["41e5de30-af85-4b7a-88ce-ea0cef9dbc16"],
    "ISxsStore": ["8601319a-d7cf-40f3-9025-7f77125453c6"],
    "ISymENCUnmanagedMethod": ["85e891da-a631-4c76-aca2-a44a39c46b8c"],
    "ISymNGenWriter": ["d682fd12-43de-411c-811b-be8404cea126"],
    "ISymNGenWriter2": ["b029e51b-4c55-4fe2-b993-9f7bc1f10db4"],
    "ISymUnmanagedAsyncMethod": ["b20d55b3-532e-4906-87e7-25bd5734abd2"],
    "ISymUnmanagedAsyncMethodPropertiesWriter": ["fc073774-1739-4232-bd56-a027294bec15"],
    "ISymUnmanagedBinder": ["aa544d42-28cb-11d3-bd22-0000f80849bd"],
    "ISymUnmanagedBinder2": ["accee350-89af-4ccb-8b40-1c2c4c6f9434"],
    "ISymUnmanagedBinder3": ["28ad3d43-b601-4d26-8a1b-25f9165af9d7"],
    "ISymUnmanagedConstant": ["48b25ed8-5bad-41bc-9cee-cd62fabc74e9"],
    "ISymUnmanagedDispose": ["969708d2-05e5-4861-a3b0-96e473cdf63f"],
    "ISymUnmanagedDocument": ["40de4037-7c81-3e1e-b022-ae1abff2ca08"],
    "ISymUnmanagedDocumentWriter": ["b01fafeb-c450-3a4d-beec-b4ceec01e006"],
    "ISymUnmanagedENCUpdate": ["e502d2dd-8671-4338-8f2a-fc08229628c4"],
    "ISymUnmanagedMethod": ["b62b923c-b500-3158-a543-24f307a8b7e1"],
    "ISymUnmanagedNamespace": ["0dff7289-54f8-11d3-bd28-0000f80849bd"],
    "ISymUnmanagedReader": ["b4ce6286-2a6b-3712-a3b7-1ee1dad467b5"],
    "ISymUnmanagedReader2": ["a09e53b2-2a57-4cca-8f63-b84f7c35d4aa"],
    "ISymUnmanagedReaderSymbolSearchInfo": ["20d9645d-03cd-4e34-9c11-9848a5b084f1"],
    "ISymUnmanagedScope": ["68005d0f-b8e0-3b01-84d5-a11a94154942"],
    "ISymUnmanagedScope2": ["ae932fba-3fd8-4dba-8232-30a2309b02db"],
    "ISymUnmanagedSourceServerModule": ["997dd0cc-a76f-4c82-8d79-ea87559d27ad"],
    "ISymUnmanagedSymbolSearchInfo": ["f8b3534a-a46b-4980-b520-bec4aceaba8f"],
    "ISymUnmanagedVariable": ["9f60eebe-2d9a-3f7c-bf58-80bc991c60bb"],
    "ISymUnmanagedWriter": ["ed14aa72-78e2-4884-84e2-334293ae5214"],
    "ISymUnmanagedWriter2": ["0b97726e-9e6d-4f05-9a26-424022093caa"],
    "ISymUnmanagedWriter3": ["12f1e02c-1e05-4b0e-9468-ebc9d1bb040f"],
    "ISymUnmanagedWriter4": ["bc7e3f53-f458-4c23-9dbd-a189e6e96594"],
    "ISymUnmanagedWriter5": ["dcf7780d-bde9-45df-acfe-21731a32000c"],
    "ISymbolIcon": ["7a4774c9-a6a3-4b30-8ff1-9081d70e9a5c"],
    "ISymbolIconFactory": ["c7252b88-e76c-4b44-8a05-046b9dc772b8"],
    "ISymbolIconSource": ["625d95a2-b6b1-408a-b289-eab2ecba62d8"],
    "ISymbolIconSourceFactory": ["a526aab0-4130-4907-b049-21f9240c7a40"],
    "ISymbolIconSourceStatics": ["8bc49738-d94e-4148-8d64-1adf0f23f25f"],
    "ISymbolIconStatics": ["8624fbdf-952c-4f76-b03f-30833be99572"],
    "ISymbolPathOptionList150": ["bd717aa1-85b7-49c1-ab11-9c524c873647"],
    "ISymmetricAlgorithmNamesStatics": ["6870727b-c996-4eae-84d7-79b2aeb73b9c"],
    "ISymmetricKeyAlgorithmProvider": ["3d7e4a33-3bd0-4902-8ac8-470d50d21376"],
    "ISymmetricKeyAlgorithmProviderStatics": ["8d3b2326-1f37-491f-b60e-f5431b26b483"],
    "ISyncAdvise": ["f2d9ec30-7c5f-11cf-b56b-00aa00a71d1a"],
    "ISyncCallback": ["0599797f-5ed9-485c-ae36-0c5d1bf2e7a5"],
    "ISyncCallback2": ["47ce84af-7442-4ead-8630-12015e030ad7"],
    "ISyncChange": ["a1952beb-0f6b-4711-b136-01da85b968a6"],
    "ISyncChangeBatch": ["70c64dee-380f-4c2e-8f70-31c55bd5f9b3"],
    "ISyncChangeBatch2": ["225f4a33-f5ee-4cc7-b039-67a262b4b2ac"],
    "ISyncChangeBatchAdvanced": ["0f1a4995-cbc8-421d-b550-5d0bebf3e9a5"],
    "ISyncChangeBatchBase": ["52f6e694-6a71-4494-a184-a8311bf5d227"],
    "ISyncChangeBatchBase2": ["6fdb596a-d755-4584-bd0c-c0c23a548fbf"],
    "ISyncChangeBatchWithFilterKeyMap": ["de247002-566d-459a-a6ed-a5aab3459fb7"],
    "ISyncChangeBatchWithPrerequisite": ["097f13be-5b92-4048-b3f2-7b42a2515e07"],
    "ISyncChangeBuilder": ["56f14771-8677-484f-a170-e386e418a676"],
    "ISyncChangeUnit": ["60edd8ca-7341-4bb7-95ce-fab6394b51cb"],
    "ISyncChangeWithFilterKeyMap": ["bfe1ef00-e87d-42fd-a4e9-242d70414aef"],
    "ISyncChangeWithPrerequisite": ["9e38382f-1589-48c3-92e4-05ecdcb4f3f7"],
    "ISyncClientFolderItem": ["cb69f9b1-de46-431c-af3f-a724569adf8e"],
    "ISyncConstraintCallback": ["8af3843e-75b3-438c-bb51-6f020d70d3cb"],
    "ISyncDataConverter": ["435d4861-68d5-44aa-a0f9-72a0b00ef9cf"],
    "ISyncEngine": ["d2bbb0bb-dd8e-412c-ab88-5db12ff1cca3"],
    "ISyncEngineEvents": ["c631b72e-37c1-4a02-94a1-279f3b9e7575"],
    "ISyncEnginePriorityModeToken": ["afd49541-5644-4500-8cb7-1e4ae8a7432b"],
    "ISyncFilter": ["087a3f15-0fcb-44c1-9639-53c14e2b5506"],
    "ISyncFilterDeserializer": ["b45b7a72-e5c7-46be-9c82-77b8b15dab8a"],
    "ISyncFilterInfo": ["794eaaf8-3f2e-47e6-9728-17e6fcf94cb7"],
    "ISyncFilterInfo2": ["19b394ba-e3d0-468c-934d-321968b2ab34"],
    "ISyncFullEnumerationChange": ["9785e0bd-bdff-40c4-98c5-b34b2f1991b3"],
    "ISyncFullEnumerationChangeBatch": ["ef64197d-4f44-4ea2-b355-4524713e3bed"],
    "ISyncFullEnumerationChangeBatch2": ["e06449f4-a205-4b65-9724-01b22101eec1"],
    "ISyncIAMEventHandler": ["9c89efc7-3c2d-4913-897f-dd317f677138"],
    "ISyncIntegrationManager": ["ef01eb89-5a19-42cb-bc8c-f10ed6c6791b"],
    "ISyncKnowledge": ["615bbb53-c945-4203-bf4b-2cb65919a0aa"],
    "ISyncKnowledge2": ["ed0addc0-3b4b-46a1-9a45-45661d2114c8"],
    "ISyncLock": ["cac39c1f-6134-43c9-a8d7-54ac66a41ac5"],
    "ISyncLockProvider": ["171559c2-9bac-4439-bbc8-1a23840a7771"],
    "ISyncMergeTombstoneChange": ["6ec62597-0903-484c-ad61-36d6e938f47b"],
    "ISyncMgrAggregateStatus": ["f566e43e-7497-4102-94ef-5f16500b2ef5"],
    "ISyncMgrConflict": ["9c204249-c443-4ba4-85ed-c972681db137"],
    "ISyncMgrConflictFolder": ["59287f5e-bc81-4fca-a7f1-e5a8ecdb1d69"],
    "ISyncMgrConflictItems": ["9c7ead52-8023-4936-a4db-d2a9a99e436a"],
    "ISyncMgrConflictPresenter": ["0b4f5353-fd2b-42cd-8763-4779f2d508a3"],
    "ISyncMgrConflictResolutionItems": ["458725b9-129d-4135-a998-9ceafec27007"],
    "ISyncMgrConflictResolveInfo": ["c405a219-25a2-442e-8743-b845a2cee93f"],
    "ISyncMgrConflictStore": ["cf8fc579-c396-4774-85f1-d908a831156e"],
    "ISyncMgrControl": ["9b63616c-36b2-46bc-959f-c1593952d19b"],
    "ISyncMgrEvent": ["fee0ef8b-46bd-4db4-b7e6-ff2c687313bc"],
    "ISyncMgrEventCollection": ["53326b4a-e949-41fa-ae2c-9293ff144a50"],
    "ISyncMgrEventFolder": ["cedac0b3-e828-40cc-9e5c-e2f4e9b447c4"],
    "ISyncMgrEventLinkUIOperation": ["64522e52-848b-4015-89ce-5a36f00b94ff"],
    "ISyncMgrEventStore": ["37e412f9-016e-44c2-81ff-db3add774266"],
    "ISyncMgrEvents": ["1cf95a1e-3fd8-47db-bbf2-5afaeb95ed09"],
    "ISyncMgrHandler": ["04ec2e43-ac77-49f9-9b98-0307ef7a72a2"],
    "ISyncMgrHandlerCollection": ["a7f337a3-d20b-45cb-9ed7-87d094ca5045"],
    "ISyncMgrHandlerInfo": ["4ff1d798-ecf7-4524-aa81-1e362a0aef3a"],
    "ISyncMgrIsolationHandlerCollection": ["1a0e696d-2797-425c-83da-11690e066f95"],
    "ISyncMgrLegacyCookie": ["c0355171-4866-4054-8b38-ec1e7ef0445f"],
    "ISyncMgrPrivateLegacyItemProperties": ["927fcf24-a0a8-4294-a40d-4aa3240d8784"],
    "ISyncMgrResolutionHandler": ["40a3d052-8bff-4c4b-a338-d4a395700de9"],
    "ISyncMgrScheduleWizardUIOperation": ["459a6c84-21d2-4ddc-8a53-f023a46066f2"],
    "ISyncMgrSessionCreator": ["17f48517-f305-4321-a08d-b25a834918fd"],
    "ISyncMgrStateChangeNotificationCallback": ["bb1c1d45-a09f-424a-be9d-029e7f4636cf"],
    "ISyncMgrStatusAdviseCallback": ["f8c87a7a-ab21-464a-89ce-d152348105c1"],
    "ISyncMgrSyncCallback": ["884ccd87-b139-4937-a4ba-4f8e19513fbe"],
    "ISyncMgrSyncItem": ["b20b24ce-2593-4f04-bd8b-7ad6c45051cd"],
    "ISyncMgrSyncItemContainer": ["90701133-be32-4129-a65c-99e616cafff4"],
    "ISyncMgrSyncItemInfo": ["e7fd9502-be0c-4464-90a1-2b5277031232"],
    "ISyncMgrSyncResult": ["2b90f17e-5a3e-4b33-bb7f-1bc48056b94d"],
    "ISyncMgrUIOperation": ["fc7cfa47-dfe1-45b5-a049-8cfd82bec271"],
    "ISyncProvider": ["8f657056-2bce-4a17-8c68-c7bb7898b56f"],
    "ISyncProviderChangeNotify": ["0373fcef-f303-4994-8d32-08429ec96b94"],
    "ISyncProviderConfigUI": ["7b0705f6-cbcd-4071-ab05-3bdc364d4a0c"],
    "ISyncProviderConfigUIInfo": ["214141ae-33d7-4d8d-8e37-f227e880ce50"],
    "ISyncProviderInfo": ["1ee135de-88a4-4504-b0d0-f7920d7e5ba6"],
    "ISyncProviderObjectCache": ["97ab75f9-73b4-424f-897f-b2ab59748350"],
    "ISyncProviderRegistration": ["cb45953b-7624-47bc-a472-eb8cac6b222e"],
    "ISyncProviderSession": ["613b1628-53da-4f2c-b96e-630c0653c59a"],
    "ISyncRegistrationChange": ["eea0d9ae-6b29-43b4-9e70-e3ae33bb2c3b"],
    "ISyncSessionExtendedErrorInfo": ["326c6810-790a-409b-b741-6999388761eb"],
    "ISyncSessionState": ["b8a940fe-9f01-483b-9434-c37d361225d9"],
    "ISyncSessionState2": ["9e37cfa3-9e38-4c61-9ca3-ffe810b45ca2"],
    "ISyncSharePartnershipManagerInternal": ["363a87ac-7b96-4808-8f6a-c066211a0c19"],
    "ISyncStatusProvider": ["1aba2312-77b6-44d7-b975-cce3f3d3fb2f"],
    "ISyncStatusProviderInfo": ["b03295b1-07b7-4627-8e80-57fc1931513f"],
    "ISyncTransferStatus": ["e55a074f-0b52-45bf-9478-a1bc558dde9a"],
    "ISyncTransferStatus2": ["9bba4906-a7eb-4bb2-869e-14a16e1e817e"],
    "ISyncedStreamReaderInfo": ["d18e07e4-d7b4-49ee-a04d-55955a063644"],
    "ISynchronizeStream": ["e4d41f01-5b8c-461a-9bae-024730d2224f"],
    "ISynchronizeStreamTimeout": ["5b543278-2a9f-4209-9f21-33ddab884908"],
    "ISynchronizedInputProvider": ["29db1a06-02ce-4cf7-9b42-565d4fab20ee", "3d60cecb-da54-4aa3-b915-e3244427d4ac"],
    "ISynchronousDataRetriever": ["9b22f2a9-a4cd-4648-9d8e-3a510d4da04b"],
    "ISyndicationAttribute": ["71e8f969-526e-4001-9a91-e84f83161ab1"],
    "ISyndicationAttributeFactory": ["624f1599-ed3e-420f-be86-640414886e4b"],
    "ISyndicationCategory": ["8715626f-0cba-4a7f-89ff-ecb5281423b6"],
    "ISyndicationCategoryFactory": ["ab42802f-49e0-4525-8ab2-ab45c02528ff"],
    "ISyndicationClient": ["9e18a9b7-7249-4b45-b229-7df895a5a1f5"],
    "ISyndicationClientFactory": ["2ec4b32c-a79b-4114-b29a-05dffbafb9a4"],
    "ISyndicationContent": ["4641fefe-0e55-40d0-b8d0-6a2ccba9fc7c"],
    "ISyndicationContentFactory": ["3d2fbb93-9520-4173-9388-7e2df324a8a0"],
    "ISyndicationErrorStatics": ["1fbb2361-45c7-4833-8aa0-be5f3b58a7f4"],
    "ISyndicationFeed": ["7ffe3cd2-5b66-4d62-8403-1bc10d910d6b"],
    "ISyndicationFeedFactory": ["23472232-8be9-48b7-8934-6205131d9357"],
    "ISyndicationGenerator": ["9768b379-fb2b-4f6d-b41c-088a5868825c"],
    "ISyndicationGeneratorFactory": ["a34083e3-1e26-4dbc-ba9d-1ab84beff97b"],
    "ISyndicationItem": ["548db883-c384-45c1-8ae8-a378c4ec486c"],
    "ISyndicationItemFactory": ["251d434f-7db8-487a-85e4-10d191e66ebb"],
    "ISyndicationLink": ["27553abd-a10e-41b5-86bd-9759086eb0c5"],
    "ISyndicationLinkFactory": ["5ed863d4-5535-48ac-98d4-c190995080b3"],
    "ISyndicationNode": ["753cef78-51f8-45c0-a9f5-f1719dec3fb2"],
    "ISyndicationNodeFactory": ["12902188-4acb-49a8-b777-a5eb92e18a79"],
    "ISyndicationPerson": ["fa1ee5da-a7c6-4517-a096-0143faf29327"],
    "ISyndicationPersonFactory": ["dcf4886d-229d-4b58-a49b-f3d2f0f5c99f"],
    "ISyndicationText": ["b9cc5e80-313a-4091-a2a6-243e0ee923f9"],
    "ISyndicationTextContext": ["9029d944-774e-4f96-9f74-c18974180b36"],
    "ISyndicationTextFactory": ["ee7342f7-11c6-4b25-ab62-e596bd162946"],
    "ISynthSinkDMus": ["1f476974-679b-11d2-8f7d-00c04fbf8fef", "1f476974-679b-11d2-8f7d-00c04fbf8fef"],
    "ISystemActivator": ["000001a0-0000-0000-c000-000000000046"],
    "ISystemAudioProperties": ["3f8f38b7-308c-47e1-924d-8645348e5db7"],
    "ISystemButtonEventController": ["59b893a9-73bc-52b5-ba41-82511b2cb46c"],
    "ISystemButtonEventControllerStatics": ["632fb07b-20bd-5e15-af4a-00dbf2064ffa"],
    "ISystemCPLUpdate": ["e5e81cab-8345-4c45-a500-8da9592f169a"],
    "ISystemCondition": ["c15fb476-89c5-420b-abd3-fb3030472128"],
    "ISystemConditionFactory": ["d269d1f1-05a7-49ae-87d7-16b2b8b9a553"],
    "ISystemCpuUsage": ["6037b3ac-02d6-4234-8362-7fe3adc81f5f"],
    "ISystemCpuUsageReport": ["2c26d0b2-9483-4f62-ab57-82b29d9719b8"],
    "ISystemDataPaths": ["e32abf70-d8fa-45ec-a942-d2e26fb60ba5"],
    "ISystemDataPathsInterop": ["864d0b26-3a37-4251-9a02-b231198de060"],
    "ISystemDataPathsStatics": ["e0f96fd0-9920-4bca-b379-f96fdf7caad8"],
    "ISystemDiagnosticInfo": ["a290fe05-dff3-407f-9a1b-0b2b317ca800"],
    "ISystemDiagnosticInfoStatics": ["d404ac21-fc7d-45f0-9a3f-39203aed9f7e"],
    "ISystemFunctionButtonEventArgs": ["4833896f-80d1-5dd6-92a7-62a508ffef5a"],
    "ISystemFunctionLockChangedEventArgs": ["cd040608-fcf9-585c-beab-f1d2eaf364ab"],
    "ISystemFunctionLockIndicatorChangedEventArgs": ["b212b94e-7a6f-58ae-b304-bae61d0371b9"],
    "ISystemGPSProperties": ["c0f46eb4-c174-481a-bc25-921986f6a6f3"],
    "ISystemIdentificationInfo": ["0c659e7d-c3c2-4d33-a2df-21bc41916eb3"],
    "ISystemIdentificationStatics": ["5581f42a-d3df-4d93-a37d-c41a616c6d01"],
    "ISystemImageProperties": ["011b2e30-8b39-4308-bea1-e8aa61e47826"],
    "ISystemInformation": ["ade87bf7-7b56-4275-8fab-b9b0e591844b"],
    "ISystemMediaProperties": ["a42b3316-8415-40dc-8c44-98361d235430"],
    "ISystemMediaTransportControls": ["99fa3ff4-1742-42a6-902e-087d41f965ec"],
    "ISystemMediaTransportControls2": ["ea98d2f6-7f3c-4af2-a586-72889808efb1"],
    "ISystemMediaTransportControlsButtonPressedEventArgs": ["b7f47116-a56f-4dc8-9e11-92031f4a87c2"],
    "ISystemMediaTransportControlsDisplayUpdater": ["8abbc53e-fa55-4ecf-ad8e-c984e5dd1550"],
    "ISystemMediaTransportControlsInterop": ["ddb0472d-c911-4a1f-86d9-dc3d71a95f5a"],
    "ISystemMediaTransportControlsPropertyChangedEventArgs": ["d0ca0936-339b-4cb3-8eeb-737607f56e08"],
    "ISystemMediaTransportControlsStatics": ["43ba380a-eca4-4832-91ab-d415fae484c6"],
    "ISystemMediaTransportControlsTimelineProperties": ["5125316a-c3a2-475b-8507-93534dc88f15"],
    "ISystemMemoryUsage": ["17ffc595-1702-49cf-aa27-2f0a32591404"],
    "ISystemMemoryUsageReport": ["38663c87-2a9f-403a-bd19-2cf3e8169500"],
    "ISystemMonitor": ["194eb241-c32c-11cf-9398-00aa00a3ddea"],
    "ISystemMonitor2": ["08e3206a-5fd2-4fde-a8a5-8cb3b63d2677"],
    "ISystemMonitorEvents": ["ee660ea0-4abd-11cf-943a-008029004347"],
    "ISystemMusicProperties": ["b47988d5-67af-4bc3-8d39-5b89022026a1"],
    "ISystemNavigationCloseRequestedPreviewEventArgs": ["83d00de1-cbe5-4f31-8414-361da046518f"],
    "ISystemNavigationManager": ["93023118-cf50-42a6-9706-69107fa122e1"],
    "ISystemNavigationManager2": ["8c510401-67be-49ae-9509-671c1e54a389"],
    "ISystemNavigationManagerPreview": ["ec5f0488-6425-4777-a536-cb5634427f0d"],
    "ISystemNavigationManagerPreviewStatics": ["0e971360-df74-4bce-84cb-bd1181ac0a71"],
    "ISystemNavigationManagerStatics": ["dc52b5ce-bee0-4305-8c54-68228ed683b5"],
    "ISystemPhotoProperties": ["4734fc3d-ab21-4424-b735-f4353a56c8fc"],
    "ISystemProperties": ["917a71c1-85f3-4dd1-b001-a50bfd21c8d2"],
    "ISystemSetupInfoStatics": ["2c9620a8-1d88-5e2d-a324-a543af4247ee"],
    "ISystemSupportDeviceInfo": ["05880b99-8247-441b-a996-a1784bab79a8"],
    "ISystemSupportInfoStatics": ["ef750974-c422-45d7-a44d-5c1c0043a2b3"],
    "ISystemSupportInfoStatics2": ["33f349a4-3fa1-4986-aa4b-057420455e6d"],
    "ISystemTrigger": ["1d80c776-3748-4463-8d7e-276dc139ac1c"],
    "ISystemTriggerFactory": ["e80423d4-8791-4579-8126-87ec8aaa407a"],
    "ISystemUIInputHostHandler": ["c91fa253-e03a-45c3-8123-15e348a62f8d"],
    "ISystemUpdateItem": ["779740eb-5624-519e-a8e2-09e9173b3fb7"],
    "ISystemUpdateLastErrorInfo": ["7ee887f7-8a44-5b6e-bd07-7aece4116ea9"],
    "ISystemUpdateManagerStatics": ["b2d3fcef-2971-51be-b41a-8bd703bb701a"],
    "ISystemVideoProperties": ["2040f715-67f8-4322-9b80-4fa9fefb83e8"],
    "ITPLangMod": ["357fbe87-6c8e-490d-a059-4746c864ae6f"],
    "ITSDT": ["d19bdb43-405b-4a7c-a791-c89110c33165"],
    "ITSGAccountingEngine": ["4ce2a0c9-e874-4f1a-86f4-06bbb9115338"],
    "ITSGAuthenticateUserSink": ["2c3e2e73-a782-47f9-8dfb-77ee1ed27a03"],
    "ITSGAuthenticationEngine": ["9ee3e5bf-04ab-4691-998c-d7f622321a56"],
    "ITSGAuthorizeConnectionSink": ["c27ece33-7781-4318-98ef-1cf2da7b7005"],
    "ITSGAuthorizeResourceSink": ["feddfcd4-fa12-4435-ae55-7ad1a9779af7"],
    "ITSGPolicyEngine": ["8bc24f08-6223-42f4-a5b4-8e37cd135bbd"],
    "ITabBandDragDropHelper": ["e658efc5-5615-4fc8-a4d5-28d9c2aa988b"],
    "ITabBrowserService": ["5b3d689b-d4f5-4ff1-a101-12ccdfee5284"],
    "ITabImageCache": ["a0be5b80-933f-4e32-900a-a28e31bdb9cf"],
    "ITabImageCacheEvents": ["b380d858-64ec-46b4-ab82-c0a0560ef589"],
    "ITabProtocolLaunch": ["abc8c20f-b26b-47d1-b9c1-62194685fcb1"],
    "ITabRecoveryData": ["f5c6d370-31ad-4fb6-bd77-15f7208a5d12"],
    "ITabStrip": ["1efb6594-857c-11d1-b16a-00c0f0283628"],
    "ITabStripEvents": ["1efb6595-857c-11d1-b16a-00c0f0283628"],
    "ITabWindow": ["49296cad-92e6-43b2-abe1-5d73d71d7ac9"],
    "ITabWindow2": ["17a643ed-26bc-4afa-b545-1bbbe77dbc30"],
    "ITabWindowEvents": ["2648f808-5c34-45a8-9139-36af1dfa9f7d"],
    "ITabWindowImage": ["aab63dd1-32fb-449e-8434-edc42c0830ed"],
    "ITabWindowImage2": ["660b3255-6433-49ed-a12b-a6a446e26431"],
    "ITabWindowManager": ["feefb420-9399-492d-969c-51af6dc38fb1"],
    "ITabWindowManager2": ["4e9c1976-d523-466a-997b-b6833e84372c"],
    "ITabWindowModalManager": ["cfcef9a8-f1ef-41fe-9c2f-bee528bdab75"],
    "ITableCreation": ["0c733abc-2a1c-11ce-ade5-00aa0044773d"],
    "ITableDefinition": ["0c733a86-2a1c-11ce-ade5-00aa0044773d"],
    "ITableDefinitionWithConstraints": ["0c733aab-2a1c-11ce-ade5-00aa0044773d"],
    "ITableItemPatternIdentifiers": ["c326e5ad-8077-4c64-98e4-e83bcf1b4389"],
    "ITableItemPatternIdentifiersStatics": ["24c4b923-e9a2-4de9-b2a4-a8b22d0be362"],
    "ITableItemProvider": ["3b2c49cd-1de2-4ee2-a3e1-fb553559d15d", "b9734fa6-771f-4d78-9c90-2517999349cd"],
    "ITablePatternIdentifiers": ["38d104fe-0d0c-412a-bf8d-51ede683baf5"],
    "ITablePatternIdentifiersStatics": ["75073d25-32c9-4903-aecf-dc3504cbd244"],
    "ITableProvider": ["7a8ed399-6824-4595-bab3-464bc9a04417", "9c860395-97b3-490a-b52a-858cc22af166"],
    "ITableRename": ["0c733a77-2a1c-11ce-ade5-00aa0044773d"],
    "ITablet": ["1cb2efc3-abc7-4172-8fcb-3bc9cb93e29f"],
    "ITabletButtonExtendedAction": ["211480ef-5db7-41c2-ade0-c68678b5c7db"],
    "ITabletButtonExtendedActions": ["e96c060d-6cee-4b10-9d77-9b0643d546e5"],
    "ITabletContext": ["45aaaf04-9d6f-41ae-8ed1-ecd6d4b2f17f"],
    "ITabletCursor": ["ef9953c6-b472-4b02-9d22-d0e247ade0e8"],
    "ITabletCursorButton": ["997a992e-8b6c-4945-bc17-a1ee563b3ab7"],
    "ITabletModeAvailabilityChangeListener": ["2ec6feac-b62e-4499-a136-ffcba5e05f0b"],
    "ITabletModeChangeListener": ["86fb57a6-3c81-4f40-a971-6280be4e526e"],
    "ITabletModeController": ["4fda780a-acd2-41f7-b4f2-ebe674c9bf2a"],
    "ITabletModeInputCallback": ["bf49be29-71c8-427e-a671-fec22c61e5f1"],
    "ITabletModeInputSource": ["3421cff7-d49b-4e87-a0e9-1f7077d9ce1b"],
    "ITabletModeViewManager": ["373e56cf-0a1b-4b4a-a1a4-a46b25ffd7e3"],
    "ITabs": ["1efb6597-857c-11d1-b16a-00c0f0283628"],
    "ITallyObject": ["232386ae-8bc8-492c-abf2-cd522fec9869"],
    "ITappedEventArgs": ["cfa126e4-253a-4c3c-953b-395c37aed309"],
    "ITappedEventArgs2": ["294388f2-177e-51d5-be56-ee0866fa968c"],
    "ITappedEventHandler": ["68d940cc-9ff0-49ce-b141-3f07ec477b97"],
    "ITappedRoutedEventArgs": ["a099e6be-e624-459a-bb1d-e05c73e2cc66"],
    "ITargetApplicationChosenEventArgs": ["ca6fb8ac-2987-4ee3-9c54-d8afbcb86c1d"],
    "ITargetFileRequest": ["42bd3355-7f88-478b-8e81-690b20340678"],
    "ITargetFileRequestDeferral": ["4aee9d91-bf15-4da9-95f6-f6b7d558225b"],
    "ITargetFileRequestedEventArgs": ["b163dbc1-1b51-4c89-a591-0fd40b3c57c9"],
    "ITargetFramePriv2": ["b2c867e6-69d6-46f2-a611-ded9a4bd7fef"],
    "ITargetInfo": ["9f7d7bb8-20b3-11da-81a5-0030f1642e3c"],
    "ITargetPropertyPath": ["40740f8e-085f-4ced-be70-6f47acf15ad0"],
    "ITargetPropertyPathFactory": ["88eeccc8-99e2-4a44-9907-b44bc86e2bbe"],
    "ITargetedContentAction": ["d75b691e-6cd6-4ca0-9d8f-4728b0b7e6b6"],
    "ITargetedContentAvailabilityChangedEventArgs": ["e0f59d26-5927-4450-965c-1ceb7becde65"],
    "ITargetedContentChangedEventArgs": ["99d488c9-587e-4586-8ef7-b54ca9453a16"],
    "ITargetedContentCollection": ["2d4b66c5-f163-44ba-9f6e-e1a4c2bb559d"],
    "ITargetedContentContainer": ["bc2494c9-8837-47c2-850f-d79d64595926"],
    "ITargetedContentContainerStatics": ["5b47e7fb-2140-4c1f-a736-c59583f227d8"],
    "ITargetedContentImage": ["a7a585d9-779f-4b1e-bbb1-8eaf53fbeab2"],
    "ITargetedContentItem": ["38168dc4-276c-4c32-96ba-565c6e406e74"],
    "ITargetedContentItemState": ["73935454-4c65-4b47-a441-472de53c79b6"],
    "ITargetedContentObject": ["041d7969-2212-42d1-9dfa-88a8e3033aa3"],
    "ITargetedContentStateChangedEventArgs": ["9a1cef3d-8073-4416-8df2-546835a6414f"],
    "ITargetedContentSubscription": ["882c2c49-c652-4c7a-acad-1f7fa2986c73"],
    "ITargetedContentSubscriptionOptions": ["61ee6ad0-2c83-421b-8467-413eaf1aeb97"],
    "ITargetedContentSubscriptionStatics": ["faddfe80-360d-4916-b53c-7ea27090d02a"],
    "ITargetedContentValue": ["aafde4b3-4215-4bf8-867f-43f04865f9bf"],
    "ITaskAdvise": ["cf203f90-a20e-11cf-b57d-00aa00a71d1a"],
    "ITaskCompletionBroker": ["874308dd-1165-4e74-8578-01fd35055de9"],
    "ITaskDefinition": ["f5bc8fc5-536d-4f77-b852-fbc1356fdeb6"],
    "ITaskDismisser": ["a9cff2d5-81c7-4116-a3a2-b2c3b816e9c2"],
    "ITaskFolder": ["8cfac062-a080-4c15-9a88-aa7c2af80dfc"],
    "ITaskFolderCollection": ["79184a66-8664-423f-97f1-637356a5d812"],
    "ITaskHandler": ["839d7762-5121-4009-9234-4f0d19394f04"],
    "ITaskHandlerStatus": ["eaec7a8f-27a0-4ddc-8675-14726a01a38a"],
    "ITaskNamedValueCollection": ["b4ef826b-63c3-46e4-a504-ef69e4f7ea4d"],
    "ITaskNamedValuePair": ["39038068-2b46-4afd-8662-7bb6f868d221"],
    "ITaskService": ["2faba4c7-4da9-4013-9697-20cc3fd40f85"],
    "ITaskSettings": ["8fd4711d-2d02-4c8c-87e3-eff699de127e"],
    "ITaskSettings2": ["2c05c3f0-6eed-4c05-a15f-ed7d7a98a369"],
    "ITaskSettings3": ["0ad9d0d7-0c7f-4ebb-9a5f-d1c648dca528"],
    "ITaskVariables": ["3e4c9351-d966-4b8b-bb87-ceba68bb0107"],
    "ITaskbarLayoutItem": ["8a2a3037-d907-4af5-996a-0262e73bbe8f"],
    "ITaskbarLayoutPolicyManager": ["99846e14-d914-4eb8-97e0-5432c32b2f40"],
    "ITaskbarList3": ["ea1afb91-9e28-4b86-90e9-9e9f8a5eefaf"],
    "ITaskbarList4": ["c43dc798-95d1-4bea-9030-bb99e2983a1a"],
    "ITaskbarManager": ["87490a19-1ad9-49f4-b2e8-86738dc5ac40"],
    "ITaskbarManager2": ["79f0a06e-7b02-4911-918c-dee0bbd20ba4"],
    "ITaskbarManagerStatics": ["db32ab74-de52-4fe6-b7b6-95ff9f8395df"],
    "ITaskbarThumbnailHandler": ["d0d73345-806e-4526-8ad6-3b3bb2ec2895"],
    "ITasks": ["445ca8e4-861b-42e3-ae5a-f5ac2490a77a"],
    "ITemplatePrinter3": ["305104a3-98b5-11cf-bb82-00aa00bdce0b"],
    "ITemplateSdo": ["8aa85302-d2e2-4e20-8b1f-a571e437d6c9"],
    "ITemporarySplashScreen": ["94e76fd7-6ec7-4a63-a8fb-5d5cb760b7f6"],
    "ITensor": ["05489593-a305-4a25-ad09-440119b4b7f6"],
    "ITensorBoolean": ["50f311ed-29e9-4a5c-a44d-8fc512584eed"],
    "ITensorBooleanStatics": ["2796862c-2357-49a7-b476-d0aa3dfe6866"],
    "ITensorBooleanStatics2": ["a3a4a501-6a2d-52d7-b04b-c435baee0115"],
    "ITensorDouble": ["91e41252-7a8f-4f0e-a28f-9637ffc8a3d0"],
    "ITensorDoubleStatics": ["a86693c5-9538-44e7-a3ca-5df374a5a70c"],
    "ITensorDoubleStatics2": ["93a570de-5e9a-5094-85c8-592c655e68ac"],
    "ITensorFeatureDescriptor": ["74455c80-946a-4310-a19c-ee0af028fce4"],
    "ITensorFloat": ["f2282d82-aa02-42c8-a0c8-df1efc9676e1"],
    "ITensorFloat16Bit": ["0ab994fc-5b89-4c3c-b5e4-5282a5316c0a"],
    "ITensorFloat16BitStatics": ["a52db6f5-318a-44d4-820b-0cdc7054a84a"],
    "ITensorFloat16BitStatics2": ["68545726-2dc7-51bf-b470-0b344cc2a1bc"],
    "ITensorFloatStatics": ["dbcd395b-3ba3-452f-b10d-3c135e573fa9"],
    "ITensorFloatStatics2": ["24610bc1-5e44-5713-b281-8f4ad4d555e8"],
    "ITensorInt16Bit": ["98a32d39-e6d6-44af-8afa-baebc44dc020"],
    "ITensorInt16BitStatics": ["98646293-266e-4b1a-821f-e60d70898b91"],
    "ITensorInt16BitStatics2": ["0cd70cf4-696c-5e5f-95d8-5ebf9670148b"],
    "ITensorInt32Bit": ["2c0c28d3-207c-4486-a7d2-884522c5e589"],
    "ITensorInt32BitStatics": ["6539864b-52fa-4e35-907c-834cac417b50"],
    "ITensorInt32BitStatics2": ["7c4b079a-e956-5ce0-a3bd-157d9d79b5ec"],
    "ITensorInt64Bit": ["499665ba-1fa2-45ad-af25-a0bd9bda4c87"],
    "ITensorInt64BitStatics": ["9648ad9d-1198-4d74-9517-783ab62b9cc2"],
    "ITensorInt64BitStatics2": ["6d3d9dcb-ff40-5ec2-89fe-084e2b6bc6db"],
    "ITensorInt8Bit": ["cddd97c5-ffd8-4fef-aefb-30e1a485b2ee"],
    "ITensorInt8BitStatics": ["b1a12284-095c-4c76-a661-ac4cee1f3e8b"],
    "ITensorInt8BitStatics2": ["c0d59637-c468-56fb-9535-c052bdb93dc0"],
    "ITensorNative": ["52f547ef-5b03-49b5-82d6-565f1ee0dd49"],
    "ITensorStaticsNative": ["39d055a4-66f6-4ebc-95d9-7a29ebe7690a"],
    "ITensorString": ["582335c8-bdb1-4610-bc75-35e9cbf009b7"],
    "ITensorStringStatics": ["83623324-cf26-4f17-a2d4-20ef8d097d53"],
    "ITensorStringStatics2": ["9e355ed0-c8e2-5254-9137-0193a3668fd8"],
    "ITensorUInt16Bit": ["68140f4b-23c0-42f3-81f6-a891c011bc3f"],
    "ITensorUInt16BitStatics": ["5df745dd-028a-481a-a27c-c7e6435e52dd"],
    "ITensorUInt16BitStatics2": ["8af40c64-d69f-5315-9348-490877bbd642"],
    "ITensorUInt32Bit": ["d8c9c2ff-7511-45a3-bfac-c38f370d2237"],
    "ITensorUInt32BitStatics": ["417c3837-e773-4378-8e7f-0cc33dbea697"],
    "ITensorUInt32BitStatics2": ["ef1a1f1c-314e-569d-b496-5c8447d20cd2"],
    "ITensorUInt64Bit": ["2e70ffad-04bf-4825-839a-82baef8c7886"],
    "ITensorUInt64BitStatics": ["7a7e20eb-242f-47cb-a9c6-f602ecfbfee4"],
    "ITensorUInt64BitStatics2": ["085a687d-67e1-5b1e-b232-4fabe9ca20b3"],
    "ITensorUInt8Bit": ["58e1ae27-622b-48e3-be22-d867aed1daac"],
    "ITensorUInt8BitStatics": ["05f67583-bc24-4220-8a41-2dcd8c5ed33c"],
    "ITensorUInt8BitStatics2": ["2ba042d6-373e-5a3a-a2fc-a6c41bd52789"],
    "ITestQuery": ["a8c1e1bf-3c81-4aed-9bad-52e89eb4081f"],
    "ITestRotationManager": ["59d1d83f-db41-47b7-b16b-d2525dcf41b6"],
    "ITetheringEntitlementCheckTriggerDetails": ["03c65e9d-5926-41f3-a94e-b50926fc421b"],
    "ITextBlob": ["53ff24d9-6414-418f-8e8d-ddd1ba692db5"],
    "ITextBlobSurrogate": ["a7fca23a-f9e1-46c8-b766-a7cdaf64edd7"],
    "ITextBlock": ["ae2d9271-3b4a-45fc-8468-f7949548f4d5"],
    "ITextBlock2": ["45206a4c-0a4e-4fbf-aee9-335d5a205f6e"],
    "ITextBlock3": ["b651dd5a-424b-48c3-9b67-486f4e139899"],
    "ITextBlock4": ["b014f270-9808-4adc-b452-60cda54100c1"],
    "ITextBlock5": ["624a2d38-edbd-4a5a-b678-e49f1e07afbd"],
    "ITextBlock6": ["31816cd9-0404-410f-91ec-33b0a0bb92b2"],
    "ITextBlock7": ["dfe20a4e-8be7-5e33-9f37-72416875b121"],
    "ITextBlockAutomationPeer": ["be2057f5-6715-4e69-a050-92bd0ce232a9"],
    "ITextBlockAutomationPeerFactory": ["76bf924b-7ca0-4b01-bc5c-a8cf4d3691de"],
    "ITextBlockStatics": ["193ec042-a847-4552-b4e8-db36655b840a"],
    "ITextBlockStatics2": ["88100b1b-ff24-4b93-a0e6-f029c94871f1"],
    "ITextBlockStatics3": ["8d16b9eb-20a1-4eab-bbf2-1d6bdcbcd705"],
    "ITextBlockStatics5": ["8e4d9c70-0d4e-48df-ae7f-bb7a9af6852e"],
    "ITextBlockStatics6": ["3d1013a9-f9a6-43a2-99d3-573b89a83ca3"],
    "ITextBlockStatics7": ["cfd57e3b-0256-585d-8b3f-feafb69d3320"],
    "ITextBox": ["e48f5a8b-1dff-4352-a1f4-e516514ec882"],
    "ITextBox2": ["f7168c00-1432-462a-9405-38f385bfc37c"],
    "ITextBox3": ["7df18c3c-2826-425e-9a94-00b7f73f3756"],
    "ITextBox4": ["b5f1a675-cce1-45af-aef9-c4787bbb5e30"],
    "ITextBox5": ["35f9cfc1-4176-44f4-b756-e9ccc4399805"],
    "ITextBox6": ["41ff2d07-5085-4e52-a51c-f94b06cd558b"],
    "ITextBox7": ["da4911f9-ffe1-4c6a-ac6d-1b4a174ccf80"],
    "ITextBox8": ["1eb6d027-0317-5c37-8aea-f747ae7f0463"],
    "ITextBoxAutomationPeer": ["3a4f1ca0-5e5d-4d26-9067-e740bf657a9f"],
    "ITextBoxAutomationPeerFactory": ["01f0c067-966b-4130-b872-469e42bd4a7f"],
    "ITextBoxBeforeTextChangingEventArgs": ["a5541db3-7784-4258-aa83-e4bedd727467"],
    "ITextBoxFactory": ["710e4278-8529-47d3-8d8e-307e34cff081"],
    "ITextBoxSelectionChangingEventArgs": ["847a24dd-9abe-52df-a80a-0cce4b496632"],
    "ITextBoxStatics": ["7e37f4fb-a4bc-4625-8838-8eb2a9091283"],
    "ITextBoxStatics2": ["7592f37d-4e76-4ee4-8e0f-7d6e1a23326b"],
    "ITextBoxStatics3": ["0e1005c0-10b5-40f6-92c2-ce134b0d3457"],
    "ITextBoxStatics5": ["07d04b45-1b2f-4627-82fd-683f197e5a75"],
    "ITextBoxStatics6": ["dc0d97e7-1cb7-433e-aa4f-9c64c98cdee5"],
    "ITextBoxStatics7": ["cd6c6f47-147e-46f8-a4e8-749c49847a3e"],
    "ITextBoxStatics8": ["7f93d7c4-7d88-5f4d-8955-a5ad3848bcb6"],
    "ITextBoxTextChangingEventArgs": ["4e6a4b75-43dd-4e33-acbe-2d8796a17927"],
    "ITextBoxTextChangingEventArgs2": ["c0723d44-53a6-415f-a981-50dfaf1becbe"],
    "ITextChangedEventArgs": ["4dd04f7d-7a11-4b2e-9933-577df39252b6"],
    "ITextChangedEventHandler": ["8eb35b97-ad87-40e8-818b-77db24759566"],
    "ITextCharacterFormat": ["5adef3db-05fb-442d-8065-642afea02ced"],
    "ITextChildProvider": ["1133c336-a89b-4130-9be6-55e33334f557", "4c2de2b9-c88f-4f88-a111-f1d336b7d1a9"],
    "ITextCollection": ["187bdcab-6a6c-41e3-a3f6-2f0eb01aac3d"],
    "ITextCommandBarFlyout": ["90384f66-cd3d-5325-8f40-59b076463c40"],
    "ITextCommandBarFlyoutFactory": ["1b5918d8-b006-5ecd-ab72-6fdb48abc1f4"],
    "ITextCompositionChangedEventArgs": ["b9c7e0f2-50b7-441d-990c-68553e2e056b"],
    "ITextCompositionEndedEventArgs": ["46e34db2-77c0-4015-8eb4-92eefdfc5914"],
    "ITextCompositionStartedEventArgs": ["df22abb2-10cf-491e-91e8-d3cd72d8a0d3"],
    "ITextConstantsStatics": ["779e7c33-189d-4bfa-97c8-10db135d976e"],
    "ITextControlCopyingToClipboardEventArgs": ["e405ef19-d0df-43da-ace6-16f9113868c3"],
    "ITextControlCuttingToClipboardEventArgs": ["5f894995-a58d-4cf3-b589-b5e500e06475"],
    "ITextControlPasteEventArgs": ["4bd1d625-221a-477e-bb2c-ad0c1ed125e7"],
    "ITextControlPasteEventHandler": ["d56db359-6f77-4296-ab9c-794939444365"],
    "ITextConversionGenerator": ["03606a5e-2aa9-4ab6-af8b-a562b63a8992"],
    "ITextConversionGeneratorFactory": ["fcaa3781-3083-49ab-be15-56dfbbb74d6f"],
    "ITextDiagnostics": ["2ffe274b-fe65-4337-827b-d5664b4c8e64"],
    "ITextDisplays": ["c241f5f2-7206-11d8-a2c7-00a0d1d6c6b3"],
    "ITextDocument": ["8cc497c0-a1df-11ce-8098-00aa0047be5d", "beee4ddb-90b2-408c-a2f6-0a0ac31e33e4"],
    "ITextDocument2": ["c241f5e0-7206-11d8-a2c7-00a0d1d6c6b3", "f2311112-8c89-49c9-9118-f057cbb814ee"],
    "ITextDocument2Old": ["01c25500-4268-11d1-883a-3c8b00c10000"],
    "ITextDocument3": ["75ab03a1-a6f8-441d-aa18-0a851d6e5e3c"],
    "ITextDocument4": ["619c20f2-cb3b-4521-981f-2865b1b93f04"],
    "ITextEditProvider": ["ea3605b4-3a05-400e-b5f9-4e91b40f6176"],
    "ITextElement": ["e83b0062-d776-4f92-baea-40e77d4791d5"],
    "ITextElement2": ["a8076aa8-f892-49f6-8cd2-89addaf06d2d"],
    "ITextElement3": ["d1db340f-1bc4-4ca8-bcf7-770bff9b27ab"],
    "ITextElement4": ["b196e222-ca0e-48a9-83bc-36ce50566ac7"],
    "ITextElement5": ["bd9552f3-540d-58bf-b6a8-07556aeda2ea"],
    "ITextElementFactory": ["35007285-cf47-4bfe-b1bc-39c93af4ae80"],
    "ITextElementOverrides": ["0ce21ee7-4f76-4dd9-bf91-163beccf84bc"],
    "ITextElementStatics": ["0a2f9b98-6c03-4470-a79b-3298a10482ce"],
    "ITextElementStatics2": ["164297b2-982b-49e1-8c03-ca43bc4d5b6d"],
    "ITextElementStatics3": ["cfefcfaf-0fa1-45ec-9a4e-9b33664dc8b1"],
    "ITextElementStatics4": ["fd8f641e-6b12-40d5-b6ef-d1bd12ac9066"],
    "ITextFont": ["8cc497c3-a1df-11ce-8098-00aa0047be5d"],
    "ITextFont2": ["c241f5e3-7206-11d8-a2c7-00a0d1d6c6b3"],
    "ITextHighlighter": ["ba6cb54b-7d75-4535-b30d-a81a00b637a4"],
    "ITextHighlighterBase": ["d957601a-5f0d-4cdf-9758-97e0eb95c8fa"],
    "ITextHighlighterBaseFactory": ["9592b2d0-eadc-4c74-92c8-6e896e22506d"],
    "ITextHighlighterFactory": ["70125461-9a8f-4fa0-b235-8ffaa507bef2"],
    "ITextHighlighterStatics": ["b3b009c4-3a7e-49cc-ab84-29c405488765"],
    "ITextHost": ["c5bdd8d0-d26e-11ce-a89e-00aa006cadc5"],
    "ITextHost2": ["13e670f5-1a5a-11cf-abeb-00aa00b65ea1"],
    "ITextHostEx": ["13e670f6-1a5a-11cf-abeb-00aa00b65ea1"],
    "ITextInputHostInfoProvider": ["c5b9c4f0-4906-4a75-a1db-edcf89a57cb7"],
    "ITextInputPanel": ["6b6a65a5-6af3-46c2-b6ea-56cd1f80df71"],
    "ITextInputPanelEventSink": ["27560408-8e64-4fe1-804e-421201584b31"],
    "ITextInputPanelRunInfo": ["9f424568-1920-48cc-9811-a993cbf5adba"],
    "ITextInputSupport": ["b8e0c04e-5bfc-4065-b424-80901c24cd6e"],
    "ITextMarkContainer": ["6bda2cdc-d9b3-4310-8fcb-5690308c2e7c"],
    "ITextMsgFilter": ["a3787420-4267-11d1-883a-3c8b00c10000"],
    "ITextPara": ["8cc497c4-a1df-11ce-8098-00aa0047be5d"],
    "ITextPara2": ["c241f5e4-7206-11d8-a2c7-00a0d1d6c6b3"],
    "ITextParagraphFormat": ["2cf8cfa6-4676-498a-93f5-bbdbfc0bd883"],
    "ITextPhoneme": ["9362a40a-9b7a-4569-94cf-d84f2f38cf9b"],
    "ITextPointer": ["ac687aa1-6a41-43ff-851e-45348aa2cf7b"],
    "ITextPredictionGenerator": ["5eacab07-abf1-4cb6-9d9e-326f2b468756"],
    "ITextPredictionGenerator2": ["b84723b8-2c77-486a-900a-a3453eedc15d"],
    "ITextPredictionGeneratorFactory": ["7257b416-8ba2-4751-9d30-9d85435653a2"],
    "ITextProvider": ["3589c92c-63f3-4367-99bb-ada653b77cf2", "db5bbc9f-4807-4f2a-8678-1b13f3c60e22"],
    "ITextProvider2": ["0dc5e6ed-3e16-4bf1-8f9a-a979878bc195", "df1d48bc-0487-4e7f-9d5e-f09e77e41246"],
    "ITextRange": ["5b9e4e57-c072-42a0-8945-af503ee54768", "8cc497c2-a1df-11ce-8098-00aa0047be5d"],
    "ITextRange2": ["c241f5e2-7206-11d8-a2c7-00a0d1d6c6b3"],
    "ITextRangeProvider": ["0274688d-06e9-4f66-9446-28a5be98fbd0", "5347ad7b-c355-46f8-aff5-909033582f63"],
    "ITextRangeProvider2": ["9bbce42c-1921-4f18-89ca-dba1910a0386", "d3be3dfb-9f54-4642-a7a5-5c18d5ee2a3f"],
    "ITextReverseConversionGenerator": ["51e7f514-9c51-4d86-ae1b-b498fbad8313"],
    "ITextReverseConversionGenerator2": ["1aafd2ec-85d6-46fd-828a-3a4830fa6e18"],
    "ITextReverseConversionGeneratorFactory": ["63bed326-1fda-41f6-89d5-23ddea3c729a"],
    "ITextRow": ["c241f5ef-7206-11d8-a2c7-00a0d1d6c6b3"],
    "ITextSelection": ["8cc497c1-a1df-11ce-8098-00aa0047be5d", "a6d36724-f28f-430a-b2cf-c343671ec0e9"],
    "ITextSelection2": ["c241f5e1-7206-11d8-a2c7-00a0d1d6c6b3"],
    "ITextServices": ["8d33f740-cf58-11ce-a89d-00aa006cadc5"],
    "ITextServices2": ["8d33f741-cf58-11ce-a89d-00aa006cadc5"],
    "ITextServices3": ["19dae8db-ddc7-4130-833f-e6abbb8101fc"],
    "ITextStoreACP": ["28888fe3-c2a0-483a-a3ea-8cb1ce51ff3d"],
    "ITextStoreACP2": ["f86ad89f-5fe4-4b8d-bb9f-ef3797a84f1f"],
    "ITextStoreACPEx": ["a2de3bc2-3d8e-11d3-81a9-f753fbe61a00"],
    "ITextStoreACPServices": ["aa80e901-2021-11d2-93e0-0060b067b86e"],
    "ITextStoreACPSink": ["22d44c94-a419-4542-a272-ae26093ececf"],
    "ITextStoreACPSinkEx": ["2bdf9464-41e2-43e3-950c-a6865ba25cd4"],
    "ITextStoreAnchor": ["9b2077b0-5f18-4dec-bee9-3cc722f5dfe0"],
    "ITextStoreAnchorEx": ["a2de3bc1-3d8e-11d3-81a9-f753fbe61a00"],
    "ITextStoreAnchorServices": ["aa80e9fe-2021-11d2-93e0-0060b067b86e"],
    "ITextStoreAnchorSink": ["aa80e905-2021-11d2-93e0-0060b067b86e"],
    "ITextStoreSinkAnchorEx": ["25642426-028d-4474-977b-111bb114fe3e"],
    "ITextStory": ["befd4473-9af6-4dbb-8d9e-1ea551cbb26e", "c241f5f3-7206-11d8-a2c7-00a0d1d6c6b3"],
    "ITextStoryRanges": ["8cc497c5-a1df-11ce-8098-00aa0047be5d"],
    "ITextStoryRanges2": ["c241f5e5-7206-11d8-a2c7-00a0d1d6c6b3"],
    "ITextStrings": ["c241f5e7-7206-11d8-a2c7-00a0d1d6c6b3"],
    "ITextTypeAheadResult": ["bcc6d6e8-7c46-47bd-90fe-ef28b703d1b4"],
    "ITfActiveLanguageProfileNotifySink": ["b246cb75-a93e-4652-bf8c-b3fe0cfd7e57"],
    "ITfCandidateList": ["a3ad50fb-9bdb-49e3-a843-6c76520fbf5d"],
    "ITfCandidateListUIElement": ["ea1ea138-19df-11d7-a6d2-00065b84435c"],
    "ITfCandidateListUIElementBehavior": ["85fad185-58ce-497a-9460-355366b64b9a"],
    "ITfCandidateString": ["581f317e-fd9d-443f-b972-ed00467c5d40"],
    "ITfCategoryMgr": ["c3acefb5-f69d-4905-938f-fcadcf4be830"],
    "ITfCleanupContextDurationSink": ["45c35144-154e-4797-bed8-d33ae7bf8794"],
    "ITfCleanupContextSink": ["01689689-7acb-4e9b-ab7c-7ea46b12b522"],
    "ITfClientId": ["d60a7b49-1b9f-4be2-b702-47e9dc05dec3"],
    "ITfCompartment": ["bb08f7a9-607a-4384-8623-056892b64371"],
    "ITfCompartmentEventSink": ["743abd5f-f26d-48df-8cc5-238492419b64"],
    "ITfCompartmentEx": ["8107db30-334b-4500-a66f-ec6d6f4118fa"],
    "ITfCompartmentMgr": ["7dcf57ac-18ad-438b-824d-979bffb74b7c"],
    "ITfComposition": ["20168d64-5a8f-4a5a-b7bd-cfa29f4d0fd9"],
    "ITfCompositionSink": ["a781718c-579a-4b15-a280-32b8577acc5e"],
    "ITfCompositionView": ["d7540241-f9a1-4364-befc-dbcd2c4395b7"],
    "ITfConfigureSystemKeystrokeFeed": ["0d2c969a-bc9c-437c-84ee-951c49b1a764"],
    "ITfContext": ["aa80e7fd-2021-11d2-93e0-0060b067b86e"],
    "ITfContextComposition": ["d40c8aae-ac92-4fc7-9a11-0ee0e23aa39b"],
    "ITfContextKeyEventSink": ["0552ba5d-c835-4934-bf50-846aaa67432f"],
    "ITfContextOwner": ["aa80e80c-2021-11d2-93e0-0060b067b86e"],
    "ITfContextOwnerCompositionServices": ["86462810-593b-4916-9764-19c08e9ce110"],
    "ITfContextOwnerCompositionSink": ["5f20aa40-b57a-4f34-96ab-3576f377cc79"],
    "ITfContextOwnerServices": ["b23eb630-3e1c-11d3-a745-0050040ab407"],
    "ITfContextRenderingMarkup": ["a305b1c0-c776-4523-bda0-7c5a2e0fef10"],
    "ITfContextView": ["2433bf8e-0f9b-435c-ba2c-180611978c30"],
    "ITfContext_P": ["2dee47c8-704d-42a0-9983-ffeed659b64d"],
    "ITfConversionCandidate": ["5fa019be-9bd8-45ba-98d5-97cb6bbc6240"],
    "ITfConversionCandidateChunk": ["8ec177bc-eaf1-45fb-a169-c3307f93528a"],
    "ITfCreatePropertyStore": ["2463fbf0-b0af-11d2-afc5-00105a2799b5"],
    "ITfDisplayAttributeCollectionMgr": ["4e3d2d48-3c17-457d-84a1-f209476de897"],
    "ITfDisplayAttributeCollectionProvider": ["3977526d-1a0a-435a-8d06-ecc9516b484f"],
    "ITfDisplayAttributeInfo": ["70528852-2f26-4aea-8c96-215150578932"],
    "ITfDisplayAttributeMgr": ["8ded7393-5db1-475c-9e71-a39111b0ff67"],
    "ITfDisplayAttributeNotifySink": ["ad56f402-e162-4f25-908f-7d577cf9bda9"],
    "ITfDisplayAttributeProvider": ["fee47777-163c-4769-996a-6e9c50ad8f54"],
    "ITfDocumentMgr": ["aa80e7f4-2021-11d2-93e0-0060b067b86e"],
    "ITfEditRecord": ["42d4d099-7c1a-4a89-b836-6c6f22160df0"],
    "ITfEditSession": ["aa80e803-2021-11d2-93e0-0060b067b86e"],
    "ITfEditTransactionSink": ["708fbf70-b520-416b-b06c-2c41ab44f8ba"],
    "ITfEnableService": ["3035d250-43b4-4253-81e6-ea87fd3eed43"],
    "ITfFnAbort": ["17f2317f-addb-49df-870e-66227bc51d1a"],
    "ITfFnAdviseText": ["3527268b-7d53-4dd9-92b7-7296ae461249"],
    "ITfFnBalloon": ["3bab89e4-5fbe-45f4-a5bc-dca36ad225a8"],
    "ITfFnConfigure": ["88f567c6-1757-49f8-a1b2-89234c1eeff9"],
    "ITfFnConfigureRegisterEudc": ["b5e26ff5-d7ad-4304-913f-21a2ed95a1b0"],
    "ITfFnConfigureRegisterWord": ["bb95808a-6d8f-4bca-8400-5390b586aedf"],
    "ITfFnConversionCandidateProvider": ["19370497-c8a3-4db8-a8c8-502b9a7598b3"],
    "ITfFnCustomSpeechCommand": ["fca6c349-a12f-43a3-8dd6-5a5a4282577b"],
    "ITfFnGetLinguisticAlternates": ["ea163ce2-7a65-4506-82a3-c528215da64e"],
    "ITfFnGetPreferredTouchKeyboardLayout": ["5f309a41-590a-4acc-a97f-d8efff13fdfc"],
    "ITfFnGetSAPIObject": ["5c0ab7ea-167d-4f59-bfb5-4693755e90ca"],
    "ITfFnLMInternal": ["04b825b1-ac9a-4f7b-b5ad-c7168f1ee445"],
    "ITfFnLMProcessor": ["7afbf8e7-ac4b-4082-b058-890899d3a010"],
    "ITfFnLangProfileUtil": ["a87a8574-a6c1-4e15-99f0-3d3965f548eb"],
    "ITfFnPlayBack": ["a3a416a4-0f64-11d3-b5b7-00c04fc324a1"],
    "ITfFnPropertyUIStatus": ["2338ac6e-2b9d-44c0-a75e-ee64f256b3bd"],
    "ITfFnReconversion": ["4cea93c0-0a58-11d3-8df0-00105a2799b5"],
    "ITfFnSearchCandidateProvider": ["87a2ad8f-f27b-4920-8501-67602280175d"],
    "ITfFnShowHelp": ["5ab1d30c-094d-4c29-8ea5-0bf59be87bf3"],
    "ITfFnSoftKbd": ["e7342d48-573f-4f22-9181-41938b2529c2"],
    "ITfFunction": ["db593490-098f-11d3-8df0-00105a2799b5"],
    "ITfFunctionProvider": ["101d6610-0990-11d3-8df0-00105a2799b5"],
    "ITfGetConversionCandidateParam": ["75f93444-4138-4139-96ff-4de5df586634"],
    "ITfGetNextWordCandidateParam": ["259d3bb8-af08-4ceb-8930-796f422fcfd5"],
    "ITfGetPhrasedConversionCandidateParam": ["76da453b-4fb4-4dcb-92d4-e292183842b7"],
    "ITfInputProcessorProfileActivationSink": ["71c6e74e-0f28-11d8-a82a-00065b84435c"],
    "ITfInputProcessorProfileMgr": ["71c6e74c-0f28-11d8-a82a-00065b84435c"],
    "ITfInputProcessorProfileSubstituteLayout": ["4fd67194-1002-4513-bff2-c0ddf6258552"],
    "ITfInputProcessorProfiles": ["1f02b6c5-7842-4ee6-8a0b-9a24183a95ca"],
    "ITfInputProcessorProfilesEx": ["892f230f-fe00-4a41-a98e-fcd6de0d35ef"],
    "ITfInputScope2": ["5731eaa0-6bc2-4681-a532-92fbb74d7c41"],
    "ITfInsertAtSelection": ["55ce16ba-3014-41c1-9ceb-fade1446ac6c"],
    "ITfIntegratableCandidateListUIElement": ["c7a6f54f-b180-416f-b2bf-7bf2e4683d7b"],
    "ITfKeyEventSink": ["aa80e7f5-2021-11d2-93e0-0060b067b86e"],
    "ITfKeyTraceEventSink": ["1cd4c13b-1c36-4191-a70a-7f3e611f367d"],
    "ITfKeystrokeMgr": ["aa80e7f0-2021-11d2-93e0-0060b067b86e"],
    "ITfKeystrokeMgr_P": ["53fa1bec-5be1-458e-ae70-a9f1dc843e81"],
    "ITfLMLattice": ["d4236675-a5bf-4570-9d42-5d6d7b02d59b"],
    "ITfLangBarEventSink": ["18a4e900-e0ae-11d2-afdd-00105a2799b5"],
    "ITfLangBarItem": ["73540d69-edeb-4ee9-96c9-23aa30b25916"],
    "ITfLangBarItemBalloon": ["01c2d285-d3c7-4b7b-b5b5-d97411d0c283"],
    "ITfLangBarItemBitmap": ["73830352-d722-4179-ada5-f045c98df355"],
    "ITfLangBarItemBitmapButton": ["a26a0525-3fae-4fa0-89ee-88a964f9f1b5"],
    "ITfLangBarItemButton": ["28c7f1d0-de25-11d2-afdd-00105a2799b5"],
    "ITfLangBarItemMgr": ["ba468c55-9956-4fb1-a59d-52a7dd7cc6aa"],
    "ITfLangBarItemSink": ["57dbe1a0-de25-11d2-afdd-00105a2799b5"],
    "ITfLangBarMgr": ["87955690-e627-11d2-8ddb-00105a2799b5"],
    "ITfLanguageProfileNotifySink": ["43c9fe15-f494-4c17-9de2-b8a4ac350aa8"],
    "ITfMSAAControl": ["b5f8fb3b-393f-4f7c-84cb-504924c2705a"],
    "ITfMenu": ["6f8a98e4-aaa0-4f15-8c5b-07e0df0a3dd8"],
    "ITfMessagePump": ["8f1b8ad8-0b6b-4874-90c5-bd76011e8f7c"],
    "ITfMouseSink": ["a1adaaa2-3a24-449d-ac96-5183e7f5c217"],
    "ITfMouseTracker": ["09d146cd-a544-4132-925b-7afa8ef322d0"],
    "ITfMouseTrackerACP": ["3bdd78e2-c16e-47fd-b883-ce6facc1a208"],
    "ITfMouseTrackerAnchor": ["f9f4e0f2-d600-4a4c-b144-77e201ebd1b0"],
    "ITfPersistentPropertyLoaderACP": ["4ef89150-0807-11d3-8df0-00105a2799b5"],
    "ITfPersistentPropertyLoaderAnchor": ["2133f790-34c2-11d3-a745-0050040ab407"],
    "ITfPreservedKeyNotifySink": ["6f77c993-d2b1-446e-853e-5912efc8a286"],
    "ITfProperty": ["e2449660-9542-11d2-bf46-00105a2799b5"],
    "ITfProperty2": ["db261faa-2142-486a-b5c6-d2101bc03d2e"],
    "ITfPropertyStore": ["6834b120-88cb-11d2-bf45-00105a2799b5"],
    "ITfQueryEmbedded": ["0fab9bdb-d250-4169-84e5-6be118fdd7a8"],
    "ITfRange": ["aa80e7ff-2021-11d2-93e0-0060b067b86e"],
    "ITfRangeACP": ["057a6296-029b-4154-b79a-0d461d4ea94c"],
    "ITfRangeAnchor": ["8b99712b-5815-4bcc-b9a9-53db1c8d6755"],
    "ITfRangeBackup": ["463a506d-6992-49d2-9b88-93d55e70bb16"],
    "ITfRangeChangeSink": ["c1a0e6af-0d60-4800-9796-1fe8e85c0cca"],
    "ITfReadOnlyProperty": ["17d49a3d-f8b8-4b2f-b254-52319dd64c53"],
    "ITfReadingInformationUIElement": ["ea1ea139-19df-11d7-a6d2-00065b84435c"],
    "ITfReverseConversion": ["a415e162-157d-417d-8a8c-0ab26c7d2781"],
    "ITfReverseConversionList": ["151d69f0-86f4-4674-b721-56911e797f47"],
    "ITfReverseConversionMgr": ["b643c236-c493-41b6-abb3-692412775cc4"],
    "ITfServiceCandidate": ["f2436e43-7144-4493-830c-bf7983fb57a6"],
    "ITfServiceCandidateChunk": ["6439b4cd-d778-4fe3-8c2f-cdcb60e4a076"],
    "ITfSoftKbdRegistry": ["f5f31f14-fdf0-4d29-835a-46adfe743b78"],
    "ITfSource": ["4ea48a35-60ae-446f-8fd6-e6a8d82459f7"],
    "ITfSourceSingle": ["73131f9c-56a9-49dd-b0ee-d046633f7528"],
    "ITfStartReconversionNotifySink": ["b9cd19cb-2919-4935-8768-ef30bae9a0cc"],
    "ITfStatusSink": ["6b7d8d73-b267-4f69-b32e-1ca321ce4f45"],
    "ITfSysHookSink": ["495388da-21a5-4852-8bb1-ed2f29da8d60"],
    "ITfSystemDeviceTypeLangBarItem": ["45672eb9-9059-46a2-838d-4530355f6a77"],
    "ITfSystemLangBarItem": ["1e13e9ec-6b33-4d4a-b5eb-8a92f029f356"],
    "ITfSystemLangBarItemSink": ["1449d9ab-13cf-4687-aa3e-8d8b18574396"],
    "ITfSystemLangBarItemText": ["5c4ce0e5-ba49-4b52-ac6b-3b397b4f701f"],
    "ITfTextEditSink": ["8127d409-ccd3-4683-967a-b43d5b482bf7"],
    "ITfTextInputProcessor": ["aa80e7f7-2021-11d2-93e0-0060b067b86e"],
    "ITfTextInputProcessorEx": ["6e4e2102-f9cd-433d-b496-303ce03a6507"],
    "ITfTextLayoutSink": ["2af2d06a-dd5b-4927-a0b4-54f19c91fade"],
    "ITfThreadFocusSink": ["c0f1db0c-3a20-405c-a303-96b6010a885f"],
    "ITfThreadMgr": ["aa80e801-2021-11d2-93e0-0060b067b86e"],
    "ITfThreadMgr2": ["0ab198ef-6477-4ee8-8812-6780edb82d5e"],
    "ITfThreadMgrEventSink": ["aa80e80e-2021-11d2-93e0-0060b067b86e"],
    "ITfThreadMgrEx": ["3e90ade3-7594-4cb0-bb58-69628f5f458c"],
    "ITfThreadMgr_P": ["7c6247a1-2884-4b7c-af24-f198047aa728"],
    "ITfThreadMgr_P_old": ["f65567a7-34a1-46f4-b5dd-8804aeb06ff7"],
    "ITfToolTipUIElement": ["52b18b5c-555d-46b2-b00a-fa680144fbdb"],
    "ITfTransitoryExtensionSink": ["a615096f-1c57-4813-8a15-55ee6e5a839c"],
    "ITfTransitoryExtensionUI": ["85277bd3-869f-11d9-b6e4-0050f2e42769"],
    "ITfTransitoryExtensionUIElement": ["858f956a-972f-42a2-a2f2-0321e1abe209"],
    "ITfTransitoryExtensionUIEntry": ["cb39a9e0-c886-4cb7-876e-c4175484d924"],
    "ITfTransitoryExtensionUIHost": ["85277bd2-869f-11d9-b6e4-0050f2e42769"],
    "ITfUIElement": ["ea1ea137-19df-11d7-a6d2-00065b84435c"],
    "ITfUIElementMgr": ["ea1ea135-19df-11d7-a6d2-00065b84435c"],
    "ITfUIElementSink": ["ea1ea136-19df-11d7-a6d2-00065b84435c"],
    "IThemeShadow": ["3eccad09-7985-5f39-8b62-6c10696dca6f"],
    "IThemeShadowFactory": ["2e71465d-0f67-590e-831b-7e5e2a32b778"],
    "IThicknessHelper": ["a86bae4b-1e8f-4eeb-9013-0b2838a97b34"],
    "IThicknessHelperStatics": ["c0991a7c-070c-4da6-8784-01ca800eb73a"],
    "IThreadAffineStorageQueryServer": ["7bf2957b-68e4-4528-915a-7ab28983dd46"],
    "IThreadNetworkContext": ["fa4ea8e9-ef13-405a-b12c-d7348c6f41fc"],
    "IThreadNeutralCallback": ["ece8a01c-eb42-40ee-9f89-16adb3c000ef"],
    "IThreadPoolStatics": ["b6bf67dd-84bd-44f8-ac1c-93ebcb9dba91"],
    "IThreadPoolTimer": ["594ebe78-55ea-4a88-a50d-3402ae1f9cf2"],
    "IThreadPoolTimerStatics": ["1a8a9d02-e482-461b-b8c7-8efad1cce590"],
    "IThreadUndoManager": ["9c4960d4-7626-4e13-beec-1adad82ff5a0"],
    "IThumbAutomationPeer": ["dc2949b5-b45e-4d6d-892f-d9422c950efb"],
    "IThumbAutomationPeerFactory": ["970743ff-af41-4600-b55d-26d43df860e1"],
    "IThumbStatics": ["955024eb-36f3-4672-a186-baaf626ac4ad"],
    "IThumbnailCache": ["f676c15d-596a-4ce2-8234-33996f445db1"],
    "IThumbnailCachePrimer": ["0f03f8fe-2b26-46f0-965a-212aa8d66b76"],
    "IThumbnailHandlerFactory": ["e35b4b2e-00da-4bc1-9f13-38bc11f5d417"],
    "IThumbnailProperties": ["693dd42f-dbe7-49b5-b3b3-2893ac5d3423"],
    "IThumbnailProvider": ["e357fccd-a995-4576-b01f-234630154e96"],
    "IThumbnailSettings": ["f4376f00-bef5-4d45-80f3-1e023bbf1209"],
    "IThumbnailStreamCache": ["90e11430-9569-41d8-ae75-6d4d2ae7cca0"],
    "IThumbnailView": ["7bb0b520-b1a7-11d2-bb23-00c04f79abcd"],
    "ITickBar": ["994683fa-f1f6-487d-a5ac-c15921bfa995"],
    "ITickBarStatics": ["2c6d7e40-799d-4a54-be09-1fefc61d018e"],
    "ITileActivatedInfo": ["80e4a3b1-3980-4f17-b738-89194e0b8f65"],
    "ITileBrush": ["c201cf06-cd84-48a5-9607-664d7361cd61"],
    "ITileBrushFactory": ["aa159f7c-ed6a-4fb3-b014-b5c7e379a4de"],
    "ITileBrushStatics": ["3497c25b-b562-4e68-8435-2399f6eb94d5"],
    "ITileChangeEvent": ["9234b3a2-4825-4dcb-9623-87d4cf66c22c"],
    "ITileEventHandler": ["e328384c-7402-49e7-8b70-31e3fea59b77"],
    "ITileFlyoutNotification": ["9a53b261-c70c-42be-b2f3-f42aa97d34e5"],
    "ITileFlyoutNotificationFactory": ["ef556ff5-5226-4f2b-b278-88a35dfe569f"],
    "ITileFlyoutUpdateManagerStatics": ["04363b0b-1ac0-4b99-88e7-ada83e953d48"],
    "ITileFlyoutUpdater": ["8d40c76a-c465-4052-a740-5c2654c1a089"],
    "ITileInViewChangeEvent": ["c720fc22-be39-40a0-9e7c-737d4cf82088"],
    "ITileInfo": ["d499ceb2-0297-46ec-a841-3b57a7591669"],
    "ITileInfo2": ["66b7d702-1591-4c2e-adfc-5997d695119f"],
    "ITileInfo3": ["cad877a0-e209-43f4-867f-e7a6f69b5183"],
    "ITileInfoCache": ["e0cae81b-625e-400d-9ded-4e4956f6fb9d"],
    "ITileInfoChangeId": ["abcb8bd7-3f8f-40d6-b4cd-6945f7751168"],
    "ITileInfoEnumerator": ["091e0351-fa3d-4a61-9ff2-f0cb048c081b"],
    "ITileInfoManagement": ["c2fbb7b6-49ef-4805-bfe7-b72f707bf66e"],
    "ITileInfoManagement2": ["69115693-ec46-4ac3-9e77-e264ac06a147"],
    "ITileInfoPlaceholder": ["0f3fa22f-901b-4b2e-a9b0-d231802d2326"],
    "ITileInfoRefCount": ["15b70eca-f6aa-4817-93c6-955a2f7e06cf"],
    "ITileManager": ["bd3e41ca-2e87-47a8-8ec0-6f0fe76752ac"],
    "ITileManager2": ["8bf51a6b-abf5-4a9c-b3c1-292fd2e2ce14"],
    "ITileManager3": ["a4d5762a-2132-470e-9f26-3c564daa97b6"],
    "ITileManagerRefCount": ["6d931756-46bf-442e-b8d6-587c028f35e9"],
    "ITileMixedRealityModel": ["b0764e5b-887d-4242-9a19-3d0a4ea78031"],
    "ITileMixedRealityModel2": ["439470b2-d7c5-410b-8319-9486a27b6c67"],
    "ITileNotification": ["ebaec8fa-50ec-4c18-b4d0-3af02e5540ab"],
    "ITileNotificationEvent": ["4065c34a-d7b4-4a55-b989-f1d9f812435b"],
    "ITileNotificationFactory": ["c6abdd6e-4928-46c8-bdbf-81a047dea0d4"],
    "ITileNotificationImagePayload": ["0b6156f9-5b67-4228-8587-ba9d5fb0ec31"],
    "ITileNotificationTextPayload": ["e3c0c163-e7c1-4604-ab39-f2c84a1c3aef"],
    "ITileNotificationsDetails": ["b4a88bdf-896a-4d8c-81b5-f1faf38f2833"],
    "ITilePropertyEnumerator": ["6cf261ba-4050-4a45-a5f0-1a04d290dc6f"],
    "ITilePropertyInfo": ["c29a1c05-ab19-4f67-8b28-c590bd633df9"],
    "ITileUpdateManagerForUser": ["55141348-2ee2-4e2d-9cc1-216a20decc9f"],
    "ITileUpdateManagerStatics": ["da159e5d-3ea9-4986-8d84-b09d5e12276d"],
    "ITileUpdateManagerStatics2": ["731c1ddc-8e14-4b7c-a34b-9d22de76c84d"],
    "ITileUpdater": ["0942a48b-1d91-44ec-9243-c1e821c29a20"],
    "ITileUpdater2": ["a2266e12-15ee-43ed-83f5-65b352bb1a84"],
    "ITileViewInfoEnumerator": ["343ac6da-0acf-4825-916d-dea091bb9449"],
    "ITileViewInformation": ["bb23efff-c14f-49e2-bb0b-e03cd796245d"],
    "ITileViewInformationCached": ["7a91de90-a194-4d5c-8468-3f53143b5563"],
    "ITimePickedEventArgs": ["8ad3ff21-5f66-4785-b999-24fef39fb6db"],
    "ITimePicker": ["e39099f2-3aff-4792-909e-2d9941ec0357"],
    "ITimePicker2": ["0ff0798c-f922-419f-8b3d-23ee7586d48e"],
    "ITimePicker3": ["fa6e4f91-ac32-59a4-94da-8b3d64289ed6"],
    "ITimePickerAutomationPeer": ["a43d44ef-3285-4df7-b4a4-e4cdf36a3a17"],
    "ITimePickerAutomationPeerFactory": ["978f6671-47f8-40a7-9e21-68128b16b4fd"],
    "ITimePickerFactory": ["553fe413-6cd7-46a9-a97b-a18bdc4b4ca3"],
    "ITimePickerFlyout": ["bb739d75-e836-439e-86d5-506d2d18e404"],
    "ITimePickerFlyoutPresenter": ["c5320638-7a18-40ed-9fd0-4c852c09b24e"],
    "ITimePickerFlyoutPresenter2": ["a13b5b68-7ee9-59f7-aad6-6532a8a8c3bf"],
    "ITimePickerFlyoutPresenterAutomationPeer": ["da93ee27-82f1-4701-8706-be297bf06043"],
    "ITimePickerFlyoutPresenterStatics2": ["aa5f0ddc-f2bb-53f2-a54d-b34acccf51e4"],
    "ITimePickerFlyoutStatics": ["3f6728ce-2169-4003-b4a8-8de7035a0ad6"],
    "ITimePickerSelectedValueChangedEventArgs": ["6e20fb35-3b9b-5bb6-9888-266524db181e"],
    "ITimePickerStatics": ["fa71dfb1-233e-4f31-b8be-a6ea670c25cd"],
    "ITimePickerStatics2": ["36d8abcd-4e10-451a-b93b-1a731ea7ee3f"],
    "ITimePickerStatics3": ["cfef1763-ba87-54d8-82d4-7c6b9734dc9d"],
    "ITimePickerValueChangedEventArgs": ["2f4edb8d-b995-4e31-8ba9-c4dcdeb21ca3"],
    "ITimeTrigger": ["656e5556-0b2a-4377-ba70-3b45a935547f", "b45747e0-eba7-4276-9f29-85c5bb300006"],
    "ITimeTriggerFactory": ["38c682fe-9b54-45e6-b2f3-269b87a6f734"],
    "ITimeZoneOnCalendar": ["bb3c25e5-46cf-4317-a3f5-02621ad54478"],
    "ITimeZoneSettingsStatics": ["9b3b2bea-a101-41ae-9fbd-028728bab73d"],
    "ITimeZoneSettingsStatics2": ["555c0db8-39a8-49fa-b4f6-a2c7fc2842ec"],
    "ITimedMetadataEncodingProperties": ["51cd30d3-d690-4cfa-97f4-4a398e9db420"],
    "ITimedMetadataEncodingPropertiesStatics": ["6629bb67-6e55-5643-89a0-7a7e8d85b52c"],
    "ITimedMetadataPresentationModeChangedEventArgs": ["d1636099-65df-45ae-8cef-dc0b53fdc2bb"],
    "ITimedMetadataStreamDescriptor": ["133336bf-296a-463e-9ff9-01cd25691408"],
    "ITimedMetadataStreamDescriptorFactory": ["c027de30-7362-4ff9-98b1-2dfd0b8d1cae"],
    "ITimedMetadataTrack": ["9e6aed9e-f67a-49a9-b330-cf03b0e9cf07"],
    "ITimedMetadataTrack2": ["21b4b648-9f9d-40ba-a8f3-1a92753aef0b"],
    "ITimedMetadataTrackError": ["b3767915-4114-4819-b9d9-dd76089e72f8"],
    "ITimedMetadataTrackFactory": ["8dd57611-97b3-4e1f-852c-0f482c81ad26"],
    "ITimedMetadataTrackFailedEventArgs": ["a57fc9d1-6789-4d4d-b07f-84b4f31acb70"],
    "ITimedMetadataTrackProvider": ["3b7f2024-f74e-4ade-93c5-219da05b6856"],
    "ITimedTextCue": ["51c79e51-3b86-494d-b359-bb2ea7aca9a9"],
    "ITimedTextLine": ["978d7ce2-7308-4c66-be50-65777289f5df"],
    "ITimedTextRegion": ["1ed0881f-8a06-4222-9f59-b21bf40124b4"],
    "ITimedTextSource": ["c4ed9ba6-101f-404d-a949-82f33fcd93b7"],
    "ITimedTextSourceResolveResultEventArgs": ["48907c9c-dcd8-4c33-9ad3-6cdce7b1c566"],
    "ITimedTextSourceStatics": ["7e311853-9aba-4ac4-bb98-2fb176c3bfdd"],
    "ITimedTextSourceStatics2": ["b66b7602-923e-43fa-9633-587075812db5"],
    "ITimedTextStyle": ["1bb2384d-a825-40c2-a7f5-281eaedf3b55"],
    "ITimedTextStyle2": ["655f492d-6111-4787-89cc-686fece57e14"],
    "ITimedTextSubformat": ["d713502f-3261-4722-a0c2-b937b2390f14"],
    "ITimeline": ["0bc465dc-be4d-4d0d-9549-2208b715f40d"],
    "ITimelineFactory": ["1d56bb07-bda4-478b-8ada-eb04d580cd5e"],
    "ITimelineMarker": ["a68ef02d-45ba-4e50-8cad-aaea3a227af5"],
    "ITimelineMarkerRoutedEventArgs": ["7c3b3ef3-2c88-4d9c-99b6-46cdbd48d4c1"],
    "ITimelineMarkerRoutedEventHandler": ["72e2fa9c-6dea-4cbe-a159-06ce95fbeced"],
    "ITimelineMarkerStatics": ["c4aef0c6-16a3-484b-87f5-6528b8f04a47"],
    "ITimelinePropertiesChangedEventArgs": ["29033a2f-c923-5a77-bcaf-055ff415ad32"],
    "ITimelineStatics": ["a902ed4e-ef10-4d6f-9a40-93cb8895f4e5"],
    "ITimerDestroyedHandler": ["34ed19fa-8384-4eb9-8209-fb5094eeec35"],
    "ITimerElapsedHandler": ["faaea667-fbeb-49cb-adb2-71184c556e43"],
    "ITimerEx": ["30510414-98b5-11cf-bb82-00aa00bdce0b"],
    "ITipAutoCompleteClient": ["5e078e03-8265-4bbe-9487-d242edbef910"],
    "ITipAutoCompleteProvider": ["7c6cf46d-8404-46b9-ad33-f5b6036d4007"],
    "ITipHelper": ["17cf72d1-bac5-11d1-b1bf-00c04fc2f3ef"],
    "ITipPullSink": ["17cf72d2-bac5-11d1-b1bf-00c04fc2f3ef"],
    "ITipTransaction": ["17cf72d0-bac5-11d1-b1bf-00c04fc2f3ef"],
    "ITitleBarAppearanceBroker": ["8eee72cd-6f62-4d1e-94cc-83ed6655a735"],
    "IToastActivatedEventArgs": ["e3bf92f3-c197-436f-8265-0625824f8dac"],
    "IToastActivatedEventArgs2": ["ab7da512-cc61-568e-81be-304ac31038fa"],
    "IToastApplicationActivator": ["b0aa121d-721c-4a8b-8af9-5ef0f5e421f7"],
    "IToastApplicationActivator2": ["ef4a3c0a-6c87-4053-b4ae-37ec3653a260"],
    "IToastCollection": ["0a8bc3b0-e0be-4858-bc2a-89dfe0b32863"],
    "IToastCollectionFactory": ["164dd3d7-73c4-44f7-b4ff-fb6d4bf1f4c6"],
    "IToastCollectionManager": ["2a1821fe-179d-49bc-b79d-a527920d3665"],
    "IToastDismissedEventArgs": ["3f89d935-d9cb-4538-a0f0-ffe7659938f8"],
    "IToastFailedEventArgs": ["35176862-cfd4-44f8-ad64-f500fd896c3b"],
    "IToastInfo": ["625524de-9e88-42ce-974c-39cbf4020a6f"],
    "IToastInfoEnumerator": ["f58d2e8a-49d5-40d3-8f9c-776e1ebaa622"],
    "IToastNotification": ["997e2675-059e-4e60-8b06-1760917c8b80"],
    "IToastNotification2": ["9dfb9fd1-143a-490e-90bf-b9fba7132de7"],
    "IToastNotification3": ["31e8aed8-8141-4f99-bc0a-c4ed21297d77"],
    "IToastNotification4": ["15154935-28ea-4727-88e9-c58680e2d118"],
    "IToastNotification6": ["43ebfe53-89ae-5c1e-a279-3aecfe9b6f54"],
    "IToastNotificationActionTriggerDetail": ["9445135a-38f3-42f6-96aa-7955b0f03da2"],
    "IToastNotificationActionTriggerFactory": ["b09dfc27-6480-4349-8125-97b3efaa0a3a"],
    "IToastNotificationActivatedEventArgs": ["92a86f82-5290-431d-be85-c4aaeeb8685f"],
    "IToastNotificationEvent": ["4065c34a-d7b4-4a55-b989-f1d9f81243cb"],
    "IToastNotificationFactory": ["04124b20-82c6-4229-b109-fd9ed4662b53"],
    "IToastNotificationHistory": ["5caddc63-01d3-4c97-986f-0533483fee14"],
    "IToastNotificationHistory2": ["3bc3d253-2f31-4092-9129-8ad5abf067da"],
    "IToastNotificationHistoryChangedTriggerDetail": ["db037ffa-0068-412c-9c83-267c37f65670"],
    "IToastNotificationHistoryChangedTriggerDetail2": ["0b36e982-c871-49fb-babb-25bdbc4cc45b"],
    "IToastNotificationHistoryChangedTriggerFactory": ["81c6faad-8797-4785-81b4-b0cccb73d1d9"],
    "IToastNotificationManagerForUser": ["79ab57f6-43fe-487b-8a7f-99567200ae94"],
    "IToastNotificationManagerForUser2": ["679c64b7-81ab-42c2-8819-c958767753f4"],
    "IToastNotificationManagerStatics": ["50ac103f-d235-4598-bbef-98fe4d1a3ad4"],
    "IToastNotificationManagerStatics2": ["7ab93c52-0e48-4750-ba9d-1a4113981847"],
    "IToastNotificationManagerStatics3": ["2717f54b-50df-4455-8e6e-41e0fc8e13ce"],
    "IToastNotificationManagerStatics4": ["8f993fd3-e516-45fb-8130-398e93fa52c3"],
    "IToastNotificationManagerStatics5": ["d6f5f569-d40d-407c-8989-88cab42cfd14"],
    "IToastNotificationsDetails": ["379ea103-532e-4d05-895c-b4471e06c88b"],
    "IToastNotifier": ["75927b93-03f3-41ec-91d3-6e5bac1b38e7"],
    "IToastNotifier2": ["354389c6-7c01-4bd5-9c20-604340cd2b74"],
    "IToastNotifier3": ["ae75a04a-3b0c-51ad-b7e8-b08ab6052549"],
    "IToastPresentationSink": ["613cbb47-5a68-4f4d-ac41-c7ac753b59f5"],
    "IToastPropertyEnumerator": ["586db4b8-9a63-4010-81c7-979f3e742929"],
    "IToastPropertyInfo": ["f81f7f25-f0d8-4820-8bbe-6a3e04cdee5b"],
    "IToc": ["d6f05441-a919-423b-91a0-89d5b4a8ab77"],
    "ITocCollection": ["23fee831-ae96-42df-b170-25a04847a3ca"],
    "ITocEntry": ["f22f5e06-585c-4def-8523-6555cfbc0cb3"],
    "ITocEntryList": ["3a8cccbd-0efd-43a3-b838-f38a552ba237"],
    "ITocParser": ["ecfb9a55-9298-4f49-887f-0b36206599d2"],
    "IToggleButton": ["589877fb-0fc7-4036-9d8b-127dfa75c16d"],
    "IToggleButtonAutomationPeer": ["62dbe6c5-bc0a-45bb-bf77-ea0f1502891f"],
    "IToggleButtonAutomationPeerFactory": ["c9218cc4-ad4b-4d03-a6a4-7d59e6360004"],
    "IToggleButtonFactory": ["d56aa2fc-fc7f-449c-9855-7a1055d668a8"],
    "IToggleButtonOverrides": ["d20e4c28-f18b-491a-9a45-f1a04a9369a4"],
    "IToggleButtonStatics": ["af1eab12-0128-4f67-9c5a-82320c445d19"],
    "IToggleMenuFlyoutItem": ["49841edd-88e9-4663-a701-cd4fd25e398f"],
    "IToggleMenuFlyoutItemAutomationPeer": ["6b57eafe-6af1-4903-8373-3437bf352345"],
    "IToggleMenuFlyoutItemAutomationPeerFactory": ["94364b77-8f6c-4837-aae3-94d010d8d162"],
    "IToggleMenuFlyoutItemFactory": ["a151966f-3bf7-46b6-b61c-9b2c1ba68843"],
    "IToggleMenuFlyoutItemStatics": ["16c724fb-6c1a-4852-9258-08c038367907"],
    "ITogglePatternIdentifiers": ["7e191f6b-34d4-4ae7-83ac-29f88882d985"],
    "ITogglePatternIdentifiersStatics": ["c7f75544-14a5-4f2f-92fc-760524de06ea"],
    "IToggleProvider": ["56d00bd0-c4f4-433c-a836-1a52a57e0892", "93b88290-656f-44f7-aeaf-78b8f944d062"],
    "IToggleSplitButton": ["28981b31-8e78-570c-bebb-685814485ae9"],
    "IToggleSplitButtonAutomationPeer": ["538e61de-7d46-5da7-94ab-acede6a12b9e"],
    "IToggleSplitButtonAutomationPeerFactory": ["9829b0a0-5a30-5eed-a3a3-1472c53b0a66"],
    "IToggleSplitButtonFactory": ["3fcf073b-e57c-573d-af38-d1b2ad387951"],
    "IToggleSplitButtonIsCheckedChangedEventArgs": ["2138f0cf-5fcd-5dbb-99ae-359483070f6b"],
    "IToggleSwitch": ["331d8f00-c5f9-46a5-b6c8-ede539304567"],
    "IToggleSwitchAutomationPeer": ["c011f174-e89e-4790-bf9a-78ebb5f59e9f"],
    "IToggleSwitchAutomationPeerFactory": ["31f933e3-fef8-4419-9df5-d9ef7196ea34"],
    "IToggleSwitchOverrides": ["bfd07f53-f8ca-4e47-949e-9e80429b3d16"],
    "IToggleSwitchStatics": ["1d37147f-97df-4226-92ca-ddf453d7fd5a"],
    "IToggleSwitchTemplateSettings": ["02b7bdcd-628a-4363-86e0-51d6e2e89e58"],
    "ITokenBrokerMessageBroker": ["fdee13ad-356f-4aee-8927-5e388b2a8ff4"],
    "ITokenBrokerMessageBrokerFactory": ["620780ad-22d5-4214-b81e-7d23ea8bc251"],
    "ITokenBrokerResultValue": ["b5732e8e-97a6-4a33-bd3d-75ca0727af15"],
    "ITokenCollection": ["22d8b4f2-f577-4adb-a335-c2ae88416fab"],
    "IToolTip": ["7de5d75f-4415-429f-b523-699bdb8c30db"],
    "IToolTip2": ["2b1ade26-299a-5d54-800b-3bea123b4c20"],
    "IToolTipFactory": ["89839403-b538-49e3-a430-3ac037dc6fe0"],
    "IToolTipService": ["03a55f87-bfcc-4a1e-8fea-98f610832cea"],
    "IToolTipServiceStatics": ["86e649f8-e245-48aa-a8c8-d1073ed76319"],
    "IToolTipStatics": ["f00285b8-4ba9-4f4f-86a7-86003813ceb3"],
    "IToolTipStatics2": ["6845e646-9c7f-5011-8a78-7da9d87eb3b6"],
    "IToolTipTemplateSettings": ["d4388247-0ec4-4506-affd-afac2225b48c"],
    "IToolbarEvents": ["66833fe5-8583-11d1-b16a-00c0f0283628"],
    "ITopViewAwareItem": ["8279feb8-5ca4-45c4-be27-770dcdea1deb"],
    "ITopViewDescription": ["fe812157-522c-46cb-8d53-6efe3dce2c46"],
    "ITorchControl": ["a6053665-8250-416c-919a-724296afa306"],
    "ITouchCapabilities": ["20dd55f9-13f1-46c8-9285-2c05fa3eda6f"],
    "ITouchHitTestingEventArgs": ["22f3b823-0b7c-424e-9df7-33d4f962931b"],
    "ITouchKeyboardExperienceManager": ["9516d866-ca0f-40ca-8997-efa618b50f99"],
    "ITpmVirtualSmartCardManager": ["112b1dff-d9dc-41f7-869f-d67fee7cb591"],
    "ITpmVirtualSmartCardManager2": ["fdf8a2b9-02de-47f4-bc26-aa85ab5e5267"],
    "ITpmVirtualSmartCardManager3": ["3c745a97-f375-4150-be17-5950f694c699"],
    "ITpmVirtualSmartCardManagerStatusCallback": ["1a1bb35f-abb8-451c-a1ae-33d98f1bef4a"],
    "ITraceDataCollector": ["0383750b-098b-11d8-9414-505054503030"],
    "ITraceDataProvider": ["03837512-098b-11d8-9414-505054503030"],
    "ITraceDataProviderCollection": ["03837510-098b-11d8-9414-505054503030"],
    "ITraceEvent": ["8cc97f40-9028-4ff3-9b62-7d1f79ca7bcb"],
    "ITraceEventCallback": ["3ed25501-593f-43e9-8f38-3ab46f5a4a52"],
    "ITraceRelogger": ["f754ad43-3bcc-4286-8009-9c5da214e84e"],
    "ITracingStatusChangedEventArgs": ["410b7711-ff3b-477f-9c9a-d2efda302dc3"],
    "ITrackEvents": ["f002a70d-e74b-4721-9243-5704338cfc2f"],
    "ITrackSelection": ["6d5140c5-7436-11ce-8034-00aa006009fa"],
    "ITrackShellMenu": ["8278f932-2a3e-11d2-838f-00c04fd918d0"],
    "ITrackerJS9": ["a731980e-7d1e-4652-8432-ad2b3bc0ea44"],
    "ITrackerOwner": ["eb24c20b-9816-4ac7-8cff-36f67a118f4e"],
    "ITrackingMoniker": ["00000321-0000-0000-c000-000000000046"],
    "ITrackingProtection": ["30510803-98b5-11cf-bb82-00aa00bdce0b"],
    "ITransProtocolSink": ["7291765a-a83f-401d-81a6-112c3a468a7b"],
    "ITransactionData": ["79eac9cf-baf9-11ce-8c82-00aa004ba90b"],
    "ITransactionDataXSS": ["4e4c93db-9ea7-417c-9c7e-a22a3c9b6b0d"],
    "ITransactionEnlistmentAsync": ["0fb15081-af41-11ce-bd2b-204c4f4f5020"],
    "ITransactionExport": ["0141fda5-8fc0-11ce-bd18-204c4f4f5020"],
    "ITransactionExportFactory": ["e1cf9b53-8745-11ce-a9ba-00aa006c3706"],
    "ITransactionImport": ["e1cf9b5a-8745-11ce-a9ba-00aa006c3706"],
    "ITransactionImportWhereabouts": ["0141fda4-8fc0-11ce-bd18-204c4f4f5020"],
    "ITransactionInternal": ["c28722e5-bc1a-4c55-a68d-33219f698910"],
    "ITransactionJoin": ["0c733a5e-2a1c-11ce-ade5-00aa0044773d"],
    "ITransactionLastEnlistmentAsync": ["c82bd533-5b30-11d3-8a91-00c04f79eb6d"],
    "ITransactionLastResourceAsync": ["c82bd532-5b30-11d3-8a91-00c04f79eb6d"],
    "ITransactionLocal": ["0c733a5f-2a1c-11ce-ade5-00aa0044773d"],
    "ITransactionObject": ["0c733a60-2a1c-11ce-ade5-00aa0044773d"],
    "ITransactionPhase0EnlistmentAsync": ["82dc88e1-a954-11d1-8f88-00600895e7d5"],
    "ITransactionPhase0Factory": ["82dc88e0-a954-11d1-8f88-00600895e7d5"],
    "ITransactionPhase0NotifyAsync": ["ef081809-0c76-11d2-87a6-00c04f990f34"],
    "ITransactionProperty2": ["acf84c81-9f6c-47d5-9b45-4bd6b02bcecf"],
    "ITransactionProxy": ["02558374-df2e-4dae-bd6b-1d5c994f9bdc"],
    "ITransactionReceiver": ["59313e03-b36c-11cf-a539-00aa006887c3"],
    "ITransactionReceiverFactory": ["59313e02-b36c-11cf-a539-00aa006887c3"],
    "ITransactionResourceAsync": ["69e971f0-23ce-11cf-ad60-00aa00a74ccd"],
    "ITransactionTransmitter": ["59313e01-b36c-11cf-a539-00aa006887c3"],
    "ITransactionTransmitterFactory": ["59313e00-b36c-11cf-a539-00aa006887c3"],
    "ITransactionVoterBallotAsync2": ["5433376c-414d-11d3-b206-00c04fc2f3ef"],
    "ITransactionVoterFactory2": ["5433376a-414d-11d3-b206-00c04fc2f3ef"],
    "ITransactionVoterNotifyAsync2": ["5433376b-414d-11d3-b206-00c04fc2f3ef"],
    "ITranscodeImage": ["bae86ddd-dc11-421c-b7ab-cc55d1d65c44"],
    "ITransferAdviseSink": ["d594d0d8-8da7-457b-b3b4-ce5dbaac0b88"],
    "ITransferConfirmation": ["14cc750c-7b0b-43dc-910e-b687f84e7c3b"],
    "ITransferDestination": ["48addd32-3ca5-4124-abe3-b5a72531b207"],
    "ITransferHelper": ["42339a50-7a91-44f9-87ac-37e6ec1b1a88"],
    "ITransferMediumItem": ["77f295d5-2d6f-4e19-b8ae-322f3e721ab5"],
    "ITransferProvider": ["b1c59f87-f6be-4771-ba95-ba09f9f709ad"],
    "ITransferSource": ["00adb003-bde9-45c6-8e29-d09f9353e108"],
    "ITransferSource2": ["d6b78e20-b98a-49fa-ae7e-2ba7fce522f5"],
    "ITransform": ["4df74078-bfd6-4ed1-9682-d2fd8bf2fe6f"],
    "ITransform3D": ["ae3ed43a-a9fc-4c31-86cd-56d9ca251a69"],
    "ITransform3DFactory": ["052c1f7a-8d73-48cd-bbb8-d00434caae5d"],
    "ITransformFactory": ["1a955a66-7cf4-4320-b416-6181192fcc6d"],
    "ITransformGroup": ["63418ccc-8d2d-4737-b951-2afce1ddc4c4"],
    "ITransformGroupStatics": ["25312f2a-cfab-4b24-9713-5bdead1929c0"],
    "ITransformPattern2Identifiers": ["08aaa03d-dea7-402f-8097-9a2783d60e5d"],
    "ITransformPattern2IdentifiersStatics": ["78963644-11f0-467c-a72b-5dac41c1f6fe"],
    "ITransformPatternIdentifiers": ["e4115b8c-c3c8-4a37-b994-2709a7811665"],
    "ITransformPatternIdentifiersStatics": ["4570edab-d705-40c4-a1dc-e9acfcef85f6"],
    "ITransformProvider": ["6829ddc4-4f91-4ffa-b86f-bd3e2987cb4c", "79670fdd-f6a9-4a65-af17-861db799a2da"],
    "ITransformProvider2": ["4758742f-7ac2-460c-bc48-09fc09308a93", "a8b11756-a39f-4e97-8c7d-c1ea8dd633c5"],
    "ITransientNotificationDetails": ["bebf1b6f-4d08-4e3e-9902-a256a285c970"],
    "ITransition": ["3c677c7c-01d0-4dce-b333-976f93312b08"],
    "ITransitionFactory": ["dc9ab2cf-3bc9-44aa-b3fc-883a83233a2c"],
    "ITranslateTransform": ["c975905c-3c36-4229-817b-178f64c0e113"],
    "ITranslateTransformStatics": ["f419aa91-e042-4111-9c2f-d201304123dd"],
    "ITransportParameters": ["eb0c4e24-2283-438d-8fff-dbe9df1cb2cc"],
    "ITransportParametersUpdateHandler": ["16fd02d5-da61-49d7-aab2-76867dd42db7"],
    "ITransportSettingsInternal": ["5123e076-29e3-4bfd-84fe-0192d411e3e8"],
    "ITravelEntry2": ["ed4f9add-3cc4-46b7-a416-2ff54d7156bb"],
    "ITravelLog2": ["0a46d8e2-2072-4aed-8509-badb844e51f6"],
    "ITravelLogClientDocPriv": ["bc876e52-7dc2-440e-87a8-3c1221f10c92"],
    "ITravelLogClientPriv": ["cef3b021-5ab5-465e-9d62-0e97a2e30d3b"],
    "ITravelLogClientWrapper": ["0ad364ce-adcb-11d3-8269-00805fc732c0"],
    "ITravelLogRecoveryData": ["5f59b0c4-f563-41f3-b7cb-02ca36c4dbc6"],
    "ITravelLogUI": ["92549fb6-2504-4018-83c5-0a950df000f2"],
    "ITrayDeskBand": ["6d67e846-5b9c-4db8-9cbc-dde12f4254f1"],
    "ITrayNotify": ["d133ce13-3537-48ba-93a7-afcd5d2053b4"],
    "ITreeView": ["9353cc5c-dd6e-453c-aedd-0c3ac993978b", "c74190b4-8589-11d1-b16a-00c0f0283628"],
    "ITreeView2": ["4f33a2e6-2f29-55d3-a1ab-1f4a863bf960"],
    "ITreeViewCollapsedEventArgs": ["391db3b0-1e58-4539-9e93-387978f46cce"],
    "ITreeViewCollapsedEventArgs2": ["747b2f4f-7b25-56aa-8300-78d83b7ab2db"],
    "ITreeViewDragItemsCompletedEventArgs": ["3ca8632c-4311-574e-8ab4-3b7aa5de7a88"],
    "ITreeViewDragItemsStartingEventArgs": ["7bdb7ec4-e125-5773-9a3f-6695233d6250"],
    "ITreeViewEvents": ["c74190b5-8589-11d1-b16a-00c0f0283628"],
    "ITreeViewExpandingEventArgs": ["c5e1fa63-4154-49d2-a21f-c34176605e3a"],
    "ITreeViewExpandingEventArgs2": ["a12f54c3-87b9-5623-9c74-e6dd443cde18"],
    "ITreeViewFactory": ["cc5267c3-6c69-49ce-b445-753acee7948b"],
    "ITreeViewItem": ["4e05d3e6-6167-44e7-9c74-291ddd6df6eb"],
    "ITreeViewItem2": ["007baf7f-0493-51b4-879c-458024b34149"],
    "ITreeViewItemAutomationPeer": ["2331d648-b617-437f-920c-71d450503e65"],
    "ITreeViewItemAutomationPeerFactory": ["73d388bf-1d01-4159-82c0-2b2996dbfdce"],
    "ITreeViewItemFactory": ["4ea32731-568d-4d0d-adfd-3d8dc5aa5d88"],
    "ITreeViewItemInvokedEventArgs": ["472ab521-0242-4290-9363-ab4fe704527f"],
    "ITreeViewItemStatics": ["436795be-7396-46dc-a264-21c56581c5e5"],
    "ITreeViewItemStatics2": ["a8af82f3-d803-5c25-b48d-ae0e73b16d8e"],
    "ITreeViewItemTemplateSettings": ["ec323744-de31-4936-bfc2-1cb37ba1dc08"],
    "ITreeViewItemTemplateSettingsFactory": ["11a1953b-31b7-4f40-8633-02fc614b518c"],
    "ITreeViewItemTemplateSettingsStatics": ["55c720a8-70ed-4c21-93f4-2d79c1a4a5f7"],
    "ITreeViewList": ["0f00a54e-099a-47a5-a942-94692b01f452"],
    "ITreeViewListAutomationPeer": ["71c1b5bc-bb29-4479-a8a8-606be6b823ae"],
    "ITreeViewListAutomationPeerFactory": ["00f597e2-f811-475a-bfe6-290fe707fa88"],
    "ITreeViewListFactory": ["288f6232-41d2-46f7-b1f5-691c625264b7"],
    "ITreeViewNode": ["c04c8ed3-9af2-4e75-a329-7497a110e7a8"],
    "ITreeViewNodeFactory": ["6ec62d90-aa19-414a-8a45-0a5589a836f7"],
    "ITreeViewNodeStatics": ["5d8276fe-e1d1-4b61-9e81-c7fb189a2980"],
    "ITreeViewStatics": ["ef913e08-83f2-4e16-bfb1-1577b98355f5"],
    "ITreeViewStatics2": ["16b1c8f9-7aa1-5e38-8218-7bba3ea417c0"],
    "ITridentConsentRequest": ["30510851-98b5-11cf-bb82-00aa00bdce0b"],
    "ITridentFilter": ["b0a6c398-978f-4a61-b42f-746f2719ecd9"],
    "ITridentPrivateDebugAPI": ["3d75c45f-b457-42bc-9ce8-34d4df6cb2a8"],
    "ITridentService2": ["f62d9369-75ef-4578-8856-232802c76468"],
    "ITridentService3": ["620cc4c4-c9c6-11da-95af-00e08161165f"],
    "ITridentService4": ["b40761ac-1eda-4d86-9a5c-5669e95e939f"],
    "ITridentService5": ["eae049e0-2668-4ed7-9df6-029c094ae154"],
    "ITridentTouchInput": ["30510850-98b5-11cf-bb82-00aa00bdce0b"],
    "ITridentTouchInputSite": ["30510849-98b5-11cf-bb82-00aa00bdce0b"],
    "ITrigger": ["09941815-ea89-4b5b-89e0-2a773801fac3"],
    "ITriggerAction": ["a2c0df02-63d5-4b46-9b83-0868d3079621"],
    "ITriggerActionFactory": ["68d2c0b9-3289-414f-8f6e-c6b97aedda03"],
    "ITriggerBase": ["e7ea222f-dee6-4393-a8b2-8923d641f395"],
    "ITriggerBaseFactory": ["6a3b9e57-fc5d-42d0-8cb9-ca50667af746"],
    "ITriggerCollection": ["85df5081-1b24-4f32-878a-d9d14df4cb77"],
    "ITriggeredConnectionStateChangedEventArgs": ["c6a780ad-f6e1-4d54-96e2-33f620bca88a"],
    "ITrustState": ["6ac11fdb-c797-47d9-92d8-a6b796d3b42d"],
    "ITrustedSignalsEnrollmentHandler": ["b9bbf500-16b5-4612-8c7d-6fd4893321a2"],
    "ITrusteeAdmin": ["0c733aa1-2a1c-11ce-ade5-00aa0044773d"],
    "ITrusteeGroupAdmin": ["0c733aa2-2a1c-11ce-ade5-00aa0044773d"],
    "ITryHarderFactory": ["7d39402f-5b52-4b34-b528-b95f66927e1d"],
    "ITryHarderItem": ["5e8a79a2-8188-41cd-962b-9c74e3c5d20c"],
    "ITryHarderItemFactory": ["c9653430-dcca-4345-bd1b-78a1f7505203"],
    "ITsSbBaseNotifySink": ["808a6537-1282-4989-9e09-f43938b71722"],
    "ITsSbClientConnection": ["18857499-ad61-4b1b-b7df-cbcd41fb8338"],
    "ITsSbClientConnectionPropertySet": ["e51995b0-46d6-11dd-aa21-cedc55d89593"],
    "ITsSbEnvironment": ["8c87f7f7-bf51-4a5c-87bf-8e94fb6e2256"],
    "ITsSbEnvironmentPropertySet": ["d0d1bf7e-7acf-11dd-a243-e51156d89593"],
    "ITsSbFilterPluginStore": ["85b44b0f-ed78-413f-9702-fa6d3b5ee755"],
    "ITsSbGenericNotifySink": ["4c4c8c4f-300b-46ad-9164-8468a7e7568c"],
    "ITsSbGlobalStore": ["9ab60f7b-bd72-4d9f-8a3a-a0ea5574e635"],
    "ITsSbLoadBalanceResult": ["24fdb7ac-fea6-11dc-9672-9a8956d89593"],
    "ITsSbLoadBalancing": ["24329274-9eb7-11dc-ae98-f2b456d89593"],
    "ITsSbLoadBalancingNotifySink": ["5f8a8297-3244-4e6a-958a-27c822c1e141"],
    "ITsSbOrchestration": ["64fc1172-9eb7-11dc-8b00-3aba56d89593"],
    "ITsSbOrchestrationNotifySink": ["36c37d61-926b-442f-bca5-118c6d50dcf2"],
    "ITsSbPlacement": ["daadee5f-6d32-480e-9e36-ddab2329f06d"],
    "ITsSbPlacementNotifySink": ["68a0c487-2b4f-46c2-94a1-6ce685183634"],
    "ITsSbPlugin": ["48cd7406-caab-465f-a5d6-baa863b9ea4f"],
    "ITsSbPluginNotifySink": ["44dfe30b-c3be-40f5-bf82-7a95bb795adf"],
    "ITsSbPluginPropertySet": ["95006e34-7eff-4b6c-bb40-49a4fda7cea6"],
    "ITsSbPropertySet": ["5c025171-bb1e-4baf-a212-6d5e9774b33b"],
    "ITsSbProvider": ["87a4098f-6d7b-44dd-bc17-8ce44e370d52"],
    "ITsSbProvisioning": ["2f6f0dbb-9e4f-462b-9c3f-fccc3dcb6232"],
    "ITsSbProvisioningPluginNotifySink": ["aca87a8e-818b-4581-a032-49c3dfb9c701"],
    "ITsSbResourceNotification": ["65d3e85a-c39b-11dc-b92d-3cd255d89593"],
    "ITsSbResourceNotificationEx": ["a8a47fde-ca91-44d2-b897-3aa28a43b2b7"],
    "ITsSbResourcePlugin": ["ea8db42c-98ed-4535-a88b-2a164f35490f"],
    "ITsSbResourcePluginStore": ["5c38f65f-bcf1-4036-a6bf-9e3cccae0b63"],
    "ITsSbServiceNotification": ["86cb68ae-86e0-4f57-8a64-bb7406bc5550"],
    "ITsSbSession": ["d453aac7-b1d8-4c5e-ba34-9afb4c8c5510"],
    "ITsSbTarget": ["16616ecc-272d-411d-b324-126893033856"],
    "ITsSbTargetPropertySet": ["f7bda5d6-994c-4e11-a079-2763b61830ac"],
    "ITsSbTaskInfo": ["523d1083-89be-48dd-99ea-04e82ffa7265"],
    "ITsSbTaskPlugin": ["fa22ef0f-8705-41be-93bc-44bdbcf1c9c4"],
    "ITsSbTaskPluginNotifySink": ["6aaf899e-c2ec-45ee-aa37-45e60895261a"],
    "ITsfCandidateList": ["5f80c8ba-9345-4c10-ad72-1361d02e137a"],
    "ITsfCandidateListEventSink": ["79b6cb08-a878-4ddd-bbcd-eba440e8e40b"],
    "ITsfCommandList": ["f37c232b-8fa0-4266-97e3-8e3328dd559d"],
    "ITsfDocument": ["04275d85-49f9-41e4-bd67-a251301faa15"],
    "ITsfDocumentEventSink": ["fbfa2389-1e19-4edb-90c8-9c1f85b62fee"],
    "ITsfEventSource": ["c3a0b2d3-eb9d-42ff-a7ff-f85ed899f6f5"],
    "ITsfInputProviderContext": ["e9c7c82b-b693-40bf-a853-b77e7406c7b2"],
    "ITsfInputProviderContextEventSink": ["c291dd0f-bdd2-4610-920d-54f0518fd9ba"],
    "ITsfRange": ["48ddc685-e434-43ec-a24f-c651c67e99d9"],
    "ITsfServices": ["b7143315-4f17-4eff-bd8b-99f8d7feece6"],
    "ITuneRequest": ["07ddc146-fc3d-11d2-9d8c-00c04f72d980"],
    "ITuneRequestInfo": ["a3b152df-7a90-4218-ac54-9830bee8c0b6"],
    "ITuneRequestInfoEx": ["ee957c52-b0d0-4e78-8dd1-b87a08bfd893"],
    "ITuner": ["28c52640-018a-11d3-9d8e-00c04f72d980"],
    "ITunerCap": ["e60dfa45-8d56-4e65-a8ab-d6be9412c249"],
    "ITunerCapEx": ["ed3e0c66-18c8-4ea6-9300-f6841fdd35dc"],
    "ITuningSpace": ["061c6e30-e622-11d2-9493-00c04f72d980"],
    "ITuningSpaceContainer": ["5b692e84-e2f1-11d2-9493-00c04f72d980"],
    "ITuningSpaces": ["901284e4-33fe-4b69-8d63-634a596f3756"],
    "ITwoPaneView": ["1b4d0db5-14ad-5926-bb8a-5b0a5c0085f0"],
    "ITwoPaneViewFactory": ["18ff792d-58b4-59ed-a051-51aceffbcca9"],
    "ITwoPaneViewStatics": ["5a35c389-85c4-55f4-abb1-97451bc32d71"],
    "ITwoPanelHingedDevicePosturePreview": ["72245c31-4b39-42a6-8e73-7235ade16853"],
    "ITwoPanelHingedDevicePosturePreviewReading": ["a0251452-4ad6-4b38-8426-c59a15493a7d"],
    "ITwoPanelHingedDevicePosturePreviewReadingChangedEventArgs": ["2d2d1bc6-02ce-474a-a556-a75b1cf93a03"],
    "ITwoPanelHingedDevicePosturePreviewStatics": ["0c4733d2-57e0-4180-bd5e-f31a2138423e"],
    "ITxProxyHolder": ["13d86f31-0139-41af-bcad-c7d50435fe9f"],
    "ITypeAheadProvider": ["fc412e64-434d-4a1c-b401-f524ef039c42"],
    "ITypeAheadProviderEventSink": ["342ecf84-d6d8-4eb5-9283-91a59d8a01f8"],
    "ITypeAheadSearchHistoryProvider": ["9a739bcb-8b06-4a94-9547-9afb9515554e"],
    "ITypeAheadSearchSettingsCallback": ["b9b1b058-e35b-4390-8b55-7d9e01ddc509"],
    "ITypeLibRegistration": ["76a3e735-02df-4a12-98eb-043ad3600af3"],
    "ITypeLibRegistrationReader": ["ed6a8a2a-b160-4e77-8f73-aa7435cd5c27"],
    "ITypeLibResolver": ["8f026edb-785e-4470-a8e1-b4e84e9d1779"],
    "ITypeName": ["b81ff171-20f3-11d2-8dcc-00a0c9b00522"],
    "ITypeNameBuilder": ["b81ff171-20f3-11d2-8dcc-00a0c9b00523"],
    "ITypeNameFactory": ["b81ff171-20f3-11d2-8dcc-00a0c9b00521"],
    "ITypeToSearch": ["567f0f7d-a499-4461-973f-072cbdda90d6"],
    "ITypeToSearch2": ["db8aec44-c731-49ed-b8ef-c8faf39e46c2"],
    "ITypeToSearchIMESettings": ["884a374d-2338-4a9a-828a-c2f506807418"],
    "ITypeToSearchPriv": ["2c3a00dc-f02b-4500-9a39-cdad9a74d0a5"],
    "ITypeToSearchPriv2": ["f695e830-cede-42ba-820e-7c57a5ac198c"],
    "ITypography": ["866f65d5-ea97-42ab-9288-9c01aebc7a97"],
    "ITypographyStatics": ["67b9ec88-6c57-4ce0-95f1-d4b9ed632fb4"],
    "IUACIndicatorControl": ["b9bc2a50-43c3-41aa-a085-5db14e184bae"],
    "IUAPViewWrapper": ["a52f5b9b-ee55-4add-b559-55f1c012e15f"],
    "IUDFData": ["e768e9b8-8088-4fa2-a454-10b71f049a9b"],
    "IUDFDataCollection": ["473ac99b-af0c-4d30-9b81-4ac9b4e92b95"],
    "IUIAnimationInterpolator": ["7815cbba-ddf7-478c-a46c-7b6c738b7978"],
    "IUIAnimationInterpolator2": ["ea76aff8-ea22-4a23-a0ef-a6a966703518"],
    "IUIAnimationLoopIterationChangeHandler2": ["2d3b15a4-4762-47ab-a030-b23221df3ae0"],
    "IUIAnimationManager": ["9169896c-ac8d-4e7d-94e5-67fa4dc2f2e8"],
    "IUIAnimationManager2": ["d8b6f7d4-4109-4d3f-acee-879926968cb1"],
    "IUIAnimationManagerEventHandler": ["783321ed-78a3-4366-b574-6af607a64788"],
    "IUIAnimationManagerEventHandler2": ["f6e022ba-bff3-42ec-9033-e073f33e83c3"],
    "IUIAnimationPrimitiveInterpolation": ["bab20d63-4361-45da-a24f-ab8508846b5b"],
    "IUIAnimationPriorityComparison": ["83fa9b74-5f86-4618-bc6a-a2fac19b3f44"],
    "IUIAnimationPriorityComparison2": ["5b6d7a37-4621-467c-8b05-70131de62ddb"],
    "IUIAnimationStoryboard": ["a8ff128f-9bf9-4af1-9e67-e5e410defb84"],
    "IUIAnimationStoryboard2": ["ae289cd2-12d4-4945-9419-9e41be034df2"],
    "IUIAnimationStoryboardEventHandler": ["3d5c9008-ec7c-4364-9f8a-9af3c58cbae6"],
    "IUIAnimationStoryboardEventHandler2": ["bac5f55a-ba7c-414c-b599-fbf850f553c6"],
    "IUIAnimationTimer": ["6b0efad1-a053-41d6-9085-33a689144665"],
    "IUIAnimationTimerClientEventHandler": ["bedb4db6-94fa-4bfb-a47f-ef2d9e408c25"],
    "IUIAnimationTimerEventHandler": ["274a7dea-d771-4095-abbd-8df7abd23ce3"],
    "IUIAnimationTimerUpdateHandler": ["195509b7-5d5e-4e3e-b278-ee3759b367ad"],
    "IUIAnimationTransition": ["dc6ce252-f731-41cf-b610-614b6ca049ad"],
    "IUIAnimationTransition2": ["62ff9123-a85a-4e9b-a218-435a93e268fd"],
    "IUIAnimationTransitionFactory": ["fcd91e03-3e3b-45ad-bbb1-6dfc8153743d"],
    "IUIAnimationTransitionFactory2": ["937d4916-c1a6-42d5-88d8-30344d6efe31"],
    "IUIAnimationTransitionLibrary": ["ca5a14b1-d24f-48b8-8fe4-c78169ba954e"],
    "IUIAnimationTransitionLibrary2": ["03cfae53-9580-4ee3-b363-2ece51b4af6a"],
    "IUIAnimationVariable": ["8ceeb155-2849-4ce5-9448-91ff70e1e4d9"],
    "IUIAnimationVariable2": ["4914b304-96ab-44d9-9e77-d5109b7e7466"],
    "IUIAnimationVariableChangeHandler": ["6358b7ba-87d2-42d5-bf71-82e919dd5862"],
    "IUIAnimationVariableChangeHandler2": ["63acc8d2-6eae-4bb0-b879-586dd8cfbe42"],
    "IUIAnimationVariableCurveChangeHandler2": ["72895e91-0145-4c21-9192-5aab40eddf80"],
    "IUIAnimationVariableIntegerChangeHandler": ["bb3e1550-356e-44b0-99da-85ac6017865e"],
    "IUIAnimationVariableIntegerChangeHandler2": ["829b6cf1-4f3a-4412-ae09-b243eb4c6b58"],
    "IUIApplication": ["d428903c-729a-491d-910d-682a08ff2522"],
    "IUIAutomation": ["30cbe57d-d9d0-452a-ab13-7ac5ac4825ee"],
    "IUIAutomation2": ["34723aff-0c9d-49d0-9896-7ab52df8cd8a"],
    "IUIAutomation3": ["73d768da-9b51-4b89-936e-c209290973e7"],
    "IUIAutomation4": ["1189c02a-05f8-4319-8e21-e817e3db2860"],
    "IUIAutomation5": ["25f700c8-d816-4057-a9dc-3cbdee77e256"],
    "IUIAutomation6": ["aae072da-29e3-413d-87a7-192dbf81ed10"],
    "IUIAutomation7": ["29de312e-83c6-4309-8808-e8dfcb46c3c2"],
    "IUIAutomationActiveTextPositionChangedEventHandler": ["f97933b0-8dae-4496-8997-5ba015fe0d82"],
    "IUIAutomationAndCondition": ["a7d0af36-b912-45fe-9855-091ddc174aec"],
    "IUIAutomationAnnotationPattern": ["9a175b21-339e-41b1-8e8b-623f6b681098"],
    "IUIAutomationBlockingCore": ["016f611a-b360-4768-8b28-6779ddfde2e0"],
    "IUIAutomationBoolCondition": ["1b4e1f2e-75eb-4d0b-8952-5a69988e2307"],
    "IUIAutomationCacheRequest": ["b32a92b5-bc25-4078-9c08-d7ee95c48e03"],
    "IUIAutomationChangesEventHandler": ["58edca55-2c3e-4980-b1b9-56c17f27a2a0"],
    "IUIAutomationCondition": ["352ffba8-0973-437c-a61f-f64cafd81df9"],
    "IUIAutomationCrossBitnessHook": ["4ece4541-81d4-44ac-9df6-d199ef66f904"],
    "IUIAutomationCustomNavigationPattern": ["01ea217a-1766-47ed-a6cc-acf492854b1f"],
    "IUIAutomationDockPattern": ["fde5ef97-1464-48f6-90bf-43d0948e86ec"],
    "IUIAutomationDragPattern": ["1dc7b570-1f54-4bad-bcda-d36a722fb7bd"],
    "IUIAutomationDropTargetPattern": ["69a095f7-eee4-430e-a46b-fb73b1ae39a5"],
    "IUIAutomationElement": ["d22108aa-8ac5-49a5-837b-37bbb3d7591e"],
    "IUIAutomationElement2": ["6749c683-f70d-4487-a698-5f79d55290d6"],
    "IUIAutomationElement3": ["8471df34-aee0-4a01-a7de-7db9af12c296"],
    "IUIAutomationElement4": ["3b6e233c-52fb-4063-a4c9-77c075c2a06b"],
    "IUIAutomationElement5": ["98141c1d-0d0e-4175-bbe2-6bff455842a7"],
    "IUIAutomationElement6": ["4780d450-8bca-4977-afa5-a4a517f555e3"],
    "IUIAutomationElement7": ["204e8572-cfc3-4c11-b0c8-7da7420750b7"],
    "IUIAutomationElement8": ["8c60217d-5411-4cde-bcc0-1ceda223830c"],
    "IUIAutomationElement9": ["39325fac-039d-440e-a3a3-5eb81a5cecc3"],
    "IUIAutomationElementArray": ["14314595-b4bc-4055-95f2-58f2e42c9855"],
    "IUIAutomationElementInternal": ["704da7b3-c469-4d5a-9c4b-906ca89315a9"],
    "IUIAutomationElementVisualRelative": ["a572f832-778e-48e6-b358-1537749936f3"],
    "IUIAutomationEventHandler": ["146c3c17-f12e-4e22-8c27-f894b9b79c69"],
    "IUIAutomationEventHandlerGroup": ["c9ee12f2-c13b-4408-997c-639914377f4e"],
    "IUIAutomationEventHandlerGroup2": ["87618ec8-7f72-40e9-ae07-dc00e08f7934"],
    "IUIAutomationExpandCollapsePattern": ["619be086-1f4e-4ee4-bafa-210128738730"],
    "IUIAutomationFocusChangedEventHandler": ["c270f6b5-5c69-4290-9745-7a7f97169468"],
    "IUIAutomationGridItemPattern": ["78f8ef57-66c3-4e09-bd7c-e79b2004894d"],
    "IUIAutomationGridPattern": ["414c3cdc-856b-4f5b-8538-3131c6302550"],
    "IUIAutomationInvokePattern": ["fb377fbe-8ea6-46d5-9c73-6499642d3059"],
    "IUIAutomationItemContainerPattern": ["c690fdb2-27a8-423c-812d-429773c9084e"],
    "IUIAutomationLegacyIAccessiblePattern": ["828055ad-355b-4435-86d5-3b51c14a9b1b"],
    "IUIAutomationMultipleViewPattern": ["8d253c91-1dc5-4bb5-b18f-ade16fa495e8"],
    "IUIAutomationNotCondition": ["f528b657-847b-498c-8896-d52b565407a1"],
    "IUIAutomationNotificationEventHandler": ["c7cb2637-e6c2-4d0c-85de-4948c02175c7"],
    "IUIAutomationObjectModelPattern": ["71c284b3-c14d-4d14-981e-19751b0d756d"],
    "IUIAutomationOrCondition": ["8753f032-3db1-47b5-a1fc-6e34a266c712"],
    "IUIAutomationPatternHandler": ["d97022f3-a947-465e-8b2a-ac4315fa54e8"],
    "IUIAutomationPatternInstance": ["c03a7fe4-9431-409f-bed8-ae7c2299bc8d"],
    "IUIAutomationPropertyChangedEventHandler": ["40cd37d4-c756-4b0c-8c6f-bddfeeb13b50"],
    "IUIAutomationPropertyCondition": ["99ebf2cb-5578-4267-9ad4-afd6ea77e94b"],
    "IUIAutomationProxyFactory": ["85b94ecd-849d-42b6-b94d-d6db23fdf5a4"],
    "IUIAutomationProxyFactoryEntry": ["d50e472e-b64b-490c-bca1-d30696f9f289"],
    "IUIAutomationProxyFactoryMapping": ["09e31e18-872d-4873-93d1-1e541ec133fd"],
    "IUIAutomationRangeValuePattern": ["59213f4f-7346-49e5-b120-80555987a148"],
    "IUIAutomationRegistrar": ["8609c4ec-4a1a-4d88-a357-5a66e060e1cf"],
    "IUIAutomationScrollItemPattern": ["b488300f-d015-4f19-9c29-bb595e3645ef"],
    "IUIAutomationScrollPattern": ["88f4d42a-e881-459d-a77c-73bbbb7e02dc"],
    "IUIAutomationSelectionItemPattern": ["a8efa66a-0fda-421a-9194-38021f3578ea"],
    "IUIAutomationSelectionPattern": ["5ed5202e-b2ac-47a6-b638-4b0bf140d78e"],
    "IUIAutomationSelectionPattern2": ["0532bfae-c011-4e32-a343-6d642d798555"],
    "IUIAutomationSpreadsheetItemPattern": ["7d4fb86c-8d34-40e1-8e83-62c15204e335"],
    "IUIAutomationSpreadsheetPattern": ["7517a7c8-faae-4de9-9f08-29b91e8595c1"],
    "IUIAutomationStructureChangedEventHandler": ["e81d1b4e-11c5-42f8-9754-e7036c79f054"],
    "IUIAutomationStructuredMarkupEmbeddedElementCollection": ["3601892e-a3fc-4697-a3ac-bd5e4b9da10c"],
    "IUIAutomationStructuredMarkupEventHandler": ["b30cedb7-454e-498c-b9d0-dff9fd1e8220"],
    "IUIAutomationStructuredMarkupPattern": ["7c9189bb-72fa-46a0-a0de-ed117ce8bb6d"],
    "IUIAutomationStructuredMarkupRange": ["1dc24bd0-aef2-4ef3-8298-0b83ad8804a9"],
    "IUIAutomationStylesPattern": ["85b5f0a2-bd79-484a-ad2b-388c9838d5fb"],
    "IUIAutomationSynchronizedInputPattern": ["2233be0b-afb7-448b-9fda-3b378aa5eae1"],
    "IUIAutomationTableItemPattern": ["0b964eb3-ef2e-4464-9c79-61d61737a27e"],
    "IUIAutomationTablePattern": ["620e691c-ea96-4710-a850-754b24ce2417"],
    "IUIAutomationTextChildPattern": ["6552b038-ae05-40c8-abfd-aa08352aab86"],
    "IUIAutomationTextEditPattern": ["17e21576-996c-4870-99d9-bff323380c06"],
    "IUIAutomationTextEditTextChangedEventHandler": ["92faa680-e704-4156-931a-e32d5bb38f3f"],
    "IUIAutomationTextPattern": ["32eba289-3583-42c9-9c59-3b6d9a1e9b6a"],
    "IUIAutomationTextPattern2": ["506a921a-fcc9-409f-b23b-37eb74106872"],
    "IUIAutomationTextRange": ["a543cc6a-f4ae-494b-8239-c814481187a8"],
    "IUIAutomationTextRange2": ["bb9b40e0-5e04-46bd-9be0-4b601b9afad4"],
    "IUIAutomationTextRange3": ["6a315d69-5512-4c2e-85f0-53fce6dd4bc2"],
    "IUIAutomationTextRangeArray": ["ce4ae76a-e717-4c98-81ea-47371d028eb6"],
    "IUIAutomationTextRangeVisualRelative": ["df8b3b0e-148e-4ad2-ae14-f809766a6746"],
    "IUIAutomationTextReadingRange": ["21063ad6-ec07-4414-90ad-ea51394bf3d0"],
    "IUIAutomationTogglePattern": ["94cf8058-9b8d-4ab9-8bfd-4cd0a33c8c70"],
    "IUIAutomationTransformPattern": ["a9b55844-a55d-4ef0-926d-569c16ff89bb"],
    "IUIAutomationTransformPattern2": ["6d74d017-6ecb-4381-b38b-3c17a48ff1c2"],
    "IUIAutomationTreeWalker": ["4042c624-389c-4afc-a630-9df854a541fc"],
    "IUIAutomationValuePattern": ["a94cd8b1-0844-4cd6-9d2d-640537ab39e9"],
    "IUIAutomationVirtualizedItemPattern": ["6ba3d7a6-04cf-4f11-8793-a8d1cde9969f"],
    "IUIAutomationWindowPattern": ["0faef453-9208-43ef-bbb2-3b485177864f"],
    "IUICollection": ["df4f45bf-6f9d-4dd7-9d68-d8f9cd18c4db"],
    "IUICollectionChangedEvent": ["6502ae91-a14d-44b5-bbd0-62aacc581d52"],
    "IUICommand": ["4026dfb9-7691-4142-b71c-dcf08ea4dd9c", "4ff93a75-4145-47ff-ac7f-dff1c1fa5b0f"],
    "IUICommand2": ["48f8a5b1-82b4-47a3-8a7a-a097bc5e349d"],
    "IUICommandFactory": ["a21a8189-26b0-4676-ae94-54041bc125e8"],
    "IUICommandHandler": ["75ae0a2d-dc03-4c9f-8883-069660d0beb6"],
    "IUICommandInvokedHandler": ["daf77a4f-c27a-4298-9ac6-2922c45e7da6"],
    "IUIContentRoot": ["1dfcbac6-b36b-5cb9-9bc5-2b7a0eddc378"],
    "IUIContext": ["bb5cfacd-5bd8-59d0-a59e-1c17a4d6d243"],
    "IUIContextualUI": ["eea11f37-7c46-437c-8e55-b52122b29293"],
    "IUIElement": [
        "0a498932-d65c-4e0c-80da-8a2ca8f25320",
        "676d0be9-b65c-41c6-ba40-58cf87f201c1",
        "759d0500-d979-11ce-84ec-00aa00614f3e",
    ],
    "IUIElement10": ["d531c629-ad2c-5f6b-adcf-fb87287d18d7"],
    "IUIElement2": ["676d0bf9-b66c-41d6-ba50-58cf87f201d1"],
    "IUIElement3": ["bc2b28f1-26f2-4aab-b256-3b5350881e37"],
    "IUIElement4": ["69145cd4-199a-4657-9e57-e99e8f136712"],
    "IUIElement5": ["8eed9bc2-a58c-4453-af0f-a92ee06d0317"],
    "IUIElement7": ["cafc4968-6369-4249-80f9-3d656319e811"],
    "IUIElement8": ["3ab70e85-d508-4477-b6f8-0e435701c836"],
    "IUIElement9": ["b4a04776-4e88-50ca-8f2b-08940d6c5f94"],
    "IUIElementCollection": ["d6602d54-88f6-43f6-85d8-a9d914a6dd3b"],
    "IUIElementFactory": ["b9ee93fe-a338-419f-ac32-91dcaadf5d08"],
    "IUIElementOverrides": ["608d2f1d-7858-4aeb-89e4-b54e2c7ed3d3"],
    "IUIElementOverrides7": ["b97f7f68-c29b-4c99-a1c3-952619d6e720"],
    "IUIElementOverrides8": ["4a5a645c-548d-48cf-b998-7844d6e235a1"],
    "IUIElementOverrides9": ["9a6e5973-6d63-54f2-90fa-62813b20b7b9"],
    "IUIElementStatics": ["58d3573b-f52c-45be-988b-a5869564873c"],
    "IUIElementStatics10": ["60d25362-4b3e-53da-8b78-38db94ae8f26"],
    "IUIElementStatics2": ["58d3574b-f53c-45be-989b-a5869564874c"],
    "IUIElementStatics3": ["d1f87ade-eca1-4561-a32b-64601b4e0597"],
    "IUIElementStatics4": ["1d157d61-16af-411f-b774-272375a4ac2c"],
    "IUIElementStatics5": ["59bd7d91-8fa3-4c65-ba1b-40df38556cbb"],
    "IUIElementStatics6": ["647e03b7-036a-4dea-9540-1dd7fd1266f1"],
    "IUIElementStatics7": ["da9b4493-a695-4145-ae93-888024396a0f"],
    "IUIElementStatics8": ["17be3487-4875-4915-b0b1-a4c0f851df3f"],
    "IUIElementStatics9": ["71467e77-8ca3-5ed7-95db-d51cdad77f81"],
    "IUIElementWeakCollection": ["10341223-e66d-519e-acf8-556bd244eac3"],
    "IUIElementWeakCollectionFactory": ["57242561-188a-5304-8792-a43f35d90f99"],
    "IUIEventLogger": ["ec3e1034-dbf4-41a1-95d5-03e0f1026e05"],
    "IUIEventingManager": ["3be6ea7f-9a9b-4198-9368-9b0f923bd534"],
    "IUIFramework": ["f4f0385d-6872-43a8-ad09-4c339cb3f5c5"],
    "IUIGlobalNotify": ["07eca99c-604e-4472-bfee-34936e5af764"],
    "IUIHostLocale": ["2c2ea031-02be-11d1-8c85-00c04fc2aa89"],
    "IUIHostLocale2": ["2c2ea032-02be-11d1-8c85-00c04fc2aa89"],
    "IUIHostLocale3": ["2c2ea033-02be-11d1-8c85-00c04fc2aa89"],
    "IUIImage": ["23c8c838-4de6-436b-ab01-5554bb7c30dd"],
    "IUIImageFromBitmap": ["18aba7f3-4c1c-4ba2-bf6c-f5c3326fa816"],
    "IUIManagerEventSink": ["cd91d690-a7e8-4265-9b38-8bb3bbaba7de"],
    "IUINavigationController": ["e5aeefdd-f50e-4a55-8cdc-d33229548175"],
    "IUINavigationControllerStatics": ["2f14930a-f6f8-4a48-8d89-94786cca0c2e"],
    "IUINavigationControllerStatics2": ["e0cb28e3-b20b-4b0b-9ed4-f3d53cec0de4"],
    "IUIRadioInstance": ["dad2e05e-d00c-49f5-a904-2f83b01520d2"],
    "IUIRadioInstanceCollection": ["a56b8db0-d8a2-4f4b-a9ca-7f3dd4c26eff"],
    "IUIRadioManager": ["db3afbfb-08e6-46c6-aa70-bf9a34c30ab7"],
    "IUIRadioManagerNotifySink": ["b453e674-f489-41c5-9955-983c9fc264b2"],
    "IUIRibbon": ["803982ab-370a-4f7e-a9e7-8784036a6e26"],
    "IUISettings": ["85361600-1c63-4627-bcb1-3a89e0bc9c55"],
    "IUISettings2": ["bad82401-2721-44f9-bb91-2bb228be442f"],
    "IUISettings3": ["03021be4-5254-4781-8194-5168f7d06d7b"],
    "IUISettings4": ["52bb3002-919b-4d6b-9b78-8dd66ff4b93b"],
    "IUISettings5": ["5349d588-0cb5-5f05-bd34-706b3231f0bd"],
    "IUISettings6": ["aef19bd7-fe31-5a04-ada4-469aaec6dfa9"],
    "IUISettingsAnimationsEnabledChangedEventArgs": ["0c7b4b3d-2ea1-533e-894d-415bc5243c29"],
    "IUISettingsAutoHideScrollBarsChangedEventArgs": ["87afd4b2-9146-5f02-8f6b-06d454174c0f"],
    "IUISettingsController": ["78a51ac4-15c0-5a1b-a75b-acbf9cb8bb9e"],
    "IUISettingsControllerStatics": ["eb3c68cc-c220-578c-8119-7db324ed26a6"],
    "IUISettingsMessageDurationChangedEventArgs": ["338aad52-4a5d-5b59-8002-d930f608fd6e"],
    "IUISimplePropertySet": ["c205bb48-5b1c-4219-a106-15bd0a5f24e2"],
    "IUIViewSettings": ["c63657f6-8850-470d-88f8-455e16ea2c26"],
    "IUIViewSettingsInterop": ["3694dbf9-8f68-44be-8ff5-195c98ede8a6"],
    "IUIViewSettingsStatics": ["595c97a5-f8f6-41cf-b0fb-aacdb81fd5f6"],
    "IUNCParseCallback": ["095027b9-4db5-456f-8aea-7caf8657674c"],
    "IUPnPAddressFamilyControl": ["e3bf6178-694e-459f-a5a6-191ea0ffa1c7"],
    "IUPnPAsyncResult": ["4d65fd08-d13e-4274-9c8b-dd8d028c8644"],
    "IUPnPDeviceControlHttpHeaders": ["204810bb-73b2-11d4-bf42-00b0d0118b56"],
    "IUPnPDeviceDocumentAccessEx": ["c4bc4050-6178-4bd1-a4b8-6398321f3247"],
    "IUPnPEventingControl": ["29b4fdfe-201b-4581-baa5-88a2cc12668e"],
    "IUPnPFirewallHelper": ["0bb0be05-7475-4306-ac1b-c233db5bcc08"],
    "IUPnPHttpHeaderControl": ["0405af4f-8b5c-447c-80f2-b75984a31f3c"],
    "IUPnPNetworkInterfaceControl": ["aa2072a2-f5a7-4db0-9075-3af1414f91df"],
    "IUPnPServiceAsync": ["098bdaf5-5ec1-49e7-a260-b3a11dd8680c"],
    "IUPnPServiceDocumentAccess": ["21905529-0a5e-4589-825d-7e6d87ea6998"],
    "IUPnPServiceEnumProperty": ["38873b37-91bb-49f4-b249-2e8efbb8a816"],
    "IURLExecutionContextInternal": ["f01d35df-ec24-4e75-8085-cf9ebe01274c"],
    "IURSResultCallback": ["e5851812-0959-41c0-99b4-b9d5819c4189"],
    "IUiaManager": ["d42d11eb-f22a-4b2e-932e-ed24236cb4d7"],
    "IUiaManagerWindowRegistration": ["83140d1c-7e82-4cfb-96e4-f997cede7e10"],
    "IUiaWindowNotifierCallback": ["4f9c5cec-0197-49fe-b800-0d5a72a6c505"],
    "IUiaWindowRegistrationToken": ["6dc8c1be-86e5-4eef-8335-72cab53f06c8"],
    "IUibcInteractionBroker": ["b4932782-415d-4d51-aa2c-848037cf4e9f"],
    "IUnbufferedFileHandleOplockCallback": ["d1019a0e-6243-4329-8497-2e75894d7710"],
    "IUnbufferedFileHandleProvider": ["a65c9109-42ab-4b94-a7b1-dd2e4e68515e"],
    "IUnbufferedFileHandleProviderInternal": ["cb15a49f-a5f0-41bf-ba39-361cee68ee91"],
    "IUncloakWindowService": ["b706dded-208c-4795-b610-e7c002c31edc"],
    "IUnderline": ["a5fa8202-61c0-47d7-93ef-bc0b577c5f26"],
    "IUndoNode": ["38c9ea3a-1706-4761-ab49-5a0b4e4597ee"],
    "IUnfulfilledConsumable": ["2df7fbbb-1cdd-4cb8-a014-7b9cf8986927"],
    "IUnhandledError": ["9459b726-53b5-4686-9eaf-fa8162dc3980"],
    "IUnhandledErrorDetectedEventArgs": ["679ab78b-b336-4822-ac40-0d750f0b7a2b"],
    "IUnhandledErrorForwarder": ["9fca4c0c-9663-4653-9b32-0cdc24f89e88"],
    "IUnhandledExceptionEventArgs": ["7230269c-054e-4cf3-86c5-be90eb6863d5"],
    "IUnhandledExceptionEventHandler": ["9274e6bd-49a1-4958-beee-d0e19587b6e3"],
    "IUnicodeCharactersStatics": ["97909e87-9291-4f91-b6c8-b6e359d7a7fb"],
    "IUnidiAsyncNotifyChannel": ["20aa39c2-b631-4aec-bd78-fbafe79d7b9c"],
    "IUnidiAsyncNotifyRegistration": ["5eecac03-f33d-453c-8dd7-72571c03431a"],
    "IUnifiedPosErrorData": ["2b998c3a-555c-4889-8ed8-c599bb3a712a"],
    "IUnifiedPosErrorDataFactory": ["4b982551-1ffe-451b-a368-63e0ce465f5a"],
    "IUninstallDeviceFunction": ["776e1355-b286-4d5c-9398-a14d1b3b89e9"],
    "IUnmapLibraryCallback": ["5c206559-9085-4525-ac79-0093a0f4146d"],
    "IUnregisterPhysicalConnection": ["6c38e231-2a0d-428d-81f8-07cc428bb9a4"],
    "IUnregisterSubdevice": ["16738177-e199-41f9-9a87-abb2a5432f21"],
    "IUnsecuredApartment": ["1cfaba8c-1523-11d1-ad79-00c04fd8fdff"],
    "IUnsupportedAppRequirement": ["6182445c-894b-5cbc-8976-a98e0a9b998d"],
    "IUnwrappableDataObject": ["13439143-ccd0-43ef-97d0-93a09fe7f199"],
    "IUpFrontConfirmation": ["6ee8a11f-f5f0-4feb-8b78-a69aaa8a2a6a"],
    "IUpdatableItemSet": ["5c718a08-6ca1-4ae9-a9cc-7caf009f41b1"],
    "IUpdatableItemSetCallback": ["c8730a0e-4d28-4813-b152-7f2d156ea908"],
    "IUpdate": ["6a92b07a-d821-4682-b423-5c805022cc4d"],
    "IUpdate2": ["144fe9b0-d23d-4a8b-8634-fb4457533b7a"],
    "IUpdate3": ["112eda6b-95b3-476f-9d90-aee82c6b8181"],
    "IUpdate4": ["27e94b0d-5139-49a2-9a61-93522dc54652"],
    "IUpdate5": ["c1c2f21a-d2f4-4902-b5c6-8a081c19a890"],
    "IUpdateCollection": ["07f7438c-7709-4ca5-b518-91279288134e"],
    "IUpdateDownloadContent": ["54a2cb2d-9a0c-48b6-8a50-9abb69ee2d02"],
    "IUpdateDownloadContent2": ["c97ad11b-f257-420b-9d9f-377f733f6f68"],
    "IUpdateDownloadContentCollection": ["bc5513c8-b3b8-4bf7-a4d4-361c0d8c88ba"],
    "IUpdateDownloadResult": ["bf99af76-b575-42ad-8aa4-33cbb5477af1"],
    "IUpdateDownloader": ["68f1c6f9-7ecc-4666-a464-247fe12496c3"],
    "IUpdateException": ["a376dd5e-09d4-427f-af7c-fed5b6e1c1d6"],
    "IUpdateExceptionCollection": ["503626a3-8e14-4729-9355-0fe664bd2321"],
    "IUpdateFilesResultInternal": ["dda36318-d9de-4318-a622-a4396e5fd917"],
    "IUpdateHistoryEntry": ["be56a644-af0e-4e0e-a311-c1d8e695cbff"],
    "IUpdateHistoryEntry2": ["c2bfb780-4539-4132-ab8c-0a8772013ab6"],
    "IUpdateHistoryEntryCollection": ["a7f04f3c-a290-435b-aadf-a116c3357a5c"],
    "IUpdateIDList": ["6589b6d2-5f8d-4b9e-b7e0-23cdd9717d8c"],
    "IUpdateIdentity": ["46297823-9940-4c09-aed9-cd3ea6d05968"],
    "IUpdateInstallationResult": ["d940f0f8-3cbb-4fd0-993f-471e7f2328ad"],
    "IUpdateInstaller": ["7b929c68-ccdc-4226-96b1-8724600b54c2"],
    "IUpdateInstaller2": ["3442d4fe-224d-4cee-98cf-30e0c4d229e6"],
    "IUpdateInstaller3": ["16d11c35-099a-48d0-8338-5fae64047f8e"],
    "IUpdateInstaller4": ["ef8208ea-2304-492d-9109-23813b0958e1"],
    "IUpdateLockdown": ["a976c28d-75a1-42aa-94ae-8af8b872089a"],
    "IUpdateMgr": ["0517321b-22ce-4ed1-a86c-ba05bad085f0"],
    "IUpdateNavPaneSettings": ["5925316d-20b6-4ff9-a980-96482aa885de"],
    "IUpdateOperationTree": ["3a6bfcb4-bc06-4b4f-a99d-7a15b5728a76"],
    "IUpdateSearcher": ["8f45abf1-f9ae-4b95-a933-f0f66e5056ea"],
    "IUpdateSearcher2": ["4cbdcb2d-1589-4beb-bd1c-3e582ff0add0"],
    "IUpdateSearcher3": ["04c6895d-eaf2-4034-97f3-311de9be413a"],
    "IUpdateService": ["76b3b17e-aed6-4da5-85f0-83587f81abe3"],
    "IUpdateService2": ["1518b460-6518-4172-940f-c75883b24ceb"],
    "IUpdateServiceCollection": ["9b0353aa-0e52-44ff-b8b0-1f7fa0437f88"],
    "IUpdateServiceManager": ["23857e3c-02ba-44a3-9423-b1c900805f37"],
    "IUpdateServiceManager2": ["0bb8531d-7e8d-424f-986c-a0b8f60a3e7b"],
    "IUpdateServiceRegistration": ["dde02280-12b3-4e0b-937b-6747f6acb286"],
    "IUpdateSession": ["816858a4-260d-4260-933a-2585f1abc76b"],
    "IUpdateSession2": ["91caf7b0-eb23-49ed-9937-c52d817f46f7"],
    "IUpdateSession3": ["918efd1e-b5d8-4c90-8540-aeb9bdc56f9d"],
    "IUploadOperation": ["3e5624e0-7389-434c-8b35-427fd36bbdae"],
    "IUploadOperation2": ["556189f2-2774-4df6-9fa5-209f2bfb12f7"],
    "IUploadOperation3": ["42c92ca3-de39-4546-bc62-3774b4294de3"],
    "IUploadOperation4": ["50edef31-fac5-41ee-b030-dc77caee9faa"],
    "IUri": ["a39ee748-6a27-4817-a6f2-13914bef5890"],
    "IUriBuilder": ["4221b2e1-8955-46c0-bd5b-de9897565de7"],
    "IUriBuilderFactory": ["e982ce48-0b96-440c-bc37-0c869b27a29e"],
    "IUriContainer": ["a158a630-ed6f-45fb-b987-f68676f57752"],
    "IUriEscapeStatics": ["c1d432ba-c824-4452-a7fd-512bc3bbe9a1"],
    "IUriPriv": ["50295b0c-6b79-4935-aed8-05d80ec86a60"],
    "IUriPriv2": ["3d9e99dd-a9e7-4f49-9e60-a75ed89fd463"],
    "IUriRuntimeClass": ["9e365e57-48b2-4160-956f-c7385120bbfc"],
    "IUriRuntimeClassFactory": ["44a9796f-723e-4fdf-a218-033e75b0c084"],
    "IUriRuntimeClassWithAbsoluteCanonicalUri": ["758d9661-221c-480f-a339-50656673f46f"],
    "IUriToStreamResolver": ["b0aba86a-9aeb-4d3a-9590-003e3ca7e290"],
    "IUrlAccessor": ["0b63e318-9ccc-11d0-bcdb-00805fccce04"],
    "IUrlAccessor2": ["c7310734-ac80-11d1-8df3-00c04fb6ef4f"],
    "IUrlAccessor3": ["6fbc7005-0455-4874-b8ff-7439450241a3"],
    "IUrlAccessor4": ["5cc51041-c8d2-41d7-bca3-9e9e286297dc"],
    "IUrlBlockBroker": ["fbe803b5-5b26-4ba8-a59d-0a382e68993d"],
    "IUrlBlockClient": ["1c56e38c-949a-42f0-9000-e7396e87c095"],
    "IUrlBlockIsUrlAllowedLookupCallback": ["8506bdf6-580a-4b8f-8e4f-9f137ecb35e2"],
    "IUrlCacheManager": ["a168aadc-1674-49da-ad4f-4f27df8760d0"],
    "IUrlHistoryPriv": ["ae638e65-78b1-45ce-86ac-f3b9859b0dfd"],
    "IUrlReputationResult": ["f465adeb-62f6-4435-8183-857c07d99932"],
    "IUrlReputationResult2": ["4dd73573-561b-4f4e-b866-5382790eb81a"],
    "IUrlReputationSolution2": ["2ca901f9-192f-4df8-b2ef-5af3df3811d5"],
    "IUrlmonBindingInternal": ["27936671-8a0d-436d-b5be-064c00e73a54"],
    "IUsbBulkInEndpointDescriptor": ["3c6e4846-06cf-42a9-9dc2-971c1b14b6e3"],
    "IUsbBulkInPipe": ["f01d2d3b-4548-4d50-b326-d82cdabe1220"],
    "IUsbBulkOutEndpointDescriptor": ["2820847a-ffee-4f60-9be1-956cac3ecb65"],
    "IUsbBulkOutPipe": ["a8e9ee6e-0115-45aa-8b21-37b225bccee7"],
    "IUsbConfiguration": ["68177429-36a9-46d7-b873-fc689251ec30"],
    "IUsbConfigurationDescriptor": ["f2176d92-b442-407a-8207-7d646c0385f3"],
    "IUsbConfigurationDescriptorStatics": ["424ced93-e740-40a1-92bd-da120ea04914"],
    "IUsbControlRequestType": ["8e9465a6-d73d-46de-94be-aae7f07c0f5c"],
    "IUsbDescriptor": ["0a89f216-5f9d-4874-8904-da9ad3f5528f"],
    "IUsbDevice": ["5249b992-c456-44d5-ad5e-24f5a089f63b"],
    "IUsbDeviceClass": ["051942f9-845e-47eb-b12a-38f2f617afe7"],
    "IUsbDeviceClasses": ["686f955d-9b92-4b30-9781-c22c55ac35cb"],
    "IUsbDeviceClassesStatics": ["b20b0527-c580-4599-a165-981b4fd03230"],
    "IUsbDeviceDescriptor": ["1f48d1f6-ba97-4322-b92c-b5b189216588"],
    "IUsbDeviceStatics": ["066b85a2-09b7-4446-8502-6fe6dcaa7309"],
    "IUsbEndpointDescriptor": ["6b4862d9-8df7-4b40-ac83-578f139f0575"],
    "IUsbEndpointDescriptorStatics": ["c890b201-9a6a-495e-a82c-295b9e708106"],
    "IUsbInterface": ["a0322b95-7f47-48ab-a727-678c25be2112"],
    "IUsbInterfaceDescriptor": ["199670c7-b7ee-4f90-8cd5-94a2e257598a"],
    "IUsbInterfaceDescriptorStatics": ["e34a9ff5-77d6-48b6-b0be-16c6422316fe"],
    "IUsbInterfaceSetting": ["1827bba7-8da7-4af7-8f4c-7f3032e781f5"],
    "IUsbInterruptInEndpointDescriptor": ["c0528967-c911-4c3a-86b2-419c2da89039"],
    "IUsbInterruptInEventArgs": ["b7b04092-1418-4936-8209-299cf5605583"],
    "IUsbInterruptInPipe": ["fa007116-84d7-48c7-8a3f-4c0b235f2ea6"],
    "IUsbInterruptOutEndpointDescriptor": ["cc9fed81-10ca-4533-952d-9e278341e80f"],
    "IUsbInterruptOutPipe": ["e984c8a9-aaf9-49d0-b96c-f661ab4a7f95"],
    "IUsbSetupPacket": ["104ba132-c78f-4c51-b654-e49d02f2cb03"],
    "IUsbSetupPacketFactory": ["c9257d50-1b2e-4a41-a2a7-338f0cef3c14"],
    "IUsbTargetPipeContinuousReaderCallbackReadComplete": ["e44fc7cc-0037-45fe-b27c-3963fdf13997"],
    "IUsbTargetPipeContinuousReaderCallbackReadersFailed": ["4b891219-3c53-4a8c-8731-4e1b4be0e233"],
    "IUseImmediateCommitPropertyPages": ["fd6feba0-24ac-11d1-ab1b-00a0c9055a90"],
    "IUseToBrowseItem": ["05edda5c-98a3-4717-8adb-c5e7da991eb1"],
    "IUserAccountChangeCallback": ["a561e69a-b4b8-4113-91a5-64c6bcca3430"],
    "IUserActivity": ["fc103e9e-2cab-4d36-aea2-b4bb556cef0f"],
    "IUserActivity2": ["9dc40c62-08c4-47ac-aa9c-2bb2221c55fd"],
    "IUserActivity3": ["e7697744-e1a2-5147-8e06-55f1eeef271c"],
    "IUserActivityAttribution": ["34a5c8b5-86dd-4aec-a491-6a4faea5d22e"],
    "IUserActivityAttributionFactory": ["e62bd252-c566-4f42-9974-916c4d76377e"],
    "IUserActivityChannel": ["bac0f8b8-a0e4-483b-b948-9cbabd06070c"],
    "IUserActivityChannel2": ["1698e35b-eb7e-4ea0-bf17-a459e8be706c"],
    "IUserActivityChannelStatics": ["c8c005ab-198d-4d80-abb2-c9775ec4a729"],
    "IUserActivityChannelStatics2": ["8e87de30-aa4f-4624-9ad0-d40f3ba0317c"],
    "IUserActivityChannelStatics3": ["53bc4ddb-bbdf-5984-802a-5305874e205c"],
    "IUserActivityContentInfo": ["b399e5ad-137f-409d-822d-e1af27ce08dc"],
    "IUserActivityContentInfoStatics": ["9988c34b-0386-4bc9-968a-8200b004144f"],
    "IUserActivityFactory": ["7c385758-361d-4a67-8a3b-34ca2978f9a3"],
    "IUserActivityInterop": ["1ade314d-0e0a-40d9-824c-9a088a50059f"],
    "IUserActivityRequest": ["a0ef6355-cf35-4ff0-8833-50cb4b72e06d"],
    "IUserActivityRequestManager": ["0c30be4e-903d-48d6-82d4-4043ed57791b"],
    "IUserActivityRequestManagerInterop": ["dd69f876-9699-4715-9095-e37ea30dfa1b"],
    "IUserActivityRequestManagerStatics": ["c0392df1-224a-432c-81e5-0c76b4c4cefa"],
    "IUserActivityRequestedEventArgs": ["a4cc7a4c-8229-4cfd-a3bc-c61d318575a4"],
    "IUserActivitySession": ["ae434d78-24fa-44a3-ad48-6eda61aa1924"],
    "IUserActivitySessionHistoryItem": ["e8d59bd3-3e5d-49fd-98d7-6da97521e255"],
    "IUserActivitySourceHostInterop": ["c15df8bc-8844-487a-b85b-7578e0f61419"],
    "IUserActivityStatics": ["8c8fd333-0e09-47f6-9ac7-95cf5c39367b"],
    "IUserActivityVisualElements": ["94757513-262f-49ef-bbbf-9b75d2e85250"],
    "IUserActivityVisualElements2": ["caae7fc7-3eef-4359-825c-9d51b9220de3"],
    "IUserApplicationStateChangeHandler": ["7656cfa4-b63a-4542-a8de-ef402bac895d"],
    "IUserAssistProvider": ["fd032784-a057-4d4a-9e1d-0e0c471e2974"],
    "IUserAuthenticationStatusChangeDeferral": ["88b59568-bb30-42fb-a270-e9902e40efa7"],
    "IUserAuthenticationStatusChangingEventArgs": ["8c030f28-a711-4c1e-ab48-04179c15938f"],
    "IUserCertificateEnrollmentManager": ["96313718-22e1-4819-b20b-ab46a6eca06e"],
    "IUserCertificateEnrollmentManager2": ["0dad9cb1-65de-492a-b86d-fc5c482c3747"],
    "IUserCertificateStore": ["c9fb1d83-789f-4b4e-9180-045a757aac6d"],
    "IUserChangedEventArgs": ["086459dc-18c6-48db-bc99-724fb9203ccc"],
    "IUserChangedEventArgs2": ["6b2ccb44-6f01-560c-97ad-fc7f32ec581f"],
    "IUserConsentVerifierInterop": ["39e050c3-4e74-441a-8dc0-b81104df949c"],
    "IUserConsentVerifierStatics": ["af4f3f91-564c-4ddc-b8b5-973447627c65"],
    "IUserContextProperties": ["97cfe5f8-cfcc-4c42-8571-fc4d1235ccc7"],
    "IUserControl": ["a7a69ec9-ea35-4679-bf29-f4f09286d314"],
    "IUserControlFactory": ["38b1ed92-a28a-4972-93df-f4f759b8afd2"],
    "IUserControlStatics": ["e8887976-2c5c-41cf-be6a-9e44befdf655"],
    "IUserData": ["c4442b4f-580b-44d9-a9b4-15a617e8b910"],
    "IUserDataAccount": ["b9c4367e-b348-4910-be94-4ad4bba6dea7"],
    "IUserDataAccount2": ["078cd89f-de82-404b-8195-c8a3ac198f60"],
    "IUserDataAccount3": ["01533845-6c43-4286-9d69-3e1709a1f266"],
    "IUserDataAccount4": ["c4315210-eae5-4f0a-a8b2-1cca115e008f"],
    "IUserDataAccountManagerForUser": ["56a6e8db-db8f-41ab-a65f-8c5971aac982"],
    "IUserDataAccountManagerStatics": ["0d9b89ea-1928-4a20-86d5-3c737f7dc3b0"],
    "IUserDataAccountManagerStatics2": ["6a3ded88-316b-435e-b534-f7d4b4b7dba6"],
    "IUserDataAccountPartnerAccountInfo": ["5f200037-f6ef-4ec3-8630-012c59c1149f"],
    "IUserDataAccountProviderActivatedEventArgs": ["1bc9f723-8ef1-4a51-a63a-fe711eeab607"],
    "IUserDataAccountProviderAddAccountOperation": ["b9c72530-3f84-4b5d-8eaa-45e97aa842ed"],
    "IUserDataAccountProviderOperation": ["a20aad63-888c-4a62-a3dd-34d07a802b2b"],
    "IUserDataAccountProviderResolveErrorsOperation": ["6235dc15-bfcb-41e1-9957-9759a28846cc"],
    "IUserDataAccountProviderSettingsOperation": ["92034db7-8648-4f30-acfa-3002658ca80d"],
    "IUserDataAccountStore": ["2073b0ad-7d0a-4e76-bf45-2368f978a59a"],
    "IUserDataAccountStore2": ["b1e0aef7-9560-4631-8af0-061d30161469"],
    "IUserDataAccountStore3": ["8142c094-f3c9-478b-b117-6585bebb6789"],
    "IUserDataAccountStoreChangedEventArgs": ["84e3e2e5-8820-4512-b1f6-2e035be1072c"],
    "IUserDataAccountSystemAccessManagerStatics": ["9d6b11b9-cbe5-45f5-822b-c267b81dbdb6"],
    "IUserDataAccountSystemAccessManagerStatics2": ["943f854d-4b4e-439f-83d3-979b27c05ac7"],
    "IUserDataAvailabilityStateChangedEventArgs": ["a76582c9-06a2-4273-a803-834c9f87fbeb"],
    "IUserDataBufferUnprotectResult": ["8efd0e90-fa9a-46a4-a377-01cebf1e74d8"],
    "IUserDataPaths": ["f9c53912-abc4-46ff-8a2b-dc9d7fa6e52f"],
    "IUserDataPathsInterop": ["f12ef0b5-befb-46c9-9ee5-8a0681f13f8c"],
    "IUserDataPathsStatics": ["01b29def-e062-48a1-8b0c-f2c7a9ca56c0"],
    "IUserDataProtectionManager": ["1f13237d-b42e-4a88-9480-0f240924c876"],
    "IUserDataProtectionManagerStatics": ["977780e8-6dce-4fae-af85-782ac2cf4572"],
    "IUserDataStorageItemProtectionInfo": ["5b6680f6-e87f-40a1-b19d-a6187a0c662f"],
    "IUserDataTask": ["7c6585d1-e0d4-4f99-aee2-bc2d5ddadf4c"],
    "IUserDataTaskBatch": ["382da5fe-20b5-431c-8f42-a5d292ec930c"],
    "IUserDataTaskDataProviderConnection": ["9ff39d1d-a447-428b-afe9-e5402bdeb041"],
    "IUserDataTaskDataProviderTriggerDetails": ["ae273202-b1c9-453e-afc5-b30af3bd217d"],
    "IUserDataTaskList": ["49412e39-7c1d-4df1-bed3-314b7cbf5e4e"],
    "IUserDataTaskListCompleteTaskRequest": ["f65e14a3-1a42-49da-8552-2873e52c55eb"],
    "IUserDataTaskListCompleteTaskRequestEventArgs": ["d77c393d-4cf2-48ad-87fd-963f0eaa7a95"],
    "IUserDataTaskListCreateOrUpdateTaskRequest": ["2133772c-55c2-4300-8279-04326e07cce4"],
    "IUserDataTaskListCreateOrUpdateTaskRequestEventArgs": ["12c55a52-e378-419b-ae38-a5e9e604476e"],
    "IUserDataTaskListDeleteTaskRequest": ["4b863c68-7657-4f3d-b074-d47ec8df07e7"],
    "IUserDataTaskListDeleteTaskRequestEventArgs": ["6063dad9-f562-4145-8efe-d50078c92b7f"],
    "IUserDataTaskListLimitedWriteOperations": ["7aa267f2-6078-4183-919e-4f29f19cfae9"],
    "IUserDataTaskListSkipOccurrenceRequest": ["ab87e34d-1cd3-431c-9f58-089aa4338d85"],
    "IUserDataTaskListSkipOccurrenceRequestEventArgs": ["7a3b924a-cc2f-4e7b-aacd-a5b9d29cfa4e"],
    "IUserDataTaskListSyncManager": ["8e591a95-1dcf-469f-93ec-ba48bb553c6b"],
    "IUserDataTaskListSyncManagerSyncRequest": ["40a73807-7590-4149-ae19-b211431a9f48"],
    "IUserDataTaskListSyncManagerSyncRequestEventArgs": ["8ead1c12-768e-43bd-8385-5cdc351ffdea"],
    "IUserDataTaskManager": ["8451c914-e60b-48a9-9211-7fb8a56cb84c"],
    "IUserDataTaskManagerStatics": ["b35539f8-c502-47fc-a81e-100883719d55"],
    "IUserDataTaskQueryOptions": ["959f27ed-909a-4d30-8c1b-331d8fe667e2"],
    "IUserDataTaskReader": ["03e688b1-4ccf-4500-883b-e76290cfed63"],
    "IUserDataTaskRecurrenceProperties": ["73df80b0-27c6-40ce-b149-9cd41485a69e"],
    "IUserDataTaskRegenerationProperties": ["92ab0007-090e-4704-bb5c-84fc0b0d9c31"],
    "IUserDataTaskStore": ["f06a9cb0-f1db-45ba-8a62-086004c0213d"],
    "IUserDeviceAssociationChangedEventArgs": ["bd1f6f6c-bb5d-4d7b-a5f0-c8cd11a38d42"],
    "IUserDeviceAssociationStatics": ["7e491e14-f85a-4c07-8da9-7fe3d0542343"],
    "IUserDictionariesRegistrar": ["aa176b85-0e12-4844-8e1a-eef1da77f586"],
    "IUserFilter": ["3f457174-09a5-493d-a222-a2385c138a25"],
    "IUserIdKeyManager": ["dee152d9-40a4-4bf9-8ac3-62cf1bb2203b"],
    "IUserIdentifiers": ["7ab9cb99-c065-47f6-a020-f21a6f9857f5"],
    "IUserInfoDialog": ["e2ed0e45-87e4-4f0b-9d63-3b7d64c590e2"],
    "IUserInputString": ["00f243a1-205b-45ba-ae26-abbc53aa7a6f"],
    "IUserManagementWizards": ["251f5a5a-564a-4889-bb5e-be7cfab519c7"],
    "IUserManagementWizardsWithCancel": ["60c40185-8039-41dd-8fcc-3b378e4a8dbe"],
    "IUserManager": ["73aecad8-7e70-4e21-8767-82b03c862455"],
    "IUserNotification2": ["215913cc-57eb-4fab-ab5a-e5fa7bea2a6c"],
    "IUserNotificationCallback": ["19108294-0441-4aff-8013-fa0a730b0bea"],
    "IUserNotificationChangedEventArgs": ["b6bd6839-79cf-4b25-82c0-0ce1eef81f8c"],
    "IUserNotificationChangedTriggerFactory": ["cad4436c-69ab-4e18-a48a-5ed2ac435957"],
    "IUserNotificationListener": ["62553e41-8a06-4cef-8215-6033a5be4b03"],
    "IUserNotificationListenerStatics": ["ff6123cf-4386-4aa3-b73d-b804e5b63b23"],
    "IUserOOBEController": ["e897c734-8193-4146-8291-0591117b6046"],
    "IUserOOBEControllerAutoElevated": ["d0b0abe8-f93f-4b96-b5ea-0889178eef29"],
    "IUserPackageStateChangeHandler": ["a478f456-5d69-41d4-8fd5-a414c516c781"],
    "IUserPicker": ["7d548008-f1e3-4a6c-8ddc-a9bb0f488aed"],
    "IUserPickerStatics": ["de3290dc-7e73-4df6-a1ae-4d7eca82b40d"],
    "IUserProfilePersonalizationSettings": ["8ceddab4-7998-46d5-8dd3-184f1c5f9ab9"],
    "IUserProfilePersonalizationSettingsStatics": ["91acb841-5037-454b-9883-bb772d08dd16"],
    "IUserService": ["07b3b2ba-90ee-4464-9f6f-a824b13b91c1"],
    "IUserSigninStateChange": ["adf5b6fa-ca40-4e2a-86bf-b8e835fe0280"],
    "IUserStatics": ["155eb23b-242a-45e0-a2e9-3171fc6a7fdd"],
    "IUserTileBroker": ["d6d737ff-9e13-4a65-be89-a1e013cc6b76"],
    "IUserTileValidator": ["0406e498-0916-49c2-a1c4-10db7bf76766"],
    "IUserWatcher": ["155eb23b-242a-45e0-a2e9-3171fc6a7fbb"],
    "IUsersFilesDescription": ["1e31cf5b-edc7-4a9a-8500-8ca0446b52e9"],
    "IUssdMessage": ["2f9acf82-2004-4d5d-bf81-2aba1b4be4a8"],
    "IUssdMessageFactory": ["2f9acf82-1003-4d5d-bf81-2aba1b4be4a8"],
    "IUssdReply": ["2f9acf82-2005-4d5d-bf81-2aba1b4be4a8"],
    "IUssdSession": ["2f9acf82-2002-4d5d-bf81-2aba1b4be4a8"],
    "IUssdSessionStatics": ["2f9acf82-1001-4d5d-bf81-2aba1b4be4a8"],
    "IVB5Control": ["fcfb3d26-a0fa-1068-a738-08002b3371b5"],
    "IVB6Control": ["e93ad7c1-c347-11d1-a3e2-00a0c90aea82"],
    "IVBDataObject": ["2334d2b1-713e-11cf-8ae5-00aa00c00905"],
    "IVBDataObjectFiles": ["2334d2b3-713e-11cf-8ae5-00aa00c00905"],
    "IVBFormat": ["9849fd60-3768-101b-8d72-ae6164ffe3cf"],
    "IVBGetControl": ["40a050a0-3c31-101b-a82e-08002b2b2337"],
    "IVEHandler": ["856ca1b2-7dab-11d3-acec-00c04f86c309"],
    "IVEInternal": ["d5dd8176-dfb2-4569-b4a0-eb3e65ed7ef8"],
    "IVMRAspectRatioControl": ["ede80b5c-bad6-4623-b537-65586c9f8dfd"],
    "IVMRAspectRatioControl9": ["00d96c29-bbde-4efc-9901-bb5036392146"],
    "IVMRDeinterlaceControl": ["bb057577-0db8-4e6a-87a7-1a8c9a505a0f"],
    "IVMRDeinterlaceControl9": ["a215fb8d-13c2-4f7f-993c-003d6271a459"],
    "IVMRFilterConfig": ["9e5530c5-7034-48b4-bb46-0b8a6efc8e36"],
    "IVMRFilterConfig9": ["5a804648-4f66-4867-9c43-4f5c822cf1b8"],
    "IVMRImageCompositor": ["7a4fb5af-479f-4074-bb40-ce6722e43c82"],
    "IVMRImageCompositor9": ["4a5c89eb-df51-4654-ac2a-e48e02bbabf6"],
    "IVMRImagePresenter": ["ce704fe7-e71e-41fb-baa2-c4403e1182f5"],
    "IVMRImagePresenter9": ["69188c61-12a3-40f0-8ffc-342e7b433fd7"],
    "IVMRImagePresenterConfig": ["9f3a1c85-8555-49ba-935f-be5b5b29d178"],
    "IVMRImagePresenterConfig9": ["45c15cab-6e22-420a-8043-ae1f0ac02c7d"],
    "IVMRImagePresenterExclModeConfig": ["e6f7ce40-4673-44f1-8f77-5499d68cb4ea"],
    "IVMRMixerBitmap": ["1e673275-0257-40aa-af20-7c608d4a0428"],
    "IVMRMixerBitmap9": ["ced175e5-1935-4820-81bd-ff6ad00c9108"],
    "IVMRMixerControl": ["1c1a17b0-bed0-415d-974b-dc6696131599"],
    "IVMRMixerControl9": ["1a777eaa-47c8-4930-b2c9-8fee1c1b0f3b"],
    "IVMRMonitorConfig": ["9cf0b1b6-fbaa-4b7f-88cf-cf1f130a0dce"],
    "IVMRMonitorConfig9": ["46c2e457-8ba0-4eef-b80b-0680f0978749"],
    "IVMRSurface": ["a9849bbe-9ec8-4263-b764-62730f0d15d0"],
    "IVMRSurface9": ["dfc581a1-6e1f-4c3a-8d0a-5e9792ea2afc"],
    "IVMRSurfaceAllocator": ["31ce832e-4484-458b-8cca-f4d7e3db0b52"],
    "IVMRSurfaceAllocator9": ["8d5148ea-3f5d-46cf-9df1-d1b896eedb1f"],
    "IVMRSurfaceAllocatorEx9": ["6de9a68a-a928-4522-bf57-655ae3866456"],
    "IVMRSurfaceAllocatorNotify": ["aada05a8-5a4e-4729-af0b-cea27aed51e2"],
    "IVMRSurfaceAllocatorNotify9": ["dca3f5df-bb3a-4d03-bd81-84614bfbfa0c"],
    "IVMRVideoStreamControl": ["058d1f11-2a54-4bef-bd54-df706626b727"],
    "IVMRVideoStreamControl9": ["d0cfe38b-93e7-4772-8957-0400c49a4485"],
    "IVMRWindowlessControl": ["0eb1088c-4dcd-46f0-878f-39dae86a51b7"],
    "IVMRWindowlessControl9": ["8f537d09-f85e-4414-b23b-502e54c79927"],
    "IVPManager": ["aac18c18-e186-46d2-825d-a1f8dc8e395a"],
    "IVPNotify2": ["ebf47183-8764-11d1-9e69-00c04fd7c15b"],
    "IVSMDCodeDomCreator": ["4cc03bf7-4d89-4198-8e4d-17e217ca07b2"],
    "IVSMDCodeDomProvider": ["73e59688-c7c4-4a85-af64-a538754784c5"],
    "IVSMDDesigner": ["7494682a-37a0-11d2-a273-00c04f8ef4ff"],
    "IVSMDDesignerLoader": ["74946834-37a0-11d2-a273-00c04f8ef4ff"],
    "IVSMDDesignerService": ["74946829-37a0-11d2-a273-00c04f8ef4ff"],
    "IVSMDPerPropertyBrowsing": ["7494683c-37a0-11d2-a273-00c04f8ef4ff"],
    "IVSMDPropertyBrowser": ["74946810-37a0-11d2-a273-00c04f8ef4ff"],
    "IVSMDPropertyGrid": ["74946837-37a0-11d2-a273-00c04f8ef4ff"],
    "IVSMDTypeResolutionService": ["3411dd99-2445-43c8-918e-99bfbfaf8292"],
    "IVSWebReferenceDynamicProperties": ["c65a2f92-b350-4b0f-9bc6-b00e24bc8b9d"],
    "IVSWebReferenceDynamicProperties2": ["e4311e4c-0819-404b-b0d9-f5f44716ecec"],
    "IVSyncService": ["cdafd676-bd46-47cd-ba75-7238df0275ba"],
    "IVacProcessRegistrar": ["a07a355f-6e39-4a32-998d-1f4c217452ee"],
    "IValidate": ["e482e5c6-e31e-4143-a2e6-dbc3d8e4b8d3"],
    "IValidateBinding": ["04a578b2-e778-422a-a805-b3ee54d90bd9"],
    "IValidator": ["63df8730-dc81-4062-84a2-1ff943f59fac"],
    "IValueAndLanguage": ["b9914881-a1ee-4bc4-92a5-466968e30436"],
    "IValueConverter": ["e6f2fef0-0712-487f-b313-f300b8d79aa1"],
    "IValueMap": ["03837534-098b-11d8-9414-505054503030"],
    "IValueMapItem": ["03837533-098b-11d8-9414-505054503030"],
    "IValuePatternIdentifiers": ["425bf64c-5333-4e41-b470-2bad14ecd085"],
    "IValuePatternIdentifiersStatics": ["c247e8f7-adcc-440f-b123-33788a40525a"],
    "IValueProvider": ["2086b7a7-ac0e-47d1-ab9b-2a64292afdf8", "c7935180-6fb3-4201-b174-7df73adbf64a"],
    "IVanUIManager": ["4bf3b9ec-d6e5-4f66-b1bf-a91aae2d696b"],
    "IVariablePhotoCapturedEventArgs": ["d1eb4c5c-1b53-4e4a-8b5c-db7887ac949b"],
    "IVariablePhotoSequenceCapture": ["d0112d1d-031e-4041-a6d6-bd742476a8ee"],
    "IVariablePhotoSequenceCapture2": ["fe2c62bc-50b0-43e3-917c-e3b92798942f"],
    "IVariablePhotoSequenceController": ["7fbff880-ed8c-43fd-a7c3-b35809e4229a"],
    "IVariableSizedWrapGrid": ["9ca507c7-23c9-4f01-b80f-be5c21eef474"],
    "IVariableSizedWrapGridStatics": ["fe9db859-8127-4aef-b7a2-949847486e96"],
    "IVariantDictionary": ["4a7deb90-b069-11d0-b373-00a0c90c2bd8"],
    "IVdsAdmin": ["d188e97d-85aa-4d33-abc6-26299a10ffc1"],
    "IVdsAdvancedDisk": ["6e6f6b40-977c-4069-bddd-ac710059f8c0"],
    "IVdsAdvancedDisk2": ["9723f420-9355-42de-ab66-e31bb15beeac"],
    "IVdsAdvancedDisk3": ["3858c0d5-0f35-4bf5-9714-69874963bc36"],
    "IVdsAdviseSink": ["8326cd1d-cf59-4936-b786-5efc08798e25"],
    "IVdsAsync": ["d5d23b6d-5a55-4492-9889-397a3c2d2dbc"],
    "IVdsController": ["cb53d96e-dffb-474a-a078-790d1e2bc082"],
    "IVdsControllerControllerPort": ["ca5d735f-6bae-42c0-b30e-f2666045ce71"],
    "IVdsControllerPort": ["18691d0d-4e7f-43e8-92e4-cf44beeed11c"],
    "IVdsCreatePartitionEx": ["9882f547-cfc3-420b-9750-00dfbec50662"],
    "IVdsDisk": ["07e5c822-f00c-47a1-8fce-b244da56fd06"],
    "IVdsDisk2": ["40f73c8b-687d-4a13-8d96-3d7f2e683936"],
    "IVdsDisk3": ["8f4b2f5d-ec15-4357-992f-473ef10975b9"],
    "IVdsDiskOnline": ["90681b1d-6a7f-48e8-9061-31b7aa125322"],
    "IVdsDiskPartitionMF": ["538684e0-ba3d-4bc0-aca9-164aff85c2a9"],
    "IVdsDiskPartitionMF2": ["9cbe50ca-f2d2-4bf4-ace1-96896b729625"],
    "IVdsDiskPrivate": ["4c67c6ed-04cc-4644-bfc5-22cd34c0aae4"],
    "IVdsDrive": ["ff24efa4-aade-4b6b-898b-eaa6a20887c7"],
    "IVdsDrive2": ["60b5a730-addf-4436-8ca7-5769e2d1ffa4"],
    "IVdsHbaPort": ["2abd757f-2851-4997-9a13-47d2a885d6ca"],
    "IVdsHwProvider": ["d99bdaae-b13a-4178-9fdb-e27f16b4603e"],
    "IVdsHwProviderPrivate": ["98f17bf3-9f33-4f12-8714-8b4075092c2e"],
    "IVdsHwProviderPrivateMpio": ["310a7715-ac2b-4c6f-9827-3d742f351676"],
    "IVdsHwProviderStoragePools": ["d5b5937a-f188-4c79-b86c-11c920ad11b8"],
    "IVdsHwProviderType": ["3e0f5166-542d-4fc6-947a-012174240b7e"],
    "IVdsHwProviderType2": ["8190236f-c4d0-4e81-8011-d69512fcc984"],
    "IVdsIscsiInitiatorAdapter": ["b07fedd4-1682-4440-9189-a39b55194dc5"],
    "IVdsIscsiInitiatorPortal": ["38a0a9ab-7cc8-4693-ac07-1f28bd03c3da"],
    "IVdsIscsiPortal": ["7fa1499d-ec85-4a8a-a47b-ff69201fcd34"],
    "IVdsIscsiPortalGroup": ["fef5f89d-a3dd-4b36-bf28-e7dde045c593"],
    "IVdsIscsiPortalLocal": ["ad837c28-52c1-421d-bf04-fae7da665396"],
    "IVdsIscsiTarget": ["aa8f5055-83e5-4bcc-aa73-19851a36a849"],
    "IVdsLun": ["3540a9c7-e60f-4111-a840-8bba6c2c83d8"],
    "IVdsLun2": ["e5b3a735-9efb-499a-8071-4394d9ee6fcb"],
    "IVdsLunControllerPorts": ["451fe266-da6d-406a-bb60-82e534f85aeb"],
    "IVdsLunIscsi": ["0d7c1e64-b59b-45ae-b86a-2c2cc6a42067"],
    "IVdsLunMpio": ["7c5fbae3-333a-48a1-a982-33c15788cde3"],
    "IVdsLunNaming": ["907504cb-6b4e-4d88-a34d-17ba661fbb06"],
    "IVdsLunNumber": ["d3f95e46-54b3-41f9-b678-0f1871443a08"],
    "IVdsLunPlex": ["0ee1a790-5d2e-4abb-8c99-c481e8be2138"],
    "IVdsMaintenance": ["daebeef3-8523-47ed-a2b9-05cecce2a1ae"],
    "IVdsMigrateDisks": ["33b87426-5c06-49f4-84bd-f486b1b4a21d"],
    "IVdsOpenVDisk": ["75c8f324-f715-4fe3-a28e-f9011b61a4a1"],
    "IVdsOwnershipChangeQuery": ["54d1f9e3-7fd3-421a-af9c-53c2d8ee5bcf"],
    "IVdsPack": ["3b69d7f5-9d94-4648-91ca-79939ba263bf"],
    "IVdsPack2": ["13b50bff-290a-47dd-8558-b7c58db1a71a"],
    "IVdsProvider": ["10c5e575-7984-4e81-a56b-431f5f92ae42"],
    "IVdsProviderPrivate": ["11f3cd41-b7e8-48ff-9472-9dff018aa292"],
    "IVdsProviderSupport": ["1732be13-e8f9-4a03-bfbc-5f616aa66ce1"],
    "IVdsRemovable": ["0316560b-5db4-4ed9-bbb5-213436ddc0d9"],
    "IVdsService": ["0818a8ef-9ba9-40d8-a6f9-e22833cc771e"],
    "IVdsServiceHba": ["0ac13689-3134-47c6-a17c-4669216801be"],
    "IVdsServiceInitialization": ["4afc3636-db01-4052-80c3-03bbcb8d3c69"],
    "IVdsServiceIscsi": ["14fbe036-3ed7-4e10-90e9-a5ff991aff01"],
    "IVdsServiceLoader": ["e0393303-90d4-4a97-ab71-e9b671ee2729"],
    "IVdsServiceSAN": ["fc5d23e8-a88b-41a5-8de0-2d2f73c5a630"],
    "IVdsServiceSw": ["15fc031c-0652-4306-b2c3-f558b8f837e2"],
    "IVdsServiceUninstallDisk": ["b6b22da8-f903-4be7-b492-c09d875ac9da"],
    "IVdsStoragePool": ["932ca8cf-0eb3-4ba8-9620-22665d7f8450"],
    "IVdsSubSystem": ["6fcee2d3-6d90-4f91-80e2-a5c7caaca9d8"],
    "IVdsSubSystem2": ["be666735-7800-4a77-9d9c-40f85b87e292"],
    "IVdsSubSystemImportTarget": ["83bfb87f-43fb-4903-baa6-127f01029eec"],
    "IVdsSubSystemInterconnect": ["9e6fa560-c141-477b-83ba-0b6c38f7febf"],
    "IVdsSubSystemIscsi": ["0027346f-40d0-4b45-8cec-5906dc0380c8"],
    "IVdsSubSystemNaming": ["0d70faa3-9cd4-4900-aa20-6981b6aafc75"],
    "IVdsSwProvider": ["9aa58360-ce33-4f92-b658-ed24b14425b8"],
    "IVdsSwProviderPrivate": ["e882c452-cf37-482a-bbff-e6ee614e8023"],
    "IVdsSwProviderPrivateGetDisk": ["bd6ba17f-973f-4d69-9a83-b88727b5263f"],
    "IVdsSwProviderPrivateOffline": ["0a5534ff-b5dc-445d-9963-dd6d6f7cabdf"],
    "IVdsSwProviderPrivateUninstall": ["c276ba54-f480-455b-bd51-8ab05331ffba"],
    "IVdsVDisk": ["1e062b84-e5e6-4b4b-8a25-67b81e8f13e8"],
    "IVdsVdProvider": ["b481498c-8354-45f9-84a0-0bdd2832a91f"],
    "IVdsVdProviderPrivate": ["f18bbc5d-58d7-4d87-b46a-4f4869279c97"],
    "IVdsVolume": ["88306bb2-e71f-478c-86a2-79da200a0f11"],
    "IVdsVolume2": ["72ae6713-dcbb-4a03-b36b-371f6ac6b53d"],
    "IVdsVolumeMF": ["ee2d5ded-6236-4169-931d-b9778ce03dc6"],
    "IVdsVolumeMF2": ["4dbcee9a-6343-4651-b85f-5e75d74d983c"],
    "IVdsVolumeMF3": ["6788faf9-214e-4b85-ba59-266953616e09"],
    "IVdsVolumeOnline": ["1be2275a-b315-4f70-9e44-879b3a2a53f2"],
    "IVdsVolumePlex": ["4daa0135-e1d1-40f1-aaa5-3cc1e53221c3"],
    "IVdsVolumePrivate": ["93b08bff-ddcb-4d28-bc3a-749658e40118"],
    "IVdsVolumeShrink": ["d68168c9-82a2-4f85-b6e9-74707c49a58f"],
    "IVector2KeyFrameAnimation": ["df414515-4e29-4f11-b55e-bf2a6eb36294"],
    "IVector2NaturalMotionAnimation": ["0f3e0b7d-e512-479d-a00c-77c93a30a395"],
    "IVector2NaturalMotionAnimationFactory": ["8c74ff61-0761-48a2-bddb-6afcc52b89d8"],
    "IVector3KeyFrameAnimation": ["c8039daa-a281-43c2-a73d-b68e3c533c40"],
    "IVector3NaturalMotionAnimation": ["9c17042c-e2ca-45ad-969e-4e78b7b9ad41"],
    "IVector3NaturalMotionAnimationFactory": ["21a81d2f-0880-457b-ac87-b609018c876d"],
    "IVector3Transition": ["d2e209dc-c4a2-5101-9a68-fa0150505589"],
    "IVector3TransitionFactory": ["c3706699-ee9b-50dc-8807-f51d5a759495"],
    "IVector4KeyFrameAnimation": ["2457945b-addd-4385-9606-b6a3d5e4e1b9"],
    "IVectorChangedEventArgs": ["575933df-34fe-4480-af15-07691f3d5d9b"],
    "IVenueData": ["66f39187-60e3-4b2f-b527-4f53f1c3c677"],
    "IVerbStateTaskCallBack": ["f2153260-232e-4474-9d0a-9f2ab153441d"],
    "IVerifyingTrust": ["e7e281ba-1399-4f64-8e52-12ec05c5df71"],
    "IVersionInfo": ["401518ec-db00-4611-9b29-2a0e4b9afa85"],
    "IVersionManager": ["e56f8cdb-571e-4a28-96a0-f7ed9652772e"],
    "IVibrationDevice": ["40f21a3e-8844-47ff-b312-06185a3844da"],
    "IVibrationDeviceStatics": ["53e2eded-2290-4ac9-8eb3-1a84122eb71c"],
    "IVideoCall": ["5ef23627-e34a-4cb3-8c41-5a5e8265a9da"],
    "IVideoCallFactory": ["8e7c1701-821a-4ccc-9cb8-889bc3cc8468"],
    "IVideoCallInitializationParameters": ["a166b7f6-a433-4326-85b1-0f532180e6d4"],
    "IVideoCompositor": ["8510b43e-420c-420f-96c7-7c98bba1fc55"],
    "IVideoCompositorDefinition": ["7946b8d0-2010-4ae3-9ab2-2cef42edd4d2"],
    "IVideoCompositorDefinitionFactory": ["4366fd10-68b8-4d52-89b6-02a968cca899"],
    "IVideoDeviceController": ["99555575-2e2e-40b8-b6c7-f82d10013210"],
    "IVideoDeviceControllerGetDevicePropertyResult": ["c5d88395-6ed5-4790-8b5d-0ef13935d0f8"],
    "IVideoDisplayProperties": ["5609fdb1-5d2d-4872-8170-45dee5bc2f5c"],
    "IVideoDisplayProperties2": ["b410e1ce-ab52-41ab-a486-cc10fab152f9"],
    "IVideoEffectDefinition": ["39f38cf0-8d0f-4f3e-84fc-2d46a5297943"],
    "IVideoEffectDefinitionFactory": ["81439b4e-6e33-428f-9d21-b5aafef7617c"],
    "IVideoEffectsStatics": ["1fcda5e8-baf1-4521-980c-3bcebb44cf38"],
    "IVideoEncoder": ["02997c3b-8e1b-460e-9270-545e0de9563e"],
    "IVideoEncodingProperties": ["76ee6c9a-37c2-4f2a-880a-1282bbb4373d"],
    "IVideoEncodingProperties2": ["f743a1ef-d465-4290-a94b-ef0f1528f8e3"],
    "IVideoEncodingProperties3": ["386bcdc4-873a-479f-b3eb-56c1fcbec6d7"],
    "IVideoEncodingProperties4": ["724ef014-c10c-40f2-9d72-3ee13b45fa8e"],
    "IVideoEncodingProperties5": ["4959080f-272f-4ece-a4df-c0ccdb33d840"],
    "IVideoEncodingPropertiesStatics": ["3ce14d44-1dc5-43db-9f38-ebebf90152cb"],
    "IVideoEncodingPropertiesStatics2": ["cf1ebd5d-49fe-4d00-b59a-cfa4dfc51944"],
    "IVideoFrame": ["0cc06625-90fc-4c92-bd95-7ded21819d1c"],
    "IVideoFrame2": ["3837840d-336c-4366-8d46-060798736c5d"],
    "IVideoFrameFactory": ["014b6d69-2228-4c92-92ff-50c380d3e776"],
    "IVideoFrameNative": ["26ba702b-314a-4620-aaf6-7a51aa58fa18"],
    "IVideoFrameNativeFactory": ["69e3693e-8e1e-4e63-ac4c-7fdc21d9731d"],
    "IVideoFrameStatics": ["ab2a556f-6111-4b33-8ec3-2b209a02e17a"],
    "IVideoFrameStep": ["e46a9787-2b71-444d-a4b5-1fab7b708d6a"],
    "IVideoMediaFrame": ["00dd4ccb-32bd-4fe1-a013-7cc13cf5dbcf"],
    "IVideoMediaFrameFormat": ["46027fc0-d71b-45c7-8f14-6d9a0ae604e4"],
    "IVideoOTA": ["33bd34d4-7d76-424a-845d-92fe5813d1fd"],
    "IVideoOTACallback": ["f21770ae-7e3f-4af2-b318-3080992be7b0"],
    "IVideoOTACallbackEx": ["d66c7b93-78a6-4e6c-8b63-ffb52e83cfa4"],
    "IVideoOTACallbackEx2": ["0ebe9090-c74e-47a5-8a6d-7a94a30eb49b"],
    "IVideoOTAEx": ["084ad270-a71c-4edd-8327-c43032cd598b"],
    "IVideoProcAmp": ["4050560e-42a7-413a-85c2-09269a2d0f44"],
    "IVideoProperties": ["719ae507-68de-4db8-97de-49998c059f2f"],
    "IVideoQualityChangeEventArgs": ["69646776-1dfb-4db4-9edb-8d15af3c00c4"],
    "IVideoStabilizationEffect": ["0808a650-9698-4e57-877b-bd7cb2ee0f8a"],
    "IVideoStabilizationEffectEnabledChangedEventArgs": ["187eff28-67bb-4713-b900-4168da164529"],
    "IVideoStateChangeEventArgs": ["5e77a448-094d-4dce-95ac-cdd849826fed"],
    "IVideoStream": ["71867226-5936-4d2f-837e-a902ea3b4213"],
    "IVideoStreamConfiguration": ["d8770a6f-4390-4b5e-ad3e-0f8af0963490"],
    "IVideoStreamDescriptor": ["12ee0d55-9c2b-4440-8057-2c7a90f0cbec"],
    "IVideoStreamDescriptor2": ["8b306e10-453e-4088-832d-c36fa4f94af3"],
    "IVideoStreamDescriptorFactory": ["494ef6d1-bb75-43d2-9e5e-7b79a3afced4"],
    "IVideoStreamExt": ["9010592c-61f3-48c7-8f2d-33944e7a5da3"],
    "IVideoTemporalDenoisingControl": ["7ab34735-3e2a-4a32-baff-4358c4fbdd57"],
    "IVideoTrack": ["99f3b7f3-e298-4396-bb6a-a51be6a2a20a"],
    "IVideoTrackOpenFailedEventArgs": ["7679e231-04f9-4c82-a4ee-8602c8bb4754"],
    "IVideoTrackSupportInfo": ["4bb534a0-fc5f-450d-8ff0-778d590486de"],
    "IVideoTransformEffectDefinition": ["9664bb6a-1ea6-4aa6-8074-abe8851ecae2"],
    "IVideoTransformEffectDefinition2": ["f0a8089f-66c8-4694-9fd9-1136abf7444a"],
    "IVideoTransformSphericalProjection": ["cf4401f0-9bf2-4c39-9f41-e022514a8468"],
    "IViewActivityTracker": ["2822155f-414f-49c3-bb80-f521e3d988df"],
    "IViewCUIEventStore": ["18e60597-2f88-4b40-8b98-82e0f3a84a92"],
    "IViewChangeEvent": ["c186ef54-732a-4eac-bf74-5bc5a8163cea"],
    "IViewChapter": ["0c733a98-2a1c-11ce-ade5-00aa0044773d"],
    "IViewDefinition": ["db993c09-9f95-4973-8782-25491e171afe"],
    "IViewFilter": ["0c733a9b-2a1c-11ce-ade5-00aa0044773d"],
    "IViewFilters": ["c3d55399-683d-4a2b-a3a1-97bd4a682811"],
    "IViewHelper": ["e85ccef5-aaaa-47f0-b5e3-61f7aecdc4c1"],
    "IViewModePreferences": ["878fcd3a-0b99-42c9-84d0-d3f1d403554b"],
    "IViewModePreferencesStatics": ["69b60a65-5de5-40d8-8306-3833df7a2274"],
    "IViewObjectPresentFlip": ["30510847-98b5-11cf-bb82-00aa00bdce0b"],
    "IViewObjectPresentFlip2": ["30510856-98b5-11cf-bb82-00aa00bdce0b"],
    "IViewObjectPresentFlipSite": ["30510846-98b5-11cf-bb82-00aa00bdce0b"],
    "IViewObjectPresentFlipSite2": ["aad0cbf1-e7fd-4f12-8902-c78132a8e01d"],
    "IViewObjectPresentNotify": ["305107f8-98b5-11cf-bb82-00aa00bdce0b"],
    "IViewObjectPresentNotifySite": ["305107fa-98b5-11cf-bb82-00aa00bdce0b"],
    "IViewObjectPresentSite": ["305106e1-98b5-11cf-bb82-00aa00bdce0b"],
    "IViewObjectPresentSiteInternal": ["305106f6-98b5-11cf-bb82-00aa00bdce0b"],
    "IViewObjectPrint": ["305106e3-98b5-11cf-bb82-00aa00bdce0b"],
    "IViewPinUnpinVerb": ["4c331282-59e0-4d96-a1f7-930b2f636598"],
    "IViewPinVerb": ["25276cab-443e-47f5-81e7-9ea292ab58ad"],
    "IViewPositionChangedEventHandler": ["e5d6c3a8-7726-47d3-a475-a88bae5d8801"],
    "IViewPositionController": ["ed89406c-763f-4c6f-ae59-bf69c7a44687"],
    "IViewPropertyInfo": ["6f439ba7-0b57-41ba-8147-311d90a39c33"],
    "IViewResultRelatedItem": ["50bc72da-9633-47cb-80ac-727661fb9b9f"],
    "IViewRowset": ["0c733a97-2a1c-11ce-ade5-00aa0044773d"],
    "IViewSaveRestriction": ["7565d7ae-8cf5-4e7d-8bd0-3e43232292c3"],
    "IViewService": ["0821241f-484f-4e87-9c9c-a0a8e1fd7f17"],
    "IViewSort": ["0c733a9a-2a1c-11ce-ade5-00aa0044773d"],
    "IViewStateIdentityItem": ["9d264146-a94f-4195-9f9f-3bb12ce0c955"],
    "IViewStateInfo": ["71233fa0-8b30-45bb-8275-d4106df98734"],
    "IViewSwitcherProvider": ["33f288a6-5c2c-4d27-bac7-7536088f1219"],
    "IViewbox": ["05252c58-ba9d-4809-9ec3-fa0d16710ba1"],
    "IViewboxStatics": ["5cd1e72d-e8d3-4865-8f08-b6b2d689adf1"],
    "IViewportData": ["319ab26f-0df3-476d-944e-7af64aa43327"],
    "IVirtualDesktop": ["ff72ffdd-be7e-43fc-9c03-ad81681e88e4"],
    "IVirtualDesktopAccessibility": ["9975b71d-0a84-4909-bdde-b455bbfa55c6"],
    "IVirtualDesktopAnimationSyncNotification": ["6cafd3f1-05d1-4d26-a32a-9907a72c920b"],
    "IVirtualDesktopAnimationSyncNotificationService": ["0ddaf2d8-c38f-4638-95fc-fb9c6ddae52f"],
    "IVirtualDesktopHotkeyHandler": ["1a5fca39-f9fc-48e2-9a70-3cb48eb23175"],
    "IVirtualDesktopManager": ["a5cd92ff-29be-454c-8d04-d82879fb3f1b"],
    "IVirtualDesktopManagerInternal": ["f31574d6-b682-4cdc-bd56-1827860abec6"],
    "IVirtualDesktopNotification": ["c179334c-4295-40d3-bea1-c654d965605a"],
    "IVirtualDesktopNotificationService": ["0cd45e71-d927-4f15-8b0a-8fef525337bf"],
    "IVirtualDesktopPinnedApps": ["4ce81583-1e4c-4632-a621-07a53543148f"],
    "IVirtualDesktopTabletModePolicyService": ["56b32065-0bb3-42e2-975d-a559de1316e8"],
    "IVirtualSurfaceImageSource": ["4a711fea-bfac-11e0-a06a-9de44724019b"],
    "IVirtualSurfaceImageSourceFactory": ["3ab2212a-bfac-11e0-8a92-69e44724019b"],
    "IVirtualSurfaceImageSourceNative": ["e9550983-360b-4f53-b391-afd695078691"],
    "IVirtualSurfaceUpdatesCallbackNative": ["dbf2e947-8e6c-4254-9eee-7738f71386c9"],
    "IVirtualSurround": ["b8bb0d7d-75ea-4359-abdf-d256f849d065"],
    "IVirtualUIGroupItemSpy": ["4fbab242-3ed6-4a68-b5a5-3805fe9100ed"],
    "IVirtualizedItemProvider": ["17d4a04b-d658-48e0-a574-5a516c58dfa7", "cb98b665-2d35-4fac-ad35-f3c60d0c0b8b"],
    "IVirtualizedSelectionArraySpy": ["17d0605c-17ca-4b6a-870c-ca9b7ed6c937"],
    "IVirtualizingPanel": ["38aad50c-12cf-4d1e-a884-c9df85f07cd9"],
    "IVirtualizingPanelFactory": ["be19f839-cbd0-43e9-a5d0-0bdba0ffbd38"],
    "IVirtualizingPanelOverrides": ["5ef6bd7d-677f-408d-a96c-b19507750466"],
    "IVirtualizingPanelProtected": ["c9c9ab42-c232-479d-a7c9-5e7611196a45"],
    "IVirtualizingStackPanel": ["7567cd9a-a3b4-4dea-bb11-549e2c2f919d"],
    "IVirtualizingStackPanelOverrides": ["cbe6f72c-2892-46d1-987f-58ca1081f040"],
    "IVirtualizingStackPanelStatics": ["8314e778-91d3-4d56-ac09-223adcd2bd3f"],
    "IVisibilityChangedEventArgs": ["bf9918ea-d801-4564-a495-b1e84f8ad085"],
    "IVisibilityExemptionSuppressed": ["54beb45b-4e5b-4dd4-ab33-1e3e9552d2c7"],
    "IVisibleInDescription": ["1d17905d-aeb6-4ac9-8cd5-2c103f186212"],
    "IVisibleInList": ["d18f09e2-81c2-4217-a295-43b66fa4e495"],
    "IVisual": ["117e202d-a859-4c89-873b-c2aa566788e3"],
    "IVisual2": ["3052b611-56c3-4c3e-8bf3-f6e1ad473f06"],
    "IVisualCollection": ["8b745505-fd3e-4a98-84a8-e949468c6bcb"],
    "IVisualElement": ["01e64612-1d82-42f4-8e3f-a722ded33fc7"],
    "IVisualElementEnumerator": ["93af7f9c-2f24-4377-be59-a3a109d0ac64"],
    "IVisualElementEnumerator2": ["ccf5f433-f021-4fdc-a315-72235c9160bb"],
    "IVisualElementEnumerator3": ["0e05b317-bac6-40f3-994c-89c845548c16"],
    "IVisualElementEnumeratorFastMarshal": ["481ce96b-2744-4dce-81c1-e0caa156ec6d"],
    "IVisualElementEnumeratorFastMarshal2": ["b1145b6b-7e71-46a9-a394-d809f1cd6a26"],
    "IVisualElementEventDispatcher": ["8200309e-b0a8-4269-bd55-e0442725d348"],
    "IVisualElementEventSink": ["79286f11-6882-4f8b-9817-622e638d6478"],
    "IVisualElementsRequest": ["c138333a-9308-4072-88cc-d068db347c68"],
    "IVisualElementsRequestDeferral": ["a1656eb0-0126-4357-8204-bd82bb2a046d"],
    "IVisualElementsRequestedEventArgs": ["7b6fc982-3a0d-4ece-af96-cd17e1b00b2d"],
    "IVisualFactory": ["ad0ff93e-b502-4eb5-87b4-9a38a71d0137"],
    "IVisualInteractionSource": ["ca0e8a86-d8d6-4111-b088-70347bd2b0ed"],
    "IVisualInteractionSource2": ["aa914893-a73c-414d-80d0-249bad2fbd93"],
    "IVisualInteractionSource3": ["d941ef2a-0d5c-4057-92d7-c9711533204f"],
    "IVisualInteractionSourceObjectFactory": ["b2ca917c-e98a-41f2-b3c9-891c9266c8f6"],
    "IVisualInteractionSourceStatics": ["369965e1-8645-4f75-ba00-6479cd10c8e6"],
    "IVisualInteractionSourceStatics2": ["a979c032-5764-55e0-bc1f-0778786dcfde"],
    "IVisualProperties": ["e693cf68-d967-4112-8763-99172aee5e5a"],
    "IVisualState": ["6320affc-c31a-4450-afde-f6ea7bd1f586"],
    "IVisualState2": ["0fa0f896-64c0-45fb-8d24-fb83298c0d93"],
    "IVisualStateChangedEventArgs": ["fe216ab1-f31f-4791-8989-c70e1d9b59ff"],
    "IVisualStateChangedEventHandler": ["e6d5bbd5-e029-43a6-b36d-84a81042d774"],
    "IVisualStateGroup": ["e4f9d9a4-e028-44de-9b15-4929ae0a26c2"],
    "IVisualStateManager": ["6fda9f9a-6fab-4112-9258-1006a3c3476e"],
    "IVisualStateManagerFactory": ["85e598fd-a575-47b6-9e30-383cd08585f2"],
    "IVisualStateManagerOverrides": ["4a66910e-7979-43c8-8ff4-ec6122750006"],
    "IVisualStateManagerProtected": ["4b3b8640-b0b7-404c-9ef4-d949640e245d"],
    "IVisualStateManagerStatics": ["01d0e9e0-d713-414e-a74e-e63ec7ac8c3d"],
    "IVisualTransition": ["55c5905e-2bc7-400d-aaa4-1a2981491ee0"],
    "IVisualTransitionFactory": ["ea75864f-d1e0-4dae-b429-89fc322724f4"],
    "IVisualTreeHelper": ["24b935e3-52c7-4141-8bac-a73d06130569"],
    "IVisualTreeHelperStatics": ["e75758c4-d25d-4b1d-971f-596f17f12baa"],
    "IVisualTreeHelperStatics2": ["07bcd176-869f-44a7-8797-2103a4c3e47a"],
    "IVisualTreeHelperStatics3": ["40420d50-ca16-57da-8aac-944c8af577fd"],
    "IVisualTreeService": ["a593b11a-d17f-48bb-8f66-83910731c8a5"],
    "IVisualTreeService2": ["130f5136-ec43-4f61-89c7-9801a36d2e95"],
    "IVisualTreeService3": ["0e79c6e0-85a0-4be8-b41a-655cf1fd19bd"],
    "IVisualTreeServiceCallback": ["aa7a8931-80e4-4fec-8f3b-553f87b4966e"],
    "IVisualTreeServiceCallback2": ["bad9eb88-ae77-4397-b948-5fa2db0a19ea"],
    "IVisualUnorderedCollection": ["338faa70-54c8-40a7-8029-c9ceeb0aa250"],
    "IVmGPUPGuestMemoryAccess": ["15df23e2-05cf-48d1-ae3a-3826fcb6041c"],
    "IVmGPUPGuestMsiAccess": ["72469f11-9256-419a-aea5-38de4701b2ee"],
    "IVoiceCommand": ["936f5273-ec82-42a6-a55c-d2d79ec6f920"],
    "IVoiceCommandActivatedEventArgs": ["ab92dcfd-8d43-4de6-9775-20704b581b00"],
    "IVoiceCommandCompletedEventArgs": ["c85e675d-fe42-432c-9907-09df9fcf64e8"],
    "IVoiceCommandConfirmationResult": ["a022593e-8221-4526-b083-840972262247"],
    "IVoiceCommandContentTile": ["3eefe9f0-b8c7-4c76-a0de-1607895ee327"],
    "IVoiceCommandDefinition": ["7972aad0-0974-4979-984b-cb8959cd61ae"],
    "IVoiceCommandDefinitionManagerStatics": ["8fe7a69e-067e-4f16-a18c-5b17e9499940"],
    "IVoiceCommandDisambiguationResult": ["ecc68cfe-c9ac-45df-a8ea-feea08ef9c5e"],
    "IVoiceCommandResponse": ["0284b30e-8a3b-4cc4-a6a1-cad5be2716b5"],
    "IVoiceCommandResponseStatics": ["2932f813-0d3b-49f2-96dd-625019bd3b5d"],
    "IVoiceCommandServiceConnection": ["d894bb9f-21da-44a4-98a2-fb131920a9cc"],
    "IVoiceCommandServiceConnectionStatics": ["370ebffb-2d34-42df-8770-074d0f334697"],
    "IVoiceCommandUserMessage": ["674eb3c0-44f6-4f07-b979-4c723fc08597"],
    "IVoiceInformation": ["b127d6a4-1291-4604-aa9c-83134083352c"],
    "IVoipCallCoordinator": ["0d5f3579-f6dd-4e10-9f25-3d8c91376ee8", "4f118bcf-e8ef-4434-9c5f-a8d893fafe79"],
    "IVoipCallCoordinator2": ["0290a9b8-645d-4711-8e32-926bfabf6928", "beb4a9f3-c704-4234-89ce-e88cc0d28fbe"],
    "IVoipCallCoordinator3": ["338d0cbf-9b55-4021-87ca-e64b9bd666c7", "80a2ede6-0d02-40cd-8891-b4cec6472c82"],
    "IVoipCallCoordinator4": ["83737239-9311-468f-bb49-47e0dfb5d93e"],
    "IVoipCallCoordinatorStatics": ["10fb55bb-e07d-407e-bc39-f7cc3641d979", "7f5d1f2b-e04a-4d10-b31a-a55c922cc2fb"],
    "IVoipCallCoordinatorWithAppDeterminedUpgrade": ["4ec3eda6-9cf0-405c-bccd-cb7a8632a456"],
    "IVoipCallCoordinatorWithUpgrade": ["6172ccbc-6dd1-4f8e-b938-5393530c31ca"],
    "IVoipCallStateChangeHandler": ["03a327aa-6a4a-4d6c-a02c-4b69e0b5ae88"],
    "IVoipOperation": ["559b526d-c2cb-44d9-83a5-60cda4b71d36"],
    "IVoipOperationsManager": ["ba77e23c-38d9-4dfb-853f-f901978ff7fa"],
    "IVoipPhoneCall": ["6cf1f19a-7794-4a5a-8c68-ae87947a6990", "716654be-28e8-495e-b657-8053074b4150"],
    "IVoipPhoneCall2": ["1ac5b7dc-c83f-4862-8393-1ea14af7efea", "741b46e1-245f-41f3-9399-3141d25b52e3"],
    "IVoipPhoneCall3": ["0d891522-e258-4aa9-907a-1aa413c25523", "a92ab1d1-52fb-4adf-8225-4d289b866fe0"],
    "IVoipPhoneCallReady": ["b3f5ac79-f40f-4e52-a8ee-e8a9a71f511a"],
    "IVolatilePropertyStoreEndpoint": ["9b2573cc-9cbb-406f-84d6-b172c16ef245"],
    "IVolumeChangeRequestedEventArgs": ["6f026d5c-cf75-4c2b-913e-6d7c6c329179"],
    "IVolumetricAudioCompositor": ["3d05d0f2-0735-4320-96a6-d3a328de8608"],
    "IVolumetricAudioCompositorClient": ["ebe42893-d3af-4086-9d3e-ee056da0daa0"],
    "IVpnAppId": ["7b06a635-5c58-41d9-94a7-bfbcf1d8ca54"],
    "IVpnAppIdFactory": ["46adfd2a-0aab-4fdb-821d-d3ddc919788b"],
    "IVpnChannel": ["4ac78d07-d1a8-4303-a091-c8d2e0915bc3"],
    "IVpnChannel2": ["2255d165-993b-4629-ad60-f1c3f3537f50"],
    "IVpnChannel4": ["d7266ede-2937-419d-9570-486aebb81803"],
    "IVpnChannelActivityEventArgs": ["a36c88f2-afdc-4775-855d-d4ac0a35fc55"],
    "IVpnChannelActivityStateChangedArgs": ["3d750565-fdc0-4bbe-a23b-45fffc6d97a1"],
    "IVpnChannelConfiguration": ["0e2ddca2-2012-4fe4-b179-8c652c6d107e"],
    "IVpnChannelConfiguration2": ["f30b574c-7824-471c-a118-63dbc93ae4c7"],
    "IVpnChannelStatics": ["88eb062d-e818-4ffd-98a6-363e3736c95d"],
    "IVpnCredential": ["b7e78af3-a46d-404b-8729-1832522853ac"],
    "IVpnCustomCheckBox": ["43878753-03c5-4e61-93d7-a957714c4282"],
    "IVpnCustomComboBox": ["9a24158e-dba1-4c6f-8270-dcf3c9761c4c"],
    "IVpnCustomEditBox": ["3002d9a0-cfbf-4c0b-8f3c-66f503c20b39"],
    "IVpnCustomErrorBox": ["9ec4efb2-c942-42af-b223-588b48328721"],
    "IVpnCustomPrompt": ["9b2ebe7b-87d5-433c-b4f6-eee6aa68a244"],
    "IVpnCustomPromptBooleanInput": ["c4c9a69e-ff47-4527-9f27-a49292019979"],
    "IVpnCustomPromptElement": ["73bd5638-6f04-404d-93dd-50a44924a38b"],
    "IVpnCustomPromptOptionSelector": ["3b8f34d9-8ec1-4e95-9a4e-7ba64d38f330"],
    "IVpnCustomPromptText": ["3bc8bdee-3a42-49a3-abdd-07b2edea752d"],
    "IVpnCustomPromptTextInput": ["c9da9c75-913c-47d5-88ba-48fc48930235"],
    "IVpnCustomTextBox": ["daa4c3ca-8f23-4d36-91f1-76d937827942"],
    "IVpnDomainNameAssignment": ["4135b141-ccdb-49b5-9401-039a8ae767e9"],
    "IVpnDomainNameInfo": ["ad2eb82f-ea8e-4f7a-843e-1a87e32e1b9a"],
    "IVpnDomainNameInfo2": ["ab871151-6c53-4828-9883-d886de104407"],
    "IVpnDomainNameInfoFactory": ["2507bb75-028f-4688-8d3a-c4531df37da8"],
    "IVpnInterfaceId": ["9e2ddca2-1712-4ce4-b179-8c652c6d1011"],
    "IVpnInterfaceIdFactory": ["9e2ddca2-1712-4ce4-b179-8c652c6d1000"],
    "IVpnManagementAgent": ["193696cd-a5c4-4abe-852b-785be4cb3e34"],
    "IVpnNamespaceAssignment": ["d7f7db18-307d-4c0e-bd62-8fa270bbadd6"],
    "IVpnNamespaceInfo": ["30edfb43-444f-44c5-8167-a35a91f1af94"],
    "IVpnNamespaceInfoFactory": ["cb3e951a-b0ce-442b-acbb-5f99b202c31c"],
    "IVpnNativeProfile": ["a4aee29e-6417-4333-9842-f0a66db69802"],
    "IVpnNativeProfile2": ["0fec2467-cdb5-4ac7-b5a3-0afb5ec47682"],
    "IVpnPacketBuffer": ["c2f891fc-4d5c-4a63-b70d-4e307eacce55"],
    "IVpnPacketBuffer2": ["665e91f0-8805-4bf5-a619-2e84882e6b4f"],
    "IVpnPacketBuffer3": ["e256072f-107b-4c40-b127-5bc53e0ad960"],
    "IVpnPacketBufferFactory": ["9e2ddca2-1712-4ce4-b179-8c652c6d9999"],
    "IVpnPacketBufferList": ["c2f891fc-4d5c-4a63-b70d-4e307eacce77"],
    "IVpnPacketBufferList2": ["3e7acfe5-ea1e-482a-8d98-c065f57d89ea"],
    "IVpnPickedCredential": ["9a793ac7-8854-4e52-ad97-24dd9a842bce"],
    "IVpnPlugIn": ["ceb78d07-d0a8-4703-a091-c8c2c0915bc4"],
    "IVpnPlugInProfile": ["0edf0da4-4f00-4589-8d7b-4bf988f6542c"],
    "IVpnPlugInProfile2": ["611c4892-cf94-4ad6-ba99-00f4ff34565e"],
    "IVpnProfile": ["7875b751-b0d7-43db-8a93-d3fe2479e56a"],
    "IVpnRoute": ["b5731b83-0969-4699-938e-7776db29cfb3"],
    "IVpnRouteAssignment": ["db64de22-ce39-4a76-9550-f61039f80e48"],
    "IVpnRouteFactory": ["bdeab5ff-45cf-4b99-83fb-db3bc2672b02"],
    "IVpnSystemHealth": ["99a8f8af-c0ee-4e75-817a-f231aee5123d"],
    "IVpnTrafficFilter": ["2f691b60-6c9f-47f5-ac36-bb1b042e2c50"],
    "IVpnTrafficFilterAssignment": ["56ccd45c-e664-471e-89cd-601603b9e0f3"],
    "IVpnTrafficFilterFactory": ["480d41d5-7f99-474c-86ee-96df168318f1"],
    "IVpoContext": ["4f4f92b5-6ded-4e9b-a93f-013891b3a8b7"],
    "IVsASMXMetadataStorageProvider": ["c5e5042e-f39a-4c27-ae06-1b1715ea7223"],
    "IVsAction": ["15d2c32a-0770-4872-bb5f-ec21b0fa2436"],
    "IVsActivityLog": ["76af73f9-a322-42b0-a515-d4d7553508fe"],
    "IVsAddNewWebProjectItemDlg": ["41f92ab8-98b0-4cf4-907b-c5ce4403a570"],
    "IVsAddProjectItemDlg": ["11dfcceb-d935-4a9f-9796-5ba433c5af8e"],
    "IVsAddProjectItemDlg2": ["6b90d260-e363-4e8a-ae51-bd19c493416d"],
    "IVsAddToolboxItems": ["c1a29ac2-8fec-407a-8650-41e05f5e87f7"],
    "IVsAddWebReferenceDlg": ["bd71396f-39c6-4e3f-bba2-79ce33a8b302"],
    "IVsAddWebReferenceDlg2": ["fe037b96-a8d1-4961-a3f3-e969094ba978"],
    "IVsAddWebReferenceDlg3": ["46e27779-a3e6-484b-a0ee-15795b173ae6"],
    "IVsAddWebReferenceResult": ["4b85c5ef-9089-4e4c-a310-325bf87baf23"],
    "IVsAggregatableProject": ["ffb2e715-7312-4b93-83d7-d37bcc561c90"],
    "IVsAggregatableProject2": ["44cec4a2-7148-4044-b836-678374e296f2"],
    "IVsAggregatableProjectFactory": ["44569501-2ad0-4966-9bac-12b799a1ced6"],
    "IVsAppCommandLine": ["c7f21561-d58a-11d2-bf4a-0080c728d9a0"],
    "IVsAppCompat": ["0f9810e7-36ba-4986-938b-f7e14ee02f9a"],
    "IVsAppContainerDeveloperLicensing": ["ab6d6e32-671e-444f-8b52-ea446698b038"],
    "IVsAppContainerProjectDeploy": ["a830ac2a-4d69-45a3-a157-6574756034d5"],
    "IVsAppContainerProjectDeployCallback": ["d1f433df-b126-49a7-a1fd-f4099efc1a05"],
    "IVsAppContainerProjectDeployEvents": ["35cc3fd8-5435-4b9e-95cd-7e30c378fbdf"],
    "IVsAppContainerProjectDeployOperation": ["7773bd9e-1f28-4787-986b-1c42c000e31c"],
    "IVsAppContainerProjectDeployResult": ["96785cea-89f6-4fe6-ab54-f86e877ddfcd"],
    "IVsApplicationSettings": ["cc5b9866-bd93-4aff-8d61-c73ed3bb77d0"],
    "IVsAssemblyNameUnification": ["f33d7d20-49ce-47a7-9e3b-dcc9dd19af00"],
    "IVsAssemblyReference": ["b62a68c9-ea0a-4ad1-b7e5-80280798a41e"],
    "IVsAssemblyReferenceProviderContext": ["15fe7e6b-8cae-446d-8d54-4f73c08ed8c0"],
    "IVsAsyncEnum": ["c734671a-9bb0-45c5-a08e-b9ab73cf5f47"],
    "IVsAsyncEnumCallback": ["ee559c3d-0189-4f81-b088-c6cc6a394ca1"],
    "IVsAsyncToolWindowFactory": ["e6d4cefd-0b9e-4971-bc98-ed9fbc797d94"],
    "IVsAsyncToolWindowFactoryProvider": ["ba087b5e-4614-4928-bcec-85bf35eb031b"],
    "IVsAsynchOpenFromScc": ["99871a31-db02-4da9-98fb-89d8edc700ce"],
    "IVsAsynchOpenFromSccProjectEvents": ["c31c30ef-3b22-4f02-93bb-bcda5fa192aa"],
    "IVsAsynchronousProjectCreate": ["d1bb7312-01f8-49f7-8e9a-087434bd154a"],
    "IVsAsynchronousProjectCreateUI": ["808d838c-5821-4e4d-9399-0ab656a64e48"],
    "IVsAtomicTextProvider": ["29cdd341-0f95-42f2-b71c-75bc51a7eb72"],
    "IVsAutoOutliningClient": ["5151882e-58e1-4856-bfe8-4f17a30be839"],
    "IVsBackForwardNavigation": ["b7ee8dba-e930-4c5d-984d-b07f8eb60977"],
    "IVsBackForwardNavigation2": ["6366f292-8597-4e66-b332-c9d00d4367b8"],
    "IVsBatchProjectActionContext": ["49ed97f3-eae0-47ac-9a2e-dc15d0459f7b"],
    "IVsBatchUpdate": ["a2d3286e-b5ae-4981-8d32-e9053fcf997d"],
    "IVsBooleanSymbolExpressionEvaluator": ["59252755-82ac-4a88-a489-453feebc694d"],
    "IVsBooleanSymbolExpressionEvaluator2": ["d02a169e-f096-48b0-9a1c-b6ac30fae9ad"],
    "IVsBooleanSymbolPresenceBulkChecker": ["a37429bd-c5fe-4263-a8ad-d06d060b4632"],
    "IVsBooleanSymbolPresenceChecker": ["416c706c-933e-4acb-8d30-f02c28dd4874"],
    "IVsBroadcastMessageEvents": ["fc5ef273-dce3-4dbb-aee3-f54f91f00286"],
    "IVsBrowseComponentSet": ["804dcbde-3a63-4c3c-9316-296c4c7e9140"],
    "IVsBrowseContainersList": ["288f2a0c-b2e5-4799-9b9c-24e6efcefbf4"],
    "IVsBrowseObject": ["bc5b644e-7fd7-4a75-98cc-0c2c98aa96f6"],
    "IVsBrowseProjectLocation": ["368fc032-ae91-44a2-be6b-093a8a9e63cc"],
    "IVsBufferExtraFiles": ["66ee1dde-6336-4a1e-9c99-d2864285aba6"],
    "IVsBuildDependency": ["28d58eee-effc-4b4d-834c-3a746feac7ae"],
    "IVsBuildMacroInfo": ["9015b3ab-9fe2-430d-b79f-e0e581bd5b8b"],
    "IVsBuildManagerAccessor": ["c580a81b-9ffc-41eb-b8d7-5dcad29601b7"],
    "IVsBuildManagerAccessor2": ["bc89279f-b8ae-45dc-a171-52b8b8ba7945"],
    "IVsBuildManagerAccessor3": ["b7e1d5a7-7fd2-454f-96b9-ab77d975c706"],
    "IVsBuildManagerAccessor4": ["22580b39-7b9c-4e2d-87fa-9eb8f12aa9af"],
    "IVsBuildPropertyStorage": ["e7355fdf-a118-48f5-9655-7efd9d2dc352"],
    "IVsBuildPropertyStorage2": ["3b175ac0-f7e2-4187-80a0-a73c39313c49"],
    "IVsBuildPropertyStorage3": ["9669894b-8698-4e4a-bf06-aeca45559c36"],
    "IVsBuildPropertyStorageEvents": ["2c6c93fd-c88f-45ac-ac2b-39e91176f894"],
    "IVsBuildStatusCallback": ["a17326ad-c97b-4278-86e2-72163c4c6a8c"],
    "IVsBuildableProjectCfg": ["8588e475-bb33-4763-b4ba-0322f839aa3c"],
    "IVsBuildableProjectCfg2": ["09857e8e-74cc-43a7-993d-3ec774dca298"],
    "IVsBulkFileOperation": ["2d124b9b-8989-4f82-8e9d-ae0b002e0615"],
    "IVsButtonBar": ["4c4095ec-0af1-48b2-a900-db496765ee9e"],
    "IVsButtonBarClient": ["b59af843-e075-496e-a00d-e8eeb3c748eb"],
    "IVsButtonBarManager": ["b4d5b0a3-1945-4f5f-b5e1-4add352e78c1"],
    "IVsCallBrowser": ["6ed4e844-a0af-4d6f-b108-8e655785bc88"],
    "IVsCanCoordinatorClipTextSpan": ["215564f6-7007-4826-9384-9ed0e962de27"],
    "IVsCfg": ["b8f932a5-5037-48c9-ab3a-a4abba79358b"],
    "IVsCfgBrowseObject": ["a630cff5-eb22-40b7-9464-5f8d4b98b1cb"],
    "IVsCfgProvider": ["eeabd2be-4f4f-4ccb-86ad-9f469c5c9686"],
    "IVsCfgProvider2": ["623e34d5-82c1-42ed-a82c-6ca0478ffdda"],
    "IVsCfgProviderEvents": ["e6d78900-bb40-4039-9c54-593a242b65da"],
    "IVsCfgProviderEventsHelper": ["0d6d480c-894f-48e4-98d2-e0a7127750e4"],
    "IVsChangeClusterEvents": ["e55c4e80-a01c-47e8-9e94-d664b94df6cf"],
    "IVsChangeTrackingUndoManager": ["e33c4dcf-f50c-4356-8cd8-87a7f213337b"],
    "IVsClassView": ["d7ecce71-9c14-49a9-a93d-a5ed6286ac46"],
    "IVsCmdNameMapping": ["6d10ba00-9465-4f93-8b1d-11e36ee1ff65"],
    "IVsCoTaskMemFreeMyStrings": ["47811da4-330f-4eb5-9d14-bbc82773da66"],
    "IVsCodeDefView": ["588470cc-84f8-4a57-9ac4-86bca0625ff4"],
    "IVsCodeDefViewContext": ["e7070f9a-502f-4454-b4a2-fe261c568c37"],
    "IVsCodePageSelection": ["49539bfe-84dd-4b7e-8a82-b9e1c7639940"],
    "IVsCodeShareHandler": ["f4936be4-7ae0-4c97-9d82-51d219fc5d77"],
    "IVsCodeWindow": ["8560cecd-dfac-4f7b-9d2a-e6d9810f3443"],
    "IVsCodeWindow2": ["81a91fb7-7625-461a-8a9c-b1cc701eccc5"],
    "IVsCodeWindowEvents": ["26acc7fd-c665-426b-b120-e96762c5dd1a"],
    "IVsCodeWindowEvents2": ["6703f718-2939-40c2-8f8f-ab393378aec8"],
    "IVsCodeWindowEx": ["186f17a5-7270-4bc5-a8de-72f4a0e49647"],
    "IVsCodeWindowManager": ["4758cb90-6110-4440-b577-2e3fc91e4b84"],
    "IVsColorableItem": ["56694a40-78d0-45dd-ab15-681bc207579c"],
    "IVsColorizer": ["6698ef11-ff17-441c-8c5d-bc24a339b37d"],
    "IVsColorizer2": ["868a4381-537a-4d61-803c-301819ce2c2f"],
    "IVsComReference": ["3b1d9f20-1152-44d2-851c-12a88da14337"],
    "IVsComReferenceDlg": ["cc05ee57-c6c0-4742-a469-0961e50b0049"],
    "IVsComReferenceDlgEvents": ["66a77728-86e1-4d18-88c5-ee0d4fd4bf60"],
    "IVsComReferenceProviderContext": ["8f310644-1d6a-4982-9d3d-c328a1384b43"],
    "IVsCombinedBrowseComponentSet": ["64cbd015-9d4b-4daf-8801-68eda90b98c5"],
    "IVsCommandArgInfo": ["aad53083-6316-4a65-82c3-85732ac52e52"],
    "IVsCommandWindow": ["0660cd86-f3ab-4008-930d-bae8b10ff8ca"],
    "IVsCommandWindow2": ["e22363b8-e7d3-49b5-b094-7395bb35ce13"],
    "IVsCommandWindowCompletion": ["34896bbb-a3d5-4c80-bcce-e9271beedc11"],
    "IVsCommandWindowsCollection": ["615ff029-fefa-492c-8cd2-c3f66644c3f9"],
    "IVsCommentTaskInfo": ["d94c96da-a6c4-4f52-84f6-52ecf05dea3a"],
    "IVsCommentTaskToken": ["327c43d7-ccb1-41d7-9a7b-ce87751201f7"],
    "IVsCommitGestureSink": ["957970b0-71e1-11d3-aff1-00105a9991ef"],
    "IVsCommonMessagePump": ["fb3b20f4-9c8e-454a-984b-b1334f790541"],
    "IVsCommonMessagePumpClientEvents": ["9c6d9104-7db9-4abd-841d-f0cfd24de3d0"],
    "IVsCommonMessagePumpFactory": ["e8e8300a-c63f-423f-b596-29308ca0ab4c"],
    "IVsCompletionSet": ["0ef79249-b0bf-4cd0-a966-c4713546c3a5"],
    "IVsCompletionSet3": ["b30b03b0-db30-43c7-a959-c81522988f8e"],
    "IVsCompletionSetBuilder": ["cb570e9b-7b88-4159-9819-6f7e71effa95"],
    "IVsCompletionSetEx": ["3f710016-58d5-4887-ad76-936d1a45a588"],
    "IVsComponentEnumeratorFactory": ["332cedee-6610-11d3-85fd-00c04f6123b3"],
    "IVsComponentEnumeratorFactory2": ["64f6b8c1-3dec-4606-8c8c-651a7e26a3de"],
    "IVsComponentEnumeratorFactory3": ["0c2b582a-ddb2-440c-a777-3d46c3502337"],
    "IVsComponentEnumeratorFactory4": ["8f18fe7e-acb7-4031-aae5-039b49df5191"],
    "IVsComponentModelHost": ["c442a6b0-3f06-4003-912d-9b8cb750c5e7"],
    "IVsComponentSelectorData": ["45bd8e74-6727-11d3-8600-00c04f6123b3"],
    "IVsComponentSelectorDlg": ["66899421-f497-4503-8c9d-adae290f2f27"],
    "IVsComponentSelectorDlg2": ["2d7cdc3d-fa79-4df3-9cd2-aacf65a2846e"],
    "IVsComponentSelectorDlg3": ["00ae51bd-26d7-4974-801b-b0890e1753f8"],
    "IVsComponentSelectorDlg4": ["c43f5129-896f-4653-98e8-b0a16bfe0fc1"],
    "IVsComponentSelectorProvider": ["1375e029-1fdd-47ff-a22c-6709242133e2"],
    "IVsComponentUser": ["910035b1-d8be-403a-975e-e4fb68ce40a1"],
    "IVsCompoundAction": ["b414d071-87ba-411a-9780-33fc7d87d882"],
    "IVsCompoundActionEvents": ["29b88b8e-bc39-45ae-acab-0c670e49bcc2"],
    "IVsCompoundViewChange": ["b5c14ff1-8431-458c-bebc-34c6925d1976"],
    "IVsConfigurationManagerDlg": ["57f5e77f-75c9-42a3-8daf-579c3556a0dd"],
    "IVsConfigureToolboxItem": ["6c3e27f9-775a-456b-8d37-2d7057abb8f1"],
    "IVsConnectedServiceInstanceReference": ["13a70605-f511-4350-8daf-4387f10b97be"],
    "IVsConnectedServiceInstanceReferenceProviderContext": ["c9127230-28c1-413d-bdc5-39f3a700fcbd"],
    "IVsConnectedServiceProperties": ["6ed0b110-2132-4675-9f87-7715b312ccc2"],
    "IVsContainedCode": ["171a72ae-bae6-4b66-9a58-4691f08ed9f2"],
    "IVsContainedLanguage": ["518ab114-e3c6-4bbc-a469-99279f1a54e9"],
    "IVsContainedLanguageCodeSupport": ["f386be91-0e80-43af-8eb6-8b829fa06282"],
    "IVsContainedLanguageColorizer": ["88105779-d75b-459e-b7ad-78f63bd40714"],
    "IVsContainedLanguageFactory": ["9fd1bd52-9d32-4697-b446-36582b865c34"],
    "IVsContainedLanguageHost": ["0429916f-69e1-4336-ab7e-72086fb0d6bc"],
    "IVsContainedLanguageHostEvents": ["f2a52136-803e-4cef-bba7-52d610fe34ba"],
    "IVsContainedLanguageProjectNameProvider": ["f77b0dd6-420b-4e7c-a0b3-c8d5b10a0997"],
    "IVsContainedLanguageStaticEventBinding": ["22ff7776-2c9a-48c4-809f-39e5184cc32d"],
    "IVsContextualIntellisenseFilter": ["c0c5974a-288d-4719-ab48-9cb812b5e895"],
    "IVsContextualIntellisenseFilterProvider": ["f7827dce-0b39-474d-8d48-fe8100c9044c"],
    "IVsCppDebugUIVisualizer": ["e8eb78c4-0569-4b6a-bc28-4d5e1b0a350a"],
    "IVsCreateAggregateProject": ["84f41718-d169-4567-a0cd-b3cbcf58ff71"],
    "IVsCustomDebuggerEventHandler110": ["b704f6b1-1339-4c29-b402-ddd5a7f6f82a"],
    "IVsCustomDebuggerStoppingEventHandler110": ["f5cd73fa-13b2-4166-87dc-562ea46e0075"],
    "IVsCustomFindScope": ["51066b51-499a-419b-a7b3-18c1db46eb95"],
    "IVsCustomFindScopeLookIn": ["b82e262a-a6a4-407f-b562-42785c2c61fc"],
    "IVsCustomFindScopeNotify": ["169b2f24-bb17-40d8-ae2a-13b651b610ca"],
    "IVsCustomFindScopeSearch": ["bc70e6de-4b40-438f-8f83-afe1cc6ab101"],
    "IVsDataEnvironment": ["cd138ad4-a0bf-4681-8fa7-b6d57d55c4db"],
    "IVsDataObjectStringMapEvents": ["dfec8e49-b682-43e0-841a-c25c5e2ea1e9"],
    "IVsDataObjectStringMapManager": ["662afcec-ad0c-4f59-97e2-f61e0c673514"],
    "IVsDataObjectStringMapManager2": ["65ca3ec7-633e-4846-9946-17a80ff4c34c"],
    "IVsDataSourceFactory": ["24034437-cb2e-47dd-ae2b-14d56481a2f0"],
    "IVsDebugLaunch": ["a5412570-5fb9-11d1-a811-00a0c9110051"],
    "IVsDebugLaunchHook": ["9040e456-ff48-41ff-aedd-d5eb36a0ddfb"],
    "IVsDebugLaunchNotifyListener110": ["4a991d8c-4711-448f-90a9-0d962667799b"],
    "IVsDebugLaunchNotifyListener120A": ["2cf077b1-ecc0-4dc5-bf44-414a4190012d"],
    "IVsDebugLaunchNotifyListenerFactory110": ["a8ee3398-a74d-429c-8d1c-e3ad96637649"],
    "IVsDebugName": ["0bce4f72-5889-4733-8605-413c28f5899f"],
    "IVsDebugProcessNotify": ["23320efc-7c7a-4c3d-ad85-93a4e620fdd0"],
    "IVsDebugRemoteDiscoveryUI": ["81fb5379-b64e-4d8f-8628-e5305306f12a"],
    "IVsDebugTargetSelectionService": ["310466ba-2b59-4cce-9592-95e195096939"],
    "IVsDebuggableProjectCfg": ["2bc88742-618d-46b2-b65d-67ac990e3215"],
    "IVsDebuggableProjectCfg2": ["2559d053-417e-4276-a905-193191b5816a"],
    "IVsDebuggableProtocol": ["ca647009-a436-4d08-ba0f-9027a97a818b"],
    "IVsDebugger": ["7d960b16-7af8-11d0-8e5e-00a0c911005a"],
    "IVsDebugger10": ["91d280b4-49e5-4345-8906-fa888f08e828"],
    "IVsDebugger2": ["b33300fb-fefe-4e00-a74a-17a5eed1b1ed"],
    "IVsDebugger3": ["f6a3b3e7-5a0e-420b-98d0-ae6963cad9f3"],
    "IVsDebugger4": ["8548668a-f63a-46bb-a3bd-5d053229820a"],
    "IVsDebugger5": ["7c6788df-f3ee-4da7-ae43-148ea5635538"],
    "IVsDebugger6": ["ef0e965c-d5ab-4be5-819b-9ca1ad0c4de1"],
    "IVsDebugger7": ["fddc501d-d9f5-46aa-99f3-07173ce7e004"],
    "IVsDebugger8": ["71af033c-1c1b-4fd4-87ab-08b441dbce1d"],
    "IVsDebugger9": ["bfdff000-3761-49b2-ba9b-4c1db1d82789"],
    "IVsDebuggerDelayedEnterBreak": ["a01c5df6-ed76-4bce-b38d-50563c2e59f0"],
    "IVsDebuggerDelayedEnterBreakSink": ["b00e6e5a-7a25-454d-858a-396f7d24e17f"],
    "IVsDebuggerDeploy140": ["202f2ce9-7ea5-48ed-acea-7fd533923814"],
    "IVsDebuggerEvents": ["7d960b15-7af8-11d0-8e5e-00a0c911005a"],
    "IVsDebuggerScriptInstallCheck": ["0f6a40b8-d6b5-44b9-86e9-1d6b1b208e3f"],
    "IVsDebuggerSymbolSettings120A": ["ba6e5e41-be38-4d79-be35-570160be009e"],
    "IVsDebuggerSymbolSettings150": ["d4cea00d-f3ed-49c9-9513-bc4fec8c6a98"],
    "IVsDebuggerSymbolSettings161": ["20bc5bab-4e63-49e4-a7e4-611e705e0a05"],
    "IVsDebuggerSymbolSettingsManager120A": ["b4460c14-0296-4182-aecd-73514987f21e"],
    "IVsDefaultButtonBarImages": ["73b7dc00-f498-4abd-ab79-d07afd52f395"],
    "IVsDefaultToolboxTabState": ["1749a33b-2099-4a22-b32a-e96add887142"],
    "IVsDeferredDocView": ["f22a0ad5-8f51-4f66-a644-ea64770cf8b7"],
    "IVsDeferredSaveProject": ["83b2961f-ac2b-409b-89bd-dcf698e3c402"],
    "IVsDependency": ["9db6689f-3c5f-43ed-b0d5-54851a980b93"],
    "IVsDependencyProvider": ["819cc554-c7bf-4965-a4d4-937b2b6cd2e1"],
    "IVsDeployDependency": ["a086e870-aa0b-4ef9-8cf3-4a38267b9c7d"],
    "IVsDeployDependency2": ["77f54647-95e6-4033-91a8-51ccd014d945"],
    "IVsDeployStatusCallback": ["e9964f8d-5600-4623-b611-ff4007b22419"],
    "IVsDeployableProjectCfg": ["358f6c9f-cd65-446a-b79a-30cee094fdc1"],
    "IVsDeployableProjectCfg2": ["a981529f-4d0d-46ee-a758-ac26e50e099d"],
    "IVsDesignTimeAssemblyResolution": ["eda26258-95df-44a0-a244-d545e6c1196c"],
    "IVsDesignTimeAssemblyResolution2": ["c0031543-0b20-4fa7-b627-8ed28f4b5f64"],
    "IVsDesignerInfo": ["59518321-3cca-4bc9-bc1b-adbceef21f14"],
    "IVsDetermineWizardTrust": ["42085c99-3f5b-4b61-9737-592479718cec"],
    "IVsDiagnosticsItem": ["a20b98d4-f56c-4b53-819b-3b0e7147b961"],
    "IVsDiagnosticsProvider": ["79f357cd-d78e-44f7-8442-376ff2bff0c4"],
    "IVsDifferenceService": ["e20e53be-8b7a-408f-aea7-c0aad6d1b946"],
    "IVsDiscoveryService": ["b9a32c80-b14d-4ae3-a955-5cbc3e7fab10"],
    "IVsDispatch": ["09ccd272-5fa0-11d2-b1f8-0080c747d9a0"],
    "IVsDocDataFileChangeControl": ["bf955013-a875-439d-a4e7-a3bbdf12aa4f"],
    "IVsDocOutlineProvider": ["47b1d60a-4eb8-4723-b991-992e6393e392"],
    "IVsDocOutlineProvider2": ["9eb7079f-3445-4c43-99d8-46ea8ca1d659"],
    "IVsDocumentLockHolder": ["685933f2-c1ad-4540-a15a-d3f977a81af7"],
    "IVsDocumentPreviewer": ["1a19a9db-766e-40b4-90fe-b6ef0be6299b"],
    "IVsDpiAware": ["2283d00f-c00f-405e-8c23-8d31cc714fdd"],
    "IVsDropdownBar": ["d7820968-4cf8-4760-b633-570282e5f66d"],
    "IVsDropdownBar2": ["bc766334-6e04-442c-92f1-f687ecf8f741"],
    "IVsDropdownBarClient": ["aee77bdd-05c8-4de1-b48e-1b003f49acb7"],
    "IVsDropdownBarClient3": ["9f0dc18b-2ed7-435e-b0d2-0ed5577b9635"],
    "IVsDropdownBarClientEx": ["f74462e6-2e8e-477c-ba7d-f03d336dcb36"],
    "IVsDropdownBarManager": ["5ccb1170-6527-4d88-be3e-198f0ef5538d"],
    "IVsDummy": ["e8edd020-efab-4aba-99a6-aba6345ae135"],
    "IVsDynamicNavigationItem": ["3304fdef-9284-4340-b6b7-37ce11167c8c"],
    "IVsDynamicTabProvider": ["e82466ca-cf0e-4653-9e76-4d4c6c548da2"],
    "IVsENCRebuildableProjectCfg": ["bf031840-afb9-11d2-ae14-00a0c9110055"],
    "IVsENCRebuildableProjectCfg2": ["d13e943a-9ee0-457f-8766-7d8b6bc06565"],
    "IVsENCRebuildableProjectCfg3": ["12342e6d-563a-4195-b267-d080383dd437"],
    "IVsENCRebuildableProjectCfg4": ["64f7cf8b-8800-4dd7-b472-2090c90ddb64"],
    "IVsEditorFactory": ["40fb079b-b62c-486f-9823-c9a2eae8dbfd"],
    "IVsEditorFactory2": ["8abd2347-3360-46ae-96fa-3b70a44d3f73"],
    "IVsEditorFactory3": ["c2274805-a963-49e1-bd01-97ddee5ae744"],
    "IVsEditorFactoryChooser": ["00462323-0c58-4b10-bc63-95ed7427744c"],
    "IVsEditorFactoryNotify": ["02ac210f-139b-4f8e-9159-501cf2a87d6e"],
    "IVsEditorGoBackLocations": ["714fff37-5cdc-424a-bcb4-ca50800524f1"],
    "IVsEmpWeb": ["3675acf5-0c81-11d3-85c9-00a0c9cfcc16"],
    "IVsEmpWebResource": ["3675acf6-0c81-11d3-85c9-00a0c9cfcc16"],
    "IVsEnhancedDataTip": ["b8092238-a091-42f1-a945-080b381fbcfc"],
    "IVsEnumBSTR": ["a0a9c2b0-95a3-4819-ada3-5bd9756bbd36"],
    "IVsEnumBufferCoordinatorSpans": ["5fceea4c-d49f-4acd-b816-130a5dcd4c54"],
    "IVsEnumCodeBlocks": ["07a45a82-5354-4dde-ac7d-60f2cdd5573b"],
    "IVsEnumCommentTaskTokens": ["ec47207e-5a2a-45d4-9fa4-f9ab94e380b4"],
    "IVsEnumCryptoProviderContainers": ["af855397-c4dc-478b-abd4-c3dbb3759e72"],
    "IVsEnumCryptoProviders": ["f7fc33a9-10da-42be-9f88-9700e583ec33"],
    "IVsEnumDebugName": ["9ad7ec03-4157-45b4-a999-403d6db94578"],
    "IVsEnumDependencies": ["0ed850af-c30a-42ba-aa20-3436adf24937"],
    "IVsEnumDocumentPreviewers": ["b2ca3152-8051-4141-bf11-14a77a4f254e"],
    "IVsEnumExposedObjects": ["d0b027bc-8c1f-11d0-8a34-00a0c91e2acd"],
    "IVsEnumExternalErrors": ["20890a77-47c8-44dd-abc7-3f0920c1b79a"],
    "IVsEnumGUID": ["c7a919cc-79c5-43d7-9b1e-b22e459f6557"],
    "IVsEnumGuids": ["bec804f7-f5de-4f3e-8ebb-dab26649f33f"],
    "IVsEnumHiddenRegions": ["681b0fff-30b4-4578-a911-b67fb049dafa"],
    "IVsEnumHierarchies": ["97a31b3b-b37f-43a5-92f4-71e6e63f80f6"],
    "IVsEnumHierarchyItemsFactory": ["30e5c390-c3e6-40ac-bd1d-7015b1b5f541"],
    "IVsEnumIndependentViews": ["b9040f95-dadb-443a-a3c3-1c442f1bda72"],
    "IVsEnumLayerMarkers": ["8f591607-2a26-4a9d-a6c5-147c2e51e895"],
    "IVsEnumLibraries2": ["fe2bb01d-6eba-4796-adf9-59ec7d100ac2"],
    "IVsEnumLineMarkers": ["35e981f1-77ef-4343-aaa1-8741f38627a2"],
    "IVsEnumNavInfoNodes": ["d2042a65-5e86-4cfa-ad68-f2d6886628d7"],
    "IVsEnumOutputs": ["0a8ac2fb-87bc-4795-8c8b-47e877f48fe8"],
    "IVsEnumSearchProviders": ["6aa5c352-fcbe-45be-af99-fe1f8d2935ec"],
    "IVsEnumSelectedSymbols": ["cac67c59-301a-415d-b269-790f7d4731bc"],
    "IVsEnumServiceReferenceMetadataStorages": ["4c5ee29b-8be6-4a9b-910b-f57ef6a36d6e"],
    "IVsEnumSharedProjectReferences": ["ff92c68e-8503-4e30-a205-3ab4ef219990"],
    "IVsEnumStreamMarkers": ["06e27359-6fee-4ccc-9e8b-afc20c0f662a"],
    "IVsEnumSyntheticRegions": ["67d9795e-cea4-45ff-a3da-055cf78f139a"],
    "IVsEnumTaskItems": ["66638598-522b-4058-9e65-faf237700e81"],
    "IVsEnumTextBuffers": ["74bbee88-ab6e-4276-9bd2-27f566b8bbaf"],
    "IVsEnumTextSpans": ["0f343a75-968b-439e-81d6-0d066e53d28d"],
    "IVsEnumTextViews": ["db685578-e6d4-4d5e-b714-fa344a509abf"],
    "IVsEnumWCFMetadataStorages": ["e9532448-d152-4ad4-be45-8a8a9cbfe14d"],
    "IVsEnumWindowSearchFilters": ["7fd10a54-08d9-4f5b-8142-239f6ef688e4"],
    "IVsEnumWindowSearchOptions": ["ecd23b8c-20eb-4d95-ad05-6a8c87413d10"],
    "IVsErrorItem": ["ce3df110-7630-4d6c-81d5-5cfa12addae6"],
    "IVsErrorItem2": ["96c14ea1-1435-4da9-8ddd-72dfbc2194e9"],
    "IVsErrorList": ["d824a797-62d2-4f60-98f8-4423624bc1bf"],
    "IVsExpansion": ["798cc43b-7714-4dc1-925a-47863c24630d"],
    "IVsExpansionClient": ["9dd0f39a-9502-4068-93b7-b6adab33ecd8"],
    "IVsExpansionEnumeration": ["341e80be-5b26-4dee-a111-32a8373d1b51"],
    "IVsExpansionEvents": ["08107089-905f-47ab-989f-e365c5087402"],
    "IVsExpansionFunction": ["563011a2-1611-48ed-b3b1-189060064f66"],
    "IVsExpansionIntellisenseHost": ["def59d57-46fe-4984-8ca4-5efa3ac5d16e"],
    "IVsExpansionManager": ["ca09e5ea-fee7-4b52-afe6-8ea2ec53f681"],
    "IVsExpansionSession": ["3dfa7603-3b51-4484-81cd-ff1470123c7c"],
    "IVsExposedCOMServer": ["d0b027be-8c1f-11d0-8a34-00a0c91e2acd"],
    "IVsExposedCOMServer2": ["2bc4e9c6-66b3-11d1-b194-00a0c91e2acd"],
    "IVsExposedMainExe": ["d0b027de-8c1f-11d0-8a34-00a0c91e2acd"],
    "IVsExposedObject": ["d0b027bd-8c1f-11d0-8a34-00a0c91e2acd"],
    "IVsExposedObjectProvider": ["d0b027ca-8c1f-11d0-8a34-00a0c91e2acd"],
    "IVsExposedObjectProvider2": ["2bc4e9c5-66b3-11d1-b194-00a0c91e2acd"],
    "IVsExtensibility": ["3c536122-57b1-46de-ab34-acc524140093"],
    "IVsExtensibility2": ["12133bc2-390a-4b30-ad5b-504c1d1c89e7"],
    "IVsExtensibility3": ["a17be28d-6cdc-4c1e-be3e-f0ed067ea3e2"],
    "IVsExtensibleObject": ["d2c45f92-23b5-408b-b41d-d4365fb7eda8"],
    "IVsExternalCompletionSet": ["373a9399-fdf5-4f64-8866-e14b7f2cfff7"],
    "IVsExternalFilesManager": ["e36756de-bb4f-4900-a7f0-e827bdbd2092"],
    "IVsExternalFilesManager2": ["999b1784-a1ee-42eb-b4b6-e928008ffb5d"],
    "IVsFavoritesProvider": ["e8b06f4d-6d01-11d2-aa7d-00c04f990343"],
    "IVsFileBackup": ["7b32bdf9-89d3-4574-b6ac-f2eee9deab18"],
    "IVsFileBackup2": ["4ffa05a4-6c77-4952-ab60-b33e0a6416c5"],
    "IVsFileChange": ["250e1e9a-d2fc-410f-99e4-1aba5b390a9a"],
    "IVsFileChangeEvents": ["f04c8816-7f77-450d-9527-14d0b93da159"],
    "IVsFileChangeEx": ["9bc72973-194a-4ea8-b4d5-afb0b0d0dcb1"],
    "IVsFileChangeEx2": ["00d5f3b7-eae1-4902-93bb-37a111eb8e7f"],
    "IVsFileChangeEx3": ["a4afcb52-b595-43f9-87dd-6eb348181e14"],
    "IVsFileExtensionMappingEvents": ["d1abedeb-5163-4235-ade6-17efaa3a5549"],
    "IVsFileMergeService": ["9003d4ed-2b8e-46b8-9838-78f5ae7b656d"],
    "IVsFileReference": ["deb39e27-ef55-4626-a586-24fbdd918792"],
    "IVsFileReferenceProviderContext": ["1d594baa-05bc-4882-b118-4ca95ad56e41"],
    "IVsFileUpgrade": ["5d2d55f2-e545-4301-9c22-52bc694ca76c"],
    "IVsFileUpgrade2": ["f2394417-a219-4297-bb4e-e66864a6a7db"],
    "IVsFilterAddProjectItemDlg": ["d93a191c-525a-43bc-acfd-7ef494143cf4"],
    "IVsFilterAddProjectItemDlg2": ["61116cff-5319-440a-81ce-5d9f54a610de"],
    "IVsFilterKeys": ["c00858cf-2e17-4323-9d79-0b0cfc39a92f"],
    "IVsFilterKeys2": ["a1ff0d7c-1f51-4a95-b107-ec6ffe2c5794"],
    "IVsFilterNewProjectDlg": ["b10ec465-cec8-41cd-a132-6c1a58f565fb"],
    "IVsFinalTextChangeCommitEvents": ["ce62717c-797d-445f-bc89-1d02c54ccf96"],
    "IVsFindCancelDialog": ["fe7c62a2-c121-4995-9ec1-561b80d2da11"],
    "IVsFindCancelDialog2": ["0c8e8e61-71af-41dd-b213-b98d042f07fe"],
    "IVsFindHelper": ["bb02e777-ec3e-479f-980e-8e36b9617dca"],
    "IVsFindScope": ["0fe9496a-129c-40ee-99d8-7705a6283518"],
    "IVsFindSymbol": ["7ff85070-4667-4532-b149-63a7b205060b"],
    "IVsFindSymbol2": ["7ff85072-4667-4532-b149-63a7b205060b"],
    "IVsFindSymbolEvents": ["18220dbe-1aeb-44ea-a924-f3571d202ef4"],
    "IVsFindSymbolEvents2": ["18220db2-1aeb-44ea-a924-f3571d202ef4"],
    "IVsFindTarget": ["de89d360-c06a-11d2-936c-d714766e8b50"],
    "IVsFindTarget2": ["de311250-1f14-430e-b896-efbddd8abb3e"],
    "IVsFinder": ["d0c79c30-c06a-11d2-936c-d714766e8b50"],
    "IVsFireSolutionEvents": ["a4662d0f-fa14-48ac-8e68-d481ef200627"],
    "IVsFireSolutionEvents2": ["ed6aab26-108f-4b4f-a57b-14d20982713d"],
    "IVsFireUpdateSolutionEvents": ["d8c0b590-65ec-42f7-903f-8ed7c1b3d629"],
    "IVsFontAndColorCacheManager": ["55d3d8c8-f08c-4b31-b70d-fcc52468a5b2"],
    "IVsFontAndColorDefaults": ["5fa2ac9a-3bef-423a-8b5e-6645811bfb6b"],
    "IVsFontAndColorDefaultsProvider": ["3448ff72-b072-435e-9059-29d89c0a3cd0"],
    "IVsFontAndColorEvents": ["f73e1d1e-3d1b-44f0-b736-d59f960b7f9e"],
    "IVsFontAndColorGroup": ["1d42a4c9-57de-4d3e-8010-485adfc1e95b"],
    "IVsFontAndColorStorage": ["40bc7b1a-e625-4da1-86b4-7660f3ccbb16"],
    "IVsFontAndColorStorage2": ["1ee6c79a-b763-42e6-ac95-fd0cc00de315"],
    "IVsFontAndColorStorage3": ["baa340bb-fa34-4ccb-8c81-436566368517"],
    "IVsFontAndColorStorage4": ["cf43601b-fa34-4ccb-8c81-436566368517"],
    "IVsFontAndColorUtilities": ["a356a017-07ee-4d06-acde-fefdbb49eb50"],
    "IVsFormatFilterProvider": ["181237a7-4861-4d6c-8ca1-8a004bea2e8e"],
    "IVsFrameworkMultiTargeting": ["b096b75c-5df5-42c6-888f-a007cceb6635"],
    "IVsFrameworkMultiTargeting2": ["0f0cc2b9-8293-4756-9516-ecb1db326487"],
    "IVsFrameworkRetargetingDlg": ["47f60934-4361-443a-9411-020bc2055608"],
    "IVsFreeThreadedFileChangeEvents": ["a869b861-3f5c-4bd5-a7a2-b1975af11c53"],
    "IVsFreeThreadedFileChangeEvents2": ["2019c53d-105b-4116-8a1a-4703796e5052"],
    "IVsFullTextScanner": ["be93f7b1-f2fd-45b4-938d-1c66441cd421"],
    "IVsGeneratorProgress": ["bed89b98-6ec9-43cb-b0a8-41d6e2d6669d"],
    "IVsGetCfgProvider": ["509d0e4f-a770-44c3-9185-d4f1e4813ad6"],
    "IVsGetScciProviderInterface": ["53544c4d-c1f3-0adc-bea7-ea1a8fecfdd9"],
    "IVsGlobalSearch": ["49429df4-080d-4218-b4cf-9b7ab81116e9"],
    "IVsGlobalSearchCallback": ["c9af73d3-767d-44c8-bfd9-b4f95afe215f"],
    "IVsGlobalSearchTask": ["88fa9f00-b004-4949-83ad-968b419b6ced"],
    "IVsGlobalSearchUI": ["8ed03960-f01b-4a63-a492-7e55ae118d3d"],
    "IVsGlobalSearchUIResultsCategory": ["6b8dc5b9-04cc-49a6-8011-1ff2a6749b2a"],
    "IVsGlobals": ["192ac688-e7c6-4f9d-8180-4b37efbf6f3a"],
    "IVsGlobals2": ["ac735863-23ef-46ed-a3ec-87b58b3df5da"],
    "IVsGlobalsCallback": ["e2cc506a-588b-4f65-a1f0-2244c060abcb"],
    "IVsGlobalsCallback2": ["5447ce90-561e-4c8e-be70-9fd5f89bcfa7"],
    "IVsGradient": ["fd3f680a-d5c1-437a-8a21-8084310bf037"],
    "IVsGroupSelectionDialog": ["2b3b3a2d-4e79-11d3-9477-00c04f683646"],
    "IVsHTMLConverter": ["218d0424-9c53-4ea1-a679-a0aed59b0e4f"],
    "IVsHandleInComingCallDynamicInProc": ["adb942c5-1637-4d76-8635-7a9376f20699"],
    "IVsHasRelatedSaveItems": ["d82269c8-c3db-4bd9-af32-ab140bcfdae3"],
    "IVsHelp": ["4a791148-19e4-11d3-b86b-00c04f79f802"],
    "IVsHelp2": ["78413d2d-0492-4a9b-ab25-730633679977"],
    "IVsHelpAttributeList": ["0a56fb1e-1b2f-4699-8178-63b98e816f35"],
    "IVsHelpEvents": ["507e4490-5a8c-11d3-b897-00c04f79f802"],
    "IVsHelpFavorites": ["d1333514-2b6b-4479-8135-a39e286e146d"],
    "IVsHelpOwner": ["b9b0983a-364c-4866-873f-d5ed190138fb"],
    "IVsHelpProvider": ["a0b29e84-6cfd-490d-9a17-b0bf64d58c55"],
    "IVsHelpSystem": ["854d7ac0-bc3d-11d0-b421-00a0c90f9dc4"],
    "IVsHelpTopicShowEvents": ["d1aac64a-6a25-4274-b2c6-bc3b840b6e54"],
    "IVsHiColorItem": ["16c240b3-4773-43c2-932a-1e8dd2f6f0f8"],
    "IVsHiddenColorableItemInTextEditorCategory": ["fae9c935-0da2-476b-ad3c-d73fb69432d7"],
    "IVsHiddenRegion": ["41e57382-63f9-48e6-9dbd-163d2b14d41b"],
    "IVsHiddenRegionEx": ["fa54dac7-23d3-4c27-b46e-0d2591e5cf0a"],
    "IVsHiddenTextClient": ["ca3f0e7f-cfa6-444e-a3fe-7b3dfad6e5e4"],
    "IVsHiddenTextClientEx": ["225f2f59-39cf-4ae3-a08e-44cf751de700"],
    "IVsHiddenTextManager": ["0e5b1e59-53a7-4636-adbb-0b23c561e293"],
    "IVsHiddenTextSession": ["82b21bae-664b-43e1-95b1-0302805ff7d3"],
    "IVsHiddenTextSessionEx": ["a43c0083-755f-4385-9574-4c14bffc4344"],
    "IVsHiddenTextSessionEx2": ["a40043f7-0865-4322-9308-32133314ad6c"],
    "IVsHierarchicalOutput": ["2d39742a-c729-44c3-ac5b-85785d4c1c22"],
    "IVsHierarchy": ["59b2d1d0-5db0-4f9f-9609-13f0168516d6"],
    "IVsHierarchy2": ["41e82a90-2488-4595-9661-396a1c54b72e"],
    "IVsHierarchyDeleteHandler": ["320e51f6-d238-4bd0-ba89-cca91dbcf411"],
    "IVsHierarchyDeleteHandler2": ["78fd1cbd-387b-4262-bd7b-65c34f86356e"],
    "IVsHierarchyDeleteHandler3": ["3ccb143a-fb8d-455c-8413-9e051b98e557"],
    "IVsHierarchyDirectionalDropDataTarget": ["edf56d0f-44e4-4e24-abc1-3851b568ef26"],
    "IVsHierarchyDropDataSource": ["ac7d8be5-b7f5-400b-b02c-35207672f56b"],
    "IVsHierarchyDropDataSource2": ["d84d04b8-8e0d-4298-ad9c-27f8c0d5484a"],
    "IVsHierarchyDropDataTarget": ["5aa5b118-b3d4-40c5-8739-231ce192850c"],
    "IVsHierarchyEvents": ["6ddd8dc3-32b2-4bf1-a1e1-b6da40526d1e"],
    "IVsHierarchyEvents2": ["0d707b06-f2e8-4556-a98a-d015b67ae3ef"],
    "IVsHierarchyManipulation": ["f3581db8-1dce-4267-8145-b6906ac4d028"],
    "IVsHierarchyManipulationStateContext": ["e9274a0a-cc2f-4ecb-9fd0-f7bb59c7a47f"],
    "IVsHierarchyRefactorNotify": ["fe5fee31-c302-4961-876f-f3c8f853e4f8"],
    "IVsHighlight": ["22212cd2-83ff-11d2-92e6-005345000000"],
    "IVsIME": ["dc7ede19-3dd1-4e20-a7f1-110883ed996f"],
    "IVsImageButton": ["61df9cce-e88e-4fe2-9976-77a4f478e24b"],
    "IVsImageMonikerImageList": ["8660a8eb-6c2e-45c7-920a-73a45ef4de8e"],
    "IVsImageMonikerSource": ["05bcd36e-0c17-4ab6-95ac-70aefa2991ee"],
    "IVsImageService": ["59a26c3b-4e73-4e57-b1c2-f8a44bca3ca1"],
    "IVsImageService2": ["676ce47b-7375-4d53-b0bc-ef9322a2ae62"],
    "IVsImmediateStatementCompletion": ["5ce7ae60-7b66-4301-8892-90bc0b49a89b"],
    "IVsImmediateStatementCompletion2": ["58f03d6e-f781-4e44-bd88-3bde817cbdcd"],
    "IVsInfoBar": ["b8257fe8-9ff5-4f59-a613-02405b32a82a"],
    "IVsInfoBarActionItem": ["25482db2-7bba-49df-841b-55a01d067679"],
    "IVsInfoBarActionItemCollection": ["a0e65f0e-daeb-48b3-aa63-c274605b3eed"],
    "IVsInfoBarHost": ["5580ae4b-c849-41f8-bc4c-fa7d8207f293"],
    "IVsInfoBarTextSpan": ["a513499a-a1d0-4c21-bdee-16761bafd930"],
    "IVsInfoBarTextSpanCollection": ["186dd013-096e-4134-8dc2-a0861607da50"],
    "IVsInfoBarUIElement": ["369c66d9-2a2b-49cf-9e17-83a1679475b6"],
    "IVsInfoBarUIEvents": ["c115d9e6-db96-42b1-ae1a-71a5e3835d53"],
    "IVsInfoBarUIFactory": ["15c4ab06-6c7c-4ecb-85ab-fbc32801da39"],
    "IVsInsertionUI": ["bb73a6e1-b824-42a1-9ab1-2f254386dffc"],
    "IVsInstalledProduct": ["098fca58-5f42-11d3-8bdc-00c04f8ec28c"],
    "IVsIntelliMouseHandler": ["35a96ffb-7ed0-4d76-93ce-49be83a9c91e"],
    "IVsIntellisenseCompletor": ["05dfcf7a-c78a-4e20-aafb-4a0f4d26e0fb"],
    "IVsIntellisenseEngine": ["4371079a-47c3-4b7a-93ae-bfb90fedb8f0"],
    "IVsIntellisenseHost": ["0377986b-c450-453c-a7be-67116c9129a6"],
    "IVsIntellisenseLangTip": ["1e34d422-7120-4d9e-96ff-e880b665d30d"],
    "IVsIntellisenseOptions": ["592346b2-c79c-4d3f-885a-3da61899ee4b"],
    "IVsIntellisenseProject": ["3b83b579-4969-4e12-a964-11ec19cc1503"],
    "IVsIntellisenseProjectEventSink": ["dfb5c0c2-817e-4a19-8c6d-e387fd68b50b"],
    "IVsIntellisenseProjectHost": ["6c62f743-d2d3-46b3-bfbc-f04b54ee3f79"],
    "IVsIntellisenseProjectManager": ["b299765f-1fc2-41a7-bec1-64721d86e658"],
    "IVsInvalidateCachedCommandState": ["0a026971-5a0e-45c9-9479-e62ab18b7de6"],
    "IVsInvisibleEditor": ["2ec892af-9642-417f-b452-8aa1acbfba99"],
    "IVsInvisibleEditorManager": ["14439cde-b6cf-4dd6-9615-67e8b3df380d"],
    "IVsItemTypeResolutionService": ["c6cf64f7-8863-4e50-9df1-892aa83d70d7"],
    "IVsItemTypeResolutionSite": ["45abed49-8d6e-47b8-a0d6-c9f2405817c6"],
    "IVsLangSpecificSyntax": ["0e7798ad-4000-48df-aa1d-851425d45825"],
    "IVsLanguageBlock": ["ba303df5-6283-4961-a4ce-76d4f0662d11"],
    "IVsLanguageClipboardOps": ["2ed7b280-b372-415e-862d-d7d9aeafcd10"],
    "IVsLanguageClipboardOpsEx": ["e36e3541-45d6-4ad8-b5af-ddcb3e02cf3f"],
    "IVsLanguageContextProvider": ["19404d57-f8e4-42f4-9255-b8f889b0c50c"],
    "IVsLanguageDebugInfo": ["f30a6a07-5340-4c0e-b312-5772558b0e63"],
    "IVsLanguageDebugInfo2": ["f1af0080-c965-4e73-8763-3c6309707d59"],
    "IVsLanguageDebugInfo3": ["37f90b98-666a-452f-91f3-c60266aeb13e"],
    "IVsLanguageDebugInfoRemap": ["7e3faae7-f89e-448b-a5eb-c7d73e0685f5"],
    "IVsLanguageDragDropOps": ["b3f95731-540e-4f1c-b6d9-1a7ff6dec782"],
    "IVsLanguageInfo": ["11ddb920-52c7-4237-8610-9fe8bb11656d"],
    "IVsLanguageInfoPackage": ["8c444ef9-5863-4ab1-a1d0-55cc60ac253a"],
    "IVsLanguageLineIndent": ["e5a25e79-4a3c-4fcb-b375-196f5e8d1b2d"],
    "IVsLanguageServiceBuildErrorReporter": ["a7c1346c-6fd6-4ad5-a6fa-ae732aa42040"],
    "IVsLanguageServiceBuildErrorReporter2": ["832aacf8-0848-4f87-b037-ede1b9f11c90"],
    "IVsLanguageTextOps": ["518020a6-8d59-4c80-9aae-015ab9dcc3de"],
    "IVsLastChangeTimeProvider": ["35e88f96-047c-443c-a336-91bb8e2b40ec"],
    "IVsLaunchPad": ["ef16a8b0-41cf-11d1-84a4-00a0c9110055"],
    "IVsLaunchPad2": ["0dbd685a-0a10-4e25-b88e-02e58e60785e"],
    "IVsLaunchPad3": ["96a8c871-bd60-47cd-bcba-d4455806c54f"],
    "IVsLaunchPad4": ["70a675a3-71b7-462b-b7ff-02c6956f2715"],
    "IVsLaunchPadEvents": ["65bc5c20-41d1-11d1-84a4-00a0c9110055"],
    "IVsLaunchPadFactory": ["c21c16a2-1612-4995-b445-f7b1c1657878"],
    "IVsLaunchPadOutputParser": ["a9832932-5f3b-487d-a80d-95115eaddac3"],
    "IVsLayeredTextView": ["60bd661b-133c-4b5c-a335-4b174c5a352f"],
    "IVsLibrary": ["e86128e4-3b1b-4be9-beb6-d30e5bf40850"],
    "IVsLibrary2": ["edd9f8a9-3ffe-4c4c-94f8-610b88e19160"],
    "IVsLibrary2Ex": ["d9c7d24d-7ed2-4a9d-93d1-450426cb27df"],
    "IVsLibrary3": ["4b78a0fc-cfcf-46cb-9363-c13e55165de3"],
    "IVsLibraryMgr": ["dc1b976f-4dc7-4b3d-9ec7-a0de9d39bc13"],
    "IVsLibraryReferenceManager": ["699d5e17-9b22-466b-acfa-2e12cd64e249"],
    "IVsLifetimeControlledObject": ["b3b2e5d4-f03e-4bb9-85f9-61b5f45ac498"],
    "IVsLineAttributes": ["bbb6eaea-4835-4263-bedb-2705607803ca"],
    "IVsLinkCapableUndoManager": ["f747d466-83ca-41d6-a0e8-3f78283d01e7"],
    "IVsLinkedUndoClient": ["33452684-fab0-4f76-b4e9-19ee0b96b4ad"],
    "IVsLinkedUndoTransactionManager": ["f65478cc-96f1-4ba9-9ef9-a575acb96031"],
    "IVsLiteTree": ["c4158c7d-5052-48d9-8643-7a821bb0f50b"],
    "IVsLiteTreeEvents": ["87066898-76ab-45e2-b33c-c5b6b99bb03e"],
    "IVsLiteTreeList": ["1e425321-94cb-448e-8e1e-e1ea2479e5e2"],
    "IVsLongIdleEvents": ["db08a383-3818-4cc9-944f-1a6f4e174c64"],
    "IVsLongIdleManager": ["6b809f03-072b-46e0-b041-df4f4cbaa36c"],
    "IVsMRESearchProvider": ["3ef528c5-c45a-47e0-b9ee-a212a32a99ec"],
    "IVsMRUItemsStore": ["3db65a1a-15b6-4449-b8e6-be31f632dc51"],
    "IVsMSBuildHostObject": ["45f31264-bacd-45a9-ae64-036120c52582"],
    "IVsMSBuildTaskFileManager": ["33372170-a08f-47f9-b1ae-cd9f2c3bb7c9"],
    "IVsMacroRecorder": ["04bbf6a5-4697-11d2-890e-0060083196c6"],
    "IVsMacros": ["55ed27c1-4ce7-11d2-890f-0060083196c6"],
    "IVsManifestReferenceResolver": ["da5c54dc-7f35-4149-8e1c-948deba1ca92"],
    "IVsMatcherDataInfo": ["e7494ebb-5be2-4a5f-b063-8e0853be6d1e"],
    "IVsMenuEditor": ["6fbcb271-b391-4f80-b560-45e650def0a7"],
    "IVsMenuEditorFactory": ["eaf61568-f99b-4bc2-83c4-1dad8ffae9e5"],
    "IVsMenuEditorSite": ["61b34381-6d7c-461d-949a-1ae178cba00d"],
    "IVsMenuEditorTransactionEvents": ["a0e39f2d-1333-4e71-b3ac-fc7bbfd92d9e"],
    "IVsMenuEvents": ["bd868c04-7979-4db0-a2e1-f55490a42640"],
    "IVsMenuEventsService": ["b01b8dee-677e-4adc-87c2-3e2517fb6ef7"],
    "IVsMenuItem": ["dc0a8728-f58b-4444-b9f0-32d6868bf399"],
    "IVsMergeableUIItem": ["0ae3e015-2900-4ddf-87af-cc522ae02284"],
    "IVsMethodData": ["69d2811c-682c-4290-b92e-5dfb823df24c"],
    "IVsMethodDataEx": ["28abe611-dcb8-4684-9793-105c92839aab"],
    "IVsMethodTipWindow": ["794767f6-538a-4cd3-b29e-6c76c79a7c9c"],
    "IVsMethodTipWindow2": ["e9e55e72-13bc-4362-b80a-a2eb33a75809"],
    "IVsMethodTipWindow3": ["5c17e526-0f7b-40fc-8e94-e12adc618a02"],
    "IVsMonitorSelection": ["55ab9450-f9c7-4305-94e8-bef12065338d"],
    "IVsMonitorSelection2": ["692e4f21-1ef2-41b1-9116-eed8daa79e7f"],
    "IVsMonitorUserContext": ["9c074fdb-3d7d-4512-9604-72b3b0a5f609"],
    "IVsMouseCursorProvider": ["e32f08db-6364-4276-8ea8-baa6752f7807"],
    "IVsMultiItemSelect": ["96973fc6-c2e4-4cb9-8baf-7f7cd6dbc604"],
    "IVsMultiViewDocumentView": ["0f4b629e-8c34-4b5e-a450-f9f8dcfe3009"],
    "IVsNavInfo": ["61772db8-2d5b-49cb-9ce8-891459921f7f"],
    "IVsNavInfo2": ["916ba1dd-4c84-431e-9b06-fc80f9496fcf"],
    "IVsNavInfoNode": ["1bd1dd01-1246-4694-9da7-8adcd9ca3275"],
    "IVsNavigableLocationResolver": ["82d04b51-1626-43aa-b57f-9b23d4280333"],
    "IVsNavigateToService": ["6ab63b41-fa6d-4fdd-9636-4e2e408ebd49"],
    "IVsNavigateToService2": ["6606a1ca-7810-4bb5-a036-725e90a06931"],
    "IVsNavigationTool": ["fdaeb434-f941-4370-9b89-325249efec48"],
    "IVsNewDocumentStateContext": ["44dd5120-6dfb-4590-a5cb-1066114996ca"],
    "IVsNonLocalProject": ["1a1dfc92-f6ec-4fef-a26f-6d0da546f32a"],
    "IVsNonSolutionProjectFactory": ["8cbffbbe-241e-4b9c-9926-c06f7374386c"],
    "IVsObjBrowser": ["0df98187-fd9a-4669-8a56-727910a4866c"],
    "IVsObjectBrowserDescription2": ["0587fed2-8072-401f-9090-bca98c44bbf7"],
    "IVsObjectBrowserDescription3": ["2bcd7a6a-d251-4286-9a61-bdedde91114f"],
    "IVsObjectList": ["c48f7ab9-8966-4138-b602-14c5eb8bd857"],
    "IVsObjectList2": ["e37f46c4-c627-4d88-a091-2992ee33b51d"],
    "IVsObjectListOwner": ["5801db45-16aa-4f08-bb57-82a070b79512"],
    "IVsObjectManager": ["01e95d2e-2d20-4662-9de7-4c1c35524260"],
    "IVsObjectManager2": ["6a0392e4-68e8-4fbc-afcf-85155533e48e"],
    "IVsObjectManagerEvents": ["7c4c8065-fb7e-45d8-9b50-940a8fcb5876"],
    "IVsObjectSearch": ["44a39218-81bd-4669-9de0-f282a8baee34"],
    "IVsObjectSearchPane": ["bba468e0-2d3d-450e-af95-ccb9de1162e8"],
    "IVsOpenProjectOrSolutionDlg": ["09b17094-f50c-40e0-8ab5-57c22a786596"],
    "IVsOutliningCapableLanguage": ["b97d5c98-0507-40fa-bf89-ce4f73eba651"],
    "IVsOutliningSession": ["9a436975-a86a-4459-a350-b05604b53309"],
    "IVsOutput": ["0238dcc5-62d6-4dac-a977-2c6a36c502f4"],
    "IVsOutput2": ["653bb330-1205-4cf8-8f88-723d6e199a01"],
    "IVsOutputGroup": ["fcc03d95-7c2e-4398-aaae-0f4b56104fc8"],
    "IVsOutputGroup2": ["06a3b841-fbea-46cb-81ea-36db4d005545"],
    "IVsOutputWindow": ["533fad11-fe7f-41ee-a381-8b67792cd692"],
    "IVsOutputWindow2": ["f4deb52c-53a3-42fd-a039-3493f09e53fc"],
    "IVsOutputWindow3": ["35dbfd79-2b63-4355-a828-8e3d6d440687"],
    "IVsOutputWindowPane": ["9b878a55-296a-404d-80c4-1468bb7cdc43"],
    "IVsOutputWindowPane2": ["4a65481b-49cf-4fcb-a891-32ae435ec941"],
    "IVsOutputWindowPane3": ["d3d762d1-711a-4a4e-af75-670f5160c38d"],
    "IVsOutputWindowPaneNoPump": ["5c552b00-38fb-489e-a544-d1ad948d3213"],
    "IVsOverrideTextViewAccessibilityState": ["805db878-bc47-4149-862a-a12725dbc434"],
    "IVsOwnedProjectFactory": ["e4197123-1086-4d51-b2d5-903f4d61c5aa"],
    "IVsPackage": ["d4f3f4b1-e900-4e51-adb3-d532348f83cb"],
    "IVsPackage2": ["0130701b-b0be-474b-b4b6-35babb2008f1"],
    "IVsPackageDefinedTextMarkerType": ["c70f1528-1a66-403f-ad42-f60f9d413e05"],
    "IVsPackageDynamicToolOwner": ["7db81657-7722-4407-b675-9f4a6feeea15"],
    "IVsPackageDynamicToolOwnerEx": ["91c30f81-e72a-4997-9b07-a0aecb8c9169"],
    "IVsPackageExtensionProvider": ["1fc6af83-7f43-467e-b2c4-28e2b1b376ab"],
    "IVsPackageInfo": ["9248b73c-1a06-414e-a926-9fea3f38a375"],
    "IVsPackageInfoQueryService": ["1669c91d-923e-4cfe-82c5-e99075abb0ef"],
    "IVsPackageLoadEvents": ["21861181-88b1-410a-bca8-441fb3f3f1fc"],
    "IVsPackageSelectedInfo": ["9c268ebf-a8a0-4226-b1e2-b8b8badb0544"],
    "IVsPackageStaticExData": ["64ac2451-bd18-11d1-87b5-00a0c91e2a46"],
    "IVsParentHierarchy": ["8fe0e50a-785a-4a50-8edb-1d054d68ef87"],
    "IVsParentProject": ["79001cd1-69c6-45b8-8f7a-dccce0469e8d"],
    "IVsParentProject2": ["d63bb7d7-d7a0-4c02-aa85-7e9233797cdb"],
    "IVsParseCommandLine": ["366704d5-85d0-4f7d-b267-90fa4dd37d5b"],
    "IVsParseCommandLine2": ["7837df15-0604-4ea1-8515-cd5a30972482"],
    "IVsPathVariableResolver": ["17a4ef87-4472-47f6-b066-fe96036678d0"],
    "IVsPerPropertyBrowsing": ["0ff510a3-5fa5-49f1-8ccc-190d71083f3e"],
    "IVsPersistConnectedServices": ["9c68f455-ff06-43d0-8473-195efafcb833"],
    "IVsPersistDocData": ["d5d49c61-1c0b-4ea1-9adb-a79fb1dbc7b5"],
    "IVsPersistDocData2": ["9d71890d-090c-4b67-80c3-4cb55c600b60"],
    "IVsPersistDocData3": ["dec057f4-46d1-4bd3-9d63-21e5e3f19368"],
    "IVsPersistHierarchyItem": ["18933f6e-0937-4888-8c77-ec8a393b21ea"],
    "IVsPersistHierarchyItem2": ["5a494367-df56-4062-8eda-54e2c1ff42bc"],
    "IVsPersistPropertyStream": ["d0b027cd-8c1f-11d0-8a34-00a0c91e2acd"],
    "IVsPersistSolutionOpts": ["53ba0f89-24dd-46e1-a7d6-ed24c039fbc4"],
    "IVsPersistSolutionOpts2": ["d79ca884-27fc-43f4-a51b-d0b068b312c9"],
    "IVsPersistSolutionProps": ["0d0e68ea-c910-45a7-8c24-7bbfa7d2d201"],
    "IVsPersistSolutionProps2": ["8d2ec486-8098-4afa-ab94-d270a5ef08ce"],
    "IVsPersistentTextImage": ["c47ffd1e-d84e-43a5-8cbe-e4ad06be795b"],
    "IVsPlatformReference": ["6756f947-41fe-46c7-88f1-5cbe4606a5a0"],
    "IVsPlatformReferenceProviderContext": ["e19bda1e-41e3-47ba-8308-82d18f399d73"],
    "IVsPlatformReferenceProviderContext2": ["65429265-78cc-4772-9826-5bf9e2295c62"],
    "IVsPlatformReferenceProviderContext3": ["2ee3c85d-04d8-461b-b7ac-8e4f9c59dc97"],
    "IVsPrefetchLoadProgress": ["2bd6379a-cd38-4ff7-bcc5-c2968b2fe48d"],
    "IVsPrefetchLoadProgress2": ["c917ecd8-ed08-49be-97f2-6c994bf32072"],
    "IVsPrefetchProjectFactory": ["c9635d64-f4ba-4162-a9e2-008d5789e61f"],
    "IVsPreliminaryTextChangeCommitEvents": ["7f57b996-148b-46de-a261-b1a02e6d9dba"],
    "IVsPreviewChangesEngine": ["6de3e607-1e2c-4f56-b4a6-bcaf63a0bb9f"],
    "IVsPreviewChangesList": ["b334f714-993b-4902-89e0-792213b538db"],
    "IVsPreviewChangesService": ["af142b19-fb37-40c0-9c28-6617adbffac7"],
    "IVsPrioritizedSolutionEvents": ["925e8559-17df-494c-87da-bbee251702de"],
    "IVsPrioritizedSolutionEventsSink": ["6e8674b2-efa9-4cd6-9743-cc7a549bb0eb"],
    "IVsProfferCommands": ["8cc0cde1-c16a-4749-99af-6f7523c34a57"],
    "IVsProfferCommands2": ["c508b13c-06c5-40c7-b405-d327d4f8e268"],
    "IVsProfferCommands3": ["3a83904d-4540-4c51-95a7-618b32a9a9c0"],
    "IVsProfferCommands4": ["3edbd520-6748-43a4-8be4-cadab7472cf6"],
    "IVsProfilableProjectCfg": ["c486a0c9-c170-4cad-a2a2-292ee54969b5"],
    "IVsProfileDataManager": ["466efaf6-f832-4079-83cd-4bbb02719c1d"],
    "IVsProfileSettingsFileCollection": ["0faf274a-3898-445a-822f-7d42927efef9"],
    "IVsProfileSettingsFileInfo": ["8e8e55a9-4111-4808-a0d0-7f067fb3a62f"],
    "IVsProfileSettingsTree": ["23b6fed1-c3cb-4006-bad0-64a7eb61df39"],
    "IVsProfilerAttachTargetInfo": ["85de5afd-0624-45ed-b0b7-53666bebdfdb"],
    "IVsProfilerLaunchBrowserTargetInfo": ["8dfd2dfc-d11e-4430-b311-1d4c732c45c3"],
    "IVsProfilerLaunchExeTargetInfo": ["9df0cde8-5971-408a-b76f-993a8a78eee0"],
    "IVsProfilerLaunchTargetInfo": ["5e580d53-b85d-41ab-a8f8-b4cd5517ec49"],
    "IVsProfilerLaunchWebServerTargetInfo": ["0d9fab5b-0b37-44d5-b6c2-a66ef7fe7f6c"],
    "IVsProfilerLauncher": ["d7dc8c01-afff-45fe-b338-426e8072f6b7"],
    "IVsProfilerTargetInfo": ["11f356e3-2bdc-4ab4-acd2-48db043951aa"],
    "IVsProfilesManagerUI": ["d06b7887-893c-439c-a231-8bf3e5335e30"],
    "IVsProject": ["cd4028ed-c4d8-44ba-890f-e7fb02a380c6"],
    "IVsProject2": ["4af886c3-7796-4c81-a174-4a87080dee58"],
    "IVsProject3": ["1c11116e-4ff2-4a80-82dc-69f95042e0a4"],
    "IVsProject4": ["12a0d88d-d8fe-4637-8350-214b5c29de31"],
    "IVsProject5": ["b04f747b-48ee-4ec7-8a2e-e9417f6214c3"],
    "IVsProjectBuildMessageEvents": ["7fbea20b-68a9-48ec-9032-114268286b24"],
    "IVsProjectBuildMessageReporter": ["359bf057-da83-455c-9b72-ec00cb478c85"],
    "IVsProjectBuildSystem": ["eb0718c0-e050-4657-872b-e845cd4f617b"],
    "IVsProjectCfg": ["2dbdf061-439b-4822-9727-ca3ed918b658"],
    "IVsProjectCfg2": ["a7ade7a0-f286-4c03-8137-d6d0ef3d6848"],
    "IVsProjectCfgDebugTargetSelection": ["255b9803-ba83-421b-924e-cde7faaa86a3"],
    "IVsProjectCfgDebugTypeSelection": ["1021a0ee-5e4e-4a9b-acda-b607fef3ab65"],
    "IVsProjectCfgProvider": ["803e46e2-6a0d-4d5d-9f84-6ce1248b068d"],
    "IVsProjectClassifierInfo": ["c28ffcea-421b-46ea-bac8-d8dc225ddaca"],
    "IVsProjectDataConnection": ["8e40d748-f682-4951-b465-16d0c252a69d"],
    "IVsProjectDebugTargetProvider": ["4c5f0ceb-5ac9-4ea4-85e2-72e088ea75a8"],
    "IVsProjectDeployDependency": ["b4d28a5b-063d-4622-b0c7-c3ddebfcdccf"],
    "IVsProjectFactory": ["33fcd00a-bd45-403c-9c66-07ba9a923501"],
    "IVsProjectFactory2": ["55e1a1e1-ecac-46e0-bde3-1e35bc68c31c"],
    "IVsProjectFaultResolver": ["c94fb6dd-91aa-495f-b399-51f1428723fc"],
    "IVsProjectFileReloadManagerEvents": ["2ae1e600-a58a-4a31-a534-afcb7200542c"],
    "IVsProjectFilter": ["d0b027d5-8c1f-11d0-8a34-00a0c91e2acd"],
    "IVsProjectFlavorCfg": ["3bffc423-6c82-46c0-af2a-79a3ed3eda93"],
    "IVsProjectFlavorCfgOutputGroups": ["52f50fac-b245-4a81-9a02-dbf8f115389b"],
    "IVsProjectFlavorCfgProvider": ["2b81d5f8-f8bd-4a65-8f51-f3bfcd51a924"],
    "IVsProjectFlavorReferenceManager": ["b42565fe-1fe7-418e-b3f0-cf56c5450e80"],
    "IVsProjectFlavorReferences": ["66db9803-1019-48ca-99f2-dad69e49532c"],
    "IVsProjectFlavorReferences2": ["54be5d82-5886-4ef1-97c0-81716586fb8a"],
    "IVsProjectFlavorReferences3": ["005431fc-cf9c-4154-9b28-ec975d88948d"],
    "IVsProjectFlavorUpgradeViaFactory": ["d717b926-12ee-4285-9123-522ed54c4859"],
    "IVsProjectFlavorUpgradeViaFactory2": ["9b790cc4-a83d-4d55-b89d-c3ded06e8d31"],
    "IVsProjectMRU": ["d60edeea-3629-42cc-baaf-9ac52e63eeaf"],
    "IVsProjectReference": ["49c80755-ea7f-4cce-9a9e-41e3c9efa753"],
    "IVsProjectReferenceProviderContext": ["3a77035e-cb2a-4582-b60e-1123207f2029"],
    "IVsProjectResources": ["3f819030-50cf-4b72-b3fc-b3b9bfbbee69"],
    "IVsProjectSelector": ["dfad4c39-fcb2-4bdf-a389-2ea6db28f062"],
    "IVsProjectServerHost": ["c044f284-ca0b-41f9-a4c0-e2b650234f30"],
    "IVsProjectSpecialFiles": ["7ceb5f64-3af3-4fc4-843d-e8e61f43b13c"],
    "IVsProjectSpecificEditorMap": ["4b2bebaa-ba1e-4479-8720-8ce19d276098"],
    "IVsProjectSpecificEditorMap2": ["f84a6d1d-f305-4055-a02c-a642b871bb20"],
    "IVsProjectStartupServices": ["82780f79-a3ed-4b7f-90c0-5fee14cbb53e"],
    "IVsProjectTextImageProvider": ["82a40d77-d2d4-4c93-ab11-8d50adf02b1e"],
    "IVsProjectUpgrade": ["75661d39-f5da-41b9-abda-9cf54c6b1ac9"],
    "IVsProjectUpgradeViaFactory": ["0dba1379-5d67-4a6c-8c06-a5795af7364b"],
    "IVsProjectUpgradeViaFactory2": ["e5f6cff6-c3e1-45bc-9559-c03f94fdf15b"],
    "IVsProjectUpgradeViaFactory3": ["943ce488-176f-457b-8c88-3502c775501c"],
    "IVsProjectUpgradeViaFactory4": ["9be1f919-4c3c-45b7-9816-e04053f8ecc6"],
    "IVsPropertiesInfo": ["c0975213-3d73-44e1-8b46-4578e16d4457"],
    "IVsPropertyBag": ["aaeeac4c-3bf3-492c-927d-84ab7d93d6df"],
    "IVsPropertyBrowser": ["b1e402b6-d8e0-4422-9164-421fee099f00"],
    "IVsPropertyFileIn": ["805b0e0a-7122-4855-962f-887e46d2f112"],
    "IVsPropertyFileOut": ["3018e511-6282-41fc-8e1f-77ab1bdde523"],
    "IVsPropertyInterfaceBroker": ["d0b027d8-8c1f-11d0-8a34-00a0c91e2acd"],
    "IVsPropertyPage": ["237abd5f-9537-4aee-a893-72ab9a0ea8e8"],
    "IVsPropertyPage2": ["6fc6a958-b2e7-441b-823c-10ea30b24eec"],
    "IVsPropertyPageFrame": ["bc039978-213e-4ca0-81c4-10edf2af2d66"],
    "IVsPropertyPageNotify": ["48002e6a-ce3c-4c7e-9d10-3d46a3af5881"],
    "IVsPropertyStreamIn": ["ec9abafb-e744-44b5-8771-0b875ee6fc5c"],
    "IVsPropertyStreamOut": ["bf283741-e0ad-49c0-bea4-1e267e52208f"],
    "IVsProvideColorableItems": ["100b9a33-905c-4312-b2a2-452189f19ab9"],
    "IVsProvideComponentEnumeration": ["4df7bba0-660f-11d3-85fd-00c04f6123b3"],
    "IVsProvideDebuggingInfo": ["665aadc9-dff5-4ddf-a119-60d2eea051c6"],
    "IVsProvideTargetedToolboxItems": ["cdf20ee2-b038-42ea-aa42-e1caaffcdca5"],
    "IVsProvideUserContext": ["997d7904-d948-4c8b-8bab-0bda1e212f6e"],
    "IVsProvideUserContext2": ["3931def1-8200-481f-a6c2-a4740de84658"],
    "IVsProvideUserContextForObject": ["f98ccc8a-9c5f-41eb-8421-711c0f1880e6"],
    "IVsProvisionalItem": ["9977da6b-0c38-4565-a38a-71cf8cd1ef53"],
    "IVsPublishableProjectCfg": ["816b2fbe-5c62-439e-8f67-8f0d5d82bc67"],
    "IVsPublishableProjectStatusCallback": ["279398e7-6fc1-40a2-9fb3-c321db469e9b"],
    "IVsQueryDebuggableProjectCfg": ["ce25fcee-9e4d-4ec8-856e-38e2bdb2e13b"],
    "IVsQueryDebuggableProjectCfg2": ["7666c707-8b4b-461c-b555-348c94cb79df"],
    "IVsQueryEditQuerySave": ["53544c4d-7e28-4d0c-a00f-3446801350ce"],
    "IVsQueryEditQuerySave2": ["53544c4d-5984-11d3-a606-005004775ab1"],
    "IVsQueryEditQuerySave3": ["53474c4d-6279-30c2-b4b4-005004775ab4"],
    "IVsQueryLineChangeCommit": ["72e67329-8765-4586-8b15-0b445e6f3b57"],
    "IVsQueryUndoManager": ["6ed9a1cd-e8fd-460a-8690-dd6e5e44b02d"],
    "IVsQueryUndoUnit": ["036fbe7a-9abd-4894-b7f6-1ed3bd0ee247"],
    "IVsReadOnlyViewNotification": ["fc62b6c7-6e71-44c6-8dd8-016fd5952612"],
    "IVsRefactorNotify": ["130497e3-5cdb-4f29-9804-a2af805016d7"],
    "IVsReference": ["ef0757d6-678e-45db-8251-8aa39cc8320c"],
    "IVsReferenceManager": ["88e00a52-3b22-45c4-8fa0-321319dda03f"],
    "IVsReferenceManager2": ["b7821f84-d9c8-48f9-93c4-3c4c98a477a1"],
    "IVsReferenceManagerUser": ["3ad23841-9a64-4582-b226-e4cfe3942446"],
    "IVsReferenceManagerUserReloadRequired": ["400c66c9-5272-418c-9113-1c9bdfd7d7ba"],
    "IVsReferenceProviderContext": ["5b99fa62-eeab-4048-accb-7a8eb569cbf5"],
    "IVsRegisterCustomFindScope": ["72f08bd4-412b-4f54-8b7c-02997c483981"],
    "IVsRegisterDataSourceFactories": ["113592fe-dee5-48ad-9d66-5b26794a4003"],
    "IVsRegisterEditors": ["78036a8d-a04c-43e4-8bc0-846e63afa9a2"],
    "IVsRegisterFindScope": ["08363d65-c178-4484-a293-d148173dd750"],
    "IVsRegisterNewDialogFilters": ["9455bdb5-2a5a-45f1-a558-72b88a78e6e3"],
    "IVsRegisterPrefetchProjectFactory": ["46f1c80f-ea5d-47a0-806f-4c0a916e1396"],
    "IVsRegisterPriorityCommandTarget": ["ed77d5ec-b0de-4721-bdc6-38dcbe589b4c"],
    "IVsRegisterProjectDebugTargetProvider": ["4c5f0cea-5ac9-4ea4-85e2-72e088ea75a8"],
    "IVsRegisterProjectSelector": ["b042860a-5a69-4259-bc88-f1c79ae16c50"],
    "IVsRegisterProjectTypes": ["f08400bb-0960-47f4-9e12-591dbf370546"],
    "IVsRegisterScciProvider": ["53544c4d-c1f3-4fa8-bea7-ea1a8fecfdd9"],
    "IVsRegisterUIFactories": ["a146bac8-4337-4d8f-8c51-9b5147dbcb8a"],
    "IVsRelativePathResolver": ["26831fb7-7c55-4ab1-b4ad-e37783f2d4a8"],
    "IVsReportExternalErrors": ["96f0cabd-db51-428f-a42d-c756057d35c2"],
    "IVsResourceManager": ["f0d7a6f0-c722-4ab6-a5d9-c7ff13027410"],
    "IVsResourceManager2": ["2597dabc-bba7-4758-9a33-8894157ad74a"],
    "IVsResourceView": ["ad3b499c-281d-46bb-b43b-071413528c04"],
    "IVsRunningDocTableEvents": ["bea6bb4f-a905-49ca-a216-202df370e07e"],
    "IVsRunningDocTableEvents2": ["15c7826f-443c-406d-98f8-55f6260669ec"],
    "IVsRunningDocTableEvents3": ["376ed667-f576-458f-b991-2cfd3ebc7b08"],
    "IVsRunningDocTableEvents4": ["79a342f3-d637-4d54-83dc-ddd511743a49"],
    "IVsRunningDocTableEvents5": ["ee37a122-55a0-4d1d-970a-78d5eecad16e"],
    "IVsRunningDocTableEvents6": ["f5c9a40a-61de-46aa-b025-8cc83048e13f"],
    "IVsRunningDocumentTable": ["a928aa21-ea77-47ac-8a07-355206c94bdd"],
    "IVsRunningDocumentTable2": ["cd68d3cf-7124-4d3a-afed-3e305c2b7d0b"],
    "IVsRunningDocumentTable3": ["30525828-bd80-4bdf-9255-d1e0e1c0f34f"],
    "IVsRunningDocumentTable4": ["86a4da78-d580-4ae4-a1be-f805bc663e04"],
    "IVsRunningDocumentTable5": ["dd4e3397-637c-4597-b337-045bb3ff24b5"],
    "IVsSQLCLRReferences": ["7e6f344d-52c0-4edc-814b-16c6de4ae9b4"],
    "IVsSQLCLRReferencesUpdateCallback": ["7e6f344e-52c0-4edc-814b-16c6de4ae9b4"],
    "IVsSaveOptionsDlg": ["c3e2ed14-4e64-4c26-84d7-68ccd071a0c8"],
    "IVsSccAddWebProjectFromSourceControl": ["53544c4d-724a-46c8-8d01-6d4518ca118c"],
    "IVsSccControlNewSolution": ["753d3585-2077-4e60-8ec5-96ee793f3d1a"],
    "IVsSccEngine": ["53544c4d-f82c-11d0-8d84-00aa00a3f593"],
    "IVsSccEnlistmentPathTranslation": ["53544c4d-01f8-11d0-8e5e-00a0c911005a"],
    "IVsSccGlyphs": ["9c82ca77-a583-4fd1-8c15-0b3995d9ab2f"],
    "IVsSccGlyphs2": ["b3c3f5e2-7460-4ad6-9581-3a24a3dfe417"],
    "IVsSccManager": ["53544c4d-0f05-4735-8aac-264109cf68ac"],
    "IVsSccManager2": ["53544c4d-b927-4320-b9da-13d2cb3ea93b"],
    "IVsSccManager3": ["224209ed-e56c-4c8d-a7ff-31cf4686798d"],
    "IVsSccManagerTooltip": ["53544c4d-df28-406d-81da-96deeb800b64"],
    "IVsSccOpenFromSourceControl": ["a341396a-1b4a-4164-8e6e-bddc527c861c"],
    "IVsSccPopulateList": ["53544c4d-f8cf-11d0-8d84-00aa00a3f593"],
    "IVsSccProject": ["53544c4d-cd19-4928-a834-afcd8a966c36"],
    "IVsSccProject2": ["53544c4d-ac92-49ac-9172-603e01fa483a"],
    "IVsSccProjectEnlistmentChoice": ["53544c4d-06f8-11d0-8e5e-00a0c911005a"],
    "IVsSccProjectEnlistmentFactory": ["53544c4d-00f8-11d0-8e5e-00a0c911005a"],
    "IVsSccProjectEvents": ["4c3f73b6-9939-4a4b-8d25-326a8abed50f"],
    "IVsSccProjectFactoryUpgradeChoice": ["53544c4d-e3a4-4938-a5ec-6593a79cf27c"],
    "IVsSccProjectProviderBinding": ["53544c4d-02f8-11d0-8e5e-00a0c911005a"],
    "IVsSccProvider": ["49440575-e33c-4169-9735-f3fd5ae54d8d"],
    "IVsSccProviderFactory": ["53544c4d-03f8-11d0-8e5e-00a0c911005a"],
    "IVsSccProviderRegisteredSettings": ["beb3bc40-5c07-4a90-86dd-6a9977b78867"],
    "IVsSccProviderSettings": ["74995c8c-f619-4638-ac6c-371e98731d6c"],
    "IVsSccToolsOptions": ["53544c4d-304b-4d82-ad93-074816c1a0e5"],
    "IVsSccTrackProjectEvents": ["4871bdef-3b4a-49ce-80cf-51502fa9a464"],
    "IVsSccVirtualFolders": ["53544c4d-0adc-4f55-bd82-7e8383c02cfb"],
    "IVsScriptJmcProjectControl": ["b2908bbe-c9a6-4aa7-b258-3db0dda1d688"],
    "IVsScriptJmcUserSettingsProvider": ["ceaa99fb-69e7-426d-b3d4-ca1bb1b6bdc3"],
    "IVsSearchCallback": ["face369a-f6ab-4ea8-8fa5-e50e326a7cfb"],
    "IVsSearchFilterToken": ["4abdc811-9cc0-4e07-b34a-442d6cc2c29a"],
    "IVsSearchItemDynamicResult": ["412a7ebb-c4bd-46cd-b17d-97e337b6f514"],
    "IVsSearchItemResult": ["b03b8a31-6bf6-46b1-ac58-0c973f05ffc8"],
    "IVsSearchProvider": ["e85fdfc2-a874-4871-88a3-a2e904183a05"],
    "IVsSearchProviderCallback": ["8dc9cf50-ce22-40d4-a7e2-c5073b506a03"],
    "IVsSearchQuery": ["6223b428-b465-4b2b-864a-d0ffbc4741fd"],
    "IVsSearchQueryParser": ["7e6c0144-256b-46b5-b4a7-0005c86cf85f"],
    "IVsSearchTask": ["d709f307-68db-4600-9ee2-d9f11ba1e005"],
    "IVsSearchToken": ["db478cc1-3e66-467a-a893-ede208e18ca1"],
    "IVsSelectedSymbol": ["9d86535e-5fe7-4aaf-8846-f1fb5556109a"],
    "IVsSelectedSymbols": ["8a8921be-42c7-4984-82e9-c68b12c2b22e"],
    "IVsSelectionEvents": ["82871589-d680-4d86-b969-9d1102b00f6f"],
    "IVsSerializeNavigationItem": ["00757da7-aae5-4fe4-9fdf-2e85364e228b"],
    "IVsServiceInfo": ["5b5ac77c-213b-4642-9d20-5bf902649356"],
    "IVsServiceInfo2": ["0161283a-d9b6-4c8e-8c9b-121d0e413dd1"],
    "IVsServiceInfoQueryService": ["932aa966-86be-44d9-8403-2f4a2c17adb1"],
    "IVsServiceReferenceMetadataStorage": ["0743635e-4f48-457c-9323-0af36982fa28"],
    "IVsServiceReferenceMetadataStorageEvents": ["c6df0d84-83e9-4e07-ba41-903a03763c5b"],
    "IVsServiceReferenceMetadataStorageProvider": ["6d076165-1aff-4d68-9bd1-fa09adf57d34"],
    "IVsServiceReferenceMetadataStorageProviderEvents": ["dbfecce0-41a5-41a6-ad3b-67286c457a4f"],
    "IVsSetSpanMappingEvents": ["98ceedbd-07a4-4376-ade8-5a46b7f5f384"],
    "IVsSetTargetFrameworkWorkerCallback": ["52b20422-91b2-4fb9-97fe-90d6fa334741"],
    "IVsSettingsErrorInformation": ["33d90d1c-2665-4eec-9194-a79afd63275f"],
    "IVsSettingsManager": ["94d59a1d-a3a8-46ab-b1de-b7f034018137"],
    "IVsSettingsReader": ["38c38501-1428-4abb-8b27-2f0e1e6dd757"],
    "IVsSettingsStorageContainer": ["0b578bca-3358-441a-8ea5-9ae07182bebb"],
    "IVsSettingsStore": ["6b43326c-ab7c-4263-a7ef-354b9dcbf3d8"],
    "IVsSettingsStore2": ["3366139a-0829-4c1d-9818-95d4b63dd38b"],
    "IVsSettingsWriter": ["0f1cf980-afc6-406e-958d-7f24287e3916"],
    "IVsSetupCompositionService": ["ecab2b82-92fe-4671-a822-908a389541f6"],
    "IVsSetupCompositionService2": ["d9f18e9f-9842-4d1b-adde-8e5601332038"],
    "IVsSetupCompositionService3": ["f902bfa6-b9ed-4d0c-9c8a-fcb1ddd442d2"],
    "IVsSetupManifestEvents": ["842f4c6d-85fb-4580-b811-cfedc7daf1b1"],
    "IVsSetupPackageInfo": ["c806da70-8757-46e1-b46f-3e668d9e1463"],
    "IVsSharedAssetsProject": ["ecc3cab9-ffd8-4aba-b0d3-25a505cd3b19"],
    "IVsSharedAssetsProjectEvents": ["389526a8-4344-4a8b-acda-1f180058e57f"],
    "IVsSharedMSBuildFilesManagerHierarchy2": ["cfcb9b0d-59ad-4bd8-b288-a2539b54633a"],
    "IVsSharedProjectQueryCanBeReferenced": ["684863a4-bc6e-467c-8218-5c84cab616da"],
    "IVsSharedProjectReference": ["dd928d98-26e0-4255-a3ce-3ba866296f8b"],
    "IVsSharedProjectReferenceProviderContext": ["c4385811-f65e-4049-a60f-20b9ab884bbc"],
    "IVsSharedProjectReferencesHelper": ["bb0d419c-04cd-457a-bc3c-954f447ec806"],
    "IVsShell": ["fd9dc8e3-2ffc-446d-8c50-99ca4a3d2d1c"],
    "IVsShell2": ["f3519e2d-d5d2-4455-b9f4-5f61f993bd66"],
    "IVsShell3": ["07bdc931-e86d-4531-a59c-20c614d6e492"],
    "IVsShell4": ["7ab9748c-7f33-4996-8b00-091b562950a5"],
    "IVsShell5": ["0963c9c9-1083-4baf-b3f0-55139f708821"],
    "IVsShell6": ["d111db4b-584e-4f93-bcec-5f7e0990e9e7"],
    "IVsShell7": ["912079dd-342a-4a53-ab7f-752553679a47"],
    "IVsShellContext": ["5e819c22-a727-11d2-aa82-00c04f990343"],
    "IVsShellPropertyEvents": ["7a54fea1-e786-4a30-8f38-45b3703e50dd"],
    "IVsShortcutManager": ["78201465-554e-4a7b-998f-443156fd71d3"],
    "IVsSimpleBrowseComponentSet": ["b027f23c-e6b9-415c-acf0-3d7cfafcc662"],
    "IVsSimpleDocFactory": ["9d0ca895-4f60-4de8-980d-06aad61ce88c"],
    "IVsSimpleLibrary2": ["2f328444-6e74-48b4-8b95-08015f9d65d9"],
    "IVsSimpleObjectList2": ["a0c6d693-8226-4ca6-ab03-557aa5a33f75"],
    "IVsSimplePreviewChangesList": ["c42d228e-b275-4fe6-8469-f3184663b883"],
    "IVsSingleFileGenerator": ["3634494c-492f-4f91-8009-4541234e4e99"],
    "IVsSingleFileGeneratorFactory": ["3ada7a5d-591e-4c9e-8b87-5e33f8e64aa8"],
    "IVsSmartOpenScope": ["677d16f2-982e-49e6-acdb-797991764ad8"],
    "IVsSmartTagData": ["8c2a8a68-8844-4e55-b0a1-805b4da0deb2"],
    "IVsSmartTagTipWindow": ["e2dece2a-3a77-4fd3-a4b2-fa5ec4ea41d9"],
    "IVsSmartTagTipWindow2": ["4c5b474b-b539-4a60-9819-82a5bed76c60"],
    "IVsSolution": ["7f7cd0db-91ef-49dc-9fa9-02d128515dd4"],
    "IVsSolution2": ["95c6a090-bb9e-4bf2-b0be-f1d04f0ecea3"],
    "IVsSolution3": ["58dcf7bf-f14e-43ec-a7b2-9f78edd06418"],
    "IVsSolution4": ["d2fb5b25-eaf0-4be9-8e9b-f2c662ab9826"],
    "IVsSolution5": ["90570d49-7b10-4dcd-b9ac-530d91f4ebb5"],
    "IVsSolution6": ["96cb263f-eb15-4f70-b735-ad5ad7f6d363"],
    "IVsSolution7": ["d32b0c42-8aee-4772-b5c3-04565cda5a47"],
    "IVsSolution8": ["51a3a58a-e65e-46f8-a63c-49665a675016"],
    "IVsSolutionBatchProjectActionEvents": ["e4e928f3-1143-4c65-8f10-142400138f6d"],
    "IVsSolutionBuildManager": ["93e969d6-1aa0-455f-b208-6ed3c82b5c58"],
    "IVsSolutionBuildManager2": ["80353f58-f2a3-47b8-b2df-0475e07bb1c6"],
    "IVsSolutionBuildManager3": ["b6ea87ed-c498-4484-81ac-0bed187e28e6"],
    "IVsSolutionBuildManager4": ["2c07342b-ba98-4235-983c-8638391a420a"],
    "IVsSolutionBuildManager5": ["75d64352-c2f9-4bf8-9c89-57cfe548bf75"],
    "IVsSolutionBuildManager6": ["61aa4ea9-018f-4394-ad31-1e76d1bf80c8"],
    "IVsSolutionBuilder": ["d0b027ce-8c1f-11d0-8a34-00a0c91e2acd"],
    "IVsSolutionDebuggingAssistant": ["910e8282-f867-11d0-ab36-00a0c90f2713"],
    "IVsSolutionDebuggingAssistant2": ["0a2ee8d5-53ef-410f-8504-3e0afdac5995"],
    "IVsSolutionEvents": ["a8516b56-7421-4dbd-ab87-57af7a2e85de"],
    "IVsSolutionEvents2": ["a711df67-b00a-4e82-a990-51b2b450ea0f"],
    "IVsSolutionEvents3": ["f1de2d75-3b95-4510-9b2b-565bc0e38877"],
    "IVsSolutionEvents4": ["23ec4d20-54a9-4365-82c8-abdfba686ecf"],
    "IVsSolutionEvents5": ["af530689-9987-48be-af20-d9392a9c67ff"],
    "IVsSolutionEvents6": ["9ad84ab1-5c4e-4084-b161-21b6696237cb"],
    "IVsSolutionEvents7": ["a459c228-5617-4136-bcbe-c282df6d9a62"],
    "IVsSolutionEvents8": ["36b55a6c-8da0-428f-828c-80de9105f9c1"],
    "IVsSolutionEventsProjectUpgrade": ["7b1d55c6-4f6a-4865-b9b3-1a696e233065"],
    "IVsSolutionLoadEvents": ["6acff38a-0d6c-4792-b9d2-9469d60a2ad7"],
    "IVsSolutionLoadManager": ["dcf13d02-c7a2-427f-9f03-b3360257b301"],
    "IVsSolutionLoadManagerSupport": ["d48db33c-0f89-47ad-ab42-d6683608bd60"],
    "IVsSolutionLogger": ["4ccb7a7a-bceb-427c-84c5-ff0bd655311e"],
    "IVsSolutionPersistence": ["67a65088-52f3-4c47-b829-1b53a112e8dc"],
    "IVsSolutionSecurityOptions": ["05a323e9-5069-474e-9bcc-14f87302b213"],
    "IVsSolutionUIEvents": ["56870613-ab44-40b6-8125-f0d82d566c26"],
    "IVsSolutionUIHierarchyWindow": ["d286024e-6940-4d08-986d-ce82e732baab"],
    "IVsSpecifyProjectDesignerPages": ["e7e36a24-6435-48fb-8e5b-d2589fc18d72"],
    "IVsSplitPane": ["721d4d8e-e987-4712-b878-88a0e7dba117"],
    "IVsSplitRoot": ["5486c948-af82-4da5-a968-97f3ada66670"],
    "IVsSplitter": ["66280096-a495-48e9-8af4-e758fde1fcdc"],
    "IVsStartPageDownload": ["f5b2c031-7093-447f-8486-514fb2ccad4f"],
    "IVsStartupProjectsListService": ["daec2267-c961-44f3-96e2-3053e4ef550c"],
    "IVsStatusbar": ["dc0af70e-5097-4dd3-9983-5a98c3a19942"],
    "IVsStatusbar3": ["5a257c4a-2eb3-4db7-83df-29f4a45b632c"],
    "IVsStatusbarUser": ["d388bd3b-4d50-4356-b09a-8917e706d196"],
    "IVsStatusbarUser2": ["6d3e477a-4b61-444c-860d-f725e5560b40"],
    "IVsStringMap": ["4743cc21-8943-414d-84c2-e5de2438d02f"],
    "IVsStrongNameKeys": ["b0de8148-dabc-4ab9-b418-413e63df6e6c"],
    "IVsStrongNameKeys2": ["ea4f4fec-d6ba-40d3-b536-823518822c9d"],
    "IVsStructuredFileIO": ["12b43f9f-8550-4ffa-850f-fe9d4d396c20"],
    "IVsStructuredFileIOHelper": ["0612fca3-b60e-410b-bcce-43953ff0763c"],
    "IVsSupportCodeDefView": ["d34e5a63-e990-472a-9852-45fb36aa67ab"],
    "IVsSupportItemHandoff": ["e09c9dcf-d4b7-4d6e-a676-1fc64b4bf6eb"],
    "IVsSupportItemHandoff2": ["2afa4f74-7a1a-4dee-8f99-46e74e5a3c0f"],
    "IVsSwatchClient": ["e68652d0-396c-4937-95a3-f0ae7acd0e15"],
    "IVsSwitchToolWindow": ["34dbaa55-2ca4-44ef-9f92-85435d3e4451"],
    "IVsSymbolicNavigationManager": ["c4d4f197-941e-43b1-9d42-be527f9d5d00"],
    "IVsSymbolicNavigationNotify": ["4de38661-bb8f-4b9b-8d2f-425949341bbe"],
    "IVsSyntheticRegion": ["b9c97ab2-2a37-4134-93e9-c3014f364aa8"],
    "IVsSyntheticTextClient": ["1a8fbf86-5949-4e08-b9b6-f528afb2df9c"],
    "IVsSyntheticTextManager": ["2ab20832-0942-42f9-974f-4e65b85dabf3"],
    "IVsSyntheticTextSession": ["0c71e351-5141-4b6f-b838-e212f0764875"],
    "IVsTargetFrameworkAssemblies": ["399dc6d4-84d6-4208-afa6-362098e7972f"],
    "IVsTask": ["0b98eab8-00bb-45d0-ae2f-3de35cd68235"],
    "IVsTask2": ["26f21acd-a055-4f5b-97be-27c2ec4d7a33"],
    "IVsTaskBody": ["05a07459-551f-4cdf-b38a-16089d083110"],
    "IVsTaskCompletionSource": ["ce465203-16bc-4ebd-b4d1-9b4416b80931"],
    "IVsTaskItem": ["0f6d7fb4-2649-4e51-bc20-3698f9f51358"],
    "IVsTaskItem2": ["970a6925-5ffa-4a77-972f-7ab90c0130e5"],
    "IVsTaskItem3": ["f353950e-c381-4ba6-bcaa-6ba64e53d252"],
    "IVsTaskList": ["9d21bcc5-2c63-4a61-b055-2f3df78eb30a"],
    "IVsTaskList2": ["62357211-57fd-4425-a9e5-9a6e0d3b731c"],
    "IVsTaskList3": ["6028fb96-e279-4707-8945-7a503aec636e"],
    "IVsTaskListEvents": ["d529fad1-4be0-4bea-92a3-a58a4b89d056"],
    "IVsTaskProvider": ["6909c6ed-2af5-4a35-8ea7-e6095a3ecf9e"],
    "IVsTaskProvider2": ["a7e6b1f9-dff1-4354-870f-196be871f329"],
    "IVsTaskProvider3": ["afa6b21d-d599-43f9-a3ab-0840359f11c3"],
    "IVsTaskProvider4": ["6f6e00cc-2261-49e2-8fd9-356b6637a2d9"],
    "IVsTaskProvider5": ["1565244d-2daf-486f-acef-54c1a32d03fa"],
    "IVsTaskSchedulerService": ["83cfbaaf-0df9-403d-ae42-e738f0ac9735"],
    "IVsTaskSchedulerService2": ["8176dc77-36e2-4987-955b-9f63c6f3f229"],
    "IVsTemplateInfo": ["99d395af-e402-40b4-86d1-43edd260abf4"],
    "IVsTestLog": ["575bc578-7562-44e7-986c-5b31398cf121"],
    "IVsTextBuffer": ["c08e5275-0d26-4de9-8892-994024c23750"],
    "IVsTextBufferCoordinator": ["84465401-2886-4ce0-af50-c0560226ed40"],
    "IVsTextBufferDataEvents": ["b7515e7a-70f0-44ed-96b7-fb7eb6450c10"],
    "IVsTextBufferEvents": ["44b0cab3-6df8-4931-9064-8fd18afbc88e"],
    "IVsTextBufferEx": ["9f0823e9-544d-4fa0-9400-0d602c9a510e"],
    "IVsTextBufferProvider": ["76a3b2c0-c743-11d0-a7a6-00a0c9110051"],
    "IVsTextBufferTempInit": ["f229a34e-5880-4c20-94c3-717cf4be1fda"],
    "IVsTextColorState": ["a7a64de3-9b5c-47f0-abad-0aedbd6cc057"],
    "IVsTextEditFonts": ["f39ab913-e6c9-4546-a265-1e43f8de924c"],
    "IVsTextEditGeneral": ["2e1bfd1c-5b26-4aca-b97b-ed9d261ba3e7"],
    "IVsTextEditPerLanguage": ["5943bd7e-d722-42db-a251-fe2add8711ea"],
    "IVsTextEditorPropertyCategoryContainer": ["a6078038-d578-4f32-b9b2-c83e1726454d"],
    "IVsTextEditorPropertyContainer": ["7669cc95-4640-461c-8158-16f65265d77c"],
    "IVsTextFind": ["0bf16544-9cec-40e1-80b1-e467e21b97fe"],
    "IVsTextHidingLayerModule": ["1a705427-815c-4db6-9b5c-6d45cdddd0c4"],
    "IVsTextImage": ["67068dc0-c069-11d2-936c-d714766e8b50"],
    "IVsTextImage2": ["f86209fe-6baa-40dc-aa5d-6c9e83b032b9"],
    "IVsTextImageEvents": ["b1adb4fc-562f-43e6-8a91-cd2cffa2b377"],
    "IVsTextImageUtilities": ["c5557baa-b685-46dc-af46-c16bfde8fab7"],
    "IVsTextLayer": ["0e145d3f-befc-4fd9-8714-b01ae89f4396"],
    "IVsTextLayer2": ["1fe22ab1-40ca-45a0-bd56-7e65fa3b774c"],
    "IVsTextLayerEvents": ["cde3413a-ad8e-495f-a74f-760547294a6f"],
    "IVsTextLayerMarker": ["28c149d2-8fcb-4ab3-8584-9a2747f3f8fc"],
    "IVsTextLineMarker": ["31e2dca7-ccff-4e09-b433-17c739cf69ad"],
    "IVsTextLineMarkerEx": ["1c31ee6e-fc66-4fc8-8cc5-6a4134369f4e"],
    "IVsTextLines": ["ecf3e19d-149c-43aa-80c2-d0a46946daa3"],
    "IVsTextLines2": ["181b18a3-a0e8-436b-8aef-500043c7cc78"],
    "IVsTextLinesEvents": ["598d7074-dc17-4162-9a2f-97dd4540c2dd"],
    "IVsTextMacroHelper": ["caf8109f-b74b-429f-a11a-4944aade9ab2"],
    "IVsTextManager": ["909f83e3-b3fc-4bbf-8820-64378744b39b"],
    "IVsTextManager2": ["072a28fd-1af3-48af-9c85-c79404dba30c"],
    "IVsTextManager3": ["f06df8bd-23f9-49a3-94c3-f3228cf60f2d"],
    "IVsTextManager4": ["4125abf2-621e-4fe8-a4f2-c7a9f5ef2eed"],
    "IVsTextManagerEvents": ["b3175059-c6aa-4519-86c3-1fe594d26c35"],
    "IVsTextManagerEvents2": ["4697e418-183e-414e-9173-e5fbf27692a9"],
    "IVsTextManagerEvents3": ["040929d6-0e89-4987-a450-c0f91d03dfc8"],
    "IVsTextManagerEvents4": ["0298015a-2c85-4076-9483-f56d91ba14e2"],
    "IVsTextMarker": ["950122d9-1a51-43ca-8ced-b5d9e42de1b5"],
    "IVsTextMarkerClient": ["b1938f1b-d7a9-42f8-9960-d009027b3d2e"],
    "IVsTextMarkerClientAdvanced": ["c4b874d3-1491-4f13-8b9e-17249ec4902b"],
    "IVsTextMarkerClientEx": ["ba48a96d-40e9-4723-bdd8-b99072a1a426"],
    "IVsTextMarkerColorSet": ["93373f76-df07-46db-9415-1772069f60a4"],
    "IVsTextMarkerContextProvider": ["f1671b6b-1090-4dff-bbfd-133eb428bb6c"],
    "IVsTextMarkerGlyphDropHandler": ["1e220776-3c20-46e9-a691-de549c295e26"],
    "IVsTextMarkerType": ["8c4a2b6e-6377-4c71-9940-fba1be6edd6f"],
    "IVsTextMarkerTypeProvider": ["7ef86cfd-d561-4ba5-9f38-c1bff588e3ac"],
    "IVsTextOut": ["2bd8d42f-5bc5-4b7f-ab50-fe9310f2fe53"],
    "IVsTextReplaceEvents": ["cf9928d9-65ae-4319-a446-94ed5c45ecde"],
    "IVsTextScanner": ["ebd73923-c190-45c1-91c5-0bc61a8aab14"],
    "IVsTextSelectionAction": ["cb49cf53-cce9-4493-ad7a-3595f4c1caf3"],
    "IVsTextSpanSet": ["e6bbdfd0-c06a-11d2-936c-d714766e8b50"],
    "IVsTextStorage": ["1abac269-8fb0-438e-8217-230ac6eb5766"],
    "IVsTextStorage2": ["92fe8718-09df-4615-9bc8-492e67eeb1ab"],
    "IVsTextStorageColorState": ["1f027f1f-9696-4816-b345-3cd7d3122a48"],
    "IVsTextStream": ["d3af020b-a862-4d22-b373-20f1b30b7d9e"],
    "IVsTextStreamEvents": ["96fc7d44-bcdd-4f00-ae4d-07e26b2c0e52"],
    "IVsTextStreamMarker": ["10d17872-91ba-4d65-80cc-e5fc3222ac82"],
    "IVsTextTipData": ["90609097-17c8-40e8-8128-67194c7384b1"],
    "IVsTextTipWindow": ["a6accb2f-1e0d-458b-a878-d40eb89c1df4"],
    "IVsTextTipWindow2": ["085f0ab4-5518-4898-8d4a-48e4d3e177dd"],
    "IVsTextTrackingPoint": ["d6bf0a8a-3798-49c5-8806-648a635eacc8"],
    "IVsTextView": ["bb23a14b-7c61-469a-9890-a95648ced5e6"],
    "IVsTextView3": ["dc5cecdf-26bf-4014-bf54-a6d3636a83ef"],
    "IVsTextViewEvents": ["e1965da9-e791-49e2-9f9d-ed766d885967"],
    "IVsTextViewEx": ["eaf1ea5b-eb6d-4852-9d87-666e09bc4bee"],
    "IVsTextViewFilter": ["6b6f0b32-b88b-40f8-a8fe-97438c5bdbef"],
    "IVsTextViewIntellisenseHost": ["0816a38b-2b41-4d2a-b1ff-23c1e28d8a18"],
    "IVsTextViewIntellisenseHostProvider": ["2e758295-344b-48d6-86ac-bd81f89cb4b8"],
    "IVsThemeThumbnailProvider": ["e1abf09d-ad4a-4adb-86ec-89ee37d2571a"],
    "IVsThreadPool": ["615ff0fb-a19b-4bc8-b9af-372ea191ba46"],
    "IVsThreadSafeCommandWindow": ["811deb01-c1b0-4172-9ca3-504c5095882e"],
    "IVsThreadSafeTextView": ["fec3bf2a-7833-4777-ae74-5fff86d6794e"],
    "IVsThreadedWaitDialog": ["e051c7b7-7648-473c-8a7d-2b9554a31f9d"],
    "IVsThreadedWaitDialog2": ["88194d8b-88da-4c33-a2c6-15140626e222"],
    "IVsThreadedWaitDialog3": ["e92e3159-2381-4179-a500-9676dee38896"],
    "IVsThreadedWaitDialog4": ["7619bd89-3b7e-4838-ad11-434bec7d9530"],
    "IVsThreadedWaitDialogCallback": ["f5caf6e8-ad40-4d9d-8366-a919f03ca969"],
    "IVsThreadedWaitDialogFactory": ["d10d92b6-d073-456f-8a26-b63811202b21"],
    "IVsTipWindow": ["64c7ffc4-b9ee-4599-b130-ff9d890ecfd4"],
    "IVsToolWindowFactory": ["a7a1c907-c3d2-4acb-9114-4ee23b6fcf7e"],
    "IVsToolWindowToolbar": ["4544d333-8d5f-4517-9113-3550d618f2ad"],
    "IVsToolWindowToolbarHost": ["cf7549a9-7a2a-4a6e-acf4-05452c98cf7e"],
    "IVsToolWindowToolbarHost2": ["2efc69a8-5e06-436d-88d5-f099353356da"],
    "IVsToolWindowToolbarHost3": ["8ee99928-6a35-470b-8aff-96b0319f6b9a"],
    "IVsToolWindowToolbarHost4": ["4d6ca502-1fb1-4a49-81c7-8d2d423f7f0f"],
    "IVsToolbarTrayHost": ["2b3321ee-693f-4b46-9536-e44dad8c6e60"],
    "IVsToolbox": ["70e643e2-1673-4764-8a39-63cb1aee0dc9"],
    "IVsToolbox2": ["08e728dc-9c45-4060-a243-b73443b7ca16"],
    "IVsToolbox3": ["5c67b771-43ad-4bcf-9342-e82cf8e4cbfd"],
    "IVsToolbox4": ["8a9899ae-041f-431b-85d0-e44f35d65cdd"],
    "IVsToolbox5": ["724b9aaf-f1d1-4ae8-923b-0f2469b1502a"],
    "IVsToolbox6": ["a403b9b7-34c3-4eef-b40e-5ac270277d84"],
    "IVsToolbox7": ["58928e40-8514-42ee-8efa-f5ceeebbf653"],
    "IVsToolboxActiveUserHook": ["a00c298a-6520-4822-abd8-c5cd03846599"],
    "IVsToolboxClipboardCycler": ["6a2a1d82-c590-4ab1-8cc2-d95bacbba9e0"],
    "IVsToolboxClipboardCycler2": ["3ed19650-63fe-440e-a3d2-87bc421b04d2"],
    "IVsToolboxDataProvider": ["f925da6b-3f43-4437-9e1e-4d4c1bbdab3f"],
    "IVsToolboxDataProvider2": ["1cd73232-a3c7-48fa-8b0a-2e35804097bf"],
    "IVsToolboxDataProviderRegistry": ["653be2da-ba98-41b7-8abc-7a38b0e1c01a"],
    "IVsToolboxItemProvider": ["f2f94425-e001-4c4d-816c-70202e9a594c"],
    "IVsToolboxItemProvider2": ["35c56762-5ab2-4c9f-ae5a-bf11e4d8fb88"],
    "IVsToolboxPageChooser": ["652c0d0f-217e-46e8-9b85-0ec52279da8f"],
    "IVsToolboxUser": ["b5e12e94-6653-4a0d-9c42-5357f2654360"],
    "IVsToolsOptions": ["ae31d40e-cd7a-45cb-8def-5ea0e44c688a"],
    "IVsToolsOptionsHelp": ["ddf4f502-c740-47b7-95cc-3ff4b765ba99"],
    "IVsTrackBatchRetargetingEvents": ["b8cb3252-2133-4869-9e34-dbcecd058081"],
    "IVsTrackProjectDocuments": ["53544c4d-449a-4487-a56f-740cf8130032"],
    "IVsTrackProjectDocuments2": ["53544c4d-6639-11d3-a60d-005004775ab1"],
    "IVsTrackProjectDocuments3": ["53544c4d-9097-4325-9270-754eb85a6351"],
    "IVsTrackProjectDocuments4": ["53544c4d-19f7-4351-9168-240478819500"],
    "IVsTrackProjectDocumentsEvents": ["53544c4d-a98b-4fd3-aa79-b182ee26185b"],
    "IVsTrackProjectDocumentsEvents2": ["53544c4d-663d-11d3-a60d-005004775ab1"],
    "IVsTrackProjectDocumentsEvents3": ["53544c4d-bd74-4d21-a79f-2c190e38ab6f"],
    "IVsTrackProjectDocumentsEvents4": ["53544c4d-db74-4078-9642-5d1bc0bb5b26"],
    "IVsTrackProjectRetargeting": ["d991bc9b-9c68-447f-a3a7-95962ad75dd2"],
    "IVsTrackProjectRetargetingEvents": ["60e3f077-6867-4528-96c7-98dd5b541d85"],
    "IVsTrackSelectionEx": ["18291fd1-a1dd-4264-aead-6afd616bf15a"],
    "IVsTshell": ["f6a0fa50-b78b-11d0-a79e-00a0c9110051"],
    "IVsTypeLibraryWrapper": ["e6065b70-c9b6-4636-80f5-1cf92d7ece5b"],
    "IVsTypeLibraryWrapperCallback": ["aff2b95e-229b-4a14-a422-e99452ad2f8c"],
    "IVsUIAccelerator": ["4e25556d-941d-4c29-a171-384ea84f6705"],
    "IVsUIBoundBooleanProperty": ["1406a251-7ebd-49d9-ae68-454f1906e6ff"],
    "IVsUIBoundCollectionProperty": ["b957e62c-a5e4-4c0a-b33f-51edeabff367"],
    "IVsUIBoundDWordProperty": ["ae72464d-2866-46c1-b088-21838df1c1ed"],
    "IVsUIBoundDataSourceProperty": ["b47682c3-726d-48f0-bcc9-247c8d1c4e1f"],
    "IVsUIBoundDoubleProperty": ["00705016-e9ef-4caf-bab1-8e4484ed7b69"],
    "IVsUIBoundFormattedProperty": ["6e4a81aa-6694-4261-940d-837d8991dba4"],
    "IVsUIBoundGuidProperty": ["6d0f82bc-c086-44f0-9ab0-92f67db1c896"],
    "IVsUIBoundInt32Property": ["e5d6702c-cec1-4f24-b74e-abebccd65bf0"],
    "IVsUIBoundPropertyBase": ["42261aac-332f-4360-b925-0f532f9944be"],
    "IVsUIBoundQWordProperty": ["2ca8b41c-091c-4d98-ad2e-23d075551e1a"],
    "IVsUIBoundStringProperty": ["d86e711d-1ca3-4541-87ce-ffc8f604f454"],
    "IVsUICollection": ["f9362b93-c6fd-4c51-8af9-b4bc13953e6c"],
    "IVsUICollectionChangeEvents": ["d47abbe0-4e31-424d-8dc9-31de024e75e7"],
    "IVsUIContextEvents": ["0393d191-94ac-4997-9310-2eac67495816"],
    "IVsUIContextMonitor": ["2b663830-25e6-4a21-94a3-24322fa4f01d"],
    "IVsUIDataConverter": ["6e48eb81-add0-4f9f-af78-c02f053250b3"],
    "IVsUIDataConverterManager": ["806ba229-8188-4663-a918-65b0e0cc0503"],
    "IVsUIDataSource": ["8d11dd44-7ef2-4c7a-b188-7da136657f68"],
    "IVsUIDataSourcePropertyChangeEvents": ["ec495559-b090-435e-8d7e-3d95286a9be8"],
    "IVsUIDataSourceShape": ["ddd2cb35-dc38-46a9-8c9e-f8bc0649cf80"],
    "IVsUIDataSourceShapeProvider": ["7eef6797-7698-42a9-9157-dd8c90f5854a"],
    "IVsUIDispatch": ["0df3e43a-5356-4a33-8ac1-3be6e3337c37"],
    "IVsUIDynamicCollection": ["6d155041-b4b8-4121-8d74-841e5da4373e"],
    "IVsUIElement": ["62c0a03e-4979-4b4e-90f0-56df90521f79"],
    "IVsUIElementPane": ["d5083078-66c7-4047-b101-62a5f7997ec5"],
    "IVsUIEnumDataSourceProperties": ["327922b7-0b7f-4123-8446-0e614b337673"],
    "IVsUIEnumDataSourceVerbs": ["51c2fffb-35fa-4ad2-81b1-11816c482aaa"],
    "IVsUIEventSink": ["515953ac-99c6-4f1b-8645-636a57e4b1e2"],
    "IVsUIFactory": ["d416ba0d-25c6-463b-b2bd-f06142f0d4b7"],
    "IVsUIHierWinClipboardHelper": ["df29d855-d0ec-4da1-bcc3-42fa3a09b1cb"],
    "IVsUIHierWinClipboardHelperEvents": ["4d25f3c7-3138-4ac6-91af-d7ff6929db9f"],
    "IVsUIHierarchy": ["e82609ea-5169-47f4-91d0-6957272cbe9f"],
    "IVsUIHierarchyNativeWindow": ["280cc247-9ef8-42f2-9009-a75b86ea871b"],
    "IVsUIHierarchyWindow": ["a2dd88c9-d878-4323-95a3-77daf258e5d0"],
    "IVsUIHierarchyWindow2": ["5b8c06a0-4379-4218-a046-b1dc466e5818"],
    "IVsUIObject": ["86fd1a37-a8c2-41df-98fa-086d79bfd33e"],
    "IVsUIShell": ["b61fc35b-eebf-4dec-bff1-28a2dd43c38f"],
    "IVsUIShell2": ["4e6b6ef9-8e3d-4756-99e9-1192baad5496"],
    "IVsUIShell3": ["1c763d26-637c-46f8-a55c-6ecc84df4e4f"],
    "IVsUIShell4": ["c59cda92-d99d-42da-b221-8e36b8dc478e"],
    "IVsUIShell5": ["2b70ea30-51f2-48bb-aba8-051946a37283"],
    "IVsUIShell6": ["7033d7ed-0e98-4c91-9881-1dd84891d378"],
    "IVsUIShell7": ["c5ffe6b0-c6e0-45a4-9fe2-da5deb84e59d"],
    "IVsUIShellArrangeWindows": ["54457dad-5384-41b5-b6aa-efffde468cdc"],
    "IVsUIShellDocumentWindowMgr": ["686c2af1-a2e5-4f6c-b660-b63fd4f70c18"],
    "IVsUIShellOpenDocument": ["35299eec-11ee-4518-9f08-401638d1d3bc"],
    "IVsUIShellOpenDocument2": ["0649bda0-0978-4ca0-ab0b-0f619199bcca"],
    "IVsUIShellOpenDocument3": ["e6a63a28-154c-42cb-a6e7-9252c2e6d943"],
    "IVsUIShellOpenDocument4": ["c4a93d85-65d1-4497-8ea8-b394de2e3c2b"],
    "IVsUISimpleDataSource": ["110596dc-7a19-4e04-9106-1db0580f77e9"],
    "IVsUIWin32Bitmap": ["0dd7cf3a-6203-466f-b1c1-7653809cb73a"],
    "IVsUIWin32Element": ["ad9a00f2-ac5b-4a49-94b7-17cc3ce1a46a"],
    "IVsUIWin32Icon": ["55445e7e-dad5-4c41-9f38-03511d922d1e"],
    "IVsUIWin32ImageList": ["5ea86615-2308-4da4-8a7a-e442fe40c44f"],
    "IVsUIWpfElement": ["ca87e95d-5aee-4a16-bdca-94a1f7f769a9"],
    "IVsUIWpfLoader": ["89db8ab3-9035-4016-aa8a-76f7ae09b65f"],
    "IVsUndoRedoClusterWithCommitEvents": ["f98298d9-53c4-43db-90d6-d1a3ca4b1849"],
    "IVsUndoTrackingEvents": ["31024dd7-30e5-4c91-821d-218bdeada18b"],
    "IVsUndoUnit": ["a8c3d107-7edf-4b1b-8a81-080ac91590e9"],
    "IVsUpdateSolutionEvents": ["a9f86308-5ea7-485d-bab8-e8989c3cfbdc"],
    "IVsUpdateSolutionEvents2": ["f59dbc1a-91c3-45c9-9796-1cab558502dd"],
    "IVsUpdateSolutionEvents3": ["40025c28-3303-42ca-bed8-0f3bd856bd6d"],
    "IVsUpdateSolutionEvents4": ["84ca83ee-ee80-42c1-99ce-1de83f2fca3a"],
    "IVsUpdateSolutionEvents5": ["95498691-cb06-4bc1-8a83-f84c6d565e21"],
    "IVsUpdateSolutionEventsAsync": ["703ecc2c-7631-46a9-ad1e-19d9592c7a6b"],
    "IVsUpdateSolutionEventsAsyncCallback": ["02d0878c-53f5-4ce9-b55c-3577dae64761"],
    "IVsUpgradeBuildPropertyStorage": ["27712a1d-abea-42e2-95a5-31d370759429"],
    "IVsUpgradeLogger": ["ae88c42e-b3d6-4fec-9c63-c9f1b28233ea"],
    "IVsUpgradeLogger2": ["dcf3e6de-2dc0-421e-9dbb-375bb5255a80"],
    "IVsUserContext": ["761081df-d45f-4683-9b9e-1b7241e56f5c"],
    "IVsUserContextCustomize": ["0f817159-761d-447e-9600-4c3387f4c0fd"],
    "IVsUserContextExport": ["b50f15a4-c42d-4dc1-ae09-7d2069ec58e9"],
    "IVsUserContextItem": ["720b8500-17b3-4c89-ae84-2cfe7251b4b8"],
    "IVsUserContextItemCollection": ["2a6de4a2-5b3d-46eb-a65c-24c4ef4f396f"],
    "IVsUserContextItemEvents": ["a2078f0e-a310-420a-ba27-16531905b88f"],
    "IVsUserContextItemProvider": ["715c98b7-05fb-4a1a-86c8-ff00ce2e5d64"],
    "IVsUserContextUpdate": ["f5ed7d1c-61b6-428a-8129-e13b36d9e9a7"],
    "IVsUserData": ["978a8e17-4df8-432a-9623-d530a26452bc"],
    "IVsUserDataEvents": ["5e120d5e-9637-47d9-861c-92fa03683c6c"],
    "IVsUserSettings": ["770e285d-3b7d-4342-b3c4-42bd9f53a300"],
    "IVsUserSettings2": ["bcaacbea-0763-491e-84e0-ed29dd8ebba8"],
    "IVsUserSettings3": ["2ad1813a-8691-468a-a777-bd0fda5cf48e"],
    "IVsUserSettingsMigration": ["692e1ebf-9d60-4a56-b10f-596dc48cc230"],
    "IVsUserSettingsQuery": ["334e1f15-7d97-4231-81b0-998e4a960e69"],
    "IVsVba": ["a659f1b2-ad34-11d1-abad-0080c7b89c95"],
    "IVsViewRangeClient": ["30491a5b-a47e-4c9c-8204-18586648a277"],
    "IVsWCFAsyncResult": ["70d6d8a3-1d8d-44e8-8cd8-64b047e9f309"],
    "IVsWCFCompletionCallback": ["183f0821-1f02-4e07-901a-f4f19c162935"],
    "IVsWCFMetadataStorage": ["8d095035-ab0c-4363-891a-8c79f5cda259"],
    "IVsWCFMetadataStorageEvents": ["77fded51-e1ee-42b4-9e6c-bc892487d0ab"],
    "IVsWCFMetadataStorageProvider": ["f71d2b05-680f-423b-b00f-52a2944ac45c"],
    "IVsWCFMetadataStorageProviderEvents": ["610dfeb0-5c2b-46c2-bb44-1de7dc42d409"],
    "IVsWCFObject": ["5e1f02cc-7a5f-4db0-8d55-a05cc0a4aa56"],
    "IVsWCFReferenceContract": ["0ed7423c-615c-47eb-931a-8e7d3f45ddcd"],
    "IVsWCFReferenceEndpoint": ["efd57b55-a7da-4c65-a6df-90b3b656d749"],
    "IVsWCFReferenceEvents": ["729d5091-e77f-4d0b-b03a-2310ad58ddc2"],
    "IVsWCFReferenceGroup": ["806cfc9a-2476-4d28-a5b2-c9ebc617b24e"],
    "IVsWCFReferenceGroupCollection": ["343173d2-f910-4c03-930d-16ab1568431b"],
    "IVsWCFReferenceGroupMetadataItem": ["8167ca28-d8bc-4537-9ff8-d237dd447391"],
    "IVsWCFReferenceGroupOptions": ["3cfcb0c9-5a1c-451a-9ccf-cae41c3a5344"],
    "IVsWCFReferenceManager": ["2349f2f8-d2d5-4268-898c-35f1f013426d"],
    "IVsWCFReferenceManagerFactory": ["2fe19f72-edd1-4fa4-9f36-a90a52ed166a"],
    "IVsWebAppMigration": ["d1a24b44-033e-445f-b3aa-be3f23c5617c"],
    "IVsWebBrowser": ["e8b06f50-6d01-11d2-aa7d-00c04f990343"],
    "IVsWebBrowserUser": ["e8b06f4b-6d01-11d2-aa7d-00c04f990343"],
    "IVsWebBrowserUser2": ["821abd48-96dc-4315-a2c4-82a7239b8166"],
    "IVsWebBrowsingService": ["e8b06f51-6d01-11d2-aa7d-00c04f990343"],
    "IVsWebFavorites": ["e8b06f4c-6d01-11d2-aa7d-00c04f990343"],
    "IVsWebFormDesignerSupport": ["2139dfc1-b0ad-4c17-a817-74f2ba47c714"],
    "IVsWebMigration": ["1d1851be-913d-40f4-ad7c-ad1f69a34e27"],
    "IVsWebMigrationService": ["db0ad857-2f21-40c2-80f2-7cb9300f9dca"],
    "IVsWebPreview": ["9ec9ba55-b328-11d2-9a98-00c04f79efc3"],
    "IVsWebPreviewAction": ["9ec9ba56-b328-11d2-9a98-00c04f79efc3"],
    "IVsWebProject": ["0bd8000a-f537-4889-9fbc-c5f63b313956"],
    "IVsWebProxy": ["62a84aef-423d-4827-833f-7918753c0269"],
    "IVsWebService": ["d02603f6-bdb0-410c-9ba8-9e34e5ff4bec"],
    "IVsWebServiceEvents": ["f20ab4a1-4ba3-4842-ac78-2550669f751a"],
    "IVsWebServiceProvider": ["c736666c-6970-4ae7-9b1f-5c0407a30556"],
    "IVsWebServiceProviderEvents": ["8170cb5a-d602-4886-a990-8260a5928133"],
    "IVsWebURLMRU": ["e8b06f3d-6d01-11d2-aa7d-00c04f990343"],
    "IVsWindowFrame": ["11138f8a-38c0-4436-b5a6-2f5ef2c3e242"],
    "IVsWindowFrame2": ["801885a0-9dc6-4e34-b064-1c3228f66794"],
    "IVsWindowFrame3": ["b2c3d311-2599-4ce1-9967-f224d99d374b"],
    "IVsWindowFrame4": ["841f8242-83bb-4c6d-8357-e12c21bf6caa"],
    "IVsWindowFrame5": ["0461cf82-2583-4f9a-a1d6-7d61de87b58b"],
    "IVsWindowFrame6": ["04fd91be-9184-4543-9526-8bccc4ed850d"],
    "IVsWindowFrameEvents": ["15d6e42b-36ad-4af9-a144-c6f07027a6ed"],
    "IVsWindowFrameEvents2": ["104b9b1b-9488-4608-a11d-7c3aaa65e407"],
    "IVsWindowFrameNotify": ["fe46e1df-e8a8-48d3-932e-b61bc092e681"],
    "IVsWindowFrameNotify2": ["f4de74e7-078a-430e-b0e1-8b131bdef335"],
    "IVsWindowFrameNotify3": ["8c213ac2-ff13-4361-9fc5-39d368d26cd3"],
    "IVsWindowFrameSwitcher": ["c40cf83b-a231-46b3-aa07-8cc30d5e1a04"],
    "IVsWindowPane": ["b0834d0f-acff-4ea5-809b-97cbb5d3d26b"],
    "IVsWindowPaneCommit": ["508ed8e9-923d-44ed-8165-5b96da4e0829"],
    "IVsWindowPaneCommitFilter": ["072b9701-2f81-4468-8eb6-074206504b62"],
    "IVsWindowSearch": ["8640a5bb-a6f8-4e4c-b4d7-c7041cff3c71"],
    "IVsWindowSearchBooleanOption": ["c1335086-78c1-4f9a-823f-5a7166bc051c"],
    "IVsWindowSearchCommandOption": ["f2be6603-d990-4810-8c0b-8cd36c5b51e9"],
    "IVsWindowSearchCustomFilter": ["bd1e4938-41cf-4f9c-abb3-2fa4f114197d"],
    "IVsWindowSearchEvents": ["a1702207-bf76-4a77-ad7d-0f41c558fdd3"],
    "IVsWindowSearchFilter": ["e807aaec-6ddf-41a0-8b5b-8a0a630a7648"],
    "IVsWindowSearchHost": ["576deaf2-b527-4345-9a4b-bdab6426fe03"],
    "IVsWindowSearchHostFactory": ["7525c3af-ce45-46b3-88d3-4327b50fd8b9"],
    "IVsWindowSearchOption": ["77d79ce1-9a26-4dc2-9182-3c5e1d1dfb4c"],
    "IVsWindowSearchSimpleFilter": ["236d9124-37ca-4edc-af07-2d8dfa416f42"],
    "IVsWindowView": ["7e7c4b21-079f-4830-9ed5-e0cb0bf281f1"],
    "IVsWorkingFolders": ["b362db16-833e-4f93-b108-71b2177c3930"],
    "IVsWorkingFoldersEvents": ["dbf44e6b-78ff-413d-98b7-5cb601fb672a"],
    "IVsWritableSettingsStore": ["16fa7461-9e7c-4f28-b28f-aabbf73c0193"],
    "IVsXMLMemberData": ["05ec0018-fb7f-4492-9f91-21245c5a3d15"],
    "IVsXMLMemberData3": ["c04165c2-3cac-4508-b651-dd24906dbd4d"],
    "IVsXMLMemberData4": ["60721047-d8b3-4ff2-b963-d4d1f3102f77"],
    "IVsXMLMemberData5": ["abf5e2fb-3f36-4b99-b384-bdf85d598c6c"],
    "IVsXMLMemberData6": ["73f13643-a469-444d-8fff-55d69229f5aa"],
    "IVsXMLMemberDataCallBack": ["c7ae54ab-abf2-494a-bc8c-c577abb874c9"],
    "IVsXMLMemberDataCapability": ["98f1a862-a153-4369-86b8-7c4e3d0d5e37"],
    "IVsXMLMemberDataDeprecation": ["af87bddd-fb89-4787-9809-1749fd500abc"],
    "IVsXMLMemberDataRegisterCallBack": ["b9b17d7e-aab8-43cb-ab40-b4e26e0b6d48"],
    "IVsXMLMemberIndex": ["f9c06c61-207b-41d5-9ca2-690b3ae01083"],
    "IVsXMLMemberIndexService": ["d31e676b-d416-4da7-977e-20e00aae1118"],
    "IVssAdmin": ["77ed5996-2f63-11d3-8a39-00c04f72d8e3"],
    "IVssAdminEx": ["7858a9f8-b1fa-41a6-964f-b9b36b8cd8d8"],
    "IVssAsrWriterBackup": ["001e7348-6c2f-46c1-bb33-b392fea94a55"],
    "IVssAsrWriterRestore": ["6a0a259b-4010-45f8-b407-2e2c7129bf0a"],
    "IVssAsrWriterRestoreEx": ["272cd7d7-1235-49b3-8207-203241cc5484"],
    "IVssAsync": ["507c37b4-cf5b-4e95-b0af-14eb9767467e"],
    "IVssCoordinator": ["da9f41d4-1a5d-41d0-a614-6dfd78df5d05"],
    "IVssCoordinatorCallback": ["6a36e2b7-7cf8-48b7-8d9f-d4f96fa413a8"],
    "IVssCoordinatorEx": ["d7ddd290-2a4d-4c4e-bf69-2b5b16c74fc2"],
    "IVssCoordinatorEx2": ["ce8d4a71-423c-485d-8842-feb463f7f590"],
    "IVssDifferentialSoftwareSnapshotMgmt": ["214a0f28-b737-4026-b847-4f9e37d79529"],
    "IVssDifferentialSoftwareSnapshotMgmt2": ["949d7353-675f-4275-8969-f044c6277815"],
    "IVssDifferentialSoftwareSnapshotMgmt3": ["383f7e71-a4c5-401f-b27f-f826289f8458"],
    "IVssEnumMgmtObject": ["01954e6b-9254-4e6e-808c-c9e05d007696"],
    "IVssEnumObject": ["ae1c7110-2f60-11d3-8a39-00c04f72d8e3"],
    "IVssFileShareSnapshotProvider": ["c8636060-7c2e-11df-8c4a-0800200c9a66"],
    "IVssHardwareSnapshotProvider": ["9593a157-44e9-4344-bbeb-44fbf9b06b10"],
    "IVssHardwareSnapshotProviderEx": ["7f5ba925-cdb1-4d11-a71f-339eb7e709fd"],
    "IVssProviderCreateSnapshotSet": ["5f894e5b-1e39-4778-8e23-9abad9f0e08c"],
    "IVssProviderNotifications": ["e561901f-03a5-4afe-86d0-72baeece7004"],
    "IVssRemoteCoordinator": ["bf5aeed7-92ba-4484-97be-ef7da4825680"],
    "IVssRemsnapCoordinatorInternal": ["f2c2787d-95ab-40d4-942d-298f5f757874"],
    "IVssSnapshotMgmt": ["fa7df749-66e7-4986-a27f-e2f04ae53772"],
    "IVssSnapshotMgmt2": ["0f61ec39-fe82-45f2-a3f0-768b5d427102"],
    "IVssSoftwareSnapshotProvider": ["609e123e-2c5a-44d3-8f01-0b1d9a47d1ff"],
    "IVssWriter": ["6050b110-ce87-4126-a114-50aefcfc95f8"],
    "IVssWriterCallback": ["511fc40d-a899-4423-a1f5-d154e0af2387"],
    "IVxBufferGraph": ["125ae4f6-7cca-4756-a175-a2ca5e7f60da"],
    "IVxContentType": ["6faa3727-ed8f-4fc0-8032-82ad17394029"],
    "IVxContentTypeChangedEvent": ["b58ad157-69a4-4225-aa41-0e5547b6cda3"],
    "IVxContentTypeChangedEventArgs": ["e9ed1827-223d-4cf1-aa25-09c3a0ff6f67"],
    "IVxContentTypeRegistryService": ["aeefbb53-ff73-45d0-a826-4f978725d21e"],
    "IVxDisposable": ["00c8c1e7-de26-42cf-a058-5ccda2b42beb"],
    "IVxEventArgsEvent": ["765b3465-12be-4cfe-8bd1-85b27f2cb081"],
    "IVxGraphBufferContentTypeChangedEvent": ["566861da-0ce4-4f47-896f-133cfb73a62f"],
    "IVxGraphBufferContentTypeChangedEventArgs": ["020c7be6-00fe-43e1-ba03-e62fb81eb8f9"],
    "IVxGraphBuffersChangedEvent": ["d1b54e5e-2782-4cd7-b6a0-2eff76c07dfb"],
    "IVxGraphBuffersChangedEventArgs": ["395bd869-ffa5-4eea-97bf-8ce42a7b3fcd"],
    "IVxMappingPoint": ["446d7a04-48a5-4721-91a7-bf28c6653192"],
    "IVxMappingSpan": ["db0e4bfb-1747-494b-a4c6-1eb544fb9df7"],
    "IVxNormalizedSnapshotSpanCollection": ["df81e2df-b253-4859-9429-bb9712cf7f2b"],
    "IVxNormalizedSpanCollection": ["f12c3b51-b3c2-42ea-86b0-6185c6f712a8"],
    "IVxNormalizedTextChangeCollection": ["cab6d7ae-e6a1-411d-ac94-bdc1629bb621"],
    "IVxPlatformFactory": ["a5596e43-5f0e-4dec-83e9-45f8fe64c64f"],
    "IVxProjectionBuffer": ["d8a38847-94af-4919-aa4e-be760e66905d"],
    "IVxProjectionBufferBase": ["dc35621d-2318-46d3-88cd-ca026f95b9c1"],
    "IVxProjectionSnapshot": ["ea74bbf4-8acb-4c36-a3ef-f05d9e14ca9e"],
    "IVxProjectionSourceBuffersChangedEvent": ["5fd8dc1e-0c10-4026-8fde-a3f198815998"],
    "IVxProjectionSourceBuffersChangedEventArgs": ["d058cf17-7aa6-41da-8816-90b93250e998"],
    "IVxProjectionSourceSpansChangedEvent": ["6c6c11a3-ec8a-426d-9c73-180431dcf306"],
    "IVxProjectionSourceSpansChangedEventArgs": ["9ef0e53c-b564-46d9-8616-d28034ac48c9"],
    "IVxPropertyCollection": ["275f2096-2f87-4886-bff7-a216f6decaab"],
    "IVxPropertyOwner": ["b7b3e0d6-f9f3-415e-a977-a06cc723aff1"],
    "IVxReadOnlyRegion": ["ece504c9-946e-4dd0-b929-0315736f86e4"],
    "IVxReadOnlyRegionEdit": ["93a8521c-26ec-44fc-9a8b-3f7af2974eaa"],
    "IVxSnapshotSpanEvent": ["8b881e32-b5f3-47a1-b62d-1dd1f2ff7803"],
    "IVxSnapshotSpanEventArgs": ["521a6cf3-58c3-4f05-be86-64871c7e7787"],
    "IVxTextBuffer": ["df9ab9af-f07e-43c5-9106-eaf5849760d2"],
    "IVxTextBufferCreatedEvent": ["7a45771d-7a36-4d18-9b81-c5daa88985b8"],
    "IVxTextBufferCreatedEventArgs": ["318855de-0da5-4d1d-9cce-481d99b75f16"],
    "IVxTextBufferEdit": ["ff1f08f7-7447-49e1-af8f-0a0929a21ac9"],
    "IVxTextBufferFactoryService": ["a8f4abb4-783f-462b-b5ee-384e63e63f5b"],
    "IVxTextChange": ["9b3001b6-bc6d-4dfc-9b7e-0e6f2c776d8e"],
    "IVxTextContentChangedEvent": ["5be64365-ae6e-4d88-b265-b22c5e743450"],
    "IVxTextContentChangedEventArgs": ["0fe2e653-3d0b-43db-b76f-12c5e04db756"],
    "IVxTextContentChangingEvent": ["5e12035a-0f79-408d-8d48-6896ff85bf7d"],
    "IVxTextContentChangingEventArgs": ["f26e15b3-89f8-4d5e-9bff-3d95c0101499"],
    "IVxTextDocument": ["5498337a-84b2-41bf-ab74-e5b88419079f"],
    "IVxTextDocumentEvent": ["36811be1-5281-4eca-9a64-dacb86fabf66"],
    "IVxTextDocumentEventArgs": ["d85f080d-428e-4ac7-b478-dac2f0cb3a4e"],
    "IVxTextDocumentFactoryService": ["f4d19c93-7267-4509-9284-88e8c08be615"],
    "IVxTextDocumentFileActionEvent": ["7598112a-a45e-4ec3-9b15-2536d26b1cab"],
    "IVxTextDocumentFileActionEventArgs": ["dc0c964d-81ae-4d24-8d4f-9340cc78d6ae"],
    "IVxTextEdit": ["aaaa0268-3374-4d81-8c09-c130688ab1e8"],
    "IVxTextSearchService": ["30d6bd3f-c415-42a6-b6e2-fad40ba8ab35"],
    "IVxTextSnapshot": ["f989d547-f569-495c-819b-9810e2bb6dd3"],
    "IVxTextSnapshotChangedEventArgs": ["ab1c7415-f8da-41f3-8262-221a2cf59cc4"],
    "IVxTextSnapshotLine": ["7b15e2bd-277b-42e8-869f-71b9fb79f962"],
    "IVxTextStructureNavigator": ["112990cb-72c0-43a9-ab89-bca935c4806f"],
    "IVxTextVersion": ["dc22e98b-dee1-4836-8fcc-ae137a47b89e"],
    "IVxThumbnailSupport": ["d83723ad-977d-4bf0-8534-1f1f72f5ac00"],
    "IVxTrackingPoint": ["d59ac777-8bb7-4634-a566-2d812970f5f6"],
    "IVxTrackingSpan": ["1ed17a9a-cc3f-4c10-aefb-92a19fee5abc"],
    "IWABAccountsSettings": ["d20b9b1a-d98a-4614-b864-569ab45cb262"],
    "IWABExtInit": ["ea22ebf0-87a4-11d1-9acf-00a0c91f9c8b"],
    "IWCNConnectNotify": ["c100be9f-d33a-4a4b-bf23-bbef4663d017"],
    "IWCNDevice": ["c100be9c-d33a-4a4b-bf23-bbef4663d017"],
    "IWDFCmResourceList": ["9f4546e9-fb4f-4df6-b8b8-b39e5d7d1ad4"],
    "IWDFDevice": ["d657fe45-460a-49c3-8219-766ae8032a80"],
    "IWDFDevice2": ["1b0d07b1-f596-4a76-99b3-b9492ad8df9f"],
    "IWDFDevice3": ["863d943a-c9cd-4655-a8d6-c84ef411cc0d"],
    "IWDFDeviceInitialize": ["74cc381c-0871-43c1-878b-3f7c9d16933d"],
    "IWDFDeviceInitialize2": ["424c00ba-fcd0-4c52-bd4a-6c5d3ec0dfd9"],
    "IWDFDriver": ["ad368ebe-4139-43e3-a875-69b266a9139c"],
    "IWDFDriverCreatedFile": ["b7615d26-494b-47a6-b4cf-0271bcc3da4b"],
    "IWDFFile": ["cc8fe04b-fe8b-4245-afd6-c31bc830c791"],
    "IWDFFile2": ["97893137-ce7f-4918-bc43-a91aef84b043"],
    "IWDFFile3": ["7188ca4f-1bd4-4fbc-a34a-2dc7b57f17cc"],
    "IWDFFileHandleTargetFactory": ["1427b7e8-e365-400b-9b92-5ace55168e25"],
    "IWDFInterrupt": ["aa2ad894-1c27-4ef4-b648-0d2223526b87"],
    "IWDFIoQueue": ["ae1162b9-8b11-4714-993d-93dc48cc9e8a"],
    "IWDFIoRequest": ["896df312-22b4-4a9d-95dd-a364aaf59769"],
    "IWDFIoRequest2": ["1b67f4cd-b278-4085-93e7-57970d98b92b"],
    "IWDFIoRequest3": ["92795040-b8aa-487a-b110-b80ebbd40b44"],
    "IWDFIoRequestCompletionParams": ["723d4f3c-7722-4c49-99ae-195937bd9582"],
    "IWDFIoTarget": ["cc060d79-c0c2-407f-8b10-a5e900fc3474"],
    "IWDFIoTarget2": ["eaebcbbb-deb5-4849-8acf-fb38336b94c7"],
    "IWDFIoTargetStateManagement": ["88b077aa-eff6-4eba-9e4d-064c70822b98"],
    "IWDFMemory": ["ab098f88-8f16-472a-b0bc-eca46486c102"],
    "IWDFNamedPropertyStore": ["394b48c9-bca0-498f-8e2c-01225464a932"],
    "IWDFNamedPropertyStore2": ["1464ee0e-8e0f-4fda-b1a0-b3614c405d56"],
    "IWDFObject": ["64275c66-2e71-4060-b5f4-3a76df96ed3c"],
    "IWDFPropertyStoreFactory": ["45be7e06-9b65-434d-a7d6-9572d7f73d53"],
    "IWDFRemoteInterface": ["49cbab14-e7cf-490b-8cdd-e0e6b2ac0247"],
    "IWDFRemoteInterfaceInitialize": ["8073d34c-4a21-4321-b6c7-a963fbecb6ad"],
    "IWDFRemoteTarget": ["d3ddb29d-bb46-48de-901b-96bed7b1d350"],
    "IWDFRequestCompletionParams": ["707a2b42-69b8-4971-a49c-4031861e7aff"],
    "IWDFUnifiedPropertyStore": ["6b966713-ac73-4975-ac3c-9df31c68da73"],
    "IWDFUnifiedPropertyStoreFactory": ["6ad8fac3-8b77-4997-99e4-6b78c5f548d6"],
    "IWDFUsbInterface": ["a6714a4d-c764-498f-b6d2-032f10ca4e36"],
    "IWDFUsbRequestCompletionParams": ["5cb1d859-f7ee-411e-9fa5-0159cc118324"],
    "IWDFUsbTargetDevice": ["4cd12e96-900a-44c3-a1b7-05b8954dab76"],
    "IWDFUsbTargetFactory": ["3f7becf9-3a65-4348-a4f3-339d5734a9c6"],
    "IWDFUsbTargetPipe": ["f373216e-8c42-4c5c-95b4-d2a40b99c0fa"],
    "IWDFUsbTargetPipe2": ["8efe1ab4-f4a2-42bb-9b2b-bbada19d8b80"],
    "IWDFWorkItem": ["e3142542-5259-4f20-a1ed-f57055af9265"],
    "IWICBitmap": ["00000121-a8f2-4877-ba0a-fd2b6645fb94"],
    "IWICBitmapClipper": ["e4fbcf03-223d-4e81-9333-d635556dd1b5"],
    "IWICBitmapCodecInfo": ["e87a44c4-b76e-4c47-8b09-298eb12a2714"],
    "IWICBitmapCodecProgressNotification": ["64c1024e-c3cf-4462-8078-88c2b11c46d9"],
    "IWICBitmapDecoder": ["9edde9e7-8dee-47ea-99df-e6faf2ed44bf"],
    "IWICBitmapDecoderInfo": ["d8cd007f-d08f-4191-9bfc-236ea7f0e4b5"],
    "IWICBitmapDecoderInfoInternal": ["c55b70fa-4fe3-47f6-a728-d69eb6e11da1"],
    "IWICBitmapEncoder": ["00000103-a8f2-4877-ba0a-fd2b6645fb94"],
    "IWICBitmapEncoderInfo": ["94c9b4ee-a09f-4f92-8a1e-4a9bce7e76fb"],
    "IWICBitmapFlipRotator": ["5009834f-2d6a-41ce-9e1b-17c5aff7a782"],
    "IWICBitmapFrameDecode": ["3b16811b-6a43-4ec9-a813-3d930c13b940"],
    "IWICBitmapFrameEncode": ["00000105-a8f2-4877-ba0a-fd2b6645fb94"],
    "IWICBitmapFrameEncodeInternal": ["e8cfe115-2841-42f1-b4e9-e1aa358f383e"],
    "IWICBitmapLock": ["00000123-a8f2-4877-ba0a-fd2b6645fb94"],
    "IWICBitmapScaler": ["00000302-a8f2-4877-ba0a-fd2b6645fb94"],
    "IWICBitmapSource": ["00000120-a8f2-4877-ba0a-fd2b6645fb94"],
    "IWICBitmapSourceTransform": ["3b16811b-6a43-4ec9-b713-3d5a0c13b940"],
    "IWICColorContext": ["3c613a02-34b2-44ea-9a7c-45aea9c6fd6d"],
    "IWICColorTransform": ["b66f034f-d0e2-40ab-b436-6de39e321a94"],
    "IWICColorTransformOverride": ["00000401-a8f2-4877-ba0a-fd2b6645fb94"],
    "IWICComponentFactory": ["412d0c3a-9650-44fa-af5b-dd2a06c8e8fb"],
    "IWICComponentInfo": ["23bc3f0a-698b-4357-886b-f24d50671334"],
    "IWICComponentInfoInternal": ["9692b173-1fa5-47ae-89b0-357fbaf34026"],
    "IWICComponentInternal": ["6e740908-a17a-4e4c-b1d8-84255e26c971"],
    "IWICConvertBgrToYCbCrInternal": ["e9426080-398a-441e-b5ff-4e52710b11ac"],
    "IWICDdsDecoder": ["409cd537-8532-40cb-9774-e2feb2df4e9c"],
    "IWICDdsEncoder": ["5cacdb4c-407e-41b3-b936-d0f010cd6732"],
    "IWICDdsFrameDecode": ["3d4c0c61-18a4-41e4-bd80-481a4fc9f464"],
    "IWICDecoderBitmapSource": ["4be49267-6e40-48c3-af9b-4b3de6d800c9"],
    "IWICDevelopRaw": ["fbec5e44-f7be-4b65-b7f8-c0c81fef026d"],
    "IWICDevelopRawNotificationCallback": ["95c75a6e-3e8c-4ec2-85a8-aebcc551e59b"],
    "IWICEnumMetadataItem": ["dc2bb46d-3f07-481e-8625-220c4aedbb33"],
    "IWICFastMetadataEncoder": ["b84e2c09-78c9-4ac4-8bd3-524ae1663a2f"],
    "IWICFormatConverter": ["00000301-a8f2-4877-ba0a-fd2b6645fb94"],
    "IWICFormatConverterInfo": ["9f34fb65-13f4-4f15-bc57-3726b5e53d9f"],
    "IWICGdiPlusInternal": ["88a640d2-3a21-4367-acfb-f448da43e6e0"],
    "IWICImageEncoder": ["04c75bf8-3ce1-473b-acc5-3cc4f5e94999"],
    "IWICImagingFactory": ["ec5ec8a9-c395-4314-9c77-54d7a935ff70"],
    "IWICImagingFactory2": ["7b816b45-1996-4476-b132-de9e247c8af0"],
    "IWICImagingFactoryInternal": ["32f8712f-0444-451a-8f3d-d69cbbf96f30"],
    "IWICImagingFactoryTestInternal": ["c282a175-e758-40e2-94a8-e4c9b55cbd6c"],
    "IWICJpegFrameDecode": ["8939f66e-c46a-4c21-a9d1-98b327ce1679"],
    "IWICJpegFrameDecodeInternal": ["796e20d9-1c0b-4e5a-9cb6-0fedc0b05cb1"],
    "IWICJpegFrameEncode": ["2f0c601f-d2c6-468c-abfa-49495d983ed1"],
    "IWICMetadataBlockReader": ["feaa2a8d-b3f3-43e4-b25c-d1de990a1ae1"],
    "IWICMetadataBlockReaderInfo": ["00240e6f-3f23-4432-b0cc-48d5bbff6c36"],
    "IWICMetadataBlockWriter": ["08fb9676-b444-41e8-8dbe-6a53a542bff1"],
    "IWICMetadataHandlerInfo": ["aba958bf-c672-44d1-8d61-ce6df2e682c2"],
    "IWICMetadataPolicyComponent": ["242b8952-6b0b-4a3f-8701-4b47e271ea16"],
    "IWICMetadataQueryReader": ["30989668-e1c9-4597-b395-458eedb808df"],
    "IWICMetadataQueryReaderInternal": ["6a2e1dea-d2fa-4c8c-ac66-ad388b018d21"],
    "IWICMetadataQueryWriter": ["a721791a-0def-4d06-bd91-2118bf1db10b"],
    "IWICMetadataReader": ["9204fe99-d8fc-4fd5-a001-9536b067a899"],
    "IWICMetadataReaderInfo": ["eebf1f5b-07c1-4447-a3ab-22acaf78a804"],
    "IWICMetadataWriter": ["f7836e16-3be0-470b-86bb-160d0aecd7de"],
    "IWICMetadataWriterInfo": ["b22e3fba-3925-4323-b5c1-9ebfc430f236"],
    "IWICPalette": ["00000040-a8f2-4877-ba0a-fd2b6645fb94"],
    "IWICPersistStream": ["00675040-6908-45f8-86a3-49c7dfd6d9ad"],
    "IWICPixelFormatInfo": ["e8eda601-3d48-431a-ab44-69059be88bbe"],
    "IWICPixelFormatInfo2": ["a9db33a2-af5f-43c7-b679-74f5984b5aa4"],
    "IWICPlanarBitmapFrameEncode": ["f928b7b8-2221-40c1-b72e-7e82f1974d1a"],
    "IWICPlanarBitmapSourceTransform": ["3aff9cce-be95-4303-b927-e7d16ff4a613"],
    "IWICPlanarFormatConverter": ["bebee9cb-83b0-4dcc-8132-b0aaa55eac96"],
    "IWICPlanarFormatConverterInternal": ["1d10445f-70cb-4e35-9b37-30c19c645b5e"],
    "IWICProgressCallback": ["4776f9cd-9517-45fa-bf24-e89c5ec5c60c"],
    "IWICProgressiveLevelControl": ["daac296f-7aa5-4dbf-8d15-225c5976f891"],
    "IWICStream": ["135ff860-22b7-4ddf-b0f6-218f4f299a43"],
    "IWICStreamProvider": ["449494bc-b468-4927-96d7-ba90d31ab505"],
    "IWICTransformSource": ["fa5b7bef-ae88-47bd-bab5-f0534c431601"],
    "IWMAddressAccess": ["bb3c6389-1633-4e92-af14-9f3173ba39d0"],
    "IWMAddressAccess2": ["65a83fc2-3e98-4d4d-81b5-2a742886b33d"],
    "IWMAuthorizer": ["d9b67d36-a9ad-4eb4-baef-db284ef5504c"],
    "IWMBackupRestoreProps": ["3c8e0da6-996f-4ff3-a1af-4838f9377e2e"],
    "IWMBandwidthSharing": ["ad694af1-f8d9-42f8-bc47-70311b0c4f9e"],
    "IWMClientConnections": ["73c66010-a299-41df-b1f0-ccf03b09c1c6"],
    "IWMClientConnections2": ["4091571e-4701-4593-bb3d-d5f5f0c74246"],
    "IWMCodecAMVideoAccelerator": ["d98ee251-34e0-4a2d-9312-9b4c788d9fa1"],
    "IWMCodecInfo": ["a970f41e-34de-4a98-b3ba-e4b3ca7528f0"],
    "IWMCodecInfo2": ["aa65e273-b686-4056-91ec-dd768d4df710"],
    "IWMCodecInfo3": ["7e51f487-4d93-4f98-8ab4-27d0565adc51"],
    "IWMCodecLeakyBucket": ["a81ba647-6227-43b7-b231-c7b15135dd7d"],
    "IWMCodecOutputTimestamp": ["b72adf95-7adc-4a72-bc05-577d8ea6bf68"],
    "IWMCodecPrivateData": ["73f0be8e-57f7-4f01-aa66-9f57340cfe0e"],
    "IWMCodecProps": ["2573e11a-f01a-4fdd-a98d-63b8e0ba9589"],
    "IWMCodecStrings": ["a7b2504b-e58a-47fb-958b-cac7165a057d"],
    "IWMCodecVideoAccelerator": ["990641b0-739f-4e94-a808-9888da8f75af"],
    "IWMColorConvProps": ["e6a49e22-c099-421d-aad3-c061fb4ae85b"],
    "IWMColorLegalizerProps": ["776c93b3-b72d-4508-b6d0-208785f553e7"],
    "IWMCredentialCallback": ["342e0eb7-e651-450c-975b-2ace2c90c48e"],
    "IWMDMDevice": ["1dcb3a02-33ed-11d3-8470-00c04f79dbc0"],
    "IWMDMDevice2": ["e34f3d37-9d67-4fc1-9252-62d28b2f8b55"],
    "IWMDMDevice3": ["6c03e4fe-05db-4dda-9e3c-06233a6d5d65"],
    "IWMDMDeviceControl": ["1dcb3a04-33ed-11d3-8470-00c04f79dbc0"],
    "IWMDMDeviceSession": ["82af0a65-9d96-412c-83e5-3c43e4b06cc7"],
    "IWMDMEnumDevice": ["1dcb3a01-33ed-11d3-8470-00c04f79dbc0"],
    "IWMDMEnumStorage": ["1dcb3a05-33ed-11d3-8470-00c04f79dbc0"],
    "IWMDMLogger": ["110a3200-5a79-11d3-8d78-444553540000"],
    "IWMDMMetaData": ["ec3b0663-0951-460a-9a80-0dceed3c043c"],
    "IWMDMNotification": ["3f5e95c0-0f43-4ed4-93d2-c89a45d59b81"],
    "IWMDMObjectInfo": ["1dcb3a09-33ed-11d3-8470-00c04f79dbc0"],
    "IWMDMOperation": ["1dcb3a0b-33ed-11d3-8470-00c04f79dbc0"],
    "IWMDMOperation2": ["33445b48-7df7-425c-ad8f-0fc6d82f9f75"],
    "IWMDMOperation3": ["d1f9b46a-9ca8-46d8-9d0f-1ec9bae54919"],
    "IWMDMProgress": ["1dcb3a0c-33ed-11d3-8470-00c04f79dbc0"],
    "IWMDMProgress2": ["3a43f550-b383-4e92-b04a-e6bbc660fefc"],
    "IWMDMProgress3": ["21de01cb-3bb4-4929-b21a-17af3f80f658"],
    "IWMDMRevoked": ["ebeccedb-88ee-4e55-b6a4-8d9f07d696aa"],
    "IWMDMStorage": ["1dcb3a06-33ed-11d3-8470-00c04f79dbc0"],
    "IWMDMStorage2": ["1ed5a144-5cd5-4683-9eff-72cbdb2d9533"],
    "IWMDMStorage3": ["97717eea-926a-464e-96a4-247b0216026e"],
    "IWMDMStorage4": ["c225bac5-a03a-40b8-9a23-91cf478c64a6"],
    "IWMDMStorageControl": ["1dcb3a08-33ed-11d3-8470-00c04f79dbc0"],
    "IWMDMStorageControl2": ["972c2e88-bd6c-4125-8e09-84f837e637b6"],
    "IWMDMStorageControl3": ["b3266365-d4f3-4696-8d53-bd27ec60993a"],
    "IWMDMStorageGlobals": ["1dcb3a07-33ed-11d3-8470-00c04f79dbc0"],
    "IWMDRMEditor": ["ff130ebc-a6c3-42a6-b401-c3382c3e08b3"],
    "IWMDRMMessageParser": ["a73a0072-25a0-4c99-b4a5-ede8101a6c39"],
    "IWMDRMReader": ["d2827540-3ee7-432c-b14c-dc17f085d3b3"],
    "IWMDRMReader2": ["befe7a75-9f1d-4075-b9d9-a3c37bda49a0"],
    "IWMDRMReader3": ["e08672de-f1e7-4ff4-a0a3-fc4b08e4caf8"],
    "IWMDRMTranscryptionManager": ["b1a887b2-a4f0-407a-b02e-efbd23bbecdf"],
    "IWMDRMTranscryptor": ["69059850-6e6f-4bb2-806f-71863ddfc471"],
    "IWMDRMTranscryptor2": ["e0da439f-d331-496a-bece-18e5bac5dd23"],
    "IWMDRMWriter": ["d6ea5dd0-12a0-43f4-90ab-a3fd451e6a07"],
    "IWMDRMWriter2": ["38ee7a94-40e2-4e10-aa3f-33fd3210ed5b"],
    "IWMDRMWriter3": ["a7184082-a4aa-4dde-ac9c-e75dbd1117ce"],
    "IWMDeviceManager": ["1dcb3a00-33ed-11d3-8470-00c04f79dbc0"],
    "IWMDeviceManager2": ["923e5249-8731-4c5b-9b1c-b8b60b6e46af"],
    "IWMDeviceManager3": ["af185c41-100d-46ed-be2e-9ce8c44594ef"],
    "IWMDeviceRegistration": ["f6211f03-8d21-4e94-93e6-8510805f2d99"],
    "IWMFrameInterpProps": ["4c06bb9b-626c-4614-8329-cc6a21b93fa0"],
    "IWMGetSecureChannel": ["94bc0598-c3d2-11d3-bedf-00c04f612986"],
    "IWMHeaderInfo": ["96406bda-2b2b-11d3-b36b-00c04f6108ff"],
    "IWMHeaderInfo2": ["15cf9781-454e-482e-b393-85fae487a810"],
    "IWMHeaderInfo3": ["15cc68e3-27cc-4ecd-b222-3f5d02d80bd5"],
    "IWMIExtension": ["adc1f06e-5c7e-11d2-8b74-00104b2afb41"],
    "IWMIStreamProps": ["6816dad3-2b4b-4c8e-8149-874c3483a753"],
    "IWMImageInfo": ["9f0aa3b6-7267-4d89-88f2-ba915aa5c4c6"],
    "IWMIndexer": ["6d7cdc71-9888-11d3-8edc-00c04f6109cf"],
    "IWMIndexer2": ["b70f1e42-6255-4df0-a6b9-02b212d9e2bb"],
    "IWMInputMediaProps": ["96406bd5-2b2b-11d3-b36b-00c04f6108ff"],
    "IWMInterlaceProps": ["7b12e5d1-bd22-48ea-bc06-98e893221c89"],
    "IWMLanguageList": ["df683f00-2d49-4d8e-92b7-fb19f6a0dc57"],
    "IWMLicenseBackup": ["05e5ac9f-3fb6-4508-bb43-a4067ba1ebe8"],
    "IWMLicenseRestore": ["c70b6334-a22e-4efb-a245-15e65a004a13"],
    "IWMLicenseRevocationAgent": ["6967f2c9-4e26-4b57-8894-799880f7ac7b"],
    "IWMMediaProps": ["96406bce-2b2b-11d3-b36b-00c04f6108ff"],
    "IWMMetadataEditor": ["96406bd9-2b2b-11d3-b36b-00c04f6108ff"],
    "IWMMetadataEditor2": ["203cffe3-2e18-4fdf-b59d-6e71530534cf"],
    "IWMMutualExclusion": ["96406bde-2b2b-11d3-b36b-00c04f6108ff"],
    "IWMMutualExclusion2": ["0302b57d-89d1-4ba2-85c9-166f2c53eb91"],
    "IWMOutputMediaProps": ["96406bd7-2b2b-11d3-b36b-00c04f6108ff"],
    "IWMPAudioRenderConfig": ["e79c6349-5997-4ce4-917c-22a3391ec564"],
    "IWMPCdrom": ["cfab6e98-8730-11d3-b388-00c04f68574b"],
    "IWMPCdromBurn": ["bd94dbeb-417f-4928-aa06-087d56ed9b59"],
    "IWMPCdromCollection": ["ee4c8fe2-34b2-11d3-a3bf-006097c9b344"],
    "IWMPCdromRip": ["56e2294f-69ed-4629-a869-aea72c0dcc2c"],
    "IWMPClosedCaption": ["4f2df574-c588-11d3-9ed0-00c04fb6e937"],
    "IWMPClosedCaption2": ["350ba78b-6bc8-4113-a5f5-312056934eb6"],
    "IWMPContentContainer": ["ad7f4d9c-1a9f-4ed2-9815-ecc0b58cb616"],
    "IWMPContentContainerList": ["a9937f78-0802-4af8-8b8d-e3f045bc8ab5"],
    "IWMPContentPartner": ["55455073-41b5-4e75-87b8-f13bdb291d08"],
    "IWMPContentPartnerCallback": ["9e8f7da2-0695-403c-b697-da10fafaa676"],
    "IWMPControls": ["74c09e02-f828-11d2-a74b-00a0c905f36e"],
    "IWMPControls2": ["6f030d25-0890-480f-9775-1f7e40ab5b8e"],
    "IWMPControls3": ["a1d1110e-d545-476a-9a78-ac3e4cb1e6bd"],
    "IWMPConvert": ["d683162f-57d4-4108-8373-4a9676d1c2e9"],
    "IWMPCore": ["d84cca99-cce2-11d2-9ecc-0000f8085981"],
    "IWMPCore2": ["bc17e5b7-7561-4c18-bb90-17d485775659"],
    "IWMPCore3": ["7587c667-628f-499f-88e7-6a6f4e888464"],
    "IWMPDVD": ["8da61686-4668-4a5c-ae5d-803193293dbe"],
    "IWMPDownloadCollection": ["0a319c7f-85f9-436c-b88e-82fd88000e1c"],
    "IWMPDownloadItem": ["c9470e8e-3f6b-46a9-a0a9-452815c34297"],
    "IWMPDownloadItem2": ["9fbb3336-6da3-479d-b8ff-67d46e20a987"],
    "IWMPDownloadManager": ["e15e9ad1-8f20-4cc4-9ec7-1a328ca86a0d"],
    "IWMPEffects": ["d3984c13-c3cb-48e2-8be5-5168340b4f35"],
    "IWMPEffects2": ["695386ec-aa3c-4618-a5e1-dd9a8b987632"],
    "IWMPError": ["a12dcf7d-14ab-4c1b-a8cd-63909f06025b"],
    "IWMPErrorItem": ["3614c646-3b3b-4de7-a81e-930e3f2127b3"],
    "IWMPErrorItem2": ["f75ccec0-c67c-475c-931e-8719870bee7d"],
    "IWMPEvents": ["19a6627b-da9e-47c1-bb23-00b5e668236a"],
    "IWMPEvents2": ["1e7601fa-47ea-4107-9ea9-9004ed9684ff"],
    "IWMPEvents3": ["1f504270-a66b-4223-8e96-26a06c63d69f"],
    "IWMPEvents4": ["26dabcfa-306b-404d-9a6f-630a8405048d"],
    "IWMPFolderMonitorServices": ["788c8743-e57f-439d-a468-5bc77f2e59c6"],
    "IWMPGraphCreation": ["bfb377e5-c594-4369-a970-de896d5ece74"],
    "IWMPLibrary": ["3df47861-7df1-4c1f-a81b-4c26f0f7a7c6"],
    "IWMPLibrary2": ["dd578a4e-79b1-426c-bf8f-3add9072500b"],
    "IWMPLibraryServices": ["39c2f8d5-1cf2-4d5e-ae09-d73492cf9eaa"],
    "IWMPLibrarySharingServices": ["82cba86b-9f04-474b-a365-d6dd1466e541"],
    "IWMPMedia": ["94d55e95-3fac-11d3-b155-00c04f79faa6"],
    "IWMPMedia2": ["ab7c88bb-143e-4ea4-acc3-e4350b2106c3"],
    "IWMPMedia3": ["f118efc7-f03a-4fb4-99c9-1c02a5c1065b"],
    "IWMPMediaCollection": ["8363bc22-b4b4-4b19-989d-1cd765749dd1"],
    "IWMPMediaCollection2": ["8ba957f5-fd8c-4791-b82d-f840401ee474"],
    "IWMPMediaPluginRegistrar": ["68e27045-05bd-40b2-9720-23088c78e390"],
    "IWMPMetadataPicture": ["5c29bbe0-f87d-4c45-aa28-a70f0230ffa9"],
    "IWMPMetadataText": ["769a72db-13d2-45e2-9c48-53ca9d5b7450"],
    "IWMPNetwork": ["ec21b779-edef-462d-bba4-ad9dde2b29a7"],
    "IWMPNodeRealEstate": ["42751198-5a50-4460-bcb4-709f8bdc8e59"],
    "IWMPNodeRealEstateHost": ["1491087d-2c6b-44c8-b019-b3c929d2ada9"],
    "IWMPNodeWindowed": ["96740bfa-c56a-45d1-a3a4-762914d4ade9"],
    "IWMPNodeWindowedHost": ["a300415a-54aa-4081-adbf-3b13610d8958"],
    "IWMPNodeWindowless": ["9b9199ad-780c-4eda-b816-261eba5d1575"],
    "IWMPNodeWindowlessHost": ["be7017c6-ce34-4901-8106-770381aa6e3e"],
    "IWMPPlayer": ["6bf52a4f-394a-11d3-b153-00c04f79faa6"],
    "IWMPPlayer2": ["0e6b01d1-d407-4c85-bf5f-1c01f6150280"],
    "IWMPPlayer3": ["54062b68-052a-4c25-a39f-8b63346511d4"],
    "IWMPPlayer4": ["6c497d62-8919-413c-82db-e935fb3ec584"],
    "IWMPPlayerApplication": ["40897764-ceab-47be-ad4a-8e28537f9bbf"],
    "IWMPPlayerServices": ["1d01fbdb-ade2-4c8d-9842-c190b95c3306"],
    "IWMPPlayerServices2": ["1bb1592f-f040-418a-9f71-17c7512b4d70"],
    "IWMPPlaylist": ["d5f0f4f1-130c-11d3-b14e-00c04f79faa6"],
    "IWMPPlaylistArray": ["679409c0-99f7-11d3-9fb7-00105aa620bb"],
    "IWMPPlaylistCollection": ["10a13217-23a7-439b-b1c0-d847c79b7774"],
    "IWMPPlugin": ["f1392a70-024c-42bb-a998-73dfdfe7d5a7"],
    "IWMPPluginEnable": ["5fca444c-7ad1-479d-a4ef-40566a5309d6"],
    "IWMPPluginUI": ["4c5e8f9f-ad3e-4bf9-9753-fcd30d6d38dd"],
    "IWMPQuery": ["a00918f3-a6b0-4bfb-9189-fd834c7bc5a5"],
    "IWMPRemoteMediaServices": ["cbb92747-741f-44fe-ab5b-f1a48f3b2a59"],
    "IWMPRenderConfig": ["959506c1-0314-4ec5-9e61-8528db5e5478"],
    "IWMPServices": ["afb6b76b-1e20-4198-83b3-191db6e0b149"],
    "IWMPSettings": ["9104d1ab-80c9-4fed-abf0-2e6417a6df14"],
    "IWMPSettings2": ["fda937a4-eece-4da5-a0b6-39bf89ade2c2"],
    "IWMPSkinManager": ["076f2fa6-ed30-448b-8cc5-3f3ef3529c7a"],
    "IWMPStringCollection": ["4a976298-8c0d-11d3-b389-00c04f68574b"],
    "IWMPStringCollection2": ["46ad648d-53f1-4a74-92e2-2a1b68d63fd4"],
    "IWMPSubscriptionService": ["376055f8-2a59-4a73-9501-dca5273a7a10"],
    "IWMPSubscriptionService2": ["a94c120e-d600-4ec6-b05e-ec9d56d84de0"],
    "IWMPSubscriptionServiceCallback": ["dd01d127-2dc2-4c3a-876e-63312079f9b0"],
    "IWMPSyncDevice": ["82a2986c-0293-4fd0-b279-b21b86c058be"],
    "IWMPSyncDevice2": ["88afb4b2-140a-44d2-91e6-4543da467cd1"],
    "IWMPSyncDevice3": ["b22c85f9-263c-4372-a0da-b518db9b4098"],
    "IWMPSyncServices": ["8b5050ff-e0a4-4808-b3a8-893a9e1ed894"],
    "IWMPTranscodePolicy": ["b64cbac3-401c-4327-a3e8-b9feb3a8c25c"],
    "IWMPUserEventSink": ["cfccfa72-c343-48c3-a2de-b7a4402e39f2"],
    "IWMPVideoRenderConfig": ["6d6cf803-1ec0-4c8d-b3ca-f18e27282074"],
    "IWMPWindowMessageSink": ["3a0daa30-908d-4789-ba87-aed879b5c49b"],
    "IWMPacketSize": ["cdfb97ab-188f-40b3-b643-5b7903975c59"],
    "IWMPacketSize2": ["8bfc2b9e-b646-4233-a877-1c6a079669dc"],
    "IWMPlayerHook": ["e5b7ca9a-0f1c-4f66-9002-74ec50d8b304"],
    "IWMPlayerTimestampHook": ["28580dda-d98e-48d0-b7ae-69e473a02825"],
    "IWMProfile": ["96406bdb-2b2b-11d3-b36b-00c04f6108ff"],
    "IWMProfile2": ["07e72d33-d94e-4be7-8843-60ae5ff7e5f5"],
    "IWMProfile3": ["00ef96cc-a461-4546-8bcd-c9a28f0e06f5"],
    "IWMProfileManager": ["d16679f2-6ca0-472d-8d31-2f5d55aee155"],
    "IWMProfileManager2": ["7a924e51-73c1-494d-8019-23d37ed9b89a"],
    "IWMProfileManagerLanguage": ["ba4dcc78-7ee0-4ab8-b27a-dbce8bc51454"],
    "IWMPropertyVault": ["72995a79-5090-42a4-9c8c-d9d0b6d34be5"],
    "IWMProximityDetection": ["6a9fd8ee-b651-4bf0-b849-7d4ece79a2b1"],
    "IWMReader": ["96406bd6-2b2b-11d3-b36b-00c04f6108ff"],
    "IWMReaderAccelerator": ["bddc4d08-944d-4d52-a612-46c3fda07dd4"],
    "IWMReaderAdvanced": ["96406bea-2b2b-11d3-b36b-00c04f6108ff"],
    "IWMReaderAdvanced2": ["ae14a945-b90c-4d0d-9127-80d665f7d73e"],
    "IWMReaderAdvanced3": ["5dc0674b-f04b-4a4e-9f2a-b1afde2c8100"],
    "IWMReaderAdvanced4": ["945a76a2-12ae-4d48-bd3c-cd1d90399b85"],
    "IWMReaderAdvanced5": ["24c44db0-55d1-49ae-a5cc-f13815e36363"],
    "IWMReaderAdvanced6": ["18a2e7f8-428f-4acd-8a00-e64639bc93de"],
    "IWMReaderAllocatorEx": ["9f762fa7-a22e-428d-93c9-ac82f3aafe5a"],
    "IWMReaderCallback": ["96406bd8-2b2b-11d3-b36b-00c04f6108ff"],
    "IWMReaderCallbackAdvanced": ["96406beb-2b2b-11d3-b36b-00c04f6108ff"],
    "IWMReaderNetworkConfig": ["96406bec-2b2b-11d3-b36b-00c04f6108ff"],
    "IWMReaderNetworkConfig2": ["d979a853-042b-4050-8387-c939db22013f"],
    "IWMReaderPlaylistBurn": ["f28c0300-9baa-4477-a846-1744d9cbf533"],
    "IWMReaderStreamClock": ["96406bed-2b2b-11d3-b36b-00c04f6108ff"],
    "IWMReaderTimecode": ["f369e2f0-e081-4fe6-8450-b810b2f410d1"],
    "IWMReaderTypeNegotiation": ["fdbe5592-81a1-41ea-93bd-735cad1adc05"],
    "IWMRegisterCallback": ["cf4b1f99-4de2-4e49-a363-252740d99bc1"],
    "IWMRegisteredDevice": ["a4503bec-5508-4148-97ac-bfa75760a70d"],
    "IWMResamplerProps": ["e7e9984f-f09f-4da4-903f-6e2e0efe56b5"],
    "IWMResizerProps": ["57665d4c-0414-4faa-905b-10e546f81c33"],
    "IWMSBuffer": ["e1cd3524-03d7-11d2-9eed-006097d2d7cf"],
    "IWMSBufferAllocator": ["61103ca4-2033-11d2-9ef1-006097d2d7cf"],
    "IWMSInternalAdminNetSource": ["8bb23e5f-d127-4afb-8d02-ae5b66d54c78"],
    "IWMSInternalAdminNetSource2": ["e74d58c3-cf77-4b51-af17-744687c43eae"],
    "IWMSInternalAdminNetSource3": ["6b63d08e-4590-44af-9eb3-57ff1e73bf80"],
    "IWMSampleExtensionSupport": ["9bca9884-0604-4c2a-87da-793ff4d586c3"],
    "IWMSecureChannel": ["2720598a-d0f2-4189-bd10-91c46ef0936f"],
    "IWMStatusCallback": ["6d7cdc70-9888-11d3-8edc-00c04f6109cf"],
    "IWMStreamConfig": ["96406bdc-2b2b-11d3-b36b-00c04f6108ff"],
    "IWMStreamConfig2": ["7688d8cb-fc0d-43bd-9459-5a8dec200cfa"],
    "IWMStreamConfig3": ["cb164104-3aa9-45a7-9ac9-4daee131d6e1"],
    "IWMStreamList": ["96406bdd-2b2b-11d3-b36b-00c04f6108ff"],
    "IWMStreamPrioritization": ["8c1c6090-f9a8-4748-8ec3-dd1108ba1e77"],
    "IWMSyncReader": ["9397f121-7705-4dc9-b049-98b698188414"],
    "IWMSyncReader2": ["faed3d21-1b6b-4af7-8cb6-3e189bbc187b"],
    "IWMValidate": ["cee3def2-3808-414d-be66-fafd472210bc"],
    "IWMVideoDecoderHurryup": ["352bb3bd-2d4d-4323-9e71-dcdcfbd53ca6"],
    "IWMVideoDecoderReconBuffer": ["45bda2ac-88e2-4923-98ba-3949080711a3"],
    "IWMVideoForceKeyFrame": ["9f8496be-5b9a-41b9-a9e8-f21cd80596c2"],
    "IWMVideoMediaProps": ["96406bcf-2b2b-11d3-b36b-00c04f6108ff"],
    "IWMWatermarkInfo": ["6f497062-f2e2-4624-8ea7-9dd40d81fc8d"],
    "IWMWriter": ["96406bd4-2b2b-11d3-b36b-00c04f6108ff"],
    "IWMWriterAdvanced": ["96406be3-2b2b-11d3-b36b-00c04f6108ff"],
    "IWMWriterAdvanced2": ["962dc1ec-c046-4db8-9cc7-26ceae500817"],
    "IWMWriterAdvanced3": ["2cd6492d-7c37-4e76-9d3b-59261183a22e"],
    "IWMWriterFileSink": ["96406be5-2b2b-11d3-b36b-00c04f6108ff"],
    "IWMWriterFileSink2": ["14282ba7-4aef-4205-8ce5-c229035a05bc"],
    "IWMWriterFileSink3": ["3fea4feb-2945-47a7-a1dd-c53a8fc4c45c"],
    "IWMWriterNetworkSink": ["96406be7-2b2b-11d3-b36b-00c04f6108ff"],
    "IWMWriterPostView": ["81e20ce4-75ef-491a-8004-fc53c45bdc3e"],
    "IWMWriterPostViewCallback": ["d9d6549d-a193-4f24-b308-03123d9b7f8d"],
    "IWMWriterPreprocess": ["fc54a285-38c4-45b5-aa23-85b9f7cb424b"],
    "IWMWriterPushSink": ["dc10e6a5-072c-467d-bf57-6330a9dde12a"],
    "IWMWriterSink": ["96406be4-2b2b-11d3-b36b-00c04f6108ff"],
    "IWNSChannelDetails": ["7b342288-4015-4d6b-90aa-1c53d718fa6a"],
    "IWPCBlockedUrls": ["30510413-98b5-11cf-bb82-00aa00bdce0b"],
    "IWPCDownloadContext": ["536cc788-c28d-4be0-a187-8fc319b1619f"],
    "IWPCGamesSettings": ["95e87780-e158-489e-b452-bbb850790715"],
    "IWPCProviderConfig": ["bef54196-2d02-4a26-b6e5-d65af295d0f1"],
    "IWPCProviderState": ["50b6a267-c4bd-450b-adb5-759073837c9e"],
    "IWPCProviderSupport": ["41eba572-23ed-4779-bec1-8df96206c44c"],
    "IWPCSettings": ["8fdf6ca1-0189-47e4-b670-1a8a4636e340"],
    "IWPCWebSettings": ["ffccbdb8-0992-4c30-b0f1-1cbb09c240aa"],
    "IWRdsGraphicsChannel": ["684b7a0b-edff-43ad-d5a2-4a8d5388f401"],
    "IWRdsGraphicsChannelEvents": ["67f2368c-d674-4fae-66a5-d20628a640d2"],
    "IWRdsGraphicsChannelManager": ["0fd57159-e83e-476a-a8b9-4a7976e71e18"],
    "IWRdsProtocolConnection": ["324ed94f-fdaf-4ff6-81a8-42abe755830b"],
    "IWRdsProtocolConnectionCallback": ["f1d70332-d070-4ef1-a088-78313536c2d6"],
    "IWRdsProtocolConnectionSettings": ["83fcf5d3-f6f4-ea94-9cd2-32f280e1e510"],
    "IWRdsProtocolLicenseConnection": ["1d6a145f-d095-4424-957a-407fae822d84"],
    "IWRdsProtocolListener": ["fcbc131b-c686-451d-a773-e279e230f540"],
    "IWRdsProtocolListenerCallback": ["3ab27e5b-4449-4dc1-b74a-91621d4fe984"],
    "IWRdsProtocolLogonErrorRedirector": ["519fe83b-142a-4120-a3d5-a405d315281a"],
    "IWRdsProtocolManager": ["dc796967-3abb-40cd-a446-105276b58950"],
    "IWRdsProtocolSettings": ["654a5a6a-2550-47eb-b6f7-ebd637475265"],
    "IWRdsProtocolShadowCallback": ["e0667ce0-0372-40d6-adb2-a0f3322674d6"],
    "IWRdsProtocolShadowConnection": ["9ae85ce6-cade-4548-8feb-99016597f60a"],
    "IWRdsRemoteFXGraphicsConnection": ["0fad5dcf-c6d3-423c-b097-163d6a676151"],
    "IWRdsWddmIddProps": ["1382df4d-a289-43d1-a184-144726f9af90"],
    "IWSCDefaultProduct": ["0476d69c-f21a-11e5-9ce9-5e5517507c66"],
    "IWSCProductList": ["722a338c-6e8e-4e72-ac27-1417fb0c81c2"],
    "IWSChangeNotify": ["b1c35c72-1cf9-422f-aad3-db78cfe796ac"],
    "IWSDAddress": ["b9574c6c-12a6-4f74-93a1-3318ff605759"],
    "IWSDAsyncCallback": ["a63e109d-ce72-49e2-ba98-e845f5ee1666"],
    "IWSDAsyncResult": ["11a9852a-8dd8-423e-b537-9356db4fbfb8"],
    "IWSDAttachment": ["5d55a616-9df8-4b09-b156-9ba351a48b76"],
    "IWSDDeviceHost": ["917fe891-3d13-4138-9809-934c8abeb12c"],
    "IWSDDeviceHostNotify": ["b5bee9f9-eeda-41fe-96f7-f45e14990fb0"],
    "IWSDDeviceProxy": ["eee0c031-c578-4c0e-9a3b-973c35f409db"],
    "IWSDEndpointProxy": ["1860d430-b24c-4975-9f90-dbb39baa24ec"],
    "IWSDEventingStatus": ["49b17f52-637a-407a-ae99-fbe82a4d38c0"],
    "IWSDHttpAddress": ["d09ac7bd-2a3e-4b85-8605-2737ff3e4ea0"],
    "IWSDHttpAuthParameters": ["0b476df0-8dac-480d-b05c-99781a5884aa"],
    "IWSDHttpMessageParameters": ["540bd122-5c83-4dec-b396-ea62a2697fdf"],
    "IWSDInboundAttachment": ["5bd6ca65-233c-4fb8-9f7a-2641619655c9"],
    "IWSDMessageParameters": ["1fafe8a2-e6fc-4b80-b6cf-b7d45c416d7c"],
    "IWSDMetadataExchange": ["06996d57-1d67-4928-9307-3d7833fdb846"],
    "IWSDOutboundAttachment": ["aa302f8d-5a22-4ba5-b392-aa8486f4c15d"],
    "IWSDSSLClientCertificate": ["de105e87-a0da-418e-98ad-27b9eed87bdc"],
    "IWSDScopeMatchingRule": ["fcafe424-fef5-481a-bd9f-33ce0574256f"],
    "IWSDServiceMessaging": ["94974cf4-0cab-460d-a3f6-7a0ad623c0e6"],
    "IWSDServiceProxy": ["d4c7fb9c-03ab-4175-9d67-094fafebf487"],
    "IWSDServiceProxyEventing": ["f9279d6d-1012-4a94-b8cc-fd35d2202bfe"],
    "IWSDSignatureProperty": ["03ce20aa-71c4-45e2-b32e-3766c61c790f"],
    "IWSDTransportAddress": ["70d23498-4ee6-4340-a3df-d845d2235467"],
    "IWSDUdpAddress": ["74d6124a-a441-4f78-a1eb-97a8d1996893"],
    "IWSDUdpMessageParameters": ["9934149f-8f0c-447b-aa0b-73124b0ca7f0"],
    "IWSDXMLContext": ["75d8f3ee-3e5a-43b4-a15a-bcf6887460c0"],
    "IWSDiscoveredService": ["4bad8a3b-b374-4420-9632-aac945b374aa"],
    "IWSDiscoveryProvider": ["8ffc8e55-f0eb-480f-88b7-b435dd281d45"],
    "IWSDiscoveryProviderNotify": ["73ee3ced-b6e6-4329-a546-3e8ad46563d2"],
    "IWSDiscoveryPublisher": ["ae01e1a8-3ff9-4148-8116-057cc616fe13"],
    "IWSDiscoveryPublisherNotify": ["e67651b0-337a-4b3c-9758-733388568251"],
    "IWSMan": ["190d8637-5cd3-496d-ad24-69636bb5a3b5"],
    "IWSManConnectionOptions": ["f704e861-9e52-464f-b786-da5eb2320fdd"],
    "IWSManConnectionOptionsEx": ["ef43edf7-2a48-4d93-9526-8bd6ab6d4a6b"],
    "IWSManConnectionOptionsEx2": ["f500c9ec-24ee-48ab-b38d-fc9a164c658e"],
    "IWSManEnumerator": ["f3457ca9-abb9-4fa5-b850-90e8ca300e7f"],
    "IWSManEx": ["2d53bdaa-798e-49e6-a1aa-74d01256f411"],
    "IWSManEx2": ["1d1b5ae0-42d9-4021-8261-3987619512e9"],
    "IWSManEx3": ["6400e966-011d-4eac-8474-049e0848afad"],
    "IWSManInternal": ["04ae2b1d-9954-4d99-94a9-a961e72c3a13"],
    "IWSManResourceLocator": ["a7a1ba28-de41-466a-ad0a-c4059ead7428"],
    "IWSManResourceLocatorInternal": ["effaead7-7ec8-4716-b9be-f2e7e9fb4adb"],
    "IWSManSession": ["fc84fc58-1286-40c4-9da0-c8ef6ec241e0"],
    "IWTSBitmapRenderService": ["ea326091-05fe-40c1-b49c-3d2ef4626a0e"],
    "IWTSBitmapRenderer": ["5b7acc97-f3c9-46f7-8c5b-fa685d3441b1"],
    "IWTSBitmapRendererCallback": ["d782928e-fe4e-4e77-ae90-9cd0b3e3b353"],
    "IWTSListener": ["a1230206-9a39-4d58-8674-cdb4dff4e73b"],
    "IWTSListenerCallback": ["a1230203-d6a7-11d8-b9fd-000bdbd1f198"],
    "IWTSPlugin": ["a1230201-1439-4e62-a414-190d0ac3d40e"],
    "IWTSPluginServiceProvider": ["d3e07363-087c-476c-86a7-dbb15f46ddb4"],
    "IWTSProtocolConnection": ["23083765-9095-4648-98bf-ef81c914032d"],
    "IWTSProtocolConnectionCallback": ["23083765-75eb-41fe-b4fb-e086242afa0f"],
    "IWTSProtocolLicenseConnection": ["23083765-178c-4079-8e4a-fea6496a4d70"],
    "IWTSProtocolListener": ["23083765-45f0-4394-8f69-32b2bc0ef4ca"],
    "IWTSProtocolListenerCallback": ["23083765-1a2d-4de2-97de-4a35f260f0b3"],
    "IWTSProtocolLogonErrorRedirector": ["fd9b61a7-2916-4627-8dee-4328711ad6cb"],
    "IWTSProtocolManager": ["f9eaf6cc-ed79-4f01-821d-1f881b9f66cc"],
    "IWTSProtocolShadowCallback": ["503a2504-aae5-4ab1-93e0-6d1c4bc6f71a"],
    "IWTSProtocolShadowConnection": ["ee3b0c14-37fb-456b-bab3-6d6cd51e13bf"],
    "IWTSSBPlugin": ["dc44be78-b18d-4399-b210-641bf67a002c"],
    "IWTSVirtualChannel": ["a1230207-d6a7-11d8-b9fd-000bdbd1f198"],
    "IWTSVirtualChannelCallback": ["a1230204-d6a7-11d8-b9fd-000bdbd1f198"],
    "IWTSVirtualChannelManager": ["a1230205-d6a7-11d8-b9fd-000bdbd1f198"],
    "IWaaSAssessor": ["2347bbef-1a3b-45a4-902d-3e09c269b45e"],
    "IWaitCursorManager": ["fc992f1f-debb-4596-b355-50c7a6dd1222"],
    "IWaitHandle": ["96b30c8d-548a-4253-a701-6bba919ef08f"],
    "IWaitNotify": ["0e540078-9738-48eb-8f1d-613054cf260e"],
    "IWaitOnThreadsBeforeExit": ["14e03031-ba5b-41d2-bbb5-3204f1e0ea67"],
    "IWakeOnRPCCalls": ["728e9d41-2d68-4714-99bd-fae3742125d5"],
    "IWakeUpOnTaskCompletion": ["a6b2f80c-7141-4178-b6a5-d7106ca391ea"],
    "IWalletActionActivatedEventArgs": ["fcfc027b-1a1a-4d22-923f-ae6f45fa52d9"],
    "IWalletBarcode": ["4f857b29-de80-4ea4-a1cd-81cd084dac27"],
    "IWalletBarcodeFactory": ["30117161-ed9c-469e-bbfd-306c95ea7108"],
    "IWalletItem": ["20b54be8-118d-4ec4-996c-b963e7bd3e74"],
    "IWalletItemCustomProperty": ["b94b40f3-fa00-40fd-98dc-9de46697f1e7"],
    "IWalletItemCustomPropertyFactory": ["d0046a44-61a1-41aa-b259-a5610ab5d575"],
    "IWalletItemFactory": ["53e27470-4f0b-4a3e-99e5-0bbb1eab38d4"],
    "IWalletItemStore": ["7160484b-6d49-48f8-91a9-40a1d0f13ef4"],
    "IWalletItemStore2": ["65e682f0-7009-4a15-bd54-4fff379bffe2"],
    "IWalletItemSystemStore": ["522e2bff-96a2-4a17-8d19-fe1d9f837561"],
    "IWalletItemSystemStore2": ["f98d3a4e-be00-4fdd-9734-6c113c1ac1cb"],
    "IWalletManagerStatics": ["5111d6b8-c9a4-4c64-b4dd-e1e548001c0d"],
    "IWalletManagerSystemStatics": ["bee8eb89-2634-4b9a-8b23-ee8903c91fe0"],
    "IWalletRelevantLocation": ["9fd8782a-e3f9-4de1-bab3-bb192e46b3f3"],
    "IWalletTransaction": ["40e1e940-2606-4519-81cb-bff1c60d1f79"],
    "IWalletVerb": ["17b826d6-e3c1-4c74-8a94-217aadbc4884"],
    "IWalletVerbFactory": ["76012771-be58-4d5e-83ed-58b1669c7ad9"],
    "IWamAdmin": ["29822ab7-f302-11d0-9953-00c04fd919c1"],
    "IWamAdmin2": ["29822ab8-f302-11d0-9953-00c04fd919c1"],
    "IWaveCyclicClock": ["dec1ec78-419a-11d1-ad09-00c04fb91bc4"],
    "IWavePciClock": ["d5d7a256-5d10-11d1-adae-00c04fb91bc4"],
    "IWbemAddressResolution": ["f7ce2e12-8c90-11d1-9e7b-00c04fc324a8"],
    "IWbemBackupRestore": ["c49e32c7-bc8b-11d2-85d4-00105a1f8304"],
    "IWbemBackupRestoreEx": ["a359dec5-e813-4834-8a2a-ba7f1d777d76"],
    "IWbemCallResult": ["44aca675-e8fc-11d0-a07c-00c04fb68820"],
    "IWbemClassObject": ["dc12a681-737f-11cf-884d-00aa004b2e24"],
    "IWbemClientConnectionTransport": ["a889c72a-fcc1-4a9e-af61-ed071333fb5b"],
    "IWbemClientTransport": ["f7ce2e11-8c90-11d1-9e7b-00c04fc324a8"],
    "IWbemConfigureRefresher": ["49353c92-516b-11d1-aea6-00c04fb68820"],
    "IWbemConnectorLogin": ["d8ec9cb1-b135-4f10-8b1b-c7188bb0d186"],
    "IWbemConstructClassObject": ["9ef76194-70d5-11d1-ad90-00c04fd8fdff"],
    "IWbemContext": ["44aca674-e8fc-11d0-a07c-00c04fb68820"],
    "IWbemDecoupledBasicEventProvider": ["86336d20-ca11-4786-9ef1-bc8a946b42fc"],
    "IWbemDecoupledEventSink": ["cd94ebf2-e622-11d2-9cb3-00105a1f4801"],
    "IWbemDecoupledRegistrar": ["1005cbcf-e64f-4646-bcd3-3a089d8a84b4"],
    "IWbemEventConsumerProvider": ["e246107a-b06e-11d0-ad61-00c04fd8fdff"],
    "IWbemEventProvider": ["e245105b-b06e-11d0-ad61-00c04fd8fdff"],
    "IWbemEventProviderQuerySink": ["580acaf8-fa1c-11d0-ad72-00c04fd8fdff"],
    "IWbemEventProviderSecurity": ["631f7d96-d993-11d2-b339-00105a1f4aaf"],
    "IWbemEventSink": ["3ae0080a-7e3a-4366-bf89-0feedc931659"],
    "IWbemHiPerfEnum": ["2705c288-79ae-11d2-b348-00105a1f8177"],
    "IWbemHiPerfProvider": ["49353c93-516b-11d1-aea6-00c04fb68820"],
    "IWbemLevel1Login": ["f309ad18-d86a-11d0-a075-00c04fb68820"],
    "IWbemLocator": ["dc12a687-737f-11cf-884d-00aa004b2e24"],
    "IWbemObjectAccess": ["49353c9a-516b-11d1-aea6-00c04fb68820"],
    "IWbemObjectSink": ["7c857801-7381-11cf-884d-00aa004b2e24"],
    "IWbemObjectSinkEx": ["e7d35cfa-348b-485e-b524-252725d697ca"],
    "IWbemObjectTextSrc": ["bfbf883a-cad7-11d3-a11b-00105a1f515a"],
    "IWbemPath": ["3bc15af2-736c-477e-9e51-238af8667dcc"],
    "IWbemPathKeyList": ["9ae62877-7544-4bb0-aa26-a13824659ed6"],
    "IWbemPropertyProvider": ["ce61e841-65bc-11d0-b6bd-00aa003240c7"],
    "IWbemProviderIdentity": ["631f7d97-d993-11d2-b339-00105a1f4aaf"],
    "IWbemProviderInit": ["1be41572-91dd-11d1-aeb2-00c04fb68820"],
    "IWbemProviderInitSink": ["1be41571-91dd-11d1-aeb2-00c04fb68820"],
    "IWbemQualifierSet": ["dc12a680-737f-11cf-884d-00aa004b2e24"],
    "IWbemQuery": ["81166f58-dd98-11d3-a120-00105a1f515a"],
    "IWbemRefresher": ["49353c99-516b-11d1-aea6-00c04fb68820"],
    "IWbemServices": ["9556dc99-828c-11cf-a37e-00aa003240c7"],
    "IWbemShutdown": ["b7b31df9-d515-11d3-a11c-00105a1f515a"],
    "IWbemStatusCodeText": ["eb87e1bc-3233-11d2-aec9-00c04fb68820"],
    "IWbemTransport": ["553fe584-2156-11d0-b6ae-00aa003240c7"],
    "IWbemUnboundObjectSink": ["e246107b-b06e-11d0-ad61-00c04fd8fdff"],
    "IWbemUnsecuredApartment": ["31739d04-3471-4cf4-9a7c-57a44ae71956"],
    "IWdsTransportCacheable": ["46ad894b-0bab-47dc-84b2-7b553f1d8f80"],
    "IWdsTransportClient": ["b5dbc93a-cabe-46ca-837f-3e44e93c6545"],
    "IWdsTransportCollection": ["b8ba4b1a-2ff4-43ab-996c-b2b10a91a6eb"],
    "IWdsTransportConfigurationManager": ["84cc4779-42dd-4792-891e-1321d6d74b44"],
    "IWdsTransportConfigurationManager2": ["d0d85caf-a153-4f1d-a9dd-96f431c50717"],
    "IWdsTransportContent": ["d405d711-0296-4ab4-a860-ac7d32e65798"],
    "IWdsTransportContentProvider": ["b9489f24-f219-4acf-aad7-265c7c08a6ae"],
    "IWdsTransportDiagnosticsPolicy": ["13b33efc-7856-4f61-9a59-8de67b6b87b6"],
    "IWdsTransportManager": ["5b0d35f5-1b13-4afd-b878-6526dc340b5d"],
    "IWdsTransportMulticastSessionPolicy": ["4e5753cf-68ec-4504-a951-4a003266606b"],
    "IWdsTransportNamespace": ["fa561f57-fbef-4ed3-b056-127cb1b33b84"],
    "IWdsTransportNamespaceAutoCast": ["ad931a72-c4bd-4c41-8fbc-59c9c748df9e"],
    "IWdsTransportNamespaceManager": ["3e22d9f6-3777-4d98-83e1-f98696717ba3"],
    "IWdsTransportNamespaceScheduledCast": ["3840cecf-d76c-416e-a4cc-31c741d2874b"],
    "IWdsTransportNamespaceScheduledCastAutoStart": ["d606af3d-ea9c-4219-961e-7491d618d9b9"],
    "IWdsTransportNamespaceScheduledCastManualStart": ["013e6e4c-e6a7-4fb5-b7ff-d9f5da805c31"],
    "IWdsTransportServer": ["09ccd093-830d-4344-a30a-73ae8e8fca90"],
    "IWdsTransportServer2": ["256e999f-6df4-4538-81b9-857b9ab8fb47"],
    "IWdsTransportServicePolicy": ["b9468578-9f2b-48cc-b27a-a60799c2750c"],
    "IWdsTransportServicePolicy2": ["65c19e5c-aa7e-4b91-8944-91e0e5572797"],
    "IWdsTransportSession": ["f4efea88-65b1-4f30-a4b9-2793987796fb"],
    "IWdsTransportSetupManager": ["f7238425-efa8-40a4-aef9-c98d969c0b75"],
    "IWdsTransportSetupManager2": ["02be79da-7e9e-4366-8b6e-2aa9a91be47f"],
    "IWdsTransportTftpClient": ["b022d3ae-884d-4d85-b146-53320e76ef62"],
    "IWdsTransportTftpManager": ["1327a7c8-ae8a-4fb3-8150-136227c37e9a"],
    "IWeakReference": ["00000037-0000-0000-c000-000000000046"],
    "IWeakReferenceSource": ["00000038-0000-0000-c000-000000000046"],
    "IWebAccount": ["69473eb2-8031-49be-80bb-96cb46d99aba"],
    "IWebAccount2": ["7b56d6f8-990b-4eb5-94a7-5621f3a8b824"],
    "IWebAccountClientView": ["e7bd66ba-0bc7-4c66-bfd4-65d3082cbca8"],
    "IWebAccountClientViewFactory": ["616d16a4-de22-4855-a326-06cebf2a3f23"],
    "IWebAccountCommand": ["caa39398-9cfa-4246-b0c4-a913a3896541"],
    "IWebAccountCommandFactory": ["bfa6cdff-2f2d-42f5-81de-1d56bafc496d"],
    "IWebAccountCommandInvokedHandler": ["1ee6e459-1705-4a9a-b599-a0c3d6921973"],
    "IWebAccountEventArgs": ["6fb7037d-424e-44ec-977c-ef2415462a5a"],
    "IWebAccountFactory": ["ac9afb39-1de9-4e92-b78f-0581a87f6e5c"],
    "IWebAccountInvokedArgs": ["e7abcc40-a1d8-4c5d-9a7f-1d34b2f90ad2"],
    "IWebAccountManagerStatics": ["b2e8e1a6-d49a-4032-84bf-1a2847747bf1"],
    "IWebAccountManagerStatics2": ["68a7a829-2d5f-4653-8bb0-bd2fa6bd2d87"],
    "IWebAccountManagerStatics3": ["dd4523a6-8a4f-4aa2-b15e-03f550af1359"],
    "IWebAccountManagerStatics4": ["59ebc2d2-f7db-412f-bc3f-f2fea04430b4"],
    "IWebAccountMapManagerStatics": ["e8fa446f-3a1b-48a4-8e90-1e59ca6f54db"],
    "IWebAccountMonitor": ["7445f5fd-aa9d-4619-8d5d-c138a4ede3e5"],
    "IWebAccountMonitor2": ["a7adc1f8-24b8-4f01-9ae5-24545e71233a"],
    "IWebAccountProvider": ["29dcc8c3-7ab9-4a7c-a336-b942f9dbf7c7"],
    "IWebAccountProvider2": ["4a01eb05-4e42-41d4-b518-e008a5163614"],
    "IWebAccountProvider3": ["da1c518b-970d-4d49-825c-f2706f8ca7fe"],
    "IWebAccountProvider4": ["718fd8db-e796-4210-b74e-84d29894b080"],
    "IWebAccountProviderActivatedEventArgs": ["72b71774-98ea-4ccf-9752-46d9051004f1"],
    "IWebAccountProviderAddAccountOperation": ["73ebdccf-4378-4c79-9335-a5d7ab81594e"],
    "IWebAccountProviderBaseReportOperation": ["bba4acbb-993b-4d57-bbe4-1421e3668b4c"],
    "IWebAccountProviderCommand": ["d69bdd9a-a0a6-4e9b-88dc-c71e757a3501"],
    "IWebAccountProviderCommandFactory": ["d5658a1b-b176-4776-8469-a9d3ff0b3f59"],
    "IWebAccountProviderCommandInvokedHandler": ["b7de5527-4c8f-42dd-84da-5ec493abdb9a"],
    "IWebAccountProviderDeleteAccountOperation": ["0abb48b8-9e01-49c9-a355-7d48caf7d6ca"],
    "IWebAccountProviderFactory": ["1d767df1-e1e1-4b9a-a774-5c7c7e3bf371"],
    "IWebAccountProviderManageAccountOperation": ["ed20dc5c-d21b-463e-a9b7-c1fd0edae978"],
    "IWebAccountProviderOperation": ["6d5d2426-10b1-419a-a44e-f9c5161574e6"],
    "IWebAccountProviderRetrieveCookiesOperation": ["5a040441-0fa3-4ab1-a01c-20b110358594"],
    "IWebAccountProviderSignOutAccountOperation": ["b890e21d-0c55-47bc-8c72-04a6fc7cac07"],
    "IWebAccountProviderSilentReportOperation": ["e0b545f8-3b0f-44da-924c-7b18baaa62a9"],
    "IWebAccountProviderTokenObjects": ["408f284b-1328-42db-89a4-0bce7a717d8e"],
    "IWebAccountProviderTokenObjects2": ["1020b893-5ca5-4fff-95fb-b820273fc395"],
    "IWebAccountProviderTokenOperation": ["95c613be-2034-4c38-9434-d26c14b2b4b2"],
    "IWebAccountProviderUIReportOperation": ["28ff92d3-8f80-42fb-944f-b2107bbd42e6"],
    "IWebAccountScopeManagerStatics": ["5c6ce37c-12b2-423a-bf3d-85b8d7e53656"],
    "IWebAppDiagnosticsObjectInitialization": ["16ff3a42-a5f5-432b-b625-8e8e16f57e15"],
    "IWebAppDiagnosticsSetup": ["379bfbe1-c6c9-432a-93e1-6d17656c538c"],
    "IWebApplicationActivation": ["bcdcd0de-330e-481b-b843-4898a6a8ebac"],
    "IWebApplicationAuthoringMode": ["720aea93-1964-4db0-b005-29eb9e2b18a9"],
    "IWebApplicationCtxSvc": ["cccecee2-d225-4294-858e-2b8c3f7d84ea"],
    "IWebApplicationHost": ["cecbd2c3-a3a5-4749-9681-20e9161c6794"],
    "IWebApplicationNavigationEvents": ["c22615d2-d318-4da2-8422-1fcaf77b10e4"],
    "IWebApplicationScriptEvents": ["7c3f6998-1567-4bba-b52b-48d32141d613"],
    "IWebApplicationUIEvents": ["5b2b3f99-328c-41d5-a6f7-7483ed8e71dd"],
    "IWebApplicationUpdateEvents": ["3e59e6b7-c652-4daf-ad5e-16feb350cde3"],
    "IWebAuthenticationBrokerContinuationEventArgs": ["75dda3d4-7714-453d-b7ff-b95e3a1709da"],
    "IWebAuthenticationBrokerStatics": ["2f149f1a-e673-40b5-bc22-201a6864a37b"],
    "IWebAuthenticationBrokerStatics2": ["73cdfb9e-14e7-41da-a971-aaf4410b621e"],
    "IWebAuthenticationCoreManagerHelper": ["06a50525-e715-4123-9276-9d6f865ba55f"],
    "IWebAuthenticationCoreManagerInterop": ["f4b8e804-811e-4436-b69c-44cb67b72084"],
    "IWebAuthenticationCoreManagerStatics": ["6aca7c92-a581-4479-9c10-752eff44fd34"],
    "IWebAuthenticationCoreManagerStatics2": ["f584184a-8b57-4820-b6a4-70a5b6fcf44a"],
    "IWebAuthenticationCoreManagerStatics3": ["2404eeb2-8924-4d93-ab3a-99688b419d56"],
    "IWebAuthenticationCoreManagerStatics4": ["54e633fe-96e0-41e8-9832-1298897c2aaf"],
    "IWebAuthenticationResult": ["64002b4b-ede9-470a-a5cd-0323faf6e262"],
    "IWebBrowserEventsService": ["54a8f188-9ebd-4795-ad16-9b4945119636"],
    "IWebBrowserEventsUrlService": ["87cc5d04-eafa-4833-9820-8f986530cc00"],
    "IWebBrowserHandler": ["5f568e3e-317c-402e-a883-546b0f7673a4"],
    "IWebBrowserPriv": ["3050f804-98b5-11cf-bb82-00aa00bdce0b"],
    "IWebBrowserPriv2": ["3ed72303-6ffc-4214-ba90-faf1862dec8a"],
    "IWebBrowserPriv3": ["6e4fe5a4-3e03-40cb-93f9-31aaae4e9cfb"],
    "IWebBrowserPriv6": ["5abdc2ad-7329-4c95-8d32-bb84799fcf88"],
    "IWebClassLibProjectEvents": ["465be4d1-b10c-4a7e-afcf-3c55ad3edae3"],
    "IWebDriverCommandRouter": ["707c3391-b999-4008-9d39-4cf4fed66a85"],
    "IWebDriverHostAdapter": ["91b98dd9-77f9-4643-92f0-7689b3252db7"],
    "IWebDriverHostWindow": ["036774a6-cff3-4354-83a6-a4471077861f"],
    "IWebDriverReplyHandler": ["7ce30566-a867-4898-a831-5c3d387435bf"],
    "IWebErrorStatics": ["fe616766-bf27-4064-87b7-6563bb11ce2e"],
    "IWebFileCtxService": ["05b4b4b7-6a9d-4a70-bdb1-04cbb26c9248"],
    "IWebFilter": ["8cb47392-2da9-4143-a8f0-b5549dcb2ba5"],
    "IWebFilterCollection": ["b523345e-de24-48ce-8e1a-2cb09f6613cf"],
    "IWebGeocoordinates": ["305107c7-98b5-11cf-bb82-00aa00bdce0b"],
    "IWebGeolocation": ["305107c5-98b5-11cf-bb82-00aa00bdce0b"],
    "IWebGeoposition": ["305107cd-98b5-11cf-bb82-00aa00bdce0b"],
    "IWebGeopositionError": ["305107c9-98b5-11cf-bb82-00aa00bdce0b"],
    "IWebHijackCheck": ["0fa1c826-629f-48ed-8be1-cde5f29f7b81"],
    "IWebPageMetaInfo": ["0e7d89b3-6618-49ed-8086-c3b62eedcdde"],
    "IWebPlatStorageBroker": ["4f133b63-9c9e-4196-be49-83286adb466e"],
    "IWebPlatform": ["dedcdb67-0e27-4593-81e5-437734383fd2"],
    "IWebPlatformActiveElementEvent": ["9f18701e-809a-4b84-8905-a135ef7b756e"],
    "IWebPlatformAdvancedEvents": ["4fefb201-7a7f-47ff-841d-1cf1eb1c8ac7"],
    "IWebPlatformDocumentRender": ["c277811c-42eb-459a-9631-975c2c80c874"],
    "IWebPlatformDownloadNotify": ["89490e5f-1ea2-424e-b238-7e1ba6b06661"],
    "IWebPlatformHistoryEvents": ["69190047-d9f5-4ae4-a182-bba682c7509a"],
    "IWebPlatformHostDiagnostics": ["e97f1cd4-b0df-4519-b816-91f00c4564db"],
    "IWebPlatformHostUI": ["ba87af46-50fd-43de-aeb9-926d78ac0ce2"],
    "IWebPlatformIndexDBEvents": ["3777b9cf-88b9-47d7-a93a-0541dcadee33"],
    "IWebPlatformIntelliformEvents": ["fc23424c-8a5f-47ce-ae32-c8dfc9c97037"],
    "IWebPlatformLifetimeEvents": ["8ace3c54-9589-4946-9d9b-c36b882511f7"],
    "IWebPlatformMediaEvents": ["c69b4f68-80f4-4a36-ab70-9c73a8b2a6bf"],
    "IWebPlatformNavigationEvents": ["7fe59da0-016a-4344-832c-b7f863b5f924"],
    "IWebPlatformNewWindowInitializer": ["f2157b59-546a-4df2-ad32-e79823ce0a06"],
    "IWebPlatformPaintEvent": ["ab3b05e2-af5d-48b1-a47d-957341511cf4"],
    "IWebPlatformReadingModeEvents": ["6e576292-7e17-43d7-8992-5b6809a338ce"],
    "IWebPlatformScriptEvent": ["991ff102-6992-467e-acd5-133d36f0b22d"],
    "IWebPlatformSecurityManager": ["49d33aad-f985-4b70-97a0-28eceb6523bf"],
    "IWebPlatformWebWorkerLifetimeEvents": ["3edb126a-cad4-4390-a8c6-3ecea81d8aed"],
    "IWebPreviewCallback": ["0d83cfb6-ea1c-4de1-a9b5-d1ad54f5fc98"],
    "IWebProviderError": ["db191bb1-50c5-4809-8dca-09c99410245c"],
    "IWebProviderErrorFactory": ["e3c40a2d-89ef-4e37-847f-a8b9d5a32910"],
    "IWebProviderTokenRequest": ["1e18778b-8805-454b-9f11-468d2af1095a"],
    "IWebProviderTokenRequest2": ["b5d72e4c-10b1-4aa6-88b1-0b6c9e0c1e46"],
    "IWebProviderTokenRequest3": ["1b2716aa-4289-446e-9256-dafb6f66a51e"],
    "IWebProviderTokenResponse": ["ef213793-ef55-4186-b7ce-8cb2e7f9849e"],
    "IWebProviderTokenResponseFactory": ["fa49d99a-25ba-4077-9cfa-9db4dea7b71a"],
    "IWebProxy": ["174c81fe-aecd-4dae-b8a0-2c6318dd86a8"],
    "IWebRequestBlockingResponse": ["fe02e513-6c7e-4464-a3a7-ab1002aa21b8"],
    "IWebRequestEventDetailsOptionalProperties": ["6dab99e9-2197-4b0e-8844-e5a155f6ecd8"],
    "IWebRequestHttpBody": ["44626cda-4fcb-4503-8ded-80ef9beebd2c"],
    "IWebRequestHttpHeaders": ["7997d63f-89c5-40f5-b6fd-16796d7ff373"],
    "IWebRequestListener": ["cb14c4bc-3902-4e26-8fca-82673622d5e2"],
    "IWebSlice": ["91590abc-9c90-49ef-9b02-70f94d2c5544"],
    "IWebSlicesManager": ["d318fb7e-ff28-497e-a566-9df09e6c503b"],
    "IWebSocket": ["f877396f-99b1-4e18-bc08-850c9adf156e"],
    "IWebSocketClosedEventArgs": ["ceb78d07-d0a8-4703-a091-c8c2c0915bc3"],
    "IWebSocketControl": ["2ec4bdc3-d9a5-455a-9811-de24d45337e9"],
    "IWebSocketControl2": ["79c3be03-f2ca-461e-af4e-9665bc2d0620"],
    "IWebSocketErrorStatics": ["27cdf35b-1f61-4709-8e02-61283ada4e9d"],
    "IWebSocketInformation": ["5e01e316-c92a-47a5-b25f-07847639d181"],
    "IWebSocketInformation2": ["ce1d39ce-a1b7-4d43-8269-8d5b981bd47a"],
    "IWebSocketServerCustomValidationRequestedEventArgs": ["ffeffe48-022a-4ab7-8b36-e10af4640e6b"],
    "IWebTokenRequest": ["b77b4d68-adcb-4673-b364-0cf7b35caf97"],
    "IWebTokenRequest2": ["d700c079-30c8-4397-9654-961c3be8b855"],
    "IWebTokenRequest3": ["5a755b51-3bb1-41a5-a63d-90bc32c7db9a"],
    "IWebTokenRequestFactory": ["6cf2141c-0ff0-4c67-b84f-99ddbe4a72c9"],
    "IWebTokenRequestResult": ["c12a8305-d1f8-4483-8d54-38fe292784ff"],
    "IWebTokenResponse": ["67a7c5ca-83f6-44c6-a3b1-0eb69e41fa8a"],
    "IWebTokenResponseFactory": ["ab6bf7f8-5450-4ef6-97f7-052b0431c0f0"],
    "IWebUIActivationStatics": ["351b86bd-43b3-482b-85db-35d87b517ad9"],
    "IWebUIActivationStatics2": ["c8e88696-4d78-4aa4-8f06-2a9eadc6c40a"],
    "IWebUIActivationStatics3": ["91abb686-1af5-4445-b49f-9459f40fc8de"],
    "IWebUIActivationStatics4": ["5e391429-183f-478d-8a25-67f80d03935b"],
    "IWebUIBackgroundTaskInstance": ["23f12c25-e2f7-4741-bc9c-394595de24dc"],
    "IWebUIBackgroundTaskInstanceStatics": ["9c7a5291-19ae-4ca3-b94b-fe4ec744a740"],
    "IWebUINavigatedDeferral": ["d804204d-831f-46e2-b432-3afce211f962"],
    "IWebUINavigatedEventArgs": ["a75841b8-2499-4030-a69d-15d2d9cfe524"],
    "IWebUINavigatedOperation": ["7a965f08-8182-4a89-ab67-8492e8750d4b"],
    "IWebUIView": ["6783f64f-52da-4fd7-be69-8ef6284b423c"],
    "IWebUIViewStatics": ["b591e668-8e59-44f9-8803-1b24c9149d30"],
    "IWebUriData": ["f9a2d0f8-6014-4004-9e11-3542e8797866"],
    "IWebUriDataGetStreamHandler": ["04ba378b-7a67-4565-abda-14dc1acdcae7"],
    "IWebUriDataGetStreamOperation": ["f9a2d0f8-6014-4004-9e11-3542e8797866"],
    "IWebView": ["5862cc46-1f7d-479b-92a6-de7858fe8d54"],
    "IWebView2": ["d481759e-3eff-4462-823d-fd52f9ba4cc8"],
    "IWebView3": ["c497789b-b499-4d69-b5c2-ae9d5d6d594e"],
    "IWebView4": ["e28243bc-67f3-462a-b4e0-3bbf6c3dab0b"],
    "IWebView5": ["8c9884a6-2f3b-4a55-a463-8444c2095d00"],
    "IWebView6": ["38ccd942-2536-467c-a211-af359c3b4fda"],
    "IWebView7": ["27707c2b-042f-5353-9021-55cd06585fdf"],
    "IWebViewBrush": ["40e86f75-0cf4-4b72-a4d6-cf5d15780116"],
    "IWebViewBrushStatics": ["d74daa24-1d05-463e-b028-6baa4420e762"],
    "IWebViewContentLoadingEventArgs": ["6e2980bb-98b8-413e-8129-971c6f7e4c8a"],
    "IWebViewControl": ["3f921316-bc70-4bda-9136-c94370899fab"],
    "IWebViewControl2": ["4d3c06f9-c8df-41cc-8bd5-2a947b204503"],
    "IWebViewControlAcceleratorKeyPressedEventArgs": ["77a2a53e-7c74-437d-a290-3ac0d8cd5655"],
    "IWebViewControlContentLoadingEventArgs": ["9a3fccb2-b9bb-404b-a22b-66dccd1250c6"],
    "IWebViewControlDOMContentLoadedEventArgs": ["be8bc008-9541-4545-9ff2-2df585b29f7d"],
    "IWebViewControlDeferredPermissionRequest": ["2ce349e0-d759-445c-9926-8995298f152b"],
    "IWebViewControlLongRunningScriptDetectedEventArgs": ["2a6e5bba-98b4-45bc-bbeb-0f69ce49c599"],
    "IWebViewControlMoveFocusRequestedEventArgs": ["6b2a340d-4bd0-405e-b7c1-1e72a492f446"],
    "IWebViewControlNavigationCompletedEventArgs": ["20409918-4a15-4c46-a55d-f79edb0bde8b"],
    "IWebViewControlNavigationStartingEventArgs": ["0c9057c5-0a08-41c7-863b-71e3a9549137"],
    "IWebViewControlNewWindowRequestedEventArgs": ["3df44bbb-a124-46d5-a083-d02cacdff5ad"],
    "IWebViewControlNewWindowRequestedEventArgs2": ["b53c5ca6-2aae-4bfc-92b9-c30e92b48098"],
    "IWebViewControlPermissionRequest": ["e5bc836c-f22f-40e2-95b2-7729f840eb7f"],
    "IWebViewControlPermissionRequestedEventArgs": ["27204d51-2488-4cc5-968e-0a771e59c147"],
    "IWebViewControlProcess": ["02c723ec-98d6-424a-b63e-c6136c36a0f2"],
    "IWebViewControlProcessFactory": ["47b65cf9-a2d2-453c-b097-f6779d4b8e02"],
    "IWebViewControlProcessOptions": ["1cca72a7-3bd6-4826-8261-6c8189505d89"],
    "IWebViewControlScriptNotifyEventArgs": ["491de57b-6f49-41bb-b591-51b85b817037"],
    "IWebViewControlSettings": ["c9967fbf-5e98-4cfd-8cce-27b0911e3de8"],
    "IWebViewControlSite": ["133f47c6-12dc-4898-bd47-04967de648ba"],
    "IWebViewControlSite2": ["d13b2e3f-48ee-4730-8243-d2ed0c05606a"],
    "IWebViewControlUnsupportedUriSchemeIdentifiedEventArgs": ["e3b81944-e4fc-43dc-94ca-f980f30bc51d"],
    "IWebViewControlUnviewableContentIdentifiedEventArgs": ["4a9680db-88f2-4e20-b693-b4e2df4aa581"],
    "IWebViewControlWebResourceRequestedEventArgs": ["44d6524d-55a4-4d8b-891c-931d8e25d42e"],
    "IWebViewDOMContentLoadedEventArgs": ["c47eba15-dc6b-4b36-9d80-82fb8817b988"],
    "IWebViewDeferredPermissionRequest": ["a3dcc461-7350-4d3a-8fb9-40eeec2746c2"],
    "IWebViewFactory4": ["82edac58-ee6a-4c9b-a3a0-9347a7d0ef4c"],
    "IWebViewLongRunningScriptDetectedEventArgs": ["f3f020ab-a46c-42b0-9efe-69764d5cffa6"],
    "IWebViewNavigationCompletedEventArgs": ["11e6f20b-eba7-44c0-889b-edeb6a064ddd"],
    "IWebViewNavigationFailedEventArgs": ["af09609a-129c-4170-9e9c-e2cdf025dca4"],
    "IWebViewNavigationFailedEventHandler": ["a31eafe1-41dc-47f8-ae22-9706c8f143d4"],
    "IWebViewNavigationStartingEventArgs": ["94cb8668-8367-43d5-91bb-96eba37ec784"],
    "IWebViewNewWindowRequestedEventArgs": ["470fa818-6862-44d9-b3d1-c0696373de35"],
    "IWebViewPermissionRequest": ["17b76332-66c4-4131-999e-df7de20a8c9c"],
    "IWebViewPermissionRequestedEventArgs": ["dadecfd0-6e1e-473f-b0be-b02404d6a86d"],
    "IWebViewSeparateProcessLostEventArgs": ["a405700a-c482-40b5-aaea-e10cfa9f5abe"],
    "IWebViewSettings": ["1d50ad4d-abf6-4785-8df3-fdebc1270301"],
    "IWebViewStatics": ["a0b561de-5fdb-443b-b9f0-5c30f6b7a1f4"],
    "IWebViewStatics2": ["322f8780-e812-466b-9e50-8e9fec24018a"],
    "IWebViewStatics3": ["129bef8a-4509-4374-b0d1-a7104d0c3a2f"],
    "IWebViewStatics4": ["44b197b0-b746-40f3-9936-4ebbff6b47b8"],
    "IWebViewStatics5": ["08a0b8d1-508a-4db8-97ef-0fa505e19ec2"],
    "IWebViewUnsupportedUriSchemeIdentifiedEventArgs": ["b9c9e1a7-620f-4895-935d-10fbac6fd29e"],
    "IWebViewUnviewableContentIdentifiedEventArgs": ["37bc16e1-6062-4678-b20b-6c36ac9c59ac"],
    "IWebViewUnviewableContentIdentifiedEventArgs2": ["9abe1154-36f0-4268-8d88-121eedf45e6a"],
    "IWebViewWebResourceRequestedEventArgs": ["378d21f6-c77f-5d8b-8f30-93c99df79435"],
    "IWebWizardHost2": ["f9c013dc-3c23-4041-8e39-cfb402f7ea59"],
    "IWeeklyTrigger": ["5038fc98-82ff-436d-8728-a512a57c9dc1"],
    "IWerReportSubmitCallback": ["a7a3dd4c-defc-46a2-832e-5a743be69e8c"],
    "IWerStore": ["1e3a0e4f-1412-444f-8a94-fc6a09cd4195"],
    "IWhiteBalanceControl": ["781f047e-7162-49c8-a8f9-9481c565363e"],
    "IWiFiAdapter": ["a6c4e423-3d75-43a4-b9de-11e26b72d9b0"],
    "IWiFiAdapter2": ["5bc4501d-81e4-453d-9430-1fcafbadd6b6"],
    "IWiFiAdapterStatics": ["da25fddd-d24c-43e3-aabd-c4659f730f99"],
    "IWiFiAvailableNetwork": ["26e96246-183e-4704-9826-71b4a2f0f668"],
    "IWiFiConnectionResult": ["143bdfd9-c37d-40be-a5c8-857bce85a931"],
    "IWiFiDirectAdvertisement": ["ab511a2d-2a06-49a1-a584-61435c7905a6"],
    "IWiFiDirectAdvertisement2": ["b759aa46-d816-491b-917a-b40d7dc403a2"],
    "IWiFiDirectAdvertisementPublisher": ["b35a2d1a-9b1f-45d9-925a-694d66df68ef"],
    "IWiFiDirectAdvertisementPublisherStatusChangedEventArgs": ["aafde53c-5481-46e6-90dd-32116518f192"],
    "IWiFiDirectConnectionListener": ["699c1b0d-8d13-4ee9-b9ec-9c72f8251f7d"],
    "IWiFiDirectConnectionParameters": ["b2e55405-5702-4b16-a02c-bbcd21ef6098"],
    "IWiFiDirectConnectionParameters2": ["ab3b0fbe-aa82-44b4-88c8-e3056b89801d"],
    "IWiFiDirectConnectionParametersStatics": ["598af493-7642-456f-b9d8-e8a9eb1f401a"],
    "IWiFiDirectConnectionRequest": ["8eb99605-914f-49c3-a614-d18dc5b19b43"],
    "IWiFiDirectConnectionRequestedEventArgs": ["f99d20be-d38d-484f-8215-e7b65abf244c"],
    "IWiFiDirectDevice": ["72deaaa8-72eb-4dae-8a28-8513355d2777"],
    "IWiFiDirectDeviceStatics": ["e86cb57c-3aac-4851-a792-482aaf931b04"],
    "IWiFiDirectDeviceStatics2": ["1a953e49-b103-437e-9226-ab67971342f9"],
    "IWiFiDirectInformationElement": ["affb72d6-76bb-497e-ac8b-dc72838bc309"],
    "IWiFiDirectInformationElementStatics": ["dbd02f16-11a5-4e60-8caa-34772148378a"],
    "IWiFiDirectLegacySettings": ["a64fdbba-f2fd-4567-a91b-f5c2f5321057"],
    "IWiFiDirectService": ["50aabbb8-5f71-45ec-84f1-a1e4fc7879a3"],
    "IWiFiDirectServiceAdvertiser": ["a4aa1ee1-9d8f-4f4f-93ee-7ddea2e37f46"],
    "IWiFiDirectServiceAdvertiserFactory": ["3106ac0d-b446-4f13-9f9a-8ae925feba2b"],
    "IWiFiDirectServiceAutoAcceptSessionConnectedEventArgs": ["dcd9e01e-83df-43e5-8f43-cbe8479e84eb"],
    "IWiFiDirectServiceProvisioningInfo": ["8bdb7cfe-97d9-45a2-8e99-db50910fb6a6"],
    "IWiFiDirectServiceRemotePortAddedEventArgs": ["d4cebac1-3fd3-4f0e-b7bd-782906f44411"],
    "IWiFiDirectServiceSession": ["81142163-e426-47cb-8640-e1b3588bf26f"],
    "IWiFiDirectServiceSessionDeferredEventArgs": ["8dfc197f-1201-4f1f-b6f4-5df1b7b9fb2e"],
    "IWiFiDirectServiceSessionRequest": ["a0e27c8b-50cb-4a58-9bcf-e472b99fba04"],
    "IWiFiDirectServiceSessionRequestedEventArgs": ["74bdcc11-53d6-4999-b4f8-6c8ecc1771e7"],
    "IWiFiDirectServiceStatics": ["7db40045-fd74-4688-b725-5dce86acf233"],
    "IWiFiNetworkReport": ["9524ded2-5911-445e-8194-be4f1a704895"],
    "IWiFiWpsConfigurationResult": ["67b49871-17ee-42d1-b14f-5a11f1226fb5"],
    "IWiaAppErrorHandler": ["6c16186c-d0a6-400c-80f4-d26986a0e734"],
    "IWiaDevMgr2": ["79c07cf1-cbdd-41ee-8ec3-f00080cada7a"],
    "IWiaErrorHandler": ["0e4a51b1-bc1f-443d-a835-72e890759ef3"],
    "IWiaImageFilter": ["a8a79ffa-450b-41f1-8f87-849ccd94ebf6"],
    "IWiaItem2": ["6cba0075-1287-407d-9b77-cf0e030435cc"],
    "IWiaMiniDrvTransferCallback": ["a9d2ee89-2ce5-4ff0-8adb-c961d1d774ca"],
    "IWiaPreview": ["95c2b4fd-33f2-4d86-ad40-9431f0df08f7"],
    "IWiaSegmentationFilter": ["ec46a697-ac04-4447-8f65-ff63d5154b21"],
    "IWiaTransfer": ["c39d6942-2f4e-4d04-92fe-4ef4d3a1de5a"],
    "IWiaTransferCallback": ["27d4eaaf-28a6-4ca5-9aab-e678168b9527"],
    "IWiaUIExtension2": ["305600d7-5088-46d7-9a15-b77b09cdba7a"],
    "IWin32ApplicationView": ["f3527610-c76d-4316-ac8e-28651acf3df3"],
    "IWin32Broker": ["e5305f56-8174-43c2-a911-fdb7972e8709"],
    "IWinInetCacheHints2": ["7857aeac-d31f-49bf-884e-dd46df36780a"],
    "IWinInetHttpHeaders": ["9b92daac-c102-44c4-9dbf-78f959c69e10"],
    "IWinInetHttpTimeouts": ["f286fa56-c1fd-4270-8e67-b3eb790a81e8"],
    "IWinMLEvaluationContext": ["95848f9e-583d-4054-af12-916387cd8426"],
    "IWinMLModel": ["e2eeb6a9-f31f-4055-a521-e30b5b33664a"],
    "IWinMLRuntime": ["a0425329-40ae-48d9-bce3-829ef7b8a41a"],
    "IWinMLRuntimeFactory": ["a807b84d-4ae5-4bc0-a76a-941aa246bd41"],
    "IWinRTActivationProperties": ["9fc104cb-0379-43b5-a1a0-ce1260700e0a"],
    "IWinRTApplicationCatalogInternal": ["e7cfd93a-9eda-42cf-88fb-1be3b609b113"],
    "IWinRTApplicationView": ["e99a73b1-cde0-477b-91b8-e995fa037387"],
    "IWinRTBitmapDecoderInternal": ["1588aafc-288d-497a-b167-05ff88b584fb"],
    "IWinRTBitmapPropertiesViewInternal": ["e14fcb26-e6ed-4d22-9f7a-d9bd3a8ee392"],
    "IWinRTCatalogInternal": ["22de7513-3849-4767-847d-c66aebc88040"],
    "IWinRTClassActivator": ["86ddd2d7-ad80-44f6-a12e-63698b52825d"],
    "IWinRTDesktopBroker": ["4dcc0cf3-f33b-415c-bcfa-a68759c2cecb"],
    "IWinRTInprocActivator": ["e1cdd77a-65d3-4db0-b339-21f6a48cc2ff"],
    "IWinRTRuntimeClassInfo": ["3ca31250-4cd0-42ef-a711-2f5686e69e07"],
    "IWinRTServerInfo": ["5868bd9b-be16-4c83-a560-0121173c48f1"],
    "IWinSATInitiateEvents": ["262a1918-ba0d-41d5-92c2-fab4633ee74f"],
    "IWindow2": ["d384759f-34f6-4482-8435-f552f9b24cc8"],
    "IWindow3": ["b70bdc9d-1c35-462a-9b97-808d5af9f28e"],
    "IWindow4": ["bfe1b8ce-6c40-50f9-854c-7021d2bc9de6"],
    "IWindowActivatedEventArgs": ["179d65e7-4658-4cb6-aa13-41d094ea255e"],
    "IWindowActivatedEventHandler": ["18026348-8619-4c7b-b534-ced45d9de219"],
    "IWindowClosedEventHandler": ["0db89161-20d7-45df-9122-ba89576703ba"],
    "IWindowCreatedEventArgs": ["31b71470-feff-4654-af48-9b398ab5772b"],
    "IWindowManagementPreview": ["4ef55b0d-561d-513c-a67c-2c02b69cef41"],
    "IWindowManagementPreviewStatics": ["0f9725c6-c004-5a23-8fd2-8d092ce2704a"],
    "IWindowPatternIdentifiers": ["39f78bb4-7032-41e2-b79e-27b74a8628de"],
    "IWindowPatternIdentifiersStatics": ["07d0ad06-6302-4d29-878b-19da03fc228d"],
    "IWindowPickerBroker": ["d691c2d4-fc05-458f-8fb9-4b9b43cacb4d"],
    "IWindowProvider": ["1baa8b3d-38cf-415a-85d3-20e43a0ec1b1", "987df77b-db06-4d77-8f8a-86a9c3bb90b9"],
    "IWindowServiceProxy": ["cdae3790-e890-4803-b2cf-0baeeedbfaf5"],
    "IWindowSizeChangedEventArgs": ["5a200ec7-0426-47dc-b86c-6f475915e451"],
    "IWindowSizeChangedEventHandler": ["5c21c742-2ced-4fd9-ba38-7118d40e966b"],
    "IWindowSizingBroker": ["6d236977-a057-4ccd-8808-b6f6bc3ab2cf"],
    "IWindowStatics": ["93328409-4ea1-4afa-83dc-0c4e73e88bb1"],
    "IWindowToIgnoreRegistrar": ["b94093ab-2b05-4b40-936f-df4bbe4b7ee3"],
    "IWindowVisibilityChangedEventHandler": ["10406ad6-b090-4a4a-b2ad-d682df27130f"],
    "IWindowingEnvironment": ["264363c0-2a49-5417-b3ae-48a71c63a3bd"],
    "IWindowingEnvironmentAddedEventArgs": ["ff2a5b7f-f183-5c66-99b2-429082069299"],
    "IWindowingEnvironmentChangedEventArgs": ["4160cfc6-023d-5e9a-b431-350e67dc978a"],
    "IWindowingEnvironmentRemovedEventArgs": ["2e5b5473-beff-5e53-9316-7e775fe568b3"],
    "IWindowingEnvironmentStatics": ["874e9fb7-c642-55ab-8aa2-162f734a9a72"],
    "IWindowlessActivationNotification": ["ea063302-6a3f-4a01-b1ec-28e2f1a3225c"],
    "IWindowsDevicesAllJoynBusAttachmentFactoryInterop": ["4b8f7505-b239-4e7b-88af-f6682575d861"],
    "IWindowsDevicesAllJoynBusAttachmentInterop": ["fd89c65b-b50e-4a19-9d0c-b42b783281cd"],
    "IWindowsDevicesAllJoynBusObjectFactoryInterop": ["6174e506-8b95-4e36-95c0-b88fed34938c"],
    "IWindowsDevicesAllJoynBusObjectInterop": ["d78aa3d5-5054-428f-99f2-ec3a5de3c3bc"],
    "IWindowsDriverUpdate": ["b383cd1a-5ce9-4504-9f63-764b1236f191"],
    "IWindowsDriverUpdate2": ["615c4269-7a48-43bd-96b7-bf6ca27d6c3e"],
    "IWindowsDriverUpdate3": ["49ebd502-4a96-41bd-9e3e-4c5057f4250c"],
    "IWindowsDriverUpdate4": ["004c6a2b-0c19-4c69-9f5c-a269b2560db9"],
    "IWindowsDriverUpdate5": ["70cf5c82-8642-42bb-9dbc-0cfd263c6c4f"],
    "IWindowsDriverUpdateEntry": ["ed8bfe40-a60b-42ea-9652-817dfcfa23ec"],
    "IWindowsDriverUpdateEntryCollection": ["0d521700-a372-4bef-828b-3d00c10adebd"],
    "IWindowsIntegrityPolicyStatics": ["7d1d81db-8d63-4789-9ea5-ddcf65a94f3c"],
    "IWindowsLockModeHelper": ["f342d19e-cc22-4648-bb5d-03ccf75b47c5"],
    "IWindowsMediaLibrarySharingDevice": ["3dccc293-4fd9-4191-a25b-8e57c5d27bd4"],
    "IWindowsMediaLibrarySharingDeviceProperties": ["c4623214-6b06-40c5-a623-b2ff4c076bfd"],
    "IWindowsMediaLibrarySharingDeviceProperty": ["81e26927-7a7d-40a7-81d4-bddc02960e3e"],
    "IWindowsMediaLibrarySharingDevices": ["1803f9d6-fe6d-4546-bf5b-992fe8ec12d1"],
    "IWindowsMediaLibrarySharingServices": ["01f5f85e-0a81-40da-a7c8-21ef3af8440c"],
    "IWindowsPackageSettingRoaming": ["cf8c07a3-30f6-45d5-9cda-ba924f967d59"],
    "IWindowsParentalControls": ["28b4d88b-e072-49e6-804d-26edbe21a7b9"],
    "IWindowsParentalControlsCore": ["4ff40a0f-3f3b-4d7c-a41b-4f39d7b44d05"],
    "IWindowsUpdateAgentInfo": ["85713fa1-7796-4fa2-be3b-e2d6124dd373"],
    "IWindowsXamlManager": ["56096c31-1aa0-5288-8818-6e74a2dcaff5"],
    "IWindowsXamlManagerStatics": ["28258a12-7d82-505b-b210-712b04a58882"],
    "IWininetBroker": ["b06b0ce5-689b-4afd-b326-0a08a1a647af"],
    "IWirelessNetworkConnectResult": ["5a09cb29-975d-485b-96e6-cb053a5a2309"],
    "IWizardClient": ["bdeadf03-c265-11d0-bced-00a0c90ab50f"],
    "IWizardTransaction": ["777ba801-2498-4875-933a-3067de883070"],
    "IWlanConnectionProfileDetails": ["562098cb-b35a-4bf1-a884-b7557e88ff86"],
    "IWordBreakerConfig": ["8fa0d5a6-dedf-11d0-9a61-00c04fb68bf7"],
    "IWordSegment": ["d2d4ba6d-987c-4cc0-b6bd-d49a11b38f9a"],
    "IWordSegmentsTokenizingHandler": ["a5dd6357-bf2a-4c4f-a31f-29e71c6f8b35"],
    "IWordsSegmenter": ["86b4d4d1-b2fe-4e34-a81d-66640300454f"],
    "IWordsSegmenterFactory": ["e6977274-fc35-455c-8bfb-6d7f4653ca97"],
    "IWorkItemHandler": ["1d1a8b8b-fa66-414f-9cbd-b65fc99d17fa"],
    "IWorkflowPrintTicket": ["41d52285-35e8-448e-a8c5-e4b6a2cf826c"],
    "IWorkflowPrintTicketValidationResult": ["0ad1f392-da7b-4a36-bf36-6a99a62e2059"],
    "IWorkplaceSettingsStatics": ["e4676ffd-2d92-4c08-bad4-f6590b54a6d3"],
    "IWorkspace": ["b41da63b-a4b8-4036-89c5-83c31266ba49", "b922bbb8-4c55-4fea-8496-beb0b44285e5"],
    "IWorkspace2": ["96d8d7cf-783e-4286-834c-ebc0e95f783c"],
    "IWorkspace3": ["1becbe4a-d654-423b-afeb-be8d532c13c6"],
    "IWorkspaceBrokerAx": ["2f93474c-2ed7-4a68-afd1-d3c9781f341e"],
    "IWorkspaceBrokerAx2": ["57d42f01-d762-4680-9893-326b08f22652"],
    "IWorkspaceClientExt": ["12b952f4-41ca-4f21-a829-a6d07d9a16e5"],
    "IWorkspaceRegistration": ["b922bbb8-4c55-4fea-8496-beb0b44285e6"],
    "IWorkspaceRegistration2": ["cf59f654-39bb-44d8-94d0-4635728957e9"],
    "IWorkspaceReportMessage": ["a7c06739-500f-4e8c-99a8-2bd6955899eb"],
    "IWorkspaceResTypeRegistry": ["1d428c79-6e2e-4351-a361-c0401a03a0ba"],
    "IWorkspaceScriptable": ["efea49a2-dda5-429d-8f42-b23b92c4c347"],
    "IWorkspaceScriptable2": ["efea49a2-dda5-429d-8f42-b33ba2c4c348"],
    "IWorkspaceScriptable3": ["531e6512-2cbf-4bd2-80a5-d90a71636a9a"],
    "IWowExecuteCallback": ["3552e971-528c-4988-be75-64952f5f85a6"],
    "IWpdSerializer": ["b32f4002-bb27-45ff-af4f-06631c1e8dad"],
    "IWpnAppEndpoint": ["dcaee35a-508d-4419-9e56-50d658c2c812"],
    "IWpnAppEndpoint2": ["2a2e31bb-eecc-4c86-9178-5a6dea632d12"],
    "IWpnAppEndpoint3": ["926516e8-d891-45bc-9de5-6959fb8ecac5"],
    "IWpnAssetsEndpoint": ["a922da21-e2dc-455d-b5ad-1926fe43e055"],
    "IWpnChannelRequest": ["bc0d0f9f-ecd0-4545-b41e-6df5f379bde0"],
    "IWpnConnectionStatusSink": ["6325c8e0-de7f-42cb-84fb-233e8672710e"],
    "IWpnIdleTaskEndpoint": ["81a3a0c4-2b64-4adf-968f-cc03c7dc641d"],
    "IWpnInternalConnectionManager": ["3664a8a8-e537-48af-a4d9-b4bf7b940f36"],
    "IWpnInternalConnectionManager2": ["6d01851e-5cf7-4cab-a70e-311cfbeb417c"],
    "IWpnMirroringAccountSwitcher": ["d33574ce-09a0-4860-891d-1cfba99e1928"],
    "IWpnNotification": ["faecab4e-4476-4e92-8706-513a5937100d"],
    "IWpnNotificationData": ["921f16d0-18dc-4ec6-8a86-e9b344db7db5"],
    "IWpnNotificationFeedback": ["e9e21919-137d-41f6-8234-23284dbe1e82"],
    "IWpnNotificationSink": ["b9925352-f282-4abc-87e5-2d5bab4a5d5a"],
    "IWpnNotificationSink2": ["918d50cc-dcbe-4d1f-ba9f-3432d6ff3914"],
    "IWpnPackageRegistrationEndpoint": ["82915f80-a7be-49d4-9d3a-ab288f4f0a55"],
    "IWpnPhoneAppEndpoint": ["ffcf616a-0f5d-4a6e-bdcf-f56e18da45d1"],
    "IWpnPhoneRegistrationEndpoint": ["5da1f290-1df6-4a9a-8a0f-e1584d9969fc"],
    "IWpnPlatform": ["df8e9480-ca73-448e-b8f0-da000f581428"],
    "IWpnPlatformInternal": ["cd6bb9b5-0cff-41d5-a3c4-7d23a91019bf"],
    "IWpnPlatformShellHelper": ["f7c1d568-9f5d-4941-b642-e47265ec651b"],
    "IWpnPollingUrlTempCache": ["c1322a56-83e5-41cb-b68d-93cb4f17fec2"],
    "IWpnPresentationEndpoint": ["0e467ac1-65f2-48d6-8bf2-375430548a87"],
    "IWpnPresentationEndpoint2": ["b2662ce9-d8b3-4cc9-89e2-40a97af0211e"],
    "IWpnPresentationTileSink": ["e716b283-6be7-4e6f-a88f-1cde47d5e355"],
    "IWpnPresentationToastMetadataSink2": ["2c3dc443-633b-4c3d-b456-6dd36c6d223d"],
    "IWpnPresentationToastSink": ["904a654e-bee8-4654-bbba-e78766776239"],
    "IWpnRegistrationEndpoint": ["f655b052-348b-4ab0-947b-a7dafa44d404"],
    "IWpnRegistrationEndpoint2": ["babc8bba-5bcc-4c5c-b41c-d774c34036fe"],
    "IWpnSettingAppList": ["5431334c-0ce7-4248-b7db-efa5dbbf23ec"],
    "IWpnSettingCallback": ["71538e01-5877-4d2d-ac1a-ff42b6da910d"],
    "IWpnSettingsEndpoint": ["ff94ea7e-7d6c-406e-826e-0ad128677b50"],
    "IWpnSettingsEndpoint2": ["d5ddaa9b-94c9-4e5e-8037-042489d17f6d"],
    "IWpnSrumProvider": ["bdffe8e0-729b-4bd6-a769-a296c15ee54e"],
    "IWpnSystemRegistrationEndpoint": ["7d85494e-d99e-493a-bf51-80d2c9feab49"],
    "IWpnTestEndpoint": ["780163d0-41b0-4fe4-9b46-47a13e159e5a"],
    "IWpnToastFeedback": ["4f38fd3e-2c10-4c00-9ec1-62bd536a1feb"],
    "IWrapGrid": ["0552178b-7567-47c2-bd5c-ad8394c828ba"],
    "IWrapGridStatics": ["d04a6b97-13cb-479c-a285-e4e56846c4cb"],
    "IWriteCookie": ["d97a6da0-a862-11cf-84ae-00a0c90c2bd8"],
    "IWriteEngine2": ["27354135-7f64-5b0f-8f00-5d77afbe261e"],
    "IWriteEngine2EventArgs": ["27354136-7f64-5b0f-8f00-5d77afbe261e"],
    "IWriteRecordCompletion": ["f9b2b7de-3ab4-4af8-bac0-fd9a83113242"],
    "IWriteSpeedDescriptor": ["27354144-7f64-5b0f-8f00-5d77afbe261e"],
    "IWriteableBitmap": ["bf0b7e6f-df7c-4a85-8413-a1216285835c"],
    "IWriteableBitmapFactory": ["5563ebb1-3ef2-42c5-9c6d-1cf5dcc041ff"],
    "IWsDocumentUpdate": ["7724f749-b79e-42a0-aa9e-878b498f26ec"],
    "IWsPlatform": ["993eceb0-6f1b-49fe-8ba2-21b6a5317de1"],
    "IWsStoreAppData": ["6eedf548-1c00-4415-bd0a-b122a3cbdb2a"],
    "IWsStoreAppEndpoint": ["b80dfda4-1915-4a94-ad31-c08fc2c1eb91"],
    "IWsStoreAppServicingEndpoint": ["6a4eb77f-114c-4ff0-9aa8-9e159df6c137"],
    "IWsStoreRegistrationEndpoint": ["1bb12744-3e9b-4959-9226-54751dedba5a"],
    "IWsStoreScopeNotificationEndpoint": ["c8d470d4-d34c-4743-8061-d05af8e6b8fc"],
    "IWsStoreStatisticsEndpoint": ["6246699e-57cb-41b8-894c-12b180346274"],
    "IWsSupplementalPropertiesEndpoint": ["76983f1a-0762-4f61-82a2-4f982478c1ca"],
    "IWsbApplicationAsync": ["0843f6f7-895c-44a6-b0c2-05a5022aa3a1"],
    "IWsbApplicationBackupSupport": ["1eff3510-4a27-46ad-b9e0-08332f0f4f6d"],
    "IWsbApplicationRestoreSupport": ["8d3bdb38-4ee8-4718-85f9-c7dbc4ab77aa"],
    "IWscProduct": ["8c38232e-3a45-4a27-92b0-1a16a975f669"],
    "IWscProduct2": ["f896ca54-fe09-4403-86d4-23cb488d81d8"],
    "IWscProduct3": ["55536524-d1d1-4726-8c7c-04996a1904e7"],
    "IWwanConnectionProfileDetails": ["0e4da8fe-835f-4df3-82fd-df556ebc09ef"],
    "IWwanConnectionProfileDetails2": ["7a754ede-a1ed-48b2-8e92-b460033d52e2"],
    "IWwwFormUrlDecoderEntry": ["125e7431-f678-4e8e-b670-20a9b06c512d"],
    "IWwwFormUrlDecoderRuntimeClass": ["d45a0451-f225-4542-9296-0e1df5d254df"],
    "IWwwFormUrlDecoderRuntimeClassFactory": ["5b8c6b3d-24ae-41b5-a1bf-f0c3d544845b"],
    "IX500DistinguishedName": ["728ab303-217d-11da-b2a4-000e7bbb2b09"],
    "IX509Attribute": ["728ab322-217d-11da-b2a4-000e7bbb2b09"],
    "IX509AttributeArchiveKey": ["728ab327-217d-11da-b2a4-000e7bbb2b09"],
    "IX509AttributeArchiveKeyHash": ["728ab328-217d-11da-b2a4-000e7bbb2b09"],
    "IX509AttributeClientId": ["728ab325-217d-11da-b2a4-000e7bbb2b09"],
    "IX509AttributeCspProvider": ["728ab32b-217d-11da-b2a4-000e7bbb2b09"],
    "IX509AttributeExtensions": ["728ab324-217d-11da-b2a4-000e7bbb2b09"],
    "IX509AttributeOSVersion": ["728ab32a-217d-11da-b2a4-000e7bbb2b09"],
    "IX509AttributeRenewalCertificate": ["728ab326-217d-11da-b2a4-000e7bbb2b09"],
    "IX509Attributes": ["728ab323-217d-11da-b2a4-000e7bbb2b09"],
    "IX509CertificateRequest": ["728ab341-217d-11da-b2a4-000e7bbb2b09"],
    "IX509CertificateRequestCertificate": ["728ab343-217d-11da-b2a4-000e7bbb2b09"],
    "IX509CertificateRequestCertificate2": ["728ab35a-217d-11da-b2a4-000e7bbb2b09"],
    "IX509CertificateRequestCmc": ["728ab345-217d-11da-b2a4-000e7bbb2b09"],
    "IX509CertificateRequestCmc2": ["728ab35d-217d-11da-b2a4-000e7bbb2b09"],
    "IX509CertificateRequestPkcs10": ["728ab342-217d-11da-b2a4-000e7bbb2b09"],
    "IX509CertificateRequestPkcs10V2": ["728ab35b-217d-11da-b2a4-000e7bbb2b09"],
    "IX509CertificateRequestPkcs10V3": ["54ea9942-3d66-4530-b76e-7c9170d3ec52"],
    "IX509CertificateRequestPkcs10V4": ["728ab363-217d-11da-b2a4-000e7bbb2b09"],
    "IX509CertificateRequestPkcs7": ["728ab344-217d-11da-b2a4-000e7bbb2b09"],
    "IX509CertificateRequestPkcs7V2": ["728ab35c-217d-11da-b2a4-000e7bbb2b09"],
    "IX509CertificateRevocationList": ["728ab360-217d-11da-b2a4-000e7bbb2b09"],
    "IX509CertificateRevocationListEntries": ["728ab35f-217d-11da-b2a4-000e7bbb2b09"],
    "IX509CertificateRevocationListEntry": ["728ab35e-217d-11da-b2a4-000e7bbb2b09"],
    "IX509CertificateTemplate": ["54244a13-555a-4e22-896d-1b0e52f76406"],
    "IX509CertificateTemplateWritable": ["f49466a7-395a-4e9e-b6e7-32b331600dc0"],
    "IX509CertificateTemplates": ["13b79003-2181-11da-b2a4-000e7bbb2b09"],
    "IX509EndorsementKey": ["b11cd855-f4c4-4fc6-b710-4422237f09e9"],
    "IX509Enrollment": ["728ab346-217d-11da-b2a4-000e7bbb2b09"],
    "IX509Enrollment2": ["728ab350-217d-11da-b2a4-000e7bbb2b09"],
    "IX509EnrollmentHelper": ["728ab351-217d-11da-b2a4-000e7bbb2b09"],
    "IX509EnrollmentPolicyServer": ["13b79026-2181-11da-b2a4-000e7bbb2b09"],
    "IX509EnrollmentStatus": ["728ab304-217d-11da-b2a4-000e7bbb2b09"],
    "IX509EnrollmentWebClassFactory": ["728ab349-217d-11da-b2a4-000e7bbb2b09"],
    "IX509Extension": ["728ab30d-217d-11da-b2a4-000e7bbb2b09"],
    "IX509ExtensionAlternativeNames": ["728ab315-217d-11da-b2a4-000e7bbb2b09"],
    "IX509ExtensionAuthorityKeyIdentifier": ["728ab318-217d-11da-b2a4-000e7bbb2b09"],
    "IX509ExtensionBasicConstraints": ["728ab316-217d-11da-b2a4-000e7bbb2b09"],
    "IX509ExtensionCertificatePolicies": ["728ab320-217d-11da-b2a4-000e7bbb2b09"],
    "IX509ExtensionEnhancedKeyUsage": ["728ab310-217d-11da-b2a4-000e7bbb2b09"],
    "IX509ExtensionKeyUsage": ["728ab30f-217d-11da-b2a4-000e7bbb2b09"],
    "IX509ExtensionMSApplicationPolicies": ["728ab321-217d-11da-b2a4-000e7bbb2b09"],
    "IX509ExtensionSmimeCapabilities": ["728ab31b-217d-11da-b2a4-000e7bbb2b09"],
    "IX509ExtensionSubjectKeyIdentifier": ["728ab317-217d-11da-b2a4-000e7bbb2b09"],
    "IX509ExtensionTemplate": ["728ab312-217d-11da-b2a4-000e7bbb2b09"],
    "IX509ExtensionTemplateName": ["728ab311-217d-11da-b2a4-000e7bbb2b09"],
    "IX509Extensions": ["728ab30e-217d-11da-b2a4-000e7bbb2b09"],
    "IX509MachineEnrollmentFactory": ["728ab352-217d-11da-b2a4-000e7bbb2b09"],
    "IX509NameValuePair": ["728ab33f-217d-11da-b2a4-000e7bbb2b09"],
    "IX509NameValuePairs": ["728ab340-217d-11da-b2a4-000e7bbb2b09"],
    "IX509PolicyServerListManager": ["884e204b-217d-11da-b2a4-000e7bbb2b09"],
    "IX509PolicyServerUrl": ["884e204a-217d-11da-b2a4-000e7bbb2b09"],
    "IX509PrivateKey": ["728ab30c-217d-11da-b2a4-000e7bbb2b09"],
    "IX509PrivateKey2": ["728ab362-217d-11da-b2a4-000e7bbb2b09"],
    "IX509PublicKey": ["728ab30b-217d-11da-b2a4-000e7bbb2b09"],
    "IX509SCEPEnrollment": ["728ab361-217d-11da-b2a4-000e7bbb2b09"],
    "IX509SCEPEnrollment2": ["728ab364-217d-11da-b2a4-000e7bbb2b09"],
    "IX509SCEPEnrollmentHelper": ["728ab365-217d-11da-b2a4-000e7bbb2b09"],
    "IX509SignatureInformation": ["728ab33c-217d-11da-b2a4-000e7bbb2b09"],
    "IXAConfig": ["c8a6e3a1-9a8c-11cf-a308-00a0c905416e"],
    "IXAMLHostWindow": ["662a21f0-4ad5-4fcf-b790-7b83d7d9ee2f"],
    "IXAMLHostWindowMessageHook": ["491945d9-124c-49a7-8f98-447e7ac633c2"],
    "IXAObtainRMInfo": ["e793f6d2-f53d-11cf-a60d-00a0c905416e"],
    "IXAPO": ["a410b984-9839-4819-a0be-2856ae6b3adb"],
    "IXAPOParameters": ["26d95c66-80f2-499a-ad54-5ae7f01c6d98"],
    "IXAResourceManager": ["4131e751-1aea-11d0-944b-00a0c905416e"],
    "IXAResourceManagerFactory": ["4131e750-1aea-11d0-944b-00a0c905416e"],
    "IXATransLookup": ["f3b1f131-eeda-11ce-aed4-00aa0051e2c4"],
    "IXATransLookup2": ["bf193c85-0d1a-4290-b88f-d2cb8873d1e7"],
    "IXATransaction": ["4131e752-1aea-11d0-944b-00a0c905416e"],
    "IXAudio2": ["2b02e3cf-2e0b-4ec3-be45-1b2a3fe7210d", "60d8dac8-5aa1-4e8e-b597-2f5e2883d484"],
    "IXAudio2Extension": ["84ac29bb-d619-44d2-b197-e4acf7df3ed6"],
    "IXDSCodec": ["c4c4c4b3-0049-4e2b-98fb-9537f6ce516d"],
    "IXDSCodecConfig": ["c4c4c4d3-0049-4e2b-98fb-9537f6ce516d"],
    "IXDSCodecEvents": ["c4c4c4c3-0049-4e2b-98fb-9537f6ce516d"],
    "IXDSToRat": ["c5c5c5b0-3abc-11d6-b25b-00c04fa0c026"],
    "IXFeed": ["a44179a4-e0f6-403b-af8d-d080f425a451"],
    "IXFeed2": ["ce528e77-3716-4eb7-956d-f5e37502e12a"],
    "IXFeedEnclosure": ["bfbfb953-644f-4792-b69c-dfaca4cbf89a"],
    "IXFeedEvents": ["1630852e-1263-465b-98e5-fe60ffec4ac2"],
    "IXFeedFolder": ["4c963678-3a51-4b88-8531-98b90b6508f2"],
    "IXFeedFolderEvents": ["7964b769-234a-4bb1-a5f4-90454c8ad07e"],
    "IXFeedItem": ["e757b2f5-e73e-434e-a1bf-2bd7c3e60fcb"],
    "IXFeedItem2": ["6cda2dc7-9013-4522-9970-2a9dd9ead5a3"],
    "IXFeedsEnum": ["dc43a9d5-5015-4301-8c96-a47434b4d658"],
    "IXFeedsManager": ["5357e238-fb12-4aca-a930-cab7832b84bf"],
    "IXMLDOMDocument3": ["2933bf96-7b36-11d2-b20e-00c04f983e60"],
    "IXMLDOMParseError2": ["3efaa428-272f-11d2-836f-0000f87a7782"],
    "IXMLDOMParseErrorCollection": ["3efaa429-272f-11d2-836f-0000f87a7782"],
    "IXMLEventHandler": ["aefbfa84-8d67-456d-a83a-378a93358f54"],
    "IXMLGraphBuilder": ["1bb05960-5fbf-11d2-a521-44df07c10000"],
    "IXMLHTTPRequest": ["ed8c108d-4349-11d2-91a4-00c04f7969e8"],
    "IXMLHTTPRequest2": ["e5d37dc0-552a-4d52-9cc0-a14d546fbd04"],
    "IXMLHTTPRequest2Callback": ["a44a9299-e321-40de-8866-341b41669162"],
    "IXMLHTTPRequest3": ["a1c9feee-0617-4f23-9d58-8961ea43567c"],
    "IXMLHTTPRequest3Callback": ["b9e57830-8c6c-4a6f-9c13-47772bb047bb"],
    "IXMLHttpRequest3": ["ed8c108f-4349-11d2-91a4-00c04f7969e8"],
    "IXMLHttpRequestEventTarget": ["30510830-98b5-11cf-bb82-00aa00bdce0b"],
    "IXMLPersist": ["7aa27c9d-9443-4ffc-9e92-15196ebf61ec"],
    "IXMLViewerIdentity": ["cc0baf51-3321-11d2-ae28-0080c7337ea1"],
    "IXMicTestMode": ["5a625ea4-a89f-4eb2-a45a-9ad4e37d4b00"],
    "IXWizard": ["777ba87a-2498-4875-933a-3067de883070"],
    "IXWizardHostEvent": ["777ba8a2-2498-4875-933a-3067de883070"],
    "IXWizardMessage": ["777ba823-2498-4875-933a-3067de883070"],
    "IXWizardMessageEvent": ["777ba824-2498-4875-933a-3067de883070"],
    "IXWizardNavigate": ["777ba8d3-2498-4875-933a-3067de883070"],
    "IXWizardPageEvent": ["777ba8c2-2498-4875-933a-3067de883070"],
    "IXWizardPageReport": ["777ba82a-2498-4875-933a-3067de883070"],
    "IXWizardPropertyBag": ["777ba8da-2498-4875-933a-3067de883070"],
    "IXWizardSource": ["777ba826-2498-4875-933a-3067de883070"],
    "IXWizardTaskEvent": ["777ba8b2-2498-4875-933a-3067de883070"],
    "IXWizardTaskReport": ["777ba82c-2498-4875-933a-3067de883070"],
    "IXWizardTransaction": ["777ba827-2498-4875-933a-3067de883070"],
    "IXWizardTransactionEvent": ["777ba828-2498-4875-933a-3067de883070"],
    "IXamlBinaryWriter": ["829d2ad3-620a-46f6-845d-436a05927100"],
    "IXamlBinaryWriterStatics": ["0d8ed07a-9b82-4aa8-b68b-026f2de1cc86"],
    "IXamlBindScopeDiagnostics": ["f264a29d-bded-43aa-a5b0-26ac21a81eb8"],
    "IXamlBindingHelper": ["faa6fb06-8ab9-4ef7-8ae7-fbd30bbfd06d"],
    "IXamlBindingHelperStatics": ["f65cfb71-c80c-4ffa-86ee-558754ee336d"],
    "IXamlCompositionBrushBase": ["03e432d9-b35c-4a79-811c-c5652004da0e"],
    "IXamlCompositionBrushBaseFactory": ["394f0823-2451-4ed8-bd24-488149b3428d"],
    "IXamlCompositionBrushBaseOverrides": ["d19127f1-38b4-4ea1-8f33-849629a4c9c1"],
    "IXamlCompositionBrushBaseProtected": ["1513f3d8-0457-4e1c-ad77-11c1d9879743"],
    "IXamlCompositionBrushBaseStatics": ["4fd49b06-061a-441f-b97a-adfbd41ae681"],
    "IXamlDiagnostics": ["18c9e2b6-3f43-4116-9f2b-ff935d7770d2"],
    "IXamlDirect": ["5ffa1295-add2-590f-a051-70989b866ade"],
    "IXamlDirectObject": ["10614a82-cee4-4645-ba25-d071ce778355"],
    "IXamlDirectStatics": ["321887cc-14e4-5c6f-878d-fbb604ad7d17"],
    "IXamlLight": ["0cc3fc1f-b327-4a18-9648-7c84db26ce22"],
    "IXamlLightFactory": ["87ded768-3055-43b8-8ef6-798dc4c2329a"],
    "IXamlLightOverrides": ["7c6296c7-0173-48e1-b73d-7fa216a9ac28"],
    "IXamlLightProtected": ["5ecf220b-1252-43d0-9729-6ea692046838"],
    "IXamlLightStatics": ["b5ea9d69-b508-4e9c-bd27-6b044b5f78a0"],
    "IXamlMarkupHelper": ["d0e6673c-5342-44ef-85a7-ed327a739d9a"],
    "IXamlMarkupHelperStatics": ["c9bc3725-f34f-445c-81a2-6b72a5e8f072"],
    "IXamlMember": ["c541f58c-43a9-4216-b718-e0b11b14e93e"],
    "IXamlMetadataProvider": ["b3765d69-68a5-4b32-8861-fdb90c1f5836"],
    "IXamlReader": ["24374cf1-cceb-48bf-a514-41b0186f84c2"],
    "IXamlReaderStatics": ["9891c6bd-534f-4955-b85a-8a8dc0dca602"],
    "IXamlRenderingBackgroundTask": ["5d5fe9aa-533e-44b8-a975-fc5f1e3bff52"],
    "IXamlRenderingBackgroundTaskFactory": ["a3d1bb63-38f8-4da3-9fca-fd8128a2cbf9"],
    "IXamlRenderingBackgroundTaskOverrides": ["9c2a6997-a908-4711-b4b2-a960db3d8e5a"],
    "IXamlRoot": ["34b50756-1696-5b6d-8e9b-c71464ccad5a"],
    "IXamlRootChangedEventArgs": ["92d71c21-d23c-5a17-bcb8-001504b6bb19"],
    "IXamlSourceFocusNavigationRequest": ["fbb93bb5-1496-5a80-ac00-e757359755e6"],
    "IXamlSourceFocusNavigationRequestFactory": ["e746ab8f-b4ef-5390-97e5-cc0a2779c574"],
    "IXamlSourceFocusNavigationResult": ["88d55a5f-9603-5d8f-9cc7-d1c4070d9801"],
    "IXamlSourceFocusNavigationResultFactory": ["43bbadbf-f9e1-5527-b8c5-09339ff2ca76"],
    "IXamlType": ["7920eab1-a2e5-479a-bd50-6cef3c0b4970"],
    "IXamlType2": ["9f0c6e3b-433b-56ad-8f69-78a4dd3e64f9"],
    "IXamlUICommand": ["8494f8d4-ead1-5f01-ad2e-a8cad4f9dc0e"],
    "IXamlUICommandFactory": ["1eec08c3-e061-5e10-9f2a-2baa840885c2"],
    "IXamlUICommandStatics": ["66bc457c-1a0c-58ed-876e-71533f966db6"],
    "IXamlUIPresenter": ["a714944a-1619-4fc6-b31b-89512ef022a2"],
    "IXamlUIPresenterHost": ["aafb84cd-9f6d-4f80-ac2c-0e6cb9f31659"],
    "IXamlUIPresenterHost2": ["61595672-7ca4-4a21-b56a-88f4812388ca"],
    "IXamlUIPresenterHost3": ["b14292bf-7320-41bb-9f26-4d6fd34db45a"],
    "IXamlUIPresenterStatics": ["71eaeac8-45e1-4192-85aa-3a422edd23cf"],
    "IXamlUIPresenterStatics2": ["5c6b68d2-cf1c-4f53-bf09-6a745f7a9703"],
    "IXamlViewHost": ["f1b5677a-51f5-46d9-9108-3d9c8201199b"],
    "IXblIdpAuthManager": ["eb5ddb08-8bbf-449b-ac21-b02ddeb3b136"],
    "IXblIdpAuthTokenResult": ["46ce0225-f267-4d68-b299-b2762552dec1"],
    "IXblIdpAuthTokenResult2": ["75d760b0-60b9-412d-994f-26b2cd5f7812"],
    "IXboxLiveDeviceAddress": ["f5bbd279-3c86-4b57-a31a-b9462408fd01"],
    "IXboxLiveDeviceAddressStatics": ["5954a819-4a79-4931-827c-7f503e963263"],
    "IXboxLiveEndpointPair": ["1e9a839b-813e-44e0-b87f-c87a093475e4"],
    "IXboxLiveEndpointPairCreationResult": ["d9a8bb95-2aab-4d1e-9794-33ecc0dcf0fe"],
    "IXboxLiveEndpointPairStateChangedEventArgs": ["592e3b55-de08-44e7-ac3b-b9b9a169583a"],
    "IXboxLiveEndpointPairStatics": ["64316b30-217a-4243-8ee1-6729281d27db"],
    "IXboxLiveEndpointPairTemplate": ["6b286ecf-3457-40ce-b9a1-c0cfe0213ea7"],
    "IXboxLiveEndpointPairTemplateStatics": ["1e13137b-737b-4a23-bc64-0870f75655ba"],
    "IXboxLiveInboundEndpointPairCreatedEventArgs": ["dc183b62-22ba-48d2-80de-c23968bd198b"],
    "IXboxLiveQualityOfServiceMeasurement": ["4d682bce-a5d6-47e6-a236-cfde5fbdf2ed"],
    "IXboxLiveQualityOfServiceMeasurementStatics": ["6e352dca-23cf-440a-b077-5e30857a8234"],
    "IXboxLiveQualityOfServiceMetricResult": ["aeec53d1-3561-4782-b0cf-d3ae29d9fa87"],
    "IXboxLiveQualityOfServicePrivatePayloadResult": ["5a6302ae-6f38-41c0-9fcc-ea6cb978cafc"],
    "IXml2Dex": ["18c628ed-962a-11d2-8d08-00a0c9441e20"],
    "IXmlAttribute": ["ac144aa4-b4f1-4db6-b206-8a22c308db0a"],
    "IXmlCDataSection": ["4d04b46f-c8bd-45b4-8899-0400d7c2c60f"],
    "IXmlCharacterData": ["132e42ab-4e36-4df6-b1c8-0ce62fd88b26"],
    "IXmlComment": ["bca474d5-b61f-4611-9cac-2e92e3476d47"],
    "IXmlDocument": ["f7f3a506-1e87-42d6-bcfb-b8c809fa5494"],
    "IXmlDocumentFragment": ["e2ea6a96-0c21-44a5-8bc9-9e4a262708ec"],
    "IXmlDocumentIO": ["6cd0e74e-ee65-4489-9ebf-ca43e87ba637"],
    "IXmlDocumentIO2": ["5d034661-7bd8-4ad5-9ebf-81e6347263b1"],
    "IXmlDocumentStatics": ["5543d254-d757-4b79-9539-232b18f50bf1"],
    "IXmlDocumentType": ["f7342425-9781-4964-8e94-9b1c6dfc9bc7"],
    "IXmlDomImplementation": ["6de58132-f11d-4fbb-8cc6-583cba93112f"],
    "IXmlElement": ["2dfb8a1f-6b10-4ef8-9f83-efcce8faec37"],
    "IXmlEntityReference": ["2e2f47bc-c3d0-4ccf-bb86-0ab8c36a61cf"],
    "IXmlHttpRequestInternal": ["25bd7db0-b780-4d26-98e7-bb2a6b42e460"],
    "IXmlLoadSettings": ["58aa07a8-fed6-46f7-b4c5-fb1ba72108d6"],
    "IXmlNamedNodeMap": ["b3a69eb0-aab0-4b82-a6fa-b1453f7c021b"],
    "IXmlNode": ["1c741d59-2122-47d5-a856-83f3d4214875"],
    "IXmlNodeList": ["8c60ad77-83a4-4ec1-9c54-7ba429e13da6"],
    "IXmlNodeSelector": ["63dbba8b-d0db-4fe1-b745-f9433afdc25b"],
    "IXmlNodeSerializer": ["5cc5b382-e6dd-4991-abef-06d8d2e7bd0c"],
    "IXmlProcessingInstruction": ["2707fd1e-1e92-4ece-b6f4-26f069078ddc"],
    "IXmlReader": ["7279fc81-709d-4095-b63d-69fe4b0d9030"],
    "IXmlResolver": ["7279fc82-709d-4095-b63d-69fe4b0d9030"],
    "IXmlText": ["f931a4cb-308d-4760-a1d5-43b67450ac7e"],
    "IXmlWriter": ["7279fc88-709d-4095-b63d-69fe4b0d9030"],
    "IXmlWriterLite": ["862494c6-1310-4aad-b3cd-2dbeebf670d3"],
    "IXpsDocument": ["e8d907db-62a9-4a95-abe7-e01763dd30f8"],
    "IXpsDocumentConsumer": ["4368d8a2-4181-4a9f-b295-3d9a38bb9ba0"],
    "IXpsDocumentPackageTarget": ["3b0b6d38-53ad-41da-b212-d37637a6714e"],
    "IXpsDocumentPackageTarget3D": ["60ba71b8-3101-4984-9199-f4ea775ff01d"],
    "IXpsDocumentProvider": ["b8cf8530-5562-47c4-ab67-b1f69ecf961e"],
    "IXpsOMBrush": ["56a3f80c-ea4c-4187-a57b-a2a473b2b42b"],
    "IXpsOMCanvas": ["221d1452-331e-47c6-87e9-6ccefb9b5ba3"],
    "IXpsOMColorProfileResource": ["67bd7d69-1eef-4bb1-b5e7-6f4f87be8abe"],
    "IXpsOMColorProfileResourceCollection": ["12759630-5fba-4283-8f7d-cca849809edb"],
    "IXpsOMCoreProperties": ["3340fe8f-4027-4aa1-8f5f-d35ae45fe597"],
    "IXpsOMDashCollection": ["081613f4-74eb-48f2-83b3-37a9ce2d7dc6"],
    "IXpsOMDictionary": ["897c86b8-8eaf-4ae3-bdde-56419fcf4236"],
    "IXpsOMDocument": ["2c2c94cb-ac5f-4254-8ee9-23948309d9f0"],
    "IXpsOMDocumentCollection": ["d1c87f0d-e947-4754-8a25-971478f7e83e"],
    "IXpsOMDocumentSequence": ["56492eb4-d8d5-425e-8256-4c2b64ad0264"],
    "IXpsOMDocumentStructureResource": ["85febc8a-6b63-48a9-af07-7064e4ecff30"],
    "IXpsOMFontResource": ["a8c45708-47d9-4af4-8d20-33b48c9b8485"],
    "IXpsOMFontResourceCollection": ["70b4a6bb-88d4-4fa8-aaf9-6d9c596fdbad"],
    "IXpsOMGeometry": ["64fcf3d7-4d58-44ba-ad73-a13af6492072"],
    "IXpsOMGeometryFigure": ["d410dc83-908c-443e-8947-b1795d3c165a"],
    "IXpsOMGeometryFigureCollection": ["fd48c3f3-a58e-4b5a-8826-1de54abe72b2"],
    "IXpsOMGlyphs": ["819b3199-0a5a-4b64-bec7-a9e17e780de2"],
    "IXpsOMGlyphsEditor": ["a5ab8616-5b16-4b9f-9629-89b323ed7909"],
    "IXpsOMGradientBrush": ["edb59622-61a2-42c3-bace-acf2286c06bf"],
    "IXpsOMGradientStop": ["5cf4f5cc-3969-49b5-a70a-5550b618fe49"],
    "IXpsOMGradientStopCollection": ["c9174c3a-3cd3-4319-bda4-11a39392ceef"],
    "IXpsOMImageBrush": ["3df0b466-d382-49ef-8550-dd94c80242e4"],
    "IXpsOMImageResource": ["3db8417d-ae50-485e-9a44-d7758f78a23f"],
    "IXpsOMImageResourceCollection": ["7a4a1a71-9cde-4b71-b33f-62de843eabfe"],
    "IXpsOMLinearGradientBrush": ["005e279f-c30d-40ff-93ec-1950d3c528db"],
    "IXpsOMMatrixTransform": ["b77330ff-bb37-4501-a93e-f1b1e50bfc46"],
    "IXpsOMNameCollection": ["4bddf8ec-c915-421b-a166-d173d25653d2"],
    "IXpsOMObjectFactory": ["f9b2a685-a50d-4fc2-b764-b56e093ea0ca"],
    "IXpsOMObjectFactory1": ["0a91b617-d612-4181-bf7c-be5824e9cc8f"],
    "IXpsOMPackage": ["18c3df65-81e1-4674-91dc-fc452f5a416f"],
    "IXpsOMPackage1": ["95a9435e-12bb-461b-8e7f-c6adb04cd96a"],
    "IXpsOMPackageTarget": ["219a9db0-4959-47d0-8034-b1ce84f41a4d"],
    "IXpsOMPackageWriter": ["4e2aa182-a443-42c6-b41b-4f8e9de73ff9"],
    "IXpsOMPackageWriter3D": ["e8a45033-640e-43fa-9bdf-fddeaa31c6a0"],
    "IXpsOMPage": ["d3e18888-f120-4fee-8c68-35296eae91d4"],
    "IXpsOMPage1": ["305b60ef-6892-4dda-9cbb-3aa65974508a"],
    "IXpsOMPageReference": ["ed360180-6f92-4998-890d-2f208531a0a0"],
    "IXpsOMPageReferenceCollection": ["ca16ba4d-e7b9-45c5-958b-f98022473745"],
    "IXpsOMPart": ["74eb2f0b-a91e-4486-afac-0fabeca3dfc6"],
    "IXpsOMPartResources": ["f4cf7729-4864-4275-99b3-a8717163ecaf"],
    "IXpsOMPartUriCollection": ["57c650d4-067c-4893-8c33-f62a0633730f"],
    "IXpsOMPath": ["37d38bb6-3ee9-4110-9312-14b194163337"],
    "IXpsOMPrintTicketResource": ["e7ff32d2-34aa-499b-bbe9-9cd4ee6c59f7"],
    "IXpsOMRadialGradientBrush": ["75f207e5-08bf-413c-96b1-b82b4064176b"],
    "IXpsOMRemoteDictionaryResource": ["c9bd7cd4-e16a-4bf8-8c84-c950af7a3061"],
    "IXpsOMRemoteDictionaryResource1": ["bf8fc1d4-9d46-4141-ba5f-94bb9250d041"],
    "IXpsOMRemoteDictionaryResourceCollection": ["5c38db61-7fec-464a-87bd-41e3bef018be"],
    "IXpsOMResource": ["da2ac0a2-73a2-4975-ad14-74097c3ff3a5"],
    "IXpsOMShareable": ["7137398f-2fc1-454d-8c6a-2c3115a16ece"],
    "IXpsOMSignatureBlockResource": ["4776ad35-2e04-4357-8743-ebf6c171a905"],
    "IXpsOMSignatureBlockResourceCollection": ["ab8f5d8e-351b-4d33-aaed-fa56f0022931"],
    "IXpsOMSolidColorBrush": ["a06f9f05-3be9-4763-98a8-094fc672e488"],
    "IXpsOMStoryFragmentsResource": ["c2b3ca09-0473-4282-87ae-1780863223f0"],
    "IXpsOMThumbnailGenerator": ["15b873d5-1971-41e8-83a3-6578403064c7"],
    "IXpsOMTileBrush": ["0fc2328d-d722-4a54-b2ec-be90218a789e"],
    "IXpsOMVisual": ["bc3e7333-fb0b-4af3-a819-0b4eaad0d2fd"],
    "IXpsOMVisualBrush": ["97e294af-5b37-46b4-8057-874d2f64119b"],
    "IXpsOMVisualCollection": ["94d8abde-ab91-46a8-82b7-f5b05ef01a96"],
    "IXpsPartIterator": ["0021d3cd-af6f-42ab-9999-14bc82a62d2e"],
    "IXpsPrintJob": ["5ab89b06-8194-425f-ab3b-d7a96e350161"],
    "IXpsPrintJobStream": ["7a77dc5f-45d6-4dff-9307-d8cb846347ca"],
    "IXpsRasterizationFactory": ["e094808a-24c6-482b-a3a7-c21ac9b55f17"],
    "IXpsRasterizationFactory1": ["2d6e5f77-6414-4a1e-a8e0-d4194ce6a26f"],
    "IXpsRasterizationFactory2": ["9c16ce3e-10f5-41fd-9ddc-6826669c2ff6"],
    "IXpsRasterizer": ["7567cfc8-c156-47a8-9dac-11a2ae5bdd6b"],
    "IXpsRasterizerNotificationCallback": ["9ab8fd0d-cb94-49c2-9cb0-97ec1d5469d2"],
    "IXpsSignature": ["6ae4c93e-1ade-42fb-898b-3a5658284857"],
    "IXpsSignatureBlock": ["151fac09-0b97-4ac6-a323-5e4297d4322b"],
    "IXpsSignatureBlockCollection": ["23397050-fe99-467a-8dce-9237f074ffe4"],
    "IXpsSignatureCollection": ["a2d1d95d-add2-4dff-ab27-6b9c645ff322"],
    "IXpsSignatureManager": ["d3e8d338-fdc4-4afc-80b5-d532a1782ee1"],
    "IXpsSignatureRequest": ["ac58950b-7208-4b2d-b2c4-951083d3b8eb"],
    "IXpsSignatureRequestCollection": ["f0253e68-9f19-412e-9b4f-54d3b0ac6cd9"],
    "IXpsSigningOptions": ["7718eae4-3215-49be-af5b-594fef7fcfa6"],
    "IXsltProcessor": ["7b64703f-550c-48c6-a90f-93a5b964518f"],
    "IXsltProcessor2": ["8da45c56-97a5-44cb-a8be-27d86280c70a"],
    "IXsltProcessorFactory": ["274146c0-9a51-4663-bf30-0ef742146f20"],
    "IXusbGameControllerInputSink": ["b2ac1d95-6ecb-42b3-8aab-025401ca4712"],
    "IXusbGameControllerProvider": ["6e2971eb-0efb-48b4-808b-837643b2f216"],
    "IZoneIdentifier2": ["eb5e760c-09ef-45c0-b510-70830ce31e6a"],
    "IZoneIdentifierPriv2": ["31114b0a-accb-4e12-a053-754cb41c1d0f"],
    "IZoomControl": ["3a1e0b12-32da-4c17-bfd7-8d0c73c8f5a5"],
    "IZoomControl2": ["69843db0-2e99-4641-8529-184f319d1671"],
    "IZoomEvents": ["41b68150-904c-4e17-a0ba-a438182e359d"],
    "IZoomSettings": ["6ad66b24-14b4-4bfd-b18f-88fe24463b52"],
    "IeAxiAdminInstaller": ["9aea8a59-e0c9-40f1-87dd-757061d56177"],
    "IeAxiInstaller": ["c374ce57-e034-4327-aa86-6b5d71ce604f"],
    "IeAxiInstaller2": ["bc0ec710-a3ed-4f99-b14f-5fd59fdacea3"],
    "IeAxiService": ["e9e92380-9ecd-4982-a0eb-6815a56ccf27"],
    "IeAxiService2": ["79f729c0-2ccb-47a4-b8ea-594521f4298a"],
    "IeAxiServiceCallback": ["1823e7ba-ec36-447a-9b2e-b4912e15afe7"],
    "IeAxiSystemInstaller": ["a50ea6f8-4764-4299-b309-022b2a8b4d8d"],
    "ImageListEvents": ["2c247f22-8591-11d1-b16a-00c0f0283628"],
    "Imports": ["642789f9-210d-4574-96fd-5a653451e216"],
    "IncrementalSearch": ["c5bee6d8-ed45-4317-96bf-97eb88ea3a07"],
    "ItemOperations": ["d5dbe57b-c074-4e95-b015-abeeaa391693"],
    "ItsPubPlugin": ["70c04b05-f347-412b-822f-36c99c54ca45"],
    "ItsPubPlugin2": ["fa4ce418-aad7-4ec6-bad1-0a321ba465d5"],
    "JSharpProjectConfigurationProperties3": ["3600ddb7-34c2-4ced-9337-5b266cc0a169"],
    "LOGGINGUI": ["31dcab89-bb3e-11d0-9299-00c04fb6678b"],
    "LOGGINGUI2": ["fae6e2a8-bf79-4ac6-aa58-71347c92d593"],
    "LanguageSettings": ["000c0353-0000-0000-c000-000000000046"],
    "Languages": ["a4f4246c-c131-11d2-8ad1-00c04f79e479"],
    "Level": ["2281373a-8bd3-11d0-b4ef-00a0c9138ca4"],
    "Levels": ["22813758-8bd3-11d0-b4ef-00a0c9138ca4"],
    "LifetimeInformation": ["c8f4f9cc-b7e5-4458-bce3-e1542468f26b"],
    "LineFormat": ["000c0317-0000-0000-c000-000000000046"],
    "LinkedWindows": ["f00ef34a-a654-4c1b-897a-585d5bcbb35a", "f00ef34a-a654-4c1b-897a-585d5bcbb35a"],
    "ListViewEvents": ["bdd1f04a-858b-11d1-b16a-00c0f0283628"],
    "MD_Collection": ["22813751-8bd3-11d0-b4ef-00a0c9138ca4"],
    "Macros": ["f9f99155-6d4d-49b1-ad63-c78c3e8a5916"],
    "Modules": ["b0f3b256-d962-4319-b7c0-a52486c16cb9"],
    "MsoDebugOptions": ["000c035a-0000-0000-c000-000000000046"],
    "NewFile": ["000c0936-0000-0000-c000-000000000046"],
    "ODSOColumn": ["000c1531-0000-0000-c000-000000000046"],
    "ODSOColumns": ["000c1532-0000-0000-c000-000000000046"],
    "ODSOFilter": ["000c1533-0000-0000-c000-000000000046"],
    "ODSOFilters": ["000c1534-0000-0000-c000-000000000046"],
    "ObjectExtenders": ["8d0aa9cc-8465-42f3-ad6e-dfde28ccc75d"],
    "OfficeDataSourceObject": ["000c1530-0000-0000-c000-000000000046"],
    "OfficeSpace_Chunk": ["000c013e-0000-0000-c000-000000000046"],
    "OfficeSpace_ContextualUI": ["000c014d-0000-0000-c000-000000000046"],
    "OfficeSpace_Control": ["000c013c-0000-0000-c000-000000000046"],
    "OfficeSpace_ExecuteThisOrOtherAction": ["000c0148-0000-0000-c000-000000000046"],
    "OfficeSpace_FileMenuAnchor": ["000c0149-0000-0000-c000-000000000046"],
    "OfficeSpace_IControl": ["000c0134-0000-0000-c000-000000000046"],
    "OfficeSpace_IDataCache": ["000c0133-0000-0000-c000-000000000046"],
    "OfficeSpace_IDataSource": ["000c0132-0000-0000-c000-000000000046"],
    "OfficeSpace_IDataSourceAdapter": ["000c013b-0000-0000-c000-000000000046"],
    "OfficeSpace_IFlyoutAnchor": ["000c012c-0000-0000-c000-000000000046"],
    "OfficeSpace_IOfficeSpace": ["000c012d-0000-0000-c000-000000000046"],
    "OfficeSpace_List": ["000c0140-0000-0000-c000-000000000046"],
    "OfficeSpace_MiniToolBar": ["000c014e-0000-0000-c000-000000000046"],
    "OfficeSpace_Root": ["000c0131-0000-0000-c000-000000000046"],
    "OfficeSpace_Tab": ["000c013f-0000-0000-c000-000000000046"],
    "OutputGroup": ["a3a80783-875f-435b-9639-e5ce888df737"],
    "OutputGroups": ["f9fa748e-e302-44cf-891b-e263189d585e"],
    "OutputWindow": ["eab0a63d-c3a8-496e-9acf-a82cef6a43b3"],
    "OutputWindowPane": ["ffc9dfc4-61ca-4b0c-83c2-0703a24f5c16"],
    "OutputWindowPanes": ["b02cf62a-9470-4308-a521-9675fba395ab"],
    "PackageReferences": ["146a9209-0d04-4024-9fd6-132143a337e4"],
    "PictureFormat": ["000c031a-0000-0000-c000-000000000046"],
    "Positions": ["2281375a-8bd3-11d0-b4ef-00a0c9138ca4"],
    "Process2": ["95ac1923-6eaa-427c-b43e-6274a8ca6c95"],
    "Process3": ["d401c665-4ec7-452b-aa91-985d16772d84"],
    "Process4": ["49db35dd-fdd9-43ba-bd3f-2baf50f5c45e"],
    "Processes": ["9f379969-5eac-4a54-b2bc-6946cffb56ef"],
    "Program": ["6a38d87c-bba0-11d2-8ad1-00c04f79e479"],
    "Programs": ["dc6a118a-bbab-11d2-8ad1-00c04f79e479"],
    "Project": ["866311e6-c887-4143-9833-645f5b93f6f1", "866311e6-c887-4143-9833-645f5b93f6f1"],
    "ProjectConfigurationProperties": ["3cdaa65d-1e9d-11d3-b202-00c04f79cacb"],
    "ProjectConfigurationProperties2": ["3cdaa65d-1e9d-11d4-b203-00c04f79cacb"],
    "ProjectConfigurationProperties3": ["9918dab5-fc67-4cd4-b352-2f3fa1e2bd08"],
    "ProjectItem": ["0b48100a-473e-433c-ab8f-66b9739ab620", "0b48100a-473e-433c-ab8f-66b9739ab620"],
    "ProjectItems": ["8e2f1269-185e-43c7-8899-950ad2769ccf", "8e2f1269-185e-43c7-8899-950ad2769ccf"],
    "ProjectProperties": ["3cdaa65e-1e9d-11d3-b202-00c04f79cacb"],
    "ProjectProperties2": ["3cdaa65e-1e9d-11d4-b212-00c04f79cacb"],
    "ProjectProperties3": ["7c9d1773-f1f3-447c-af1a-218e5e2c2f7f"],
    "Projects": ["e3ec0add-31b3-461f-8303-8a5e6931257a", "e3ec0add-31b3-461f-8303-8a5e6931257a"],
    "PropertyTest": ["000c0333-0000-0000-c000-000000000046"],
    "PropertyTests": ["000c0334-0000-0000-c000-000000000046"],
    "Recordset15": ["0000050e-0000-0010-8000-00aa006d2ea4", "0000150e-0000-0010-8000-00aa006d2ea4"],
    "Recordset20": ["0000054f-0000-0010-8000-00aa006d2ea4", "0000154f-0000-0010-8000-00aa006d2ea4"],
    "Recordset21": ["00000555-0000-0010-8000-00aa006d2ea4", "00001555-0000-0010-8000-00aa006d2ea4"],
    "RecordsetEvents": ["00000266-0000-0010-8000-00aa006d2ea4", "00001266-0000-0010-8000-00aa006d2ea4"],
    "RecordsetEventsVt": ["00000403-0000-0010-8000-00aa006d2ea4", "00001403-0000-0010-8000-00aa006d2ea4"],
    "Reference2": ["4fff24c5-5644-4a47-a48a-b74c3f1f8fc8"],
    "Reference3": ["5021602e-2025-4299-88d2-0a92e8b41adf"],
    "Reference4": ["f71b6036-80f1-4f08-bc59-b5d92865f629"],
    "Reference5": ["676a4c6f-f436-40de-88e9-db12bb864598"],
    "Reference6": ["957f4f7e-035c-4e0e-9df5-6eb86cb0bcad"],
    "References": ["b8758ee4-0553-4bc9-8432-440449d35c14"],
    "References2": ["8bf64af0-ad98-46d1-8e3e-a02af56f80ae"],
    "References3": ["0b2b0873-6de1-4045-88dd-b2cbd94e3547"],
    "RelatedFiles": ["7c55a332-a2ec-4387-a242-cd1b9a29f1d2"],
    "SAppxManifestDesignerService": ["5692cb97-bf4f-49ee-b62e-718a6c8f9cb2"],
    "SAsyncServiceProvider": ["944774c9-7422-4e87-b01c-189182c779a6"],
    "SProfferAsyncService": ["594ac716-4b5c-4a85-b36f-f1e728f71603"],
    "SVSWebReferenceDynamicProperties": ["c65a2f92-b350-4b0f-9bc6-b00e24bc8b9d"],
    "SVsAccountManagementService": ["33024f95-187c-4f15-aa48-38d05c1e8b58"],
    "SVsAccountManager": ["231e1bd9-eecc-4e16-9fca-a1d24a20ee71"],
    "SVsActivityLog": ["24367a32-ef56-405b-a395-5cf2bccb2283"],
    "SVsAddWebReferenceDlg3": ["32d47224-21a6-4d8f-9223-c91f0d69c501"],
    "SVsAppContainerDeveloperLicensing": ["46b0c039-de36-4dae-a038-9f1635f5f962"],
    "SVsAppContainerProjectDeploy": ["7e97079c-bb7c-4003-8dfb-730cd0b88250"],
    "SVsAssemblyNameUnification": ["b54b4062-117d-46fc-be19-cd20f2867d52"],
    "SVsBuildManagerAccessor": ["9a9569d2-2f7e-4af6-9e40-630f86d3f3f9"],
    "SVsBuiltInServiceInfoQueryService": ["11d239a8-47cd-4fac-9841-d4c0e1e4b5f4"],
    "SVsCallBrowser": ["f9d0f5ff-c093-4e80-a886-57610d58a728"],
    "SVsCodeDefView": ["66230816-ac33-49b5-97db-0f6df2a83624"],
    "SVsCommandWindowsCollection": ["e337f382-3cab-44a5-af0e-3daca541c89a"],
    "SVsCommonMessagePumpFactory": ["e269cba1-c9fb-45a8-91ca-ec8d3474fdd2"],
    "SVsComponentModelHost": ["debf6a60-a2cb-4059-8677-0067f046c4bc"],
    "SVsComponentSelectorDlg2": ["525d42ef-d7f6-412a-9d64-79e787e70e45"],
    "SVsConfigurationManagerDlg": ["8f435bad-95a1-4032-8cd0-dc74f67cb106"],
    "SVsCreateAggregateProject": ["50b729ad-ac3b-451f-be03-9ea167f5d637"],
    "SVsDataObjectStringMapManager": ["8016834a-90e4-4e01-b24f-958daa30b7d5"],
    "SVsDataSourceFactory": ["ba361a60-1c0e-40db-bad6-503413fc3ad2"],
    "SVsDebugRemoteDiscoveryUI": ["4c1207a4-2b59-426b-8f31-980d0e7a427c"],
    "SVsDebugTargetSelectionService": ["89291c82-99bc-4fa3-98c0-802eeb2fbd70"],
    "SVsDesignTimeAssemblyResolution": ["1b31ccfd-1b75-4ad8-9581-51b27b150c27"],
    "SVsDetermineWizardTrust": ["9a3b199d-2294-4da6-9b43-7a4eafe31fa0"],
    "SVsDifferenceService": ["77115e75-ef9e-4f30-92f2-3fe78bcaf6cf"],
    "SVsErrorList": ["599bcd9e-cafa-43df-aa03-129c0004c2bd"],
    "SVsFileMergeService": ["34d4713e-eb24-4746-938b-be5640d03210"],
    "SVsFontAndColorCacheManager": ["fb5f088f-1c86-4648-b01c-0a1c40840c51"],
    "SVsFrameworkMultiTargeting": ["6f209208-4d8f-4412-b125-cd839b055d52"],
    "SVsFrameworkRetargetingDlg": ["d4d51b8e-6ecf-4c42-a3e2-e0925e5115d6"],
    "SVsGlobalSearch": ["37470c6f-f752-4e39-8292-0d2b435e0d6f"],
    "SVsHelpFavorites": ["4a81432b-bfcc-4832-9be9-15977da82072"],
    "SVsHierarchyManipulation": ["1c917a11-5b6e-4752-9dec-94b041a05745"],
    "SVsHubService": ["95d652e5-d9b2-4ee6-bb09-bdbb1dcb5263"],
    "SVsImageService": ["acc9eb93-cad8-41de-80da-bd35cc5112ae"],
    "SVsInfoBarUIFactory": ["8e223e35-68a4-4744-9140-c575682a66b4"],
    "SVsIntellisenseEngine": ["d380c630-e46f-40e1-b71d-f3d1682c5aa8"],
    "SVsIntellisenseProjectHost": ["5d13ece7-aa1f-400f-b65d-fa2abd4f1cd4"],
    "SVsIntellisenseProjectManager": ["5cb6b09c-64f5-4579-8593-7720dab2ef8d"],
    "SVsInvalidateCachedCommandState": ["74590f40-42ef-4df4-b762-902b09884657"],
    "SVsLongIdleManager": ["9b7f0fb5-adb7-402d-aadb-56511ae76e1a"],
    "SVsMRUItemsStore": ["baaf2bb3-60ef-4439-a8c3-c09b5fad7dbe"],
    "SVsMainWindowDropTarget": ["8abe01db-4cb1-4be7-961f-d30b2ef6aeb1"],
    "SVsMenuEventsService": ["0d646997-5c08-4ef2-b709-b5c70f009a70"],
    "SVsNavigateToService": ["65c44ef9-16f8-4f36-bd73-f10335ec452e"],
    "SVsOpenProjectOrSolutionDlg": ["a3761d3f-7c1e-4526-a8d5-1575631f09fc"],
    "SVsPackageInfoQueryService": ["b5477757-d697-4dfe-a8ef-04e2992f7d26"],
    "SVsPathVariableResolver": ["89db7429-f4a4-4f26-b832-2eb963a19aaa"],
    "SVsPreviewChangesService": ["12143874-da05-4d05-9f57-2d339c142220"],
    "SVsProfferCommands": ["8cc0cde1-c16a-4749-99af-6f7523c34a57"],
    "SVsProfileDataManager": ["20945017-0113-4636-bbfc-0716071b5b84"],
    "SVsProfilerLauncher": ["ebedc435-d4b7-4428-83ef-d59eaa18c7df"],
    "SVsProfilesManagerUI": ["3b0749ff-31e8-42d8-9cd2-f612148d7bdc"],
    "SVsProjectMRU": ["d8982a22-9ce1-45ed-963c-815854b1cfa2"],
    "SVsQueryEditQuerySave": ["53544c4d-1984-11d3-a606-005004775ab1"],
    "SVsReferenceManager": ["b9ce963c-c8f4-48f9-8302-0c2d75e48d1e"],
    "SVsRegisterDebugTargetProvider": ["6b25ed7d-e462-4bba-b181-81d9f73fcd72"],
    "SVsRegisterNewDialogFilters": ["cb7c5b29-6782-47b7-aa13-21d07026d5e1"],
    "SVsResourceManager": ["e9706ef6-4f76-4c6e-8bf0-6e448550470b"],
    "SVsSQLCLRReferences": ["8ed9966c-102f-45b0-8293-bb9f2463a6f2"],
    "SVsSccManager": ["53544c4d-1927-4320-b9da-13d2cb3ea93b"],
    "SVsSccToolsOptions": ["53544c4d-104b-4d82-ad93-074816c1a0e5"],
    "SVsServiceInfoQueryService": ["68fb1880-81f7-4939-8bbc-a957a1033345"],
    "SVsSettingsManager": ["c4deebee-f4c1-4a09-b47c-ef17e83d269d"],
    "SVsSettingsReader": ["7c1bd0d6-2086-46ab-8f07-b9335d0fe7d8"],
    "SVsSetupCompositionService": ["b03f88b8-f356-422b-997c-f55bd0668bdc"],
    "SVsSharedProjectReferencesHelper": ["db598271-ad61-4bb2-80ba-729af83f0ee3"],
    "SVsSmartOpenScope": ["52f0dab8-99a9-4aea-a037-42581b7009d2"],
    "SVsStartPageDownload": ["a60fce08-2f9c-4676-86f0-bcd4973fc702"],
    "SVsStartupProjectsListService": ["66b406df-e206-47f6-a42b-cee6b4201082"],
    "SVsStrongNameKeys": ["97bae668-2cf2-4ed8-a019-d279e3d74c80"],
    "SVsSymbolicNavigationManager": ["c67a5f0c-31c0-4316-9ef9-b451b30c829e"],
    "SVsTargetFrameworkAssemblies": ["c269ada8-95f9-4987-a247-151fb2ddfb34"],
    "SVsTaskSchedulerService": ["ab244925-40a8-4c5c-b0a5-717bb5d615b6"],
    "SVsThreadPool": ["7482e83d-842a-447c-8ddb-687f7052f7c7"],
    "SVsThreadedWaitDialog": ["1ac64571-85cf-4234-aa00-b57e907e326a"],
    "SVsThreadedWaitDialogFactory": ["d2ddf9c8-fe3b-4dd9-9499-78d8ea277210"],
    "SVsToolboxDataProviderRegistry": ["3af9e499-91b8-4b54-bd1d-81f414a587c9"],
    "SVsToolsOptions": ["376208e4-2679-4c9e-b3d5-929eb0f1a1f7"],
    "SVsTrackProjectDocuments": ["53544c4d-1639-11d3-a60d-005004775ab1"],
    "SVsTrackProjectRetargeting": ["530462a8-1ecb-4f7f-979e-a0237fea12c3"],
    "SVsUIContextMonitor": ["63b07ba0-b399-4b71-aa69-0d97c097b69c"],
    "SVsUIDataConverters": ["3a4aec59-cf2a-42c9-8da8-66e19d7c547d"],
    "SVsUIFactory": ["570352bf-9b42-4c1f-b0c4-a8323d8f7bd3"],
    "SVsUpgradeLogger": ["dfb0136f-202e-40b5-872e-ae8289a45b59"],
    "SVsWCFReferenceManagerFactory": ["ddd04e59-6b86-4a73-8bc7-3ff5d7b1111c"],
    "SVsWebProxy": ["6454f7ca-478c-4932-b007-abb100905bd4"],
    "SVsWindowSearchHostFactory": ["a4e62c4f-c462-43bf-a46b-7a6e9db2e767"],
    "ScopeFolder": ["000c0368-0000-0000-c000-000000000046"],
    "ScopeFolders": ["000c0369-0000-0000-c000-000000000046"],
    "Scripts": ["000c0340-0000-0000-c000-000000000046"],
    "SearchFolders": ["000c036a-0000-0000-c000-000000000046"],
    "SearchScope": ["000c0367-0000-0000-c000-000000000046"],
    "SearchScopes": ["000c0366-0000-0000-c000-000000000046"],
    "SelectedItem": ["049d2cdf-3731-4cb6-a233-be97bce922d3", "049d2cdf-3731-4cb6-a233-be97bce922d3"],
    "SelectedItems": ["6caa67cf-43ae-4184-aaab-0200ddf6b240", "6caa67cf-43ae-4184-aaab-0200ddf6b240"],
    "SelectionContainer": ["02273422-8dd4-4a9f-8a8b-d70443d510f4", "02273422-8dd4-4a9f-8a8b-d70443d510f4"],
    "ShadowFormat": ["000c031b-0000-0000-c000-000000000046"],
    "Shape": ["000c031c-0000-0000-c000-000000000046"],
    "ShapeNode": ["000c0318-0000-0000-c000-000000000046"],
    "ShapeNodes": ["000c0319-0000-0000-c000-000000000046"],
    "ShapeRange": ["000c031d-0000-0000-c000-000000000046"],
    "Shapes": ["000c031e-0000-0000-c000-000000000046"],
    "SharedMSBuildFilesManagerHierarchy": ["22912bb2-3ff9-4d55-b4db-d210b6035d4c"],
    "SharedProjectReferenceProviderGuid": ["88b47069-c019-4eec-b69c-3c8630f83ba5"],
    "Signature": ["000c0411-0000-0000-c000-000000000046"],
    "SignatureSet": ["000c0410-0000-0000-c000-000000000046"],
    "Solution2": ["fa238614-fbb1-4314-a7f7-49ae8bb6c6ba"],
    "Solution3": ["df23915f-fda3-4dd5-9caa-2e1372c2bb16"],
    "Solution4": ["cda7305c-78b6-4d9d-90ad-93ebe71f9341"],
    "SolutionBuild": ["a3c1c40c-9218-4d4c-9daa-075f64f6922c"],
    "SolutionBuild2": ["c2516e4b-5d69-459d-b539-c95a71c4fa3d"],
    "SolutionConfiguration": ["60aaad75-cb8d-4c62-9959-24d6a6a50de7"],
    "SolutionConfiguration2": ["1099aaa6-4169-430d-9f57-0b4c76624b3b"],
    "SolutionConfigurations": ["23e78ed7-c9e1-462d-8bc6-366003486ed9"],
    "SolutionContext": ["fc6a1a82-9c8a-47bb-a046-6e965df5a99b"],
    "SolutionContexts": ["0685b546-fb84-4917-ab98-98d40f892d61"],
    "SolutionFolder": ["f8f69788-267c-4408-8967-74f26108c438"],
    "SourceControl": ["f1ddc2c2-df76-4ebb-9de8-48ad2557062c"],
    "SourceControl2": ["111522ab-f439-4d85-9a36-1716da4da114"],
    "SourceControlBindings": ["544a6477-be0b-42ed-b47b-553ed8c5f22c"],
    "StackFrame2": ["fd76baf1-20df-4659-864f-e8aeb46139fb"],
    "StatusBar": ["c34301a1-3ef1-41d8-932a-fea4a8a8ce0c"],
    "TYPELIB_GEN_DTINFO": ["000204f2-0000-0000-c000-000000000046"],
    "TaskItem": ["58e4d419-6b8c-4c63-92de-70161cd95890"],
    "TaskItems": ["4b51103d-513c-4773-b56a-354d0928fd04"],
    "TaskItems2": ["b820f931-645a-473f-8246-922cf069e1fe"],
    "TaskList": ["4e4f0569-e16a-4da1-92de-10882a4ddd8c"],
    "Templates": ["30c96324-a117-4618-a9a9-0b06ec455121"],
    "TextBuffer": ["f47dc7e7-84b6-474f-bb91-631640aa0560", "f47dc7e7-84b6-474f-bb91-631640aa0560"],
    "TextDocument": ["cb218890-1382-472b-9118-782700c88115"],
    "TextEditor": ["9ff3ddca-1795-4191-a5b1-02d1ae35d074"],
    "TextEffectFormat": ["000c031f-0000-0000-c000-000000000046"],
    "TextFrame": ["000c0320-0000-0000-c000-000000000046"],
    "TextPane": ["0a3bf283-05f8-4669-9bcb-a84b6423349a"],
    "TextPane2": ["ace19c7b-a0ac-4089-94fd-749cf4380e1f"],
    "TextPanes": ["d9013d31-3652-46b2-a25a-29a881b9f86b"],
    "TextPoint": ["7f59e94e-4939-40d2-9f7f-b7651c25905d"],
    "TextRanges": ["b6422e9c-9efd-4f87-bddc-c7fd8f2fd303"],
    "TextSelection": ["1fa0e135-399a-4d2c-a4fe-d21e2480f921"],
    "TextWindow": ["2fc54dc9-922b-44eb-8cc0-ba182584dc4b"],
    "Thread2": ["86fd0779-fbbe-41cc-b444-6ee8676f4f2c"],
    "ThreeDFormat": ["000c0321-0000-0000-c000-000000000046"],
    "ToolBox": ["56fcd5af-7f17-4c5c-aa8d-ae2bb2ddbf38"],
    "ToolBoxItem": ["46538d1b-4d81-4002-8bb4-dbdb65babb23"],
    "ToolBoxItem2": ["82c9dbf2-1da8-4ed6-a5ec-8b876b46317c"],
    "ToolBoxItems": ["395c7dfb-f158-431c-8f43-dda83b4ef54e"],
    "ToolBoxTab": ["ce2def9e-3387-4bf2-967b-a1f7f70df325"],
    "ToolBoxTab2": ["a64715cb-85d7-41c3-8e71-2302d4eebc34"],
    "ToolBoxTab3": ["09d8476f-e6bf-46fb-a0a9-61c331b90f06"],
    "ToolBoxTabs": ["cf177b52-4f2f-42a0-8da3-ce78679a0d2d"],
    "ToolWindows": ["19ac6f68-3019-4d65-8d98-404dfb96b8e2"],
    "Transports": ["ea47c3d9-fd41-4402-bdc6-7f07d0c8e3fc"],
    "TunerInputType": ["266eee46-6c63-11cf-8a03-00aa006ecb65"],
    "UIHierarchy": ["72a2a2ef-c209-408c-a377-76871774adb7"],
    "UIHierarchyItem": ["fbd0d024-09cd-4d9f-9e2b-cacd628426a5"],
    "UIHierarchyItems": ["db8406b0-a916-449c-a277-bb04028f4394"],
    "UiContextSynchronousSolutionOperation": ["30315f71-bb05-436b-8cc1-6a62b368c842"],
    "UndoContext": ["d8dec44d-caf2-4b39-a539-b91ae921ba92"],
    "VBFileProperties": ["516bd64e-51c0-11d3-85cf-00c04f6123b3"],
    "VBFolderProperties": ["8e4aa768-51e1-11d3-85cf-00c04f6123b3"],
    "VBPackageSettings": ["4e42424e-d013-4716-a7d3-47141b70432c"],
    "VBPackageSettings2": ["471f93fa-0d7a-44fe-ac48-190cbb8b84c7"],
    "VBProjectConfigProperties": ["3cdaa65d-1e9d-11d3-b202-00c04f79cacb"],
    "VBProjectConfigProperties2": ["3cdaa65d-1e9d-11d4-b203-00c04f79cacb"],
    "VBProjectConfigurationProperties4": ["189a5eb4-4b8d-4083-9400-77cf9633783a"],
    "VBProjectConfigurationProperties5": ["08624013-5567-494a-afe9-a4d1499e50b9"],
    "VBProjectConfigurationProperties6": ["3519671b-b697-4721-bad5-3bc4bfc76ab4"],
    "VBProjectProperties": ["3cdaa65e-1e9d-11d3-b202-00c04f79cacb"],
    "VBProjectProperties2": ["3cdaa65e-1e9d-11d4-b212-00c04f79cacb"],
    "VBProjectProperties3": ["a93bfe7b-cfda-471d-93c6-1747d0b06e8e"],
    "VBProjectProperties4": ["c530b098-acc9-434e-9671-124eaa73fa00"],
    "VBProjectProperties6": ["7d84f860-7e2a-42c4-9a70-455b8238dd66"],
    "VBProjectProperties7": ["ecb0a5b7-1c4e-4400-a6c4-4b83614d9cc0"],
    "VJSharpProjectProperties3": ["7c9d1773-f1f3-447c-af1a-218e5e2c2f7f"],
    "VSProject": ["2cfb826f-f6bf-480d-a546-95a0381cc411"],
    "VSProject2": ["b1042570-25c6-424a-b58b-56fa83aa828a"],
    "VSProject3": ["0245db80-6f23-4b81-9517-dca8778dab77"],
    "VSProject4": ["1c91c1d8-5046-437a-a414-7d1739172f5e"],
    "VSProjectEvents": ["f8b92546-f1a2-4066-92f6-fdf2e691a50c"],
    "VSProjectEvents2": ["6dcbc5a7-37bf-461c-958f-a81da10d242e"],
    "VSProjectItem": ["89ff44c6-979d-49b6-af56-ec9509001de4"],
    "VSWebPackage": ["443e6a57-0669-42a7-9b84-51ebf6719d78"],
    "VSWebProjectItem": ["c77eb2d2-f01e-4c87-8c91-262213c40b31"],
    "VSWebProjectItem2": ["ac170ac6-d938-4796-bada-bb4dece4c2c5"],
    "VSWebSite": ["70758ca4-91f8-46ad-80a7-73bc21bae68b"],
    "VSWebSiteEvents": ["9f1b1c2c-fa11-44ab-a7da-926ff1927c70"],
    "VirtualPoint": ["42320454-626c-4dd0-9ecb-357c4f1966d8"],
    "VsProjectCapabilityExpressionMatcher": ["943a3169-d328-4e42-8af6-7200e5e8c2e4"],
    "WebComponent": ["000cd100-0000-0000-c000-000000000046"],
    "WebComponentFormat": ["000cd102-0000-0000-c000-000000000046"],
    "WebComponentProperties": ["000c0373-0000-0000-c000-000000000046"],
    "WebComponentWindowExternal": ["000cd101-0000-0000-c000-000000000046"],
    "WebFileProperties": ["51b867e4-cd7e-4ff6-93aa-ca151e36351f"],
    "WebFileProperties2": ["899456b4-e5ad-49ef-ab04-1ced913a6e44"],
    "WebFolderProperties": ["422ac997-e209-4faa-8dc6-9d2e5efa4216"],
    "WebPageFont": ["000c0913-0000-0000-c000-000000000046"],
    "WebPageFonts": ["000c0914-0000-0000-c000-000000000046"],
    "WebReference": ["dcb348c9-62ed-4332-b90f-077aac7bab14"],
    "WebReference2": ["9d6065ec-93a1-4caa-8985-9b7783330be7"],
    "WebReferences": ["c9e6c08e-1fbb-4f2c-9d26-a206bac90004"],
    "WebService": ["298682ba-70dd-40bf-95e9-4dd4293ba56d"],
    "WebServices": ["7baea84d-83b3-449d-b029-d225bd95820e"],
    "WebSettings": ["8fa8d496-caf1-40b3-bc58-5fc877fefea7"],
    "WebSiteProperties": ["477bfd8a-5fd5-434f-981b-2fd3c145b473"],
    "WebSiteProperties2": ["0f4edfb6-c797-42fb-a7e0-0c93d6f4fb6b"],
    "WebSiteProperties3": ["42b54c4b-2a9c-4ebc-a9a2-344a8f96107f"],
    "WebSiteProperties4": ["102301ab-2290-4067-b0ae-9cb1af9c14b5"],
    "WebSiteProperties5": ["856aeff3-563b-47f6-8f21-c8fa77583ebd"],
    "WindowConfiguration": ["41d02413-8a67-4c28-a980-ad7539ed415d"],
    "WindowConfigurations": ["e577442a-98e1-46c5-bd2e-d25807ec81ce"],
    "WindowVisibilityEventsRoot": ["c7b4bcc9-e23e-400c-8821-c85b6b31369e"],
    "Windows2": ["31efb5b1-c655-4ada-bb52-3ed87fb2a4ae"],
    "ADO": ["00000534-0000-0010-8000-00aa006d2ea4"],
    "ADOADOCollection": ["00000512-0000-0010-8000-00aa006d2ea4"],
    "ADOCatalog": ["00000603-0000-0010-8000-00aa006d2ea4"],
    "ADOCollection": ["00000512-0000-0010-8000-00aa006d2ea4"],
    "ADOColumn": ["0000061c-0000-0010-8000-00aa006d2ea4"],
    "ADOCommand": ["986761e8-7269-4890-aa65-ad7c03697a6d", "b08400bd-f9d1-4d02-b856-71d5dba123e9"],
    "ADOConnection": ["00000550-0000-0010-8000-00aa006d2ea4", "00001550-0000-0010-8000-00aa006d2ea4"],
    "ADODynaADOCollection": ["00000513-0000-0010-8000-00aa006d2ea4"],
    "ADODynaCollection": ["00000513-0000-0010-8000-00aa006d2ea4"],
    "ADOGroup": ["00000628-0000-0010-8000-00aa006d2ea4"],
    "ADOIndex": ["0000061f-0000-0010-8000-00aa006d2ea4"],
    "ADOKey": ["00000622-0000-0010-8000-00aa006d2ea4"],
    "ADOParameter": ["0000050c-0000-0010-8000-00aa006d2ea4", "0000150c-0000-0010-8000-00aa006d2ea4"],
    "ADORecord": ["00000562-0000-0010-8000-00aa006d2ea4", "00001562-0000-0010-8000-00aa006d2ea4"],
    "ADORecordset": ["00000556-0000-0010-8000-00aa006d2ea4", "00001556-0000-0010-8000-00aa006d2ea4"],
    "ADOStream": ["00000565-0000-0010-8000-00aa006d2ea4", "00001565-0000-0010-8000-00aa006d2ea4"],
    "ADOTable": ["00000610-0000-0010-8000-00aa006d2ea4"],
    "ADOUser": ["00000627-0000-0010-8000-00aa006d2ea4"],
    "AssemblyReferencesEvents": ["e5e56972-0cfe-49b7-9efb-923613fda978"],
    "BuildEvents": ["794a2ba5-ffa6-4fc5-bf13-957b2c22edd7"],
    "BuildManagerEvents": ["5f4aae42-bc94-401d-9213-b8a8b9e553de"],
    "CodeModelEvents": ["66adc510-0ca2-475d-a343-57192bce38bf"],
    "CodeModelEventsRoot": ["c6e28776-b7ff-421f-8c18-57f82e447704"],
    "CommandBarActiveX": ["000c030d-0000-0000-c000-000000000046"],
    "CommandBarControlEvents": ["9e66fe98-a1c6-421d-8c0c-6da4e652e770"],
    "DMSMQEventEvents": ["d7d6e078-dccd-11d0-aa4b-0060970debae"],
    "DTEEvents": ["fa1bb6d7-ca83-11d2-aab2-00c04f688dde"],
    "DebuggerEvents": ["d4eae958-0fba-11d3-b880-00c04f79e479"],
    "DebuggerEventsRoot": ["d4bb39fb-0f0e-11d3-b880-00c04f79e479"],
    "DebuggerExpressionEvaluationEvents": ["6973a466-e09c-4195-9ae8-07b7aaff7d85"],
    "DebuggerExpressionEvaluationEventsRoot": ["45ae9835-6090-4cca-97e0-5ea9a5608fbe"],
    "DebuggerProcessEvents": ["ce9ddba3-b23b-4c53-bb3e-5471659289d1"],
    "DebuggerProcessEventsRoot": ["c2eb9070-38b3-404d-bed8-2d5f5d971df5"],
    "DocumentEventsRoot": ["dc5437f4-f114-11d2-aacf-00c04f688dde"],
    "EnvironmentDocuments": ["76ed1c48-ed86-4e9e-acf8-a40e765daf25"],
    "EnvironmentFontsAndColors": ["f809cab6-2c9f-41f2-a5af-e26fb80e62ad"],
    "EnvironmentGeneral": ["48e61d9c-8c8d-42d3-914b-46d70c8b7a40"],
    "EnvironmentHelp": ["aebded64-a206-11d3-b8b5-00c04f79f802"],
    "EnvironmentKeyboard": ["9c722678-490d-408f-98ae-b6b9a68aa45d"],
    "EnvironmentProjectsAndSolution": ["478f06d4-5d57-473f-9b74-5f8e88efa5e7"],
    "EnvironmentTaskList": ["4bc18a5b-dbb6-4af5-a443-2e3f19365304"],
    "EnvironmentWebBrowser": ["a3286b03-5ac6-44f0-8cc3-ebed7f1124e5"],
    "FindEvents": ["c5331acd-c5d5-11d2-8598-006097c68e81"],
    "FontsAndColors": ["256068f6-1add-4f7b-ba76-571314c413ad"],
    "Group25": ["00000616-0000-0010-8000-00aa006d2ea4"],
    "ICivicAddressReportFactoryEvents": ["c96039ff-72ec-4617-89bd-84d88bedc722"],
    "ICounterItemUnion": ["de1a6b74-9182-4c41-8e2c-24c2cd30ee83"],
    "IDTExtensibility2": ["b65ad801-abaf-11d0-bb8b-00a0c90f2744"],
    "IInkCollectorEvents": ["11a583f2-712d-4fea-abcf-ab4af38ea06b"],
    "IInkEditEvents": ["e3b0b797-a72e-46db-a0d7-6c9eba8e9bbc"],
    "IInkEvents": ["427b1865-ca3f-479a-83a9-0f420f2a0073"],
    "IInkOverlayEvents": ["31179b69-e563-489e-b16f-712f1e8a0651"],
    "IInkPictureEvents": ["60ff4fee-22ff-4484-acc1-d308d9cd7ea3"],
    "IInkRecognitionEvents": ["17bce92f-2e21-47fd-9d33-3c6afbfd8c59"],
    "IInkStrokesEvents": ["f33053ec-5d25-430a-928f-76a6491dde15"],
    "ILatLongReportFactoryEvents": ["16ee6cb7-ab3c-424b-849f-269be551fcbc"],
    "IMSVidCtlEvents": ["b0edf164-910a-11d2-b632-00c04f79498e"],
    "IManipulationEvents": ["4f62c8da-9c53-4b22-93df-927a862bbb03"],
    "IMathInputControlEvents": ["683336b5-a47d-4358-96f9-875a472ae70a"],
    "IMsoDispObj": ["000c0300-0000-0000-c000-000000000046"],
    "IMsoOleAccDispObj": ["000c0301-0000-0000-c000-000000000046"],
    "IPenInputPanelEvents": ["b7e489da-3719-439f-848f-e7acbd820f17"],
    "IRDPSessionEvents": ["98a97042-6698-40e9-8efd-b3200990004b"],
    "ISpPrivateEngineCall": ["8e7c791e-4467-11d3-9723-00c04f72db08"],
    "ISpeechRecoContextEvents": ["7b8fcb42-0e9d-4f00-a048-7b04d6179d3d"],
    "ISpeechVoiceEvents": ["a372acd1-3bef-4bbd-8ffb-cb3e2b416af8"],
    "ISystemMonitorUnion": ["c8a77338-265f-4de5-aa25-c7da1ce5a8f4"],
    "ITSWkspEvents": ["b922bbb8-4c55-4fea-8496-beb0b44285e9"],
    "IWorkspaceBrokerAxEvents": ["7a3d0adc-0cc4-473d-b327-d37886308f28"],
    "ImportsEvents": ["037ad859-7a75-4cf3-8a38-83d6e045fee3"],
    "MiscSlnFilesEventsRoot": ["7658b944-f37b-11d2-aacf-00c04f688dde"],
    "OutputWindowEvents": ["0a3546a8-6840-11d2-97c1-00c04fb6c6ff"],
    "OutputWindowEventsRoot": ["aa6f4085-33b6-4629-b9ea-692101007cc2"],
    "ProjectItemsEvents": ["22800963-2811-410d-bf87-a7808eac977d"],
    "ProjectsEvents": ["85451f83-b5ca-437f-a619-0cb705707420"],
    "PublishEvents": ["827be7dc-1817-4171-a8ff-aab3854913bf"],
    "ReferencesEvents": ["1cf40c9e-d548-4b45-ad0f-3d7843f62bbb"],
    "SelectionEvents": ["eb6783db-1819-496d-84a4-3cff883010f6"],
    "Solution": ["26f6cc4b-7a48-4e4d-8af5-9e960232e05f"],
    "SolutionEvents": ["bf8bbf37-5415-46a9-940d-594cad9dec26"],
    "TaskListEvents": ["1125c422-49bd-11d2-8823-00c04fb6c6ff"],
    "TaskListEventsRoot": ["6bc8c372-c6f0-4be6-b255-827ac190bf71"],
    "TextDocumentKeyPressEvents": ["505b7600-8fcc-487c-9e4f-c7fd0b5fb690"],
    "TextDocumentKeyPressEventsRoot": ["d7eade3f-bd19-4422-9c4c-85a02535437c"],
    "TextEditorEvents": ["23b7a868-6c89-436a-94fa-25d755456a77"],
    "TextEditorEventsRoot": ["b3c38885-b288-44a8-b290-34fe63bf3c76"],
    "User25": ["00000619-0000-0010-8000-00aa006d2ea4"],
    "VSLangProjWebReferencesEvents": ["33bd7fef-eeb4-412a-a4c1-9fbff6f57067"],
    "WMPOCXEvents": ["6bf52a51-394a-11d3-b153-00c04f79faa6"],
    "WebReferencesEvents": ["63fe9f71-d793-435e-9f80-fd4082ca1444"],
    "WebServicesEvents": ["e7e27be0-ff6a-4d94-9b1b-d67f01d1e0fe"],
    "WebSiteMiscEvents": ["9d9d4002-3258-4ebb-bf58-af62c3890990"],
    "WindowEventsRoot": ["17d12026-ba99-403e-a359-71fd1e5a72cd"],
    "WindowVisibilityEvents": ["84de07bc-43a2-4275-bcf9-d207d20e49ed"],
    "FIAsyncActionProgressHandler_1_UINT32": ["b7f0b891-6d95-5c32-a91f-65f7a311b0e9"],
    "FIAsyncActionWithProgressCompletedHandler_1_UINT32": ["1f29e65e-49e0-577d-ac96-bcf0087e563d"],
    "FIAsyncActionWithProgress_1_UINT32": ["429f47f0-1388-5b75-b44c-44ddc4f525c0"],
    "FIAsyncOperationCompletedHandler_1_Windows__CApplicationModel__CCore__CAppRestartFailureReason": [
        "dcec478a-9f27-5c5d-afdb-c91aee4f1f02"
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CApplicationModel__CDataTransfer__CClipboardHistoryItemsResult": [
        "841da82d-a32c-5997-8450-f54af1d5477e"
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CApplicationModel__CEmail__CEmailAttachment": [
        "c7d576e2-6cfb-591f-be32-b598c51dda97"
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CApplicationModel__CInternal__CDataTransfer__CShareAppExtension": [
        "7837b98d-9c05-506b-b2d4-5eeb9c7a2d95"
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CApplicationModel__CUserActivities__CUserActivityChannel": [
        "0119a781-5e09-5791-a102-563a61b0a706"
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CFoundation__CTimeSpan": ["6937cf09-5a3a-56ed-a8eb-0ee4c0421e36"],
    "FIAsyncOperationCompletedHandler_1_Windows__CFoundation__CUri": ["ad46f1cc-2bb0-585c-9885-03c2780d4d58"],
    "FIAsyncOperationCompletedHandler_1_Windows__CInternal__CBindableObservableItem": [
        "09150ddf-2c3c-501e-ba65-b4249f2c87d7"
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CInternal__CSecurity__CSmartScreen__CUriReputationExperienceInfo": [
        "aad9a740-4131-5fe0-9888-c925750b8a99"
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CInternal__CSecurity__CWebAuthentication__CUserHostIdentity": [
        "ae363a51-a0de-5827-80f4-961b407b40c2"
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CInternal__CStorage__CRecentItemsUpdateResult": [
        "f00922e9-30b4-5533-9ca3-52c89039f0ac"
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CMedia__CPlaylists__CPlaylist": [
        "427deafd-b226-5ef0-9320-c9f325e37474"
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CSecurity__CEnterpriseData__CProtectionPolicyEvaluationResult": [
        "2833ba54-a4e1-5c2d-8a7a-136e8510c78b"
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CStorage__CFileProperties__CBasicProperties": [
        "c8659aae-4926-52ad-8f60-d89fe5a8df5f"
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CStorage__CFileProperties__CDocumentProperties": [
        "4452ed4c-642b-501b-9617-7d68b4ac3c66"
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CStorage__CFileProperties__CImageProperties": [
        "c63729bc-e4c3-564c-b137-2cb4f5966a83"
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CStorage__CFileProperties__CMusicProperties": [
        "d84e1312-d661-5b7f-9566-7421bdedc1ea"
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CStorage__CFileProperties__CStorageItemThumbnail": [
        "6d0036f2-a8a8-505d-b042-d087dc1fc1b7"
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CStorage__CFileProperties__CVideoProperties": [
        "43401d34-61ab-5cf2-921f-55b616631d1d"
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CStorage__CIStorageItem": ["92c3102f-a327-5318-a6c1-76f6b2a0abfb"],
    "FIAsyncOperationCompletedHandler_1_Windows__CStorage__CKnownFoldersAccessStatus": [
        "a2f87fc6-4ea5-58cf-9490-181604fbd6a2"
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CStorage__CProvider__CFileUpdateStatus": [
        "bb185a07-0285-5f37-9c7d-2fc6a3e0e6e5"
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CStorage__CSearch__CIndexedState": [
        "b67a3cba-f5f7-5e51-968a-385126d1f918"
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CStorage__CStorageFile": ["e521c894-2c26-5946-9e61-2b5e188d01ed"],
    "FIAsyncOperationCompletedHandler_1_Windows__CStorage__CStorageFolder": ["c211026e-9e63-5452-ba54-3a07d6a96874"],
    "FIAsyncOperationCompletedHandler_1_Windows__CStorage__CStorageLibrary": ["36d560c3-731f-5c70-b907-30bc99bc300f"],
    "FIAsyncOperationCompletedHandler_1_Windows__CStorage__CStorageStreamTransaction": [
        "d11739e6-2995-5d33-bfff-51b6041f68c1"
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CStorage__CStreams__CIInputStream": [
        "d0bd0125-9049-57a3-bd66-e2525d98c814"
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CStorage__CStreams__CIRandomAccessStreamReference": [
        "60847289-ea0b-5df6-89df-f2c62cba9693"
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CStorage__CStreams__CRandomAccessStreamReference": [
        "3d203732-ded7-5d32-87e6-c179781f791f"
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CSystem__CLaunchFileStatus": ["4b8472dd-edaa-5cda-9eee-d23495e32e9e"],
    "FIAsyncOperationCompletedHandler_1_Windows__CSystem__CUserProfile__CSetAccountPictureResult": [
        "603f3e31-7a51-518c-9280-c188ea4213d8"
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CSystem__CUserProfile__CSetImageFeedResult": [
        "f214731a-1305-5b44-932c-af9a1e4d78c9"
    ],
    "FIAsyncOperationCompletedHandler_1_Windows__CUI__CPopups__CIUICommand": ["dd33fd5b-a24d-5a44-91fe-dd6441770103"],
    "FIAsyncOperationCompletedHandler_1___FIKeyValuePair_2_SharingPlatform__CIDeviceIdentifier___FIVectorView_1_SharingPlatform__CISessionIdentifier": [
        "b259ae0d-1b0a-5572-ba2d-63a31f1756c1"
    ],
    "FIAsyncOperationCompletedHandler_1___FIMapView_2_HSTRING_Windows__CApplicationModel__CVoiceCommands__CVoiceCommandDefinition": [
        "309486d0-0a2a-57a8-aad3-327dea8a1f6c"
    ],
    "FIAsyncOperationCompletedHandler_1___FIMapView_2_HSTRING_Windows__CStorage__CStreams__CRandomAccessStreamReference": [
        "d4cb6b80-821a-5a7b-898d-d58917b31a36"
    ],
    "FIAsyncOperationCompletedHandler_1___FIMap_2_HSTRING_HSTRING": ["39bb624e-b5c6-5785-ba46-3f45aaf3ef35"],
    "FIAsyncOperationCompletedHandler_1___FIVectorView_1_Windows__CApplicationModel__CEmail__CEmailConversation": [
        "998bc7cf-7032-5ff3-808c-0a1351d4f217"
    ],
    "FIAsyncOperationCompletedHandler_1___FIVectorView_1_Windows__CInternal__CBindableObservableItem": [
        "afe289b8-4332-58c4-8c6b-afa45510595d"
    ],
    "FIAsyncOperationCompletedHandler_1___FIVectorView_1_Windows__CInternal__CIPropertyValueProvider": [
        "4e3ca6a1-701d-5154-a7b3-4fe05b26c757"
    ],
    "FIAsyncOperationCompletedHandler_1___FIVectorView_1_Windows__CInternal__CStorage__CRecentItemsUpdateResult": [
        "92de267f-abb7-585b-8426-60f944c71e1d"
    ],
    "FIAsyncOperationCompletedHandler_1___FIVectorView_1_Windows__CStorage__CBulkAccess__CFileInformation": [
        "ebdb2c85-d27a-5c93-a1b3-6ca3651ada5d"
    ],
    "FIAsyncOperationCompletedHandler_1___FIVectorView_1_Windows__CStorage__CBulkAccess__CFolderInformation": [
        "020713ec-604a-5e45-b03f-1b9e65253804"
    ],
    "FIAsyncOperationCompletedHandler_1___FIVectorView_1_Windows__CStorage__CBulkAccess__CIStorageItemInformation": [
        "ff163034-ece9-55be-a6f8-08c72aae56b4"
    ],
    "FIAsyncOperationCompletedHandler_1___FIVectorView_1_Windows__CStorage__CIStorageItem": [
        "51436e75-ace1-5a68-b260-f843b846f0db"
    ],
    "FIAsyncOperationCompletedHandler_1___FIVectorView_1_Windows__CStorage__CStorageFile": [
        "cb4206c5-0988-5104-afa9-253c298f86fd"
    ],
    "FIAsyncOperationCompletedHandler_1___FIVectorView_1_Windows__CStorage__CStorageFolder": [
        "ed2d1d9b-26ec-5be7-a8a3-56458933d25f"
    ],
    "FIAsyncOperationCompletedHandler_1___FIVectorView_1_Windows__CStorage__CStorageLibraryChange": [
        "ab9cea41-6df8-535d-8171-46aff187158f"
    ],
    "FIAsyncOperationCompletedHandler_1___FIVectorView_1_Windows__CUI__CWindowManagement__CWindowingEnvironment": [
        "a6a2c6b9-7761-509c-95ea-93415423d15f"
    ],
    "FIAsyncOperationCompletedHandler_1___FIVectorView_1___FIKeyValuePair_2_SharingPlatform__CIDeviceIdentifier___FIVectorView_1_SharingPlatform__CISessionIdentifier": [
        "674dce15-b9c9-5ec9-b058-aaba6f976c16"
    ],
    "FIAsyncOperationCompletedHandler_1___FIVector_1_UINT32": ["0c36380e-bc60-5a66-9fb4-8e774ef7a5f3"],
    "FIAsyncOperationCompletedHandler_1___FIVector_1_Windows__CApplicationModel__CAppointments__CAppointmentCalendar": [
        "c6c57d46-7878-5b40-ae31-80cfefd9d032"
    ],
    "FIAsyncOperationCompletedHandler_1___FIVector_1_Windows__CApplicationModel__CAppointments__CAppointmentException": [
        "f2ba8472-36c9-55c6-bf35-e8077ac60070"
    ],
    "FIAsyncOperationCompletedHandler_1___FIVector_1_Windows__CApplicationModel__CAppointments__CAppointmentStoreChange": [
        "ffe195f6-3244-584e-8b5a-bfed5def8d2d"
    ],
    "FIAsyncOperationCompletedHandler_1___FIVector_1_Windows__CApplicationModel__CChat__CChatMessage": [
        "078ca199-d002-56ee-8cd1-2d3722d1e70e"
    ],
    "FIAsyncOperationCompletedHandler_1___FIVector_1_Windows__CApplicationModel__CChat__CChatMessageTransport": [
        "b721d6b4-3152-5540-af0b-6045714bd551"
    ],
    "FIAsyncOperationCompletedHandler_1___FIVector_1_Windows__CApplicationModel__CInternal__CDataTransfer__CShareAppExtension": [
        "c6dc3bff-be2e-57e9-b732-2a01cade1690"
    ],
    "FIAsyncOperationProgressHandler_2_int_int": ["ce8c672e-65e7-5f2d-abf2-12e992f24de3"],
    "FIAsyncOperationWithProgressCompletedHandler_2_int_int": ["e0138214-ccde-5e2e-9b49-c9f103d167fb"],
    "FIAsyncOperationWithProgress_2_int_int": ["f53af7e6-ee94-5f7a-9792-317e7fe89a55"],
    "FIAsyncOperation_1_Windows__CApplicationModel__CCore__CAppRestartFailureReason": [
        "0938905d-54c0-572f-8451-4bfd2b52edda"
    ],
    "FIAsyncOperation_1_Windows__CApplicationModel__CDataTransfer__CClipboardHistoryItemsResult": [
        "677b06b8-0134-5692-b487-4c8e2408ca01"
    ],
    "FIAsyncOperation_1_Windows__CApplicationModel__CEmail__CEmailAttachment": ["e216fdf3-ba0c-586b-a174-2bcfc8f412a6"],
    "FIAsyncOperation_1_Windows__CApplicationModel__CInternal__CDataTransfer__CShareAppExtension": [
        "aded60c2-a38e-561f-bf1b-7ba3858cc162"
    ],
    "FIAsyncOperation_1_Windows__CApplicationModel__CUserActivities__CUserActivityChannel": [
        "c46a9f01-559c-5c7d-b8d7-3c264aa5e166"
    ],
    "FIAsyncOperation_1_Windows__CFoundation__CTimeSpan": ["154a8b46-06e5-56e2-b8d8-03b724cd9e47"],
    "FIAsyncOperation_1_Windows__CFoundation__CUri": ["641cb9dd-a28d-59e2-b8db-a227eda6cf2e"],
    "FIAsyncOperation_1_Windows__CInternal__CBindableObservableItem": ["83a2d37c-7da2-5c4e-bdec-dfb8685fa2c9"],
    "FIAsyncOperation_1_Windows__CInternal__CSecurity__CSmartScreen__CUriReputationExperienceInfo": [
        "b2b6814f-02c2-5b0c-9e14-159eb77f4462"
    ],
    "FIAsyncOperation_1_Windows__CInternal__CSecurity__CWebAuthentication__CUserHostIdentity": [
        "cd6f56ba-a90a-5556-a48f-36a097b3ce5c"
    ],
    "FIAsyncOperation_1_Windows__CInternal__CStorage__CRecentItemsUpdateResult": [
        "ff2b816d-f5a3-536c-a2ff-ff1aa93a1471"
    ],
    "FIAsyncOperation_1_Windows__CMedia__CPlaylists__CPlaylist": ["8ffb74ab-912f-5bc1-87fa-2865f673cbfc"],
    "FIAsyncOperation_1_Windows__CSecurity__CEnterpriseData__CProtectionPolicyEvaluationResult": [
        "e8d81715-c56c-5a6b-b738-5df6c2775b7b"
    ],
    "FIAsyncOperation_1_Windows__CStorage__CFileProperties__CBasicProperties": ["5186131a-4467-504b-977a-0785a8230485"],
    "FIAsyncOperation_1_Windows__CStorage__CFileProperties__CDocumentProperties": [
        "6c86e97c-5699-5700-8d35-d350ad3e4df2"
    ],
    "FIAsyncOperation_1_Windows__CStorage__CFileProperties__CImageProperties": ["fcd07511-e7f8-5bda-8c04-795a639dae8f"],
    "FIAsyncOperation_1_Windows__CStorage__CFileProperties__CMusicProperties": ["0d023b76-20a7-56f3-84ab-ce31e6544b71"],
    "FIAsyncOperation_1_Windows__CStorage__CFileProperties__CStorageItemThumbnail": [
        "11c7cc5e-c04e-50e7-a65e-6f6903690c16"
    ],
    "FIAsyncOperation_1_Windows__CStorage__CFileProperties__CVideoProperties": ["447d4590-d3f9-58bf-ac58-6f9a50839efe"],
    "FIAsyncOperation_1_Windows__CStorage__CIStorageItem": ["5fc9c137-ebb7-5e6c-9cba-686f2ec2b0bb"],
    "FIAsyncOperation_1_Windows__CStorage__CKnownFoldersAccessStatus": ["d7f094b5-0ea2-5654-85b9-38ee5de90ffa"],
    "FIAsyncOperation_1_Windows__CStorage__CProvider__CFileUpdateStatus": ["8f0f439e-87d0-531f-85b1-54f4528f29c3"],
    "FIAsyncOperation_1_Windows__CStorage__CSearch__CIndexedState": ["88694b1f-f380-574d-8a05-4f67bd52cd11"],
    "FIAsyncOperation_1_Windows__CStorage__CStorageFile": ["5e52f8ce-aced-5a42-95b4-f674dd84885e"],
    "FIAsyncOperation_1_Windows__CStorage__CStorageFolder": ["6be9e7d7-e83a-5cbc-802c-1768960b52c3"],
    "FIAsyncOperation_1_Windows__CStorage__CStorageLibrary": ["2f160a19-99c1-52b9-8dca-14e4ab79f287"],
    "FIAsyncOperation_1_Windows__CStorage__CStorageStreamTransaction": ["0d81405a-9bd3-5e87-82f4-9b4128a887eb"],
    "FIAsyncOperation_1_Windows__CStorage__CStreams__CIInputStream": ["a8fe0732-556d-5841-b7ee-b3450fb52666"],
    "FIAsyncOperation_1_Windows__CStorage__CStreams__CIRandomAccessStreamReference": [
        "65178d50-e6a2-5d16-b244-65e9725e5a0c"
    ],
    "FIAsyncOperation_1_Windows__CStorage__CStreams__CRandomAccessStreamReference": [
        "d90442ca-543c-504b-9eb9-294bcad8a283"
    ],
    "FIAsyncOperation_1_Windows__CSystem__CLaunchFileStatus": ["e602e409-6ae3-5f2e-9e3f-a8540d02b2ba"],
    "FIAsyncOperation_1_Windows__CSystem__CUserProfile__CSetAccountPictureResult": [
        "6809e406-6d3b-5164-8f32-b845b0781405"
    ],
    "FIAsyncOperation_1_Windows__CSystem__CUserProfile__CSetImageFeedResult": ["5361bfc9-0740-544a-9797-1ffe5e73c54e"],
    "FIAsyncOperation_1_Windows__CUI__CPopups__CIUICommand": ["b8770535-6a4b-52b1-b578-f3cdc5007a1f"],
    "FIAsyncOperation_1___FIKeyValuePair_2_SharingPlatform__CIDeviceIdentifier___FIVectorView_1_SharingPlatform__CISessionIdentifier": [
        "53d75e21-2c99-57c1-aa81-585595e72dc1"
    ],
    "FIAsyncOperation_1___FIMapView_2_HSTRING_Windows__CApplicationModel__CVoiceCommands__CVoiceCommandDefinition": [
        "ddaf40b6-f12e-5fd9-8f40-d5631347a29f"
    ],
    "FIAsyncOperation_1___FIMapView_2_HSTRING_Windows__CStorage__CStreams__CRandomAccessStreamReference": [
        "fc012d44-2dcf-5162-be9a-7668675aa590"
    ],
    "FIAsyncOperation_1___FIMap_2_HSTRING_HSTRING": ["84e30b9c-351d-5fcb-8b0a-bc145407f915"],
    "FIAsyncOperation_1___FIVectorView_1_Windows__CApplicationModel__CEmail__CEmailConversation": [
        "d1cae34e-e480-5fc0-9bd6-fd74fd5fd109"
    ],
    "FIAsyncOperation_1___FIVectorView_1_Windows__CInternal__CBindableObservableItem": [
        "cdd2619f-48a9-5ce3-8b30-8168975133e9"
    ],
    "FIAsyncOperation_1___FIVectorView_1_Windows__CInternal__CIPropertyValueProvider": [
        "85a4dfda-8289-53d8-8a90-7477bf93503a"
    ],
    "FIAsyncOperation_1___FIVectorView_1_Windows__CInternal__CStorage__CRecentItemsUpdateResult": [
        "31e9ea80-e6c3-5543-a803-4753549f7a26"
    ],
    "FIAsyncOperation_1___FIVectorView_1_Windows__CStorage__CBulkAccess__CFileInformation": [
        "222f6bb6-e71e-55cb-885d-e051e35995dc"
    ],
    "FIAsyncOperation_1___FIVectorView_1_Windows__CStorage__CBulkAccess__CFolderInformation": [
        "7f10e569-2bf7-5752-8f75-602809a7d304"
    ],
    "FIAsyncOperation_1___FIVectorView_1_Windows__CStorage__CBulkAccess__CIStorageItemInformation": [
        "413d160c-3e1a-5603-acba-1e176d6a6082"
    ],
    "FIAsyncOperation_1___FIVectorView_1_Windows__CStorage__CIStorageItem": ["4b1c0fd7-7a01-5e7a-a6fe-be4500283f23"],
    "FIAsyncOperation_1___FIVectorView_1_Windows__CStorage__CStorageFile": ["03362e33-e413-5f29-97d0-48a4780935f9"],
    "FIAsyncOperation_1___FIVectorView_1_Windows__CStorage__CStorageFolder": ["ca40b21b-aeb1-5a61-9e08-3bd5d9594023"],
    "FIAsyncOperation_1___FIVectorView_1_Windows__CStorage__CStorageLibraryChange": [
        "66e11b8a-9003-52c9-84a8-ae5ccebe8cf9"
    ],
    "FIAsyncOperation_1___FIVectorView_1_Windows__CUI__CWindowManagement__CWindowingEnvironment": [
        "08fb2096-672f-544f-a689-0ec676f31f94"
    ],
    "FIAsyncOperation_1___FIVectorView_1___FIKeyValuePair_2_SharingPlatform__CIDeviceIdentifier___FIVectorView_1_SharingPlatform__CISessionIdentifier": [
        "5be2d67a-47f6-5310-89df-080e452dd965"
    ],
    "FIAsyncOperation_1___FIVector_1_UINT32": ["c54a35be-faee-592d-870d-9386431cf8cf"],
    "FIAsyncOperation_1___FIVector_1_Windows__CApplicationModel__CAppointments__CAppointmentCalendar": [
        "332fd03c-9c50-5816-b6ed-3ca697dfd613"
    ],
    "FIAsyncOperation_1___FIVector_1_Windows__CApplicationModel__CAppointments__CAppointmentException": [
        "dcdfc297-1ceb-5ce9-b8c7-9ebc367b52f9"
    ],
    "FIAsyncOperation_1___FIVector_1_Windows__CApplicationModel__CAppointments__CAppointmentStoreChange": [
        "0ffbd39b-89fa-5a4f-98e4-a3d1efc5518b"
    ],
    "FIAsyncOperation_1___FIVector_1_Windows__CApplicationModel__CChat__CChatMessage": [
        "e5a048ef-0336-53a7-9dcf-8b89d48924af"
    ],
    "FIAsyncOperation_1___FIVector_1_Windows__CApplicationModel__CChat__CChatMessageTransport": [
        "7d1cdb62-ef72-50b2-b805-fcdc25f2a6ad"
    ],
    "FIAsyncOperation_1___FIVector_1_Windows__CApplicationModel__CInternal__CDataTransfer__CShareAppExtension": [
        "20b684df-2da1-5284-b9f2-6a417fbadb60"
    ],
    "FIEventHandler_1_Windows__CApplicationModel__CActivation__CBackgroundActivatedEventArgs": [
        "49a07732-e7b8-5c5b-9de7-22e33cb97004"
    ],
    "FIEventHandler_1_Windows__CApplicationModel__CActivation__CCommandLineActivationCompletedEventArgs": [
        "67a11498-0807-59f0-af29-73b8eaa6b45e"
    ],
    "FIEventHandler_1_Windows__CApplicationModel__CContracts__CInternal__CApplicationContractStreamCreatedEventArgs": [
        "c093a9c2-5399-5d76-9085-a815268ffebd"
    ],
    "FIEventHandler_1_Windows__CApplicationModel__CContracts__CInternal__CApplicationContractStreamRequestedEventArgs": [
        "de937a2d-a3a1-5a5b-b09f-09f30114862b"
    ],
    "FIEventHandler_1_Windows__CApplicationModel__CContracts__CInternal__CBackgroundContractCompletedEventArgs": [
        "84fc7937-abc2-58b4-9818-88dfbc7b396b"
    ],
    "FIEventHandler_1_Windows__CApplicationModel__CContracts__CInternal__CBackgroundContractResultsAvailableEventArgs": [
        "9799b47c-bab9-5ae6-9ad7-7bbe1bd923aa"
    ],
    "FIEventHandler_1_Windows__CApplicationModel__CContracts__CInternal__CCdpBinaryClientDataReceivedEventArgs": [
        "78d45870-cf3b-567e-a994-7aa5bdf8513f"
    ],
    "FIEventHandler_1_Windows__CApplicationModel__CContracts__CInternal__CCdpBinaryHostDataReceivedEventArgs": [
        "70cd66a6-aadd-5a46-9ff9-c0af03a84fc9"
    ],
    "FIEventHandler_1_Windows__CApplicationModel__CCore__CUnhandledErrorDetectedEventArgs": [
        "f68bc421-6b54-559b-9cdd-489aad0bd41d"
    ],
    "FIEventHandler_1_Windows__CApplicationModel__CDataTransfer__CClipboardHistoryChangedEventArgs": [
        "df4aac23-4002-5d4c-a237-2526e344978d"
    ],
    "FIEventHandler_1_Windows__CApplicationModel__CEnteredBackgroundEventArgs": [
        "e0739c32-fc14-5361-a8b3-0809699fbcbd"
    ],
    "FIEventHandler_1_Windows__CApplicationModel__CLeavingBackgroundEventArgs": [
        "9b6171c2-abb2-5194-afc0-cef167c424eb"
    ],
    "FIEventHandler_1_Windows__CApplicationModel__CSuspendingEventArgs": ["338579bf-1a35-5cc4-a622-a6f384fd892c"],
    "FIEventHandler_1_Windows__CSystem__CInternal__CRemoteSystems__CRemoteSystemBinaryChannelDataReceivedEventArgs": [
        "1c8d5425-fafe-55e8-ba3d-f5caabd7e8f6"
    ],
    "FIEventHandler_1_Windows__CSystem__CInternal__CRemoteSystems__CRemoteSystemBinaryChannelStartFailedEventArgs": [
        "bca98197-ab2a-5a88-907b-a56c957b1b41"
    ],
    "FIEventHandler_1_Windows__CSystem__CInternal__CSignInCompleteEventArgs": ["d00c8d81-0c6e-5769-99f5-bb497757a174"],
    "FIEventHandler_1_Windows__CSystem__CInternal__CSignOutCompleteEventArgs": ["3e0dc3d5-ff88-5099-9b2f-338d7901882a"],
    "FIEventHandler_1_Windows__CSystem__CInternal__CUserCreatedEventArgs": ["2e9fc58c-95f5-5f9f-82d0-ee0fe908197a"],
    "FIEventHandler_1_Windows__CSystem__CInternal__CUserDeletedEventArgs": ["78aafd27-939f-5205-a6a6-c2643a05d1a1"],
    "FIEventHandler_1_Windows__CUI__CWindowManagement__CWindowingEnvironmentAddedEventArgs": [
        "629f60d4-a159-5b86-92f5-25785020ab07"
    ],
    "FIEventHandler_1_Windows__CUI__CWindowManagement__CWindowingEnvironmentRemovedEventArgs": [
        "2021b8a9-ec5c-5e7c-af4d-d28eb1807d68"
    ],
    "FIEventHandler_1_boolean": ["6ea71ff9-100d-54c3-bb4a-6922523cf9a9"],
    "FIIterable_1_ContentManagement__CAppInstallInfoRecord": ["3125e57c-be43-5e92-b20e-9f496eb9a270"],
    "FIIterable_1_ContentManagement__CTargetedContent__CTargetedContentItem": ["4fad6398-e6e3-52f5-b643-d638f95bd248"],
    "FIIterable_1_PhoneInternal__CExperiences__CSync__CAccount": ["bee1defe-2016-5a2f-aa3e-fbd0bd6bb42e"],
    "FIIterable_1_PhoneInternal__CExperiences__CSync__CAccountSyncContentType": [
        "10caf5cc-8cc8-56ed-9ef5-554f25997a41"
    ],
    "FIIterable_1_PhoneInternal__CExperiences__CSync__CPartnershipType": ["bd889ecc-2677-5097-b218-f72d022882f4"],
    "FIIterable_1_SharingPlatform__CIDeviceIdentifier": ["5332fa6b-2433-5d32-a44f-908e09f3d83a"],
    "FIIterable_1_SharingPlatform__CIParticipantIdentifier": ["1e1d9537-f233-55eb-93c3-9a14aa207113"],
    "FIIterable_1_SharingPlatform__CISessionIdentifier": ["a9bdcb81-19d5-56a4-bb29-467a16962a62"],
    "FIIterable_1_UINT64": ["4b3a3229-7995-5f3c-b248-6c1f7e664f01"],
    "FIIterable_1_Windows__CApplicationModel__CAppointments__CAppointmentStore": [
        "eadc29e5-d3d3-5e36-9860-4f9f02032b15"
    ],
    "FIIterable_1_Windows__CApplicationModel__CBackground__CIBackgroundTaskYieldable": [
        "22cfe4a5-c293-5a87-8c62-755f59ecdbda"
    ],
    "FIIterable_1_Windows__CApplicationModel__CBackground__CIBrokerConditionBuilder": [
        "2169027b-c03e-5289-9260-8545edbe8ab2"
    ],
    "FIIterable_1_Windows__CApplicationModel__CContacts__CInternal__CIContactActionControl": [
        "29cd4061-8075-560b-bdcb-aa095571def0"
    ],
    "FIIterable_1_Windows__CApplicationModel__CContacts__CInternal__CIContactActionControlItem": [
        "ef4b8064-125b-5802-a58b-a6ddcbdaf903"
    ],
    "FIIterable_1_Windows__CApplicationModel__CContacts__CInternal__CIContactDisplayInformation": [
        "c327f511-ef2f-5f5b-8d7d-309b27fe0c98"
    ],
    "FIIterable_1_Windows__CApplicationModel__CCore__CCoreApplicationView": ["32bc12d1-2653-5a41-a55e-88a12af2026a"],
    "FIIterable_1_Windows__CApplicationModel__CDataTransfer__CClipboardHistoryItem": [
        "5c3705f4-8e46-5ae5-97bf-88220cccffd9"
    ],
    "FIIterable_1_Windows__CApplicationModel__CDataTransfer__CShareProvider": ["0903b218-5cad-53e6-9a21-6f4b31c4a409"],
    "FIIterable_1_Windows__CApplicationModel__CInternal__CDataTransfer__CShareAppExtension": [
        "b3812296-e254-5250-9d5c-72769c3b6473"
    ],
    "FIIterable_1_Windows__CApplicationModel__CInternal__CStartupTaskInternal": [
        "79a181b1-771c-56de-bc43-596b9f845ae0"
    ],
    "FIIterable_1_Windows__CApplicationModel__CSearch__CCore__CSearchSuggestion": [
        "df956160-f155-5816-b38b-a2ff0629ba0e"
    ],
    "FIIterable_1_Windows__CDevices__CInput__CPointerDevice": ["ad26662c-845b-5c6d-aeaa-406f48c21ae9"],
    "FIIterable_1_Windows__CDevices__CInput__CPointerDeviceUsage": ["592d6618-eaab-5a79-a47a-c7fc0b749a4e"],
    "FIIterable_1_Windows__CInternal__CApplicationModel__CWindowManagement__CAppView": [
        "0cb2f4d8-2c6a-5b98-9993-4f4df196e726"
    ],
    "FIIterable_1_Windows__CInternal__CApplicationModel__CWindowManagement__CAppViewId": [
        "85e6248b-0c40-5d7d-941b-c4d67a4a8e4c"
    ],
    "FIIterable_1_Windows__CInternal__CApplicationModel__CWindowManagement__CWindow": [
        "4de2711b-d34f-5384-a86b-4721d3797c42"
    ],
    "FIIterable_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIBackupFrequency": [
        "5285864b-6f14-573a-9c80-ac795a2dda41"
    ],
    "FIIterable_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIBackupRelatedActionItem": [
        "3ce8fee2-08fb-5a41-8cf2-f88a5a659b1a"
    ],
    "FIIterable_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIBackupSettingsProvider": [
        "8f2e9986-5050-5c56-b89b-cebe1129406d"
    ],
    "FIIterable_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIBackupTargetItem": [
        "ae5e92e3-6244-5990-8a0f-42a4f9e37775"
    ],
    "FIIterable_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIEnumBackupsProvider": [
        "21eed57c-4315-57d0-8d5e-c340e42c69f1"
    ],
    "FIIterable_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIFolderBackupScopeItem": [
        "0a39515d-da42-5a58-97a0-879a847fc1d0"
    ],
    "FIIterable_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIManualCleanupOption": [
        "cd66fe76-aef7-5a3d-a299-80f7ff6ed584"
    ],
    "FIIterable_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIRetentionListItem": [
        "0c5c68ee-4b44-502b-8b86-57559adb9bd2"
    ],
    "FIIterable_1_Windows__CInternal__CBindableObservableItem": ["1c1ae678-79cc-5ed1-9788-f74b0a091c31"],
    "FIIterable_1_Windows__CInternal__CFeedback__CFeedbackItem": ["eb604eca-b1b5-50ae-9ef7-192df74a9618"],
    "FIIterable_1_Windows__CInternal__CIPropertyValueProvider": ["384b0c5a-4f0b-5998-9c1d-17e15c97036f"],
    "FIIterable_1_Windows__CInternal__CSecurity__CAuthentication__CWeb__CWamProviderRegistrationInformation": [
        "37dc6a44-0dfb-59f1-8443-f5abbe570e26"
    ],
    "FIIterable_1_Windows__CInternal__CSecurity__CSmartScreen__CButtonInfo": ["69c26f3c-53aa-56cc-818f-4be79004cd02"],
    "FIIterable_1_Windows__CInternal__CSettingSync__CICollectionBackup": ["b4caf315-c6b6-5984-be3c-e5030bb48ecd"],
    "FIIterable_1_Windows__CInternal__CShell__CJumpView__CContextMenuItemWrapper": [
        "ed14d371-c667-570f-b8e7-48c335eb8d8c"
    ],
    "FIIterable_1_Windows__CInternal__CShell__CJumpView__CJumpViewCategoryInfo": [
        "9c66d8f2-6dc1-5750-b092-844a166d0292"
    ],
    "FIIterable_1_Windows__CInternal__CShell__CJumpView__CJumpViewItemInfo": ["dac3c587-ae16-522a-af95-581a76a4d1d2"],
    "FIIterable_1_Windows__CInternal__CShell__CSharePicker__CIShareTarget": ["de6b928b-900c-56e0-b7df-fb94b18bde87"],
    "FIIterable_1_Windows__CInternal__CShell__CStartUI__CUserTileCommand": ["713fc1c3-2b0d-5821-b332-c0652991cd97"],
    "FIIterable_1_Windows__CInternal__CShell__CStartUI__CUserTileSwitchUser": ["b6355018-ed7e-544d-821f-eaed4c549ce7"],
    "FIIterable_1_Windows__CInternal__CShell__CTaskFlow__CDataEngine__CAppActivitySessionData": [
        "c7276de3-9e38-561b-b50a-7fe282fc2e46"
    ],
    "FIIterable_1_Windows__CInternal__CShell__CViewManagerInterop__CIViewWrapper": [
        "e3344d21-1d99-5eec-a98b-3ce7f54767bf"
    ],
    "FIIterable_1_Windows__CInternal__CStateRepository__CAppExecutionAlias": ["a0c06b01-0827-552a-ae77-ee64463aafca"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CAppExtension": ["180750b3-2eed-50d5-b3e1-5e3d613b69a4"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CAppExtensionHost": ["b63839ca-2ec3-57de-a98d-d40046f55fe4"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CAppService": ["f2239de4-75de-5d69-b523-07177727e395"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CAppUriHandler": ["839e892f-e6d2-532b-baf1-aaa2ddd84bd7"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CApplication": ["d0107609-38d7-593e-989e-0d270786cb22"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CApplicationBackgroundTask": [
        "68569c75-a713-50e7-87a9-4440dd2b0fd0"
    ],
    "FIIterable_1_Windows__CInternal__CStateRepository__CApplicationContentUriRule": [
        "8c585b49-ca9c-5ad7-a96c-7becde7a2e13"
    ],
    "FIIterable_1_Windows__CInternal__CStateRepository__CApplicationExtension": [
        "902da083-8c1c-5559-9a76-4a842071144f"
    ],
    "FIIterable_1_Windows__CInternal__CStateRepository__CApplicationLicense": ["5b0c7045-19bf-5af8-92e4-922d6fb97b6b"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CApplicationPolicy": ["103a7e91-b168-556b-8659-98d82f5bfce5"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CApplicationProperty": ["d4cfa90b-bb5f-55f8-a539-0be9768ce3e0"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CAppxExtension": ["a5a9fda8-0a10-51f6-ad3e-5f4d7f507a4a"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CAppxManifest": ["6bd3e781-2c4b-59b0-bb61-cec8d0002b31"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CBackgroundServiceAgent": [
        "07814813-9fc8-5782-9077-f1ad03a81529"
    ],
    "FIIterable_1_Windows__CInternal__CStateRepository__CBnsNotification": ["8f24ccd2-9707-5252-925c-e4737903765d"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CBundle": ["4adac360-6479-568d-9cdf-10285d6d4792"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CBundlePackage": ["f7fcdc5d-dceb-5334-9dfe-e4ff163cba69"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CBundleResource": ["66c77256-a2bd-5b19-864a-8ab9f274ce05"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CContentGroup": ["b3d0b59a-0345-5fbd-a5d5-a4313d9baa13"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CContentGroupFile": ["984dbada-a488-581e-a820-7a3a8a760a54"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CDefaultTile": ["d9a448bb-91a0-5c4c-b1a6-048f493ff26b"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CDependency": ["4c947b4b-cc4f-5987-810d-76442e288b8a"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CDependencyGraph": ["3e24d21f-87d0-5356-85f0-14631e5f1d0f"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CDeploymentHistory": ["646cee97-26d8-5597-9286-fda4bce5bd4e"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CDeploymentRequest": ["d0b0f67c-2273-5096-81d5-7c9a9e55c8e5"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CDeploymentRequestDependency": [
        "5bfb7958-c12b-5953-86df-c35bb1aa4ae6"
    ],
    "FIIterable_1_Windows__CInternal__CStateRepository__CEnterprise": ["d3c5473e-a177-55df-83ae-964c7f79d3e4"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CFile": ["a8703a2e-989f-5134-8d1f-e5c44f265d00"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CFileTypeAssociation": ["eecbe8a8-4e02-5054-be0d-6dfd5db89a8c"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CMigratorPatch": ["d9ba3fef-e73c-5069-8bf4-6c20892bfb13"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CMrtApplication": ["a9bbad79-fc21-5a1f-81f8-401f6f624c59"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CMrtDefaultTile": ["f4a0e48a-6f06-55b7-8a2a-ee1f1d660cbd"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CMrtPackage": ["27f3aecf-a1ef-5130-ad72-1f121c1398bc"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CMrtSharedPri": ["6e441692-9e50-5556-9ac2-61c8a7b2f8fa"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CMrtUserPri": ["e435df0b-f2c2-5fc7-b991-45d2c2b91a01"],
    "FIIterable_1_Windows__CInternal__CStateRepository__COptionalBundle": ["16a22ca6-7d7b-5421-a791-950e0a6d96df"],
    "FIIterable_1_Windows__CInternal__CStateRepository__COptionalBundlePackage": [
        "ba5c2773-a020-5359-aee2-5b4498a35fc3"
    ],
    "FIIterable_1_Windows__CInternal__CStateRepository__COptionalBundleResource": [
        "5ac40afd-99f8-5bf5-bbc5-273ff167b67a"
    ],
    "FIIterable_1_Windows__CInternal__CStateRepository__CPackage": ["c8854c02-37a4-570f-8500-efb02303e3ae"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CPackageExtension": ["7f64e071-20c5-52d3-ac29-8afb38a80988"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CPackageFamily": ["33e5fea6-250e-5b1d-b3a3-410d94b3a743"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CPackageFamilyPolicy": ["26a0ca21-7625-52f9-88e4-6f22468715c2"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CPackageFamilyUser": ["39831f67-c1ec-5817-95a8-64cd49b9ead4"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CPackageIdentity": ["26ef5858-e9f1-5bc7-ad54-b1345efe3ae1"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CPackageLocation": ["e7d25b7d-0505-5638-a845-5f9ae08e5795"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CPackageMachineStatus": [
        "d2caa613-2191-5612-bb06-afddd2a128a5"
    ],
    "FIIterable_1_Windows__CInternal__CStateRepository__CPackagePolicy": ["63ec069f-cfd0-5faa-91ac-a12dc51ea2a7"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CPackageProperty": ["b3eb17fe-34a5-5bde-be4b-18d3ad226dc7"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CPackageSourceUri": ["eca5938b-fc43-5152-87a1-05480b044d8c"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CPackageUser": ["26c74f9b-2447-5fc8-97b5-ed7d489ab499"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CPackageUserStatus": ["59a77fc6-c744-59bb-9f00-cf13889f862c"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CPrimaryTile": ["76ba1ac1-171e-5c9b-a77f-0895f3356d8d"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CPrimaryTileUser": ["23d7823f-fa59-5c4f-bf0b-fa10c6a96a44"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CPrimaryTileUserChangelog": [
        "a5eb4f75-6a36-5bca-82cf-c3472e4e514c"
    ],
    "FIIterable_1_Windows__CInternal__CStateRepository__CPrimaryTileUserDataChange": [
        "da069297-d440-588a-8550-8302e7e879b8"
    ],
    "FIIterable_1_Windows__CInternal__CStateRepository__CPrimaryTileView": ["d9209b18-1ca3-57d0-acd6-dea0353f218a"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CProtocol": ["fbcc47f2-4d57-5bdf-a7ba-2a7e2e10859d"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CPublisherCacheFolder": [
        "e9636702-4789-55a2-8f7b-e4835d352615"
    ],
    "FIIterable_1_Windows__CInternal__CStateRepository__CResource": ["aac24c35-7c9c-5747-a33d-70bd1de5191b"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CSecondaryTile": ["905c7d44-b6ec-5c2c-9faf-c08d02ef793f"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CSecondaryTileUser": ["f6d5beab-0e23-5900-a61b-425dc2202ef4"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CSecondaryTileUserChangelog": [
        "9c55f672-56d2-5fdc-ae2a-5d367d6090ca"
    ],
    "FIIterable_1_Windows__CInternal__CStateRepository__CSecondaryTileUserDataChange": [
        "d54e91cc-2033-5964-b69d-bd0f2459c396"
    ],
    "FIIterable_1_Windows__CInternal__CStateRepository__CSecondaryTileView": ["c8d25b4f-6a45-5eb2-a5da-113fab6d2cc9"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CSequence": ["63c71431-4b66-5a23-8e6d-8e8868315e47"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CTargetDeviceFamily": ["b0d8bda8-99f5-533b-9f80-08ab330c7f16"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CTask": ["ac32e21a-4df1-505d-9f98-41cbe5dfeae2"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CTileView": ["53afb3c8-d1c7-51a2-9f66-b13f31c5a359"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CTileViewQueryFilter": ["f9468821-8325-5d30-a568-0ae3b79b5b36"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CUser": ["449500fe-b209-59b5-a010-ecf0bb28a879"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CVolume": ["445fb49c-d4ec-571d-8891-abf6c5596900"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CWowDependencyGraph": ["4709f748-96ac-5383-9924-e40e66a6e554"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CXap": ["23268074-d50b-58d4-8a23-5e203e355728"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CXapExtension": ["21ca063e-25cb-5d8a-8a15-25c21b178fee"],
    "FIIterable_1_Windows__CInternal__CStateRepository__CXboxPackage": ["88b676e9-30ed-55a7-a2cd-e1fb7146bd3c"],
    "FIIterable_1_Windows__CInternal__CStorage__CFileOperation": ["0f4123d4-515a-5e8b-b8be-fc803ca26c80"],
    "FIIterable_1_Windows__CInternal__CStorage__CIFileOperationItemErrorInfo": ["842e53c5-0a75-5877-a4af-572c7e1f183b"],
    "FIIterable_1_Windows__CInternal__CStorage__CIStorageItemCommand": ["6d1af52d-2a28-513c-be23-a1086fc47e1f"],
    "FIIterable_1_Windows__CInternal__CStorage__CRecentItemsUpdateResult": ["8f158fe5-84e1-584f-b952-b68659168afc"],
    "FIIterable_1_Windows__CInternal__CUI__CShutdown__CShutdownUXOption": ["90c2d884-25f2-5f86-aa5b-6f7315917c61"],
    "FIIterable_1_Windows__CManagement__CDeployment__CInternal__CDiskUsageInformation": [
        "597d8e9d-47d6-5cb3-9620-acc5ff7e7e18"
    ],
    "FIIterable_1_Windows__CMedia__CSpeechRecognition__CInternal__CSpeechRecognitionCorrectionGraphArc": [
        "eac144a9-e4d7-5837-b5b2-985e90d87baf"
    ],
    "FIIterable_1_Windows__CMedia__CSpeechRecognition__CInternal__CSpeechRecognitionCorrectionGraphNode": [
        "8f7fdf50-8fc2-5795-b85b-668e419f4301"
    ],
    "FIIterable_1_Windows__CMedia__CSpeech__CSpeechSupportedLanguage": ["2826cbb3-f13c-5393-befa-6c17c14abff9"],
    "FIIterable_1_Windows__CNetworking__CConnectivity__CDataUsage": ["7e37a2ba-2983-50e6-9c79-18944dc36fd9"],
    "FIIterable_1_Windows__CNetworking__CUX__CIAvailableNetwork": ["fcbb8770-8eb0-5f9c-97e2-6989656ef9bd"],
    "FIIterable_1_Windows__CNetworking__CUX__CIAvailableNetworkOffer": ["111cdd58-d8e7-5995-a984-85a8e5dd9f3e"],
    "FIIterable_1_Windows__CNetworking__CUX__CIAvailableNetworkProvider": ["4f59e401-2d60-509b-91a9-b74153349d35"],
    "FIIterable_1_Windows__CNetworking__CUX__CICertItemInfo": ["639b7404-7b4c-5ee2-b872-c7f98ba8bc0a"],
    "FIIterable_1_Windows__CNetworking__CUX__CIHotspot2RegisterProvider": ["fc6b0467-4270-56a8-80a8-00956597b938"],
    "FIIterable_1_Windows__CNetworking__CUX__CISimItemInfo": ["be350e5a-2f7b-5944-90fa-9606b75a281c"],
    "FIIterable_1_Windows__CNetworking__CUX__CIUXCategory": ["9405cadf-64e0-55bc-8e19-07a783f3000d"],
    "FIIterable_1_Windows__CNetworking__CUX__CIVPNCustomInputItem": ["b99e1a34-783e-507a-923f-64d022c9c9b0"],
    "FIIterable_1_Windows__CNetworking__CUX__CIWiFiEapMethod": ["34f71bb5-cd98-5748-82ca-5298af095d99"],
    "FIIterable_1_Windows__CNetworking__CUX__CIWiFiProfile": ["14701cc0-b2ac-5a27-9b2e-c89b4413f743"],
    "FIIterable_1_Windows__CNetworking__CUX__CIWiFiSenseSocialNetwork": ["0a67427f-833a-5913-af45-6990bad307a5"],
    "FIIterable_1_Windows__CNetworking__CUX__CNetworkMediaType": ["cbc84f97-31e2-52f7-bdac-e9c22b4968e4"],
    "FIIterable_1_Windows__CSecurity__CCredentials__CWebAccountProvider": ["7413656a-4784-5ede-bcd0-ea5ec4dd1a7b"],
    "FIIterable_1_Windows__CServices__CTargetedContent__CInternal__CTargetedContentTriggerInternal": [
        "fa4f30bc-096b-5280-b633-948d8ebba990"
    ],
    "FIIterable_1_Windows__CStorage__CAccessCache__CAccessListEntry": ["4995c2b0-736b-588d-ae42-6f69b025b388"],
    "FIIterable_1_Windows__CStorage__CBulkAccess__CFileInformation": ["dd96d7e9-892b-5932-b677-5bc32588008f"],
    "FIIterable_1_Windows__CStorage__CBulkAccess__CFolderInformation": ["5c720bf5-7636-51fd-9ef7-d5f57f071a9b"],
    "FIIterable_1_Windows__CStorage__CBulkAccess__CIStorageItemInformation": ["43bc252e-a3d6-5f00-a12c-b088d3b912d4"],
    "FIIterable_1_Windows__CStorage__CIStorageFile": ["76d43c7e-fd09-5908-a2b9-a49b4848294b"],
    "FIIterable_1_Windows__CStorage__CIStorageFolder": ["d09b688f-402a-5b3f-b552-1ffa23116952"],
    "FIIterable_1_Windows__CStorage__CIStorageItem": ["bb8b8418-65d1-544b-b083-6d172f568c73"],
    "FIIterable_1_Windows__CStorage__CPickers__CIPickerFileType": ["58d1dedc-7fc2-5e64-a5b9-0fa43f4f3023"],
    "FIIterable_1_Windows__CStorage__CPickers__CUpdateFilesResult": ["d7f5e177-842c-5f49-b5c4-42f64f0936c8"],
    "FIIterable_1_Windows__CStorage__CSearch__CSortEntry": ["35aff6f9-ef75-5280-bb84-a2bf8317cf35"],
    "FIIterable_1_Windows__CStorage__CStorageFile": ["9ac00304-83ea-5688-87b6-ae38aab65d0b"],
    "FIIterable_1_Windows__CStorage__CStorageFolder": ["4669befc-ae5c-52b1-8a97-5466ce61e94e"],
    "FIIterable_1_Windows__CStorage__CStorageLibrary": ["851e3cfd-306b-5c8e-ae3c-a8d83c623604"],
    "FIIterable_1_Windows__CStorage__CStorageLibraryChange": ["87c15dfc-0c5e-518b-9206-97d3d9823c61"],
    "FIIterable_1_Windows__CStorage__CStreams__CIRandomAccessStream": ["ba666a00-1555-5df4-81a5-07d23f7ffceb"],
    "FIIterable_1_Windows__CStorage__CStreams__CIRandomAccessStreamReference": ["ae075afa-2f06-5011-9fe1-1af33410e707"],
    "FIIterable_1_Windows__CSystem__CInternal__CIUserProfile": ["850846ff-500a-51c7-96d4-e4180d4cf0ae"],
    "FIIterable_1_Windows__CSystem__CInternal__CLaunch__CAppServiceExtensionInfo": [
        "73846a01-cd74-5600-8649-fe43c7e64d0a"
    ],
    "FIIterable_1_Windows__CSystem__CInternal__CLaunch__CExtensionInfo": ["46fe7bc0-d826-574d-985e-9a777db6beca"],
    "FIIterable_1_Windows__CSystem__CRemoteSystems__CRemoteSystem": ["ef4c3ed5-43a3-5e4f-bf01-7fe0ca4b4e4e"],
    "FIIterable_1_Windows__CUI__CCore__CAnimationMetrics__CIPropertyAnimation": [
        "c75f1bd1-a3c1-5881-9da0-1ecdb8e51bc3"
    ],
    "FIIterable_1_Windows__CUI__CInput__CPointerPoint": ["f6f2cba6-7076-5b59-9631-f6ac32b57695"],
    "FIIterable_1_Windows__CUI__CNotifications__CShownTileNotification": ["1863baee-44f1-5e51-bcdf-a3cdab826a15"],
    "FIIterable_1_Windows__CUI__CPopups__CIUICommand": ["e63de42b-53c3-5e07-90d3-98172d545412"],
    "FIIterable_1_Windows__CUI__CSearch__CInternal__CCommon__CLocalGroupScore": [
        "09d7e883-eb64-5a37-949e-3c0fa8abdc7e"
    ],
    "FIIterable_1_Windows__CUI__CWindowManagement__CDisplayRegion": ["75bb951a-8daa-511e-a84f-43b7d24365e6"],
    "FIIterable_1_Windows__CUI__CWindowManagement__CWindowingEnvironment": ["43788292-08cd-5ecc-8dc6-4206ba561ecb"],
    "FIIterable_1___FIKeyValuePair_2_ContentManagement__CWindowPosition_UINT32": [
        "1454d187-b3b9-5845-b51e-2e1140cc31b1"
    ],
    "FIIterable_1___FIKeyValuePair_2_EventRegistrationToken_int": ["cf0ad675-afee-549f-a1ea-bc5435c6b465"],
    "FIIterable_1___FIKeyValuePair_2_GUID_HSTRING": ["521a45b6-dfcc-5794-aec3-820d1a4bf537"],
    "FIIterable_1___FIKeyValuePair_2_GUID_IWeakReference": ["dd1bed65-0fc8-5c0f-9a89-019ecf5bd473"],
    "FIIterable_1___FIKeyValuePair_2_HSTRING_ContentManagement__CTargetedContent__CTargetedContentValue": [
        "dd1b833f-723d-5fa3-a2d6-43df7a6e41a1"
    ],
    "FIIterable_1___FIKeyValuePair_2_HSTRING_IWeakReference": ["ae146c5f-ef7b-5d5f-8a4e-1af50fd9d0f5"],
    "FIIterable_1___FIKeyValuePair_2_HSTRING_Windows__CFoundation__CIPropertyValue": [
        "b79e4978-c24d-5513-8a27-188bf762b06f"
    ],
    "FIIterable_1___FIKeyValuePair_2_HSTRING_Windows__CInternal__CSecurity__CAuthentication__CWeb__CWamProviderRegistrationInformation": [
        "e62af38c-468c-5935-90bd-3cb26e0fa192"
    ],
    "FIIterable_1___FIKeyValuePair_2_HSTRING_Windows__CMedia__CSpeechRecognition__CInternal__CISharedListConstraint": [
        "e36b8d54-676e-501a-ab31-abace34c99a4"
    ],
    "FIIterable_1___FIKeyValuePair_2_HSTRING_Windows__CMedia__CSpeechRecognition__CVoiceCommandSet": [
        "86e4878a-45de-5203-be77-81c04c9b44e6"
    ],
    "FIIterable_1___FIKeyValuePair_2_HSTRING_Windows__CStorage__CStreams__CRandomAccessStreamReference": [
        "c9729ba7-5e20-569d-a3d1-97a4e653e5bb"
    ],
    "FIIterable_1___FIKeyValuePair_2_HSTRING_Windows__CStorage__CWINRT__zPROPERTYKEY": [
        "cb7ce21b-f111-56cf-888f-c8b3fa288862"
    ],
    "FIIterable_1___FIKeyValuePair_2_HSTRING___FIVectorView_1_Windows__CInternal__CShell__CJumpView__CJumpViewCategoryInfo": [
        "eb3032aa-eeb0-50b7-8530-0efd7970fe7d"
    ],
    "FIIterable_1___FIKeyValuePair_2_HSTRING_byte": ["2a8cd53f-ffbd-57ea-867c-12a448d00aae"],
    "FIIterable_1___FIKeyValuePair_2_SharingPlatform__CIDeviceIdentifier___FIVectorView_1_SharingPlatform__CISessionIdentifier": [
        "76894330-8832-5a48-9af1-27ea9a21e1ea"
    ],
    "FIIterable_1___FIKeyValuePair_2_UINT32_HSTRING": ["e62289f2-8541-5938-932f-6974b59fc2cb"],
    "FIIterable_1___FIKeyValuePair_2_UINT32_IInspectable": ["8cba11e2-a805-502a-b120-311135ec2c8a"],
    "FIIterable_1___FIKeyValuePair_2_UINT32_IWeakReference": ["135b0dc7-de84-5404-a193-47d8fe08b731"],
    "FIIterable_1___FIKeyValuePair_2_UINT32_UINT32": ["a511fcd8-aee1-58aa-aef7-d829f1e41eaf"],
    "FIIterable_1___FIKeyValuePair_2_UINT32_Windows__CApplicationModel__CCore__CCoreApplicationView": [
        "3d7ac3bf-85cc-5506-b172-376a667151a3"
    ],
    "FIIterable_1___FIKeyValuePair_2_UINT32_Windows__CSystem__CUser": ["75fd4ba5-bdf0-52c1-8f39-79928ca979e1"],
    "FIIterable_1___FIKeyValuePair_2_UINT32_Windows__CUI__CCore__CCoreDispatcher": [
        "d6cd65f0-2b09-5c3a-b11a-b3fac5df98b8"
    ],
    "FIIterable_1___FIKeyValuePair_2_UINT32_Windows__CUI__CCore__CICoreWindow": [
        "b78ec97f-7a3d-51d9-b0a4-8e88175a843e"
    ],
    "FIIterable_1___FIKeyValuePair_2_UINT32_Windows__CUI__CCore__CPointerEventArgs": [
        "bceb3a1c-1fc9-56d7-a2d5-ebac62a7aad1"
    ],
    "FIIterable_1___FIVector_1_float": ["c3ebad4a-7528-56f8-b402-752b7d8f60bb"],
    "FIIterator_1_ContentManagement__CAppInstallInfoRecord": ["95fbb062-0622-50b4-90fd-fc92ecbaa68b"],
    "FIIterator_1_ContentManagement__CTargetedContent__CTargetedContentItem": ["169339ac-c151-5d0f-986f-a06dc5d18dcd"],
    "FIIterator_1_PhoneInternal__CExperiences__CSync__CAccount": ["f1d162f9-51fa-57ac-891f-1e8746aca666"],
    "FIIterator_1_PhoneInternal__CExperiences__CSync__CAccountSyncContentType": [
        "20b2230c-ebdb-5f21-87f7-e2af0fceda6e"
    ],
    "FIIterator_1_PhoneInternal__CExperiences__CSync__CPartnershipType": ["8d62af85-4c9e-5484-97f4-13d08575f710"],
    "FIIterator_1_SharingPlatform__CIDeviceIdentifier": ["bb80f605-83a7-5d35-8301-84ad954d9126"],
    "FIIterator_1_SharingPlatform__CIParticipantIdentifier": ["76295605-cd71-55e5-9731-b0bb644ec2f5"],
    "FIIterator_1_SharingPlatform__CISessionIdentifier": ["f3cd5df8-73c5-56c9-b17f-07833fa9b37a"],
    "FIIterator_1_UINT64": ["c473ed96-76e3-5ff2-9435-47feebfe9539"],
    "FIIterator_1_Windows__CApplicationModel__CAppointments__CAppointmentStore": [
        "5eecd042-b2b5-5cdb-af84-ad52bafbdf09"
    ],
    "FIIterator_1_Windows__CApplicationModel__CBackground__CIBackgroundTaskYieldable": [
        "efb3ef77-6bcb-557c-85d3-3437921b63dc"
    ],
    "FIIterator_1_Windows__CApplicationModel__CBackground__CIBrokerConditionBuilder": [
        "52e7dfd5-4cce-54a4-b368-cd4dce2d40b9"
    ],
    "FIIterator_1_Windows__CApplicationModel__CContacts__CInternal__CIContactActionControl": [
        "7aff36a5-7e33-5726-a7cd-cd33d8e47c86"
    ],
    "FIIterator_1_Windows__CApplicationModel__CContacts__CInternal__CIContactActionControlItem": [
        "ae494278-8172-5d63-8946-2d5a17a2112f"
    ],
    "FIIterator_1_Windows__CApplicationModel__CContacts__CInternal__CIContactDisplayInformation": [
        "2fbadad5-e4f1-5b9b-994b-2895bd690a51"
    ],
    "FIIterator_1_Windows__CApplicationModel__CCore__CCoreApplicationView": ["4f5f6944-264b-5868-809e-c7ac1ac5edad"],
    "FIIterator_1_Windows__CApplicationModel__CDataTransfer__CClipboardHistoryItem": [
        "63fac521-1395-5c95-aaff-9736378a4f2f"
    ],
    "FIIterator_1_Windows__CApplicationModel__CDataTransfer__CShareProvider": ["886f5642-e9f9-573b-9213-5840b5062b40"],
    "FIIterator_1_Windows__CApplicationModel__CInternal__CDataTransfer__CShareAppExtension": [
        "abeb0c31-c23e-561e-ae2e-333ab8f377ed"
    ],
    "FIIterator_1_Windows__CApplicationModel__CInternal__CStartupTaskInternal": [
        "0422d79c-49bb-5435-ae80-dbdda44adb75"
    ],
    "FIIterator_1_Windows__CApplicationModel__CSearch__CCore__CSearchSuggestion": [
        "c3157582-f72f-513a-b089-6208188ec2b6"
    ],
    "FIIterator_1_Windows__CDevices__CInput__CPointerDevice": ["de94641c-7960-5fcd-abe8-d6ba609ef7d3"],
    "FIIterator_1_Windows__CDevices__CInput__CPointerDeviceUsage": ["9ab2160d-11ef-5eca-8dd9-3e13aa4e5f99"],
    "FIIterator_1_Windows__CFoundation__CIExtensionRegistration": ["b4d4a79e-fe15-5272-9988-617a34d8300b"],
    "FIIterator_1_Windows__CInternal__CApplicationModel__CWindowManagement__CAppView": [
        "af931e5a-683d-5a36-bb7d-411604df5b03"
    ],
    "FIIterator_1_Windows__CInternal__CApplicationModel__CWindowManagement__CAppViewId": [
        "b00b33e6-8e54-58cb-8500-6accd06cf231"
    ],
    "FIIterator_1_Windows__CInternal__CApplicationModel__CWindowManagement__CWindow": [
        "838319e7-2ad6-5bed-bafe-87558bd435bd"
    ],
    "FIIterator_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIBackupFrequency": [
        "3eb91eed-4481-5471-9d13-38fdd970a831"
    ],
    "FIIterator_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIBackupRelatedActionItem": [
        "c763cf04-59d9-5adb-984c-c8b89d41c22f"
    ],
    "FIIterator_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIBackupSettingsProvider": [
        "ca504c61-df9d-5b87-a583-4b7fbba8acc6"
    ],
    "FIIterator_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIBackupTargetItem": [
        "523a7332-b38d-5d7f-a93d-d4f846a22d2b"
    ],
    "FIIterator_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIEnumBackupsProvider": [
        "c25ebcbb-fa80-5837-87c1-7c2985cd4a7c"
    ],
    "FIIterator_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIFolderBackupScopeItem": [
        "9d1a27a6-069f-54e1-997f-45733126aef5"
    ],
    "FIIterator_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIManualCleanupOption": [
        "76fbea69-ffbb-58a2-a2a0-b0c00cedcf65"
    ],
    "FIIterator_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIRetentionListItem": [
        "608baa1f-eabd-5ef3-92cd-cf9ab77a5f32"
    ],
    "FIIterator_1_Windows__CInternal__CBindableObservableItem": ["e5d742a0-4f08-578a-a9a9-1d72a66c755c"],
    "FIIterator_1_Windows__CInternal__CFeedback__CFeedbackItem": ["3db085da-a6f1-5bf4-b6ee-0fd4172e2c8a"],
    "FIIterator_1_Windows__CInternal__CIPropertyValueProvider": ["69a2b070-e493-51f9-bb4b-a93ea2c6bfd2"],
    "FIIterator_1_Windows__CInternal__CSecurity__CAuthentication__CWeb__CWamProviderRegistrationInformation": [
        "ba332cec-b667-5c9d-a963-ff4b920887fe"
    ],
    "FIIterator_1_Windows__CInternal__CSecurity__CSmartScreen__CButtonInfo": ["60f00258-24f8-5460-bb2d-853a614a50ec"],
    "FIIterator_1_Windows__CInternal__CSettingSync__CICollectionBackup": ["5f4d2516-ea8f-58aa-b008-168baeabab88"],
    "FIIterator_1_Windows__CInternal__CShell__CJumpView__CContextMenuItemWrapper": [
        "4c9bcaff-eb85-5906-a511-0b30eaf0691e"
    ],
    "FIIterator_1_Windows__CInternal__CShell__CJumpView__CJumpViewCategoryInfo": [
        "c084a330-b05c-5958-9165-f679d394d26c"
    ],
    "FIIterator_1_Windows__CInternal__CShell__CJumpView__CJumpViewItemInfo": ["6fc00940-c0a6-54e6-b4b7-a8a88dc15f47"],
    "FIIterator_1_Windows__CInternal__CShell__CSharePicker__CIShareTarget": ["6671d399-174f-59c1-90fa-86b81ab4c4ca"],
    "FIIterator_1_Windows__CInternal__CShell__CStartUI__CUserTileCommand": ["b9d3b83f-854f-5393-95fd-9b52c18e8ef6"],
    "FIIterator_1_Windows__CInternal__CShell__CStartUI__CUserTileSwitchUser": ["5ca10cca-8070-5897-9a3d-89a98315269e"],
    "FIIterator_1_Windows__CInternal__CShell__CTaskFlow__CDataEngine__CAppActivitySessionData": [
        "78ba6d0a-ac8e-5dcf-aaf8-adb4ab4a7665"
    ],
    "FIIterator_1_Windows__CInternal__CShell__CViewManagerInterop__CIViewWrapper": [
        "64ece9ce-a6ce-5c3f-9baf-392bb881318e"
    ],
    "FIIterator_1_Windows__CInternal__CStateRepository__CAppExecutionAlias": ["9b56f824-4f97-51bc-8cfc-93cb11e2fa15"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CAppExtension": ["1f370079-e333-58e1-83cb-ab53fb9bf923"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CAppExtensionHost": ["49293e79-8359-5ed3-b62c-c3d692b7f409"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CAppService": ["cdae9f6a-2875-51a5-b70d-9e9904089dff"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CAppUriHandler": ["8e2fc32f-0c77-5294-b159-27712fb76662"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CApplication": ["da11ee9a-71b9-53f6-9825-813f67f4a5d8"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CApplicationBackgroundTask": [
        "8b13c11a-7a3f-5b1b-a238-a5c434dd48fd"
    ],
    "FIIterator_1_Windows__CInternal__CStateRepository__CApplicationContentUriRule": [
        "c454bbfd-48d9-5c3c-a36f-b8d9fd60d556"
    ],
    "FIIterator_1_Windows__CInternal__CStateRepository__CApplicationExtension": [
        "18167874-64a9-5446-b5ca-58bd99a78da4"
    ],
    "FIIterator_1_Windows__CInternal__CStateRepository__CApplicationLicense": ["76291eff-ce87-5a9d-a9d8-49ef31f16fa5"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CApplicationPolicy": ["7fd8a92b-dace-5b0d-87d3-6c0f3fa015fc"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CApplicationProperty": ["f0b9f6ec-92f9-5e08-989b-0b476f6fc9df"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CAppxExtension": ["3db5ae45-1a2b-59d0-af48-e36b09b4942c"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CAppxManifest": ["99960ee4-8d2d-550c-8562-1fa01c964b95"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CBackgroundServiceAgent": [
        "13275968-89b0-5645-a5f5-163258fce149"
    ],
    "FIIterator_1_Windows__CInternal__CStateRepository__CBnsNotification": ["c6848e51-153a-5ac2-a70b-350f25679ddd"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CBundle": ["1c796604-5177-5cad-8284-da75e3dc3594"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CBundlePackage": ["2b2ebd31-6a53-5d51-9e7a-0647311184c1"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CBundleResource": ["9415747f-2944-5b90-a89c-0355ac6ea670"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CContentGroup": ["bbe8f153-9b97-596c-809b-8f3f3f4f8189"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CContentGroupFile": ["42ec6a38-f3c9-5d16-9199-5c177c286fa6"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CDefaultTile": ["b5657bb8-1fa1-5e59-b0ed-b10077f74aa3"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CDependency": ["97cb0c18-2a6f-5402-bfd3-25b1f358243d"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CDependencyGraph": ["0bd9c873-f85f-57a6-a53e-801038354be7"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CDeploymentHistory": ["9f4219f1-ca16-5624-8436-2c9357e0e411"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CDeploymentRequest": ["deeec5a4-2380-5f50-883e-0fd138b5aab4"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CDeploymentRequestDependency": [
        "ebeed2d1-7023-59b9-bb90-c016bea993e4"
    ],
    "FIIterator_1_Windows__CInternal__CStateRepository__CEnterprise": ["2b372964-fe7c-56a9-9d04-a05896ec1c6c"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CFile": ["80f33c3e-8a19-52b1-a1b5-5a5846a30b9f"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CFileTypeAssociation": ["0e371b49-375d-5b9b-9413-0697026cff94"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CMigratorPatch": ["a4cdb545-34d0-5700-9f17-bbb8e4468fd7"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CMrtApplication": ["bdef771e-f5ac-53b5-9c0a-0c753cba66db"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CMrtDefaultTile": ["4f855185-3506-56e4-87b4-78cfc2a9f8e0"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CMrtPackage": ["d57dcd42-4b5a-504b-ae07-8c1cb11bba4d"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CMrtSharedPri": ["412b56af-1eff-5d7a-87c7-f6af7f2be596"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CMrtUserPri": ["e92f8ab5-08f6-5cfd-876d-483564d42b81"],
    "FIIterator_1_Windows__CInternal__CStateRepository__COptionalBundle": ["a459da97-d268-5c26-82b8-dc9aee59fae4"],
    "FIIterator_1_Windows__CInternal__CStateRepository__COptionalBundlePackage": [
        "a0bae989-aa13-5a43-ac0e-2b01882a988f"
    ],
    "FIIterator_1_Windows__CInternal__CStateRepository__COptionalBundleResource": [
        "7f623b82-92fc-526f-acbc-906808449920"
    ],
    "FIIterator_1_Windows__CInternal__CStateRepository__CPackage": ["e910d209-71dd-53d9-8c47-bb86d9514875"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CPackageExtension": ["8bedf89c-d1fd-5460-9504-47ab988762f5"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CPackageFamily": ["78ba48bc-172a-5508-8969-b08c789875f1"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CPackageFamilyPolicy": ["f24af43d-ba14-52a7-a845-0e89e78dbbc8"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CPackageFamilyUser": ["0d9532ef-0661-5e72-a7bd-2a604685ff18"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CPackageIdentity": ["b7b12961-5019-57f0-a410-ce32da3e255e"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CPackageLocation": ["b96158f6-3099-58ab-9ff0-bcb9a29b083f"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CPackageMachineStatus": [
        "f74013c9-5122-5d22-955f-72cd957b115f"
    ],
    "FIIterator_1_Windows__CInternal__CStateRepository__CPackagePolicy": ["cce9f04f-ff44-59bc-a656-59976ebe9682"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CPackageProperty": ["d0a4f700-c2e7-55fe-9d6d-95251e374aea"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CPackageSourceUri": ["97238417-ae5b-5c24-90df-205063743b3c"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CPackageUser": ["0e9c049f-f276-5afd-910b-ac84466324bc"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CPackageUserStatus": ["6c1164e3-9b2d-5f82-b49e-6ab5f23d8db7"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CPrimaryTile": ["c921a30a-b197-5898-842b-0d5afafd8b69"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CPrimaryTileUser": ["9dcb88c3-9b7b-594d-9170-fd64b239a795"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CPrimaryTileUserChangelog": [
        "9f5a37e6-26b6-58a5-a485-1444ca0d7d29"
    ],
    "FIIterator_1_Windows__CInternal__CStateRepository__CPrimaryTileUserDataChange": [
        "15b2bc91-0a52-5ba5-8f3a-9302adfa28a6"
    ],
    "FIIterator_1_Windows__CInternal__CStateRepository__CPrimaryTileView": ["17b4f07b-7484-5364-bd11-f0be747c5d19"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CProtocol": ["02eddd9e-b4a1-5a96-ae13-1dfc22e58e97"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CPublisherCacheFolder": [
        "917df321-a995-5707-99e9-d3575b90b1a3"
    ],
    "FIIterator_1_Windows__CInternal__CStateRepository__CResource": ["db82b1a8-3046-586b-8e8c-5aa54b51744f"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CSecondaryTile": ["e50ddb3f-cd57-58d7-8134-499045eca5de"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CSecondaryTileUser": ["009794cb-9904-547e-ba66-f58fe94dc614"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CSecondaryTileUserChangelog": [
        "6d76cad5-e60d-5433-b1e6-541218f789b2"
    ],
    "FIIterator_1_Windows__CInternal__CStateRepository__CSecondaryTileUserDataChange": [
        "3c310f81-daa9-5425-baa9-7e7958c75b5f"
    ],
    "FIIterator_1_Windows__CInternal__CStateRepository__CSecondaryTileView": ["ffd2261b-2cc0-58e2-9735-606c7ff63d12"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CSequence": ["6710628b-662c-5188-982d-99fea982d86d"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CTargetDeviceFamily": ["d6cf516f-19dd-5b31-a4bf-9d931f7b632e"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CTask": ["b2eafff3-64d3-5ca1-b4e3-5a6aeb2bf136"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CTileView": ["7d88b5c6-cf84-5e7e-a847-3996fe4b5b1a"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CTileViewQueryFilter": ["31c96f24-32ee-5cfd-b8b0-9a36a1f892f4"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CUser": ["2364a9ab-cff3-5d28-bf15-28ee3147b97e"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CVolume": ["b075e820-98d2-523c-833e-38b43a468ed7"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CWowDependencyGraph": ["05eacd99-54ec-5cdd-9bc5-d58ea5d9d974"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CXap": ["c9c55778-006c-5d9d-85c4-6d746e749f66"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CXapExtension": ["0dba15a6-14a7-5c26-87d8-1181eca87a97"],
    "FIIterator_1_Windows__CInternal__CStateRepository__CXboxPackage": ["15eb1e94-cd8e-52df-97b2-cb74b8b08fd5"],
    "FIIterator_1_Windows__CInternal__CStorage__CFileOperation": ["4eeba2cd-2c8a-5db9-bd80-fbfaa708ebd2"],
    "FIIterator_1_Windows__CInternal__CStorage__CIFileOperationItemErrorInfo": ["193d0db0-2a68-5f8e-a366-e6624a36003e"],
    "FIIterator_1_Windows__CInternal__CStorage__CIStorageItemCommand": ["4ac5cb27-c463-5872-a7b1-c9371d6e18a5"],
    "FIIterator_1_Windows__CInternal__CStorage__CRecentItemsUpdateResult": ["9f8ff8d0-2712-530a-a7c0-5e8430e4294b"],
    "FIIterator_1_Windows__CInternal__CUI__CShutdown__CShutdownUXOption": ["02d4320a-46a9-529f-8cc5-25ae4cdb698e"],
    "FIIterator_1_Windows__CManagement__CDeployment__CInternal__CDiskUsageInformation": [
        "6f6e372f-2ff7-57c5-bab8-e6bc3a190353"
    ],
    "FIIterator_1_Windows__CMedia__CSpeechRecognition__CInternal__CSpeechRecognitionCorrectionGraphArc": [
        "ed924d49-3b0a-5410-8011-391354f30f5c"
    ],
    "FIIterator_1_Windows__CMedia__CSpeechRecognition__CInternal__CSpeechRecognitionCorrectionGraphNode": [
        "da49e1aa-87dc-5bd7-a606-1a59d53455b1"
    ],
    "FIIterator_1_Windows__CMedia__CSpeech__CSpeechSupportedLanguage": ["1241c7a6-0584-518e-9a26-0a3407194b9b"],
    "FIIterator_1_Windows__CNetworking__CConnectivity__CDataUsage": ["1bd33f1b-0bbb-5888-9c9b-18b63b0306f9"],
    "FIIterator_1_Windows__CNetworking__CUX__CIAvailableNetwork": ["610c2632-122a-5bad-bf77-c324a56d5bdd"],
    "FIIterator_1_Windows__CNetworking__CUX__CIAvailableNetworkOffer": ["dede3f3d-e3e1-5fbb-8778-24050dac3863"],
    "FIIterator_1_Windows__CNetworking__CUX__CIAvailableNetworkProvider": ["86f1f6ab-c88b-55fb-bf8b-3b248cb22d75"],
    "FIIterator_1_Windows__CNetworking__CUX__CICertItemInfo": ["1e597f3e-6c7a-56f8-bc73-89616ba18fc7"],
    "FIIterator_1_Windows__CNetworking__CUX__CIHotspot2RegisterProvider": ["d448daf4-27d1-5183-87f1-2a0cf524f38a"],
    "FIIterator_1_Windows__CNetworking__CUX__CISimItemInfo": ["e2e0c851-3497-5372-9f02-0a3d632a1c0e"],
    "FIIterator_1_Windows__CNetworking__CUX__CIUXCategory": ["a2a54126-8ea1-5732-ac3d-2e4928583b07"],
    "FIIterator_1_Windows__CNetworking__CUX__CIVPNCustomInputItem": ["6ca6a900-bf10-5dd4-b68c-1e2eb78be5f6"],
    "FIIterator_1_Windows__CNetworking__CUX__CIWiFiEapMethod": ["9fdc416b-374f-5b44-a5f7-3365bbdd1bd5"],
    "FIIterator_1_Windows__CNetworking__CUX__CIWiFiProfile": ["05118850-90e1-5d41-b6ca-ad54b8cb8605"],
    "FIIterator_1_Windows__CNetworking__CUX__CIWiFiSenseSocialNetwork": ["3b9b8887-3823-5771-94d5-accc71b7a2eb"],
    "FIIterator_1_Windows__CNetworking__CUX__CNetworkMediaType": ["b6b89422-2717-512f-a610-ef9cebff447b"],
    "FIIterator_1_Windows__CSecurity__CCredentials__CWebAccountProvider": ["e2e7ec4d-2889-5b44-8bde-2225b1253c3c"],
    "FIIterator_1_Windows__CServices__CTargetedContent__CInternal__CTargetedContentTriggerInternal": [
        "b237fe82-7e21-5bdb-bc8c-7d8ceae4b402"
    ],
    "FIIterator_1_Windows__CStorage__CAccessCache__CAccessListEntry": ["d1a0a6c4-889d-519b-8508-26241b329b7e"],
    "FIIterator_1_Windows__CStorage__CBulkAccess__CFileInformation": ["bf2f6543-230e-50bf-9c57-9e4ba8635903"],
    "FIIterator_1_Windows__CStorage__CBulkAccess__CFolderInformation": ["ff68b5b6-caad-553a-9808-95eea700c9de"],
    "FIIterator_1_Windows__CStorage__CBulkAccess__CIStorageItemInformation": ["3da6401d-1279-55a1-962c-25cd23b99b27"],
    "FIIterator_1_Windows__CStorage__CIStorageFile": ["314d2318-74ee-535c-b361-2144dbc573a0"],
    "FIIterator_1_Windows__CStorage__CIStorageFolder": ["73e42360-10fc-513c-9c38-d7fb007abbc4"],
    "FIIterator_1_Windows__CStorage__CIStorageItem": ["05b487c2-3830-5d3c-98da-25fa11542dbd"],
    "FIIterator_1_Windows__CStorage__CPickers__CIPickerFileType": ["8063fc5f-83d0-53ef-ad6b-b173e1dc0356"],
    "FIIterator_1_Windows__CStorage__CPickers__CUpdateFilesResult": ["081d7f8f-3ea9-50ee-a46b-2a74e2727fbc"],
    "FIIterator_1_Windows__CStorage__CSearch__CSortEntry": ["520434a2-acf7-58c9-b47a-2741f2fac2c2"],
    "FIIterator_1_Windows__CStorage__CStorageFile": ["43e29f53-0298-55aa-a6c8-4edd323d9598"],
    "FIIterator_1_Windows__CStorage__CStorageFolder": ["5aac96fb-b3b9-5a7f-a920-4b5a8df81168"],
    "FIIterator_1_Windows__CStorage__CStorageLibrary": ["0a1c6409-fbd3-58c8-9af3-6262cc56e5b3"],
    "FIIterator_1_Windows__CStorage__CStorageLibraryChange": ["c48a1103-56e6-5398-84fe-92edad7fc111"],
    "FIIterator_1_Windows__CStorage__CStreams__CIRandomAccessStream": ["c875446a-587f-58da-897e-3bbe5ec7c30b"],
    "FIIterator_1_Windows__CStorage__CStreams__CIRandomAccessStreamReference": ["712e1447-a302-58ca-8cf7-c3b9b4ba67ec"],
    "FIIterator_1_Windows__CSystem__CInternal__CIUserProfile": ["37398851-df2c-5799-813f-3273bf578aec"],
    "FIIterator_1_Windows__CSystem__CInternal__CLaunch__CAppServiceExtensionInfo": [
        "23dab554-811b-54cb-b653-821fc62de4b0"
    ],
    "FIIterator_1_Windows__CSystem__CInternal__CLaunch__CExtensionInfo": ["9808ea27-0bf8-5e8c-95c5-d873cb12c525"],
    "FIIterator_1_Windows__CSystem__CRemoteSystems__CRemoteSystem": ["774edcdb-70a0-52f6-88db-0f2260ba593c"],
    "FIIterator_1_Windows__CUI__CCore__CAnimationMetrics__CIPropertyAnimation": [
        "bb6799d3-9f1a-5a4e-a940-945f1ab8c4fe"
    ],
    "FIIterator_1_Windows__CUI__CInput__CPointerPoint": ["721fe01c-5ad4-5262-b078-3ab345105db8"],
    "FIIterator_1_Windows__CUI__CNotifications__CShownTileNotification": ["04d8d70b-7c15-5f60-9894-b21366b427c2"],
    "FIIterator_1_Windows__CUI__CPopups__CIUICommand": ["f45db3d3-7299-57ce-a73e-297cf0af3083"],
    "FIIterator_1_Windows__CUI__CSearch__CInternal__CCommon__CLocalGroupScore": [
        "9b3b3f76-be7a-5937-bc09-cdd77ef4c1a4"
    ],
    "FIIterator_1_Windows__CUI__CWindowManagement__CDisplayRegion": ["c2925e39-4a55-5c3c-ae3e-275a0feb9005"],
    "FIIterator_1_Windows__CUI__CWindowManagement__CWindowingEnvironment": ["f140bf72-fe16-5655-93d7-11b373431525"],
    "FIIterator_1___FIKeyValuePair_2_ContentManagement__CWindowPosition_UINT32": [
        "8764bf05-7d02-5928-8cb5-9b97c032938c"
    ],
    "FIIterator_1___FIKeyValuePair_2_EventRegistrationToken_int": ["72ecdb76-ad50-5d91-abd9-a5d72d602d1c"],
    "FIIterator_1___FIKeyValuePair_2_GUID_HSTRING": ["290f4857-9fa8-534d-985c-0737196e465f"],
    "FIIterator_1___FIKeyValuePair_2_GUID_IWeakReference": ["638ef085-af16-544a-8fdf-005e15ba6f6c"],
    "FIIterator_1___FIKeyValuePair_2_HSTRING_ContentManagement__CTargetedContent__CTargetedContentValue": [
        "1e51de4d-3138-5bc2-a6b5-6bbe9dd46106"
    ],
    "FIIterator_1___FIKeyValuePair_2_HSTRING_IWeakReference": ["b94eeb4a-3f1a-517a-a9b8-5c95152b8449"],
    "FIIterator_1___FIKeyValuePair_2_HSTRING_Windows__CFoundation__CIPropertyValue": [
        "4f2e4809-42af-57d5-9d2b-5c1adc328d5e"
    ],
    "FIIterator_1___FIKeyValuePair_2_HSTRING_Windows__CInternal__CSecurity__CAuthentication__CWeb__CWamProviderRegistrationInformation": [
        "91bb4b28-093c-540e-9599-bb721a09cec8"
    ],
    "FIIterator_1___FIKeyValuePair_2_HSTRING_Windows__CMedia__CSpeechRecognition__CInternal__CISharedListConstraint": [
        "426e2ac5-a00b-57fd-871b-82b7023ec62c"
    ],
    "FIIterator_1___FIKeyValuePair_2_HSTRING_Windows__CMedia__CSpeechRecognition__CVoiceCommandSet": [
        "d19b13f3-9058-53bd-8d53-3ee1ea84389b"
    ],
    "FIIterator_1___FIKeyValuePair_2_HSTRING_Windows__CStorage__CStreams__CRandomAccessStreamReference": [
        "9419af53-acb8-5328-8853-70ba87eb6ad5"
    ],
    "FIIterator_1___FIKeyValuePair_2_HSTRING_Windows__CStorage__CWINRT__zPROPERTYKEY": [
        "ba53cdab-831d-59ce-b57d-58fb4313666d"
    ],
    "FIIterator_1___FIKeyValuePair_2_HSTRING___FIVectorView_1_Windows__CInternal__CShell__CJumpView__CJumpViewCategoryInfo": [
        "01b8cd94-e0fe-5ed9-b72a-61da1e2d5f6f"
    ],
    "FIIterator_1___FIKeyValuePair_2_HSTRING_byte": ["bdea44aa-b64a-56b5-8636-9ae88b242de1"],
    "FIIterator_1___FIKeyValuePair_2_SharingPlatform__CIDeviceIdentifier___FIVectorView_1_SharingPlatform__CISessionIdentifier": [
        "a375119e-dfd5-51a6-bde2-87297a3181be"
    ],
    "FIIterator_1___FIKeyValuePair_2_UINT32_HSTRING": ["57fb7d9a-b0c4-5d75-9162-453cbfbe89e8"],
    "FIIterator_1___FIKeyValuePair_2_UINT32_IInspectable": ["a73cb07b-f558-5ca9-95c3-9ecc408c7fca"],
    "FIIterator_1___FIKeyValuePair_2_UINT32_IWeakReference": ["a434f1db-4348-547d-9873-8c384b69ee2f"],
    "FIIterator_1___FIKeyValuePair_2_UINT32_UINT32": ["f2e7279d-32da-5cf0-8ef2-0ad599b773f7"],
    "FIIterator_1___FIKeyValuePair_2_UINT32_Windows__CApplicationModel__CCore__CCoreApplicationView": [
        "7df3fb08-34ac-5e78-98e9-a7a9078a7229"
    ],
    "FIIterator_1___FIKeyValuePair_2_UINT32_Windows__CSystem__CUser": ["5a18bbfd-df3f-5125-8c16-ffd6d7d490d5"],
    "FIIterator_1___FIKeyValuePair_2_UINT32_Windows__CUI__CCore__CCoreDispatcher": [
        "691a76fc-7973-5813-90e2-c69c7e3cf5f8"
    ],
    "FIIterator_1___FIKeyValuePair_2_UINT32_Windows__CUI__CCore__CICoreWindow": [
        "2d8e5e96-2980-5803-8630-21c68ca98b8e"
    ],
    "FIIterator_1___FIKeyValuePair_2_UINT32_Windows__CUI__CCore__CPointerEventArgs": [
        "a8834feb-9edf-5ed0-9566-6b1c4bff21ab"
    ],
    "FIIterator_1___FIVector_1_float": ["ae159e2c-309d-5485-a126-4c30abcb4571"],
    "FIKeyValuePair_2_ContentManagement__CWindowPosition_UINT32": ["79e5e386-1300-536f-a923-03bde6ed9ec7"],
    "FIKeyValuePair_2_EventRegistrationToken_int": ["ffa0bdcf-7066-56e4-85a1-d90c0a26705a"],
    "FIKeyValuePair_2_GUID_HSTRING": ["c036d8be-41a8-5324-a7c4-0db5cca70ef5"],
    "FIKeyValuePair_2_GUID_IWeakReference": ["835db0d5-1fe5-5def-8afc-0e65f8276efc"],
    "FIKeyValuePair_2_HSTRING_ContentManagement__CTargetedContent__CTargetedContentValue": [
        "ead6fd2a-bd4c-51d9-8267-28e524030a6b"
    ],
    "FIKeyValuePair_2_HSTRING_IWeakReference": ["7796c95e-3779-58b3-b922-efe76029156d"],
    "FIKeyValuePair_2_HSTRING_Windows__CFoundation__CIPropertyValue": ["f6604ec5-4de5-5477-9b9d-a29525bde6f7"],
    "FIKeyValuePair_2_HSTRING_Windows__CInternal__CSecurity__CAuthentication__CWeb__CWamProviderRegistrationInformation": [
        "ebac36d1-8663-5c19-ad53-64c3e49af219"
    ],
    "FIKeyValuePair_2_HSTRING_Windows__CMedia__CSpeechRecognition__CInternal__CISharedListConstraint": [
        "4c14d993-a787-5c9a-839f-feed12e19456"
    ],
    "FIKeyValuePair_2_HSTRING_Windows__CMedia__CSpeechRecognition__CVoiceCommandSet": [
        "2bda6840-c39e-5534-8099-22004ab33fc2"
    ],
    "FIKeyValuePair_2_HSTRING_Windows__CStorage__CStreams__CRandomAccessStreamReference": [
        "e5195792-aeab-56e8-bd30-1372c4340bf6"
    ],
    "FIKeyValuePair_2_HSTRING_Windows__CStorage__CWINRT__zPROPERTYKEY": ["7f807f09-b53c-5b18-9ee0-c9585a34cdd1"],
    "FIKeyValuePair_2_HSTRING___FIVectorView_1_Windows__CInternal__CShell__CJumpView__CJumpViewCategoryInfo": [
        "ff989388-e4e2-59d9-8189-759705ad28ae"
    ],
    "FIKeyValuePair_2_HSTRING_byte": ["41c2af3c-d7ff-5f46-9fc4-7dcc178b09a3"],
    "FIKeyValuePair_2_SharingPlatform__CIDeviceIdentifier___FIVectorView_1_SharingPlatform__CISessionIdentifier": [
        "cde8fcf3-0951-5124-94e5-9b7939b22f58"
    ],
    "FIKeyValuePair_2_UINT32_HSTRING": ["362a6330-076c-533a-b801-8303fc6d3ac1"],
    "FIKeyValuePair_2_UINT32_IInspectable": ["be671f2e-59f2-5d0f-ae04-8e3abe689881"],
    "FIKeyValuePair_2_UINT32_IWeakReference": ["93fb395f-4bdb-5fa7-8da7-31b972bca0fc"],
    "FIKeyValuePair_2_UINT32_UINT32": ["1e74a399-46c7-5548-91bf-f2c7b0b88f11"],
    "FIKeyValuePair_2_UINT32_Windows__CApplicationModel__CCore__CCoreApplicationView": [
        "1958f12d-c3fd-59b8-a071-338fdb431403"
    ],
    "FIKeyValuePair_2_UINT32_Windows__CSystem__CUser": ["5b77a15d-f0d0-5546-9bc0-d153d70d28be"],
    "FIKeyValuePair_2_UINT32_Windows__CUI__CCore__CCoreDispatcher": ["ec1b9412-b677-58ee-9032-a47d8ffab675"],
    "FIKeyValuePair_2_UINT32_Windows__CUI__CCore__CICoreWindow": ["dd1b7a81-8145-57f9-9df3-6a48d666bd81"],
    "FIKeyValuePair_2_UINT32_Windows__CUI__CCore__CPointerEventArgs": ["af4e1c68-eb34-5800-9e70-f9ffb9a6fa5c"],
    "FIMapChangedEventArgs_1_GUID": ["980c67ca-7c32-599a-9f8f-defc1c63925d"],
    "FIMapView_2_ContentManagement__CWindowPosition_UINT32": ["0c15010e-8e08-5108-8dd7-0aa21700862a"],
    "FIMapView_2_EventRegistrationToken_int": ["d0c43d9c-edea-5afb-9ff4-6ca30dd95064"],
    "FIMapView_2_GUID_HSTRING": ["ad10c18b-7726-5283-a0c0-4067ee6ca05f"],
    "FIMapView_2_GUID_IWeakReference": ["68a4e71c-1e09-576b-ac06-66c5c5b7d935"],
    "FIMapView_2_HSTRING_ContentManagement__CTargetedContent__CTargetedContentValue": [
        "e0a5b80e-9bd9-58d0-ba7d-19472fd6f404"
    ],
    "FIMapView_2_HSTRING_IWeakReference": ["45a1b28f-2869-5bd2-b0b7-195a7a905408"],
    "FIMapView_2_HSTRING_Windows__CFoundation__CIPropertyValue": ["82b5eb78-0aa4-5dca-a5ed-24c949312875"],
    "FIMapView_2_HSTRING_Windows__CInternal__CSecurity__CAuthentication__CWeb__CWamProviderRegistrationInformation": [
        "45f9868b-70be-5ecc-9875-1b97814e6b0e"
    ],
    "FIMapView_2_HSTRING_Windows__CMedia__CSpeechRecognition__CInternal__CISharedListConstraint": [
        "504c62db-4292-523e-af92-d7add4428993"
    ],
    "FIMapView_2_HSTRING_Windows__CMedia__CSpeechRecognition__CVoiceCommandSet": [
        "121115fd-3858-5888-8626-b69ded969bd6"
    ],
    "FIMapView_2_HSTRING_Windows__CStorage__CStreams__CRandomAccessStreamReference": [
        "0a4ce7a5-dfe0-5796-a438-effdfaa31f1b"
    ],
    "FIMapView_2_HSTRING_Windows__CStorage__CWINRT__zPROPERTYKEY": ["4c520b82-e1ab-5b43-a749-e4f1a93f22cf"],
    "FIMapView_2_HSTRING___FIVectorView_1_Windows__CInternal__CShell__CJumpView__CJumpViewCategoryInfo": [
        "17d43e1a-4a72-542d-8013-d1fd940b1e89"
    ],
    "FIMapView_2_HSTRING_byte": ["864c9cdb-725f-5911-b692-cb12e2c56d36"],
    "FIMapView_2_SharingPlatform__CIDeviceIdentifier___FIVectorView_1_SharingPlatform__CISessionIdentifier": [
        "5104d3e9-5038-517e-9cf6-28c106cee038"
    ],
    "FIMapView_2_UINT32_HSTRING": ["f32a029f-7d70-5f32-b1f3-2ef931c7b34c"],
    "FIMapView_2_UINT32_IInspectable": ["3b321e40-cb99-539b-b1cb-69e91a9a05fe"],
    "FIMapView_2_UINT32_IWeakReference": ["ed4a22ac-d4cd-5ae9-a391-43f68ae0e6d6"],
    "FIMapView_2_UINT32_UINT32": ["813e23e9-c38c-5af9-9c94-c672f1968662"],
    "FIMapView_2_UINT32_Windows__CApplicationModel__CCore__CCoreApplicationView": [
        "e4b1e213-5103-5514-8b7e-251acea49ac3"
    ],
    "FIMapView_2_UINT32_Windows__CSystem__CUser": ["024bb286-762a-5e50-bb2f-ce4c8d563e13"],
    "FIMapView_2_UINT32_Windows__CUI__CCore__CCoreDispatcher": ["aef156e9-6434-5147-97e1-7039f800e2aa"],
    "FIMapView_2_UINT32_Windows__CUI__CCore__CICoreWindow": ["69221d8c-4b8c-55b2-8759-abf039b283cc"],
    "FIMapView_2_UINT32_Windows__CUI__CCore__CPointerEventArgs": ["1cff7ba0-c668-5d76-b68d-f1f2749d291d"],
    "FIMap_2_ContentManagement__CWindowPosition_UINT32": ["1005e0a4-4221-5c33-a9b3-ceee5c0b9d98"],
    "FIMap_2_EventRegistrationToken_int": ["8b8cdf57-b1b1-5713-b2df-1f1988f1c172"],
    "FIMap_2_GUID_HSTRING": ["f4dd39d2-2c6d-5298-89e1-0b9938e1886a"],
    "FIMap_2_GUID_IWeakReference": ["4ad8883a-d011-5f48-a0f3-8c8e859c03b7"],
    "FIMap_2_GUID_Windows__CApplicationModel__CBackground__CBackgroundTaskRegistration": [
        "aaca6f20-2990-5c73-8c6a-ce9224bb0170"
    ],
    "FIMap_2_GUID_Windows__CApplicationModel__CBackground__CIBackgroundTaskRegistration": [
        "6fe872bd-1090-50ef-aa1a-82b7f9bce2b8"
    ],
    "FIMap_2_HSTRING_ContentManagement__CTargetedContent__CTargetedContentValue": [
        "96d0a476-a1fd-5703-a512-b9fceb0f35ce"
    ],
    "FIMap_2_HSTRING_IWeakReference": ["cf3b0272-84cf-511a-a13d-f160bee129e2"],
    "FIMap_2_HSTRING_Windows__CApplicationModel__CBackground__CBackgroundTaskRegistrationGroup": [
        "f451776c-7fde-5cd0-a068-68884c99d37c"
    ],
    "FIMap_2_HSTRING_Windows__CApplicationModel__CChat__CChatMessageStatus": ["a6c9690b-cd11-53f3-b695-8ef8a66ca785"],
    "FIMap_2_HSTRING_Windows__CApplicationModel__CStore__CProductLicense": ["56c2be30-197a-59cc-9acf-26ea81a8753f"],
    "FIMap_2_HSTRING_Windows__CApplicationModel__CStore__CProductListing": ["100b61ec-b969-57fa-822a-cc321bfaa6c5"],
    "FIMap_2_HSTRING_Windows__CApplicationModel__CVoiceCommands__CVoiceCommandDefinition": [
        "c4c9b3e4-0df7-56af-8ead-52633456e8a1"
    ],
    "FIMap_2_HSTRING_Windows__CFoundation__CIPropertyValue": ["2c0d081c-bbea-5cb6-88ad-253bd8d0a97b"],
    "FIMap_2_HSTRING_Windows__CInternal__CSecurity__CAuthentication__CWeb__CWamProviderRegistrationInformation": [
        "3d25aa3b-000e-5db7-b8a6-6eb59e4a47e5"
    ],
    "FIMap_2_HSTRING_Windows__CMedia__CSpeechRecognition__CInternal__CISharedListConstraint": [
        "b955aacb-902f-5ce5-9526-df71cc06d767"
    ],
    "FIMap_2_HSTRING_Windows__CMedia__CSpeechRecognition__CVoiceCommandSet": ["49aec24b-4678-5ce4-879d-b22ba71d3140"],
    "FIMap_2_HSTRING_Windows__CServices__CTargetedContent__CTargetedContentValue": [
        "f24d969d-ba69-5e26-b3ab-9c94f9bd8747"
    ],
    "FIMap_2_HSTRING_Windows__CStorage__CApplicationDataContainer": ["b56241e6-507b-5cd7-b9c3-297bcbd5bcef"],
    "FIMap_2_HSTRING_Windows__CStorage__CStreams__CRandomAccessStreamReference": [
        "e5d2ccfc-825a-5a8e-82aa-095ed5dbd5d1"
    ],
    "FIMap_2_HSTRING_Windows__CStorage__CWINRT__zPROPERTYKEY": ["6f5cc41e-808c-59ed-b958-a4525b846836"],
    "FIMap_2_HSTRING___FIVectorView_1_HSTRING": ["b63397c9-5d89-530b-becf-2b843a15c4e4"],
    "FIMap_2_HSTRING___FIVectorView_1_Windows__CInternal__CShell__CJumpView__CJumpViewCategoryInfo": [
        "0ef0ff94-35a1-5039-9427-be8ecabd35c6"
    ],
    "FIMap_2_HSTRING_byte": ["25c55baa-a035-5284-bb06-b49c1c7e61cc"],
    "FIMap_2_SharingPlatform__CIDeviceIdentifier___FIVectorView_1_SharingPlatform__CISessionIdentifier": [
        "b89c8c58-c29b-58fd-b335-bc1af0054b13"
    ],
    "FIMap_2_UINT32_HSTRING": ["19c1d962-32c8-5346-8447-dc6cfb42004b"],
    "FIMap_2_UINT32_IInspectable": ["84b0c2f9-f7c9-5356-86f9-1a411c36a8dc"],
    "FIMap_2_UINT32_IWeakReference": ["6a78ee42-4de9-5999-ba42-0e7fdc63bde6"],
    "FIMap_2_UINT32_UINT32": ["b5a17ec4-87a4-5644-9322-f14ecf249fd6"],
    "FIMap_2_UINT32_Windows__CApplicationModel__CCore__CCoreApplicationView": ["06f9adec-7353-58bf-be90-d12631d08cd9"],
    "FIMap_2_UINT32_Windows__CSystem__CUser": ["f133b694-6aba-51f2-9001-72f3e0092d51"],
    "FIMap_2_UINT32_Windows__CUI__CCore__CCoreDispatcher": ["b5daa92d-79da-5cbd-a3e1-842757f4f941"],
    "FIMap_2_UINT32_Windows__CUI__CCore__CICoreWindow": ["f8565c99-fa40-5f3a-aa1a-3222f0155b21"],
    "FIMap_2_UINT32_Windows__CUI__CCore__CPointerEventArgs": ["6d6e1762-41ff-5a4e-8e19-79c42509961d"],
    "FIObservableMap_2_HSTRING_Windows__CStorage__CStreams__CRandomAccessStreamReference": [
        "82286dd7-475f-59ef-a226-c5963cbf786c"
    ],
    "FIObservableVector_1_HSTRING": ["37500595-dcf0-5d27-b8c4-cf388e374de8"],
    "FIObservableVector_1_Windows__CApplicationModel__CContacts__CInternal__CIContactActionControl": [
        "ff6e21da-4a28-5523-99c2-63f93999354c"
    ],
    "FIObservableVector_1_Windows__CApplicationModel__CContacts__CInternal__CIContactActionControlItem": [
        "a31cf301-3808-5bbb-a2cd-5785383a7eda"
    ],
    "FIObservableVector_1_Windows__CApplicationModel__CSearch__CCore__CSearchSuggestion": [
        "e885956c-72c1-514f-ad9a-2943b880ae13"
    ],
    "FIObservableVector_1_Windows__CInternal__CBindableObservableItem": ["3a913fea-c7dd-5a16-9ebf-0984f6517b65"],
    "FIObservableVector_1_Windows__CStorage__CStorageFolder": ["358f44df-2a45-5cb8-9385-1ff66808cde0"],
    "FIObservableVector_1_Windows__CUI__CWindowManagement__CDisplayRegion": ["24f9cbcf-78d3-5eac-8d42-2efbe5512bbb"],
    "FIObservableVector_1_float": ["7751e226-9556-58cf-b36a-364f09016f81"],
    "FIReferenceArray_1_GUID": ["eecf9838-c1c2-5b4a-976f-cec261ae1d55"],
    "FIReferenceArray_1_HSTRING": ["0385688e-e3c7-5c5e-a389-5524ede349f1"],
    "FIReferenceArray_1_IInspectable": ["9cd7a84f-0c80-59c5-b44e-977841bb43d9"],
    "FIReferenceArray_1_UINT16": ["6624a2dd-83f7-519c-9d55-bb1f6560456b"],
    "FIReferenceArray_1_UINT32": ["97374b68-eb87-56cc-b18e-27ef0f9cfc0c"],
    "FIReferenceArray_1_UINT64": ["38b60434-d67c-523e-9d0e-24d643411073"],
    "FIReferenceArray_1_Windows__CFoundation__CDateTime": ["1b8e9594-588e-5a07-9e65-0731a4c9a2db"],
    "FIReferenceArray_1_Windows__CFoundation__CPoint": ["39313214-5c7d-599d-ae5a-17d9d6492258"],
    "FIReferenceArray_1_Windows__CFoundation__CRect": ["8a444256-d661-5e9a-a72b-d8f1d7962d0c"],
    "FIReferenceArray_1_Windows__CFoundation__CSize": ["3b40e9d4-e0c3-56f6-b88b-e505eb73757b"],
    "FIReferenceArray_1_Windows__CFoundation__CTimeSpan": ["ad73197d-2cfa-57a6-8993-9fac40feb791"],
    "FIReferenceArray_1___z__zint64": ["6e333271-2e2a-5955-8790-836c76ee53b6"],
    "FIReferenceArray_1_boolean": ["e8e72666-48cc-593f-ba85-2663496956e3"],
    "FIReferenceArray_1_byte": ["2af22683-3734-56d0-a60e-688cc85d1619"],
    "FIReferenceArray_1_double": ["d301f253-e0a3-5d2b-9a41-a4d62bec4623"],
    "FIReferenceArray_1_float": ["6ab1ea83-cb41-5f99-92cc-23bd4336a1fb"],
    "FIReferenceArray_1_int": ["a6d080a5-b087-5bc2-9a9f-5cd687b4d1f7"],
    "FIReferenceArray_1_short": ["912f8fd7-adc0-5d60-a896-7ed76089cc5b"],
    "FIReferenceArray_1_wchar__zt": ["a4095aab-eb7d-5782-8fad-1609dea249ad"],
    "FIReference_1_HSTRING": ["fd416dfb-2a07-52eb-aae3-dfce14116c05"],
    "FIReference_1_UINT16": ["5ab7d2c3-6b62-5e71-a4b6-2d49c4f238fd"],
    "FIReference_1_Windows__CFoundation__CSize": ["61723086-8e53-5276-9f36-2a4bb93e2b75"],
    "FIReference_1_Windows__CGraphics__CDisplay__CDisplayOrientations": ["35504d04-b4f9-5ccb-affd-0df63d370efc"],
    "FIReference_1_Windows__CInternal__CApplicationModel__CWindowManagement__CAppViewExecutionState": [
        "12741485-ca3b-5d37-b0e1-161f70753091"
    ],
    "FIReference_1_Windows__CInternal__CApplicationModel__CWindowManagement__CAppViewVisibility": [
        "542db172-c294-56c7-9621-5e474acebdd1"
    ],
    "FIReference_1_Windows__CInternal__CApplicationModel__CWindowManagement__CMessageRoutingInfo": [
        "e954779c-8133-5f09-a517-96b7db8e70ce"
    ],
    "FIReference_1_Windows__CInternal__CSecurity__CSmartScreen__CDownload__CDownloadScenario": [
        "42b18a57-e6d3-50bc-a5b2-0a074bbd3495"
    ],
    "FIReference_1_Windows__CPhone__CUI__CCore__CFULL__zSCREEN__zTYPE": ["a0865d4d-b3a8-5c87-bb0c-ae3e4e17656e"],
    "FIReference_1_Windows__CStorage__CFileAttributes": ["7efefa72-a793-5e0c-b3a9-0a438b3e27d6"],
    "FIReference_1_Windows__CStorage__CFileProperties__CPhotoOrientation": ["3d05c642-57e0-561f-9ba4-d5bbf0262421"],
    "FIReference_1_Windows__CStorage__CFileProperties__CVideoOrientation": ["544202bf-9b0a-558a-a4dc-d4030909c33e"],
    "FIReference_1_Windows__CUI__CCore__CAppViewBackButtonVisibility": ["f17b7bc6-f966-554a-9e91-73a5ea1f3952"],
    "FIReference_1_Windows__CUI__CViewManagement__CApplicationViewWindowingMode": [
        "a03e4edb-37d3-5064-8ab3-be572e5df8b4"
    ],
    "FIReference_1_wchar__zt": ["fb393ef3-bbac-5bd5-9144-84f23576f415"],
    "FITypedEventHandler_2_ContentManagement__CTargetedContent__CTargetedContentSubscription_ContentManagement__CTargetedContent__CTargetedContentUpdatedEventArgs": [
        "4e53ffea-0c52-588b-8a6d-bcb4d217038f"
    ],
    "FITypedEventHandler_2_DeviceFlows__CSystemInteractionProviders__CIBluetoothAudioProvider_DeviceFlows__CSystemInteractionProviders__CIBluetoothProfileChangedEventArgs": [
        "8996789b-a6df-5f3e-8a38-978dd37d8385"
    ],
    "FITypedEventHandler_2_DevicesFlowInteraction__CConnection__CIDeviceConnectionListener_DevicesFlowInteraction__CConnection__CIConnectionStateChangedEventArgs": [
        "6701ab9f-04b6-5993-9f10-721046a2ff9c"
    ],
    "FITypedEventHandler_2_IInspectable_HSTRING": ["dc471c97-550a-573c-9a01-f94a67aa3850"],
    "FITypedEventHandler_2_IInspectable_PhoneInternal__CExperiences__CSync__CAccountChangedEventArgs": [
        "405958ac-b107-5784-aa1b-56d1c83f3a60"
    ],
    "FITypedEventHandler_2_IInspectable_Windows__CInternal__CBackupRestore__CSettingsProviders__CIPropertyChangedEventArgs": [
        "7baabf4e-a184-5a2a-8f78-d912c6d8dc63"
    ],
    "FITypedEventHandler_2_IInspectable_Windows__CUI__CCore__CCharacterReceivedEventArgs": [
        "5aa4a848-86b2-506b-89ab-5eb5786420c6"
    ],
    "FITypedEventHandler_2_IInspectable_Windows__CUI__CCore__CComponentDisplayInformationInternalChangedEventArgs": [
        "b622fd6b-95cd-530d-a14f-268f156702eb"
    ],
    "FITypedEventHandler_2_IInspectable_Windows__CUI__CCore__CContextMenuRequestedEventArgs": [
        "24120ddd-c9c1-5ad4-8c61-97926e9f0093"
    ],
    "FITypedEventHandler_2_IInspectable_Windows__CUI__CCore__CCoreWindowEventArgs": [
        "1a8ac270-a777-50f7-88a1-e34e56c09449"
    ],
    "FITypedEventHandler_2_IInspectable_Windows__CUI__CCore__CInputEnabledEventArgs": [
        "c9965f1c-3641-51b6-b823-048ec3628fb0"
    ],
    "FITypedEventHandler_2_IInspectable_Windows__CUI__CCore__CKeyEventArgs": ["eadffdf7-d70e-5688-906c-c2b1229ea16d"],
    "FITypedEventHandler_2_IInspectable_Windows__CUI__CCore__CPointerEventArgs": [
        "26aabf41-a0fd-5e66-b188-6c74182d00cd"
    ],
    "FITypedEventHandler_2_IInspectable_Windows__CUI__CCore__CTouchHitTestingEventArgs": [
        "c76e9d25-6a96-58fd-874f-ae52bd603af8"
    ],
    "FITypedEventHandler_2_IInspectable_Windows__CUI__CSearch__CInternal__CSearchBoxControl__CIQuerySubmittedEventArgs": [
        "e684f8fe-31a9-57da-993f-06b5757f41f5"
    ],
    "FITypedEventHandler_2_IInspectable_Windows__CUI__CSearch__CInternal__CSearchBoxControl__CIQueryTextChangedEventArgs": [
        "a3565a5e-1b1c-5efe-bc3f-52ebf0f41dd1"
    ],
    "FITypedEventHandler_2_IInspectable_Windows__CUI__CSearch__CInternal__CSearchBoxControl__CIResultSuggestionChosenEventArgs": [
        "5f5295c7-295f-5735-9660-62869757524a"
    ],
    "FITypedEventHandler_2_IInspectable_Windows__CUI__CSearch__CInternal__CSearchResults__CIResultsReadyEventArgs": [
        "bcc41b25-3a50-529f-a2fd-6eab7aa94669"
    ],
    "FITypedEventHandler_2_SharingPlatform__CIDeviceSessionBinaryChannel_SharingPlatform__CISharingSessionMessageReceivedEventArgs": [
        "72d9a31d-d0e9-5738-8155-998e21d4f702"
    ],
    "FITypedEventHandler_2_SharingPlatform__CIInvitationManager_SharingPlatform__CIInvitationEventArgs": [
        "5efcb24a-4566-58f9-a12b-2a1228ddcc35"
    ],
    "FITypedEventHandler_2_SharingPlatform__CISession_SharingPlatform__CIInvitationRequestEventArgs": [
        "edd82829-3b9c-57df-aeb9-8d40dbf21f00"
    ],
    "FITypedEventHandler_2_SharingPlatform__CISession_SharingPlatform__CIParticipantJoinedEventArgs": [
        "4deb0507-da74-5ad3-8c2b-3f15a45d5881"
    ],
    "FITypedEventHandler_2_SharingPlatform__CISession_SharingPlatform__CIParticipantLeftEventArgs": [
        "9be1bd30-b563-5475-8fdd-319dfeb064c4"
    ],
    "FITypedEventHandler_2_SharingPlatform__CISession_SharingPlatform__CISessionStateChangedEventArgs": [
        "61eea13a-3a8c-5f2a-92de-472fa5268a94"
    ],
    "FITypedEventHandler_2_Windows__CApplicationModel__CActivation__CSplashScreen_IInspectable": [
        "7725b2a5-287d-5ed2-a789-2a6a2673c7fe"
    ],
    "FITypedEventHandler_2_Windows__CApplicationModel__CCalls__CPhoneLineWatcher_IInspectable": [
        "d55ce56a-23ac-5185-bf76-2808ec83c78b"
    ],
    "FITypedEventHandler_2_Windows__CApplicationModel__CCalls__CPhoneLineWatcher_Windows__CApplicationModel__CCalls__CPhoneLineWatcherEventArgs": [
        "727cff26-a887-5361-8924-95f7bab4e25d"
    ],
    "FITypedEventHandler_2_Windows__CApplicationModel__CCalls__CPhoneLine_IInspectable": [
        "7c5f5192-9fc0-5543-9bc4-411482e4ea93"
    ],
    "FITypedEventHandler_2_Windows__CApplicationModel__CChat__CChatMessageTransport_Windows__CApplicationModel__CChat__CRcsServiceKindSupportedChangedEventArgs": [
        "2a904076-15f2-5616-9d3b-632ef0d46b18"
    ],
    "FITypedEventHandler_2_Windows__CApplicationModel__CCore__CCoreApplicationViewTitleBar_IInspectable": [
        "28342e21-dad3-5e32-bae1-afe7b26c66fb"
    ],
    "FITypedEventHandler_2_Windows__CApplicationModel__CCore__CCoreApplicationView_Windows__CApplicationModel__CActivation__CIActivatedEventArgs": [
        "cf193a96-eb13-5e3b-8bdf-87b6efae8339"
    ],
    "FITypedEventHandler_2_Windows__CApplicationModel__CCore__CCoreApplicationView_Windows__CApplicationModel__CCore__CHostedViewClosingEventArgs": [
        "d9a3f433-9bcc-54d6-b3cf-7b01f026d4cd"
    ],
    "FITypedEventHandler_2_Windows__CApplicationModel__CDataTransfer__CDataPackage_IInspectable": [
        "c156b0c3-1cbc-5ca4-901c-62c5a8ca5cb5"
    ],
    "FITypedEventHandler_2_Windows__CApplicationModel__CDataTransfer__CDataPackage_Windows__CApplicationModel__CDataTransfer__COperationCompletedEventArgs": [
        "dd48af6c-ef9a-59cb-b326-57d9e2411f21"
    ],
    "FITypedEventHandler_2_Windows__CApplicationModel__CDataTransfer__CDataPackage_Windows__CApplicationModel__CDataTransfer__CShareCompletedEventArgs": [
        "f8f7e24a-56fe-58df-bc15-2365aec03966"
    ],
    "FITypedEventHandler_2_Windows__CApplicationModel__CDataTransfer__CDataTransferManager_Windows__CApplicationModel__CDataTransfer__CDataRequestedEventArgs": [
        "ec6f9cc8-46d0-5e0e-b4d2-7d7773ae37a0"
    ],
    "FITypedEventHandler_2_Windows__CApplicationModel__CDataTransfer__CDataTransferManager_Windows__CApplicationModel__CDataTransfer__CShareProvidersRequestedEventArgs": [
        "147e2860-7397-582f-80db-b8685383a937"
    ],
    "FITypedEventHandler_2_Windows__CApplicationModel__CDataTransfer__CDataTransferManager_Windows__CApplicationModel__CDataTransfer__CTargetApplicationChosenEventArgs": [
        "c4ac1ba2-7851-5a44-bc8d-3d7c713f1f41"
    ],
    "FITypedEventHandler_2_Windows__CApplicationModel__CInternal__CDataTransfer__CIShareAppExtensionActivator_IInspectable": [
        "85192e36-f4fc-51fb-be45-a858a0bc4981"
    ],
    "FITypedEventHandler_2_Windows__CApplicationModel__CInternal__CDataTransfer__CNearShare__CShareReceiverHandler_IInspectable": [
        "3df14611-e7da-5243-9fbf-ebdfceeb2ae4"
    ],
    "FITypedEventHandler_2_Windows__CApplicationModel__CInternal__CDataTransfer__CShareExperience_IInspectable": [
        "7d737708-8f1a-562c-83a6-6721d0b93a0f"
    ],
    "FITypedEventHandler_2_Windows__CApplicationModel__CInternal__CDataTransfer__CShareExperience_Windows__CApplicationModel__CInternal__CDataTransfer__CShareAppExtension": [
        "0a7ad054-9117-51c7-b220-4387fff51a6d"
    ],
    "FITypedEventHandler_2_Windows__CApplicationModel__CInternal__CDataTransfer__CShareExperience_Windows__CApplicationModel__CInternal__CDataTransfer__CSharedToAppExtensionEventArgs": [
        "d9e920a6-7f42-518b-a30a-4c92b09d13b0"
    ],
    "FITypedEventHandler_2_Windows__CApplicationModel__CInternal__CDataTransfer__CShareExperience_Windows__CApplicationModel__CInternal__CDataTransfer__CSharedToShareProviderEventArgs": [
        "ff3574dc-3b3e-5d0b-b9f0-642c4b637eda"
    ],
    "FITypedEventHandler_2_Windows__CApplicationModel__CInternal__CDataTransfer__CSharingOperation_IInspectable": [
        "563e4e0d-b0a2-5e4a-8958-8f3d2be525bd"
    ],
    "FITypedEventHandler_2_Windows__CApplicationModel__CInternal__CDataTransfer__CSharingOperation_Windows__CApplicationModel__CInternal__CDataTransfer__CIErrorOccurredEventArgs": [
        "53f63a10-c9e8-5149-8552-e61b3eb3bdf2"
    ],
    "FITypedEventHandler_2_Windows__CApplicationModel__CSearch__CCore__CSearchSuggestionManager_Windows__CApplicationModel__CSearch__CCore__CRequestingFocusOnKeyboardInputEventArgs": [
        "bb198760-4739-5559-80e6-f0e1af5355fd"
    ],
    "FITypedEventHandler_2_Windows__CApplicationModel__CSearch__CCore__CSearchSuggestionManager_Windows__CApplicationModel__CSearch__CCore__CSearchSuggestionsRequestedEventArgs": [
        "7e7f3cdf-80d9-5646-8743-ec1e38645d68"
    ],
    "FITypedEventHandler_2_Windows__CApplicationModel__CSearch__CSearchPane_Windows__CApplicationModel__CSearch__CSearchPaneQueryChangedEventArgs": [
        "7ccd7da1-8767-5eef-972d-31d09f1bf308"
    ],
    "FITypedEventHandler_2_Windows__CApplicationModel__CSearch__CSearchPane_Windows__CApplicationModel__CSearch__CSearchPaneQuerySubmittedEventArgs": [
        "5f05121b-61a6-5f6b-b007-20816dfe7009"
    ],
    "FITypedEventHandler_2_Windows__CApplicationModel__CSearch__CSearchPane_Windows__CApplicationModel__CSearch__CSearchPaneResultSuggestionChosenEventArgs": [
        "ec31e5d4-3b8c-5757-96bf-14096be946cd"
    ],
    "FITypedEventHandler_2_Windows__CApplicationModel__CSearch__CSearchPane_Windows__CApplicationModel__CSearch__CSearchPaneSuggestionsRequestedEventArgs": [
        "95088dc0-6c14-55b8-8a8f-9df1ca44d1d4"
    ],
    "FITypedEventHandler_2_Windows__CApplicationModel__CSearch__CSearchPane_Windows__CApplicationModel__CSearch__CSearchPaneVisibilityChangedEventArgs": [
        "3975ff72-971b-54b6-9b5f-cc442e2a87f0"
    ],
    "FITypedEventHandler_2_Windows__CDevices__CInput__CMouseDevice_Windows__CDevices__CInput__CMouseEventArgs": [
        "5d72e594-28e4-5895-a34b-ea910f70fdbb"
    ],
    "FITypedEventHandler_2_Windows__CFoundation__CPrivate__CComponentSite_IInspectable": [
        "a1cbb6d1-8b48-58fe-8cbb-0684edcc3536"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CAppResolver__CIAppResolverActivatedArgs_IInspectable": [
        "fc0a819e-738e-54ca-b18b-e846d52db909"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CApplicationModel__CWindowManagement__CAppViewWatcher_IInspectable": [
        "398df093-712d-5869-bf0e-ea6079727a7c"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CApplicationModel__CWindowManagement__CAppViewWatcher_Windows__CInternal__CApplicationModel__CWindowManagement__CAppViewActivationRequestedEventArgs": [
        "6a934e9b-430b-5f39-8e97-67281084bdd6"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CApplicationModel__CWindowManagement__CAppViewWatcher_Windows__CInternal__CApplicationModel__CWindowManagement__CAppViewActivationShowRequestedEventArgs": [
        "5a69146b-9b1a-5091-8e57-1580fdfc958b"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CApplicationModel__CWindowManagement__CAppViewWatcher_Windows__CInternal__CApplicationModel__CWindowManagement__CAppViewChangedEventArgs": [
        "5ce6216a-8add-5b73-82b5-9fa6feddcddb"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CApplicationModel__CWindowManagement__CAppViewWatcher_Windows__CInternal__CApplicationModel__CWindowManagement__CAppViewExecutionStateChangedEventArgs": [
        "4f82e701-1352-5464-9e9d-6861d1b021a7"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CApplicationModel__CWindowManagement__CAppViewWatcher_Windows__CInternal__CApplicationModel__CWindowManagement__CAppViewInputStateChangedEventArgs": [
        "7909ef45-76d7-52db-9918-dc35fa1f8247"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CApplicationModel__CWindowManagement__CAppViewWatcher_Windows__CInternal__CApplicationModel__CWindowManagement__CAppViewShowRequestedEventArgs": [
        "030b3fc6-a1af-515b-bd66-5efdbb526f92"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CApplicationModel__CWindowManagement__CAppViewWatcher_Windows__CInternal__CApplicationModel__CWindowManagement__CAppViewSilverlightPropertyChangedEventArgs": [
        "be0303ef-9b8e-5fa8-96d3-de20f3b8842c"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CApplicationModel__CWindowManagement__CAppViewWatcher_Windows__CInternal__CApplicationModel__CWindowManagement__CAppViewSplashPropertyChangedEventArgs": [
        "bcdfb34e-c6d2-5208-ba15-3e6b80a692ca"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CApplicationModel__CWindowManagement__CAppViewWatcher_Windows__CInternal__CApplicationModel__CWindowManagement__CAppViewSwitchRequestedEventArgs": [
        "3dd54791-5ae7-5686-a7b8-3bd3221ca892"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CApplicationModel__CWindowManagement__CAppViewWatcher_Windows__CInternal__CApplicationModel__CWindowManagement__CAppViewUniversalPropertyChangedEventArgs": [
        "dc73ab32-c518-58f2-a6aa-4af67a7479aa"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CApplicationModel__CWindowManagement__CAppViewWatcher_Windows__CInternal__CApplicationModel__CWindowManagement__CAppViewVisibilityChangedEventArgs": [
        "c8596c50-6cae-5d90-b7f5-c624355a678c"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CApplicationModel__CWindowManagement__CAppViewWatcher_Windows__CInternal__CApplicationModel__CWindowManagement__CIAppViewChangedEventArgs": [
        "e35049a5-aa89-5bd5-896a-730656e1273f"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CApplicationModel__CWindowManagement__CWindowWatcher_IInspectable": [
        "fbeba321-f5c5-58c2-aaf8-c028231b2f47"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CApplicationModel__CWindowManagement__CWindowWatcher_Windows__CInternal__CApplicationModel__CWindowManagement__CWindowChangedEventArgs": [
        "07897eb6-ef65-59dc-b8b5-d91cfed1f0c7"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CApplicationModel__CWindowManagement__CWindowWatcher_Windows__CInternal__CApplicationModel__CWindowManagement__CWindowForegroundChangedEventArgs": [
        "deb3ac18-4cfc-5d67-bcc8-3cf362e17176"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CApplicationModel__CWindowManagement__CWindowWatcher_Windows__CInternal__CApplicationModel__CWindowManagement__CWindowVisibilityChangedEventArgs": [
        "6c5566a0-1da1-59de-90e4-311cc734c648"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CBackupRestore__CSettingsProviders__CIAddTargetCapability_IInspectable": [
        "712c87d1-ac48-5925-ac7c-77b681a24692"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CIVirtualizedVector_IInspectable": [
        "2f4ee019-e8a5-5a02-8d2a-419bc85dc8b2"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CSecurity__CAuthentication__CWeb__CTokenBrokerInternal_Windows__CInternal__CSecurity__CAuthentication__CWeb__CWebAccountAddedEventArgs": [
        "c092cc2f-5eca-5a5d-9c9c-f050e892dd97"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CSecurity__CAuthentication__CWeb__CTokenBrokerInternal_Windows__CInternal__CSecurity__CAuthentication__CWeb__CWebAccountChangedEventArgs": [
        "dc8b9f35-216c-54ff-99db-cd7e04c6a074"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CSecurity__CAuthentication__CWeb__CTokenBrokerInternal_Windows__CInternal__CSecurity__CAuthentication__CWeb__CWebAccountDeletePendingEventArgs": [
        "104e5d12-179f-597c-80ce-18627ceeb8b6"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CSecurity__CAuthentication__CWeb__CTokenBrokerInternal_Windows__CInternal__CSecurity__CAuthentication__CWeb__CWebAccountDeletedEventArgs": [
        "df3657fc-19c8-5e99-b48f-4a59b98d4e8a"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CSecurity__CAuthentication__CWeb__CTokenBrokerInternal_Windows__CInternal__CSecurity__CAuthentication__CWeb__CWebAccountProviderAddedEventArgs": [
        "842f9cfd-1d05-5cbe-ae94-3ab74e672446"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CSecurity__CAuthentication__CWeb__CTokenBrokerInternal_Windows__CInternal__CSecurity__CAuthentication__CWeb__CWebAccountProviderChangedEventArgs": [
        "50ce6ccb-94b2-5a0b-8841-3639c33d1467"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CSecurity__CAuthentication__CWeb__CTokenBrokerInternal_Windows__CInternal__CSecurity__CAuthentication__CWeb__CWebAccountProviderDeletedEventArgs": [
        "790534dc-1918-5d1f-92c5-09390ee109c5"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CShellComponentSettings__CNavigationBarSettings_Windows__CInternal__CShellComponentSettings__CSettingsChangeEventArgs": [
        "2a131cc9-faf5-5f77-b74d-b9bf9fded52c"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CShell__CDesktop__CViewManagerInterop__CIObjectWithVisibility_Windows__CInternal__CShell__CDesktop__CViewManagerInterop__CIVisibilityChangedEventArgs": [
        "ddf8df0d-f27d-5b03-8a0a-2024ae23200d"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CShell__CExperience__CActionCenterExperienceManager_IInspectable": [
        "e970dc6e-8e87-5d0e-b1c3-418983ebf313"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CShell__CExperience__CCortanaExperienceManager_IInspectable": [
        "8c3747a8-c17f-5244-bf7f-b0def1bcb3b3"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CShell__CExperience__CCortanaExperienceManager_Windows__CInternal__CShell__CExperience__CICortanaShownEventArgs": [
        "5f55fc43-98da-50b4-a85c-5a270fb53933"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CShell__CExperience__CCortanaExperienceManager_Windows__CInternal__CShell__CExperience__CIFocusNavigateEventArgs": [
        "ca92c148-f3da-5773-8c5f-5b48eff74423"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CShell__CExperience__CCortanaExperienceManager_int": [
        "6373ab33-0d8c-55e9-8119-5226c919ed56"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CShell__CExperience__CDevicePickerExperienceManager_IInspectable": [
        "2c81f7f2-bba6-5111-aa7f-80c20bcd02ba"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CShell__CExperience__CIShellExperienceView_Windows__CInternal__CShell__CExperience__CIShellExperienceViewChangedArg": [
        "c7cb8998-38d6-5814-b6b0-9afbe92490b3"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CShell__CExperience__CIShellExperienceView_Windows__CInternal__CShell__CExperience__CIShellExperienceViewEventArg": [
        "207476a9-4bee-509c-86b6-98be78d897b9"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CShell__CExperience__CJumpViewExperienceManager_Windows__CInternal__CShell__CExperience__CJumpViewExperienceEventArgs": [
        "28536166-c75b-5df1-99ca-96967f7d999a"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CShell__CExperience__CShellExperienceDispatcher_Windows__CInternal__CShell__CExperience__CIShellExperienceViewStateChangedEventArgs": [
        "6592b66a-4a51-5ccc-82c5-9042acf93a44"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CShell__CExperience__CShellExperienceStart_Windows__CInternal__CShell__CExperience__CShellModeChangedEventArgs": [
        "62135944-7c39-59db-be5f-698ffff1b7b2"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CShell__CExperience__CShellExperienceStart_Windows__CInternal__CShell__CExperience__CStartExperienceAnimationRequestedEventArgs": [
        "e5e30a1f-ea5c-5621-a565-19b03f69eec6"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CShell__CExperience__CShellExperience_Windows__CInternal__CShell__CExperience__CShellExperienceReactivatedEventArgs": [
        "4edb8aae-aa1f-5654-a3b5-caa7d2903586"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CShell__CExperience__CStartExperienceManager_IInspectable": [
        "f4a345a3-fb95-5cfa-8fca-beddf290d08a"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CShell__CExperience__CStartExperienceManager_int": [
        "3a704c3d-32f2-5ed8-96fe-b5f870360f6e"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CShell__CExperience__CWelcomeScreenExperienceManager_IInspectable": [
        "76ea518f-8e9c-5dc4-97f3-1dfccb23e6e0"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CShell__CHolographic__CIViewHostItem_Windows__CInternal__CShell__CHolographic__CIViewHostItemEventArgs": [
        "d751e20a-9eb1-5432-b47a-399f5fb761c2"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CShell__CJumpView__CJumpViewExperienceWrapper_HSTRING": [
        "4b5a05a6-61f9-520f-9893-f3b47ba090cf"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CShell__CModalExperience__CIModalWindowExperienceManager_Windows__CInternal__CShell__CModalExperience__CIModalExperienceEventArgs": [
        "f6834c1c-7fd2-59bb-bfa3-f48f7e1a6cc6"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CShell__CPopups__CPopupClient_Windows__CInternal__CShell__CPopups__CPopupClientPropertyChangedEventArgs": [
        "83b33293-dd08-5235-b7c1-2ceaa7672ad5"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CShell__CViewManagerInterop__CIClientWindowState_IInspectable": [
        "cef8cd8b-9cbb-5f2d-a1cc-fee13c39e6ba"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CShell__CViewManagerInterop__CIClientWindowState_Windows__CInternal__CShell__CViewManagerInterop__CIClientWindowPrepareForPresentationChangedEventArgs": [
        "aa6f11c0-2b34-564e-a791-a90cb576d55f"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CShell__CViewManagerInterop__CIClientWindowState_Windows__CInternal__CShell__CViewManagerInterop__CIClientWindowReadyForPresentationChangedEventArgs": [
        "8cecdf70-ced8-5bc7-84a7-d80615fedcdd"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CShell__CViewManagerInterop__CIForegroundManager_Windows__CInternal__CShell__CViewManagerInterop__CIForegroundViewChangedEventArgs": [
        "c786210f-b588-5cf0-a587-d9c7fb6195a4"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CShell__CViewManagerInterop__CIForegroundManager_Windows__CInternal__CShell__CViewManagerInterop__CISelectViewToActivateForHitTestEventArgs": [
        "c96138cc-bae3-5f4b-a448-4fbbe4f564b5"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CShell__CViewManagerInterop__CIViewEventDispatcher_Windows__CInternal__CShell__CViewManagerInterop__CIUserLogoffCompleteEventArgs": [
        "10c2a12c-1cc4-516c-9b1d-1edd8206220a"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CShell__CViewManagerInterop__CIViewEventDispatcher_Windows__CInternal__CShell__CViewManagerInterop__CIViewEventDispatcherReadyChangedEventArgs": [
        "ae8a65be-d6ce-5521-b2c9-867dc6d2f33e"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CShell__CViewManagerInterop__CIViewWrapper_Windows__CInternal__CShell__CViewManagerInterop__CIViewEventArgs": [
        "d1b9407f-a351-5319-bce5-178ee5585391"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CShell__CViewManagerInterop__CIViewWrapper_Windows__CInternal__CShell__CViewManagerInterop__CIViewHandledEventArgs": [
        "067c572c-3d80-58c9-807a-311aafdc58b6"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CStorage__CFileOperation_Windows__CInternal__CStorage__CFileOperationStatus": [
        "6b7584dd-5381-55d9-8fa6-33b86bb4f810"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CUI__CCloseRequest_Windows__CInternal__CUI__CCloseRequestedEventArgs": [
        "2491e7f1-0ff2-5536-b711-4cfdda5802f3"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CUI__CShutdown__CShutdownUXViewModel_Windows__CInternal__CUI__CShutdown__CShutdownChoice": [
        "fc7897b2-94a8-5848-8953-321fb26a5299"
    ],
    "FITypedEventHandler_2_Windows__CInternal__CUI__CShutdown__CShutdownUXViewModel_Windows__CInternal__CUI__CShutdown__CShutdownView": [
        "c9c87c56-0624-5c39-b08d-568959968f8e"
    ],
    "FITypedEventHandler_2_Windows__CMedia__CSpeech__CSpeechSupportedLanguage_Windows__CMedia__CSpeech__CSpeechSupportedLanguageStateChangedEventArgs": [
        "38adb60a-7c3b-56ea-852b-76febdfa0524"
    ],
    "FITypedEventHandler_2_Windows__CNetworking__CPushNotifications__CPushNotificationChannel_Microsoft__CPushNotifications__CInternal__CPushConnectionStatusChangedEventArgs": [
        "816efc7d-b90b-551f-ae4c-ce1f75a3d067"
    ],
    "FITypedEventHandler_2_Windows__CNetworking__CUX__CIWiFiUXCategory_IInspectable": [
        "49d30cf4-df00-5ff2-9428-edda3af3a295"
    ],
    "FITypedEventHandler_2_Windows__CStorage__CAccessCache__CStorageItemMostRecentlyUsedList_Windows__CStorage__CAccessCache__CItemRemovedEventArgs": [
        "029dace8-98d1-5bf7-b780-9717e95027ff"
    ],
    "FITypedEventHandler_2_Windows__CStorage__CBulkAccess__CIStorageItemInformation_IInspectable": [
        "5b98b352-e0cf-58de-b2ec-4fd786bbb5a7"
    ],
    "FITypedEventHandler_2_Windows__CStorage__CInternal__CPickers__CCachedFileUpdaterBasket_IInspectable": [
        "aeb0205d-7e41-565b-b00e-79fa1d0b513e"
    ],
    "FITypedEventHandler_2_Windows__CStorage__CInternal__CPickers__CCachedFileUpdaterOperation_Windows__CStorage__CInternal__CPickers__CPickerOperationCompletedEventArgs": [
        "ebe145f7-5c0d-5fcb-a15e-c09cc34e35f2"
    ],
    "FITypedEventHandler_2_Windows__CStorage__CInternal__CPickers__CFileOpenPickerBasket_IInspectable": [
        "ee8d5f2d-1e70-5115-875f-4bbb274eaaec"
    ],
    "FITypedEventHandler_2_Windows__CStorage__CInternal__CPickers__CFileOpenPickerBasket_Windows__CStorage__CInternal__CPickers__CBasketItemAddedEventArgs": [
        "f2945242-8238-5e49-bd37-f75d5888368f"
    ],
    "FITypedEventHandler_2_Windows__CStorage__CInternal__CPickers__CFileOpenPickerBasket_Windows__CStorage__CInternal__CPickers__CBasketItemRemovedEventArgs": [
        "911db0d3-43b4-5e19-9e0f-6b34a1deccd0"
    ],
    "FITypedEventHandler_2_Windows__CStorage__CInternal__CPickers__CFileOpenPickerOperation_Windows__CStorage__CInternal__CPickers__CPickerOperationCompletedEventArgs": [
        "16f5b50a-4f18-5ed6-a046-bb7a4ce55c8d"
    ],
    "FITypedEventHandler_2_Windows__CStorage__CInternal__CPickers__CFileSavePickerBasket_IInspectable": [
        "81fe57e4-9430-5888-907a-2e0fe235d8aa"
    ],
    "FITypedEventHandler_2_Windows__CStorage__CInternal__CPickers__CFileSavePickerBasket_Windows__CStorage__CInternal__CPickers__CSaveFileNameChangeRequestedEventArgs": [
        "4068d2ad-fcfe-50ac-85de-a7dc52dc3811"
    ],
    "FITypedEventHandler_2_Windows__CStorage__CInternal__CPickers__CFileSavePickerOperation_Windows__CStorage__CInternal__CPickers__CPickerOperationCompletedEventArgs": [
        "79690658-a3a6-5636-bb74-4a3986785821"
    ],
    "FITypedEventHandler_2_Windows__CStorage__CPickers__CProvider__CFileOpenPickerUIInternal_IInspectable": [
        "5efc9172-d33b-560d-9a57-cd1f42d89974"
    ],
    "FITypedEventHandler_2_Windows__CStorage__CPickers__CProvider__CFileOpenPickerUIInternal_Windows__CStorage__CPickers__CProvider__CCurrentLocationRequestedEventArgs": [
        "2250a95a-151c-5a22-acd4-bd26e5ea6d70"
    ],
    "FITypedEventHandler_2_Windows__CStorage__CPickers__CProvider__CFileOpenPickerUI_Windows__CStorage__CPickers__CProvider__CFileRemovedEventArgs": [
        "f1fb2939-695b-5f56-841a-a52a7d148572"
    ],
    "FITypedEventHandler_2_Windows__CStorage__CPickers__CProvider__CFileOpenPickerUI_Windows__CStorage__CPickers__CProvider__CPickerClosingEventArgs": [
        "2b06bdac-983b-5552-b5c9-b0990a2db3a1"
    ],
    "FITypedEventHandler_2_Windows__CStorage__CPickers__CProvider__CFileSavePickerUIInternal_IInspectable": [
        "b3a53f8c-81c0-5ec6-86ab-93a811448271"
    ],
    "FITypedEventHandler_2_Windows__CStorage__CPickers__CProvider__CFileSavePickerUI_IInspectable": [
        "f1e6a632-f97f-54d9-9e1b-a714edc3ff06"
    ],
    "FITypedEventHandler_2_Windows__CStorage__CPickers__CProvider__CFileSavePickerUI_Windows__CStorage__CPickers__CProvider__CTargetFileRequestedEventArgs": [
        "d3e1f8c7-45c5-5249-b336-a111bfaa985b"
    ],
    "FITypedEventHandler_2_Windows__CStorage__CProvider__CCachedFileUpdaterUI_IInspectable": [
        "45fdd443-c0b9-57b0-a84f-7d876edc3149"
    ],
    "FITypedEventHandler_2_Windows__CStorage__CProvider__CCachedFileUpdaterUI_Windows__CStorage__CProvider__CFileUpdateRequestedEventArgs": [
        "ed56ab72-ebd3-52c8-b0ac-987d30090351"
    ],
    "FITypedEventHandler_2_Windows__CStorage__CSearch__CIStorageQueryResultBase_IInspectable": [
        "4ba22861-00c4-597f-b6bf-3af516f3b870"
    ],
    "FITypedEventHandler_2_Windows__CStorage__CStorageLibrary_IInspectable": ["edc09538-bbae-5b2b-9e81-b449ea7e48fe"],
    "FITypedEventHandler_2_Windows__CUI__CCore__CCoreComponentInputSource_Windows__CUI__CCore__CClosestInteractiveBoundsRequestedEventArgs": [
        "e2c62d42-0577-5112-9e59-eae159bf39e9"
    ],
    "FITypedEventHandler_2_Windows__CUI__CCore__CCoreDispatcher_Windows__CUI__CCore__CAcceleratorKeyEventArgs": [
        "136dff0d-f7e8-5153-b31c-86390c701880"
    ],
    "FITypedEventHandler_2_Windows__CUI__CCore__CCoreWindowSite_Windows__CUI__CCore__CComponentWindowActivatedEventArgs": [
        "6be4f3e3-d3d4-5578-a27a-ddbffcac8b02"
    ],
    "FITypedEventHandler_2_Windows__CUI__CCore__CCoreWindowSite_Windows__CUI__CCore__CNavigationFocusEventArgs": [
        "e0651831-8e29-5111-98b8-4b621ef71808"
    ],
    "FITypedEventHandler_2_Windows__CUI__CCore__CCoreWindow_IInspectable": ["6368ae3d-52d4-5290-b936-717a9acf5bea"],
    "FITypedEventHandler_2_Windows__CUI__CCore__CCoreWindow_Windows__CUI__CCore__CApplicationViewConsolidatedEventArgsInternal": [
        "3aacfcab-c204-5b53-a7e2-58d1a57c260d"
    ],
    "FITypedEventHandler_2_Windows__CUI__CCore__CCoreWindow_Windows__CUI__CCore__CAutomationProviderRequestedEventArgs": [
        "54db5c04-81f7-5f46-9fb8-e49beec70a24"
    ],
    "FITypedEventHandler_2_Windows__CUI__CCore__CCoreWindow_Windows__CUI__CCore__CCharacterReceivedEventArgs": [
        "73f846a8-0af6-5872-8fb8-ae2f56d8553e"
    ],
    "FITypedEventHandler_2_Windows__CUI__CCore__CCoreWindow_Windows__CUI__CCore__CClosestInteractiveBoundsRequestedEventArgs": [
        "21a652d2-bfe2-5b2e-a2ab-ca45253be8b0"
    ],
    "FITypedEventHandler_2_Windows__CUI__CCore__CCoreWindow_Windows__CUI__CCore__CComponentDisplayInformationChangedEventArgs": [
        "560bdf38-2857-594f-b379-7336171ebdca"
    ],
    "FITypedEventHandler_2_Windows__CUI__CCore__CCoreWindow_Windows__CUI__CCore__CContextMenuRequestedEventArgs": [
        "424a7a1d-5575-5a99-94ae-f051e10793a5"
    ],
    "FITypedEventHandler_2_Windows__CUI__CCore__CCoreWindow_Windows__CUI__CCore__CCoreWindowEventArgs": [
        "d08e4f66-3457-57f2-ba0c-cb347133bd15"
    ],
    "FITypedEventHandler_2_Windows__CUI__CCore__CCoreWindow_Windows__CUI__CCore__CCoreWindowPopupShowingEventArgs": [
        "b32d6422-78b2-5e00-84a8-6e3167aaabde"
    ],
    "FITypedEventHandler_2_Windows__CUI__CCore__CCoreWindow_Windows__CUI__CCore__CDisplayChangedEventArgs": [
        "b87a8ffa-0358-50a4-accb-4fa016957903"
    ],
    "FITypedEventHandler_2_Windows__CUI__CCore__CCoreWindow_Windows__CUI__CCore__CInputDelegatedEventArgs": [
        "1d5ca873-9576-5dd2-a3de-b3c8ee678f03"
    ],
    "FITypedEventHandler_2_Windows__CUI__CCore__CCoreWindow_Windows__CUI__CCore__CInputEnabledEventArgs": [
        "e230a64a-506a-59c3-bb61-5559ff995663"
    ],
    "FITypedEventHandler_2_Windows__CUI__CCore__CCoreWindow_Windows__CUI__CCore__CKeyEventArgs": [
        "a3ec0774-55ac-5d61-8232-b35c5d35c93c"
    ],
    "FITypedEventHandler_2_Windows__CUI__CCore__CCoreWindow_Windows__CUI__CCore__CNavigationFocusEventArgs": [
        "afa44231-7446-5ab4-81f3-8c3166d8e604"
    ],
    "FITypedEventHandler_2_Windows__CUI__CCore__CCoreWindow_Windows__CUI__CCore__CPointerEventArgs": [
        "420e1bb6-e99d-5e64-8e25-07467e3cae9e"
    ],
    "FITypedEventHandler_2_Windows__CUI__CCore__CCoreWindow_Windows__CUI__CCore__CSettingChangedEventArgs": [
        "d3147847-8d69-5746-8a25-16fa4713403b"
    ],
    "FITypedEventHandler_2_Windows__CUI__CCore__CCoreWindow_Windows__CUI__CCore__CTouchHitTestingEventArgs": [
        "197654c9-0c47-502b-9aa1-0deb03ed9702"
    ],
    "FITypedEventHandler_2_Windows__CUI__CCore__CCoreWindow_Windows__CUI__CCore__CViewStateChangedEventArgs": [
        "1338640c-b0a7-5092-a369-8b07127a2dce"
    ],
    "FITypedEventHandler_2_Windows__CUI__CCore__CCoreWindow_Windows__CUI__CCore__CVisibilityChangedEventArgs": [
        "14b7f692-5583-52a1-aa42-fc1843c0f748"
    ],
    "FITypedEventHandler_2_Windows__CUI__CCore__CCoreWindow_Windows__CUI__CCore__CWindowActivatedEventArgs": [
        "26a73b35-a7f9-52db-88d6-15726deb2523"
    ],
    "FITypedEventHandler_2_Windows__CUI__CCore__CCoreWindow_Windows__CUI__CCore__CWindowSizeChangedEventArgs": [
        "318dbb67-4089-5690-9040-1d454fb2f686"
    ],
    "FITypedEventHandler_2_Windows__CUI__CCore__CIComponentFocus_Windows__CUI__CCore__CFocusEventArgs": [
        "89248efa-a247-5acf-93f3-2cb7d44dd260"
    ],
    "FITypedEventHandler_2_Windows__CUI__CCore__CICoreAccelerators_Windows__CUI__CCore__CAcceleratorKeyEventArgs": [
        "67022807-c4c4-5c8b-abe9-545c4fdbe8e1"
    ],
    "FITypedEventHandler_2_Windows__CUI__CCore__CICorePointerRedirector_Windows__CUI__CCore__CPointerEventArgs": [
        "29742d27-177d-54c3-b974-616fc45a2b0c"
    ],
    "FITypedEventHandler_2_Windows__CUI__CInput__CEdgeGesture_Windows__CUI__CInput__CEdgeGestureEventArgs": [
        "b62d7f11-c7b1-5bf0-a347-3366252db4ce"
    ],
    "FITypedEventHandler_2_Windows__CUI__CInput__CGestureRecognizer_Windows__CUI__CInput__CCrossSlidingEventArgs": [
        "1fc1eb70-0c26-5cf0-9e50-843a34083613"
    ],
    "FITypedEventHandler_2_Windows__CUI__CInput__CGestureRecognizer_Windows__CUI__CInput__CDraggingEventArgs": [
        "be7cca42-98dd-5d72-9e91-976113d7985e"
    ],
    "FITypedEventHandler_2_Windows__CUI__CInput__CGestureRecognizer_Windows__CUI__CInput__CHoldingEventArgs": [
        "0027bdf5-6948-53f7-afbe-d4d8fe500feb"
    ],
    "FITypedEventHandler_2_Windows__CUI__CInput__CGestureRecognizer_Windows__CUI__CInput__CManipulationCompletedEventArgs": [
        "c24f5605-3059-52cc-bdf3-7098146d34d7"
    ],
    "FITypedEventHandler_2_Windows__CUI__CInput__CGestureRecognizer_Windows__CUI__CInput__CManipulationInertiaStartingEventArgs": [
        "350a72ab-34a5-5193-913d-3d4c5983842c"
    ],
    "FITypedEventHandler_2_Windows__CUI__CInput__CGestureRecognizer_Windows__CUI__CInput__CManipulationStartedEventArgs": [
        "110d75c8-ba5e-5462-8b2d-4a1582574b61"
    ],
    "FITypedEventHandler_2_Windows__CUI__CInput__CGestureRecognizer_Windows__CUI__CInput__CManipulationUpdatedEventArgs": [
        "eb5216f5-020a-5e40-9c4b-48912c690e2d"
    ],
    "FITypedEventHandler_2_Windows__CUI__CInput__CGestureRecognizer_Windows__CUI__CInput__CRightTappedEventArgs": [
        "8420d242-ba34-5b17-92f3-8f767f1d0de4"
    ],
    "FITypedEventHandler_2_Windows__CUI__CInput__CGestureRecognizer_Windows__CUI__CInput__CTappedEventArgs": [
        "27f3ad57-8994-5712-8b83-a93ba17c03c2"
    ],
    "FITypedEventHandler_2_Windows__CUI__CInput__CKeyboardDeliveryInterceptor_Windows__CUI__CCore__CKeyEventArgs": [
        "2c1caf11-9d6f-5e0f-a9ea-4c7c734d73d6"
    ],
    "FITypedEventHandler_2_Windows__CUI__CInput__CRadialController_Windows__CUI__CInput__CRadialControllerScreenContactEndedEventArgs": [
        "f131de09-4dbe-515d-b618-6b4f093f15ef"
    ],
    "FITypedEventHandler_2_Windows__CUI__CInternal__CPopups__CMessageDialogOperation_Windows__CUI__CInternal__CPopups__CMessageDialogOperationCompletedEventArgs": [
        "d498e8cd-bc7e-591c-bb3e-fc1398f5c538"
    ],
    "FITypedEventHandler_2_Windows__CUI__CInternal__CPopups__CPopupMenuOperation_Windows__CUI__CInternal__CPopups__CPopupMenuOperationCompletedEventArgs": [
        "3a0021d9-b265-55ae-9563-eea826405ebb"
    ],
    "FITypedEventHandler_2_Windows__CUI__CSearch__CInternal__CCommon__CIBindableObservableItemCollection_Windows__CUI__CSearch__CInternal__CCommon__CIItemCollectionChangedEventArgs": [
        "244ed887-e63a-50c4-b946-bd76eb3280d4"
    ],
    "FITypedEventHandler_2_Windows__CUI__CSearch__CInternal__CGlobalSuggestions__CGlobalSuggestionsCollection_UINT32": [
        "6a1bcb15-c19e-5ee1-ab67-d703fa807381"
    ],
    "FITypedEventHandler_2_Windows__CUI__CViewManagement__CAccessibilitySettings_IInspectable": [
        "f5917e6f-5abf-5e65-b5b4-1b9c8d94e788"
    ],
    "FITypedEventHandler_2_Windows__CUI__CViewManagement__CApplicationView_IInspectable": [
        "00c1f983-c836-565c-8bbf-7053055bdb4c"
    ],
    "FITypedEventHandler_2_Windows__CUI__CViewManagement__CApplicationView_Windows__CUI__CViewManagement__CApplicationViewConsolidatedEventArgs": [
        "463c606a-8c82-5a29-a2bd-040781f25348"
    ],
    "FITypedEventHandler_2_Windows__CUI__CViewManagement__CInputPane_Windows__CUI__CViewManagement__CInputPaneVisibilityEventArgs": [
        "b813d684-d953-5a8a-9b30-78b79fb9147b"
    ],
    "FITypedEventHandler_2_Windows__CUI__CViewManagement__CUISettings_IInspectable": [
        "2dbdba9d-20da-519d-9078-09f835bc5bc7"
    ],
    "FITypedEventHandler_2_Windows__CUI__CViewManagement__CUISettings_Windows__CUI__CViewManagement__CUISettingsAnimationsEnabledChangedEventArgs": [
        "deff0f90-59e1-5859-a245-3d275081c2ad"
    ],
    "FITypedEventHandler_2_Windows__CUI__CViewManagement__CUISettings_Windows__CUI__CViewManagement__CUISettingsAutoHideScrollBarsChangedEventArgs": [
        "808aef30-2660-51b0-9c11-f75dd42006b4"
    ],
    "FITypedEventHandler_2_Windows__CUI__CViewManagement__CUISettings_Windows__CUI__CViewManagement__CUISettingsMessageDurationChangedEventArgs": [
        "ec807b08-1ac6-5b37-9af7-1aaf1c93577e"
    ],
    "FITypedEventHandler_2_Windows__CUI__CWindowManagement__CDisplayRegion_IInspectable": [
        "4a24205c-ae81-533e-9cf2-20c3bd8656f6"
    ],
    "FITypedEventHandler_2_Windows__CUI__CWindowManagement__CWindowingEnvironment_IInspectable": [
        "4b71293f-8229-5370-b9e4-8ed8723b45dd"
    ],
    "FITypedEventHandler_2_Windows__CUI__CWindowManagement__CWindowingEnvironment_Windows__CUI__CWindowManagement__CWindowingEnvironmentChangedEventArgs": [
        "16b1a412-6e19-5f2b-9e85-fa92cab202bc"
    ],
    "FIVectorView_1_ContentManagement__CAppInstallInfoRecord": ["e3e5794e-6220-5c66-bd02-60ce159d9506"],
    "FIVectorView_1_ContentManagement__CTargetedContent__CTargetedContentItem": [
        "8f383740-b03d-5c3f-b1c5-5b38fde4e942"
    ],
    "FIVectorView_1_PhoneInternal__CExperiences__CSync__CAccount": ["23a1f5e5-53e0-574d-8f6a-aba20c56a508"],
    "FIVectorView_1_PhoneInternal__CExperiences__CSync__CAccountSyncContentType": [
        "9dc3982b-b9c1-5f9c-98b9-115afbd80afc"
    ],
    "FIVectorView_1_PhoneInternal__CExperiences__CSync__CPartnershipType": ["3a5a628d-f925-5b01-9a29-ab552d2f35a0"],
    "FIVectorView_1_SharingPlatform__CIDeviceIdentifier": ["03a0df9d-e9cb-5574-a086-bc60c34be3d3"],
    "FIVectorView_1_SharingPlatform__CIParticipantIdentifier": ["9ba151e2-233b-5318-ba04-9675519e2789"],
    "FIVectorView_1_SharingPlatform__CISessionIdentifier": ["b49f07ad-96bc-59d0-9b93-3b7503895a14"],
    "FIVectorView_1_UINT64": ["23d156c7-7ef9-5096-aaba-1e6c9ab5ceb4"],
    "FIVectorView_1_Windows__CApplicationModel__CAppointments__CAppointmentStore": [
        "6b5af8d1-8118-5d8a-8b54-be15553769a0"
    ],
    "FIVectorView_1_Windows__CApplicationModel__CBackground__CIBackgroundTaskYieldable": [
        "4808d005-d473-5341-a69f-f9c5a933337d"
    ],
    "FIVectorView_1_Windows__CApplicationModel__CBackground__CIBrokerConditionBuilder": [
        "5d1c4b7b-9b70-51f9-80ac-cb49e3eea04d"
    ],
    "FIVectorView_1_Windows__CApplicationModel__CContacts__CInternal__CIContactActionControl": [
        "b0e65ef3-6916-53ff-a47c-d220830e1cb4"
    ],
    "FIVectorView_1_Windows__CApplicationModel__CContacts__CInternal__CIContactActionControlItem": [
        "4acb3252-1b1a-5370-abdf-b0a4fe433e60"
    ],
    "FIVectorView_1_Windows__CApplicationModel__CContacts__CInternal__CIContactDisplayInformation": [
        "53ac34f4-02cf-5b7e-bf3f-c1434f5f079e"
    ],
    "FIVectorView_1_Windows__CApplicationModel__CCore__CCoreApplicationView": ["de9e16c4-1b7c-5126-b1d8-7cd04f13bd08"],
    "FIVectorView_1_Windows__CApplicationModel__CDataTransfer__CClipboardHistoryItem": [
        "c91de16d-13ff-55b0-897d-18a131d57ac9"
    ],
    "FIVectorView_1_Windows__CApplicationModel__CDataTransfer__CShareProvider": [
        "946537a2-932c-5b77-ab36-b70650f0bcd5"
    ],
    "FIVectorView_1_Windows__CApplicationModel__CInternal__CDataTransfer__CShareAppExtension": [
        "7e3b269b-779a-507e-bc1b-c0f267bb5775"
    ],
    "FIVectorView_1_Windows__CApplicationModel__CInternal__CStartupTaskInternal": [
        "887a2f49-8225-56ee-bb8b-98e3e5180472"
    ],
    "FIVectorView_1_Windows__CApplicationModel__CSearch__CCore__CSearchSuggestion": [
        "05ac2ec0-f0c8-5cad-b4f9-f985e0f79fe9"
    ],
    "FIVectorView_1_Windows__CApplicationModel__CUserDataAccounts__CSystemAccess__CDeviceAccountConfiguration": [
        "583fa489-106e-5351-910e-567f271031a7"
    ],
    "FIVectorView_1_Windows__CDevices__CEnumeration__CDeviceWatcherEventKind": ["fb7a93ea-caad-59be-8c31-18ebc3ace6cc"],
    "FIVectorView_1_Windows__CDevices__CInput__CPointerDevice": ["cf5674f1-9808-5a2b-80b8-5684ed0ea816"],
    "FIVectorView_1_Windows__CDevices__CInput__CPointerDeviceUsage": ["8e5a2c7e-3830-50d5-92ba-3163c89cbbd0"],
    "FIVectorView_1_Windows__CInternal__CApplicationModel__CWindowManagement__CAppView": [
        "abdd652d-805a-530b-8980-a88abc82d313"
    ],
    "FIVectorView_1_Windows__CInternal__CApplicationModel__CWindowManagement__CAppViewId": [
        "3c718b3f-bdd8-5fc0-a1ca-9560a047802a"
    ],
    "FIVectorView_1_Windows__CInternal__CApplicationModel__CWindowManagement__CWindow": [
        "60899686-c1cb-5c6d-9bc3-1299b573422b"
    ],
    "FIVectorView_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIBackupFrequency": [
        "9a743050-9d7e-5f0e-b6b3-268880a3bca1"
    ],
    "FIVectorView_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIBackupRelatedActionItem": [
        "a21aba16-e8b0-5dc4-941d-39cd7186bbde"
    ],
    "FIVectorView_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIBackupSettingsProvider": [
        "9d081338-4955-5a20-964d-29c64a095124"
    ],
    "FIVectorView_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIBackupTargetItem": [
        "4cf64f4f-fe98-5281-99fb-d7ad25f839d5"
    ],
    "FIVectorView_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIEnumBackupsProvider": [
        "6f9dc897-f533-5a72-946d-0bac47120bc6"
    ],
    "FIVectorView_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIFolderBackupScopeItem": [
        "42d74087-098e-59db-bf3f-25dfb148a863"
    ],
    "FIVectorView_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIManualCleanupOption": [
        "073ad92f-d3ba-5bd6-a00b-7a6b19c5fdf0"
    ],
    "FIVectorView_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIRetentionListItem": [
        "4fd9d425-b05c-5882-b055-141851f0b16d"
    ],
    "FIVectorView_1_Windows__CInternal__CBindableObservableItem": ["796a555e-dc7f-5495-b3b4-cdcd443a538c"],
    "FIVectorView_1_Windows__CInternal__CFeedback__CFeedbackItem": ["268ffc22-2dd6-539a-bdad-b910cc444251"],
    "FIVectorView_1_Windows__CInternal__CIPropertyValueProvider": ["087e736a-63ce-5249-8c7a-fdb0182f21c9"],
    "FIVectorView_1_Windows__CInternal__CSecurity__CAuthentication__CWeb__CWamProviderRegistrationInformation": [
        "a6a36de6-0931-51a1-bdd2-d73f4f6dff22"
    ],
    "FIVectorView_1_Windows__CInternal__CSecurity__CSmartScreen__CButtonInfo": ["e9444d66-3ff9-5410-8984-f9063f825683"],
    "FIVectorView_1_Windows__CInternal__CSettingSync__CICollectionBackup": ["6aaa05b7-eb95-5a83-ad39-b58b4228af05"],
    "FIVectorView_1_Windows__CInternal__CShell__CJumpView__CContextMenuItemWrapper": [
        "9c2a41f8-3641-5881-a1b3-4d4076649598"
    ],
    "FIVectorView_1_Windows__CInternal__CShell__CJumpView__CJumpViewCategoryInfo": [
        "f91611c7-1a15-573c-94da-9c2e939e7fd7"
    ],
    "FIVectorView_1_Windows__CInternal__CShell__CJumpView__CJumpViewItemInfo": ["56e27030-adfb-53d6-8e60-7afeb951f03e"],
    "FIVectorView_1_Windows__CInternal__CShell__CSharePicker__CIShareTarget": ["cc3e04b0-1a07-5efb-b40f-48bab8f608b4"],
    "FIVectorView_1_Windows__CInternal__CShell__CStartUI__CUserTileCommand": ["fe4ad596-da0b-59ec-a686-001049fdcb6f"],
    "FIVectorView_1_Windows__CInternal__CShell__CStartUI__CUserTileSwitchUser": [
        "9460aafe-41e0-54c6-8c1b-24abfceae321"
    ],
    "FIVectorView_1_Windows__CInternal__CShell__CTaskFlow__CDataEngine__CAppActivitySessionData": [
        "07823850-f24d-5522-943c-01bed4f5d542"
    ],
    "FIVectorView_1_Windows__CInternal__CShell__CViewManagerInterop__CIViewWrapper": [
        "7c2e7f09-9f15-59f8-80da-a4c1b1ebe2ea"
    ],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CAppExecutionAlias": ["56a70670-09fa-5053-8cdd-d8342a6d0276"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CAppExtension": ["79701584-d18e-57e6-ae6b-9897de3b420d"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CAppExtensionHost": ["d1f9291c-6186-5071-92e1-16d0728b06df"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CAppService": ["8b9ae10d-b29a-51cb-adfb-e94ad37480dd"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CAppUriHandler": ["d44270bd-68f9-5da1-a9f1-7c08a8112463"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CAppUriHandlerLauncherInfo": [
        "c338a4da-6bcb-54c1-aa44-9ee9087ca23b"
    ],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CApplication": ["b9b520ed-923d-5730-b827-b257f90b1932"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CApplicationBackgroundTask": [
        "3b173a27-c1d5-51dd-a02e-feeda8f1ea19"
    ],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CApplicationContentUriRule": [
        "c1c155d5-f8c8-5d06-a76f-073a6675b45c"
    ],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CApplicationExtension": [
        "c690b3c6-01c5-5e19-b96b-a35f92922928"
    ],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CApplicationLicense": [
        "fbf2b39c-a81a-5a26-9907-48cdd560bba3"
    ],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CApplicationPolicy": ["eed7d0c9-7239-5613-82aa-56cfa932defa"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CApplicationProperty": [
        "5eae7810-9253-51a0-b926-9c20eff2fe98"
    ],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CAppxExtension": ["e63f839b-69a2-5e6d-9d8b-c86861471972"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CAppxManifest": ["647533f8-4b8f-54b4-914d-45411691eb45"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CBackgroundServiceAgent": [
        "26ed6a28-cd1c-54e5-8d5b-c465490fce45"
    ],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CBnsNotification": ["30cb88d0-68a6-5b32-a8bd-bba169ba36e7"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CBundle": ["4a17042f-b545-56fc-9cf9-390af5c4e476"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CBundlePackage": ["ef569833-f713-5669-b961-0d7586de466f"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CBundleResource": ["847ed722-c0a7-5ea5-ad4c-d8d26039f093"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CContentGroup": ["1a6a1418-6e1b-58ab-a697-dd08ee218000"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CContentGroupFile": ["33860597-1e9a-5bc1-81a2-4b185a62de2c"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CDefaultTile": ["3cadcf60-7cb8-559e-b681-6bd1bd5865a2"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CDependency": ["083ee5b1-d894-552f-8f64-29fb294755d3"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CDependencyGraph": ["66d2ce49-2ebb-5cb4-8f27-ddbd019099a5"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CDeploymentHistory": ["4717c75c-a95d-509f-8db5-9d780ccd3c20"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CDeploymentRequest": ["53470f1a-bed6-557c-95ee-964ec0f9bf13"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CDeploymentRequestDependency": [
        "7ea6e5fb-588e-5d7c-ab49-955a30047d0a"
    ],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CEnterprise": ["e2a9494b-166f-5243-be1b-5977377a8b7a"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CFile": ["6af33884-2dd8-5cba-979e-671af6ae2421"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CFileTypeAssociation": [
        "89bc3f49-f8d9-5103-ba13-de497e609167"
    ],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CFileTypeAssociationLauncherInfo": [
        "15f99879-aa48-571f-845d-144893440cfd"
    ],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CMigratorPatch": ["96b8f345-7bf8-5d0b-802c-891ff1b3e5c7"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CMrtApplication": ["5f799f53-b323-5e2e-ba52-e176d0ca4cda"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CMrtDefaultTile": ["2e946340-53bf-54c2-8fa2-56ebd4439fbb"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CMrtPackage": ["056644f8-9fc1-59ce-b607-a9df16ce2e68"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CMrtSharedPri": ["ebc8fbab-d14d-513d-8b01-1c755ad58b0a"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CMrtUserPri": ["db84e836-6b9c-57cf-bce4-a072679abcd2"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__COptionalBundle": ["670b0187-9a9c-5cef-9c0d-757c73a17ad9"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__COptionalBundlePackage": [
        "bc3ed956-02df-5af2-94af-5909f6a48a1b"
    ],
    "FIVectorView_1_Windows__CInternal__CStateRepository__COptionalBundleResource": [
        "a9da98ca-be65-5017-82e4-b45189fb40f6"
    ],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CPackage": ["f99c6e11-2770-5d87-b2d0-99975ffe4500"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CPackageExtension": ["2e5431e7-226d-540d-be83-a8dc8d3bc615"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CPackageFamily": ["3bda17d4-605f-5555-a3da-baa0cb640d6a"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CPackageFamilyPolicy": [
        "96362321-f8c2-591f-b3ef-32979d06a8bb"
    ],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CPackageFamilyUser": ["40b0d684-7fdd-5de8-92ba-2bd093388129"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CPackageIdentity": ["ac2bb731-24c7-50bb-b359-d4e9a02fbbaa"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CPackageLocation": ["0564c99d-a644-5135-b768-40714d44f066"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CPackageMachineStatus": [
        "eaf315d9-7ffe-541d-9605-cfc58b823abf"
    ],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CPackagePolicy": ["500f5564-558d-5886-ba4a-b41ffeb39322"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CPackageProperty": ["79a5c465-ef19-5e2a-bdf2-7b368df9c018"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CPackageSourceUri": ["52516ebe-44fc-5126-8972-50bc8f018da3"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CPackageUser": ["87d78196-5c2c-5b8a-b40c-b99083eb509b"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CPackageUserStatus": ["ae237d1b-356d-59d5-8b8a-ec4487a24f83"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CPrimaryTile": ["0a87420f-4bbc-5066-b7ae-24514f477f55"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CPrimaryTileUser": ["6c8c6b1a-3bd8-5059-8346-1b61a66c51fe"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CPrimaryTileUserChangelog": [
        "5caf6cee-9eb2-5e8e-b267-15cf85bbb1eb"
    ],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CPrimaryTileUserDataChange": [
        "6dd00567-b07e-59ee-ad82-d9d8ec4c2914"
    ],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CPrimaryTileView": ["dcc05ce1-9c55-5b0a-b86a-9928306ce405"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CProtocol": ["63624def-cd42-5bcf-96e6-e27614e5d807"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CProtocolLauncherInfo": [
        "04222ebf-3c08-5a6f-b227-d886a2b52873"
    ],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CPublisherCacheFolder": [
        "a3389ff8-ac2a-51c8-a289-b81adb9a6421"
    ],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CResource": ["e102601f-d181-5b28-b053-24db6399b0ff"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CSecondaryTile": ["18483209-fba0-5ca6-86c6-4fc822559cee"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CSecondaryTileUser": ["54a9a389-eaf0-5096-95f3-c5ddb9b5ed3a"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CSecondaryTileUserChangelog": [
        "8d1899ee-82c9-5f06-bb5a-718a85a174bf"
    ],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CSecondaryTileUserDataChange": [
        "6a94ad8a-dd00-5816-a025-016d0ba262b6"
    ],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CSecondaryTileView": ["7ed8fa69-a6fa-5d0f-a8e2-f27417c21b0e"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CSequence": ["aa229816-335b-590b-acfa-dd97d3d0777e"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CTargetDeviceFamily": [
        "8447319c-9975-57ac-9708-7b93d5216498"
    ],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CTask": ["efcd73b5-ec08-5bf7-9ed3-a8abff85590f"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CTileView": ["74ab0f33-cc46-5c44-8e0f-7bca52cbfc94"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CTileViewQueryFilter": [
        "03e6e8a0-96f1-543f-8486-9a6a1ac8b4d2"
    ],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CUser": ["282763e5-6bc5-5402-9179-eb0bf7c666df"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CVolume": ["ce5fd27f-f5fe-52b2-9b43-3f69134a213a"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CWowDependencyGraph": [
        "1ce2d78f-9ccc-5f7f-9b3c-d05db76cbb18"
    ],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CXap": ["7e00d4d9-681b-5671-b748-d5cca60d436d"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CXapExtension": ["66086b5b-aae0-58fb-ad37-4365764081d1"],
    "FIVectorView_1_Windows__CInternal__CStateRepository__CXboxPackage": ["6c05e050-497b-570d-8e30-50d5810b35bd"],
    "FIVectorView_1_Windows__CInternal__CStorage__CFileOperation": ["17d5f279-abe7-546f-b1ad-73dbce6187ae"],
    "FIVectorView_1_Windows__CInternal__CStorage__CIFileOperationItemErrorInfo": [
        "96297ff2-4bbd-5ca3-9cd5-c84df1995b7e"
    ],
    "FIVectorView_1_Windows__CInternal__CStorage__CIStorageItemCommand": ["02139bf3-dced-548d-9e89-4a72ea5fae89"],
    "FIVectorView_1_Windows__CInternal__CStorage__CRecentItemsUpdateResult": ["3847d85b-4366-52f8-a7ce-9371a67d1da9"],
    "FIVectorView_1_Windows__CInternal__CUI__CShutdown__CShutdownUXOption": ["fab1a66e-7a0c-55bd-b138-fb09398869d2"],
    "FIVectorView_1_Windows__CManagement__CDeployment__CInternal__CDiskUsageInformation": [
        "f03e6413-2530-5a50-81be-94e77537cb24"
    ],
    "FIVectorView_1_Windows__CManagement__CDeployment__CPackageUserInformation": [
        "b1180150-8515-597c-995d-68e2a71c3d53"
    ],
    "FIVectorView_1_Windows__CMedia__CSpeechRecognition__CInternal__CSpeechRecognitionCorrectionGraphArc": [
        "3f9bccd7-f356-5f0a-aa38-2b44d92cd8c7"
    ],
    "FIVectorView_1_Windows__CMedia__CSpeechRecognition__CInternal__CSpeechRecognitionCorrectionGraphNode": [
        "7dc0ef63-6812-55ef-8edf-fc5b3b021b5a"
    ],
    "FIVectorView_1_Windows__CMedia__CSpeech__CSpeechSupportedLanguage": ["4432a11d-5598-5f4e-8b9b-d115bd196be8"],
    "FIVectorView_1_Windows__CNetworking__CConnectivity__CDataUsage": ["56952265-2b58-5e4e-bd1d-7b269d4bb336"],
    "FIVectorView_1_Windows__CNetworking__CUX__CIAvailableNetwork": ["1baf803a-4275-5787-9cf2-a3c03737c8fc"],
    "FIVectorView_1_Windows__CNetworking__CUX__CIAvailableNetworkOffer": ["39fc786d-a669-5c17-9f6a-1d84f77deb3b"],
    "FIVectorView_1_Windows__CNetworking__CUX__CIAvailableNetworkProvider": ["5d8ed6dc-6824-55c2-ab04-c287435967da"],
    "FIVectorView_1_Windows__CNetworking__CUX__CICertItemInfo": ["de2e489d-b17e-59fd-9ca4-9267b5f203e8"],
    "FIVectorView_1_Windows__CNetworking__CUX__CIHotspot2RegisterProvider": ["f379dce6-3494-55f2-8983-80e7021ca00b"],
    "FIVectorView_1_Windows__CNetworking__CUX__CISimItemInfo": ["bde996d5-37bb-5a34-9f5b-e156ca69adb5"],
    "FIVectorView_1_Windows__CNetworking__CUX__CIUXCategory": ["0e30d042-3085-5f5c-a317-548444eca130"],
    "FIVectorView_1_Windows__CNetworking__CUX__CIVPNCustomInputItem": ["d98187a6-941d-59d1-ad4d-2e97c45ba677"],
    "FIVectorView_1_Windows__CNetworking__CUX__CIWiFiEapMethod": ["a30a2744-4c4e-5213-90a0-c8a844e2dd85"],
    "FIVectorView_1_Windows__CNetworking__CUX__CIWiFiProfile": ["8b3c7322-af87-5135-94be-2fb3a2e9f6ed"],
    "FIVectorView_1_Windows__CNetworking__CUX__CIWiFiSenseSocialNetwork": ["5d0e8d3c-612a-5320-bef5-9b460ccf021a"],
    "FIVectorView_1_Windows__CNetworking__CUX__CNetworkMediaType": ["28f9f624-c289-55c4-82a4-99153e5dc533"],
    "FIVectorView_1_Windows__CSecurity__CAuthentication__COnlineId__COnlineIdServiceTicketRequest": [
        "1a7c6c05-3fef-5eeb-aaff-625ee3ebc07c"
    ],
    "FIVectorView_1_Windows__CSecurity__CCredentials__CWebAccountProvider": ["fcce45dd-2213-54e6-b918-c0f31a8c6d54"],
    "FIVectorView_1_Windows__CServices__CTargetedContent__CInternal__CTargetedContentTriggerInternal": [
        "45028a9c-53a4-5173-b928-7e53e1d6acfd"
    ],
    "FIVectorView_1_Windows__CStorage__CAccessCache__CAccessListEntry": ["42b49b8a-3014-5d27-8f2c-1ef5ee89ec00"],
    "FIVectorView_1_Windows__CStorage__CBulkAccess__CFileInformation": ["50bcd975-67ba-53b7-a5a7-1fb59f04bbb3"],
    "FIVectorView_1_Windows__CStorage__CBulkAccess__CFolderInformation": ["506f1329-dbdc-5a37-91d5-b047cb24276d"],
    "FIVectorView_1_Windows__CStorage__CBulkAccess__CIStorageItemInformation": ["da3a4ef8-d315-529b-a73b-524490573f7e"],
    "FIVectorView_1_Windows__CStorage__CIStorageFile": ["4296b6e8-e219-5e74-8dde-196f57200a82"],
    "FIVectorView_1_Windows__CStorage__CIStorageFolder": ["6a8c9209-6392-5b08-aee9-f2add7decc49"],
    "FIVectorView_1_Windows__CStorage__CIStorageItem": ["85575a41-06cb-58d0-b98a-7c8f06e6e9d7"],
    "FIVectorView_1_Windows__CStorage__CPickers__CIPickerFileType": ["6229d054-ea09-5209-92f7-9d36cd94e36b"],
    "FIVectorView_1_Windows__CStorage__CPickers__CUpdateFilesResult": ["8d278995-3c91-5a98-a90d-83ba78bbdf05"],
    "FIVectorView_1_Windows__CStorage__CSearch__CSortEntry": ["823c7604-b37b-5465-a169-29497893cdb9"],
    "FIVectorView_1_Windows__CStorage__CStorageFile": ["80646519-5e2a-595d-a8cd-2a24b4067f1b"],
    "FIVectorView_1_Windows__CStorage__CStorageFolder": ["e20debc6-dc4e-542e-a2e7-a24d19c8dd62"],
    "FIVectorView_1_Windows__CStorage__CStorageLibraryChange": ["0d3879e2-5c7e-5b6c-954d-10c6da95fbff"],
    "FIVectorView_1_Windows__CStorage__CStreams__CIRandomAccessStream": ["92cd0a46-2266-5cd6-9293-e111299f2793"],
    "FIVectorView_1_Windows__CStorage__CStreams__CIRandomAccessStreamReference": [
        "4d904a36-6418-5c09-a622-a1cc8c27eeff"
    ],
    "FIVectorView_1_Windows__CSystem__CInternal__CIUserProfile": ["0b932b01-4ce8-5571-8831-91d5e361a4dd"],
    "FIVectorView_1_Windows__CSystem__CInternal__CLaunch__CAppServiceExtensionInfo": [
        "cebb16a9-927e-53b7-9861-8fce18dca39d"
    ],
    "FIVectorView_1_Windows__CSystem__CInternal__CLaunch__CExtensionInfo": ["49244656-5ea6-5680-bf99-87ef7636f6c8"],
    "FIVectorView_1_Windows__CSystem__CRemoteSystems__CIRemoteSystemFilter": ["d2810ae1-cff2-5636-8feb-054c5d3a1ae2"],
    "FIVectorView_1_Windows__CSystem__CRemoteSystems__CRemoteSystem": ["a82a6d6d-b72b-5e32-bac5-b80d99c0b34f"],
    "FIVectorView_1_Windows__CUI__CCore__CAnimationMetrics__CIPropertyAnimation": [
        "3a6ed95d-6a50-5ead-a4c6-09f8babc632c"
    ],
    "FIVectorView_1_Windows__CUI__CInput__CPointerPoint": ["f0f57411-7786-5174-8752-4c5e834b6da2"],
    "FIVectorView_1_Windows__CUI__CInput__CRadialControllerSystemMenuItemKind": [
        "dd29cfe2-a92f-5266-be5f-5d4407fd8580"
    ],
    "FIVectorView_1_Windows__CUI__CNotifications__CShownTileNotification": ["2b23baa9-1d54-5440-bd32-86ed70f15c9e"],
    "FIVectorView_1_Windows__CUI__CPopups__CIUICommand": ["ed1165e6-f377-5b00-8172-93c1bd04deb4"],
    "FIVectorView_1_Windows__CUI__CSearch__CInternal__CCommon__CLocalGroupScore": [
        "de29ae0c-d332-551f-a7cd-a56bbc13330e"
    ],
    "FIVectorView_1_Windows__CUI__CWindowManagement__CDisplayRegion": ["6a3df344-6eed-5b4d-97dc-a4123e24d37a"],
    "FIVectorView_1_Windows__CUI__CWindowManagement__CWindowingEnvironment": ["a782655a-67ed-502f-a1e4-58ea1712c97d"],
    "FIVectorView_1___FIKeyValuePair_2_HSTRING_IInspectable": ["696a5329-ed0f-57cc-9379-ff81e8235bcc"],
    "FIVectorView_1___FIKeyValuePair_2_IInspectable_IInspectable": ["b9ce76da-2946-57a6-ae2e-596435a5b889"],
    "FIVectorView_1___FIKeyValuePair_2_SharingPlatform__CIDeviceIdentifier___FIVectorView_1_SharingPlatform__CISessionIdentifier": [
        "a1cade01-7ae9-5429-b91b-20395a0cc157"
    ],
    "FIVectorView_1___FIVector_1_float": ["1320f6a5-998f-5bd9-8ec1-698beaa80173"],
    "FIVector_1_ContentManagement__CAppInstallInfoRecord": ["4c815ba6-2563-5feb-8ed7-014242d84e31"],
    "FIVector_1_ContentManagement__CTargetedContent__CTargetedContentItem": ["4ec3458a-8a80-5e13-8a88-33e6ef2e8ffd"],
    "FIVector_1_PhoneInternal__CExperiences__CSync__CAccount": ["fef08a66-c868-5d5b-b403-47013bf611e5"],
    "FIVector_1_PhoneInternal__CExperiences__CSync__CAccountSyncContentType": ["e44397b4-5a3c-5283-a1c5-17f662ec50b6"],
    "FIVector_1_PhoneInternal__CExperiences__CSync__CPartnershipType": ["287f3078-a088-53c2-a8dc-e473e33d6a31"],
    "FIVector_1_SharingPlatform__CIParticipantIdentifier": ["14551c9c-5183-5aea-a791-c81c5e1f9570"],
    "FIVector_1_UINT64": ["cf4a637f-456a-5a47-a927-bcf07fc69901"],
    "FIVector_1_Windows__CApplicationModel__CAppExtensions__CAppExtension": ["76157168-b2a7-5300-9c96-23673c4fd2fd"],
    "FIVector_1_Windows__CApplicationModel__CAppointments__CAppointment": ["6c8b9662-38be-596d-b84d-92f8a6e6d804"],
    "FIVector_1_Windows__CApplicationModel__CAppointments__CAppointmentCalendar": [
        "b8ab13d3-e9e7-5713-ab22-6d32014bee4b"
    ],
    "FIVector_1_Windows__CApplicationModel__CAppointments__CAppointmentException": [
        "7a634408-5d3d-5f17-b587-16dbe5fa808b"
    ],
    "FIVector_1_Windows__CApplicationModel__CAppointments__CAppointmentStore": ["5c5f7adb-6423-5fcc-82d1-1b6c948e8f6a"],
    "FIVector_1_Windows__CApplicationModel__CAppointments__CAppointmentStoreChange": [
        "87314be6-9abe-5099-83e1-a14ae65df915"
    ],
    "FIVector_1_Windows__CApplicationModel__CBackground__CIBackgroundTaskYieldable": [
        "4772472d-1b99-5e5e-a5df-a92cc831c6c9"
    ],
    "FIVector_1_Windows__CApplicationModel__CBackground__CIBrokerConditionBuilder": [
        "364cf641-18a1-591e-bee0-3fd17635e7f4"
    ],
    "FIVector_1_Windows__CApplicationModel__CCalls__CPhoneCallHistoryEntry": ["569f74f9-1abc-53ab-aa2c-2d97f04fcc12"],
    "FIVector_1_Windows__CApplicationModel__CChat__CChatConversation": ["f8407822-27a0-5aa9-8ad3-a4c642f62ca0"],
    "FIVector_1_Windows__CApplicationModel__CChat__CChatMessage": ["4d511443-4aff-529d-9f96-2897e170586f"],
    "FIVector_1_Windows__CApplicationModel__CChat__CChatMessageChange": ["34ffe277-ba58-53bc-87dd-3293d094681b"],
    "FIVector_1_Windows__CApplicationModel__CChat__CChatMessageTransport": ["284974b3-63b4-5771-91ea-e8234dbabe51"],
    "FIVector_1_Windows__CApplicationModel__CChat__CIChatItem": ["132dec30-d1a8-590e-9bfd-85ca955ff5a2"],
    "FIVector_1_Windows__CApplicationModel__CChat__CRcsEndUserMessageAction": ["2ea81630-1432-57be-ad56-6af85716d771"],
    "FIVector_1_Windows__CApplicationModel__CChat__CRcsTransport": ["d375041c-94af-53b1-8b80-4816f971cb9c"],
    "FIVector_1_Windows__CApplicationModel__CContacts__CContactAnnotation": ["c7e0c300-8d7c-5b61-860b-0ace85847adf"],
    "FIVector_1_Windows__CApplicationModel__CContacts__CContactAnnotationList": [
        "7890cd8b-6733-521f-bbf4-bb9a9f9b2ca8"
    ],
    "FIVector_1_Windows__CApplicationModel__CContacts__CContactChange": ["346c816a-e2fc-5b5c-928a-a8d59bab5930"],
    "FIVector_1_Windows__CApplicationModel__CContacts__CContactField": ["b2f8f683-bce7-50bc-ab1d-47a946d39788"],
    "FIVector_1_Windows__CApplicationModel__CContacts__CContactInstantMessageField": [
        "0c503917-0c6e-5b50-874b-6d19df7fb314"
    ],
    "FIVector_1_Windows__CApplicationModel__CContacts__CContactList": ["7ab0bfba-495a-5b9b-bc64-524fd77e919c"],
    "FIVector_1_Windows__CApplicationModel__CContacts__CContactLocationField": ["d732491a-0c09-5497-8ba2-12a54095b4d3"],
    "FIVector_1_Windows__CApplicationModel__CContacts__CContactMatchReason": ["71a58125-0296-5ad1-b0cd-3e8645e60b27"],
    "FIVector_1_Windows__CApplicationModel__CContacts__CInternal__CIContactActionControl": [
        "9cce78a5-0001-5c83-a110-4304cca216e0"
    ],
    "FIVector_1_Windows__CApplicationModel__CContacts__CInternal__CIContactActionControlItem": [
        "df409b2d-378f-5f4c-9189-52489d1f7a8f"
    ],
    "FIVector_1_Windows__CApplicationModel__CContacts__CInternal__CIContactDisplayInformation": [
        "bcb4879b-057c-54ef-982b-0a5d76f6c025"
    ],
    "FIVector_1_Windows__CApplicationModel__CCore__CAppListEntry": ["b063023c-b4e2-50f8-92e2-db9f0e882366"],
    "FIVector_1_Windows__CApplicationModel__CCore__CCoreApplicationView": ["8af29ecf-6cc4-5a34-99c6-cd9069809253"],
    "FIVector_1_Windows__CApplicationModel__CDataTransfer__CClipboardHistoryItem": [
        "38637e8a-4921-5a6a-a5b4-adf1f69a22cb"
    ],
    "FIVector_1_Windows__CApplicationModel__CDataTransfer__CShareProvider": ["a1687865-31e2-5536-97ec-292269a78046"],
    "FIVector_1_Windows__CApplicationModel__CEmail__CEmailCertificateValidationStatus": [
        "da4181c7-ab26-5a16-ae74-21c07a4ff902"
    ],
    "FIVector_1_Windows__CApplicationModel__CEmail__CEmailConversation": ["957a0227-18a4-5340-85ce-949c8c68981c"],
    "FIVector_1_Windows__CApplicationModel__CEmail__CEmailFolder": ["210b6128-9910-55d0-828b-3ef80c16c6a0"],
    "FIVector_1_Windows__CApplicationModel__CEmail__CEmailMailbox": ["2ae2ba7d-b7b9-5f33-884c-75a101e31265"],
    "FIVector_1_Windows__CApplicationModel__CEmail__CEmailMailboxChange": ["a8faf394-fef2-5514-b092-8ec4c95a0fed"],
    "FIVector_1_Windows__CApplicationModel__CEmail__CEmailMessage": ["b20fa783-2339-5822-a89d-1df8893d354a"],
    "FIVector_1_Windows__CApplicationModel__CEmail__CEmailRecipientResolutionResult": [
        "424ab511-833c-5b15-b349-89e3d7b8a3bb"
    ],
    "FIVector_1_Windows__CApplicationModel__CInternal__CDataTransfer__CShareAppExtension": [
        "181a12f3-9de2-5af3-b4d6-819031f6027d"
    ],
    "FIVector_1_Windows__CApplicationModel__CInternal__CStartupTaskInternal": ["367c523f-ba79-5a6c-a534-8513d4f5d34c"],
    "FIVector_1_Windows__CApplicationModel__CResources__CCore__CResourceQualifier": [
        "4f4b75ee-9915-5467-983c-ed51df0eb704"
    ],
    "FIVector_1_Windows__CApplicationModel__CSearch__CCore__CSearchSuggestion": [
        "1cc36c46-19be-5d6b-a56d-047413252c69"
    ],
    "FIVector_1_Windows__CApplicationModel__CStartupTask": ["c41649ef-ad77-5cb9-aef1-37c47c8877b5"],
    "FIVector_1_Windows__CApplicationModel__CStore__CUnfulfilledConsumable": ["e053ff3a-ca1f-5135-931d-f03508032850"],
    "FIVector_1_Windows__CApplicationModel__CUserDataAccounts__CSystemAccess__CDeviceAccountConfiguration": [
        "90aea8c5-68d3-5c6f-8f14-00477eed0ca8"
    ],
    "FIVector_1_Windows__CApplicationModel__CUserDataAccounts__CUserDataAccount": [
        "89258618-1fc4-5551-9343-e51c5f420551"
    ],
    "FIVector_1_Windows__CApplicationModel__CUserDataTasks__CUserDataTask": ["cc681ce4-da95-5297-adbe-dc4e47f3fa2a"],
    "FIVector_1_Windows__CApplicationModel__CUserDataTasks__CUserDataTaskList": [
        "abbd21ed-d35d-5f62-b547-54b2b0e1dd0c"
    ],
    "FIVector_1_Windows__CData__CText__CAlternateWordForm": ["b6104dde-f602-5778-be14-88a202c0ab7e"],
    "FIVector_1_Windows__CData__CText__CSelectableWordSegment": ["67c58aab-ab27-5d3f-a090-81e08d0ce4b4"],
    "FIVector_1_Windows__CData__CText__CTextPhoneme": ["6cb92948-7b12-5d79-99be-4af6ca396b8e"],
    "FIVector_1_Windows__CData__CText__CWordSegment": ["3895c4cc-e9e2-56d3-900d-c284458c8cfe"],
    "FIVector_1_Windows__CDevices__CEnumeration__CDeviceInformation": ["0fca458f-ad7f-5259-a74d-25e8fef48c1b"],
    "FIVector_1_Windows__CDevices__CEnumeration__CDeviceWatcherEvent": ["c10dccd3-d015-5d85-9a63-862410844e4d"],
    "FIVector_1_Windows__CDevices__CEnumeration__CDeviceWatcherEventKind": ["cde5ec02-6bdf-5b11-8674-99dc8a595207"],
    "FIVector_1_Windows__CDevices__CEnumeration__CPnp__CPnpObject": ["51ded63f-e60f-5205-b778-680d5e39b5fc"],
    "FIVector_1_Windows__CDevices__CHaptics__CSimpleHapticsControllerFeedback": [
        "10f3947f-1f20-5cf7-826b-6408386436f8"
    ],
    "FIVector_1_Windows__CDevices__CInput__CPointerDevice": ["a7de34a0-53a0-51ac-a17d-074bb4e96334"],
    "FIVector_1_Windows__CDevices__CInput__CPointerDeviceUsage": ["3966d060-a17a-5792-b84b-34234f1c78d8"],
    "FIVector_1_Windows__CDevices__CSms__CISmsBinaryMessage": ["d9904edc-5391-51f8-9bd8-db81e5763766"],
    "FIVector_1_Windows__CDevices__CSms__CISmsMessage": ["84c9f362-51fa-5e23-a9b3-43ae289d7100"],
    "FIVector_1_Windows__CGaming__CPreview__CGamesEnumeration__CGameListEntry": [
        "58f4cdd2-5b23-5d0f-97d8-684619860220"
    ],
    "FIVector_1_Windows__CGlobalization__CCollation__CCharacterGrouping": ["9b1db9e5-f1e6-505c-88f2-82e82f7e9d2e"],
    "FIVector_1_Windows__CGraphics__CDisplay__CCore__CHdmiDisplayMode": ["361306c9-ca16-55a6-9542-6f95c5a28b82"],
    "FIVector_1_Windows__CGraphics__CImaging__CBitmapCodecInformation": ["1817453d-ded6-5d5d-9623-1020a1a8d3b3"],
    "FIVector_1_Windows__CInternal__CApplicationModel__CWindowManagement__CAppView": [
        "a4ffdad3-02ff-5606-9658-61a12bd09327"
    ],
    "FIVector_1_Windows__CInternal__CApplicationModel__CWindowManagement__CAppViewId": [
        "83f09169-5781-59c2-9077-25a3b835f205"
    ],
    "FIVector_1_Windows__CInternal__CApplicationModel__CWindowManagement__CWindow": [
        "6d8c2f8a-b79b-5ffd-be24-18dafcd94f34"
    ],
    "FIVector_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIBackupFrequency": [
        "7746c23a-82d4-518f-b47a-8a89010ddd9e"
    ],
    "FIVector_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIBackupRelatedActionItem": [
        "e242d819-6fd0-54e5-8c23-86546c08e34d"
    ],
    "FIVector_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIBackupSettingsProvider": [
        "c5de726c-b5ae-53ba-aa95-8fc131e4f604"
    ],
    "FIVector_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIBackupTargetItem": [
        "5dce45ec-e3c3-56cc-b650-ab1abae1869e"
    ],
    "FIVector_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIEnumBackupsProvider": [
        "b0d5dbdc-1f2b-50f4-96ba-fbaa9d7aa623"
    ],
    "FIVector_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIFolderBackupScopeItem": [
        "a1154a5e-9caa-5364-909c-aabe0fcbaba3"
    ],
    "FIVector_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIManualCleanupOption": [
        "c712c57a-30b5-5508-9bfd-83903bdcda97"
    ],
    "FIVector_1_Windows__CInternal__CBackupRestore__CSettingsProviders__CIRetentionListItem": [
        "c7cd3581-f4ec-5367-8217-0448b579df8e"
    ],
    "FIVector_1_Windows__CInternal__CBindableObservableItem": ["e4897799-363a-5d4f-bbc5-e1e5531513ad"],
    "FIVector_1_Windows__CInternal__CFeedback__CFeedbackItem": ["58754b09-ec64-5d7a-a00a-98c7920bd51e"],
    "FIVector_1_Windows__CInternal__CIPropertyValueProvider": ["262e5028-416c-5026-9ddb-0abb23c1cb2d"],
    "FIVector_1_Windows__CInternal__CSecurity__CAuthentication__CWeb__CWamProviderRegistrationInformation": [
        "c08c94c3-8959-5de0-89b9-9453e2fb4ad6"
    ],
    "FIVector_1_Windows__CInternal__CSecurity__CSmartScreen__CButtonInfo": ["50a07d41-5535-5d66-b3c2-bd900af35b4d"],
    "FIVector_1_Windows__CInternal__CSettingSync__CICollectionBackup": ["afe12a9c-9dc8-55ea-821d-312ab0521426"],
    "FIVector_1_Windows__CInternal__CShell__CJumpView__CContextMenuItemWrapper": [
        "8ea44823-a7dc-5d8e-86dd-ee280ccafbe8"
    ],
    "FIVector_1_Windows__CInternal__CShell__CJumpView__CJumpViewCategoryInfo": ["573b8868-4796-54f4-a3c9-bf574403a54e"],
    "FIVector_1_Windows__CInternal__CShell__CJumpView__CJumpViewItemInfo": ["400dd6dc-f660-5933-ba2a-d28ab63c3195"],
    "FIVector_1_Windows__CInternal__CShell__CSharePicker__CIShareTarget": ["a67d2797-25b2-5a85-ab83-5b720096197f"],
    "FIVector_1_Windows__CInternal__CShell__CStartUI__CUserTileCommand": ["0c3ecc4c-82fc-5c09-a92d-f43f6fa0e7ec"],
    "FIVector_1_Windows__CInternal__CShell__CStartUI__CUserTileSwitchUser": ["75a4a402-02a4-549f-a985-4058c00def61"],
    "FIVector_1_Windows__CInternal__CShell__CTaskFlow__CDataEngine__CAppActivitySessionData": [
        "78814b6b-a23e-574b-85bd-7bd4c5c75cf5"
    ],
    "FIVector_1_Windows__CInternal__CShell__CViewManagerInterop__CIViewWrapper": [
        "be43fcb0-a94f-5436-a95c-486b1021993c"
    ],
    "FIVector_1_Windows__CInternal__CStateRepository__CAppExecutionAlias": ["1fb3466a-3cd2-5c89-849c-c52a383892b2"],
    "FIVector_1_Windows__CInternal__CStateRepository__CAppExtension": ["731137ff-388b-506b-81fc-fc870878174b"],
    "FIVector_1_Windows__CInternal__CStateRepository__CAppExtensionHost": ["a0503e30-bcd6-52c2-87c8-4ae7e2c519da"],
    "FIVector_1_Windows__CInternal__CStateRepository__CAppService": ["6825a989-eecd-5fa9-8c07-6b7e4aaf8cd2"],
    "FIVector_1_Windows__CInternal__CStateRepository__CAppUriHandler": ["d30857f6-3ac3-58a7-8338-bc137ccfd51d"],
    "FIVector_1_Windows__CInternal__CStateRepository__CAppUriHandlerLauncherInfo": [
        "083e2667-5a27-5f40-bee2-e470c9902f4c"
    ],
    "FIVector_1_Windows__CInternal__CStateRepository__CApplication": ["9cd9a876-3033-518f-85aa-1c5071981b3e"],
    "FIVector_1_Windows__CInternal__CStateRepository__CApplicationBackgroundTask": [
        "5299e896-6fab-52cd-9947-27726481b910"
    ],
    "FIVector_1_Windows__CInternal__CStateRepository__CApplicationContentUriRule": [
        "91157fcf-82fa-5008-bbac-d50606444948"
    ],
    "FIVector_1_Windows__CInternal__CStateRepository__CApplicationExtension": ["8ece93ce-2adf-587b-99dc-3952ecab530a"],
    "FIVector_1_Windows__CInternal__CStateRepository__CApplicationLicense": ["b4268880-151a-5ef8-8120-b4402f2491ee"],
    "FIVector_1_Windows__CInternal__CStateRepository__CApplicationPolicy": ["17b96d4c-1332-5e6c-b134-070658124105"],
    "FIVector_1_Windows__CInternal__CStateRepository__CApplicationProperty": ["f4e6be64-8bae-5905-8440-d5fde32d56f5"],
    "FIVector_1_Windows__CInternal__CStateRepository__CAppxExtension": ["16cbf29f-d887-5d90-aa23-913714dabc12"],
    "FIVector_1_Windows__CInternal__CStateRepository__CAppxManifest": ["3abeef42-3e1b-5e44-a440-824f2393599b"],
    "FIVector_1_Windows__CInternal__CStateRepository__CBackgroundServiceAgent": [
        "a5a94afe-9fae-534e-a40c-5504d35cc1b2"
    ],
    "FIVector_1_Windows__CInternal__CStateRepository__CBnsNotification": ["86873348-feba-59ce-860f-df32e8eb90eb"],
    "FIVector_1_Windows__CInternal__CStateRepository__CBundle": ["5eafddd3-c711-5454-b4e7-8100c0788329"],
    "FIVector_1_Windows__CInternal__CStateRepository__CBundlePackage": ["6dde55ab-4565-5615-acb5-abe44b048aa6"],
    "FIVector_1_Windows__CInternal__CStateRepository__CBundleResource": ["1f42d0fa-0a10-50ba-9787-06547f192acc"],
    "FIVector_1_Windows__CInternal__CStateRepository__CContentGroup": ["54882540-217b-5aaf-8230-afaa5b48af06"],
    "FIVector_1_Windows__CInternal__CStateRepository__CContentGroupFile": ["4b4e7b9a-776c-5f6a-82fe-5fd741fe015c"],
    "FIVector_1_Windows__CInternal__CStateRepository__CDefaultTile": ["bd0d0c5f-7399-50bb-af87-397ce4ad47dc"],
    "FIVector_1_Windows__CInternal__CStateRepository__CDependency": ["48976f63-3816-5821-ad40-d97e17fc5f88"],
    "FIVector_1_Windows__CInternal__CStateRepository__CDependencyGraph": ["2144b0c6-45d0-571e-a47b-96da54fb5c90"],
    "FIVector_1_Windows__CInternal__CStateRepository__CDeploymentHistory": ["ba89c9b0-8eaa-5ab5-8af5-8007f404f325"],
    "FIVector_1_Windows__CInternal__CStateRepository__CDeploymentRequest": ["e933a0a4-ef7e-5b17-8bf2-b32071132d91"],
    "FIVector_1_Windows__CInternal__CStateRepository__CDeploymentRequestDependency": [
        "d9e68834-6ccb-54f8-b6b5-8817dee99c5b"
    ],
    "FIVector_1_Windows__CInternal__CStateRepository__CEnterprise": ["a0893f20-f191-539f-9aa1-6e817c7801a3"],
    "FIVector_1_Windows__CInternal__CStateRepository__CFile": ["dab496d7-2383-51af-802c-01c7284ad2f1"],
    "FIVector_1_Windows__CInternal__CStateRepository__CFileTypeAssociation": ["78df7f26-afd7-5cc1-9d62-ec831a44ac80"],
    "FIVector_1_Windows__CInternal__CStateRepository__CFileTypeAssociationLauncherInfo": [
        "fc55d7f4-c1af-5c25-b77d-d1f9516765b4"
    ],
    "FIVector_1_Windows__CInternal__CStateRepository__CMigratorPatch": ["dc315d63-9775-528c-8c3d-1d49a4f0994b"],
    "FIVector_1_Windows__CInternal__CStateRepository__CMrtApplication": ["a3905282-f9fd-5e05-932c-1b632dea2a9d"],
    "FIVector_1_Windows__CInternal__CStateRepository__CMrtDefaultTile": ["3dc9a974-9fd2-5aa8-81a7-f854ef29302d"],
    "FIVector_1_Windows__CInternal__CStateRepository__CMrtPackage": ["939d0524-6f9f-5c7f-8d0d-4a1cc5014d68"],
    "FIVector_1_Windows__CInternal__CStateRepository__CMrtSharedPri": ["01a34cb5-62b7-55b9-a056-b590bc516a8e"],
    "FIVector_1_Windows__CInternal__CStateRepository__CMrtUserPri": ["fa40a827-a50e-5e0f-960b-712836a50da4"],
    "FIVector_1_Windows__CInternal__CStateRepository__COptionalBundle": ["f2a03749-789d-5c73-aad2-0d7adb65a8b9"],
    "FIVector_1_Windows__CInternal__CStateRepository__COptionalBundlePackage": ["6bd2f892-fa26-588d-a5cc-e8d5ce2d410e"],
    "FIVector_1_Windows__CInternal__CStateRepository__COptionalBundleResource": [
        "3d87321a-c178-5a89-a98d-7f2ebaf8804f"
    ],
    "FIVector_1_Windows__CInternal__CStateRepository__CPackage": ["3b99da4d-8852-5715-aa06-bbd5a5da1401"],
    "FIVector_1_Windows__CInternal__CStateRepository__CPackageExtension": ["f9eab6cc-573a-544f-9020-85c849c211be"],
    "FIVector_1_Windows__CInternal__CStateRepository__CPackageFamily": ["162e9e25-ff7c-5346-8b86-bbf172af0eb9"],
    "FIVector_1_Windows__CInternal__CStateRepository__CPackageFamilyPolicy": ["e7dafe36-3d1f-5365-b5f9-7c9fc22a0869"],
    "FIVector_1_Windows__CInternal__CStateRepository__CPackageFamilyUser": ["249ebcde-1271-54b9-894a-8de10c08a422"],
    "FIVector_1_Windows__CInternal__CStateRepository__CPackageIdentity": ["88ab0217-9821-5132-94df-26fd7ec6e9e3"],
    "FIVector_1_Windows__CInternal__CStateRepository__CPackageLocation": ["f76f75e6-cb0a-5daa-a02a-ed79cd81e2a6"],
    "FIVector_1_Windows__CInternal__CStateRepository__CPackageMachineStatus": ["8586cb55-ae89-501f-90b8-2f703e3737b1"],
    "FIVector_1_Windows__CInternal__CStateRepository__CPackagePolicy": ["cb0bce6c-6bdd-5c2f-bf4a-f4a43c197df6"],
    "FIVector_1_Windows__CInternal__CStateRepository__CPackageProperty": ["64e63837-bfa8-5263-bb01-03273936c8a7"],
    "FIVector_1_Windows__CInternal__CStateRepository__CPackageSourceUri": ["51a20b6d-9a37-5d41-8877-0d631202f2a9"],
    "FIVector_1_Windows__CInternal__CStateRepository__CPackageUser": ["f8a7ac37-f3ad-5d96-9592-fa1ec9f15638"],
    "FIVector_1_Windows__CInternal__CStateRepository__CPackageUserStatus": ["f9370361-71df-5056-a6b2-812d8e4d0cdf"],
    "FIVector_1_Windows__CInternal__CStateRepository__CPrimaryTile": ["255d0cd1-9825-52e6-a7b7-b206c7f26ffa"],
    "FIVector_1_Windows__CInternal__CStateRepository__CPrimaryTileUser": ["55ea7559-e2f5-5544-a315-62235b224c2e"],
    "FIVector_1_Windows__CInternal__CStateRepository__CPrimaryTileUserChangelog": [
        "97f0b4f1-746f-5523-8c8a-783319b56965"
    ],
    "FIVector_1_Windows__CInternal__CStateRepository__CPrimaryTileUserDataChange": [
        "1e3c8a0e-59d0-5e21-9b32-b88244a586f3"
    ],
    "FIVector_1_Windows__CInternal__CStateRepository__CPrimaryTileView": ["bc3a306d-fc58-5e9f-be5d-d38195554fc2"],
    "FIVector_1_Windows__CInternal__CStateRepository__CProtocol": ["cc120b37-0db1-536f-81c0-618b5008b969"],
    "FIVector_1_Windows__CInternal__CStateRepository__CProtocolLauncherInfo": ["a52273c5-909f-5299-849e-faeebbc04f27"],
    "FIVector_1_Windows__CInternal__CStateRepository__CPublisherCacheFolder": ["fb7bf6d1-3455-5a90-a162-bccd9c35613e"],
    "FIVector_1_Windows__CInternal__CStateRepository__CResource": ["2a4f0efc-1216-54d1-888a-8d0f838d228d"],
    "FIVector_1_Windows__CInternal__CStateRepository__CSecondaryTile": ["2c0ffa34-ec2c-5e9a-8a41-8d7e7b33ab7a"],
    "FIVector_1_Windows__CInternal__CStateRepository__CSecondaryTileUser": ["1e760e3f-dc35-53fd-8079-2337fa94486b"],
    "FIVector_1_Windows__CInternal__CStateRepository__CSecondaryTileUserChangelog": [
        "d3a37fdd-029e-5a70-a611-f21756a0aea4"
    ],
    "FIVector_1_Windows__CInternal__CStateRepository__CSecondaryTileUserDataChange": [
        "3407a6d3-6ff8-558a-8d39-ec9fa9c804ac"
    ],
    "FIVector_1_Windows__CInternal__CStateRepository__CSecondaryTileView": ["0bc2e48c-ab4d-5195-8ee6-224f0f7d63d5"],
    "FIVector_1_Windows__CInternal__CStateRepository__CSequence": ["b5018dd1-2a9e-5b7c-a27b-259319384bf9"],
    "FIVector_1_Windows__CInternal__CStateRepository__CTargetDeviceFamily": ["d79836d9-574a-5aaa-9fd1-98cf6cd1f858"],
    "FIVector_1_Windows__CInternal__CStateRepository__CTask": ["32e1d828-aabe-50e6-9ef3-ba04b35eda3f"],
    "FIVector_1_Windows__CInternal__CStateRepository__CTileView": ["b9290582-0370-56a2-bc59-810b1eea5e39"],
    "FIVector_1_Windows__CInternal__CStateRepository__CTileViewQueryFilter": ["e19dfa10-3dab-53b2-8d2e-8a544b141d1e"],
    "FIVector_1_Windows__CInternal__CStateRepository__CUser": ["dc65de18-1085-530b-b1d2-00bcd0583b75"],
    "FIVector_1_Windows__CInternal__CStateRepository__CVolume": ["f0327d26-2479-57d7-909d-14dc20de876a"],
    "FIVector_1_Windows__CInternal__CStateRepository__CWowDependencyGraph": ["cefb42c0-c5fd-5872-9bab-2636fbee02d6"],
    "FIVector_1_Windows__CInternal__CStateRepository__CXap": ["d8cdc0a2-c509-5ac5-a7b0-2a29d135f65c"],
    "FIVector_1_Windows__CInternal__CStateRepository__CXapExtension": ["6527ebb6-6d99-5e66-a25f-1cabede660e0"],
    "FIVector_1_Windows__CInternal__CStateRepository__CXboxPackage": ["7fa86231-4100-5c46-b731-683b425ac9d3"],
    "FIVector_1_Windows__CInternal__CStorage__CIFileOperationItemErrorInfo": ["f9f7168c-02c0-5fb5-86a2-2dea05994483"],
    "FIVector_1_Windows__CInternal__CStorage__CIStorageItemCommand": ["46d56450-8c2a-5c68-9982-baa165bb37c2"],
    "FIVector_1_Windows__CInternal__CStorage__CRecentItemsUpdateResult": ["0211a646-fbd7-5713-bea2-de7f9f5482f5"],
    "FIVector_1_Windows__CInternal__CUI__CShutdown__CShutdownUXOption": ["e955f9f8-e89b-55b2-afe3-24b74013e0da"],
    "FIVector_1_Windows__CManagement__CDeployment__CInternal__CDiskUsageInformation": [
        "3cd878e9-83be-54cf-82f7-5a12a5fce6e9"
    ],
    "FIVector_1_Windows__CManagement__CDeployment__CPackageUserInformation": ["6ddac472-ce9e-596d-a900-0e6dec659f8d"],
    "FIVector_1_Windows__CManagement__CDeployment__CPackageVolume": ["802ef7c0-5fc3-5425-a122-b29b3d1c8228"],
    "FIVector_1_Windows__CMedia__CIMediaMarker": ["057e6bc9-7bb8-5816-988b-8e9b3fb1bff4"],
    "FIVector_1_Windows__CMedia__CSpeechRecognition__CInternal__CSpeechRecognitionCorrectionGraphArc": [
        "7982dbb5-8aba-5a8c-b215-ab563d5cc3e4"
    ],
    "FIVector_1_Windows__CMedia__CSpeechRecognition__CInternal__CSpeechRecognitionCorrectionGraphNode": [
        "e8a4627a-54de-54e8-8b6f-c8dbdf32dcdc"
    ],
    "FIVector_1_Windows__CMedia__CSpeechRecognition__CSpeechRecognitionResult": [
        "07035819-cc06-5409-96d9-7a4b7a383b93"
    ],
    "FIVector_1_Windows__CMedia__CSpeechSynthesis__CVoiceInformation": ["00bd028a-e2ad-57af-9829-f8b273d2717b"],
    "FIVector_1_Windows__CMedia__CSpeech__CSpeechSupportedLanguage": ["66db8a37-a752-5696-a014-acb5be4fe964"],
    "FIVector_1_Windows__CNetworking__CConnectivity__CAttributedNetworkUsage": ["d220b5a5-540c-55c3-bfe9-45eab220a951"],
    "FIVector_1_Windows__CNetworking__CConnectivity__CConnectionProfile": ["d0a5c969-441b-594c-8891-6fda42d8283f"],
    "FIVector_1_Windows__CNetworking__CConnectivity__CConnectivityInterval": ["52698cdd-59ff-54b6-a4e5-d47f9f8ab3ea"],
    "FIVector_1_Windows__CNetworking__CConnectivity__CDataUsage": ["54c601c4-263e-584b-9c55-4e6b2788faf7"],
    "FIVector_1_Windows__CNetworking__CConnectivity__CLanIdentifier": ["a9920fca-8d49-57e5-8574-80ebf827e5e4"],
    "FIVector_1_Windows__CNetworking__CConnectivity__CNetworkUsage": ["7c6dbdb3-9bcc-5191-ab9c-02cc62181572"],
    "FIVector_1_Windows__CNetworking__CEndpointPair": ["f996138f-a866-5ca4-ba46-09fcb2de7013"],
    "FIVector_1_Windows__CNetworking__CUX__CIAvailableNetwork": ["0a0f6e0b-65ae-5f3f-941b-3597508526e9"],
    "FIVector_1_Windows__CNetworking__CUX__CIAvailableNetworkOffer": ["4916a864-3ae4-5e78-aa14-6a5b2fe54ed3"],
    "FIVector_1_Windows__CNetworking__CUX__CIAvailableNetworkProvider": ["1e6ed886-b560-5232-b307-efd67f1799fd"],
    "FIVector_1_Windows__CNetworking__CUX__CICertItemInfo": ["3e0f576a-64a8-58b4-a088-bd0e149bd881"],
    "FIVector_1_Windows__CNetworking__CUX__CIHotspot2RegisterProvider": ["5622537f-12ee-5bc1-b140-d69f0ec25c50"],
    "FIVector_1_Windows__CNetworking__CUX__CISimItemInfo": ["a04a6058-ed97-5833-be47-9104cf0ce396"],
    "FIVector_1_Windows__CNetworking__CUX__CIUXCategory": ["6feabef1-e897-57d2-a8d2-bb3ec1b38f5d"],
    "FIVector_1_Windows__CNetworking__CUX__CIVPNCustomInputItem": ["bd68c066-3724-55ba-9f40-285fce904072"],
    "FIVector_1_Windows__CNetworking__CUX__CIWiFiEapMethod": ["5e8345c4-f8f1-599f-a200-a7446ba0a177"],
    "FIVector_1_Windows__CNetworking__CUX__CIWiFiProfile": ["6c02c57f-5dea-557e-b369-a2515d2d5ec9"],
    "FIVector_1_Windows__CNetworking__CUX__CIWiFiSenseSocialNetwork": ["ad124bc0-075a-5b9a-b544-8e111fa3af03"],
    "FIVector_1_Windows__CNetworking__CUX__CNetworkMediaType": ["501a5755-064c-5034-9e9a-1d94e924d5a8"],
    "FIVector_1_Windows__CSecurity__CAuthentication__CIdentity__CCore__CMicrosoftAccountMultiFactorSessionInfo": [
        "5fb049e0-d8ae-5ce7-9164-d6747d7888dc"
    ],
    "FIVector_1_Windows__CSecurity__CAuthentication__COnlineId__COnlineIdServiceTicket": [
        "a8794900-8517-56e7-bc36-c7480519135f"
    ],
    "FIVector_1_Windows__CSecurity__CAuthentication__COnlineId__COnlineIdServiceTicketRequest": [
        "f6ed9226-b260-5f49-9b84-e89e43cbabc6"
    ],
    "FIVector_1_Windows__CSecurity__CAuthentication__CWeb__CCore__CWebTokenResponse": [
        "58dc4e4c-a84d-5ad6-a6d9-6ee477329c9f"
    ],
    "FIVector_1_Windows__CSecurity__CAuthentication__CWeb__CProvider__CWebAccountClientView": [
        "43184ef9-2c17-599d-8fa3-48270f365492"
    ],
    "FIVector_1_Windows__CSecurity__CCredentials__CPasswordCredential": ["1d0e801c-b8b4-5c03-a32c-45dcf65cc978"],
    "FIVector_1_Windows__CSecurity__CCredentials__CWebAccount": ["fe11c488-371a-5330-b7fa-282326fdfbda"],
    "FIVector_1_Windows__CSecurity__CCredentials__CWebAccountProvider": ["496bc8c3-614a-59b5-9fa4-5d71b17faa19"],
    "FIVector_1_Windows__CServices__CTargetedContent__CInternal__CTargetedContentTriggerInternal": [
        "b59404b5-d83a-53dd-8845-e0e17df68feb"
    ],
    "FIVector_1_Windows__CServices__CTargetedContent__CTargetedContentAction": ["f3ad0d23-dd06-51c5-8fe4-8d030d5c093a"],
    "FIVector_1_Windows__CServices__CTargetedContent__CTargetedContentCollection": [
        "efa7e21b-562c-5fcc-82bd-0ceebd9d9c61"
    ],
    "FIVector_1_Windows__CServices__CTargetedContent__CTargetedContentFile": ["aede9a39-ffa7-5885-8cc5-46d7e05230a4"],
    "FIVector_1_Windows__CServices__CTargetedContent__CTargetedContentImage": ["b967c042-f7b9-538d-a427-c102c22a6501"],
    "FIVector_1_Windows__CServices__CTargetedContent__CTargetedContentItem": ["827bf6cf-4301-5b2a-a3bd-09edb0417241"],
    "FIVector_1_Windows__CStorage__CIStorageFile": ["021a3f69-ad1e-5fb9-978a-056984ae2b2d"],
    "FIVector_1_Windows__CStorage__CIStorageFolder": ["ad736464-7886-5872-88e3-395643c94759"],
    "FIVector_1_Windows__CStorage__CIStorageItem": ["802508e2-9c2c-5b91-89a8-39bcf7223344"],
    "FIVector_1_Windows__CStorage__CPickers__CIPickerFileType": ["35cc9ef9-7693-5446-816e-8f54751fdc73"],
    "FIVector_1_Windows__CStorage__CPickers__CUpdateFilesResult": ["7383b778-02c0-51ea-8ccc-298863ab7544"],
    "FIVector_1_Windows__CStorage__CSearch__CIIndexableContent": ["d44eaa11-4871-50c5-8e70-ab765b5bb332"],
    "FIVector_1_Windows__CStorage__CSearch__CSortEntry": ["d8ea401b-47b3-5254-84f4-eea10c4cf068"],
    "FIVector_1_Windows__CStorage__CStorageFile": ["fcbc8b8b-6103-5b4e-ba00-4bc2cedb6a35"],
    "FIVector_1_Windows__CStorage__CStorageFolder": ["6c26b7be-5f01-5a60-9dd7-fd17be3a9dd6"],
    "FIVector_1_Windows__CStorage__CStorageLibraryChange": ["0e874d56-47fb-5e37-b05a-eea1bc5e4c80"],
    "FIVector_1_Windows__CStorage__CStreams__CIBuffer": ["308fe894-cc06-5007-bc85-cbe94ac1a70c"],
    "FIVector_1_Windows__CStorage__CStreams__CIRandomAccessStream": ["2736b66b-daa3-5e0c-9842-6a0f44b5440b"],
    "FIVector_1_Windows__CStorage__CStreams__CIRandomAccessStreamReference": ["cd028086-84cb-587e-9f0a-c711d7724642"],
    "FIVector_1_Windows__CSystem__CInternal__CIUserProfile": ["cdfcd9ad-38cf-5e80-a8a6-b531265ded77"],
    "FIVector_1_Windows__CSystem__CInternal__CLaunch__CAppServiceExtensionInfo": [
        "5d1b8067-5e7f-5eff-b3aa-e7d5cfaf0558"
    ],
    "FIVector_1_Windows__CSystem__CInternal__CLaunch__CExtensionInfo": ["a0cd89fa-c82c-5db1-b2d1-cd32747e65eb"],
    "FIVector_1_Windows__CSystem__CRemoteSystems__CIRemoteSystemFilter": ["6874a925-e651-5eae-88a7-63df5b999205"],
    "FIVector_1_Windows__CSystem__CRemoteSystems__CRemoteSystem": ["401d73fe-9b73-53ac-8ea5-e7bec456c292"],
    "FIVector_1_Windows__CSystem__CUser": ["8cb35b00-501c-5532-a664-38c9c429bb1a"],
    "FIVector_1_Windows__CUI__CInput__CPointerPoint": ["dfa655cf-fde7-5048-b4bf-c909231b7edb"],
    "FIVector_1_Windows__CUI__CInput__CRadialControllerSystemMenuItemKind": ["be61f6bf-0d38-5a33-8ae6-43498ec7ce92"],
    "FIVector_1_Windows__CUI__CNotifications__CAdaptiveNotificationText": ["13cf8eab-bcf0-5f03-a79b-fafde70516f3"],
    "FIVector_1_Windows__CUI__CNotifications__CScheduledTileNotification": ["69272d2c-74a5-5cd9-b2c5-51af99fcc732"],
    "FIVector_1_Windows__CUI__CNotifications__CScheduledToastNotification": ["693ec648-d35a-5be9-a9c1-ba334c337b83"],
    "FIVector_1_Windows__CUI__CNotifications__CShownTileNotification": ["b4bad011-41fa-5704-92ed-a697af1f1d7c"],
    "FIVector_1_Windows__CUI__CNotifications__CToastCollection": ["d0ee15ce-85f3-5ee1-8c83-e69bb60337da"],
    "FIVector_1_Windows__CUI__CNotifications__CToastNotification": ["810f8c42-a267-5ba0-9538-48b9ecc433b8"],
    "FIVector_1_Windows__CUI__CNotifications__CUserNotification": ["c3a1ccf9-15cc-5a3f-a7c1-b62c5c3fb20c"],
    "FIVector_1_Windows__CUI__CPopups__CIUICommand": ["105139a1-dcb8-5f65-97ef-cb1bf0b75f9d"],
    "FIVector_1_Windows__CUI__CSearch__CInternal__CCommon__CLocalGroupScore": ["4175d1f3-31de-5134-897a-489377b748c1"],
    "FIVector_1_Windows__CUI__CStartScreen__CSecondaryTile": ["7746d0eb-48b1-54ea-b91a-e0c303ac208a"],
    "FIVector_1_Windows__CUI__CStartScreen__CSecondaryTileVisualElements": ["ed460c68-6b09-55f2-829a-4bd7525eb780"],
    "FIVector_1_Windows__CUI__CWindowManagement__CDisplayRegion": ["ee81b89d-d580-5c79-889b-9e11ee20a055"],
    "FIVector_1_Windows__CUI__CWindowManagement__CWindowingEnvironment": ["92b96ade-7f9d-5535-8b48-e6e7d230751d"],
    "FIVector_1_Windows__CWeb__CAtomPub__CResourceCollection": ["572a8cab-2af3-5c4f-bea7-de6852805b5b"],
    "FIVector_1_Windows__CWeb__CAtomPub__CWorkspace": ["4477115d-e35c-5a07-b922-f897ce56333d"],
    "FIVector_1___FIKeyValuePair_2_IInspectable_IInspectable": ["f4091a72-42cd-513d-99e0-eda70bad3d24"],
    "FIVector_1___FIMapView_2_HSTRING_IInspectable": ["9ac5167a-7c19-53d6-85b8-1e479a971d1e"],
    "FIVector_1___FIVector_1_float": ["020d3024-7451-51db-b864-bceabda468cc"],
    "FIVector_1___F__CIPropertySet": ["5edafa1c-8b95-5636-831d-25728c19b04f"],
    "FIVector_1_boolean": ["6180171d-2ed8-5e24-8a55-01ecb1009eb2"],
    "FIVector_1_byte": ["381832a4-3c25-53a4-9bb7-f33ecdcf044f"],
    "FMapChangedEventHandler_2_HSTRING_Windows__CStorage__CStreams__CRandomAccessStreamReference": [
        "c6ca2c4d-10f9-5a2d-b6a4-222bbdded42c"
    ],
    "FVectorChangedEventHandler_1_HSTRING": ["cb6c396f-4861-5296-b14b-bd90b941a3e0"],
    "FVectorChangedEventHandler_1_Windows__CApplicationModel__CContacts__CInternal__CIContactActionControl": [
        "525019b7-f775-5795-9237-6b23381b30a9"
    ],
    "FVectorChangedEventHandler_1_Windows__CApplicationModel__CContacts__CInternal__CIContactActionControlItem": [
        "ff0ff776-190e-55eb-8b91-1618d2352e15"
    ],
    "FVectorChangedEventHandler_1_Windows__CApplicationModel__CSearch__CCore__CSearchSuggestion": [
        "cb7b988b-468a-5eae-afe4-df8b005f80af"
    ],
    "FVectorChangedEventHandler_1_Windows__CInternal__CBindableObservableItem": [
        "1d57e9ec-6582-59bf-9dfe-ef1f16eb9607"
    ],
    "FVectorChangedEventHandler_1_Windows__CStorage__CStorageFolder": ["2057b641-4b9b-5338-a19a-e9a951916775"],
    "FVectorChangedEventHandler_1_Windows__CUI__CWindowManagement__CDisplayRegion": [
        "4f469e77-b8b2-52b2-aae5-d951f5711f89"
    ],
    "FVectorChangedEventHandler_1_float": ["78c6b6af-1777-5f03-9f99-95541630b5f2"],
    "x_ABI_CWindows_CInternal_CSecurity_CSmartScreen_CDownload_CIDownloadReputationResult": [
        "b23967d8-6222-4624-98fc-e1205fb5ed00"
    ],
    "x_ABI_CWindows_CInternal_CSecurity_CSmartScreen_CDownload_CIDownloadReputationService": [
        "33fadaeb-be5a-4ef6-9040-a7080a06b59d"
    ],
    "x_ABI_CWindows_CInternal_CSecurity_CSmartScreen_CDownload_CIDownloadReputationServiceStatics": [
        "10a51b1f-28cd-40c2-b8ce-ca8c048eb9d8"
    ],
    "x_ABI_CWindows_CInternal_CSecurity_CSmartScreen_CDownload_CIFileReputationResult": [
        "48748dc6-576c-47c0-8169-b99cc31a68fe"
    ],
    "x_ABI_CWindows_CInternal_CSecurity_CSmartScreen_CDownload_CIFileReputationService": [
        "67e7f99b-1b65-4343-825d-eb17c9681805"
    ],
    "x_ABI_CWindows_CInternal_CSecurity_CSmartScreen_CIAppReputationService": ["d9dc3975-1062-470a-994c-409151ff8f54"],
    "x_ABI_CWindows_CInternal_CSecurity_CSmartScreen_CIAppReputationServiceStatics": [
        "343baa78-e34f-466c-9ffa-81af5ce4cd34"
    ],
    "x_ABI_CWindows_CInternal_CSecurity_CSmartScreen_CIButtonInfo": ["9ad9b845-b683-493e-8d39-45a56d54617d"],
    "x_ABI_CWindows_CInternal_CSecurity_CSmartScreen_CIConfigurationStore": ["71789660-fa6c-4c1f-af07-91a94c4c4d9f"],
    "x_ABI_CWindows_CInternal_CSecurity_CSmartScreen_CIDeferredParametersHandler": [
        "741baa78-e96f-466c-9ffa-81af5ce4cd59"
    ],
    "x_ABI_CWindows_CInternal_CSecurity_CSmartScreen_CIEventLogger": ["a3104ea9-a816-4fdc-860c-75408a04b686"],
    "x_ABI_CWindows_CInternal_CSecurity_CSmartScreen_CIEventLoggerFactory": ["16ae6386-0aa2-45fc-aab2-f2ee3a0f3188"],
    "x_ABI_CWindows_CInternal_CSecurity_CSmartScreen_CIHtmlContentInfo": ["680d04e6-9661-4ac5-b962-58b112ffa5e6"],
    "x_ABI_CWindows_CInternal_CSecurity_CSmartScreen_CIPopupButtonInfo": ["c729ad47-6f3a-46f4-af74-3b5c3311e6ed"],
    "x_ABI_CWindows_CInternal_CSecurity_CSmartScreen_CIUriReputationExperienceInfo": [
        "7fdde05c-d2db-495b-b06d-4a8d84f3ab99"
    ],
    "x_ABI_CWindows_CInternal_CSecurity_CSmartScreen_CIUriReputationResult": ["1d5bc3a2-a3ff-4517-bb16-25bf18ef7378"],
    "x_ABI_CWindows_CInternal_CSecurity_CSmartScreen_CIUriReputationService": ["a774d785-2808-4471-a254-ab93932b61ea"],
    "x_ABI_CWindows_CInternal_CSecurity_CSmartScreen_CIUriReputationServiceStatics": [
        "29a3ab33-0fd7-44f5-9bff-c0b6c081fbfb"
    ],
    "x_ABI_CWindows_CInternal_CSecurity_CSmartScreen_CIUriReputationSettings": ["3474d734-3408-4471-a344-a3439343634a"],
    "x_ApplicationTheme_CIAppThemeApiStatics": ["c5f80e59-a9fc-439d-9fc4-d290858e1867"],
    "x_ApplicationTheme_CIAppThemeBrokeredApiStatics": ["e287f4c6-2d4d-417c-9683-5aebc3748cab"],
    "x_ApplicationTheme_CIAppThemeBrokeredApiStatics2": ["c87581d5-86cf-4954-bb3a-cd54c8c8f026"],
    "x_ApplicationTheme_CIAppThemeBrokeredPlatformApiStatics": ["57d63fab-8068-4863-8c98-1a06acd39123"],
    "x_ApplicationTheme_CIAppThemeBrokeredStreamApiStatics": ["524abea5-b9b3-4de5-9ca0-39082673aca7"],
    "x_ApplicationTheme_CIThemeImageStream": ["6e29abd4-0d1e-43e3-86c5-dd1360033b20"],
    "x_ContentManagement_CIActionHelper": ["3de57b85-d574-488b-9d07-81cd7c7e49df"],
    "x_ContentManagement_CIAppInstallInfoRecord": ["82929d2b-e4ba-49a3-af91-dadf7766d476"],
    "x_ContentManagement_CIAppManager": ["05e033e9-71df-4144-a1c6-a80806e71984"],
    "x_ContentManagement_CIContentDeliveryManagerConfiguration": ["b327e68c-b800-42f5-b32c-2ceb8ba5921d"],
    "x_ContentManagement_CIContentManagementBroker": ["3a69b236-b165-48ee-a67b-8c69dfc25578"],
    "x_ContentManagement_CIContextualSuggestionsManager": ["b56a8e91-f7d4-47db-a915-40f6f26a2ed6"],
    "x_ContentManagement_CICreativeEventReportedCache": ["d78a1df0-8b05-4341-bb0a-c4447a03a912"],
    "x_ContentManagement_CIFeatureManager": ["0b6ddd08-896c-4665-a48d-8ec84a507666"],
    "x_ContentManagement_CIIdentityManager": ["4d87b505-273b-4fd3-b58f-2cbb586e954e"],
    "x_ContentManagement_CILaunchManager": ["3cb33ed0-2338-4892-aa4c-c96803309c9a"],
    "x_ContentManagement_CINotificationManager": ["b412ca38-e35f-4f90-b212-aded7a773962"],
    "x_ContentManagement_CIProcessContextualSuggestionsEvent": ["8d90e3e1-f1d7-4681-aec8-5c436a53c1d4"],
    "x_ContentManagement_CIProcessCreativeEvent": ["f0f510ec-e306-4fa9-9162-cd5142078f72"],
    "x_ContentManagement_CIProcessLockScreenEvent": ["30edbf80-0d30-4f30-a533-63ab65344500"],
    "x_ContentManagement_CIProcessStartMenuEvent": ["c133af56-71bc-4a53-8020-2af3cc1ba2f5"],
    "x_ContentManagement_CIThumbnailCacheHelper": ["d75aa9a4-4b0c-4d61-8fa9-51016cc2622c"],
    "x_ContentManagement_CIWindowExperienceManager": ["ae8be46e-c53f-4d3c-bca2-52b917ba6d04"],
    "x_ContentManagement_CTargetedContent_CITargetedContentCollection": ["275f413e-8d08-4317-a941-9c1a0c28b88c"],
    "x_ContentManagement_CTargetedContent_CITargetedContentImage": ["9e70de81-066b-494d-b0da-f90a90bf8266"],
    "x_ContentManagement_CTargetedContent_CITargetedContentInteractionReporter": [
        "111d9cd1-419d-4ade-a083-68f73750c18e"
    ],
    "x_ContentManagement_CTargetedContent_CITargetedContentItem": ["3a48f6a2-4e17-4a86-aca9-a93a958ecafb"],
    "x_ContentManagement_CTargetedContent_CITargetedContentSubscription": ["ec918fa8-1974-4c19-ade0-6e1ae4148ac2"],
    "x_ContentManagement_CTargetedContent_CITargetedContentSubscriptionStatics": [
        "6cfef37d-8a37-4c33-a163-2b33a7ba0584"
    ],
    "x_ContentManagement_CTargetedContent_CITargetedContentUpdatedEventArgs": ["889f16fc-66ce-4e67-8288-5d301a8bbb3c"],
    "x_ContentManagement_CTargetedContent_CITargetedContentValue": ["175437d0-ab0a-4cfd-aa42-d32e2ae5d0dc"],
    "x_ContentManagement_CTargetedContent_CInternal_CIPartialTrustSubscriptionFactory": [
        "86c6f555-2dcd-423c-ba53-4197b86d3b51"
    ],
    "x_ContentManagement_CTargetedContent_CInternal_CISubscriptionManager": ["d5343860-de91-4cae-b38a-84536a72847c"],
    "x_ContentManagement_CTargetedContent_CInternal_CISubscriptionPriv": ["abd0aea7-14e7-4d83-80d4-ee8a293e8af9"],
    "x_DeviceFlows_CSystemInteractionProviders_CIBluetoothAudioProvider": ["3fa75aa4-8b88-4993-b293-9c4a0de2f5e8"],
    "x_DeviceFlows_CSystemInteractionProviders_CIBluetoothProfileChangedEventArgs": [
        "0ca3fd5f-8057-4ab8-af24-1bb2982a7dd9"
    ],
    "x_DeviceFlows_CSystemInteractionProviders_CIDevicesFlowProvider": ["36774b83-39df-4f8c-9b8b-7706aa8327cc"],
    "x_DeviceFlows_CSystemInteractionProviders_CIDisplayInteractionProvider": ["b1dca328-f2cc-43ad-a89a-ca91550ea9bf"],
    "x_DevicesFlowInteraction_CConnection_CIConnectionErrorInfo": ["1111702c-fb5a-4bfb-aff8-4f8b418bd0a5"],
    "x_DevicesFlowInteraction_CConnection_CIConnectionStateChangedEventArgs": ["6a0b2a60-3955-4802-ba14-93d5af8d3a23"],
    "x_DevicesFlowInteraction_CConnection_CIDeviceConnection": ["fda06235-f98e-4e82-96e0-bf01e37fbf0d"],
    "x_DevicesFlowInteraction_CConnection_CIDeviceConnectionListener": ["8e249e31-fd7a-4fb0-9a23-721b68e5318f"],
    "x_DevicesFlowInteraction_CConnection_CIDeviceConnectionManager": ["74525071-bff2-4721-b28e-d1e0088994ea"],
    "x_DevicesFlowInteraction_CConnection_CIDeviceConnectionManagerStatic": ["eddbab7d-0ead-458b-b7d9-13a3af74eb9b"],
    "x_DevicesFlowInteraction_CConnection_CIDeviceInteractionManager": ["60b1f356-1787-4510-bf85-d32c39d9398a"],
    "x_DevicesFlowInteraction_CConnection_CIDeviceInteractionManagerStatic": ["3e98ed04-3b2d-4436-934c-bdc8a843395c"],
    "x_DevicesFlowInteraction_CConnection_CIDeviceInteractionTelemetry": ["601364b9-faef-4fa6-aad1-a1e562ec8dcd"],
    "x_DevicesFlowInteraction_CConnection_CIDeviceWithDisplayConnection": ["8b317a4b-d737-4949-be6b-a36fdf2e8d6a"],
    "x_DevicesFlowInteraction_CConnection_CIPairingInteractionHandler": ["b78ef25b-b784-49c4-9538-243d087f346f"],
    "x_DevicesFlowInteraction_CConnection_CIPairingOperation": ["99efee85-2021-4ffa-b1eb-c2293c50d2b0"],
    "x_DevicesFlowInteraction_CConnection_CIUIBCHandler": ["5f5a5449-e8f3-453b-b6c8-4b89f032f4f7"],
    "x_Microsoft_CPushNotifications_CInternal_CIPushConnectionStatusChangedEventArgs": [
        "a34e9f68-c847-4ed4-90be-f875f6763c03"
    ],
    "x_Microsoft_CPushNotifications_CInternal_CIPushNotificationChannelExtensionForPhoneLegacy": [
        "21d0d7de-d64a-4299-b715-165fca5502af"
    ],
    "x_Microsoft_CPushNotifications_CInternal_CIPushNotificationChannelManagerExtensionForPhoneLegacy": [
        "eb86fab7-cf3e-4462-8cd6-9b88863d2420"
    ],
    "x_PhoneInternal_CExperiences_CCalendar_CIAppointmentStoreStaticsInternal": [
        "644c4f46-de45-4575-bd19-597c9d2fc0bb"
    ],
    "x_PhoneInternal_CExperiences_CCalendar_CISearchAppointmentResult": ["36fdfc25-2307-41c5-b995-e38637c6f84c"],
    "x_PhoneInternal_CExperiences_CChat_CIChatMessageStoreInternal": ["b9eca16c-1856-4972-83ba-a4c1161c66f2"],
    "x_PhoneInternal_CExperiences_CSync_CIAccount": ["69cdf7ef-80d4-457f-9ba7-e339c90b6735"],
    "x_PhoneInternal_CExperiences_CSync_CIAccountChangedEventArgs": ["c0634414-6dba-46cc-a0b0-33afdf8f3f89"],
    "x_PhoneInternal_CExperiences_CSync_CIAccountErrorInformation": ["334a5d9c-8026-47e5-a9f6-efc7500e6315"],
    "x_PhoneInternal_CExperiences_CSync_CIAccountPropertiesStatics": ["6e9ae4b1-61fd-4978-b813-82bc96870769"],
    "x_PhoneInternal_CExperiences_CSync_CIAccountSyncScheduleInformation": ["51233c4a-d688-44b8-8008-277cd6780410"],
    "x_PhoneInternal_CExperiences_CSync_CIAccountsManagerStatics": ["28a8c3fc-758e-4ac3-be71-7461a2a525bc"],
    "x_PhoneInternal_CExperiences_CSync_CIEmailServerSettingsDiscovery": ["a813844e-71de-4935-a165-a0877a8de5d7"],
    "x_PhoneInternal_CExperiences_CSync_CIExchangeServerDiscoveryResult": ["f8858201-d546-4126-a4e3-6736ca5900d5"],
    "x_PhoneInternal_CExperiences_CSync_CIInternetMailServerDiscoveryResult": ["6521c1ab-9657-417d-a49b-20dc57fc0a92"],
    "x_PhoneInternal_CExperiences_CSync_CIWebAuthSettings": ["9eadf9ab-506c-4644-9a06-de9f9e40113e"],
    "x_ProximityConnect_CBroker_CIDockConnectionSession": ["b3ea42e4-e4e6-4516-a457-e41d497fd388"],
    "x_ProximityConnect_CBroker_CIProximityConnectBroker": ["ddc4185e-1350-4548-ae7e-3f8885b8bafb"],
    "x_SharedStartModel_CIAppInstallHelpers": ["6829ec37-50a6-4788-8bc4-d2b869844824"],
    "x_SharedStartModel_CIEdpTileHelpers": ["e65b9b04-89cc-40e2-87bc-2902f7b23903"],
    "x_SharedStartModel_CILayoutSelectionHelpers": ["539fe289-c0e0-4959-9a2f-bd846bc9b2c8"],
    "x_SharedStartModel_CIPlatformSpecificTileVerbHelperStatics": ["052a8f0f-5fc4-4eb9-bf3b-8bc4d985873a"],
    "x_SharedStartModel_CIPlatformSpecificTileVerbHelperStatics2": ["60dc66f7-ee76-4b26-b95b-59366af24aa4"],
    "x_SharedStartModel_CIStartLayoutInitializationStatics": ["af581601-f71a-4a31-8f8d-91f7df79371f"],
    "x_SharedStartModel_CITileGridSizeHelperStatics": ["51fbae08-24c9-4093-bafd-db18b2cebd98"],
    "x_SharingPlatform_CIBinarySessionStreamStatics": ["045cf0a4-8964-4416-a5e6-4836c320e62c"],
    "x_SharingPlatform_CIDeviceIdentifier": ["54eaeb79-a261-47e6-b34e-7b5f8d012890"],
    "x_SharingPlatform_CIDeviceIdentifierStatics": ["743bf1a5-5e76-4ebe-9b36-9700ce9acea8"],
    "x_SharingPlatform_CIDeviceSessionBinaryChannel": ["56645f2a-f779-48c1-aacf-62586a3c7279"],
    "x_SharingPlatform_CIDeviceSessionChannel": ["9fda45aa-73c9-404b-bc95-1108ea66e487"],
    "x_SharingPlatform_CIDeviceSessionChannelCallback": ["255b794d-a24b-457c-8107-4ef363f95da5"],
    "x_SharingPlatform_CIDeviceSessionQueryStatic": ["c892d1c9-0e80-431c-acf7-58bebc0c405d"],
    "x_SharingPlatform_CIInvitationEventArgs": ["4b16d732-e6d2-4e17-9020-24c2490fc3f5"],
    "x_SharingPlatform_CIInvitationManager": ["abef8a40-a0ae-45fd-aa13-8089191ebbe6"],
    "x_SharingPlatform_CIInvitationManagerStatics": ["1f8d4340-7889-4f5d-8431-b65dc77c9d8f"],
    "x_SharingPlatform_CIInvitationRequestEventArgs": ["0985abbf-9850-40a4-b56b-7ba581d1294b"],
    "x_SharingPlatform_CIParticipantIdentifier": ["fe3102bc-2491-40fc-be29-10368639afa9"],
    "x_SharingPlatform_CIParticipantJoinedEventArgs": ["9fdbf962-061c-44e8-acfe-779a37343f90"],
    "x_SharingPlatform_CIParticipantLeftEventArgs": ["d683f1fa-96e4-470a-aed4-73a49ed00ad4"],
    "x_SharingPlatform_CISession": ["391f3070-ca7d-4d62-a38a-d7ed4b10d2b2"],
    "x_SharingPlatform_CISessionIdentifier": ["59720dde-9dc2-4196-a962-dd6a9320d578"],
    "x_SharingPlatform_CISessionIdentifierStatics": ["8bbaf23a-8587-4ce2-95ac-b475a32021f4"],
    "x_SharingPlatform_CISessionStateChangedEventArgs": ["b00cb57e-69a4-4176-a0be-fa70fa672a68"],
    "x_SharingPlatform_CISessionStatics": ["6d82c119-880a-4a3d-af6b-df0bb266518c"],
    "x_SharingPlatform_CISharingPlatformStatics": ["dfb8ba41-a6f5-480f-b875-991ed198150a"],
    "x_SharingPlatform_CISharingSessionMessageReceivedEventArgs": ["21a4458b-ad30-41ee-a502-c0b4eb857ebc"],
    "x_StartLayout_CIStartLayout": ["a2fe1af5-3eb7-4213-8761-6918a2c4b7fc"],
    "x_StartLayout_CIStartLayoutInitialization": ["571d4428-f553-4eba-a396-7f94f61d3ed2"],
    "x_SttProxy_CIProxyMessageReceivedListener": ["9e4acadc-549f-40bd-aea2-27d09522d7bc"],
    "x_SttProxy_CISttBroker": ["a7577229-a6a7-4bb6-908e-db18ac89ba60"],
    "x_WindowsInternal_CApplicationModel_CCalls_CIAppLauncherStatics": ["5393122d-07dd-45d3-9aed-acfbf1895eab"],
    "x_WindowsInternal_CApplicationModel_CCalls_CIIncomingCallToastStatics": ["495958d0-37b1-494b-90a4-07258caf648f"],
    "x_WindowsInternal_CApplicationModel_CCalls_CIPhoneVoicemailExtended": ["4cede541-c2a9-4342-bac3-dc63905312b0"],
    "x_WindowsInternal_CApplicationModel_CCalls_CIRcsPresenceManagerStatics": ["9f725c20-a3b4-4333-8553-739f44ae1791"],
    "x_WindowsInternal_CShell_CDataStoreCache_CIMRTResourceBroker": ["41dd8330-e9bc-dc1b-3251-5fc433f9fe09"],
    "x_WindowsInternal_CShell_CUnifiedTile_CCuratedTileCollections_CICuratedCollectionInitializationStatics": [
        "23755ada-c906-47a2-a10b-4da3c6395bfe"
    ],
    "x_WindowsInternal_CShell_CUnifiedTile_CCuratedTileCollections_CICuratedCollectionSelectionHelpers": [
        "ead4db3c-9613-4ce2-9129-1673291a06eb"
    ],
    "x_WindowsInternal_CShell_CUnifiedTile_CCuratedTileCollections_CITileGridSizeHelperStatics": [
        "b8dc54ce-bf4b-440c-a1a7-af888c4198f1"
    ],
    "x_WindowsInternal_CShell_CUnifiedTile_CILegacyPhoneUnifiedTileIdentifier": [
        "6a30abf7-3532-440f-b274-0808599650b5"
    ],
    "x_WindowsInternal_CShell_CUnifiedTile_CILegacyPhoneUnifiedTileIdentifierFactory": [
        "175f5434-559b-4b38-ae24-d2375ce84d17"
    ],
    "x_WindowsInternal_CShell_CUnifiedTile_CIPackagedUnifiedTileIdentifier": ["a7668288-cc23-4b67-be8b-6c10455986b8"],
    "x_WindowsInternal_CShell_CUnifiedTile_CIPackagedUnifiedTileIdentifierFactory": [
        "ec3e7864-aaab-4367-9c63-94d289545500"
    ],
    "x_WindowsInternal_CShell_CUnifiedTile_CITargetedContentUnifiedTileIdentifier": [
        "e469435a-81af-4bb5-8418-e74d3f567bca"
    ],
    "x_WindowsInternal_CShell_CUnifiedTile_CITargetedContentUnifiedTileIdentifierFactory": [
        "ad07506d-ca39-4cdf-ad80-c30f01e553f5"
    ],
    "x_WindowsInternal_CShell_CUnifiedTile_CIUnifiedTileIdentifier": ["e12904ba-efe1-4d5e-8756-eab44171ccb8"],
    "x_WindowsInternal_CShell_CUnifiedTile_CIUnifiedTileIdentifierStatics": ["87a52467-266a-4b20-a2c8-e316bfbaf64a"],
    "x_WindowsInternal_CShell_CUnifiedTile_CIWin32UnifiedTileIdentifier": ["5e8c6b47-79d6-40ac-8f45-30f87e82c583"],
    "x_WindowsInternal_CShell_CUnifiedTile_CIWin32UnifiedTileIdentifierFactory": [
        "0e7735be-a965-44a6-a75f-54b8bcd67bec"
    ],
    "x_Windows_CApplicationModel_CActions_CIActionActivationInfo": ["8b97f5ac-023f-43c2-ad4b-d94aa08582bd"],
    "x_Windows_CApplicationModel_CActions_CIActionArgs": ["828e7693-094b-4c6c-979b-5b6fdfec9a0c"],
    "x_Windows_CApplicationModel_CActions_CIActionExecutionBroker": ["515fed51-6f4d-45cb-845f-148f7765e829"],
    "x_Windows_CApplicationModel_CActions_CIActionHandler": ["3b52b746-6561-4abb-b920-9cc5a2006302"],
    "x_Windows_CApplicationModel_CActions_CIBackStackActivationInfo": ["af5ae8ee-e466-4676-8872-4b05ab0fbd58"],
    "x_Windows_CApplicationModel_CActions_CIExplicitlyPositionedHostedFlyoutActivationInfo": [
        "42598afc-655b-444c-8cdd-8f2e84436226"
    ],
    "x_Windows_CApplicationModel_CActions_CIHostedActionHandler": ["32bfd230-91ce-4920-9f3d-de42085c97a5"],
    "x_Windows_CApplicationModel_CActions_CIHostedFlyoutActivationInfo": ["d91c3051-7d72-4196-848a-3662d0d6d2d7"],
    "x_Windows_CApplicationModel_CActions_CIHostedFlyoutOperation": ["51e25ffb-b912-486a-a461-9d25cf6b8b4a"],
    "x_Windows_CApplicationModel_CActions_CIMainWindowActivationInfo": ["adf3165c-ba9e-42a7-922f-2005d7bd711a"],
    "x_Windows_CApplicationModel_CActivation_CIActivatedEventArgs": ["cf651713-cd08-4fd8-b697-a281b6544e2e"],
    "x_Windows_CApplicationModel_CActivation_CIActivatedEventArgsWithUser": ["1cf09b9e-9962-4936-80ff-afc8e8ae5c8c"],
    "x_Windows_CApplicationModel_CActivation_CIApplicationViewActivatedEventArgs": [
        "930cef4b-b829-40fc-88f4-8513e8a64738"
    ],
    "x_Windows_CApplicationModel_CActivation_CIBarcodeScannerPreviewActivatedEventArgs": [
        "6772797c-99bf-4349-af22-e4123560371c"
    ],
    "x_Windows_CApplicationModel_CActivation_CICachedFileUpdaterActivatedEventArgs": [
        "d06eb1c7-3805-4ecb-b757-6cf15e26fef3"
    ],
    "x_Windows_CApplicationModel_CActivation_CICameraSettingsActivatedEventArgs": [
        "fb67a508-2dad-490a-9170-dca036eb114b"
    ],
    "x_Windows_CApplicationModel_CActivation_CICommandLineActivatedEventArgs": ["4506472c-006a-48eb-8afb-d07ab25e3366"],
    "x_Windows_CApplicationModel_CActivation_CICommandLineActivationCompletedEventArgs": [
        "e22fdae2-eb1e-4b83-8967-c4247a44b602"
    ],
    "x_Windows_CApplicationModel_CActivation_CICommandLineActivationOperation": [
        "994b2841-c59e-4f69-bcfd-b61ed4e622eb"
    ],
    "x_Windows_CApplicationModel_CActivation_CICommandLineActivationOperationPrivate": [
        "2145426c-15f6-4fca-9976-0eb8e57bbbe2"
    ],
    "x_Windows_CApplicationModel_CActivation_CIComponentActivationPrivate": ["888a30d9-4b13-4792-a149-f3502438d42f"],
    "x_Windows_CApplicationModel_CActivation_CIContinuationActivatedEventArgs": [
        "e58106b5-155f-4a94-a742-c7e08f4e188c"
    ],
    "x_Windows_CApplicationModel_CActivation_CIDeviceActivatedEventArgs": ["cd50b9a9-ce10-44d2-8234-c355a073ef33"],
    "x_Windows_CApplicationModel_CActivation_CIDialReceiverActivatedEventArgs": [
        "fb777ed7-85ee-456e-a44d-85d730e70aed"
    ],
    "x_Windows_CApplicationModel_CActivation_CIFileActivatedEventArgs": ["bb2afc33-93b1-42ed-8b26-236dd9c78496"],
    "x_Windows_CApplicationModel_CActivation_CIFileActivatedEventArgsWithCallerPackageFamilyName": [
        "2d60f06b-d25f-4d25-8653-e1c5e1108309"
    ],
    "x_Windows_CApplicationModel_CActivation_CIFileActivatedEventArgsWithNeighboringFiles": [
        "433ba1a4-e1e2-48fd-b7fc-b5d6eee65033"
    ],
    "x_Windows_CApplicationModel_CActivation_CIFileOpenPickerActivatedEventArgs": [
        "72827082-5525-4bf2-bc09-1f5095d4964d"
    ],
    "x_Windows_CApplicationModel_CActivation_CIFileOpenPickerActivatedEventArgs2": [
        "5e731f66-8d1f-45fb-af1d-73205c8fc7a1"
    ],
    "x_Windows_CApplicationModel_CActivation_CIFileOpenPickerContinuationEventArgs": [
        "f0fa3f3a-d4e8-4ad3-9c34-2308f32fcec9"
    ],
    "x_Windows_CApplicationModel_CActivation_CIFileSavePickerActivatedEventArgs": [
        "81c19cf1-74e6-4387-82eb-bb8fd64b4346"
    ],
    "x_Windows_CApplicationModel_CActivation_CIFileSavePickerActivatedEventArgs2": [
        "6b73fe13-2cf2-4d48-8cbc-af67d23f1ce7"
    ],
    "x_Windows_CApplicationModel_CActivation_CIFileSavePickerContinuationEventArgs": [
        "2c846fe1-3bad-4f33-8c8b-e46fae824b4b"
    ],
    "x_Windows_CApplicationModel_CActivation_CIFolderPickerContinuationEventArgs": [
        "51882366-9f4b-498f-beb0-42684f6e1c29"
    ],
    "x_Windows_CApplicationModel_CActivation_CIForegroundActivationMode": ["4c18b616-ff4b-4954-9b2e-8019aff960f1"],
    "x_Windows_CApplicationModel_CActivation_CIInitializeActivatedEventArgs": ["e63d1b34-5ed4-4edf-8b51-9a260ffd16e9"],
    "x_Windows_CApplicationModel_CActivation_CIInitializeApplicationViewActivatedEventArgs": [
        "5300779a-0d50-411c-8c2c-67e5d4155f1f"
    ],
    "x_Windows_CApplicationModel_CActivation_CIInitializePrelaunchActivatedEventArgs": [
        "3751b892-f670-4f8d-af13-9cd405db1f36"
    ],
    "x_Windows_CApplicationModel_CActivation_CILaunchActivatedEventArgs": ["fbc93e26-a14a-4b4f-82b0-33bed920af52"],
    "x_Windows_CApplicationModel_CActivation_CILaunchActivatedEventArgs2": ["0fd37ebc-9dc9-46b5-9ace-bd95d4565345"],
    "x_Windows_CApplicationModel_CActivation_CILockScreenActivatedEventArgs": ["3ca77966-6108-4a41-8220-ee7d133c8532"],
    "x_Windows_CApplicationModel_CActivation_CILockScreenCallActivatedEventArgs": [
        "06f37fbe-b5f2-448b-b13e-e328ac1c516a"
    ],
    "x_Windows_CApplicationModel_CActivation_CIMultiviewActivationProperties": ["7ca84d06-f54c-4ba8-bd6f-9abaf9380d51"],
    "x_Windows_CApplicationModel_CActivation_CINavigationActivatedEventArgs": ["f172beb7-5016-48f3-858b-da6d2000ed58"],
    "x_Windows_CApplicationModel_CActivation_CIPickerReturnedActivatedEventArgs": [
        "360defb9-a9d3-4984-a4ed-9ec734604921"
    ],
    "x_Windows_CApplicationModel_CActivation_CIPrelaunchActivatedEventArgs": ["0c44717b-19f7-48d6-b046-cf22826eaa74"],
    "x_Windows_CApplicationModel_CActivation_CIPrint3DWorkflowActivatedEventArgs": [
        "3f57e78b-f2ac-4619-8302-ef855e1c9b90"
    ],
    "x_Windows_CApplicationModel_CActivation_CIPrintTaskSettingsActivatedEventArgs": [
        "ee30a0c9-ce56-4865-ba8e-8954ac271107"
    ],
    "x_Windows_CApplicationModel_CActivation_CIProtocolActivatedEventArgs": ["6095f4dd-b7c0-46ab-81fe-d90f36d00d24"],
    "x_Windows_CApplicationModel_CActivation_CIProtocolActivatedEventArgsWithCallerPackageFamilyNameAndData": [
        "d84a0c12-5c8f-438c-83cb-c28fcc0b2fdb"
    ],
    "x_Windows_CApplicationModel_CActivation_CIProtocolForResultsActivatedEventArgs": [
        "e75132c2-7ae7-4517-80ac-dbe8d7cc5b9c"
    ],
    "x_Windows_CApplicationModel_CActivation_CIProtocolWithResultsContinuationActivatedEventArgs": [
        "4e5222d5-e809-4cd3-8dfa-309fc09b3379"
    ],
    "x_Windows_CApplicationModel_CActivation_CIRestrictedComponentActivationPrivate": [
        "c8a0ed19-ff81-44de-9659-92883b6b4027"
    ],
    "x_Windows_CApplicationModel_CActivation_CIRestrictedLaunchActivatedEventArgs": [
        "e0b7ac81-bfc3-4344-a5da-19fd5a27baae"
    ],
    "x_Windows_CApplicationModel_CActivation_CISearchActivatedEventArgs": ["8cb36951-58c8-43e3-94bc-41d33f8b630e"],
    "x_Windows_CApplicationModel_CActivation_CISearchActivatedEventArgsWithLinguisticDetails": [
        "c09f33da-08ab-4931-9b7c-451025f21f81"
    ],
    "x_Windows_CApplicationModel_CActivation_CIShareTargetActivatedEventArgs": ["4bdaf9c8-cdb2-4acb-bfc3-6648563378ec"],
    "x_Windows_CApplicationModel_CActivation_CISplashScreen": ["ca4d975c-d4d6-43f0-97c0-0833c6391c24"],
    "x_Windows_CApplicationModel_CActivation_CIStartupTaskActivatedEventArgs": ["03b11a58-5276-4d91-8621-54611864d5fa"],
    "x_Windows_CApplicationModel_CActivation_CITileActivatedInfo": ["80e4a3b1-3980-4f17-b738-89194e0b8f65"],
    "x_Windows_CApplicationModel_CActivation_CIToastNotificationActivatedEventArgs": [
        "92a86f82-5290-431d-be85-c4aaeeb8685f"
    ],
    "x_Windows_CApplicationModel_CActivation_CIViewSwitcherProvider": ["33f288a6-5c2c-4d27-bac7-7536088f1219"],
    "x_Windows_CApplicationModel_CActivation_CIWalletActionActivatedEventArgs": [
        "fcfc027b-1a1a-4d22-923f-ae6f45fa52d9"
    ],
    "x_Windows_CApplicationModel_CActivation_CIWebAccountProviderActivatedEventArgs": [
        "72b71774-98ea-4ccf-9752-46d9051004f1"
    ],
    "x_Windows_CApplicationModel_CActivation_CIWebAuthenticationBrokerContinuationEventArgs": [
        "75dda3d4-7714-453d-b7ff-b95e3a1709da"
    ],
    "x_Windows_CApplicationModel_CBackground_CIAlarmTrigger": ["fbdc7d76-1b12-4f8e-b121-64f1b94a2cfb"],
    "x_Windows_CApplicationModel_CBackground_CIAlarmTriggerFactory": ["4725971e-c31d-4857-b33b-50779cf665c1"],
    "x_Windows_CApplicationModel_CBackground_CIBackgroundRegistrationTrigger": ["44f5033a-9b58-43e3-84d5-fc830c3f566f"],
    "x_Windows_CApplicationModel_CBackground_CIBackgroundTaskFactory": ["39743a29-5221-4421-9efc-2e47c5f75788"],
    "x_Windows_CApplicationModel_CBackground_CIBackgroundTaskInstance3": ["30c408eb-6e1b-4e07-a679-51cd46ea9e28"],
    "x_Windows_CApplicationModel_CBackground_CIBackgroundTaskInstanceFactory": ["2c70d536-8527-48e8-9996-75848ffa2f50"],
    "x_Windows_CApplicationModel_CBackground_CIBackgroundTaskInstanceInternal": [
        "120d48c3-5406-4510-b688-87bea2ab43db"
    ],
    "x_Windows_CApplicationModel_CBackground_CIBackgroundTaskInternal": ["455dd187-a6b1-4ea5-87ac-d3874e9a89cc"],
    "x_Windows_CApplicationModel_CBackground_CIBackgroundTaskRegistrationGroupInternal": [
        "f75c08f8-e91e-4664-bd69-664db0fd4748"
    ],
    "x_Windows_CApplicationModel_CBackground_CIBackgroundTaskWaitable": ["275fbc9a-6c70-4871-afae-ad2a486f012d"],
    "x_Windows_CApplicationModel_CBackground_CIBackgroundTaskYieldAnyResult": ["a700a55c-c19e-4f6e-9bd8-673683ef3171"],
    "x_Windows_CApplicationModel_CBackground_CIBackgroundTaskYieldable": ["6639ed40-1f50-4ce2-a825-503edacef44f"],
    "x_Windows_CApplicationModel_CBackground_CIBackgroundWorkManagerInternal": ["350e1244-4575-45ee-8595-0aa8c6506fc7"],
    "x_Windows_CApplicationModel_CBackground_CIBackgroundWorkManagerInternal2": [
        "01cf8bd4-e3d6-413d-8339-36d46e78d12c"
    ],
    "x_Windows_CApplicationModel_CBackground_CIBrokerConditionBuilder": ["47db9573-d0c5-4a7c-b825-b016c04191be"],
    "x_Windows_CApplicationModel_CBackground_CIBrokerEventDetailsActions": ["eed5842b-a557-448d-82bc-e3af9f65bf47"],
    "x_Windows_CApplicationModel_CBackground_CIBrokerTriggerBuilder": ["8c6389fa-012c-4ff7-854a-7683725723a5"],
    "x_Windows_CApplicationModel_CBackground_CIBrokerTriggerBuilder2": ["a1ad48b0-c496-4211-9782-9f08667d755d"],
    "x_Windows_CApplicationModel_CBackground_CICSystemCondition": ["96ce08cd-c964-4ee3-a8c4-f4ef36b27d1a"],
    "x_Windows_CApplicationModel_CBackground_CICSystemConditionFactory": ["6f989a99-770e-4539-840b-ec97284926d5"],
    "x_Windows_CApplicationModel_CBackground_CICSystemTrigger": ["87e77d9c-4fec-4b95-ad6e-3c6dcfdedc02"],
    "x_Windows_CApplicationModel_CBackground_CICSystemTriggerFactory": ["7f4ffeb2-0241-433c-bce3-ea42f22bfa3d"],
    "x_Windows_CApplicationModel_CBackground_CICustomSystemTrigger": ["7cef9a3e-1614-4a47-8a8b-4dff6f25f0e6"],
    "x_Windows_CApplicationModel_CBackground_CICustomSystemTriggerDetails": ["4edebe61-718d-473a-be82-486f7f5aadb3"],
    "x_Windows_CApplicationModel_CBackground_CICustomSystemTriggerFactory": ["b20a4480-3ae6-4f5d-acab-19f8a325299e"],
    "x_Windows_CApplicationModel_CBackground_CIStorageLibraryChangeTrackerTriggerFactory": [
        "1eb0ffd0-5a85-499e-a888-824607124f50"
    ],
    "x_Windows_CApplicationModel_CBackground_CIStorageLibraryContentChangedTrigger": [
        "1637e0a7-829c-45bc-929b-a1e7ea78d89b"
    ],
    "x_Windows_CApplicationModel_CBackground_CIStorageLibraryContentChangedTriggerStatics": [
        "7f9f1b39-5f90-4e12-914e-a7d8e0bbfb18"
    ],
    "x_Windows_CApplicationModel_CCalls_CILockScreenCallUIPriv": ["8bd75dbc-6b52-49d0-8544-1f2f8c1d2926"],
    "x_Windows_CApplicationModel_CCalls_CIPhoneCallBlockingStatics": ["19646f84-2b79-26f1-a46f-694be043f313"],
    "x_Windows_CApplicationModel_CCalls_CIPhoneCallManagerStatics": ["60edac78-78a6-4872-a3ef-98325ec8b843"],
    "x_Windows_CApplicationModel_CCalls_CIPhoneCallManagerStatics2": ["c7e3c8bc-2370-431c-98fd-43be5f03086d"],
    "x_Windows_CApplicationModel_CCalls_CIPhoneCallStore": ["5f610748-18a6-4173-86d1-28be9dc62dba"],
    "x_Windows_CApplicationModel_CCalls_CIPhoneCallVideoCapabilities": ["02382786-b16a-4fdb-be3b-c4240e13ad0d"],
    "x_Windows_CApplicationModel_CCalls_CIPhoneCallVideoCapabilitiesManagerStatics": [
        "f3c64b56-f00b-4a1c-a0c6-ee1910749ce7"
    ],
    "x_Windows_CApplicationModel_CCalls_CIPhoneDialOptions": ["b639c4b8-f06f-36cb-a863-823742b5f2d4"],
    "x_Windows_CApplicationModel_CCalls_CIPhoneLine": ["27c66f30-6a69-34ca-a2ba-65302530c311"],
    "x_Windows_CApplicationModel_CCalls_CIPhoneLineCellularDetails": ["192601d5-147c-4769-b673-98a5ec8426cb"],
    "x_Windows_CApplicationModel_CCalls_CIPhoneLineConfiguration": ["fe265862-f64f-4312-b2a8-4e257721aa95"],
    "x_Windows_CApplicationModel_CCalls_CIPhoneLineStatics": ["f38b5f23-ceb0-404f-bcf2-ba9f697d8adf"],
    "x_Windows_CApplicationModel_CCalls_CIPhoneLineWatcher": ["8a45cd0a-6323-44e0-a6f6-9f21f64dc90a"],
    "x_Windows_CApplicationModel_CCalls_CIPhoneLineWatcherEventArgs": ["d07c753e-9e12-4a37-82b7-ad535dad6a67"],
    "x_Windows_CApplicationModel_CCalls_CIPhoneVoicemail": ["c9ce77f6-6e9f-3a8b-b727-6e0cf6998224"],
    "x_Windows_CApplicationModel_CContacts_CInternal_CIContactActionControl": ["28f07475-6fc0-4da4-8c88-c04dea9d7552"],
    "x_Windows_CApplicationModel_CContacts_CInternal_CIContactActionControlItem": [
        "1ce0548c-7a49-4cf4-8e2d-437c94b2e895"
    ],
    "x_Windows_CApplicationModel_CContacts_CInternal_CIContactCardDelayedDataLoaderPriv": [
        "255391c3-8dd3-4f68-ac96-7144a2f7184b"
    ],
    "x_Windows_CApplicationModel_CContacts_CInternal_CIContactCardExperience": ["1b49844a-6401-4dc0-a5c0-44dca16f9210"],
    "x_Windows_CApplicationModel_CContacts_CInternal_CIContactCardExperienceDelayedDataLoader": [
        "009d8be9-09f1-472b-a1fc-da1f65dba0b4"
    ],
    "x_Windows_CApplicationModel_CContacts_CInternal_CIContactDisplayInformation": [
        "29f8fd6a-f851-44fd-b112-e8242f6f6364"
    ],
    "x_Windows_CApplicationModel_CContacts_CInternal_CIContactManagerBrokerStatic": [
        "720c12cb-9f1d-41de-ac92-0139b7bf7c61"
    ],
    "x_Windows_CApplicationModel_CContacts_CInternal_CIContactManagerBrokerStatic2": [
        "bc3049e0-e1b3-43cc-99cb-75f46c5ec88d"
    ],
    "x_Windows_CApplicationModel_CContacts_CInternal_CIContactPreferenceManager": [
        "31c489ad-a5a3-4fad-910f-2e792339eed5"
    ],
    "x_Windows_CApplicationModel_CContacts_CInternal_CIContactServiceDescription": [
        "d703fff4-f2eb-4ee0-9178-42dacf97375f"
    ],
    "x_Windows_CApplicationModel_CContacts_CInternal_CIContactUIHelper": ["9d117221-55ec-414f-8253-2d8e18d9c08c"],
    "x_Windows_CApplicationModel_CContacts_CInternal_CIContactUIHelper2": ["c90f3112-643f-4ab0-ae2d-24c0c2d8db8c"],
    "x_Windows_CApplicationModel_CContacts_CInternal_CIContactsListManager": ["73d6eac7-945c-41f5-9dc5-812bc0752855"],
    "x_Windows_CApplicationModel_CContacts_CInternal_CIControlMapActionControlItem": [
        "290b2e5f-e401-48dd-a86b-694d4839f734"
    ],
    "x_Windows_CApplicationModel_CContracts_CInternal_CIAppServiceConnectionWithTriggerType": [
        "d788ff21-7e90-40eb-a848-ec925f6c1d29"
    ],
    "x_Windows_CApplicationModel_CContracts_CInternal_CIApplicationContractManagerStatics": [
        "28c47916-c389-4efa-bf8f-bcdc620587f5"
    ],
    "x_Windows_CApplicationModel_CContracts_CInternal_CIApplicationContractRequest": [
        "994aa3c2-0fd2-4182-887f-7a061a6d96cb"
    ],
    "x_Windows_CApplicationModel_CContracts_CInternal_CIApplicationContractStream": [
        "a12a538d-1dcd-4524-9f13-1704cb404207"
    ],
    "x_Windows_CApplicationModel_CContracts_CInternal_CIApplicationContractStreamCreatedEventArgs": [
        "007ea1aa-4e76-47cb-9bc1-0a750acc32a2"
    ],
    "x_Windows_CApplicationModel_CContracts_CInternal_CIApplicationContractStreamRequestedEventArgs": [
        "3150fcaf-cbde-4951-8211-8b3146f2ed85"
    ],
    "x_Windows_CApplicationModel_CContracts_CInternal_CIApplicationContractStreamSupport": [
        "f18e5de6-eec1-47c0-ba9b-c45d4585bc63"
    ],
    "x_Windows_CApplicationModel_CContracts_CInternal_CIBackgroundContractCompletedEventArgs": [
        "6c72007f-4df2-4bcf-a66f-401465045944"
    ],
    "x_Windows_CApplicationModel_CContracts_CInternal_CIBackgroundContractExecutable": [
        "888f22e6-8f0a-48e5-ae9c-12dd757a4b63"
    ],
    "x_Windows_CApplicationModel_CContracts_CInternal_CIBackgroundContractExecutionController": [
        "c2d3a50d-ce51-4c91-96bb-8420e327a616"
    ],
    "x_Windows_CApplicationModel_CContracts_CInternal_CIBackgroundContractExecutor": [
        "4c54db4d-f179-4ec4-882f-c3789d935d6f"
    ],
    "x_Windows_CApplicationModel_CContracts_CInternal_CIBackgroundContractOperation": [
        "52740068-c5fb-4b7d-88f3-892ce0c91868"
    ],
    "x_Windows_CApplicationModel_CContracts_CInternal_CIBackgroundContractOperationFactoryInterop": [
        "68bc0b59-0e5b-4e44-ad6b-a41225b45e20"
    ],
    "x_Windows_CApplicationModel_CContracts_CInternal_CIBackgroundContractRequestFactory": [
        "c9b2a3be-2042-4b9c-8e96-906c8b66593b"
    ],
    "x_Windows_CApplicationModel_CContracts_CInternal_CIBackgroundContractResultsAvailableEventArgs": [
        "d0cb2e3b-6e87-416c-8b5b-c0651e60816b"
    ],
    "x_Windows_CApplicationModel_CContracts_CInternal_CIBackgroundContractStore": [
        "729fa2a1-18b0-4281-a3b7-be7ef7e67072"
    ],
    "x_Windows_CApplicationModel_CContracts_CInternal_CICdpBinaryClient": ["372b805f-5761-4c5e-b7f5-2ffe0bd65f99"],
    "x_Windows_CApplicationModel_CContracts_CInternal_CICdpBinaryClientDataReceivedEventArgs": [
        "fff6f121-c002-4517-896e-b34dd695edbf"
    ],
    "x_Windows_CApplicationModel_CContracts_CInternal_CICdpBinaryHost": ["7f6acb70-2941-4469-af9b-4815e4120bc5"],
    "x_Windows_CApplicationModel_CContracts_CInternal_CICdpBinaryHostDataReceivedEventArgs": [
        "92aed5c6-26f7-4878-9a54-8f12002c7dc5"
    ],
    "x_Windows_CApplicationModel_CContracts_CInternal_CICdpEndpointSupport": ["346c0e67-e506-4b5b-b02a-bbaa369461b7"],
    "x_Windows_CApplicationModel_CContracts_CInternal_CICdpLaunchResult": ["aa443b0b-9628-4c68-8672-c28023777c33"],
    "x_Windows_CApplicationModel_CContracts_CInternal_CICdpLauncherClient": ["8a87ed9a-2ca0-4187-a7c9-eefc2f229c0b"],
    "x_Windows_CApplicationModel_CContracts_CInternal_CIContractBroker": ["62c96812-86bb-4d6a-9fe5-2151fda3119e"],
    "x_Windows_CApplicationModel_CContracts_CInternal_CIContractBrokerBaseTrustAccessibleServer": [
        "98fba1b6-2909-418d-9ecf-c21600fa7822"
    ],
    "x_Windows_CApplicationModel_CContracts_CInternal_CIContractBrokerPartialTrustStatics": [
        "2931fe47-4c9a-4e70-8de4-b80394ff42c1"
    ],
    "x_Windows_CApplicationModel_CContracts_CInternal_CIContractBrokerStoreStatics": [
        "bafd5973-3bb1-4dfd-b1c4-b290ae7adb14"
    ],
    "x_Windows_CApplicationModel_CContracts_CInternal_CIContractBrokerTarget": ["6a003b80-c7e8-42b1-b97c-ef4412a8ae80"],
    "x_Windows_CApplicationModel_CCore_CIActivatableApplication": ["92696c00-7578-48e1-ac1a-2ca909e2c8cf"],
    "x_Windows_CApplicationModel_CCore_CIActivationDispatcher": ["e2a02097-3198-4a9e-be11-5d082801199d"],
    "x_Windows_CApplicationModel_CCore_CIActivationEventCallback": ["fefdc269-a317-4e33-9f50-c285c9c29725"],
    "x_Windows_CApplicationModel_CCore_CIAssociateViewWithObjectModel": ["6ef1c57f-e05d-4ed5-940a-5be3b1153659"],
    "x_Windows_CApplicationModel_CCore_CIComponentPrivate": ["9862ca9f-91c6-4d9f-9533-1f4dff2516f8"],
    "x_Windows_CApplicationModel_CCore_CICoreApplication": ["0aacf7a4-5e1d-49df-8034-fb6a68bc5ed1"],
    "x_Windows_CApplicationModel_CCore_CICoreApplication2": ["998681fb-1ab6-4b7f-be4a-9a0645224c04"],
    "x_Windows_CApplicationModel_CCore_CICoreApplication3": ["feec0d39-598b-4507-8a67-772632580a57"],
    "x_Windows_CApplicationModel_CCore_CICoreApplicationExit": ["cf86461d-261e-4b72-9acd-44ed2ace6a29"],
    "x_Windows_CApplicationModel_CCore_CICoreApplicationPrivate": ["17b0e613-942a-422d-904c-f90dc71a7dae"],
    "x_Windows_CApplicationModel_CCore_CICoreApplicationUnhandledError": ["f0e24ab0-dd09-42e1-b0bc-e0e131f78d7e"],
    "x_Windows_CApplicationModel_CCore_CICoreApplicationUseCount": ["518dc408-c077-475b-809e-0bc0c57e4b74"],
    "x_Windows_CApplicationModel_CCore_CICoreApplicationView": ["638bb2db-451d-4661-b099-414f34ffb9f1"],
    "x_Windows_CApplicationModel_CCore_CICoreApplicationView2": ["68eb7adf-917f-48eb-9aeb-7de53e086ab1"],
    "x_Windows_CApplicationModel_CCore_CICoreApplicationView3": ["07ebe1b3-a4cf-4550-ab70-b07e85330bc8"],
    "x_Windows_CApplicationModel_CCore_CICoreApplicationView5": ["2bc095a8-8ef0-446d-9e60-3a3e0428c671"],
    "x_Windows_CApplicationModel_CCore_CICoreApplicationView6": ["c119d49a-0679-49ba-803f-b79c5cf34cca"],
    "x_Windows_CApplicationModel_CCore_CICoreApplicationViewForceMarshal": ["92cee296-66e6-4678-984a-579e02c88be6"],
    "x_Windows_CApplicationModel_CCore_CICoreApplicationViewInternal": ["2e5500b6-66ad-467f-abb5-022a64283d88"],
    "x_Windows_CApplicationModel_CCore_CICoreApplicationViewTitleBar": ["006d35e3-e1f1-431b-9508-29b96926ac53"],
    "x_Windows_CApplicationModel_CCore_CICoreImmersiveApplication": ["1ada0e3e-e4a2-4123-b451-dc96bf800419"],
    "x_Windows_CApplicationModel_CCore_CICoreImmersiveApplication2": ["828e1e36-e9e3-4cfc-9b66-48b78ea9bb2c"],
    "x_Windows_CApplicationModel_CCore_CICoreImmersiveApplication3": ["34a05b2f-ee0d-41e5-8314-cf10c91bf0af"],
    "x_Windows_CApplicationModel_CCore_CIFrameworkView": ["faab5cd0-8924-45ac-ad0f-a08fae5d0324"],
    "x_Windows_CApplicationModel_CCore_CIFrameworkViewInternal": ["6a4d1606-88d2-4d1a-a07d-7fb49792b4f8"],
    "x_Windows_CApplicationModel_CCore_CIFrameworkViewSource": ["cd770614-65c4-426c-9494-34fc43554862"],
    "x_Windows_CApplicationModel_CCore_CIHostPrivate": ["3ee65a6a-be0d-4861-aab4-6efcadf8ccfc"],
    "x_Windows_CApplicationModel_CCore_CIHostedViewClosingEventArgs": ["d238943c-b24e-4790-acb5-3e4243c4ff87"],
    "x_Windows_CApplicationModel_CCore_CIPrelaunchConfig": ["c8577823-74ee-4c35-839a-aacfb7d440d1"],
    "x_Windows_CApplicationModel_CCore_CIUnhandledError": ["9459b726-53b5-4686-9eaf-fa8162dc3980"],
    "x_Windows_CApplicationModel_CCore_CIUnhandledErrorDetectedEventArgs": ["679ab78b-b336-4822-ac40-0d750f0b7a2b"],
    "x_Windows_CApplicationModel_CCore_CInternal_CIAppListEntry2": ["31e51672-c330-43d7-bdb9-69c469e20f6c"],
    "x_Windows_CApplicationModel_CCore_CInternal_CIAppListEntryInternal": ["4c7545fd-63ed-4409-8f55-7170e531b880"],
    "x_Windows_CApplicationModel_CCore_CInternal_CIAppListEntryInternalStatics": [
        "722f2b9b-5e83-40f7-a9d6-52e300a17805"
    ],
    "x_Windows_CApplicationModel_CDataTransfer_CIClipboardContentOptions": ["e888a98c-ad4b-5447-a056-ab3556276d2b"],
    "x_Windows_CApplicationModel_CDataTransfer_CIClipboardHistoryChangedEventArgs": [
        "c0be453f-8ea2-53ce-9aba-8d2212573452"
    ],
    "x_Windows_CApplicationModel_CDataTransfer_CIClipboardHistoryItem": ["0173bd8a-afff-5c50-ab92-3d19f481ec58"],
    "x_Windows_CApplicationModel_CDataTransfer_CIClipboardHistoryItemsResult": ["e6dfdee6-0ee2-52e3-852b-f295db65939a"],
    "x_Windows_CApplicationModel_CDataTransfer_CIClipboardStatics": ["c627e291-34e2-4963-8eed-93cbb0ea3d70"],
    "x_Windows_CApplicationModel_CDataTransfer_CIClipboardStatics2": ["d2ac1b6a-d29f-554b-b303-f0452345fe02"],
    "x_Windows_CApplicationModel_CDataTransfer_CIClipboardStatics3": ["6c4e9666-4ad5-596a-96ac-0ee6c0be4d98"],
    "x_Windows_CApplicationModel_CDataTransfer_CIDataPackage": ["61ebf5c7-efea-4346-9554-981d7e198ffe"],
    "x_Windows_CApplicationModel_CDataTransfer_CIDataPackage2": ["041c1fe9-2409-45e1-a538-4c53eeee04a7"],
    "x_Windows_CApplicationModel_CDataTransfer_CIDataPackage3": ["88f31f5d-787b-4d32-965a-a9838105a056"],
    "x_Windows_CApplicationModel_CDataTransfer_CIDataPackage4": ["13a24ec8-9382-536f-852a-3045e1b29a3b"],
    "x_Windows_CApplicationModel_CDataTransfer_CIDataPackagePropertySet": ["cd1c93eb-4c4c-443a-a8d3-f5c241e91689"],
    "x_Windows_CApplicationModel_CDataTransfer_CIDataPackagePropertySet2": ["eb505d4a-9800-46aa-b181-7b6f0f2b919a"],
    "x_Windows_CApplicationModel_CDataTransfer_CIDataPackagePropertySet3": ["9e87fd9b-5205-401b-874a-455653bd39e8"],
    "x_Windows_CApplicationModel_CDataTransfer_CIDataPackagePropertySet4": ["6390ebf5-1739-4c74-b22f-865fab5e8545"],
    "x_Windows_CApplicationModel_CDataTransfer_CIDataPackagePropertySetView": ["b94cec01-0c1a-4c57-be55-75d01289735d"],
    "x_Windows_CApplicationModel_CDataTransfer_CIDataPackagePropertySetView2": ["6054509b-8ebe-4feb-9c1e-75e69de54b84"],
    "x_Windows_CApplicationModel_CDataTransfer_CIDataPackagePropertySetView3": ["db764ce5-d174-495c-84fc-1a51f6ab45d7"],
    "x_Windows_CApplicationModel_CDataTransfer_CIDataPackagePropertySetView4": ["4474c80d-d16f-40ae-9580-6f8562b94235"],
    "x_Windows_CApplicationModel_CDataTransfer_CIDataPackagePropertySetView5": ["6f0a9445-3760-50bb-8523-c4202ded7d78"],
    "x_Windows_CApplicationModel_CDataTransfer_CIDataPackageView": ["7b840471-5900-4d85-a90b-10cb85fe3552"],
    "x_Windows_CApplicationModel_CDataTransfer_CIDataPackageView2": ["40ecba95-2450-4c1d-b6b4-ed45463dee9c"],
    "x_Windows_CApplicationModel_CDataTransfer_CIDataPackageView3": ["d37771a8-ddad-4288-8428-d1cae394128b"],
    "x_Windows_CApplicationModel_CDataTransfer_CIDataPackageView4": ["dfe96f1f-e042-4433-a09f-26d6ffda8b85"],
    "x_Windows_CApplicationModel_CDataTransfer_CIDataProviderDeferral": ["c2cf2373-2d26-43d9-b69d-dcb86d03f6da"],
    "x_Windows_CApplicationModel_CDataTransfer_CIDataProviderHandler": ["e7ecd720-f2f4-4a2d-920e-170a2f482a27"],
    "x_Windows_CApplicationModel_CDataTransfer_CIDataProviderRequest": ["ebbc7157-d3c8-47da-acde-f82388d5f716"],
    "x_Windows_CApplicationModel_CDataTransfer_CIDataRequest": ["4341ae3b-fc12-4e53-8c02-ac714c415a27"],
    "x_Windows_CApplicationModel_CDataTransfer_CIDataRequestDeferral": ["6dc4b89f-0386-4263-87c1-ed7dce30890e"],
    "x_Windows_CApplicationModel_CDataTransfer_CIDataRequestedEventArgs": ["cb8ba807-6ac5-43c9-8ac5-9ba232163182"],
    "x_Windows_CApplicationModel_CDataTransfer_CIDataTransferManager": ["a5caee9b-8708-49d1-8d36-67d25a8da00c"],
    "x_Windows_CApplicationModel_CDataTransfer_CIDataTransferManager2": ["30ae7d71-8ba8-4c02-8e3f-ddb23b388715"],
    "x_Windows_CApplicationModel_CDataTransfer_CIDataTransferManagerStatics": ["a9da01aa-e00e-4cfe-aa44-2dd932dca3d8"],
    "x_Windows_CApplicationModel_CDataTransfer_CIDataTransferManagerStatics2": ["c54ec2ec-9f97-4d63-9868-395e271ad8f5"],
    "x_Windows_CApplicationModel_CDataTransfer_CIDataTransferManagerStatics3": ["05845473-6c82-4f5c-ac23-62e458361fac"],
    "x_Windows_CApplicationModel_CDataTransfer_CIHtmlFormatHelperStatics": ["e22e7749-dd70-446f-aefc-61cee59f655e"],
    "x_Windows_CApplicationModel_CDataTransfer_CIOperationCompletedEventArgs": ["e7af329d-051d-4fab-b1a9-47fd77f70a41"],
    "x_Windows_CApplicationModel_CDataTransfer_CIOperationCompletedEventArgs2": [
        "858fa073-1e19-4105-b2f7-c8478808d562"
    ],
    "x_Windows_CApplicationModel_CDataTransfer_CIShareCompletedEventArgs": ["4574c442-f913-4f60-9df7-cc4060ab1916"],
    "x_Windows_CApplicationModel_CDataTransfer_CIShareProvider": ["2fabe026-443e-4cda-af25-8d81070efd80"],
    "x_Windows_CApplicationModel_CDataTransfer_CIShareProviderFactory": ["172a174c-e79e-4f6d-b07d-128f469e0296"],
    "x_Windows_CApplicationModel_CDataTransfer_CIShareProviderHandler": ["e7f9d9ba-e1ba-4e4d-bd65-d43845d3212f"],
    "x_Windows_CApplicationModel_CDataTransfer_CIShareProviderOperation": ["19cef937-d435-4179-b6af-14e0492b69f6"],
    "x_Windows_CApplicationModel_CDataTransfer_CIShareProvidersRequestedEventArgs": [
        "f888f356-a3f8-4fce-85e4-8826e63be799"
    ],
    "x_Windows_CApplicationModel_CDataTransfer_CIShareTargetInfo": ["385be607-c6e8-4114-b294-28f3bb6f9904"],
    "x_Windows_CApplicationModel_CDataTransfer_CIShareUIOptions": ["72fa8a80-342f-4d90-9551-2ae04e37680c"],
    "x_Windows_CApplicationModel_CDataTransfer_CISharedStorageAccessManagerStatics": [
        "c6132ada-34b1-4849-bd5f-d09fee3158c5"
    ],
    "x_Windows_CApplicationModel_CDataTransfer_CIStandardDataFormatsStatics": ["7ed681a1-a880-40c9-b4ed-0bee1e15f549"],
    "x_Windows_CApplicationModel_CDataTransfer_CIStandardDataFormatsStatics2": ["42a254f4-9d76-42e8-861b-47c25dd0cf71"],
    "x_Windows_CApplicationModel_CDataTransfer_CIStandardDataFormatsStatics3": ["3b57b069-01d4-474c-8b5f-bc8e27f38b21"],
    "x_Windows_CApplicationModel_CDataTransfer_CITargetApplicationChosenEventArgs": [
        "ca6fb8ac-2987-4ee3-9c54-d8afbcb86c1d"
    ],
    "x_Windows_CApplicationModel_CDataTransfer_CShareTarget_CIQuickLink": ["603e4308-f0be-4adc-acc9-8b27ab9cf556"],
    "x_Windows_CApplicationModel_CDataTransfer_CShareTarget_CIShareOperation": ["2246bab8-d0f8-41c1-a82a-4137db6504fb"],
    "x_Windows_CApplicationModel_CDataTransfer_CShareTarget_CIShareOperation2": [
        "0ffb97c1-9778-4a09-8e5b-cb5e482d0555"
    ],
    "x_Windows_CApplicationModel_CDataTransfer_CShareTarget_CIShareOperation3": [
        "5ef6b382-b7a7-4571-a2a6-994a034988b2"
    ],
    "x_Windows_CApplicationModel_CIEnteredBackgroundEventArgs": ["f722dcc2-9827-403d-aaed-ecca9ac17398"],
    "x_Windows_CApplicationModel_CILeavingBackgroundEventArgs": ["39c6ec9a-ae6e-46f9-a07a-cfc23f88733e"],
    "x_Windows_CApplicationModel_CISuspendingDeferral": ["59140509-8bc9-4eb4-b636-dabdc4f46f66"],
    "x_Windows_CApplicationModel_CISuspendingEventArgs": ["96061c05-2dba-4d08-b0bd-2b30a131c6aa"],
    "x_Windows_CApplicationModel_CISuspendingOperation": ["9da4ca41-20e1-4e9b-9f65-a9f435340c3a"],
    "x_Windows_CApplicationModel_CInfrastructure_CICoreApplicationInitializationPrivate": [
        "a3d3a6b9-d5e8-41c1-8d83-f671664a0c54"
    ],
    "x_Windows_CApplicationModel_CInfrastructure_CISetWindowWithWindowFactory": [
        "5af48779-f000-493c-99f1-982fbbf305e0"
    ],
    "x_Windows_CApplicationModel_CInternal_CDataTransfer_CIDataRequestResult": ["3979463a-a5fe-4533-abe6-35e2a2102014"],
    "x_Windows_CApplicationModel_CInternal_CDataTransfer_CIDataTransferManagerStatics3": [
        "6d6e1199-2837-4109-83f9-41f42519925a"
    ],
    "x_Windows_CApplicationModel_CInternal_CDataTransfer_CIErrorOccurredEventArgs": [
        "c8fd372d-429c-4085-8e1b-067c789dfd9c"
    ],
    "x_Windows_CApplicationModel_CInternal_CDataTransfer_CIPhoneShareAccountExtension": [
        "c90a701f-5125-4d12-aac1-651494953944"
    ],
    "x_Windows_CApplicationModel_CInternal_CDataTransfer_CIShareAppExtension": ["826a3596-8768-4225-b1a8-0a2251781c01"],
    "x_Windows_CApplicationModel_CInternal_CDataTransfer_CIShareAppExtensionActivator": [
        "a84fef1a-c56b-4a57-b39a-ecbe3137de22"
    ],
    "x_Windows_CApplicationModel_CInternal_CDataTransfer_CIShareClipboardExtension": [
        "d9bb79c4-fcff-4954-b5f3-4a14faa68005"
    ],
    "x_Windows_CApplicationModel_CInternal_CDataTransfer_CIShareExperience": ["a46d0285-9d7b-4279-b6c8-e2be697b6a8e"],
    "x_Windows_CApplicationModel_CInternal_CDataTransfer_CIShareExperienceFactory": [
        "8b30205a-f950-4b50-ae8b-7914bb0118ad"
    ],
    "x_Windows_CApplicationModel_CInternal_CDataTransfer_CIShareOperationInternal": [
        "22e58429-2957-4bb5-910b-c6219bc10688"
    ],
    "x_Windows_CApplicationModel_CInternal_CDataTransfer_CIShareUIOptions": ["51458bb3-70ea-4db3-bff0-b637a9c1e34b"],
    "x_Windows_CApplicationModel_CInternal_CDataTransfer_CISharedToAppExtensionEventArgs": [
        "284b1295-e498-470f-b783-3f1c3874e65d"
    ],
    "x_Windows_CApplicationModel_CInternal_CDataTransfer_CISharedToShareProviderEventArgs": [
        "b5e45259-b542-4dd5-80e3-f9f51cc4692c"
    ],
    "x_Windows_CApplicationModel_CInternal_CDataTransfer_CISharingOperation": ["baf275d3-50bc-41d0-8e9f-ea7c5ce8f7b3"],
    "x_Windows_CApplicationModel_CInternal_CDataTransfer_CNearShare_CINearShareExperience": [
        "cc9ab7e9-43e6-442e-bab7-f6f8fc2004c4"
    ],
    "x_Windows_CApplicationModel_CInternal_CDataTransfer_CNearShare_CINearShareExperienceFactory": [
        "070df267-6fe2-4c78-a91d-78f24b4f7f8b"
    ],
    "x_Windows_CApplicationModel_CInternal_CDataTransfer_CNearShare_CINearShareOperation": [
        "ebdc381d-dbe2-4ac0-af1c-64dc7ef6f5d3"
    ],
    "x_Windows_CApplicationModel_CInternal_CDataTransfer_CNearShare_CIShareDataInfo": [
        "f0c80630-c76c-4433-82a0-4926c5885104"
    ],
    "x_Windows_CApplicationModel_CInternal_CDataTransfer_CNearShare_CIShareReceiverBroker": [
        "3a9d7f20-a27b-46f4-8751-0203910f6336"
    ],
    "x_Windows_CApplicationModel_CInternal_CDataTransfer_CNearShare_CIShareReceiverHandler": [
        "1f8befa8-8f05-47b1-bf6c-398c162c849e"
    ],
    "x_Windows_CApplicationModel_CInternal_CDataTransfer_CNearShare_CIShareReceiverHandlerFactory": [
        "a235541c-83ba-4bc6-b96a-7a563d8445db"
    ],
    "x_Windows_CApplicationModel_CInternal_CDataTransfer_CNearShare_CIShareSenderBroker": [
        "898d173c-121d-42a1-835c-0f315e380402"
    ],
    "x_Windows_CApplicationModel_CInternal_CIFullTrustProcessLauncherInternalStatics": [
        "0e4d0003-ac6a-47c6-ac56-e181bad94d9d"
    ],
    "x_Windows_CApplicationModel_CInternal_CIPackageCatalogInternalStatics": ["5cc754cf-f82f-471b-ba04-1783588b7144"],
    "x_Windows_CApplicationModel_CInternal_CIPackageContentGroups": ["11020a40-6da0-4625-b0b4-27267f847d7e"],
    "x_Windows_CApplicationModel_CInternal_CIPackageInternalStatics": ["a3595605-234a-4b06-98b9-a533636fa322"],
    "x_Windows_CApplicationModel_CInternal_CIPackageInternalStatics2": ["bb95c564-53d6-41f7-afda-54af141a881c"],
    "x_Windows_CApplicationModel_CInternal_CIStartupTaskInternal": ["22aa83c0-1615-4f47-aaee-a63a926da3af"],
    "x_Windows_CApplicationModel_CInternal_CIStartupTaskInternalStatics": ["381385b1-0079-44e6-9cd2-4f89981dcca2"],
    "x_Windows_CApplicationModel_CInternal_CUserActivities_CIUserActivityHistoryPayload": [
        "24fe016d-695f-4241-91a9-53b6158c7cb5"
    ],
    "x_Windows_CApplicationModel_CInternal_CUserActivities_CIUserActivityHistoryPayloadFactory": [
        "36eabd18-4a88-4880-8fed-47c3e3d151c2"
    ],
    "x_Windows_CApplicationModel_CInternal_CUserActivities_CIUserActivityInternal": [
        "b2db361a-1510-41de-b6fe-3a7bbac3af34"
    ],
    "x_Windows_CApplicationModel_CInternal_CUserActivities_CIUserActivityMonitor": [
        "0a61d46b-4bac-4a46-ab6b-c62d31ffe96e"
    ],
    "x_Windows_CApplicationModel_CInternal_CUserActivities_CIUserActivityPayload": [
        "ca3695b4-9797-4bbc-85cc-6cd805ee498c"
    ],
    "x_Windows_CApplicationModel_CInternal_CUserActivities_CIUserActivityPayloadFactory": [
        "6ce42127-1c3d-4cfd-9c47-01e32e0e4f24"
    ],
    "x_Windows_CApplicationModel_CPhone_CInternal_CIApplicationInstanceContinuation": [
        "62dd0a65-4f0f-4b93-a012-3752dc44d51f"
    ],
    "x_Windows_CApplicationModel_CPhone_CInternal_CIContinuationDataProviderPriv": [
        "21b41627-706f-438a-afdd-d6764294a8e5"
    ],
    "x_Windows_CApplicationModel_CSearch_CCore_CIRequestingFocusOnKeyboardInputEventArgs": [
        "a1195f27-b1a7-41a2-879d-6a68687e5985"
    ],
    "x_Windows_CApplicationModel_CSearch_CCore_CISearchSuggestion": ["5b5554b0-1527-437b-95c5-8d18d2b8af55"],
    "x_Windows_CApplicationModel_CSearch_CCore_CISearchSuggestionManager": ["3f0c50a1-cb9d-497b-b500-3c04ac959ad2"],
    "x_Windows_CApplicationModel_CSearch_CCore_CISearchSuggestionsRequestedEventArgs": [
        "6fd519e5-9e7e-4ab4-8be3-c76b1bd4344a"
    ],
    "x_Windows_CApplicationModel_CSearch_CILocalContentSuggestionSettings": ["eeaeb062-743d-456e-84a3-23f06f2d15d7"],
    "x_Windows_CApplicationModel_CSearch_CISearchPane": ["fdacec38-3700-4d73-91a1-2f998674238a"],
    "x_Windows_CApplicationModel_CSearch_CISearchPaneQueryChangedEventArgs": ["3c064fe9-2351-4248-a529-7110f464a785"],
    "x_Windows_CApplicationModel_CSearch_CISearchPaneQueryLinguisticDetails": ["82fb460e-0940-4b6d-b8d0-642b30989e15"],
    "x_Windows_CApplicationModel_CSearch_CISearchPaneQuerySubmittedEventArgs": ["143ba4fc-e9c5-4736-91b2-e8eb9cb88356"],
    "x_Windows_CApplicationModel_CSearch_CISearchPaneQuerySubmittedEventArgsWithLinguisticDetails": [
        "460c92e5-4c32-4538-a4d4-b6b4400d140f"
    ],
    "x_Windows_CApplicationModel_CSearch_CISearchPaneResultSuggestionChosenEventArgs": [
        "c8316cc0-aed2-41e0-bce0-c26ca74f85ec"
    ],
    "x_Windows_CApplicationModel_CSearch_CISearchPaneStatics": ["9572adf1-8f1d-481f-a15b-c61655f16a0e"],
    "x_Windows_CApplicationModel_CSearch_CISearchPaneStaticsWithHideThisApplication": [
        "00732830-50f1-4d03-99ac-c6644c8ed8b5"
    ],
    "x_Windows_CApplicationModel_CSearch_CISearchPaneSuggestionsRequest": ["81b10b1c-e561-4093-9b4d-2ad482794a53"],
    "x_Windows_CApplicationModel_CSearch_CISearchPaneSuggestionsRequestDeferral": [
        "a0d009f7-8748-4ee2-ad44-afa6be997c51"
    ],
    "x_Windows_CApplicationModel_CSearch_CISearchPaneSuggestionsRequestedEventArgs": [
        "c89b8a2f-ac56-4460-8d2f-80023bec4fc5"
    ],
    "x_Windows_CApplicationModel_CSearch_CISearchPaneVisibilityChangedEventArgs": [
        "3c4d3046-ac4b-49f2-97d6-020e6182cb9c"
    ],
    "x_Windows_CApplicationModel_CSearch_CISearchQueryLinguisticDetails": ["46a1205b-69c9-4745-b72f-a8a4fc8f24ae"],
    "x_Windows_CApplicationModel_CSearch_CISearchQueryLinguisticDetailsFactory": [
        "cac6c3b8-3c64-4dfd-ad9f-479e4d4065a4"
    ],
    "x_Windows_CApplicationModel_CSearch_CISearchSuggestionCollection": ["323a8a4b-fbea-4446-abbc-3da7915fdd3a"],
    "x_Windows_CApplicationModel_CSearch_CISearchSuggestionsRequest": ["4e4e26a7-44e5-4039-9099-6000ead1f0c6"],
    "x_Windows_CApplicationModel_CSearch_CISearchSuggestionsRequestDeferral": ["b71598a9-c065-456d-a845-1eccec5dc28b"],
    "x_Windows_CApplicationModel_CUserActivities_CCore_CICoreUserActivityManagerStatics": [
        "b84424fe-a1ee-4dad-be54-d5fa81f60eba"
    ],
    "x_Windows_CApplicationModel_CUserActivities_CIUserActivity": ["7a846e18-1416-4d61-bc2f-a9e1b9791ef5"],
    "x_Windows_CApplicationModel_CUserActivities_CIUserActivityChannel": ["264f21f3-33ed-4aa6-be4c-436e705a65fc"],
    "x_Windows_CApplicationModel_CUserActivities_CIUserActivityChannelStatics": [
        "c8c005ab-198d-4d80-abb2-c9775ec4a729"
    ],
    "x_Windows_CApplicationModel_CUserActivities_CIUserActivitySession": ["ae434d78-24fa-44a3-ad48-6eda61aa1924"],
    "x_Windows_CApplicationModel_CUserActivities_CIUserActivityVisualElements": [
        "868c1780-b7fc-4c53-a009-89e920836017"
    ],
    "x_Windows_CCortana_CSpeech_CISpeechSettingsStatics": ["701a24fe-b373-4a89-a2ea-d34eed4dcbe2"],
    "x_Windows_CDevices_CInput_CIKeyboardCapabilities": ["3a3f9b56-6798-4bbc-833e-0f34b17c65ff"],
    "x_Windows_CDevices_CInput_CIMouseCapabilities": ["bca5e023-7dd9-4b6b-9a92-55d43cb38f73"],
    "x_Windows_CDevices_CInput_CIMouseDevice": ["88edf458-f2c8-49f4-be1f-c256b388bc11"],
    "x_Windows_CDevices_CInput_CIMouseDeviceStatics": ["484a9045-6d70-49db-8e68-46ffbd17d38d"],
    "x_Windows_CDevices_CInput_CIMouseEventArgs": ["f625aa5d-2354-4cc7-9230-96941c969fde"],
    "x_Windows_CDevices_CInput_CIPointerDevice": ["93c9bafc-ebcb-467e-82c6-276feae36b5a"],
    "x_Windows_CDevices_CInput_CIPointerDevice2": ["f8a6d2a0-c484-489f-ae3e-30d2ee1ffd3e"],
    "x_Windows_CDevices_CInput_CIPointerDeviceStatics": ["d8b89aa1-d1c6-416e-bd8d-5790914dc563"],
    "x_Windows_CDevices_CInput_CITouchCapabilities": ["20dd55f9-13f1-46c8-9285-2c05fa3eda6f"],
    "x_Windows_CFoundation_CIActivatableClassRegistration": ["9bbcae23-3dd6-49c3-b63c-1c587e7a6a67"],
    "x_Windows_CFoundation_CIActivatableClassRegistrationPrivate": ["0f7a4324-453a-4216-9944-3e24a43263bb"],
    "x_Windows_CFoundation_CIActivationContext": ["a6da413d-96ff-4575-a935-ce5ef6b722ef"],
    "x_Windows_CFoundation_CIActivationContextFactory": ["78c23c4c-270b-441b-b48d-282f8254d86c"],
    "x_Windows_CFoundation_CIDllServerActivatableClassRegistration": ["c8aa04f6-66c6-46a3-8fe6-f56be7ddc091"],
    "x_Windows_CFoundation_CIExeServerActivatableClassRegistration": ["9308c3c5-c2ac-49d1-a024-660a2bb5d5ac"],
    "x_Windows_CFoundation_CIExeServerRegistration": ["ec734a06-0401-4317-bac1-3b7e207242e3"],
    "x_Windows_CFoundation_CIExtensionCatalog": ["07cee0d8-d555-4d61-9c37-01c194b0f208"],
    "x_Windows_CFoundation_CIExtensionRegistration": ["905754d7-1cc5-404e-a9d4-c517bc35e88d"],
    "x_Windows_CFoundation_CIGetActivationFactory": ["4edb8ee2-96dd-49a7-94f7-4607ddab8e3c"],
    "x_Windows_CFoundation_CPrivate_CIComponentSite": ["f2a57aa9-917a-48d5-8e22-841e6dae347a"],
    "x_Windows_CFoundation_CPrivate_CIComponentSiteFactory": ["8c829518-827a-49cc-ab6b-75606d70a3fb"],
    "x_Windows_CFoundation_CPrivate_CIComponentSitePicker": ["9e987a71-7f34-4d85-9738-d1498fa9fbda"],
    "x_Windows_CFoundation_CPrivate_CIComponentStatics": ["12b41bef-540c-4cae-a8d9-1d2dfa2080fc"],
    "x_Windows_CFoundation_CPrivate_CIComponentUIActivatedEventArgs": ["55bb3fd1-0ecd-4945-ab2c-60d6d1385e86"],
    "x_Windows_CFoundation_CPrivate_CIComponentUIPrivateActivatedEventArgs": ["88142b7c-1ba3-4f41-b143-8404272b2d4d"],
    "x_Windows_CFoundation_CPrivate_CICompositionDevice": ["48f4a8e5-ad4c-47c0-b09d-3e1e3c96d8c7"],
    "x_Windows_CFoundation_CPrivate_CICompositionVisual": ["91591001-9037-4f22-aa74-9018e63d9388"],
    "x_Windows_CFoundation_CPrivate_CICoreApplicationView4": ["ff022ffc-f4f6-4a09-b3ae-69728520d2dd"],
    "x_Windows_CFoundation_CPrivate_CICoreApplicationViewInternal2": ["9ebd287a-8a6b-4191-915f-01b8da7dc177"],
    "x_Windows_CFoundation_CPrivate_CIRestrictedComponentStatics": ["0cd393c7-d9f7-4aee-b0e2-6ae3c2fb461c"],
    "x_Windows_CFoundation_CPrivate_CITokenBrokerComponentUILauncher": ["3276359f-9ba7-47bf-8f8b-c31bca8b0ba5"],
    "x_Windows_CGaming_CInternal_CIGamingTcuiActivationArgs": ["2c883267-dc11-4ea3-a858-5b46dd0f54b8"],
    "x_Windows_CGaming_CInternal_CIGamingTcuiAsyncOperationCompletion": ["ea46fb8e-3f3f-4ab0-adcc-e1a1798822f6"],
    "x_Windows_CGaming_CInternal_CIGamingTcuiBroker": ["4ca0dfa4-27e2-4a71-a8c0-f938214d301b"],
    "x_Windows_CGraphics_CDisplay_CCore_CInternal_CIHdmiDisplayInformationExtensionStatics": [
        "1077b49f-e210-4a01-8d5a-ec78b3ad93e7"
    ],
    "x_Windows_CGraphics_CDisplay_CIDisplayPropertiesInternal": ["67299cc6-32fe-4051-a50d-9c7245b43964"],
    "x_Windows_CGraphics_CImaging_CIBitmapDecoderInternal": ["02f47158-6c4c-43f2-84c0-06f826d81d3f"],
    "x_Windows_CInternal_CAppResolver_CIAppResolverActivatedArgs": ["fcef6ffc-959f-4ed6-82dc-50c611b8873d"],
    "x_Windows_CInternal_CAppResolver_CIAppResolverActivationArgsFactory": ["ed382808-fd3f-43a9-8c0a-83c7fa2aaff9"],
    "x_Windows_CInternal_CAppResolver_CIAppResolverApplication": ["bbfe5731-ee09-415c-8418-6e290bc2a865"],
    "x_Windows_CInternal_CAppUriDefaults_CIAppUriDefaultStatics": ["ade3f92b-54ca-4dbe-8cb2-e841824ac26a"],
    "x_Windows_CInternal_CApplicationDefaults_CIApplicationDefaultCategoriesStatics": [
        "a4877229-1b50-4c6b-b916-8eae18584671"
    ],
    "x_Windows_CInternal_CApplicationDefaults_CIApplicationDefaultHelpers": ["53bfea3d-86f7-48b5-af54-2130b3727357"],
    "x_Windows_CInternal_CApplicationDefaults_CIApplicationUsage": ["05f688aa-7abd-4ee2-a8ab-c410422d3497"],
    "x_Windows_CInternal_CApplicationDefaults_CIApplicationUsageStatics": ["4af57321-e772-4436-964c-e790135fd97a"],
    "x_Windows_CInternal_CApplicationDefaults_CIEnlightenmentPromptStatics": ["9e24ba1a-5ffc-406b-935d-d7f6241f062b"],
    "x_Windows_CInternal_CApplicationModel_CActivation_CIFolderActivatedEventArgs": [
        "96f79d71-c461-4b3d-8428-4a095a986272"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIAppModel": ["90ea19c8-8014-484d-a9f3-c1aecb25e39b"],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIAppView": ["add68ce2-bfd3-4208-a2c8-d48fb2e32c41"],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIAppViewActivationRequestedEventArgs": [
        "dac0a812-87a6-4f5a-8493-b80e07a89344"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIAppViewActivationRequestedEventArgsPrivate": [
        "caa08fe1-2af5-45e1-afb2-343d75e72b90"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIAppViewActivationShowRequestedEventArgs": [
        "6deb3499-706f-4575-80c9-7c534f7af176"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIAppViewAdapter": [
        "30047570-f926-4b1d-b331-913eff8a960b"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIAppViewBehaviorStatics": [
        "05f3eb97-d7d7-4f49-919d-368bc0323fb4"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIAppViewChangedEventArgs": [
        "a5447aa8-063b-4ddc-8b81-021591a43bf1"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIAppViewExecutionStateChangedEventArgs": [
        "9345de75-e838-4721-9f20-7b09ac8be053"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIAppViewInputStateChangedEventArgs": [
        "c496e6ee-b0c7-4820-ac0b-51020218c047"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIAppViewOperation": [
        "218f2289-559b-4436-b7d5-acf16ded5c16"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIAppViewPrivate": [
        "01066031-1e08-4f01-854c-df2f10d3c10f"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIAppViewPrivateStatics": [
        "e3ccca43-a0a5-449c-b2b1-4295eed275bd"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIAppViewRequestCompleted": [
        "abc8da5a-e51c-4bdd-8c4d-6a1e3958b63f"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIAppViewRequestEventArgs": [
        "5c19477e-81ef-4d21-baa4-c3040ad2ea6b"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIAppViewShowRequestedEventArgs": [
        "51daf61b-50da-4291-b2fe-d93006a3efe1"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIAppViewSilverlightPropertyChangedEventArgs": [
        "162a2ca7-07f7-429d-bd62-c37bcf10f602"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIAppViewSplashPropertyChangedEventArgs": [
        "f5cef0fc-fb55-44be-9653-3f5b3bf4bf7e"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIAppViewStatics": [
        "882d9981-e3b3-4275-a857-00c3910fb5c3"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIAppViewSwitchRequestedEventArgs": [
        "7e2b31e8-c8d6-4483-9f92-0a8ab7300f07"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIAppViewUniversalPropertyChangedEventArgs": [
        "57e9a04f-e685-491c-b433-f71b7b334bd3"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIAppViewVisibilityChangedEventArgs": [
        "a768d72d-edbd-4f38-b426-72f9f42ec757"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIAppViewWatcher": [
        "3169ab14-dd32-4d2f-b943-0e53446f5085"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIAppViewWatcherPrivate": [
        "7115874b-c436-4c7f-8e23-af62ddb69052"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIAsyncOperationCompletion": [
        "4c50ba5a-1b14-4e1a-b4f6-ca30a08bb9da"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIAutomation": ["7289707d-4a94-4bd5-8e93-be0d13f5c505"],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIComponentHandler": [
        "86a0d5cc-8a89-4ecc-9ce0-36c789bc75d0"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIComponentUIRelationshipStore": [
        "f0fb8d26-800e-4b7b-8b1d-1a2a0ad272f4"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CICoreAppModel": ["291f5445-7b2c-44a8-9859-1b4b10bd4b74"],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIDispatchedEventHandler": [
        "5700b524-bd26-40f7-8c68-5a7fa42df5e9"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIEventDispatchedNotification": [
        "9915dbaf-84aa-4d75-afbc-abe6212403b5"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIEventInvokeCompleteHandler": [
        "2d292ce3-445e-41c1-aa1a-65e5bc5891f4"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CISilverlightAppModel": [
        "c4130531-1af7-459e-a116-97ac497f414a"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CISilverlightAppModelPrivate": [
        "6835e523-32cc-4442-999b-4281299615fc"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CISplashAppModel": [
        "d8ebb53f-ff8d-431b-9850-a82fb53a0933"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CISplashAppModelPrivate": [
        "1518667a-fced-4814-8d61-d40dc11d6ad6"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CISplashScreen": ["ecc8094d-d468-4860-9d61-260400aa9829"],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CISystemKeyPressedOperation": [
        "3a29762d-93c6-430f-b154-1f89c033703b"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIUIAConnectOperation": [
        "32ad0de1-9e8d-44f0-946e-b94220c166f4"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIUniversalAppModel": [
        "bb1b3bfe-28ab-45df-ba57-d8ebc214aebe"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIUniversalAppModelPrivate": [
        "5bc38ff9-86b3-4206-8899-55322416cfd1"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIUniversalBatch": [
        "7fb024b8-0c52-44f0-aa7b-442557825557"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIUniversalTitleBar": [
        "402af51f-a72c-45b8-8fe3-cff04ed914f1"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIUniversalTitleBarPrivate": [
        "f811e521-305b-4063-b908-b0e2ebcff305"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIWindow": ["4f6719dc-762f-41da-b4e8-d3a037bca583"],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIWindowAdapter": ["f5fbab60-996f-4889-a68e-2980d80cbf31"],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIWindowBehaviorStatics": [
        "d928b176-b291-4bd6-9f6f-2e21e3ef6cbc"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIWindowChangedEventArgs": [
        "317be656-a8be-48a0-95c9-cd02915bc9de"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIWindowForegroundChangedEventArgs": [
        "39439654-626a-4823-a964-37c5b7ce651c"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIWindowForegroundChangedEventArgsPrivate": [
        "14ad4c26-c78d-4609-83f4-5d5dda67746c"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIWindowPrivate": ["93317a29-d9a6-4b2b-8cc6-5b8ee99e86ce"],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIWindowPrivateStatics": [
        "264681ce-419c-4679-9899-778dd47a175a"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIWindowStatics": ["5e75aba7-c424-4076-9d47-409a1eda087f"],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIWindowVisibilityChangedEventArgs": [
        "239cf425-667d-43c3-a3e2-a49471e9a0d3"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIWindowWatcher": ["c5230dad-4d49-4c07-aafa-7bafbbff72b0"],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIWindowWatcherPrivate": [
        "79c919b6-e9d1-4c74-b30b-570c75b06dae"
    ],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIWorkCallback": ["57c81164-0b87-4050-8d81-0e1a1fef4ddf"],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIWorkspace": ["59066ac8-285b-4209-a3bd-a6dc2f723e96"],
    "x_Windows_CInternal_CApplicationModel_CWindowManagement_CIWorkspaceOperation": [
        "7ef88815-17a0-47e9-b6b4-52d5dd440784"
    ],
    "x_Windows_CInternal_CBackupRestore_CSettingsProviders_CIAddTargetCapability": [
        "2966b3cb-0db2-45e8-92ff-617bde7e3f9c"
    ],
    "x_Windows_CInternal_CBackupRestore_CSettingsProviders_CIAppBackupScopeItem": [
        "c239eaf0-8e99-42d5-b573-eb2562eb689e"
    ],
    "x_Windows_CInternal_CBackupRestore_CSettingsProviders_CIAppDataBackupCapabilitiesProvider": [
        "255aba9f-6cee-4148-9f92-ce70bfee8ab8"
    ],
    "x_Windows_CInternal_CBackupRestore_CSettingsProviders_CIBackupFrequency": ["11228dba-c3e5-440a-9276-d93c900c2883"],
    "x_Windows_CInternal_CBackupRestore_CSettingsProviders_CIBackupPropertiesBase": [
        "48b32ae0-6d75-4b7a-ad34-39b4fef39602"
    ],
    "x_Windows_CInternal_CBackupRestore_CSettingsProviders_CIBackupRelatedActionItem": [
        "b948c7e7-dcaa-4445-8080-91b841e6437e"
    ],
    "x_Windows_CInternal_CBackupRestore_CSettingsProviders_CIBackupSettingsProvider": [
        "38f502a3-d89d-4e26-b33c-c3701805c919"
    ],
    "x_Windows_CInternal_CBackupRestore_CSettingsProviders_CIBackupStatusCapability": [
        "bcb544ad-a7e8-4626-8228-71e529694009"
    ],
    "x_Windows_CInternal_CBackupRestore_CSettingsProviders_CIBackupTargetItem": [
        "3a7f7145-fc0e-4de0-99e3-47eafe9e909e"
    ],
    "x_Windows_CInternal_CBackupRestore_CSettingsProviders_CIBoolBasedBackupFrequencyCapability": [
        "e97b5581-2926-49b0-8a22-d5ab52a2ce6a"
    ],
    "x_Windows_CInternal_CBackupRestore_CSettingsProviders_CIBoolBasedRetentionCapability": [
        "24212bfc-01de-4fbb-b24b-8a8ae348433e"
    ],
    "x_Windows_CInternal_CBackupRestore_CSettingsProviders_CIEnumBackupSettingsProviders": [
        "6450d4ae-35cb-46f6-9219-be4f2a6b0d85"
    ],
    "x_Windows_CInternal_CBackupRestore_CSettingsProviders_CIEnumBackupsProvider": [
        "60e67856-2e3d-4d0e-bf4a-315bb78b0220"
    ],
    "x_Windows_CInternal_CBackupRestore_CSettingsProviders_CIFixedBackupScopesCapability": [
        "c51ec00c-30cd-4434-98e3-ef0c18873f4d"
    ],
    "x_Windows_CInternal_CBackupRestore_CSettingsProviders_CIFolderBackupScopeItem": [
        "9626ec99-0ca2-40fd-abf4-78aeb66a65cc"
    ],
    "x_Windows_CInternal_CBackupRestore_CSettingsProviders_CIFolderExcludesBackupScopesCapability": [
        "0be62ce3-4e52-4253-9393-93d6fd8d75db"
    ],
    "x_Windows_CInternal_CBackupRestore_CSettingsProviders_CIFolderIncludesBackupScopesCapability": [
        "e3a4428e-65ce-4c38-9cdf-4b8c8c831ed3"
    ],
    "x_Windows_CInternal_CBackupRestore_CSettingsProviders_CIListBasedBackupFrequencyCapability": [
        "bab43323-70ff-47df-a7cb-23366ed025e9"
    ],
    "x_Windows_CInternal_CBackupRestore_CSettingsProviders_CIListBasedManualCleanupCapability": [
        "721c1064-38e6-48db-b9d5-c4e6fb050fdc"
    ],
    "x_Windows_CInternal_CBackupRestore_CSettingsProviders_CIListBasedRetentionCapability": [
        "e36a1beb-9667-4000-a752-b6eb669bc589"
    ],
    "x_Windows_CInternal_CBackupRestore_CSettingsProviders_CIManageBackupsCapability": [
        "97916853-1b15-448d-a899-a1ddb9955d4f"
    ],
    "x_Windows_CInternal_CBackupRestore_CSettingsProviders_CIManualBackupCapability": [
        "90d2d315-a5b9-4f66-af8a-ac8ce94428b8"
    ],
    "x_Windows_CInternal_CBackupRestore_CSettingsProviders_CIManualCleanupOption": [
        "020c954c-436c-42d5-ad9c-2c827b9fb933"
    ],
    "x_Windows_CInternal_CBackupRestore_CSettingsProviders_CIOneBackupHandlerStatics": [
        "c01d2385-eae8-42b0-abac-85a30f2ea27f"
    ],
    "x_Windows_CInternal_CBackupRestore_CSettingsProviders_CIPropertyChangedEventArgs": [
        "086c5c83-e0cb-4b8c-bcd6-071ac289c92d"
    ],
    "x_Windows_CInternal_CBackupRestore_CSettingsProviders_CIRangeBasedTargetQuotaCapability": [
        "21a248c1-486a-4dd4-b3f5-120c9906cfad"
    ],
    "x_Windows_CInternal_CBackupRestore_CSettingsProviders_CIRelatedBackupSettingsCapability": [
        "d6fdf416-24fb-47f7-805e-2178f9381edd"
    ],
    "x_Windows_CInternal_CBackupRestore_CSettingsProviders_CIRemoveBackupCapability": [
        "e8342a99-1e5c-4c5e-aa01-1e1207e62626"
    ],
    "x_Windows_CInternal_CBackupRestore_CSettingsProviders_CIRestoreBackupCapability": [
        "c67194f3-e1af-44c1-a730-585736944358"
    ],
    "x_Windows_CInternal_CBackupRestore_CSettingsProviders_CIRetentionListItem": [
        "d199d661-aeaf-4ae2-a1ad-33dc026cf981"
    ],
    "x_Windows_CInternal_CBackupRestore_CSettingsProviders_CISystemImageBackupCapabilitiesProvider": [
        "8322677e-f250-4b17-9041-03ecbf55ef8f"
    ],
    "x_Windows_CInternal_CBackupRestore_CSettingsProviders_CISystemSettingsBackupCapabilitiesProvider": [
        "cc851f02-c8b6-47d5-b14e-8c8322982e3d"
    ],
    "x_Windows_CInternal_CBackupRestore_CSettingsProviders_CITargetValidationCapability": [
        "5ac6372f-c0e6-4416-aa41-600e32478615"
    ],
    "x_Windows_CInternal_CBackupRestore_CSettingsProviders_CIUserDataBackupCapabilitiesProvider": [
        "ba867308-3977-4425-825e-eb3991e547d9"
    ],
    "x_Windows_CInternal_CBackupRestore_CSettingsProviders_CIVolumeBackupScopeItem": [
        "bff357e0-b895-4ff7-b517-53396de7014f"
    ],
    "x_Windows_CInternal_CFeedback_CIFeedbackBroker": ["e8a1369b-088f-4245-92d5-757cfa385e82"],
    "x_Windows_CInternal_CFeedback_CIFeedbackItem": ["0de8dc84-5de4-4db8-ac8f-9fbbf602ba25"],
    "x_Windows_CInternal_CFoundation_CContracts_CIActivationFactoryContractRedirector": [
        "da805a35-961f-4194-a4bb-e9e86347d589"
    ],
    "x_Windows_CInternal_CFoundation_CContracts_CIActivationFactoryContractRedirectorContext": [
        "7d6e17e4-e332-45e3-a8c9-b7291a38c23b"
    ],
    "x_Windows_CInternal_CIBindableObservableItem": ["a85c7967-039d-40b3-94ac-34c0e46ed12a"],
    "x_Windows_CInternal_CIBrokeredFileExplorerHelpersStatics": ["ef2c8ccc-d025-45fd-8f3b-65eb736c1598"],
    "x_Windows_CInternal_CICachedItemSource": ["2b3f0182-a1a0-4bab-a613-f974996f3e01"],
    "x_Windows_CInternal_CIFileExplorerConfiguration": ["9f7ed89d-2aab-420e-94f9-d14ff13d0854"],
    "x_Windows_CInternal_CIFileExplorerHelpersStatics": ["010b8729-25db-421d-ac8c-4d320dce3c11"],
    "x_Windows_CInternal_CIFileExplorerLinkResolverStatics": ["69ebf62f-c411-41f1-90b7-13d1d94bc7b3"],
    "x_Windows_CInternal_CIHashable": ["29328bc2-06ab-4ece-b8f9-a81711f0704b"],
    "x_Windows_CInternal_CIPropertyMatchProvider": ["d625488b-de6c-44aa-a8a4-88b6cc131930"],
    "x_Windows_CInternal_CIPropertyValueProvider": ["f264ea25-504c-4552-8add-71791c7298bf"],
    "x_Windows_CInternal_CIRealizedItemsProvider": ["53610ae4-4bd2-402c-9a2b-e7d25151e599"],
    "x_Windows_CInternal_CIStorageItemPropertiesInternalMarshal": ["e5dc526b-87ea-434c-add9-fdd49c3f20c4"],
    "x_Windows_CInternal_CIVirtualizedSelectionProvider": ["b3eb3c63-9918-41d8-a9c1-71fc5a6e7d1a"],
    "x_Windows_CInternal_CIVirtualizedVector": ["5a8cb364-86b9-4852-881f-4f0602b76f61"],
    "x_Windows_CInternal_COneCore_CShellExperience_CICoreExperienceBroker": ["4ab5c6e0-38d4-4bc9-ad1c-452d4ca99b22"],
    "x_Windows_CInternal_COneCore_CViewEventHandlers_CIComponentRelationshipStore": [
        "f07c78aa-32b6-4f71-9cca-05b43394d316"
    ],
    "x_Windows_CInternal_COneCore_CViewEventHandlers_CICoreCUIBroker": ["789576fc-b406-4626-a33f-b3a86aa6c1dd"],
    "x_Windows_CInternal_COneCore_CViewEventHandlers_CICoreCUIBrokerProvider": ["0a5f9dad-caa7-4537-92eb-2eb6b7d7867c"],
    "x_Windows_CInternal_COneCore_CViewEventHandlers_CICoreComponentUIViewEventHandler": [
        "4a4251ad-d57e-470e-81c1-cb3b53cc4483"
    ],
    "x_Windows_CInternal_CPropertySystem_CIPropertyDescription": ["3ce52d31-3fbc-4ee2-b0b2-84fbda5518c6"],
    "x_Windows_CInternal_CPropertySystem_CIPropertySystemStatics": ["9d452201-448b-4ca5-982f-0f7e4599c256"],
    "x_Windows_CInternal_CSecurity_CAuthentication_CWeb_CIAuthenticationHostingCoreManagerStatics": [
        "e5844fd4-69c4-4faf-9053-c52c76f2e10c"
    ],
    "x_Windows_CInternal_CSecurity_CAuthentication_CWeb_CIGetDefaultSignInAccountResult": [
        "9e8e4bd8-bfc5-4785-94c2-b210db698776"
    ],
    "x_Windows_CInternal_CSecurity_CAuthentication_CWeb_CIHttpCookieRequestResult": [
        "2a4aa61d-9df9-4ae4-8b5f-ea2dc5ed53b9"
    ],
    "x_Windows_CInternal_CSecurity_CAuthentication_CWeb_CITokenBrokerAddAccountOperationProperties": [
        "727af179-5474-499a-ba13-e2eec292cc78"
    ],
    "x_Windows_CInternal_CSecurity_CAuthentication_CWeb_CITokenBrokerInternalStatics": [
        "07650a66-66ea-489d-aa90-0dabc75f3567"
    ],
    "x_Windows_CInternal_CSecurity_CAuthentication_CWeb_CITokenBrokerInternalStatics2": [
        "25b7f084-b824-4ef8-97b6-c0fb78358b31"
    ],
    "x_Windows_CInternal_CSecurity_CAuthentication_CWeb_CITokenBrokerInternalStatics3": [
        "8d189c21-9fb8-4e21-ba5a-b4e3468ba63b"
    ],
    "x_Windows_CInternal_CSecurity_CAuthentication_CWeb_CITokenBrokerInternalStatics4": [
        "b53a11bd-746a-45ee-80e6-aa5b7faa597c"
    ],
    "x_Windows_CInternal_CSecurity_CAuthentication_CWeb_CITokenBrokerInternalStatics5": [
        "57d369ee-7364-4ab0-a307-bdd25bce408c"
    ],
    "x_Windows_CInternal_CSecurity_CAuthentication_CWeb_CITokenBrokerListenerInternal": [
        "cc51f0fc-48d9-4e33-a38c-85546b542fe7"
    ],
    "x_Windows_CInternal_CSecurity_CAuthentication_CWeb_CITokenBrokerProviderInternal": [
        "578d4e6f-d752-472b-b527-33570cb4c2be"
    ],
    "x_Windows_CInternal_CSecurity_CAuthentication_CWeb_CITokenBrokerSystemExtension": [
        "312c4894-77ef-42fd-b198-0c6c6017184e"
    ],
    "x_Windows_CInternal_CSecurity_CAuthentication_CWeb_CIWamObjectStore": ["a9ee00e9-1a3b-4315-9cbe-8cf3d6347c5f"],
    "x_Windows_CInternal_CSecurity_CAuthentication_CWeb_CIWamObjectStoreManagerStatics": [
        "4631f6e7-ffcd-4b75-8fc6-160350fa89ab"
    ],
    "x_Windows_CInternal_CSecurity_CAuthentication_CWeb_CIWamProviderRegistrationInformation": [
        "63a0a1e5-f8fe-4ba6-8508-caef1277dd35"
    ],
    "x_Windows_CInternal_CSecurity_CAuthentication_CWeb_CIWamProviderRegistrationInformation2": [
        "2ac205be-4b07-45fb-a9f0-02ad6d3c3451"
    ],
    "x_Windows_CInternal_CSecurity_CAuthentication_CWeb_CIWamProviderRegistrationInformation3": [
        "3a5a4a5f-f916-41be-953c-56ee6e94f378"
    ],
    "x_Windows_CInternal_CSecurity_CAuthentication_CWeb_CIWamProviderRegistrationStatics": [
        "e60e20a2-87a0-4b34-8502-ee3b8fb4ec16"
    ],
    "x_Windows_CInternal_CSecurity_CAuthentication_CWeb_CIWamProviderUtilitiesStatics": [
        "0c1aa468-e0b9-46a3-a6c6-700c546ff991"
    ],
    "x_Windows_CInternal_CSecurity_CAuthentication_CWeb_CIWebAccountAddedEventArgs": [
        "07179bf3-f0d8-45a8-9743-a954563d5710"
    ],
    "x_Windows_CInternal_CSecurity_CAuthentication_CWeb_CIWebAccountChangedEventArgs": [
        "e61cdc47-495c-4872-be72-04c6e07669a4"
    ],
    "x_Windows_CInternal_CSecurity_CAuthentication_CWeb_CIWebAccountDeletePendingEventArgs": [
        "a4a7e0b9-9f2e-4c5e-8ac6-8014bb2bf267"
    ],
    "x_Windows_CInternal_CSecurity_CAuthentication_CWeb_CIWebAccountDeletedEventArgs": [
        "4eb69902-92c8-48d9-9de4-a870b7dcf707"
    ],
    "x_Windows_CInternal_CSecurity_CAuthentication_CWeb_CIWebAccountProviderAddedEventArgs": [
        "a7d2b794-be6a-416b-b775-151aafe80e68"
    ],
    "x_Windows_CInternal_CSecurity_CAuthentication_CWeb_CIWebAccountProviderChangedEventArgs": [
        "c8660cf5-e1be-4022-ae30-8ff07707abdf"
    ],
    "x_Windows_CInternal_CSecurity_CAuthentication_CWeb_CIWebAccountProviderDeletedEventArgs": [
        "76a25771-2d57-4491-864a-997d850bfacd"
    ],
    "x_Windows_CInternal_CSecurity_CAuthentication_CWeb_CIWebAccountSetter": ["d9a260bf-ca96-4d92-af87-3d22326e66f5"],
    "x_Windows_CInternal_CSecurity_CAuthentication_CWeb_CIWebAuthenticationCoreInternalManagerStatics": [
        "083ab645-4069-4383-a713-7d1482e7a32c"
    ],
    "x_Windows_CInternal_CSecurity_CAuthentication_CWeb_CIWebTokenRequestInternal": [
        "557a8316-c97e-45f1-83c9-2420e9b9c1f2"
    ],
    "x_Windows_CInternal_CSecurity_CAuthentication_CWeb_CIWebTokenRequestResultInternal": [
        "e92ddf59-6209-4a2b-91ca-8d6f84c46ec6"
    ],
    "x_Windows_CInternal_CSecurity_CAuthentication_CWeb_CIWebTokenRequestStatusSetter": [
        "85cd407e-911e-435a-8a42-9b5142219be9"
    ],
    "x_Windows_CInternal_CSecurity_CCredentials_CIWebAccountInternal": ["281d779d-89e9-4af3-9f42-4d2379d0f1b0"],
    "x_Windows_CInternal_CSecurity_CCredentials_CIWebAccountInternalFactory": ["067cd3b2-1f07-4710-8ae5-5cd2e71efc11"],
    "x_Windows_CInternal_CSecurity_CCredentials_CIWebAccountProviderInternal": ["30c936f0-4c20-45e9-ba93-5a001f1506f9"],
    "x_Windows_CInternal_CSecurity_CCredentials_CIWebAccountProviderInternalFactory": [
        "4f81bfe6-fdb4-4dc4-86b9-4af32d514b78"
    ],
    "x_Windows_CInternal_CSecurity_CCredentials_CIWebAccountProviderSystemInformation": [
        "3b043d7e-726f-41e2-8933-f968f503b854"
    ],
    "x_Windows_CInternal_CSecurity_CCredentials_CIWebAccountProviderUserContext": [
        "c997b7de-ff59-4392-bcde-50ea5ffc1e1c"
    ],
    "x_Windows_CInternal_CSecurity_CCredentials_CIWebAccountProviderWithMrtResourceIcon": [
        "2b9c347e-56fb-4947-ab47-6982bb2cf28d"
    ],
    "x_Windows_CInternal_CSecurity_CCredentials_CIWebAccountSystemInformation": [
        "40285a2b-65d5-41f5-b904-76c860d86e26"
    ],
    "x_Windows_CInternal_CSecurity_CWebAuthentication_CIAuthenticationManager": [
        "eb2c0c45-76f9-4a0a-bb73-fcf47d73a4eb"
    ],
    "x_Windows_CInternal_CSecurity_CWebAuthentication_CISystemAuthenticatorInternal": [
        "7b3eeda3-c532-45a0-852d-1dc941df780e"
    ],
    "x_Windows_CInternal_CSecurity_CWebAuthentication_CIUserHostIdentity": ["79882e54-c2ae-4f76-9577-9fe028b48255"],
    "x_Windows_CInternal_CSettingSync_CIAppCollection": ["b7a67f90-af6b-4325-8683-735d089bfe80"],
    "x_Windows_CInternal_CSettingSync_CICollection": ["2d1a29e9-218b-436f-a0dc-09f5a2e12f31"],
    "x_Windows_CInternal_CSettingSync_CICollectionBackup": ["8a906b1c-2d64-4db3-856c-7266915abb1d"],
    "x_Windows_CInternal_CSettingSync_CICollectionBackupsInternalStatics": ["be8faa4b-f73b-4d8f-b218-4b79342f33a8"],
    "x_Windows_CInternal_CSettingSync_CICollectionBackupsManager": ["09b0cf04-09a1-435a-91ab-09fdf3566c87"],
    "x_Windows_CInternal_CSettingSync_CINotifyAccountChange": ["3cd63077-a08c-481a-93eb-c5d7568ae886"],
    "x_Windows_CInternal_CSettingSync_CIRoamingDataQuery": ["cc0ea3fc-f8ec-4792-aa73-e0b6d0f7bbf6"],
    "x_Windows_CInternal_CSettingSync_CIRoamingDataQueryFactory": ["a90c0cff-9143-4ae5-9ef0-74e2b84d4dd2"],
    "x_Windows_CInternal_CSettingSync_CISettingSyncController": ["b17aa045-3f02-4eda-a2de-5f5280844b06"],
    "x_Windows_CInternal_CShellComponentSettings_CINavigationBarSettings": ["d1bdffac-d73e-48af-b346-a19a20d1e0a8"],
    "x_Windows_CInternal_CShellComponentSettings_CISettingsChangeEventArgs": ["2f352e8e-3e56-4a02-974b-98c02b654c72"],
    "x_Windows_CInternal_CShell_CDesktop_CViewManagerInterop_CIObjectProviderForView": [
        "7741cf2f-885f-4102-aff3-3482ce291ddb"
    ],
    "x_Windows_CInternal_CShell_CDesktop_CViewManagerInterop_CIObjectProviderForWindow": [
        "0f9d5f79-22ef-4898-88f4-9b5c3ad2b5fe"
    ],
    "x_Windows_CInternal_CShell_CDesktop_CViewManagerInterop_CIObjectWithView": [
        "1f09d4ca-c8b3-4b22-854b-ce0134ebf5d0"
    ],
    "x_Windows_CInternal_CShell_CDesktop_CViewManagerInterop_CIObjectWithVisibility": [
        "87592b53-3883-4191-b37f-f49f5cb91b5f"
    ],
    "x_Windows_CInternal_CShell_CDesktop_CViewManagerInterop_CIObjectWithWindow": [
        "8d2a8bc4-d46e-4079-bdcb-7c4c0841d5e8"
    ],
    "x_Windows_CInternal_CShell_CDesktop_CViewManagerInterop_CIViewEventDispatcherDesktopExtension": [
        "f36451a9-014a-43ea-9492-ff81c012e15f"
    ],
    "x_Windows_CInternal_CShell_CDesktop_CViewManagerInterop_CIViewVisibilityOverride": [
        "7ae7a925-240e-4f93-9f3b-87d346eb1835"
    ],
    "x_Windows_CInternal_CShell_CDesktop_CViewManagerInterop_CIVisibilityChangedEventArgs": [
        "665255b1-7fb8-4bf1-8fa5-9908708becd5"
    ],
    "x_Windows_CInternal_CShell_CExperience_CIActionCenterExperienceManager": ["0204e158-c053-499b-811c-acd15ef07559"],
    "x_Windows_CInternal_CShell_CExperience_CICortanaExperienceManager": ["cc316ad0-3e56-4dcb-bf02-8c10ea8bfbbe"],
    "x_Windows_CInternal_CShell_CExperience_CICortanaShownEventArgs": ["9697311c-768a-4cd5-9b37-049855339820"],
    "x_Windows_CInternal_CShell_CExperience_CIDeviceDiscoveryExperienceManager": [
        "4f8c32e2-f707-4d00-ad96-edffd27b6b73"
    ],
    "x_Windows_CInternal_CShell_CExperience_CIDevicePickerExperienceManager": ["af056671-a2c2-431f-9e6e-feced34ce6a9"],
    "x_Windows_CInternal_CShell_CExperience_CIDisplayTopologyChangeExperienceManager": [
        "aa5bb64c-3f65-470f-a4e2-74834bc300c5"
    ],
    "x_Windows_CInternal_CShell_CExperience_CIExpansionExperienceManager": ["c83daff1-ca5a-48c0-93d9-10c3b962bb31"],
    "x_Windows_CInternal_CShell_CExperience_CIExperienceManagerPriorityManipulator": [
        "fdae1e57-9570-4461-bab5-532c0f899149"
    ],
    "x_Windows_CInternal_CShell_CExperience_CIFocusNavigateEventArgs": ["b0f15396-8df4-4167-b062-b2c66f34efbb"],
    "x_Windows_CInternal_CShell_CExperience_CIHostExperienceManager": ["2410129c-64a0-4b85-9e61-12caec38d6ef"],
    "x_Windows_CInternal_CShell_CExperience_CIImeStatusNotificationExperienceManager": [
        "08f4f43b-7be0-4a08-b5df-24044d7e8b72"
    ],
    "x_Windows_CInternal_CShell_CExperience_CIInputDialExperienceManager": ["599db028-e1d3-433d-9f90-32468634d59e"],
    "x_Windows_CInternal_CShell_CExperience_CIJumpViewExperienceEventArgs": ["afe9aba4-877b-44b7-b9cb-1d0c97c6b204"],
    "x_Windows_CInternal_CShell_CExperience_CIJumpViewExperienceManager": ["58a98b87-ed3c-4e12-b5df-c72bf4470aee"],
    "x_Windows_CInternal_CShell_CExperience_CINetworkFlyoutExperienceManager": ["e44f17e6-ab85-409c-8d01-17d74bec150e"],
    "x_Windows_CInternal_CShell_CExperience_CIPenWorkspaceExperienceManager": ["6a9391e9-c8c9-4a1b-b31f-1f6f529ca573"],
    "x_Windows_CInternal_CShell_CExperience_CIPeopleBarContainerExperienceManager": [
        "faf18a66-2374-41b2-b79b-ce800bc3122d"
    ],
    "x_Windows_CInternal_CShell_CExperience_CIPeopleBarFlyoutExperienceManager": [
        "1b7781cd-1b97-4728-8b6e-67a7e55cc53c"
    ],
    "x_Windows_CInternal_CShell_CExperience_CIPeopleBarJumpViewExperienceManager": [
        "ab65b025-ff88-470a-9513-b62bcd7ce879"
    ],
    "x_Windows_CInternal_CShell_CExperience_CIPeopleTestExperienceManager": ["06bbbdb5-9a5a-471f-9c17-ff2675105b33"],
    "x_Windows_CInternal_CShell_CExperience_CIQuickConnectExperienceManager": ["7fec38c1-a520-4797-848f-66efa8bd3502"],
    "x_Windows_CInternal_CShell_CExperience_CIQuickConnectViewService": ["4aaaff25-9e49-4ab5-b2af-c798c01c536c"],
    "x_Windows_CInternal_CShell_CExperience_CIQuickConnectViewService2": ["cb2ddc0d-d9ed-46c2-955a-d9eb426a8595"],
    "x_Windows_CInternal_CShell_CExperience_CISharePickerExperienceManager": ["067407f4-e024-432d-8db2-446eb8bfc91d"],
    "x_Windows_CInternal_CShell_CExperience_CIShellExperience": ["db37659c-5741-4985-a443-dda995e92f5f"],
    "x_Windows_CInternal_CShell_CExperience_CIShellExperienceDispatcher": ["69bb2711-c5f2-41da-8d6d-448a336a24c5"],
    "x_Windows_CInternal_CShell_CExperience_CIShellExperienceDispatcherCustomization": [
        "b18447e2-209d-43d3-add5-a3434f4d558b"
    ],
    "x_Windows_CInternal_CShell_CExperience_CIShellExperienceManagerFactory": ["2e8fcb18-a0ee-41ad-8ef8-77fb3a370ca5"],
    "x_Windows_CInternal_CShell_CExperience_CIShellExperiencePositioner": ["c6ff146a-7f1d-492e-8981-e95cda605ef7"],
    "x_Windows_CInternal_CShell_CExperience_CIShellExperiencePrivate": ["c1635471-1417-4750-811f-a6122953c5a3"],
    "x_Windows_CInternal_CShell_CExperience_CIShellExperienceProperties": ["c56c5799-4bb3-7fae-7fad-4db2f6a53eff"],
    "x_Windows_CInternal_CShell_CExperience_CIShellExperienceReactivatedEventArgs": [
        "c1707d4e-b7cf-4c02-8c49-e72509ea16f5"
    ],
    "x_Windows_CInternal_CShell_CExperience_CIShellExperienceStart": ["4c4d0c66-5bd5-fd8c-617f-3c7778f46bb6"],
    "x_Windows_CInternal_CShell_CExperience_CIShellExperienceStartStatics": ["fb2e3e59-b442-4b5b-9128-2319bf8de3b0"],
    "x_Windows_CInternal_CShell_CExperience_CIShellExperienceStatics": ["82badb30-4e84-4ab7-817c-46691c8a6d1c"],
    "x_Windows_CInternal_CShell_CExperience_CIShellExperienceView": ["9f8649aa-a188-4bda-a412-ecb6807c94d8"],
    "x_Windows_CInternal_CShell_CExperience_CIShellExperienceViewChangedArg": ["1b7d8b95-d5cb-4cff-874f-11fdf16217ac"],
    "x_Windows_CInternal_CShell_CExperience_CIShellExperienceViewEventArg": ["945f341f-df0f-41d1-adae-5b9dabbb2139"],
    "x_Windows_CInternal_CShell_CExperience_CIShellExperienceViewStateChangedEventArgs": [
        "dd55cb0d-94d4-466e-886b-fff56e33e219"
    ],
    "x_Windows_CInternal_CShell_CExperience_CIShellModeChangedEventArgs": ["881a8656-783e-170e-b39a-0f7f2f675c94"],
    "x_Windows_CInternal_CShell_CExperience_CIShoulderTapExperienceManager": ["8667db0d-6960-465f-b9a4-c461863efa91"],
    "x_Windows_CInternal_CShell_CExperience_CISoftLandingExperienceManager": ["984634c4-91f4-4a71-89ca-5baa258a1d7b"],
    "x_Windows_CInternal_CShell_CExperience_CIStartExperienceAnimationRequestedEventArgs": [
        "3eafee73-b241-4b19-ac9a-32f202f8e21a"
    ],
    "x_Windows_CInternal_CShell_CExperience_CIStartExperienceBroker": ["99e01be7-d840-6dfb-694f-8814c2ec727e"],
    "x_Windows_CInternal_CShell_CExperience_CIStartExperienceManager": ["c2d211a1-a6d4-49b5-9704-d74cb4dff1ee"],
    "x_Windows_CInternal_CShell_CExperience_CIStartUserInfo": ["22c9ef4c-a7dc-476c-bb5c-dc03de666fd3"],
    "x_Windows_CInternal_CShell_CExperience_CIStartUserInfoBroker": ["988881d6-4fa0-4554-86b0-25911104973a"],
    "x_Windows_CInternal_CShell_CExperience_CITestExperienceManager": ["cc0fb627-2cf4-4040-a314-335ca155b411"],
    "x_Windows_CInternal_CShell_CExperience_CITrayBatteryFlyoutExperienceManager": [
        "0a73aedc-1c68-410d-8d53-63af80951e8f"
    ],
    "x_Windows_CInternal_CShell_CExperience_CITrayClockFlyoutExperienceManager": [
        "b1604325-6b59-427b-bf1b-80a2db02d3d8"
    ],
    "x_Windows_CInternal_CShell_CExperience_CITrayFlyoutExperienceManager": ["5e070648-c39d-40fd-8519-295d9d707d5a"],
    "x_Windows_CInternal_CShell_CExperience_CITrayMtcUvcFlyoutExperienceManager": [
        "7154c95d-c519-49bd-a97e-645bbfabe111"
    ],
    "x_Windows_CInternal_CShell_CExperience_CIVirtualTouchpadExperienceManager": [
        "17c4ec91-62df-486d-aa0d-6a11c725e414"
    ],
    "x_Windows_CInternal_CShell_CExperience_CIWelcomeScreenExperienceManager": ["c102fc7c-3a03-49be-be1f-52d75486011c"],
    "x_Windows_CInternal_CShell_CHolographic_CIActivateViewHandler": ["171e84dd-5b19-41ee-8cec-a45ace383b29"],
    "x_Windows_CInternal_CShell_CHolographic_CIControlChangeHandler": ["f15d50d2-fa11-4fed-ace8-7f91f372887f"],
    "x_Windows_CInternal_CShell_CHolographic_CICortanaExperiencePositionerForwarder": [
        "3b54c267-ca15-4ec5-9d76-8ff7b6252309"
    ],
    "x_Windows_CInternal_CShell_CHolographic_CIHolographicCoordinator": ["7dbcfdc3-8bbd-46b4-af9a-eca0b65af9a1"],
    "x_Windows_CInternal_CShell_CHolographic_CIHolographicForegroundAssistant": [
        "0249c870-f630-4a75-8d01-b316c814157a"
    ],
    "x_Windows_CInternal_CShell_CHolographic_CIHolographicViewHostItemHistory": [
        "321d1a85-14d5-4a15-bfec-edf12b00f03f"
    ],
    "x_Windows_CInternal_CShell_CHolographic_CIHolographicViewHostItemSource": ["334a8e75-f9cf-4161-9035-68246f9ea21d"],
    "x_Windows_CInternal_CShell_CHolographic_CIViewHostItemEventArgs": ["fd9e009a-061f-45df-a623-54eb80d770a5"],
    "x_Windows_CInternal_CShell_CHolographic_CIViewHostItemPropertyChangedArgs": [
        "9e9bf7a6-7bfc-48e0-87e5-259b27939cd4"
    ],
    "x_Windows_CInternal_CShell_CIActivationPolicy": ["30b590d9-f894-4572-a394-99378a14d7d8"],
    "x_Windows_CInternal_CShell_CIInputDialMenuBroker": ["c0cc0db0-9fb8-4095-88e2-faa91590f02d"],
    "x_Windows_CInternal_CShell_CIRadialControllerMenuItemInvokedArgs": ["314d5a50-0725-4192-b2d0-7ab185c40092"],
    "x_Windows_CInternal_CShell_CJumpView_CIContextMenuItemWrapper": ["d1273efa-b70c-4397-94a6-882233dcbb2f"],
    "x_Windows_CInternal_CShell_CJumpView_CIJumpListBrokered": ["dbcb3ef5-c950-4e55-8c56-108bf02e7b72"],
    "x_Windows_CInternal_CShell_CJumpView_CIJumpListBrokeredStatics": ["4a35d108-6b22-4d9f-be4f-66f682062751"],
    "x_Windows_CInternal_CShell_CJumpView_CIJumpViewBrokerStatics": ["4a8a1adf-fea8-481d-88d1-aee47d8d6a05"],
    "x_Windows_CInternal_CShell_CJumpView_CIJumpViewCategoryInfo": ["6c52ee51-55f0-4c40-825d-ccde152ad439"],
    "x_Windows_CInternal_CShell_CJumpView_CIJumpViewExperienceWrapper": ["d56f48b2-459c-4c8a-a548-206b37dae17b"],
    "x_Windows_CInternal_CShell_CJumpView_CIJumpViewItemInfo": ["2d0ad4f6-4048-4da8-b86a-59c079758a10"],
    "x_Windows_CInternal_CShell_CJumpView_CIJumpViewParams": ["3f799ae7-6b98-4382-8cff-efce332ffbfc"],
    "x_Windows_CInternal_CShell_CLockScreenViewUX_CIAboveLockView": ["1e3d4646-9fc1-43dc-adc0-236f7746d550"],
    "x_Windows_CInternal_CShell_CModalExperience_CIModalExperienceDefaultOptions": [
        "074e185b-ef4b-4231-9a8e-eb1bb4ef2099"
    ],
    "x_Windows_CInternal_CShell_CModalExperience_CIModalExperienceEventArgs": ["64ea1e5c-e838-43eb-bdde-09bc5aee78c0"],
    "x_Windows_CInternal_CShell_CModalExperience_CIModalExperienceManagerStatic": [
        "9bee8350-74a1-45c1-a90b-f263581b945b"
    ],
    "x_Windows_CInternal_CShell_CModalExperience_CIModalWindowExperienceManager": [
        "faacf24c-7de0-4ea3-9d2a-0dcc7475e219"
    ],
    "x_Windows_CInternal_CShell_CModalExperience_CIModalWindowExperienceManagerAsUser": [
        "50c6090b-023e-4fde-b226-57c3e26d2881"
    ],
    "x_Windows_CInternal_CShell_CPopups_CIPopupClient": ["56f0dd5a-a0d5-433a-8575-5baddbe704c3"],
    "x_Windows_CInternal_CShell_CPopups_CIPopupClientBroker": ["4637e79c-de03-4aef-8a87-e796659e5e8d"],
    "x_Windows_CInternal_CShell_CPopups_CIPopupClientBrokerProvider": ["5627cb1e-76a9-4621-a276-b68fb43d4d25"],
    "x_Windows_CInternal_CShell_CPopups_CIPopupClientPropertyChangedEventArgs": [
        "d51e18a2-1df9-4307-804b-da3f01ce9b82"
    ],
    "x_Windows_CInternal_CShell_CPopups_CIPopupClientStatics": ["b2571928-3f1d-4f6d-8930-fd9f7d5a69fc"],
    "x_Windows_CInternal_CShell_CPopups_CIPopupPropertyChangedEventHandler": ["39651043-0a27-44fb-aa1f-c9b50d082ca0"],
    "x_Windows_CInternal_CShell_CSharePicker_CISharePickerBrokerStatics": ["259cc30a-4d7d-4a07-b2d2-b62b6f186d81"],
    "x_Windows_CInternal_CShell_CSharePicker_CIShareTarget": ["fe7dd868-458e-4334-aba9-02d4339aa7e2"],
    "x_Windows_CInternal_CShell_CShare_CIPeopleShareLaunchActivatedEventArgs": ["92ab3caa-b6f2-48be-aa64-4af79309f541"],
    "x_Windows_CInternal_CShell_CShare_CIShareExperienceCallbacks": ["bd8defd0-d961-4f83-8e79-a0f50c52c63c"],
    "x_Windows_CInternal_CShell_CStartUI_CIStartPlacesLauncherStatics": ["8dad2fb1-aed0-4873-80d7-db4eafed3187"],
    "x_Windows_CInternal_CShell_CStartUI_CITileDragAndDropHelperStatics": ["6337f02d-c2bc-4b0b-b6ae-a0b017200566"],
    "x_Windows_CInternal_CShell_CStartUI_CITileImageHelperStatics": ["2363a8f9-4138-4c23-a8a4-83fbeecaddc6"],
    "x_Windows_CInternal_CShell_CStartUI_CIUserTileCommand": ["65d0daac-bc3d-45ab-8628-d3f30415135c"],
    "x_Windows_CInternal_CShell_CStartUI_CIUserTileMenuStatics": ["1727f7b0-3bd5-4256-8e75-680f9f6cadb4"],
    "x_Windows_CInternal_CShell_CStartUI_CIUserTileSwitchUser": ["94432454-c6ac-40c0-ba40-d5c31a0c5136"],
    "x_Windows_CInternal_CShell_CTaskFlow_CDataEngine_CIAppActivitySessionData": [
        "371bbd4d-b9f3-41d4-8a71-c391961ee20a"
    ],
    "x_Windows_CInternal_CShell_CTaskFlow_CDataEngine_CIAppActivitySessionDataFactory": [
        "7e3d1ebb-c998-42d6-a125-825703f54a9d"
    ],
    "x_Windows_CInternal_CShell_CTaskFlow_CDataEngine_CIAppActivitySessionListener": [
        "631128e4-0022-449e-accc-ddb2a2cc046b"
    ],
    "x_Windows_CInternal_CShell_CTaskFlow_CDataEngine_CIAppActivitySessionListenerFactory": [
        "123c8cac-27d7-4c83-989e-787cc26b90a3"
    ],
    "x_Windows_CInternal_CShell_CTaskFlow_CDataEngine_CIAppViewActivitySessions": [
        "940d35c7-e366-4eb4-b726-a07549fe66b8"
    ],
    "x_Windows_CInternal_CShell_CTaskFlow_CDataEngine_CIAppViewActivitySessionsFactory": [
        "021548c5-1f6c-43d5-887b-c12486584365"
    ],
    "x_Windows_CInternal_CShell_CTaskFlow_CDataEngine_CIAppViewExecutionData": ["ddad6261-6d99-4684-8807-53542c7cd3d8"],
    "x_Windows_CInternal_CShell_CTaskFlow_CDataEngine_CIAppViewExecutionDataFactory": [
        "ab30c2db-5be8-48b5-9597-6d336980b92c"
    ],
    "x_Windows_CInternal_CShell_CTaskFlow_CDataEngine_CIAppViewListener": ["67aa6de9-e367-4622-ad00-f436b1980e17"],
    "x_Windows_CInternal_CShell_CTaskFlow_CDataEngine_CIAppViewListenerFactory": [
        "8b78226f-0431-4f5d-9ae1-5040c0215993"
    ],
    "x_Windows_CInternal_CShell_CTaskFlow_CDataEngine_CIAppViewTitleChangeData": [
        "95b486aa-abbf-499a-9362-85def1a328a3"
    ],
    "x_Windows_CInternal_CShell_CTaskFlow_CDataEngine_CIAppViewTitleChangeDataFactory": [
        "de89c263-9646-40ff-ad55-8d44c17c0f67"
    ],
    "x_Windows_CInternal_CShell_CTaskFlow_CDataEngine_CIAppViewTitleChangeListener": [
        "3886cfac-d6c4-4af1-8b2c-00885f428e86"
    ],
    "x_Windows_CInternal_CShell_CTaskFlow_CDataEngine_CIAppViewTitleChangeListenerFactory": [
        "647a61b2-1338-468e-a372-32e0271185c2"
    ],
    "x_Windows_CInternal_CShell_CTaskFlow_CDataEngine_CIFileActivityData": ["a4322b3c-9c8d-40d8-8015-375589e260db"],
    "x_Windows_CInternal_CShell_CTaskFlow_CDataEngine_CIFileActivityDataFactory": [
        "1dfa50c1-ebb2-43db-acc4-3d892f62f2a9"
    ],
    "x_Windows_CInternal_CShell_CTaskFlow_CDataEngine_CIFileActivityListenerFactory": [
        "df82ca6c-f3b0-4584-8158-8e072e4417e7"
    ],
    "x_Windows_CInternal_CShell_CTaskFlow_CDataEngine_CISubViewData": ["f421430f-b89a-4899-b36c-ae361a113904"],
    "x_Windows_CInternal_CShell_CTaskFlow_CDataEngine_CISubViewDataFactory": ["33c823f4-f4cf-41ab-a933-ca4364b67cb9"],
    "x_Windows_CInternal_CShell_CTaskFlow_CDataEngine_CISubViewListener": ["77b98b15-2d56-40b4-a7fa-8c5d2b7d768b"],
    "x_Windows_CInternal_CShell_CTaskFlow_CDataEngine_CISubViewListenerFactory": [
        "8c0b3c46-f3b4-4394-b8be-4b91c945b5eb"
    ],
    "x_Windows_CInternal_CShell_CTaskFlow_CDataEngine_CITaskDataArbiter": ["a1c0a58e-7a56-4f4b-b2c4-44749529b399"],
    "x_Windows_CInternal_CShell_CTaskFlow_CDataEngine_CITaskDataBroker": ["8ad89301-af07-45e5-b583-ab8d42032339"],
    "x_Windows_CInternal_CShell_CTaskFlow_CDataEngine_CITaskDataListener": ["e9821dd9-a9b2-47c8-9aac-7b6b042ef0b0"],
    "x_Windows_CInternal_CShell_CTaskFlow_CDataEngine_CIUserPresenceData": ["17d0d62d-889f-49c0-b398-7fb61baf0953"],
    "x_Windows_CInternal_CShell_CTaskFlow_CDataEngine_CIUserPresenceDataFactory": [
        "14ac9b14-6870-4c6f-adc1-ca2e8036a49c"
    ],
    "x_Windows_CInternal_CShell_CTaskFlow_CDataEngine_CIUserPresenceListenerFactory": [
        "42c5bb25-1f0e-43c4-b5bf-3c94be37cd85"
    ],
    "x_Windows_CInternal_CShell_CViewManagerInterop_CIApplicationPreferredLaunchViewSizeChangedArgs": [
        "f598bfc8-f459-431a-93aa-470efd1e151d"
    ],
    "x_Windows_CInternal_CShell_CViewManagerInterop_CIApplicationPreferredLaunchWindowingModeChangedArgs": [
        "d3bccb71-bfb7-4d45-8e98-63e53eb64464"
    ],
    "x_Windows_CInternal_CShell_CViewManagerInterop_CIBasicViewManagement": ["e662e2f1-294a-4b7e-b5e9-59aef81c012e"],
    "x_Windows_CInternal_CShell_CViewManagerInterop_CIBasicViewWrapper": ["e092dc92-c492-4665-bdf3-d9842e1c012e"],
    "x_Windows_CInternal_CShell_CViewManagerInterop_CIClientWindowPrepareForPresentationChangedEventArgs": [
        "fe572bd5-f747-4a28-a7c8-6b84cb43deb4"
    ],
    "x_Windows_CInternal_CShell_CViewManagerInterop_CIClientWindowReadyForPresentationChangedEventArgs": [
        "593ed2db-a1ee-4997-b822-f3fb111c012e"
    ],
    "x_Windows_CInternal_CShell_CViewManagerInterop_CIClientWindowState": ["7357c375-0d63-4d6c-a22a-d2d4fc1c012e"],
    "x_Windows_CInternal_CShell_CViewManagerInterop_CIForegroundManager": ["978b2543-9cbd-4fcd-95a0-b8faa61c012e"],
    "x_Windows_CInternal_CShell_CViewManagerInterop_CIForegroundViewChangedEventArgs": [
        "56dd4b13-d62a-4583-bdd1-3e829a1c012e"
    ],
    "x_Windows_CInternal_CShell_CViewManagerInterop_CINavigateToViewArgs": ["332ae7bb-4fd5-415e-9d03-169f39a72ba7"],
    "x_Windows_CInternal_CShell_CViewManagerInterop_CINavigationFailedArgs": ["323969b3-f6c5-4ce8-ae53-27a29f8378b5"],
    "x_Windows_CInternal_CShell_CViewManagerInterop_CISelectViewToActivateForHitTestEventArgs": [
        "7a4b95d9-207b-4e52-9c05-d7c8de1c012e"
    ],
    "x_Windows_CInternal_CShell_CViewManagerInterop_CIUserLogoffCompleteEventArgs": [
        "cde8db35-efeb-4def-946e-fc9965264299"
    ],
    "x_Windows_CInternal_CShell_CViewManagerInterop_CIViewEventArgs": ["96c11dea-68de-44ef-a7f7-3aa869663d57"],
    "x_Windows_CInternal_CShell_CViewManagerInterop_CIViewEventArgsForNavigationRequest": [
        "a8d2a90c-a403-4593-95ff-012516ae9351"
    ],
    "x_Windows_CInternal_CShell_CViewManagerInterop_CIViewEventArgsForSelectTargetView": [
        "741390c6-ef1e-43ce-bfc2-6cfb131c012e"
    ],
    "x_Windows_CInternal_CShell_CViewManagerInterop_CIViewEventArgsForShowAsStandalone": [
        "ff24ec4d-0f9a-48f8-8083-39f5065b6a49"
    ],
    "x_Windows_CInternal_CShell_CViewManagerInterop_CIViewEventArgsForShowAsViewMode": [
        "ffc41fc2-6037-4426-8bfb-7716e14343f7"
    ],
    "x_Windows_CInternal_CShell_CViewManagerInterop_CIViewEventArgsForSwitch": ["8a11574c-5d5f-48d7-bd8c-d7a801fca248"],
    "x_Windows_CInternal_CShell_CViewManagerInterop_CIViewEventDispatcher": ["f5ef6433-2dc3-4aeb-b387-7c6cba1c012e"],
    "x_Windows_CInternal_CShell_CViewManagerInterop_CIViewEventDispatcherConfiguration": [
        "a93305f8-195b-4272-92db-4793ca1c012e"
    ],
    "x_Windows_CInternal_CShell_CViewManagerInterop_CIViewEventDispatcherCrashRecovery": [
        "73d6c545-9771-4aba-bb8c-713133ed635a"
    ],
    "x_Windows_CInternal_CShell_CViewManagerInterop_CIViewEventDispatcherReadyChangedEventArgs": [
        "55bf2c4d-7d53-45bf-b624-f136ee69adfb"
    ],
    "x_Windows_CInternal_CShell_CViewManagerInterop_CIViewForegroundStateChangedEventArgs": [
        "e20aafe2-b26a-492c-815c-f0220f1c012e"
    ],
    "x_Windows_CInternal_CShell_CViewManagerInterop_CIViewHandledEventArgs": ["a3b199dc-8a9d-4cf2-9219-5cff951c012e"],
    "x_Windows_CInternal_CShell_CViewManagerInterop_CIViewPropertyChangedArgs": [
        "360030af-7930-47a7-a1dd-184464be39de"
    ],
    "x_Windows_CInternal_CShell_CViewManagerInterop_CIViewRecoveryState": ["71a3f425-a716-4859-b1a4-1d9044e6a055"],
    "x_Windows_CInternal_CShell_CViewManagerInterop_CIViewResourcePolicies": ["a4946191-41b4-45aa-bc6a-ad2f4351596c"],
    "x_Windows_CInternal_CShell_CViewManagerInterop_CIViewWrapper": ["8ab3bd56-9b4a-45da-b2fc-9b9d331c012e"],
    "x_Windows_CInternal_CShell_CViewManagerInterop_CIViewWrapperSplashScreenSupport": [
        "2ce345bd-11db-4b6f-a348-a64e187a0e67"
    ],
    "x_Windows_CInternal_CStateRepository_CIAppExecutionAlias": ["dd8ef209-729e-4106-bccf-e51c65d17c02"],
    "x_Windows_CInternal_CStateRepository_CIAppExecutionAliasStatics": ["fc2b79e5-f76a-41ed-be1a-3b69adff2664"],
    "x_Windows_CInternal_CStateRepository_CIAppExtension": ["a1266eb4-3ea3-4295-bc22-e19961c7957e"],
    "x_Windows_CInternal_CStateRepository_CIAppExtensionHost": ["1d5fb1ee-9b55-4b11-b0b7-9162d1f75d41"],
    "x_Windows_CInternal_CStateRepository_CIAppExtensionHostStatics": ["9ea6951a-3208-4673-9a7c-e67263828ee6"],
    "x_Windows_CInternal_CStateRepository_CIAppExtensionStatics": ["91707564-ce06-44fb-b6bf-d54bb86759a8"],
    "x_Windows_CInternal_CStateRepository_CIAppService": ["ae655c6c-b973-45eb-aa3e-8b6467ff272f"],
    "x_Windows_CInternal_CStateRepository_CIAppServiceStatics": ["ea289835-41db-4cf5-8871-fc7b1eaa477c"],
    "x_Windows_CInternal_CStateRepository_CIAppUriHandler": ["6c49acc8-ff43-497f-afd8-42c00346b6ac"],
    "x_Windows_CInternal_CStateRepository_CIAppUriHandlerLauncherInfo": ["d814470d-0c54-4f90-9853-f51845a90be2"],
    "x_Windows_CInternal_CStateRepository_CIAppUriHandlerStatics": ["00d7de5d-b362-45b7-83dd-e51c0f1becfb"],
    "x_Windows_CInternal_CStateRepository_CIApplication": ["fb0fa6fa-0c68-4f21-996a-5dda63b62907"],
    "x_Windows_CInternal_CStateRepository_CIApplicationBackgroundTask": ["3ff4ffb5-a734-4ee0-b8dc-b29d313ea111"],
    "x_Windows_CInternal_CStateRepository_CIApplicationBackgroundTaskStatics": ["92db0912-63ca-485c-b2a3-9e51a35c7127"],
    "x_Windows_CInternal_CStateRepository_CIApplicationContentUriRule": ["6e4bf1ca-dc5a-4156-bead-7d2485f3c77d"],
    "x_Windows_CInternal_CStateRepository_CIApplicationContentUriRuleStatics": ["ff8e9edc-c570-44ef-a8d9-8f23b812d6a3"],
    "x_Windows_CInternal_CStateRepository_CIApplicationExtension": ["360482cc-2685-49c0-807e-d6530ddc39ef"],
    "x_Windows_CInternal_CStateRepository_CIApplicationExtensionStatics": ["af9817b4-2d09-4467-9b31-4899b2aea6e0"],
    "x_Windows_CInternal_CStateRepository_CIApplicationLicense": ["f4a997fa-ea71-417f-b399-176869f08f86"],
    "x_Windows_CInternal_CStateRepository_CIApplicationLicenseStatics": ["750dfaea-9dd3-4284-9a23-401778fcd524"],
    "x_Windows_CInternal_CStateRepository_CIApplicationPolicy": ["e4dc2404-9035-4794-ba58-113415ea9ba8"],
    "x_Windows_CInternal_CStateRepository_CIApplicationPolicyStatics": ["f0e216de-fb72-42f9-94df-c4c9cdb8b28c"],
    "x_Windows_CInternal_CStateRepository_CIApplicationProperty": ["98945040-9374-4e98-a1ce-0ad51d7a1db7"],
    "x_Windows_CInternal_CStateRepository_CIApplicationPropertyStatics": ["7fe36c7d-c0d2-4ed2-970c-95f671367f20"],
    "x_Windows_CInternal_CStateRepository_CIApplicationResourceResolver": ["47afda03-0a2a-4c2f-9321-5fd5b487d897"],
    "x_Windows_CInternal_CStateRepository_CIApplicationResourceResolverStatics": [
        "84463b2a-c88e-4597-b41f-17d3bf6486e9"
    ],
    "x_Windows_CInternal_CStateRepository_CIApplicationStatics": ["a2e68a2e-20c7-49f4-ba27-268b020ad4f8"],
    "x_Windows_CInternal_CStateRepository_CIAppxExtension": ["ddce4f61-6426-4143-927c-e95afc2b17c5"],
    "x_Windows_CInternal_CStateRepository_CIAppxExtensionStatics": ["12ec6ae1-d289-452d-9802-2306cc0e0f6d"],
    "x_Windows_CInternal_CStateRepository_CIAppxManifest": ["79ba6b5e-4ab0-48a0-b576-91153efd3388"],
    "x_Windows_CInternal_CStateRepository_CIAppxManifestStatics": ["5fc148b1-ad6b-4d3d-b11d-e881979c15f4"],
    "x_Windows_CInternal_CStateRepository_CIBackgroundServiceAgent": ["74b75ef6-8ae3-4e8c-98a8-8f9af39e93e2"],
    "x_Windows_CInternal_CStateRepository_CIBackgroundServiceAgentStatics": ["8903ddb8-8d91-4f36-807f-2c0977a2892d"],
    "x_Windows_CInternal_CStateRepository_CIBnsNotification": ["73b99527-13c1-4c24-9048-896456e138e2"],
    "x_Windows_CInternal_CStateRepository_CIBnsNotificationStatics": ["b5fbcaf7-cf20-46b9-8dc2-d080d76fac4d"],
    "x_Windows_CInternal_CStateRepository_CIBundle": ["428085db-2f00-41b3-bcb4-51e94cc69f09"],
    "x_Windows_CInternal_CStateRepository_CIBundlePackage": ["d68d86f0-6a9d-4867-9e0d-9e6bdb3c0e35"],
    "x_Windows_CInternal_CStateRepository_CIBundlePackageStatics": ["a33626e5-ac02-4301-9d73-b704399469ad"],
    "x_Windows_CInternal_CStateRepository_CIBundleResource": ["9415fc42-6646-49f8-afaa-69b41dc0dc71"],
    "x_Windows_CInternal_CStateRepository_CIBundleResourceStatics": ["2ce50bec-9ca5-4a53-9973-464ad50c134f"],
    "x_Windows_CInternal_CStateRepository_CIBundleStatics": ["e923820d-aebc-498f-b3ff-9eecd3ff19fc"],
    "x_Windows_CInternal_CStateRepository_CIContentGroup": ["6ed784dd-13c1-49ec-b7a0-b5897a8c980e"],
    "x_Windows_CInternal_CStateRepository_CIContentGroupFile": ["787a9c74-038d-4c62-b726-3e989e206463"],
    "x_Windows_CInternal_CStateRepository_CIContentGroupFileStatics": ["e4fef838-30df-47bc-813a-8eb21784830d"],
    "x_Windows_CInternal_CStateRepository_CIContentGroupStatics": ["33d2b25f-fb4f-48ef-8ac0-28662caf0577"],
    "x_Windows_CInternal_CStateRepository_CIDefaultTile": ["19886422-a021-4187-9e4d-961c80c12226"],
    "x_Windows_CInternal_CStateRepository_CIDefaultTileStatics": ["e4e8b1a3-4837-4ef9-9cb6-97368eb7f809"],
    "x_Windows_CInternal_CStateRepository_CIDependency": ["a7012a80-0542-4c8f-8229-003f6be71349"],
    "x_Windows_CInternal_CStateRepository_CIDependencyGraph": ["79f51b1c-f79f-4c22-8bc2-a5b3875f4a63"],
    "x_Windows_CInternal_CStateRepository_CIDependencyGraphStatics": ["489844ee-561f-4977-a656-8c83695eb966"],
    "x_Windows_CInternal_CStateRepository_CIDependencyStatics": ["80b50b64-0df1-4a97-9390-9fc814b2481e"],
    "x_Windows_CInternal_CStateRepository_CIDeploymentHistory": ["6f7b42f6-f729-438f-8e90-d43a282431d4"],
    "x_Windows_CInternal_CStateRepository_CIDeploymentHistoryStatics": ["9125d22c-1935-48a3-91f9-de64bf7440fc"],
    "x_Windows_CInternal_CStateRepository_CIDeploymentRequest": ["309906f5-1d51-4bf1-a76c-e82fea753019"],
    "x_Windows_CInternal_CStateRepository_CIDeploymentRequestDependency": ["591a8a1c-a1e8-4ad3-b368-8f33154dd4e7"],
    "x_Windows_CInternal_CStateRepository_CIDeploymentRequestDependencyStatics": [
        "4bc24a6f-a579-4318-9888-98810b5ee9b7"
    ],
    "x_Windows_CInternal_CStateRepository_CIDeploymentRequestStatics": ["f51013ad-c710-4ff7-9b0c-8754cebc2b5b"],
    "x_Windows_CInternal_CStateRepository_CIEnterprise": ["49c52322-b817-4fae-9701-2a40848573d5"],
    "x_Windows_CInternal_CStateRepository_CIEnterpriseStatics": ["2a7443bf-6ad0-475d-a31f-c59df67ab9c4"],
    "x_Windows_CInternal_CStateRepository_CIFile": ["c0b0c148-b29a-467b-92cc-118099a378f3"],
    "x_Windows_CInternal_CStateRepository_CIFileStatics": ["e7f99b73-6464-4b86-a4bc-9ed3651b94db"],
    "x_Windows_CInternal_CStateRepository_CIFileTypeAssociation": ["4cc8fe6a-5976-4ece-ac32-62e2a5497f46"],
    "x_Windows_CInternal_CStateRepository_CIFileTypeAssociationLauncherInfo": ["8f8bf3e3-b9be-4969-9eb5-e49b5a12d2ec"],
    "x_Windows_CInternal_CStateRepository_CIFileTypeAssociationStatics": ["8645456f-d9a2-4b82-afec-58f0e8df0acf"],
    "x_Windows_CInternal_CStateRepository_CIMigratorPatch": ["b2ebd76a-5c0a-4d5e-979e-13b82da8911e"],
    "x_Windows_CInternal_CStateRepository_CIMigratorPatchStatics": ["4b9574b1-b903-4161-ac0c-cb0d0d4b312d"],
    "x_Windows_CInternal_CStateRepository_CIMrtApplication": ["8afe010a-b611-484e-944d-5ea6e4a23569"],
    "x_Windows_CInternal_CStateRepository_CIMrtApplicationStatics": ["f7e80409-27e5-4514-805f-a431c4ce3b96"],
    "x_Windows_CInternal_CStateRepository_CIMrtDefaultTile": ["11bcfe6e-7e02-4a89-8384-01bee5954b14"],
    "x_Windows_CInternal_CStateRepository_CIMrtDefaultTileStatics": ["eb2a98bd-c501-47d0-8df8-38afec395f1f"],
    "x_Windows_CInternal_CStateRepository_CIMrtPackage": ["e15958e5-d7fd-435b-a075-0b959b6788d5"],
    "x_Windows_CInternal_CStateRepository_CIMrtPackageStatics": ["ede4711a-0c90-4d5b-acf3-58af696d9425"],
    "x_Windows_CInternal_CStateRepository_CIMrtSharedPri": ["ced591f2-cf14-4b3e-b4da-6ece807905b2"],
    "x_Windows_CInternal_CStateRepository_CIMrtSharedPriStatics": ["223e9a8a-0b52-46c7-b8b8-34cda968f318"],
    "x_Windows_CInternal_CStateRepository_CIMrtUserPri": ["5159af2d-7f48-4383-9625-38a284ea6983"],
    "x_Windows_CInternal_CStateRepository_CIMrtUserPriStatics": ["92d3e03a-c2a6-4074-8a36-7e44c09262bf"],
    "x_Windows_CInternal_CStateRepository_CIOptionalBundle": ["f94dd24f-2002-43a9-b2a8-c2d0520cecf4"],
    "x_Windows_CInternal_CStateRepository_CIOptionalBundlePackage": ["0a116b25-b2bf-41c3-9565-3fc99f5e3a11"],
    "x_Windows_CInternal_CStateRepository_CIOptionalBundlePackageStatics": ["3fb1d9ea-62de-46ef-9035-af8851ac5e05"],
    "x_Windows_CInternal_CStateRepository_CIOptionalBundleResource": ["5a7f6daa-d960-4bb6-b95e-912ffe8d7ec4"],
    "x_Windows_CInternal_CStateRepository_CIOptionalBundleResourceStatics": ["2a7287ee-0bc5-4bcb-9528-87a2c73bb46a"],
    "x_Windows_CInternal_CStateRepository_CIOptionalBundleStatics": ["8a7191bb-a153-40c0-b325-da50324eee0d"],
    "x_Windows_CInternal_CStateRepository_CIPackage": ["350844bd-012b-4fc0-9278-3f75cbe61297"],
    "x_Windows_CInternal_CStateRepository_CIPackageExtension": ["f126f3cb-df3e-407e-8007-8b374c5a8f41"],
    "x_Windows_CInternal_CStateRepository_CIPackageExtensionStatics": ["d266abd9-46c7-426d-a49a-442c979a7020"],
    "x_Windows_CInternal_CStateRepository_CIPackageFamily": ["5d4d5c0f-bed2-4016-a917-320bdd0ee602"],
    "x_Windows_CInternal_CStateRepository_CIPackageFamilyPolicy": ["da46ca2b-6126-4aae-a5f7-672a94ca776c"],
    "x_Windows_CInternal_CStateRepository_CIPackageFamilyPolicyStatics": ["01e6e15a-7659-4e66-8f82-223e1831afc8"],
    "x_Windows_CInternal_CStateRepository_CIPackageFamilyStatics": ["86f5b0ee-9560-4d76-a06a-ca4c8bfe4426"],
    "x_Windows_CInternal_CStateRepository_CIPackageFamilyUser": ["ababc380-d1ae-4da3-9385-bea8f704aa5b"],
    "x_Windows_CInternal_CStateRepository_CIPackageFamilyUserStatics": ["8f71b0c5-78ec-439d-ad13-9053a6e2aba0"],
    "x_Windows_CInternal_CStateRepository_CIPackageIdentity": ["eb4c1bec-2247-4c57-8bd4-00e30e79cd53"],
    "x_Windows_CInternal_CStateRepository_CIPackageIdentityStatics": ["84485035-7d09-4684-8440-e8eb94f59919"],
    "x_Windows_CInternal_CStateRepository_CIPackageLocation": ["a39a796c-2c0e-4530-bf70-d633ee369785"],
    "x_Windows_CInternal_CStateRepository_CIPackageLocationStatics": ["dd4cd077-46ac-4e8f-9afb-f0055ae35b32"],
    "x_Windows_CInternal_CStateRepository_CIPackageMachineStatus": ["4f9d1b31-aef1-4e62-a730-04f96013dca6"],
    "x_Windows_CInternal_CStateRepository_CIPackageMachineStatusStatics": ["f2393a3d-9768-4781-b328-addff6396b2e"],
    "x_Windows_CInternal_CStateRepository_CIPackagePolicy": ["7619d03f-b9b1-446c-aeb9-f126825fd333"],
    "x_Windows_CInternal_CStateRepository_CIPackagePolicyStatics": ["f7a88ec3-6f33-46bf-83b8-78aaf94ac396"],
    "x_Windows_CInternal_CStateRepository_CIPackageProperty": ["bac7aafa-fbb8-4b69-b8cf-7c987fd8dc1a"],
    "x_Windows_CInternal_CStateRepository_CIPackagePropertyStatics": ["cb50698c-dfd0-4c85-ba99-7e2045875ce9"],
    "x_Windows_CInternal_CStateRepository_CIPackageResourceResolver": ["5f23e0db-307f-47c2-b201-f75be694da0d"],
    "x_Windows_CInternal_CStateRepository_CIPackageResourceResolverStatics": ["cb4720b3-052a-4478-b348-29a7cf0d828e"],
    "x_Windows_CInternal_CStateRepository_CIPackageSourceUri": ["b3b62566-ec3c-4f37-93ed-1089e768cc3a"],
    "x_Windows_CInternal_CStateRepository_CIPackageSourceUriStatics": ["d9f9bd2c-32f3-497f-9e3c-e178f7f859be"],
    "x_Windows_CInternal_CStateRepository_CIPackageStatics": ["a14c8099-29fd-4730-9c5f-7cd2abac36f1"],
    "x_Windows_CInternal_CStateRepository_CIPackageUser": ["32227928-3a92-4d68-86c5-9c0c727c205e"],
    "x_Windows_CInternal_CStateRepository_CIPackageUserStatics": ["4594fad2-aa09-4ed9-b9eb-bd38949814e4"],
    "x_Windows_CInternal_CStateRepository_CIPackageUserStatus": ["885339d0-6346-4dfc-a21e-74b6ac42aa03"],
    "x_Windows_CInternal_CStateRepository_CIPackageUserStatusStatics": ["3501b642-b61e-457f-8ff0-b6b8aa1c7ba5"],
    "x_Windows_CInternal_CStateRepository_CIPrimaryTile": ["8d205971-b109-44a5-b0b9-1d350decb99b"],
    "x_Windows_CInternal_CStateRepository_CIPrimaryTileStatics": ["dffffac5-1308-4628-ab09-f40141656472"],
    "x_Windows_CInternal_CStateRepository_CIPrimaryTileUser": ["f584872a-dfff-4e66-8937-7fec49c10f79"],
    "x_Windows_CInternal_CStateRepository_CIPrimaryTileUserChangelog": ["5027de1d-77b4-43b7-991c-f6ef19907cd9"],
    "x_Windows_CInternal_CStateRepository_CIPrimaryTileUserChangelogStatics": ["9f3ec961-0877-4541-928a-0f4cbf478bf1"],
    "x_Windows_CInternal_CStateRepository_CIPrimaryTileUserDataChange": ["16462b61-3298-441c-af1b-1c0995748cf7"],
    "x_Windows_CInternal_CStateRepository_CIPrimaryTileUserDataChangeStatics": ["55ec7551-7388-44da-a7c8-7be03b4f081e"],
    "x_Windows_CInternal_CStateRepository_CIPrimaryTileUserNotificationChannel": [
        "366a9874-5ea2-436a-828f-0145bd6cf463"
    ],
    "x_Windows_CInternal_CStateRepository_CIPrimaryTileUserNotificationChannelStatics": [
        "b17fc34b-d906-4cd1-ad70-c16d125d1686"
    ],
    "x_Windows_CInternal_CStateRepository_CIPrimaryTileUserStatics": ["76b8f79f-34a1-4d59-bfaa-1472aba872e5"],
    "x_Windows_CInternal_CStateRepository_CIPrimaryTileView": ["8ae37a84-1205-443a-a444-8228ae42e38c"],
    "x_Windows_CInternal_CStateRepository_CIPrimaryTileViewStatics": ["82122bea-b05d-4ca4-9607-7c215e0435f5"],
    "x_Windows_CInternal_CStateRepository_CIProtocol": ["fdd7e51e-d1cc-41d9-ae36-a5fac6fe5216"],
    "x_Windows_CInternal_CStateRepository_CIProtocolLauncherInfo": ["219c82b0-40f6-4f7e-a532-4373bb075ed7"],
    "x_Windows_CInternal_CStateRepository_CIProtocolStatics": ["0f2f217e-7957-4262-a74c-df03d9e9e9c1"],
    "x_Windows_CInternal_CStateRepository_CIPublisherCacheFolder": ["4cace330-0a8f-49ef-9e85-39cd667de608"],
    "x_Windows_CInternal_CStateRepository_CIPublisherCacheFolderStatics": ["f8f4dd1b-371f-48d3-b2be-c71c9c34b202"],
    "x_Windows_CInternal_CStateRepository_CIResource": ["9a7923cc-7aee-431d-b021-80d544a9487b"],
    "x_Windows_CInternal_CStateRepository_CIResourceStatics": ["f70a43a0-7021-41cf-b0fe-ec696f324d6e"],
    "x_Windows_CInternal_CStateRepository_CISecondaryTile": ["74882a66-25ef-4796-86de-983846764004"],
    "x_Windows_CInternal_CStateRepository_CISecondaryTileStatics": ["1d8083db-6790-4c69-8dd7-2a01c1c756f9"],
    "x_Windows_CInternal_CStateRepository_CISecondaryTileUser": ["c3506429-9cf3-4fee-8b32-e0c3eba9dbbf"],
    "x_Windows_CInternal_CStateRepository_CISecondaryTileUserChangelog": ["7a269e7a-d77f-41e6-b9b3-06877dfb2ca2"],
    "x_Windows_CInternal_CStateRepository_CISecondaryTileUserChangelogStatics": [
        "37f1d0c1-cb10-4a32-b15c-3ad3522e0152"
    ],
    "x_Windows_CInternal_CStateRepository_CISecondaryTileUserDataChange": ["577f0ca3-d685-4480-9254-ccce83c68930"],
    "x_Windows_CInternal_CStateRepository_CISecondaryTileUserDataChangeStatics": [
        "1ab8bfa1-0bf3-481f-9faf-58f1acc75e25"
    ],
    "x_Windows_CInternal_CStateRepository_CISecondaryTileUserNotificationChannel": [
        "100e0fe5-f8e6-4211-b7ad-21085e53a12e"
    ],
    "x_Windows_CInternal_CStateRepository_CISecondaryTileUserNotificationChannelStatics": [
        "fe39030f-8455-4bf4-af4a-a34c336e4c13"
    ],
    "x_Windows_CInternal_CStateRepository_CISecondaryTileUserStatics": ["3f593a63-8c13-4aaf-b4c6-840d3dda9e89"],
    "x_Windows_CInternal_CStateRepository_CISecondaryTileView": ["146e58b8-5f0e-4ed9-b78f-d9bba4c19e27"],
    "x_Windows_CInternal_CStateRepository_CISecondaryTileViewStatics": ["d88678cf-e543-4953-b04d-bc5da7b90592"],
    "x_Windows_CInternal_CStateRepository_CISequence": ["a93b6589-990c-482c-a58c-a932260202d8"],
    "x_Windows_CInternal_CStateRepository_CISequenceStatics": ["4235841b-f135-4a3b-889d-a929c3d8be3c"],
    "x_Windows_CInternal_CStateRepository_CITargetDeviceFamily": ["e5dbfeae-3a40-4926-920c-a1ad8882663e"],
    "x_Windows_CInternal_CStateRepository_CITargetDeviceFamilyStatics": ["cb3a2a28-41c0-4687-9ea6-c248191321de"],
    "x_Windows_CInternal_CStateRepository_CITask": ["65acff39-4550-48d2-af38-8846061b0d5a"],
    "x_Windows_CInternal_CStateRepository_CITaskStatics": ["1c377d90-e45e-4983-9722-e2297718797e"],
    "x_Windows_CInternal_CStateRepository_CITileView": ["a1196ae9-cfc4-40f3-9f82-547fd281ea09"],
    "x_Windows_CInternal_CStateRepository_CITileViewQueryFilter": ["04602114-d4b3-488d-b06e-2ff82fd0732b"],
    "x_Windows_CInternal_CStateRepository_CITileViewStatics": ["d239aef3-1f67-43ec-be5e-8fbc2cb72000"],
    "x_Windows_CInternal_CStateRepository_CIUser": ["5ff67899-ea70-4533-8f93-6d7a2937b0a2"],
    "x_Windows_CInternal_CStateRepository_CIUserStatics": ["b07904dd-31f6-452c-a738-fa5a2fda337b"],
    "x_Windows_CInternal_CStateRepository_CIVolume": ["af81563e-995d-495e-b5c9-eaa27eeb8bd5"],
    "x_Windows_CInternal_CStateRepository_CIVolumeStatics": ["2d5d0fda-9a4a-4155-9371-8d360401b26d"],
    "x_Windows_CInternal_CStateRepository_CIWowDependencyGraph": ["90acc473-8dc2-439f-b720-840c55dc1aa2"],
    "x_Windows_CInternal_CStateRepository_CIWowDependencyGraphStatics": ["621c6f4c-36c7-4a6b-98ad-f19269a8bf58"],
    "x_Windows_CInternal_CStateRepository_CIXap": ["0abeee28-3c64-4961-a399-cd3bcfbf2a34"],
    "x_Windows_CInternal_CStateRepository_CIXapExtension": ["e5dc9c69-7c2f-4a44-a2fe-0ad70f9914e4"],
    "x_Windows_CInternal_CStateRepository_CIXapExtensionStatics": ["88d8c30d-8e7b-47f4-ad16-d014c35e1fd1"],
    "x_Windows_CInternal_CStateRepository_CIXapStatics": ["2f2cd542-df5a-4f71-a46d-6d694f32fa97"],
    "x_Windows_CInternal_CStateRepository_CIXboxPackage": ["5c42ad4a-5a45-4ece-8c16-791fa465d1e0"],
    "x_Windows_CInternal_CStateRepository_CIXboxPackageStatics": ["cc4d7eec-098e-4763-95dd-4a6d9c3c08b0"],
    "x_Windows_CInternal_CStateRepository_CManagement_CIRepositoryManager": ["4248db36-4387-45b8-977b-19da657fcb4e"],
    "x_Windows_CInternal_CStateRepository_CTileDataLayer_CIAppInfoStatics": ["18b90d67-6bdc-40f8-bec7-ef13c43cfcb1"],
    "x_Windows_CInternal_CStorage_CICustomStateHandler": ["e7c0dcc8-a66d-415a-9b20-88bb8ef945aa"],
    "x_Windows_CInternal_CStorage_CIDDEExecHelper": ["0e33cf63-b2dc-449d-a8be-2aded57e6589"],
    "x_Windows_CInternal_CStorage_CIFileOperation": ["14a029c3-bd5a-4b51-8001-119dcd9a5d0c"],
    "x_Windows_CInternal_CStorage_CIFileOperationItemErrorInfo": ["b639a0d3-4c38-46d7-9ace-03baf335683b"],
    "x_Windows_CInternal_CStorage_CIFileOperationManager": ["cf559460-af04-4ee3-a8a6-cb7550fa124e"],
    "x_Windows_CInternal_CStorage_CIFileOperationManagerStatics": ["5a1215ab-e82f-4434-8228-dda67acb0e75"],
    "x_Windows_CInternal_CStorage_CIFileOperationStatus": ["369650a4-db76-4f2b-bfd0-ad929e879659"],
    "x_Windows_CInternal_CStorage_CIKnownFoldersFileExplorerStatics": ["b82810d5-7e81-48ac-8073-676b9a4a1017"],
    "x_Windows_CInternal_CStorage_CIKnownFoldersUserModelStaticsPriv": ["4bd0fcbb-ad6f-4796-993b-f3cf27c59444"],
    "x_Windows_CInternal_CStorage_CIRecentItemHelpersStatics": ["7c1b140d-df32-4492-b5e8-0259d018e7d2"],
    "x_Windows_CInternal_CStorage_CIStorageBrokerAccessCheck": ["684a703a-2827-4459-9944-644fb342097b"],
    "x_Windows_CInternal_CStorage_CIStorageFileStartExperienceStatic": ["fcc9183f-a396-877e-b145-d60016c97f46"],
    "x_Windows_CInternal_CStorage_CIStorageItemCommand": ["bd6ed860-fbb4-4863-adf2-52f9fa15c49c"],
    "x_Windows_CInternal_CStorage_CIStorageItemCommandFactoryStatics": ["6621920f-e05c-4e25-a92e-e38954a2701a"],
    "x_Windows_CInternal_CStorage_CIStorageItemFileExplorerPriv": ["b92c48ae-97fd-452a-8de1-2732d7e7102d"],
    "x_Windows_CInternal_CStorage_CIStorageProviderCustomStates": ["d9e10050-8810-4cc2-a3e6-97f068cb0f85"],
    "x_Windows_CInternal_CStorage_CPickers_CIFilePickerConfiguration": ["9e2d0683-3112-40db-bb0f-1a16b1c7a4a3"],
    "x_Windows_CInternal_CStorage_CPickers_CIFilePickerHelpersStatics": ["482b3629-2b52-46df-a676-dcc675685606"],
    "x_Windows_CInternal_CStorage_CPickers_CProvider_CIExplorerExtensions": ["69d6a2b4-f9c0-4826-b534-341ce43f7f96"],
    "x_Windows_CInternal_CStorage_CPickers_CProvider_CIFilePickerActivatedEventArgsPhonePrivate": [
        "5a278751-3138-405e-b1b6-d0c31a24d157"
    ],
    "x_Windows_CInternal_CStorage_CPickers_CProvider_CIFolderPickerUI": ["33bb9b45-9be7-4990-8450-faf9dfc3e555"],
    "x_Windows_CInternal_CStorage_CPickers_CProvider_CIModernFilePicker": ["6a5d39b1-0d8f-41b7-9b16-220673ab3ee9"],
    "x_Windows_CInternal_CStorage_CThumbnailCache_CIThumbnailCache": ["ff41dbc3-30c7-496a-bf1b-3697b1a21f18"],
    "x_Windows_CInternal_CStorage_CThumbnailCache_CIThumbnailResult": ["277f0b63-2e83-43bd-8a09-02098e3da243"],
    "x_Windows_CInternal_CThumbnailCache_CIThumbnailCacheInternal": ["6e2be37c-0df9-4b63-9108-80b1dbb51b9b"],
    "x_Windows_CInternal_CThumbnailCache_CIThumbnailResult": ["603a6214-9da4-44a6-9f96-11f73ea875d1"],
    "x_Windows_CInternal_CUI_CContentDeliveryManager_CIExpansionExperience": ["db147050-dcbf-4699-abaf-273e512e2a91"],
    "x_Windows_CInternal_CUI_CICloseRequest": ["caa5a33c-fa79-4046-81bf-4b88b7f1796e"],
    "x_Windows_CInternal_CUI_CICloseRequestStatics": ["d20efec6-70f8-4512-9337-26cac0b63b67"],
    "x_Windows_CInternal_CUI_CICloseRequestedEventArgs": ["42b352f7-5950-4038-90d5-b6652a9c8825"],
    "x_Windows_CInternal_CUI_CShutdown_CILogonUIPowerTransitionHandlerRegistration": [
        "f8f5b9e7-b85c-4dbd-90b7-c006a6a37e4a"
    ],
    "x_Windows_CInternal_CUI_CShutdown_CIShutdownChoicesViewModel": ["e449cd09-7b95-4075-96b4-e72a473db36c"],
    "x_Windows_CInternal_CUI_CShutdown_CIShutdownConfirmationViewModel": ["c3e893b3-af20-4c5a-9f28-75314a8bbbfd"],
    "x_Windows_CInternal_CUI_CShutdown_CIShutdownReasonsViewModel": ["cb187199-41ef-4feb-95db-ae15febcfbe0"],
    "x_Windows_CInternal_CUI_CShutdown_CIShutdownUXOption": ["e64aecc1-d683-419d-87e7-3c6261c64d0d"],
    "x_Windows_CInternal_CUI_CShutdown_CIShutdownUXViewModel": ["3d0980d5-1d41-46a3-a0d5-637f10c6e301"],
    "x_Windows_CInternal_CUI_CShutdown_CIShutdownUXViewModelFactory": ["1cc9d633-5180-4f2a-8fee-89e30086b023"],
    "x_Windows_CInternal_CUI_CSoftLanding_CISoftLandingExperience": ["f667b6f7-7bb8-4c98-a7de-574cee3e98a1"],
    "x_Windows_CInternal_CUI_CSoftLanding_CISoftLandingExperienceUnused": ["3472b1ee-bfc1-4533-996d-f3031d5f76a1"],
    "x_Windows_CInternal_CUI_CStartScreen_CISecondaryTilePrivate": ["cabce3e3-52b5-4019-9787-e36c43a25d92"],
    "x_Windows_CInternal_CUI_CStartScreen_CISecondaryTileStaticsPrivate": ["894bc14d-9651-4a1d-9996-cd80acf55c0e"],
    "x_Windows_CInternal_CUI_CTaskBarSuggestions_CITaskBarSuggestionsPinHelper": [
        "8fe68768-eeb4-415e-b678-ddaf57ffab61"
    ],
    "x_Windows_CManagement_CDeployment_CInternal_CIDiskUsageInformation": ["c51181c9-b056-450d-a183-2061e588e557"],
    "x_Windows_CManagement_CDeployment_CInternal_CIPackageManagerInternal": ["cebcd84d-1a8e-4846-9fd3-e6c1a715965e"],
    "x_Windows_CManagement_CDeployment_CInternal_CIPackageManagerRepairAclsInternal": [
        "522bd202-7231-4b88-8440-11bdede449a3"
    ],
    "x_Windows_CManagement_CDeployment_CInternal_CIPackageManagerStateCreationInternal": [
        "898427ec-f059-482a-9eca-a83889514f00"
    ],
    "x_Windows_CManagement_CDeployment_CInternal_CIPackageOperation": ["7abb46c0-e484-4f5f-bf4e-58b9c10ca38f"],
    "x_Windows_CManagement_CDeployment_CInternal_CIPackageVolumeInternal": ["d3e215de-c654-4759-9308-8be0d554881a"],
    "x_Windows_CMedia_CPlaylists_CIPlaylist": ["803736f5-cf44-4d97-83b3-7a089e9ab663"],
    "x_Windows_CMedia_CPlaylists_CIPlaylistStatics": ["c5c331cd-81f9-4ff3-95b9-70b6ff046b68"],
    "x_Windows_CMedia_CSpeechRecognition_CIVoiceCommandManager": ["aa3a8dd5-b6e7-4ee2-baa9-dd6baced0a2b"],
    "x_Windows_CMedia_CSpeechRecognition_CIVoiceCommandSet": ["0bedda75-46e6-4b11-a088-5c68632899b5"],
    "x_Windows_CMedia_CSpeechRecognition_CInternal_CISharedListConstraint": ["26b4f165-26ca-4259-a24f-2d00e7f295ba"],
    "x_Windows_CMedia_CSpeechRecognition_CInternal_CISharedListConstraintFactory": [
        "9961fb74-7307-47ba-b9e7-7d0cddd3c8d1"
    ],
    "x_Windows_CMedia_CSpeechRecognition_CInternal_CISpeechRecognitionCorrectionGraph": [
        "590d6add-e536-40f7-aaf6-c89552be1b7d"
    ],
    "x_Windows_CMedia_CSpeechRecognition_CInternal_CISpeechRecognitionCorrectionGraphArc": [
        "f0f7137d-aadb-4308-9428-cd0688cec05a"
    ],
    "x_Windows_CMedia_CSpeechRecognition_CInternal_CISpeechRecognitionCorrectionGraphNode": [
        "6d47644d-8acc-49be-896d-c83b62314748"
    ],
    "x_Windows_CMedia_CSpeechRecognition_CInternal_CISpeechRecognitionDictationDetail": [
        "110e4d02-3c4b-47b1-860d-2270db7d33a5"
    ],
    "x_Windows_CMedia_CSpeechRecognition_CInternal_CISpeechRecognitionTopicConstraintProperties": [
        "9d110257-32cb-482f-a957-c4dcdc3b2a08"
    ],
    "x_Windows_CMedia_CSpeechRecognition_CInternal_CISpeechRecognitionTopicConstraintTextContext": [
        "193f8f71-6c74-49cd-94e1-843adac1d0c1"
    ],
    "x_Windows_CMedia_CSpeechRecognition_CInternal_CISpeechRecognizerControl": ["2308bd67-c10c-467f-bfbf-d4c89be4cf4b"],
    "x_Windows_CMedia_CSpeechRecognition_CInternal_CISpeechRecognizerPropertiesInternal": [
        "2645e35b-924f-47de-b5a8-b2d7c1e7faa1"
    ],
    "x_Windows_CMedia_CSpeechRecognition_CInternal_CIVoiceCommandManagerWithAsyncGetCommandSets": [
        "3d609045-ced8-4eaa-bb16-b265a72ab032"
    ],
    "x_Windows_CMedia_CSpeech_CISpeechSettingsStatic": ["1085d99a-9b04-4af6-8d33-3b27bc0d6f23"],
    "x_Windows_CMedia_CSpeech_CISpeechSupportedLanguage": ["aba66304-a3eb-4ad0-928c-695e3601632c"],
    "x_Windows_CMedia_CSpeech_CISpeechSupportedLanguageImplementation": ["3cea7d32-1d90-4fe3-bb86-618f9ee59aeb"],
    "x_Windows_CMedia_CSpeech_CISpeechSupportedLanguageImplementationFactory": ["4fb7380b-63f9-4991-9fa6-50823b07fc41"],
    "x_Windows_CMedia_CSpeech_CISpeechSupportedLanguageStateChangeNotify": ["c6fe78b0-3783-409e-b5bc-95637f142583"],
    "x_Windows_CMedia_CSpeech_CISpeechSupportedLanguageStateChangedEventArgs": ["b8cc7066-6d50-42b7-be76-eebe41ac8c83"],
    "x_Windows_CNetworking_CConnectivity_CINetworkAdapterHelperPrivate": ["b4955b97-e1b7-4a54-a137-31bc7b5be589"],
    "x_Windows_CNetworking_CConnectivity_CINetworkInformationPrivate": ["6d4b31c4-8adb-4f45-88c9-58e7b38cbdcf"],
    "x_Windows_CNetworking_CConnectivity_CINetworkInformationPrivate2": ["eceb8ee9-b88a-4b6c-9602-e8a6bb162785"],
    "x_Windows_CNetworking_CUX_CIAdapterProperties": ["93652a8b-62a3-41b3-a265-927b6ce7c07e"],
    "x_Windows_CNetworking_CUX_CIAirplaneModeEventHandler": ["edc5094a-ab95-478c-9570-fc4c4aadd481"],
    "x_Windows_CNetworking_CUX_CIAuthProxyPrompt": ["9b076e6e-05bb-4e16-b06a-55b60edae9b7"],
    "x_Windows_CNetworking_CUX_CIAvailableNetwork": ["cefb4dcc-ee0b-4a2e-ba6e-b1e2789a964e"],
    "x_Windows_CNetworking_CUX_CIAvailableNetworkEventHandler": ["abf19b60-0f0e-46cf-88be-e2132ffdf04f"],
    "x_Windows_CNetworking_CUX_CIAvailableNetworkOffer": ["5397c67b-4918-43c1-ba7e-8444448f8fef"],
    "x_Windows_CNetworking_CUX_CIAvailableNetworkProvider": ["60695e7b-0dde-44fd-ba98-63606218db97"],
    "x_Windows_CNetworking_CUX_CICertItemInfo": ["93fd79c9-79f4-43b1-8731-c04961e6cd68"],
    "x_Windows_CNetworking_CUX_CIConnectionCompletionUIPrompt": ["f41878cc-2bd6-48c5-8486-db7eda35b59a"],
    "x_Windows_CNetworking_CUX_CIConnectionFlowEventHandler": ["c49b4943-977e-4ced-9307-375144bd9a75"],
    "x_Windows_CNetworking_CUX_CIDAActionNeededUIPrompt": ["4df0ba60-eaf9-4b53-b806-8f72740a4e70"],
    "x_Windows_CNetworking_CUX_CIDACompletionUIPrompt": ["9cd9f512-1a18-4fa0-acf2-eb99cb98ec0a"],
    "x_Windows_CNetworking_CUX_CIDACredUIInput": ["c9d50b78-9694-44b2-acdc-7cf2a2e6a449"],
    "x_Windows_CNetworking_CUX_CIDACredUIInputFactory": ["a2ca929f-d430-44b3-831b-93e1f16e1870"],
    "x_Windows_CNetworking_CUX_CIEAPGenericIdentityInput": ["04bde693-ec7b-47c5-a1d0-3241ceb06424"],
    "x_Windows_CNetworking_CUX_CIEAPGenericIdentityInputFactory": ["25041b95-2b5d-482f-8f22-c75478abf7dc"],
    "x_Windows_CNetworking_CUX_CIEAPGenericIdentityUIPrompt": ["a66d7e22-0e91-4b2e-afbb-e670277a8362"],
    "x_Windows_CNetworking_CUX_CIEAPPasswordChangeUIPrompt": ["a38b29dd-3e53-4a2f-b6da-9bd13c58db43"],
    "x_Windows_CNetworking_CUX_CIEAPSimIdentityInput": ["54503d9c-97f7-4624-b712-3a07e563bea3"],
    "x_Windows_CNetworking_CUX_CIEAPSimIdentityInputFactory": ["d4050a78-2df5-4d76-a5d0-eaa6b87ab4f8"],
    "x_Windows_CNetworking_CUX_CIEAPSimIdentityUIPrompt": ["e6247dde-bfe8-408b-ab21-2ba890945c96"],
    "x_Windows_CNetworking_CUX_CIEAPTLSCertPasswordUIPrompt": ["8969ba84-c62a-4938-a80a-f7869ad99630"],
    "x_Windows_CNetworking_CUX_CIEAPTLSCertPinCredUIPrompt": ["6c1e48f7-6cf8-4bbc-82de-efbb91daf44b"],
    "x_Windows_CNetworking_CUX_CIEAPTLSCertSelectInput": ["c87ccf7a-4663-4eeb-8230-d5a86fcd074f"],
    "x_Windows_CNetworking_CUX_CIEAPTLSCertSelectInputFactory": ["ec25c66a-e2fd-4f6a-a106-43d6294f6ae8"],
    "x_Windows_CNetworking_CUX_CIEAPTLSCertSelectUIPrompt": ["b3885ad0-5e57-4e06-b310-042195232034"],
    "x_Windows_CNetworking_CUX_CIEAPUserIdentityUIPrompt": ["682e7509-fb9b-4351-b38b-d08bd652e631"],
    "x_Windows_CNetworking_CUX_CIEAPValidateServerCertInput": ["77c7586c-726d-498d-92df-b83feb97a727"],
    "x_Windows_CNetworking_CUX_CIEAPValidateServerCertInputFactory": ["f949c481-4e2a-4e7f-bf59-ddd7eb0e7a83"],
    "x_Windows_CNetworking_CUX_CIEAPValidateServerCertUIPrompt": ["2775015d-836f-4da7-bdf5-dc8ce20bd87f"],
    "x_Windows_CNetworking_CUX_CIEthernetUXCategory": ["987db579-3ba3-4c95-a762-c931ff53663c"],
    "x_Windows_CNetworking_CUX_CIHotspot2RegisterProvider": ["c9678f0d-6324-4b5a-8bc5-a55f303e88ab"],
    "x_Windows_CNetworking_CUX_CIHotspot2RegistrationEventHandler": ["bab533de-4108-4ba2-ac37-dd912c985d0c"],
    "x_Windows_CNetworking_CUX_CIMBCompletionUIPrompt": ["2e1f98f5-c3cc-4924-96e8-f7cea7698841"],
    "x_Windows_CNetworking_CUX_CIMBInProgressUIPrompt": ["dc2dca6f-669b-4378-b5db-68345ce65756"],
    "x_Windows_CNetworking_CUX_CIMBPinUIPrompt": ["a58268c7-2d42-468f-a438-0c8a984115c9"],
    "x_Windows_CNetworking_CUX_CIMBUXCategory": ["a6f7deca-199e-43cc-b675-d539a933109f"],
    "x_Windows_CNetworking_CUX_CINetworkLocationInput": ["a46ca5da-1186-4224-b4c0-4fa2fc9980e0"],
    "x_Windows_CNetworking_CUX_CINetworkLocationInputFactory": ["34fb9e69-6837-4930-8fdb-fe444d18fac3"],
    "x_Windows_CNetworking_CUX_CINetworkUXManager": ["12f66348-dc79-4155-a131-e4ea1fc46df5"],
    "x_Windows_CNetworking_CUX_CIPasswordChangeInput": ["e10deb05-6b58-4b7b-adc8-65cb74a3553d"],
    "x_Windows_CNetworking_CUX_CIPasswordChangeInputFactory": ["9934b56b-2a2d-4505-9fde-4a76aa1b212f"],
    "x_Windows_CNetworking_CUX_CIRasCompletionUIPrompt": ["d6dccda2-a053-416f-8cc4-0558e9fa6399"],
    "x_Windows_CNetworking_CUX_CIRasCredUIInput": ["d84faf4c-c16a-4372-8a0f-8c7ceef38c76"],
    "x_Windows_CNetworking_CUX_CIRasCredUIInputFactory": ["eaafec2d-0c41-4155-b636-42a2a8a50cca"],
    "x_Windows_CNetworking_CUX_CIRasCredUIUIPrompt": ["7557033e-7c82-411d-b38f-de5315d37b1b"],
    "x_Windows_CNetworking_CUX_CIRasCustomUIPrompt": ["d55e7bf4-34b7-4143-9ab9-8f0e12b00ea9"],
    "x_Windows_CNetworking_CUX_CIRasInProgressUIPrompt": ["1e46ce8a-8c4a-40dc-9951-e02b6b276bc6"],
    "x_Windows_CNetworking_CUX_CIRasThirdpartyAuthTokenInput": ["b12a4c5a-0109-4215-b735-e6e4992d6f20"],
    "x_Windows_CNetworking_CUX_CIRasThirdpartyAuthTokenInputFactory": ["0ebdace2-951a-45f9-85e7-4e794828138d"],
    "x_Windows_CNetworking_CUX_CIRasThirdpartyAuthUIPrompt": ["355dfcd2-4f31-4505-9aed-7abc52db1be5"],
    "x_Windows_CNetworking_CUX_CIRasUXCategory": ["cdf2d6a5-df11-47c0-850e-62f342410c53"],
    "x_Windows_CNetworking_CUX_CISimItemInfo": ["5291370c-4f84-4653-bbb9-5935d4f790e7"],
    "x_Windows_CNetworking_CUX_CITextInput": ["b2af5f7f-d10f-4d9c-9e0b-bf7a8597e57d"],
    "x_Windows_CNetworking_CUX_CITextInputFactory": ["66ea13f6-945d-4ae6-b01c-34663f948d35"],
    "x_Windows_CNetworking_CUX_CIUXCategory": ["91e76f1b-9eef-4592-b3aa-630094a37d41"],
    "x_Windows_CNetworking_CUX_CIUXCategoryEventHandler": ["e4945a59-ccbf-46f1-ad0b-96d19b343464"],
    "x_Windows_CNetworking_CUX_CIUXManager": ["6f9bbe05-ff62-4f69-8d02-9de60cac77d7"],
    "x_Windows_CNetworking_CUX_CIUserCredInput": ["ec52d38a-5340-4351-ac18-392d10a08217"],
    "x_Windows_CNetworking_CUX_CIUserCredInputFactory": ["d2efd1c0-eec0-49db-a6d7-aba60a949209"],
    "x_Windows_CNetworking_CUX_CIUserInputType": ["70dba485-cd56-4f15-9f82-86b1460e09a8"],
    "x_Windows_CNetworking_CUX_CIVPNCustomInputItem": ["2ecc3473-c61e-47ef-b3ad-9b47ac36efc4"],
    "x_Windows_CNetworking_CUX_CIWcnPinInput": ["f56f9807-a5cf-4157-b1e3-63958153d7f6"],
    "x_Windows_CNetworking_CUX_CIWcnPinInputFactory": ["5c0b2776-7350-4757-9d5d-dda53f269f7f"],
    "x_Windows_CNetworking_CUX_CIWiFiAdapterProperties": ["a533bcac-da74-4ae2-895b-a43faddd7e89"],
    "x_Windows_CNetworking_CUX_CIWiFiAvailableNetwork": ["d5892900-5da1-4a18-968c-e4def930d6fe"],
    "x_Windows_CNetworking_CUX_CIWiFiCertSelectUIPrompt": ["1716b552-b486-49fc-a564-f46c6c785527"],
    "x_Windows_CNetworking_CUX_CIWiFiEapMethod": ["dfbed548-6b6f-4fae-895b-8178cfeeaac7"],
    "x_Windows_CNetworking_CUX_CIWiFiInProgressUIPrompt": ["92a01658-cfa5-41ff-96f4-5e391eae5268"],
    "x_Windows_CNetworking_CUX_CIWiFiPassKeyUIPrompt": ["61fd3165-2ea2-4279-8b9a-99c53e6615ed"],
    "x_Windows_CNetworking_CUX_CIWiFiProfile": ["288daae6-36b4-452f-8870-5b0ec3d0391d"],
    "x_Windows_CNetworking_CUX_CIWiFiSenseSocialNetwork": ["5a3891f1-bc5f-43c2-b6b7-c82d0fa987aa"],
    "x_Windows_CNetworking_CUX_CIWiFiSettings": ["badb78fb-e728-4a5f-ac80-3017eac0b087"],
    "x_Windows_CNetworking_CUX_CIWiFiUXCategory": ["cfc67e3b-38d1-487b-871b-f0fffe0cc915"],
    "x_Windows_CNetworking_CUX_CIWiFiWCNComboUIPrompt": ["7131e0b4-2cca-46c3-a970-d315c4f73a23"],
    "x_Windows_CNetworking_CUX_CIWiFiWCNPinUIPrompt": ["3f16aded-24c5-48cf-8d0f-c090b3317c3a"],
    "x_Windows_CPhone_CStartScreen_CIDualSimTile": ["143ab213-d05f-4041-a18c-3e3fcb75b41e"],
    "x_Windows_CPhone_CStartScreen_CIDualSimTileStatics": ["50567c9e-c58f-4dc9-b6e8-fa6777eeeb37"],
    "x_Windows_CPhone_CStartScreen_CIToastNotificationManagerStatics3": ["2717f54b-50df-4455-8e6e-41e0fc8e13ce"],
    "x_Windows_CSecurity_CEnterpriseData_CIProtectionPolicyManagerInternalStatics": [
        "c68d66ce-0d6d-4832-88b3-f136b1e868c3"
    ],
    "x_Windows_CSecurity_CEnterpriseData_CIProtectionPolicyManagerInternalStatics2": [
        "db39fd14-a012-4a52-840c-3ce091285d5b"
    ],
    "x_Windows_CServices_CTargetedContent_CInternal_CINotifySubscription": ["118ec4a0-443d-467d-b568-de895db52e7b"],
    "x_Windows_CServices_CTargetedContent_CInternal_CISubscriptionManager": ["50a5378f-a64e-4d5a-a911-6342b5ff64c0"],
    "x_Windows_CServices_CTargetedContent_CInternal_CITargetedContentActionInternal": [
        "da349da6-4976-4ccd-a6e0-92292ecee11c"
    ],
    "x_Windows_CServices_CTargetedContent_CInternal_CITargetedContentActionStaticsInternal": [
        "5095e466-bb07-4fb0-a18b-88f3bf86b2bd"
    ],
    "x_Windows_CServices_CTargetedContent_CInternal_CITargetedContentCacheChangeTracker": [
        "7f4935e3-0135-4f14-8a1c-457877d80c66"
    ],
    "x_Windows_CServices_CTargetedContent_CInternal_CITargetedContentCacheReader": [
        "ca2f34cf-283f-453e-b2d2-841b8c2f5c34"
    ],
    "x_Windows_CServices_CTargetedContent_CInternal_CITargetedContentCacheWriter": [
        "5a5c091e-749b-4a59-a67c-dcaa26772e8d"
    ],
    "x_Windows_CServices_CTargetedContent_CInternal_CITargetedContentCollectionInternalProperties": [
        "39fbb644-e218-4e45-ab28-d26a2cbe7446"
    ],
    "x_Windows_CServices_CTargetedContent_CInternal_CITargetedContentFilePathInternal": [
        "c766afef-ffdc-40be-8294-2297ae97f9c4"
    ],
    "x_Windows_CServices_CTargetedContent_CInternal_CITargetedContentItemInternalProperties": [
        "2b3a823f-4d5a-4980-a36f-107ca5a7ddbd"
    ],
    "x_Windows_CServices_CTargetedContent_CInternal_CITargetedContentObjectInternal": [
        "d57bf733-13bf-4dda-800c-4d5b5fd2ac12"
    ],
    "x_Windows_CServices_CTargetedContent_CInternal_CITargetedContentObjectMetadataInternal": [
        "11a25863-dd58-4a33-a547-d481ef956f29"
    ],
    "x_Windows_CServices_CTargetedContent_CInternal_CITargetedContentSubscriptionInternal": [
        "1547dcdf-43fb-4ea7-b3c0-d10f3b1f34ff"
    ],
    "x_Windows_CServices_CTargetedContent_CInternal_CITargetedContentTriggerInternal": [
        "f4251157-4c58-48fe-b495-bcaf364fbb3c"
    ],
    "x_Windows_CServices_CTargetedContent_CInternal_CITargetedContentTriggerManagerStaticsInternal": [
        "8e67c2b2-5490-4ab7-b9d1-f722fa29af14"
    ],
    "x_Windows_CShell_CModalExperienceHelpers_CIDesktopModalExperiencePreparation": [
        "8054d141-b170-49eb-8cc6-b5b5efab6afa"
    ],
    "x_Windows_CStorage_CAccessCache_CIItemRemovedEventArgs": ["59677e5c-55be-4c66-ba66-5eaea79d2631"],
    "x_Windows_CStorage_CAccessCache_CIStorageApplicationPermissionsStatics": ["4391dfaa-d033-48f9-8060-3ec847d2e3f1"],
    "x_Windows_CStorage_CAccessCache_CIStorageApplicationPermissionsStatics2": ["072716ec-aa05-4294-9a11-1a3d04519ad0"],
    "x_Windows_CStorage_CAccessCache_CIStorageItemAccessList": ["2caff6ad-de90-47f5-b2c3-dd36c9fdd453"],
    "x_Windows_CStorage_CAccessCache_CIStorageItemMostRecentlyUsedList": ["016239d5-510d-411e-8cf1-c3d1effa4c33"],
    "x_Windows_CStorage_CAccessCache_CIStorageItemMostRecentlyUsedList2": ["da481ea0-ed8d-4731-a1db-e44ee2204093"],
    "x_Windows_CStorage_CBulkAccess_CIFileInformationFactory": ["401d88be-960f-4d6d-a7d0-1a3861e76c83"],
    "x_Windows_CStorage_CBulkAccess_CIFileInformationFactoryFactory": ["84ea0e7d-e4a2-4f00-8afa-af5e0f826bd5"],
    "x_Windows_CStorage_CBulkAccess_CIStorageItemInformation": ["87a5cb8b-8972-4f40-8de0-d86fb179d8fa"],
    "x_Windows_CStorage_CFileProperties_CIBasicProperties": ["d05d55db-785e-4a66-be02-9beec58aea81"],
    "x_Windows_CStorage_CFileProperties_CIDocumentProperties": ["7eab19bc-1821-4923-b4a9-0aea404d0070"],
    "x_Windows_CStorage_CFileProperties_CIImageProperties": ["523c9424-fcff-4275-afee-ecdb9ab47973"],
    "x_Windows_CStorage_CFileProperties_CIMusicProperties": ["bc8aab62-66ec-419a-bc5d-ca65a4cb46da"],
    "x_Windows_CStorage_CFileProperties_CIStorageItemContentProperties": ["05294bad-bc38-48bf-85d7-770e0e2ae0ba"],
    "x_Windows_CStorage_CFileProperties_CIStorageItemExtraProperties": ["c54361b2-54cd-432b-bdbc-4b19c4b470d7"],
    "x_Windows_CStorage_CFileProperties_CIThumbnailProperties": ["693dd42f-dbe7-49b5-b3b3-2893ac5d3423"],
    "x_Windows_CStorage_CFileProperties_CIVideoProperties": ["719ae507-68de-4db8-97de-49998c059f2f"],
    "x_Windows_CStorage_CIAppDataPaths": ["7301d60a-79a2-48c9-9ec0-3fda092f79e1"],
    "x_Windows_CStorage_CIAppDataPathsStatics": ["d8eb2afe-a9d9-4b14-b999-e3921379d903"],
    "x_Windows_CStorage_CICachedFileManagerStatics": ["8ffc224a-e782-495d-b614-654c4f0b2370"],
    "x_Windows_CStorage_CIDownloadsFolderStatics": ["27862ed0-404e-47df-a1e2-e37308be7b37"],
    "x_Windows_CStorage_CIDownloadsFolderStatics2": ["e93045bd-8ef8-4f8e-8d15-ac0e265f390d"],
    "x_Windows_CStorage_CIFileIOStatics": ["887411eb-7f54-4732-a5f0-5e43e3b8c2f5"],
    "x_Windows_CStorage_CIKnownFoldersCameraRollStatics": ["5d115e66-27e8-492f-b8e5-2f90896cd4cd"],
    "x_Windows_CStorage_CIKnownFoldersPlaylistsStatics": ["dad5ecd6-306f-4d6a-b496-46ba8eb106ce"],
    "x_Windows_CStorage_CIKnownFoldersSavedPicturesStatics": ["055c93ea-253d-467c-b6ca-a97da1e9a18d"],
    "x_Windows_CStorage_CIKnownFoldersStatics": ["5a2a7520-4802-452d-9ad9-4351ada7ec35"],
    "x_Windows_CStorage_CIKnownFoldersStatics2": ["194bd0cd-cf6e-4d07-9d53-e9163a2536e9"],
    "x_Windows_CStorage_CIKnownFoldersStatics3": ["c5194341-9742-4ed5-823d-fc1401148764"],
    "x_Windows_CStorage_CIKnownFoldersStatics4": ["1722e6bf-9ff9-4b21-bed5-90ecb13a192e"],
    "x_Windows_CStorage_CIKnownFoldersStaticsPriv": ["93f7aaff-6037-4818-858a-73e8d44af96f"],
    "x_Windows_CStorage_CIPathIOStatics": ["0f2f3758-8ec7-4381-922b-8f6c07d288f3"],
    "x_Windows_CStorage_CIStorageFile": ["fa3f6186-4214-428c-a64c-14c9ac7315ea"],
    "x_Windows_CStorage_CIStorageFile2": ["954e4bcf-0a77-42fb-b777-c2ed58a52e44"],
    "x_Windows_CStorage_CIStorageFilePropertiesWithAvailability": ["afcbbe9b-582b-4133-9648-e44ca46ee491"],
    "x_Windows_CStorage_CIStorageFileStatics": ["5984c710-daf2-43c8-8bb4-a4d3eacfd03f"],
    "x_Windows_CStorage_CIStorageFileStatics2": ["5c76a781-212e-4af9-8f04-740cae108974"],
    "x_Windows_CStorage_CIStorageFileStaticsPrivateWinRt": ["21d106da-8644-468f-a6cc-643bb12f07c5"],
    "x_Windows_CStorage_CIStorageFolder": ["72d1cb78-b3ef-4f75-a80b-6fd9dae2944b"],
    "x_Windows_CStorage_CIStorageFolder2": ["e827e8b9-08d9-4a8e-a0ac-fe5ed3cbbbd3"],
    "x_Windows_CStorage_CIStorageFolder3": ["9f617899-bde1-4124-aeb3-b06ad96f98d4"],
    "x_Windows_CStorage_CIStorageFolderStatics": ["08f327ff-85d5-48b9-aee9-28511e339f9f"],
    "x_Windows_CStorage_CIStorageFolderStatics2": ["b4656dc3-71d2-467d-8b29-371f0f62bf6f"],
    "x_Windows_CStorage_CIStorageItem": ["4207a996-ca2f-42f7-bde8-8b10457a7f30"],
    "x_Windows_CStorage_CIStorageItem2": ["53f926d2-083c-4283-b45b-81c007237e44"],
    "x_Windows_CStorage_CIStorageItemProperties": ["86664478-8029-46fe-a789-1c2f3e2ffb5c"],
    "x_Windows_CStorage_CIStorageItemProperties2": ["8e86a951-04b9-4bd2-929d-fef3f71621d0"],
    "x_Windows_CStorage_CIStorageItemPropertiesWithProvider": ["861bf39b-6368-4dee-b40e-74684a5ce714"],
    "x_Windows_CStorage_CIStorageItemThumbnailAccessPriv": ["d1e62f23-cb3f-4fcb-a8f9-03b0dba2e39c"],
    "x_Windows_CStorage_CIStorageLibrary": ["1edd7103-0e5e-4d6c-b5e8-9318983d6a03"],
    "x_Windows_CStorage_CIStorageLibrary3": ["8a281291-2154-4201-8113-d2c05ce1ad23"],
    "x_Windows_CStorage_CIStorageLibraryChange": ["00980b23-2be2-4909-aa48-159f5203a51e"],
    "x_Windows_CStorage_CIStorageLibraryChangeReader": ["f205bc83-fca2-41f9-8954-ee2e991eb96f"],
    "x_Windows_CStorage_CIStorageLibraryChangeTracker": ["9e157316-6073-44f6-9681-7492d1286c90"],
    "x_Windows_CStorage_CIStorageLibraryStatics": ["4208a6db-684a-49c6-9e59-90121ee050d6"],
    "x_Windows_CStorage_CIStorageLibraryStatics2": ["ffb08ddc-fa75-4695-b9d1-7f81f97832e3"],
    "x_Windows_CStorage_CIStorageProvider": ["e705eed4-d478-47d6-ba46-1a8ebe114a20"],
    "x_Windows_CStorage_CIStorageProvider2": ["010d1917-3404-414b-9fd7-cd44472eaa39"],
    "x_Windows_CStorage_CIStorageStreamTransaction": ["f67cf363-a53d-4d94-ae2c-67232d93acdd"],
    "x_Windows_CStorage_CIStreamedFileDataRequest": ["1673fcce-dabd-4d50-beee-180b8a8191b6"],
    "x_Windows_CStorage_CIStreamedFileDataRequestedHandler": ["fef6a824-2fe1-4d07-a35b-b77c50b5f4cc"],
    "x_Windows_CStorage_CISystemDataPaths": ["e32abf70-d8fa-45ec-a942-d2e26fb60ba5"],
    "x_Windows_CStorage_CISystemDataPathsStatics": ["e0f96fd0-9920-4bca-b379-f96fdf7caad8"],
    "x_Windows_CStorage_CIUserDataPaths": ["f9c53912-abc4-46ff-8a2b-dc9d7fa6e52f"],
    "x_Windows_CStorage_CIUserDataPathsStatics": ["01b29def-e062-48a1-8b0c-f2c7a9ca56c0"],
    "x_Windows_CStorage_CInternal_CPickers_CIBasketItemAddedEventArgs": ["2e15ad0c-ed78-4b03-81e0-ae4196418c62"],
    "x_Windows_CStorage_CInternal_CPickers_CIBasketItemRemovedEventArgs": ["2775b3f7-9e02-49ad-b05e-1f942a96706b"],
    "x_Windows_CStorage_CInternal_CPickers_CICachedFileUpdaterBasket": ["7e06aaee-4edf-4462-a8b4-1193f0bb83f9"],
    "x_Windows_CStorage_CInternal_CPickers_CICachedFileUpdaterInfo": ["349607e3-ab8d-45a4-bbc1-e1891fee0f58"],
    "x_Windows_CStorage_CInternal_CPickers_CICachedFileUpdaterOperation": ["93eeea8c-9859-46d4-a646-afaa363ba63b"],
    "x_Windows_CStorage_CInternal_CPickers_CIFileOpenPickerBasket": ["4e78b060-6e32-4bfb-8c54-3684e489444d"],
    "x_Windows_CStorage_CInternal_CPickers_CIFileOpenPickerInfo": ["a3efdedf-8046-46ad-a048-fa4aa6d3df65"],
    "x_Windows_CStorage_CInternal_CPickers_CIFileOpenPickerOperation": ["47d674e6-ae11-4469-afe6-d3d9087ad3b2"],
    "x_Windows_CStorage_CInternal_CPickers_CIFileOpenPickerOperationFactory": ["18b23b94-78ad-49c0-9126-466a30520450"],
    "x_Windows_CStorage_CInternal_CPickers_CIFilePickerExperienceActivatedEventArgs": [
        "765b62f7-ef86-4cb7-8792-a12f1b0b0849"
    ],
    "x_Windows_CStorage_CInternal_CPickers_CIFileSavePickerBasket": ["6cc1e12c-3cd2-4298-b9e9-08b87b9eb960"],
    "x_Windows_CStorage_CInternal_CPickers_CIFileSavePickerInfo": ["bea8dfc8-a297-4ddf-8b3b-9a8b8e99f567"],
    "x_Windows_CStorage_CInternal_CPickers_CIFileSavePickerOperation": ["f219dceb-e23c-439f-8815-f3eb585eec7d"],
    "x_Windows_CStorage_CInternal_CPickers_CIFileSavePickerOperationFactory": ["92341c54-7128-4101-a29b-ad9e80ca0938"],
    "x_Windows_CStorage_CInternal_CPickers_CIFolderPickerOperationFactory": ["b6d7d783-36f0-4a74-b6c0-96b5879e2b47"],
    "x_Windows_CStorage_CInternal_CPickers_CIPickerExperience": ["b60c2d54-0c1b-4608-8397-981e3e1f8243"],
    "x_Windows_CStorage_CInternal_CPickers_CIPickerOperation": ["83f297c1-a66f-427b-b357-d02a7e017548"],
    "x_Windows_CStorage_CInternal_CPickers_CIPickerOperationCompletedEventArgs": [
        "6e17f550-12af-4844-9c5b-6de002f506df"
    ],
    "x_Windows_CStorage_CInternal_CPickers_CISaveFileNameChangeRequestedEventArgs": [
        "9aae0029-e155-40ac-812c-46beda102f4d"
    ],
    "x_Windows_CStorage_CPickers_CICachedFileUpdateManager": ["4f4053ce-3625-4eaa-9cb0-c2bfca1d37bd"],
    "x_Windows_CStorage_CPickers_CIFileOpenPicker": ["2ca8278a-12c5-4c5f-8977-94547793c241"],
    "x_Windows_CStorage_CPickers_CIFileOpenPicker2": ["8ceb6cd2-b446-46f7-b265-90f8e55ad650"],
    "x_Windows_CStorage_CPickers_CIFileOpenPicker3": ["d9a5c5b3-c5dc-5b98-bd80-a8d0ca0584d8"],
    "x_Windows_CStorage_CPickers_CIFileOpenPickerStatics": ["6821573b-2f02-4833-96d4-abbfad72b67b"],
    "x_Windows_CStorage_CPickers_CIFileOpenPickerStatics2": ["e8917415-eddd-5c98-b6f3-366fdfcad392"],
    "x_Windows_CStorage_CPickers_CIFileOpenPickerWithOperationId": ["3f57b569-2522-4ca5-aa73-a15509f1fcbf"],
    "x_Windows_CStorage_CPickers_CIFileSavePicker": ["3286ffcb-617f-4cc5-af6a-b3fdf29ad145"],
    "x_Windows_CStorage_CPickers_CIFileSavePicker2": ["0ec313a2-d24b-449a-8197-e89104fd42cc"],
    "x_Windows_CStorage_CPickers_CIFileSavePicker3": ["698aec69-ba3c-4e51-bd90-4abcbbf4cfaf"],
    "x_Windows_CStorage_CPickers_CIFileSavePicker4": ["e7d83a5a-ddfa-5de0-8b70-c842c21988ec"],
    "x_Windows_CStorage_CPickers_CIFileSavePickerStatics": ["28e3cf9e-961c-5e2c-aed7-e64737f4ce37"],
    "x_Windows_CStorage_CPickers_CIFolderPicker": ["084f7799-f3fb-400a-99b1-7b4a772fd60d"],
    "x_Windows_CStorage_CPickers_CIFolderPicker2": ["8eb3ba97-dc85-4616-be94-9660881f2f5d"],
    "x_Windows_CStorage_CPickers_CIFolderPicker3": ["673b1e29-d326-53c0-bd24-a25c714cee36"],
    "x_Windows_CStorage_CPickers_CIFolderPickerStatics": ["9be34740-7ca1-5942-a3c8-46f2551ecff3"],
    "x_Windows_CStorage_CPickers_CIPickerFileType": ["c72ecb37-09e8-460e-9485-baa88e6d5752"],
    "x_Windows_CStorage_CPickers_CIStorageItemInternalForCachedFileUpdater": ["e97191a2-78b0-47eb-a359-4c3a47cafac3"],
    "x_Windows_CStorage_CPickers_CIUpdateFilesResult": ["e2772e7a-f05c-4bc8-8bd0-30f887a686f9"],
    "x_Windows_CStorage_CPickers_CInternal_CICachedFileItem": ["741a9dde-e140-47a8-a942-2a9d5f40aa51"],
    "x_Windows_CStorage_CPickers_CInternal_CICachedFileUpdatePolicyListener": ["269fbb13-5213-45a0-82c3-b4aa2f2a8871"],
    "x_Windows_CStorage_CPickers_CInternal_CICachedFileUpdaterBasketCallbacks": [
        "e89eb877-f439-435c-b49e-6a3796dac7e1"
    ],
    "x_Windows_CStorage_CPickers_CInternal_CICachedFileUpdaterBasketChangedEventSink": [
        "124ac7a9-259e-4fda-8fae-308b27027773"
    ],
    "x_Windows_CStorage_CPickers_CInternal_CICachedFileUpdaterEventSink": ["ab12af35-2ffb-4fb5-9c29-9a57959af92d"],
    "x_Windows_CStorage_CPickers_CInternal_CICachedFileUpdaterPickerBasketManager": [
        "ce0799f8-1fa7-47b5-bbc2-4889842ddf72"
    ],
    "x_Windows_CStorage_CPickers_CInternal_CIFileOpenPickerBasketChangedEventSink": [
        "de45e6e4-ff09-4894-82fe-5e88ec9bd4b4"
    ],
    "x_Windows_CStorage_CPickers_CInternal_CIFileOpenPickerBasketManager": ["4f425ae5-2a8c-4947-8e76-1ed9dfc5d9cb"],
    "x_Windows_CStorage_CPickers_CInternal_CIFileSavePickerBasketCallbacks": ["2bc6fd3d-2814-4ee6-b468-672b3df95339"],
    "x_Windows_CStorage_CPickers_CInternal_CIFileSavePickerBasketChangedEventSink": [
        "7159e50f-89fa-49d5-8739-9da8c251af3d"
    ],
    "x_Windows_CStorage_CPickers_CInternal_CIFileSavePickerBasketManager": ["948cc8f4-923f-47aa-86c0-6ef57d71a683"],
    "x_Windows_CStorage_CPickers_CInternal_CIFileSavePickerEventSink": ["130a644e-4409-49a4-bff6-c0e3b5ed0ddb"],
    "x_Windows_CStorage_CPickers_CInternal_CIHostedViewEventSink": ["675debb9-4997-4095-abeb-f67ecedf68d7"],
    "x_Windows_CStorage_CPickers_CInternal_CIItemDeselectedSink": ["81091e1e-8d78-4a6e-8607-54525540dfc3"],
    "x_Windows_CStorage_CPickers_CInternal_CIPickerBasketManager": ["3088e009-a3a3-461d-b0da-6f9799064ce4"],
    "x_Windows_CStorage_CPickers_CInternal_CIPickerControllerUI": ["d048d71e-3e13-4914-867f-1b468b690aae"],
    "x_Windows_CStorage_CPickers_CInternal_CIPickerControllerUIHelper": ["324cf05e-4880-442a-902f-57746bc4356b"],
    "x_Windows_CStorage_CPickers_CProvider_CICurrentLocationRequest": ["ad0d8c06-cacf-4759-83a9-381bf8ad1570"],
    "x_Windows_CStorage_CPickers_CProvider_CICurrentLocationRequestDeferral": ["d1383cc7-c47e-4076-a457-7ba31385edff"],
    "x_Windows_CStorage_CPickers_CProvider_CICurrentLocationRequestedEventArgs": [
        "f9d82b04-08c4-4e0f-9532-e0ab6501a545"
    ],
    "x_Windows_CStorage_CPickers_CProvider_CIFileOpenPickerUI": ["dda45a10-f9d4-40c4-8af5-c5b6b5a61d1d"],
    "x_Windows_CStorage_CPickers_CProvider_CIFileOpenPickerUIInternal": ["6968c9cf-54cb-47e1-b986-e2080af8647c"],
    "x_Windows_CStorage_CPickers_CProvider_CIFileRemovedEventArgs": ["13043da7-7fca-4c2b-9eca-6890f9f00185"],
    "x_Windows_CStorage_CPickers_CProvider_CIFileSavePickerUI": ["9656c1e7-3e56-43cc-8a39-33c73d9d542b"],
    "x_Windows_CStorage_CPickers_CProvider_CIFileSavePickerUIInternal": ["dd8a1e6c-18da-4dee-a19b-fec313e53284"],
    "x_Windows_CStorage_CPickers_CProvider_CIPickerClosingDeferral": ["7af7f71e-1a67-4a31-ae80-e907708a619b"],
    "x_Windows_CStorage_CPickers_CProvider_CIPickerClosingEventArgs": ["7e59f224-b332-4f12-8b9f-a8c2f06b32cd"],
    "x_Windows_CStorage_CPickers_CProvider_CIPickerClosingOperation": ["4ce9fb84-beee-4e39-a773-fc5f0eae328d"],
    "x_Windows_CStorage_CPickers_CProvider_CITargetFileRequest": ["42bd3355-7f88-478b-8e81-690b20340678"],
    "x_Windows_CStorage_CPickers_CProvider_CITargetFileRequestDeferral": ["4aee9d91-bf15-4da9-95f6-f6b7d558225b"],
    "x_Windows_CStorage_CPickers_CProvider_CITargetFileRequestedEventArgs": ["b163dbc1-1b51-4c89-a591-0fd40b3c57c9"],
    "x_Windows_CStorage_CProvider_CICachedFileUpdaterStatics": ["9fc90920-7bcf-4888-a81e-102d7034d7ce"],
    "x_Windows_CStorage_CProvider_CICachedFileUpdaterUI": ["9e6f41e6-baf2-4a97-b600-9333f5df80fd"],
    "x_Windows_CStorage_CProvider_CICachedFileUpdaterUI2": ["8856a21c-8699-4340-9f49-f7cad7fe8991"],
    "x_Windows_CStorage_CProvider_CIFileUpdateRequest": ["40c82536-c1fe-4d93-a792-1e736bc70837"],
    "x_Windows_CStorage_CProvider_CIFileUpdateRequest2": ["82484648-bdbe-447b-a2ee-7afe6a032a94"],
    "x_Windows_CStorage_CProvider_CIFileUpdateRequestDeferral": ["ffcedb2b-8ade-44a5-bb00-164c4e72f13a"],
    "x_Windows_CStorage_CProvider_CIFileUpdateRequestedEventArgs": ["7b0a9342-3905-438d-aaef-78ae265f8dd2"],
    "x_Windows_CStorage_CProvider_CIStorageProviderPropertyCapabilities": ["658d2f0e-63b7-4567-acf9-51abe301dda5"],
    "x_Windows_CStorage_CSearch_CIQueryOptions": ["1e5e46ee-0f45-4838-a8e9-d0479d446c30"],
    "x_Windows_CStorage_CSearch_CIQueryOptionsFactory": ["032e1f8c-a9c1-4e71-8011-0dee9d4811a3"],
    "x_Windows_CStorage_CSearch_CIQueryOptionsWithProviderFilter": ["5b9d1026-15c4-44dd-b89a-47a59b7d7c4f"],
    "x_Windows_CStorage_CSearch_CIStorageFileQueryResult": ["52fda447-2baa-412c-b29f-d4b1778efa1e"],
    "x_Windows_CStorage_CSearch_CIStorageFileQueryResult2": ["4e5db9dd-7141-46c4-8be3-e9dc9e27275c"],
    "x_Windows_CStorage_CSearch_CIStorageFolderQueryOperations": ["cb43ccc9-446b-4a4f-be97-757771be5203"],
    "x_Windows_CStorage_CSearch_CIStorageFolderQueryResult": ["6654c911-7d66-46fa-aecf-e4a4baa93ab8"],
    "x_Windows_CStorage_CSearch_CIStorageItemQueryResult": ["e8948079-9d58-47b8-b2b2-41b07f4795f9"],
    "x_Windows_CStorage_CSearch_CIStorageLibraryChangeTrackerTriggerDetails": ["1dc7a369-b7a3-4df2-9d61-eba85a0343d2"],
    "x_Windows_CStorage_CSearch_CIStorageLibraryContentChangedTriggerDetails": ["2a371977-abbf-4e1d-8aa5-6385d8884799"],
    "x_Windows_CStorage_CSearch_CIStorageQueryResultBase": ["c297d70d-7353-47ab-ba58-8c61425dc54b"],
    "x_Windows_CStorage_CSearch_CInternal_CIBrokeredStorageLibraryContentChangedTriggerHelper": [
        "5e555330-7402-485f-834f-e862ca4a28ed"
    ],
    "x_Windows_CStorage_CStreams_CIFileRandomAccessStreamStatics": ["73550107-3b57-4b5d-8345-554d2fc621f0"],
    "x_Windows_CStorage_CStreams_CIInputStreamReference": ["43929d18-5ec9-4b5a-919c-4205b0c804b6"],
    "x_Windows_CStorage_CStreams_CIRandomAccessStreamReferenceStatics": ["857309dc-3fbf-4e7d-986f-ef3b1a07a964"],
    "x_Windows_CStorage_CStreams_CIRandomAccessStreamReferenceStaticsPrivate": ["5feeadb8-518f-40f8-a15d-1d80c2e5a822"],
    "x_Windows_CStorage_CStreams_CIRandomAccessStreamStatics": ["524cedcf-6e29-4ce5-9573-6b753db66c3a"],
    "x_Windows_CSystem_CIProtocolForResultsOperation": ["d581293a-6de9-4d28-9378-f86782e182bb"],
    "x_Windows_CSystem_CInternal_CICredentialSerialization": ["c39ab8a5-824f-4acf-92e0-bb53b8a90555"],
    "x_Windows_CSystem_CInternal_CISetUserAutologonResult": ["aa955c53-26ba-49f6-b527-5750cb199949"],
    "x_Windows_CSystem_CInternal_CISignInArbiter": ["d3ee3737-cb59-4732-ac03-c2be6f02b7f1"],
    "x_Windows_CSystem_CInternal_CISignInCompleteEventArgs": ["4b82c7ab-c805-4e9c-9d57-43b568dd964e"],
    "x_Windows_CSystem_CInternal_CISignInContext": ["3503377d-2055-4d2d-9fcf-f02531eb5b9a"],
    "x_Windows_CSystem_CInternal_CISignInContext2": ["5da3f048-82e8-4c82-8bfd-c389baeda720"],
    "x_Windows_CSystem_CInternal_CISignInResult": ["c3e53f22-a1e9-4678-873b-fb8b39895af8"],
    "x_Windows_CSystem_CInternal_CISignInResult2": ["9e708d69-d982-4a01-ab53-2d57b8a9624f"],
    "x_Windows_CSystem_CInternal_CISignInResult3": ["c1927091-1d15-4a06-8996-21d610a35f22"],
    "x_Windows_CSystem_CInternal_CISignInStateManager": ["100eb64b-b24c-4c38-8964-720d926d05a4"],
    "x_Windows_CSystem_CInternal_CISignOutCompleteEventArgs": ["397fbe36-b236-4922-8bb1-93028cd57dbc"],
    "x_Windows_CSystem_CInternal_CISignOutResult": ["6406c65d-90e2-4532-81f0-a94a8bf0cac3"],
    "x_Windows_CSystem_CInternal_CIUserAccountInformationStatic": ["2a0fd5e5-b524-4dea-ae5e-d8c792022d79"],
    "x_Windows_CSystem_CInternal_CIUserCreatedEventArgs": ["5af5819b-31b6-412a-b6cc-b97a3c5f34f7"],
    "x_Windows_CSystem_CInternal_CIUserDataManagerStatics": ["fa7e184a-11ce-413f-8064-7184b1b241a3"],
    "x_Windows_CSystem_CInternal_CIUserDeletedEventArgs": ["2d3edf68-f0cf-41a5-afcd-2dda7688d8b0"],
    "x_Windows_CSystem_CInternal_CIUserManagerShowUIExtension": ["5121a8d1-f96e-480e-9e81-314ae1129ee1"],
    "x_Windows_CSystem_CInternal_CIUserManagerStatics": ["252e7f79-acfa-4ea2-9a7e-fa27a8a4d3d9"],
    "x_Windows_CSystem_CInternal_CIUserManagerStatics2": ["039a83e3-d5bd-491a-9e47-3feba3427a92"],
    "x_Windows_CSystem_CInternal_CIUserProfile": ["dd66c6b5-ad7f-417a-a552-3508dedef087"],
    "x_Windows_CSystem_CInternal_CIValidateCredentialsResult": ["3db0edb5-177d-46f3-b8c2-09d6fd550d55"],
    "x_Windows_CSystem_CInternal_CLaunch_CIAsUserPartialTrustComponentHost": ["3c15a1b5-0536-4ab0-a046-99688b513288"],
    "x_Windows_CSystem_CInternal_CLaunch_CIExtensionInfo": ["def041c5-cd85-4add-959b-e848f800d000"],
    "x_Windows_CSystem_CInternal_CLaunch_CILauncherQueryAssociationStatics": ["876fc658-021d-475d-b318-bef52c0e242f"],
    "x_Windows_CSystem_CInternal_CLaunch_CILauncherQueryInfoStatics": ["9eb0164f-16c5-45a6-9d11-6ba6b20d9635"],
    "x_Windows_CSystem_CInternal_CLaunch_CILauncherService": ["972a91df-91b7-4055-afff-368bcc232759"],
    "x_Windows_CSystem_CInternal_CLaunch_CILegacyTaskModelActivation": ["0e7ad0ea-1fb3-4a97-a5cf-c9d87a539ef4"],
    "x_Windows_CSystem_CInternal_CLaunch_CIObjectWithExtensionInfo": ["e79c92d4-ee51-4049-9bf4-f1263c15f63f"],
    "x_Windows_CSystem_CInternal_CLaunch_CIQueryAssociationBrokerStatics": ["267265c8-eb6e-409d-b104-e6451ee39433"],
    "x_Windows_CSystem_CInternal_CLaunch_CIRemoteLauncherInteropStatics": ["23e04109-0f43-4c82-987e-97cd9a114397"],
    "x_Windows_CSystem_CInternal_CRemoteSystems_CIRemoteSystemBinaryChannel": ["7d78fc07-6689-41a6-9aa0-f7c60d4a8b6c"],
    "x_Windows_CSystem_CInternal_CRemoteSystems_CIRemoteSystemBinaryChannelDataReceivedEventArgs": [
        "44b1aa27-9f82-41aa-9f09-090120314aef"
    ],
    "x_Windows_CSystem_CInternal_CRemoteSystems_CIRemoteSystemBinaryChannelStartFailedEventArgs": [
        "4cf71e34-99ab-40a6-8f95-c264a360fb2c"
    ],
    "x_Windows_CSystem_CInternal_CRemoteSystems_CIRemoteSystemBinaryChannelStatics": [
        "ff1fb434-ca53-493e-bf2d-cc43e54e66d0"
    ],
    "x_Windows_CSystem_CInternal_CRemoteSystems_CIRemoteSystemBrokerStatics": ["30c55527-c7ac-438b-a317-dbee6cdcd8df"],
    "x_Windows_CSystem_CInternal_CRemoteSystems_CIRemoteSystemInternal": ["39342663-2893-4cfc-895a-9ab947e6c080"],
    "x_Windows_CSystem_CInternal_CRemoteSystems_CIRemoteSystemInteropStatics": ["21e95fa6-94a0-47f0-9558-800478b14fb2"],
    "x_Windows_CSystem_CInternal_CRemoteSystems_CIRemoteSystemStaticsInternal": [
        "c40fb2d3-c58e-4687-a339-0dba42bac7df"
    ],
    "x_Windows_CSystem_CPrivate_CILauncherStaticsForUserInternal": ["cbec102c-e5cf-4a7c-aeaf-636883833d9c"],
    "x_Windows_CSystem_CPrivate_CILauncherStaticsInternal": ["301636d2-7293-4228-9841-678163deb517"],
    "x_Windows_CSystem_CPrivate_CILauncherStaticsInternal2": ["4226291e-4bf7-4153-9c97-ca3118e17688"],
    "x_Windows_CSystem_CPrivate_CILauncherUIOptionsInternal": ["06dcb7d4-3bb2-4ddb-b376-5aeb47a93b4e"],
    "x_Windows_CSystem_CPrivate_CIPendingFileLaunch": ["0d7936bc-a809-4d2c-a601-eca9337a2251"],
    "x_Windows_CSystem_CPrivate_CIPendingLaunch": ["dded66d8-9b74-4749-8f77-b4bca20dc9d5"],
    "x_Windows_CSystem_CPrivate_CIPendingLaunch2": ["7c04f508-092c-4623-8020-012ef0852661"],
    "x_Windows_CSystem_CPrivate_CIPendingProtocolLaunch": ["0c69eff8-f9ba-4046-89c6-f9ab5da06527"],
    "x_Windows_CSystem_CPrivate_CIProtocolForResultsOperationSourcePriv": ["40c30f12-eec2-4696-a072-ef59d110ca7f"],
    "x_Windows_CSystem_CPrivate_CIProtocolForResultsOperationTargetPriv": ["35367f5c-ff56-4f2c-b59b-c05f7716b07c"],
    "x_Windows_CSystem_CPrivate_CIProtocolOperationWaitForResultsPriv": ["b82af0eb-77f5-4fc9-9d5e-61052634f692"],
    "x_Windows_CSystem_CPrivate_CIValueSetProvider": ["b71a78d3-427e-495d-8d3f-daf4e0088691"],
    "x_Windows_CSystem_CUserProfile_CIAdvertisingManagerHelperStatics": ["89fd71cb-1240-4957-a55e-8e1891378120"],
    "x_Windows_CSystem_CUserProfile_CIAdvertisingManagerHelperStatics2": ["984c5db4-0719-431b-80a8-2b4b11bbdbf1"],
    "x_Windows_CSystem_CUserProfile_CILockScreenCreativeStream": ["29d25bfc-e5db-473e-9e19-cdb9c77393a4"],
    "x_Windows_CSystem_CUserProfile_CILockScreenImageFeedStatics": ["2c0d73f6-03a9-41a6-9b01-495251ff51d5"],
    "x_Windows_CSystem_CUserProfile_CILockScreenStatics": ["3ee9d3ad-b607-40ae-b426-7631d9821269"],
    "x_Windows_CSystem_CUserProfile_CILockScreenStaticsPrivate": ["1a6c6cf6-ca91-4626-9cd9-df1078af8b6e"],
    "x_Windows_CSystem_CUserProfile_CIUserInformationStatics": ["77f3a910-48fa-489c-934e-2ae85ba8f772"],
    "x_Windows_CSystem_CUserProfile_CIUserProfilePersonalizationSettings": ["8ceddab4-7998-46d5-8dd3-184f1c5f9ab9"],
    "x_Windows_CSystem_CUserProfile_CIUserProfilePersonalizationSettingsStatics": [
        "91acb841-5037-454b-9883-bb772d08dd16"
    ],
    "x_Windows_CUI_CCore_CAnimationMetrics_CIAnimationDescription": ["7d11a549-be3d-41de-b081-05c149962f9b"],
    "x_Windows_CUI_CCore_CAnimationMetrics_CIAnimationDescriptionFactory": ["c6e27abe-c1fb-48b5-9271-ecc70ac86ef0"],
    "x_Windows_CUI_CCore_CAnimationMetrics_CIOpacityAnimation": ["803aabe5-ee7e-455f-84e9-2506afb8d2b4"],
    "x_Windows_CUI_CCore_CAnimationMetrics_CIPropertyAnimation": ["3a01b4da-4d8c-411e-b615-1ade683a9903"],
    "x_Windows_CUI_CCore_CAnimationMetrics_CIScaleAnimation": ["023552c7-71ab-428c-9c9f-d31780964995"],
    "x_Windows_CUI_CCore_CIAcceleratorKeyEventArgs": ["ff1c4c4a-9287-470b-836e-9086e3126ade"],
    "x_Windows_CUI_CCore_CIAcceleratorKeyEventArgs2": ["d300a9f6-2f7e-4873-a555-166e596ee1c5"],
    "x_Windows_CUI_CCore_CIApplicationViewConsolidatedEventArgsInternal": ["d0e0bc3c-cffa-4ad7-92a9-b865985bb8c5"],
    "x_Windows_CUI_CCore_CIAutomationProviderRequestedEventArgs": ["961ff258-21bf-4b42-a298-fa479d4c52e2"],
    "x_Windows_CUI_CCore_CICharacterReceivedEventArgs": ["c584659f-99b2-4bcc-bd33-04e63f42902e"],
    "x_Windows_CUI_CCore_CIClosestInteractiveBoundsRequestedEventArgs": ["347c11d7-f6f8-40e3-b29f-ae50d3e86486"],
    "x_Windows_CUI_CCore_CIComponentDisplayInformation": ["6a4e98ca-1742-468f-8617-1cb0fe5556b9"],
    "x_Windows_CUI_CCore_CIComponentDisplayInformationChangedEventArgs": ["2e9ecf43-3fcf-4ff0-b90c-44f3b3b6c8cf"],
    "x_Windows_CUI_CCore_CIComponentDisplayInformationFactory": ["aa67cdd6-573d-4c26-a6f3-071078053537"],
    "x_Windows_CUI_CCore_CIComponentDisplayInformationInternal": ["b10a3b92-b633-4409-8e16-d287e605855f"],
    "x_Windows_CUI_CCore_CIComponentDisplayInformationInternalChangedEventArgs": [
        "2e8d0385-00f6-46cf-b3a3-58c6dd6ee9e2"
    ],
    "x_Windows_CUI_CCore_CIComponentFocus": ["5f882a05-d594-48bc-9a5a-fd3b9ce90390"],
    "x_Windows_CUI_CCore_CIComponentWindowActivatedEventArgs": ["b357b2a5-6263-424c-92a0-0000966af02f"],
    "x_Windows_CUI_CCore_CIContextMenuRequestedEventArgs": ["2aa8158f-ea82-4d47-8177-eaf6488f5b80"],
    "x_Windows_CUI_CCore_CICoreAcceleratorKeys": ["9ffdf7f5-b8c9-4ef0-b7d2-1de626561fc8"],
    "x_Windows_CUI_CCore_CICoreAccelerators": ["d2ee93d5-6e89-45d4-aa50-e3a9b16c65c5"],
    "x_Windows_CUI_CCore_CICoreClosestInteractiveBoundsRequested": ["f303043a-e8bf-4e8e-ae69-c9dadd57a114"],
    "x_Windows_CUI_CCore_CICoreComponentFocusable": ["52f96fa3-8742-4411-ae69-79a85f29ac8b"],
    "x_Windows_CUI_CCore_CICoreCursor": ["96893acf-111d-442c-8a77-b87992f8e2d6"],
    "x_Windows_CUI_CCore_CICoreCursorFactory": ["f6359621-a79d-4ed3-8c32-a9ef9d6b76a4"],
    "x_Windows_CUI_CCore_CICoreDispatcher": ["60db2fa8-b705-4fde-a7d6-ebbb1891d39e"],
    "x_Windows_CUI_CCore_CICoreDispatcher2": ["6f5e63c7-e3aa-4eae-b0e0-dcf321ca4b2f"],
    "x_Windows_CUI_CCore_CICoreDispatcherWithTaskPriority": ["bafaecad-484d-41be-ba80-1d58c65263ea"],
    "x_Windows_CUI_CCore_CICoreInputSourceBase": ["9f488807-4580-4be8-be68-92a9311713bb"],
    "x_Windows_CUI_CCore_CICoreKeyboardInputSource": ["231c9088-e469-4df1-b208-6e490d71cb90"],
    "x_Windows_CUI_CCore_CICoreKeyboardInputSource2": ["fa24cb94-f963-47a5-8778-207c482b0afd"],
    "x_Windows_CUI_CCore_CICorePointerInputSource": ["bbf1bb18-e47a-48eb-8807-f8f8d3ea4551"],
    "x_Windows_CUI_CCore_CICorePointerInputSource2": ["d703708a-4516-4786-b1e5-2751d563f997"],
    "x_Windows_CUI_CCore_CICorePointerRedirector": ["8f9d0c94-5688-4b0c-a9f1-f931f7fa3dc3"],
    "x_Windows_CUI_CCore_CICoreTouchHitTesting": ["b1d8a289-3acf-4124-9fa3-ea8aba353c21"],
    "x_Windows_CUI_CCore_CICoreWindow": ["79b9d5f2-879e-4b89-b798-79e47598030c"],
    "x_Windows_CUI_CCore_CICoreWindow2": ["7c2b1b85-6917-4361-9c02-0d9e3a420b95"],
    "x_Windows_CUI_CCore_CICoreWindow3": ["32c20dd8-faef-4375-a2ab-32640e4815c7"],
    "x_Windows_CUI_CCore_CICoreWindow4": ["35caf0d0-47f0-436c-af97-0dd88f6f5f02"],
    "x_Windows_CUI_CCore_CICoreWindow5": ["4b4ae1e1-2e6d-4eaa-bda1-1c5cc1bee141"],
    "x_Windows_CUI_CCore_CICoreWindowDialog": ["e7392ce0-c78d-427e-8b2c-01ff420c69d5"],
    "x_Windows_CUI_CCore_CICoreWindowDialogFactory": ["cfb2a855-1c59-4b13-b1e5-16e29805f7c4"],
    "x_Windows_CUI_CCore_CICoreWindowEventArgs": ["272b1ef3-c633-4da5-a26c-c6d0f56b29da"],
    "x_Windows_CUI_CCore_CICoreWindowFactory": ["cd292360-2763-4085-8a9f-74b224a29175"],
    "x_Windows_CUI_CCore_CICoreWindowFlyout": ["e89d854d-2050-40bb-b344-f6f355eeb314"],
    "x_Windows_CUI_CCore_CICoreWindowFlyoutFactory": ["dec4c6c4-93e8-4f7c-be27-cefaa1af68a7"],
    "x_Windows_CUI_CCore_CICoreWindowPopupShowingEventArgs": ["26155fa2-5ba5-4ea4-a3b4-2dc7d63c8e26"],
    "x_Windows_CUI_CCore_CICoreWindowResizeManager": ["b8f0b925-b350-48b3-a198-5c1a84700243"],
    "x_Windows_CUI_CCore_CICoreWindowResizeManagerLayoutCapability": ["bb74f27b-a544-4301-80e6-0ae033ef4536"],
    "x_Windows_CUI_CCore_CICoreWindowResizeManagerStatics": ["ae4a9045-6d70-49db-8e68-46ffbd17d38d"],
    "x_Windows_CUI_CCore_CICoreWindowSite": ["b66132c2-cabe-4dd6-9936-f38ccfda5288"],
    "x_Windows_CUI_CCore_CICoreWindowSitePrivate": ["d5ccc20d-8f76-480d-95b6-e3be2e94a5c2"],
    "x_Windows_CUI_CCore_CICoreWindowStatic": ["4d239005-3c2a-41b1-9022-536bb9cf93b1"],
    "x_Windows_CUI_CCore_CICoreWindowWithContext": ["9ac40241-3575-4c3b-af66-e8c529d4d06c"],
    "x_Windows_CUI_CCore_CICoreWindowWithWindowReference": ["66422eba-c088-4c94-bd8b-5eda8fdeb273"],
    "x_Windows_CUI_CCore_CICoreWindow__CompositionIslands": ["a7ff5b48-94e0-40e6-8a80-228482b688ba"],
    "x_Windows_CUI_CCore_CIDispatchedHandler": ["d1f276c4-98d8-4636-bf49-eb79507548e9"],
    "x_Windows_CUI_CCore_CIDisplayChangedEventArgs": ["bc9704f8-daa9-47ad-9121-b4e4e53a37a7"],
    "x_Windows_CUI_CCore_CIIdleDispatchedHandler": ["a42b0c24-7f21-4abc-99c1-8f01007f0880"],
    "x_Windows_CUI_CCore_CIIdleDispatchedHandlerArgs": ["98bb6a24-dc1c-43cb-b4ed-d1c0eb2391f3"],
    "x_Windows_CUI_CCore_CIInitializeWithCoreWindow": ["188f20d6-9873-464a-ace5-57e010f465e6"],
    "x_Windows_CUI_CCore_CIInputDelegatedEventArgs": ["294a4207-88a0-4753-898f-26edb6d54237"],
    "x_Windows_CUI_CCore_CIInputEnabledEventArgs": ["80371d4f-2fd8-4c24-aa86-3163a87b4e5a"],
    "x_Windows_CUI_CCore_CIInternalCoreDispatcherStatic": ["4b4d0861-d718-4f7c-bec7-735c065f7c73"],
    "x_Windows_CUI_CCore_CIInternalCoreInput": ["c1eb11ba-7638-4e21-adbc-423a14fb197f"],
    "x_Windows_CUI_CCore_CIInternalCoreInput2": ["b6cd372b-55e6-4ad6-9356-0552073f9467"],
    "x_Windows_CUI_CCore_CIInternalCoreWindow": ["42a17e3d-7171-439a-b1fa-a31b7b957489"],
    "x_Windows_CUI_CCore_CIInternalCoreWindow2": ["c12779d8-85d2-43e5-901a-95dd4f8ecba3"],
    "x_Windows_CUI_CCore_CIInternalCoreWindow3": ["b8c7c64f-db4f-4ad8-9470-92c21990eaf2"],
    "x_Windows_CUI_CCore_CIInternalCoreWindow4": ["715fe104-1334-48fb-ada0-f0f54b90e94f"],
    "x_Windows_CUI_CCore_CIInternalCoreWindowFocus": ["08b39116-1f77-45ea-8604-742affd38833"],
    "x_Windows_CUI_CCore_CIInternalCoreWindowPhone": ["0764019b-52c1-41f9-b6f2-9cc205973692"],
    "x_Windows_CUI_CCore_CIInternalCoreWindowSiteFocus": ["b00ae9e1-ed35-4cf7-a5e6-ac793103f561"],
    "x_Windows_CUI_CCore_CIInternalUICoreStatics": ["36781f26-128e-48fa-becc-2bbbf5c6f14e"],
    "x_Windows_CUI_CCore_CIKeyEventArgs": ["5ff5e930-2544-4a17-bd78-1f2fdebb106b"],
    "x_Windows_CUI_CCore_CIKeyEventArgs2": ["583add98-0790-4571-9b12-645ef9d79e42"],
    "x_Windows_CUI_CCore_CILastInputEventTimestamp": ["60db7465-c9ec-4b79-ac73-7e0972619b28"],
    "x_Windows_CUI_CCore_CILightweightWindow": ["c6853961-483f-48ca-a06c-507503daecc5"],
    "x_Windows_CUI_CCore_CILightweightWindowStatics": ["bd12c79d-b493-4b1c-8cb1-cadcf963eaac"],
    "x_Windows_CUI_CCore_CIPointerEventArgs": ["920d9cb1-a5fc-4a21-8c09-49dfe6ffe25f"],
    "x_Windows_CUI_CCore_CISettingChangedEventArgs": ["39be6f23-75ad-4bb1-a873-7334b64dd997"],
    "x_Windows_CUI_CCore_CITimestamp": ["13c4e5d5-39cd-4cc2-9a34-3b7ff2a01dc6"],
    "x_Windows_CUI_CCore_CITouchHitTestingEventArgs": ["22f3b823-0b7c-424e-9df7-33d4f962931b"],
    "x_Windows_CUI_CCore_CIViewStateChangedEventArgs": ["ad5bfcd0-faac-4ab4-97be-097dc5b1126b"],
    "x_Windows_CUI_CCore_CIVisibilityChangedEventArgs": ["bf9918ea-d801-4564-a495-b1e84f8ad085"],
    "x_Windows_CUI_CCore_CIWindowActivatedEventArgs": ["179d65e7-4658-4cb6-aa13-41d094ea255e"],
    "x_Windows_CUI_CCore_CIWindowSizeChangedEventArgs": ["5a200ec7-0426-47dc-b86c-6f475915e451"],
    "x_Windows_CUI_CInput_CICrossSlidingEventArgs": ["e9374738-6f88-41d9-8720-78e08e398349"],
    "x_Windows_CUI_CInput_CICrossSlidingEventArgs2": ["eefb7d48-c070-59f3-8dab-bcaf621d8687"],
    "x_Windows_CUI_CInput_CIDraggingEventArgs": ["1c905384-083c-4bd3-b559-179cddeb33ec"],
    "x_Windows_CUI_CInput_CIDraggingEventArgs2": ["71efdbf9-382a-55ca-b4b9-008123c1bf1a"],
    "x_Windows_CUI_CInput_CIEdgeGesture": ["580d5292-2ab1-49aa-a7f0-33bd3f8df9f1"],
    "x_Windows_CUI_CInput_CIEdgeGestureEventArgs": ["44fa4a24-2d09-42e1-8b5e-368208796a4c"],
    "x_Windows_CUI_CInput_CIEdgeGestureStatics": ["bc6a8519-18ee-4043-9839-4fc584d60a14"],
    "x_Windows_CUI_CInput_CIGestureRecognizer": ["b47a37bf-3d6b-4f88-83e8-6dcb4012ffb0"],
    "x_Windows_CUI_CInput_CIGestureRecognizer2": ["d646097f-6ef7-5746-8ba8-8ff2206e6f3b"],
    "x_Windows_CUI_CInput_CIHoldingEventArgs": ["2bf755c5-e799-41b4-bb40-242f40959b71"],
    "x_Windows_CUI_CInput_CIHoldingEventArgs2": ["141da9ea-4c79-5674-afea-493fdeb91f19"],
    "x_Windows_CUI_CInput_CIKeyboardDeliveryInterceptor": ["b4baf068-8f49-446c-8db5-8c0ffe85cc9e"],
    "x_Windows_CUI_CInput_CIKeyboardDeliveryInterceptorStatics": ["f9f63ba2-ceba-4755-8a7e-14c0ffecd239"],
    "x_Windows_CUI_CInput_CIManipulationCompletedEventArgs": ["b34ab22b-d19b-46ff-9f38-dec7754bb9e7"],
    "x_Windows_CUI_CInput_CIManipulationCompletedEventArgs2": ["f0c0dce7-30a9-5b96-886f-6560a85e4757"],
    "x_Windows_CUI_CInput_CIManipulationInertiaStartingEventArgs": ["dd37a898-26bf-467a-9ce5-ccf3fb11371e"],
    "x_Windows_CUI_CInput_CIManipulationInertiaStartingEventArgs2": ["c25409b8-f9fa-5a45-bd97-dcbbb2201860"],
    "x_Windows_CUI_CInput_CIManipulationStartedEventArgs": ["ddec873e-cfce-4932-8c1d-3c3d011a34c0"],
    "x_Windows_CUI_CInput_CIManipulationStartedEventArgs2": ["2da3db4e-e583-5055-afaa-16fd986531a6"],
    "x_Windows_CUI_CInput_CIManipulationUpdatedEventArgs": ["cb354ce5-abb8-4f9f-b3ce-8181aa61ad82"],
    "x_Windows_CUI_CInput_CIManipulationUpdatedEventArgs2": ["f3dfb96a-3306-5903-a1c5-ff9757a8689e"],
    "x_Windows_CUI_CInput_CIMouseWheelParameters": ["ead0ca44-9ded-4037-8149-5e4cc2564468"],
    "x_Windows_CUI_CInput_CIPointerPoint": ["e995317d-7296-42d9-8233-c5be73b74a4a"],
    "x_Windows_CUI_CInput_CIPointerPointProperties": ["c79d8a4b-c163-4ee7-803f-67ce79f9972d"],
    "x_Windows_CUI_CInput_CIPointerPointProperties2": ["22c3433a-c83b-41c0-a296-5e232d64d6af"],
    "x_Windows_CUI_CInput_CIPointerPointStatics": ["a506638d-2a1a-413e-bc75-9f38381cc069"],
    "x_Windows_CUI_CInput_CIPointerPointTransform": ["4d5fe14f-b87c-4028-bc9c-59e9947fb056"],
    "x_Windows_CUI_CInput_CIPointerVisualizationSettings": ["4d1e6461-84f7-499d-bd91-2a36e2b7aaa2"],
    "x_Windows_CUI_CInput_CIPointerVisualizationSettingsStatics": ["68870edb-165b-4214-b4f3-584eca8c8a69"],
    "x_Windows_CUI_CInput_CIRightTappedEventArgs": ["4cbf40bd-af7a-4a36-9476-b1dce141709a"],
    "x_Windows_CUI_CInput_CIRightTappedEventArgs2": ["61c7b7bb-9f57-5857-a33c-c58c3dfa959e"],
    "x_Windows_CUI_CInput_CITappedEventArgs": ["cfa126e4-253a-4c3c-953b-395c37aed309"],
    "x_Windows_CUI_CInput_CITappedEventArgs2": ["294388f2-177e-51d5-be56-ee0866fa968c"],
    "x_Windows_CUI_CInternal_CPopups_CIMessageDialogActivatedEventArgs": ["2cdd15e1-af86-4aaf-a767-d14253412d16"],
    "x_Windows_CUI_CInternal_CPopups_CIMessageDialogExperience": ["23caf4b1-b2db-4872-b38d-fc9ce19b8270"],
    "x_Windows_CUI_CInternal_CPopups_CIMessageDialogFactoryWithOwnerWindow": ["b83e0e2f-5dfd-4492-acb4-e96c848b6fab"],
    "x_Windows_CUI_CInternal_CPopups_CIMessageDialogInfo": ["e4111ed7-7a54-452c-8d47-806239e5e49c"],
    "x_Windows_CUI_CInternal_CPopups_CIMessageDialogOperation": ["b93bf25c-186f-46da-b408-b5db4a497238"],
    "x_Windows_CUI_CInternal_CPopups_CIMessageDialogOperationCompletedEventArgs": [
        "4db26775-fabb-431c-ad75-9c5741d315d5"
    ],
    "x_Windows_CUI_CInternal_CPopups_CIPopupMenuExperience": ["4801b1b9-7a73-4283-b84d-7c4f9e3c4f5b"],
    "x_Windows_CUI_CInternal_CPopups_CIPopupMenuInfo": ["f22fb5f8-7e6e-4d26-b6d8-edcb059b8c28"],
    "x_Windows_CUI_CInternal_CPopups_CIPopupMenuOperation": ["91a48776-427a-410b-bb5a-c9b833d4c9d2"],
    "x_Windows_CUI_CInternal_CPopups_CIPopupMenuOperationCompletedEventArgs": ["70ea33d3-0712-4c25-b48c-a1d10dda070d"],
    "x_Windows_CUI_CInternal_CProjectionManager_CIProjectionManagerCore": ["676d32b0-3561-49d6-96d3-fdb643389ef8"],
    "x_Windows_CUI_CInternal_CProjectionManager_CIProjectionManagerCoreBroker": [
        "c046ac29-a01c-41d9-93ee-bc4fd33bb5f0"
    ],
    "x_Windows_CUI_CNotifications_CInternal_CIPostNotification": ["5fe5cea6-f3a6-4907-9ee8-0644180a206b"],
    "x_Windows_CUI_CNotifications_CInternal_CIToastNotificationInternal": ["7ad17d6d-b2b2-4948-aefb-726d1ba0a7fe"],
    "x_Windows_CUI_CPopups_CIMessageDialog": ["33f59b01-5325-43ab-9ab3-bdae440e4121"],
    "x_Windows_CUI_CPopups_CIMessageDialogFactory": ["2d161777-a66f-4ea5-bb87-793ffa4941f2"],
    "x_Windows_CUI_CPopups_CIPopupMenu": ["4e9bc6dc-880d-47fc-a0a1-72b639e62559"],
    "x_Windows_CUI_CPopups_CIUICommand": ["4ff93a75-4145-47ff-ac7f-dff1c1fa5b0f"],
    "x_Windows_CUI_CPopups_CIUICommandFactory": ["a21a8189-26b0-4676-ae94-54041bc125e8"],
    "x_Windows_CUI_CPopups_CIUICommandInvokedHandler": ["daf77a4f-c27a-4298-9ac6-2922c45e7da6"],
    "x_Windows_CUI_CSearch_CInternal_CCommon_CIBindableObservableItemCollection": [
        "894aa80c-9ea7-4e77-a1f4-d0d15a7c2225"
    ],
    "x_Windows_CUI_CSearch_CInternal_CCommon_CIConnectedSearchErrorInfoHost": ["47eb80e1-78cd-4325-8d67-85bffa376707"],
    "x_Windows_CUI_CSearch_CInternal_CCommon_CIConnectedSearchErrorMessage": ["ff26da9a-2d4d-4320-abd9-a331f2ae0d0e"],
    "x_Windows_CUI_CSearch_CInternal_CCommon_CIConnectedSearchErrorService": ["e39d8fb0-675c-47b7-832d-a80204a9f7ac"],
    "x_Windows_CUI_CSearch_CInternal_CCommon_CIDisplayModeChangedEventArgs": ["68b3e12e-1f6f-44cb-baee-fe5637c64ba6"],
    "x_Windows_CUI_CSearch_CInternal_CCommon_CIErrorOccurredEventArgs": ["6b35f5d8-852c-4509-9a85-08fb9db1c643"],
    "x_Windows_CUI_CSearch_CInternal_CCommon_CIErrorOccurredEventHandler": ["113ad4dc-9da3-4197-a012-a90e360aa089"],
    "x_Windows_CUI_CSearch_CInternal_CCommon_CIHitHighlightService": ["1dded0fa-9247-4621-9c54-edb2764225ca"],
    "x_Windows_CUI_CSearch_CInternal_CCommon_CIIHMListener": ["137e6a4e-e7c5-451c-bd05-095cfd45ad54"],
    "x_Windows_CUI_CSearch_CInternal_CCommon_CIInspectableWithSite": ["fa1d1cc8-4f0f-4e75-aed4-0302cc82249d"],
    "x_Windows_CUI_CSearch_CInternal_CCommon_CIItemCollectionChangedEventArgs": [
        "3ecb9276-ae96-4bb5-83a0-79c7676282ec"
    ],
    "x_Windows_CUI_CSearch_CInternal_CCommon_CILocalRankerFeatureData": ["3fbc6fe1-c418-4c72-a159-b5e944f601e7"],
    "x_Windows_CUI_CSearch_CInternal_CCommon_CILocalRankerWeightData": ["d968bcbe-efb5-48d5-93c3-950a0a62f374"],
    "x_Windows_CUI_CSearch_CInternal_CCommon_CILocalResultsGroup": ["e1a33e84-bffa-46f6-9f5e-cd2722dfb7bf"],
    "x_Windows_CUI_CSearch_CInternal_CCommon_CIMenuSeparator": ["43e4390a-4704-4770-883a-4da0da768ffc"],
    "x_Windows_CUI_CSearch_CInternal_CCommon_CIRegisterViewServiceConsumer": ["76550116-b458-4b21-b1bb-8a48027c1200"],
    "x_Windows_CUI_CSearch_CInternal_CCommon_CIScopeChangedEventArgs": ["bec2304c-1ce2-45ac-8eb1-a4745c191bed"],
    "x_Windows_CUI_CSearch_CInternal_CCommon_CIScopeChangedEventHandler": ["804a69e1-08e0-41c2-bb0f-2b6c9a7ae379"],
    "x_Windows_CUI_CSearch_CInternal_CCommon_CIScopeSelector": ["e2a10c6c-a31c-425a-a9c1-7b2713d1af7d"],
    "x_Windows_CUI_CSearch_CInternal_CCommon_CISearchResultsViewportService": ["6206b070-73b2-4c4a-b82e-bda6a795d421"],
    "x_Windows_CUI_CSearch_CInternal_CCommon_CIThemeListener": ["46b7f8b4-7994-436d-9454-7966bb126d03"],
    "x_Windows_CUI_CSearch_CInternal_CCommon_CITrackedRegionArray": ["081c2d4e-f234-481d-b973-46e4c7be64d5"],
    "x_Windows_CUI_CSearch_CInternal_CCommon_CIViewServiceConsumer": ["41fe86af-f148-457e-b0ec-d0389fa74670"],
    "x_Windows_CUI_CSearch_CInternal_CCommon_CIViewVisibilityChangedEventHandler": [
        "a6a2950b-e547-4832-a0ed-8c8591ffa9e5"
    ],
    "x_Windows_CUI_CSearch_CInternal_CCommon_CIViewVisibiltyChangedEventArgs": ["4f451853-4c93-4dc2-b968-1fd3e3fd418b"],
    "x_Windows_CUI_CSearch_CInternal_CCommon_CIViewVisibleService": ["93d8299e-6ca5-47cb-bf64-203f24c775c6"],
    "x_Windows_CUI_CSearch_CInternal_CCommon_CIViewportInfo": ["ce5820e7-8019-4bc5-8353-a0fadcdb55e3"],
    "x_Windows_CUI_CSearch_CInternal_CContacts_CIContactCardView": ["d4f0fbf7-52ef-4e24-90b6-588fd681bbcc"],
    "x_Windows_CUI_CSearch_CInternal_CContacts_CIContactsCollectionFactory": ["1a895d5e-ddc8-489c-9000-03d523342aa0"],
    "x_Windows_CUI_CSearch_CInternal_CGlobalSuggestions_CIGlobalSuggestionsCollection": [
        "f3381426-93f9-4fc5-b560-db1d996cc7e7"
    ],
    "x_Windows_CUI_CSearch_CInternal_CGlobalSuggestions_CIGlobalSuggestionsLogger": [
        "b2b65041-d55f-4b50-9ac5-9a3dde9ec981"
    ],
    "x_Windows_CUI_CSearch_CInternal_CGlobalSuggestions_CIItemRealizationCallback": [
        "6a9e2563-9e1e-4291-820c-6170ca16b63a"
    ],
    "x_Windows_CUI_CSearch_CInternal_CLocalResults_CILocalResultsCollectionFactory": [
        "a8cda3d0-b61a-462a-ab62-646464c69d20"
    ],
    "x_Windows_CUI_CSearch_CInternal_CLocalResults_CILocalResultsGroupDisplayInfo": [
        "8bc4e083-ab24-4e22-a341-1999eea5d005"
    ],
    "x_Windows_CUI_CSearch_CInternal_CSearchBoxControl_CIQuerySubmittedEventArgs": [
        "37178c3d-b330-4159-9c4c-75a96bd9f733"
    ],
    "x_Windows_CUI_CSearch_CInternal_CSearchBoxControl_CIQueryTextChangedEventArgs": [
        "ab842ffc-f59b-468c-b882-8ee028b6419b"
    ],
    "x_Windows_CUI_CSearch_CInternal_CSearchBoxControl_CIResultSuggestionChosenEventArgs": [
        "25e3f904-7093-4f9d-8649-56fac7488c50"
    ],
    "x_Windows_CUI_CSearch_CInternal_CSearchBoxControl_CISearchBox": ["aa90700f-2340-46a7-ab00-867fd691ecee"],
    "x_Windows_CUI_CSearch_CInternal_CSearchPane_CISearchPane": ["ed646d0b-332f-4b9b-8b0e-aef71d46f5c7"],
    "x_Windows_CUI_CSearch_CInternal_CSearchResults_CICollectionCreatedCallback": [
        "38a0dec0-e5b8-4ff7-bde1-b81ab3ce18e4"
    ],
    "x_Windows_CUI_CSearch_CInternal_CSearchResults_CILocalResultsInspector": ["a1fd22d5-3daa-4885-8c45-990610269828"],
    "x_Windows_CUI_CSearch_CInternal_CSearchResults_CILocalResultsQueryExecuteArgs": [
        "ad8aca15-875f-4a2a-bf6d-e21cf4abda73"
    ],
    "x_Windows_CUI_CSearch_CInternal_CSearchResults_CIQueryExecuteArgs": ["c3286004-e6a9-47b2-b898-c2e0a708234e"],
    "x_Windows_CUI_CSearch_CInternal_CSearchResults_CIQueryProcessor": ["fa1c27ee-a334-470a-861b-dbb78351a042"],
    "x_Windows_CUI_CSearch_CInternal_CSearchResults_CIResultsReadyEventArgs": ["4d4f3cc7-299c-459e-8d40-110a31e2c8e0"],
    "x_Windows_CUI_CSearch_CInternal_CSearchResults_CIResultsSelectionChangedEventArgs": [
        "4fc8f909-d84a-4d9d-9069-0b23f1c20ab9"
    ],
    "x_Windows_CUI_CSearch_CInternal_CSearchResults_CIResultsSelectionChangedEventHandler": [
        "d0d46119-9a38-4106-9f6a-de159f4a8c64"
    ],
    "x_Windows_CUI_CSearch_CInternal_CSearchResults_CISearchResultsSelector": ["7d858463-1b07-482e-8405-6bd792455e88"],
    "x_Windows_CUI_CSearch_CInternal_CSearchResults_CISearchResultsView": ["74deb49e-5250-46fd-af88-bb8f5e69c98e"],
    "x_Windows_CUI_CSearch_CInternal_CSearchResults_CISearchSelectionService": ["70fce2ac-8669-47ba-af95-e9d7ff5b79d6"],
    "x_Windows_CUI_CViewManagement_CIAccessibilitySettings": ["fe0e8147-c4c0-4562-b962-1327b52ad5b9"],
    "x_Windows_CUI_CViewManagement_CIActivationViewSwitcher": ["dca71bb6-7350-492b-aac7-c8a13d7224ad"],
    "x_Windows_CUI_CViewManagement_CIApplicationView": ["d222d519-4361-451e-96c4-60f4f9742db0"],
    "x_Windows_CUI_CViewManagement_CIApplicationView2": ["e876b196-a545-40dc-b594-450cba68cc00"],
    "x_Windows_CUI_CViewManagement_CIApplicationView3": ["903c9ce5-793a-4fdf-a2b2-af1ac21e3108"],
    "x_Windows_CUI_CViewManagement_CIApplicationView4": ["15e5cbec-9e0f-46b5-bc3f-9bf653e74b5e"],
    "x_Windows_CUI_CViewManagement_CIApplicationView5": ["855744ed-1080-4faa-adc9-83b2aeba7599"],
    "x_Windows_CUI_CViewManagement_CIApplicationView6": ["d38d9ffd-764a-427f-9be0-7aa640af3db9"],
    "x_Windows_CUI_CViewManagement_CIApplicationView7": ["a0369647-5faf-5aa6-9c38-befbb12a071e"],
    "x_Windows_CUI_CViewManagement_CIApplicationView9": ["9c6516f9-021a-5f01-93e5-9bdad2647574"],
    "x_Windows_CUI_CViewManagement_CIApplicationViewConsolidatedEventArgs": ["514449ec-7ea2-4de7-a6a6-7dfbaaebb6fb"],
    "x_Windows_CUI_CViewManagement_CIApplicationViewConsolidatedEventArgs2": ["1c199ecc-6dc1-40f4-afee-07d9ea296430"],
    "x_Windows_CUI_CViewManagement_CIApplicationViewFullscreenStatics": ["bc792ebd-64fe-4b65-a0c0-901ce2b68636"],
    "x_Windows_CUI_CViewManagement_CIApplicationViewInteropStatics": ["c446fb5d-4793-4896-a8e2-be57a8bb0f50"],
    "x_Windows_CUI_CViewManagement_CIApplicationViewScaling": ["1d0ddc23-23f3-4b2d-84fe-74bf37b48b66"],
    "x_Windows_CUI_CViewManagement_CIApplicationViewScalingStatics": ["b08fecf0-b946-45c8-a5e3-71f5aa78f861"],
    "x_Windows_CUI_CViewManagement_CIApplicationViewScreenCaptureDisabledBehavior": [
        "07c19b29-7b3b-44d3-b747-2fdc18553680"
    ],
    "x_Windows_CUI_CViewManagement_CIApplicationViewStatics": ["010a6306-c433-44e5-a9f2-bd84d4030a95"],
    "x_Windows_CUI_CViewManagement_CIApplicationViewStatics2": ["af338ae5-cf64-423c-85e5-f3e72448fb23"],
    "x_Windows_CUI_CViewManagement_CIApplicationViewStatics3": ["a28d7594-8c41-4e13-9719-5164796fe4c7"],
    "x_Windows_CUI_CViewManagement_CIApplicationViewStatics4": ["08fd8d33-2611-5336-a315-d98e6366c9db"],
    "x_Windows_CUI_CViewManagement_CIApplicationViewSwitcherStatics": ["975f2f1e-e656-4c5e-a0a1-717c6ffa7d64"],
    "x_Windows_CUI_CViewManagement_CIApplicationViewSwitcherStatics2": ["60e995cd-4fc2-48c4-b8e3-395f2b9f0fc1"],
    "x_Windows_CUI_CViewManagement_CIApplicationViewSwitcherStatics3": ["92059420-80a7-486d-b21f-c7a4a242a383"],
    "x_Windows_CUI_CViewManagement_CIApplicationViewTitleBar": ["00924ac0-932b-4a6b-9c4b-dc38c82478ce"],
    "x_Windows_CUI_CViewManagement_CIApplicationViewTitleBar2": ["d6fcf72f-41d6-5179-9bbe-54ddfa7c4611"],
    "x_Windows_CUI_CViewManagement_CIApplicationViewTransferContext": ["8574bc63-3c17-408e-9408-8a1a9ea81bfa"],
    "x_Windows_CUI_CViewManagement_CIApplicationViewTransferContextStatics": ["15a89d92-dd79-4b0b-bc47-d5f195f14661"],
    "x_Windows_CUI_CViewManagement_CIApplicationViewWithContext": ["bd55d512-9dc1-44fc-8501-666625df60dc"],
    "x_Windows_CUI_CViewManagement_CIInputPane": ["640ada70-06f3-4c87-a678-9829c9127c28"],
    "x_Windows_CUI_CViewManagement_CIInputPane2": ["8a6b3f26-7090-4793-944c-c3f2cde26276"],
    "x_Windows_CUI_CViewManagement_CIInputPaneControl": ["088bb24f-962f-489d-aa6e-c6be1a0a6e52"],
    "x_Windows_CUI_CViewManagement_CIInputPaneStatics": ["95f4af3a-ef47-424a-9741-fd2815eba2bd"],
    "x_Windows_CUI_CViewManagement_CIInputPaneStatics2": ["1b63529b-d9ec-4531-8445-71bab9fb828e"],
    "x_Windows_CUI_CViewManagement_CIInputPaneVisibilityEventArgs": ["d243e016-d907-4fcc-bb8d-f77baa5028f1"],
    "x_Windows_CUI_CViewManagement_CIUISettings": ["85361600-1c63-4627-bcb1-3a89e0bc9c55"],
    "x_Windows_CUI_CViewManagement_CIUISettings2": ["bad82401-2721-44f9-bb91-2bb228be442f"],
    "x_Windows_CUI_CViewManagement_CIUISettings3": ["03021be4-5254-4781-8194-5168f7d06d7b"],
    "x_Windows_CUI_CViewManagement_CIUISettings4": ["52bb3002-919b-4d6b-9b78-8dd66ff4b93b"],
    "x_Windows_CUI_CViewManagement_CIUISettings5": ["5349d588-0cb5-5f05-bd34-706b3231f0bd"],
    "x_Windows_CUI_CViewManagement_CIUISettings6": ["aef19bd7-fe31-5a04-ada4-469aaec6dfa9"],
    "x_Windows_CUI_CViewManagement_CIUISettingsAnimationsEnabledChangedEventArgs": [
        "0c7b4b3d-2ea1-533e-894d-415bc5243c29"
    ],
    "x_Windows_CUI_CViewManagement_CIUISettingsAutoHideScrollBarsChangedEventArgs": [
        "87afd4b2-9146-5f02-8f6b-06d454174c0f"
    ],
    "x_Windows_CUI_CViewManagement_CIUISettingsMessageDurationChangedEventArgs": [
        "338aad52-4a5d-5b59-8002-d930f608fd6e"
    ],
    "x_Windows_CUI_CViewManagement_CIViewModePreferences": ["878fcd3a-0b99-42c9-84d0-d3f1d403554b"],
    "x_Windows_CUI_CViewManagement_CIViewModePreferences2": ["ceda8366-33ea-4f99-b2e2-3e83e8838b6f"],
    "x_Windows_CUI_CViewManagement_CIViewModePreferencesStatics": ["69b60a65-5de5-40d8-8306-3833df7a2274"],
    "x_Windows_CUI_CWindowManagement_CIAppStreamingPositioner": ["480b51e5-ff25-4343-b791-b976726d77c2"],
    "x_Windows_CUI_CWindowManagement_CIDisplayRegion": ["dd391b01-a131-493c-8138-eeff7e92e144"],
    "x_Windows_CUI_CWindowManagement_CIDisplayRegionStatics": ["73c66a48-ede1-4792-bb92-4efe41937b16"],
    "x_Windows_CUI_CWindowManagement_CIOverlappedPositioner": ["638fd7a9-4f53-4dac-aeba-b729d7e14da4"],
    "x_Windows_CUI_CWindowManagement_CIPositioner": ["b5ba7a7e-56eb-46d5-89a0-e440b5d4f8c0"],
    "x_Windows_CUI_CWindowManagement_CITilingPositioner": ["b56c7aa8-db5f-4a5d-b7b8-f715b934c327"],
    "x_Windows_CUI_CWindowManagement_CIViewRelativePositionPreferences": ["7b369480-6029-424a-b9bb-e56f68a6921f"],
    "x_Windows_CUI_CWindowManagement_CIWindowChrome": ["41f784f3-0454-4d90-b1df-d68696717188"],
    "x_Windows_CUI_CWindowManagement_CIWindowingEnvironment": ["7bcc456f-606a-4102-a977-27b227640f81"],
    "x_Windows_CUI_CWindowManagement_CIWindowingEnvironmentAddedEventArgs": ["f3468160-d3b5-4aeb-abfd-68682b1dd228"],
    "x_Windows_CUI_CWindowManagement_CIWindowingEnvironmentChangedEventArgs": ["01b2bee9-2c9a-4f47-b19b-52a22167395d"],
    "x_Windows_CUI_CWindowManagement_CIWindowingEnvironmentRemovedEventArgs": ["bcb625fa-3750-4849-837f-890bb99fcae3"],
    "x_Windows_CUI_CWindowManagement_CIWindowingEnvironmentStatics": ["ba7c8d31-83e4-4fd1-bd1a-8656b8044114"],
    "x_Windows_CUI_CXaml_CInterop_CMarshal_CIMarshalCustomProperty": ["d4aaf124-807d-4447-9926-9515c0bc8718"],
    "x_Windows_CUI_CXaml_CInterop_CMarshal_CIMarshalCustomPropertyProvider": ["a8d489fb-e3dd-4a1f-9375-f24f47c61642"],
    "x_Windows_CUI_CXaml_CInterop_CMarshal_CIMarshalNotifyPropertyChanged": ["899267cc-efeb-4617-ab64-9b7030e550fc"],
    "x_Windows_CUI_CXaml_CInterop_CMarshal_CIMarshalPropertyChangedEventArgs": ["dcc33b73-d2c2-4307-a79a-8e18859365d8"],
    "x_Windows_CUI_CXaml_CInterop_CMarshal_CIMarshalPropertyChangedEventHandler": [
        "b3ac628d-0d5e-4909-aaef-3b3ed4b456a6"
    ],
    "dispAssemblyReferencesEvents": ["a1b04977-56dd-40d1-89e3-65e1902a9103"],
    "dispBuildEvents": ["1926364e-6b90-46cb-a44d-8a80fb11acd9"],
    "dispBuildManagerEvents": ["828914f7-1d81-4f5c-83ce-37819d7ee759"],
    "dispCodeModelEvents": ["4ea8090e-d289-4d56-98cd-c48dd2853b2e"],
    "dispCommandBarControlEvents": ["987fb893-f96d-11d0-bbbb-00a0c90f2744"],
    "dispCommandEvents": ["ff2d5c12-feea-11d0-bbc8-00a0c90f2744"],
    "dispDTEEvents": ["b50c9708-c909-4b87-a03d-af6cc4bfb422"],
    "dispDebuggerEvents": ["46209330-0fba-11d3-b880-00c04f79e479"],
    "dispDebuggerExpressionEvaluationEvents": ["73ffa13f-ad72-4154-be77-d4288f2e4fc5"],
    "dispDebuggerProcessEvents": ["7d04c01d-bb7a-47e8-92eb-e914cd61366b"],
    "dispDocumentEvents": ["dc5437f6-f114-11d2-aacf-00c04f688dde"],
    "dispFindEvents": ["c5331ace-c5d5-11d2-8598-006097c68e81"],
    "dispImportsEvents": ["40806cea-abab-4887-a356-d8869c28a6e6"],
    "dispOutputWindowEvents": ["0d3a23af-67bb-11d2-97c1-00c04fb6c6ff"],
    "dispProjectItemsEvents": ["6962753f-efd5-41c5-b083-d70687166aeb"],
    "dispProjectsEvents": ["7f508d55-627f-4d7f-be0b-9e3d829ff0ed"],
    "dispPublishEvents": ["a0b40b93-9311-410f-b210-1f65bafb0e27"],
    "dispReferencesEvents": ["287eb27c-0f8b-4d2d-8e82-a9ca50b6766e"],
    "dispSelectionEvents": ["deeb28b3-23e6-11d1-ae5c-00a0c90f26f4"],
    "dispSolutionEvents": ["fbcff1c2-261c-11d1-ae5e-00a0c90f26f4"],
    "dispTaskListEvents": ["1125c423-49bd-11d2-8823-00c04fb6c6ff"],
    "dispTextDocumentKeyPressEvents": ["4b57c85e-5100-4caf-9301-4544b85c7945"],
    "dispTextEditorEvents": ["2699dd44-c507-4da3-aa34-314a6c21dfe2"],
    "dispVSLangProjWebReferencesEvents": ["9aad53a9-32cb-4d84-97a7-b4afa94f5878"],
    "dispWebReferencesEvents": ["11c784f8-e5a0-4c19-831a-2c2d00c6d897"],
    "dispWebServicesEvents": ["b3af808b-b55a-4dfe-a9fc-c3b4f4b37903"],
    "dispWebSiteMiscEvents": ["b4c62092-f8db-4cca-9b73-5c7c56df72aa"],
    "dispWindowEvents": ["0d3a23a9-67bb-11d2-97c1-00c04fb6c6ff"],
    "dispWindowVisibilityEvents": ["94259e4b-a44a-4b77-b18f-f2cc9a601d03"],
    "FAILURE": ["0900000a-0002-0000-0000-000000000080"],
    "IKsQualityForwarder": ["97ebaacb-95bd-11d0-a3ea-00a0c9223196"],
    "AUTOMATIC": ["6b2fc80b-be21-4a6a-97c4-1179b295036e"],
    "SHORTCUTS": ["f4e57c4b-2036-45f0-a9ab-443bcfe33d9f"],
    "TEST": ["b267e3ad-a825-4a09-82b9-eec22aa3b847"],
}
